/*
Product Name: dhtmlxSuite 
Version: 4.0.3 
Edition: Standard 
License: content of this file is covered by GPL. Usage outside GPL terms is prohibited. To obtain Commercial or Enterprise license contact sales@dhtmlx.com
Copyright UAB Dinamenta http://www.dhtmlx.com
*/
if (typeof (window.dhx4) == "undefined") {
    window.dhx4 = {
        version: "4.0.3",
        skin: null,
        skinDetect: function (c) {
            var g = document.createElement("DIV");
            g.className = c + "_skin_detect";
            if (document.body.firstChild) {
                document.body.insertBefore(g, document.body.firstChild)
            } else {
                document.body.appendChild(g)
            }
            var a = g.offsetWidth;
            g.parentNode.removeChild(g);
            g = null;
            return {
                10: "dhx_skyblue",
                20: "dhx_web",
                30: "dhx_terrace"
            }[a] || null
        },
        lastId: 1,
        newId: function () {
            return this.lastId++
        },
        zim: {
            data: {},
            step: 5,
            first: function () {
                return 100
            },
            last: function () {
                var g = this.first();
                for (var c in this.data) {
                    g = Math.max(g, this.data[c])
                }
                return g
            },
            reserve: function (a) {
                this.data[a] = this.last() + this.step;
                return this.data[a]
            },
            clear: function (a) {
                if (this.data[a] != null) {
                    this.data[a] = null;
                    delete this.data[a]
                }
            }
        },
        s2b: function (a) {
            return (a == true || a == 1 || a == "true" || a == "1" || a == "yes" || a == "y")
        },
        trim: function (a) {
            return String(a).replace(/^\s{1,}/, "").replace(/\s{1,}$/, "")
        },
        template: function (c, g, a) {
            return c.replace(/#([a-zA-Z0-9_-]{1,})#/g, function (j, h) {
                if (h.length > 0 && typeof (g[h]) != "undefined") {
                    if (a == true) {
                        return window.dhx4.trim(g[h])
                    }
                    return String(g[h])
                }
                return ""
            })
        },
        absLeft: function (a) {
            if (typeof (a) == "string") {
                a = document.getElementById(a)
            }
            return this._aOfs(a).left
        },
        absTop: function (a) {
            if (typeof (a) == "string") {
                a = document.getElementById(a)
            }
            return this._aOfs(a).top
        },
        _aOfsSum: function (a) {
            var g = 0,
                c = 0;
            while (a) {
                g = g + parseInt(a.offsetTop);
                c = c + parseInt(a.offsetLeft);
                a = a.offsetParent
            }
            return {
                top: g,
                left: c
            }
        },
        _aOfsRect: function (h) {
            var m = h.getBoundingClientRect();
            var n = document.body;
            var c = document.documentElement;
            var a = window.pageYOffset || c.scrollTop || n.scrollTop;
            var j = window.pageXOffset || c.scrollLeft || n.scrollLeft;
            var l = c.clientTop || n.clientTop || 0;
            var o = c.clientLeft || n.clientLeft || 0;
            var q = m.top + a - l;
            var g = m.left + j - o;
            return {
                top: Math.round(q),
                left: Math.round(g)
            }
        },
        _aOfs: function (a) {
            if (a.getBoundingClientRect) {
                return this._aOfsRect(a)
            } else {
                return this._aOfsSum(a)
            }
        },
        _isObj: function (a) {
            return (a != null && typeof (a) == "object" && typeof (a.length) == "undefined")
        },
        _copyObj: function (h) {
            if (this._isObj(h)) {
                var g = {};
                for (var c in h) {
                    if (typeof (h[c]) == "object" && h[c] != null) {
                        g[c] = this._copyObj(h[c])
                    } else {
                        g[c] = h[c]
                    }
                }
            } else {
                var g = [];
                for (var c = 0; c < h.length; c++) {
                    if (typeof (h[c]) == "object" && h[c] != null) {
                        g[c] = this._copyObj(h[c])
                    } else {
                        g[c] = h[c]
                    }
                }
            }
            return g
        },
        screenDim: function () {
            var a = (navigator.userAgent.indexOf("MSIE") >= 0);
            var c = {};
            c.left = document.body.scrollLeft;
            c.right = c.left + (window.innerWidth || document.body.clientWidth);
            c.top = Math.max((a ? document.documentElement : document.getElementsByTagName("html")[0]).scrollTop, document.body.scrollTop);
            c.bottom = c.top + (a ? Math.max(document.documentElement.clientHeight || 0, document.documentElement.offsetHeight || 0) : window.innerHeight);
            return c
        },
        selectTextRange: function (h, l, c) {
            h = (typeof (h) == "string" ? document.getElementById(h) : h);
            var a = h.value.length;
            l = Math.max(Math.min(l, a), 0);
            c = Math.min(c, a);
            if (h.setSelectionRange) {
                try {
                    h.setSelectionRange(l, c)
                } catch (j) {}
            } else {
                if (h.createTextRange) {
                    var g = h.createTextRange();
                    g.moveStart("character", l);
                    g.moveEnd("character", c - a);
                    try {
                        g.select()
                    } catch (j) {}
                }
            }
        },
        transData: null,
        transDetect: function () {
            if (this.transData == null) {
                this.transData = {
                    transProp: false,
                    transEv: null
                };
                var g = {
                    MozTransition: "transitionend",
                    WebkitTransition: "webkitTransitionEnd",
                    OTransition: "oTransitionEnd",
                    msTransition: "transitionend",
                    transition: "transitionend"
                };
                for (var c in g) {
                    if (this.transData.transProp == false && document.documentElement.style[c] != null) {
                        this.transData.transProp = c;
                        this.transData.transEv = g[c]
                    }
                }
                g = null
            }
            return this.transData
        }
    };
    window.dhx4.isIE = (navigator.userAgent.indexOf("MSIE") >= 0 || navigator.userAgent.indexOf("Trident") >= 0);
    window.dhx4.isIE6 = (window.XMLHttpRequest == null && navigator.userAgent.indexOf("MSIE") >= 0);
    window.dhx4.isIE7 = (navigator.userAgent.indexOf("MSIE 7.0") >= 0 && navigator.userAgent.indexOf("Trident") < 0);
    window.dhx4.isOpera = (navigator.userAgent.indexOf("Opera") >= 0);
    window.dhx4.isChrome = (navigator.userAgent.indexOf("Chrome") >= 0);
    window.dhx4.isKHTML = (navigator.userAgent.indexOf("Safari") >= 0 || navigator.userAgent.indexOf("Konqueror") >= 0);
    window.dhx4.isFF = (navigator.userAgent.indexOf("Firefox") >= 0);
    window.dhx4.isIPad = (navigator.userAgent.search(/iPad/gi) >= 0)
}
if (typeof (window.dhx4.ajax) == "undefined") {
    window.dhx4.ajax = {
        cache: false,
        method: "post",
        get: function (a, c) {
            this._call("GET", a, null, true, c)
        },
        getSync: function (a) {
            return this._call("GET", a, null, false)
        },
        post: function (c, a, g) {
            if (arguments.length == 1) {
                a = ""
            } else {
                if (arguments.length == 2 && (typeof (a) == "function" || typeof (window[a]) == "function")) {
                    g = a;
                    a = ""
                } else {
                    a = String(a)
                }
            }
            this._call("POST", c, a, true, g)
        },
        postSync: function (c, a) {
            a = (a == null ? "" : String(a));
            return this._call("POST", c, a, false)
        },
        getLong: function (a, c) {
            this._call("GET", a, null, true, c, {
                url: a
            })
        },
        postLong: function (c, a, g) {
            if (arguments.length == 2 && (typeof (a) == "function" || typeof (window[a]))) {
                g = a;
                a = ""
            }
            this._call("POST", c, a, true, g, {
                url: c,
                postData: a
            })
        },
        _call: function (n, c, a, l, j, h) {
            var g = (window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP"));
            var m = (navigator.userAgent.match(/AppleWebKit/) != null && navigator.userAgent.match(/Qt/) != null && navigator.userAgent.match(/Safari/) != null);
            if (l == true) {
                g.onreadystatechange = function () {
                    if ((g.readyState == 4 && g.status == 200) || (m == true && g.readyState == 3)) {
                        window.setTimeout(function () {
                            if (typeof (j) == "function") {
                                j.apply(window, [{
                                    xmlDoc: g
                                }])
                            }
                            if (h != null) {
                                if (typeof (h.postData) != "undefined") {
                                    dhx4.ajax.postLong(h.url, h.postData, j)
                                } else {
                                    dhx4.ajax.getLong(h.url, j)
                                }
                            }
                            j = null;
                            g = null
                        }, 1)
                    }
                }
            }
            if (n == "GET" && this.cache != true) {
                c += (c.indexOf("?") >= 0 ? "&" : "?") + "dhxr" + new Date().getTime()
            }
            g.open(n, c, l);
            if (n == "POST") {
                g.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                if (this.cache != true) {
                    a += (a.length > 0 ? "&" : "") + "dhxr" + new Date().getTime()
                }
            } else {
                a = null
            }
            g.setRequestHeader("X-Requested-With", "XMLHttpRequest");
            g.send(a);
            if (!l) {
                return {
                    xmlDoc: g
                }
            }
        }
    }
}
if (typeof (window.dhx4._enableDataLoading) == "undefined") {
    window.dhx4._enableDataLoading = function (obj, initObj, xmlToJson, xmlRootTag, mode) {
        if (mode == "clear") {
            for (var a in obj._dhxdataload) {
                obj._dhxdataload[a] = null;
                delete obj._dhxdataload[a]
            }
            obj._loadData = null;
            obj._dhxdataload = null;
            obj.load = null;
            obj.loadStruct = null;
            obj = null;
            return
        }
        obj._dhxdataload = {
            initObj: initObj,
            xmlToJson: xmlToJson,
            xmlRootTag: xmlRootTag,
            onBeforeXLS: null
        };
        obj._loadData = function (data, loadParams, onLoad) {
            if (arguments.length == 2) {
                onLoad = loadParams;
                loadParams = null
            }
            var obj = null;
            if (arguments.length == 3) {
                onLoad = arguments[2]
            }
            if (typeof (data) == "string") {
                var k = data.replace(/^\s{1,}/, "").replace(/\s{1,}$/, "");
                var tag = new RegExp("^<" + this._dhxdataload.xmlRootTag);
                if (tag.test(k.replace(/^<\?xml[^\?]*\?>\s*/, ""))) {
                    if (window.DOMParser) {
                        obj = (new window.DOMParser()).parseFromString(data, "text/xml")
                    } else {
                        if (typeof (window.ActiveXObject) != "undefined") {
                            obj = new window.ActiveXObject("Microsoft.XMLDOM");
                            obj.async = "false";
                            obj.loadXML(data)
                        }
                    }
                    if (obj != null) {
                        obj = this[this._dhxdataload.xmlToJson].apply(this, [obj])
                    }
                }
                if (obj == null && (k.match(/^\{.*\}$/) != null || k.match(/^\[.*\]$/) != null)) {
                    try {
                        eval("dhx4.temp=" + k)
                    } catch (e) {
                        dhx4.temp = null
                    }
                    obj = dhx4.temp;
                    dhx4.temp = null
                }
                if (obj == null) {
                    this.callEvent("onXLS", []);
                    var params = [];
                    if (typeof (this._dhxdataload.onBeforeXLS) == "function") {
                        var k = this._dhxdataload.onBeforeXLS.apply(this, [data]);
                        if (k != null && typeof (k) == "object") {
                            if (k.url != null) {
                                data = k.url
                            }
                            if (k.params != null) {
                                for (var a in k.params) {
                                    params.push(a + "=" + encodeURIComponent(k.params[a]))
                                }
                            }
                        }
                    }
                    var t = this;
                    var callBack = function (r) {
                            var obj = null;
                            if ((r.xmlDoc.getResponseHeader("Content-Type") || "").search(/xml/gi) >= 0 || (r.xmlDoc.responseText.replace(/^\s{1,}/, "")).match(/^</) != null) {
                                obj = t[t._dhxdataload.xmlToJson].apply(t, [r.xmlDoc.responseXML])
                            } else {
                                try {
                                    eval("dhx4.temp=" + r.xmlDoc.responseText)
                                } catch (e) {
                                    dhx4.temp = null
                                }
                                obj = dhx4.temp;
                                dhx4.temp = null
                            }
                            if (obj != null) {
                                t[t._dhxdataload.initObj].apply(t, [obj, data])
                            }
                            t.callEvent("onXLE", []);
                            if (onLoad != null) {
                                if (typeof (onLoad) == "function") {
                                    onLoad.apply(t, [])
                                } else {
                                    if (typeof (window[onLoad]) == "function") {
                                        window[onLoad].apply(t, [])
                                    }
                                }
                            }
                            callBack = onLoad = null;
                            obj = r = t = null
                        };
                    params = params.join("&") + (typeof (loadParams) == "string" ? "&" + loadParams : "");
                    if (dhx4.ajax.method == "post") {
                        dhx4.ajax.post(data, params, callBack)
                    } else {
                        if (dhx4.ajax.method == "get") {
                            dhx4.ajax.get(data + (data.indexOf("?") > 0 ? "" : "") + params, callBack)
                        }
                    }
                    return
                }
            } else {
                if (typeof (data.documentElement) == "object" || (typeof (data.tagName) != "undefined" && typeof (data.getElementsByTagName) != "undefined" && data.getElementsByTagName(this._dhxdataload.xmlRootTag).length > 0)) {
                    obj = this[this._dhxdataload.xmlToJson].apply(this, [data])
                } else {
                    obj = window.dhx4._copyObj(data)
                }
            }
            if (obj != null) {
                this[this._dhxdataload.initObj].apply(this, [obj])
            }
            if (onLoad != null) {
                if (typeof (onLoad) == "function") {
                    onLoad.apply(this, [])
                } else {
                    if (typeof (window[onLoad]) == "function") {
                        window[onLoad].apply(this, [])
                    }
                }
                onLoad = null
            }
        };
        if (mode != null) {
            var k = {
                struct: "loadStruct",
                data: "load"
            };
            for (var a in mode) {
                if (mode[a] == true) {
                    obj[k[a]] = function () {
                        return this._loadData.apply(this, arguments)
                    }
                }
            }
        }
        obj = null
    }
}
if (typeof (window.dhx4._eventable) == "undefined") {
    window.dhx4._eventable = function (a, c) {
        if (c == "clear") {
            a.detachAllEvents();
            a.dhxevs = null;
            a.attachEvent = null;
            a.detachEvent = null;
            a.checkEvent = null;
            a.callEvent = null;
            a.detachAllEvents = null;
            a = null;
            return
        }
        a.dhxevs = {
            data: {}
        };
        a.attachEvent = function (g, j) {
            g = String(g).toLowerCase();
            if (!this.dhxevs.data[g]) {
                this.dhxevs.data[g] = {}
            }
            var h = window.dhx4.newId();
            this.dhxevs.data[g][h] = j;
            return h
        };
        a.detachEvent = function (l) {
            for (var h in this.dhxevs.data) {
                var j = 0;
                for (var g in this.dhxevs.data[h]) {
                    if (g == l) {
                        this.dhxevs.data[h][g] = null;
                        delete this.dhxevs.data[h][g]
                    } else {
                        j++
                    }
                }
                if (j == 0) {
                    this.dhxevs.data[h] = null;
                    delete this.dhxevs.data[h]
                }
            }
        };
        a.checkEvent = function (g) {
            g = String(g).toLowerCase();
            return (this.dhxevs.data[g] != null)
        };
        a.callEvent = function (h, l) {
            h = String(h).toLowerCase();
            if (this.dhxevs.data[h] == null) {
                return true
            }
            var j = true;
            for (var g in this.dhxevs.data[h]) {
                j = this.dhxevs.data[h][g].apply(this, l) && j
            }
            return j
        };
        a.detachAllEvents = function () {
            for (var h in this.dhxevs.data) {
                for (var g in this.dhxevs.data[h]) {
                    this.dhxevs.data[h][g] = null;
                    delete this.dhxevs.data[h][g]
                }
                this.dhxevs.data[h] = null;
                delete this.dhxevs.data[h]
            }
        };
        a = null
    }
}
dhtmlx = function (g) {
    for (var c in g) {
        dhtmlx[c] = g[c]
    }
    return dhtmlx
};
dhtmlx.extend_api = function (a, h, g) {
    var c = window[a];
    if (!c) {
        return
    }
    window[a] = function (m) {
        if (m && typeof m == "object" && !m.tagName) {
            var l = c.apply(this, (h._init ? h._init(m) : arguments));
            for (var j in dhtmlx) {
                if (h[j]) {
                    this[h[j]](dhtmlx[j])
                }
            }
            for (var j in m) {
                if (h[j]) {
                    this[h[j]](m[j])
                } else {
                    if (j.indexOf("on") == 0) {
                        this.attachEvent(j, m[j])
                    }
                }
            }
        } else {
            var l = c.apply(this, arguments)
        }
        if (h._patch) {
            h._patch(this)
        }
        return l || this
    };
    window[a].prototype = c.prototype;
    if (g) {
        dhtmlXHeir(window[a].prototype, g)
    }
};
dhtmlxAjax = {
    get: function (a, g) {
        var c = new dtmlXMLLoaderObject(true);
        c.async = (arguments.length < 3);
        c.waitCall = g;
        c.loadXML(a);
        return c
    },
    post: function (a, g, h) {
        var c = new dtmlXMLLoaderObject(true);
        c.async = (arguments.length < 4);
        c.waitCall = h;
        c.loadXML(a, true, g);
        return c
    },
    getSync: function (a) {
        return this.get(a, null, true)
    },
    postSync: function (a, c) {
        return this.post(a, c, null, true)
    }
};

function dtmlXMLLoaderObject(c, h, g, a) {
    this.xmlDoc = "";
    if (typeof (g) != "undefined") {
        this.async = g
    } else {
        this.async = true
    }
    this.onloadAction = c || null;
    this.mainObject = h || null;
    this.waitCall = null;
    this.rSeed = a || false;
    return this
}
dtmlXMLLoaderObject.count = 0;
dtmlXMLLoaderObject.prototype.waitLoadFunction = function (c) {
    var a = true;
    this.check = function () {
        if ((c) && (c.onloadAction != null)) {
            if ((!c.xmlDoc.readyState) || (c.xmlDoc.readyState == 4)) {
                if (!a) {
                    return
                }
                a = false;
                dtmlXMLLoaderObject.count++;
                if (typeof c.onloadAction == "function") {
                    c.onloadAction(c.mainObject, null, null, null, c)
                }
                if (c.waitCall) {
                    c.waitCall.call(this, c);
                    c.waitCall = null
                }
            }
        }
    };
    return this.check
};
dtmlXMLLoaderObject.prototype.getXMLTopNode = function (g, a) {
    if (typeof this.xmlDoc.status == "undefined" || this.xmlDoc.status < 400) {
        if (this.xmlDoc.responseXML) {
            var c = this.xmlDoc.responseXML.getElementsByTagName(g);
            if (c.length == 0 && g.indexOf(":") != -1) {
                var c = this.xmlDoc.responseXML.getElementsByTagName((g.split(":"))[1])
            }
            var h = c[0]
        } else {
            var h = this.xmlDoc.documentElement
        }
        if (h) {
            this._retry = false;
            return h
        }
        if (!this._retry && _isIE) {
            this._retry = true;
            var a = this.xmlDoc;
            this.loadXMLString(this.xmlDoc.responseText.replace(/^[\s]+/, ""), true);
            return this.getXMLTopNode(g, a)
        }
    }
    dhtmlxError.throwError("LoadXML", "Incorrect XML", [(a || this.xmlDoc), this.mainObject]);
    return document.createElement("DIV")
};
dtmlXMLLoaderObject.prototype.loadXMLString = function (c, a) {
    if (!_isIE) {
        var g = new DOMParser();
        this.xmlDoc = g.parseFromString(c, "text/xml")
    } else {
        this.xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
        this.xmlDoc.async = this.async;
        this.xmlDoc.onreadystatechange = function () {};
        this.xmlDoc.loadXML(c)
    }
    if (a) {
        return
    }
    if (this.onloadAction) {
        this.onloadAction(this.mainObject, null, null, null, this)
    }
    if (this.waitCall) {
        this.waitCall();
        this.waitCall = null
    }
};
dtmlXMLLoaderObject.prototype.loadXML = function (g, c, a, h) {
    if (this.rSeed) {
        g += ((g.indexOf("?") != -1) ? "&" : "?") + "a_dhx_rSeed=" + (new Date()).valueOf()
    }
    this.filePath = g;
    if ((!_isIE) && (window.XMLHttpRequest)) {
        this.xmlDoc = new XMLHttpRequest()
    } else {
        this.xmlDoc = new ActiveXObject("Microsoft.XMLHTTP")
    }
    if (this.async) {
        this.xmlDoc.onreadystatechange = new this.waitLoadFunction(this)
    }
    this.xmlDoc.open(c ? "POST" : "GET", g, this.async);
    if (h) {
        this.xmlDoc.setRequestHeader("User-Agent", "dhtmlxRPC v0.1 (" + navigator.userAgent + ")");
        this.xmlDoc.setRequestHeader("Content-type", "text/xml")
    } else {
        if (c) {
            this.xmlDoc.setRequestHeader("Content-type", (this.contenttype || "application/x-www-form-urlencoded"))
        }
    }
    this.xmlDoc.setRequestHeader("X-Requested-With", "XMLHttpRequest");
    this.xmlDoc.send(null || a);
    if (!this.async) {
        (new this.waitLoadFunction(this))()
    }
};
dtmlXMLLoaderObject.prototype.destructor = function () {
    this._filterXPath = null;
    this._getAllNamedChilds = null;
    this._retry = null;
    this.async = null;
    this.rSeed = null;
    this.filePath = null;
    this.onloadAction = null;
    this.mainObject = null;
    this.xmlDoc = null;
    this.doXPath = null;
    this.doXPathOpera = null;
    this.doXSLTransToObject = null;
    this.doXSLTransToString = null;
    this.loadXML = null;
    this.loadXMLString = null;
    this.doSerialization = null;
    this.xmlNodeToJSON = null;
    this.getXMLTopNode = null;
    this.setXSLParamValue = null;
    return null
};
dtmlXMLLoaderObject.prototype.xmlNodeToJSON = function (h) {
    var g = {};
    for (var c = 0; c < h.attributes.length; c++) {
        g[h.attributes[c].name] = h.attributes[c].value
    }
    g._tagvalue = h.firstChild ? h.firstChild.nodeValue : "";
    for (var c = 0; c < h.childNodes.length; c++) {
        var a = h.childNodes[c].tagName;
        if (a) {
            if (!g[a]) {
                g[a] = []
            }
            g[a].push(this.xmlNodeToJSON(h.childNodes[c]))
        }
    }
    return g
};

function callerFunction(a, c) {
    this.handler = function (g) {
        if (!g) {
            g = window.event
        }
        a(g, c);
        return true
    };
    return this.handler
}
function getAbsoluteLeft(a) {
    return getOffset(a).left
}
function getAbsoluteTop(a) {
    return getOffset(a).top
}
function getOffsetSum(a) {
    var g = 0,
        c = 0;
    while (a) {
        g = g + parseInt(a.offsetTop);
        c = c + parseInt(a.offsetLeft);
        a = a.offsetParent
    }
    return {
        top: g,
        left: c
    }
}
function getOffsetRect(h) {
    var m = h.getBoundingClientRect();
    var n = document.body;
    var c = document.documentElement;
    var a = window.pageYOffset || c.scrollTop || n.scrollTop;
    var j = window.pageXOffset || c.scrollLeft || n.scrollLeft;
    var l = c.clientTop || n.clientTop || 0;
    var o = c.clientLeft || n.clientLeft || 0;
    var q = m.top + a - l;
    var g = m.left + j - o;
    return {
        top: Math.round(q),
        left: Math.round(g)
    }
}
function getOffset(a) {
    if (a.getBoundingClientRect) {
        return getOffsetRect(a)
    } else {
        return getOffsetSum(a)
    }
}
function convertStringToBoolean(a) {
    if (typeof (a) == "string") {
        a = a.toLowerCase()
    }
    switch (a) {
    case "1":
    case "true":
    case "yes":
    case "y":
    case 1:
    case true:
        return true;
        break;
    default:
        return false
    }
}
function getUrlSymbol(a) {
    if (a.indexOf("?") != -1) {
        return "&"
    } else {
        return "?"
    }
}
function dhtmlDragAndDropObject() {
    if (window.dhtmlDragAndDrop) {
        return window.dhtmlDragAndDrop
    }
    this.lastLanding = 0;
    this.dragNode = 0;
    this.dragStartNode = 0;
    this.dragStartObject = 0;
    this.tempDOMU = null;
    this.tempDOMM = null;
    this.waitDrag = 0;
    window.dhtmlDragAndDrop = this;
    return this
}
dhtmlDragAndDropObject.prototype.removeDraggableItem = function (a) {
    a.onmousedown = null;
    a.dragStarter = null;
    a.dragLanding = null
};
dhtmlDragAndDropObject.prototype.addDraggableItem = function (a, c) {
    a.onmousedown = this.preCreateDragCopy;
    a.dragStarter = c;
    this.addDragLanding(a, c)
};
dhtmlDragAndDropObject.prototype.addDragLanding = function (a, c) {
    a.dragLanding = c
};
dhtmlDragAndDropObject.prototype.preCreateDragCopy = function (a) {
    if ((a || window.event) && (a || event).button == 2) {
        return
    }
    if (window.dhtmlDragAndDrop.waitDrag) {
        window.dhtmlDragAndDrop.waitDrag = 0;
        document.body.onmouseup = window.dhtmlDragAndDrop.tempDOMU;
        document.body.onmousemove = window.dhtmlDragAndDrop.tempDOMM;
        return false
    }
    if (window.dhtmlDragAndDrop.dragNode) {
        window.dhtmlDragAndDrop.stopDrag(a)
    }
    window.dhtmlDragAndDrop.waitDrag = 1;
    window.dhtmlDragAndDrop.tempDOMU = document.body.onmouseup;
    window.dhtmlDragAndDrop.tempDOMM = document.body.onmousemove;
    window.dhtmlDragAndDrop.dragStartNode = this;
    window.dhtmlDragAndDrop.dragStartObject = this.dragStarter;
    document.body.onmouseup = window.dhtmlDragAndDrop.preCreateDragCopy;
    document.body.onmousemove = window.dhtmlDragAndDrop.callDrag;
    window.dhtmlDragAndDrop.downtime = new Date().valueOf();
    if ((a) && (a.preventDefault)) {
        a.preventDefault();
        return false
    }
    return false
};
dhtmlDragAndDropObject.prototype.callDrag = function (g) {
    if (!g) {
        g = window.event
    }
    dragger = window.dhtmlDragAndDrop;
    if ((new Date()).valueOf() - dragger.downtime < 100) {
        return
    }
    if (!dragger.dragNode) {
        if (dragger.waitDrag) {
            dragger.dragNode = dragger.dragStartObject._createDragNode(dragger.dragStartNode, g);
            if (!dragger.dragNode) {
                return dragger.stopDrag()
            }
            dragger.dragNode.onselectstart = function () {
                return false
            };
            dragger.gldragNode = dragger.dragNode;
            document.body.appendChild(dragger.dragNode);
            document.body.onmouseup = dragger.stopDrag;
            dragger.waitDrag = 0;
            dragger.dragNode.pWindow = window;
            dragger.initFrameRoute()
        } else {
            return dragger.stopDrag(g, true)
        }
    }
    if (dragger.dragNode.parentNode != window.document.body && dragger.gldragNode) {
        var a = dragger.gldragNode;
        if (dragger.gldragNode.old) {
            a = dragger.gldragNode.old
        }
        a.parentNode.removeChild(a);
        var c = dragger.dragNode.pWindow;
        if (a.pWindow && a.pWindow.dhtmlDragAndDrop.lastLanding) {
            a.pWindow.dhtmlDragAndDrop.lastLanding.dragLanding._dragOut(a.pWindow.dhtmlDragAndDrop.lastLanding)
        }
        if (_isIE) {
            var j = document.createElement("Div");
            j.innerHTML = dragger.dragNode.outerHTML;
            dragger.dragNode = j.childNodes[0]
        } else {
            dragger.dragNode = dragger.dragNode.cloneNode(true)
        }
        dragger.dragNode.pWindow = window;
        dragger.gldragNode.old = dragger.dragNode;
        document.body.appendChild(dragger.dragNode);
        c.dhtmlDragAndDrop.dragNode = dragger.dragNode
    }
    dragger.dragNode.style.left = g.clientX + 15 + (dragger.fx ? dragger.fx * (-1) : 0) + (document.body.scrollLeft || document.documentElement.scrollLeft) + "px";
    dragger.dragNode.style.top = g.clientY + 3 + (dragger.fy ? dragger.fy * (-1) : 0) + (document.body.scrollTop || document.documentElement.scrollTop) + "px";
    if (!g.srcElement) {
        var h = g.target
    } else {
        h = g.srcElement
    }
    dragger.checkLanding(h, g)
};
dhtmlDragAndDropObject.prototype.calculateFramePosition = function (j) {
    if (window.name) {
        var g = parent.frames[window.name].frameElement.offsetParent;
        var h = 0;
        var c = 0;
        while (g) {
            h += g.offsetLeft;
            c += g.offsetTop;
            g = g.offsetParent
        }
        if ((parent.dhtmlDragAndDrop)) {
            var a = parent.dhtmlDragAndDrop.calculateFramePosition(1);
            h += a.split("_")[0] * 1;
            c += a.split("_")[1] * 1
        }
        if (j) {
            return h + "_" + c
        } else {
            this.fx = h
        }
        this.fy = c
    }
    return "0_0"
};
dhtmlDragAndDropObject.prototype.checkLanding = function (c, a) {
    if ((c) && (c.dragLanding)) {
        if (this.lastLanding) {
            this.lastLanding.dragLanding._dragOut(this.lastLanding)
        }
        this.lastLanding = c;
        this.lastLanding = this.lastLanding.dragLanding._dragIn(this.lastLanding, this.dragStartNode, a.clientX, a.clientY, a);
        this.lastLanding_scr = (_isIE ? a.srcElement : a.target)
    } else {
        if ((c) && (c.tagName != "BODY")) {
            this.checkLanding(c.parentNode, a)
        } else {
            if (this.lastLanding) {
                this.lastLanding.dragLanding._dragOut(this.lastLanding, a.clientX, a.clientY, a)
            }
            this.lastLanding = 0;
            if (this._onNotFound) {
                this._onNotFound()
            }
        }
    }
};
dhtmlDragAndDropObject.prototype.stopDrag = function (c, g) {
    dragger = window.dhtmlDragAndDrop;
    if (!g) {
        dragger.stopFrameRoute();
        var a = dragger.lastLanding;
        dragger.lastLanding = null;
        if (a) {
            a.dragLanding._drag(dragger.dragStartNode, dragger.dragStartObject, a, (_isIE ? event.srcElement : c.target))
        }
    }
    dragger.lastLanding = null;
    if ((dragger.dragNode) && (dragger.dragNode.parentNode == document.body)) {
        dragger.dragNode.parentNode.removeChild(dragger.dragNode)
    }
    dragger.dragNode = 0;
    dragger.gldragNode = 0;
    dragger.fx = 0;
    dragger.fy = 0;
    dragger.dragStartNode = 0;
    dragger.dragStartObject = 0;
    document.body.onmouseup = dragger.tempDOMU;
    document.body.onmousemove = dragger.tempDOMM;
    dragger.tempDOMU = null;
    dragger.tempDOMM = null;
    dragger.waitDrag = 0
};
dhtmlDragAndDropObject.prototype.stopFrameRoute = function (g) {
    if (g) {
        window.dhtmlDragAndDrop.stopDrag(1, 1)
    }
    for (var a = 0; a < window.frames.length; a++) {
        try {
            if ((window.frames[a] != g) && (window.frames[a].dhtmlDragAndDrop)) {
                window.frames[a].dhtmlDragAndDrop.stopFrameRoute(window)
            }
        } catch (c) {}
    }
    try {
        if ((parent.dhtmlDragAndDrop) && (parent != window) && (parent != g)) {
            parent.dhtmlDragAndDrop.stopFrameRoute(window)
        }
    } catch (c) {}
};
dhtmlDragAndDropObject.prototype.initFrameRoute = function (g, h) {
    if (g) {
        window.dhtmlDragAndDrop.preCreateDragCopy();
        window.dhtmlDragAndDrop.dragStartNode = g.dhtmlDragAndDrop.dragStartNode;
        window.dhtmlDragAndDrop.dragStartObject = g.dhtmlDragAndDrop.dragStartObject;
        window.dhtmlDragAndDrop.dragNode = g.dhtmlDragAndDrop.dragNode;
        window.dhtmlDragAndDrop.gldragNode = g.dhtmlDragAndDrop.dragNode;
        window.document.body.onmouseup = window.dhtmlDragAndDrop.stopDrag;
        window.waitDrag = 0;
        if (((!_isIE) && (h)) && ((!_isFF) || (_FFrv < 1.8))) {
            window.dhtmlDragAndDrop.calculateFramePosition()
        }
    }
    try {
        if ((parent.dhtmlDragAndDrop) && (parent != window) && (parent != g)) {
            parent.dhtmlDragAndDrop.initFrameRoute(window)
        }
    } catch (c) {}
    for (var a = 0; a < window.frames.length; a++) {
        try {
            if ((window.frames[a] != g) && (window.frames[a].dhtmlDragAndDrop)) {
                window.frames[a].dhtmlDragAndDrop.initFrameRoute(window, ((!g || h) ? 1 : 0))
            }
        } catch (c) {}
    }
};
_isFF = false;
_isIE = false;
_isOpera = false;
_isKHTML = false;
_isMacOS = false;
_isChrome = false;
_FFrv = false;
_KHTMLrv = false;
_OperaRv = false;
if (navigator.userAgent.indexOf("Macintosh") != -1) {
    _isMacOS = true
}
if (navigator.userAgent.toLowerCase().indexOf("chrome") > -1) {
    _isChrome = true
}
if ((navigator.userAgent.indexOf("Safari") != -1) || (navigator.userAgent.indexOf("Konqueror") != -1)) {
    _KHTMLrv = parseFloat(navigator.userAgent.substr(navigator.userAgent.indexOf("Safari") + 7, 5));
    if (_KHTMLrv > 525) {
        _isFF = true;
        _FFrv = 1.9
    } else {
        _isKHTML = true
    }
} else {
    if (navigator.userAgent.indexOf("Opera") != -1) {
        _isOpera = true;
        _OperaRv = parseFloat(navigator.userAgent.substr(navigator.userAgent.indexOf("Opera") + 6, 3))
    } else {
        if (navigator.appName.indexOf("Microsoft") != -1) {
            _isIE = true;
            if ((navigator.appVersion.indexOf("MSIE 8.0") != -1 || navigator.appVersion.indexOf("MSIE 9.0") != -1 || navigator.appVersion.indexOf("MSIE 10.0") != -1 || document.documentMode > 7) && document.compatMode != "BackCompat") {
                _isIE = 8
            }
        } else {
            if (navigator.appName == "Netscape" && navigator.userAgent.indexOf("Trident") != -1) {
                _isIE = 8
            } else {
                _isFF = true;
                _FFrv = parseFloat(navigator.userAgent.split("rv:")[1])
            }
        }
    }
}
dtmlXMLLoaderObject.prototype.doXPath = function (g, j, h, o) {
    if (_isKHTML || (!_isIE && !window.XPathResult)) {
        return this.doXPathOpera(g, j)
    }
    if (_isIE) {
        if (!j) {
            if (!this.xmlDoc.nodeName) {
                j = this.xmlDoc.responseXML
            } else {
                j = this.xmlDoc
            }
        }
        if (!j) {
            dhtmlxError.throwError("LoadXML", "Incorrect XML", [(j || this.xmlDoc), this.mainObject])
        }
        if (h != null) {
            j.setProperty("SelectionNamespaces", "xmlns:xsl='" + h + "'")
        }
        if (o == "single") {
            return j.selectSingleNode(g)
        } else {
            return j.selectNodes(g) || new Array(0)
        }
    } else {
        var a = j;
        if (!j) {
            if (!this.xmlDoc.nodeName) {
                j = this.xmlDoc.responseXML
            } else {
                j = this.xmlDoc
            }
        }
        if (!j) {
            dhtmlxError.throwError("LoadXML", "Incorrect XML", [(j || this.xmlDoc), this.mainObject])
        }
        if (j.nodeName.indexOf("document") != -1) {
            a = j
        } else {
            a = j;
            j = j.ownerDocument
        }
        var m = XPathResult.ANY_TYPE;
        if (o == "single") {
            m = XPathResult.FIRST_ORDERED_NODE_TYPE
        }
        var l = new Array();
        var c = j.evaluate(g, a, function (q) {
            return h
        }, m, null);
        if (m == XPathResult.FIRST_ORDERED_NODE_TYPE) {
            return c.singleNodeValue
        }
        var n = c.iterateNext();
        while (n) {
            l[l.length] = n;
            n = c.iterateNext()
        }
        return l
    }
};

function _dhtmlxError(c, a, g) {
    if (!this.catches) {
        this.catches = new Array()
    }
    return this
}
_dhtmlxError.prototype.catchError = function (c, a) {
    this.catches[c] = a
};
_dhtmlxError.prototype.throwError = function (c, a, g) {
    if (this.catches[c]) {
        return this.catches[c](c, a, g)
    }
    if (this.catches.ALL) {
        return this.catches.ALL(c, a, g)
    }
    alert("Error type: " + arguments[0] + "\nDescription: " + arguments[1]);
    return null
};
window.dhtmlxError = new _dhtmlxError();
dtmlXMLLoaderObject.prototype.doXPathOpera = function (g, a) {
    var j = g.replace(/[\/]+/gi, "/").split("/");
    var h = null;
    var c = 1;
    if (!j.length) {
        return []
    }
    if (j[0] == ".") {
        h = [a]
    } else {
        if (j[0] == "") {
            h = (this.xmlDoc.responseXML || this.xmlDoc).getElementsByTagName(j[c].replace(/\[[^\]]*\]/g, ""));
            c++
        } else {
            return []
        }
    }
    for (c; c < j.length; c++) {
        h = this._getAllNamedChilds(h, j[c])
    }
    if (j[c - 1].indexOf("[") != -1) {
        h = this._filterXPath(h, j[c - 1])
    }
    return h
};
dtmlXMLLoaderObject.prototype._filterXPath = function (h, g) {
    var l = new Array();
    var g = g.replace(/[^\[]*\[\@/g, "").replace(/[\[\]\@]*/g, "");
    for (var j = 0; j < h.length; j++) {
        if (h[j].getAttribute(g)) {
            l[l.length] = h[j]
        }
    }
    return l
};
dtmlXMLLoaderObject.prototype._getAllNamedChilds = function (h, g) {
    var n = new Array();
    if (_isKHTML) {
        g = g.toUpperCase()
    }
    for (var m = 0; m < h.length; m++) {
        for (var l = 0; l < h[m].childNodes.length; l++) {
            if (_isKHTML) {
                if (h[m].childNodes[l].tagName && h[m].childNodes[l].tagName.toUpperCase() == g) {
                    n[n.length] = h[m].childNodes[l]
                }
            } else {
                if (h[m].childNodes[l].tagName == g) {
                    n[n.length] = h[m].childNodes[l]
                }
            }
        }
    }
    return n
};

function dhtmlXHeir(h, g) {
    for (var j in g) {
        if (typeof (g[j]) == "function") {
            h[j] = g[j]
        }
    }
    return h
}
function dhtmlxEvent(c, g, a) {
    if (c.addEventListener) {
        c.addEventListener(g, a, false)
    } else {
        if (c.attachEvent) {
            c.attachEvent("on" + g, a)
        }
    }
}
dtmlXMLLoaderObject.prototype.xslDoc = null;
dtmlXMLLoaderObject.prototype.setXSLParamValue = function (c, g, h) {
    if (!h) {
        h = this.xslDoc
    }
    if (h.responseXML) {
        h = h.responseXML
    }
    var a = this.doXPath("/xsl:stylesheet/xsl:variable[@name='" + c + "']", h, "http://www.w3.org/1999/XSL/Transform", "single");
    if (a != null) {
        a.firstChild.nodeValue = g
    }
};
dtmlXMLLoaderObject.prototype.doXSLTransToObject = function (h, c) {
    if (!h) {
        h = this.xslDoc
    }
    if (h.responseXML) {
        h = h.responseXML
    }
    if (!c) {
        c = this.xmlDoc
    }
    if (c.responseXML) {
        c = c.responseXML
    }
    if (!_isIE) {
        if (!this.XSLProcessor) {
            this.XSLProcessor = new XSLTProcessor();
            this.XSLProcessor.importStylesheet(h)
        }
        var a = this.XSLProcessor.transformToDocument(c)
    } else {
        var a = new ActiveXObject("Msxml2.DOMDocument.3.0");
        try {
            c.transformNodeToObject(h, a)
        } catch (g) {
            a = c.transformNode(h)
        }
    }
    return a
};
dtmlXMLLoaderObject.prototype.doXSLTransToString = function (g, c) {
    var a = this.doXSLTransToObject(g, c);
    if (typeof (a) == "string") {
        return a
    }
    return this.doSerialization(a)
};
dtmlXMLLoaderObject.prototype.doSerialization = function (c) {
    if (!c) {
        c = this.xmlDoc
    }
    if (c.responseXML) {
        c = c.responseXML
    }
    if (!_isIE) {
        var a = new XMLSerializer();
        return a.serializeToString(c)
    } else {
        return c.xml
    }
};
dhtmlxEventable = function (obj) {
    obj.attachEvent = function (name, catcher, callObj) {
        name = "ev_" + name.toLowerCase();
        if (!this[name]) {
            this[name] = new this.eventCatcher(callObj || this)
        }
        return (name + ":" + this[name].addEvent(catcher))
    };
    obj.callEvent = function (name, arg0) {
        name = "ev_" + name.toLowerCase();
        if (this[name]) {
            return this[name].apply(this, arg0)
        }
        return true
    };
    obj.checkEvent = function (name) {
        return ( !! this["ev_" + name.toLowerCase()])
    };
    obj.eventCatcher = function (obj) {
        var dhx_catch = [];
        var z = function () {
                var res = true;
                for (var i = 0; i < dhx_catch.length; i++) {
                    if (dhx_catch[i] != null) {
                        var zr = dhx_catch[i].apply(obj, arguments);
                        res = res && zr
                    }
                }
                return res
            };
        z.addEvent = function (ev) {
            if (typeof (ev) != "function") {
                ev = eval(ev)
            }
            if (ev) {
                return dhx_catch.push(ev) - 1
            }
            return false
        };
        z.removeEvent = function (id) {
            dhx_catch[id] = null
        };
        return z
    };
    obj.detachEvent = function (id) {
        if (id != false) {
            var list = id.split(":");
            this[list[0]].removeEvent(list[1])
        }
    };
    obj.detachAllEvents = function () {
        for (var name in this) {
            if (name.indexOf("ev_") == 0) {
                this.detachEvent(name);
                this[name] = null
            }
        }
    };
    obj = null
};
if (!window.dhtmlx) {
    dhtmlx = {}
}
dhtmlx.assert = function (c, a) {
    if (!c) {
        dhtmlx.error(a)
    }
};
dhtmlx.assert_enabled = function () {
    return false
};
dhtmlx.assert_event = function (l, g) {
    if (!l._event_check) {
        l._event_check = {};
        l._event_check_size = {}
    }
    for (var c in g) {
        l._event_check[c.toLowerCase()] = g[c];
        var j = -1;
        for (var h in g[c]) {
            j++
        }
        l._event_check_size[c.toLowerCase()] = j
    }
};
dhtmlx.assert_method_info = function (j, c, h, l) {
    var a = [];
    for (var g = 0; g < l.length; g++) {
        a.push(l[g][0] + " : " + l[g][1] + "\n   " + l[g][2].describe() + (l[g][3] ? "; optional" : ""))
    }
    return j.name + "." + c + "\n" + h + "\n Arguments:\n - " + a.join("\n - ")
};
dhtmlx.assert_method = function (g, a) {
    for (var c in a) {
        dhtmlx.assert_method_process(g, c, a[c].descr, a[c].args, (a[c].min || 99), a[c].skip)
    }
};
dhtmlx.assert_method_process = function (l, c, j, m, g, h) {
    var a = l[c];
    if (!h) {
        l[c] = function () {
            if (arguments.length != m.length && arguments.length < g) {
                dhtmlx.log("warn", "Incorrect count of parameters\n" + l[c].describe() + "\n\nExpecting " + m.length + " but have only " + arguments.length)
            } else {
                for (var n = 0; n < m.length; n++) {
                    if (!m[n][3] && !m[n][2](arguments[n])) {
                        dhtmlx.log("warn", "Incorrect method call\n" + l[c].describe() + "\n\nActual value of " + (n + 1) + " parameter: {" + (typeof arguments[n]) + "} " + arguments[n])
                    }
                }
            }
            return a.apply(this, arguments)
        }
    }
    l[c].describe = function () {
        return dhtmlx.assert_method_info(l, c, j, m)
    }
};
dhtmlx.assert_event_call = function (g, c, a) {
    if (g._event_check) {
        if (!g._event_check[c]) {
            dhtmlx.log("warn", "Not expected event call :" + c)
        } else {
            if (dhtmlx.isNotDefined(a)) {
                dhtmlx.log("warn", "Event without parameters :" + c)
            } else {
                if (g._event_check_size[c] != a.length) {
                    dhtmlx.log("warn", "Incorrect event call, expected " + g._event_check_size[c] + " parameter(s), but have " + a.length + " parameter(s), for " + c + " event")
                }
            }
        }
    }
};
dhtmlx.assert_event_attach = function (c, a) {
    if (c._event_check && !c._event_check[a]) {
        dhtmlx.log("warn", "Unknown event name: " + a)
    }
};
dhtmlx.assert_property = function (c, a) {
    if (!c._settings_check) {
        c._settings_check = {}
    }
    dhtmlx.extend(c._settings_check, a)
};
dhtmlx.assert_check = function (g, c) {
    if (typeof g == "object") {
        for (var a in g) {
            dhtmlx.assert_settings(a, g[a], c)
        }
    }
};
dhtmlx.assert_settings = function (n, j, h) {
    h = h || this._settings_check;
    if (h) {
        if (!h[n]) {
            return dhtmlx.log("warn", "Unknown propery: " + n)
        }
        var m = "";
        var c = "";
        var a = false;
        for (var g = 0; g < h[n].length; g++) {
            var l = h[n][g];
            if (typeof l == "string") {
                continue
            }
            if (typeof l == "function") {
                a = a || l(j)
            } else {
                if (typeof l == "object" && typeof l[1] == "function") {
                    a = a || l[1](j);
                    if (a && l[2]) {
                        dhtmlx.assert_check(j, l[2])
                    }
                }
            }
            if (a) {
                break
            }
        }
        if (!a) {
            dhtmlx.log("warn", "Invalid configuration\n" + dhtmlx.assert_info(n, h) + "\nActual value: {" + (typeof j) + "} " + j)
        }
    }
};
dhtmlx.assert_info = function (c, l) {
    var a = l[c];
    var j = "";
    var h = [];
    for (var g = 0; g < a.length; g++) {
        if (typeof rule == "string") {
            j = a[g]
        } else {
            if (a[g].describe) {
                h.push(a[g].describe())
            } else {
                if (a[g][1] && a[g][1].describe) {
                    h.push(a[g][1].describe())
                }
            }
        }
    }
    return "Property: " + c + ", " + j + " \nExpected value: \n - " + h.join("\n - ")
};
if (dhtmlx.assert_enabled()) {
    dhtmlx.assert_rule_color = function (a) {
        if (typeof a != "string") {
            return false
        }
        if (a.indexOf("#") !== 0) {
            return false
        }
        if (a.substr(1).replace(/[0-9A-F]/gi, "") !== "") {
            return false
        }
        return true
    };
    dhtmlx.assert_rule_color.describe = function () {
        return "{String} Value must start from # and contain hexadecimal code of color"
    };
    dhtmlx.assert_rule_template = function (a) {
        if (typeof a == "function") {
            return true
        }
        if (typeof a == "string") {
            return true
        }
        return false
    };
    dhtmlx.assert_rule_template.describe = function () {
        return "{Function},{String} Value must be a function which accepts data object and return text string, or a sting with optional template markers"
    };
    dhtmlx.assert_rule_boolean = function (a) {
        if (typeof a == "boolean") {
            return true
        }
        return false
    };
    dhtmlx.assert_rule_boolean.describe = function () {
        return "{Boolean} true or false"
    };
    dhtmlx.assert_rule_object = function (a, c) {
        if (typeof a == "object") {
            return true
        }
        return false
    };
    dhtmlx.assert_rule_object.describe = function () {
        return "{Object} Configuration object"
    };
    dhtmlx.assert_rule_string = function (a) {
        if (typeof a == "string") {
            return true
        }
        return false
    };
    dhtmlx.assert_rule_string.describe = function () {
        return "{String} Plain string"
    };
    dhtmlx.assert_rule_htmlpt = function (a) {
        return !!dhtmlx.toNode(a)
    };
    dhtmlx.assert_rule_htmlpt.describe = function () {
        return "{Object},{String} HTML node or ID of HTML Node"
    };
    dhtmlx.assert_rule_notdocumented = function (a) {
        return false
    };
    dhtmlx.assert_rule_notdocumented.describe = function () {
        return "This options wasn't documented"
    };
    dhtmlx.assert_rule_key = function (c) {
        var a = function (g) {
                return c[g]
            };
        a.describe = function () {
            var h = [];
            for (var g in c) {
                h.push(g)
            }
            return "{String} can take one of next values: " + h.join(", ")
        };
        return a
    };
    dhtmlx.assert_rule_dimension = function (a) {
        if (a * 1 == a && !isNaN(a) && a >= 0) {
            return true
        }
        return false
    };
    dhtmlx.assert_rule_dimension.describe = function () {
        return "{Integer} value must be a positive number"
    };
    dhtmlx.assert_rule_number = function (a) {
        if (typeof a == "number") {
            return true
        }
        return false
    };
    dhtmlx.assert_rule_number.describe = function () {
        return "{Integer} value must be a number"
    };
    dhtmlx.assert_rule_function = function (a) {
        if (typeof a == "function") {
            return true
        }
        return false
    };
    dhtmlx.assert_rule_function.describe = function () {
        return "{Function} value must be a custom function"
    };
    dhtmlx.assert_rule_any = function (a) {
        return true
    };
    dhtmlx.assert_rule_any.describe = function () {
        return "Any value"
    };
    dhtmlx.assert_rule_mix = function (g, c) {
        var h = function (a) {
                if (g(a) || c(a)) {
                    return true
                }
                return false
            };
        h.describe = function () {
            return g.describe()
        };
        return h
    }
}
dhtmlx.version = "3.0";
dhtmlx.codebase = "./";
dhtmlx.copy = function (c) {
    var a = dhtmlx.copy._function;
    a.prototype = c;
    return new a()
};
dhtmlx.copy._function = function () {};
dhtmlx.extend = function (c, a) {
    for (var g in a) {
        c[g] = a[g]
    }
    if (dhtmlx.assert_enabled() && a._assert) {
        c._assert();
        c._assert = null
    }
    dhtmlx.assert(c, "Invalid nesting target");
    dhtmlx.assert(a, "Invalid nesting source");
    if (a._init) {
        c._init()
    }
    return c
};
dhtmlx.proto_extend = function () {
    var l = arguments;
    var g = l[0];
    var c = [];
    for (var j = l.length - 1; j > 0; j--) {
        if (typeof l[j] == "function") {
            l[j] = l[j].prototype
        }
        for (var h in l[j]) {
            if (h == "_init") {
                c.push(l[j][h])
            } else {
                if (!g[h]) {
                    g[h] = l[j][h]
                }
            }
        }
    }
    if (l[0]._init) {
        c.push(l[0]._init)
    }
    g._init = function () {
        for (var m = 0; m < c.length; m++) {
            c[m].apply(this, arguments)
        }
    };
    g.base = l[1];
    var a = function (m) {
            this._init(m);
            if (this._parseSettings) {
                this._parseSettings(m, this.defaults)
            }
        };
    a.prototype = g;
    g = l = null;
    return a
};
dhtmlx.bind = function (c, a) {
    return function () {
        return c.apply(a, arguments)
    }
};
dhtmlx.require = function (a) {
    if (!dhtmlx._modules[a]) {
        dhtmlx.assert(dhtmlx.ajax, "load module is required");
        dhtmlx.exec(dhtmlx.ajax().sync().get(dhtmlx.codebase + a).responseText);
        dhtmlx._modules[a] = true
    }
};
dhtmlx._modules = {};
dhtmlx.exec = function (code) {
    if (window.execScript) {
        window.execScript(code)
    } else {
        window.eval(code)
    }
};
dhtmlx.methodPush = function (a, g, c) {
    return function () {
        var h = false;
        h = a[g].apply(a, arguments);
        return h
    }
};
dhtmlx.isNotDefined = function (c) {
    return typeof c == "undefined"
};
dhtmlx.delay = function (h, c, g, a) {
    setTimeout(function () {
        var j = h.apply(c, g);
        h = c = g = null;
        return j
    }, a || 1)
};
dhtmlx.uid = function () {
    if (!this._seed) {
        this._seed = (new Date).valueOf()
    }
    this._seed++;
    return this._seed
};
dhtmlx.toNode = function (a) {
    if (typeof a == "string") {
        return document.getElementById(a)
    }
    return a
};
dhtmlx.toArray = function (a) {
    return dhtmlx.extend((a || []), dhtmlx.PowerArray)
};
dhtmlx.toFunctor = function (str) {
    return (typeof (str) == "string") ? eval(str) : str
};
dhtmlx._events = {};
dhtmlx.event = function (h, g, a, c) {
    h = dhtmlx.toNode(h);
    var j = dhtmlx.uid();
    dhtmlx._events[j] = [h, g, a];
    if (c) {
        a = dhtmlx.bind(a, c)
    }
    if (h.addEventListener) {
        h.addEventListener(g, a, false)
    } else {
        if (h.attachEvent) {
            h.attachEvent("on" + g, a)
        }
    }
    return j
};
dhtmlx.eventRemove = function (c) {
    if (!c) {
        return
    }
    dhtmlx.assert(this._events[c], "Removing non-existing event");
    var a = dhtmlx._events[c];
    if (a[0].removeEventListener) {
        a[0].removeEventListener(a[1], a[2], false)
    } else {
        if (a[0].detachEvent) {
            a[0].detachEvent("on" + a[1], a[2])
        }
    }
    delete this._events[c]
};
dhtmlx.log = function (c, g, a) {
    if (window.console && console.log) {
        c = c.toLowerCase();
        if (window.console[c]) {
            window.console[c](g || "unknown error")
        } else {
            window.console.log(c + ": " + g)
        }
        if (a) {
            window.console.log(a)
        }
    }
};
dhtmlx.log_full_time = function (a) {
    dhtmlx._start_time_log = new Date();
    dhtmlx.log("Info", "Timing start [" + a + "]");
    window.setTimeout(function () {
        var c = new Date();
        dhtmlx.log("Info", "Timing end [" + a + "]:" + (c.valueOf() - dhtmlx._start_time_log.valueOf()) / 1000 + "s")
    }, 1)
};
dhtmlx.log_time = function (a) {
    var g = "_start_time_log" + a;
    if (!dhtmlx[g]) {
        dhtmlx[g] = new Date();
        dhtmlx.log("Info", "Timing start [" + a + "]")
    } else {
        var c = new Date();
        dhtmlx.log("Info", "Timing end [" + a + "]:" + (c.valueOf() - dhtmlx[g].valueOf()) / 1000 + "s");
        dhtmlx[g] = null
    }
};
dhtmlx.error = function (c, a) {
    dhtmlx.log("error", c, a)
};
dhtmlx.EventSystem = {
    _init: function () {
        this._events = {};
        this._handlers = {};
        this._map = {}
    },
    block: function () {
        this._events._block = true
    },
    unblock: function () {
        this._events._block = false
    },
    mapEvent: function (a) {
        dhtmlx.extend(this._map, a)
    },
    callEvent: function (g, j) {
        if (this._events._block) {
            return true
        }
        g = g.toLowerCase();
        dhtmlx.assert_event_call(this, g, j);
        var h = this._events[g.toLowerCase()];
        var a = true;
        if (dhtmlx.debug) {
            dhtmlx.log("info", "[" + this.name + "] event:" + g, j)
        }
        if (h) {
            for (var c = 0; c < h.length; c++) {
                if (h[c].apply(this, (j || [])) === false) {
                    a = false
                }
            }
        }
        if (this._map[g] && !this._map[g].callEvent(g, j)) {
            a = false
        }
        return a
    },
    attachEvent: function (c, a, h) {
        c = c.toLowerCase();
        dhtmlx.assert_event_attach(this, c);
        h = h || dhtmlx.uid();
        a = dhtmlx.toFunctor(a);
        var g = this._events[c] || dhtmlx.toArray();
        g.push(a);
        this._events[c] = g;
        this._handlers[h] = {
            f: a,
            t: c
        };
        return h
    },
    detachEvent: function (h) {
        if (this._handlers[h]) {
            var c = this._handlers[h].t;
            var a = this._handlers[h].f;
            var g = this._events[c];
            g.remove(a);
            delete this._handlers[h]
        }
    }
};
dhtmlx.PowerArray = {
    removeAt: function (c, a) {
        if (c >= 0) {
            this.splice(c, (a || 1))
        }
    },
    remove: function (a) {
        this.removeAt(this.find(a))
    },
    insertAt: function (c, g) {
        if (!g && g !== 0) {
            this.push(c)
        } else {
            var a = this.splice(g, (this.length - g));
            this[g] = c;
            this.push.apply(this, a)
        }
    },
    find: function (a) {
        for (i = 0; i < this.length; i++) {
            if (a == this[i]) {
                return i
            }
        }
        return -1
    },
    each: function (a, g) {
        for (var c = 0; c < this.length; c++) {
            a.call((g || this), this[c])
        }
    },
    map: function (a, g) {
        for (var c = 0; c < this.length; c++) {
            this[c] = a.call((g || this), this[c])
        }
        return this
    }
};
dhtmlx.env = {};
if (navigator.userAgent.indexOf("Opera") != -1) {
    dhtmlx._isOpera = true
} else {
    dhtmlx._isIE = !! document.all;
    dhtmlx._isFF = !document.all;
    dhtmlx._isWebKit = (navigator.userAgent.indexOf("KHTML") != -1);
    if (navigator.appVersion.indexOf("MSIE 8.0") != -1 && document.compatMode != "BackCompat") {
        dhtmlx._isIE = 8
    }
    if (navigator.appVersion.indexOf("MSIE 9.0") != -1 && document.compatMode != "BackCompat") {
        dhtmlx._isIE = 9
    }
}
dhtmlx.env = {};
(function () {
    dhtmlx.env.transform = false;
    dhtmlx.env.transition = false;
    var a = {};
    a.names = ["transform", "transition"];
    a.transform = ["transform", "WebkitTransform", "MozTransform", "oTransform", "msTransform"];
    a.transition = ["transition", "WebkitTransition", "MozTransition", "oTransition"];
    var h = document.createElement("DIV");
    var g;
    for (var c = 0; c < a.names.length; c++) {
        while (p = a[a.names[c]].pop()) {
            if (typeof h.style[p] != "undefined") {
                dhtmlx.env[a.names[c]] = true
            }
        }
    }
})();
dhtmlx.env.transform_prefix = (function () {
    var a;
    if (dhtmlx._isOpera) {
        a = "-o-"
    } else {
        a = "";
        if (dhtmlx._isFF) {
            a = "-moz-"
        }
        if (dhtmlx._isWebKit) {
            a = "-webkit-"
        }
    }
    return a
})();
dhtmlx.env.svg = (function () {
    return document.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#BasicStructure", "1.1")
})();
dhtmlx.zIndex = {
    drag: 10000
};
dhtmlx.html = {
    create: function (c, a, g) {
        a = a || {};
        var h = document.createElement(c);
        for (var j in a) {
            h.setAttribute(j, a[j])
        }
        if (a.style) {
            h.style.cssText = a.style
        }
        if (a["class"]) {
            h.className = a["class"]
        }
        if (g) {
            h.innerHTML = g
        }
        return h
    },
    getValue: function (a) {
        a = dhtmlx.toNode(a);
        if (!a) {
            return ""
        }
        return dhtmlx.isNotDefined(a.value) ? a.innerHTML : a.value
    },
    remove: function (c) {
        if (c instanceof Array) {
            for (var a = 0; a < c.length; a++) {
                this.remove(c[a])
            }
        } else {
            if (c && c.parentNode) {
                c.parentNode.removeChild(c)
            }
        }
    },
    insertBefore: function (c, g, a) {
        if (!c) {
            return
        }
        if (g) {
            g.parentNode.insertBefore(c, g)
        } else {
            a.appendChild(c)
        }
    },
    locate: function (c, h) {
        c = c || event;
        var a = c.target || c.srcElement;
        while (a) {
            if (a.getAttribute) {
                var g = a.getAttribute(h);
                if (g) {
                    return g
                }
            }
            a = a.parentNode
        }
        return null
    },
    offset: function (h) {
        if (h.getBoundingClientRect) {
            var m = h.getBoundingClientRect();
            var n = document.body;
            var c = document.documentElement;
            var a = window.pageYOffset || c.scrollTop || n.scrollTop;
            var j = window.pageXOffset || c.scrollLeft || n.scrollLeft;
            var l = c.clientTop || n.clientTop || 0;
            var o = c.clientLeft || n.clientLeft || 0;
            var q = m.top + a - l;
            var g = m.left + j - o;
            return {
                y: Math.round(q),
                x: Math.round(g)
            }
        } else {
            var q = 0,
                g = 0;
            while (h) {
                q = q + parseInt(h.offsetTop, 10);
                g = g + parseInt(h.offsetLeft, 10);
                h = h.offsetParent
            }
            return {
                y: q,
                x: g
            }
        }
    },
    pos: function (a) {
        a = a || event;
        if (a.pageX || a.pageY) {
            return {
                x: a.pageX,
                y: a.pageY
            }
        }
        var c = ((dhtmlx._isIE) && (document.compatMode != "BackCompat")) ? document.documentElement : document.body;
        return {
            x: a.clientX + c.scrollLeft - c.clientLeft,
            y: a.clientY + c.scrollTop - c.clientTop
        }
    },
    preventEvent: function (a) {
        if (a && a.preventDefault) {
            a.preventDefault()
        }
        dhtmlx.html.stopEvent(a)
    },
    stopEvent: function (a) {
        (a || event).cancelBubble = true;
        return false
    },
    addCss: function (c, a) {
        c.className += " " + a
    },
    removeCss: function (c, a) {
        c.className = c.className.replace(RegExp(a, "g"), "")
    }
};
(function () {
    var a = document.getElementsByTagName("SCRIPT");
    dhtmlx.assert(a.length, "Can't locate codebase");
    if (a.length) {
        a = (a[a.length - 1].getAttribute("src") || "").split("/");
        a.splice(a.length - 1, 1);
        dhtmlx.codebase = a.slice(0, a.length).join("/") + "/"
    }
})();
if (!dhtmlx.ui) {
    dhtmlx.ui = {}
}
dhtmlx.Destruction = {
    _init: function () {
        dhtmlx.destructors.push(this)
    },
    destructor: function () {
        this.destructor = function () {};
        this._htmlmap = null;
        this._htmlrows = null;
        if (this._html) {
            document.body.appendChild(this._html)
        }
        this._html = null;
        if (this._obj) {
            this._obj.innerHTML = "";
            this._obj._htmlmap = null
        }
        this._obj = this._dataobj = null;
        this.data = null;
        this._events = this._handlers = {};
        if (this.render) {
            this.render = function () {}
        }
    }
};
dhtmlx.destructors = [];
dhtmlx.event(window, "unload", function () {
    if (dhtmlx.destructors) {
        for (var g = 0; g < dhtmlx.destructors.length; g++) {
            dhtmlx.destructors[g].destructor()
        }
        dhtmlx.destructors = []
    }
    for (var c in dhtmlx._events) {
        var h = dhtmlx._events[c];
        if (h[0].removeEventListener) {
            h[0].removeEventListener(h[1], h[2], false)
        } else {
            if (h[0].detachEvent) {
                h[0].detachEvent("on" + h[1], h[2])
            }
        }
        delete dhtmlx._events[c]
    }
});
dhtmlx.ajax = function (a, c, g) {
    if (arguments.length !== 0) {
        var h = new dhtmlx.ajax();
        if (g) {
            h.master = g
        }
        h.get(a, null, c)
    }
    if (!this.getXHR) {
        return new dhtmlx.ajax()
    }
    return this
};
dhtmlx.ajax.prototype = {
    getXHR: function () {
        if (dhtmlx._isIE) {
            return new ActiveXObject("Microsoft.xmlHTTP")
        } else {
            return new XMLHttpRequest()
        }
    },
    send: function (j, o, m) {
        var c = this.getXHR();
        if (typeof m == "function") {
            m = [m]
        }
        if (typeof o == "object") {
            var l = [];
            for (var g in o) {
                var n = o[g];
                if (n === null || n === dhtmlx.undefined) {
                    n = ""
                }
                l.push(g + "=" + encodeURIComponent(n))
            }
            o = l.join("&")
        }
        if (o && !this.post) {
            j = j + (j.indexOf("?") != -1 ? "&" : "?") + o;
            o = null
        }
        c.open(this.post ? "POST" : "GET", j, !this._sync);
        if (this.post) {
            c.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
        }
        var h = this;
        c.onreadystatechange = function () {
            if (!c.readyState || c.readyState == 4) {
                if (m && h) {
                    for (var a = 0; a < m.length; a++) {
                        if (m[a]) {
                            m[a].call((h.master || h), c.responseText, c.responseXML, c)
                        }
                    }
                }
                h.master = null;
                m = h = null
            }
        };
        c.send(o || null);
        return c
    },
    get: function (a, g, c) {
        this.post = false;
        return this.send(a, g, c)
    },
    post: function (a, g, c) {
        this.post = true;
        return this.send(a, g, c)
    },
    sync: function () {
        this._sync = true;
        return this
    }
};
dhtmlx.AtomDataLoader = {
    _init: function (a) {
        this.data = {};
        if (a) {
            this._settings.datatype = a.datatype || "json";
            this._after_init.push(this._load_when_ready)
        }
    },
    _load_when_ready: function () {
        this._ready_for_data = true;
        if (this._settings.url) {
            this.url_setter(this._settings.url)
        }
        if (this._settings.data) {
            this.data_setter(this._settings.data)
        }
    },
    url_setter: function (a) {
        if (!this._ready_for_data) {
            return a
        }
        this.load(a, this._settings.datatype);
        return a
    },
    data_setter: function (a) {
        if (!this._ready_for_data) {
            return a
        }
        this.parse(a, this._settings.datatype);
        return true
    },
    load: function (a, c) {
        this.callEvent("onXLS", []);
        if (typeof c == "string") {
            this.data.driver = dhtmlx.DataDriver[c];
            c = arguments[2]
        } else {
            this.data.driver = dhtmlx.DataDriver.xml
        }
        dhtmlx.ajax(a, [this._onLoad, c], this)
    },
    parse: function (c, a) {
        this.callEvent("onXLS", []);
        this.data.driver = dhtmlx.DataDriver[a || "xml"];
        this._onLoad(c, null)
    },
    _onLoad: function (j, c, a) {
        var g = this.data.driver;
        var h = g.getRecords(g.toObject(j, c))[0];
        this.data = (g ? g.getDetails(h) : j);
        this.callEvent("onXLE", [])
    },
    _check_data_feed: function (c) {
        if (!this._settings.dataFeed || this._ignore_feed || !c) {
            return true
        }
        var a = this._settings.dataFeed;
        if (typeof a == "function") {
            return a.call(this, (c.id || c), c)
        }
        a = a + (a.indexOf("?") == -1 ? "?" : "&") + "action=get&id=" + encodeURIComponent(c.id || c);
        this.callEvent("onXLS", []);
        dhtmlx.ajax(a, function (h, g) {
            this._ignore_feed = true;
            this.setValues(dhtmlx.DataDriver.json.toObject(h)[0]);
            this._ignore_feed = false;
            this.callEvent("onXLE", [])
        }, this);
        return false
    }
};
dhtmlx.DataDriver = {};
dhtmlx.DataDriver.json = {
    toObject: function (data) {
        if (!data) {
            data = "[]"
        }
        if (typeof data == "string") {
            eval("dhtmlx.temp=" + data);
            return dhtmlx.temp
        }
        return data
    },
    getRecords: function (a) {
        if (a && !(a instanceof Array)) {
            return [a]
        }
        return a
    },
    getDetails: function (a) {
        return a
    },
    getInfo: function (a) {
        return {
            _size: (a.total_count || 0),
            _from: (a.pos || 0),
            _key: (a.dhx_security)
        }
    }
};
dhtmlx.DataDriver.json_ext = {
    toObject: function (data) {
        if (!data) {
            data = "[]"
        }
        if (typeof data == "string") {
            var temp;
            eval("temp=" + data);
            dhtmlx.temp = [];
            var header = temp.header;
            for (var i = 0; i < temp.data.length; i++) {
                var item = {};
                for (var j = 0; j < header.length; j++) {
                    if (typeof (temp.data[i][j]) != "undefined") {
                        item[header[j]] = temp.data[i][j]
                    }
                }
                dhtmlx.temp.push(item)
            }
            return dhtmlx.temp
        }
        return data
    },
    getRecords: function (a) {
        if (a && !(a instanceof Array)) {
            return [a]
        }
        return a
    },
    getDetails: function (a) {
        return a
    },
    getInfo: function (a) {
        return {
            _size: (a.total_count || 0),
            _from: (a.pos || 0)
        }
    }
};
dhtmlx.DataDriver.html = {
    toObject: function (c) {
        if (typeof c == "string") {
            var a = null;
            if (c.indexOf("<") == -1) {
                a = dhtmlx.toNode(c)
            }
            if (!a) {
                a = document.createElement("DIV");
                a.innerHTML = c
            }
            return a.getElementsByTagName(this.tag)
        }
        return c
    },
    getRecords: function (a) {
        if (a.tagName) {
            return a.childNodes
        }
        return a
    },
    getDetails: function (a) {
        return dhtmlx.DataDriver.xml.tagToObject(a)
    },
    getInfo: function (a) {
        return {
            _size: 0,
            _from: 0
        }
    },
    tag: "LI"
};
dhtmlx.DataDriver.jsarray = {
    toObject: function (data) {
        if (typeof data == "string") {
            eval("dhtmlx.temp=" + data);
            return dhtmlx.temp
        }
        return data
    },
    getRecords: function (a) {
        return a
    },
    getDetails: function (g) {
        var a = {};
        for (var c = 0; c < g.length; c++) {
            a["data" + c] = g[c]
        }
        return a
    },
    getInfo: function (a) {
        return {
            _size: 0,
            _from: 0
        }
    }
};
dhtmlx.DataDriver.csv = {
    toObject: function (a) {
        return a
    },
    getRecords: function (a) {
        return a.split(this.row)
    },
    getDetails: function (g) {
        g = this.stringToArray(g);
        var a = {};
        for (var c = 0; c < g.length; c++) {
            a["data" + c] = g[c]
        }
        return a
    },
    getInfo: function (a) {
        return {
            _size: 0,
            _from: 0
        }
    },
    stringToArray: function (c) {
        c = c.split(this.cell);
        for (var a = 0; a < c.length; a++) {
            c[a] = c[a].replace(/^[ \t\n\r]*(\"|)/g, "").replace(/(\"|)[ \t\n\r]*$/g, "")
        }
        return c
    },
    row: "\n",
    cell: ","
};
dhtmlx.DataDriver.xml = {
    toObject: function (c, a) {
        if (a && (a = this.checkResponse(c, a))) {
            return a
        }
        if (typeof c == "string") {
            return this.fromString(c)
        }
        return c
    },
    getRecords: function (a) {
        return this.xpath(a, this.records)
    },
    records: "/*/item",
    getDetails: function (a) {
        return this.tagToObject(a, {})
    },
    getInfo: function (a) {
        return {
            _size: (a.documentElement.getAttribute("total_count") || 0),
            _from: (a.documentElement.getAttribute("pos") || 0),
            _key: (a.documentElement.getAttribute("dhx_security"))
        }
    },
    xpath: function (h, o) {
        if (window.XPathResult) {
            var g = h;
            if (h.nodeName.indexOf("document") == -1) {
                h = h.ownerDocument
            }
            var m = [];
            var c = h.evaluate(o, g, null, XPathResult.ANY_TYPE, null);
            var n = c.iterateNext();
            while (n) {
                m.push(n);
                n = c.iterateNext()
            }
            return m
        } else {
            var l = true;
            try {
                if (typeof (h.selectNodes) == "undefined") {
                    l = false
                }
            } catch (j) {}
            if (l) {
                return h.selectNodes(o)
            } else {
                var a = o.split("/").pop();
                return h.getElementsByTagName(a)
            }
        }
    },
    tagToObject: function (g, o) {
        o = o || {};
        var j = false;
        var h = g.attributes;
        if (h && h.length) {
            for (var m = 0; m < h.length; m++) {
                o[h[m].name] = h[m].value
            }
            j = true
        }
        var c = g.childNodes;
        var n = {};
        for (var m = 0; m < c.length; m++) {
            if (c[m].nodeType == 1) {
                var l = c[m].tagName;
                if (typeof o[l] != "undefined") {
                    if (!(o[l] instanceof Array)) {
                        o[l] = [o[l]]
                    }
                    o[l].push(this.tagToObject(c[m], {}))
                } else {
                    o[c[m].tagName] = this.tagToObject(c[m], {})
                }
                j = true
            }
        }
        if (!j) {
            return this.nodeValue(g)
        }
        o.value = this.nodeValue(g);
        return o
    },
    nodeValue: function (a) {
        if (a.firstChild) {
            return a.firstChild.wholeText || a.firstChild.data
        }
        return ""
    },
    fromString: function (c) {
        if (window.DOMParser && !dhtmlx._isIE) {
            return (new DOMParser()).parseFromString(c, "text/xml")
        }
        if (window.ActiveXObject) {
            var a = new ActiveXObject("Microsoft.xmlDOM");
            a.loadXML(c);
            return a
        }
        dhtmlx.error("Load from xml string is not supported")
    },
    checkResponse: function (h, g) {
        if (g && (g.firstChild && g.firstChild.tagName != "parsererror")) {
            return g
        }
        var c = this.fromString(h.replace(/^[\s]+/, ""));
        if (c) {
            return c
        }
        dhtmlx.error("xml can't be parsed", h)
    }
};
dhtmlx.DataLoader = {
    _init: function (a) {
        a = a || "";
        this.name = "DataStore";
        this.data = (a.datastore) || (new dhtmlx.DataStore());
        this._readyHandler = this.data.attachEvent("onStoreLoad", dhtmlx.bind(this._call_onready, this))
    },
    load: function (a, c) {
        dhtmlx.AtomDataLoader.load.apply(this, arguments);
        if (!this.data.feed) {
            this.data.feed = function (h, g) {
                if (this._load_count) {
                    return this._load_count = [h, g]
                } else {
                    this._load_count = true
                }
                this.load(a + ((a.indexOf("?") == -1) ? "?" : "&") + "posStart=" + h + "&count=" + g, function () {
                    var j = this._load_count;
                    this._load_count = false;
                    if (typeof j == "object") {
                        this.data.feed.apply(this, j)
                    }
                })
            }
        }
    },
    _onLoad: function (g, c, a) {
        this.data._parse(this.data.driver.toObject(g, c));
        this.callEvent("onXLE", []);
        if (this._readyHandler) {
            this.data.detachEvent(this._readyHandler);
            this._readyHandler = null
        }
    },
    dataFeed_setter: function (a) {
        this.data.attachEvent("onBeforeFilter", dhtmlx.bind(function (m, l) {
            if (this._settings.dataFeed) {
                var j = {};
                if (!m && !j) {
                    return
                }
                if (typeof m == "function") {
                    if (!l) {
                        return
                    }
                    m(l, j)
                } else {
                    j = {
                        text: l
                    }
                }
                this.clearAll();
                var c = this._settings.dataFeed;
                if (typeof c == "function") {
                    return c.call(this, l, j)
                }
                var h = [];
                for (var g in j) {
                    h.push("dhx_filter[" + g + "]=" + encodeURIComponent(j[g]))
                }
                this.load(c + (c.indexOf("?") < 0 ? "?" : "&") + h.join("&"), this._settings.datatype);
                return false
            }
        }, this));
        return a
    },
    _call_onready: function () {
        if (this._settings.ready) {
            var a = dhtmlx.toFunctor(this._settings.ready);
            if (a && a.call) {
                a.apply(this, arguments)
            }
        }
    }
};
dhtmlx.DataStore = function () {
    this.name = "DataStore";
    dhtmlx.extend(this, dhtmlx.EventSystem);
    this.setDriver("xml");
    this.pull = {};
    this.order = dhtmlx.toArray()
};
dhtmlx.DataStore.prototype = {
    setDriver: function (a) {
        dhtmlx.assert(dhtmlx.DataDriver[a], "incorrect DataDriver");
        this.driver = dhtmlx.DataDriver[a]
    },
    _parse: function (l) {
        this.callEvent("onParse", [this.driver, l]);
        if (this._filter_order) {
            this.filter()
        }
        var m = this.driver.getInfo(l);
        if (m._key) {
            dhtmlx.security_key = m._key
        }
        var h = this.driver.getRecords(l);
        var o = (m._from || 0) * 1;
        if (o === 0 && this.order[0]) {
            o = this.order.length
        }
        var c = 0;
        for (var g = 0; g < h.length; g++) {
            var a = this.driver.getDetails(h[g]);
            var n = this.id(a);
            if (!this.pull[n]) {
                this.order[c + o] = n;
                c++
            }
            this.pull[n] = a;
            if (this.extraParser) {
                this.extraParser(a)
            }
            if (this._scheme) {
                if (this._scheme.$init) {
                    this._scheme.$update(a)
                } else {
                    if (this._scheme.$update) {
                        this._scheme.$update(a)
                    }
                }
            }
        }
        for (var g = 0; g < m._size; g++) {
            if (!this.order[g]) {
                var n = dhtmlx.uid();
                var a = {
                    id: n,
                    $template: "loading"
                };
                this.pull[n] = a;
                this.order[g] = n
            }
        }
        this.callEvent("onStoreLoad", [this.driver, l]);
        this.refresh()
    },
    id: function (a) {
        return a.id || (a.id = dhtmlx.uid())
    },
    changeId: function (c, a) {
        dhtmlx.assert(this.pull[c], "Can't change id, for non existing item: " + c);
        this.pull[a] = this.pull[c];
        this.pull[a].id = a;
        this.order[this.order.find(c)] = a;
        if (this._filter_order) {
            this._filter_order[this._filter_order.find(c)] = a
        }
        this.callEvent("onIdChange", [c, a]);
        if (this._render_change_id) {
            this._render_change_id(c, a)
        }
    },
    get: function (a) {
        return this.item(a)
    },
    set: function (c, a) {
        return this.update(c, a)
    },
    item: function (a) {
        return this.pull[a]
    },
    update: function (c, a) {
        if (this._scheme && this._scheme.$update) {
            this._scheme.$update(a)
        }
        if (this.callEvent("onBeforeUpdate", [c, a]) === false) {
            return false
        }
        this.pull[c] = a;
        this.refresh(c)
    },
    refresh: function (a) {
        if (this._skip_refresh) {
            return
        }
        if (a) {
            this.callEvent("onStoreUpdated", [a, this.pull[a], "update"])
        } else {
            this.callEvent("onStoreUpdated", [null, null, null])
        }
    },
    silent: function (a) {
        this._skip_refresh = true;
        a.call(this);
        this._skip_refresh = false
    },
    getRange: function (h, g) {
        if (h) {
            h = this.indexById(h)
        } else {
            h = this.startOffset || 0
        }
        if (g) {
            g = this.indexById(g)
        } else {
            g = Math.min((this.endOffset || Infinity), (this.dataCount() - 1));
            if (g < 0) {
                g = 0
            }
        }
        if (h > g) {
            var c = g;
            g = h;
            h = c
        }
        return this.getIndexRange(h, g)
    },
    getIndexRange: function (h, g) {
        g = Math.min((g || Infinity), this.dataCount() - 1);
        var a = dhtmlx.toArray();
        for (var c = (h || 0); c <= g; c++) {
            a.push(this.item(this.order[c]))
        }
        return a
    },
    dataCount: function () {
        return this.order.length
    },
    exists: function (a) {
        return !!(this.pull[a])
    },
    move: function (a, h) {
        if (a < 0 || h < 0) {
            dhtmlx.error("DataStore::move", "Incorrect indexes");
            return
        }
        var g = this.idByIndex(a);
        var c = this.item(g);
        this.order.removeAt(a);
        this.order.insertAt(g, Math.min(this.order.length, h));
        this.callEvent("onStoreUpdated", [g, c, "move"])
    },
    scheme: function (a) {
        this._scheme = a
    },
    sync: function (j, h, a) {
        if (typeof h != "function") {
            a = h;
            h = null
        }
        if (dhtmlx.debug_bind) {
            this.debug_sync_master = j;
            dhtmlx.log("[sync] " + this.debug_bind_master.name + "@" + this.debug_bind_master._settings.id + " <= " + this.debug_sync_master.name + "@" + this.debug_sync_master._settings.id)
        }
        var g = j;
        if (j.name != "DataStore") {
            j = j.data
        }
        var c = dhtmlx.bind(function (n, l, m) {
            if (m != "update" || h) {
                n = null
            }
            if (!n) {
                this.order = dhtmlx.toArray([].concat(j.order));
                this._filter_order = null;
                this.pull = j.pull;
                if (h) {
                    this.silent(h)
                }
                if (this._on_sync) {
                    this._on_sync()
                }
            }
            if (dhtmlx.debug_bind) {
                dhtmlx.log("[sync:request] " + this.debug_sync_master.name + "@" + this.debug_sync_master._settings.id + " <= " + this.debug_bind_master.name + "@" + this.debug_bind_master._settings.id)
            }
            if (!a) {
                this.refresh(n)
            } else {
                a = false
            }
        }, this);
        j.attachEvent("onStoreUpdated", c);
        this.feed = function (m, l) {
            g.loadNext(l, m)
        };
        c()
    },
    add: function (j, a) {
        if (this._scheme) {
            j = j || {};
            for (var c in this._scheme) {
                j[c] = j[c] || this._scheme[c]
            }
            if (this._scheme) {
                if (this._scheme.$init) {
                    this._scheme.$update(j)
                } else {
                    if (this._scheme.$update) {
                        this._scheme.$update(j)
                    }
                }
            }
        }
        var l = this.id(j);
        var h = this.dataCount();
        if (dhtmlx.isNotDefined(a) || a < 0) {
            a = h
        }
        if (a > h) {
            dhtmlx.log("Warning", "DataStore:add", "Index of out of bounds");
            a = Math.min(this.order.length, a)
        }
        if (this.callEvent("onBeforeAdd", [l, j, a]) === false) {
            return false
        }
        if (this.exists(l)) {
            return dhtmlx.error("Not unique ID")
        }
        this.pull[l] = j;
        this.order.insertAt(l, a);
        if (this._filter_order) {
            var g = this._filter_order.length;
            if (!a && this.order.length) {
                g = 0
            }
            this._filter_order.insertAt(l, g)
        }
        this.callEvent("onafterAdd", [l, a]);
        this.callEvent("onStoreUpdated", [l, j, "add"]);
        return l
    },
    remove: function (g) {
        if (g instanceof Array) {
            for (var a = 0; a < g.length; a++) {
                this.remove(g[a])
            }
            return
        }
        if (this.callEvent("onBeforeDelete", [g]) === false) {
            return false
        }
        if (!this.exists(g)) {
            return dhtmlx.error("Not existing ID", g)
        }
        var c = this.item(g);
        this.order.remove(g);
        if (this._filter_order) {
            this._filter_order.remove(g)
        }
        delete this.pull[g];
        this.callEvent("onafterdelete", [g]);
        this.callEvent("onStoreUpdated", [g, c, "delete"])
    },
    clearAll: function () {
        this.pull = {};
        this.order = dhtmlx.toArray();
        this.feed = null;
        this._filter_order = null;
        this.callEvent("onClearAll", []);
        this.refresh()
    },
    idByIndex: function (a) {
        if (a >= this.order.length || a < 0) {
            dhtmlx.log("Warning", "DataStore::idByIndex Incorrect index")
        }
        return this.order[a]
    },
    indexById: function (c) {
        var a = this.order.find(c);
        return a
    },
    next: function (c, a) {
        return this.order[this.indexById(c) + (a || 1)]
    },
    first: function () {
        return this.order[0]
    },
    last: function () {
        return this.order[this.order.length - 1]
    },
    previous: function (c, a) {
        return this.order[this.indexById(c) - (a || 1)]
    },
    sort: function (l, c, a) {
        var g = l;
        if (typeof l == "function") {
            g = {
                as: l,
                dir: c
            }
        } else {
            if (typeof l == "string") {
                g = {
                    by: l,
                    dir: c,
                    as: a
                }
            }
        }
        var j = [g.by, g.dir, g.as];
        if (!this.callEvent("onbeforesort", j)) {
            return
        }
        if (this.order.length) {
            var m = dhtmlx.sort.create(g);
            var h = this.getRange(this.first(), this.last());
            h.sort(m);
            this.order = h.map(function (n) {
                return this.id(n)
            }, this)
        }
        this.refresh();
        this.callEvent("onaftersort", j)
    },
    filter: function (j, h) {
        if (!this.callEvent("onBeforeFilter", [j, h])) {
            return
        }
        if (this._filter_order) {
            this.order = this._filter_order;
            delete this._filter_order
        }
        if (!this.order.length) {
            return
        }
        if (j) {
            var c = j;
            h = h || "";
            if (typeof j == "string") {
                j = dhtmlx.Template.fromHTML(j);
                h = h.toString().toLowerCase();
                c = function (n, m) {
                    return j(n).toLowerCase().indexOf(m) != -1
                }
            }
            var g = dhtmlx.toArray();
            for (var a = 0; a < this.order.length; a++) {
                var l = this.order[a];
                if (c(this.item(l), h)) {
                    g.push(l)
                }
            }
            this._filter_order = this.order;
            this.order = g
        }
        this.refresh();
        this.callEvent("onAfterFilter", [])
    },
    each: function (g, c) {
        for (var a = 0; a < this.order.length; a++) {
            g.call((c || this), this.item(this.order[a]))
        }
    },
    provideApi: function (h, c) {
        this.debug_bind_master = h;
        if (c) {
            this.mapEvent({
                onbeforesort: h,
                onaftersort: h,
                onbeforeadd: h,
                onafteradd: h,
                onbeforedelete: h,
                onafterdelete: h,
                onbeforeupdate: h
            })
        }
        var g = ["get", "set", "sort", "add", "remove", "exists", "idByIndex", "indexById", "item", "update", "refresh", "dataCount", "filter", "next", "previous", "clearAll", "first", "last", "serialize"];
        for (var a = 0; a < g.length; a++) {
            h[g[a]] = dhtmlx.methodPush(this, g[a])
        }
        if (dhtmlx.assert_enabled()) {
            this.assert_event(h)
        }
    },
    serialize: function () {
        var g = this.order;
        var a = [];
        for (var c = 0; c < g.length; c++) {
            a.push(this.pull[g[c]])
        }
        return a
    }
};
dhtmlx.sort = {
    create: function (a) {
        return dhtmlx.sort.dir(a.dir, dhtmlx.sort.by(a.by, a.as))
    },
    as: {
        "int": function (g, c) {
            g = g * 1;
            c = c * 1;
            return g > c ? 1 : (g < c ? -1 : 0)
        },
        string_strict: function (g, c) {
            g = g.toString();
            c = c.toString();
            return g > c ? 1 : (g < c ? -1 : 0)
        },
        string: function (g, c) {
            g = g.toString().toLowerCase();
            c = c.toString().toLowerCase();
            return g > c ? 1 : (g < c ? -1 : 0)
        }
    },
    by: function (c, a) {
        if (!c) {
            return a
        }
        if (typeof a != "function") {
            a = dhtmlx.sort.as[a || "string"]
        }
        c = dhtmlx.Template.fromHTML(c);
        return function (h, g) {
            return a(c(h), c(g))
        }
    },
    dir: function (c, a) {
        if (c == "asc") {
            return a
        }
        return function (h, g) {
            return a(h, g) * -1
        }
    }
};
dhtmlx.KeyEvents = {
    _init: function () {
        dhtmlx.event(this._obj, "keypress", this._onKeyPress, this)
    },
    _onKeyPress: function (c) {
        c = c || event;
        var a = c.which || c.keyCode;
        this.callEvent((this._edit_id ? "onEditKeyPress" : "onKeyPress"), [a, c.ctrlKey, c.shiftKey, c])
    }
};
dhtmlx.MouseEvents = {
    _init: function () {
        if (this.on_click) {
            dhtmlx.event(this._obj, "click", this._onClick, this);
            dhtmlx.event(this._obj, "contextmenu", this._onContext, this)
        }
        if (this.on_dblclick) {
            dhtmlx.event(this._obj, "dblclick", this._onDblClick, this)
        }
        if (this.on_mouse_move) {
            dhtmlx.event(this._obj, "mousemove", this._onMouse, this);
            dhtmlx.event(this._obj, (dhtmlx._isIE ? "mouseleave" : "mouseout"), this._onMouse, this)
        }
    },
    _onClick: function (a) {
        return this._mouseEvent(a, this.on_click, "ItemClick")
    },
    _onDblClick: function (a) {
        return this._mouseEvent(a, this.on_dblclick, "ItemDblClick")
    },
    _onContext: function (a) {
        var c = dhtmlx.html.locate(a, this._id);
        if (c && !this.callEvent("onBeforeContextMenu", [c, a])) {
            return dhtmlx.html.preventEvent(a)
        }
    },
    _onMouse: function (a) {
        if (dhtmlx._isIE) {
            a = document.createEventObject(event)
        }
        if (this._mouse_move_timer) {
            window.clearTimeout(this._mouse_move_timer)
        }
        this.callEvent("onMouseMoving", [a]);
        this._mouse_move_timer = window.setTimeout(dhtmlx.bind(function () {
            if (a.type == "mousemove") {
                this._onMouseMove(a)
            } else {
                this._onMouseOut(a)
            }
        }, this), 500)
    },
    _onMouseMove: function (a) {
        if (!this._mouseEvent(a, this.on_mouse_move, "MouseMove")) {
            this.callEvent("onMouseOut", [a || event])
        }
    },
    _onMouseOut: function (a) {
        this.callEvent("onMouseOut", [a || event])
    },
    _mouseEvent: function (l, j, c) {
        l = l || event;
        var a = l.target || l.srcElement;
        var g = "";
        var m = null;
        var h = false;
        while (a && a.parentNode) {
            if (!h && a.getAttribute) {
                m = a.getAttribute(this._id);
                if (m) {
                    if (a.getAttribute("userdata")) {
                        this.callEvent("onLocateData", [m, a])
                    }
                    if (!this.callEvent("on" + c, [m, l, a])) {
                        return
                    }
                    h = true
                }
            }
            g = a.className;
            if (g) {
                g = g.split(" ");
                g = g[0] || g[1];
                if (j[g]) {
                    return j[g].call(this, l, m || dhtmlx.html.locate(l, this._id), a)
                }
            }
            a = a.parentNode
        }
        return h
    }
};
dhtmlx.Settings = {
    _init: function () {
        this._settings = this.config = {}
    },
    define: function (c, a) {
        if (typeof c == "object") {
            return this._parseSeetingColl(c)
        }
        return this._define(c, a)
    },
    _define: function (c, a) {
        dhtmlx.assert_settings.call(this, c, a);
        var g = this[c + "_setter"];
        return this._settings[c] = g ? g.call(this, a) : a
    },
    _parseSeetingColl: function (g) {
        if (g) {
            for (var c in g) {
                this._define(c, g[c])
            }
        }
    },
    _parseSettings: function (g, a) {
        var c = dhtmlx.extend({}, a);
        if (typeof g == "object" && !g.tagName) {
            dhtmlx.extend(c, g)
        }
        this._parseSeetingColl(c)
    },
    _mergeSettings: function (a, g) {
        for (var c in g) {
            switch (typeof a[c]) {
            case "object":
                a[c] = this._mergeSettings((a[c] || {}), g[c]);
                break;
            case "undefined":
                a[c] = g[c];
                break;
            default:
                break
            }
        }
        return a
    },
    _parseContainer: function (c, a, g) {
        if (typeof c == "object" && !c.tagName) {
            c = c.container
        }
        this._obj = this.$view = dhtmlx.toNode(c);
        if (!this._obj && g) {
            this._obj = g(c)
        }
        dhtmlx.assert(this._obj, "Incorrect html container");
        this._obj.className += " " + a;
        this._obj.onselectstart = function () {
            return false
        };
        this._dataobj = this._obj
    },
    _set_type: function (a) {
        if (typeof a == "object") {
            return this.type_setter(a)
        }
        dhtmlx.assert(this.types, "RenderStack :: Types are not defined");
        dhtmlx.assert(this.types[a], "RenderStack :: Inccorect type name", a);
        this.type = dhtmlx.extend({}, this.types[a]);
        this.customize()
    },
    customize: function (a) {
        if (a) {
            dhtmlx.extend(this.type, a)
        }
        this.type._item_start = dhtmlx.Template.fromHTML(this.template_item_start(this.type));
        this.type._item_end = this.template_item_end(this.type);
        this.render()
    },
    type_setter: function (a) {
        this._set_type(typeof a == "object" ? dhtmlx.Type.add(this, a) : a);
        return a
    },
    template_setter: function (a) {
        return this.type_setter({
            template: a
        })
    },
    css_setter: function (a) {
        this._obj.className += " " + a;
        return a
    }
};
dhtmlx.Template = {
    _cache: {},
    empty: function () {
        return ""
    },
    setter: function (a) {
        return dhtmlx.Template.fromHTML(a)
    },
    obj_setter: function (c) {
        var a = dhtmlx.Template.setter(c);
        var g = this;
        return function () {
            return a.apply(g, arguments)
        }
    },
    fromHTML: function (a) {
        if (typeof a == "function") {
            return a
        }
        if (this._cache[a]) {
            return this._cache[a]
        }
        a = (a || "").toString();
        a = a.replace(/[\r\n]+/g, "\\n");
        a = a.replace(/\{obj\.([^}?]+)\?([^:]*):([^}]*)\}/g, '"+(obj.$1?"$2":"$3")+"');
        a = a.replace(/\{common\.([^}\(]*)\}/g, '"+common.$1+"');
        a = a.replace(/\{common\.([^\}\(]*)\(\)\}/g, '"+(common.$1?common.$1(obj):"")+"');
        a = a.replace(/\{obj\.([^}]*)\}/g, '"+obj.$1+"');
        a = a.replace(/#([a-z0-9_]+)#/gi, '"+obj.$1+"');
        a = a.replace(/\{obj\}/g, '"+obj+"');
        a = a.replace(/\{-obj/g, "{obj");
        a = a.replace(/\{-common/g, "{common");
        a = 'return "' + a + '";';
        return this._cache[a] = Function("obj", "common", a)
    }
};
dhtmlx.Type = {
    add: function (g, c) {
        if (!g.types && g.prototype.types) {
            g = g.prototype
        }
        if (dhtmlx.assert_enabled()) {
            this.assert_event(c)
        }
        var a = c.name || "default";
        this._template(c);
        this._template(c, "edit");
        this._template(c, "loading");
        g.types[a] = dhtmlx.extend(dhtmlx.extend({}, (g.types[a] || this._default)), c);
        return a
    },
    _default: {
        css: "default",
        template: function () {
            return ""
        },
        template_edit: function () {
            return ""
        },
        template_loading: function () {
            return "..."
        },
        width: 150,
        height: 80,
        margin: 5,
        padding: 0
    },
    _template: function (g, a) {
        a = "template" + (a ? ("_" + a) : "");
        var c = g[a];
        if (c && (typeof c == "string")) {
            if (c.indexOf("->") != -1) {
                c = c.split("->");
                switch (c[0]) {
                case "html":
                    c = dhtmlx.html.getValue(c[1]).replace(/\"/g, '\\"');
                    break;
                case "http":
                    c = new dhtmlx.ajax().sync().get(c[1], {
                        uid: (new Date()).valueOf()
                    }).responseText;
                    break;
                default:
                    break
                }
            }
            g[a] = dhtmlx.Template.fromHTML(c)
        }
    }
};
dhtmlx.SingleRender = {
    _init: function () {},
    _toHTML: function (a) {
        return this.type._item_start(a, this.type) + this.type.template(a, this.type) + this.type._item_end
    },
    render: function () {
        if (!this.callEvent || this.callEvent("onBeforeRender", [this.data])) {
            if (this.data) {
                this._dataobj.innerHTML = this._toHTML(this.data)
            }
            if (this.callEvent) {
                this.callEvent("onAfterRender", [])
            }
        }
    }
};
dhtmlx.ui.Tooltip = function (a) {
    this.name = "Tooltip";
    this.version = "3.0";
    if (dhtmlx.assert_enabled()) {
        this._assert()
    }
    if (typeof a == "string") {
        a = {
            template: a
        }
    }
    dhtmlx.extend(this, dhtmlx.Settings);
    dhtmlx.extend(this, dhtmlx.SingleRender);
    this._parseSettings(a, {
        type: "default",
        dy: 0,
        dx: 20
    });
    this._dataobj = this._obj = document.createElement("DIV");
    this._obj.className = "dhx_tooltip";
    dhtmlx.html.insertBefore(this._obj, document.body.firstChild)
};
dhtmlx.ui.Tooltip.prototype = {
    show: function (a, c) {
        if (this._disabled) {
            return
        }
        if (this.data != a) {
            this.data = a;
            this.render(a)
        }
        this._obj.style.top = c.y + this._settings.dy + "px";
        this._obj.style.left = c.x + this._settings.dx + "px";
        this._obj.style.display = "block"
    },
    hide: function () {
        this.data = null;
        this._obj.style.display = "none"
    },
    disable: function () {
        this._disabled = true
    },
    enable: function () {
        this._disabled = false
    },
    types: {
        "default": dhtmlx.Template.fromHTML("{obj.id}")
    },
    template_item_start: dhtmlx.Template.empty,
    template_item_end: dhtmlx.Template.empty
};
dhtmlx.AutoTooltip = {
    tooltip_setter: function (c) {
        var a = new dhtmlx.ui.Tooltip(c);
        this.attachEvent("onMouseMove", function (h, g) {
            a.show(this.get(h), dhtmlx.html.pos(g))
        });
        this.attachEvent("onMouseOut", function (h, g) {
            a.hide()
        });
        this.attachEvent("onMouseMoving", function (h, g) {
            a.hide()
        });
        return a
    }
};
dhtmlx.compat = function (a, c) {
    if (dhtmlx.compat[a]) {
        dhtmlx.compat[a](c)
    }
};
(function () {
    if (!window.dhtmlxError) {
        var c = function () {};
        window.dhtmlxError = {
            catchError: c,
            throwError: c
        };
        window.convertStringToBoolean = function (g) {
            return !!g
        };
        window.dhtmlxEventable = function (g) {
            dhtmlx.extend(g, dhtmlx.EventSystem)
        };
        var a = {
            getXMLTopNode: function (g) {},
            doXPath: function (g) {
                return dhtmlx.DataDriver.xml.xpath(this.xml, g)
            },
            xmlDoc: {
                responseXML: true
            }
        };
        dhtmlx.compat.dataProcessor = function (l) {
            var g = "_sendData";
            var h = "_in_progress";
            var m = "_tMode";
            var j = "_waitMode";
            l[g] = function (o, q) {
                if (!o) {
                    return
                }
                if (q) {
                    this[h][q] = (new Date()).valueOf()
                }
                if (!this.callEvent("onBeforeDataSending", q ? [q, this.getState(q)] : [])) {
                    return false
                }
                var n = this;
                var r = this.serverProcessor;
                if (this[m] != "POST") {
                    dhtmlx.ajax().get(r + ((r.indexOf("?") != -1) ? "&" : "?") + this.serialize(o, q), "", function (v, s, u) {
                        a.xml = dhtmlx.DataDriver.xml.checkResponse(v, s);
                        n.afterUpdate(n, null, null, null, a)
                    })
                } else {
                    dhtmlx.ajax().post(r, this.serialize(o, q), function (v, s, u) {
                        a.xml = dhtmlx.DataDriver.xml.checkResponse(v, s);
                        n.afterUpdate(n, null, null, null, a)
                    })
                }
                this[j]++
            }
        }
    }
})();
if (!dhtmlx.attaches) {
    dhtmlx.attaches = {}
}
dhtmlx.attaches.attachAbstract = function (c, a) {
    var j = document.createElement("DIV");
    j.id = "CustomObject_" + dhtmlx.uid();
    j.style.width = "100%";
    j.style.height = "100%";
    j.cmp = "grid";
    document.body.appendChild(j);
    this.attachObject(j.id);
    a.container = j.id;
    var h = this.vs[this.av];
    h.grid = new window[c](a);
    h.gridId = j.id;
    h.gridObj = j;
    h.grid.setSizes = function () {
        if (this.resize) {
            this.resize()
        } else {
            this.render()
        }
    };
    var g = "_viewRestore";
    return this.vs[this[g]()].grid
};
dhtmlx.attaches.attachDataView = function (a) {
    return this.attachAbstract("dhtmlXDataView", a)
};
dhtmlx.attaches.attachChart = function (a) {
    return this.attachAbstract("dhtmlXChart", a)
};
dhtmlx.compat.layout = function () {};

function dataProcessor(a) {
    this.serverProcessor = a;
    this.action_param = "!nativeeditor_status";
    this.object = null;
    this.updatedRows = [];
    this.autoUpdate = true;
    this.updateMode = "cell";
    this._tMode = "GET";
    this.post_delim = "_";
    this._waitMode = 0;
    this._in_progress = {};
    this._invalid = {};
    this.mandatoryFields = [];
    this.messages = [];
    this.styles = {
        updated: "font-weight:bold;",
        inserted: "font-weight:bold;",
        deleted: "text-decoration : line-through;",
        invalid: "background-color:FFE0E0;",
        invalid_cell: "border-bottom:2px solid red;",
        error: "color:red;",
        clear: "font-weight:normal;text-decoration:none;"
    };
    this.enableUTFencoding(true);
    dhtmlxEventable(this);
    return this
}
dataProcessor.prototype = {
    setTransactionMode: function (c, a) {
        this._tMode = c;
        this._tSend = a
    },
    escape: function (a) {
        if (this._utf) {
            return encodeURIComponent(a)
        } else {
            return escape(a)
        }
    },
    enableUTFencoding: function (a) {
        this._utf = convertStringToBoolean(a)
    },
    setDataColumns: function (a) {
        this._columns = (typeof a == "string") ? a.split(",") : a
    },
    getSyncState: function () {
        return !this.updatedRows.length
    },
    enableDataNames: function (a) {
        this._endnm = convertStringToBoolean(a)
    },
    enablePartialDataSend: function (a) {
        this._changed = convertStringToBoolean(a)
    },
    setUpdateMode: function (c, a) {
        this.autoUpdate = (c == "cell");
        this.updateMode = c;
        this.dnd = a
    },
    ignore: function (c, a) {
        this._silent_mode = true;
        c.call(a || window);
        this._silent_mode = false
    },
    setUpdated: function (h, g, j) {
        if (this._silent_mode) {
            return
        }
        var c = this.findRow(h);
        j = j || "updated";
        var a = this.obj.getUserData(h, this.action_param);
        if (a && j == "updated") {
            j = a
        }
        if (g) {
            this.set_invalid(h, false);
            this.updatedRows[c] = h;
            this.obj.setUserData(h, this.action_param, j);
            if (this._in_progress[h]) {
                this._in_progress[h] = "wait"
            }
        } else {
            if (!this.is_invalid(h)) {
                this.updatedRows.splice(c, 1);
                this.obj.setUserData(h, this.action_param, "")
            }
        }
        if (!g) {
            this._clearUpdateFlag(h)
        }
        this.markRow(h, g, j);
        if (g && this.autoUpdate) {
            this.sendData(h)
        }
    },
    _clearUpdateFlag: function (a) {},
    markRow: function (l, g, j) {
        var h = "";
        var c = this.is_invalid(l);
        if (c) {
            h = this.styles[c];
            g = true
        }
        if (this.callEvent("onRowMark", [l, g, j, c])) {
            h = this.styles[g ? j : "clear"] + h;
            this.obj[this._methods[0]](l, h);
            if (c && c.details) {
                h += this.styles[c + "_cell"];
                for (var a = 0; a < c.details.length; a++) {
                    if (c.details[a]) {
                        this.obj[this._methods[1]](l, a, h)
                    }
                }
            }
        }
    },
    getState: function (a) {
        return this.obj.getUserData(a, this.action_param)
    },
    is_invalid: function (a) {
        return this._invalid[a]
    },
    set_invalid: function (g, c, a) {
        if (a) {
            c = {
                value: c,
                details: a,
                toString: function () {
                    return this.value.toString()
                }
            }
        }
        this._invalid[g] = c
    },
    checkBeforeUpdate: function (a) {
        return true
    },
    sendData: function (a) {
        if (this._waitMode && (this.obj.mytype == "tree" || this.obj._h2)) {
            return
        }
        if (this.obj.editStop) {
            this.obj.editStop()
        }
        if (typeof a == "undefined" || this._tSend) {
            return this.sendAllData()
        }
        if (this._in_progress[a]) {
            return false
        }
        this.messages = [];
        if (!this.checkBeforeUpdate(a) && this.callEvent("onValidationError", [a, this.messages])) {
            return false
        }
        this._beforeSendData(this._getRowData(a), a)
    },
    _beforeSendData: function (a, c) {
        if (!this.callEvent("onBeforeUpdate", [c, this.getState(c), a])) {
            return false
        }
        this._sendData(a, c)
    },
    serialize: function (h, j) {
        if (typeof h == "string") {
            return h
        }
        if (typeof j != "undefined") {
            return this.serialize_one(h, "")
        } else {
            var a = [];
            var g = [];
            for (var c in h) {
                if (h.hasOwnProperty(c)) {
                    a.push(this.serialize_one(h[c], c + this.post_delim));
                    g.push(c)
                }
            }
            a.push("ids=" + this.escape(g.join(",")));
            if (dhtmlx.security_key) {
                a.push("dhx_security=" + dhtmlx.security_key)
            }
            return a.join("&")
        }
    },
    serialize_one: function (h, c) {
        if (typeof h == "string") {
            return h
        }
        var a = [];
        for (var g in h) {
            if (h.hasOwnProperty(g)) {
                a.push(this.escape((c || "") + g) + "=" + this.escape(h[g]))
            }
        }
        return a.join("&")
    },
    _sendData: function (c, g) {
        if (!c) {
            return
        }
        if (!this.callEvent("onBeforeDataSending", g ? [g, this.getState(g), c] : [null, null, c])) {
            return false
        }
        if (g) {
            this._in_progress[g] = (new Date()).valueOf()
        }
        var a = new dtmlXMLLoaderObject(this.afterUpdate, this, true);
        var h = this.serverProcessor + (this._user ? (getUrlSymbol(this.serverProcessor) + ["dhx_user=" + this._user, "dhx_version=" + this.obj.getUserData(0, "version")].join("&")) : "");
        if (this._tMode != "POST") {
            a.loadXML(h + ((h.indexOf("?") != -1) ? "&" : "?") + this.serialize(c, g))
        } else {
            a.loadXML(h, true, this.serialize(c, g))
        }
        this._waitMode++
    },
    sendAllData: function () {
        if (!this.updatedRows.length) {
            return
        }
        this.messages = [];
        var c = true;
        for (var a = 0; a < this.updatedRows.length; a++) {
            c &= this.checkBeforeUpdate(this.updatedRows[a])
        }
        if (!c && !this.callEvent("onValidationError", ["", this.messages])) {
            return false
        }
        if (this._tSend) {
            this._sendData(this._getAllData())
        } else {
            for (var a = 0; a < this.updatedRows.length; a++) {
                if (!this._in_progress[this.updatedRows[a]]) {
                    if (this.is_invalid(this.updatedRows[a])) {
                        continue
                    }
                    this._beforeSendData(this._getRowData(this.updatedRows[a]), this.updatedRows[a]);
                    if (this._waitMode && (this.obj.mytype == "tree" || this.obj._h2)) {
                        return
                    }
                }
            }
        }
    },
    _getAllData: function (h) {
        var c = {};
        var a = false;
        for (var g = 0; g < this.updatedRows.length; g++) {
            var j = this.updatedRows[g];
            if (this._in_progress[j] || this.is_invalid(j)) {
                continue
            }
            if (!this.callEvent("onBeforeUpdate", [j, this.getState(j)])) {
                continue
            }
            c[j] = this._getRowData(j, j + this.post_delim);
            a = true;
            this._in_progress[j] = (new Date()).valueOf()
        }
        return a ? c : null
    },
    setVerificator: function (c, a) {
        this.mandatoryFields[c] = a || (function (g) {
            return (g != "")
        })
    },
    clearVerificator: function (a) {
        this.mandatoryFields[a] = false
    },
    findRow: function (c) {
        var a = 0;
        for (a = 0; a < this.updatedRows.length; a++) {
            if (c == this.updatedRows[a]) {
                break
            }
        }
        return a
    },
    defineAction: function (a, c) {
        if (!this._uActions) {
            this._uActions = []
        }
        this._uActions[a] = c
    },
    afterUpdateCallback: function (c, m, l, j) {
        var a = c;
        var h = (l != "error" && l != "invalid");
        if (!h) {
            this.set_invalid(c, l)
        }
        if ((this._uActions) && (this._uActions[l]) && (!this._uActions[l](j))) {
            return (delete this._in_progress[a])
        }
        if (this._in_progress[a] != "wait") {
            this.setUpdated(c, false)
        }
        var g = c;
        switch (l) {
        case "inserted":
        case "insert":
            if (m != c) {
                this.obj[this._methods[2]](c, m);
                c = m
            }
            break;
        case "delete":
        case "deleted":
            this.obj.setUserData(c, this.action_param, "true_deleted");
            this.obj[this._methods[3]](c);
            delete this._in_progress[a];
            return this.callEvent("onAfterUpdate", [c, l, m, j]);
            break
        }
        if (this._in_progress[a] != "wait") {
            if (h) {
                this.obj.setUserData(c, this.action_param, "")
            }
            delete this._in_progress[a]
        } else {
            delete this._in_progress[a];
            this.setUpdated(m, true, this.obj.getUserData(c, this.action_param))
        }
        this.callEvent("onAfterUpdate", [g, l, m, j])
    },
    afterUpdate: function (n, s, q, o, m) {
        m.getXMLTopNode("data");
        if (!m.xmlDoc.responseXML) {
            return
        }
        var r = m.doXPath("//data/action");
        for (var j = 0; j < r.length; j++) {
            var l = r[j];
            var h = l.getAttribute("type");
            var a = l.getAttribute("sid");
            var g = l.getAttribute("tid");
            n.afterUpdateCallback(a, g, h, l)
        }
        n.finalizeUpdate()
    },
    finalizeUpdate: function () {
        if (this._waitMode) {
            this._waitMode--
        }
        if ((this.obj.mytype == "tree" || this.obj._h2) && this.updatedRows.length) {
            this.sendData()
        }
        this.callEvent("onAfterUpdateFinish", []);
        if (!this.updatedRows.length) {
            this.callEvent("onFullSync", [])
        }
    },
    init: function (a) {
        this.obj = a;
        if (this.obj._dp_init) {
            this.obj._dp_init(this)
        }
    },
    setOnAfterUpdate: function (a) {
        this.attachEvent("onAfterUpdate", a)
    },
    enableDebug: function (a) {},
    setOnBeforeUpdateHandler: function (a) {
        this.attachEvent("onBeforeDataSending", a)
    },
    setAutoUpdate: function (g, c) {
        g = g || 2000;
        this._user = c || (new Date()).valueOf();
        this._need_update = false;
        this._loader = null;
        this._update_busy = false;
        this.attachEvent("onAfterUpdate", function (h, l, m, j) {
            this.afterAutoUpdate(h, l, m, j)
        });
        this.attachEvent("onFullSync", function () {
            this.fullSync()
        });
        var a = this;
        window.setInterval(function () {
            a.loadUpdate()
        }, g)
    },
    afterAutoUpdate: function (a, g, h, c) {
        if (g == "collision") {
            this._need_update = true;
            return false
        } else {
            return true
        }
    },
    fullSync: function () {
        if (this._need_update == true) {
            this._need_update = false;
            this.loadUpdate()
        }
        return true
    },
    getUpdates: function (a, c) {
        if (this._update_busy) {
            return false
        } else {
            this._update_busy = true
        }
        this._loader = this._loader || new dtmlXMLLoaderObject(true);
        this._loader.async = true;
        this._loader.waitCall = c;
        this._loader.loadXML(a)
    },
    _v: function (a) {
        if (a.firstChild) {
            return a.firstChild.nodeValue
        }
        return ""
    },
    _a: function (a) {
        var g = [];
        for (var c = 0; c < a.length; c++) {
            g[c] = this._v(a[c])
        }
        return g
    },
    loadUpdate: function () {
        var c = this;
        var a = this.obj.getUserData(0, "version");
        var g = this.serverProcessor + getUrlSymbol(this.serverProcessor) + ["dhx_user=" + this._user, "dhx_version=" + a].join("&");
        g = g.replace("editing=true&", "");
        this.getUpdates(g, function () {
            var l = c._loader.doXPath("//userdata");
            c.obj.setUserData(0, "version", c._v(l[0]));
            var h = c._loader.doXPath("//update");
            if (h.length) {
                c._silent_mode = true;
                for (var m = 0; m < h.length; m++) {
                    var j = h[m].getAttribute("status");
                    var o = h[m].getAttribute("id");
                    var n = h[m].getAttribute("parent");
                    switch (j) {
                    case "inserted":
                        c.callEvent("insertCallback", [h[m], o, n]);
                        break;
                    case "updated":
                        c.callEvent("updateCallback", [h[m], o, n]);
                        break;
                    case "deleted":
                        c.callEvent("deleteCallback", [h[m], o, n]);
                        break
                    }
                }
                c._silent_mode = false
            }
            c._update_busy = false;
            c = null
        })
    }
};
if (window.dhtmlXGridObject && !dhtmlXGridObject.prototype._init_point_connector) {
    dhtmlXGridObject.prototype._init_point_connector = dhtmlXGridObject.prototype._init_point;
    dhtmlXGridObject.prototype._init_point = function () {
        this._con_f_used = [].concat(this._con_f_used);
        dhtmlXGridObject.prototype._con_f_used = [];
        var a = function (j) {
                j = j.replace(/(\?|\&)connector[^\f]*/g, "");
                return j + (j.indexOf("?") != -1 ? "&" : "?") + "connector=true" + (this.hdr.rows.length > 0 ? "&dhx_no_header=1" : "")
            };
        var h = function (j) {
                return a.call(this, j) + (this._connector_sorting || "") + (this._connector_filter || "")
            };
        var g = function (l, m, j) {
                this._connector_sorting = "&dhx_sort[" + m + "]=" + j;
                return h.call(this, l)
            };
        var c = function (l, j, n) {
                var o = [];
                for (var m = 0; m < j.length; m++) {
                    o[m] = "dhx_filter[" + j[m] + "]=" + encodeURIComponent(n[m])
                }
                this._connector_filter = "&" + o.join("&");
                return h.call(this, l)
            };
        this.attachEvent("onCollectValues", function (j) {
            if (this._con_f_used[j]) {
                if (typeof (this._con_f_used[j]) == "object") {
                    return this._con_f_used[j]
                } else {
                    return false
                }
            }
            return true
        });
        this.attachEvent("onDynXLS", function () {
            this.xmlFileUrl = h.call(this, this.xmlFileUrl);
            return true
        });
        this.attachEvent("onBeforeSorting", function (n, m, l) {
            if (m == "connector") {
                var j = this;
                this.clearAndLoad(g.call(this, this.xmlFileUrl, n, l), function () {
                    j.setSortImgState(true, n, l)
                });
                return false
            }
            return true
        });
        this.attachEvent("onFilterStart", function (l, j) {
            var n = this.getSortingState();
            if (this._con_f_used.length) {
                var m = this;
                this.clearAndLoad(c.call(this, this.xmlFileUrl, l, j));
                if (n.length) {
                    m.setSortImgState(true, n[0], n[1])
                }
                return false
            }
            return true
        });
        this.attachEvent("onXLE", function (l, j, n, m) {
            if (!m) {
                return
            }
        });
        if (this._init_point_connector) {
            this._init_point_connector()
        }
    };
    dhtmlXGridObject.prototype._con_f_used = [];
    dhtmlXGridObject.prototype._in_header_connector_text_filter = function (c, a) {
        if (!this._con_f_used[a]) {
            this._con_f_used[a] = 1
        }
        return this._in_header_text_filter(c, a)
    };
    dhtmlXGridObject.prototype._in_header_connector_select_filter = function (c, a) {
        if (!this._con_f_used[a]) {
            this._con_f_used[a] = 2
        }
        return this._in_header_select_filter(c, a)
    };
    dhtmlXGridObject.prototype.load_connector = dhtmlXGridObject.prototype.load;
    dhtmlXGridObject.prototype.load = function (c, j, h) {
        if (!this._colls_loaded && this.cellType) {
            var a = [];
            for (var g = 0; g < this.cellType.length; g++) {
                if (this.cellType[g].indexOf("co") == 0 || this.cellType[g].indexOf("clist") == 0 || this._con_f_used[g] == 2) {
                    a.push(g)
                }
            }
            if (a.length) {
                arguments[0] += (arguments[0].indexOf("?") != -1 ? "&" : "?") + "connector=true&dhx_colls=" + a.join(",")
            }
        }
        return this.load_connector.apply(this, arguments)
    };
    dhtmlXGridObject.prototype._parseHead_connector = dhtmlXGridObject.prototype._parseHead;
    dhtmlXGridObject.prototype._parseHead = function (c, w, r) {
        this._parseHead_connector.apply(this, arguments);
        if (!this._colls_loaded) {
            var s = this.xmlLoader.doXPath("./coll_options", arguments[0]);
            for (var n = 0; n < s.length; n++) {
                var q = s[n].getAttribute("for");
                var u = [];
                var h = null;
                if (this.cellType[q] == "combo") {
                    h = this.getColumnCombo(q)
                } else {
                    if (this.cellType[q].indexOf("co") == 0) {
                        h = this.getCombo(q)
                    }
                }
                var m = this.xmlLoader.doXPath("./item", s[n]);
                var a = [];
                for (var l = 0; l < m.length; l++) {
                    var g = m[l].getAttribute("value");
                    if (h) {
                        var o = m[l].getAttribute("label") || g;
                        if (h.addOption) {
                            a.push([g, o])
                        } else {
                            h.put(g, o)
                        }
                        u[u.length] = o
                    } else {
                        u[u.length] = g
                    }
                }
                if (a.length) {
                    if (h) {
                        h.addOption(a)
                    }
                } else {
                    if (u.length && !h) {
                        if (this.registerCList) {
                            this.registerCList(q * 1, u)
                        }
                    }
                }
                if (this._con_f_used[q * 1]) {
                    this._con_f_used[q * 1] = u
                }
            }
            this._colls_loaded = true
        }
    }
}
if (window.dataProcessor && !dataProcessor.prototype.init_original) {
    dataProcessor.prototype.init_original = dataProcessor.prototype.init;
    dataProcessor.prototype.init = function (a) {
        this.init_original(a);
        a._dataprocessor = this;
        this.setTransactionMode("POST", true);
        this.serverProcessor += (this.serverProcessor.indexOf("?") != -1 ? "&" : "?") + "editing=true"
    }
}
dhtmlxError.catchError("LoadXML", function (h, g, j) {
    alert(j[0].responseText)
});

function dhtmlXCellObject(g, a) {
    this.cell = document.createElement("DIV");
    this.cell.className = "dhx_cell" + (a || "");
    this._idd = g;
    this._isCell = true;
    this.conf = {
        borders: true,
        idx: {},
        css: a || "",
        idx_data: {
            cont: "dhx_cell_cont",
            pr1: "dhx_cell_progress_bar",
            pr2: "dhx_cell_progress_img",
            menu: "dhx_cell_menu",
            toolbar: "dhx_cell_toolbar",
            ribbon: "dhx_cell_ribbon",
            sb: "dhx_cell_statusbar"
        },
        ofs_nodes: {
            t: {},
            b: {}
        }
    };
    this.dataNodes = {};
    this.views = {};
    var c = document.createElement("DIV");
    c.className = "dhx_cell_cont" + this.conf.css;
    this.cell.appendChild(c);
    c = null;
    this._updateIdx = function () {
        for (var h in this.conf.idx) {
            this.conf.idx[h] = null;
            delete this.conf.idx[h]
        }
        for (var m = 0; m < this.cell.childNodes.length; m++) {
            var j = this.cell.childNodes[m].className;
            for (var h in this.conf.idx_data) {
                var l = new RegExp(this.conf.idx_data[h]);
                if (j.match(l) != null) {
                    this.conf.idx[h] = m
                }
            }
        }
        this.callEvent("_onIdxUpdated", [])
    };
    this._adjustAttached = function () {
        for (var h in this.dataNodes) {
            if (this.dataNodes[h] != null && typeof (this.dataNodes[h].setSizes) == "function") {
                this.dataNodes[h].setSizes()
            }
        }
        if (this.dataObj != null && typeof (this.dataObj.setSizes) == "function") {
            this.dataObj.setSizes.apply(this.dataObj, arguments)
        }
    };
    this._setSize = function (l, r, m, o, q, j, n) {
        if (!this.conf.size) {
            this.conf.size = {}
        }
        this.conf.size.x = l;
        this.conf.size.y = r;
        this.conf.size.w = m;
        this.conf.size.h = o;
        this.cell.style.left = l + "px";
        this.cell.style.top = r + "px";
        this.cell.style.width = m + "px";
        this.cell.style.height = o + "px";
        this.callEvent("_onSetSize", []);
        if (j !== true) {
            this._adjustCont(q, n)
        } else {
            this._adjustAttached(q)
        }
        this._adjustProgress()
    };
    this._adjustCont = function (o, m) {
        var n = this.cell.childNodes[this.conf.idx.cont];
        var l = 0;
        for (var h in this.conf.ofs_nodes.t) {
            var j = this.conf.ofs_nodes.t[h];
            l += (j == "func" ? this[h]() : (j == true ? this.cell.childNodes[this.conf.idx[h]].offsetHeight : 0))
        }
        var q = 0;
        for (var h in this.conf.ofs_nodes.b) {
            var j = this.conf.ofs_nodes.b[h];
            q += (j == "func" ? this[h]() : (j == true ? this.cell.childNodes[this.conf.idx[h]].offsetHeight : 0))
        }
        n.style.left = "0px";
        n.style.top = l + "px";
        if (!this.conf.cells_cont) {
            this.conf.cells_cont = {};
            n.style.width = this.cell.offsetWidth + "px";
            n.style.height = Math.max(this.cell.offsetHeight - l - q, 0) + "px";
            this.conf.cells_cont.w = parseInt(n.style.width) - n.offsetWidth;
            this.conf.cells_cont.h = parseInt(n.style.height) - n.offsetHeight
        }
        n.style.left = "0px";
        n.style.top = l + "px";
        n.style.width = Math.max(this.cell.offsetWidth + this.conf.cells_cont.w, 0) + "px";
        n.style.height = Math.max(this.conf.size.h - l - q + this.conf.cells_cont.h, 0) + "px";
        n = null;
        this._adjustAttached(o);
        if (m == "expand" && this.dataType == "editor" && this.dataObj != null) {
            this.dataObj._prepareContent(true)
        }
    };
    this._mtbUpdBorder = function () {
        var j = ["menu", "toolbar"];
        for (var m = 0; m < j.length; m++) {
            if (this.conf.idx[j[m]] != null) {
                var n = this.cell.childNodes[this.conf.idx[j[m]]];
                var l = "dhx_cell_" + j[m] + "_no_borders";
                var h = "dhx_cell_" + j[m] + "_def";
                n.className = n.className.replace(new RegExp(this.conf.borders ? l : h), this.conf.borders ? h : l);
                n = null
            }
        }
    };
    this._resetSizeState = function () {
        this.conf.cells_cont = null
    };
    this.conf.view = "def";
    this.conf.views_loaded = {};
    this.conf.views_loaded[this.conf.view] = true;
    this._viewSave = function (l) {
        this.views[l] = {
            borders: this.conf.borders,
            ofs_nodes: {
                t: {},
                b: {}
            },
            dataType: this.dataType,
            dataObj: this.dataObj,
            cellCont: [],
            dataNodes: {},
            dataNodesCont: {}
        };
        var m = this.cell.childNodes[this.conf.idx.cont];
        while (m.childNodes.length > 0) {
            this.views[l].cellCont.push(m.firstChild);
            m.removeChild(m.firstChild)
        }
        this.dataType = null;
        this.dataObj = null;
        for (var j in this.dataNodes) {
            for (var h in this.conf.ofs_nodes) {
                if (typeof (this.conf.ofs_nodes[h][j]) != "undefined") {
                    this.views[l].ofs_nodes[h][j] = this.conf.ofs_nodes[h][j];
                    this.conf.ofs_nodes[h][j] = null;
                    delete this.conf.ofs_nodes[h][j]
                }
            }
            this.views[l].dataNodesCont[j] = this.cell.childNodes[this.conf.idx[j]];
            this.cell.removeChild(this.cell.childNodes[this.conf.idx[j]]);
            this.views[l].dataNodes[j] = this.dataNodes[j];
            this.dataNodes[j] = null;
            delete this.dataNodes[j];
            this._updateIdx()
        }
        this.callEvent("_onViewSave", [l])
    };
    this._viewRestore = function (l) {
        if (this.views[l] == null) {
            return
        }
        this.dataObj = this.views[l].dataObj;
        this.dataType = this.views[l].dataType;
        for (var m = 0; m < this.views[l].cellCont.length; m++) {
            this.cell.childNodes[this.conf.idx.cont].appendChild(this.views[l].cellCont[m])
        }
        for (var j in this.views[l].dataNodes) {
            this.dataNodes[j] = this.views[l].dataNodes[j];
            if (j == "menu") {
                this.cell.insertBefore(this.views[l].dataNodesCont[j], this.cell.childNodes[this.conf.idx.toolbar || this.conf.idx.cont])
            }
            if (j == "toolbar") {
                this.cell.insertBefore(this.views[l].dataNodesCont[j], this.cell.childNodes[this.conf.idx.cont])
            }
            if (j == "sb") {
                this.cell.appendChild(this.views[l].dataNodesCont[j])
            }
            this._updateIdx()
        }
        for (var j in this.views[l].ofs_nodes) {
            for (var h in this.views[l].ofs_nodes[j]) {
                this.conf.ofs_nodes[j][h] = this.views[l].ofs_nodes[j][h]
            }
        }
        if (this.conf.borders != this.views[l].borders) {
            this[this.views[l].borders ? "_showBorders" : "_hideBorders"](true)
        }
        this.callEvent("_onViewRestore", [l]);
        this._viewDelete(l)
    };
    this._viewDelete = function (l) {
        if (this.views[l] == null) {
            return
        }
        this.views[l].borders = null;
        for (var j in this.views[l].ofs_nodes) {
            for (var h in this.views[l].ofs_nodes[j]) {
                this.views[l].ofs_nodes[j][h] = null
            }
            this.views[l].ofs_nodes[j] = null
        }
        this.views[l].dataType = null;
        this.views[l].dataObj = null;
        for (var m = 0; m < this.views[l].cellCont.length; m++) {
            this.views[l].cellCont[m] = null
        }
        this.views[l].cellCont = null;
        for (var j in this.views[l].dataNodes) {
            this.views[l].dataNodes[j] = null;
            this.views[l].dataNodesCont[j] = null
        }
        this.views[l].dataNodes = this.views[l].dataNodesCont = null;
        this.views[l] = null;
        delete this.views[l]
    };
    window.dhx4._eventable(this);
    this._updateIdx();
    return this
}
dhtmlXCellObject.prototype.showView = function (a) {
    if (this.conf.view == a) {
        return false
    }
    this._viewSave(this.conf.view);
    this._viewRestore(a);
    this._updateIdx();
    this._adjustCont();
    this.conf.view = a;
    var c = (typeof (this.conf.views_loaded[this.conf.view]) == "undefined");
    this.conf.views_loaded[this.conf.view] = true;
    return c
};
dhtmlXCellObject.prototype.getViewName = function () {
    return this.conf.view
};
dhtmlXCellObject.prototype.unloadView = function (h) {
    if (h == this.conf.view) {
        var j = this.conf.unloading;
        this.conf.unloading = true;
        this.detachMenu();
        this.detachToolbar();
        this.detachStatusBar();
        this.detachRibbon();
        this._detachObject(null, true);
        this.conf.unloading = j;
        if (!this.conf.unloading) {
            this._adjustCont(this._idd)
        }
        return
    }
    if (this.views[h] == null) {
        return
    }
    var g = this.views[h];
    for (var c in g.dataNodes) {
        if (typeof (g.dataNodes[c].unload) == "function") {
            g.dataNodes[c].unload()
        }
        g.dataNodes[c] = null;
        g.dataNodesCont[c] = null
    }
    if (g.dataType == "url") {
        if (g.cellCont != null && g.cellCont[0] != "null") {
            this._detachURLEvents(g.cellCont[0])
        }
    } else {
        if (g.dataObj != null) {
            if (typeof (g.dataObj.unload) == "function") {
                g.dataObj.unload()
            } else {
                if (typeof (g.dataObj.destructor) == "function") {
                    g.dataObj.destructor()
                }
            }
            g.dataObj = null
        }
    }
    g = null;
    this._viewDelete(h);
    if (typeof (this.conf.views_loaded[h]) != "undefined") {
        delete this.conf.views_loaded[h]
    }
};
dhtmlXCellObject.prototype.getId = function () {
    return this._idd
};
dhtmlXCellObject.prototype.progressOn = function () {
    if (this.conf.progress) {
        return
    }
    this.conf.progress = true;
    var c = document.createElement("DIV");
    c.className = "dhx_cell_progress_bar";
    this.cell.appendChild(c);
    var a = document.createElement("DIV");
    a.className = "dhx_cell_progress_img";
    this.cell.appendChild(a);
    c = a = null;
    this._updateIdx();
    this._adjustProgress()
};
dhtmlXCellObject.prototype.progressOff = function () {
    if (!this.conf.progress) {
        return
    }
    this.cell.childNodes[this.conf.idx.pr2].parentNode.removeChild(this.cell.childNodes[this.conf.idx.pr2]);
    this.cell.childNodes[this.conf.idx.pr1].parentNode.removeChild(this.cell.childNodes[this.conf.idx.pr1]);
    this.conf.progress = false;
    this._updateIdx()
};
dhtmlXCellObject.prototype._adjustProgress = function () {
    if (this.conf.idx.pr1 == null) {
        return
    }
    if (!this.conf.pr) {
        this.conf.pr = {}
    }
    var c = this.cell.childNodes[this.conf.idx.pr1];
    var a = this.cell.childNodes[this.conf.idx.pr2];
    if (!this.conf.pr.ofs) {
        a.style.width = c.offsetWidth + "px";
        a.style.height = c.offsetHeight + "px";
        this.conf.pr.ofs = {
            w: a.offsetWidth - a.clientWidth,
            h: a.offsetHeight - a.clientHeight
        }
    }
    a.style.width = c.offsetWidth - this.conf.pr.ofs.w + "px";
    a.style.height = c.offsetHeight - this.conf.pr.ofs.h + "px";
    c = a = null
};
dhtmlXCellObject.prototype._showBorders = function (a) {
    if (this.conf.borders) {
        return
    }
    this.conf.borders = true;
    this.cell.childNodes[this.conf.idx.cont].className = "dhx_cell_cont" + this.conf.css;
    this.conf.cells_cont = null;
    this._mtbUpdBorder();
    this.callEvent("_onBorderChange", [true]);
    if (a !== true) {
        this._adjustCont(this._idd)
    }
};
dhtmlXCellObject.prototype._hideBorders = function (a) {
    if (!this.conf.borders) {
        return
    }
    this.conf.borders = false;
    this.cell.childNodes[this.conf.idx.cont].className = "dhx_cell_cont" + this.conf.css + " dhx_cell_cont_no_borders";
    this.conf.cells_cont = null;
    this._mtbUpdBorder();
    this.callEvent("_onBorderChange", [false]);
    if (a !== true) {
        this._adjustCont(this._idd)
    }
};
dhtmlXCellObject.prototype._getWidth = function () {
    return this.cell.offsetWidth
};
dhtmlXCellObject.prototype._getHeight = function () {
    return this.cell.offsetHeight
};
dhtmlXCellObject.prototype.showInnerScroll = function () {
    this.cell.childNodes[this.conf.idx.cont].style.overflow = "auto"
};
dhtmlXCellObject.prototype._unload = function () {
    this.conf.unloading = true;
    this.callEvent("_onCellUnload", []);
    this.progressOff();
    this.unloadView(this.conf.view);
    this.dataNodes = null;
    this.cell.parentNode.removeChild(this.cell);
    this.cell = null;
    window.dhx4._eventable(this, "clear");
    for (var c in this.views) {
        this.unloadView(c)
    }
    this.conf = null;
    for (var c in this) {
        this[c] = null
    }
};
dhtmlXCellObject.prototype.attachObject = function (j, g) {
    if (window.dhx4.s2b(g) && !(typeof (window.dhtmlXWindowsCell) != "undefined" && (this instanceof window.dhtmlXWindowsCell))) {
        g = false
    }
    if (typeof (j) == "string") {
        j = document.getElementById(j)
    }
    if (j.parentNode == this.cell.childNodes[this.conf.idx.cont]) {
        j = null;
        return
    }
    if (g) {
        j.style.display = "";
        var a = j.offsetWidth;
        var c = j.offsetHeight
    }
    this._attachObject(j);
    this.dataType = "obj";
    j.style.display = "";
    j = null;
    if (g) {
        this._adjustByCont(a, c)
    }
};
dhtmlXCellObject.prototype.appendObject = function (a) {
    if (typeof (a) == "string") {
        a = document.getElementById(a)
    }
    if (a.parentNode == this.cell.childNodes[this.conf.idx.cont]) {
        a = null;
        return
    }
    if (!this.conf.append_mode) {
        this.cell.childNodes[this.conf.idx.cont].style.overflow = "auto";
        this.conf.append_mode = true
    }
    this._attachObject(a, null, null, true);
    this.dataType = "obj";
    a.style.display = "";
    a = null
};
dhtmlXCellObject.prototype.detachObject = function (c, a) {
    this._detachObject(null, c, a)
};
dhtmlXCellObject.prototype.getAttachedMenu = function () {
    return this.dataNodes.menu
};
dhtmlXCellObject.prototype.getAttachedToolbar = function () {
    return this.dataNodes.toolbar
};
dhtmlXCellObject.prototype.getAttachedRibbon = function () {
    return this.dataNodes.ribbon
};
dhtmlXCellObject.prototype.getAttachedStatusBar = function () {
    return this.dataNodes.sb
};
dhtmlXCellObject.prototype.getAttachedObject = function () {
    return this.dataObj
};
dhtmlXCellObject.prototype.attachURL = function (c, q, g) {
    if (g == true) {
        g = {}
    }
    var h = (typeof (g) != "undefined" && g != false && g != null);
    if (!this.conf.url_data) {
        this.conf.url_data = {}
    }
    this.conf.url_data.url = c;
    this.conf.url_data.ajax = (q == true);
    this.conf.url_data.post_data = (g == true ? {} : (g || null));
    if (q == true) {
        var o = this;
        if (h) {
            var j = "";
            for (var n in g) {
                j += "&" + encodeURIComponent(n) + "=" + encodeURIComponent(g[n])
            }
            dhx4.ajax.post(c, j, function (a) {
                o.attachHTMLString("<div style='position:relative;width:100%;height:100%;overflow:auto;'>" + a.xmlDoc.responseText + "</div>");
                if (typeof (o._doOnFrameContentLoaded) == "function") {
                    o._doOnFrameContentLoaded()
                }
                o.dataType = "url-ajax";
                o = a = null
            })
        } else {
            dhx4.ajax.get(c, function (a) {
                o.attachHTMLString("<div style='position:relative;width:100%;height:100%;overflow:auto;'>" + a.xmlDoc.responseText + "</div>");
                if (typeof (o._doOnFrameContentLoaded) == "function") {
                    o._doOnFrameContentLoaded()
                }
                o.dataType = "url-ajax";
                o = a = null
            })
        }
    } else {
        if (this.dataType == "url") {
            var l = this.getFrame()
        } else {
            var l = document.createElement("IFRAME");
            l.frameBorder = 0;
            l.border = 0;
            l.style.width = "100%";
            l.style.height = "100%";
            l.style.position = "relative";
            this._attachObject(l);
            this.dataType = "url";
            this._attachURLEvents()
        }
        if (h) {
            var m = (typeof (this.conf.url_data.post_ifr) == "undefined");
            this.conf.url_data.post_ifr = true;
            if (m) {
                this._attachURLEvents()
            }
            l.src = "about:blank"
        } else {
            l.src = c + (c.indexOf("?") >= 0 ? "&" : "?") + "dhxr" + new Date().getTime()
        }
        l = null
    }
    l = null
};
dhtmlXCellObject.prototype.reloadURL = function () {
    if (!(this.dataType == "url" || this.dataType == "url-ajax")) {
        return
    }
    if (this.conf.url_data == null) {
        return
    }
    this.attachURL(this.conf.url_data.url, this.conf.url_data.ajax, this.conf.url_data.post_data)
};
dhtmlXCellObject.prototype.attachHTMLString = function (str) {
    this._attachObject(null, null, str);
    var z = str.match(/<script[^>]*>[^\f]*?<\/script>/g) || [];
    for (var i = 0; i < z.length; i++) {
        var s = z[i].replace(/<([\/]{0,1})script[^>]*>/gi, "");
        if (s) {
            if (window.execScript) {
                window.execScript(s)
            } else {
                window.eval(s)
            }
        }
    }
};
dhtmlXCellObject.prototype.attachLayout = function (a) {
    if (this.conf.skin == "dhx_skyblue" && typeof (window.dhtmlXWindowsCell) != "undefined" && (this instanceof dhtmlXWindowsCell)) {}
    if (this instanceof dhtmlXLayoutCell) {
        this._hideBorders()
    }
    var c = document.createElement("DIV");
    c.style.width = "100%";
    c.style.height = "100%";
    c.style.position = "relative";
    c.style.overflow = "hidden";
    this._attachObject(c);
    if (typeof (this._layoutMainInst) != "undefined") {
        c._layoutMainInst = this._layoutMainInst
    }
    if (this instanceof window.dhtmlXLayoutCell) {}
    if (typeof (window.dhtmlXLayoutCell) != "undefined" && this instanceof dhtmlXLayoutCell) {
        c._isParentCell = true
    }
    if (typeof (window.dhtmlXAccordionCell) != "undefined" && (this instanceof window.dhtmlXAccordionCell)) {
        c._ofs = {
            t: -1
        }
    }
    if (typeof (a) == "string") {
        a = {
            pattern: a
        }
    }
    if (typeof (a.skin) == "undefined") {
        a.skin = this.conf.skin
    }
    a.parent = c;
    this.dataType = "layout";
    this.dataObj = new dhtmlXLayoutObject(a);
    if (this instanceof dhtmlXLayoutCell) {
        this.dataObj.parentLayout = this.layout
    }
    c._layoutMainInst = null;
    a.parent = null;
    c = a = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachTree = function (a) {
    var c = document.createElement("DIV");
    c.style.width = "100%";
    c.style.height = "100%";
    c.style.position = "relative";
    c.style.overflow = "hidden";
    this._attachObject(c);
    this.dataType = "tree";
    this.dataObj = new dhtmlXTreeObject(c, "100%", "100%", (a || 0));
    this.dataObj.setSkin(this.conf.skin);
    this.dataObj.allTree.childNodes[0].style.marginTop = "2px";
    this.dataObj.allTree.childNodes[0].style.marginBottom = "2px";
    c = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachGrid = function () {
    var a = document.createElement("DIV");
    a.style.width = "100%";
    a.style.height = "100%";
    a.style.position = "relative";
    a.style.overflow = "hidden";
    this._attachObject(a);
    this.dataType = "grid";
    this.dataObj = new dhtmlXGridObject(a);
    this.dataObj.setSkin(this.conf.skin);
    if (this.conf.skin == "dhx_skyblue" && typeof (window.dhtmlXWindowsCell) != "undefined" && this instanceof window.dhtmlXWindowsCell) {
        this.dataObj.entBox.style.border = "1px solid #a4bed4";
        this.dataObj._sizeFix = 0
    } else {
        this.dataObj.entBox.style.border = "0px solid white";
        this.dataObj._sizeFix = 2
    }
    a = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachTabbar = function (a) {
    if (typeof (window.dhtmlXLayoutCell) != "undefined" && this instanceof dhtmlXLayoutCell) {
        this._hideBorders()
    }
    if (typeof (a) == "string") {
        a = {
            mode: a
        }
    } else {
        if (typeof (a) != "object" || a == null) {
            a = {}
        }
    }
    var c = document.createElement("DIV");
    c.style.width = "100%";
    c.style.height = "100%";
    c.style.position = "relative";
    c.style.overflow = "hidden";
    if (typeof (window.dhtmlXAccordionCell) != "undefined" && (this instanceof window.dhtmlXAccordionCell)) {
        c._ofs = {
            t: -1
        }
    }
    this._attachObject(c);
    a.skin = this.conf.skin;
    a.parent = c;
    this.dataType = "tabbar";
    this.dataObj = new dhtmlXTabBar(a);
    a.parent = c = null;
    a = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachAccordion = function (a) {
    if (typeof (window.dhtmlXWindowsCell) != "undefined" && (this instanceof dhtmlXWindowsCell)) {} else {
        if (this._isCell) {
            this._hideBorders()
        }
    }
    var c = document.createElement("DIV");
    c.style.width = "100%";
    c.style.height = "100%";
    c.style.position = "relative";
    this._attachObject(c);
    if (typeof (a) == "undefined") {
        a = {}
    }
    if (typeof (a.skin) == "undefined") {
        a.skin = this.conf.skin
    }
    a.parent = c;
    if (typeof (window.dhtmlXAccordionCell) != "undefined" && (this instanceof window.dhtmlXAccordionCell)) {
        c._ofs = {
            s: {
                first: -1
            },
            m: {
                first: 4
            }
        }
    }
    this.dataType = "acc";
    this.dataObj = new dhtmlXAccordion(a);
    a.obj = null;
    c = a = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachEditor = function (a) {
    var c = document.createElement("DIV");
    c.style.width = "100%";
    c.style.height = "100%";
    c.style.position = "relative";
    c.style.overflow = "hidden";
    this._attachObject(c);
    if (!(typeof (a) == "object" && a != null)) {
        a = {}
    }
    a.parent = c;
    this.dataType = "editor";
    this.dataObj = new dhtmlXEditor(a);
    c = null;
    a.parent = null;
    a = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachDataView = function (a) {
    var c = document.createElement("DIV");
    c.style.width = "100%";
    c.style.height = "100%";
    c.style.position = "relative";
    c.style.overflow = "hidden";
    this._attachObject(c);
    if (typeof (a) == "undefined") {
        a = {}
    }
    c.id = "DataViewObject_" + new Date().getTime();
    a.container = c.id;
    a.skin = this.conf.skin;
    this.dataType = "dataview";
    this.dataObj = new dhtmlXDataView(a);
    this.dataObj.setSizes = function () {
        this.render()
    };
    c = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachScheduler = function (a, m, c, h) {
    h = h || window.scheduler;
    var j = false;
    if (c) {
        var l = document.getElementById(c);
        if (l) {
            j = true
        }
    }
    if (!j) {
        var g = c || '<div class="dhx_cal_tab" name="day_tab" style="right:204px;"></div><div class="dhx_cal_tab" name="week_tab" style="right:140px;"></div><div class="dhx_cal_tab" name="month_tab" style="right:76px;"></div>';
        var l = document.createElement("DIV");
        l.id = "dhxSchedObj_" + new Date().getTime();
        l.style.width = "100%";
        l.style.height = "100%";
        l.style.position = "relative";
        l.style.overflow = "hidden";
        l.className = "dhx_cal_container";
        l.innerHTML = '<div class="dhx_cal_navline"><div class="dhx_cal_prev_button">&nbsp;</div><div class="dhx_cal_next_button">&nbsp;</div><div class="dhx_cal_today_button"></div><div class="dhx_cal_date"></div>' + g + '</div><div class="dhx_cal_header"></div><div class="dhx_cal_data"></div>'
    }
    this._attachObject(l);
    this.dataType = "scheduler";
    this.dataObj = h;
    this.dataObj.setSizes = function () {
        this.update_view()
    };
    h.init(l.id, a, m);
    l = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachForm = function (a) {
    var c = document.createElement("DIV");
    c.style.width = "100%";
    c.style.height = "100%";
    c.style.position = "relative";
    if (window.dhtmlx && dhtmlx.$customScroll) {
        dhtmlx.CustomScroll.enable(c)
    } else {
        c.style.overflow = "auto"
    }
    this._attachObject(c);
    this.dataType = "form";
    this.dataObj = new dhtmlXForm(c, a);
    this.dataObj.setSkin(this.conf.skin);
    c = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachMap = function (a) {
    var c = document.createElement("DIV");
    c.id = "GMapsObj_" + this._genStr(12);
    c.style.width = "100%";
    c.style.height = "100%";
    c.style.position = "relative";
    c.style.overflow = "hidden";
    this._attachObject(c);
    if (!a) {
        a = {
            center: new google.maps.LatLng(40.719837, -73.992348),
            zoom: 11,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        }
    }
    this.dataType = "maps";
    this.dataObj = new google.maps.Map(c, a);
    this.dataObj.setSizes = function () {
        google.maps.event.trigger(this, "resize")
    };
    c = null;
    this.callEvent("_onContentAttach", []);
    return this.dataObj
};
dhtmlXCellObject.prototype.attachChart = function (a) {
    var c = document.createElement("DIV");
    c.id = "dhxChartObj_" + window.dhx4.newId();
    c.style.width = "100%";
    c.style.height = "100%";
    document.body.appendChild(c);
    this._attachObject(c);
    a.container = c.id;
    this.dataType = "chart";
    this.dataObj = new dhtmlXChart(a);
    if (!this.dataObj.setSizes) {
        this.dataObj.setSizes = function () {
            if (this.resize) {
                this.resize()
            } else {
                this.render()
            }
        }
    }
    return this.dataObj
};
dhtmlXCellObject.prototype.attachMenu = function (a) {
    if (this.dataNodes.menu) {
        return
    }
    if (typeof (a) == "undefined") {
        a = {}
    }
    if (typeof (a.skin) == "undefined") {
        a.skin = this.conf.skin
    }
    a.parent = this._attachObject("menu").firstChild;
    this.dataNodes.menu = new dhtmlXMenuObject(a);
    this._adjustCont(this._idd);
    a.parent = null;
    a = null;
    return this.dataNodes.menu
};
dhtmlXCellObject.prototype.detachMenu = function () {
    if (!this.dataNodes.menu) {
        return
    }
    this.dataNodes.menu.unload();
    this.dataNodes.menu = null;
    delete this.dataNodes.menu;
    this._detachObject("menu")
};
dhtmlXCellObject.prototype.showMenu = function () {
    this._mtbShowHide("menu", "")
};
dhtmlXCellObject.prototype.hideMenu = function () {
    this._mtbShowHide("menu", "none")
};
dhtmlXCellObject.prototype.attachToolbar = function (a) {
    if (!(this.dataNodes.ribbon == null && this.dataNodes.toolbar == null)) {
        return
    }
    if (typeof (a) == "undefined") {
        a = {}
    } else {
        if (typeof (a) == "string") {
            a = {
                skin: a
            }
        }
    }
    if (typeof (a.skin) == "undefined") {
        a.skin = this.conf.skin
    }
    a.parent = this._attachObject("toolbar").firstChild;
    this.dataNodes.toolbar = new dhtmlXToolbarObject(a);
    this._adjustCont(this._idd);
    this.dataNodes.toolbar._masterCell = this;
    this.dataNodes.toolbar.attachEvent("_onIconSizeChange", function () {
        this._masterCell._adjustCont()
    });
    a.parent = null;
    a = null;
    return this.dataNodes.toolbar
};
dhtmlXCellObject.prototype.detachToolbar = function () {
    if (!this.dataNodes.toolbar) {
        return
    }
    this.dataNodes.toolbar._masterCell = null;
    this.dataNodes.toolbar.unload();
    this.dataNodes.toolbar = null;
    delete this.dataNodes.toolbar;
    this._detachObject("toolbar")
};
dhtmlXCellObject.prototype.showToolbar = function () {
    this._mtbShowHide("toolbar", "")
};
dhtmlXCellObject.prototype.hideToolbar = function () {
    this._mtbShowHide("toolbar", "none")
};
dhtmlXCellObject.prototype.attachRibbon = function (a) {
    if (!(this.dataNodes.ribbon == null && this.dataNodes.toolbar == null)) {
        return
    }
    if (typeof (a) == "undefined") {
        a = {}
    }
    if (typeof (a.skin) == "undefined") {
        a.skin = this.conf.skin
    }
    a.parent = this._attachObject("ribbon").firstChild;
    this.dataNodes.ribbon = new dhtmlXRibbon(a);
    var c = this;
    this.dataNodes.ribbon.attachEvent("_onHeightChanged", function () {
        c._adjustCont(c._idd)
    });
    this._adjustCont();
    a.parent = null;
    a = null;
    return this.dataNodes.ribbon
};
dhtmlXCellObject.prototype.detachRibbon = function () {
    if (!this.dataNodes.ribbon) {
        return
    }
    this.dataNodes.ribbon.unload();
    this.dataNodes.ribbon = null;
    delete this.dataNodes.ribbon;
    this._detachObject("ribbon")
};
dhtmlXCellObject.prototype.showRibbon = function () {
    this._mtbShowHide("ribbon", "")
};
dhtmlXCellObject.prototype.hideRibbon = function () {
    this._mtbShowHide("ribbon", "none")
};
dhtmlXCellObject.prototype.attachStatusBar = function (a) {
    if (this.dataNodes.sb) {
        return
    }
    if (this.conf.skin == "dhx_skyblue" && typeof (window.dhtmlXWindowsCell) != "undefined" && (this instanceof dhtmlXWindowsCell)) {
        this.cell.childNodes[this.conf.idx.cont].className += " dhx_cell_statusbar_attached"
    }
    this.dataNodes.sb = this._attachObject("sb", a);
    this.dataNodes.sb.setText = function (c) {
        this.childNodes[0].innerHTML = c
    };
    this.dataNodes.sb.getText = function () {
        return this.childNodes[0].innerHTML
    };
    this.dataNodes.sb.onselectstart = function (c) {
        return false
    };
    return this.dataNodes.sb
};
dhtmlXCellObject.prototype.detachStatusBar = function () {
    if (!this.dataNodes.sb) {
        return
    }
    if (this.conf.skin == "dhx_skyblue" && typeof (window.dhtmlXWindowsCell) != "undefined" && (this instanceof dhtmlXWindowsCell)) {
        this.cell.childNodes[this.conf.idx.cont].className = this.cell.childNodes[this.conf.idx.cont].className.replace(/\s{0,}dhx_cell_statusbar_attached/, "")
    }
    this.dataNodes.sb.setText = this.dataNodes.sb.getText = this.dataNodes.sb.onselectstart = null;
    this.dataNodes.sb = null;
    delete this.dataNodes.sb;
    this._detachObject("sb")
};
dhtmlXCellObject.prototype.showStatusBar = function () {
    this._mtbShowHide("sb", "")
};
dhtmlXCellObject.prototype.hideStatusBar = function () {
    this._mtbShowHide("sb", "none")
};
dhtmlXCellObject.prototype._mtbShowHide = function (c, a) {
    if (!this.dataNodes[c]) {
        return
    }
    this.cell.childNodes[this.conf.idx[c]].style.display = a;
    this._adjustCont()
};
dhtmlXCellObject.prototype.getFrame = dhtmlXCellObject.prototype._getFrame = function () {
    if (this.dataType != "url") {
        return null
    }
    return this.cell.childNodes[this.conf.idx.cont].firstChild
};
dhtmlXCellObject.prototype._genStr = function () {
    if (!this._genStrId) {
        this._genStrId = new Date().getTime()
    }
    return this._genStrId++
};
dhtmlXCellObject.prototype._attachURLEvents = function () {
    if (this.dataType != "url") {
        return
    }
    var g = this;
    var c = this._idd;
    var a = this.cell.childNodes[this.conf.idx.cont].firstChild;
    if (typeof (this._doOnFrameMouseDown) != "function") {
        this._doOnFrameMouseDown = function (h) {
            g.callEvent("_onContentMouseDown", [c, h || event])
        }
    }
    if (typeof (window.addEventListener) == "function") {
        a.onload = function () {
            try {
                if (typeof (g._doOnFrameMouseDown) == "function") {
                    this.contentWindow.document.body.addEventListener("mousedown", g._doOnFrameMouseDown, false)
                }
            } catch (h) {}
            try {
                if (typeof (g._doOnFrameContentLoaded) == "function") {
                    g._doOnFrameContentLoaded()
                }
            } catch (h) {}
        }
    } else {
        a.onreadystatechange = function (h) {
            if (this.readyState == "complete") {
                try {
                    if (typeof (g._doOnFrameMouseDown) == "function") {
                        this.contentWindow.document.body.attachEvent("onmousedown", g._doOnFrameMouseDown)
                    }
                } catch (j) {}
                try {
                    if (typeof (g._doOnFrameContentLoaded) == "function") {
                        g._doOnFrameContentLoaded()
                    }
                } catch (j) {}
            }
        }
    }
};
dhtmlXCellObject.prototype._doOnFrameContentLoaded = function () {
    if (this.conf.url_data.post_ifr == true) {
        var l = this.getFrame().contentWindow.document;
        var j = l.createElement("FORM");
        j.method = "POST";
        j.action = this.conf.url_data.url;
        l.body.appendChild(j);
        var g = {};
        g["dhxr" + new Date().getTime()] = "1";
        for (var c in this.conf.url_data.post_data) {
            g[c] = this.conf.url_data.post_data[c]
        }
        for (var c in g) {
            var h = l.createElement("INPUT");
            h.type = "hidden";
            h.name = c;
            h.value = g[c];
            j.appendChild(h);
            h = null
        }
        this.conf.url_data.post_ifr = false;
        j.submit()
    } else {
        this.callEvent("_onContentLoaded", [this._idd])
    }
};
dhtmlXCellObject.prototype._detachURLEvents = function (a) {
    if (a == null) {
        if (this.dataType != "url") {
            return
        }
        a = this.cell.childNodes[this.conf.idx.cont].firstChild
    }
    if (typeof (window.addEventListener) == "function") {
        a.onload = null;
        try {
            a.contentWindow.document.body.removeEventListener("mousedown", this._doOnFrameMouseDown, false)
        } catch (c) {}
    } else {
        a.onreadystatechange = null;
        try {
            a.contentWindow.document.body.detachEvent("onmousedown", this._doOnFrameMouseDown)
        } catch (c) {}
    }
    a = null
};
dhtmlXCellObject.prototype._attachObject = function (n, j, m, a, l) {
    if (n == "menu") {
        if (typeof (l) != "undefined") {
            n = l
        } else {
            n = document.createElement("DIV");
            n.className = "dhx_cell_menu_" + (this.conf.borders ? "def" : "no_borders");
            n.appendChild(document.createElement("DIV"))
        }
        this.cell.insertBefore(n, this.cell.childNodes[this.conf.idx.toolbar || this.conf.idx.cont]);
        this.conf.ofs_nodes.t.menu = true;
        this._updateIdx();
        return n
    }
    if (n == "toolbar") {
        if (typeof (l) != "undefined") {
            n = l
        } else {
            n = document.createElement("DIV");
            n.className = "dhx_cell_toolbar_" + (this.conf.borders ? "def" : "no_borders");
            n.appendChild(document.createElement("DIV"));
            n.firstChild.className = "dhx_toolbar_base_18_dhx_skyblue"
        }
        this.cell.insertBefore(n, this.cell.childNodes[this.conf.idx.cont]);
        this.conf.ofs_nodes.t.toolbar = true;
        this._updateIdx();
        return n
    }
    if (n == "ribbon") {
        if (typeof (l) != "undefined") {
            n = l
        } else {
            n = document.createElement("DIV");
            n.className = "dhx_cell_ribbon_" + (this.conf.borders ? "def" : "no_borders");
            n.appendChild(document.createElement("DIV"))
        }
        this.cell.insertBefore(n, this.cell.childNodes[this.conf.idx.cont]);
        this.conf.ofs_nodes.t.ribbon = true;
        this._updateIdx();
        this._adjustCont(this._idd);
        return n
    }
    if (n == "sb") {
        if (typeof (l) != "undefined") {
            n = l
        } else {
            var c = j || {};
            var o = (typeof (c.text) == "string" && c.text.length > 0 ? c.text : "&nbsp;");
            var g = (typeof (c.height) == "number" ? c.height : false);
            var n = document.createElement("DIV");
            n.className = "dhx_cell_statusbar_def";
            n.innerHTML = "<div class='dhx_cell_statusbar_text'>" + o + "</div>";
            if (g != false) {
                n.firstChild.style.height = n.firstChild.style.lineHeight = g + "px"
            }
        }
        if (this.conf.idx.pr1 != null) {
            this.cell.insertBefore(n, this.cell.childNodes[this.conf.idx.pr1])
        } else {
            this.cell.appendChild(n)
        }
        this.conf.ofs_nodes.b.sb = true;
        this._updateIdx();
        this._adjustCont(this._idd);
        return n
    }
    if (a != true) {
        this._detachObject(null, true, null)
    }
    if (typeof (m) == "string") {
        this.cell.childNodes[this.conf.idx.cont].innerHTML = m
    } else {
        this.cell.childNodes[this.conf.idx.cont].appendChild(n)
    }
    n = null
};
dhtmlXCellObject.prototype._detachObject = function (j, c, a) {
    this.callEvent("_onBeforeContentDetach", []);
    if (j == "menu" || j == "toolbar" || j == "ribbon" || j == "sb") {
        var h = this.cell.childNodes[this.conf.idx[j]];
        h.parentNode.removeChild(h);
        h = null;
        this.conf.ofs_nodes[j == "sb" ? "b" : "t"][j] = false;
        this._updateIdx();
        if (!this.conf.unloading) {
            this._adjustCont(this._idd)
        }
        return
    }
    if (c == true) {
        a = false
    } else {
        if (typeof (a) == "undefined") {
            a = document.body
        } else {
            if (typeof (a) == "string") {
                a = document.getElementById(a)
            }
        }
    }
    if (a === false) {
        if (this.dataType == "url") {
            this._detachURLEvents()
        } else {
            if (this.dataObj != null) {
                if (typeof (this.dataObj.unload) == "function") {
                    this.dataObj.unload()
                } else {
                    if (typeof (this.dataObj.destructor) == "function") {
                        this.dataObj.destructor()
                    }
                }
            }
        }
    }
    var h = this.cell.childNodes[this.conf.idx.cont];
    while (h.childNodes.length > 0) {
        if (a === false) {
            h.removeChild(h.lastChild)
        } else {
            h.firstChild.style.display = "none";
            a.appendChild(h.firstChild)
        }
    }
    if (this.conf.append_mode) {
        h.style.overflow = "";
        this.conf.append_mode = false
    }
    var g = (this.dataType == "tabbar");
    this.dataObj = null;
    this.dataType = null;
    a = h = null;
    if (this.conf.unloading != true && g) {
        this.showHeader(true);
        this._showBorders()
    }
};
dhtmlXCellObject.prototype._attachFromCell = function (c) {
    this.detachObject(true);
    var h = "layout";
    if (typeof (window.dhtmlXWindowsCell) != "undefined" && this instanceof window.dhtmlXWindowsCell) {
        h = "window"
    }
    if (typeof (window.dhtmlXWindowsCell) != "undefined" && c instanceof window.dhtmlXWindowsCell && c.wins.w[c._idd].conf.parked) {
        c.wins._winCellSetOpacity(c._idd, "open", false)
    }
    if (typeof (window.dhtmlXAccordionCell) != "undefined" && c instanceof window.dhtmlXAccordionCell && c.conf.opened == false) {
        c._cellSetOpacity("open", false)
    }
    for (var g in c.dataNodes) {
        this._attachObject(g, null, null, null, c.cell.childNodes[c.conf.idx[g]]);
        this.dataNodes[g] = c.dataNodes[g];
        c.dataNodes[g] = null;
        c.conf.ofs_nodes[g == "sb" ? "b" : "t"][g] = false;
        c._updateIdx()
    }
    this._mtbUpdBorder();
    if (c.dataType != null && c.dataObj != null) {
        this.dataType = c.dataType;
        this.dataObj = c.dataObj;
        while (c.cell.childNodes[c.conf.idx.cont].childNodes.length > 0) {
            this.cell.childNodes[this.conf.idx.cont].appendChild(c.cell.childNodes[c.conf.idx.cont].firstChild)
        }
        c.dataType = null;
        c.dataObj = null;
        if (this.dataType == "grid") {
            if (h == "window" && this.conf.skin == "dhx_skyblue") {
                this.dataObj.entBox.style.border = "1px solid #a4bed4";
                this.dataObj._sizeFix = 0
            } else {
                this.dataObj.entBox.style.border = "0px solid white";
                this.dataObj._sizeFix = 2
            }
        }
    } else {
        while (c.cell.childNodes[c.conf.idx.cont].childNodes.length > 0) {
            this.cell.childNodes[this.conf.idx.cont].appendChild(c.cell.childNodes[c.conf.idx.cont].firstChild)
        }
    }
    this.conf.view = c.conf.view;
    c.conf.view = "def";
    for (var g in c.views) {
        this.views[g] = c.views[g];
        c.views[g] = null;
        delete c.views[g]
    }
    c._updateIdx();
    c._adjustCont();
    this._updateIdx();
    this._adjustCont();
    if (h == "window" && this.wins.w[this._idd].conf.parked) {
        this.wins._winCellSetOpacity(this._idd, "close", false)
    }
};

function dhtmlXCalendarObject(l, s) {
    this.i = {};
    var g = null;
    if (typeof (l) == "string") {
        var h = document.getElementById(l)
    } else {
        var h = l
    }
    if (h && typeof (h) == "object" && h.tagName && String(h.tagName).toLowerCase() != "input") {
        g = h
    }
    h = null;
    if (typeof (l) != "object" || !l.length) {
        l = [l]
    }
    for (var c = 0; c < l.length; c++) {
        if (typeof (l[c]) == "string") {
            l[c] = (document.getElementById(l[c]) || null)
        }
        if (l[c] != null && l[c].tagName && String(l[c].tagName).toLowerCase() == "input") {
            this.i[window.dhx4.newId()] = {
                input: l[c]
            }
        } else {
            if (!(l[c] instanceof Array) && l[c] instanceof Object && (l[c].input != null || l[c].button != null)) {
                if (l[c].input != null && typeof (l[c].input) == "string") {
                    l[c].input = document.getElementById(l[c].input)
                }
                if (l[c].button != null && typeof (l[c].button) == "string") {
                    l[c].button = document.getElementById(l[c].button)
                }
                this.i[window.dhx4.newId()] = l[c]
            }
        }
        l[c] = null
    }
    this.conf = {
        skin: (s || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhtmlxcalendar") || "dhx_skyblue"),
        zi: window.dhx4.newId(),
        touch: (typeof (window.ontouchstart) != "undefined")
    };
    this.setSkin = function (q, a) {
        if (this.conf.skin == q && !a) {
            return
        }
        this.conf.skin = q;
        this.base.className = "dhtmlxcalendar_" + this.conf.skin;
        this._ifrSize()
    };
    this.base = document.createElement("DIV");
    this.base.style.display = "none";
    this.base.appendChild(document.createElement("DIV"));
    if (g != null) {
        this._hasParent = true;
        g.appendChild(this.base);
        g = null
    } else {
        document.body.appendChild(this.base)
    }
    this.setParent = function (a) {
        if (this._hasParent) {
            if (typeof (a) == "object") {
                a.appendChild(this.base)
            } else {
                if (typeof (a) == "string") {
                    document.getElementById(a).appendChild(this.base)
                }
            }
        }
    };
    this.setSkin(this.conf.skin, true);
    if (this.conf.touch) {
        this.base.ontouchstart = function (a) {
            a = a || event;
            if (a.preventDefault) {
                a.preventDefault()
            }
            a.cancelBubble = true
        }
    } else {
        this.base.onclick = function (a) {
            a = a || event;
            a.cancelBubble = true
        };
        this.base.onmousedown = function () {
            return false
        }
    }
    this.loadUserLanguage = function (x) {
        if (!this.langData[x]) {
            return
        }
        this.lang = x;
        this.setWeekStartDay(this.langData[this.lang].weekstart);
        this.setDateFormat(this.langData[this.lang].dateformat || "%Y-%m-%d");
        if (this.msCont) {
            var v = 0;
            for (var u = 0; u < this.msCont.childNodes.length; u++) {
                for (var a = 0; a < this.msCont.childNodes[u].childNodes.length; a++) {
                    this.msCont.childNodes[u].childNodes[a].innerHTML = this.langData[this.lang].monthesSNames[v++]
                }
            }
        }
    };
    this.contMonth = document.createElement("DIV");
    this.contMonth.className = "dhtmlxcalendar_month_cont";
    this.contMonth.onselectstart = function (a) {
        a = a || event;
        a.cancelBubble = true;
        if (a.preventDefault) {
            a.preventDefault()
        } else {
            a.returnValue = false
        }
        return false
    };
    this.base.firstChild.appendChild(this.contMonth);
    var m = document.createElement("UL");
    m.className = "dhtmlxcalendar_line";
    this.contMonth.appendChild(m);
    var r = document.createElement("LI");
    r.className = "dhtmlxcalendar_cell dhtmlxcalendar_month_hdr";
    r.innerHTML = "<div class='dhtmlxcalendar_month_arrow dhtmlxcalendar_month_arrow_left' onmouseover='this.className=\"dhtmlxcalendar_month_arrow dhtmlxcalendar_month_arrow_left_hover\";' onmouseout='this.className=\"dhtmlxcalendar_month_arrow dhtmlxcalendar_month_arrow_left\";'></div><span></span><div class='dhtmlxcalendar_month_arrow dhtmlxcalendar_month_arrow_right' onmouseover='this.className=\"dhtmlxcalendar_month_arrow dhtmlxcalendar_month_arrow_right_hover\";' onmouseout='this.className=\"dhtmlxcalendar_month_arrow dhtmlxcalendar_month_arrow_right\";'></div>";
    m.appendChild(r);
    var j = this;
    r[this.conf.touch ? "ontouchstart" : "onclick"] = function (v) {
        v = v || event;
        var q = (v.target || v.srcElement);
        if (q.className && q.className.indexOf("dhtmlxcalendar_month_arrow") === 0) {
            j._hideSelector();
            var u = (q.parentNode.firstChild == q ? -1 : 1);
            var a = new Date(j._activeMonth);
            j._drawMonth(new Date(j._activeMonth.getFullYear(), j._activeMonth.getMonth() + u, 1, 0, 0, 0, 0));
            j._evOnArrowClick([a, new Date(j._activeMonth)]);
            return
        }
        if (q.className && q.className == "dhtmlxcalendar_month_label_month") {
            v.cancelBubble = true;
            j._showSelector("month", Math.round(q.offsetLeft + q.offsetWidth / 2), q.offsetTop + q.offsetHeight + 2, "selector_month", true);
            return
        }
        if (q.className && q.className == "dhtmlxcalendar_month_label_year") {
            v.cancelBubble = true;
            j._showSelector("year", Math.round(q.offsetLeft + q.offsetWidth / 2), q.offsetTop + q.offsetHeight + 2, "selector_year", true);
            return
        }
        j._hideSelector()
    };
    this.contDays = document.createElement("DIV");
    this.contDays.className = "dhtmlxcalendar_days_cont";
    this.base.firstChild.appendChild(this.contDays);
    this.setWeekStartDay = function (a) {
        if (a == 0) {
            a = 7
        }
        this._wStart = Math.min(Math.max((isNaN(a) ? 1 : a), 1), 7);
        this._drawDaysOfWeek()
    };
    this._drawDaysOfWeek = function () {
        if (this.contDays.childNodes.length == 0) {
            var x = document.createElement("UL");
            x.className = "dhtmlxcalendar_line";
            this.contDays.appendChild(x)
        } else {
            var x = this.contDays.firstChild
        }
        var u = this._wStart;
        var v = this.langData[this.lang].daysSNames;
        v.push(String(this.langData[this.lang].daysSNames[0]).valueOf());
        for (var y = 0; y < 8; y++) {
            if (x.childNodes[y] == null) {
                var a = document.createElement("LI");
                x.appendChild(a)
            } else {
                var a = x.childNodes[y]
            }
            if (y == 0) {
                a.className = "dhtmlxcalendar_cell_wn";
                a.innerHTML = "<div class='dhtmlxcalendar_label'>" + (this.langData[this.lang].weekname || "w") + "</div>"
            } else {
                a.className = "dhtmlxcalendar_cell" + (u >= 6 ? " dhtmlxcalendar_day_weekday_cell" : "") + (y == 1 ? "_first" : "");
                a.innerHTML = v[u];
                if (++u > 7) {
                    u = 1
                }
            }
        }
        if (this._activeMonth != null) {
            this._drawMonth(this._activeMonth)
        }
    };
    this._wStart = this.langData[this.lang].weekstart;
    this.setWeekStartDay(this._wStart);
    this.contDates = document.createElement("DIV");
    this.contDates.className = "dhtmlxcalendar_dates_cont";
    this.base.firstChild.appendChild(this.contDates);
    this.contDates[this.conf.touch ? "ontouchend" : "onclick"] = function (x) {
        x = x || event;
        var q = (x.target || x.srcElement);
        if (q.parentNode != null && q.parentNode._date != null) {
            q = q.parentNode
        }
        if (q._date != null && !q._css_dis) {
            var v = j._activeDate.getHours();
            var u = j._activeDate.getMinutes();
            var w = q._date;
            if (j.checkEvent("onBeforeChange")) {
                if (!j.callEvent("onBeforeChange", [new Date(q._date.getFullYear(), q._date.getMonth(), q._date.getDate(), v, u)])) {
                    return
                }
            }
            if (j._activeDateCell != null) {
                j._activeDateCell._css_date = false;
                j._updateCellStyle(j._activeDateCell._q, j._activeDateCell._w)
            }
            var a = (j._activeDate.getFullYear() + "_" + j._activeDate.getMonth() != w.getFullYear() + "_" + w.getMonth());
            j._nullDate = false;
            j._activeDate = new Date(w.getFullYear(), w.getMonth(), w.getDate(), v, u);
            j._activeDateCell = q;
            j._activeDateCell._css_date = true;
            j._activeDateCell._css_hover = false;
            j._updateCellStyle(j._activeDateCell._q, j._activeDateCell._w);
            if (a) {
                j._drawMonth(j._activeDate)
            }
            if (j._activeInp && j.i[j._activeInp] && j.i[j._activeInp].input != null) {
                j.i[j._activeInp].input.value = j._dateToStr(new Date(j._activeDate.getTime()))
            }
            if (!j._hasParent) {
                j._hide()
            }
            j._evOnClick([new Date(j._activeDate.getTime())])
        }
    };
    if (!this.conf.touch) {
        this.contDates.onmouseover = function (q) {
            q = q || event;
            var a = (q.target || q.srcElement);
            if (a.parentNode != null && a.parentNode._date != null) {
                a = a.parentNode
            }
            if (a._date != null) {
                if (j._lastHover == a || a._css_hover) {
                    return
                }
                a._css_hover = true;
                j._updateCellStyle(a._q, a._w);
                j._lastHover = a;
                j._evOnMouseOver([new Date(a._date.getFullYear(), a._date.getMonth(), a._date.getDate(), 0, 0, 0, 0), q]);
                a = null
            }
        };
        this.contDates.onmouseout = function (a) {
            j._clearDayHover(a || event)
        }
    }
    this._lastHover = null;
    this._clearDayHover = function (a) {
        if (!this._lastHover) {
            return
        }
        this._lastHover._css_hover = false;
        this._updateCellStyle(this._lastHover._q, this._lastHover._w);
        j._evOnMouseOut([new Date(this._lastHover._date.getFullYear(), this._lastHover._date.getMonth(), this._lastHover._date.getDate(), 0, 0, 0, 0), a]);
        this._lastHover = null
    };
    for (var c = 0; c < 6; c++) {
        var m = document.createElement("UL");
        m.className = "dhtmlxcalendar_line";
        this.contDates.appendChild(m);
        for (var o = 0; o <= 7; o++) {
            var r = document.createElement("LI");
            if (o == 0) {
                r.className = "dhtmlxcalendar_cell_wn"
            } else {
                r.className = "dhtmlxcalendar_cell"
            }
            m.appendChild(r)
        }
    }
    this.contTime = document.createElement("DIV");
    this.contTime.className = "dhtmlxcalendar_time_cont";
    this.base.firstChild.appendChild(this.contTime);
    this.showTime = function () {
        this.contTime.style.display = "";
        this._ifrSize()
    };
    this.hideTime = function () {
        this.contTime.style.display = "none";
        this._ifrSize()
    };
    var m = document.createElement("UL");
    m.className = "dhtmlxcalendar_line";
    this.contTime.appendChild(m);
    var r = document.createElement("LI");
    r.className = "dhtmlxcalendar_cell dhtmlxcalendar_time_hdr";
    r.innerHTML = "<div class='dhtmlxcalendar_time_img'></div><span class='dhtmlxcalendar_label_hours'></span><span class='dhtmlxcalendar_label_colon'> : </span><span class='dhtmlxcalendar_label_minutes'></span>";
    m.appendChild(r);
    r[this.conf.touch ? "ontouchstart" : "onclick"] = function (u) {
        u = u || event;
        var a = (u.target || u.srcElement);
        if (a.tagName != null && a.tagName.toLowerCase() == "span" && a._par == true && a.parentNode != null) {
            a = a.parentNode
        }
        if (a.className && a.className == "dhtmlxcalendar_label_hours") {
            u.cancelBubble = true;
            var q = j.contMonth.offsetHeight + j.contDays.offsetHeight + j.contDates.offsetHeight + a.offsetTop;
            j._showSelector("hours", Math.round(a.offsetLeft + a.offsetWidth / 2), q - 2, "selector_hours", true);
            return
        }
        if (a.className && a.className == "dhtmlxcalendar_label_minutes") {
            u.cancelBubble = true;
            if (j._minutesInterval == 1) {
                var v = j.getFormatedDate("%i");
                a.innerHTML = "<span class='dhtmlxcalendar_selected_date'>" + v.charAt(0) + "</span>" + v.charAt(1);
                a.firstChild._par = true;
                j._selectorMode = 1
            }
            var q = j.contMonth.offsetHeight + j.contDays.offsetHeight + j.contDates.offsetHeight + a.offsetTop;
            j._showSelector("minutes", Math.round(a.offsetLeft + a.offsetWidth / 2), q - 2, "selector_minutes", true);
            return
        }
        j._hideSelector()
    };
    this._activeMonth = null;
    this._activeDate = new Date();
    this._activeDateCell = null;
    this.setDate = function (q) {
        this._nullDate = (typeof (q) == "undefined" || q === "" || !q);
        if (!(q instanceof Date)) {
            q = this._strToDate(String(q || ""));
            if (q == "Invalid Date") {
                q = new Date()
            }
        }
        var a = q.getTime();
        if (this._isOutOfRange(a)) {
            return
        }
        this._activeDate = new Date(a);
        this._drawMonth(this._nullDate ? new Date() : this._activeDate);
        this._updateVisibleHours();
        this._updateVisibleMinutes()
    };
    this.getDate = function (q) {
        if (this._nullDate) {
            return null
        }
        var a = new Date(this._activeDate.getTime());
        if (q) {
            return this._dateToStr(a)
        }
        return a
    };
    this._drawMonth = function (D) {
        if (!(D instanceof Date)) {
            return
        }
        if (isNaN(D.getFullYear())) {
            D = new Date(this._activeMonth.getFullYear(), this._activeMonth.getMonth(), 1, 0, 0, 0, 0)
        }
        this._activeMonth = new Date(D.getFullYear(), D.getMonth(), 1, 0, 0, 0, 0);
        this._activeDateCell = null;
        var A = new Date(this._activeMonth.getTime());
        var v = A.getDay();
        var H = v - this._wStart;
        if (H < 0) {
            H = H + 7
        }
        A.setDate(A.getDate() - H);
        var K = D.getMonth();
        var L = new Date(this._activeDate.getFullYear(), this._activeDate.getMonth(), this._activeDate.getDate(), 0, 0, 0, 0).getTime();
        var y = 0;
        for (var u = 0; u < 6; u++) {
            var C = this._wStart;
            for (var J = 0; J <= 7; J++) {
                if (J == 0) {
                    var I = this.getWeekNumber(new Date(A.getFullYear(), A.getMonth(), A.getDate() + y, 0, 0, 0, 0));
                    this.contDates.childNodes[u].childNodes[J].innerHTML = "<div class='dhtmlxcalendar_label'>" + I + "</div>"
                } else {
                    var a = new Date(A.getFullYear(), A.getMonth(), A.getDate() + y, 0, 0, 0, 0);
                    var F = a.getDay();
                    var x = a.getTime();
                    var E = "dhtmlxcalendar_label";
                    if (this._tipData[x] != null) {
                        if (this._tipData[x].usePopup && typeof (window.dhtmlXPopup) == "function") {
                            this.contDates.childNodes[u].childNodes[J].removeAttribute("title");
                            this._initTooltipPopup()
                        } else {
                            this.contDates.childNodes[u].childNodes[J].setAttribute("title", this._tipData[x].text)
                        }
                        if (this._tipData[x].showIcon) {
                            E += " dhtmlxcalendar_label_title"
                        }
                    } else {
                        this.contDates.childNodes[u].childNodes[J].removeAttribute("title")
                    }
                    this.contDates.childNodes[u].childNodes[J].innerHTML = "<div class='" + E + "'>" + a.getDate() + "</div>";
                    this.contDates.childNodes[u].childNodes[J]._date = new Date(x);
                    this.contDates.childNodes[u].childNodes[J]._q = u;
                    this.contDates.childNodes[u].childNodes[J]._w = J;
                    this.contDates.childNodes[u].childNodes[J]._css_month = (a.getMonth() == K);
                    this.contDates.childNodes[u].childNodes[J]._css_date = (!this._nullDate && x == L);
                    this.contDates.childNodes[u].childNodes[J]._css_weekend = (C >= 6);
                    this.contDates.childNodes[u].childNodes[J]._css_dis = this._isOutOfRange(x);
                    this.contDates.childNodes[u].childNodes[J]._css_holiday = (this._holidays[x] == true);
                    this._updateCellStyle(u, J);
                    if (x == L) {
                        this._activeDateCell = this.contDates.childNodes[u].childNodes[J]
                    }
                    if (++C > 7) {
                        C = 1
                    }
                    y++
                }
            }
        }
        this.contMonth.firstChild.firstChild.childNodes[1].innerHTML = this._buildMonthHdr(D)
    };
    this._updateCellStyle = function (x, a) {
        var v = this.contDates.childNodes[x].childNodes[a];
        var u = "dhtmlxcalendar_cell dhtmlxcalendar_cell";
        u += (v._css_month ? "_month" : "");
        u += (v._css_date ? "_date" : "");
        u += (v._css_weekend ? "_weekend" : "");
        u += (v._css_holiday ? "_holiday" : "");
        u += (v._css_dis ? "_dis" : "");
        u += (v._css_hover && !v._css_dis ? "_hover" : "");
        v.className = u;
        v = null
    };
    this._minutesInterval = 5;
    this._initSelector = function (D, x) {
        if (!this._selCover) {
            this._selCover = document.createElement("DIV");
            this._selCover.className = "dhtmlxcalendar_selector_cover";
            this.base.firstChild.appendChild(this._selCover)
        }
        if (!this._sel) {
            this._sel = document.createElement("DIV");
            this._sel.className = "dhtmlxcalendar_selector_obj";
            this.base.firstChild.appendChild(this._sel);
            this._sel.appendChild(document.createElement("TABLE"));
            this._sel.firstChild.className = "dhtmlxcalendar_selector_table";
            this._sel.firstChild.cellSpacing = 0;
            this._sel.firstChild.cellPadding = 0;
            this._sel.firstChild.border = 0;
            this._sel.firstChild.appendChild(document.createElement("TBODY"));
            this._sel.firstChild.firstChild.appendChild(document.createElement("TR"));
            this._sel.firstChild.firstChild.firstChild.appendChild(document.createElement("TD"));
            this._sel.firstChild.firstChild.firstChild.appendChild(document.createElement("TD"));
            this._sel.firstChild.firstChild.firstChild.appendChild(document.createElement("TD"));
            this._sel.firstChild.firstChild.firstChild.childNodes[0].className = "dhtmlxcalendar_selector_cell_left";
            this._sel.firstChild.firstChild.firstChild.childNodes[1].className = "dhtmlxcalendar_selector_cell_middle";
            this._sel.firstChild.firstChild.firstChild.childNodes[2].className = "dhtmlxcalendar_selector_cell_right";
            this._sel.firstChild.firstChild.firstChild.childNodes[0].innerHTML = "&nbsp;";
            this._sel.firstChild.firstChild.firstChild.childNodes[2].innerHTML = "&nbsp;";
            if (!this.conf.touch) {
                this._sel.firstChild.firstChild.firstChild.childNodes[0].onmouseover = function () {
                    this.className = "dhtmlxcalendar_selector_cell_left dhtmlxcalendar_selector_cell_left_hover"
                };
                this._sel.firstChild.firstChild.firstChild.childNodes[0].onmouseout = function () {
                    this.className = "dhtmlxcalendar_selector_cell_left"
                };
                this._sel.firstChild.firstChild.firstChild.childNodes[2].onmouseover = function () {
                    this.className = "dhtmlxcalendar_selector_cell_right dhtmlxcalendar_selector_cell_right_hover"
                };
                this._sel.firstChild.firstChild.firstChild.childNodes[2].onmouseout = function () {
                    this.className = "dhtmlxcalendar_selector_cell_right"
                };
                this._sel.onmouseover = function (w) {
                    w = w || event;
                    var q = (w.target || w.srcElement);
                    if (q._cell === true) {
                        if (j._selHover != q) {
                            j._clearSelHover()
                        }
                        if (String(q.className).match(/^\s{0,}dhtmlxcalendar_selector_cell\s{0,}$/gi) != null) {
                            q.className += " dhtmlxcalendar_selector_cell_hover";
                            j._selHover = q
                        }
                    }
                };
                this._sel.onmouseout = function () {
                    j._clearSelHover()
                }
            }
            this._sel.firstChild.firstChild.firstChild.childNodes[0][this.conf.touch ? "ontouchstart" : "onclick"] = function (q) {
                q = q || event;
                q.cancelBubble = true;
                j._scrollYears(-1)
            };
            this._sel.firstChild.firstChild.firstChild.childNodes[2][this.conf.touch ? "ontouchstart" : "onclick"] = function (q) {
                q = q || event;
                q.cancelBubble = true;
                j._scrollYears(1)
            };
            this._sel._ta = {};
            this._selHover = null;
            this._sel.appendChild(document.createElement("DIV"));
            this._sel.lastChild.className = "dhtmlxcalendar_selector_obj_arrow"
        }
        if (this._sel._ta[D] == true) {
            return
        }
        if (D == "month") {
            this._msCells = {};
            this.msCont = document.createElement("DIV");
            this.msCont.className = "dhtmlxcalendar_area_" + x;
            this._sel.firstChild.firstChild.firstChild.childNodes[1].appendChild(this.msCont);
            var u = 0;
            for (var a = 0; a < 4; a++) {
                var C = document.createElement("UL");
                C.className = "dhtmlxcalendar_selector_line";
                this.msCont.appendChild(C);
                for (var E = 0; E < 3; E++) {
                    var F = document.createElement("LI");
                    F.innerHTML = this.langData[this.lang].monthesSNames[u];
                    F.className = "dhtmlxcalendar_selector_cell";
                    C.appendChild(F);
                    F._month = u;
                    F._cell = true;
                    this._msCells[u++] = F
                }
            }
            this.msCont[this.conf.touch ? "ontouchstart" : "onclick"] = function (w) {
                w = w || event;
                w.cancelBubble = true;
                var q = (w.target || w.srcElement);
                if (q._month != null) {
                    j._hideSelector();
                    j._updateActiveMonth();
                    j._drawMonth(new Date(j._activeMonth.getFullYear(), q._month, 1, 0, 0, 0, 0));
                    j._doOnSelectorChange()
                }
            }
        }
        if (D == "year") {
            this._ysCells = {};
            this.ysCont = document.createElement("DIV");
            this.ysCont.className = "dhtmlxcalendar_area_" + x;
            this._sel.firstChild.firstChild.firstChild.childNodes[1].appendChild(this.ysCont);
            for (var a = 0; a < 4; a++) {
                var C = document.createElement("UL");
                C.className = "dhtmlxcalendar_selector_line";
                this.ysCont.appendChild(C);
                for (var E = 0; E < 3; E++) {
                    var F = document.createElement("LI");
                    F.className = "dhtmlxcalendar_selector_cell";
                    F._cell = true;
                    C.appendChild(F)
                }
            }
            this.ysCont[this.conf.touch ? "ontouchstart" : "onclick"] = function (w) {
                w = w || event;
                w.cancelBubble = true;
                var q = (w.target || w.srcElement);
                if (q._year != null) {
                    j._hideSelector();
                    j._drawMonth(new Date(q._year, j._activeMonth.getMonth(), 1, 0, 0, 0, 0));
                    j._doOnSelectorChange()
                }
            }
        }
        if (D == "hours") {
            this._hsCells = {};
            this.hsCont = document.createElement("DIV");
            this.hsCont.className = "dhtmlxcalendar_area_" + x;
            this._sel.firstChild.firstChild.firstChild.childNodes[1].appendChild(this.hsCont);
            var u = 0;
            for (var a = 0; a < 4; a++) {
                var C = document.createElement("UL");
                C.className = "dhtmlxcalendar_selector_line";
                this.hsCont.appendChild(C);
                for (var E = 0; E < 6; E++) {
                    var F = document.createElement("LI");
                    F.innerHTML = this._fixLength(u, 2);
                    F.className = "dhtmlxcalendar_selector_cell";
                    C.appendChild(F);
                    F._hours = u;
                    F._cell = true;
                    this._hsCells[u++] = F
                }
            }
            this.hsCont[this.conf.touch ? "ontouchstart" : "onclick"] = function (w) {
                w = w || event;
                w.cancelBubble = true;
                var q = (w.target || w.srcElement);
                if (q._hours != null) {
                    j._hideSelector();
                    j._activeDate.setHours(q._hours);
                    j._updateActiveHours();
                    j._updateVisibleHours();
                    j._doOnSelectorChange()
                }
            }
        }
        if (D == "minutes") {
            var A = 4;
            var v = 3;
            var y = 2;
            if (this._minutesInterval == 1) {
                if (this._selectorMode == 1) {
                    A = 2;
                    v = 3;
                    y = 1
                } else {
                    A = 2;
                    v = 5;
                    y = 1;
                    x += "5"
                }
            }
            if (this._minutesInterval == 10) {
                A = 2
            }
            if (this._minutesInterval == 15) {
                A = 1;
                v = 4;
                x += "4"
            }
            this._rsCells = {};
            this.rsCont = document.createElement("DIV");
            this.rsCont.className = "dhtmlxcalendar_area_" + x;
            this._sel.firstChild.firstChild.firstChild.childNodes[1].appendChild(this.rsCont);
            var u = 0;
            for (var a = 0; a < A; a++) {
                var C = document.createElement("UL");
                C.className = "dhtmlxcalendar_selector_line";
                this.rsCont.appendChild(C);
                for (var E = 0; E < v; E++) {
                    var F = document.createElement("LI");
                    F.innerHTML = (y > 1 ? this._fixLength(u, y) : u);
                    F.className = "dhtmlxcalendar_selector_cell";
                    C.appendChild(F);
                    F._minutes = u;
                    F._cell = true;
                    this._rsCells[u] = F;
                    u += this._minutesInterval
                }
            }
            this.rsCont[this.conf.touch ? "ontouchstart" : "onclick"] = function (H) {
                H = H || event;
                H.cancelBubble = true;
                var w = (H.target || H.srcElement);
                if (w._minutes != null) {
                    if (j._minutesInterval == 1) {
                        var q = j.getFormatedDate("%i");
                        if (j._selectorMode == 1) {
                            q = w._minutes.toString() + q.charAt(1)
                        } else {
                            q = q.charAt(0) + w._minutes.toString()
                        }
                        j._activeDate.setMinutes(Number(q));
                        j._hideSelector();
                        if (j._selectorMode == 1) {
                            j._updateVisibleMinutes(true);
                            j._selectorMode = 2;
                            j._showSelector("minutes", j._sel._x, j._sel._y, "selector_minutes", true);
                            j._updateActiveMinutes();
                            return
                        } else {
                            j._selectorMode = 1
                        }
                    } else {
                        j._hideSelector();
                        j._activeDate.setMinutes(w._minutes);
                        j._updateActiveMinutes()
                    }
                    j._updateVisibleMinutes();
                    j._doOnSelectorChange()
                }
            }
        }
        this._sel._ta[D] = true
    };
    this._showSelector = function (w, q, A, v, a) {
        if (a === true && this._sel != null && this._isSelectorVisible() && w == this._sel._t) {
            this._hideSelector();
            return
        }
        if (this.conf.skin == "dhx_terrace") {
            q += 12
        }
        if (!this._sel || !this._sel._ta[w]) {
            this._initSelector(w, v)
        }
        if (w != this._sel._t && this._sel._t == "minutes" && this._minutesInterval == 1) {
            this.contTime.firstChild.firstChild.childNodes[3].innerHTML = this.getFormatedDate("%i")
        }
        this._sel._x = q;
        this._sel._y = A;
        this._sel.style.visibility = "hidden";
        this._sel.style.display = "";
        this._selCover.style.width = this.base.offsetWidth - 2 + "px";
        this._selCover.style.top = this.contMonth.offsetHeight + "px";
        this._selCover.style.height = this.contDates.offsetHeight + this.contDays.offsetHeight - 1 + "px";
        this._selCover.style.display = "";
        this._sel._t = w;
        this._sel.className = "dhtmlxcalendar_selector_obj dhtmlxcalendar_" + v;
        this._sel.childNodes[0].firstChild.firstChild.childNodes[0].style.display = this._sel.childNodes[0].firstChild.firstChild.childNodes[2].style.display = (w == "year" ? "" : "none");
        var u = Math.max(0, q - Math.round(this._sel.offsetWidth / 2));
        if (u + this._sel.offsetWidth > this._sel.parentNode.offsetWidth) {
            u = this._sel.parentNode.offsetWidth - this._sel.offsetWidth
        }
        this._sel.style.left = u + "px";
        if (w == "hours" || w == "minutes") {
            this._sel.style.top = A - this._sel.offsetHeight + "px"
        } else {
            this._sel.style.top = A + "px"
        }
        this._sel.childNodes[1].style.width = this._sel.childNodes[0].offsetWidth + "px";
        this._sel.style.visibility = "visible";
        this._doOnSelectorShow(w)
    };
    this._doOnSelectorShow = function (a) {
        if (a == "month") {
            this._updateActiveMonth()
        }
        if (a == "year") {
            this._updateYearsList(this._activeMonth)
        }
        if (a == "hours") {
            this._updateActiveHours()
        }
        if (a == "minutes") {
            this._updateActiveMinutes()
        }
    };
    this._hideSelector = function (a) {
        if (!this._sel) {
            return
        }
        this._sel.style.display = "none";
        this._sel.style.visible = "hidden";
        this._selCover.style.display = "none";
        if (this._sel._t == "minutes" && this._minutesInterval == 1) {
            this.contTime.firstChild.firstChild.childNodes[3].innerHTML = this.getFormatedDate("%i");
            this._unloadSelector("minutes")
        }
    };
    this._isSelectorVisible = function () {
        if (!this._sel) {
            return false
        }
        return (this._sel.style.display != "none")
    };
    this._doOnSelectorChange = function (a) {
        this.callEvent("onChange", [new Date(this._activeMonth.getFullYear(), this._activeMonth.getMonth(), this._activeDate.getDate(), this._activeDate.getHours(), this._activeDate.getMinutes(), this._activeDate.getSeconds()), a === true])
    };
    this._clearSelHover = function () {
        if (!this._selHover) {
            return
        }
        this._selHover.className = String(this._selHover.className.replace(/dhtmlxcalendar_selector_cell_hover/gi, ""));
        this._selHover = null
    };
    this._unloadSelector = function (u) {
        if (!this._sel) {
            return
        }
        if (!this._sel._ta[u]) {
            return
        }
        if (u == "month") {
            this.msCont.onclick = this.msCont.ontouchstart = null;
            this._msActive = null;
            for (var q in this._msCells) {
                this._msCells[q]._cell = null;
                this._msCells[q]._month = null;
                this._msCells[q].parentNode.removeChild(this._msCells[q]);
                this._msCells[q] = null
            }
            this._msCells = null;
            while (this.msCont.childNodes.length > 0) {
                this.msCont.removeChild(this.msCont.lastChild)
            }
            this.msCont.parentNode.removeChild(this.msCont);
            this.msCont = null
        }
        if (u == "year") {
            this.ysCont.onclick = this.ysCont.ontouchstart = null;
            for (var q in this._ysCells) {
                this._ysCells[q]._cell = null;
                this._ysCells[q]._year = null;
                this._ysCells[q].parentNode.removeChild(this._ysCells[q]);
                this._ysCells[q] = null
            }
            this._ysCells = null;
            while (this.ysCont.childNodes.length > 0) {
                this.ysCont.removeChild(this.ysCont.lastChild)
            }
            this.ysCont.parentNode.removeChild(this.ysCont);
            this.ysCont = null
        }
        if (u == "hours") {
            this.hsCont.onclick = this.hsCont.ontouchstart = null;
            this._hsActive = null;
            for (var q in this._hsCells) {
                this._hsCells[q]._cell = null;
                this._hsCells[q]._hours = null;
                this._hsCells[q].parentNode.removeChild(this._hsCells[q]);
                this._hsCells[q] = null
            }
            this._hsCells = null;
            while (this.hsCont.childNodes.length > 0) {
                this.hsCont.removeChild(this.hsCont.lastChild)
            }
            this.hsCont.parentNode.removeChild(this.hsCont);
            this.hsCont = null
        }
        if (u == "minutes") {
            this.rsCont.onclick = this.rsCont.ontouchstart = null;
            this._rsActive = null;
            for (var q in this._rsCells) {
                this._rsCells[q]._cell = null;
                this._rsCells[q]._minutes = null;
                this._rsCells[q].parentNode.removeChild(this._rsCells[q]);
                this._rsCells[q] = null
            }
            this._rsCells = null;
            while (this.rsCont.childNodes.length > 0) {
                this.rsCont.removeChild(this.rsCont.lastChild)
            }
            this.rsCont.parentNode.removeChild(this.rsCont);
            this.rsCont = null
        }
        this._sel._ta[u] = null
    };
    this.setMinutesInterval = function (a) {
        if (!(a == 1 || a == 5 || a == 10 || a == 15)) {
            return
        }
        this._minutesInterval = a;
        this._unloadSelector("minutes")
    };
    this._updateActiveMonth = function () {
        if (typeof (this._msActive) != "undefined" && typeof (this._msCells[this._msActive]) != "undefined") {
            this._msCells[this._msActive].className = "dhtmlxcalendar_selector_cell"
        }
        this._msActive = this._activeMonth.getMonth();
        this._msCells[this._msActive].className = "dhtmlxcalendar_selector_cell dhtmlxcalendar_selector_cell_active"
    };
    this._updateActiveYear = function () {
        var a = this._activeMonth.getFullYear();
        if (this._ysCells[a]) {
            this._ysCells[a].className = "dhtmlxcalendar_selector_cell dhtmlxcalendar_selector_cell_active"
        }
    };
    this._updateYearsList = function (A) {
        for (var v in this._ysCells) {
            this._ysCells[v] = null;
            delete this._ysCells[v]
        }
        var x = 12 * Math.floor(A.getFullYear() / 12);
        for (var y = 0; y < 4; y++) {
            for (var u = 0; u < 3; u++) {
                this.ysCont.childNodes[y].childNodes[u].innerHTML = x;
                this.ysCont.childNodes[y].childNodes[u]._year = x;
                this.ysCont.childNodes[y].childNodes[u].className = "dhtmlxcalendar_selector_cell";
                this._ysCells[x++] = this.ysCont.childNodes[y].childNodes[u]
            }
        }
        this._updateActiveYear()
    };
    this._scrollYears = function (a) {
        var u = (a < 0 ? this.ysCont.firstChild.firstChild._year : this.ysCont.lastChild.lastChild._year) + a;
        var q = new Date(u, this._activeMonth.getMonth(), 1, 0, 0, 0, 0);
        this._updateYearsList(q)
    };
    this._updateActiveHours = function () {
        if (typeof (this._hsActive) != "undefined" && typeof (this._hsCells[this._hsActive]) != "undefined") {
            this._hsCells[this._hsActive].className = "dhtmlxcalendar_selector_cell"
        }
        this._hsActive = this._activeDate.getHours();
        this._hsCells[this._hsActive].className = "dhtmlxcalendar_selector_cell dhtmlxcalendar_selector_cell_active"
    };
    this._updateVisibleHours = function () {
        this.contTime.firstChild.firstChild.childNodes[1].innerHTML = this._fixLength(this._activeDate.getHours(), 2)
    };
    this._updateActiveMinutes = function () {
        if (this._rsActive != null && typeof (this._rsActive) != "undefined" && typeof (this._rsCells[this._rsActive]) != "undefined") {
            this._rsCells[this._rsActive].className = "dhtmlxcalendar_selector_cell"
        }
        if (this._minutesInterval == 1) {
            this._rsActive = (this.getFormatedDate("%i").toString()).charAt(this._selectorMode == 1 ? 0 : 1)
        } else {
            this._rsActive = this._activeDate.getMinutes()
        }
        if (typeof (this._rsCells[this._rsActive]) != "undefined") {
            this._rsCells[this._rsActive].className = "dhtmlxcalendar_selector_cell dhtmlxcalendar_selector_cell_active"
        }
    };
    this._updateVisibleMinutes = function (q) {
        var a = this._fixLength(this._activeDate.getMinutes(), 2).toString();
        if (q == true) {
            a = a.charAt(0) + "<span class='dhtmlxcalendar_selected_date'>" + a.charAt(1) + "</span>"
        }
        this.contTime.firstChild.firstChild.childNodes[3].innerHTML = a;
        if (q == true) {
            this.contTime.firstChild.firstChild.childNodes[3].lastChild._par = true
        }
    };
    this._fixLength = function (a, q) {
        while (String(a).length < q) {
            a = "0" + String(a)
        }
        return a
    };
    this._dateFormat = "";
    this._dateFormatRE = null;
    this.setDateFormat = function (w) {
        var v = {};
        if (this._strToDate != null) {
            for (var q in this.i) {
                if (this.i[q].input != null && this.i[q].input.value.length > 0) {
                    var x = this._strToDate(this.i[q].input.value, this._dateFormat || this.langData[this.lang].dateformat || "%Y-%m-%d");
                    if (x instanceof Date) {
                        v[q] = x
                    }
                }
            }
        }
        this._dateFormat = w;
        var u = String(this._dateFormat).replace(/%[a-zA-Z]+/g, function (a) {
            var y = a.replace(/%/, "");
            switch (y) {
            case "n":
            case "h":
            case "j":
            case "g":
            case "G":
                return "\\d{1,2}";
            case "m":
            case "d":
            case "H":
            case "i":
            case "s":
            case "y":
                return "\\d{2}";
            case "Y":
                return "\\d{4}";
            case "M":
                return "(" + j.langData[j.lang].monthesSNames.join("|").toLowerCase() + "){1,}";
            case "F":
                return "(" + j.langData[j.lang].monthesFNames.join("|").toLowerCase() + "){1,}";
            case "D":
                return "[a-z]{2}";
            case "a":
            case "A":
                return "AM|PM"
            }
            return a
        });
        this._dateFormatRE = new RegExp(u, "i");
        for (var q in v) {
            this.i[q].input.value = this._dateToStr(v[q])
        }
        v = null
    };
    this.setDateFormat(this.langData[this.lang].dateformat || "%Y-%m-%d");
    this._getInd = function (v, a) {
        for (var u = 0; u < a.length; u++) {
            if (a[u].toLowerCase() == v) {
                return u
            }
        }
        return -1
    };
    this._updateDateStr = function (q) {
        if (!this._dateFormatRE || !q.match(this._dateFormatRE)) {
            return
        }
        if (q == this.getFormatedDate()) {
            return
        }
        var a = this._strToDate(q);
        if (!(a instanceof Date)) {
            return
        }
        if (this.checkEvent("onBeforeChange")) {
            if (!this.callEvent("onBeforeChange", [new Date(a.getFullYear(), a.getMonth(), a.getDate(), a.getHours(), a.getMinutes(), a.getSeconds())])) {
                if (this.i != null && this._activeInp != null && this.i[this._activeInp] != null && this.i[this._activeInp].input != null) {
                    this.i[this._activeInp].input.value = this.getFormatedDate()
                }
                return
            }
        }
        this._nullDate = false;
        this._activeDate = a;
        this._drawMonth(this._nullDate ? new Date() : this._activeDate);
        this._updateVisibleMinutes();
        this._updateVisibleHours();
        if (this._sel && this._isSelectorVisible()) {
            this._doOnSelectorShow(this._sel._t)
        }
        this._doOnSelectorChange(true)
    };
    this.showMonth = function (a) {
        if (typeof (a) == "string") {
            a = this._strToDate(a)
        }
        if (!(a instanceof Date)) {
            return
        }
        this._drawMonth(a)
    };
    this.setFormatedDate = function (w, x, q, v) {
        var u = this._strToDate(x, w);
        if (v) {
            return u
        }
        this.setDate(u)
    };
    this.getFormatedDate = function (q, a) {
        if (!(a && a instanceof Date)) {
            if (this._nullDate) {
                return ""
            }
            a = new Date(this._activeDate)
        }
        return this._dateToStr(a, q)
    };
    this.getWeekNumber = function (w) {
        if (typeof (w) == "string") {
            w = this._strToDate(w)
        }
        if (!(w instanceof Date)) {
            return "Invalid Date"
        }
        if (typeof (this._ftDay) == "undefined") {
            this._ftDay = 4
        }
        var D = this._wStart;
        var v = D + 7;
        var C = 4;
        var q = new Date(w.getFullYear(), 0, 1, 0, 0, 0, 0);
        var u = q.getDay();
        if (u == 0) {
            u = 7
        }
        if (C < D) {
            C += 7;
            u += 7
        }
        var y = 0;
        if (u >= D && u <= C) {} else {
            y = 1
        }
        var x = u - D;
        var A = new Date(w.getFullYear(), 0, 1 - x + y * 7, 0, 0, 0, 0);
        var F = 604800000;
        var a = new Date(w.getFullYear(), w.getMonth(), w.getDate() + 1, 0, 0, 0, 0);
        var E = Math.ceil((a.getTime() - A.getTime()) / F);
        return E
    };
    this.showWeekNumbers = function () {
        this.base.firstChild.className = "dhtmlxcalendar_wn"
    };
    this.hideWeekNumbers = function () {
        this.base.firstChild.className = ""
    };
    this.show = function (u) {
        if (!u && this._hasParent) {
            this._show();
            return
        }
        if (typeof (u) == "object" && typeof (u._dhtmlxcalendar_uid) != "undefined" && this.i[u._dhtmlxcalendar_uid] == u) {
            this._show(u._dhtmlxcalendar_uid);
            return
        }
        if (typeof (u) == "undefined") {
            for (var q in this.i) {
                if (!u) {
                    u = q
                }
            }
        }
        if (!u) {
            return
        }
        this._show(u)
    };
    this.hide = function () {
        if (this._isVisible()) {
            this._hide()
        }
    };
    this.isVisible = function () {
        return this._isVisible()
    };
    this._activeInp = null;
    this.pos = "bottom";
    this.setPosition = function (a, q) {
        this._px = null;
        this._py = null;
        if (a == "right" || a == "bottom") {
            this.pos = a
        } else {
            this.pos = "int";
            if (typeof (a) != "undefined" && !isNaN(a)) {
                this.base.style.left = a + "px";
                this._px = a
            }
            if (typeof (q) != "undefined" && !isNaN(q)) {
                this.base.style.top = q + "px";
                this._py = q
            }
            this._ifrSize()
        }
    };
    this._show = function (y, a) {
        if (a === true && this._activeInp == y && this._isVisible()) {
            this._hide();
            return
        }
        this.base.style.visibility = "hidden";
        this.base.style.display = "";
        if (!y) {
            if (this._px && this._py) {
                this.base.style.left = this._px + "px";
                this.base.style.top = this._py + "px"
            } else {
                this.base.style.left = "0px";
                this.base.style.top = "0px"
            }
        } else {
            if (this.base.className.indexOf("dhtmlxcalendar_in_input") == -1) {
                this.base.className += " dhtmlxcalendar_in_input"
            }
            var v = (this.i[y].input || this.i[y].button);
            var q = (navigator.appVersion.indexOf("MSIE") != -1);
            var w = Math.max((q ? document.documentElement : document.getElementsByTagName("html")[0]).scrollTop, document.body.scrollTop);
            var u = w + (q ? Math.max(document.documentElement.clientHeight || 0, document.documentElement.offsetHeight || 0, document.body.clientHeight || 0) : window.innerHeight);
            if (this.pos == "right") {
                this.base.style.left = this._getLeft(v) + v.offsetWidth + "px";
                this.base.style.top = Math.min(this._getTop(v), u - this.base.offsetHeight) + "px"
            } else {
                if (this.pos == "bottom") {
                    var x = this._getTop(v) + v.offsetHeight + 1;
                    if (x + this.base.offsetHeight > u) {
                        x = this._getTop(v) - this.base.offsetHeight
                    }
                    this.base.style.left = this._getLeft(v) + "px";
                    this.base.style.top = x + "px"
                } else {
                    this.base.style.left = (this._px || 0) + "px";
                    this.base.style.top = (this._py || 0) + "px"
                }
            }
            this._activeInp = y;
            v = null
        }
        this._hideSelector();
        this.base.style.visibility = "visible";
        this.base.style.zIndex = window.dhx4.zim.reserve(this.conf.zi);
        this._ifrSize();
        if (this._ifr) {
            this._ifr.style.display = ""
        }
        this.callEvent("onShow", [])
    };
    this._hide = function () {
        this._hideSelector();
        this.base.style.display = "none";
        window.dhx4.zim.clear(this.conf.zi);
        if (this.base.className.indexOf("dhtmlxcalendar_in_input") >= 0) {
            this.base.className = this.base.className.replace(/\s{0,}dhtmlxcalendar_in_input/gi, "")
        }
        this._activeInp = null;
        if (this._ifr) {
            this._ifr.style.display = "none"
        }
        this.callEvent("onHide", [])
    };
    this._isVisible = function () {
        return (this.base.style.display != "none")
    };
    this._getLeft = function (a) {
        return this._posGetOffset(a).left
    };
    this._getTop = function (a) {
        return this._posGetOffset(a).top
    };
    this._posGetOffsetSum = function (a) {
        var u = 0,
            q = 0;
        while (a) {
            u = u + parseInt(a.offsetTop);
            q = q + parseInt(a.offsetLeft);
            a = a.offsetParent
        }
        return {
            top: u,
            left: q
        }
    };
    this._posGetOffsetRect = function (v) {
        var y = v.getBoundingClientRect();
        var A = document.body;
        var q = document.documentElement;
        var a = window.pageYOffset || q.scrollTop || A.scrollTop;
        var w = window.pageXOffset || q.scrollLeft || A.scrollLeft;
        var x = q.clientTop || A.clientTop || 0;
        var C = q.clientLeft || A.clientLeft || 0;
        var D = y.top + a - x;
        var u = y.left + w - C;
        return {
            top: Math.round(D),
            left: Math.round(u)
        }
    };
    this._posGetOffset = function (a) {
        return this[a.getBoundingClientRect ? "_posGetOffsetRect" : "_posGetOffsetSum"](a)
    };
    this._rangeActive = false;
    this._rangeFrom = null;
    this._rangeTo = null;
    this._rangeSet = {};
    this.setInsensitiveDays = function (v) {
        var a = this._extractDates(v);
        for (var u = 0; u < a.length; u++) {
            this._rangeSet[new Date(a[u].getFullYear(), a[u].getMonth(), a[u].getDate(), 0, 0, 0, 0).getTime()] = true
        }
        this._drawMonth(this._activeMonth)
    };
    this.clearInsensitiveDays = function () {
        this._clearRangeSet();
        this._drawMonth(this._activeMonth)
    };
    this._holidays = {};
    this.setHolidays = function (u) {
        if (u == null) {
            this._clearHolidays()
        } else {
            if (u != null) {
                var a = this._extractDates(u);
                for (var v = 0; v < a.length; v++) {
                    this._holidays[new Date(a[v].getFullYear(), a[v].getMonth(), a[v].getDate(), 0, 0, 0, 0).getTime()] = true
                }
            }
        }
        this._drawMonth(this._activeMonth)
    };
    this._extractDates = function (v) {
        if (typeof (v) == "string" || v instanceof Date) {
            v = [v]
        }
        var u = [];
        for (var x = 0; x < v.length; x++) {
            if (typeof (v[x]) == "string") {
                var y = v[x].split(",");
                for (var a = 0; a < y.length; a++) {
                    u.push(this._strToDate(y[a]))
                }
            } else {
                if (v[x] instanceof Date) {
                    u.push(v[x])
                }
            }
        }
        return u
    };
    this._clearRange = function () {
        this._rangeActive = false;
        this._rangeType = null;
        this._rangeFrom = null;
        this._rangeTo = null
    };
    this._clearRangeSet = function () {
        for (var q in this._rangeSet) {
            this._rangeSet[q] = null;
            delete this._rangeSet[q]
        }
    };
    this._clearHolidays = function () {
        for (var q in this._holidays) {
            this._holidays[q] = null;
            delete this._holidays[q]
        }
    };
    this._isOutOfRange = function (q) {
        if (this._rangeSet[q] == true) {
            return true
        }
        if (this._rangeActive) {
            if (this._rangeType == "in" && (q < this._rangeFrom || q > this._rangeTo)) {
                return true
            }
            if (this._rangeType == "out" && (q >= this._rangeFrom && q <= this._rangeTo)) {
                return true
            }
            if (this._rangeType == "from" && q < this._rangeFrom) {
                return true
            }
            if (this._rangeType == "to" && q > this._rangeTo) {
                return true
            }
        }
        var a = new Date(q);
        if (this._rangeWeek) {
            if (this._rangeWeekData[a.getDay()] === true) {
                return true
            }
        }
        if (this._rangeMonth) {
            if (this._rangeMonthData[a.getDate()] === true) {
                return true
            }
        }
        if (this._rangeYear) {
            if (this._rangeYearData[a.getMonth() + "_" + a.getDate()] === true) {
                return true
            }
        }
        return false
    };
    this.clearSensitiveRange = function () {
        this._clearRange();
        this._drawMonth(this._activeMonth)
    };
    this.setSensitiveRange = function (v, u, a) {
        var q = false;
        if (v != null && u != null) {
            if (!(v instanceof Date)) {
                v = this._strToDate(v)
            }
            if (!(u instanceof Date)) {
                u = this._strToDate(u)
            }
            if (v.getTime() > u.getTime()) {
                return
            }
            this._rangeFrom = new Date(v.getFullYear(), v.getMonth(), v.getDate(), 0, 0, 0, 0).getTime();
            this._rangeTo = new Date(u.getFullYear(), u.getMonth(), u.getDate(), 0, 0, 0, 0).getTime();
            this._rangeActive = true;
            this._rangeType = "in";
            q = true
        }
        if (!q && v != null && u == null) {
            if (!(v instanceof Date)) {
                v = this._strToDate(v)
            }
            this._rangeFrom = new Date(v.getFullYear(), v.getMonth(), v.getDate(), 0, 0, 0, 0).getTime();
            this._rangeTo = null;
            if (a === true) {
                this._rangeFrom++
            }
            this._rangeActive = true;
            this._rangeType = "from";
            q = true
        }
        if (!q && v == null && u != null) {
            if (!(u instanceof Date)) {
                u = this._strToDate(u)
            }
            this._rangeFrom = null;
            this._rangeTo = new Date(u.getFullYear(), u.getMonth(), u.getDate(), 0, 0, 0, 0).getTime();
            if (a === true) {
                this._rangeTo--
            }
            this._rangeActive = true;
            this._rangeType = "to";
            q = true
        }
        if (q) {
            this._drawMonth(this._activeMonth)
        }
    };
    this.setInsensitiveRange = function (q, a) {
        if (q != null && a != null) {
            if (!(q instanceof Date)) {
                q = this._strToDate(q)
            }
            if (!(a instanceof Date)) {
                a = this._strToDate(a)
            }
            if (q.getTime() > a.getTime()) {
                return
            }
            this._rangeFrom = new Date(q.getFullYear(), q.getMonth(), q.getDate(), 0, 0, 0, 0).getTime();
            this._rangeTo = new Date(a.getFullYear(), a.getMonth(), a.getDate(), 0, 0, 0, 0).getTime();
            this._rangeActive = true;
            this._rangeType = "out";
            this._drawMonth(this._activeMonth);
            return
        }
        if (q != null && a == null) {
            this.setSensitiveRange(null, q, true);
            return
        }
        if (q == null && a != null) {
            this.setSensitiveRange(a, null, true);
            return
        }
    };
    this.disableDays = function (y, x) {
        if (y == "week") {
            if (typeof (x) != "object" && typeof (x.length) == "undefined") {
                x = [x]
            }
            if (!this._rangeWeekData) {
                this._rangeWeekData = {}
            }
            for (var u in this._rangeWeekData) {
                this._rangeWeekData[u] = false;
                delete this._rangeWeekData[u]
            }
            for (var w = 0; w < x.length; w++) {
                this._rangeWeekData[x[w]] = true;
                if (x[w] == 7) {
                    this._rangeWeekData[0] = true
                }
            }
            this._rangeWeek = true
        }
        if (y == "month") {
            if (typeof (x) != "object" && typeof (x.length) == "undefined") {
                x = [x]
            }
            if (!this._rangeMonthData) {
                this._rangeMonthData = {}
            }
            for (var u in this._rangeMonthData) {
                this._rangeMonthData[u] = false;
                delete this._rangeMonthData[u]
            }
            for (var w = 0; w < x.length; w++) {
                this._rangeMonthData[x[w]] = true
            }
            this._rangeMonth = true
        }
        if (y == "year") {
            var v = this._extractDates(x);
            if (!this._rangeYearData) {
                this._rangeYearData = {}
            }
            for (var u in this._rangeYearData) {
                this._rangeYearData[u] = false;
                delete this._rangeYearData[u]
            }
            for (var w = 0; w < v.length; w++) {
                this._rangeYearData[v[w].getMonth() + "_" + v[w].getDate()] = true
            }
            this._rangeYear = true
        }
        this._drawMonth(this._activeMonth)
    };
    this.enableDays = function (a) {
        if (a == "week") {
            this._rangeWeek = false
        }
        if (a == "month") {
            this._rangeMonth = false
        }
        if (a == "year") {
            this._rangeYear = false
        }
        this._drawMonth(this._activeMonth)
    };
    this._tipData = {};
    this._tipTM = null;
    this._tipTMTime = 400;
    this._tipEvs = false;
    this._tipPopup = null;
    this._tipCellDate = null;
    this._tipCellDim = null;
    this.setTooltip = function (v, y, A, a) {
        var w = this._extractDates(v);
        for (var x = 0; x < w.length; x++) {
            var u = new Date(w[x].getFullYear(), w[x].getMonth(), w[x].getDate(), 0, 0, 0, 0).getTime();
            this._tipData[u] = {
                text: y,
                showIcon: A,
                usePopup: a
            }
        }
        this._drawMonth(this._activeMonth)
    };
    this.clearTooltip = function (u) {
        var v = this._extractDates(u);
        for (var w = 0; w < v.length; w++) {
            var a = new Date(v[w].getFullYear(), v[w].getMonth(), v[w].getDate(), 0, 0, 0, 0).getTime();
            this._tipData[a] = null;
            delete this._tipData[a]
        }
        this._drawMonth(this._activeMonth)
    };
    this._initTooltipPopup = function () {
        if (this._tipEvs) {
            return
        }
        this.attachEvent("onMouseOver", function (q) {
            var a = new Date(q.getFullYear(), q.getMonth(), q.getDate(), 0, 0, 0, 0).getTime();
            if (this._tipData[a] != null) {
                if (this._tipTM) {
                    window.clearTimeout(this._tipTM)
                }
                this._tipCellDate = q;
                this._tipCellDim = this.getCellDimension(q);
                this._tipText = this._tipData[a].text;
                this._tipTM = window.setTimeout(this._showTooltipPopup, this._tipTMTime)
            }
        });
        this.attachEvent("onMouseOut", this._hideTooltipPopup);
        this._tipEvs = true
    };
    this._showTooltipPopup = function (v, a, A, q, u) {
        if (!j._tipPopup) {
            j._tipPopup = new dhtmlXPopup({
                mode: "top"
            })
        }
        j._tipPopup.attachHTML(j._tipText);
        j._tipPopup.show(j._tipCellDim.x, j._tipCellDim.y, j._tipCellDim.w, j._tipCellDim.h);
        j.callEvent("onPopupShow", [j._tipCellDate])
    };
    this._hideTooltipPopup = function () {
        if (this._tipTM) {
            window.clearTimeout(this._tipTM)
        }
        if (this._tipPopup != null && this._tipPopup.isVisible()) {
            this._tipPopup.hide();
            this.callEvent("onPopupHide", [this._tipCellDate])
        }
    };
    this.getPopup = function () {
        return this._tipPopup
    };
    this.getCellDimension = function (v) {
        if (typeof (v) == "string") {
            v = this._strToDate(v)
        }
        if (!(v instanceof Date)) {
            return null
        }
        var x = new Date(v.getFullYear(), v.getMonth(), v.getDate(), 0, 0, 0, 0).getTime();
        var u = null;
        for (var y = 0; y < this.contDates.childNodes.length; y++) {
            for (var a = 0; a < this.contDates.childNodes[y].childNodes.length; a++) {
                var A = this.contDates.childNodes[y].childNodes[a];
                if (A._date != null && A._date.getTime() == x) {
                    u = {
                        x: this._getLeft(A),
                        y: this._getTop(A),
                        w: A.offsetWidth,
                        h: A.offsetHeight
                    }
                }
                A = null
            }
        }
        return u
    };
    this._updateFromInput = function (a) {
        if (this._nullInInput && ((a.value).replace(/\s/g, "")).length == 0) {
            if (this.checkEvent("onBeforeChange")) {
                if (!this.callEvent("onBeforeChange", [null])) {
                    if (this.i != null && this._activeInp != null && this.i[this._activeInp] != null && this.i[this._activeInp].input != null) {
                        this.i[this._activeInp].input.value = this.getFormatedDate()
                    }
                    return
                }
            }
            this.setDate(null)
        } else {
            this._updateDateStr(a.value)
        }
        a = null
    };
    this._doOnClick = function (q) {
        q = q || event;
        var a = (q.target || q.srcElement);
        if (a._dhtmlxcalendar_uid && a._dhtmlxcalendar_uid != j._activeInp && j._isVisible() && j._activeInp) {
            j._hide();
            return
        }
        if (!a._dhtmlxcalendar_uid || !j.i[a._dhtmlxcalendar_uid]) {
            if (j._isSelectorVisible()) {
                j._hideSelector()
            } else {
                if (!j._hasParent && j._isVisible()) {
                    j._hide()
                }
            }
        }
    };
    this._doOnKeyDown = function (a) {
        a = a || event;
        if (a.keyCode == 27 || a.keyCode == 13) {
            if (j._isSelectorVisible()) {
                j._hideSelector()
            } else {
                if (j._isVisible() && !j._hasParent) {
                    j._hide()
                }
            }
        }
    };
    this._doOnInpClick = function (q) {
        q = q || event;
        var a = (q.target || q.srcElement);
        if (!a._dhtmlxcalendar_uid) {
            return
        }
        if (!j._listenerEnabled) {
            j._updateFromInput(a)
        }
        j._show(a._dhtmlxcalendar_uid, true)
    };
    this._doOnInpKeyUp = function (q) {
        q = q || event;
        var a = (q.target || q.srcElement);
        if (q.keyCode == 13 || !a._dhtmlxcalendar_uid) {
            return
        }
        if (!j._listenerEnabled) {
            j._updateFromInput(a)
        }
    };
    this._doOnBtnClick = function (q) {
        q = q || event;
        var a = (q.target || q.srcElement);
        if (!a._dhtmlxcalendar_uid) {
            return
        }
        if (j.i[a._dhtmlxcalendar_uid].input != null) {
            j._updateFromInput(j.i[a._dhtmlxcalendar_uid].input)
        }
        j._show(a._dhtmlxcalendar_uid, true)
    };
    this._doOnUnload = function () {
        if (j && j.unload) {
            j.unload()
        }
    };
    if (typeof (window.addEventListener) == "function") {
        document.body.addEventListener((this.conf.touch ? "touchstart" : "click"), j._doOnClick, false);
        window.addEventListener("keydown", j._doOnKeyDown, false);
        window.addEventListener("unload", j._doOnUnload, false)
    } else {
        document.body.attachEvent("onclick", j._doOnClick);
        document.body.attachEvent("onkeydown", j._doOnKeyDown);
        window.attachEvent("onunload", j._doOnUnload)
    }
    this.attachObj = function (u) {
        var q = window.dhx4.newId();
        if (typeof (u) == "string") {
            this.i[q] = {
                input: document.getElementById(u)
            }
        } else {
            if (typeof (u.tagName) != "undefined") {
                this.i[q] = {
                    input: u
                }
            } else {
                if (typeof (u) == "object" && (u.input != null || u.button != null)) {
                    this.i[q] = {};
                    if (u.input != null) {
                        this.i[q].input = (typeof (u.input) == "string" ? document.getElementById(u.input) : u.input)
                    }
                    if (u.button != null) {
                        this.i[q].button = (typeof (u.button) == "string" ? document.getElementById(u.button) : u.button)
                    }
                }
            }
        }
        this._attachEventsToObject(q);
        return q
    };
    this.detachObj = function (v) {
        var u = null;
        if (this.i[v] != null) {
            u = v
        } else {
            if (typeof (v) == "string") {
                v = document.getElementById(v);
                u = v._dhtmlxcalendar_uid
            } else {
                if (typeof (v.tagName) != "undefined") {
                    u = v._dhtmlxcalendar_uid
                } else {
                    if (typeof (v) == "object" && (v.input != null || v.button != null)) {
                        if (u == null && v.input != null) {
                            u = (typeof (v.input) == "string" ? document.getElementById(v.input) : v.input)._dhtmlxcalendar_uid
                        }
                        if (u == null && v.button != null) {
                            u = (typeof (v.button) == "string" ? document.getElementById(v.button) : v.button)._dhtmlxcalendar_uid
                        }
                    }
                }
            }
        }
        if (u != null && this.i[u] != null) {
            this._detachEventsFromObject(u);
            for (var q in this.i[q]) {
                this.i[u][q]._dhtmlxcalendar_uid = null;
                this.i[u][q] = null;
                delete this.i[u][q]
            }
            this.i[u] = null;
            delete this.i[u];
            return true
        }
        return false
    };
    this._attachEventsToObject = function (q) {
        if (this.i[q].button != null) {
            this.i[q].button._dhtmlxcalendar_uid = q;
            if (typeof (window.addEventListener) == "function") {
                this.i[q].button.addEventListener((this.conf.touch ? "touchstart" : "click"), j._doOnBtnClick, false)
            } else {
                this.i[q].button.attachEvent("onclick", j._doOnBtnClick)
            }
        } else {
            if (this.i[q].input != null) {
                this.i[q].input._dhtmlxcalendar_uid = q;
                if (typeof (window.addEventListener) == "function") {
                    this.i[q].input.addEventListener((this.conf.touch ? "touchstart" : "click"), j._doOnInpClick, false);
                    this.i[q].input.addEventListener("keyup", j._doOnInpKeyUp, false)
                } else {
                    this.i[q].input.attachEvent("onclick", j._doOnInpClick);
                    this.i[q].input.attachEvent("onkeyup", j._doOnInpKeyUp)
                }
            }
        }
    };
    this._detachEventsFromObject = function (q) {
        if (this.i[q].button != null) {
            if (typeof (window.addEventListener) == "function") {
                this.i[q].button.removeEventListener((this.conf.touch ? "touchstart" : "click"), j._doOnBtnClick, false)
            } else {
                this.i[q].button.detachEvent("onclick", j._doOnBtnClick)
            }
        } else {
            if (this.i[q].input != null) {
                if (typeof (window.addEventListener) == "function") {
                    this.i[q].input.removeEventListener((this.conf.touch ? "touchstart" : "click"), j._doOnInpClick, false);
                    this.i[q].input.removeEventListener("keyup", j._doOnInpKeyUp, false)
                } else {
                    this.i[q].input.detachEvent("onclick", j._doOnInpClick);
                    this.i[q].input.detachEvent("onkeyup", j._doOnInpKeyUp)
                }
            }
        }
    };
    this.enableListener = function (a) {
        if (!a) {
            return
        }
        if (typeof (window.addEventListener) == "function") {
            a.addEventListener("focus", j._listenerEvFocus, false);
            a.addEventListener("blur", j._listenerEvBlur, false)
        } else {
            a.attachEvent("onfocus", j._listenerEvFocus);
            a.attachEvent("onblur", j._listenerEvBlur)
        }
        a = null
    };
    this.disableListener = function (a) {
        if (!a) {
            return
        }
        a._f0 = false;
        if (this._tmListener) {
            window.clearTimeout(this._tmListener)
        }
        if (typeof (window.addEventListener) == "function") {
            a.removeEventListener("focus", j._listenerEvFocus, false);
            a.removeEventListener("blur", j._listenerEvBlur, false)
        } else {
            a.detachEvent("onfocus", j._listenerEvFocus);
            a.detachEvent("onblur", j._listenerEvBlur)
        }
        a = null
    };
    this._startListener = function (a) {
        if (this._tmListener) {
            window.clearTimeout(this._tmListener)
        }
        if (typeof (a._v1) == "undefined") {
            a._v1 = a.value
        }
        if (a._v1 != a.value) {
            this._updateFromInput(a);
            a._v1 = a.value
        }
        if (a._f0) {
            this._tmListener = window.setTimeout(function () {
                j._startListener(a)
            }, 100)
        }
    };
    this._listenerEvFocus = function (q) {
        q = q || event;
        var a = q.target || q.srcElement;
        a._f0 = true;
        j._startListener(a);
        a = null
    };
    this._listenerEvBlur = function (q) {
        q = q || event;
        var a = q.target || q.srcElement;
        a._f0 = false;
        a = null
    };
    for (var n in this.i) {
        this._attachEventsToObject(n)
    }
    window.dhx4._eventable(this);
    this._evOnArrowClick = function (a) {
        return this.callEvent("onArrowClick", a)
    };
    this._evOnClick = function (a) {
        return this.callEvent("onClick", a)
    };
    this._evOnMouseOut = function (a) {
        return this.callEvent("onMouseOut", a)
    };
    this._evOnMouseOver = function (a) {
        return this.callEvent("onMouseOver", a)
    };
    this.unload = function () {
        this._activeDate = null;
        this._activeDateCell = null;
        this._activeInp = null;
        this._activeMonth = null;
        this._dateFormat = null;
        this._dateFormatRE = null;
        this._lastHover = null;
        if (this._tmListener) {
            window.clearTimeout(this._tmListener)
        }
        this._tmListener = null;
        if (typeof (window.addEventListener) == "function") {
            document.body.removeEventListener((this.conf.touch ? "touchstart" : "click"), j._doOnClick, false);
            window.removeEventListener("keydown", j._doOnKeyDown, false);
            window.removeEventListener("unload", j._doOnUnload, false)
        } else {
            document.body.detachEvent("onclick", j._doOnClick);
            document.body.detachEvent("onkeydown", j._doOnKeyDown);
            window.detachEvent("onunload", j._doOnKeyDown)
        }
        this._doOnClick = null;
        this._doOnKeyDown = null;
        this._doOnUnload = null;
        for (var q in this.i) {
            this.i[q]._dhtmlxcalendar_uid = null;
            this._detachEventsFromObject(q);
            this.disableListener(this.i[q].input);
            this.i[q] = null;
            delete this.i[q]
        }
        this.i = null;
        this._doOnInpClick = null;
        this._doOnInpKeyUp = null;
        window.dhx4._eventable(this, "clear");
        this.contMonth.onselectstart = null;
        this.contMonth.firstChild.firstChild.onclick = null;
        this.contMonth.firstChild.firstChild.ontouchstart = null;
        this.contMonth.firstChild.firstChild.firstChild.onmouseover = null;
        this.contMonth.firstChild.firstChild.firstChild.onmouseout = null;
        this.contMonth.firstChild.firstChild.lastChild.onmouseover = null;
        this.contMonth.firstChild.firstChild.lastChild.onmouseout = null;
        while (this.contMonth.firstChild.firstChild.childNodes.length > 0) {
            this.contMonth.firstChild.firstChild.removeChild(this.contMonth.firstChild.firstChild.lastChild)
        }
        this.contMonth.firstChild.removeChild(this.contMonth.firstChild.firstChild);
        this.contMonth.removeChild(this.contMonth.firstChild);
        this.contMonth.parentNode.removeChild(this.contMonth);
        this.contMonth = null;
        while (this.contDays.firstChild.childNodes.length > 0) {
            this.contDays.firstChild.removeChild(this.contDays.firstChild.lastChild)
        }
        this.contDays.removeChild(this.contDays.firstChild);
        this.contDays.parentNode.removeChild(this.contDays);
        this.contDays = null;
        this.contDates.onclick = null;
        this.contDates.ontouchstart = null;
        this.contDates.onmouseover = null;
        this.contDates.onmouseout = null;
        while (this.contDates.childNodes.length > 0) {
            while (this.contDates.lastChild.childNodes.length > 0) {
                this.contDates.lastChild.lastChild._css_date = null;
                this.contDates.lastChild.lastChild._css_month = null;
                this.contDates.lastChild.lastChild._css_weekend = null;
                this.contDates.lastChild.lastChild._css_hover = null;
                this.contDates.lastChild.lastChild._date = null;
                this.contDates.lastChild.lastChild._q = null;
                this.contDates.lastChild.lastChild._w = null;
                this.contDates.lastChild.removeChild(this.contDates.lastChild.lastChild)
            }
            this.contDates.removeChild(this.contDates.lastChild)
        }
        this.contDates.parentNode.removeChild(this.contDates);
        this.contDates = null;
        this.contTime.firstChild.firstChild.onclick = null;
        this.contTime.firstChild.firstChild.ontouchstart = null;
        while (this.contTime.firstChild.firstChild.childNodes.length > 0) {
            this.contTime.firstChild.firstChild.removeChild(this.contTime.firstChild.firstChild.lastChild)
        }
        this.contTime.firstChild.removeChild(this.contTime.firstChild.firstChild);
        this.contTime.removeChild(this.contTime.firstChild);
        this.contTime.parentNode.removeChild(this.contTime);
        this.contTime = null;
        this._lastHover = null;
        this._unloadSelector("month");
        this._unloadSelector("year");
        this._unloadSelector("hours");
        this._unloadSelector("minutes");
        if (this._selCover) {
            this._selCover.parentNode.removeChild(this._selCover);
            this._selCover = null
        }
        if (this._sel) {
            for (var q in this._sel._ta) {
                this._sel._ta[q] = null
            }
            this._sel._ta = null;
            this._sel._t = null;
            this._sel.onmouseover = null;
            this._sel.onmouseout = null;
            while (this._sel.firstChild.firstChild.firstChild.childNodes.length > 0) {
                this._sel.firstChild.firstChild.firstChild.lastChild.onclick = null;
                this._sel.firstChild.firstChild.firstChild.lastChild.onmouseover = null;
                this._sel.firstChild.firstChild.firstChild.lastChild.onmouseout = null;
                this._sel.firstChild.firstChild.firstChild.removeChild(this._sel.firstChild.firstChild.firstChild.lastChild)
            }
            this._sel.firstChild.firstChild.removeChild(this._sel.firstChild.firstChild.firstChild);
            this._sel.firstChild.removeChild(this._sel.firstChild.firstChild);
            while (this._sel.childNodes.length > 0) {
                this._sel.removeChild(this._sel.lastChild)
            }
            this._sel.parentNode.removeChild(this._sel);
            this._sel = null
        }
        this.base.onclick = null;
        this.base.onmousedown = null;
        this.base.ontouchstart = null;
        this.base.onmouseout = null;
        this.base.parentNode.removeChild(this.base);
        this.base = null;
        this._clearDayHover = null;
        this._clearSelHover = null;
        this._doOnSelectorChange = null;
        this._doOnSelectorShow = null;
        this._drawMonth = null;
        this._fixLength = null;
        this._getLeft = null;
        this._getTop = null;
        this._ifrSize = null;
        this._hide = null;
        this._hideSelector = null;
        this._initSelector = null;
        this._isSelectorVisible = null;
        this._isVisible = null;
        this._posGetOffset = null;
        this._posGetOffsetRect = null;
        this._posGetOffsetSum = null;
        this._scrollYears = null;
        this._show = null;
        this._showSelector = null;
        this._strToDate = null;
        this._updateActiveHours = null;
        this._updateActiveMinutes = null;
        this._updateActiveMonth = null;
        this._updateActiveYear = null;
        this._updateCellStyle = null;
        this._updateDateStr = null;
        this._updateVisibleHours = null;
        this._updateVisibleMinutes = null;
        this._updateYearsList = null;
        this.enableIframe = null;
        this.hide = null;
        this.hideTime = null;
        this.setDate = null;
        this.setDateFormat = null;
        this.setYearsRange = null;
        this.show = null;
        this.showTime = null;
        this.unload = null;
        if (this._tipPopup != null) {
            this._tipPopup.unload();
            this._tipPopup = null
        }
        for (var q in this) {
            delete this[q]
        }
        q = j = null
    };
    this.setDate(this._activeDate);
    return this
}
dhtmlXCalendarObject.prototype.lang = "en";
dhtmlXCalendarObject.prototype.langData = {
    en: {
        dateformat: "%Y-%m-%d",
        hdrformat: "%F %Y",
        monthesFNames: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
        monthesSNames: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
        daysFNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
        daysSNames: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
        weekstart: 1,
        weekname: "w"
    }
};
dhtmlXCalendarObject.prototype._buildMonthHdr = function (j) {
    var c = this;
    var h = function (l) {
            return (String(l).length == 1 ? "0" + String(l) : l)
        };
    var a = function (l, m) {
            return "<span class='dhtmlxcalendar_month_label_" + l + "'>" + m + "</span>"
        };
    var g = String(this.langData[this.lang].hdrformat || ("%F %Y")).replace(/%[a-z]/gi, function (l) {
        switch (l) {
        case "%m":
            return a("month", h(j.getMonth() + 1));
        case "%n":
            return a("month", j.getMonth() + 1);
        case "%M":
            return a("month", c.langData[c.lang].monthesSNames[j.getMonth()]);
        case "%F":
            return a("month", c.langData[c.lang].monthesFNames[j.getMonth()]);
        case "%y":
            return a("year", h(j.getYear() % 100));
        case "%Y":
            return a("year", j.getFullYear());
        case "%%":
            return "%";
        default:
            return l
        }
    });
    c = h = a = null;
    return g
};
dhtmlXCalendarObject.prototype.enableIframe = function (a) {
    if (a == true) {
        if (!this._ifr) {
            this._ifr = document.createElement("IFRAME");
            this._ifr.frameBorder = 0;
            this._ifr.border = 0;
            this._ifr.setAttribute("src", "javascript:false;");
            this._ifr.className = "dhtmlxcalendar_ifr";
            this._ifr.onload = function () {
                this.onload = null;
                this.contentWindow.document.open("text/html", "replace");
                this.contentWindow.document.write("<html><head><style>html,body{width:100%;height:100%;overflow:hidden;margin:0px;}</style></head><body</body></html>")
            };
            this.base.parentNode.insertBefore(this._ifr, this.base);
            this._ifrSize()
        }
    } else {
        if (this._ifr) {
            this._ifr.parentNode.removeChild(this._ifr);
            this._ifr = null
        }
    }
};
dhtmlXCalendarObject.prototype._ifrSize = function () {
    if (this._ifr) {
        this._ifr.style.left = this.base.style.left;
        this._ifr.style.top = this.base.style.top;
        this._ifr.style.width = this.base.offsetWidth + "px";
        this._ifr.style.height = this.base.offsetHeight + "px"
    }
};
dhtmlxCalendarObject = dhtmlXCalendarObject;
dhtmlXCalendarObject.prototype._strToDate = function (j, y) {
    y = (y || this._dateFormat);
    y = y.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\\:|]/g, "\\$&");
    var C = [];
    var o = [];
    y = y.replace(/%[a-z]/gi, function (q) {
        switch (q) {
        case "%d":
        case "%m":
        case "%y":
        case "%h":
        case "%H":
        case "%i":
        case "%s":
            o.push(q);
            return "(\\d{2})";
        case "%D":
        case "%l":
        case "%M":
        case "%F":
            o.push(q);
            return "([a-z\u0430-\u044F\u0451]{1,})";
        case "%j":
        case "%n":
        case "%g":
        case "%G":
            o.push(q);
            return "(\\d{1,2})";
        case "%Y":
            o.push(q);
            return "(\\d{4})";
        case "%a":
            o.push(q);
            return "(\\[am|pm])";
        case "%A":
            o.push(q);
            return "(\\[AM|PM])"
        }
        return q
    });
    var D = new RegExp(y);
    var s = j.match(D);
    if (s == null || s.length - 1 != o.length) {
        return "Invalid Date"
    }
    for (var c = 1; c < s.length; c++) {
        C.push(s[c])
    }
    var g = {
        "%y": 1,
        "%Y": 1,
        "%n": 2,
        "%m": 2,
        "%M": 2,
        "%F": 2,
        "%d": 3,
        "%j": 3,
        "%a": 4,
        "%A": 4,
        "%H": 5,
        "%G": 5,
        "%h": 5,
        "%g": 5,
        "%i": 6,
        "%s": 7
    };
    var u = {};
    var m = {};
    for (var c = 0; c < o.length; c++) {
        if (typeof (g[o[c]]) != "undefined") {
            var h = g[o[c]];
            if (!u[h]) {
                u[h] = [];
                m[h] = []
            }
            u[h].push(C[c]);
            m[h].push(o[c])
        }
    }
    C = [];
    o = [];
    for (var c = 1; c <= 7; c++) {
        if (u[c] != null) {
            for (var x = 0; x < u[c].length; x++) {
                C.push(u[c][x]);
                o.push(m[c][x])
            }
        }
    }
    var n = this;
    var a = new Date();
    a.setDate(1);
    a.setMinutes(0);
    a.setSeconds(0);
    for (var c = 0; c < C.length; c++) {
        switch (o[c]) {
        case "%d":
        case "%j":
        case "%n":
        case "%m":
        case "%Y":
        case "%H":
        case "%G":
        case "%i":
        case "%s":
            if (!isNaN(C[c])) {
                a[{
                    "%d": "setDate",
                    "%j": "setDate",
                    "%n": "setMonth",
                    "%m": "setMonth",
                    "%Y": "setFullYear",
                    "%H": "setHours",
                    "%G": "setHours",
                    "%i": "setMinutes",
                    "%s": "setSeconds"
                }[o[c]]](Number(C[c]) + (o[c] == "%m" || o[c] == "%n" ? -1 : 0))
            }
            break;
        case "%M":
        case "%F":
            var l = this._getInd(C[c].toLowerCase(), n.langData[n.lang][{
                "%M": "monthesSNames",
                "%F": "monthesFNames"
            }[o[c]]]);
            if (l >= 0) {
                a.setMonth(l)
            }
            break;
        case "%y":
            if (!isNaN(C[c])) {
                var A = Number(C[c]);
                a.setFullYear(A + (A > 50 ? 1900 : 2000))
            }
            break;
        case "%g":
        case "%h":
            if (!isNaN(C[c])) {
                var A = Number(C[c]);
                if (A <= 12 && A >= 0) {
                    a.setHours(A + (this._getInd("pm", C) >= 0 ? (A == 12 ? 0 : 12) : (A == 12 ? -12 : 0)))
                }
            }
            break
        }
    }
    n = null;
    return a
};
dhtmlXCalendarObject.prototype._dateToStr = function (l, h) {
    var g = this;
    if (l instanceof Date) {
        var j = function (m) {
                return (String(m).length == 1 ? "0" + String(m) : m)
            };
        var a = function (m) {
                switch (m) {
                case "%d":
                    return j(l.getDate());
                case "%j":
                    return l.getDate();
                case "%D":
                    return g.langData[g.lang].daysSNames[l.getDay()];
                case "%l":
                    return g.langData[g.lang].daysFNames[l.getDay()];
                case "%m":
                    return j(l.getMonth() + 1);
                case "%n":
                    return l.getMonth() + 1;
                case "%M":
                    return g.langData[g.lang].monthesSNames[l.getMonth()];
                case "%F":
                    return g.langData[g.lang].monthesFNames[l.getMonth()];
                case "%y":
                    return j(l.getYear() % 100);
                case "%Y":
                    return l.getFullYear();
                case "%g":
                    return (l.getHours() + 11) % 12 + 1;
                case "%h":
                    return j((l.getHours() + 11) % 12 + 1);
                case "%G":
                    return l.getHours();
                case "%H":
                    return j(l.getHours());
                case "%i":
                    return j(l.getMinutes());
                case "%s":
                    return j(l.getSeconds());
                case "%a":
                    return (l.getHours() > 11 ? "pm" : "am");
                case "%A":
                    return (l.getHours() > 11 ? "PM" : "AM");
                case "%%":
                    "%";
                default:
                    return m
                }
            };
        var c = String(h || this._dateFormat).replace(/%[a-zA-Z]/g, a)
    }
    g = null;
    return (c || String(l))
};
window.dhtmlxDblCalendarObject = window.dhtmlXDoubleCalendarObject = window.dhtmlXDoubleCalendar = function (c) {
    var a = this;
    this.leftCalendar = new dhtmlXCalendarObject(c);
    this.leftCalendar.hideTime();
    this.rightCalendar = new dhtmlXCalendarObject(c);
    this.rightCalendar.hideTime();
    this.leftCalendar.attachEvent("onClick", function (g) {
        a._updateRange("rightCalendar", g, null);
        a._evOnClick(["left", g])
    });
    this.rightCalendar.attachEvent("onClick", function (g) {
        a._updateRange("leftCalendar", null, g);
        a._evOnClick(["right", g])
    });
    this.leftCalendar.attachEvent("onBeforeChange", function (g) {
        return a._evOnBeforeChange(["left", g])
    });
    this.rightCalendar.attachEvent("onBeforeChange", function (g) {
        return a._evOnBeforeChange(["right", g])
    });
    this.show = function () {
        this.leftCalendar.show();
        this.rightCalendar.base.style.marginLeft = this.leftCalendar.base.offsetWidth - 1 + "px";
        this.rightCalendar.show()
    };
    this.hide = function () {
        this.leftCalendar.hide();
        this.rightCalendar.hide()
    };
    this.setDateFormat = function (g) {
        this.leftCalendar.setDateFormat(g);
        this.rightCalendar.setDateFormat(g)
    };
    this.setDates = function (h, g) {
        if (h != null) {
            this.leftCalendar.setDate(h)
        }
        if (g != null) {
            this.rightCalendar.setDate(g)
        }
        this._updateRange()
    };
    this._updateRange = function (g, j, h) {
        if (arguments.length == 3) {
            (g == "leftCalendar" ? this.leftCalendar : this.rightCalendar).setSensitiveRange(j, h)
        } else {
            this.leftCalendar.setSensitiveRange(null, this.rightCalendar.getDate());
            this.rightCalendar.setSensitiveRange(this.leftCalendar.getDate(), null)
        }
    };
    this.getFormatedDate = function () {
        return this.leftCalendar.getFormatedDate.apply(this.leftCalendar, arguments)
    };
    this.unload = function () {
        window.dhx4._eventable(this, "clear");
        this.leftCalendar.unload();
        this.rightCalendar.unload();
        this.leftCalendar = this.rightCalendar = null;
        this._updateRange = null;
        this._evOnClick = null;
        this._evOnBeforeChange = null;
        this.show = null;
        this.hide = null;
        this.setDateFormat = null;
        this.setDates = null;
        this.getFormatedDate = null;
        this.unload = null;
        a = null
    };
    this._evOnClick = function (g) {
        return this.callEvent("onClick", g)
    };
    this._evOnBeforeChange = function (g) {
        return this.callEvent("onBeforeChange", g)
    };
    window.dhx4._eventable(this);
    return this
};

function dhtmlXCombo(l, r, g, n, j) {
    var m = this;
    var h = null;
    var s = null;
    if (typeof (l) == "object" && !l.tagName) {
        h = l;
        l = h.parent;
        g = h.width;
        r = h.name;
        n = h.mode;
        s = h.skin
    }
    this.cont = (typeof (l) == "string" ? document.getElementById(l) : l);
    this.conf = {
        skin: null,
        form_name: r || "dhxcombo",
        combo_width: (parseInt(g) || this.cont.offsetWidth || 120) - (dhx4.isFF || dhx4.isIE ? 2 : 0),
        combo_image: false,
        combo_focus: false,
        opts_type: (typeof (n) == "string" && typeof (this.modes[n]) != "undefined" ? n : "option"),
        opts_count: 8,
        opts_count_min: 3,
        opts_width: null,
        item_h: null,
        list_zi_id: window.dhx4.newId(),
        allow_free_text: true,
        allow_empty_value: true,
        enabled: true,
        img_path: "",
        img_def: "",
        img_def_dis: true,
        template: {
            input: "#text#",
            option: "#text#"
        },
        f_mode: false,
        f_url: false,
        f_cache: false,
        f_cache_data: {},
        f_dyn: false,
        f_dyn_end: false,
        f_mask: "",
        f_ac: true,
        f_ac_text: "",
        f_server_tm: null,
        f_server_last: "",
        last_hover: null,
        last_selected: null,
        last_match: null,
        last_text: "",
        last_value: "",
        tm_hover: null,
        tm_confirm_blur: null,
        clear_click: false,
        clear_blur: false,
        clear_bsp: false,
        clear_key: false,
        sp: {
            dhx_skyblue: {
                list_ofs: 1
            },
            dhx_web: {
                list_ofs: 0
            },
            dhx_terrace: {
                list_ofs: 1
            }
        }
    };
    this.conf.combo_image = (this.modes[this.conf.opts_type].image == true);
    this.t = {};
    this.base = document.createElement("DIV");
    this.base.style.width = this.conf.combo_width + "px";
    this.base.innerHTML = "<input type='text' class='dhxcombo_input' style='width:" + (this.conf.combo_width - 24 - (this.conf.combo_image ? 23 : 0)) + "px;" + (this.conf.combo_image ? "margin-left:23px;" : "") + "' autocomplete='off'><input type='hidden' value=''><input type='hidden' value='false'><div class='dhxcombo_select_button'><div class='dhxcombo_select_img'></div></div>" + (this.conf.combo_image ? "<div class='dhxcombo_top_image'>" + this.modes[this.conf.opts_type].getTopImage(null, this.conf.enabled) + "</div>" : "");
    this.cont.appendChild(this.base);
    this.list = document.createElement("DIV");
    this.list.style.display = "none";
    document.body.insertBefore(this.list, document.body.firstChild);
    this.setSkin(s || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxcombo") || "dhx_skyblue");
    this._updateTopImage = function (a) {
        if (!this.conf.combo_image) {
            return
        }
        if (a != null) {
            this.base.lastChild.innerHTML = this.t[a].obj.getTopImage(this.t[a].item, this.conf.enabled)
        } else {
            this.base.lastChild.innerHTML = this.modes[this.conf.opts_type].getTopImage(null, this.conf.enabled)
        }
    };
    this._filterOpts = function (C) {
        if (this.conf.f_server_tm) {
            window.clearTimeout(this.conf.f_server_tm)
        }
        var v = String(this.base.firstChild.value).replace(new RegExp(this.conf.f_ac_text + "$", "i"), "");
        if (this.conf.f_server_last == v.toLowerCase()) {
            this._checkForMatch();
            return
        }
        if (this.conf.f_url != null && this.checkEvent("onDynXLS")) {
            this.conf.f_server_last = v.toLowerCase();
            this.callEvent("onDynXLS", [v]);
            return
        }
        if (this.conf.f_url != null) {
            if (v.length == 0) {
                this.conf.f_server_last = v.toLowerCase();
                this.clearAll();
                return
            }
            if (this.conf.f_cache == true && this.conf.f_cache_data[v] != null) {
                this.clearAll();
                this.conf.f_server_last = v.toLowerCase();
                for (var x = 0; x < this.conf.f_cache_data[v].data.length; x++) {
                    this.load(this.conf.f_cache_data[v].data[x])
                }
                if (this.conf.f_dyn) {
                    this.conf.f_dyn_end = this.conf.f_cache_data[v].dyn_end;
                    this.conf.f_mask = this.conf.f_cache_data[v].mask
                }
                if (C !== true) {
                    this._showList(true);
                    this._checkForMatch()
                }
            } else {
                this.conf.f_server_tm = window.setTimeout(function () {
                    m.conf.f_server_last = v.toLowerCase();
                    m.conf.f_mask = v;
                    var q = "mask=" + encodeURIComponent(v);
                    if (m.conf.f_dyn) {
                        q += "&pos=0";
                        m.conf.f_dyn_end = false
                    }
                    var a = function (E) {
                            if (m.conf.f_cache) {
                                if (!m.conf.f_cache_data[v]) {
                                    m.conf.f_cache_data[v] = {
                                        data: [],
                                        dyn_end: false,
                                        mask: v
                                    }
                                }
                                m.conf.f_cache_data[v].data.push(E.xmlDoc.responseXML)
                            }
                            m.clearAll();
                            m.load(E.xmlDoc.responseXML);
                            if (m.conf.f_ac && m.conf.f_mode == "start" && m.conf.clear_bsp == false && m.list.firstChild != null) {
                                var D = m.list.firstChild._optId;
                                var F = String(m.t[D].obj.getText(m.list.firstChild, true));
                                if (String(F).toLowerCase().indexOf(String(v).toLowerCase()) === 0) {
                                    m.base.firstChild.value = F;
                                    m._selectRange(v.length, F.length)
                                }
                            }
                            if (C !== true) {
                                m._showList(true);
                                m._checkForMatch()
                            }
                            a = null
                        };
                    if (window.dhx4.ajax.method == "post") {
                        window.dhx4.ajax.post(m.conf.f_url, q, a)
                    } else {
                        if (window.dhx4.ajax.method == "get") {
                            window.dhx4.ajax.get(m.conf.f_url + (String(m.conf.f_url).indexOf("?") >= 0 ? "&" : "?") + q, a)
                        }
                    }
                }, 200)
            }
        } else {
            this.conf.f_server_last = v.toLowerCase();
            var w = (v.length == 0 ? true : new RegExp((this.conf.f_mode == "start" ? "^" : "") + v, "i"));
            var A = null;
            for (var u in this.t) {
                var y = this.t[u].obj.getText(this.t[u].item, true);
                if (w === true || w.test(y) == true) {
                    this.t[u].item.style.display = "";
                    if (A == null && v.length > 0) {
                        A = String(this.t[u].obj.getText(this.t[u].item, true))
                    }
                } else {
                    this.t[u].item.style.display = "none"
                }
            }
            if (this.conf.f_ac && this.conf.f_mode == "start" && this.conf.clear_bsp == false && A != null) {
                this.conf.f_ac_text = A.replace(new RegExp("^" + v, "i"), "");
                this.base.firstChild.value = A;
                this._selectRange(this.conf.f_server_last.length, this.base.firstChild.value.length)
            }
            if (this.conf.f_mode == "between" && this.conf.clear_bsp == true) {
                this._checkForMatch(true)
            }
            if (C !== true) {
                this._showList(true);
                this._checkForMatch()
            }
        }
    };
    this._initObj = function (a) {
        if (typeof (a.template) != "undefined") {
            this.setTemplate(a.template)
        }
        this.addOption(a.options)
    };
    this._xmlToObj = function (D, F) {
        var K = {
            options: []
        };
        var H = (F == true ? D : D.getElementsByTagName("complete"));
        if (H.length > 0) {
            var v = H[0].childNodes;
            for (var u = 0; u < v.length; u++) {
                if (typeof (v[u].tagName) != "undefined") {
                    if (String(v[u].tagName).toLowerCase() == "template") {
                        for (var J = 0; J < v[u].childNodes.length; J++) {
                            if (v[u].childNodes[J].tagName != null) {
                                var C = v[u].childNodes[J].tagName;
                                if (typeof (this.conf.template[C]) != "undefined") {
                                    this.conf.template[C] = (v[u].childNodes[J].firstChild != null ? v[u].childNodes[J].firstChild.nodeValue : "")
                                }
                            }
                        }
                    }
                    if (String(v[u].tagName).toLowerCase() == "option") {
                        var A = false;
                        if (F == true) {
                            A = (window.dhx4.s2b(v[u].selected) || v[u].getAttribute("selected") != null)
                        } else {
                            A = window.dhx4.s2b(v[u].getAttribute("selected"))
                        }
                        var x = {
                            value: v[u].getAttribute("value"),
                            text: (v[u].firstChild != null ? v[u].firstChild.nodeValue : ""),
                            selected: A,
                            checked: window.dhx4.s2b(v[u].getAttribute("checked"))
                        };
                        for (var I in {
                            img: 1,
                            img_dis: 1,
                            img_src: 1,
                            img_src_dis: 1
                        }) {
                            if (v[u].getAttribute(I) != null) {
                                x[I] = v[u].getAttribute(I)
                            }
                        }
                        for (var J = 0; J < v[u].childNodes.length; J++) {
                            if (v[u].childNodes[J].tagName != null && String(v[u].childNodes[J].tagName).toLowerCase() == "text") {
                                x.text = {};
                                var y = v[u].childNodes[J];
                                for (var E = 0; E < y.childNodes.length; E++) {
                                    if (y.childNodes[E].tagName != null) {
                                        x.text[y.childNodes[E].tagName] = (y.childNodes[E].firstChild != null ? y.childNodes[E].firstChild.nodeValue : "")
                                    }
                                }
                            }
                        }
                        K.options.push(x)
                    }
                }
            }
            H = v = null
        }
        return K
    };
    window.dhx4._enableDataLoading(this, "_initObj", "_xmlToObj", "complete", {
        data: true
    });
    window.dhx4._eventable(this);
    this._getNearItem = function (u, q) {
        var a = null;
        while (u != null) {
            u = u[q < 0 ? "previousSibling" : "nextSibling"];
            if (a == null && u != null && u.style.display == "" && u._optId != null) {
                a = u;
                u = null
            }
        }
        return a
    };
    this.setName(this.conf.form_name);
    this._doOnListMouseMove = function (q) {
        q = q || event;
        var a = q.target || q.srcElement;
        while (a != null && a != this) {
            if (typeof (a._optId) != "undefined") {
                if (m.conf.tm_hover) {
                    window.clearTimeout(m.conf.tm_hover)
                }
                m._setSelected(a._optId)
            }
            a = a.parentNode
        }
        a = null
    };
    this._doOnListMouseDown = function (a) {
        a = a || event;
        a.cancelBubble = true;
        m.conf.clear_click = true;
        window.setTimeout(function () {
            m.base.firstChild.focus()
        }, 1)
    };
    this._doOnListMouseUp = function (u) {
        u = u || event;
        var a = u.target || u.srcElement;
        while (a != null && a != this) {
            if (typeof (a._optId) != "undefined") {
                var q = true;
                if (typeof (m.t[a._optId].obj.optionClick) == "function" && m.t[a._optId].obj.optionClick(a, u, m) !== true) {
                    q = false
                }
                if (q) {
                    m._setSelected(a._optId, null, true);
                    m._confirmSelect("click")
                }
            }
            a = a.parentNode
        }
        a = null
    };
    this._doOnListMouseOut = function (a) {
        if (m.conf.tm_hover) {
            window.clearTimeout(m.conf.tm_hover)
        }
        m.conf.tm_hover = window.setTimeout(function () {
            var q = m.conf.last_match || m.conf.last_selected;
            if (m.conf.last_match == null && m.t[q] != null) {
                if (m.base.firstChild.value != m.t[q].obj.getText(m.t[q].item, true)) {
                    q = null
                }
            }
            m._setSelected(q, null, true)
        }, 1)
    };
    this._doOnBaseMouseDown = function (w) {
        if (!m.conf.enabled) {
            return
        }
        m.conf.clear_click = true;
        w = w || event;
        var q = w.target || w.srcElement;
        if (q != this.firstChild) {
            window.setTimeout(function () {
                m.base.firstChild.focus()
            }, 1);
            var v = q;
            while (v != this && v != null) {
                if (v == this.lastChild) {
                    if (typeof (m.modes[m.conf.opts_type].topImageClick) == "function") {
                        var u = (m.conf.last_hover || m.conf.last_selected);
                        var a = (u != null ? m.t[u].item : null);
                        if (m.modes[m.conf.opts_type].topImageClick(a, m) !== true) {
                            u = a = null;
                            return
                        }
                    }
                    v = null
                } else {
                    v = v.parentNode
                }
            }
        }
        if (m._isListVisible()) {
            m._hideList()
        } else {
            if (q != this.firstChild) {
                m.conf.clear_blur = true
            }
            m._showList();
            m._setSelected(m.conf.last_selected, true, true)
        }
        q = null
    };
    this._doOnBodyMouseDown = function () {
        if (m.conf.clear_click) {
            m.conf.clear_click = false;
            return
        }
        m._confirmSelect("blur")
    };
    this._doOnInputFocus = function () {
        m.conf.clear_blur = false;
        if (m.conf.tm_confirm_blur) {
            window.clearTimeout(m.conf.tm_confirm_blur)
        }
        if (m.conf.combo_focus == false) {
            m.conf.combo_focus = true;
            m.callEvent("onFocus", [])
        }
    };
    this._doOnInputBlur = function () {
        if (m.conf.clear_blur == true) {
            m.conf.clear_blur = false;
            return
        }
        if (m.conf.tm_confirm_blur) {
            window.clearTimeout(m.conf.tm_confirm_blur)
        }
        m.conf.tm_confirm_blur = window.setTimeout(function () {
            if (m.conf.clear_click == false) {
                m._confirmSelect("blur");
                m.conf.combo_focus = false;
                m.callEvent("onBlur", [])
            }
        }, 20)
    };
    this._doOnInputKeyUp = function (a) {
        a = a || event;
        if (m.conf.f_mode != false) {
            m.conf.clear_bsp = (a.keyCode == 8 || a.keyCode == 46);
            m._filterOpts();
            return
        } else {
            m._checkForMatch()
        }
    };
    this._doOnInputKeyDown = function (a) {
        a = a || event;
        if ((a.keyCode == 38 || a.keyCode == 40) && !a.ctrlKey && !a.shiftKey && !a.altKey) {
            if (a.preventDefault) {
                a.preventDefault()
            } else {
                a.returnValue = false
            }
            a.cancelBubble = true;
            m._keyOnUpDown(a.keyCode == 38 ? -1 : 1)
        }
        if (a.keyCode == 113) {
            if (!m._isListVisible()) {
                m._showList();
                if (m.base.firstChild.value == m.conf.last_text) {
                    m._setSelected(m.conf.last_selected, true, true);
                    m.base.firstChild.value = m.conf.last_text;
                    m.conf.f_server_last = m.base.firstChild.value.toLowerCase()
                } else {
                    m.conf.f_server_last = m.base.firstChild.value.toLowerCase();
                    if (m.conf.f_mode == false) {
                        m._checkForMatch()
                    }
                }
            } else {}
        } if (a.keyCode == 27) {
            if (a.preventDefault) {
                a.preventDefault()
            } else {
                a.returnValue = false
            }
            a.cancelBubble = true;
            m._cancelSelect()
        }
        if (a.keyCode == 13) {
            if (a.preventDefault) {
                a.preventDefault()
            }
            m._confirmSelect("kbd")
        }
        m.conf.clear_key = true;
        m.callEvent("onKeyPressed", [a.keyCode || a.charCode])
    };
    this._doOnInputKeyPress = function (a) {
        if (m.conf.clear_key) {
            m.conf.clear_key = false;
            return
        }
        a = a || event;
        m.callEvent("onKeyPressed", [a.keyCode || a.charCode])
    };
    this._keyOnUpDown = function (a) {
        var q = null;
        if (this.conf.last_hover) {
            q = this.t[this.conf.last_hover].item
        } else {
            if (this.conf.last_selected) {
                q = this.t[this.conf.last_selected].item
            }
        }
        if (!q && this._getListVisibleCount() == 0) {
            return
        }
        if (q != null && q.style.display != "") {
            q = null
        }
        this._showList();
        if (q != null) {
            if (this.t[q._optId].obj.isSelected(q)) {
                q = this._getNearItem(q, a)
            }
        } else {
            q = this.list.firstChild;
            if (q.style.display != "") {
                q = this._getNearItem(q, 1)
            }
        }
        if (q == null) {
            return
        }
        this._setSelected(q._optId, true, true);
        if (this.conf.f_mode == false) {
            this.base.firstChild.value = this.t[q._optId].obj.getText(q, true)
        } else {
            var u = String(this.t[q._optId].obj.getText(q, true));
            if (this.conf.f_mode == "start" && this.conf.f_ac == true) {
                if (u.toLowerCase().indexOf(this.conf.f_server_last) === 0) {
                    this.conf.f_ac_text = u.substring(this.conf.f_server_last.length, u.length);
                    this.base.firstChild.value = u;
                    this._selectRange(this.conf.f_server_last.length, this.base.firstChild.value.length)
                } else {
                    this.base.firstChild.value = u;
                    this.conf.f_server_last = this.base.firstChild.value.toLowerCase();
                    this._selectRange(0, this.base.firstChild.value.length)
                }
            } else {
                this.base.firstChild.value = u;
                this.conf.f_server_last = this.base.firstChild.value.toLowerCase()
            }
        }
        q = null
    };
    this.conf.evs_nodes = [{
        node: document.body,
        evs: {
            mousedown: "_doOnBodyMouseDown"
        }
    }, {
        node: this.base,
        evs: {
            mousedown: "_doOnBaseMouseDown"
        }
    }, {
        node: this.base.firstChild,
        evs: {
            keyup: "_doOnInputKeyUp",
            keydown: "_doOnInputKeyDown",
            keypress: "_doOnInputKeyPress",
            focus: "_doOnInputFocus",
            blur: "_doOnInputBlur"
        }
    }, {
        node: this.list,
        evs: {
            mousemove: "_doOnListMouseMove",
            mousedown: "_doOnListMouseDown",
            mouseup: "_doOnListMouseUp",
            mouseout: "_doOnListMouseOut"
        }
    }];
    for (var c = 0; c < this.conf.evs_nodes.length; c++) {
        for (var o in this.conf.evs_nodes[c].evs) {
            if (window.addEventListener) {
                this.conf.evs_nodes[c].node.addEventListener(o, this[this.conf.evs_nodes[c].evs[o]], false)
            } else {
                this.conf.evs_nodes[c].node.attachEvent("on" + o, this[this.conf.evs_nodes[c].evs[o]])
            }
        }
    }
    this.unload = function () {
        this.clearAll();
        this.t = null;
        for (var v = 0; v < this.conf.evs_nodes.length; v++) {
            for (var u in this.conf.evs_nodes[v].evs) {
                if (window.addEventListener) {
                    this.conf.evs_nodes[v].node.removeEventListener(u, this[this.conf.evs_nodes[v].evs[u]], false)
                } else {
                    this.conf.evs_nodes[v].node.detachEvent("on" + u, this[this.conf.evs_nodes[v].evs[u]])
                }
                this.conf.evs_nodes[v].evs[u] = null;
                delete this.conf.evs_nodes[v].evs[u]
            }
            this.conf.evs_nodes[v].node = null;
            this.conf.evs_nodes[v].evs = null;
            delete this.conf.evs_nodes[v].node;
            delete this.conf.evs_nodes[v].evs;
            this.conf.evs_nodes[v] = null
        }
        window.dhx4._eventable(this, "clear");
        window.dhx4._enableDataLoading(this, null, null, null, "clear");
        this.DOMelem_input = this.DOMelem_button = this.DOMlist = null;
        for (var u in this.conf) {
            this.conf[u] = null;
            delete this.conf[u]
        }
        this.conf = null;
        this.base.parentNode.removeChild(this.base);
        this.list.parentNode.removeChild(this.list);
        this.base = this.list = this.cont = null;
        this.modes = null;
        for (var u in this) {
            if (typeof (this[u]) == "function") {
                this[u] = null
            }
        }
        m = null
    };
    this.DOMelem_input = this.base.firstChild;
    this.DOMelem_button = this.base.childNodes[this.base.childNodes.length - (this.conf.combo_image ? 2 : 1)];
    this.DOMlist = this.list;
    this.DOMelem = this.base;
    this.DOMParent = l;
    l = null;
    if (h != null) {
        if (h.filter != null) {
            if (typeof (h.filter) == "string") {
                this.enableFilteringMode(true, h.filter, window.dhx4.s2b(h.filter_cache), window.dhx4.s2b(h.filter_sub_load))
            } else {
                this.enableFilteringMode(true)
            }
        }
        if (h.image_path != null) {
            this.setImagePath(h.image_path)
        }
        if (h.default_image != null || h.default_image_dis != null) {
            this.setDefaultImage(h.default_image, h.default_image_dis)
        }
        if (h.items || h.options) {
            this.addOption(h.items || h.options)
        }
        if (h.xml || h.json) {
            this.load(h.xml || h.json)
        }
        if (typeof (h.readonly) != "undefined") {
            this.readonly(h.readonly)
        }
        h = null
    }
    return this
}
function dhtmlXComboFromSelect(g) {
    if (typeof (g) == "string") {
        g = document.getElementById(g)
    }
    var c = g.offsetWidth;
    var q = g.getAttribute("name") || null;
    var h = document.createElement("SPAN");
    g.parentNode.insertBefore(h, g);
    var l = g.getAttribute("mode") || g.getAttribute("opt_type") || "option";
    var j = new dhtmlXCombo(h, q, c, l);
    h = null;
    var n = g.getAttribute("imagePath");
    if (n) {
        j.setImagePath(n)
    }
    var o = g.getAttribute("defaultImage");
    var m = g.getAttribute("defaultImageDis");
    if (window.dhx4.s2b(m) == true) {
        m = true
    }
    if (o != null || m != null) {
        j.setDefaultImage(o, m)
    }
    var a = j._xmlToObj([g], true);
    if (a.options.length > 0) {
        j.addOption(a.options)
    }
    a = null;
    g.parentNode.removeChild(g);
    g = null;
    return j
}
dhtmlXCombo.prototype.setName = function (a) {
    this.conf.form_name = a;
    this.base.childNodes[1].name = a;
    this.base.childNodes[2].name = a + "_new_value"
};
dhtmlXCombo.prototype.readonly = function (a) {
    if (window.dhx4.s2b(a)) {
        this.base.firstChild.setAttribute("readOnly", "true")
    } else {
        this.base.firstChild.removeAttribute("readOnly")
    }
};
dhtmlXCombo.prototype.setPlaceholder = function (a) {
    if (typeof (a) == "undefined" || a == null) {
        a = ""
    }
    this.base.firstChild.setAttribute("placeholder", String(a))
};
dhtmlXCombo.prototype.setTemplate = function (g) {
    for (var c in g) {
        if (typeof (this.conf.template[c]) != "undefined") {
            this.conf.template[c] = String(g[c])
        }
    }
    for (var c in this.t) {
        this.t[c].obj.setText(this.t[c].item, this.t[c].item._conf.text)
    }
    this._confirmSelect()
};
dhtmlXCombo.prototype.setSkin = function (a) {
    if (a == this.conf.skin) {
        return
    }
    this.conf.skin = a;
    this.base.className = "dhxcombo_" + this.conf.skin + (this.conf.enabled ? "" : " dhxcombo_disabled");
    this.list.className = "dhxcombolist_" + this.conf.skin
};
dhtmlXCombo.prototype.getInput = function () {
    return this.base.firstChild
};
dhtmlXCombo.prototype.getButton = function () {
    return this.base.childNodes[this.base.childNodes.length - (this.conf.combo_image ? 2 : 1)]
};
dhtmlXCombo.prototype.getList = function () {
    return this.list
};
dhtmlXCombo.prototype.getBase = function () {
    return this.base
};
dhtmlXCombo.prototype.getParent = function () {
    return this.DOMParent
};
dhtmlXCombo.prototype.forEachOption = function (a) {
    for (var c = 0; c < this.list.childNodes.length; c++) {
        a.apply(window, [this._getOption(this.list.childNodes[c]._optId, c)])
    }
};
dhtmlXCombo.prototype.setFocus = function () {
    if (this.conf.enabled) {
        this.base.firstChild.focus()
    }
};
dhtmlXCombo.prototype.setFontSize = function (a, c) {
    if (a != null) {
        this.base.firstChild.style.fontSize = a
    }
    if (c != null) {
        this.list.style.fontSize = c
    }
};
dhtmlXCombo.prototype.getOption = function (j) {
    var l = null;
    var g = null;
    for (var h = 0; h < this.list.childNodes.length; h++) {
        if (l == null) {
            var c = this.list.childNodes[h]._optId;
            if (this.t[c].obj.getValue(this.t[c].item) == j) {
                l = c;
                g = h
            }
        }
    }
    return (l == null ? null : this._getOption(l, g))
};
dhtmlXCombo.prototype.getOptionByIndex = function (a) {
    if (a < 0) {
        return null
    }
    if (this.list.childNodes[a] == null) {
        return null
    }
    return this._getOption(this.list.childNodes[a]._optId, a)
};
dhtmlXCombo.prototype.getOptionByLabel = function (j) {
    var l = null;
    var g = null;
    for (var h = 0; h < this.list.childNodes.length; h++) {
        if (l == null) {
            var c = this.list.childNodes[h]._optId;
            if (this.t[c].obj.getText(this.t[c].item, true) == j) {
                l = c;
                g = h
            }
        }
    }
    return (l == null ? null : this._getOption(l, g))
};
dhtmlXCombo.prototype.getSelectedIndex = function () {
    return this._getOptionProp(this.conf.last_selected, "index", -1)
};
dhtmlXCombo.prototype.getSelectedText = function () {
    return this._getOptionProp(this.conf.last_selected, "text", "")
};
dhtmlXCombo.prototype.getSelectedValue = function () {
    return this._getOptionProp(this.conf.last_selected, "value", null)
};
dhtmlXCombo.prototype.getActualValue = function () {
    return this.base.childNodes[1].value
};
dhtmlXCombo.prototype.getComboText = function () {
    return this.base.childNodes[0].value
};
dhtmlXCombo.prototype.getIndexByValue = function (c) {
    var a = this.getOption(c);
    return (a != null ? a.index : -1)
};
dhtmlXCombo.prototype.setComboText = function (a) {
    this.conf.last_text = this.base.firstChild.value = a;
    this.conf.f_server_last = this.base.firstChild.value.toLowerCase()
};
dhtmlXCombo.prototype.setComboValue = function (c) {
    var a = this.getOption(c);
    if (a != null) {
        this.selectOption(a.index)
    } else {
        this.conf.last_value = c;
        this.base.childNodes[1].value = this.conf.last_value;
        this.base.childNodes[2].value = "true"
    }
};
dhtmlXCombo.prototype.selectOption = function (c, g, a) {
    if (c < 0 || c >= this.list.childNodes.length) {
        return
    }
    var h = this.list.childNodes[c]._optId;
    this._setSelected(h, this._isListVisible(), true);
    this._confirmSelect("script")
};
dhtmlXCombo.prototype.unSelectOption = function () {};
dhtmlXCombo.prototype.confirmValue = function () {
    this._confirmSelect("script")
};
dhtmlXCombo.prototype.enable = function (a) {
    a = (typeof (a) == "undefined" ? true : window.dhx4.s2b(a));
    if (this.conf.enabled == a) {
        return
    }
    this.conf.enabled = a;
    if (a) {
        this.base.className = "dhxcombo_" + this.conf.skin;
        this.base.firstChild.removeAttribute("disabled")
    } else {
        this._hideList();
        this.base.className = "dhxcombo_" + this.conf.skin + " dhxcombo_disabled";
        this.base.firstChild.setAttribute("disabled", "true")
    }
    this._updateTopImage(this.conf.last_selected)
};
dhtmlXCombo.prototype.disable = function (a) {
    a = (typeof (a) == "undefined" ? true : window.dhx4.s2b(a));
    this.enable(!a)
};
dhtmlXCombo.prototype.isEnabled = function () {
    return (this.conf.enabled == true)
};
dhtmlXCombo.prototype.show = function (a) {
    if (typeof (a) == "undefined") {
        a = true
    } else {
        a = window.dhx4.s2b(a)
    }
    this.base.style.display = (a == true ? "" : "none")
};
dhtmlXCombo.prototype.hide = function (a) {
    if (typeof (a) == "undefined") {
        a = true
    }
    this.show(!a)
};
dhtmlXCombo.prototype.isVisible = function () {
    return (this.base.style.display == "")
};
dhtmlXCombo.prototype.enableFilteringMode = function (h, c, a, g) {
    if (h == true || h == "between") {
        this.conf.f_mode = (h == true ? "start" : "between");
        if (c != null) {
            this.conf.f_url = c;
            this.conf.f_cache = window.dhx4.s2b(a);
            this.conf.f_dyn = window.dhx4.s2b(g)
        } else {
            this.conf.f_url = null;
            this.conf.f_cache = false;
            this.conf.f_dyn = false
        }
    } else {
        this.conf.f_mode = false;
        this.conf.f_url = null;
        this.conf.f_cache = false;
        this.conf.f_dyn = false
    }
};
dhtmlXCombo.prototype.filter = function (c) {
    for (var g = 0; g < this.list.childNodes.length; g++) {
        var a = c.apply(window, [this._getOption(this.list.childNodes[g]._optId, g)]);
        this.list.childNodes[g].style.display = (a === true ? "" : "none")
    }
};
dhtmlXCombo.prototype.sort = function (g) {
    var a = [];
    for (var c = 0; c < this.list.childNodes.length; c++) {
        var h = this.list.childNodes[c]._optId;
        a.push([h, this._getOption(h, c)])
    }
    if (g == "asc" || g == "desc") {
        k = true;
        a.sort(function (l, j) {
            l = l[1].text_option.toLowerCase();
            j = j[1].text_option.toLowerCase();
            var m = (g == "asc" ? 1 : -1);
            return (l > j ? m : -1 * m)
        })
    } else {
        if (typeof (g) == "function" || typeof (window[g]) == "function") {
            if (typeof (window[g]) == "function") {
                g = window[g]
            }
            a.sort(function (l, j) {
                return g.apply(window, [l[1], j[1]])
            })
        }
    }
    while (this.list.childNodes.length > 0) {
        this.list.removeChild(this.list.lastChild)
    }
    for (var c = 0; c < a.length; c++) {
        this.list.appendChild(this.t[a[c][0]].item)
    }
};
dhtmlXCombo.prototype.enableAutocomplete = function (a) {
    if (typeof (a) == "undefined") {
        a = true
    } else {
        a = window.dhx4.s2b(a)
    }
    this.conf.f_ac = a
};
dhtmlXCombo.prototype.disableAutocomplete = function (a) {
    if (typeof (a) == "undefined") {
        a = true
    } else {
        a = window.dhx4.s2b(a)
    }
    this.enableAutocomplete(!a)
};
dhtmlXCombo.prototype.allowFreeText = function (a) {
    this.conf.allow_free_text = (typeof (a) == "undefined" ? true : window.dhx4.s2b(a))
};
dhtmlXCombo.prototype._checkForMatch = function (h) {
    var a = window.dhx4.trim(this.base.firstChild.value).toLowerCase();
    var j = null;
    var c = this.list.firstChild;
    while (c != null) {
        if (c.style.display == "" && c._optId != null) {
            var g = window.dhx4.trim(this.t[c._optId].obj.getText(c, true)).toLowerCase();
            if (a == g) {
                j = c._optId;
                c = null
            }
        }
        if (c != null) {
            c = c.nextSibling
        }
    }
    if (this.conf.last_match == null) {
        if (j != null) {
            this._setSelected(j, true, true);
            this.conf.last_match = j
        } else {
            if (this.conf.f_mode != "between" || h == true) {
                this._setSelected(null, true, true);
                this.conf.last_match = null
            }
        }
    } else {
        if (j != null) {
            if (j != this.conf.last_match) {
                this._setSelected(j, true, true);
                this.conf.last_match = j
            }
        } else {
            this._setSelected(null, true, true);
            this.conf.last_match = null
        }
    }
};
dhtmlXCombo.prototype._selectRange = function (c, a) {
    if (this.conf.combo_focus == true) {
        window.dhx4.selectTextRange(this.base.firstChild, c, a)
    }
};
dhtmlXCombo.prototype.openSelect = function () {
    if (!this._isListVisible()) {
        this._showList()
    }
};
dhtmlXCombo.prototype.closeAll = function () {
    this._hideList()
};
dhtmlXCombo.prototype._showList = function (a) {
    if (this._getListVisibleCount() == 0) {
        if (a && this._isListVisible()) {
            this._hideList()
        }
        return
    }
    if (this._isListVisible()) {
        this._checkListHeight();
        return
    }
    this.list.style.zIndex = window.dhx4.zim.reserve(this.conf.list_zi_id);
    this.list.style.visibility = "hidden";
    this.list.style.display = "";
    this.list.style.width = Math.max(this.conf.opts_width || 0, this.conf.combo_width) + "px";
    this.list.style.top = window.dhx4.absTop(this.base) + this.base.offsetHeight - 1 + "px";
    this.list.style.left = window.dhx4.absLeft(this.base) + "px";
    this._checkListHeight();
    this.list.style.visibility = "visible";
    this.callEvent("onOpen", [])
};
dhtmlXCombo.prototype._hideList = function () {
    if (!this._isListVisible()) {
        return
    }
    window.dhx4.zim.clear(this.conf.list_zi_id);
    this.list.style.display = "none";
    this.conf.clear_click = false;
    this.callEvent("onClose", [])
};
dhtmlXCombo.prototype._isListVisible = function () {
    return (this.list.style.display == "")
};
dhtmlXCombo.prototype._getListVisibleCount = function () {
    var a = 0;
    for (var c = 0; c < this.list.childNodes.length; c++) {
        a += (this.list.childNodes[c].style.display == "" ? 1 : 0)
    }
    return a
};
dhtmlXCombo.prototype._checkListHeight = function () {
    if (!this._isListVisible()) {
        return
    }
    if (this.conf.item_h == null) {
        var o = this.list.firstChild;
        while (o != null) {
            if (o.style.display == "") {
                this.conf.item_h = o.offsetHeight;
                o = null
            } else {
                o = o.nextSibling
            }
        }
        o = null
    }
    var q = window.dhx4.screenDim();
    var l = window.dhx4.absTop(this.base);
    var a = this.base.offsetHeight;
    var c = Math.max(0, Math.floor((l - q.top) / this.conf.item_h));
    var n = Math.max(0, Math.floor((q.bottom - (l + a)) / this.conf.item_h));
    var r = this._getListVisibleCount();
    if (n < Math.min(this.conf.opts_count_min, r) && c > n) {
        n = null
    }
    var m = Math.min((n == null ? c : n), this.conf.opts_count, r);
    var g = (m < r ? (m * this.conf.item_h) + "px" : "");
    var j = this.conf.sp[this.conf.skin].list_ofs;
    this.list.style.height = g;
    this.list.style.top = (n == null ? l - this.list.offsetHeight + j : l + a - j) + "px"
};
dhtmlXCombo.prototype._scrollToItem = function (j) {
    var h = this.t[j].item.offsetTop;
    var g = h + this.t[j].item.offsetHeight;
    var c = this.list.scrollTop;
    var a = c + this.list.clientHeight;
    if (h < c) {
        this.list.scrollTop = h
    } else {
        if (g > a) {
            this.list.scrollTop = g - this.list.clientHeight
        }
    }
};
dhtmlXCombo.prototype._setSelected = function (l, j, c) {
    if (c) {
        this._updateTopImage(l)
    }
    if (l != null && this.conf.last_hover == l) {
        if (j) {
            this._scrollToItem(l)
        }
        return
    }
    if (this.conf.last_hover != null) {
        this.t[this.conf.last_hover].obj.setSelected(this.t[this.conf.last_hover].item, false);
        this.conf.last_hover = null;
        if (l == null) {
            this.callEvent("onSelectionChange", [])
        }
    }
    if (l != null) {
        this.t[l].obj.setSelected(this.t[l].item, true);
        this.conf.last_hover = l;
        this.callEvent("onSelectionChange", []);
        if (this.t[l].item == this.t[l].item.parentNode.lastChild && this.conf.f_url != null && this.conf.f_dyn == true && !this.conf.f_dyn_end) {
            var h = "mask=" + encodeURIComponent(this.conf.f_mask) + "&pos=" + this.list.childNodes.length;
            var a = this;
            var g = function (n) {
                    if (a.conf.f_cache) {
                        a.conf.f_cache_data[a.conf.f_mask].data.push(n.xmlDoc.responseXML)
                    }
                    var m = a.list.childNodes.length;
                    a.load(n.xmlDoc.responseXML);
                    if (m == a.list.childNodes.length) {
                        a.conf.f_dyn_end = true;
                        if (a.conf.f_cache) {
                            a.conf.f_cache_data[a.conf.f_mask].dyn_end = true
                        }
                    }
                    g = a = null
                };
            if (window.dhx4.ajax.method == "post") {
                window.dhx4.ajax.post(this.conf.f_url, h, g)
            } else {
                if (window.dhx4.ajax.method == "get") {
                    window.dhx4.ajax.get(this.conf.f_url + (String(this.conf.f_url).indexOf("?") >= 0 ? "&" : "?") + h, g)
                }
            }
        }
        if (j) {
            this._scrollToItem(l)
        }
    }
};
dhtmlXCombo.prototype.addOption = function (l, m, c, a, h) {
    var g = null;
    if (!(l instanceof Array)) {
        var n = this._renderOption({
            value: l,
            text: m,
            css: c,
            img: a
        });
        if (g == null && window.dhx4.s2b(h) == true) {
            g = n
        }
    } else {
        for (var j = 0; j < l.length; j++) {
            if (l[j] instanceof Array) {
                n = this._renderOption({
                    value: l[j][0],
                    text: l[j][1],
                    css: l[j][2],
                    img: l[j][3]
                });
                if (g == null && window.dhx4.s2b(l[j][4]) == true) {
                    g = n
                }
            } else {
                var n = this._renderOption(l[j]);
                if (g == null && window.dhx4.s2b(l[j].selected) == true) {
                    g = n
                }
            }
        }
    }
    if (g != null) {
        this._setSelected(g, this._isListVisible(), true);
        this._confirmSelect("onInit")
    }
};
dhtmlXCombo.prototype.updateOption = function (a, g, c, h) {
    var j = this._getOptionId(a);
    if (j == null) {
        return
    }
    this.t[j].obj.update(this.t[j].item, {
        value: g,
        text: c,
        css: h
    });
    if (this.conf.last_selected == j) {
        this.conf.last_text = this.base.firstChild.value = this.t[j].obj.getText(this.t[j].item, true);
        this.conf.f_server_last = this.base.firstChild.value.toLowerCase()
    }
};
dhtmlXCombo.prototype.deleteOption = function (h) {
    for (var c in this.t) {
        var g = this.t[c].obj.getValue(this.t[c].item);
        if (g == h) {
            this._removeOption(c)
        }
    }
    if (this._isListVisible()) {
        this._showList(true)
    }
};
dhtmlXCombo.prototype.clearAll = function () {
    for (var c in this.t) {
        this._removeOption(c)
    }
    if (this.conf.tm_hover) {
        window.clearTimeout(this.conf.tm_hover)
    }
    this.conf.last_hover = null;
    this.conf.last_selected = null;
    this.list.scrollTop = 0;
    this._hideList()
};
dhtmlXCombo.prototype._renderOption = function (c) {
    var g = window.dhx4.newId();
    var a = document.createElement("DIV");
    a._optId = g;
    a._tpl = this.conf.template;
    if (typeof (c.img) == "undefined" && typeof (c.img_src) != "undefined") {
        c.img = c.img_src;
        delete c.img_src
    }
    if (typeof (c.img_dis) == "undefined" && typeof (c.img_src_dis) != "undefined") {
        c.img_dis = c.img_src_dis;
        delete c.img_src_dis
    }
    c.img_path = this.conf.img_path;
    c.img_def = this.conf.img_def;
    c.img_def_dis = this.conf.img_def_dis;
    this.list.appendChild(a);
    this.t[a._optId] = {
        obj: this.modes[this.conf.opts_type].render(a, c),
        item: a,
        conf: {
            type: this.conf.opts_type
        }
    };
    a = null;
    return g
};
dhtmlXCombo.prototype._removeOption = function (a) {
    this.t[a].obj.destruct(this.t[a].item);
    this.t[a].obj = null;
    this.t[a].item.parentNode.removeChild(this.t[a].item);
    this.t[a].item = null;
    this.t[a].conf = null;
    this.t[a] = null;
    delete this.t[a];
    if (this.conf.last_hover == a) {
        this.conf.last_hover = null
    }
    if (this.conf.last_selected == a) {
        this.conf.last_selected = null;
        this._confirmSelect("onDelete")
    }
};
dhtmlXCombo.prototype._confirmSelect = function (c) {
    var a = false;
    if (this.conf.f_server_tm) {
        window.clearTimeout(this.conf.f_server_tm)
    }
    if (this.conf.last_hover != null) {
        a = a || (this.conf.last_value != this._getOptionValue(this.conf.last_hover));
        this.conf.last_match = this.conf.last_selected = this.conf.last_hover;
        this.conf.last_value = this._getOptionValue(this.conf.last_selected);
        this.conf.last_text = this.base.firstChild.value = this.t[this.conf.last_selected].obj.getText(this.t[this.conf.last_selected].item, true);
        this.conf.f_server_last = this.base.firstChild.value.toLowerCase();
        this.base.childNodes[1].value = this.conf.last_value;
        this.base.childNodes[2].value = "false"
    } else {
        if (this.conf.allow_free_text || (this.base.firstChild.value == "" && this.conf.allow_empty_value)) {
            a = a || (this.conf.last_text != this.base.firstChild.value);
            this.conf.last_match = this.conf.last_value = this.conf.last_selected = null;
            this.conf.last_text = this.base.firstChild.value;
            this.conf.f_server_last = this.base.firstChild.value.toLowerCase();
            this.base.childNodes[1].value = this.conf.last_text;
            this.base.childNodes[2].value = "true"
        } else {
            this._cancelSelect();
            this._updateTopImage(this.conf.last_selected);
            return
        }
    }
    if (this.conf.f_ac && this.conf.f_mode == "start") {
        this.conf.f_ac_text = "";
        if (c != "blur") {
            this._selectRange(this.base.firstChild.value.length, this.base.firstChild.value.length)
        }
    }
    this._hideList();
    if (a == true && c != "onInit" && c != "onDelete") {
        this.callEvent("onChange", [this.conf.last_value, this.conf.last_text])
    }
};
dhtmlXCombo.prototype._cancelSelect = function () {
    this._hideList();
    this.base.firstChild.value = this.conf.last_text;
    if (this.conf.f_mode != false) {
        this._filterOpts(true)
    }
};
dhtmlXCombo.prototype._getOption = function (m, h) {
    if (!this.t[m]) {
        return null
    }
    if (typeof (h) == "undefined") {
        h = -1
    }
    if (h < 0) {
        for (var l = 0; l < this.list.childNodes.length; l++) {
            if (h < 0 && this.list.childNodes[l]._optId == m) {
                h = l
            }
        }
    }
    var j = {
        value: this.t[m].obj.getValue(this.t[m].item),
        text: this.t[m].obj.getText(this.t[m].item),
        text_input: this.t[m].obj.getText(this.t[m].item, true),
        text_option: this.t[m].obj.getText(this.t[m].item, null, true),
        css: this.t[m].obj.getCss(this.t[m].item),
        selected: (m == this.conf.last_selected),
        index: h
    };
    if (typeof (this.t[m].obj.getExtraData) == "function") {
        var g = this.t[m].obj.getExtraData(this.t[m].item);
        for (var c in g) {
            if (typeof (j[c]) == "undefined") {
                j[c] = g[c]
            }
        }
    }
    return j
};
dhtmlXCombo.prototype._getOptionProp = function (h, g, c) {
    if (h != null) {
        var a = this._getOption(h);
        if (a != null) {
            return a[g]
        }
    }
    return c
};
dhtmlXCombo.prototype._getOptionId = function (c) {
    var h = null;
    for (var a = 0; a < this.list.childNodes.length; a++) {
        if (h == null) {
            var g = this.list.childNodes[a]._optId;
            if (c == this.t[g].obj.getValue(this.t[g].item)) {
                h = g
            }
        }
    }
    return h
};
dhtmlXCombo.prototype._getOptionValue = function (a) {
    return this._getOptionProp(a, "value", null)
};
dhtmlXCombo.prototype.setSize = function (a) {
    this.conf.combo_width = parseInt(a);
    this.base.style.width = this.conf.combo_width + "px";
    this.base.firstChild.style.width = (this.conf.combo_width - 24 - (this.conf.combo_image ? 23 : 0)) + "px";
    this.base.firstChild.style.marginLeft = (this.conf.combo_image ? "23px" : "0px")
};
dhtmlXCombo.prototype.setOptionWidth = function (a) {
    this.conf.opts_width = (parseInt(a) || null)
};
dhtmlXCombo.prototype.modes = {};
dhtmlXCombo.prototype.doWithItem = function (a, m, j, g) {
    var l = (a >= 0 && a < this.list.childNodes.length ? this.list.childNodes[a]._optId : null);
    if (l == null) {
        return null
    }
    if (typeof (this.t[l].obj[m]) != "function") {
        return null
    }
    var h = [this.t[l].item];
    for (var c = 2; c < arguments.length; c++) {
        h.push(arguments[c])
    }
    return this.t[l].obj[m].apply(this.t[l].obj, h)
};

function dhtmlXComboExtend(h, g) {
    for (var c in dhtmlXCombo.prototype.modes[g]) {
        if (typeof (dhtmlXCombo.prototype.modes[h][c]) == "undefined") {
            dhtmlXCombo.prototype.modes[h][c] = dhtmlXCombo.prototype.modes[g][c]
        }
    }
}
dhtmlXCombo.prototype.modes.option = {
    image: false,
    option_css: "dhxcombo_option_text",
    render: function (a, c) {
        a._conf = {
            value: c.value,
            css: ""
        };
        a.className = "dhxcombo_option";
        a.innerHTML = "<div class='" + this.option_css + "'>&nbsp;</div>";
        if (c.css != null) {
            a.lastChild.style.cssText = c.css;
            a._conf.css = c.css
        }
        this.setText(a, c.text);
        return this
    },
    destruct: function (a) {
        a._conf = null
    },
    update: function (a, c) {
        a._conf.value = c.value;
        a._conf.css = c.css;
        a.lastChild.style.cssText = c.css;
        this.setText(a, c.text)
    },
    setText: function (c, g) {
        c._conf.text = g;
        var a = (typeof (g) == "object" ? window.dhx4.template(c._tpl.option, c._conf.text, true) : window.dhx4.trim(c._conf.text || ""));
        c.lastChild.innerHTML = (a.length == 0 ? "&nbsp;" : a)
    },
    getText: function (g, a, c) {
        if (window.dhx4.s2b(a) && typeof (g._conf.text) == "object") {
            return window.dhx4.template(g._tpl.input, g._conf.text, true)
        }
        if (window.dhx4.s2b(c) && typeof (g._conf.text) == "object") {
            return window.dhx4.template(g._tpl.option, g._conf.text, true)
        }
        return g._conf.text
    },
    getValue: function (a) {
        return a._conf.value
    },
    getCss: function (a) {
        return a._conf.css
    },
    setSelected: function (a, c) {
        a.className = "dhxcombo_option" + (c ? " dhxcombo_option_selected" : "")
    },
    isSelected: function (a) {
        return String(a.className).indexOf("dhxcombo_option_selected") >= 0
    },
    getExtraData: function (a) {
        return {
            type: "option"
        }
    }
};
dhtmlXCombo.prototype.modes.checkbox = {
    image: true,
    image_css: "dhxcombo_checkbox dhxcombo_chbx_#state#",
    option_css: "dhxcombo_option_text dhxcombo_option_text_chbx",
    render: function (a, c) {
        a._conf = {
            value: c.value,
            css: "",
            checked: window.dhx4.s2b(c.checked)
        };
        a.className = "dhxcombo_option";
        a.innerHTML = "<div class='" + String(this.image_css).replace("#state#", (a._conf.checked ? "1" : "0")) + "'></div><div class='" + this.option_css + "'>&nbsp;</div>";
        a.firstChild._optChbxId = a._optId;
        if (c.css != null) {
            a.lastChild.style.cssText += c.css;
            a._conf.css = c.css
        }
        this.setText(a, c.text);
        return this
    },
    setChecked: function (a, c) {
        a._conf.checked = window.dhx4.s2b(c);
        a.firstChild.className = String(this.image_css).replace("#state#", (a._conf.checked ? "1" : "0"))
    },
    isChecked: function (a) {
        return (a._conf.checked == true)
    },
    getExtraData: function (a) {
        return {
            type: "checkbox",
            checked: a._conf.checked
        }
    },
    optionClick: function (h, g, j) {
        var c = true;
        var a = (g.target || g.srcElement);
        while (c == true && a != null && a != h) {
            if (a._optChbxId != null) {
                if (j.callEvent("onCheck", [h._conf.value, !h._conf.checked]) === true) {
                    this.setChecked(h, !this.isChecked(h))
                }
                c = false
            } else {
                a = a.parentNode
            }
        }
        a = j = h = null;
        return c
    },
    getTopImage: function (c, a) {
        return ""
    },
    topImageClick: function (a, c) {
        return true
    }
};
dhtmlXComboExtend("checkbox", "option");
dhtmlXCombo.prototype.setChecked = function (a, c) {
    this.doWithItem(a, "setChecked", c)
};
dhtmlXCombo.prototype.getChecked = function (a, h) {
    var c = [];
    for (var g = 0; g < this.list.childNodes.length; g++) {
        if (this.isChecked(g)) {
            c.push(this._getOptionProp(this.list.childNodes[g]._optId, "value", ""))
        }
    }
    return c
};
dhtmlXCombo.prototype.isChecked = function (a) {
    return this.doWithItem(a, "isChecked")
};
dhtmlXCombo.prototype.modes.image = {
    image: true,
    image_css: "dhxcombo_image",
    option_css: "dhxcombo_option_text dhxcombo_option_text_image",
    render: function (a, c) {
        a._conf = {
            value: c.value,
            css: ""
        };
        a.className = "dhxcombo_option";
        a.innerHTML = "<div class='" + this.image_css + "'></div><div class='" + this.option_css + "'>&nbsp;</div>";
        if (c.css != null) {
            a.lastChild.style.cssText += c.css;
            a._conf.css = c.css
        }
        this.setText(a, c.text);
        this.setImage(a, c.img, c.img_dis, c.img_path, c.img_def, c.img_def_dis);
        return this
    },
    update: function (a, c) {
        a._conf.value = c.value;
        a._conf.css = c.css;
        a.lastChild.style.cssText = c.css;
        this.setText(a, c.text);
        this.setImage(a, c.img, c.img_dis, c.img_path, c.img_def, c.img_def_dis)
    },
    setImage: function (g, a, j, l, h, c) {
        if (a != null && a.length > 0) {
            a = l + a
        } else {
            if (h != null && h.length > 0) {
                a = l + h
            } else {
                a = null
            }
        }
        if (j != null && j.length > 0) {
            j = l + j
        } else {
            if (c != null && c.length > 0) {
                j = l + c
            } else {
                if (c == true) {
                    j = a
                } else {
                    j = null
                }
            }
        }
        g._conf.img = a;
        g._conf.img_dis = j;
        g.firstChild.style.backgroundImage = (a != null ? "url(" + a + ")" : "none")
    },
    getExtraData: function (a) {
        return {
            type: "image"
        }
    },
    getTopImage: function (h, g) {
        var c = (g ? "img" : "img_dis");
        if (h != null && h._conf[c] != null) {
            return "<div class='" + this.image_css + "' style='background-image:url(" + h._conf[c] + ");'></div>"
        }
        return ""
    }
};
dhtmlXComboExtend("image", "option");
dhtmlXCombo.prototype.setDefaultImage = function (a, c) {
    if (a != null) {
        this.conf.img_def = a
    }
    if (c != null) {
        this.conf.img_def_dis = c
    }
};
dhtmlXCombo.prototype.setImagePath = function (a) {
    this.conf.img_path = a
};

function dhtmlXColorPicker(n) {
    if (!(this instanceof dhtmlXColorPicker)) {
        return new dhtmlXColorPicker(n)
    }
    dhx4._eventable(this);
    var j = this,
        h = undefined,
        m = null,
        g, a, c;
    this._nodes = [];
    this.activeNode = null;
    this._inputListenerId = null;
    this.base = null;
    this._globalNode = null;
    this.memory = null;
    this.skin = null;
    this.conf = {
        cp_id: dhx4.newId(),
        x: 0,
        y: 0,
        c: 0,
        indent: 2,
        position: "right",
        customColors: false,
        selectedColor: null,
        hide: false,
        hideOnSelect: false,
        lang: "en",
        closeable: true
    };
    this.value = {
        red: null,
        blue: null,
        green: null,
        hue: null,
        sat: null,
        lum: null
    };
    this._initMoveSelection = function (l) {
        l = l || event;
        if (typeof (window.addEventListener) == "function") {
            j._controllerNodes.colorArea.addEventListener("mousemove", j._setMoveSelection, false);
            document.body.addEventListener("mouseup", j._cleanMoveSelection, false)
        } else {
            j._controllerNodes.colorArea.attachEvent("onmousemove", j._setMoveSelection);
            document.body.attachEvent("onmouseup", j._cleanMoveSelection)
        }
        j._setMoveSelection(l, j._controllerNodes.colorArea);
        return false
    };
    this._cleanMoveSelection = function () {
        if (typeof (window.removeEventListener) == "function") {
            j._controllerNodes.colorArea.removeEventListener("mousemove", j._setMoveSelection, false);
            document.body.removeEventListener("mouseup", j._cleanMoveSelection, false)
        } else {
            j._controllerNodes.colorArea.detachEvent("onmousemove", j._setMoveSelection);
            document.body.detachEvent("onmouseup", j._cleanMoveSelection)
        }
        return false
    };
    this._setMoveSelection = function (l) {
        l = l || event;
        var o = j._getOffsetPosition(l, j._controllerNodes.colorArea);
        if (j._controllerNodes.fr_cover) {
            setTimeout(function () {
                j._setColorAreaXY(o.x, o.y);
                j._setColorByXYC()
            }, 0)
        } else {
            j._setColorAreaXY(o.x, o.y);
            j._setColorByXYC()
        }
        return false
    };
    this._initMoveContrast = function (l) {
        l = l || event;
        if (typeof (window.addEventListener) == "function") {
            document.body.addEventListener("mousemove", j._setMoveContrast, false);
            document.body.addEventListener("mouseup", j._cleanMoveContrast, false)
        } else {
            document.body.attachEvent("onmousemove", j._setMoveContrast);
            document.body.attachEvent("onmouseup", j._cleanMoveContrast)
        }
        j._setMoveContrast(l, j._controllerNodes.contrastArea)
    };
    this._cleanMoveContrast = function () {
        if (typeof (window.removeEventListener) == "function") {
            document.body.removeEventListener("mousemove", j._setMoveContrast, false);
            document.body.removeEventListener("mouseup", j._cleanMoveContrast, false)
        } else {
            document.body.detachEvent("onmousemove", j._setMoveContrast);
            document.body.detachEvent("onmouseup", j._cleanMoveContrast)
        }
    };
    this._setMoveContrast = function (l) {
        l = l || event;
        var o = j._getOffsetPosition(l, j._controllerNodes.contrastArea);
        j._setContrastY(o.y);
        j._setColorByXYC(true)
    };
    this._doOnSelectColor = function () {
        var l = j.colorAIP.rgb2hex({
            r: j.value.red,
            g: j.value.green,
            b: j.value.blue
        });
        if (j.activeNode != null) {
            if (j.activeNode.valueCont) {
                j.activeNode.valueCont.value = l
            }
            if (j.activeNode.valueColor) {
                j.activeNode.valueColor.style.backgroundColor = l
            }
        }
        if (j.base._dhx_remove || j.conf.hideOnSelect) {
            j.hide()
        }
        j.callEvent("onSelect", [l, ((j.activeNode) ? j.activeNode.node : null)])
    };
    this._doOnCancel = function () {
        if (j.callEvent("onCancel", [((j.activeNode) ? j.activeNode.node : null)]) == true && j.conf.closeable == true) {
            j.hide()
        }
    };
    this._doOnFocusByInput = function () {
        var o = (this != window) ? this : event.srcElement;
        var l = (j.activeNode && j.activeNode.valueCont && j.activeNode.valueCont == o) ? j.activeNode : j._getNodeByValueCont(o);
        j.activeNode = l;
        if (l && l == j.activeNode) {
            j._initListenerInput()
        }
    };
    this._doOnBlurByInput = function () {
        var o = (this != window) ? this : event.srcElement;
        var l = (j.activeNode && j.activeNode.valueCont && j.activeNode.valueCont == o) ? j.activeNode : j._getNodeByValueCont(o);
        if (l && l == j.activeNode) {
            j._removeListenerInput()
        }
    };
    this._doOnClickByNode = function (o) {
        o = o || event;
        var l = (this != window) ? this : event.srcElement;
        j.activeNode = (j.activeNode.node != l) ? j._getNodeByElement(l) : j.activeNode;
        if (!j.isVisible()) {
            j.show()
        }
    };
    this.saveColor = function () {
        j.memory.setValue(j.value)
    };
    this._onSelectMemoryEl = function (o) {
        var l;
        j._refreshCoordinatesByHSL(o.value.hue, o.value.sat, o.value.lum);
        for (l in o.value) {
            j.value[l] = o.value[l]
        }
        j._refreshContrast();
        j._refreshInputValues();
        j._refreshColorValue()
    };
    this._doOnClickByBody = function (q) {
        q = q || event;
        var l = true,
            o = q.target || q.srcElement;
        if (j._isBaseNode(o)) {
            l = false
        }
        if (l && j.activeNode && (j.activeNode.node == o || j.activeNode.valueCont == o)) {
            l = false
        }
        if (l) {
            j.hide()
        }
    };
    this._doOnChangeHSL = function () {
        var q = parseInt(j._controllerNodes.hue.value),
            o = parseInt(j._controllerNodes.sat.value),
            l = parseInt(j._controllerNodes.lum.value),
            r;
        if (isNaN(q) || q > 359 || q < 0) {
            j._controllerNodes.hue.value = j.value.hue
        } else {
            j.value.hue = q
        }
        if (isNaN(o) || o > 100 || o < 0) {
            j._controllerNodes.sat.value = j.value.sat
        } else {
            j.value.sat = o
        }
        if (isNaN(l) || l > 100 || l < 0) {
            j._controllerNodes.lum.value = j.value.lum
        } else {
            j.value.lum = l
        }
        r = j.colorAIP.hsl2rgb(j.value.hue, j.value.sat / 100, j.value.lum / 100);
        j.value.red = Math.round(255 * r.r);
        j.value.green = Math.round(255 * r.g);
        j.value.blue = Math.round(255 * r.b);
        j._refreshCoordinatesByHSL(j.value.hue, j.value.sat, j.value.lum);
        j._refreshContrast();
        j._refreshInputValues();
        j._refreshColorValue()
    };
    this._doOnChangeRGB = function () {
        var r = parseInt(j._controllerNodes.red.value),
            q = parseInt(j._controllerNodes.green.value),
            l = parseInt(j._controllerNodes.blue.value),
            o;
        if (isNaN(r) || r > 255 || r < 0) {
            j._controllerNodes.red.value = j.value.red
        } else {
            j.value.red = r
        }
        if (isNaN(q) || q > 255 || q < 0) {
            j._controllerNodes.green.value = j.value.green
        } else {
            j.value.green = q
        }
        if (isNaN(l) || l > 255 || l < 0) {
            j._controllerNodes.blue.value = j.value.blue
        } else {
            j.value.blue = l
        }
        o = j.colorAIP.rgb2hsl(j.value.red / 255, j.value.green / 255, j.value.blue / 255);
        j.value.hue = Math.round(o.h);
        j.value.sat = Math.round(o.s * 100);
        j.value.lum = Math.round(o.l * 100);
        j._refreshCoordinatesByHSL(j.value.hue, j.value.sat, j.value.lum);
        j._refreshContrast();
        j._refreshInputValues();
        j._refreshColorValue()
    };
    this._doOnChangeHSV = function () {
        j._controllerNodes.hsv.value = j.setColor(j._controllerNodes.hsv.value)
    };
    this._checkType = function (o) {
        var l;
        if (o instanceof Array) {
            l = j._checkType(o[0]);
            switch (l) {
            case "string":
                return "array_string";
                break;
            case "input":
            case "textarea":
                return "array_input";
                break;
            case "object":
                return "array_object";
                break;
            default:
                return undefined
            }
        } else {
            if (o == undefined) {
                return null
            } else {
                if (typeof (o) == "string") {
                    return "string"
                } else {
                    if (o.tagName && o.tagName.toLowerCase() == "input") {
                        return "input"
                    } else {
                        if (o.tagName && o.tagName.toLowerCase() == "textarea") {
                            return "textarea"
                        } else {
                            if (o.tagName) {
                                return "container"
                            } else {
                                if (typeof (o) == "object") {
                                    return "object"
                                } else {
                                    return undefined
                                }
                            }
                        }
                    }
                }
            }
        }
    };
    this._initByObject = function (l) {
        if (l.parent && l.parent.tagName) {
            j.base = l.parent
        } else {
            if (typeof (l.parent) == "string") {
                j.base = document.getElementById(l.parent)
            } else {
                j.base = document.createElement("div");
                j.base._dhx_remove = true
            }
        }
        if (l.color) {
            j.conf.selectedColor = l.color
        }
        if (typeof (l.closeable) != "undefined") {
            this.conf.closeable = dhx4.s2b(l.closeable)
        }
        if (l.custom_colors) {
            this._tempInitCC = function () {
                var r, q;
                this.initMemoryColors();
                this.conf.customColors = true;
                if (l.custom_colors instanceof Array) {
                    q = l.custom_colors.length;
                    for (r = 0; r < q; r++) {
                        this.setCustomColors(l.custom_colors[r])
                    }
                }
                if (this.base.parentNode) {
                    this.showMemory()
                }
                delete this._tempInitCC
            }
        }
        if (l.hide) {
            j.conf.hide = true
        }
        if (l.input) {
            j._addNode(l.input, l.target_color, l.target_value)
        }
        var o = l.skin || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxcolorpicker") || "dhx_skyblue";
        j.setSkin(o);
        if (l.colors) {
            j.initMemoryColors();
            j.conf.customColors = true
        }
        if (l.link) {
            j._addNode(l.link)
        }
    };
    this.unload = function () {
        var r, o, q;
        if (this.isVisible()) {
            this.hide()
        }
        this.destructMemory();
        o = this._nodes.length;
        for (r = 0; r < o; r++) {
            this._detachEventsFromNode(this._nodes[r]);
            for (q in this._nodes[r]) {
                this._nodes[r][q] = null
            }
            delete this._nodes[r]
        }
        this._nodes = null;
        if (!this.base._dhx_remove) {
            this.base.className = this.base.className.replace(/\s?dhtmlxcp_\S*/, "")
        } else {
            delete this.base._dhx_remove
        }
        if (typeof (window.addEventListener) == "function") {
            this._controllerNodes.colorArea.removeEventListener("mousedown", this._initMoveSelection, false);
            this._controllerNodes.colorArea.removeEventListener("dblclick", this._doOnSelectColor, false);
            this._controllerNodes.contrastArea.removeEventListener("mousedown", this._initMoveContrast, false);
            this._controllerNodes.button_save.removeEventListener("click", this._doOnSelectColor, false);
            this._controllerNodes.button_cancel.removeEventListener("click", this._doOnCancel, false);
            this._controllerNodes.hue.removeEventListener("change", this._doOnChangeHSL, false);
            this._controllerNodes.sat.removeEventListener("change", this._doOnChangeHSL, false);
            this._controllerNodes.lum.removeEventListener("change", this._doOnChangeHSL, false);
            this._controllerNodes.red.removeEventListener("change", this._doOnChangeRGB, false);
            this._controllerNodes.green.removeEventListener("change", this._doOnChangeRGB, false);
            this._controllerNodes.blue.removeEventListener("change", this._doOnChangeRGB, false);
            this._controllerNodes.hsv.removeEventListener("change", this._doOnChangeHSV, false)
        } else {
            this._controllerNodes.colorArea.detachEvent("onmousedown", this._initMoveSelection);
            this._controllerNodes.colorArea.detachEvent("ondblclick", this._doOnSelectColor);
            this._controllerNodes.contrastArea.detachEvent("onmousedown", this._initMoveContrast);
            this._controllerNodes.button_save.detachEvent("onclick", this._doOnSelectColor);
            this._controllerNodes.button_cancel.detachEvent("onclick", this._doOnCancel);
            this._controllerNodes.hue.detachEvent("onchange", this._doOnChangeHSL);
            this._controllerNodes.sat.detachEvent("onchange", this._doOnChangeHSL);
            this._controllerNodes.lum.detachEvent("onchange", this._doOnChangeHSL);
            this._controllerNodes.red.detachEvent("onchange", this._doOnChangeRGB);
            this._controllerNodes.green.detachEvent("onchange", this._doOnChangeRGB);
            this._controllerNodes.blue.detachEvent("onchange", this._doOnChangeRGB);
            this._controllerNodes.hsv.detachEvent("onchange", this._doOnChangeHSV)
        }
        if (this._controllerNodes.fr_cover) {
            if (this._controllerNodes.fr_cover.parentNode) {
                this._controllerNodes.fr_cover.parentNode.removeChild(this._controllerNodes.fr_cover)
            }
            delete this._controllerNodes.fr_cover
        }
        dhx4.zim.clear(this.conf.cp_id);
        dhx4._eventable(this, "clear");
        for (q in this) {
            this[q] = null
        }
        j = null, m = null, c = null
    };
    h = this._checkType(n);
    switch (h) {
    case "object":
        j._initByObject(n);
        break;
    case "input":
    case "textarea":
        j._initByObject({});
        this._addNode(n);
        break;
    case "string":
        m = document.getElementById(n);
        return new dhtmlXColorPicker(m);
        break;
    case "container":
        j._initByObject({
            parent: n
        });
        break;
    case null:
        j._initByObject({});
        break;
    case "array_string":
    case "array_input":
        j._initByObject({});
        a = n.length;
        for (g = 0; g < a; g++) {
            this._addNode(n[g])
        }
        break;
    case "array_object":
        j._initByObject({});
        a = n.length;
        for (g = 0; g < a; g++) {
            c = this._addNode(n[g].input, n[g].target_color, n[g].target_value).conf;
            c.customColors = (n[g].custom_colors != undefined) ? dhx4.s2b(n[g].custom_colors) : c.customColors;
            c.selectedColor = (n[g].color != undefined) ? n[g].color : c.selectedColor
        }
        break
    }
    this.base.innerHTML = "<div class='dhxcp_g_area'><div class='dhxcp_sub_area'><div class='dhxcp_g_color_area'><div class='dhxcp_color_selector'><div class='dhxcp_v_line'></div><div class='dhxcp_h_line'></div></div><div class='dhxcp_contrast_area'><div class='dhxcp_h_line'></div></div></div><div class='dhxcp_g_input_area'><div class='dhxcp_value_cont'><div class='dhxcp_value_color'></div><input type='text' class='dhxcp_value'/></div><table class='dhxcp_inputs_cont' cellpadding='0' cellspacing='0' border='0'><tr><td class='dhxcp_label_hsl'>" + this.i18n[this.conf.lang].labelHue + "</td><td class='dhxcp_input_hsl'><input type='text' class='dhxcp_input_hsl'/></td><td class='dhxcp_label_rgb'>" + this.i18n[this.conf.lang].labelRed + "</td><td class='dhxcp_input_rgb'><input type='text' class='dhxcp_input_rgb'/></td></tr><tr><td class='dhxcp_label_hsl'>" + this.i18n[this.conf.lang].labelSat + "</td><td class='dhxcp_input_hsl'><input type='text' class='dhxcp_input_hsl'/></td><td class='dhxcp_label_rgb'>" + this.i18n[this.conf.lang].labelGreen + "</td><td class='dhxcp_input_rgb'><input type='text' class='dhxcp_input_rgb'/></td></tr><tr><td class='dhxcp_label_hsl'>" + this.i18n[this.conf.lang].labelLum + "</td><td class='dhxcp_input_hsl'><input type='text' class='dhxcp_input_hsl'/></td><td class='dhxcp_label_rgb'>" + this.i18n[this.conf.lang].labelBlue + "</td><td class='dhxcp_input_rgb'><input type='text' class='dhxcp_input_rgb'/></td></tr></table></div><div class='dhxcp_g_memory_area'></div><div class='dhxcp_buttons_area'><button class='dhx_button_save'>" + this.i18n[this.conf.lang].btnSelect + "</button><button class='dhx_button_cancel'>" + this.i18n[this.conf.lang].btnCancel + "</button></div></div>";
    "</div>";
    this._globalNode = this.base.firstChild;
    this._controllerNodes = {
        colorArea: this._globalNode.firstChild.firstChild.firstChild,
        v_line: this._globalNode.firstChild.firstChild.firstChild.childNodes[0],
        h_line: this._globalNode.firstChild.firstChild.firstChild.childNodes[1],
        contrastArea: this._globalNode.firstChild.firstChild.childNodes[1],
        contrast_line: this._globalNode.firstChild.firstChild.childNodes[1].firstChild,
        color: this._globalNode.firstChild.childNodes[1].childNodes[0].firstChild,
        hsv: this._globalNode.firstChild.childNodes[1].childNodes[0].childNodes[1],
        hue: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[0].childNodes[1].firstChild,
        sat: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[1].childNodes[1].firstChild,
        lum: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[2].childNodes[1].firstChild,
        red: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[0].childNodes[3].firstChild,
        green: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[1].childNodes[3].firstChild,
        blue: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[2].childNodes[3].firstChild,
        memory_block: this._globalNode.firstChild.childNodes[2],
        button_save: this._globalNode.firstChild.childNodes[3].firstChild,
        button_cancel: this._globalNode.firstChild.childNodes[3].childNodes[1]
    };
    this._labelNodes = {
        labelHue: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[0].firstChild,
        labelSat: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[1].firstChild,
        labelLum: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[2].firstChild,
        labelRed: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[0].childNodes[2],
        labelGreen: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[1].childNodes[2],
        labelBlue: this._globalNode.firstChild.childNodes[1].childNodes[1].firstChild.childNodes[2].childNodes[2],
        btnAddColor: null,
        btnSelect: this._globalNode.firstChild.childNodes[3].firstChild,
        btnCancel: this._globalNode.firstChild.childNodes[3].childNodes[1]
    };
    if (typeof (this._tempInitCC) == "function") {
        this._tempInitCC()
    }
    if (typeof (window.addEventListener) == "function") {
        this._controllerNodes.colorArea.addEventListener("mousedown", this._initMoveSelection, false);
        this._controllerNodes.colorArea.addEventListener("dblclick", this._doOnSelectColor, false);
        this._controllerNodes.contrastArea.addEventListener("mousedown", this._initMoveContrast, false);
        this._controllerNodes.button_save.addEventListener("click", this._doOnSelectColor, false);
        this._controllerNodes.button_cancel.addEventListener("click", this._doOnCancel, false);
        this._controllerNodes.hue.addEventListener("change", this._doOnChangeHSL, false);
        this._controllerNodes.sat.addEventListener("change", this._doOnChangeHSL, false);
        this._controllerNodes.lum.addEventListener("change", this._doOnChangeHSL, false);
        this._controllerNodes.red.addEventListener("change", this._doOnChangeRGB, false);
        this._controllerNodes.green.addEventListener("change", this._doOnChangeRGB, false);
        this._controllerNodes.blue.addEventListener("change", this._doOnChangeRGB, false);
        this._controllerNodes.hsv.addEventListener("change", this._doOnChangeHSV, false)
    } else {
        this._controllerNodes.colorArea.attachEvent("onmousedown", this._initMoveSelection);
        this._controllerNodes.colorArea.attachEvent("ondblclick", this._doOnSelectColor);
        this._controllerNodes.contrastArea.attachEvent("onmousedown", this._initMoveContrast);
        this._controllerNodes.button_save.attachEvent("onclick", this._doOnSelectColor);
        this._controllerNodes.button_cancel.attachEvent("onclick", this._doOnCancel);
        this._controllerNodes.hue.attachEvent("onchange", this._doOnChangeHSL);
        this._controllerNodes.sat.attachEvent("onchange", this._doOnChangeHSL);
        this._controllerNodes.lum.attachEvent("onchange", this._doOnChangeHSL);
        this._controllerNodes.red.attachEvent("onchange", this._doOnChangeRGB);
        this._controllerNodes.green.attachEvent("onchange", this._doOnChangeRGB);
        this._controllerNodes.blue.attachEvent("onchange", this._doOnChangeRGB);
        this._controllerNodes.hsv.attachEvent("onchange", this._doOnChangeHSV)
    }
    if (this.conf.selectedColor) {
        this.setColor(this.conf.selectedColor)
    } else {
        this._setColorAreaXY(10, 10);
        this._setContrastY(10);
        j._setColorByXYC()
    }
    if (this._nodes.length) {
        for (var g = 0; g < this._nodes.length; g++) {
            this._attachEventsToNode(this._nodes[g])
        }
    }
    if (this.conf.hide) {
        this.hide()
    }
    if (typeof (this._cpInitFRM) == "function") {
        this._cpInitFRM()
    }
}
dhtmlXColorPicker.prototype.linkTo = function (c, g, h) {
    if (arguments.length == 1) {
        g = h = c
    }
    var a;
    c = c || null;
    h = h || null;
    if (typeof (g) == "string") {
        g = document.getElementById(g)
    }
    a = this._addNode(g, c, h);
    if (a) {
        this._attachEventsToNode(a)
    }
    return a
};
dhtmlXColorPicker.prototype._isBaseNode = function (a) {
    if (a == this.base) {
        return true
    }
    if (a.parentElement == document.body) {
        return false
    } else {
        if (!a.parentElement) {
            return false
        } else {
            return this._isBaseNode(a.parentElement)
        }
    }
};
dhtmlXColorPicker.prototype._hasInput = function (g) {
    var c, a, h = false;
    a = this._nodes.length;
    for (c = 0; c < a; c++) {
        if (this._nodes[c].valueCont == g) {
            h = true;
            break
        }
    }
    return h
};
dhtmlXColorPicker.prototype._findNodesByArray = function (j) {
    var g, a, c, h = [];
    a = j.length;
    for (g = 0; g < a; g++) {
        if (typeof (j[g]) == "string") {
            c = document.getElementById(j[g])
        } else {
            c = j[g]
        }
        if (c) {
            this._addNode(c)
        }
    }
};
dhtmlXColorPicker.prototype._addNode = function (j, m, l) {
    var c, h, g, a;
    if (typeof (j) == "string") {
        c = document.getElementById(j)
    } else {
        c = j
    }
    if (typeof (m) == "string") {
        m = document.getElementById(m)
    }
    if (typeof (l) == "string") {
        l = document.getElementById(l)
    }
    if (!c) {
        return null
    }
    if (dhx4.s2b(c.getAttribute("colorbox"))) {
        h = document.createElement("div");
        h.style.width = c.offsetWidth + "px";
        h.style.height = c.offsetHeight + "px";
        c.style.width = c.offsetWidth - (c.offsetHeight + 8) + "px";
        c.parentNode.insertBefore(h, c);
        h.style.position = "relative";
        g = document.createElement("div");
        h.appendChild(c);
        h.appendChild(g);
        g.className = "dhxcp_colorBox";
        c.className += " dhxcp_colorInput";
        g.style.width = g.style.height = c.offsetHeight + "px"
    }
    a = {
        node: c,
        valueColor: (m != undefined) ? m : g || c,
        valueCont: (l != undefined) ? l : c,
        conf: {
            customColors: (c.getAttribute("customcolors") != null) ? dhx4.s2b(c.getAttribute("customcolors")) : null,
            selectedColor: c.getAttribute("selectedcolor")
        }
    };
    this._nodes.push(a);
    if (!this.activeNode) {
        this.activeNode = a
    }
    return a
};
dhtmlXColorPicker.prototype.getNode = function (g) {
    var a = null,
        c = null;
    if (typeof (g) == "string") {
        a = document.getElementById(g)
    } else {
        a = g
    }
    if (a.tagName != undefined) {
        c = this._getNodeByElement(a)
    }
    return c
};
dhtmlXColorPicker.prototype._getNodeByElement = function (g) {
    var h = null,
        c, a;
    a = this._nodes.length;
    for (c = 0; c < a; c++) {
        if (this._nodes[c].node == g) {
            h = this._nodes[c]
        }
    }
    return h
};
dhtmlXColorPicker.prototype._getNodeByValueCont = function (g) {
    var h = null,
        c, a;
    a = this._nodes.length;
    for (c = 0; c < a; c++) {
        if (this._nodes[c].valueCont && this._nodes[c].valueCont == g) {
            h = this._nodes[c]
        }
    }
    return h
};
dhtmlXColorPicker.prototype.initMemoryColors = function () {
    var c = this;
    this._controllerNodes.memory_block.innerHTML = "<div class='dhxcp_memory_button_cont'><button class='dhxcp_save_to_memory'><div class='dhxcp_label_bm'>" + this.i18n[this.conf.lang].btnAddColor + "</div></button></div><div class='dhxcp_memory_els_cont'><a class='dhxcp_memory_el'></a><a class='dhxcp_memory_el'></a><a class='dhxcp_memory_el'></a><a class='dhxcp_memory_el'></a><a class='dhxcp_memory_el'></a><a class='dhxcp_memory_el'></a><a class='dhxcp_memory_el'></a><a class='dhxcp_memory_el'></a></div>";
    this.memory = new this.Memory(this._controllerNodes.memory_block.childNodes[1]);
    this.memory.onSelect = this._onSelectMemoryEl;
    this.memory.onSave = function (h) {
        var g = c.colorAIP.rgb2hex({
            r: h.red,
            g: h.green,
            b: h.blue
        });
        c.callEvent("onSaveColor", [g])
    };
    var a = this._controllerNodes.memory_block.childNodes[0].firstChild;
    this._labelNodes.btnAddColor = this._controllerNodes.memory_block.childNodes[0].firstChild.firstChild;
    if (typeof (window.addEventListener) == "function") {
        a.addEventListener("click", this.saveColor, false)
    } else {
        a.attachEvent("onclick", this.saveColor)
    }
};
dhtmlXColorPicker.prototype._refreshCoordinatesByHSL = function (n, m, c) {
    var a, j, g;
    a = Math.round((this.configColorArea.maxX - this.configColorArea.minX) * n / 359) + this.configColorArea.minX;
    j = Math.round((this.configColorArea.maxY - this.configColorArea.minY) * (100 - c) / 100) + this.configColorArea.minY;
    g = Math.round((this.configColorArea.maxY - this.configColorArea.minY) * (100 - m) / 100) + this.configColorArea.minY;
    this._setColorAreaXY(a, j);
    this._setContrastY(g)
};
dhtmlXColorPicker.prototype.setColor = function (m) {
    var h, g, l = true,
        c, a = this.colorAIP.rgb2hex({
            r: this.value.red,
            g: this.value.green,
            b: this.value.blue
        }),
        j;
    if (m instanceof Array) {
        h = {
            r: parseInt(m[0]),
            g: parseInt(m[1]),
            b: parseInt(m[2])
        }
    } else {
        if (typeof (m) == "string") {
            m = m.replace(/\s/g, "");
            if (/^rgb\((\d{1,3})\,(\d{1,3})\,(\d{1,3})\)$/i.test(m)) {
                g = m.match(/^rgb\((\d{1,3})\,(\d{1,3})\,(\d{1,3})\)$/i);
                h = {
                    r: parseInt(g[1]),
                    g: parseInt(g[2]),
                    b: parseInt(g[3])
                }
            } else {
                h = this.colorAIP.hex2rgb(m)
            }
        }
    }
    l = l && h instanceof Object;
    l = l && (0 <= h.r && h.r <= 255);
    l = l && (0 <= h.g && h.g <= 255);
    l = l && (0 <= h.b && h.b <= 255);
    if (!l) {
        return a
    }
    j = this.colorAIP.rgb2hex({
        r: h.r,
        g: h.g,
        b: h.b
    });
    if (j == a) {
        return a
    }
    this.value.red = h.r;
    this.value.green = h.g;
    this.value.blue = h.b;
    c = this.colorAIP.rgb2hsl(h.r / 255, h.g / 255, h.b / 255);
    this.value.hue = Math.round(c.h);
    this.value.sat = Math.round(c.s * 100);
    this.value.lum = Math.round(c.l * 100);
    this._refreshCoordinatesByHSL(this.value.hue, this.value.sat, this.value.lum);
    this._refreshContrast();
    this._refreshInputValues();
    this._refreshColorValue();
    return j
};
dhtmlXColorPicker.prototype.getSelectedColor = function () {
    return [this.colorAIP.rgb2hex({
        r: this.value.red,
        g: this.value.green,
        b: this.value.blue
    }), [this.value.red, this.value.green, this.value.blue], [this.value.hue, this.value.sat, this.value.lum]]
};
dhtmlXColorPicker.prototype._attachEventsToNode = function (a) {
    if (typeof (window.addEventListener) == "function") {
        a.node.addEventListener("click", this._doOnClickByNode, false)
    } else {
        a.node.attachEvent("onclick", this._doOnClickByNode)
    }
    if (a.valueCont && a.valueCont.tagName.toLowerCase() == "input") {
        if (typeof (window.addEventListener) == "function") {
            a.valueCont.addEventListener("focus", this._doOnFocusByInput, false);
            a.valueCont.addEventListener("blur", this._doOnBlurByInput, false)
        } else {
            a.valueCont.attachEvent("onfocus", this._doOnFocusByInput);
            a.valueCont.attachEvent("onblur", this._doOnBlurByInput)
        }
    }
};
dhtmlXColorPicker.prototype._detachEventsFromNode = function (a) {
    if (typeof (window.addEventListener) == "function") {
        a.node.removeEventListener("click", this._doOnClickByNode, false)
    } else {
        a.node.detachEvent("onclick", this._doOnClickByNode)
    }
    if (a.valueCont && a.valueCont.tagName.toLowerCase() == "input") {
        if (typeof (window.addEventListener) == "function") {
            a.valueCont.removeEventListener("focus", this._doOnFocusByInput, false);
            a.valueCont.removeEventListener("blur", this._doOnBlurByInput, false)
        } else {
            a.valueCont.detachEvent("onfocus", this._doOnFocusByInput);
            a.valueCont.detachEvent("onblur", this._doOnBlurByInput)
        }
    }
};
dhtmlXColorPicker.prototype.show = function (c) {
    var a = false;
    if (c != undefined) {
        this.activeNode = this.getNode(c) || this.activeNode
    }
    if (this.activeNode && this.activeNode.valueCont && this.activeNode.valueCont.value) {
        this.setColor(this.activeNode.valueCont.value)
    }
    if (this.activeNode) {
        a = (this.activeNode.conf.customColors != null) ? this.activeNode.conf.customColors : this.conf.customColors;
        this.setColor(this.activeNode.conf.selectedColor)
    } else {
        a = this.conf.customColors
    }
    if (a) {
        this.showMemory()
    } else {
        this.hideMemory()
    }
    if (this.base._dhx_remove) {
        this.base.firstChild.style.zIndex = dhx4.zim.reserve(this.conf.cp_id);
        if (document.body.firstChild) {
            document.body.insertBefore(this.base, document.body.firstChild)
        } else {
            document.body.appendChild(this.base)
        }
        this._refreshPosition();
        if (typeof (window.addEventListener) == "function") {
            document.body.addEventListener("mousedown", this._doOnClickByBody, false)
        } else {
            document.body.attachEvent("onmousedown", this._doOnClickByBody)
        }
    } else {
        this.base.appendChild(this._globalNode)
    }
    if (this._controllerNodes.fr_cover) {
        this.base.insertBefore(this._controllerNodes.fr_cover, this._globalNode)
    }
    this.callEvent("onShow", [((this.activeNode) ? this.activeNode.node : null)])
};
dhtmlXColorPicker.prototype.setPosition = function (c, j) {
    var h = null,
        a = parseInt(c),
        g = parseInt(j);
    if (isNaN(a)) {
        h = (c.toLowerCase() == "left") ? "left" : (c.toLowerCase() == "bottom") ? "bottom" : null
    }
    if (this.base._dhx_remove) {
        if (h == null) {} else {
            this.conf.position = h;
            this._refreshPosition(h)
        }
    } else {
        if (isNaN(a) || isNaN(g)) {} else {
            this._globalNode.style.left = a + "px";
            this._globalNode.style.top = g + "px";
            if (this._controllerNodes.fr_cover) {
                this._controllerNodes.fr_cover.style.left = this._globalNode.style.left;
                this._controllerNodes.fr_cover.style.top = this._globalNode.style.top
            }
        }
    }
};
dhtmlXColorPicker.prototype._initListenerInput = function () {
    var a = this;
    this._inputListenerId = this._inputListenerId || setInterval(function () {
        a._refreshValueByInput()
    }, 70)
};
dhtmlXColorPicker.prototype._removeListenerInput = function () {
    if (this._inputListenerId) {
        clearInterval(this._inputListenerId);
        this._inputListenerId = null
    }
};
dhtmlXColorPicker.prototype._refreshValueByInput = function () {
    var c = this.activeNode.valueCont.value,
        a = this.getSelectedColor()[0];
    if (this._inputListenerId) {
        if (/^#[\da-f]{6}$/i.test(c) && c != a) {
            this.setColor(c);
            this.callEvent("onSelect", [c, this.activeNode.node])
        }
    }
};
dhtmlXColorPicker.prototype._refreshPosition = function (c) {
    if (this.activeNode == null) {
        return
    }
    var l = dhx4.absTop(this.activeNode.node),
        a = dhx4.absLeft(this.activeNode.node),
        g = dhx4.screenDim(),
        h = this._globalNode.offsetHeight,
        j = 0;
    c = c || this.conf.position;
    switch (c) {
    case "bottom":
        this._globalNode.style.top = l + this.activeNode.node.offsetHeight + this.conf.indent + "px";
        this._globalNode.style.left = a + "px";
        break;
    default:
        this._globalNode.style.left = a + this.activeNode.node.offsetWidth + this.conf.indent + "px";
        j = l;
        if (g.bottom - (j + h) <= 0) {
            j = g.bottom - (h + this.conf.indent)
        }
        if (j - g.top < 0) {
            j = g.top + this.conf.indent
        }
        this._globalNode.style.top = j + "px"
    }
    if (this._controllerNodes.fr_cover) {
        this._controllerNodes.fr_cover.style.left = this._globalNode.style.left;
        this._controllerNodes.fr_cover.style.top = this._globalNode.style.top
    }
};
dhtmlXColorPicker.prototype.isVisible = function () {
    var a = false;
    if (this.base._dhx_remove) {
        a = this.base.parentNode == document.body
    } else {
        a = this._globalNode.parentNode == this.base
    }
    return a
};
dhtmlXColorPicker.prototype.hide = function () {
    if (this.base._dhx_remove) {
        if (this.base.parentNode) {
            this.base.parentNode.removeChild(this.base);
            dhx4.zim.clear(this.conf.cp_id);
            if (typeof (window.addEventListener) == "function") {
                document.body.removeEventListener("mousedown", this._doOnClickByBody, false)
            } else {
                document.body.detachEvent("onmousedown", this._doOnClickByBody)
            }
        }
    } else {
        if (this.isVisible() == false) {
            return
        }
        this.base.removeChild(this._globalNode)
    }
    if (this._controllerNodes.fr_cover && this._controllerNodes.fr_cover.parentNode) {
        this._controllerNodes.fr_cover.parentNode.removeChild(this._controllerNodes.fr_cover)
    }
    if (this.callEvent != undefined) {
        this.callEvent("onHide", [((this.activeNode) ? this.activeNode.node : null)])
    }
};
dhtmlXColorPicker.prototype.configColorArea = {
    minX: 1,
    maxX: 209,
    minY: 1,
    maxY: 119
};
dhtmlXColorPicker.prototype._skinCollection = {
    dhx_skyblue: true,
    dhx_web: true,
    dhx_terrace: true
};
dhtmlXColorPicker.prototype.i18n = {
    en: {
        labelHue: "Hue",
        labelSat: "Sat",
        labelLum: "Lum",
        labelRed: "Red",
        labelGreen: "Green",
        labelBlue: "Blue",
        btnAddColor: "Save the color",
        btnSelect: "Select",
        btnCancel: "Cancel"
    }
};
dhtmlXColorPicker.prototype.loadUserLanguage = function (a) {
    if (typeof (this._mergeLangModules) == "function") {
        this._mergeLangModules()
    }
    this.conf.lang = a;
    this._refreshLanguage()
};
dhtmlXColorPicker.prototype._refreshLanguage = function () {
    var a, c = this.i18n[this.conf.lang];
    for (a in c) {
        if (this._labelNodes[a]) {
            this._labelNodes[a].innerHTML = c[a]
        }
    }
};
dhtmlXColorPicker.prototype._setColorAreaXY = function (a, g) {
    var c = this.configColorArea;
    a = parseInt(a);
    if (c.minX > a) {
        this.conf.x = c.minX
    } else {
        if (a > c.maxX) {
            this.conf.x = c.maxX
        } else {
            if (!isNaN(a)) {
                this.conf.x = a
            }
        }
    }
    g = parseInt(g);
    if (c.minY > g) {
        this.conf.y = c.minY
    } else {
        if (g > c.maxY) {
            this.conf.y = c.maxY
        } else {
            if (!isNaN(g)) {
                this.conf.y = g
            }
        }
    }
    this._refreshLines()
};
dhtmlXColorPicker.prototype._setColorByXYC = function (c) {
    c = c || false;
    this.value.hue = Math.round((359 * (this.conf.x - this.configColorArea.minX)) / (this.configColorArea.maxX - this.configColorArea.minX));
    this.value.lum = Math.round(100 - (100 * (this.conf.y - this.configColorArea.minY)) / (this.configColorArea.maxY - this.configColorArea.minY));
    this.value.sat = Math.round(100 - (100 * (this.conf.c - this.configColorArea.minY)) / (this.configColorArea.maxY - this.configColorArea.minY));
    var a = this.colorAIP.hsl2rgb(this.value.hue, this.value.sat / 100, this.value.lum / 100);
    this.value.red = Math.round(255 * a.r);
    this.value.green = Math.round(255 * a.g);
    this.value.blue = Math.round(255 * a.b);
    if (!c) {
        this._refreshContrast()
    }
    this._refreshInputValues();
    this._refreshColorValue()
};
dhtmlXColorPicker.prototype._setContrastY = function (c) {
    var a = this.configColorArea;
    c = parseInt(c);
    if (!isNaN(c)) {
        this.conf.c = Math.min(Math.max(a.minY, c), a.maxY)
    }
    this._refreshContrastLine()
};
dhtmlXColorPicker.prototype._refreshInputValues = function () {
    this._controllerNodes.hue.value = this.value.hue;
    this._controllerNodes.sat.value = this.value.sat;
    this._controllerNodes.lum.value = this.value.lum;
    this._controllerNodes.red.value = this.value.red;
    this._controllerNodes.green.value = this.value.green;
    this._controllerNodes.blue.value = this.value.blue
};
dhtmlXColorPicker.prototype._refreshColorValue = function () {
    this._controllerNodes.color.style.backgroundColor = "rgb(" + [this.value.red, this.value.green, this.value.blue].join(", ") + ")";
    var a = this.colorAIP.rgb2hex({
        r: this.value.red,
        g: this.value.green,
        b: this.value.blue
    });
    this._controllerNodes.hsv.value = a;
    this.callEvent("onChange", [a])
};
dhtmlXColorPicker.prototype._refreshContrast = function () {
    var h = this.colorAIP.hsl2rgb(this.value.hue, 0, this.value.lum / 100);
    var j = this.colorAIP.hsl2rgb(this.value.hue, 1, this.value.lum / 100);
    var g = this._checkIeVersion();
    if (g && g <= 8) {
        var l = this._controllerNodes.contrastArea.firstChild;
        if (l == this._controllerNodes.contrast_line) {
            l = document.createElement("div");
            l.className += "dhxcp_ie_gradient";
            this._controllerNodes.contrastArea.appendChild(l);
            this._controllerNodes.contrastArea.appendChild(this._controllerNodes.contrast_line)
        }
        var c = this.colorAIP.rgb2hex({
            r: Math.round(255 * h.r),
            g: Math.round(255 * h.g),
            b: Math.round(255 * h.b)
        });
        var a = this.colorAIP.rgb2hex({
            r: Math.round(255 * j.r),
            g: Math.round(255 * j.g),
            b: Math.round(255 * j.b)
        });
        l.style.filter = "progid:DXImageTransform.Microsoft.gradient(startColorstr='" + a + "', endColorstr='" + c + "', GradientType=0)"
    } else {
        h = [Math.round(255 * h.r), Math.round(255 * h.g), Math.round(255 * h.b)];
        j = [Math.round(255 * j.r), Math.round(255 * j.g), Math.round(255 * j.b)];
        this._controllerNodes.contrastArea.style.backgroundImage = "linear-gradient(to top, rgb(" + h.join(",") + "), rgb(" + j.join(",") + "))"
    }
};
dhtmlXColorPicker.prototype._refreshLines = function () {
    this._controllerNodes.v_line.style.left = this.conf.x + "px";
    this._controllerNodes.h_line.style.top = this.conf.y + "px"
};
dhtmlXColorPicker.prototype._refreshContrastLine = function () {
    this._controllerNodes.contrast_line.style.top = this.conf.c + "px"
};
dhtmlXColorPicker.prototype._getOffsetPosition = function (h, a) {
    var c = {
        x: NaN,
        y: NaN
    },
        g = h.target || h.srcElement;
    if (g == a) {
        c.x = (h.offsetX != undefined) ? h.offsetX : h.layerX;
        c.y = (h.offsetY != undefined) ? h.offsetY : h.layerY
    } else {
        if (g == this._controllerNodes.v_line) {
            c.y = (h.offsetY != undefined) ? h.offsetY : h.layerY
        } else {
            c.x = (h.offsetX != undefined) ? h.offsetX : h.layerX
        }
    }
    return c
};
dhtmlXColorPicker.prototype.colorAIP = {
    hex2rgb: function (c) {
        var a = c.match(/^(#)([\da-f]{2})([\da-f]{2})([\da-f]{2})$/i);
        if (a != null) {
            return {
                r: parseInt("0x" + a[2]),
                g: parseInt("0x" + a[3]),
                b: parseInt("0x" + a[4])
            }
        } else {
            return null
        }
    },
    rgb2hex: function (j) {
        var h = parseInt(j.r),
            c = parseInt(j.g),
            a = parseInt(j.b);
        h = h || 0, c = c || 0, a = a || 0;
        return "#" + ((h) ? ((h < 16) ? "0" + h.toString(16) : h.toString(16)) : "00") + ((c) ? ((c < 16) ? "0" + c.toString(16) : c.toString(16)) : "00") + ((a) ? ((a < 16) ? "0" + a.toString(16) : a.toString(16)) : "00")
    },
    rgb2hsl: function (o, n, h) {
        var m, l, c;
        var a = Math.max(o, n, h),
            j = Math.min(o, n, h);
        c = 0.5 * (a + j);
        if (a == j) {
            m = 0
        } else {
            if (a == o) {
                m = 60 * (n - h) / (a - j);
                if (n < h) {
                    m += 360
                }
            } else {
                if (a == n) {
                    m = 60 * (h - o) / (a - j) + 120
                } else {
                    m = 60 * (o - n) / (a - j) + 240
                }
            }
        }
        if (c == 0 || a == j) {
            l = 0
        } else {
            if (c <= 0.5) {
                l = 0.5 * (a - j) / c
            } else {
                l = 0.5 * (a - j) / (1 - c)
            }
        }
        return {
            h: m,
            s: l,
            l: c
        }
    },
    hsl2rgb: function (o, g, m) {
        var j, l, n;
        var c = [],
            a = [];
        if (m <= 0.5) {
            j = m * (1 + g)
        } else {
            j = m + g - (m * g)
        }
        l = 2 * m - j;
        n = o / 360;
        c.push(n + 1 / 3);
        c.push(n);
        c.push(n - 1 / 3);
        for (var h = 0; h < 3; h++) {
            if (c[h] < 0) {
                c[h] += 1
            } else {
                if (c[h] > 1) {
                    c[h] -= 1
                }
            }
            if (c[h] < 1 / 6) {
                a.push(l + (j - l) * 6 * c[h])
            } else {
                if (c[h] < 0.5) {
                    a.push(j)
                } else {
                    if (c[h] < 2 / 3) {
                        a.push(l + (j - l) * (2 / 3 - c[h]) * 6)
                    } else {
                        a.push(l)
                    }
                }
            }
        }
        return {
            r: a[0],
            g: a[1],
            b: a[2]
        }
    }
};
dhtmlXColorPicker.prototype._checkIeVersion = function () {
    var a;
    var c = navigator.userAgent.match(/(MSIE)\s(\d\.\d)/i);
    a = (c && c[2]) ? parseInt(c[2]) : null;
    return a
};
dhtmlXColorPicker.prototype.setCustomColors = function () {
    if (this.memory == null) {
        this.initMemoryColors();
        this.conf.customColors = true
    }
    var h, g, m, c, j, a;
    g = arguments.length;
    for (h = 0; h < g; h++) {
        if (arguments[h] instanceof Array) {
            m = this._rgb2value(arguments[h][0], arguments[h][1], arguments[h][2]);
            this.memory.setValue(m, null, false);
            continue
        } else {
            if (typeof (arguments[h]) == "string") {
                c = arguments[h].match(/^rgb\((\d{1,3})\,(\d{1,3})\,(\d{1,3})\)$/i);
                if (c instanceof Array) {
                    m = this._rgb2value(c[1], c[2], c[3]);
                    this.memory.setValue(m, null, false);
                    continue
                }
                c = arguments[h].match(/(#[\da-f]{6})/ig);
                if (c instanceof Array) {
                    a = c.length;
                    for (j = 0; j < a; j++) {
                        m = this._hex2value(c[j]);
                        this.memory.setValue(m, null, false)
                    }
                }
            }
        }
    }
};
dhtmlXColorPicker.prototype._rgb2value = function (j, h, a) {
    var c = this.colorAIP.rgb2hsl(j / 255, h / 255, a / 255);
    return {
        red: j,
        green: h,
        blue: a,
        hue: Math.round(c.h),
        sat: Math.round(c.s * 100),
        lum: Math.round(c.l * 100)
    }
};
dhtmlXColorPicker.prototype._hex2value = function (g) {
    var c, a;
    c = this.colorAIP.hex2rgb(g);
    a = this.colorAIP.rgb2hsl(c.r / 255, c.g / 255, c.b / 255);
    return {
        red: c.r,
        green: c.g,
        blue: c.b,
        hue: Math.round(a.h),
        sat: Math.round(a.s * 100),
        lum: Math.round(a.l * 100)
    }
};
dhtmlXColorPicker.prototype.showMemory = function () {
    if (this.memory == null) {
        this.initMemoryColors()
    }
    if (!this._globalNode.className.match(/dhxcp_add_memory/)) {
        this._globalNode.className += " dhxcp_add_memory"
    }
    this.conf.customColors = true
};
dhtmlXColorPicker.prototype.hideMemory = function () {
    if (this.memory != null) {
        this._globalNode.className = this._globalNode.className.replace(/\sdhxcp_add_memory/, "")
    }
    this.conf.customColors = false
};
dhtmlXColorPicker.prototype.setSkin = function (j) {
    j = j.toLowerCase();
    var g, c = -1,
        a, h = "dhtmlxcp";
    g = this.base.className.match(/\S\w+/ig);
    if (g instanceof Array) {
        for (a in this._skinCollection) {
            if (c == -1) {
                c = this._indexOf(g, h + "_" + a)
            } else {
                break
            }
        }
        c = (c == -1) ? g.length : c
    } else {
        g = [];
        c = 0
    }
    g[c] = h + "_" + j;
    this.base.className = g.join(" ");
    this.skin = j
};
dhtmlXColorPicker.prototype.hideOnSelect = function (a) {
    a = dhx4.s2b(a);
    this.conf.hideOnSelect = a
};
dhtmlXColorPicker.prototype._indexOf = function (a, h) {
    var g, c, j = -1;
    c = a.length;
    for (g = c; g >= 0; g--) {
        if (a[g] == h) {
            j = g;
            break
        }
    }
    return j
};
dhtmlXColorPicker.prototype.destructMemory = function () {
    if (this.memory == null) {
        return
    }
    this.hideMemory();
    var a = this._controllerNodes.memory_block.childNodes[0].firstChild;
    this._labelNodes.btnAddColor = null;
    if (typeof (window.addEventListener) == "function") {
        a.removeEventListener("click", this.saveColor, false)
    } else {
        a.detachEvent("onclick", this.saveColor)
    }
    this.memory.remove();
    this._controllerNodes.memory_block.innerHTML = "";
    this.memory = null
};
dhtmlXColorPicker.prototype.Memory = function (g) {
    var c = this,
        a = null,
        h = {
            red: 255,
            blue: 255,
            green: 255,
            hue: 0,
            sat: 0,
            lum: 100
        };
    this.select = function () {
        var l = (this != window) ? this : event.srcElement;
        var j = j || l.dhxpc_memory;
        if (a != null) {
            c.unSelect()
        }
        a = j;
        j.domElement.className += " dhxcp_memory_el_select";
        if (typeof (c.onSelect) == "function") {
            c.onSelect(j)
        }
    };
    this.onSelect = null;
    this.onSave = null;
    this._createMemoryController = function (j) {
        var l = {
            domElement: j,
            value: dhx4._copyObj(h)
        };
        j.dhxpc_memory = l;
        if (typeof (window.addEventListener) == "function") {
            j.addEventListener("click", c.select, false)
        } else {
            j.attachEvent("onclick", c.select)
        }
        return l
    };
    this._findMemoryControllers = function (q) {
        var n = q.getElementsByTagName("a"),
            m, j, o = [];
        j = n.length;
        for (m = 0; m < j; m++) {
            o.push(this._createMemoryController(n[m]))
        }
        return o
    };
    this.controllers = this._findMemoryControllers(g);
    this.unSelect = function () {
        if (a) {
            a.domElement.className = a.domElement.className.replace(/\s.*$/i, "")
        }
        a = null
    };
    this.setActiveNext = function () {
        var m = null,
            j;
        if (a == null) {
            a = this.controllers[0]
        } else {
            m = this.getIndex(a);
            j = this.controllers.length;
            this.unSelect();
            a = (m + 1 < j) ? this.controllers[m + 1] : this.controllers[0]
        }
        a.domElement.className += " dhxcp_memory_el_next";
        return a
    };
    this.setValue = function (l, j, m) {
        a = j || a;
        if (a == null) {
            a = this.controllers[0]
        }
        a.value.red = l.red;
        a.value.blue = l.blue;
        a.value.green = l.green;
        a.value.hue = l.hue;
        a.value.sat = l.sat;
        a.value.lum = l.lum;
        a.domElement.style.backgroundColor = "rgb(" + [l.red, l.green, l.blue].join(", ") + ")";
        this.setActiveNext();
        if ((m != false) && (typeof (this.onSave) == "function")) {
            this.onSave(l)
        }
    };
    this.clean = function () {
        var j = this.controllers.length,
            n;
        for (var m = 0; m < j; m++) {
            n = this.controllers[m];
            n.value = dhx4._copyObj(h);
            n.domElement.style.backgroundColor = "rgb(" + [h.red, h.green, h.blue].join(", ") + ")"
        }
        this.unSelect();
        a = this.controllers[0]
    };
    this.getIndex = function (n) {
        var m, j, o = -1;
        j = this.controllers.length;
        for (m = 0; m < j; m++) {
            if (this.controllers[m] == n) {
                o = m;
                break
            }
        }
        return o
    };
    this.remove = function () {
        var m, j;
        j = this.controllers.length;
        for (m = 0; m < j; m++) {
            if (typeof (window.addEventListener) == "function") {
                this.controllers[m].domElement.removeEventListener("click", this.select, false)
            } else {
                this.controllers[m].domElement.detachEvent("onclick", this.select)
            }
            delete this.controllers[m].domElement.dhxpc_memory
        }
        delete this.onSelect;
        delete this.controllers;
        delete this.onSave
    }
};
if (window.dhx4.isIE6) {
    dhtmlXColorPicker.prototype._cpInitFRM = function () {
        var a;
        if (!this._controllerNodes.fr_cover) {
            a = document.createElement("IFRAME");
            a.className = "dhxcp_frm";
            a.border = 0;
            a.frameBorder = 0;
            this._controllerNodes.fr_cover = a
        }
        if (!this.base._dhx_remove) {
            this.base.insertBefore(a, this._globalNode)
        }
    }
}
function dhtmlXSlider(g) {
    var c = this;
    this.conf = {
        size: null,
        skin: null,
        vertical: false,
        min: 0,
        max: 99,
        value: 0,
        step: 1,
        margin: 2,
        border: 1,
        disabled: false,
        tooltip: false,
        visible: true,
        linkTo: undefined
    };
    this._attachedNode = {};
    this.base = null;
    var a = null;
    if (arguments.length > 1) {
        return new dhtmlXSlider(this._renderArgumets(arguments))
    } else {
        if (typeof (g) == "string" || (typeof (g) == "object" && g.tagName)) {
            return new dhtmlXSlider({
                parent: g
            })
        }
    }
    if (typeof (g.parent) == "string") {
        this.base = document.getElementById(g.parent)
    } else {
        this.base = g.parent
    }
    this._mergeConfig(this._readAttFormNode(this.base));
    this._mergeConfig(g);
    if (this.conf.size == null || this.conf.size == undefined) {
        if (this.conf.vertical) {
            this.conf.size = this.base.offsetHeight
        } else {
            this.conf.size = this.base.offsetWidth
        }
    }
    var h = this.conf.skin || window.dhx4.skin || (typeof (dhtmlx) !== "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxslider") || "dhx_skyblue";
    this.setSkin(h);
    this.base.innerHTML = "<div class='dhxsl_container'><div class='dhxsl_track'></div><div class='dhxsl_runner'></div></div>";
    this._nodes = {
        cont: this.base.firstChild,
        track: this.base.firstChild.firstChild,
        runner: this.base.firstChild.childNodes[1]
    };
    this._nodes.cont.onmousedown = this._nodes.track.onmousedown = this._nodes.cont.onselectstart = this._nodes.track.onselectstart = function (j) {
        j = j || event;
        if (typeof (j.preventDefault) == "function") {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
        return false
    };
    this.conf.value = this._normalize(this.conf.value);
    this._setOrient(this.conf.vertical);
    this.setSize(this.conf.size);
    this._initMover = function (j) {
        j = j || event;
        a = {};
        a.value = c.conf.value;
        a.coord = (c.conf.vertical) ? j.clientY : j.clientX;
        if (c.conf.disabled == false) {
            if (typeof (window.addEventListener) == "function") {
                window.addEventListener("mousemove", c._move, false);
                window.addEventListener("mouseup", c._cleanMove, false)
            } else {
                document.body.attachEvent("onmousemove", c._move);
                document.body.attachEvent("onmouseup", c._cleanMove)
            }
        }
        c.callEvent("_onRunnerMouseDown", []);
        return false
    };
    this._move = function (o) {
        o = o || event;
        var n = (c.conf.vertical) ? c._nodes.runner.offsetHeight : c._nodes.runner.offsetWidth;
        var l = c.conf.max - c.conf.min;
        var j = (c.conf.vertical) ? o.clientY : o.clientX;
        var m = a.value + (j - a.coord) * l / (c.conf.size - n);
        c.setValue(Math.round(m), true)
    };
    this._cleanMove = function (j) {
        if (typeof (window.addEventListener) == "function") {
            window.removeEventListener("mousemove", c._move, false);
            window.removeEventListener("mouseup", c._cleanMove, false)
        } else {
            document.body.detachEvent("onmousemove", c._move);
            document.body.detachEvent("onmouseup", c._cleanMove)
        }
        a = null;
        c.callEvent("onSlideEnd", [c.conf.value]);
        c.callEvent("_onRunnerMouseUp", [])
    };
    this._doOnSetValue = function (o) {
        if (a) {
            return false
        }
        o = o || event;
        var n = (c.conf.vertical) ? (o.offsetY || o.layerY) : (o.offsetX || o.layerX);
        var m = (c.conf.vertical) ? c._nodes.runner.offoffsetHeightsetHe : c._nodes.runner.offsetWidth;
        var j = c.conf.max - c.conf.min;
        var l = n * j / (c.conf.size) + c.conf.min;
        c.setValue(Math.round(l), true);
        if (!a) {
            c._initMover(o)
        }
        return false
    };
    this._doOnChangeInput = function (l) {
        l = l || event;
        var j = l.target || l.srcElement;
        c.setValue(j.value)
    };
    this._doOnKeyDown = function (l) {
        l = l || event;
        var j = l.target || l.srcElement;
        if (l.keyCode == 13) {
            c.setValue(j.value)
        }
    };
    this._attachEvents(this._nodes);
    this.unload = function () {
        dhx4._eventable(this, "clear");
        this._detachNode();
        this._detachEvents(this._nodes);
        this.base.removeChild(this._nodes.cont);
        this._nodes.cont.onmousedown = this._nodes.track.onmousedown = this._nodes.cont.onselectstart = this._nodes.track.onselectstart = null;
        delete this._nodes.cont;
        delete this._nodes.track;
        delete this._nodes.max;
        delete this._nodes.min;
        delete this._nodes.runner;
        if (/\s?dhtmlxslider_\S*/.test(this.base.className)) {
            this.base.className = this.base.className.replace(/\s?dhtmlxslider_\S*/, "")
        }
        for (var j in this) {
            this[j] = null
        }
        c = null
    };
    dhx4._eventable(this);
    if (this.conf.disabled) {
        this.disable()
    }
    if (this.conf.tooltip) {
        this.enableTooltip()
    }
    if (!this.conf.visible) {
        this.hide()
    }
    if (this.conf.linkTo) {
        this.linkTo(this.conf.linkTo)
    }
    return this
}
dhtmlXSlider.prototype._setOrient = function (a) {
    a = a || false;
    if (/\s?dhxsl_cont_hr/i.test(this._nodes.cont.className)) {
        this._nodes.cont.className = this._nodes.cont.className.replace(/\s?dhxsl_cont_hr/i, "")
    }
    if (/\s?dhxsl_cont_vr/i.test(this._nodes.cont.className)) {
        this._nodes.cont.className = this._nodes.cont.className.replace(/\s?dhxsl_cont_vr/i, "")
    }
    if (a) {
        this._nodes.cont.className += " dhxsl_cont_vr"
    } else {
        this._nodes.cont.className += " dhxsl_cont_hr"
    }
};
dhtmlXSlider.prototype._attachEvents = function (a) {
    if (typeof (window.addEventListener) == "function") {
        a.runner.addEventListener("mousedown", this._initMover, false);
        a.cont.addEventListener("mousedown", this._doOnSetValue, false)
    } else {
        a.runner.attachEvent("onmousedown", this._initMover);
        a.cont.attachEvent("onmousedown", this._doOnSetValue)
    }
};
dhtmlXSlider.prototype._detachEvents = function (a) {
    if (typeof (window.addEventListener) == "function") {
        a.runner.removeEventListener("mousedown", this._initMover, false);
        a.cont.removeEventListener("mousedown", this._doOnSetValue, false)
    } else {
        a.runner.detachEvent("onmousedown", this._initMover);
        a.cont.detachEvent("onmousedown", this._doOnSetValue)
    }
};
dhtmlXSlider.prototype._mergeConfig = function (c) {
    for (var a in c) {
        switch (a.toLowerCase()) {
        case "size":
        case "min":
        case "max":
        case "value":
        case "step":
            this.conf[a] = parseInt(c[a]);
            break;
        case "vertical":
        case "tooltip":
        case "disabled":
        case "visible":
            this.conf[a] = dhx4.s2b(c[a]);
            break;
        case "parent":
            continue;
            break;
        default:
            this.conf[a] = c[a]
        }
    }
};
dhtmlXSlider.prototype._readAttFormNode = function (h) {
    var m = h.attributes,
        a = m.length,
        g, j = {},
        c;
    for (g = 0; g < a; g++) {
        c = m[g];
        switch (c.name.toLowerCase()) {
        case "size":
        case "min":
        case "max":
        case "value":
        case "step":
            j[c.name] = parseInt(c.value);
            break;
        case "skin":
            j.skin = c.value;
            break;
        case "vertical":
        case "disabled":
        case "visible":
            j[c.name] = dhx4.s2b(c.value);
            break;
        case "linkto":
            j.linkTo = c.value;
            break;
        case "tooltip":
            j.tooltip = dhx4.s2b(c.value);
            break
        }
    }
    return j
};
dhtmlXSlider.prototype._renderArgumets = function (a) {
    var h = {},
        g, c;
    c = a.length;
    for (g = 0; g < c; g++) {
        switch (g) {
        case 0:
            h.parent = a[g];
            break;
        case 1:
            h.size = a[g];
            break;
        case 2:
            h.skin = a[g];
            break;
        case 3:
            h.vertical = a[g];
            break;
        case 4:
            h.min = a[g];
            break;
        case 5:
            h.max = a[g];
            break;
        case 6:
            h.value = a[g];
            break;
        case 7:
            h.step = a[g];
            break
        }
    }
    return h
};
dhtmlXSlider.prototype._skinCollection = {
    dhx_skyblue: true,
    dhx_web: true,
    dhx_terrace: true
};
dhtmlXSlider.prototype._indexOf = function (a, h) {
    var g, c, j = -1;
    c = a.length;
    for (g = c; g >= 0; g--) {
        if (a[g] == h) {
            j = g;
            break
        }
    }
    return j
};
dhtmlXSlider.prototype._refreshRunner = function () {
    var a, c;
    if (this.conf.vertical) {
        a = this._nodes.cont.offsetHeight - this._nodes.runner.offsetHeight;
        c = this._getCoord(a);
        this._nodes.runner.style.top = c + this.conf.border + "px";
        this._nodes.runner.style.left = Math.round((this._nodes.cont.offsetWidth - this._nodes.runner.offsetWidth) / 2) + "px"
    } else {
        a = this._nodes.cont.offsetWidth - this._nodes.runner.offsetWidth;
        c = this._getCoord(a);
        this._nodes.runner.style.left = c + this.conf.border + "px";
        this._nodes.runner.style.top = Math.round((this._nodes.cont.offsetHeight - this._nodes.runner.offsetHeight) / 2) + "px"
    }
};
dhtmlXSlider.prototype._setValueByCoord = function (h) {
    var a = dhx4.absLeft(this._nodes.cont),
        j = dhx4.absTop(this._nodes.cont),
        g, c;
    if (this.conf.vertical) {
        c = (h.y - j - this._nodes.runner.offsetHeight / 2) / (this._nodes.cont.offsetHeight - this._nodes.runner.offsetHeight)
    } else {
        c = (h.x - a - this._nodes.runner.offsetWidth / 2) / (this._nodes.cont.offsetWidth - this._nodes.runner.offsetWidth)
    }
    g = Math.round((this.conf.max - this.conf.min) * c + this.conf.min);
    this.setValue(g, true)
};
dhtmlXSlider.prototype._getCoord = function (a) {
    var g = this.conf;
    var c = (g.value - g.min) / (g.max - g.min);
    return Math.round(a * c)
};
dhtmlXSlider.prototype._normalize = function (a) {
    a = parseInt(a);
    return Math.round(a / this.conf.step) * this.conf.step
};
dhtmlXSlider.prototype._attachNode = function (c) {
    var a = c.tagName.toLowerCase();
    if (!a) {
        return
    }
    this._attachedNode.node = c;
    switch (a) {
    case "input":
        if (typeof (window.addEventListener) == "function") {
            c.addEventListener("change", this._doOnChangeInput, false);
            c.addEventListener("keydown", this._doOnKeyDown, false)
        } else {
            c.attachEvent("onchange", this._doOnChangeInput);
            c.attachEvent("onkeydown", this._doOnKeyDown)
        }
        this._attachedNode.setValue = function (g) {
            c.value = g
        };
        break;
    default:
        this._attachedNode.setValue = function (g) {
            c.innerHTML = g
        }
    }
    this._attachedNode.setValue(this.conf.value)
};
dhtmlXSlider.prototype._detachNode = function () {
    var c = this._attachedNode.node;
    if (!c) {
        return
    }
    var a = c.tagName;
    switch (a) {
    case "input":
        if (typeof (window.addEventListener) == "function") {
            c.removeEventListener("change", this._doOnChangeInput, false);
            c.removeEventListener("keydown", this._doOnChangeInput, false)
        } else {
            c.detachEvent("change", this._doOnChangeInput);
            c.detachEvent("keydown", this._doOnChangeInput)
        }
        break
    }
    delete this._attachedNode.node;
    delete this._attachedNode.setValue
};
dhtmlXSlider.prototype.setSize = function (a) {
    a = parseInt(a);
    if (!isNaN(a)) {
        if (this.conf.vertical) {
            if (this._nodes.cont.style.width) {
                delete this._nodes.cont.style.width
            }
            this._nodes.cont.style.height = a - this.conf.margin + "px"
        } else {
            if (this._nodes.cont.style.height) {
                delete this._nodes.cont.style.height
            }
            this._nodes.cont.style.width = a - this.conf.margin + "px"
        }
        this._refreshRunner()
    }
};
dhtmlXSlider.prototype.setSkin = function (j) {
    j = j.toLowerCase();
    var g, c = -1,
        a, h = "dhtmlxslider";
    g = this.base.className.match(/\S\w+/ig);
    if (g instanceof Array) {
        for (a in this._skinCollection) {
            if (c == -1) {
                c = this._indexOf(g, h + "_" + a)
            } else {
                break
            }
        }
        c = (c == -1) ? g.length : c
    } else {
        g = [];
        c = 0
    }
    g[c] = h + "_" + j;
    this.base.className = g.join(" ");
    this.conf.skin = j;
    if (this._nodes) {
        this._refreshRunner()
    }
};
dhtmlXSlider.prototype.setValue = function (a, c) {
    a = parseInt(a);
    c = c || false;
    if (!isNaN(a)) {
        a = this._normalize(a);
        a = Math.max(this.conf.min, a);
        a = Math.min(this.conf.max, a);
        if (this.conf.value !== a) {
            this.conf.value = a;
            this._refreshRunner();
            if (this.conf.tooltip) {
                this._nodes.cont.title = this.conf.value
            }
            if (c) {
                this.callEvent("onChange", [this.conf.value, this])
            }
        }
    }
    if (typeof (this._attachedNode.setValue) == "function") {
        this._attachedNode.setValue(this.conf.value)
    }
};
dhtmlXSlider.prototype.getValue = function () {
    return this.conf.value
};
dhtmlXSlider.prototype.disable = function (g) {
    g = (g == false) ? false : true;
    var c = null;
    if (g) {
        for (var a in this._nodes) {
            if (a == "cont") {
                continue
            }
            c = new RegExp("\\s?dhxsl_" + a + "_dis", "i");
            if (!c.test(this._nodes[a].className)) {
                this._nodes[a].className += " dhxsl_" + a + "_dis"
            }
        }
        this.conf.disabled = true
    } else {
        this.enable()
    }
};
dhtmlXSlider.prototype.enable = function () {
    var c;
    for (var a in this._nodes) {
        if (a == "cont") {
            continue
        }
        c = new RegExp("\\s?dhxsl_" + a + "_dis", "i");
        if (c.test(this._nodes[a].className)) {
            this._nodes[a].className = this._nodes[a].className.replace(c, "")
        }
    }
    this.conf.disabled = false
};
dhtmlXSlider.prototype.isEnabled = function () {
    return !this.conf.disabled
};
dhtmlXSlider.prototype.disableTooltip = function () {
    this._nodes.cont.removeAttribute("title");
    this.conf.tooltip = false
};
dhtmlXSlider.prototype.enableTooltip = function (a) {
    if (typeof (a) == "undefined") {
        a = true
    } else {
        a = dhx4.s2b(a)
    }
    if (a) {
        this._nodes.cont.title = this.conf.value;
        this.conf.tooltip = true
    } else {
        this.disableTooltip()
    }
};
dhtmlXSlider.prototype.setMax = function (a) {
    a = parseInt(a);
    if (!isNaN(a) && this.conf.min < a) {
        this.conf.max = a;
        this.setValue(this.conf.value)
    }
};
dhtmlXSlider.prototype.getMax = function () {
    return this.conf.max
};
dhtmlXSlider.prototype.setMin = function (a) {
    a = parseInt(a);
    if (!isNaN(a) && this.conf.max > a) {
        this.conf.min = a;
        this.setValue(this.conf.value)
    }
};
dhtmlXSlider.prototype.getMin = function () {
    return this.conf.min
};
dhtmlXSlider.prototype.setStep = function (a) {
    a = parseInt(a);
    var c = this.conf.max - this.conf.min;
    if (!isNaN(a) && a < c) {
        this.conf.step = a;
        this.setValue(this.conf.value)
    }
};
dhtmlXSlider.prototype.getStep = function () {
    return this.conf.step
};
dhtmlXSlider.prototype.show = function () {
    if (/\s?dhxsl_hidden/i.test(this._nodes.cont.className)) {
        this._nodes.cont.className = this._nodes.cont.className.replace(/\s?dhxsl_hidden/i, "")
    }
    this.conf.visible = true
};
dhtmlXSlider.prototype.hide = function () {
    if (!/\s?dhxsl_hidden/i.test(this._nodes.cont.className)) {
        this._nodes.cont.className += " dhxsl_hidden"
    }
    this.conf.visible = false
};
dhtmlXSlider.prototype.isVisible = function () {
    return this.conf.visible
};
dhtmlXSlider.prototype.linkTo = function (a) {
    if (typeof (a) == "string") {
        a = document.getElementById(a)
    }
    if (this._attachedNode.node) {
        this._detachNode()
    }
    this._attachNode(a)
};

function dhtmlXPopup(g) {
    var h = this;
    this.conf = g || {};
    g = null;
    this.mode = (this.conf.mode || "bottom");
    this.conf.zi = window.dhx4.newId();
    this.conf.isIE = (navigator.userAgent.indexOf("MSIE") >= 0);
    this.p = document.createElement("DIV");
    this.p.style.display = "none";
    this.p.innerHTML = "<div class='dhx_popup_area" + (this.conf.isIE ? " dhx_popup_area_ie" : "") + "'><table cellspacing='0' cellpadding='0' border='0' class='dhx_popup_table'><tbody></tbody></table></div><div class='dhx_popup_arrow dhx_popup_arrow_" + this.mode + "'></div>";
    document.body.appendChild(this.p);
    this.skinParams = {
        dhx_terrace: {
            t0: 19,
            t1: 9,
            t2: 19,
            t3: 9
        },
        dhx_skyblue: {
            t0: 12,
            t1: 9,
            t2: 12,
            t3: 9
        },
        dhx_web: {
            t0: 12,
            t1: 9,
            t2: 12,
            t3: 9
        }
    };
    this.p.onclick = function (j) {
        j = j || event;
        h._clearClick = true;
        if (h._nodeObj != null) {
            h.callEvent("onContentClick", []);
            return true
        }
        var a = (j.target || j.srcElement);
        var l = null;
        while (a != h.p && a != null) {
            if (typeof (a._idd) != "undefined" && !a._isSeparator) {
                l = a._idd;
                a = null
            } else {
                a = a.parentNode
            }
        }
        a = null;
        if (l != null) {
            h.callEvent("onClick", [l]);
            if (h != null && h.isVisible != null && h.isVisible() && h.callEvent("onBeforeHide", ["select", j, l]) === true) {
                j.cancelBubble = true;
                h.hide()
            }
        }
    };
    this.separator = "DHXSEP_" + window.dhx4.newId();
    this.tpl = [];
    this._setTemplate = function (a) {
        this.tpl = a.split(",")
    };
    this.show = function (j) {
        var a = null;
        if (arguments.length == 1) {
            if (!j) {
                j = this.conf.id[0]
            } else {
                if (!this._idExists(j)) {
                    return
                }
            }
            if (this.conf.toolbar) {
                a = this.conf.toolbar._getItemDim(j)
            }
            if (this.conf.ribbon) {
                a = this.conf.ribbon._getItemDim(j)
            }
            if (this.conf.form) {
                a = this.conf.form._getItemDim(j)
            }
        } else {
            if (arguments.length == 4) {
                this._clearClick = true;
                a = {
                    left: arguments[0],
                    top: arguments[1],
                    width: arguments[2],
                    height: arguments[3]
                };
                j = null
            }
        }
        if (!a) {
            return
        }
        this.p.style.visibility = "hidden";
        this.p.style.display = "";
        this._setPos(a);
        this.p.style.zIndex = window.dhx4.zim.reserve(this.conf.zi);
        this.p.style.visibility = "visible";
        this._lastId = j;
        this.callEvent("onShow", [j])
    };
    this._setPos = function (H, m) {
        var u = H.left;
        var r = H.top;
        var A = H.width;
        var K = H.height;
        this._posData = {
            left: u,
            top: r,
            width: A,
            height: K
        };
        var M = window.dhx4.screenDim();
        var E = m || this.mode;
        if (typeof (m) == "undefined") {
            m = false
        }
        var O = {
            top: (r - this.p.offsetHeight) - M.top,
            bottom: M.bottom - (r + K + this.p.offsetHeight),
            left: u - this.p.offsetWidth - M.left,
            right: M.right - (u + A + this.p.offsetWidth)
        };
        if (!m && O[E] < 0) {
            var I = this._getAvailPos(E, O);
            if (I !== false) {
                this._setPos(H, I);
                return
            }
        }
        if (E == "top" || E == "bottom") {
            var C = this.skinParams[this.conf.skin].t2;
            var v = this.skinParams[this.conf.skin].t3;
            var q = Math.round(this.p.offsetWidth / 2);
            var a = Math.round(this.p.lastChild.offsetWidth / 2);
            if (u < M.left) {
                var L = Math.min(u + A, M.left);
                A = u + A - L;
                u = L
            }
            if (u + A > M.right) {
                A = M.right - u
            }
            var s = Math.round(u + A / 2);
            var l = s - q;
            var J = s - C - a;
            var o = s + a + C - this.p.offsetWidth;
            if (l < M.left - v) {
                l = Math.min(M.left - v, J)
            } else {
                if (l + this.p.offsetWidth > M.right + v) {
                    l = Math.max(o, M.right + v - this.p.offsetWidth)
                }
            }
            this.p.style.left = l + "px";
            this.p.style.top = (E == "top" ? r - this.p.offsetHeight : r + K) + "px";
            s = s - l - a;
            this.p.lastChild.className = "dhx_popup_arrow dhx_popup_arrow_" + E;
            this.p.lastChild.style.top = (E == "top" ? this.p.offsetHeight - this.p.lastChild.offsetHeight : 0) + "px";
            this.p.lastChild.style.left = s + "px"
        }
        if (E == "left" || E == "right") {
            var C = this.skinParams[this.conf.skin].t0;
            var v = this.skinParams[this.conf.skin].t1;
            var n = Math.round(this.p.offsetHeight / 2);
            var Q = Math.round(this.p.lastChild.offsetHeight / 2);
            if (r < M.top) {
                var j = Math.min(r + K, M.top);
                K = r + K - j;
                r = j
            }
            if (r + K > M.bottom) {
                K = M.bottom - r
            }
            var s = Math.round(r + K / 2);
            var F = s - n;
            var P = s - C - Q;
            var N = s + Q + C - this.p.offsetHeight;
            if (F < M.top - v) {
                F = Math.min(M.top - v, P)
            } else {
                if (F + this.p.offsetHeight > M.bottom + v) {
                    F = Math.max(N, M.bottom + v - this.p.offsetHeight)
                }
            }
            this.p.style.left = (E == "left" ? u - this.p.offsetWidth : u + A) + "px";
            this.p.style.top = F + "px";
            s = s - F - Q;
            this.p.lastChild.className = "dhx_popup_arrow dhx_popup_arrow_" + E;
            this.p.lastChild.style.left = (E == "left" ? this.p.offsetWidth - this.p.lastChild.offsetWidth : 0) + "px";
            this.p.lastChild.style.top = s + "px"
        }
        if (this._IEDisp && this._nodeId != null) {
            var D = document.getElementById(this._nodeId);
            window.setTimeout(function () {
                D.style.visibility = "visible";
                D = null
            }, 1)
        }
    };
    this._getAvailPos = function (r, o) {
        var l = {
            top: ["bottom", "right", "left"],
            bottom: ["top", "right", "left"],
            left: ["right", "bottom", "top"],
            right: ["left", "bottom", "top"]
        };
        var m = null;
        for (var n = 0; n < l[r].length; n++) {
            if (m == null && o[l[r][n]] > 0) {
                m = l[r][n]
            }
        }
        if (m == null) {
            m = "bottom";
            for (var j in o) {
                if (o[j] > o[m]) {
                    m = j
                }
            }
        }
        if (m == r) {
            return false
        }
        return m
    };
    this._repaint = function () {
        if (this.isVisible()) {
            this._setPos(this._posData)
        }
    };
    this.clear = function () {
        if (this._nodeObj) {
            if (this.conf.isIE && typeof (dhtmlXLayoutObject) != "undefined" && this._nodeObj instanceof dhtmlXLayoutObject) {
                this.p.onmousedown = null
            }
            if (this._nodeObj.unload) {
                this._nodeObj.unload()
            } else {
                if (this._nodeObj.destruct) {
                    this._nodeObj.destruct()
                }
            }
            this._nodeObj = this._nodeId = null;
            if (this._nodeObjEv != null) {
                for (var j = 0; j < this._nodeObjEv.length; j++) {
                    this.detachEvent(this._nodeObjEv[j])
                }
                this._nodeObjEv = null
            }
        }
        if (this._IEHoverInited) {
            this._IEHoverClear()
        }
        var a = this.p.firstChild.firstChild.firstChild;
        while (a.childNodes.length > 0) {
            a.removeChild(a.lastChild)
        }
        a = null;
        this.itemData = {}
    };
    this.hide = function () {
        if (this.p.style.display != "none") {
            this.p.style.display = "none";
            window.dhx4.zim.clear(this.conf.zi);
            var a = this._lastId;
            this._lastId = null;
            this.callEvent("onHide", [a])
        }
    };
    this.isVisible = function () {
        return (this.p.style.display == "")
    };
    this.itemData = {};
    this.getItemData = function (a) {
        if (!a) {
            return this.itemData
        }
        if (this.itemData[a]) {
            return this.itemData[a]
        }
        return {}
    };
    this.setSkin = function (a) {
        this.conf.skin = a;
        this.p.className = "dhx_popup_" + this.conf.skin;
        if (this._nodeObj != null && typeof (this._nodeObj.setSkin) == "function") {
            this._nodeObj.setSkin(this.conf.skin)
        }
        this._repaint()
    };
    this.attachList = function (l, s) {
        this._setTemplate(l);
        this.clear();
        var m = this.p.firstChild.firstChild.firstChild;
        for (var o = 0; o < s.length; o++) {
            var n = document.createElement("TR");
            if (s[o] != this.separator) {
                if (typeof (s[o].id) == "undefined" || s[o].id == null) {
                    n._idd = window.dhx4.newId();
                    while (this.itemData[n._idd] != null) {
                        n._idd = window.dhx4.newId()
                    }
                } else {
                    n._idd = s[o].id
                }
                this.itemData[n._idd] = s[o]
            }
            m.appendChild(n);
            if (s[o] == this.separator) {
                n.className = "dhx_popup_sep";
                n._isSeparator = true;
                var u = document.createElement("TD");
                u.className = "dhx_popup_sep";
                u.colSpan = this.tpl.length;
                u.innerHTML = "<div class='dhx_popup_sep'>&nbsp;</div>";
                n.appendChild(u);
                u = null
            } else {
                for (var a = 0; a < this.tpl.length; a++) {
                    var j = "dhx_popup_td";
                    if (this._IEFirstLast && (this.tpl.length == 1 || a == 0 || a == this.tpl.length - 1)) {
                        if (this.tpl.length == 1) {
                            j += " dhx_popup_td_single"
                        } else {
                            j += (a == 0 ? " dhx_popup_td_first" : " dhx_popup_td_last")
                        }
                    }
                    var u = document.createElement("TD");
                    u.className = j;
                    u.innerHTML = s[o][this.tpl[a]] || "&nbsp;";
                    n.appendChild(u);
                    u = null
                }
                if (this._IEHover) {
                    n._IEHover = true;
                    if (!this._IEHoverInited) {
                        this._IEHoverInit()
                    }
                }
            }
            n = null
        }
        m = null;
        this._repaint()
    };
    this._attachNode = function (m, l) {
        this.clear();
        this._nodeId = "dhxpopup_node_" + window.dhx4.newId();
        var a = this.p.firstChild.firstChild.firstChild;
        var j = document.createElement("TR");
        j.className = "dhxnode";
        a.appendChild(j);
        var n = document.createElement("TD");
        n.className = "dhx_popup_td";
        n.innerHTML = "<div id='" + this._nodeId + "' style='position:relative;'></div>";
        if (l.width) {
            n.firstChild.style.width = l.width + "px"
        }
        if (l.height) {
            n.firstChild.style.height = l.height + "px"
        }
        j.appendChild(n);
        n = j = a = null;
        if (typeof (this["_attach_init_" + m]) == "function") {
            this["_attach_init_" + m](l);
            this._enableIEVFix()
        }
        this._repaint();
        return this._nodeObj
    };
    this.unload = function () {
        if (typeof (window.addEventListener) == "function") {
            window.removeEventListener("click", this._doOnClick, false);
            window.removeEventListener("keyup", this._doOnKeyUp, false);
            window.removeEventListener("unload", this._doOnUnload, false)
        } else {
            document.body.detachEvent("onclick", this._doOnClick, false);
            document.body.detachEvent("onkeyup", this._doOnKeyUp, false);
            document.body.detachEvent("onunload", this._doOnUnload, false)
        }
        this.clear();
        this._doOnClick = null;
        this._doOnUnload = null;
        this._doOnKeyUp = null;
        if (this.conf.toolbarEvent != null && this.conf.toolbar != null) {
            if (this.conf.toolbar.detachEvent != null) {
                this.conf.toolbar.detachEvent(this.conf.toolbarEvent)
            } else {
                this.conf.toolbar._getItemDim = null
            }
        }
        if (this.conf.ribbonEvent != null && this.conf.ribbon != null) {
            if (this.conf.ribbon.detachEvent != null) {
                this.conf.ribbon.detachEvent(this.conf.ribbonEvent)
            } else {
                this.conf.ribbon._getItemDim = null
            }
        }
        if (this.conf.slider) {
            for (var a = 0; a < this.conf.slider_events.length; a++) {
                this.conf.slider.detachEvent(this.conf.slider_events[a])
            }
            this.conf.slider_events = null;
            this._sliderShow = this._sliderHide = null;
            this.conf.slider = null
        }
        window.dhx4._eventable(this, "clear");
        this.attachList = this.attachAccordion = this.attachCalendar = this.attachForm = this.attachGrid = this.attachLayout = this.attachTabbar = this.attachTree = this.attachHTML = this.attachObject = this._attachNode = null;
        this.show = this.hide = this.isVisible = this._setTemplate = this._repaint = this._setPos = this.getItemData = this.clear = this._idExists = this._doOnToolbarClick = this._doOnRibbonClick = this.setSkin = null;
        this.tpl = this.itemData = this.separator = this.mode = null;
        this._clearClick = this._lastId = this._posData = this.skinParams = this.skinParent = null;
        this.p.onclick = null;
        this.p.parentNode.removeChild(this.p);
        this.p = null;
        this.conf.toolbar = this.conf.toolbarEvent = this.conf.ribbon = this.conf.ribbonEvent = this.conf.form = this.conf.id = null;
        this.conf = null;
        this._IEHover = this._IEHoverTM = this._IEHoverInit = this._IEHoverClear = this._IEHoverRender = this._IEHoverInited = null;
        this._IEDisp = null;
        this.unload = null;
        h = null
    };
    window.dhx4._eventable(this);
    this._doOnClick = function (n) {
        n = n || event;
        if (h._clearClick) {
            h._clearClick = false;
            return
        }
        if (h.conf.form != null) {
            var o;
            var j = (n.target || n.srcElement);
            if ((j.tagName || "").toLowerCase() == "option") {
                j = j.parentNode
            }
            if (j.className != null && j.className.search("dhxform") >= 0) {
                if (j.parentNode != null && j.parentNode.parentNode != null && j.parentNode.parentNode._idd != null) {
                    o = j.parentNode.parentNode._idd;
                    if (j.parentNode.parentNode._type == "ra") {
                        o = [j.parentNode.parentNode._group, j.parentNode.parentNode._value]
                    }
                }
            } else {
                var a = true;
                var l = false;
                while (a && !l) {
                    var m = (j.className || "").toLowerCase();
                    if (m.length > 0) {
                        l = (m == "dhxform_btn" || m.search(/dhxeditor_inside/gi) >= 0 || m == "dhxcombo_input" || m.search(/dhxcombolist/gi) >= 0)
                    }
                    j = j.parentNode;
                    a = (j != null)
                }
                if (l) {
                    return
                }
            }
            j = null;
            if (o != null && h._idExists(o)) {
                return
            }
        }
        if (h.isVisible() && h.callEvent("onBeforeHide", ["click", n]) === true) {
            h.hide()
        }
    };
    this._doOnKeyUp = function (a) {
        a = a || event;
        if (a.keyCode == 27) {
            if (h.isVisible() && h.callEvent("onBeforeHide", ["esc", a]) === true) {
                h.hide()
            }
        }
    };
    this._doOnUnload = function () {
        h.unload()
    };
    if (typeof (window.addEventListener) == "function") {
        window.addEventListener("click", this._doOnClick, false);
        window.addEventListener("keyup", this._doOnKeyUp, false);
        window.addEventListener("unload", this._doOnUnload, false)
    } else {
        document.body.attachEvent("onclick", this._doOnClick, false);
        document.body.attachEvent("onkeyup", this._doOnKeyUp, false);
        document.body.attachEvent("onunload", this._doOnUnload, false)
    }
    this._idExists = function (l) {
        var a = false;
        for (var j = 0; j < this.conf.id.length; j++) {
            if (this.conf.id[j] instanceof Array) {
                a = a || (this.conf.id[j][0] == l[0] && this.conf.id[j][1] == l[1])
            } else {
                a = a || this.conf.id[j] == l
            }
        }
        return a
    };
    this._IEDisp = (this.conf.isIE && (navigator.userAgent.search("MSIE 6.0") >= 0 || document.compatMode != "CSS1Compat"));
    this._IEHover = (this.conf.isIE && navigator.userAgent.search("MSIE 6.0") >= 0);
    if (this._IEHover) {
        this._IEHoverInit = function () {
            this.p.onmouseover = function () {
                var a = event.srcElement;
                while (a != this && a._IEHover != true) {
                    a = a.parentNode
                }
                if (a._IEHover) {
                    if (h._IEHoverTM) {
                        window.clearTimeout(h._IEHoverTM)
                    }
                    if (h._lastIEHover == a) {
                        return
                    }
                    h._IEHoverRender(a);
                    a = null
                }
            };
            this.p.onmouseout = function () {
                if (h._IEHoverTM) {
                    window.clearTimeout(h._IEHoverTM)
                }
                h._IEHoverTM = window.setTimeout(function () {
                    h._IEHoverRender(null)
                }, 1)
            };
            this._IEHoverRender = function (a) {
                if (this._lastIEHover != null) {
                    if (this._lastIEHover.className.search(/tr_hover/gi) >= 0) {
                        this._lastIEHover.className = this._lastIEHover.className.replace(/\s{0,}tr_hover/gi, "");
                        this._lastIEHover = null
                    }
                }
                if (a != null && a.className.search(/tr_hover/gi) < 0) {
                    a.className += " tr_hover";
                    h._lastIEHover = a
                }
            };
            this._IEHoverInited = true
        };
        this._IEHoverClear = function () {
            this.p.onmouseover = null;
            this.p.onmouseout = null;
            this._IEHoverInited = false
        }
    }
    this._IEFirstLast = (this.conf.isIE && navigator.userAgent.search(/MSIE [6,7,8]\.0/i) >= 0);
    this._enableIEVFix = function () {
        if (this.conf.isIE && navigator.userAgent.search("MSIE 6.0") >= 0) {
            var j = this.attachEvent("onHide", function () {
                document.getElementById(this._nodeId).style.visibility = "hidden"
            });
            var a = this.attachEvent("onShow", function () {
                document.getElementById(this._nodeId).style.visibility = "visible"
            });
            if (this._nodeObjEv == null) {
                this._nodeObjEv = []
            }
            this._nodeObjEv.push(j, a)
        }
    };
    if (typeof (window.dhtmlXToolbarObject) != "undefined" && this.conf.toolbar != null && this.conf.toolbar instanceof window.dhtmlXToolbarObject && this.conf.id != null) {
        if (!(this.conf.id instanceof Array)) {
            this.conf.id = [this.conf.id]
        }
        this.skinParent = this.conf.toolbar.conf.skin;
        this._doOnToolbarClick = function (j) {
            for (var a = 0; a < h.conf.id.length; a++) {
                if (j == h.conf.id[a]) {
                    if (j != h._lastId) {
                        h.show(j);
                        h._clearClick = true
                    }
                }
            }
        };
        if (typeof (dhtmlXToolbarObject.prototype._getItemDim) == "undefined") {
            dhtmlXToolbarObject.prototype._getItemDim = function (l) {
                var a = this.objPull[this.idPrefix + l];
                var j = {
                    left: window.dhx4.absLeft(a.obj),
                    top: window.dhx4.absTop(a.obj),
                    width: a.obj.offsetWidth + (a.arw ? a.arw.offsetWidth : 0),
                    height: a.obj.offsetHeight
                };
                a = null;
                return j
            }
        }
        this.conf.toolbarEvent = this.conf.toolbar.attachEvent("onClick", this._doOnToolbarClick)
    }
    if (typeof (window.dhtmlXRibbon) != "undefined" && this.conf.ribbon != null && this.conf.ribbon instanceof window.dhtmlXRibbon && this.conf.id != null) {
        if (!(this.conf.id instanceof Array)) {
            this.conf.id = [this.conf.id]
        }
        this.skinParent = this.conf.ribbon.conf.skin;
        this._doOnRibbonClick = function (j) {
            for (var a = 0; a < h.conf.id.length; a++) {
                if (j == h.conf.id[a]) {
                    if (j != h._lastId) {
                        h.show(j);
                        h._clearClick = true
                    }
                }
            }
        };
        if (typeof (dhtmlXRibbon.prototype._getItemDim) == "undefined") {
            dhtmlXRibbon.prototype._getItemDim = function (l) {
                var a = this._items[l].base;
                var j = {
                    left: window.dhx4.absLeft(a),
                    top: window.dhx4.absTop(a),
                    width: a.offsetWidth,
                    height: a.offsetHeight
                };
                a = null;
                return j
            }
        }
        this.conf.ribbonEvent = this.conf.ribbon.attachEvent("_showPopup", this._doOnRibbonClick)
    }
    if (typeof (window.dhtmlXForm) != "undefined" && this.conf.form != null && this.conf.form instanceof window.dhtmlXForm && this.conf.id != null) {
        if (!(this.conf.id instanceof Array)) {
            this.conf.id = [this.conf.id]
        }
        if (!this.conf.mode) {
            this.mode = "right"
        }
        this.skinParent = this.conf.form.skin;
        if (typeof (dhtmlXForm.prototype._getItemDim) == "undefined") {
            dhtmlXForm.prototype._getItemDim = function (a, j) {
                return this.doWithItem(a, "_getDim")
            };
            for (var c in {
                input: 1,
                password: 1,
                select: 1,
                multiselect: 1,
                checkbox: 1,
                radio: 1,
                button: 1,
                combo: 1,
                btn2state: 1,
                calendar: 1,
                colorpicker: 1,
                editor: 1
            }) {
                if (dhtmlXForm.prototype.items[c] != null) {
                    dhtmlXForm.prototype.items[c]._getDim = function (j) {
                        var a = j;
                        if ({
                            ta: true,
                            pw: true,
                            se: true,
                            calendar: true,
                            colorpicker: 1,
                            editor: true
                        }[j._type]) {
                            a = j.childNodes[j._ll ? 1 : 0].childNodes[0]
                        }
                        if ({
                            ch: true,
                            ra: true,
                            btn2state: true
                        }[j._type]) {
                            a = j.childNodes[j._ll ? 1 : 0].childNodes[1]
                        }
                        if ({
                            bt: true
                        }[j._type]) {
                            a = j.firstChild
                        }
                        if ({
                            combo: true
                        }[j._type]) {
                            a = j._combo.DOMParent.firstChild
                        }
                        var l = {
                            left: window.dhx4.absLeft(a),
                            top: window.dhx4.absTop(a),
                            width: a.offsetWidth,
                            height: a.offsetHeight
                        };
                        a = null;
                        return l
                    }
                }
            }
        }
    }
    if (typeof (window.dhtmlXSlider) != "undefined" && this.conf.slider != null && this.conf.slider instanceof window.dhtmlXSlider) {
        if (!this.conf.mode) {
            this.mode = "top"
        }
        this.conf.slider_tm = null;
        this._sliderShow = function () {
            if (h.conf.slider_tm) {
                window.clearTimeout(h.conf.slider_tm)
            }
            var a = h.conf.slider._nodes.runner;
            var j = {
                left: window.dhx4.absLeft(a),
                top: window.dhx4.absTop(a),
                width: a.offsetWidth,
                height: a.offsetHeight
            };
            h.show(j.left, j.top, j.width, j.height)
        };
        this._sliderHide = function () {
            h.conf.slider_tm = window.setTimeout(function () {
                h.hide()
            }, 200)
        };
        this.conf.slider_events = [this.conf.slider.attachEvent("_onRunnerMouseDown", this._sliderShow), this.conf.slider.attachEvent("_onRunnerMouseUp", this._sliderHide), this.conf.slider.attachEvent("onChange", this._sliderShow)]
    }
    this.setSkin(this.skinParent || this.conf.skin || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhx_popup") || "dhx_skyblue");
    return this
}
dhtmlXPopup.prototype.attachObject = function (a) {
    return this._attachNode("object", {
        obj: a
    })
};
dhtmlXPopup.prototype._attach_init_object = function (a) {
    this._nodeObj = (typeof (a.obj) == "string" ? document.getElementById(a.obj) : a.obj);
    a.obj = null;
    document.getElementById(this._nodeId).appendChild(this._nodeObj);
    this._nodeObj.style.display = "";
    this._nodeObj.style.visibility = "visible"
};
dhtmlXPopup.prototype.attachHTML = function (a) {
    return this._attachNode("html", {
        html: a
    })
};
dhtmlXPopup.prototype._attach_init_html = function (a) {
    document.getElementById(this._nodeId).innerHTML = a.html;
    this._nodeObj = {
        text: a.html
    }
};
dhtmlXPopup.prototype.attachForm = function (a) {
    return this._attachNode("form", {
        struct: a
    })
};
dhtmlXPopup.prototype._attach_init_form = function (c) {
    var a = this;
    this._nodeObj = new dhtmlXForm(this._nodeId, c.struct);
    this._nodeObj.setSkin(this.conf.skin);
    this._nodeObj.attachEvent("_onBeforeEditorAccess", function () {
        a._clearClick = true
    })
};
dhtmlXPopup.prototype.attachCalendar = function () {
    return this._attachNode("calendar", {})
};
dhtmlXPopup.prototype._attach_init_calendar = function (a) {
    this._nodeObj = new dhtmlXCalendarObject(this._nodeId);
    this._nodeObj.setSkin(this.conf.skin);
    this._nodeObj.show()
};
dhtmlXPopup.prototype.attachGrid = function (c, a) {
    return this._attachNode("grid", {
        width: c || 400,
        height: a || 200
    })
};
dhtmlXPopup.prototype._attach_init_grid = function () {
    this._nodeObj = new dhtmlXGridObject(this._nodeId);
    this._nodeObj.setSkin(this.conf.skin)
};
dhtmlXPopup.prototype.attachTree = function (g, c, a) {
    return this._attachNode("tree", {
        width: g || 400,
        height: c || 200,
        rootId: a || 0
    })
};
dhtmlXPopup.prototype._attach_init_tree = function (a) {
    this._nodeObj = new dhtmlXTreeObject(this._nodeId, "100%", "100%", (a.rootId))
};
dhtmlXPopup.prototype.attachLayout = function (c, a, g) {
    return this._attachNode("layout", {
        width: c || 400,
        height: a || 200,
        pattern: g || "3L"
    })
};
dhtmlXPopup.prototype._attach_init_layout = function (a) {
    this._nodeObj = new dhtmlXLayoutObject(this._nodeId, a.pattern, this.conf.skin)
};
dhtmlXPopup.prototype.attachAccordion = function (g, a, c) {
    return this._attachNode("accordion", {
        width: g || 400,
        height: a || 200,
        conf: c || {}
    })
};
dhtmlXPopup.prototype._attach_init_accordion = function (a) {
    a.conf.parent = this._nodeId;
    a.conf.skin = this.conf.skin;
    this._nodeObj = new dhtmlXAccordion(a.conf)
};
dhtmlXPopup.prototype.attachTabbar = function (g, a, c) {
    if (typeof (c) == "string") {
        c = {
            mode: c
        }
    } else {
        if (typeof (c) != "object" || c == null) {
            c = {}
        }
    }
    return this._attachNode("tabbar", {
        width: g || 400,
        height: a || 200,
        conf: c
    })
};
dhtmlXPopup.prototype._attach_init_tabbar = function (a) {
    a.conf.parent = this._nodeId;
    a.conf.skin = this.conf.skin;
    this._nodeObj = new dhtmlXTabBar(a.conf)
};
dhtmlXPopup.prototype.attachEditor = function (g, a, c) {
    return this._attachNode("editor", {
        width: g || 400,
        height: a || 200,
        conf: c || {}
    })
};
dhtmlXPopup.prototype._attach_init_editor = function (c) {
    document.getElementById(this._nodeId).className = "dhxeditor_" + this.conf.skin;
    c.conf.parent = this._nodeId;
    if (c.conf.skin == null) {
        c.conf.skin = this.conf.skin
    }
    this._nodeObj = new dhtmlXEditor(c.conf);
    var a = this.attachEvent("onShow", function () {
        if (this._nodeObj instanceof window.dhtmlXEditor) {
            this._nodeObj.setSizes()
        }
    });
    if (this._nodeObjEv == null) {
        this._nodeObjEv = []
    }
    this._nodeObjEv.push(a)
};
dhtmlXPopup.prototype.attachColorPicker = function (a) {
    if (typeof (a) != "object" || a == null) {
        a = {}
    }
    return this._attachNode("colorpicker", {
        conf: a
    })
};
dhtmlXPopup.prototype._attach_init_colorpicker = function (a) {
    a.conf.skin = this.conf.skin;
    a.conf.parent = this._nodeId;
    this._nodeObj = new dhtmlXColorPicker(a.conf)
};

function dhtmlXMenuObject(j, l) {
    var h = this;
    this.conf = {
        skin: (l || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxmenu") || "dhx_skyblue"),
        mode: "web",
        align: "left",
        is_touched: false,
        selected: -1,
        last_click: -1,
        fixed_pos: false,
        rtl: false,
        icons_path: "",
        arrow_ff_fix: (navigator.userAgent.indexOf("MSIE") >= 0 && document.compatMode == "BackCompat"),
        live_id: window.dhx4.newId(),
        tags: {
            root: "menu",
            item: "item",
            text_ext: "itemtext",
            userdata: "userdata",
            tooltip: "tooltip",
            hotkey: "hotkey",
            href: "href"
        },
        autoload: {},
        hide_tm: {},
        top_mode: true,
        top_tmtime: 200,
        v_enabled: false,
        v: {
            x1: null,
            x2: null,
            y1: null,
            y2: null
        },
        dir_toplv: "bottom",
        dir_sublv: "right",
        auto_overflow: false,
        overflow_limit: 0,
        of_utm: null,
        of_utime: 20,
        of_ustep: 3,
        of_dtm: null,
        of_dtime: 20,
        of_dstep: 3,
        tm_sec: 400,
        tm_handler: null,
        dload: false,
        dload_url: "",
        dload_icon: false,
        dload_params: {
            action: "loadMenu"
        },
        dload_pid: "parentId",
        tl_botmarg: 1,
        tl_rmarg: 0,
        tl_ofsleft: 1,
        context: false,
        ctx_zoneid: false,
        ctx_autoshow: true,
        ctx_autohide: true,
        ctx_hideall: true,
        ctx_zones: {},
        ctx_baseid: null,
        selected_sub: [],
        opened_poly: []
    };
    if (typeof (j) == "object" && j != null && typeof (j.tagName) == "undefined") {
        if (j.icons_path != null || j.icon_path != null) {
            this.conf.icons_path = (j.icons_path || j.icon_path)
        }
        if (j.skin != null) {
            this.conf.skin = j.skin
        }
        if (j.visible_area) {
            this.conf.v_enabled = true;
            this.conf.v = {
                x1: j.visible_area.x1,
                x2: j.visible_area.x2,
                y1: j.visible_area.y1,
                y2: j.visible_area.y2
            }
        }
        for (var g in {
            json: 1,
            xml: 1,
            items: 1,
            top_text: 1,
            align: 1,
            open_mode: 1,
            overflow: 1,
            dynamic: 1,
            dynamic_icon: 1,
            context: 1,
            onload: 1,
            onclick: 1,
            oncheckboxclick: 1,
            onradioclick: 1
        }) {
            if (j[g] != null) {
                this.conf.autoload[g] = j[g]
            }
        }
        j = j.parent
    }
    if (j == null) {
        this.base = document.body
    } else {
        var c = (typeof (j) == "string" ? document.getElementById(j) : j);
        if (c != null) {
            this.base = c;
            if (!this.base.id) {
                this.base.id = (new Date()).valueOf()
            }
            this.base.className += " dhtmlxMenu_" + this.conf.skin + "_Middle dir_left";
            this.base._autoSkinUpdate = true;
            if (this.base.oncontextmenu) {
                this.base._oldContextMenuHandler = this.base.oncontextmenu
            }
            this.conf.ctx_baseid = this.base.id;
            this.base.onselectstart = function (a) {
                a = a || event;
                if (a.preventDefault) {
                    a.preventDefault()
                } else {
                    a.returnValue = false
                }
                return false
            };
            this.base.oncontextmenu = function (a) {
                a = a || event;
                if (a.preventDefault) {
                    a.preventDefault()
                } else {
                    a.returnValue = false
                }
                return false
            }
        } else {
            this.base = document.body
        }
    }
    this.idPrefix = "";
    this.topId = "dhxWebMenuTopId";
    this.idPull = {};
    this.itemPull = {};
    this.userData = {};
    this.radio = {};
    this.setSkin = function (n) {
        var o = this.conf.skin;
        this.conf.skin = n;
        switch (this.conf.skin) {
        case "dhx_skyblue":
        case "dhx_web":
            this.conf.tl_botmarg = 2;
            this.conf.tl_rmarg = 1;
            this.conf.tl_ofsleft = 1;
            break;
        case "dhx_terrace":
            this.conf.tl_botmarg = 0;
            this.conf.tl_rmarg = 0;
            this.conf.tl_ofsleft = 0;
            break
        }
        if (this.base._autoSkinUpdate) {
            this.base.className = this.base.className.replace("dhtmlxMenu_" + o + "_Middle", "") + " dhtmlxMenu_" + this.conf.skin + "_Middle"
        }
        for (var m in this.idPull) {
            this.idPull[m].className = String(this.idPull[m].className).replace(o, this.conf.skin)
        }
    };
    this.setSkin(this.conf.skin);
    this._addSubItemToSelected = function (n, m) {
        var a = true;
        for (var o = 0; o < this.conf.selected_sub.length; o++) {
            if ((this.conf.selected_sub[o][0] == n) && (this.conf.selected_sub[o][1] == m)) {
                a = false
            }
        }
        if (a == true) {
            this.conf.selected_sub.push(new Array(n, m))
        }
        return a
    };
    this._removeSubItemFromSelected = function (r, o) {
        var a = new Array();
        var n = false;
        for (var s = 0; s < this.conf.selected_sub.length; s++) {
            if ((this.conf.selected_sub[s][0] == r) && (this.conf.selected_sub[s][1] == o)) {
                n = true
            } else {
                a[a.length] = this.conf.selected_sub[s]
            }
        }
        if (n == true) {
            this.conf.selected_sub = a
        }
        return n
    };
    this._getSubItemToDeselectByPolygon = function (r) {
        var a = new Array();
        for (var s = 0; s < this.conf.selected_sub.length; s++) {
            if (this.conf.selected_sub[s][1] == r) {
                a[a.length] = this.conf.selected_sub[s][0];
                a = a.concat(this._getSubItemToDeselectByPolygon(this.conf.selected_sub[s][0]));
                var o = true;
                for (var n = 0; n < this.conf.opened_poly.length; n++) {
                    if (this.conf.opened_poly[n] == this.conf.selected_sub[s][0]) {
                        o = false
                    }
                }
                if (o == true) {
                    this.conf.opened_poly[this.conf.opened_poly.length] = this.conf.selected_sub[s][0]
                }
                this.conf.selected_sub[s][0] = -1;
                this.conf.selected_sub[s][1] = -1
            }
        }
        return a
    };
    this._hidePolygon = function (a) {
        if (this.idPull["polygon_" + a] != null) {
            if (this.idPull["polygon_" + a]._zId != null) {
                window.dhx4.zim.clear(this.idPull["polygon_" + a]._zId)
            }
            if (typeof (this._menuEffect) != "undefined" && this._menuEffect !== false) {
                this._hidePolygonEffect("polygon_" + a)
            } else {
                if (this.idPull["polygon_" + a].style.display == "none") {
                    return
                }
                this.idPull["polygon_" + a].style.display = "none";
                if (this.idPull["arrowup_" + a] != null) {
                    this.idPull["arrowup_" + a].style.display = "none"
                }
                if (this.idPull["arrowdown_" + a] != null) {
                    this.idPull["arrowdown_" + a].style.display = "none"
                }
                this._updateItemComplexState(a, true, false);
                if (window.dhx4.isIE6 && this.idPull["polygon_" + a + "_ie6cover"] != null) {
                    this.idPull["polygon_" + a + "_ie6cover"].style.display = "none"
                }
            }
            a = String(a).replace(this.idPrefix, "");
            if (a == this.topId) {
                a = null
            }
            this.callEvent("onHide", [a]);
            if (a != null && this.conf.skin == "dhx_terrace" && this.itemPull[this.idPrefix + a].parent == this.idPrefix + this.topId) {
                this._improveTerraceButton(this.idPrefix + a, true)
            }
        }
    };
    this._showPolygon = function (H, n) {
        var M = this._countVisiblePolygonItems(H);
        if (M == 0) {
            return
        }
        var I = "polygon_" + H;
        if ((this.idPull[I] != null) && (this.idPull[H] != null)) {
            if (this.conf.top_mode && this.conf.mode == "web" && !this.conf.context) {
                if (!this.idPull[H]._mouseOver && n == this.conf.dir_toplv) {
                    return
                }
            }
            if (!this.conf.fixed_pos) {
                this._autoDetectVisibleArea()
            }
            var J = 0;
            var L = 0;
            var O = null;
            var D = null;
            if (this.idPull[I]._zId == null) {
                this.idPull[I]._zId = window.dhx4.newId()
            }
            this.idPull[I]._zInd = window.dhx4.zim.reserve(this.idPull[I]._zId);
            this.idPull[I].style.visibility = "hidden";
            this.idPull[I].style.left = "0px";
            this.idPull[I].style.top = "0px";
            this.idPull[I].style.display = "";
            this.idPull[I].style.zIndex = this.idPull[I]._zInd;
            if (this.conf.auto_overflow) {
                if (this.idPull[I].firstChild.offsetHeight > this.conf.v.y1 + this.conf.v.y2) {
                    var C = Math.floor((this.conf.v.y2 - this.conf.v.y1 - 35) / 24);
                    this.conf.overflow_limit = C
                } else {
                    this.conf.overflow_limit = 0;
                    if (this.idPull["arrowup_" + H] != null) {
                        this._removeUpArrow(String(H).replace(this.idPrefix, ""))
                    }
                    if (this.idPull["arrowdown_" + H] != null) {
                        this._removeDownArrow(String(H).replace(this.idPrefix, ""))
                    }
                }
            }
            if (this.conf.overflow_limit > 0 && this.conf.overflow_limit < M) {
                if (this.idPull["arrowup_" + H] == null) {
                    this._addUpArrow(String(H).replace(this.idPrefix, ""))
                }
                if (this.idPull["arrowdown_" + H] == null) {
                    this._addDownArrow(String(H).replace(this.idPrefix, ""))
                }
                O = this.idPull["arrowup_" + H];
                O.style.display = "none";
                D = this.idPull["arrowdown_" + H];
                D.style.display = "none"
            }
            if (this.conf.overflow_limit > 0) {
                if (this.conf.overflow_limit < M) {
                    this.idPull[I].childNodes[1].style.height = 24 * this.conf.overflow_limit + "px";
                    O.style.width = D.style.width = this.idPull[I].childNodes[1].style.width = this.idPull[I].childNodes[1].childNodes[0].offsetWidth + "px";
                    this.idPull[I].childNodes[1].scrollTop = 0;
                    O.style.display = "";
                    J = O.offsetHeight;
                    D.style.display = "";
                    L = D.offsetHeight
                } else {
                    this.idPull[I].childNodes[1].style.height = "";
                    this.idPull[I].childNodes[1].style.width = ""
                }
            }
            if (this.itemPull[H] != null) {
                var v = "polygon_" + this.itemPull[H]["parent"]
            } else {
                if (this.conf.context) {
                    var v = this.idPull[this.idPrefix + this.topId]
                }
            }
            var a = (this.idPull[H].tagName != null ? window.dhx4.absLeft(this.idPull[H]) : this.idPull[H][0]);
            var N = (this.idPull[H].tagName != null ? window.dhx4.absTop(this.idPull[H]) : this.idPull[H][1]);
            var m = (this.idPull[H].tagName != null ? this.idPull[H].offsetWidth : 0);
            var o = (this.idPull[H].tagName != null ? this.idPull[H].offsetHeight : 0);
            var u = 0;
            var s = 0;
            var A = this.idPull[I].offsetWidth;
            var K = this.idPull[I].childNodes[1].offsetHeight + J + L;
            if (n == "bottom") {
                if (this.conf.rtl) {
                    u = a + (m != null ? m : 0) - A
                } else {
                    if (this.conf.align == "right") {
                        u = a + m - A
                    } else {
                        u = a - 1 + (n == this.conf.dir_toplv ? this.conf.tl_rmarg : 0)
                    }
                }
                s = N - 1 + o + this.conf.tl_botmarg
            }
            if (n == "right") {
                u = a + m - 1;
                s = N + 2
            }
            if (n == "left") {
                u = a - this.idPull[I].offsetWidth + 2;
                s = N + 2
            }
            if (n == "top") {
                u = a - 1;
                s = N - K + 2
            }
            if (this.conf.fixed_pos) {
                var F = 65536;
                var E = 65536
            } else {
                var F = (this.conf.v.x2 != null ? this.conf.v.x2 : 0);
                var E = (this.conf.v.y2 != null ? this.conf.v.y2 : 0);
                if (F == 0) {
                    if (window.innerWidth) {
                        F = window.innerWidth;
                        E = window.innerHeight
                    } else {
                        F = document.body.offsetWidth;
                        E = document.body.scrollHeight
                    }
                }
            }
            if (u + A > F && !this.conf.rtl) {
                u = a - A + 2
            }
            if (u < this.conf.v.x1 && this.conf.rtl) {
                u = a + m - 2
            }
            if (u < 0) {
                u = 0
            }
            if (s + K > E && this.conf.v.y2 != null) {
                s = Math.max(N + o - K + 2, (this.conf.v_enabled ? this.conf.v.y1 + 2 : 2));
                if (this.conf.context && this.idPrefix + this.topId == H && D != null) {
                    s = s - 2
                }
                if (this.itemPull[H] != null && !this.conf.context) {
                    if (this.itemPull[H]["parent"] == this.idPrefix + this.topId) {
                        s = s - this.base.offsetHeight
                    }
                }
            }
            this.idPull[I].style.left = u + "px";
            this.idPull[I].style.top = s + "px";
            if (typeof (this._menuEffect) != "undefined" && this._menuEffect !== false) {
                this._showPolygonEffect(I)
            } else {
                this.idPull[I].style.visibility = "";
                if (this.conf.overflow_limit > 0 && this.conf.overflow_limit < M) {
                    this.idPull[I].childNodes[1].scrollTop = 0;
                    this._checkArrowsState(H)
                }
                if (window.dhx4.isIE6) {
                    var r = I + "_ie6cover";
                    if (this.idPull[r] == null) {
                        var q = document.createElement("IFRAME");
                        q.className = "dhtmlxMenu_IE6CoverFix_" + this.conf.skin;
                        q.frameBorder = 0;
                        q.setAttribute("src", "javascript:false;");
                        document.body.insertBefore(q, document.body.firstChild);
                        this.idPull[r] = q
                    }
                    this.idPull[r].style.left = u + "px";
                    this.idPull[r].style.top = s + "px";
                    this.idPull[r].style.width = this.idPull[I].offsetWidth + "px";
                    this.idPull[r].style.height = this.idPull[I].offsetHeight + "px";
                    this.idPull[r].style.zIndex = this.idPull[I].style.zIndex - 1;
                    this.idPull[r].style.display = ""
                }
            }
            H = String(H).replace(this.idPrefix, "");
            if (H == this.topId) {
                H = null
            }
            this.callEvent("onShow", [H]);
            if (H != null && this.conf.skin == "dhx_terrace" && this.itemPull[this.idPrefix + H].parent == this.idPrefix + this.topId) {
                this._improveTerraceButton(this.idPrefix + H, false)
            }
        }
    };
    this._redistribSubLevelSelection = function (r, o) {
        while (this.conf.opened_poly.length > 0) {
            this.conf.opened_poly.pop()
        }
        var a = this._getSubItemToDeselectByPolygon(o);
        this._removeSubItemFromSelected(-1, -1);
        for (var m = 0; m < a.length; m++) {
            if ((this.idPull[a[m]] != null) && (a[m] != r)) {
                if (this.itemPull[a[m]]["state"] == "enabled") {
                    this.idPull[a[m]].className = "sub_item"
                }
            }
        }
        for (var m = 0; m < this.conf.opened_poly.length; m++) {
            if (this.conf.opened_poly[m] != o) {
                this._hidePolygon(this.conf.opened_poly[m])
            }
        }
        if (this.itemPull[r]["state"] == "enabled") {
            this.idPull[r].className = "sub_item_selected";
            if (this.itemPull[r]["complex"] && this.conf.dload && (this.itemPull[r]["loaded"] == "no")) {
                if (this.conf.dload_icon == true) {
                    this._updateLoaderIcon(r, true)
                }
                this.itemPull[r].loaded = "get";
                var n = r.replace(this.idPrefix, "");
                this._dhxdataload.onBeforeXLS = function () {
                    var s = {
                        params: {}
                    };
                    s.params[this.conf.dload_pid] = n;
                    for (var q in this.conf.dload_params) {
                        s.params[q] = this.conf.dload_params[q]
                    }
                    return s
                };
                this.loadStruct(this.conf.dload_url)
            }
            if (this.itemPull[r]["complex"] || (this.conf.dload && (this.itemPull[r]["loaded"] == "yes"))) {
                if ((this.itemPull[r]["complex"]) && (this.idPull["polygon_" + r] != null)) {
                    this._updateItemComplexState(r, true, true);
                    this._showPolygon(r, this.conf.dir_sublv)
                }
            }
            this._addSubItemToSelected(r, o);
            this.conf.selected = r
        }
    };
    this._doOnClick = function (n, x, r) {
        this.conf.last_click = n;
        if (this.itemPull[this.idPrefix + n]["href_link"] != null && this.itemPull[this.idPrefix + n].state == "enabled") {
            var s = document.createElement("FORM");
            var v = String(this.itemPull[this.idPrefix + n]["href_link"]).split("?");
            s.action = v[0];
            if (v[1] != null) {
                var o = String(v[1]).split("&");
                for (var a = 0; a < o.length; a++) {
                    var w = String(o[a]).split("=");
                    var u = document.createElement("INPUT");
                    u.type = "hidden";
                    u.name = (w[0] || "");
                    u.value = (w[1] || "");
                    s.appendChild(u)
                }
            }
            if (this.itemPull[this.idPrefix + n]["href_target"] != null) {
                s.target = this.itemPull[this.idPrefix + n]["href_target"]
            }
            s.style.display = "none";
            document.body.appendChild(s);
            s.submit();
            if (s != null) {
                document.body.removeChild(s);
                s = null
            }
            return
        }
        if (x.charAt(0) == "c") {
            return
        }
        if (x.charAt(1) == "d") {
            return
        }
        if (x.charAt(2) == "s") {
            return
        }
        if (this.checkEvent("onClick")) {
            this.callEvent("onClick", [n, this.conf.ctx_zoneid, r])
        } else {
            if ((x.charAt(1) == "d") || (this.conf.mode == "win" && x.charAt(2) == "t")) {
                return
            }
        }
        if (this.conf.context && this._isContextMenuVisible() && this.conf.ctx_autohide) {
            this._hideContextMenu()
        } else {
            if (this._clearAndHide) {
                this._clearAndHide()
            }
        }
    };
    this._doOnTouchMenu = function (a) {
        if (this.conf.is_touched == false) {
            this.conf.is_touched = true;
            if (this.checkEvent("onTouch")) {
                this.callEvent("onTouch", [a])
            }
        }
    };
    this._searchMenuNode = function (o, s) {
        var a = new Array();
        for (var r = 0; r < s.length; r++) {
            if (typeof (s[r]) == "object") {
                if (s[r].length == 5) {
                    if (typeof (s[r][0]) != "object") {
                        if ((s[r][0].replace(this.idPrefix, "") == o) && (r == 0)) {
                            a = s
                        }
                    }
                }
                var n = this._searchMenuNode(o, s[r]);
                if (n.length > 0) {
                    a = n
                }
            }
        }
        return a
    };
    this._getMenuNodes = function (q) {
        var n = new Array;
        for (var o in this.itemPull) {
            if (this.itemPull[o]["parent"] == q) {
                n[n.length] = o
            }
        }
        return n
    };
    this._genStr = function (a) {
        var m = "";
        var o = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        for (var n = 0; n < a; n++) {
            m += o.charAt(Math.round(Math.random() * (o.length - 1)))
        }
        return m
    };
    this.getItemType = function (a) {
        a = this.idPrefix + a;
        if (this.itemPull[a] == null) {
            return null
        }
        return this.itemPull[a]["type"]
    };
    this.forEachItem = function (n) {
        for (var m in this.itemPull) {
            n(String(m).replace(this.idPrefix, ""))
        }
    };
    this._clearAndHide = function () {
        h.conf.selected = -1;
        h.conf.last_click = -1;
        while (h.conf.opened_poly.length > 0) {
            h.conf.opened_poly.pop()
        }
        for (var a = 0; a < h.conf.selected_sub.length; a++) {
            var m = h.conf.selected_sub[a][0];
            if (h.idPull[m] != null) {
                if (h.itemPull[m]["state"] == "enabled") {
                    if (h.idPull[m].className == "sub_item_selected") {
                        h.idPull[m].className = "sub_item"
                    }
                    if (h.idPull[m].className == "dhtmlxMenu_" + h.conf.skin + "_TopLevel_Item_Selected") {
                        if (h.itemPull[m]["cssNormal"] != null) {
                            h.idPull[m].className = h.itemPull[m]["cssNormal"]
                        } else {
                            h.idPull[m].className = "dhtmlxMenu_" + h.conf.skin + "_TopLevel_Item_Normal"
                        }
                    }
                }
            }
            h._hidePolygon(m)
        }
        h.conf.is_touched = false;
        if (h.conf.context && h.conf.ctx_hideall) {
            h._hidePolygon(h.idPrefix + h.topId)
        }
    };
    this._showSubLevelItem = function (m, a) {
        if (document.getElementById("arrow_" + this.idPrefix + m) != null) {
            document.getElementById("arrow_" + this.idPrefix + m).style.display = (a ? "none" : "")
        }
        if (document.getElementById("image_" + this.idPrefix + m) != null) {
            document.getElementById("image_" + this.idPrefix + m).style.display = (a ? "none" : "")
        }
        if (document.getElementById(this.idPrefix + m) != null) {
            document.getElementById(this.idPrefix + m).style.display = (a ? "" : "none")
        }
    };
    this._hideSubLevelItem = function (a) {
        this._showSubLevelItem(a, true)
    };
    this.idPrefix = this._genStr(12) + "_";
    this._bodyClick = function (a) {
        a = a || event;
        if (a.button == 2 || (window.dhx4.isOpera && a.ctrlKey == true)) {
            return
        }
        if (h.conf.context) {
            if (h.conf.ctx_autohide && (!window.dhx4.isOpera || (h._isContextMenuVisible() && window.dhx4.isOpera))) {
                h._hideContextMenu()
            }
        } else {
            if (h._clearAndHide) {
                h._clearAndHide()
            }
        }
    };
    this._bodyContext = function (n) {
        n = n || event;
        var m = String((n.srcElement || n.target).className);
        if (m.search("dhtmlxMenu") != -1 && m.search("SubLevelArea") != -1) {
            return
        }
        var a = true;
        var o = n.target || n.srcElement;
        while (o != null) {
            if (o.id != null) {
                if (h.isContextZone(o.id)) {
                    a = false
                }
            }
            if (o == document.body) {
                a = false
            }
            o = o.parentNode
        }
        if (a) {
            h.hideContextMenu()
        }
    };
    if (typeof (window.addEventListener) != "undefined") {
        window.addEventListener("click", this._bodyClick, false);
        window.addEventListener("contextmenu", this._bodyContext, false)
    } else {
        document.body.attachEvent("onclick", this._bodyClick);
        document.body.attachEvent("oncontextmenu", this._bodyContext)
    }
    this.unload = function () {
        window.dhx4._eventable(this, "clear");
        dhtmlXMenuObject.prototype.liveInst[this.conf.live_id] = null;
        try {
            delete dhtmlXMenuObject.prototype.liveInst[this.conf.live_id]
        } catch (n) {}
        this.conf.live_id = null;
        if (typeof (window.addEventListener) == "function") {
            window.removeEventListener("click", this._bodyClick, false);
            window.removeEventListener("contextmenu", this._bodyContext, false)
        } else {
            document.body.detachEvent("onclick", this._bodyClick);
            document.body.detachEvent("oncontextmenu", this._bodyContext)
        }
        this._bodyClick = null;
        this._bodyContext = null;
        this.removeItem(this.idPrefix + this.topId, true);
        this.itemPull = null;
        this.idPull = null;
        if (this.conf.context) {
            for (var m in this.conf.ctx_zones) {
                this.removeContextZone(m)
            }
        }
        if (this.cont != null) {
            this.cont.className = "";
            this.cont.parentNode.removeChild(this.cont);
            this.cont = null
        }
        if (this.base != null) {
            this.base.className = "";
            if (!this.conf.context) {
                this.base.oncontextmenu = (this.base._oldContextMenuHandler || null)
            }
            this.base.onselectstart = null;
            this.base = null
        }
        for (var m in this) {
            this[m] = null
        }
        h = null
    };
    dhtmlXMenuObject.prototype.liveInst[this.conf.live_id] = this;
    window.dhx4._enableDataLoading(this, "_initObj", "_xmlToJson", this.conf.tags.root, {
        struct: true
    });
    window.dhx4._eventable(this);
    if (window.dhx4.s2b(this.conf.autoload.context) == true) {
        this.renderAsContextMenu()
    }
    if (this.conf.autoload.dynamic != null) {
        this.enableDynamicLoading(this.conf.autoload.dynamic, window.dhx4.s2b(this.conf.autoload.dynamic_icon))
    } else {
        if (this.conf.autoload.items != null) {
            this.loadStruct(this.conf.autoload.items, this.conf.autoload.onload)
        } else {
            if (this.conf.autoload.json != null) {
                this.loadStruct(this.conf.autoload.json, this.conf.autoload.onload)
            } else {
                if (this.conf.autoload.xml != null) {
                    this.loadStruct(this.conf.autoload.xml, this.conf.autoload.onload)
                }
            }
        }
    }
    for (var g in {
        onclick: 1,
        oncheckboxclick: 1,
        onradioclick: 1
    }) {
        if (this.conf.autoload[g] != null) {
            if (typeof (this.conf.autoload[g]) == "function") {
                this.attachEvent(g, this.conf.autoload[g])
            } else {
                if (typeof (window[this.conf.autoload[g]]) == "function") {
                    this.attachEvent(g, window[this.conf.autoload[g]])
                }
            }
        }
    }
    if (this.conf.autoload.top_text != null) {
        this.setTopText(this.conf.autoload.top_text)
    }
    if (this.conf.autoload.align != null) {
        this.setAlign(this.conf.autoload.align)
    }
    if (this.conf.autoload.open_mode != null) {
        this.setOpenMode(this.conf.autoload.open_mode)
    }
    if (this.conf.autoload.overflow != null) {
        this.setOverflowHeight(this.conf.autoload.overflow)
    }
    for (var g in this.conf.autoload) {
        this.conf.autoload[g] = null;
        delete this.conf.autoload[g]
    }
    this.conf.autoload = null;
    return this
}
dhtmlXMenuObject.prototype._init = function () {
    if (this._isInited == true) {
        return
    }
    if (this.conf.dload) {
        this._dhxdataload.onBeforeXLS = function () {
            var g = {
                params: {}
            };
            for (var c in this.conf.dload_params) {
                g.params[c] = this.conf.dload_params[c]
            }
            return g
        };
        this.loadStruct(this.conf.dload_url)
    } else {
        this._initTopLevelMenu();
        this._isInited = true
    }
};
dhtmlXMenuObject.prototype._countVisiblePolygonItems = function (l) {
    var h = 0;
    for (var c in this.itemPull) {
        var g = this.itemPull[c]["parent"];
        var j = this.itemPull[c]["type"];
        if (this.idPull[c] != null) {
            if (g == l && (j == "item" || j == "radio" || j == "checkbox") && this.idPull[c].style.display != "none") {
                h++
            }
        }
    }
    return h
};
dhtmlXMenuObject.prototype._redefineComplexState = function (c) {
    if (this.idPrefix + this.topId == c) {
        return
    }
    if ((this.idPull["polygon_" + c] != null) && (this.idPull[c] != null)) {
        var a = this._countVisiblePolygonItems(c);
        if ((a > 0) && (!this.itemPull[c]["complex"])) {
            this._updateItemComplexState(c, true, false)
        }
        if ((a == 0) && (this.itemPull[c]["complex"])) {
            this._updateItemComplexState(c, false, false)
        }
    }
};
dhtmlXMenuObject.prototype._updateItemComplexState = function (j, g, h) {
    if ((!this.conf.context) && (this._getItemLevelType(j.replace(this.idPrefix, "")) == "TopLevel")) {
        this.itemPull[j]["complex"] = g;
        return
    }
    if ((this.idPull[j] == null) || (this.itemPull[j] == null)) {
        return
    }
    this.itemPull[j]["complex"] = g;
    if (j == this.idPrefix + this.topId) {
        return
    }
    var a = null;
    var c = this.idPull[j].childNodes[this.conf.rtl ? 0 : 2];
    if (c.childNodes[0]) {
        if (String(c.childNodes[0].className).search("complex_arrow") === 0) {
            a = c.childNodes[0]
        }
    }
    if (this.itemPull[j]["complex"]) {
        if (a == null) {
            a = document.createElement("DIV");
            a.className = "complex_arrow";
            a.id = "arrow_" + j;
            while (c.childNodes.length > 0) {
                c.removeChild(c.childNodes[0])
            }
            c.appendChild(a)
        }
        if (this.conf.dload && (this.itemPull[j].loaded == "get") && this.conf.dload_icon) {
            if (a.className != "complex_arrow_loading") {
                a.className = "complex_arrow_loading"
            }
        } else {
            a.className = "complex_arrow"
        }
        return
    }
    if ((!this.itemPull[j]["complex"]) && (a != null)) {
        c.removeChild(a);
        if (this.itemPull[j]["hotkey_backup"] != null && this.setHotKey) {
            this.setHotKey(j.replace(this.idPrefix, ""), this.itemPull[j]["hotkey_backup"])
        }
    }
};
dhtmlXMenuObject.prototype._getItemLevelType = function (a) {
    return (this.itemPull[this.idPrefix + a]["parent"] == this.idPrefix + this.topId ? "TopLevel" : "SubLevelArea")
};
dhtmlXMenuObject.prototype.setIconsPath = function (a) {
    this.conf.icons_path = a
};
dhtmlXMenuObject.prototype._updateItemImage = function (g, h) {
    g = this.idPrefix + g;
    var j = (this.itemPull[g]["parent"] == this.idPrefix + this.topId && !this.conf.context);
    var l = null;
    if (j) {
        for (var a = 0; a < this.idPull[g].childNodes.length; a++) {
            try {
                if (this.idPull[g].childNodes[a].className == "dhtmlxMenu_TopLevel_Item_Icon") {
                    l = this.idPull[g].childNodes[a]
                }
            } catch (m) {}
        }
    } else {
        try {
            var l = this.idPull[g].childNodes[this.conf.rtl ? 2 : 0].childNodes[0]
        } catch (m) {}
        if (!(l != null && typeof (l.className) != "undefined" && l.className == "sub_icon")) {
            l = null
        }
    }
    if (this.itemPull[g]["type"] == "radio") {
        var o = this.itemPull[g][(this.itemPull[g]["state"] == "enabled" ? "imgen" : "imgdis")]
    } else {
        var o = this.itemPull[g][(this.itemPull[g]["state"] == "enabled" ? "imgen" : "imgdis")]
    }
    if (o.length > 0) {
        if (l != null) {
            l.src = this.conf.icons_path + o
        } else {
            if (j) {
                var l = document.createElement("IMG");
                l.className = "dhtmlxMenu_TopLevel_Item_Icon";
                l.src = this.conf.icons_path + o;
                l.border = "0";
                l.id = "image_" + g;
                if (!this.conf.rtl && this.idPull[g].childNodes.length > 0) {
                    this.idPull[g].insertBefore(l, this.idPull[g].childNodes[0])
                } else {
                    this.idPull[g].appendChild(l)
                }
            } else {
                var l = document.createElement("IMG");
                l.className = "sub_icon";
                l.src = this.conf.icons_path + o;
                l.border = "0";
                l.id = "image_" + g;
                var n = this.idPull[g].childNodes[this.conf.rtl ? 2 : 0];
                while (n.childNodes.length > 0) {
                    n.removeChild(n.childNodes[0])
                }
                n.appendChild(l)
            }
        }
    } else {
        if (l != null) {
            var c = l.parentNode;
            c.removeChild(l);
            c.innerHTML = "&nbsp;";
            c = l = null
        }
    }
};
dhtmlXMenuObject.prototype._getAllParents = function (l) {
    var g = new Array();
    for (var c in this.itemPull) {
        if (this.itemPull[c]["parent"] == l) {
            g[g.length] = this.itemPull[c]["id"];
            if (this.itemPull[c]["complex"]) {
                var h = this._getAllParents(this.itemPull[c]["id"]);
                for (var j = 0; j < h.length; j++) {
                    g[g.length] = h[j]
                }
            }
        }
    }
    return g
};
dhtmlXMenuObject.prototype._autoDetectVisibleArea = function () {
    if (this.conf.v_enabled) {
        return
    }
    var a = window.dhx4.screenDim();
    this.conf.v.x1 = a.left;
    this.conf.v.x2 = a.right;
    this.conf.v.y1 = a.top;
    this.conf.v.y2 = a.bottom
};
dhtmlXMenuObject.prototype.getItemPosition = function (j) {
    j = this.idPrefix + j;
    var h = -1;
    if (this.itemPull[j] == null) {
        return h
    }
    var a = this.itemPull[j]["parent"];
    var g = (this.idPull["polygon_" + a] != null ? this.idPull["polygon_" + a].tbd : this.cont);
    for (var c = 0; c < g.childNodes.length; c++) {
        if (g.childNodes[c] == this.idPull["separator_" + j] || g.childNodes[c] == this.idPull[j]) {
            h = c
        }
    }
    return h
};
dhtmlXMenuObject.prototype.setItemPosition = function (m, l) {
    m = this.idPrefix + m;
    if (this.idPull[m] == null) {
        return
    }
    var c = (this.itemPull[m]["parent"] == this.idPrefix + this.topId);
    var a = this.idPull[m];
    var h = this.getItemPosition(m.replace(this.idPrefix, ""));
    var g = this.itemPull[m]["parent"];
    var j = (this.idPull["polygon_" + g] != null ? this.idPull["polygon_" + g].tbd : this.cont);
    j.removeChild(j.childNodes[h]);
    if (l < 0) {
        l = 0
    }
    if (c && l < 1) {
        l = 1
    }
    if (l < j.childNodes.length) {
        j.insertBefore(a, j.childNodes[l])
    } else {
        j.appendChild(a)
    }
};
dhtmlXMenuObject.prototype.getParentId = function (a) {
    a = this.idPrefix + a;
    if (this.itemPull[a] == null) {
        return null
    }
    return ((this.itemPull[a]["parent"] != null ? this.itemPull[a]["parent"] : this.topId).replace(this.idPrefix, ""))
};
dhtmlXMenuObject.prototype.hide = function () {
    this._clearAndHide()
};
dhtmlXMenuObject.prototype.clearAll = function () {
    this.removeItem(this.idPrefix + this.topId, true);
    this._isInited = false;
    this.idPrefix = this._genStr(12) + "_";
    this.itemPull = {}
};
if (typeof (dhtmlXMenuObject.prototype.liveInst) == "undefined") {
    dhtmlXMenuObject.prototype.liveInst = {}
}
dhtmlXMenuObject.prototype._redistribTopLevelSelection = function (h, c) {
    var a = this._getSubItemToDeselectByPolygon("parent");
    this._removeSubItemFromSelected(-1, -1);
    for (var g = 0; g < a.length; g++) {
        if (a[g] != h) {
            this._hidePolygon(a[g])
        }
        if ((this.idPull[a[g]] != null) && (a[g] != h)) {
            this.idPull[a[g]].className = this.idPull[a[g]].className.replace(/Selected/g, "Normal")
        }
    }
    if (this.itemPull[this.idPrefix + h]["state"] == "enabled") {
        this.idPull[this.idPrefix + h].className = "dhtmlxMenu_" + this.conf.skin + "_TopLevel_Item_Selected";
        this._addSubItemToSelected(this.idPrefix + h, "parent");
        this.conf.selected = (this.conf.mode == "win" ? (this.conf.selected != -1 ? h : this.conf.selected) : h);
        if ((this.itemPull[this.idPrefix + h]["complex"]) && (this.conf.selected != -1)) {
            this._showPolygon(this.idPrefix + h, this.conf.dir_toplv)
        }
    }
};
dhtmlXMenuObject.prototype._initTopLevelMenu = function () {
    this.conf.dir_toplv = "bottom";
    this.conf.dir_sublv = (this.conf.rtl ? "left" : "right");
    if (this.conf.context) {
        this.idPull[this.idPrefix + this.topId] = new Array(0, 0);
        this._addSubMenuPolygon(this.idPrefix + this.topId, this.idPrefix + this.topId)
    } else {
        var a = this._getMenuNodes(this.idPrefix + this.topId);
        for (var c = 0; c < a.length; c++) {
            if (this.itemPull[a[c]]["type"] == "item") {
                this._renderToplevelItem(a[c], null)
            }
            if (this.itemPull[a[c]]["type"] == "separator") {
                this._renderSeparator(a[c], null)
            }
        }
    }
};
dhtmlXMenuObject.prototype._renderToplevelItem = function (n, l) {
    var j = this;
    var a = document.createElement("DIV");
    a.id = n;
    if (this.itemPull[n]["state"] == "enabled" && this.itemPull[n]["cssNormal"] != null) {
        a.className = this.itemPull[n]["cssNormal"]
    } else {
        a.className = "dhtmlxMenu_" + this.conf.skin + "_TopLevel_Item_" + (this.itemPull[n]["state"] == "enabled" ? "Normal" : "Disabled")
    }
    if (this.itemPull[n]["title"] != "") {
        var h = document.createElement("DIV");
        h.className = "top_level_text";
        h.innerHTML = this.itemPull[n]["title"];
        a.appendChild(h)
    }
    if (this.itemPull[n]["tip"].length > 0) {
        a.title = this.itemPull[n]["tip"]
    }
    if ((this.itemPull[n]["imgen"] != "") || (this.itemPull[n]["imgdis"] != "")) {
        var g = this.itemPull[n][(this.itemPull[n]["state"] == "enabled") ? "imgen" : "imgdis"];
        if (g) {
            var c = document.createElement("IMG");
            c.border = "0";
            c.id = "image_" + n;
            c.src = this.conf.icons_path + g;
            c.className = "dhtmlxMenu_TopLevel_Item_Icon";
            if (a.childNodes.length > 0 && !this.conf.rtl) {
                a.insertBefore(c, a.childNodes[0])
            } else {
                a.appendChild(c)
            }
        }
    }
    a.onselectstart = function (m) {
        m = m || event;
        if (m.preventDefault) {
            m.preventDefault()
        } else {
            m.returnValue = false
        }
        return false
    };
    a.oncontextmenu = function (m) {
        m = m || event;
        if (m.preventDefault) {
            m.preventDefault()
        } else {
            m.returnValue = false
        }
        return false
    };
    if (!this.cont) {
        this.cont = document.createElement("DIV");
        this.cont.dir = "ltr";
        this.cont.className = (this.conf.align == "right" ? "align_right" : "align_left");
        this.base.appendChild(this.cont)
    }
    if (l != null) {
        l++;
        if (l < 0) {
            l = 0
        }
        if (l > this.cont.childNodes.length - 1) {
            l = null
        }
    }
    if (l != null) {
        this.cont.insertBefore(a, this.cont.childNodes[l])
    } else {
        this.cont.appendChild(a)
    }
    this.idPull[a.id] = a;
    if (this.itemPull[n]["complex"] && (!this.conf.dload)) {
        this._addSubMenuPolygon(this.itemPull[n]["id"], this.itemPull[n]["id"])
    }
    a.onmouseover = function () {
        if (j.conf.mode == "web") {
            window.clearTimeout(j.conf.tm_handler)
        }
        var m = j._getSubItemToDeselectByPolygon("parent");
        j._removeSubItemFromSelected(-1, -1);
        for (var r = 0; r < m.length; r++) {
            if (m[r] != this.id) {
                j._hidePolygon(m[r])
            }
            if ((j.idPull[m[r]] != null) && (m[r] != this.id)) {
                if (j.itemPull[m[r]]["cssNormal"] != null) {
                    j.idPull[m[r]].className = j.itemPull[m[r]]["cssNormal"]
                } else {
                    if (j.idPull[m[r]].className == "sub_item_selected") {
                        j.idPull[m[r]].className = "sub_item"
                    }
                    j.idPull[m[r]].className = j.idPull[m[r]].className.replace(/Selected/g, "Normal")
                }
            }
        }
        if (j.itemPull[this.id]["state"] == "enabled") {
            this.className = "dhtmlxMenu_" + j.conf.skin + "_TopLevel_Item_Selected";
            j._addSubItemToSelected(this.id, "parent");
            j.conf.selected = (j.conf.mode == "win" ? (j.conf.selected != -1 ? this.id : j.conf.selected) : this.id);
            if (j.conf.dload) {
                if (j.itemPull[this.id].loaded == "no") {
                    this._dynLoadTM = new Date().getTime();
                    j.itemPull[this.id].loaded = "get";
                    var s = this.id.replace(j.idPrefix, "");
                    j._dhxdataload.onBeforeXLS = function () {
                        var u = {
                            params: {}
                        };
                        u.params[this.conf.dload_pid] = s;
                        for (var q in this.conf.dload_params) {
                            u.params[q] = this.conf.dload_params[q]
                        }
                        return u
                    };
                    j.loadStruct(j.conf.dload_url)
                }
                if (j.conf.top_mode && j.conf.mode == "web" && !j.conf.context) {
                    this._mouseOver = true
                }
            }
            if ((!j.conf.dload) || (j.conf.dload && (!j.itemPull[this.id]["loaded"] || j.itemPull[this.id]["loaded"] == "yes"))) {
                if ((j.itemPull[this.id]["complex"]) && (j.conf.selected != -1)) {
                    if (j.conf.top_mode && j.conf.mode == "web" && !j.conf.context) {
                        this._mouseOver = true;
                        var o = this.id;
                        this._menuOpenTM = window.setTimeout(function () {
                            j._showPolygon(o, j.conf.dir_toplv)
                        }, j.conf.top_tmtime)
                    } else {
                        j._showPolygon(this.id, j.conf.dir_toplv)
                    }
                }
            }
        }
        j._doOnTouchMenu(this.id.replace(j.idPrefix, ""))
    };
    a.onmouseout = function () {
        if (!((j.itemPull[this.id]["complex"]) && (j.conf.selected != -1)) && (j.itemPull[this.id]["state"] == "enabled")) {
            if (j.itemPull[this.id]["cssNormal"] != null) {
                a.className = j.itemPull[this.id]["cssNormal"]
            } else {
                a.className = "dhtmlxMenu_" + j.conf.skin + "_TopLevel_Item_Normal"
            }
        }
        if (j.conf.mode == "web") {
            window.clearTimeout(j.conf.tm_handler);
            j.conf.tm_handler = window.setTimeout(function () {
                j._clearAndHide()
            }, j.conf.tm_sec, "JavaScript")
        }
        if (j.conf.top_mode && j.conf.mode == "web" && !j.conf.context) {
            this._mouseOver = false;
            window.clearTimeout(this._menuOpenTM)
        }
    };
    a.onclick = function (r) {
        if (j.conf.mode == "web") {
            window.clearTimeout(j.conf.tm_handler)
        }
        if (j.conf.mode != "web" && j.itemPull[this.id]["state"] == "disabled") {
            return
        }
        r = r || event;
        r.cancelBubble = true;
        if (r.preventDefault) {
            r.preventDefault()
        } else {
            r.returnValue = false
        }
        if (j.conf.mode == "win") {
            if (j.itemPull[this.id]["complex"]) {
                if (j.conf.selected == this.id) {
                    j.conf.selected = -1;
                    var q = false
                } else {
                    j.conf.selected = this.id;
                    var q = true
                }
                if (q) {
                    j._showPolygon(this.id, j.conf.dir_toplv)
                } else {
                    j._hidePolygon(this.id)
                }
            }
        }
        var m = (j.itemPull[this.id]["complex"] ? "c" : "-");
        var u = (j.itemPull[this.id]["state"] != "enabled" ? "d" : "-");
        var o = {
            ctrl: r.ctrlKey,
            alt: r.altKey,
            shift: r.shiftKey
        };
        j._doOnClick(this.id.replace(j.idPrefix, ""), m + u + "t", o);
        return false
    };
    if (this.conf.skin == "dhx_terrace") {
        this._improveTerraceSkin()
    }
};
dhtmlXMenuObject.prototype._addSubMenuPolygon = function (m, l) {
    var c = this._renderSublevelPolygon(m, l);
    var a = this._getMenuNodes(l);
    for (g = 0; g < a.length; g++) {
        if (this.itemPull[a[g]]["type"] == "separator") {
            this._renderSeparator(a[g], null)
        } else {
            this._renderSublevelItem(a[g], null)
        }
    }
    if (m == l) {
        var h = "topLevel"
    } else {
        var h = "subLevel"
    }
    for (var g = 0; g < a.length; g++) {
        if (this.itemPull[a[g]]["complex"]) {
            this._addSubMenuPolygon(m, this.itemPull[a[g]]["id"])
        }
    }
};
dhtmlXMenuObject.prototype._renderSublevelPolygon = function (j, h) {
    var c = document.createElement("DIV");
    c.className = "dhtmlxMenu_" + this.conf.skin + "_SubLevelArea_Polygon " + (this.conf.rtl ? "dir_right" : "");
    c.dir = "ltr";
    c.oncontextmenu = function (l) {
        l = l || event;
        if (l.preventDefault) {
            l.preventDefault()
        } else {
            l.returnValue = false
        }
        l.cancelBubble = true;
        return false
    };
    c.id = "polygon_" + h;
    c.onclick = function (l) {
        l = l || event;
        l.cancelBubble = true
    };
    c.style.display = "none";
    document.body.insertBefore(c, document.body.firstChild);
    c.innerHTML = '<div style="position:relative;"></div><div style="position: relative; overflow:hidden;"></div><div style="position:relative;"></div>';
    var g = document.createElement("TABLE");
    g.className = "dhtmlxMebu_SubLevelArea_Tbl";
    g.cellSpacing = 0;
    g.cellPadding = 0;
    g.border = 0;
    var a = document.createElement("TBODY");
    g.appendChild(a);
    c.childNodes[1].appendChild(g);
    c.tbl = g;
    c.tbd = a;
    this.idPull[c.id] = c;
    if (this.sxDacProc != null) {
        this.idPull["sxDac_" + h] = new this.sxDacProc(c, c.className);
        if (window.dhx4.isIE) {
            this.idPull["sxDac_" + h]._setSpeed(this.dacSpeedIE);
            this.idPull["sxDac_" + h]._setCustomCycle(this.dacCyclesIE)
        } else {
            this.idPull["sxDac_" + h]._setSpeed(this.dacSpeed);
            this.idPull["sxDac_" + h]._setCustomCycle(this.dacCycles)
        }
    }
    return c
};
dhtmlXMenuObject.prototype._renderSublevelItem = function (a, q) {
    var n = this;
    var o = document.createElement("TR");
    o.className = (this.itemPull[a]["state"] == "enabled" ? "sub_item" : "sub_item_dis");
    var m = document.createElement("TD");
    m.className = "sub_item_icon";
    var r = this.itemPull[a][(this.itemPull[a]["state"] == "enabled" ? "imgen" : "imgdis")];
    if (r != "") {
        var v = this.itemPull[a]["type"];
        if (v == "checkbox" || v == "radio") {
            var j = document.createElement("DIV");
            j.id = "image_" + this.itemPull[a]["id"];
            j.className = "sub_icon " + r;
            m.appendChild(j)
        }
        if (!(v == "checkbox" || v == "radio")) {
            var j = document.createElement("IMG");
            j.id = "image_" + this.itemPull[a]["id"];
            j.className = "sub_icon";
            j.src = this.conf.icons_path + r;
            m.appendChild(j)
        }
    } else {
        m.innerHTML = "&nbsp;"
    }
    var l = document.createElement("TD");
    l.className = "sub_item_text";
    if (this.itemPull[a]["title"] != "") {
        var u = document.createElement("DIV");
        u.className = "sub_item_text";
        u.innerHTML = this.itemPull[a]["title"];
        l.appendChild(u)
    } else {
        l.innerHTML = "&nbsp;"
    }
    var h = document.createElement("TD");
    h.className = "sub_item_hk";
    if (this.itemPull[a]["complex"]) {
        var c = document.createElement("DIV");
        c.className = "complex_arrow";
        c.id = "arrow_" + this.itemPull[a]["id"];
        h.appendChild(c)
    } else {
        if (this.itemPull[a]["hotkey"].length > 0 && !this.itemPull[a]["complex"]) {
            var g = document.createElement("DIV");
            g.className = "sub_item_hk";
            g.innerHTML = this.itemPull[a]["hotkey"];
            h.appendChild(g)
        } else {
            h.innerHTML = "&nbsp;"
        }
    }
    o.appendChild(this.conf.rtl ? h : m);
    o.appendChild(l);
    o.appendChild(this.conf.rtl ? m : h);
    o.id = this.itemPull[a]["id"];
    o.parent = this.itemPull[a]["parent"];
    if (this.itemPull[a]["tip"].length > 0) {
        o.title = this.itemPull[a]["tip"]
    }
    o.onselectstart = function (w) {
        w = w || event;
        if (w.preventDefault) {
            w.preventDefault()
        } else {
            w.returnValue = false
        }
        return false
    };
    o.onmouseover = function (w) {
        if (n.conf.hide_tm[this.id]) {
            window.clearTimeout(n.conf.hide_tm[this.id])
        }
        if (n.conf.mode == "web") {
            window.clearTimeout(n.conf.tm_handler)
        }
        if (!this._visible) {
            n._redistribSubLevelSelection(this.id, this.parent)
        }
        this._visible = true
    };
    o.onmouseout = function () {
        if (n.conf.mode == "web") {
            if (n.conf.tm_handler) {
                window.clearTimeout(n.conf.tm_handler)
            }
            n.conf.tm_handler = window.setTimeout(function () {
                if (n && n._clearAndHide) {
                    n._clearAndHide()
                }
            }, n.conf.tm_sec, "JavaScript")
        }
        var w = this;
        if (n.conf.hide_tm[this.id]) {
            window.clearTimeout(n.conf.hide_tm[this.id])
        }
        n.conf.hide_tm[this.id] = window.setTimeout(function () {
            w._visible = false
        }, 50)
    };
    o.onclick = function (x) {
        if (!n.checkEvent("onClick") && n.itemPull[this.id]["complex"]) {
            return
        }
        x = x || event;
        x.cancelBubble = true;
        if (x.preventDefault) {
            x.preventDefault()
        } else {
            x.returnValue = false
        }
        tc = (n.itemPull[this.id]["complex"] ? "c" : "-");
        td = (n.itemPull[this.id]["state"] == "enabled" ? "-" : "d");
        var w = {
            ctrl: x.ctrlKey,
            alt: x.altKey,
            shift: x.shiftKey
        };
        switch (n.itemPull[this.id]["type"]) {
        case "checkbox":
            n._checkboxOnClickHandler(this.id.replace(n.idPrefix, ""), tc + td + "n", w);
            break;
        case "radio":
            n._radioOnClickHandler(this.id.replace(n.idPrefix, ""), tc + td + "n", w);
            break;
        case "item":
            n._doOnClick(this.id.replace(n.idPrefix, ""), tc + td + "n", w);
            break
        }
        return false
    };
    var s = this.idPull["polygon_" + this.itemPull[a]["parent"]];
    if (q != null) {
        q++;
        if (q < 0) {
            q = 0
        }
        if (q > s.tbd.childNodes.length - 1) {
            q = null
        }
    }
    if (q != null && s.tbd.childNodes[q] != null) {
        s.tbd.insertBefore(o, s.tbd.childNodes[q])
    } else {
        s.tbd.appendChild(o)
    }
    this.idPull[o.id] = o
};
dhtmlXMenuObject.prototype._renderSeparator = function (c, m) {
    var a = (this.conf.context ? "SubLevelArea" : (this.itemPull[c]["parent"] == this.idPrefix + this.topId ? "TopLevel" : "SubLevelArea"));
    if (a == "TopLevel" && this.conf.context) {
        return
    }
    var j = this;
    if (a != "TopLevel") {
        var l = document.createElement("TR");
        l.className = "sub_sep";
        var g = document.createElement("TD");
        g.colSpan = "3";
        l.appendChild(g)
    }
    var h = document.createElement("DIV");
    h.id = "separator_" + c;
    h.className = (a == "TopLevel" ? "top_sep" : "sub_sep");
    h.onselectstart = function (q) {
        q = q || event;
        if (q.preventDefault) {
            q.preventDefault()
        } else {
            q.returnValue = false
        }
    };
    h.onclick = function (r) {
        r = r || event;
        r.cancelBubble = true;
        var q = {
            ctrl: r.ctrlKey,
            alt: r.altKey,
            shift: r.shiftKey
        };
        j._doOnClick(this.id.replace("separator_" + j.idPrefix, ""), "--s", q)
    };
    if (a == "TopLevel") {
        if (m != null) {
            m++;
            if (m < 0) {
                m = 0
            }
            if (this.cont.childNodes[m] != null) {
                this.cont.insertBefore(h, this.cont.childNodes[m])
            } else {
                this.cont.appendChild(h)
            }
        } else {
            var o = this.cont.childNodes[this.cont.childNodes.length - 1];
            if (String(o).search("TopLevel_Text") == -1) {
                this.cont.appendChild(h)
            } else {
                this.cont.insertBefore(h, o)
            }
        }
        this.idPull[h.id] = h
    } else {
        var n = this.idPull["polygon_" + this.itemPull[c]["parent"]];
        if (m != null) {
            m++;
            if (m < 0) {
                m = 0
            }
            if (m > n.tbd.childNodes.length - 1) {
                m = null
            }
        }
        if (m != null && n.tbd.childNodes[m] != null) {
            n.tbd.insertBefore(l, n.tbd.childNodes[m])
        } else {
            n.tbd.appendChild(l)
        }
        g.appendChild(h);
        this.idPull[h.id] = l
    }
};
dhtmlXMenuObject.prototype.addNewSeparator = function (a, c) {
    c = this.idPrefix + (c != null ? c : this._genStr(24));
    var g = this.idPrefix + this.getParentId(a);
    this._addItemIntoGlobalStrorage(c, g, "", "separator", false, "", "");
    this._renderSeparator(c, this.getItemPosition(a))
};
dhtmlXMenuObject.prototype._initObj = function (s, u, m) {
    if (!(s instanceof Array)) {
        m = s.parentId;
        if (m != null && String(m).indexOf(this.idPrefix) !== 0) {
            m = this.idPrefix + String(m)
        }
        s = s.items
    }
    for (var g = 0; g < s.length; g++) {
        if (typeof (s[g].id) == "undefined" || s[g].id == null) {
            s[g].id = this._genStr(24)
        }
        if (String(s[g].id).indexOf(this.idPrefix) !== 0) {
            s[g].id = this.idPrefix + String(s[g].id)
        }
        var h = {
            type: "item",
            tip: "",
            hotkey: "",
            state: "enabled",
            imgen: "",
            imgdis: ""
        };
        for (var v in h) {
            if (typeof (s[g][v]) == "undefined") {
                s[g][v] = h[v]
            }
        }
        if (s[g].imgen == "" && s[g].img != null) {
            s[g].imgen = s[g].img
        }
        if (s[g].imgdis == "" && s[g].img_disabled != null) {
            s[g].imgdis = s[g].img_disabled
        }
        if (s[g].title == null && s[g].text != null) {
            s[g].title = s[g].text
        }
        if (s[g].href != null) {
            if (s[g].href.link != null) {
                s[g].href_link = s[g].href.link
            }
            if (s[g].href.target != null) {
                s[g].href_target = s[g].href.target
            }
        }
        if (s[g].userdata != null) {
            for (var v in s[g].userdata) {
                this.userData[s[g].id + "_" + v] = s[g].userdata[v]
            }
        }
        if (typeof (s[g].enabled) != "undefined" && window.dhx4.s2b(s[g].enabled) == false) {
            s[g].state = "disabled"
        } else {
            if (typeof (s[g].disabled) != "undefined" && window.dhx4.s2b(s[g].disabled) == true) {
                s[g].state = "disabled"
            }
        }
        if (typeof (s[g].parent) == "undefined") {
            s[g].parent = (m != null ? m : this.idPrefix + this.topId)
        }
        if (s[g].type == "checkbox") {
            s[g].checked = window.dhx4.s2b(s[g].checked);
            s[g].imgen = s[g].imgdis = "chbx_" + (s[g].checked ? "1" : "0")
        }
        if (s[g].type == "radio") {
            s[g].checked = window.dhx4.s2b(s[g].checked);
            s[g].imgen = s[g].imgdis = "rdbt_" + (s[g].checked ? "1" : "0");
            if (typeof (s[g].group) == "undefined" || s[g].group == null) {
                s[g].group = this._genStr(24)
            }
            if (this.radio[s[g].group] == null) {
                this.radio[s[g].group] = []
            }
            this.radio[s[g].group].push(s[g].id)
        }
        this.itemPull[s[g].id] = s[g];
        if (s[g].items != null && s[g].items.length > 0) {
            this.itemPull[s[g].id].complex = true;
            this._initObj(s[g].items, true, s[g].id)
        } else {
            if (this.conf.dload && s[g].complex == true) {
                this.itemPull[s[g].id].loaded = "no"
            }
        }
        this.itemPull[s[g].id].items = null
    }
    if (u !== true) {
        if (this.conf.dload == true) {
            if (m == null) {
                this._initTopLevelMenu()
            } else {
                this._addSubMenuPolygon(m, m);
                if (this.conf.selected == m) {
                    var r = (this.itemPull[m].parent == this.idPrefix + this.topId);
                    var c = (r && !this.conf.context ? this.conf.dir_toplv : this.conf.dir_sublv);
                    var j = false;
                    if (r && this.conf.top_mode && this.conf.mode == "web" && !this.conf.context) {
                        var w = this.idPull[m];
                        if (w._mouseOver == true) {
                            var l = this.conf.top_tmtime - (new Date().getTime() - w._dynLoadTM);
                            if (l > 1) {
                                var o = m;
                                var n = this;
                                w._menuOpenTM = window.setTimeout(function () {
                                    n._showPolygon(o, c);
                                    n = o = null
                                }, l);
                                j = true
                            }
                        }
                    }
                    if (!j) {
                        this._showPolygon(m, c)
                    }
                }
                this.itemPull[m].loaded = "yes";
                if (this.conf.dload_icon == true) {
                    this._updateLoaderIcon(m, false)
                }
            }
        } else {
            this._init()
        }
    }
};
dhtmlXMenuObject.prototype._xmlToJson = function (j, h) {
    var m = [];
    if (h == null) {
        var n = j.getElementsByTagName(this.conf.tags.root);
        if (n == null || n.length == 0) {
            return data
        }
        n = n[0]
    } else {
        n = j
    }
    if (n.getAttribute("parentId") != null) {
        h = this.idPrefix + n.getAttribute("parentId")
    }
    for (var c = 0; c < n.childNodes.length; c++) {
        if (typeof (n.childNodes[c].tagName) != "undefined" && String(n.childNodes[c].tagName).toLowerCase() == this.conf.tags.item) {
            var a = n.childNodes[c];
            var u = {
                id: this.idPrefix + (a.getAttribute("id") || this._genStr(24)),
                title: a.getAttribute("text") || "",
                imgen: a.getAttribute("img") || "",
                imgdis: a.getAttribute("imgdis") || "",
                tip: "",
                hotkey: "",
                type: a.getAttribute("type") || "item"
            };
            if (a.getAttribute("cssNormal") != null) {
                u.cssNormal = a.getAttribute("cssNormal")
            }
            if (u.type == "checkbox") {
                u.checked = a.getAttribute("checked")
            }
            if (u.type == "radio") {
                u.checked = a.getAttribute("checked");
                u.group = a.getAttribute("group")
            }
            u.state = "enabled";
            if (a.getAttribute("enabled") != null && window.dhx4.s2b(a.getAttribute("enabled")) == false) {
                u.state = "disabled"
            } else {
                if (a.getAttribute("disabled") != null && window.dhx4.s2b(a.getAttribute("disabled")) == true) {
                    u.state = "disabled"
                }
            }
            u.parent = (h != null ? h : this.idPrefix + this.topId);
            if (this.conf.dload) {
                u.complex = (a.getAttribute("complex") != null);
                if (u.complex) {
                    u.loaded = "no"
                }
            } else {
                var g = this._xmlToJson(a, u.id);
                u.items = g.items;
                u.complex = (u.items.length > 0)
            }
            for (var o = 0; o < a.childNodes.length; o++) {
                if (typeof (a.childNodes[o].tagName) != "undefined") {
                    var s = String(a.childNodes[o].tagName || "").toLowerCase();
                    if (s == this.conf.tags.userdata) {
                        var l = a.childNodes[o];
                        if (l.getAttribute("name") != null) {
                            this.userData[u.id + "_" + l.getAttribute("name")] = (l.firstChild != null && l.firstChild.nodeValue != null ? l.firstChild.nodeValue : "")
                        }
                    }
                    if (s == this.conf.tags.text_ext) {
                        u.title = a.childNodes[o].firstChild.nodeValue
                    }
                    if (s == this.conf.tags.tooltip) {
                        u.tip = a.childNodes[o].firstChild.nodeValue
                    }
                    if (s == this.conf.tags.hotkey) {
                        u.hotkey = a.childNodes[o].firstChild.nodeValue
                    }
                    if (s == this.conf.tags.href && u.type == "item") {
                        u.href_link = a.childNodes[o].firstChild.nodeValue;
                        if (a.childNodes[o].getAttribute("target") != null) {
                            u.href_target = a.childNodes[o].getAttribute("target")
                        }
                    }
                }
            }
            m.push(u)
        }
    }
    var a = {
        parentId: h,
        items: m
    };
    return a
};
dhtmlXMenuObject.prototype.enableDynamicLoading = function (a, c) {
    this.conf.dload = true;
    this.conf.dload_url = a;
    this.conf.dload_sign = (String(this.conf.dload_url).search(/\?/) == -1 ? "?" : "&");
    this.conf.dload_icon = c;
    this._init()
};
dhtmlXMenuObject.prototype._updateLoaderIcon = function (h, g) {
    if (this.idPull[h] == null) {
        return
    }
    if (String(this.idPull[h].className).search("TopLevel_Item") >= 0) {
        return
    }
    var c = (this.conf.rtl ? 0 : 2);
    if (!this.idPull[h].childNodes[c]) {
        return
    }
    if (!this.idPull[h].childNodes[c].childNodes[0]) {
        return
    }
    var a = this.idPull[h].childNodes[c].childNodes[0];
    if (String(a.className).search("complex_arrow") === 0) {
        a.className = "complex_arrow" + (g ? "_loading" : "")
    }
};
dhtmlXMenuObject.prototype.addNewSibling = function (h, j, a, c, g, n) {
    var m = this.idPrefix + (j != null ? j : this._genStr(24));
    var l = this.idPrefix + (h != null ? this.getParentId(h) : this.topId);
    this._addItemIntoGlobalStrorage(m, l, a, "item", c, g, n);
    if ((l == this.idPrefix + this.topId) && (!this.conf.context)) {
        this._renderToplevelItem(m, this.getItemPosition(h))
    } else {
        this._renderSublevelItem(m, this.getItemPosition(h))
    }
};
dhtmlXMenuObject.prototype.addNewChild = function (m, l, h, a, c, g, j) {
    if (m == null) {
        if (this.conf.context) {
            m = this.topId
        } else {
            this.addNewSibling(m, h, a, c, g, j);
            if (l != null) {
                this.setItemPosition(h, l)
            }
            return
        }
    }
    h = this.idPrefix + (h != null ? h : this._genStr(24));
    if (this.setHotKey) {
        this.setHotKey(m, "")
    }
    m = this.idPrefix + m;
    this._addItemIntoGlobalStrorage(h, m, a, "item", c, g, j);
    if (this.idPull["polygon_" + m] == null) {
        this._renderSublevelPolygon(m, m)
    }
    this._renderSublevelItem(h, l - 1);
    this._redefineComplexState(m)
};
dhtmlXMenuObject.prototype.removeItem = function (h, l, j) {
    if (!l) {
        h = this.idPrefix + h
    }
    var m = null;
    if (h != this.idPrefix + this.topId) {
        if (this.itemPull[h] == null) {
            return
        }
        if (this.idPull["polygon_" + h] && this.idPull["polygon_" + h]._tmShow) {
            window.clearTimeout(this.idPull["polygon_" + h]._tmShow)
        }
        var u = this.itemPull[h]["type"];
        if (u == "separator") {
            var s = this.idPull["separator_" + h];
            if (this.itemPull[h]["parent"] == this.idPrefix + this.topId) {
                s.onclick = null;
                s.onselectstart = null;
                s.id = null;
                s.parentNode.removeChild(s)
            } else {
                s.childNodes[0].childNodes[0].onclick = null;
                s.childNodes[0].childNodes[0].onselectstart = null;
                s.childNodes[0].childNodes[0].id = null;
                s.childNodes[0].removeChild(s.childNodes[0].childNodes[0]);
                s.removeChild(s.childNodes[0]);
                s.parentNode.removeChild(s)
            }
            this.idPull["separator_" + h] = null;
            this.itemPull[h] = null;
            delete this.idPull["separator_" + h];
            delete this.itemPull[h];
            s = null
        } else {
            m = this.itemPull[h]["parent"];
            var s = this.idPull[h];
            s.onclick = null;
            s.oncontextmenu = null;
            s.onmouseover = null;
            s.onmouseout = null;
            s.onselectstart = null;
            s.id = null;
            while (s.childNodes.length > 0) {
                s.removeChild(s.childNodes[0])
            }
            s.parentNode.removeChild(s);
            this.idPull[h] = null;
            this.itemPull[h] = null;
            delete this.idPull[h];
            delete this.itemPull[h];
            s = null
        }
        u = null
    }
    for (var o in this.itemPull) {
        if (this.itemPull[o]["parent"] == h) {
            this.removeItem(o, true, true)
        }
    }
    var r = new Array(h);
    if (m != null && !j) {
        if (this.idPull["polygon_" + m] != null) {
            if (this.idPull["polygon_" + m].tbd.childNodes.length == 0) {
                r.push(m);
                this._updateItemComplexState(m, false, false)
            }
        }
    }
    for (var c = 0; c < r.length; c++) {
        if (this.idPull["polygon_" + r[c]]) {
            var g = this.idPull["polygon_" + r[c]];
            g.onclick = null;
            g.oncontextmenu = null;
            g.tbl.removeChild(g.tbd);
            g.tbd = null;
            g.childNodes[1].removeChild(g.tbl);
            g.tbl = null;
            g.id = null;
            g.parentNode.removeChild(g);
            g = null;
            if (window.dhx4.isIE6) {
                var n = "polygon_" + r[c] + "_ie6cover";
                if (this.idPull[n] != null) {
                    document.body.removeChild(this.idPull[n]);
                    delete this.idPull[n]
                }
            }
            if (this.idPull["arrowup_" + h] != null && this._removeArrow) {
                this._removeArrow("arrowup_" + h)
            }
            if (this.idPull["arrowdown_" + h] != null && this._removeArrow) {
                this._removeArrow("arrowdown_" + h)
            }
            this.idPull["polygon_" + r[c]] = null;
            delete this.idPull["polygon_" + r[c]]
        }
    }
    r = null;
    if (this.conf.skin == "dhx_terrace" && arguments.length == 1) {
        this._improveTerraceSkin()
    }
};
dhtmlXMenuObject.prototype._addItemIntoGlobalStrorage = function (n, a, g, m, h, c, l) {
    var j = {
        id: n,
        title: g,
        imgen: (c != null ? c : ""),
        imgdis: (l != null ? l : ""),
        type: m,
        state: (h == true ? "disabled" : "enabled"),
        parent: a,
        complex: false,
        hotkey: "",
        tip: ""
    };
    this.itemPull[j.id] = j
};
dhtmlXMenuObject.prototype.renderAsContextMenu = function () {
    this.conf.context = true;
    if (this.base._autoSkinUpdate == true) {
        this.base.className = this.base.className.replace("dhtmlxMenu_" + this.conf.skin + "_Middle", "");
        this.base._autoSkinUpdate = false
    }
    if (this.conf.ctx_baseid != null) {
        this.addContextZone(this.conf.ctx_baseid)
    }
};
dhtmlXMenuObject.prototype.addContextZone = function (c) {
    if (c == document.body) {
        c = "document.body." + this.idPrefix;
        var h = document.body
    } else {
        var h = document.getElementById(c)
    }
    var l = false;
    for (var g in this.conf.ctx_zones) {
        l = l || (g == c) || (this.conf.ctx_zones[g] == h)
    }
    if (l == true) {
        return false
    }
    this.conf.ctx_zones[c] = h;
    var j = this;
    if (window.dhx4.isOpera) {
        this.operaContext = function (a) {
            j._doOnContextMenuOpera(a, j)
        };
        h.addEventListener("mouseup", this.operaContext, false)
    } else {
        if (h.oncontextmenu != null && !h._oldContextMenuHandler) {
            h._oldContextMenuHandler = h.oncontextmenu
        }
        h.oncontextmenu = function (m) {
            for (var a in dhtmlXMenuObject.prototype.liveInst) {
                if (a != j.conf.live_id) {
                    if (dhtmlXMenuObject.prototype.liveInst[a].context) {
                        dhtmlXMenuObject.prototype.liveInst[a]._hideContextMenu()
                    }
                }
            }
            m = m || event;
            m.cancelBubble = true;
            if (m.preventDefault) {
                m.preventDefault()
            } else {
                m.returnValue = false
            }
            j._doOnContextBeforeCall(m, this);
            return false
        }
    }
};
dhtmlXMenuObject.prototype._doOnContextMenuOpera = function (g, a) {
    for (var c in dhtmlXMenuObject.prototype.liveInst) {
        if (c != a.conf.live_id) {
            if (dhtmlXMenuObject.prototype.liveInst[c].context) {
                dhtmlXMenuObject.prototype.liveInst[c]._hideContextMenu()
            }
        }
    }
    g.cancelBubble = true;
    if (g.preventDefault) {
        g.preventDefault()
    } else {
        g.returnValue = false
    }
    if (g.button == 0 && g.ctrlKey == true) {
        a._doOnContextBeforeCall(g, this)
    }
    return false
};
dhtmlXMenuObject.prototype.removeContextZone = function (a) {
    if (!this.isContextZone(a)) {
        return false
    }
    if (a == document.body) {
        a = "document.body." + this.idPrefix
    }
    var c = this.conf.ctx_zones[a];
    if (window.dhx4.isOpera) {
        c.removeEventListener("mouseup", this.operaContext, false)
    } else {
        c.oncontextmenu = (c._oldContextMenuHandler != null ? c._oldContextMenuHandler : null);
        c._oldContextMenuHandler = null
    }
    try {
        this.conf.ctx_zones[a] = null;
        delete this.conf.ctx_zones[a]
    } catch (g) {}
    return true
};
dhtmlXMenuObject.prototype.isContextZone = function (a) {
    if (a == document.body && this.conf.ctx_zones["document.body." + this.idPrefix] != null) {
        return true
    }
    var c = false;
    if (this.conf.ctx_zones[a] != null) {
        if (this.conf.ctx_zones[a] == document.getElementById(a)) {
            c = true
        }
    }
    return c
};
dhtmlXMenuObject.prototype._isContextMenuVisible = function () {
    if (this.idPull["polygon_" + this.idPrefix + this.topId] == null) {
        return false
    }
    return (this.idPull["polygon_" + this.idPrefix + this.topId].style.display == "")
};
dhtmlXMenuObject.prototype._showContextMenu = function (c, g, a) {
    this._clearAndHide();
    if (this.idPull["polygon_" + this.idPrefix + this.topId] == null) {
        return false
    }
    window.clearTimeout(this.conf.tm_handler);
    this.idPull[this.idPrefix + this.topId] = new Array(c, g);
    this._showPolygon(this.idPrefix + this.topId, "bottom");
    this.callEvent("onContextMenu", [a])
};
dhtmlXMenuObject.prototype._hideContextMenu = function () {
    if (this.idPull["polygon_" + this.idPrefix + this.topId] == null) {
        return false
    }
    this._clearAndHide();
    this._hidePolygon(this.idPrefix + this.topId)
};
dhtmlXMenuObject.prototype._doOnContextBeforeCall = function (j, m) {
    this.conf.ctx_zoneid = m.id;
    this._clearAndHide();
    this._hideContextMenu();
    var h = (j.srcElement || j.target);
    var c = (window.dhx4.isIE || window.dhx4.isOpera || window.dhx4.isKHTML ? j.offsetX : j.layerX);
    var a = (window.dhx4.isIE || window.dhx4.isOpera || window.dhx4.isKHTML ? j.offsetY : j.layerY);
    var l = window.dhx4.absLeft(h) + c;
    var g = window.dhx4.absTop(h) + a;
    if (this.checkEvent("onBeforeContextMenu")) {
        if (this.callEvent("onBeforeContextMenu", [m.id, j])) {
            if (this.conf.ctx_autoshow) {
                this._showContextMenu(l, g, m.id);
                this.callEvent("onAfterContextMenu", [m.id, j])
            }
        }
    } else {
        if (this.conf.ctx_autoshow) {
            this._showContextMenu(l, g, m.id);
            this.callEvent("onAfterContextMenu", [m.id])
        }
    }
};
dhtmlXMenuObject.prototype.showContextMenu = function (a, c) {
    this._showContextMenu(a, c, false)
};
dhtmlXMenuObject.prototype.hideContextMenu = function () {
    this._hideContextMenu()
};
dhtmlXMenuObject.prototype.setAutoShowMode = function (a) {
    this.conf.ctx_autoshow = (a == true ? true : false)
};
dhtmlXMenuObject.prototype.setAutoHideMode = function (a) {
    this.conf.ctx_autohide = (a == true ? true : false)
};
dhtmlXMenuObject.prototype.setContextMenuHideAllMode = function (a) {
    this.conf.ctx_hideall = (a == true ? true : false)
};
dhtmlXMenuObject.prototype.getContextMenuHideAllMode = function () {
    return this.conf.ctx_hideall
};
dhtmlXMenuObject.prototype._improveTerraceSkin = function () {
    for (var g in this.itemPull) {
        if (this.itemPull[g].parent == this.idPrefix + this.topId && this.idPull[g] != null) {
            var j = false;
            var h = false;
            if (this.idPull[g].parentNode.firstChild == this.idPull[g]) {
                j = true
            }
            if (this.idPull[g].parentNode.lastChild == this.idPull[g]) {
                h = true
            }
            for (var c in this.itemPull) {
                if (this.itemPull[c].type == "separator" && this.itemPull[c].parent == this.idPrefix + this.topId) {
                    if (this.idPull[g].nextSibling == this.idPull["separator_" + c]) {
                        h = true
                    }
                    if (this.idPull[g].previousSibling == this.idPull["separator_" + c]) {
                        j = true
                    }
                }
            }
            this.idPull[g].style.borderLeftWidth = (j ? "1px" : "0px");
            this.idPull[g].style.borderTopLeftRadius = this.idPull[g].style.borderBottomLeftRadius = (j ? "3px" : "0px");
            this.idPull[g].style.borderTopRightRadius = this.idPull[g].style.borderBottomRightRadius = (h ? "3px" : "0px");
            this.idPull[g]._bl = j;
            this.idPull[g]._br = h
        }
    }
};
dhtmlXMenuObject.prototype._improveTerraceButton = function (c, a) {
    if (a) {
        this.idPull[c].style.borderBottomLeftRadius = (this.idPull[c]._bl ? "3px" : "0px");
        this.idPull[c].style.borderBottomRightRadius = (this.idPull[c]._br ? "3px" : "0px")
    } else {
        this.idPull[c].style.borderBottomLeftRadius = "0px";
        this.idPull[c].style.borderBottomRightRadius = "0px"
    }
};
dhtmlXMenuObject.prototype.setItemEnabled = function (a) {
    this._changeItemState(a, "enabled", this._getItemLevelType(a))
};
dhtmlXMenuObject.prototype.setItemDisabled = function (a) {
    this._changeItemState(a, "disabled", this._getItemLevelType(a))
};
dhtmlXMenuObject.prototype.isItemEnabled = function (a) {
    return (this.itemPull[this.idPrefix + a] != null ? (this.itemPull[this.idPrefix + a]["state"] == "enabled") : false)
};
dhtmlXMenuObject.prototype._changeItemState = function (l, h, c) {
    var g = false;
    var a = this.idPrefix + l;
    if ((this.itemPull[a] != null) && (this.idPull[a] != null)) {
        if (this.itemPull[a]["state"] != h) {
            this.itemPull[a]["state"] = h;
            if (this.itemPull[a]["parent"] == this.idPrefix + this.topId && !this.conf.context) {
                this.idPull[a].className = "dhtmlxMenu_" + this.conf.skin + "_TopLevel_Item_" + (this.itemPull[a]["state"] == "enabled" ? "Normal" : "Disabled")
            } else {
                this.idPull[a].className = "sub_item" + (this.itemPull[a]["state"] == "enabled" ? "" : "_dis")
            }
            this._updateItemComplexState(this.idPrefix + l, this.itemPull[this.idPrefix + l]["complex"], false);
            this._updateItemImage(l, c);
            if ((this.idPrefix + this.conf.last_click == a) && (c != "TopLevel")) {
                this._redistribSubLevelSelection(a, this.itemPull[a]["parent"])
            }
            if (c == "TopLevel" && !this.conf.context) {}
        }
    }
    return g
};
dhtmlXMenuObject.prototype.getItemText = function (a) {
    return (this.itemPull[this.idPrefix + a] != null ? this.itemPull[this.idPrefix + a]["title"] : "")
};
dhtmlXMenuObject.prototype.setItemText = function (j, h) {
    j = this.idPrefix + j;
    if ((this.itemPull[j] != null) && (this.idPull[j] != null)) {
        this._clearAndHide();
        this.itemPull[j]["title"] = h;
        if (this.itemPull[j]["parent"] == this.idPrefix + this.topId && !this.conf.context) {
            var g = null;
            for (var a = 0; a < this.idPull[j].childNodes.length; a++) {
                try {
                    if (this.idPull[j].childNodes[a].className == "top_level_text") {
                        g = this.idPull[j].childNodes[a]
                    }
                } catch (c) {}
            }
            if (String(this.itemPull[j]["title"]).length == "" || this.itemPull[j]["title"] == null) {
                if (g != null) {
                    g.parentNode.removeChild(g)
                }
            } else {
                if (!g) {
                    g = document.createElement("DIV");
                    g.className = "top_level_text";
                    if (this.conf.rtl && this.idPull[j].childNodes.length > 0) {
                        this.idPull[j].insertBefore(g, this.idPull[j].childNodes[0])
                    } else {
                        this.idPull[j].appendChild(g)
                    }
                }
                g.innerHTML = this.itemPull[j]["title"]
            }
        } else {
            var g = null;
            for (var a = 0; a < this.idPull[j].childNodes[1].childNodes.length; a++) {
                if (String(this.idPull[j].childNodes[1].childNodes[a].className || "") == "sub_item_text") {
                    g = this.idPull[j].childNodes[1].childNodes[a]
                }
            }
            if (String(this.itemPull[j]["title"]).length == "" || this.itemPull[j]["title"] == null) {
                if (g) {
                    g.parentNode.removeChild(g);
                    g = null;
                    this.idPull[j].childNodes[1].innerHTML = "&nbsp;"
                }
            } else {
                if (!g) {
                    g = document.createElement("DIV");
                    g.className = "sub_item_text";
                    this.idPull[j].childNodes[1].innerHTML = "";
                    this.idPull[j].childNodes[1].appendChild(g)
                }
                g.innerHTML = this.itemPull[j]["title"]
            }
        }
    }
};
dhtmlXMenuObject.prototype.loadFromHTML = function (g, l, h) {
    var c = this.conf.tags.item;
    this.conf.tags.item = "div";
    var j = (typeof (g) == "string" ? document.getElementById(g) : g);
    var a = this._xmlToJson(j, this.idPrefix + this.topId);
    this._initObj(a);
    this.conf.tags.item = c;
    if (l) {
        j.parentNode.removeChild(j)
    }
    j = objOd = null;
    if (onload != null) {
        if (typeof (h) == "function") {
            h()
        } else {
            if (typeof (window[h]) == "function") {
                window[h]()
            }
        }
    }
};
dhtmlXMenuObject.prototype.hideItem = function (a) {
    this._changeItemVisible(a, false)
};
dhtmlXMenuObject.prototype.showItem = function (a) {
    this._changeItemVisible(a, true)
};
dhtmlXMenuObject.prototype.isItemHidden = function (c) {
    var a = null;
    if (this.idPull[this.idPrefix + c] != null) {
        a = (this.idPull[this.idPrefix + c].style.display == "none")
    }
    return a
};
dhtmlXMenuObject.prototype._changeItemVisible = function (g, c) {
    var a = this.idPrefix + g;
    if (this.itemPull[a] == null) {
        return
    }
    if (this.itemPull[a]["type"] == "separator") {
        a = "separator_" + a
    }
    if (this.idPull[a] == null) {
        return
    }
    this.idPull[a].style.display = (c ? "" : "none");
    this._redefineComplexState(this.itemPull[this.idPrefix + g]["parent"])
};
dhtmlXMenuObject.prototype.setUserData = function (g, a, c) {
    this.userData[this.idPrefix + g + "_" + a] = c
};
dhtmlXMenuObject.prototype.getUserData = function (c, a) {
    return (this.userData[this.idPrefix + c + "_" + a] != null ? this.userData[this.idPrefix + c + "_" + a] : null)
};
dhtmlXMenuObject.prototype.setOpenMode = function (a) {
    this.conf.mode = (a == "win" ? "win" : "web")
};
dhtmlXMenuObject.prototype.setWebModeTimeout = function (a) {
    this.conf.tm_sec = (!isNaN(a) ? a : 400)
};
dhtmlXMenuObject.prototype.getItemImage = function (c) {
    var a = new Array(null, null);
    c = this.idPrefix + c;
    if (this.itemPull[c]["type"] == "item") {
        a[0] = this.itemPull[c]["imgen"];
        a[1] = this.itemPull[c]["imgdis"]
    }
    return a
};
dhtmlXMenuObject.prototype.setItemImage = function (g, a, c) {
    if (this.itemPull[this.idPrefix + g]["type"] != "item") {
        return
    }
    this.itemPull[this.idPrefix + g]["imgen"] = a;
    this.itemPull[this.idPrefix + g]["imgdis"] = c;
    this._updateItemImage(g, this._getItemLevelType(g))
};
dhtmlXMenuObject.prototype.clearItemImage = function (a) {
    this.setItemImage(a, "", "")
};
dhtmlXMenuObject.prototype.setVisibleArea = function (c, a, h, g) {
    this.conf.v_enabled = true;
    this.conf.v.x1 = c;
    this.conf.v.x2 = a;
    this.conf.v.y1 = h;
    this.conf.v.y2 = g
};
dhtmlXMenuObject.prototype.setTooltip = function (c, a) {
    c = this.idPrefix + c;
    if (!(this.itemPull[c] != null && this.idPull[c] != null)) {
        return
    }
    this.idPull[c].title = (a.length > 0 ? a : null);
    this.itemPull[c]["tip"] = a
};
dhtmlXMenuObject.prototype.getTooltip = function (a) {
    if (this.itemPull[this.idPrefix + a] == null) {
        return null
    }
    return this.itemPull[this.idPrefix + a]["tip"]
};
dhtmlXMenuObject.prototype.setTopText = function (a) {
    if (this.conf.context) {
        return
    }
    if (this._topText == null) {
        this._topText = document.createElement("DIV");
        this._topText.className = "dhtmlxMenu_TopLevel_Text_" + (this.conf.rtl ? "left" : (this.conf.align == "left" ? "right" : "left"));
        this.base.appendChild(this._topText)
    }
    this._topText.innerHTML = a
};
dhtmlXMenuObject.prototype.setAlign = function (a) {
    if (this.conf.align == a) {
        return
    }
    if (a == "left" || a == "right") {
        this.conf.align = a;
        if (this.cont) {
            this.cont.className = (this.conf.align == "right" ? "align_right" : "align_left")
        }
        if (this._topText != null) {
            this._topText.className = "dhtmlxMenu_TopLevel_Text_" + (this.conf.align == "left" ? "right" : "left")
        }
    }
};
dhtmlXMenuObject.prototype.setHref = function (g, a, c) {
    if (this.itemPull[this.idPrefix + g] == null) {
        return
    }
    this.itemPull[this.idPrefix + g]["href_link"] = a;
    if (c != null) {
        this.itemPull[this.idPrefix + g]["href_target"] = c
    }
};
dhtmlXMenuObject.prototype.clearHref = function (a) {
    if (this.itemPull[this.idPrefix + a] == null) {
        return
    }
    delete this.itemPull[this.idPrefix + a]["href_link"];
    delete this.itemPull[this.idPrefix + a]["href_target"]
};
dhtmlXMenuObject.prototype.getCircuit = function (c) {
    var a = new Array(c);
    while (this.getParentId(c) != this.topId) {
        c = this.getParentId(c);
        a[a.length] = c
    }
    return a.reverse()
};
dhtmlXMenuObject.prototype._getCheckboxState = function (a) {
    if (this.itemPull[this.idPrefix + a] == null) {
        return null
    }
    return this.itemPull[this.idPrefix + a]["checked"]
};
dhtmlXMenuObject.prototype._setCheckboxState = function (c, a) {
    if (this.itemPull[this.idPrefix + c] == null) {
        return
    }
    this.itemPull[this.idPrefix + c]["checked"] = a
};
dhtmlXMenuObject.prototype._updateCheckboxImage = function (c) {
    if (this.idPull[this.idPrefix + c] == null) {
        return
    }
    this.itemPull[this.idPrefix + c]["imgen"] = "chbx_" + (this._getCheckboxState(c) ? "1" : "0");
    this.itemPull[this.idPrefix + c]["imgdis"] = this.itemPull[this.idPrefix + c]["imgen"];
    try {
        this.idPull[this.idPrefix + c].childNodes[(this.conf.rtl ? 2 : 0)].childNodes[0].className = "sub_icon " + this.itemPull[this.idPrefix + c]["imgen"]
    } catch (a) {}
};
dhtmlXMenuObject.prototype._checkboxOnClickHandler = function (h, a, c) {
    if (a.charAt(1) == "d") {
        return
    }
    if (this.itemPull[this.idPrefix + h] == null) {
        return
    }
    var g = this._getCheckboxState(h);
    if (this.checkEvent("onCheckboxClick")) {
        if (this.callEvent("onCheckboxClick", [h, g, this.conf.ctx_zoneid, c])) {
            this.setCheckboxState(h, !g)
        }
    } else {
        this.setCheckboxState(h, !g)
    }
    if (this.checkEvent("onClick")) {
        this.callEvent("onClick", [h])
    }
};
dhtmlXMenuObject.prototype.setCheckboxState = function (c, a) {
    this._setCheckboxState(c, a);
    this._updateCheckboxImage(c)
};
dhtmlXMenuObject.prototype.getCheckboxState = function (a) {
    return this._getCheckboxState(a)
};
dhtmlXMenuObject.prototype.addCheckbox = function (n, h, o, q, r, a, j) {
    if (this.conf.context && h == this.topId) {} else {
        if (this.itemPull[this.idPrefix + h] == null) {
            return
        }
        if (n == "child" && this.itemPull[this.idPrefix + h]["type"] != "item") {
            return
        }
    }
    var l = "chbx_" + (a ? "1" : "0");
    var g = l;
    if (n == "sibling") {
        var c = this.idPrefix + (q != null ? q : this._genStr(24));
        var m = this.idPrefix + this.getParentId(h);
        this._addItemIntoGlobalStrorage(c, m, r, "checkbox", j, l, g);
        this.itemPull[c]["checked"] = a;
        this._renderSublevelItem(c, this.getItemPosition(h))
    } else {
        var c = this.idPrefix + (q != null ? q : this._genStr(24));
        var m = this.idPrefix + h;
        this._addItemIntoGlobalStrorage(c, m, r, "checkbox", j, l, g);
        this.itemPull[c]["checked"] = a;
        if (this.idPull["polygon_" + m] == null) {
            this._renderSublevelPolygon(m, m)
        }
        this._renderSublevelItem(c, o - 1);
        this._redefineComplexState(m)
    }
};
dhtmlXMenuObject.prototype.setHotKey = function (l, a) {
    l = this.idPrefix + l;
    if (!(this.itemPull[l] != null && this.idPull[l] != null)) {
        return
    }
    if (this.itemPull[l]["parent"] == this.idPrefix + this.topId && !this.conf.context) {
        return
    }
    if (this.itemPull[l]["complex"]) {
        return
    }
    var c = this.itemPull[l]["type"];
    if (!(c == "item" || c == "checkbox" || c == "radio")) {
        return
    }
    var j = null;
    try {
        if (this.idPull[l].childNodes[this.conf.rtl ? 0 : 2].childNodes[0].className == "sub_item_hk") {
            j = this.idPull[l].childNodes[this.conf.rtl ? 0 : 2].childNodes[0]
        }
    } catch (h) {}
    if (a.length == 0) {
        this.itemPull[l]["hotkey_backup"] = this.itemPull[l]["hotkey"];
        this.itemPull[l]["hotkey"] = "";
        if (j != null) {
            j.parentNode.removeChild(j)
        }
    } else {
        this.itemPull[l]["hotkey"] = a;
        this.itemPull[l]["hotkey_backup"] = null;
        if (j == null) {
            j = document.createElement("DIV");
            j.className = "sub_item_hk";
            var g = this.idPull[l].childNodes[this.conf.rtl ? 0 : 2];
            while (g.childNodes.length > 0) {
                g.removeChild(g.childNodes[0])
            }
            g.appendChild(j)
        }
        j.innerHTML = a
    }
};
dhtmlXMenuObject.prototype.getHotKey = function (a) {
    if (this.itemPull[this.idPrefix + a] == null) {
        return null
    }
    return this.itemPull[this.idPrefix + a]["hotkey"]
};
dhtmlXMenuObject.prototype._clearAllSelectedSubItemsInPolygon = function (a) {
    var g = this._getSubItemToDeselectByPolygon(a);
    for (var c = 0; c < this.conf.opened_poly.length; c++) {
        if (this.conf.opened_poly[c] != a) {
            this._hidePolygon(this.conf.opened_poly[c])
        }
    }
    for (var c = 0; c < g.length; c++) {
        if (this.idPull[g[c]] != null && this.itemPull[g[c]]["state"] == "enabled") {
            this.idPull[g[c]].className = "dhtmlxMenu_" + this.conf.skin + "_SubLevelArea_Item_Normal"
        }
    }
};
dhtmlXMenuObject.prototype._checkArrowsState = function (h) {
    var c = this.idPull["polygon_" + h].childNodes[1];
    var g = this.idPull["arrowup_" + h];
    var a = this.idPull["arrowdown_" + h];
    if (c.scrollTop == 0) {
        g.className = "dhtmlxMenu_" + this.conf.skin + "_SubLevelArea_ArrowUp_Disabled"
    } else {
        g.className = "dhtmlxMenu_" + this.conf.skin + "_SubLevelArea_ArrowUp" + (g.over ? "_Over" : "")
    }
    if (c.scrollTop + c.offsetHeight < c.scrollHeight) {
        a.className = "dhtmlxMenu_" + this.conf.skin + "_SubLevelArea_ArrowDown" + (a.over ? "_Over" : "")
    } else {
        a.className = "dhtmlxMenu_" + this.conf.skin + "_SubLevelArea_ArrowDown_Disabled"
    }
    c = g = a = null
};
dhtmlXMenuObject.prototype._addUpArrow = function (h) {
    var c = this;
    var g = document.createElement("DIV");
    g.pId = this.idPrefix + h;
    g.id = "arrowup_" + this.idPrefix + h;
    g.className = "dhtmlxMenu_" + this.conf.skin + "_SubLevelArea_ArrowUp";
    g.over = false;
    g.onselectstart = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
        return false
    };
    g.oncontextmenu = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
        return false
    };
    g.onmouseover = function () {
        if (c.conf.mode == "web") {
            window.clearTimeout(c.conf.tm_handler)
        }
        c._clearAllSelectedSubItemsInPolygon(this.pId);
        if (this.className == "dhtmlxMenu_" + c.conf.skin + "_SubLevelArea_ArrowUp_Disabled") {
            return
        }
        this.className = "dhtmlxMenu_" + c.conf.skin + "_SubLevelArea_ArrowUp_Over";
        this.over = true;
        c._canScrollUp = true;
        c._doScrollUp(this.pId, true)
    };
    g.onmouseout = function () {
        if (c.conf.mode == "web") {
            window.clearTimeout(c.conf.tm_handler);
            c.conf.tm_handler = window.setTimeout(function () {
                c._clearAndHide()
            }, c.conf.tm_sec, "JavaScript")
        }
        this.over = false;
        c._canScrollUp = false;
        if (this.className == "dhtmlxMenu_" + c.conf.skin + "_SubLevelArea_ArrowUp_Disabled") {
            return
        }
        this.className = "dhtmlxMenu_" + c.conf.skin + "_SubLevelArea_ArrowUp";
        window.clearTimeout(c.conf.of_utm)
    };
    g.onclick = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
        j.cancelBubble = true;
        return false
    };
    var a = this.idPull["polygon_" + this.idPrefix + h];
    a.childNodes[0].appendChild(g);
    this.idPull[g.id] = g;
    a = g = null
};
dhtmlXMenuObject.prototype._addDownArrow = function (h) {
    var c = this;
    var g = document.createElement("DIV");
    g.pId = this.idPrefix + h;
    g.id = "arrowdown_" + this.idPrefix + h;
    g.className = "dhtmlxMenu_" + this.conf.skin + "_SubLevelArea_ArrowDown";
    g.over = false;
    g.onselectstart = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
        return false
    };
    g.oncontextmenu = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
        return false
    };
    g.onmouseover = function () {
        if (c.conf.mode == "web") {
            window.clearTimeout(c.conf.tm_handler)
        }
        c._clearAllSelectedSubItemsInPolygon(this.pId);
        if (this.className == "dhtmlxMenu_" + c.conf.skin + "_SubLevelArea_ArrowDown_Disabled") {
            return
        }
        this.className = "dhtmlxMenu_" + c.conf.skin + "_SubLevelArea_ArrowDown_Over";
        this.over = true;
        c._canScrollDown = true;
        c._doScrollDown(this.pId, true)
    };
    g.onmouseout = function () {
        if (c.conf.mode == "web") {
            window.clearTimeout(c.conf.tm_handler);
            c.conf.tm_handler = window.setTimeout(function () {
                c._clearAndHide()
            }, c.conf.tm_sec, "JavaScript")
        }
        this.over = false;
        c._canScrollDown = false;
        if (this.className == "dhtmlxMenu_" + c.conf.skin + "_SubLevelArea_ArrowDown_Disabled") {
            return
        }
        this.className = "dhtmlxMenu_" + c.conf.skin + "_SubLevelArea_ArrowDown";
        window.clearTimeout(c.conf.of_dtm)
    };
    g.onclick = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
        j.cancelBubble = true;
        return false
    };
    var a = this.idPull["polygon_" + this.idPrefix + h];
    a.childNodes[2].appendChild(g);
    this.idPull[g.id] = g;
    a = g = null
};
dhtmlXMenuObject.prototype._removeUpArrow = function (c) {
    var a = "arrowup_" + this.idPrefix + c;
    this._removeArrow(a)
};
dhtmlXMenuObject.prototype._removeDownArrow = function (c) {
    var a = "arrowdown_" + this.idPrefix + c;
    this._removeArrow(a)
};
dhtmlXMenuObject.prototype._removeArrow = function (a) {
    var c = this.idPull[a];
    c.onselectstart = null;
    c.oncontextmenu = null;
    c.onmouseover = null;
    c.onmouseout = null;
    c.onclick = null;
    if (c.parentNode) {
        c.parentNode.removeChild(c)
    }
    c = null;
    this.idPull[a] = null;
    try {
        delete this.idPull[a]
    } catch (g) {}
};
dhtmlXMenuObject.prototype._isArrowExists = function (a) {
    if (this.idPull["arrowup_" + a] != null && this.idPull["arrowdown_" + a] != null) {
        return true
    }
    return false
};
dhtmlXMenuObject.prototype._doScrollUp = function (l, h) {
    var a = this.idPull["polygon_" + l].childNodes[1];
    if (this._canScrollUp && a.scrollTop > 0) {
        var g = false;
        var j = a.scrollTop - this.conf.of_ustep;
        if (j < 0) {
            g = true;
            j = 0
        }
        a.scrollTop = j;
        if (!g) {
            var c = this;
            this.conf.of_utm = window.setTimeout(function () {
                c._doScrollUp(l, false);
                c = null
            }, this.conf.of_utime)
        } else {
            h = true
        }
    } else {
        this._canScrollUp = false;
        this._checkArrowsState(l)
    }
    if (h) {
        this._checkArrowsState(l)
    }
};
dhtmlXMenuObject.prototype._doScrollDown = function (l, h) {
    var a = this.idPull["polygon_" + l].childNodes[1];
    if (this._canScrollDown && a.scrollTop + a.offsetHeight <= a.scrollHeight) {
        var g = false;
        var j = a.scrollTop + this.conf.of_dstep;
        if (j + a.offsetHeight >= a.scrollHeight) {
            g = true;
            j = a.scrollHeight - a.offsetHeight
        }
        a.scrollTop = j;
        if (!g) {
            var c = this;
            this.conf.of_dtm = window.setTimeout(function () {
                c._doScrollDown(l, false);
                c = null
            }, this.conf.of_dtime)
        } else {
            h = true
        }
    } else {
        this._canScrollDown = false;
        this._checkArrowsState(l)
    }
    if (h) {
        this._checkArrowsState(l)
    }
};
dhtmlXMenuObject.prototype._countPolygonItems = function (l) {
    var h = 0;
    for (var c in this.itemPull) {
        var g = this.itemPull[c]["parent"];
        var j = this.itemPull[c]["type"];
        if (g == this.idPrefix + l && (j == "item" || j == "radio" || j == "checkbox")) {
            h++
        }
    }
    return h
};
dhtmlXMenuObject.prototype.setOverflowHeight = function (h) {
    if (h === "auto") {
        this.conf.overflow_limit = 0;
        this.conf.auto_overflow = true;
        return
    }
    if (this.conf.overflow_limit == 0 && h <= 0) {
        return
    }
    this._clearAndHide();
    if (this.conf.overflow_limit >= 0 && h > 0) {
        this.conf.overflow_limit = h;
        return
    }
    if (this.conf.overflow_limit > 0 && h <= 0) {
        for (var g in this.itemPull) {
            if (this._isArrowExists(g)) {
                var c = String(g).replace(this.idPrefix, "");
                this._removeUpArrow(c);
                this._removeDownArrow(c);
                this.idPull["polygon_" + g].childNodes[1].style.height = ""
            }
        }
        this.conf.overflow_limit = 0;
        return
    }
};
dhtmlXMenuObject.prototype._getRadioImgObj = function (g) {
    try {
        var a = this.idPull[this.idPrefix + g].childNodes[(this.conf.rtl ? 2 : 0)].childNodes[0]
    } catch (c) {
        var a = null
    }
    return a
};
dhtmlXMenuObject.prototype._setRadioState = function (h, g) {
    var c = this._getRadioImgObj(h);
    if (c != null) {
        var a = this.itemPull[this.idPrefix + h];
        a.checked = g;
        a.imgen = "rdbt_" + (a.checked ? "1" : "0");
        a.imgdis = a.imgen;
        c.className = "sub_icon " + a.imgen
    }
};
dhtmlXMenuObject.prototype._radioOnClickHandler = function (h, a, c) {
    if (a.charAt(1) == "d" || this.itemPull[this.idPrefix + h]["group"] == null) {
        return
    }
    var g = this.itemPull[this.idPrefix + h]["group"];
    if (this.checkEvent("onRadioClick")) {
        if (this.callEvent("onRadioClick", [g, this.getRadioChecked(g), h, this.conf.ctx_zoneid, c])) {
            this.setRadioChecked(g, h)
        }
    } else {
        this.setRadioChecked(g, h)
    }
    if (this.checkEvent("onClick")) {
        this.callEvent("onClick", [h])
    }
};
dhtmlXMenuObject.prototype.getRadioChecked = function (h) {
    var l = null;
    for (var g = 0; g < this.radio[h].length; g++) {
        var j = this.radio[h][g].replace(this.idPrefix, "");
        var a = this._getRadioImgObj(j);
        if (a != null) {
            var c = (a.className).match(/rdbt_1$/gi);
            if (c != null) {
                l = j
            }
        }
    }
    return l
};
dhtmlXMenuObject.prototype.setRadioChecked = function (c, h) {
    if (this.radio[c] == null) {
        return
    }
    for (var a = 0; a < this.radio[c].length; a++) {
        var g = this.radio[c][a].replace(this.idPrefix, "");
        this._setRadioState(g, (g == h))
    }
};
dhtmlXMenuObject.prototype.addRadioButton = function (o, j, q, r, s, u, a, l) {
    if (this.conf.context && j == this.topId) {} else {
        if (this.itemPull[this.idPrefix + j] == null) {
            return
        }
        if (o == "child" && this.itemPull[this.idPrefix + j]["type"] != "item") {
            return
        }
    }
    var g = this.idPrefix + (r != null ? r : this._genStr(24));
    var m = "rdbt_" + (a ? "1" : "0");
    var c = m;
    if (o == "sibling") {
        var n = this.idPrefix + this.getParentId(j);
        this._addItemIntoGlobalStrorage(g, n, s, "radio", l, m, c);
        this._renderSublevelItem(g, this.getItemPosition(j))
    } else {
        var n = this.idPrefix + j;
        this._addItemIntoGlobalStrorage(g, n, s, "radio", l, m, c);
        if (this.idPull["polygon_" + n] == null) {
            this._renderSublevelPolygon(n, n)
        }
        this._renderSublevelItem(g, q - 1);
        this._redefineComplexState(n)
    }
    var h = (u != null ? u : this._genStr(24));
    this.itemPull[g]["group"] = h;
    if (this.radio[h] == null) {
        this.radio[h] = new Array()
    }
    this.radio[h][this.radio[h].length] = g;
    if (a == true) {
        this.setRadioChecked(h, String(g).replace(this.idPrefix, ""))
    }
};
dhtmlXMenuObject.prototype.serialize = function () {
    var a = "<menu>" + this._readLevel(this.idPrefix + this.topId) + "</menu>";
    return a
};
dhtmlXMenuObject.prototype._readLevel = function (h) {
    var j = "";
    for (var o in this.itemPull) {
        if (this.itemPull[o]["parent"] == h) {
            var c = "";
            var g = "";
            var r = "";
            var n = String(this.itemPull[o]["id"]).replace(this.idPrefix, "");
            var m = "";
            var q = (this.itemPull[o]["title"] != "" ? ' text="' + this.itemPull[o]["title"] + '"' : "");
            var l = "";
            if (this.itemPull[o]["type"] == "item") {
                if (this.itemPull[o]["imgen"] != "") {
                    c = ' img="' + this.itemPull[o]["imgen"] + '"'
                }
                if (this.itemPull[o]["imgdis"] != "") {
                    g = ' imgdis="' + this.itemPull[o]["imgdis"] + '"'
                }
                if (this.itemPull[o]["hotkey"] != "") {
                    r = "<hotkey>" + this.itemPull[o]["hotkey"] + "</hotkey>"
                }
            }
            if (this.itemPull[o]["type"] == "separator") {
                m = ' type="separator"'
            } else {
                if (this.itemPull[o]["state"] == "disabled") {
                    l = ' enabled="false"'
                }
            }
            if (this.itemPull[o]["type"] == "checkbox") {
                m = ' type="checkbox"' + (this.itemPull[o]["checked"] ? ' checked="true"' : "")
            }
            if (this.itemPull[o]["type"] == "radio") {
                m = ' type="radio" group="' + this.itemPull[o]["group"] + '" ' + (this.itemPull[o]["checked"] ? ' checked="true"' : "")
            }
            j += "<item id='" + n + "'" + q + m + c + g + l + ">";
            j += r;
            if (this.itemPull[o]["complex"]) {
                j += this._readLevel(o)
            }
            j += "</item>"
        }
    }
    return j
};
dhtmlXMenuObject.prototype.enableEffect = function (g, j, h) {
    this._menuEffect = (g == "opacity" || g == "slide" || g == "slide+" ? g : false);
    this._pOpStyleIE = (navigator.userAgent.search(/MSIE\s[678]\.0/gi) >= 0);
    for (var c in this.idPull) {
        if (c.search(/polygon/) === 0) {
            this._pOpacityApply(c, (this._pOpStyleIE ? 100 : 1));
            this.idPull[c].style.height = ""
        }
    }
    this._pOpMax = (typeof (j) == "undefined" ? 100 : j) / (this._pOpStyleIE ? 1 : 100);
    this._pOpStyleName = (this._pOpStyleIE ? "filter" : "opacity");
    this._pOpStyleValue = (this._pOpStyleIE ? "progid:DXImageTransform.Microsoft.Alpha(Opacity=#)" : "#");
    this._pSlSteps = (this._pOpStyleIE ? 10 : 20);
    this._pSlTMTimeMax = h || 50
};
dhtmlXMenuObject.prototype._showPolygonEffect = function (a) {
    this._pShowHide(a, true)
};
dhtmlXMenuObject.prototype._hidePolygonEffect = function (a) {
    this._pShowHide(a, false)
};
dhtmlXMenuObject.prototype._pOpacityApply = function (a, c) {
    this.idPull[a].style[this._pOpStyleName] = String(this._pOpStyleValue).replace("#", c || this.idPull[a]._op)
};
dhtmlXMenuObject.prototype._pShowHide = function (a, c) {
    if (!this.idPull) {
        return
    }
    if (this.idPull[a]._tmShow != null) {
        if ((this.idPull[a]._step_h > 0 && c == true) || (this.idPull[a]._step_h < 0 && c == false)) {
            return
        }
        window.clearTimeout(this.idPull[a]._tmShow);
        this.idPull[a]._tmShow = null;
        this.idPull[a]._max_h = null
    }
    if (c == false && (this.idPull[a].style.visibility == "hidden" || this.idPull[a].style.display == "none")) {
        return
    }
    if (c == true && this.idPull[a].style.display == "none") {
        this.idPull[a].style.visibility = "hidden";
        this.idPull[a].style.display = ""
    }
    if (this.idPull[a]._max_h == null) {
        this.idPull[a]._max_h = parseInt(this.idPull[a].offsetHeight);
        this.idPull[a]._h = (c == true ? 0 : this.idPull[a]._max_h);
        this.idPull[a]._step_h = Math.round(this.idPull[a]._max_h / this._pSlSteps) * (c == true ? 1 : -1);
        if (this.idPull[a]._step_h == 0) {
            return
        }
        this.idPull[a]._step_tm = Math.round(this._pSlTMTimeMax / this._pSlSteps);
        if (this._menuEffect == "slide+" || this._menuEffect == "opacity") {
            this.idPull[a].op_tm = this.idPull[a]._step_tm;
            this.idPull[a].op_step = (this._pOpMax / this._pSlSteps) * (c == true ? 1 : -1);
            if (this._pOpStyleIE) {
                this.idPull[a].op_step = Math.round(this.idPull[a].op_step)
            }
            this.idPull[a]._op = (c == true ? 0 : this._pOpMax);
            this._pOpacityApply(a)
        } else {
            this.idPull[a]._op = (this._pOpStyleIE ? 100 : 1);
            this._pOpacityApply(a)
        }
        if (this._menuEffect.search(/slide/) === 0) {
            this.idPull[a].style.height = "0px"
        }
        this.idPull[a].style.visibility = "visible"
    }
    this._pEffectSet(a, this.idPull[a]._h + this.idPull[a]._step_h)
};
dhtmlXMenuObject.prototype._pEffectSet = function (g, c) {
    if (!this.idPull) {
        return
    }
    if (this.idPull[g]._tmShow) {
        window.clearTimeout(this.idPull[g]._tmShow)
    }
    this.idPull[g]._h = Math.max(0, Math.min(c, this.idPull[g]._max_h));
    if (this._menuEffect.search(/slide/) === 0) {
        this.idPull[g].style.height = this.idPull[g]._h + "px"
    }
    c += this.idPull[g]._step_h;
    if (this._menuEffect == "slide+" || this._menuEffect == "opacity") {
        this.idPull[g]._op = Math.max(0, Math.min(this._pOpMax, this.idPull[g]._op + this.idPull[g].op_step));
        this._pOpacityApply(g)
    }
    if ((this.idPull[g]._step_h > 0 && c <= this.idPull[g]._max_h) || (this.idPull[g]._step_h < 0 && c >= 0)) {
        var a = this;
        this.idPull[g]._tmShow = window.setTimeout(function () {
            a._pEffectSet(g, c)
        }, this.idPull[g]._step_tm)
    } else {
        if (this._menuEffect.search(/slide/) === 0) {
            this.idPull[g].style.height = ""
        }
        if (this.idPull[g]._step_h < 0) {
            this.idPull[g].style.visibility = "hidden"
        }
        if (this._menuEffect == "slide+" || this._menuEffect == "opacity") {
            this.idPull[g]._op = (this.idPull[g]._step_h < 0 ? (this._pOpStyleIE ? 100 : 1) : this._pOpMax);
            this._pOpacityApply(g)
        }
        this.idPull[g]._tmShow = null;
        this.idPull[g]._h = null;
        this.idPull[g]._max_h = null;
        this.idPull[g]._step_tm = null
    }
};

function dhtmlXRibbon(h) {
    var g = this,
        c, a;
    this.conf = {
        type: "ribbon",
        icons_path: (h && h.icons_path) ? h.icons_path : "",
        skin: "dhx_skyblue"
    };
    this._eventHandlers = {};
    this._base = null;
    this._items = {};
    this._tabbar = null;
    this.childIds = [];
    if (typeof (h) == "string") {
        a = h
    } else {
        if (h && h.tagName) {
            a = h
        } else {
            if (h && h.parent) {
                if (h.parent.tagName || typeof (h.parent) == "string") {
                    a = h.parent
                }
            }
        }
    }
    this._doOnHighlight0 = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        if (g.items[l.type] && typeof (g.items[l.type].mouseover) == "function") {
            if (g.items[l.type].mouseover(l, g, n) != true) {
                return false
            }
        }
        if (!/dhxrb_highlight0/.test(j.className)) {
            j.className += " dhxrb_highlight0"
        }
    };
    this._doOffHighlight0 = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        if (g.items[l.type] && typeof (g.items[l.type].mouseout) == "function") {
            if (g.items[l.type].mouseout(l, g, n) != true) {
                return false
            }
        }
        if (/dhxrb_highlight1/.test(j.className)) {
            j.className = j.className.replace(/\s?dhxrb_highlight1/, "")
        }
        if (/dhxrb_highlight0/.test(j.className)) {
            j.className = j.className.replace(/\s?dhxrb_highlight0/, "")
        }
    };
    this._doOnHighlight1 = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        g.callEvent("_showPopup", [l.id]);
        if (g.items[l.type] && typeof (g.items[l.type].mousedown) == "function") {
            if (g.items[l.type].mousedown(l, g, n) != true) {
                return false
            }
        }
        if (!/dhxrb_highlight1/.test(j.className)) {
            j.className += " dhxrb_highlight1"
        }
    };
    this._doOffHighlight1 = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        if (g.items[l.type] && typeof (g.items[l.type].mouseup) == "function") {
            if (g.items[l.type].mouseup(l, g, n) != true) {
                return false
            }
        }
        if (/dhxrb_highlight1/.test(j.className)) {
            j.className = j.className.replace(/\s?dhxrb_highlight1/, "")
        }
    };
    this._doOnClick = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        if (g.items[l.type] && typeof (g.items[l.type].click) == "function") {
            g.items[l.type].click(l, g, n)
        }
    };
    this._doOnFocus = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        g.callEvent("_showPopup", [l.id]);
        if (g.items[l.type] && typeof (g.items[l.type].focus) == "function") {
            g.items[l.type].focus(l, g, n)
        }
    };
    this._doOnBlur = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        if (g.items[l.type] && typeof (g.items[l.type].blur) == "function") {
            g.items[l.type].blur(l, g, n)
        }
    };
    this._doOnChange = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        if (g.items[l.type] && typeof (g.items[l.type].change) == "function") {
            g.items[l.type].change(l, g, n)
        }
    };
    this._doOnKeydown = function (n) {
        n = n || event;
        var m = n.target || n.srcElement;
        var j = g._findItemByNode(m);
        var l = g._items[j._dhx_ribbonId];
        if (l.conf.disable) {
            return
        }
        if (g.items[l.type] && typeof (g.items[l.type].keydown) == "function") {
            g.items[l.type].keydown(l, g, n)
        }
    };
    this._tabCustomApi = {
        enable: function (n, m) {
            var l = null,
                j = null;
            m = m || false;
            if (m != true) {
                l = g._items[this._idd];
                for (j in l.childIds) {
                    j = parseInt(j);
                    g.enable(l.childIds[j])
                }
            }
            return g._tabOriginalApi.enable.apply(this, [n])
        },
        disable: function (n, m) {
            var l = null,
                j = null;
            if (m != false) {
                l = g._items[this._idd];
                for (j in l.childIds) {
                    j = parseInt(j);
                    g.disable(l.childIds[j])
                }
            }
            return g._tabOriginalApi.disable.apply(this, [n])
        },
        close: function (m) {
            var l = g._items[this._idd],
                j;
            g._removeTab(l);
            g._tabOriginalApi.close.apply(this, [m]);
            for (j in g._tabOriginalApi) {
                this[j] = null
            }
        }
    };
    this._attachEventTabbar = function () {
        this._tabbar.attachEvent("onSelect", function () {
            return g.callEvent("onSelect", arguments)
        });
        this._tabbar.attachEvent("onTabClick", function () {
            return g.callEvent("onTabClick", arguments)
        });
        this._tabbar.attachEvent("onTabClose", function () {
            return g.callEvent("onTabClose", arguments)
        })
    };
    if (typeof (a) == "string") {
        this._base = document.getElementById(a)
    } else {
        if (a && a.tagName) {
            this._base = a
        } else {
            this._base = document.createElement("div");
            this._base._dhx_remove = true;
            if (document.body.firstChild) {
                document.body.insertBefore(this._base, document.body.firstChild)
            } else {
                document.body.appendChild(this._base)
            }
        }
    }
    c = dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || dhx4.skinDetect("dhtmlxribbon") || "dhx_skyblue";
    if (typeof (h) == "object" && h.skin) {
        c = h.skin
    }
    this.setSkin(c);
    dhx4._eventable(this);
    dhx4._enableDataLoading(this, "_renderData", "_xmlToJson", "ribbon", {
        struct: true
    });
    this.attachEvent("_onHeightChanged", function () {
        this.conf.inited = true
    });
    this._base.className += " dhxrb_without_tabbar";
    this._base.innerHTML = "<div class='dhxrb_background_area'></div>";
    if (h != null) {
        if (h.json) {
            this.loadStruct(h.json, h.onload)
        } else {
            if (h.xml) {
                this.loadStruct(h.xml, h.onload)
            } else {
                this._renderData(h)
            }
        }
    }
    this.unload = function () {
        var l = null,
            j = [];
        for (l in this.childIds) {
            l = parseInt(l);
            j.push(this.childIds[l])
        }
        dhx4._enableDataLoading(this, null, null, null, "clear");
        dhx4._eventable(this, "clear");
        for (l in j) {
            l = parseInt(l);
            if (this._items[j[l]].type == "tab") {
                this.tabs(j[l]).close(false)
            } else {
                this.removeItem(j[l])
            }
        }
        if (this._tabbar) {
            this._tabbar.unload();
            this._tabbar = null
        }
        this._base.innerHTML = "";
        if (this._base._dhx_remove) {
            this._base.parentNode.removeChild(this._base)
        } else {
            this._base.className = this._base.className.replace(/\s?(dhtmlx|dhxrb)(\S*)/ig, "")
        }
        for (l in this) {
            this[l] = null
        }
        g = null
    }
}
dhtmlXRibbon.prototype.setSizes = function () {
    if (this._tabbar != null && typeof (this.setSizes) == "function") {
        this._tabbar.setSizes()
    }
};
dhtmlXRibbon.prototype._renderData = function (c) {
    var a = this._base.firstChild;
    if (c != null) {
        this.conf.icons_path = c.icons_path || this.conf.icons_path;
        if (c.tabs instanceof Array) {
            this._base.className = this._base.className.replace(/\s?dhxrb_without_tabbar/i, "");
            a.className = "dhxrb_with_tabbar";
            this._tabbar = new dhtmlXTabBar(a);
            this._attachEventTabbar();
            this._tabbar.setSkin(this.conf.skin);
            this.childIds = this._appendTabs(c.tabs)
        } else {
            if (c.items instanceof Array) {
                if (!/\s?dhxrb_without_tabbar/i.test(this._base.className)) {
                    this._base.className += " dhxrb_without_tabbar"
                }
                if (/\s?dhxrb_background_area/i.test(a.className)) {
                    a.className = "dhxrb_background_area"
                }
                a.innerHTML = "<div class='dhxrb_g_area'></div>";
                this.childIds = this._appendBlocks(c.items, a.firstChild)
            }
        }
        this.callEvent("_onHeightChanged", [])
    }
};
dhtmlXRibbon.prototype._xmlToJson = function (c) {
    var a = c.lastChild || null,
        h = {},
        g = [];
    if (a && a.tagName == "ribbon") {
        g = this._convertXmlNodeListIntoObject(a.childNodes)
    }
    if (g[0] && g[0].type && g[0].type.toLowerCase() == "block") {
        h.items = g
    } else {
        h.tabs = g
    }
    return h
};
dhtmlXRibbon.prototype._convertXmlNodeListIntoObject = function (c) {
    var g, a, j = [],
        h;
    a = c.length;
    for (g = 0; g < a; g++) {
        h = this._covertXmlNodeToObject(c[g]);
        if (h) {
            j.push(h)
        }
    }
    return j
};
dhtmlXRibbon.prototype._covertXmlNodeToObject = function (h) {
    if (!h || !h.tagName || !(h.tagName.toLowerCase() == "item" || h.tagName.toLowerCase() == "tab")) {
        return null
    }
    var g, a, c = h.attributes,
        j = {};
    a = c.length;
    for (g = 0; g < a; g++) {
        switch (c[g].name) {
        case "isbig":
            j.isbig = dhx4.s2b(c[g].value);
            break;
        case "state":
            j.state = dhx4.s2b(c[g].value);
            break;
        default:
            j[c[g].name] = c[g].value
        }
    }
    if (h.childNodes.length) {
        if (h.getAttribute("type") == "buttonCombo" || h.getAttribute("type") == "buttonSelect") {
            j.data = h
        } else {
            if (h.tagName.toLowerCase() == "tab") {
                j.items = this._convertXmlNodeListIntoObject(h.childNodes)
            } else {
                j.list = this._convertXmlNodeListIntoObject(h.childNodes)
            }
        }
    }
    return j
};
dhtmlXRibbon.prototype._appendTabs = function (j) {
    var c, a, g, h = [];
    a = j.length;
    for (c = 0; c < a; c++) {
        g = this._addTab(j[c]);
        if (j[c].items instanceof Array) {
            g.childIds = this._appendBlocks(j[c].items, g.base, g)
        }
        h.push(g.id)
    }
    return h
};
dhtmlXRibbon.prototype._addTab = function (g) {
    var a, h, c = {
        conf: {
            active: false,
            text: "",
            width: null,
            position: null,
            disable: false
        },
        base: document.createElement("div"),
        type: "tab",
        childIds: []
    };
    for (a in g) {
        if (a == "items") {
            continue
        }
        c.conf[a] = g[a]
    }
    if (!g.id) {
        c.id = dhx4.newId()
    } else {
        c.id = g.id
    }
    while (this._items[c.id]) {
        c.id = dhx4.newId()
    }
    this._tabbar.addTab(c.id, c.conf.text, c.conf.width, c.conf.position, c.conf.active);
    c.base.className = "dhxrb_g_area";
    c.base._dhx_ribbonId = c.id;
    this.tabs(c.id).attachObject(c.base);
    this._changeApiForTab(this.tabs(c.id));
    this._items[c.id] = c;
    return c
};
dhtmlXRibbon.prototype._changeApiForTab = function (c) {
    var a;
    for (a in this._tabOriginalApi) {
        this._tabOriginalApi[a] = this._tabOriginalApi[a] || c[a];
        c[a] = this._tabCustomApi[a]
    }
};
dhtmlXRibbon.prototype._tabOriginalApi = {
    enable: null,
    disable: null,
    close: null
};
dhtmlXRibbon.prototype._appendBlocks = function (a, s, g) {
    var m, h, n, j, o, c, r = [];
    g = g || null;
    h = a.length;
    for (m = 0; m < h; m++) {
        if (typeof (a[m]) == "object" && a[m].type == "block") {
            n = this._addBlock(a[m], s);
            if (a[m].list && (a[m].list instanceof Array)) {
                j = a[m].list;
                o = j.length;
                for (c = 0; c < o; c++) {
                    this._addItem(n.id, null, null, j[c])
                }
            }
            if (g != null) {
                n.parentId = g.id
            }
            if (n.conf.disable) {
                this.disable(n.id)
            }
            r.push(n.id)
        }
    }
    return r
};
dhtmlXRibbon.prototype._addBlock = function (j, h) {
    var g, a, m, c;
    m = {
        conf: {
            text: "",
            text_pos: "bottom",
            type: "block",
            mode: "cols",
            disable: false
        },
        type: "block",
        childIds: [],
        base: document.createElement("div"),
        contForItems: document.createElement("div"),
        contForText: document.createElement("div")
    };
    for (c in j) {
        if (c == "list" || c == "type" || c == "id") {
            continue
        }
        m.conf[c] = j[c]
    }
    if (!j.id) {
        m.id = dhx4.newId()
    } else {
        m.id = j.id
    }
    while (this._items[m.id]) {
        m.id = dhx4.newId()
    }
    m.base.className = "dhxrb_block_base";
    h.appendChild(m.base);
    m.contForItems.className = "dhxrb_block_items";
    m.contForText.className = "dhxrb_block_label";
    m.base.appendChild(m.contForItems);
    if (m.conf.text) {
        m.contForText.innerHTML = m.conf.text;
        if (m.conf.text_pos == "top") {
            m.base.insertBefore(m.contForText, m.contForItems)
        } else {
            m.base.appendChild(m.contForText)
        }
    }
    m.base._dhx_ribbonId = m.id;
    this._items[m.id] = m;
    return m
};
dhtmlXRibbon.prototype._addItem = function (g, c, o, m) {
    var j = this._items[g],
        a, l, r = null,
        n = this,
        h;
    if (m.type != "newLevel" && !this.items[m.type]) {
        return null
    }
    if (m.type == "newLevel") {
        this._addNewLevel(j)
    } else {
        if (j.type == "group") {
            a = document.createElement("div");
            a.className = "dhxrb_in_group";
            j.base.appendChild(a)
        } else {
            if (m.isbig) {
                a = document.createElement("div");
                a.className = "dhxrb_big_button";
                j.contForItems.appendChild(a)
            } else {
                l = this._getContainerForSmallItem(j);
                a = document.createElement("div");
                a.className = (j.conf.mode == "rows") ? "dhxrb_in_row" : "dhxrb_3rows_button";
                l.appendChild(a)
            }
        }
    }
    if (a) {
        this._attachEventForItem(a);
        h = {
            icons_path: m.icons_path || this.conf.icons_path,
            skin: this.conf.skin
        };
        for (var q in m) {
            h[q] = m[q]
        }
        if (!h.id) {
            h.id = dhx4.newId()
        }
        while (this._items[h.id]) {
            h.id = dhx4.newId()
        }
        r = (this.items[h.type] && this.items[h.type].render) ? this.items[h.type].render(a, h) : null
    }
    if (r != null) {
        this._items[r.id] = r;
        r.parentId = j.id;
        j.childIds.push(r.id);
        a._dhx_ribbonId = r.id;
        if (h.onclick && (typeof (h.onclick) == "function")) {
            this._eventHandlers[r.id] = this._eventHandlers[r.id] || {};
            this._eventHandlers[r.id]["onclick"] = h.onclick
        }
        r.callEvent = function () {
            n.callEvent.apply(n, arguments)
        };
        r._callHandler = function () {
            n._callHandler.apply(n, arguments)
        };
        if (this.items[h.type] && typeof (this.items[h.type].callAfterInit) == "function") {
            this.items[h.type].callAfterInit.apply(this, [r])
        }
    }
    return r
};
dhtmlXRibbon.prototype._callHandler = function (c, a) {
    if (this._eventHandlers[c] && this._eventHandlers[c].onclick) {
        this._eventHandlers[c].onclick.apply(this, a)
    }
};
dhtmlXRibbon.prototype.items = {};
dhtmlXRibbon.prototype.items.button = {
    render: function (c, a) {
        var g, h;
        h = {
            base: c,
            id: a.id,
            type: a.type,
            conf: {
                text: "",
                text_pos: (a.isbig) ? "bottom" : "right",
                img: null,
                imgdis: null,
                isbig: false,
                disable: false,
                skin: a.skin
            }
        };
        for (g in a) {
            if (g == "id" || g == "onclick" || g == "type") {
                continue
            }
            h.conf[g] = a[g]
        }
        c.innerHTML = "<img class='dhxrb_image" + ((h.conf.img) ? "'" : " dhxrb_invisible'") + " src='" + ((h.conf.img) ? h.conf.icons_path + h.conf.img : "") + "' /><div class='dhxrb_label_button'>" + h.conf.text + "</div>";
        if (typeof (this.afterRender) == "function") {
            this.afterRender(h)
        }
        if (h.conf.disable) {
            this.disable(h)
        }
        return h
    },
    getText: function (a) {
        return a.conf.text
    },
    setText: function (c, g) {
        var a = c.base.childNodes[1];
        c.conf.text = g;
        a.innerHTML = g
    },
    mousedown: function (a, g, c) {
        return true
    },
    click: function (a, g, c) {
        if (c.button != 0) {
            return false
        }
        g._callHandler(a.id, [a.id]);
        a.callEvent("onClick", [a.id]);
        return false
    },
    disable: function (c) {
        var g = c.base.childNodes[0],
            a = c.base.childNodes[1];
        if (c.conf.imgdis) {
            g.src = c.conf.icons_path + c.conf.imgdis;
            if (/\s?dhxrb_invisible/i.test(g.className)) {
                g.className = g.className.replace(/\s?dhxrb_invisible/i, "")
            }
        }
        if (!/\s?dhxrb_disable_text_style/i.test(a.className)) {
            a.className += " dhxrb_disable_text_style"
        }
        return true
    },
    enable: function (c) {
        var g = c.base.childNodes[0],
            a = c.base.childNodes[1];
        if (c.conf.img) {
            g.src = c.conf.icons_path + c.conf.img
        } else {
            if (!/\s?dhxrb_invisible/i.test(g.className)) {
                g.className += " dhxrb_invisible"
            }
        }
        if (/\s?dhxrb_disable_text_style/i.test(a.className)) {
            a.className = a.className.replace(/\s?dhxrb_disable_text_style/i, "")
        }
        return true
    }
};
dhtmlXRibbon.prototype.items.buttonTwoState = {
    click: function (a, g, c) {
        return false
    },
    afterRender: function (a) {
        if (a.conf.state) {
            this.setState(a, a.conf.state)
        }
    },
    mouseover: function (a) {
        if (!/dhxrb_highlight0/.test(a.base.className)) {
            a.base.className += " dhxrb_highlight0"
        }
        return false
    },
    mouseout: function (a) {
        if (/dhxrb_highlight0/.test(a.base.className)) {
            a.base.className = a.base.className.replace(/\s?dhxrb_highlight0/, "")
        }
        return false
    },
    mousedown: function (a, g, c) {
        g._callHandler(a.id, [a.id, !a.conf.state]);
        this.setState(a, !a.conf.state, true);
        return false
    },
    mouseup: function (a) {
        return false
    },
    setState: function (a, c, g) {
        g = g || false;
        c = dhx4.s2b(c);
        if (c) {
            if (!/dhxrb_highlight1/.test(a.base.className)) {
                a.base.className += " dhxrb_highlight1"
            }
        } else {
            if (/dhxrb_highlight1/.test(a.base.className)) {
                a.base.className = a.base.className.replace(/\s?dhxrb_highlight1/, "")
            }
        }
        a.conf.state = c;
        if (g) {
            a.callEvent("onStateChange", [a.id, a.conf.state])
        }
    }
};
dhtmlXRibbon.prototype.items.buttonSegment = {
    click: function (a, g, c) {
        return false
    },
    mousedown: function (a, g, c) {
        this.setState(a, g, true);
        return false
    },
    callAfterInit: function (a) {
        if (a.conf.state || dhtmlXRibbon.prototype.items.buttonSegment._getSelectedNeighbor(a, this) == null) {
            if (a.conf.state) {
                a.conf.state = false
            }
            dhtmlXRibbon.prototype.items.buttonSegment.setState(a, this, false)
        }
    },
    afterRender: function () {},
    setState: function (a, j, h) {
        h = h || false;
        var g = null,
            c = dhx4.s2b(a.conf.state);
        if (c == false) {
            g = this._getSelectedNeighbor(a, j);
            if (g != null) {
                this._unSelect(g)
            }
            if (!/dhxrb_highlight1/.test(a.base.className)) {
                a.base.className += " dhxrb_highlight1"
            }
            a.conf.state = true;
            if (h) {
                j._callHandler(a.id, [a.id, (g ? g.id : null)]);
                j.callEvent("onStateChange", [a.id, (g ? g.id : null)])
            }
        }
    },
    remove: function (g, m) {
        var j = dhx4.s2b(g.conf.state),
            l = null,
            a = 0,
            c = m._items[g.parentId],
            h;
        if (j) {
            while (c.childIds[a] && l == null) {
                h = m._items[c.childIds[a]];
                if (h.type == "buttonSegment" && h != g) {
                    l = h
                }
                a++
            }
            if (l) {
                this.setState(l, m)
            }
        }
    },
    _unSelect: function (a) {
        var c = dhx4.s2b(a.conf.state);
        if (c) {
            if (/dhxrb_highlight1/.test(a.base.className)) {
                a.base.className = a.base.className.replace(/\s?dhxrb_highlight1/, "")
            }
            a.conf.state = false
        }
    },
    _getSelectedNeighbor: function (h, n) {
        var g = n._items[h.parentId],
            c, a, m, j = null;
        a = g.childIds.length;
        for (c = 0; c < a; c++) {
            m = n._items[g.childIds[c]];
            if (m.type == "buttonSegment" && m.conf.state) {
                j = m;
                break
            }
        }
        return j
    }
};
dhtmlXRibbon.prototype.items.buttonSelect = {
    itemCollection: [],
    _isAttachedEventInWindow: false,
    afterRender: function (c) {
        var a = c.base.childNodes[1];
        a.innerHTML += "<span class='dhxrb_arrow'>&nbsp;</span>";
        c.menu = null;
        this.itemCollection.push(c);
        this._attachEventToWindow();
        a = null
    },
    setText: function (a, g) {
        var c = a.base.childNodes[1].lastChild;
        a.conf.text = g;
        a.base.childNodes[1].innerHTML = g;
        a.base.childNodes[1].appendChild(c)
    },
    _attachEventToWindow: function () {
        if (this._isAttachedEventInWindow == false) {
            if (typeof (window.addEventListener) == "function") {
                document.body.addEventListener("mousedown", this._hideAllMenus, false)
            } else {
                document.body.attachEvent("onmousedown", this._hideAllMenus)
            }
            this._isAttachedEventInWindow = true
        }
    },
    _detachEventFromWindow: function () {
        if (typeof (window.addEventListener) == "function") {
            document.body.removeEventListener("mousedown", this._hideAllMenus, false)
        } else {
            document.body.detachEvent("onmousedown", this._hideAllMenus)
        }
        this._isAttachedEventInWindow = false
    },
    _hideAllMenus: function (j) {
        j = j || event;
        var g = j.target || j.srcElement;
        var a = true;
        while (g != null && a == true) {
            if (g.className != null && /SubLevelArea_Polygon/i.test(g.className)) {
                a = false
            } else {
                g = g.parentNode
            }
        }
        if (a == false) {
            return
        }
        var c = dhtmlXRibbon.prototype.items.buttonSelect.itemCollection;
        for (var l in c) {
            var h = c[l];
            if (h.menu instanceof dhtmlXMenuObject) {
                if (h._skipHiding) {
                    h._skipHiding = false
                } else {
                    dhtmlXRibbon.prototype.items.buttonSelect.hideMenu(h)
                }
            }
        }
    },
    mousedown: function (a, g, c) {
        a._skipHiding = true;
        this.showMenu(a);
        return false
    },
    mouseup: function (a) {
        return false
    },
    click: function () {},
    setState: function () {},
    showMenu: function (c) {
        var a = dhx4.absLeft(c.base),
            g = dhx4.absTop(c.base) + c.base.offsetHeight;
        if (!(c.menu instanceof dhtmlXMenuObject)) {
            c.menu = new dhtmlXMenuObject({
                parent: c.base,
                icons_path: c.conf.icons_path,
                context: true,
                items: c.conf.items,
                skin: c.conf.skin
            });
            if (c.conf.data) {
                c.menu.loadStruct(c.conf.data);
                delete c.conf.data
            }
            c.menu.setAutoHideMode(false);
            c.menu.attachEvent("onHide", function (h) {
                if (h == null) {
                    dhtmlXRibbon.prototype.items.buttonSelect._doOnHideMenu(c)
                }
            });
            c.menu.attachEvent("onShow", function (h) {
                if (h == null) {
                    dhtmlXRibbon.prototype.items.buttonSelect._doOnShowMenu(c)
                }
            });
            c.menu.attachEvent("onClick", function (h) {
                c.callEvent("onClick", [h])
            });
            c.base.oncontextmenu = function () {
                return false
            };
            dhtmlXRibbon.prototype.items.buttonSelect.showMenu(c)
        } else {
            c.menu.showContextMenu(a, g)
        }
    },
    hideMenu: function (a) {
        if (a.menu instanceof dhtmlXMenuObject) {
            a.menu.hideContextMenu()
        }
    },
    remove: function (c) {
        var g, a;
        if (c.menu instanceof dhtmlXMenuObject) {
            c.menu.unload();
            c.menu = null
        }
        c.base.oncontextmenu = null;
        g = dhtmlXRibbon.prototype._indexOf(dhtmlXRibbon.prototype.items.buttonSelect.itemCollection, c);
        if (g != -1) {
            dhtmlXRibbon.prototype.items.buttonSelect.itemCollection.splice(g, 1)
        }
        if (dhtmlXRibbon.prototype.items.buttonSelect.itemCollection.length == 0) {
            this._detachEventFromWindow()
        }
    },
    setSkin: function (a, c) {
        if (a.menu instanceof dhtmlXMenuObject) {
            a.menu.setSkin(c)
        }
    },
    _doOnHideMenu: function (a) {
        if (a._skipHiding) {
            a._skipHiding = false
        } else {
            if (/dhxrb_highlight1/.test(a.base.className)) {
                a.base.className = a.base.className.replace(/\s?dhxrb_highlight1/, "")
            }
        }
    },
    _doOnShowMenu: function (a) {
        if (!/dhxrb_highlight1/.test(a.base.className)) {
            a.base.className += " dhxrb_highlight1"
        }
    }
};
dhtmlXRibbon.prototype.items.group = {
    render: function (c, a) {
        var g, h;
        h = {
            base: c,
            id: a.id,
            type: a.type,
            conf: {
                disable: false,
                skin: a.skin
            },
            childIds: []
        };
        c.className = "dhxrb_group";
        for (g in a) {
            if (g == "id" || g == "onclick" || g == "type") {
                continue
            }
            h.conf[g] = a[g]
        }
        return h
    },
    callAfterInit: function (j) {
        this._detachEventFromItem(j.base);
        var h, a, m = j.conf.list,
            n, g, c;
        a = (m) ? m.length : 0;
        for (h = 0; h < a; h++) {
            n = this._addItem(j.id, null, null, m[h]);
            if (n == null) {
                continue
            }
            g = n.base.childNodes[1];
            if (g && !g.innerHTML && !/\s?dhxrb_label_hide/i.test(g.className)) {
                g.className += " dhxrb_label_hide"
            }
        }
        dhtmlXRibbon.prototype.items.group.normalize(j);
        if (j.conf.disable) {
            this.disable(j.id)
        }
        m = undefined
    },
    normalize: function (n) {
        var a = n.base.children;
        var g = a.length,
            c = false,
            o = 0;
        var h, m;
        for (var j = 0; j < g; j++) {
            if (!/dhxrb_separator_group/i.test(a[j].className)) {
                if (/dhxrb_item_hide/i.test(a[j].className)) {
                    o++;
                    continue
                }
            }
            if ((Math.ceil((j - o) / 2) - Math.floor((j - o) / 2)) == 0) {
                if (/dhxrb_separator_group/i.test(a[j].className)) {
                    a[j].parentNode.removeChild(a[j]);
                    c = true;
                    break
                }
            } else {
                if (!/dhxrb_separator_group/i.test(a[j].className)) {
                    h = document.createElement("div");
                    h.className = "dhxrb_separator_groupp";
                    n.base.insertBefore(h, a[j]);
                    c = true;
                    break
                }
            }
        }
        if (c) {
            this.normalize(n)
        } else {
            m = n.base.lastChild;
            if (m && /dhxrb_separator_group/i.test(m.className)) {
                m.parentNode.removeChild(m)
            }
        }
    },
    hideChild: function (c, h) {
        var a = dhtmlXRibbon.prototype._indexOf(c.base.children, h.base);
        if (a == 0) {
            a++
        } else {
            if (a != -1) {
                a--
            } else {
                return
            }
        }
        var g = c.base.children[a];
        if (g && /dhxrb_separator_group/i.test(g.className)) {
            g.parentNode.removeChild(g)
        }
    },
    showChild: function (a) {
        this.normalize(a)
    }
};
dhtmlXRibbon.prototype.items.input = {
    render: function (c, a) {
        var g, h;
        h = {
            base: c,
            id: a.id,
            type: a.type,
            conf: {
                text: "",
                text_pos: (a.isbig) ? "bottom" : "right",
                img: null,
                imgdis: null,
                isbig: false,
                disable: false,
                skin: a.skin,
                value: ""
            }
        };
        for (g in a) {
            if (g == "id" || g == "onclick" || g == "type") {
                continue
            }
            h.conf[g] = a[g]
        }
        c.innerHTML = "<input type='text' class='dhxrb_input'><div class='dhxrb_label_button'>" + h.conf.text + "</div>";
        if (typeof (this.afterRender) == "function") {
            this.afterRender(h)
        }
        if (h.conf.disable) {
            this.disable(h)
        }
        if (h.conf.width) {
            this.setWidth(h, h.conf.width)
        }
        if (h.conf.value) {
            this.setValue(h, h.conf.value)
        }
        return h
    },
    callAfterInit: function (c) {
        var a = c.base.childNodes[0];
        this._detachEventFromItem(c.base);
        this._attachEventsToInput(a)
    },
    setText: dhtmlXRibbon.prototype.items.button.setText,
    getText: dhtmlXRibbon.prototype.items.button.getText,
    change: function (c) {
        var a = c.base.childNodes[0];
        c.conf.value = a.value
    },
    keydown: function (c, h, g) {
        if (g.keyCode == 13) {
            var a = c.base.childNodes[0];
            c.conf.value = a.value;
            h.callEvent("onEnter", [c.id, c.conf.value])
        }
    },
    remove: function (c, g) {
        var a = c.base.childNodes[0];
        g._detachEventsFromInput(a)
    },
    getValue: function (c) {
        var a = c.base.childNodes[0],
            g;
        g = a.value;
        a = undefined;
        return g
    },
    setValue: function (c, g) {
        var a = c.base.childNodes[0],
            g;
        a.value = g;
        c.conf.value = g
    },
    setWidth: function (c, g) {
        var a = c.base.childNodes[0];
        a.style.width = parseInt(g) + "px"
    },
    disable: function (g) {
        var c = g.base.childNodes[0],
            a = g.base.childNodes[1];
        c.disabled = true;
        if (!/\s?dhxrb_disable_text_style/i.test(a.className)) {
            a.className += " dhxrb_disable_text_style"
        }
        return true
    },
    enable: function (g) {
        var c = g.base.childNodes[0],
            a = g.base.childNodes[1];
        c.disabled = false;
        if (/\s?dhxrb_disable_text_style/i.test(a.className)) {
            a.className = a.className.replace(/\s?dhxrb_disable_text_style/i, "")
        }
        return true
    }
};
dhtmlXRibbon.prototype.items.checkbox = {
    render: function (c, a) {
        var g, h;
        h = {
            base: c,
            id: a.id,
            type: a.type,
            conf: {
                text: "",
                text_pos: (a.isbig) ? "bottom" : "right",
                disable: false,
                checked: false
            }
        };
        for (g in a) {
            if (g == "id" || g == "onclick" || g == "type") {
                continue
            }
            h.conf[g] = a[g]
        }
        c.innerHTML = "<div class='dhxrb_checkbox'></div><div class='dhxrb_label_checkbox'>" + h.conf.text + "</div>";
        if (typeof (this.afterRender) == "function") {
            this.afterRender(h)
        }
        if (h.conf.checked) {
            this.check(h)
        }
        return h
    },
    callAfterInit: function (a) {
        if (a.conf.disable) {
            this.disable(a.id)
        }
    },
    setText: dhtmlXRibbon.prototype.items.button.setText,
    getText: dhtmlXRibbon.prototype.items.button.getText,
    mousedown: function (a) {
        return false
    },
    mouseup: function (a) {
        return false
    },
    click: function (a, g, c) {
        if (c.button != 0) {
            return false
        }
        if (a.type == "checkbox") {
            if (a.conf.checked) {
                this.uncheck(a, true)
            } else {
                this.check(a, true)
            }
        }
    },
    check: function (a, c) {
        c = c || false;
        if (a.type != "checkbox") {
            return
        }
        a.conf.checked = true;
        if (!/\s?dhxrb_checked/i.test(a.base.className)) {
            a.base.className += " dhxrb_checked"
        }
        if (c) {
            a.callEvent("onCheck", [a.id, a.conf.checked])
        }
    },
    uncheck: function (a, c) {
        c = c || false;
        if (a.type != "checkbox") {
            return
        }
        a.conf.checked = false;
        if (/\s?dhxrb_checked/i.test(a.base.className)) {
            a.base.className = a.base.className.replace(/\s?dhxrb_checked/i, "")
        }
        if (c) {
            a.callEvent("onCheck", [a.id, a.conf.checked])
        }
    },
    disable: function (a) {
        return true
    },
    enable: function (a) {
        return true
    }
};
dhtmlXRibbon.prototype.items.text = {
    render: function (a, h) {
        var g = {
            base: a,
            id: h.id,
            type: h.type,
            conf: {
                text: ""
            }
        };
        for (var c in h) {
            if (c == "id" || c == "type") {
                continue
            }
            g.conf[c] = h[c]
        }
        a.innerHTML = "<div class='dhxrb_item_text'>" + g.conf.text + "</div>";
        if (typeof (this.afterRender) == "function") {
            this.afterRender(g)
        }
        return g
    },
    callAfterInit: function (a) {
        this._detachEventFromItem(a.base)
    },
    getText: function (a) {
        return a.conf.text
    },
    setText: function (a, c) {
        a.conf.text = c;
        a.base.innerHTML = c
    }
};
dhtmlXRibbon.prototype.items.buttonCombo = {
    render: function (a, c) {
        var g, h, j = {};
        h = {
            base: a,
            id: c.id,
            type: c.type,
            conf: {
                text: "",
                text_pos: "right",
                width: 140,
                skin: c.skin
            }
        };
        for (g in c) {
            if (g == "id" || g == "onclick" || g == "type") {
                continue
            }
            h.conf[g] = c[g]
        }
        for (g in h.conf) {
            if (g == "text" || g == "text_pos" || g == "disable" || g == "data") {
                continue
            }
            j[g] = h.conf[g]
        }
        h.base.className += " dhxrb_buttoncombo_cont";
        h.base.innerHTML = "<div class='dhxrb_buttoncombo'></div><div class='dhxrb_label_button'>" + h.conf.text + "</div>";
        j.parent = h.base.firstChild;
        h.combo = new dhtmlXCombo(j);
        h.combo.setSkin(j.skin);
        h.combo.attachEvent("onChange", function (l, m) {
            h._callHandler(h.id, [l, m]);
            h.callEvent("onSelectOption", [h.id, l, m])
        });
        if (h.conf.data) {
            h.combo.load(h.conf.data);
            delete h.conf.data
        }
        if (typeof (this.afterRender) == "function") {
            this.afterRender(h)
        }
        if (h.conf.disable) {
            this.disable(h)
        }
        return h
    },
    callAfterInit: function (a) {
        this._detachEventFromItem(a.base)
    },
    disable: function (c) {
        var a = c.base.lastChild;
        if (c.combo instanceof dhtmlXCombo) {
            c.combo.disable()
        }
        if (!/\s?dhxrb_disable_text_style/i.test(a.className)) {
            a.className += " dhxrb_disable_text_style"
        }
        return true
    },
    enable: function (c) {
        var a = c.base.lastChild;
        if (c.combo instanceof dhtmlXCombo) {
            c.combo.enable()
        }
        if (/\s?dhxrb_disable_text_style/i.test(a.className)) {
            a.className = a.className.replace(/\s?dhxrb_disable_text_style/i, "")
        }
        return true
    },
    remove: function (a) {
        if (a.combo instanceof dhtmlXCombo) {
            a.combo.unload();
            a.combo = null
        }
    },
    getValue: function (a) {
        var c = null;
        if (a.combo instanceof dhtmlXCombo) {
            c = a.combo.getSelectedValue()
        }
        return c
    },
    setValue: function (a, c) {
        if (a.combo instanceof dhtmlXCombo) {
            a.combo.setComboValue(c)
        }
    },
    setSkin: function (a, c) {
        if (a.combo instanceof dhtmlXCombo) {
            a.combo.setSkin(c)
        }
    }
};
dhtmlXRibbon.prototype.items.slider = {
    render: function (a, j) {
        var g, h, c = {};
        h = {
            base: a,
            id: j.id,
            type: j.type,
            conf: {
                text: "",
                text_pos: "right",
                size: 150,
                vertical: false,
                min: 0,
                max: 99,
                value: 0,
                step: 1,
                margin: 10,
                disabled: false,
                enableTooltip: false
            }
        };
        for (g in j) {
            if (g == "id" || g == "onclick" || g == "type") {
                continue
            }
            h.conf[g] = j[g]
        }
        for (g in h.conf) {
            if (g == "text" || g == "text_pos" || g == "isbig") {
                continue
            }
            c[g] = h.conf[g]
        }
        h.base.innerHTML = "<center><div class='dhxrb_slider'></div></center><div class='dhxrb_label_button'>" + h.conf.text + "</div>";
        c.parent = h.base.firstChild.firstChild;
        h.slider = new dhtmlXSlider(c);
        if (typeof (this.afterRender) == "function") {
            this.afterRender(h)
        }
        if (h.conf.disable) {
            this.disable(h)
        }
        h.slider.attachEvent("onChange", function (l) {
            h._callHandler(h.id, [l]);
            h.callEvent("onValueChange", [h.id, l])
        });
        return h
    },
    callAfterInit: function (a) {
        this._detachEventFromItem(a.base)
    },
    setSkin: function (a, c) {
        if (a.slider instanceof dhtmlXSlider) {
            a.slider.setSkin(c)
        }
    },
    disable: function (c) {
        var a = c.base.childNodes[1];
        if (c.slider instanceof dhtmlXSlider) {
            c.slider.disable()
        }
        if (!/\s?dhxrb_disable_text_style/i.test(a.className)) {
            a.className += " dhxrb_disable_text_style"
        }
        return true
    },
    enable: function (c) {
        var a = c.base.childNodes[1];
        if (c.slider instanceof dhtmlXSlider) {
            c.slider.enable()
        }
        if (/\s?dhxrb_disable_text_style/i.test(a.className)) {
            a.className = a.className.replace(/\s?dhxrb_disable_text_style/i, "")
        }
        return true
    },
    remove: function (a) {
        if (a.slider instanceof dhtmlXSlider) {
            a.slider.unload();
            a.slider = null
        }
    },
    getValue: function (a) {
        var c = null;
        if (a.slider instanceof dhtmlXSlider) {
            c = a.slider.getValue()
        }
        return c
    },
    setValue: function (a, c) {
        if (a.slider instanceof dhtmlXSlider) {
            a.slider.setValue(c)
        }
    }
};
dhtmlXRibbon.prototype.items._extends = function (g, c) {
    var a;
    for (a in c) {
        g[a] = g[a] || c[a]
    }
    return g
};
dhtmlXRibbon.prototype._addNewLevel = function (g) {
    var c, a;
    if (g.conf.mode == "rows") {
        c = g.contForItems.lastChild;
        if (c && /dhxrb_block_rows/i.test(c.className) && (c.childNodes.length < 3)) {
            a = document.createElement("div");
            a.className = "dhxrb_block_row";
            c.appendChild(a)
        } else {
            c = document.createElement("div");
            c.className = "dhxrb_block_rows";
            g.contForItems.appendChild(c);
            a = document.createElement("div");
            a.className = "dhxrb_block_row";
            c.appendChild(a)
        }
    } else {
        var a = document.createElement("div");
        a.className = "dhxrb_3rows_block";
        g.contForItems.appendChild(a)
    }
};
dhtmlXRibbon.prototype._attachEventForItem = function (a) {
    if (typeof (window.addEventListener) == "function") {
        a.addEventListener("mouseover", this._doOnHighlight0, false);
        a.addEventListener("mouseout", this._doOffHighlight0, false);
        a.addEventListener("mousedown", this._doOnHighlight1, false);
        a.addEventListener("mouseup", this._doOffHighlight1, false);
        a.addEventListener("click", this._doOnClick, false)
    } else {
        a.attachEvent("onmouseover", this._doOnHighlight0);
        a.attachEvent("onmouseout", this._doOffHighlight0);
        a.attachEvent("onmousedown", this._doOnHighlight1);
        a.attachEvent("onmouseup", this._doOffHighlight1);
        a.attachEvent("onclick", this._doOnClick)
    }
};
dhtmlXRibbon.prototype._detachEventFromItem = function (a) {
    if (typeof (window.addEventListener) == "function") {
        a.removeEventListener("mouseover", this._doOnHighlight0, false);
        a.removeEventListener("mouseout", this._doOffHighlight0, false);
        a.removeEventListener("mousedown", this._doOnHighlight1, false);
        a.removeEventListener("mouseup", this._doOffHighlight1, false);
        a.removeEventListener("click", this._doOnClick, false)
    } else {
        a.detachEvent("onmouseover", this._doOnHighlight0);
        a.detachEvent("onmouseout", this._doOffHighlight0);
        a.detachEvent("onmousedown", this._doOnHighlight1);
        a.detachEvent("onmouseup", this._doOffHighlight1);
        a.detachEvent("onclick", this._doOnClick)
    }
};
dhtmlXRibbon.prototype._attachEventsToInput = function (a) {
    if (typeof (window.addEventListener) == "function") {
        a.addEventListener("focus", this._doOnFocus, false);
        a.addEventListener("blur", this._doOnBlur, false);
        a.addEventListener("change", this._doOnChange, false);
        a.addEventListener("keydown", this._doOnKeydown, false)
    } else {
        a.attachEvent("onfocus", this._doOnFocus);
        a.attachEvent("onblur", this._doOnBlur);
        a.attachEvent("onchange", this._doOnChange);
        a.attachEvent("onkeydown", this._doOnKeydown)
    }
};
dhtmlXRibbon.prototype._detachEventsFromInput = function (a) {
    if (typeof (window.addEventListener) == "function") {
        a.removeEventListener("focus", this._doOnFocus, false);
        a.removeEventListener("blur", this._doOnBlur, false);
        a.removeEventListener("change", this._doOnChange, false);
        a.removeEventListener("keydown", this._doOnKeydown, false)
    } else {
        a.detachEvent("onfocus", this._doOnFocus);
        a.detachEvent("onblur", this._doOnBlur);
        a.detachEvent("onchange", this._doOnChange);
        a.detachEvent("onkeydown", this._doOnKeydown)
    }
};
dhtmlXRibbon.prototype._getContainerForSmallItem = function (g) {
    var c = g.contForItems.lastChild,
        a = null;
    if (g.conf.mode == "rows") {
        if (c && /\s?dhxrb_block_rows/i.test(c.className)) {
            a = c.lastChild;
            if (!a) {
                a = document.createElement("div");
                a.className = "dhxrb_block_row";
                c.appendChild(a)
            }
        } else {
            c = document.createElement("div");
            c.className = "dhxrb_block_rows";
            g.contForItems.appendChild(c);
            a = document.createElement("div");
            a.className = "dhxrb_block_row";
            c.appendChild(a)
        }
    } else {
        if (c && /dhxrb_3rows_block/i.test(c.className) && (c.childNodes.length < 3)) {
            a = c
        } else {
            a = document.createElement("div");
            a.className = "dhxrb_3rows_block";
            g.contForItems.appendChild(a)
        }
    }
    return a
};
dhtmlXRibbon.prototype._findItemByNode = function (a) {
    while (a && !a._dhx_ribbonId) {
        a = a.parentNode
    }
    return a
};
dhtmlXRibbon.prototype._indexOf = function (a, h) {
    var g, c;
    c = a.length;
    for (g = 0; g < c; g++) {
        if (a[g] == h) {
            return g
        }
    }
    return -1
};
dhtmlXRibbon.prototype._removeItem = function (g) {
    var a, h = -1,
        c = this._items[g.parentId];
    if (g.type == "group") {
        this._removeGroup(g);
        return
    }
    delete this._items[g.id];
    a = g.base.parentNode;
    this._detachEventFromItem(g.base);
    a.removeChild(g.base);
    if (c.type == "block") {
        if (a != c.contForItems && a.childNodes.length == 0) {
            a.parentNode.removeChild(a)
        }
    } else {
        if (c.type == "group") {
            dhtmlXRibbon.prototype.items.group.normalize(c)
        }
    }
    h = this._indexOf(c.childIds, g.id);
    if (h != -1) {
        c.childIds.splice(h, 1)
    }
    if (this.items[g.type] && (typeof (this.items[g.type].remove) == "function")) {
        this.items[g.type].remove(g, this)
    }
};
dhtmlXRibbon.prototype._removeGroup = function (h) {
    var c = [],
        j, g = this._items[h.parentId],
        a = h.base.parentNode;
    for (j in h.childIds) {
        j = parseInt(j);
        c.push(this._items[h.childIds[j]])
    }
    for (j in c) {
        j = parseInt(j);
        this._removeItem(c[j])
    }
    delete this._items[h.id];
    if (h.base.parentNode) {
        a.removeChild(h.base)
    }
    if (a.childNodes.length == 0) {
        a.parentNode.removeChild(a)
    }
    j = this._indexOf(g.childIds, h.id);
    if (j != -1) {
        g.childIds.splice(j, 1)
    }
    if (this.items[h.type] && (typeof (this.items[h.type].remove) == "function")) {
        this.items[h.type].remove(h)
    }
};
dhtmlXRibbon.prototype._removeBlock = function (h) {
    var a = [],
        g, c;
    for (g in h.childIds) {
        g = parseInt(g);
        a.push(this._items[h.childIds[g]])
    }
    for (g in a) {
        g = parseInt(g);
        this._removeItem(a[g])
    }
    delete this._items[h.id];
    h.base.parentNode.removeChild(h.base);
    if (h.parentId) {
        c = this._items[h.parentId]
    } else {
        c = this
    }
    g = this._indexOf(c.childIds, h.id);
    if (g != -1) {
        c.childIds.splice(g, 1)
    }
};
dhtmlXRibbon.prototype._removeTab = function (c, a) {
    var h = [],
        g;
    for (g in c.childIds) {
        g = parseInt(g);
        h.push(this._items[c.childIds[g]])
    }
    for (g in h) {
        g = parseInt(g);
        this._removeBlock(h[g])
    }
    delete this._items[c.id];
    g = this._indexOf(this.childIds, c.id);
    if (g != -1) {
        this.childIds.splice(g, 1)
    }
};
dhtmlXRibbon.prototype._skinCollection = {
    dhx_skyblue: true,
    dhx_web: true,
    dhx_terrace: true
};
dhtmlXRibbon.prototype._setSkinForItems = function (g) {
    var a, c;
    for (a in this._items) {
        c = this._items[a];
        c.conf.skin = g;
        if (dhtmlXRibbon.prototype.items[c.type] && typeof (dhtmlXRibbon.prototype.items[c.type].setSkin) == "function") {
            dhtmlXRibbon.prototype.items[c.type].setSkin(c, g)
        }
    }
    c = undefined, a = undefined
};
dhtmlXRibbon.prototype._setBlockText = function (a, c) {
    a.conf.text = c;
    a.contForText.innerHTML = c;
    if (!c && (c != 0) && a.contForText.parentNode) {
        a.contForText.parentNode.removeChild(a.contForText)
    } else {
        if (!a.contForText.parentNode) {
            if (a.conf.text_pos == "top") {
                a.base.insertBefore(a.contForText, a.contForItems)
            } else {
                a.base.appendChild(a.contForText)
            }
        }
    }
};
dhtmlXRibbon.prototype.hide = function (g) {
    var c = this._items[g];
    if (this.items[c.type] && (typeof (this.items[c.type].hide) == "function")) {
        if (this.items[c.type].hide(c) != true) {
            return
        }
    }
    if (c.type == "tab") {
        return
    } else {
        if (!/\s?dhxrb_item_hide/i.test(c.base.className)) {
            c.base.className += " dhxrb_item_hide"
        }
    }
    var a = this._items[c.parentId];
    if (a && this.items[a.type] && (typeof (this.items[a.type].hideChild) == "function")) {
        this.items[a.type].hideChild(a, c)
    }
};
dhtmlXRibbon.prototype.show = function (g) {
    var c = this._items[g];
    if (this.items[c.type] && (typeof (this.items[c.type].show) == "function")) {
        if (this.items[c.type].show(c) != true) {
            return
        }
    }
    if (c.type == "tab") {
        return
    } else {
        if (/\s?dhxrb_item_hide/i.test(c.base.className)) {
            c.base.className = c.base.className.replace(/\s?dhxrb_item_hide/i, "")
        }
    }
    var a = this._items[c.parentId];
    if (a && this.items[a.type] && (typeof (this.items[a.type].showChild) == "function")) {
        this.items[a.type].showChild(a, c)
    }
};
dhtmlXRibbon.prototype.getValue = function (g) {
    var a = this._items[g],
        c = undefined;
    if (this.items[a.type] && (typeof (this.items[a.type].getValue) == "function")) {
        return this.items[a.type].getValue(a)
    }
};
dhtmlXRibbon.prototype.setValue = function (g, c) {
    var a = this._items[g];
    if (this.items[a.type] && typeof (this.items[a.type].setValue) == "function") {
        this.items[a.type].setValue(a, c)
    }
};
dhtmlXRibbon.prototype.check = function (g, c) {
    c = dhx4.s2b(c);
    var a = this._items[g];
    if (a && !a.conf.checked && typeof (this.items[a.type].check) == "function") {
        this.items[a.type].check(a);
        if (c) {
            this.callEvent("onCheck", [a.id, a.conf.checked])
        }
    }
};
dhtmlXRibbon.prototype.uncheck = function (g, c) {
    c = dhx4.s2b(c);
    var a = this._items[g];
    if (a && a.conf.checked && typeof (this.items[a.type].uncheck) == "function") {
        this.items[a.type].uncheck(a);
        if (c) {
            this.callEvent("onCheck", [a.id, a.conf.checked])
        }
    }
};
dhtmlXRibbon.prototype.disable = function (h, c) {
    var g = this._items[h],
        a;
    if (this.items[g.type] && (typeof (this.items[g.type].disable) == "function")) {
        if (this.items[g.type].disable(g) != true) {
            return
        }
    }
    if (g.type == "tab") {
        return
    } else {
        if (g.type == "block" || g.type == "group") {
            for (a in g.childIds) {
                a = parseInt(a);
                this.disable(g.childIds[a])
            }
        }
    }
    if (!/\s?dhxrb_item_disable/i.test(g.base.className)) {
        g.base.className += " dhxrb_item_disable"
    }
    g.conf.disable = true
};
dhtmlXRibbon.prototype.enable = function (h, c) {
    var g = this._items[h],
        a;
    if (this.items[g.type] && (typeof (this.items[g.type].enable) == "function")) {
        if (this.items[g.type].enable(g) != true) {
            return
        }
    }
    if (g.type == "tab") {
        return
    } else {
        if (g.type == "block" || g.type == "group") {
            for (a in g.childIds) {
                a = parseInt(a);
                this.enable(g.childIds[a])
            }
        }
    }
    if (/\s?dhxrb_item_disable/i.test(g.base.className)) {
        g.base.className = g.base.className.replace(/\s?dhxrb_item_disable/i, "")
    }
    g.conf.disable = false
};
dhtmlXRibbon.prototype.isEnabled = function (c) {
    var a = this._items[c];
    if (this.items[a.type] && typeof (this.items[a.type].isEnabled) == "function") {
        return this.items[a.type].isEnabled(a)
    }
    if (a.type == "tab") {
        return
    } else {
        return a.conf.disable != true
    }
};
dhtmlXRibbon.prototype.isVisible = function (c) {
    var a = this._items[c];
    if (this.items[a.type] && (typeof (this.items[a.type].isVisible) == "function")) {
        return this.items[a.type].isVisible(a)
    }
    if (a.type == "tab") {
        return
    } else {
        return !/\s?dhxrb_item_hide/i.test(a.base.className)
    }
};
dhtmlXRibbon.prototype.setItemState = function (h, c, g) {
    c = dhx4.s2b(c);
    g = dhx4.s2b(g);
    var a = this._items[h];
    if (a && (typeof (this.items[a.type].setState) == "function")) {
        switch (a.type) {
        case "buttonSegment":
            this.items[a.type].setState(a, this, g);
            break;
        default:
            this.items[a.type].setState(a, c, g)
        }
    }
};
dhtmlXRibbon.prototype.setIconPath = function (a) {
    this.conf.icons_path = a
};
dhtmlXRibbon.prototype.removeItem = function (c) {
    var a = this._items[c];
    switch (a.type) {
    case "tab":
        break;
    case "block":
        this._removeBlock(a);
        break;
    case "group":
        this._removeGroup(a);
        break;
    default:
        this._removeItem(a)
    }
};
dhtmlXRibbon.prototype.setSkin = function (j) {
    j = (typeof (j) == "string") ? j.toLowerCase() : "";
    if (this._skinCollection[j] != true) {
        return
    }
    var g, c = -1,
        a, h = "dhtmlxribbon";
    g = this._base.className.match(/\S\w+/ig);
    if (g instanceof Array) {
        for (a in this._skinCollection) {
            if (c == -1) {
                c = this._indexOf(g, h + "_" + a)
            } else {
                break
            }
        }
        c = (c == -1) ? g.length : c
    } else {
        g = [];
        c = 0
    }
    g[c] = h + "_" + j;
    this._base.className = g.join(" ");
    this.conf.skin = j;
    if (this._tabbar != null) {
        this._tabbar.setSkin(j)
    }
    this._setSkinForItems(j)
};
dhtmlXRibbon.prototype.tabs = function (a) {
    if (this._tabbar instanceof dhtmlXTabBar) {
        return this._tabbar.tabs(a)
    } else {
        return undefined
    }
};
dhtmlXRibbon.prototype.getItemType = function (c) {
    var a = this._items[c];
    if (a) {
        return a.type
    } else {
        return undefined
    }
};
dhtmlXRibbon.prototype.getValue = function (g) {
    var a = this._items[g],
        c = undefined;
    if (a && this.items[a.type] && typeof (this.items[a.type].getValue) == "function") {
        c = this.items[a.type].getValue(a)
    }
    return c
};
dhtmlXRibbon.prototype.setValue = function (h, c, g) {
    var a = this._items[h];
    g = g || false;
    if (a && this.items[a.type] && typeof (this.items[a.type].setValue) == "function") {
        this.items[a.type].setValue(a, c)
    }
};
dhtmlXRibbon.prototype.getItemText = function (c) {
    var a = this._items[c];
    if (!a) {
        return null
    } else {
        if (a.type == "tab") {
            return this.tabs(a.id).getText()
        } else {
            if (a.type == "block") {
                return this.items.button.getText(a)
            } else {
                if (this.items[a.type] && typeof (this.items[a.type].getText) == "function") {
                    return this.items[a.type].getText(a)
                } else {
                    return null
                }
            }
        }
    }
};
dhtmlXRibbon.prototype.setItemText = function (g, c) {
    var a = this._items[g];
    if (!a) {
        return
    } else {
        if (a.type == "tab") {
            this.tabs(a.id).setText(c)
        } else {
            if (a.type == "block") {
                this._setBlockText(a, c)
            } else {
                if (this.items[a.type] && typeof (this.items[a.type].setText) == "function") {
                    this.items[a.type].setText(a, c)
                }
            }
        }
    }
};
(function () {
    var a = dhtmlXRibbon.prototype.items;
    a.buttonTwoState = a._extends(a.buttonTwoState, a.button);
    a.buttonSelect = a._extends(a.buttonSelect, a.buttonTwoState);
    a.buttonSegment = a._extends(a.buttonSegment, a.buttonTwoState)
})();

function dhtmlXToolbarObject(c, g) {
    var a = this;
    this.conf = {
        skin: (g || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxtoolbar") || "dhx_skyblue"),
        align: "left",
        align_autostart: "left",
        icons_path: "",
        iconSize: 18,
        sel_ofs_x: 0,
        sel_ofs_y: 0,
        xml_autoload: null,
        items_autoload: null
    };
    if (typeof (c) == "object" && c != null && typeof (c.tagName) == "undefined") {
        if (c.icons_path != null || c.icon_path != null) {
            this.conf.icons_path = (c.icons_path || c.icon_path)
        }
        if (c.icons_size != null) {
            this.conf.icons_size_autoload = c.icons_size
        }
        if (c.json != null) {
            this.conf.json_autoload = c.json
        }
        if (c.xml != null) {
            this.conf.xml_autoload = c.xml
        }
        if (c.onload != null) {
            this.conf.onload_autoload = c.onload
        }
        if (c.items != null) {
            this.conf.items_autoload = c.items
        }
        if (c.skin != null) {
            this.conf.skin = c.skin
        }
        if (c.align != null) {
            this.conf.align_autostart = c.align
        }
        c = c.parent
    }
    this.cont = (typeof (c) != "object") ? document.getElementById(c) : c;
    while (this.cont.childNodes.length > 0) {
        this.cont.removeChild(this.cont.childNodes[0])
    }
    c = null;
    this.cont.dir = "ltr";
    this.base = document.createElement("DIV");
    this.base.className = "dhxtoolbar_float_left";
    this.cont.appendChild(this.base);
    if (window.dhx4.isIPad) {
        this.cont.ontouchstart = function (h) {
            h = h || event;
            if ((String(h.target.tagName || "").toLowerCase() == "input")) {
                return true
            }
            if (h.preventDefault) {
                h.preventDefault()
            } else {
                h.returnValue = false
            }
            h.cancelBubble = true;
            return false
        }
    }
    this.setSkin(this.conf.skin);
    this.objPull = {};
    this.anyUsed = "none";
    this._genStr = function (h) {
        var j = "";
        var m = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        for (var l = 0; l < h; l++) {
            j += m.charAt(Math.round(Math.random() * (m.length - 1)))
        }
        return j
    };
    this.rootTypes = new Array("button", "buttonSelect", "buttonTwoState", "separator", "label", "slider", "text", "buttonInput");
    this.idPrefix = this._genStr(12);
    window.dhx4._enableDataLoading(this, "_initObj", "_xmlToJson", "toolbar", {
        struct: true
    });
    window.dhx4._eventable(this);
    this._getObj = function (m, h) {
        var j = null;
        for (var l = 0; l < m.childNodes.length; l++) {
            if (m.childNodes[l].tagName != null) {
                if (String(m.childNodes[l].tagName).toLowerCase() == String(h).toLowerCase()) {
                    j = m.childNodes[l]
                }
            }
        }
        return j
    };
    this._addImgObj = function (j) {
        var h = document.createElement("IMG");
        if (j.childNodes.length > 0) {
            j.insertBefore(h, j.childNodes[0])
        } else {
            j.appendChild(h)
        }
        return h
    };
    this._setItemImage = function (m, j, h) {
        if (h == true) {
            m.imgEn = j
        } else {
            m.imgDis = j
        }
        if ((!m.state && h == true) || (m.state && h == false)) {
            return
        }
        var l = this._getObj(m.obj, "img");
        if (l == null) {
            l = this._addImgObj(m.obj)
        }
        l.src = this.conf.icons_path + j
    };
    this._clearItemImage = function (l, h) {
        if (h == true) {
            l.imgEn = ""
        } else {
            l.imgDis = ""
        }
        if ((!l.state && h == true) || (l.state && h == false)) {
            return
        }
        var j = this._getObj(l.obj, "img");
        if (j != null) {
            j.parentNode.removeChild(j)
        }
    };
    this._setItemText = function (h, l) {
        var j = this._getObj(h.obj, "div");
        if (l == null || l.length == 0) {
            if (j != null) {
                j.parentNode.removeChild(j)
            }
            return
        }
        if (j == null) {
            j = document.createElement("DIV");
            j.className = "dhxtoolbar_text";
            h.obj.appendChild(j)
        }
        j.innerHTML = l
    };
    this._getItemText = function (h) {
        var j = this._getObj(h.obj, "div");
        if (j != null) {
            return j.innerHTML
        }
        return ""
    };
    this._enableItem = function (j) {
        if (j.state) {
            return
        }
        j.state = true;
        if (this.objPull[j.id]["type"] == "buttonTwoState" && this.objPull[j.id]["obj"]["pressed"] == true) {
            j.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_pres";
            j.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_over"
        } else {
            j.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_def";
            j.obj.renderAs = j.obj.className
        }
        if (j.arw) {
            j.arw.className = String(j.obj.className).replace("btn", "arw")
        }
        var h = this._getObj(j.obj, "img");
        if (j.imgEn != "") {
            if (h == null) {
                h = this._addImgObj(j.obj)
            }
            h.src = this.conf.icons_path + j.imgEn
        } else {
            if (h != null) {
                h.parentNode.removeChild(h)
            }
        }
    };
    this._disableItem = function (j) {
        if (!j.state) {
            return
        }
        j.state = false;
        j.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_" + (this.objPull[j.id]["type"] == "buttonTwoState" && j.obj.pressed ? "pres_" : "") + "dis";
        j.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_def";
        if (j.arw) {
            j.arw.className = String(j.obj.className).replace("btn", "arw")
        }
        var h = this._getObj(j.obj, "img");
        if (j.imgDis != "") {
            if (h == null) {
                h = this._addImgObj(j.obj)
            }
            h.src = this.conf.icons_path + j.imgDis
        } else {
            if (h != null) {
                h.parentNode.removeChild(h)
            }
        }
        if (j.polygon != null) {
            if (j.polygon.style.display != "none") {
                window.dhx4.zim.clear(j.polygon._idd);
                j.polygon.style.display = "none";
                if (j.polygon._ie6cover) {
                    j.polygon._ie6cover.style.display = "none"
                }
                if (this.conf.skin == "dhx_terrace") {
                    this._improveTerraceButtonSelect(j.id, true)
                }
            }
        }
        this.anyUsed = "none"
    };
    this.clearAll = function () {
        for (var h in this.objPull) {
            this._removeItem(String(h).replace(this.idPrefix, ""))
        }
    };
    this._doOnClick = function (h) {
        if (a && a.forEachItem) {
            a.forEachItem(function (l) {
                if (a.objPull[a.idPrefix + l]["type"] == "buttonSelect") {
                    var j = a.objPull[a.idPrefix + l];
                    if (j.arw._skip === true) {
                        j.arw._skip = false
                    } else {
                        if (j.polygon.style.display != "none") {
                            j.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_def";
                            j.obj.className = j.obj.renderAs;
                            j.arw.className = String(j.obj.renderAs).replace("btn", "arw");
                            a.anyUsed = "none";
                            window.dhx4.zim.clear(j.polygon._idd);
                            j.polygon.style.display = "none";
                            if (j.polygon._ie6cover) {
                                j.polygon._ie6cover.style.display = "none"
                            }
                            if (a.conf.skin == "dhx_terrace") {
                                a._improveTerraceButtonSelect(j.id, true)
                            }
                        }
                    }
                }
            })
        }
    };
    if (window.dhx4.isIPad) {
        document.addEventListener("touchstart", this._doOnClick, false)
    } else {
        if (typeof (window.addEventListener) != "undefined") {
            window.addEventListener("mousedown", this._doOnClick, false)
        } else {
            document.body.attachEvent("onmousedown", this._doOnClick)
        }
    }
    if (this.conf.icons_size_autoload != null) {
        this.setIconSize(this.conf.icons_size_autoload);
        this.conf.icons_size_autoload = null
    }
    if (this.conf.items_autoload != null) {
        this.loadStruct(this.conf.items_autoload, this.conf.onload_autoload);
        this.conf.items_autoload = null
    } else {
        if (this.conf.json_autoload != null) {
            this.loadStruct(this.conf.json_autoload, this.conf.onload_autoload);
            this.conf.json_autoload = null
        } else {
            if (this.conf.xml_autoload != null) {
                this.loadStruct(this.conf.xml_autoload, this.conf.onload_autoload);
                this.conf.xml_autoload = null
            }
        }
    }
    if (this.conf.align_autostart != this.conf.align) {
        this.setAlign(this.conf.align_autostart);
        this.conf.align_autostart = null
    }
    return this
}
dhtmlXToolbarObject.prototype.addSpacer = function (g) {
    var c = this.idPrefix + g;
    if (this._spacer != null) {
        if (this._spacer.idd == g) {
            return
        }
        if (this._spacer == this.objPull[c].obj.parentNode) {
            var a = true;
            while (a) {
                var m = this._spacer.childNodes[0].idd;
                this.base.appendChild(this._spacer.childNodes[0]);
                if (m == g || this._spacer.childNodes.length == 0) {
                    if (this.objPull[c].arw != null) {
                        this.base.appendChild(this.objPull[c].arw)
                    }
                    a = false
                }
            }
            this._spacer.idd = g;
            this._fixSpacer();
            return
        }
        if (this.base == this.objPull[c].obj.parentNode) {
            var a = true;
            var l = (this.objPull[c].arw != null);
            while (a) {
                var h = this.base.childNodes.length - 1;
                if (l == true) {
                    if (this.base.childNodes[h] == this.objPull[c].arw) {
                        a = false
                    }
                }
                if (this.base.childNodes[h].idd == g) {
                    a = false
                }
                if (a) {
                    if (this._spacer.childNodes.length > 0) {
                        this._spacer.insertBefore(this.base.childNodes[h], this._spacer.childNodes[0])
                    } else {
                        this._spacer.appendChild(this.base.childNodes[h])
                    }
                }
            }
            this._spacer.idd = g;
            this._fixSpacer();
            return
        }
    } else {
        var j = null;
        for (var h = 0; h < this.base.childNodes.length; h++) {
            if (this.base.childNodes[h] == this.objPull[this.idPrefix + g].obj) {
                j = h;
                if (this.objPull[this.idPrefix + g].arw != null) {
                    j = h + 1
                }
            }
        }
        if (j != null) {
            this._spacer = document.createElement("DIV");
            this._spacer.className = (this.conf.align == "right" ? " dhxtoolbar_float_left" : " dhxtoolbar_float_right");
            this._spacer.dir = "ltr";
            this._spacer.idd = g;
            while (this.base.childNodes.length > j + 1) {
                this._spacer.appendChild(this.base.childNodes[j + 1])
            }
            this.cont.appendChild(this._spacer);
            this._fixSpacer()
        }
    }
    if (this.conf.skin == "dhx_terrace") {
        this._improveTerraceSkin()
    }
};
dhtmlXToolbarObject.prototype.removeSpacer = function () {
    if (!this._spacer) {
        return
    }
    while (this._spacer.childNodes.length > 0) {
        this.base.appendChild(this._spacer.childNodes[0])
    }
    this._spacer.parentNode.removeChild(this._spacer);
    this._spacer = null;
    if (this.conf.skin == "dhx_terrace") {
        this._improveTerraceSkin()
    }
};
dhtmlXToolbarObject.prototype._fixSpacer = function () {
    if (typeof (window.addEventListener) == "undefined" && this._spacer != null) {
        this._spacer.style.borderLeft = "1px solid #a4bed4";
        var a = this._spacer;
        window.setTimeout(function () {
            a.style.borderLeft = "0px solid #a4bed4";
            a = null
        }, 1)
    }
};
dhtmlXToolbarObject.prototype.getType = function (g) {
    var h = this.getParentId(g);
    if (h != null) {
        var c = null;
        var a = this.objPull[this.idPrefix + h]._listOptions[g];
        if (a != null) {
            if (a.sep != null) {
                c = "buttonSelectSeparator"
            } else {
                c = "buttonSelectButton"
            }
        }
        return c
    } else {
        if (this.objPull[this.idPrefix + g] == null) {
            return null
        }
        return this.objPull[this.idPrefix + g]["type"]
    }
};
dhtmlXToolbarObject.prototype.getTypeExt = function (c) {
    var a = this.getType(c);
    if (a == "buttonSelectButton" || a == "buttonSelectSeparator") {
        if (a == "buttonSelectButton") {
            a = "button"
        } else {
            a = "separator"
        }
        return a
    }
    return null
};
dhtmlXToolbarObject.prototype.inArray = function (g, c) {
    for (var a = 0; a < g.length; a++) {
        if (g[a] == c) {
            return true
        }
    }
    return false
};
dhtmlXToolbarObject.prototype.getParentId = function (h) {
    var j = null;
    for (var g in this.objPull) {
        if (this.objPull[g]._listOptions) {
            for (var c in this.objPull[g]._listOptions) {
                if (c == h) {
                    j = String(g).replace(this.idPrefix, "")
                }
            }
        }
    }
    return j
};
dhtmlXToolbarObject.prototype._addItem = function (a, c) {
    this._addItemToStorage(a, c);
    if (this.conf.skin == "dhx_terrace") {
        this._improveTerraceSkin()
    }
};
dhtmlXToolbarObject.prototype.addButton = function (j, h, c, a, g) {
    this._addItem({
        id: j,
        type: "button",
        text: c,
        img: a,
        imgdis: g
    }, h)
};
dhtmlXToolbarObject.prototype.addText = function (g, c, a) {
    this._addItem({
        id: g,
        type: "text",
        text: a
    }, c)
};
dhtmlXToolbarObject.prototype.addButtonSelect = function (h, n, s, a, c, o, m, w, j, l) {
    var v = [];
    for (var g = 0; g < a.length; g++) {
        var r = {};
        if (a[g] instanceof Array) {
            r.id = a[g][0];
            r.type = (a[g][1] == "obj" ? "button" : "separator");
            r.text = (a[g][2] || null);
            r.img = (a[g][3] || null)
        } else {
            if (a[g] instanceof Object && a[g] != null && typeof (a[g].id) != "undefined" && typeof (a[g].type) != "undefined") {
                r.id = a[g].id;
                r.type = (a[g].type == "obj" ? "button" : "separator");
                r.text = a[g].text;
                r.img = a[g].img
            }
        }
        v.push(r)
    }
    this._addItem({
        id: h,
        type: "buttonSelect",
        text: s,
        img: c,
        imgdis: o,
        renderSelect: m,
        openAll: w,
        options: v,
        maxOpen: j,
        mode: l
    }, n)
};
dhtmlXToolbarObject.prototype.addButtonTwoState = function (j, h, c, a, g) {
    this._addItem({
        id: j,
        type: "buttonTwoState",
        img: a,
        imgdis: g,
        text: c
    }, h)
};
dhtmlXToolbarObject.prototype.addSeparator = function (c, a) {
    this._addItem({
        id: c,
        type: "separator"
    }, a)
};
dhtmlXToolbarObject.prototype.addSlider = function (c, m, j, h, o, g, l, a, n) {
    this._addItem({
        id: c,
        type: "slider",
        length: j,
        valueMin: h,
        valueMax: o,
        valueNow: g,
        textMin: l,
        textMax: a,
        toolTip: n
    }, m)
};
dhtmlXToolbarObject.prototype.addInput = function (h, g, c, a) {
    this._addItem({
        id: h,
        type: "buttonInput",
        value: c,
        width: a
    }, g)
};
dhtmlXToolbarObject.prototype.forEachItem = function (g) {
    for (var c in this.objPull) {
        if (this.inArray(this.rootTypes, this.objPull[c]["type"])) {
            g(this.objPull[c]["id"].replace(this.idPrefix, ""))
        }
    }
};
(function () {
    var l = "isVisible,enableItem,disableItem,isEnabled,setItemText,getItemText,setItemToolTip,getItemToolTip,getInput,setItemImage,setItemImageDis,clearItemImage,clearItemImageDis,setItemState,getItemState,setItemToolTipTemplate,getItemToolTipTemplate,setValue,getValue,setMinValue,getMinValue,setMaxValue,getMaxValue,setWidth,getWidth,setMaxOpen".split(",");
    var g = [false, "", "", false, "", "", "", "", "", "", "", "", "", false, "", "", "", null, "", [null, null], "", [null, null], "", null];
    var c = function (m, n) {
            return function (r, q, o) {
                r = this.idPrefix + r;
                if (this.objPull[r][m] != null) {
                    return this.objPull[r][m].call(this.objPull[r], q, o)
                } else {
                    return n
                }
            }
        };
    for (var j = 0; j < l.length; j++) {
        var a = l[j];
        var h = g[j];
        dhtmlXToolbarObject.prototype[a] = c(a, h)
    }
})();
dhtmlXToolbarObject.prototype.showItem = function (a) {
    a = this.idPrefix + a;
    if (this.objPull[a] != null && this.objPull[a].showItem != null) {
        this.objPull[a].showItem();
        if (this.conf.skin == "dhx_terrace") {
            this._improveTerraceSkin()
        }
    }
};
dhtmlXToolbarObject.prototype.hideItem = function (a) {
    a = this.idPrefix + a;
    if (this.objPull[a] != null && this.objPull[a].hideItem != null) {
        this.objPull[a].hideItem();
        if (this.conf.skin == "dhx_terrace") {
            this._improveTerraceSkin()
        }
    }
};
dhtmlXToolbarObject.prototype.getPosition = function (a) {
    return this._getPosition(a)
};
dhtmlXToolbarObject.prototype._getPosition = function (j, g) {
    if (this.objPull[this.idPrefix + j] == null) {
        return null
    }
    var h = null;
    var a = 0;
    for (var c = 0; c < this.base.childNodes.length; c++) {
        if (this.base.childNodes[c].idd != null) {
            if (this.base.childNodes[c].idd == j) {
                h = a
            }
            a++
        }
    }
    if (!h && this._spacer != null) {
        for (var c = 0; c < this._spacer.childNodes.length; c++) {
            if (this._spacer.childNodes[c].idd != null) {
                if (this._spacer.childNodes[c].idd == j) {
                    h = a
                }
                a++
            }
        }
    }
    return h
};
dhtmlXToolbarObject.prototype.setPosition = function (a, c) {
    this._setPosition(a, c)
};
dhtmlXToolbarObject.prototype._setPosition = function (j, h) {
    if (this.objPull[this.idPrefix + j] == null) {
        return
    }
    if (isNaN(h)) {
        h = this.base.childNodes.length
    }
    if (h < 0) {
        h = 0
    }
    var a = null;
    if (this._spacer) {
        a = this._spacer.idd;
        this.removeSpacer()
    }
    var g = this.objPull[this.idPrefix + j];
    this.base.removeChild(g.obj);
    if (g.arw) {
        this.base.removeChild(g.arw)
    }
    var c = this._getIdByPosition(h, true);
    if (c[0] == null) {
        this.base.appendChild(g.obj);
        if (g.arw) {
            this.base.appendChild(g.arw)
        }
    } else {
        this.base.insertBefore(g.obj, this.base.childNodes[c[1]]);
        if (g.arw) {
            this.base.insertBefore(g.arw, this.base.childNodes[c[1] + 1])
        }
    }
    if (a != null) {
        this.addSpacer(a)
    }
};
dhtmlXToolbarObject.prototype._getIdByPosition = function (l, c) {
    var j = null;
    var a = 0;
    var g = 0;
    for (var h = 0; h < this.base.childNodes.length; h++) {
        if (this.base.childNodes[h]["idd"] != null && j == null) {
            if ((a++) == l) {
                j = this.base.childNodes[h]["idd"]
            }
        }
        if (j == null) {
            g++
        }
    }
    g = (j == null ? null : g);
    return (c == true ? new Array(j, g) : j)
};
dhtmlXToolbarObject.prototype.removeItem = function (a) {
    this._removeItem(a);
    if (this.conf.skin == "dhx_terrace") {
        this._improveTerraceSkin()
    }
};
dhtmlXToolbarObject.prototype._removeItem = function (j) {
    var g = this.getType(j);
    j = this.idPrefix + j;
    var h = this.objPull[j];
    if (g == "button") {
        h.obj._doOnMouseOver = null;
        h.obj._doOnMouseOut = null;
        h.obj._doOnMouseUp = null;
        h.obj._doOnMouseUpOnceAnywhere = null;
        h.obj.onclick = null;
        h.obj.onmouseover = null;
        h.obj.onmouseout = null;
        h.obj.onmouseup = null;
        h.obj.onmousedown = null;
        h.obj.onselectstart = null;
        h.obj.renderAs = null;
        h.obj.idd = null;
        h.obj.parentNode.removeChild(h.obj);
        h.obj = null;
        h.id = null;
        h.state = null;
        h.img = null;
        h.imgEn = null;
        h.imgDis = null;
        h.type = null;
        h.enableItem = null;
        h.disableItem = null;
        h.isEnabled = null;
        h.showItem = null;
        h.hideItem = null;
        h.isVisible = null;
        h.setItemText = null;
        h.getItemText = null;
        h.setItemImage = null;
        h.clearItemImage = null;
        h.setItemImageDis = null;
        h.clearItemImageDis = null;
        h.setItemToolTip = null;
        h.getItemToolTip = null
    }
    if (g == "buttonTwoState") {
        h.obj._doOnMouseOver = null;
        h.obj._doOnMouseOut = null;
        h.obj.onmouseover = null;
        h.obj.onmouseout = null;
        h.obj.onmousedown = null;
        h.obj.onselectstart = null;
        h.obj.renderAs = null;
        h.obj.idd = null;
        h.obj.parentNode.removeChild(h.obj);
        h.obj = null;
        h.id = null;
        h.state = null;
        h.img = null;
        h.imgEn = null;
        h.imgDis = null;
        h.type = null;
        h.enableItem = null;
        h.disableItem = null;
        h.isEnabled = null;
        h.showItem = null;
        h.hideItem = null;
        h.isVisible = null;
        h.setItemText = null;
        h.getItemText = null;
        h.setItemImage = null;
        h.clearItemImage = null;
        h.setItemImageDis = null;
        h.clearItemImageDis = null;
        h.setItemToolTip = null;
        h.getItemToolTip = null;
        h.setItemState = null;
        h.getItemState = null
    }
    if (g == "buttonSelect") {
        for (var c in h._listOptions) {
            this.removeListOption(j, c)
        }
        h._listOptions = null;
        if (h.polygon._ie6cover) {
            document.body.removeChild(h.polygon._ie6cover);
            h.polygon._ie6cover = null
        }
        h.p_tbl.removeChild(h.p_tbody);
        h.polygon.removeChild(h.p_tbl);
        h.polygon.onselectstart = null;
        document.body.removeChild(h.polygon);
        h.p_tbody = null;
        h.p_tbl = null;
        h.polygon = null;
        h.obj.onclick = null;
        h.obj.onmouseover = null;
        h.obj.onmouseout = null;
        h.obj.onmouseup = null;
        h.obj.onmousedown = null;
        h.obj.onselectstart = null;
        h.obj.idd = null;
        h.obj.iddPrefix = null;
        h.obj.parentNode.removeChild(h.obj);
        h.obj = null;
        h.arw.onclick = null;
        h.arw.onmouseover = null;
        h.arw.onmouseout = null;
        h.arw.onmouseup = null;
        h.arw.onmousedown = null;
        h.arw.onselectstart = null;
        h.arw.parentNode.removeChild(h.arw);
        h.arw = null;
        h.renderSelect = null;
        h.state = null;
        h.type = null;
        h.id = null;
        h.img = null;
        h.imgEn = null;
        h.imgDis = null;
        h.openAll = null;
        h._isListButton = null;
        h._separatorButtonSelectObject = null;
        h._buttonButtonSelectObject = null;
        h.setWidth = null;
        h.enableItem = null;
        h.disableItem = null;
        h.isEnabled = null;
        h.showItem = null;
        h.hideItem = null;
        h.isVisible = null;
        h.setItemText = null;
        h.getItemText = null;
        h.setItemImage = null;
        h.clearItemImage = null;
        h.setItemImageDis = null;
        h.clearItemImageDis = null;
        h.setItemToolTip = null;
        h.getItemToolTip = null;
        h.addListOption = null;
        h.removeListOption = null;
        h.showListOption = null;
        h.hideListOption = null;
        h.isListOptionVisible = null;
        h.enableListOption = null;
        h.disableListOption = null;
        h.isListOptionEnabled = null;
        h.setListOptionPosition = null;
        h.getListOptionPosition = null;
        h.setListOptionImage = null;
        h.getListOptionImage = null;
        h.clearListOptionImage = null;
        h.setListOptionText = null;
        h.getListOptionText = null;
        h.setListOptionToolTip = null;
        h.getListOptionToolTip = null;
        h.forEachListOption = null;
        h.getAllListOptions = null;
        h.setListOptionSelected = null;
        h.getListOptionSelected = null
    }
    if (g == "buttonInput") {
        h.obj.childNodes[0].onkeydown = null;
        h.obj.removeChild(h.obj.childNodes[0]);
        h.obj.w = null;
        h.obj.idd = null;
        h.obj.parentNode.removeChild(h.obj);
        h.obj = null;
        h.id = null;
        h.type = null;
        h.enableItem = null;
        h.disableItem = null;
        h.isEnabled = null;
        h.showItem = null;
        h.hideItem = null;
        h.isVisible = null;
        h.setItemToolTip = null;
        h.getItemToolTip = null;
        h.setWidth = null;
        h.getWidth = null;
        h.setValue = null;
        h.getValue = null;
        h.setItemText = null;
        h.getItemText = null
    }
    if (g == "slider") {
        if (window.dhx4.isIPad) {
            document.removeEventListener("touchmove", pen._doOnMouseMoveStart, false);
            document.removeEventListener("touchend", pen._doOnMouseMoveEnd, false)
        } else {
            if (typeof (window.addEventListener) == "function") {
                window.removeEventListener("mousemove", h.pen._doOnMouseMoveStart, false);
                window.removeEventListener("mouseup", h.pen._doOnMouseMoveEnd, false)
            } else {
                document.body.detachEvent("onmousemove", h.pen._doOnMouseMoveStart);
                document.body.detachEvent("onmouseup", h.pen._doOnMouseMoveEnd)
            }
        }
        h.pen.allowMove = null;
        h.pen.initXY = null;
        h.pen.maxX = null;
        h.pen.minX = null;
        h.pen.nowX = null;
        h.pen.newNowX = null;
        h.pen.valueMax = null;
        h.pen.valueMin = null;
        h.pen.valueNow = null;
        h.pen._definePos = null;
        h.pen._detectLimits = null;
        h.pen._doOnMouseMoveStart = null;
        h.pen._doOnMouseMoveEnd = null;
        h.pen.onmousedown = null;
        h.obj.removeChild(h.pen);
        h.pen = null;
        h.label.tip = null;
        document.body.removeChild(h.label);
        h.label = null;
        h.obj.onselectstart = null;
        h.obj.idd = null;
        while (h.obj.childNodes.length > 0) {
            h.obj.removeChild(h.obj.childNodes[0])
        }
        h.obj.parentNode.removeChild(h.obj);
        h.obj = null;
        h.id = null;
        h.type = null;
        h.state = null;
        h.enableItem = null;
        h.disableItem = null;
        h.isEnabled = null;
        h.setItemToolTipTemplate = null;
        h.getItemToolTipTemplate = null;
        h.setMaxValue = null;
        h.setMinValue = null;
        h.getMaxValue = null;
        h.getMinValue = null;
        h.setValue = null;
        h.getValue = null;
        h.showItem = null;
        h.hideItem = null;
        h.isVisible = null
    }
    if (g == "separator") {
        h.obj.onselectstart = null;
        h.obj.idd = null;
        h.obj.parentNode.removeChild(h.obj);
        h.obj = null;
        h.id = null;
        h.type = null;
        h.showItem = null;
        h.hideItem = null;
        h.isVisible = null
    }
    if (g == "text") {
        h.obj.onselectstart = null;
        h.obj.idd = null;
        h.obj.parentNode.removeChild(h.obj);
        h.obj = null;
        h.id = null;
        h.type = null;
        h.showItem = null;
        h.hideItem = null;
        h.isVisible = null;
        h.setWidth = null;
        h.setItemText = null;
        h.getItemText = null
    }
    g = null;
    h = null;
    this.objPull[this.idPrefix + j] = null;
    delete this.objPull[this.idPrefix + j]
};
(function () {
    var h = "addListOption,removeListOption,showListOption,hideListOption,isListOptionVisible,enableListOption,disableListOption,isListOptionEnabled,setListOptionPosition,getListOptionPosition,setListOptionText,getListOptionText,setListOptionToolTip,getListOptionToolTip,setListOptionImage,getListOptionImage,clearListOptionImage,forEachListOption,getAllListOptions,setListOptionSelected,getListOptionSelected".split(",");
    var c = function (j) {
            return function (r, m, l, q, o, n) {
                r = this.idPrefix + r;
                if (this.objPull[r] == null) {
                    return
                }
                if (this.objPull[r]["type"] != "buttonSelect") {
                    return
                }
                return this.objPull[r][j].call(this.objPull[r], m, l, q, o, n)
            }
        };
    for (var g = 0; g < h.length; g++) {
        var a = h[g];
        dhtmlXToolbarObject.prototype[a] = c(a)
    }
})();
dhtmlXToolbarObject.prototype._rtlParseBtn = function (c, a) {
    return c + a
};
dhtmlXToolbarObject.prototype._separatorObject = function (a, g, c) {
    this.id = a.idPrefix + g;
    this.obj = document.createElement("DIV");
    this.obj.className = "dhx_toolbar_sep";
    this.obj.style.display = (c.hidden != null ? "none" : "");
    this.obj.idd = String(g);
    this.obj.title = (c.title || "");
    this.obj.onselectstart = function (h) {
        h = h || event;
        if (h.preventDefault) {
            h.preventDefault()
        } else {
            h.returnValue = false
        }
    };
    if (window.dhx4.isIPad) {
        this.obj.ontouchstart = function (h) {
            h = h || event;
            if (h.preventDefault) {
                h.preventDefault()
            } else {
                h.returnValue = false
            }
            h.cancelBubble = true;
            return false
        }
    }
    a.base.appendChild(this.obj);
    this.showItem = function () {
        this.obj.style.display = ""
    };
    this.hideItem = function () {
        this.obj.style.display = "none"
    };
    this.isVisible = function () {
        return (this.obj.style.display == "")
    };
    return this
};
dhtmlXToolbarObject.prototype._textObject = function (a, g, c) {
    this.id = a.idPrefix + g;
    this.obj = document.createElement("DIV");
    this.obj.className = "dhx_toolbar_text";
    this.obj.style.display = (c.hidden != null ? "none" : "");
    this.obj.idd = String(g);
    this.obj.title = (c.title || "");
    this.obj.onselectstart = function (h) {
        h = h || event;
        if (h.preventDefault) {
            h.preventDefault()
        } else {
            h.returnValue = false
        }
    };
    if (window.dhx4.isIPad) {
        this.obj.ontouchstart = function (h) {
            h = h || event;
            if (h.preventDefault) {
                h.preventDefault()
            } else {
                h.returnValue = false
            }
            h.cancelBubble = true;
            return false
        }
    }
    this.obj.innerHTML = (c.text || "");
    a.base.appendChild(this.obj);
    this.showItem = function () {
        this.obj.style.display = ""
    };
    this.hideItem = function () {
        this.obj.style.display = "none"
    };
    this.isVisible = function () {
        return (this.obj.style.display == "")
    };
    this.setItemText = function (h) {
        this.obj.innerHTML = h
    };
    this.getItemText = function () {
        return this.obj.innerHTML
    };
    this.setWidth = function (h) {
        this.obj.style.width = h + "px"
    };
    this.setItemToolTip = function (h) {
        this.obj.title = h
    };
    this.getItemToolTip = function () {
        return this.obj.title
    };
    return this
};
dhtmlXToolbarObject.prototype._buttonObject = function (a, h, c) {
    this.id = a.idPrefix + h;
    this.state = (c.enabled != null ? false : true);
    this.imgEn = (c.img || "");
    this.imgDis = (c.imgdis || "");
    this.img = (this.state ? (this.imgEn != "" ? this.imgEn : "") : (this.imgDis != "" ? this.imgDis : ""));
    this.obj = document.createElement("DIV");
    this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_" + (this.state ? "def" : "dis");
    this.obj.style.display = (c.hidden != null ? "none" : "");
    this.obj.allowClick = false;
    this.obj.extAction = (c.action || null);
    this.obj.renderAs = this.obj.className;
    this.obj.idd = String(h);
    this.obj.title = (c.title || "");
    this.obj.pressed = false;
    this.obj.innerHTML = a._rtlParseBtn((this.img != "" ? "<img src='" + a.conf.icons_path + this.img + "'>" : ""), (c.text != null ? "<div class='dhxtoolbar_text'>" + c.text + "</div>" : ""));
    var g = this;
    this.obj.onselectstart = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
    };
    this.obj.onmouseover = function () {
        this._doOnMouseOver()
    };
    this.obj.onmouseout = function () {
        this._doOnMouseOut()
    };
    this.obj._doOnMouseOver = function () {
        this.allowClick = true;
        if (g.state == false) {
            return
        }
        if (a.anyUsed != "none") {
            return
        }
        this.className = "dhx_toolbar_btn dhxtoolbar_btn_over";
        this.renderAs = this.className
    };
    this.obj._doOnMouseOut = function () {
        this.allowClick = false;
        if (g.state == false) {
            return
        }
        if (a.anyUsed != "none") {
            return
        }
        this.className = "dhx_toolbar_btn dhxtoolbar_btn_def";
        this.renderAs = this.renderAs
    };
    this.obj.onclick = function (j) {
        if (g.state == false) {
            return
        }
        if (this.allowClick == false) {
            return
        }
        j = j || event;
        var l = this.idd.replace(a.idPrefix, "");
        if (this.extAction) {
            try {
                window[this.extAction](l)
            } catch (j) {}
        }
        if (a && a.callEvent) {
            a.callEvent("onClick", [l])
        }
    };
    this.obj[window.dhx4.isIPad ? "ontouchstart" : "onmousedown"] = function (j) {
        if (g.state == false) {
            j = j || event;
            if (j.preventDefault) {
                j.preventDefault()
            } else {
                j.returnValue = false
            }
            j.cancelBubble = true;
            return false
        }
        if (a.anyUsed != "none") {
            return
        }
        a.anyUsed = this.idd;
        this.className = "dhx_toolbar_btn dhxtoolbar_btn_pres";
        this.pressed = true;
        this.onmouseover = function () {
            this._doOnMouseOver()
        };
        this.onmouseout = function () {
            a.anyUsed = "none";
            this._doOnMouseOut()
        };
        return false
    };
    this.obj[window.dhx4.isIPad ? "ontouchend" : "onmouseup"] = function (l) {
        if (g.state == false) {
            return
        }
        if (a.anyUsed != "none") {
            if (a.anyUsed != this.idd) {
                return
            }
        }
        var j = a.anyUsed;
        this._doOnMouseUp();
        if (window.dhx4.isIPad && j != "none") {
            a.callEvent("onClick", [this.idd.replace(a.idPrefix, "")])
        }
    };
    if (window.dhx4.isIPad) {
        this.obj.ontouchmove = function (j) {
            this._doOnMouseUp()
        }
    }
    this.obj._doOnMouseUp = function () {
        a.anyUsed = "none";
        this.className = this.renderAs;
        this.pressed = false
    };
    this.obj._doOnMouseUpOnceAnywhere = function () {
        this._doOnMouseUp();
        this.onmouseover = function () {
            this._doOnMouseOver()
        };
        this.onmouseout = function () {
            this._doOnMouseOut()
        }
    };
    a.base.appendChild(this.obj);
    this.enableItem = function () {
        a._enableItem(this)
    };
    this.disableItem = function () {
        a._disableItem(this)
    };
    this.isEnabled = function () {
        return this.state
    };
    this.showItem = function () {
        this.obj.style.display = ""
    };
    this.hideItem = function () {
        this.obj.style.display = "none"
    };
    this.isVisible = function () {
        return (this.obj.style.display == "")
    };
    this.setItemText = function (j) {
        a._setItemText(this, j)
    };
    this.getItemText = function () {
        return a._getItemText(this)
    };
    this.setItemImage = function (j) {
        a._setItemImage(this, j, true)
    };
    this.clearItemImage = function () {
        a._clearItemImage(this, true)
    };
    this.setItemImageDis = function (j) {
        a._setItemImage(this, j, false)
    };
    this.clearItemImageDis = function () {
        a._clearItemImage(this, false)
    };
    this.setItemToolTip = function (j) {
        this.obj.title = j
    };
    this.getItemToolTip = function () {
        return this.obj.title
    };
    return this
};
dhtmlXToolbarObject.prototype._buttonSelectObject = function (g, l, j) {
    this.id = g.idPrefix + l;
    this.state = (j.enabled != null ? (j.enabled == "true" ? true : false) : true);
    this.imgEn = (j.img || "");
    this.imgDis = (j.imgdis || "");
    this.img = (this.state ? (this.imgEn != "" ? this.imgEn : "") : (this.imgDis != "" ? this.imgDis : ""));
    this.mode = (j.mode || "button");
    if (this.mode == "select") {
        this.openAll = true;
        this.renderSelect = false;
        if (!j.text || j.text.length == 0) {
            j.text = "&nbsp;"
        }
    } else {
        this.openAll = (window.dhx4.s2b(j.openAll) == true);
        this.renderSelect = (j.renderSelect == null ? true : window.dhx4.s2b(j.renderSelect))
    }
    this.maxOpen = (!isNaN(j.maxOpen ? j.maxOpen : "") ? j.maxOpen : null);
    this._maxOpenTest = function () {
        if (!isNaN(this.maxOpen)) {
            if (!g._sbw) {
                var n = document.createElement("DIV");
                n.className = "dhxtoolbar_maxopen_test";
                document.body.appendChild(n);
                var m = document.createElement("DIV");
                m.className = "dhxtoolbar_maxopen_test2";
                n.appendChild(m);
                g._sbw = n.offsetWidth - m.offsetWidth;
                n.removeChild(m);
                m = null;
                document.body.removeChild(n);
                n = null
            }
        }
    };
    this._maxOpenTest();
    this.obj = document.createElement("DIV");
    this.obj.allowClick = false;
    this.obj.extAction = (j.action || null);
    this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_" + (this.state ? "def" : "dis");
    this.obj.style.display = (j.hidden != null ? "none" : "");
    this.obj.renderAs = this.obj.className;
    this.obj.onselectstart = function (m) {
        m = m || event;
        if (m.preventDefault) {
            m.preventDefault()
        } else {
            m.returnValue = false
        }
    };
    this.obj.idd = String(l);
    this.obj.title = (j.title || "");
    this.obj.pressed = false;
    this.callEvent = false;
    this.obj.innerHTML = g._rtlParseBtn((this.img != "" ? "<img src='" + g.conf.icons_path + this.img + "'>" : ""), (j.text != null ? "<div class='dhxtoolbar_text'>" + j.text + "</div>" : ""));
    g.base.appendChild(this.obj);
    this.arw = document.createElement("DIV");
    this.arw.className = "dhx_toolbar_arw dhxtoolbar_btn_" + (this.state ? "def" : "dis");
    this.arw.style.display = this.obj.style.display;
    this.arw.innerHTML = "<div class='arwimg'>&nbsp;</div>";
    this.arw.title = this.obj.title;
    this.arw.onselectstart = function (m) {
        m = m || event;
        if (m.preventDefault) {
            m.preventDefault()
        } else {
            m.returnValue = false
        }
    };
    g.base.appendChild(this.arw);
    var a = this;
    this.obj.onmouseover = function (m) {
        m = m || event;
        if (g.anyUsed != "none") {
            return
        }
        if (!a.state) {
            return
        }
        a.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_over";
        a.obj.className = a.obj.renderAs;
        a.arw.className = String(a.obj.renderAs).replace("btn", "arw")
    };
    this.obj.onmouseout = function () {
        a.obj.allowClick = false;
        if (g.anyUsed != "none") {
            return
        }
        if (!a.state) {
            return
        }
        a.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_def";
        a.obj.className = a.obj.renderAs;
        a.arw.className = String(a.obj.renderAs).replace("btn", "arw");
        a.callEvent = false
    };
    this.arw.onmouseover = this.obj.onmouseover;
    this.arw.onmouseout = this.obj.onmouseout;
    if (this.openAll == true) {} else {
        this.obj.onclick = function (m) {
            m = m || event;
            if (!a.obj.allowClick) {
                return
            }
            if (!a.state) {
                return
            }
            if (g.anyUsed != "none") {
                return
            }
            var n = a.obj.idd.replace(g.idPrefix, "");
            if (a.obj.extAction) {
                try {
                    window[a.obj.extAction](n)
                } catch (m) {}
            }
            g.callEvent("onClick", [n])
        };
        this.obj[window.dhx4.isIPad ? "ontouchstart" : "onmousedown"] = function (m) {
            m = m || event;
            if (g.anyUsed != "none") {
                return
            }
            if (!a.state) {
                return
            }
            a.obj.allowClick = true;
            a.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_pres";
            a.arw.className = "dhx_toolbar_arw dhxtoolbar_btn_pres";
            a.callEvent = true
        };
        this.obj[window.dhx4.isIPad ? "ontouchend" : "onmouseup"] = function (m) {
            m = m || event;
            m.cancelBubble = true;
            if (g.anyUsed != "none") {
                return
            }
            if (!a.state) {
                return
            }
            a.obj.className = a.obj.renderAs;
            a.arw.className = String(a.obj.renderAs).replace("btn", "arw");
            if (window.dhx4.isIPad && a.callEvent) {
                var n = a.obj.idd.replace(g.idPrefix, "");
                g.callEvent("onClick", [n])
            }
        }
    }
    if (window.dhx4.isIPad) {
        this.obj.ontouchmove = this.obj.onmouseout
    }
    this.arw[window.dhx4.isIPad ? "ontouchstart" : "onmousedown"] = function (o) {
        o = o || event;
        var w = (this.className.indexOf("dhx_toolbar_arw") === 0 ? this : this.nextSibling);
        if (w._skip) {
            o = o || event;
            o.cancelBubble = true
        } else {
            w._skip = true
        }
        w = null;
        if (!a.state) {
            return
        }
        if (g.anyUsed == a.obj.idd) {
            a.obj.className = a.obj.renderAs;
            a.arw.className = String(a.obj.renderAs).replace("btn", "arw");
            g.anyUsed = "none";
            window.dhx4.zim.clear(a.polygon._idd);
            a.polygon.style.display = "none";
            if (a.polygon._ie6cover) {
                a.polygon._ie6cover.style.display = "none"
            }
            if (g.conf.skin == "dhx_terrace") {
                g._improveTerraceButtonSelect(a.id, true)
            }
        } else {
            if (g.anyUsed != "none") {
                if (g.objPull[g.idPrefix + g.anyUsed]["type"] == "buttonSelect") {
                    var v = g.objPull[g.idPrefix + g.anyUsed];
                    if (v.polygon.style.display != "none") {
                        v.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_def";
                        v.obj.className = v.obj.renderAs;
                        v.arw.className = String(a.obj.renderAs).replace("btn", "arw");
                        window.dhx4.zim.clear(v.polygon._idd);
                        v.polygon.style.display = "none";
                        if (v.polygon._ie6cover) {
                            v.polygon._ie6cover.style.display = "none"
                        }
                        if (g.conf.skin == "dhx_terrace") {
                            g._improveTerraceButtonSelect(v.id, true)
                        }
                    }
                }
            }
            a.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_over";
            a.arw.className = "dhx_toolbar_arw dhxtoolbar_btn_pres";
            g.anyUsed = a.obj.idd;
            a.polygon.style.top = "0px";
            a.polygon.style.visibility = "hidden";
            a.polygon.style.zIndex = window.dhx4.zim.reserve(a.polygon._idd);
            a.polygon.style.display = "";
            if (g.conf.skin == "dhx_terrace") {
                g._improveTerraceButtonSelect(a.id, false)
            }
            a._fixMaxOpenHeight(a.maxOpen || null);
            g._autoDetectVisibleArea();
            var q = window.dhx4.absTop(a.obj) + a.obj.offsetHeight + g.conf.sel_ofs_y;
            var s = a.polygon.offsetHeight;
            if (q + s > g.tY2) {
                var r = (a.maxOpen != null ? Math.floor((g.tY2 - q) / 22) : 0);
                if (r >= 1) {
                    a._fixMaxOpenHeight(r)
                } else {
                    q = window.dhx4.absTop(a.obj) - s - g.conf.sel_ofs_y;
                    if (q < 0) {
                        q = 0
                    }
                }
            }
            a.polygon.style.top = q + "px";
            if (g.rtl) {
                a.polygon.style.left = window.dhx4.absLeft(a.obj) + a.obj.offsetWidth - a.polygon.offsetWidth + g.conf.sel_ofs_x + "px"
            } else {
                var n = document.body.scrollLeft;
                var m = n + (window.innerWidth || document.body.clientWidth);
                var u = window.dhx4.absLeft(a.obj) + g.conf.sel_ofs_x;
                if (u + a.polygon.offsetWidth > m) {
                    u = window.dhx4.absLeft(a.arw) + a.arw.offsetWidth - a.polygon.offsetWidth
                }
                a.polygon.style.left = Math.max(u, 5) + "px"
            }
            a.polygon.style.visibility = "visible";
            if (a.polygon._ie6cover) {
                a.polygon._ie6cover.style.left = a.polygon.style.left;
                a.polygon._ie6cover.style.top = a.polygon.style.top;
                a.polygon._ie6cover.style.width = a.polygon.offsetWidth + "px";
                a.polygon._ie6cover.style.height = a.polygon.offsetHeight + "px";
                a.polygon._ie6cover.style.display = ""
            }
        }
        return false
    };
    this.arw.onclick = function (m) {
        m = m || event;
        m.cancelBubble = true
    };
    this.arw[window.dhx4.isIPad ? "ontouchend" : "onmouseup"] = function (m) {
        m = m || event;
        m.cancelBubble = true
    };
    if (this.openAll === true) {
        this.obj.onclick = this.arw.onclick;
        this.obj.onmousedown = this.arw.onmousedown;
        this.obj.onmouseup = this.arw.onmouseup;
        if (window.dhx4.isIPad) {
            this.obj.ontouchstart = this.arw.ontouchstart;
            this.obj.ontouchend = this.arw.ontouchend
        }
    }
    this.obj.iddPrefix = g.idPrefix;
    this._listOptions = {};
    this._fixMaxOpenHeight = function (r) {
        var q = "auto";
        var o = false;
        if (r !== null) {
            var n = 0;
            for (var m in this._listOptions) {
                n++
            }
            if (n > r) {
                this._ph = 22 * r;
                q = this._ph + "px"
            } else {
                o = true
            }
        }
        this.polygon.style.width = "auto";
        this.polygon.style.height = "auto";
        if (!o && a.maxOpen != null) {
            this.polygon.style.width = this.p_tbl.offsetWidth + g._sbw + "px";
            this.polygon.style.height = q
        }
    };
    this._separatorButtonSelectObject = function (o, m, n) {
        this.obj = {};
        this.obj.tr = document.createElement("TR");
        this.obj.tr.className = "tr_sep";
        this.obj.tr.onselectstart = function (q) {
            q = q || event;
            if (q.preventDefault) {
                q.preventDefault()
            } else {
                q.returnValue = false
            }
            return false
        };
        this.obj.td = document.createElement("TD");
        this.obj.td.colSpan = "2";
        this.obj.td.className = "td_btn_sep";
        this.obj.td.onselectstart = function (q) {
            q = q || event;
            if (q.preventDefault) {
                q.preventDefault()
            } else {
                q.returnValue = false
            }
            return false
        };
        if (isNaN(n)) {
            n = a.p_tbody.childNodes.length + 1
        } else {
            if (n < 1) {
                n = 1
            }
        }
        if (n > a.p_tbody.childNodes.length) {
            a.p_tbody.appendChild(this.obj.tr)
        } else {
            a.p_tbody.insertBefore(this.obj.tr, a.p_tbody.childNodes[n - 1])
        }
        this.obj.tr.appendChild(this.obj.td);
        this.obj.sep = document.createElement("DIV");
        this.obj.sep.className = "btn_sep";
        this.obj.sep.onselectstart = function (q) {
            q = q || event;
            if (q.preventDefault) {
                q.preventDefault()
            } else {
                q.returnValue = false
            }
            return false
        };
        this.obj.td.appendChild(this.obj.sep);
        a._listOptions[o] = this.obj;
        return this
    };
    this._buttonButtonSelectObject = function (r, o, q) {
        var n = true;
        if (typeof (o.enabled) != "undefined") {
            n = window.dhx4.s2b(o.enabled)
        } else {
            if (typeof (o.disabled) != "undefined") {
                n = window.dhx4.s2b(o.disabled)
            }
        }
        this.obj = {};
        this.obj.tr = document.createElement("TR");
        this.obj.tr.en = n;
        this.obj.tr.extAction = (o.action || null);
        this.obj.tr._selected = (o.selected != null);
        this.obj.tr.className = "tr_btn" + (this.obj.tr.en ? (this.obj.tr._selected && a.renderSelect ? " tr_btn_selected" : "") : " tr_btn_disabled");
        this.obj.tr.onselectstart = function (s) {
            s = s || event;
            if (s.preventDefault) {
                s.preventDefault()
            } else {
                s.returnValue = false
            }
            return false
        };
        this.obj.tr.idd = String(r);
        if (isNaN(q)) {
            q = a.p_tbody.childNodes.length + 1
        } else {
            if (q < 1) {
                q = 1
            }
        }
        if (q > a.p_tbody.childNodes.length) {
            a.p_tbody.appendChild(this.obj.tr)
        } else {
            a.p_tbody.insertBefore(this.obj.tr, a.p_tbody.childNodes[q - 1])
        }
        this.obj.td_a = document.createElement("TD");
        this.obj.td_a.className = "td_btn_img";
        this.obj.td_a.onselectstart = function (s) {
            s = s || event;
            if (s.preventDefault) {
                s.preventDefault()
            } else {
                s.returnValue = false
            }
            return false
        };
        this.obj.td_b = document.createElement("TD");
        this.obj.td_b.className = "td_btn_txt";
        this.obj.td_b.onselectstart = function (s) {
            s = s || event;
            if (s.preventDefault) {
                s.preventDefault()
            } else {
                s.returnValue = false
            }
            return false
        };
        if (g.rtl) {
            this.obj.tr.appendChild(this.obj.td_b);
            this.obj.tr.appendChild(this.obj.td_a)
        } else {
            this.obj.tr.appendChild(this.obj.td_a);
            this.obj.tr.appendChild(this.obj.td_b)
        }
        if (o.img != null) {
            this.obj.td_a.innerHTML = "<img class='btn_sel_img' src='" + g.conf.icons_path + o.img + "' border='0'>";
            this.obj.tr._img = o.img
        } else {
            this.obj.td_a.innerHTML = "&nbsp;"
        }
        var m = (o.text != null ? o.text : (o.itemText || ""));
        this.obj.td_b.innerHTML = "<div class='btn_sel_text'>" + m + "</div>";
        this.obj.tr[window.dhx4.isIPad ? "ontouchstart" : "onmouseover"] = function () {
            if (!this.en || (this._selected && a.renderSelect)) {
                return
            }
            this.className = "tr_btn tr_btn_over"
        };
        this.obj.tr.onmouseout = function () {
            if (!this.en) {
                return
            }
            if (this._selected && a.renderSelect) {
                if (String(this.className).search("tr_btn_selected") == -1) {
                    this.className = "tr_btn tr_btn_selected"
                }
            } else {
                this.className = "tr_btn"
            }
        };
        this.obj.tr[window.dhx4.isIPad ? "ontouchend" : "onclick"] = function (s) {
            s = s || event;
            s.cancelBubble = true;
            if (!this.en) {
                return
            }
            a.setListOptionSelected(this.idd.replace(g.idPrefix, ""));
            a.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_def";
            a.obj.className = a.obj.renderAs;
            a.arw.className = String(a.obj.renderAs).replace("btn", "arw");
            window.dhx4.zim.clear(a.polygon._idd);
            a.polygon.style.display = "none";
            if (a.polygon._ie6cover) {
                a.polygon._ie6cover.style.display = "none"
            }
            if (g.conf.skin == "dhx_terrace") {
                g._improveTerraceButtonSelect(a.id, true)
            }
            g.anyUsed = "none";
            var u = this.idd.replace(g.idPrefix, "");
            if (this.extAction) {
                try {
                    window[this.extAction](u)
                } catch (s) {}
            }
            g.callEvent("onClick", [u])
        };
        a._listOptions[r] = this.obj;
        return this
    };
    this.polygon = document.createElement("DIV");
    this.polygon.dir = "ltr";
    this.polygon.style.display = "none";
    this.polygon.className = "dhx_toolbar_poly_" + g.conf.skin + " dhxtoolbar_icons_" + g.conf.iconSize;
    this.polygon.onselectstart = function (m) {
        m = m || event;
        if (m.preventDefault) {
            m.preventDefault()
        } else {
            m.returnValue = false
        }
    };
    this.polygon.onmousedown = function (m) {
        m = m || event;
        m.cancelBubble = true
    };
    this.polygon.style.overflowY = "auto";
    this.polygon._idd = window.dhx4.newId();
    if (window.dhx4.isIPad) {
        this.polygon.ontouchstart = function (m) {
            m = m || event;
            if (m.preventDefault) {
                m.preventDefault()
            } else {
                m.returnValue = false
            }
            m.cancelBubble = true;
            return false
        }
    }
    this.p_tbl = document.createElement("TABLE");
    this.p_tbl.className = "buttons_cont";
    this.p_tbl.cellSpacing = "0";
    this.p_tbl.cellPadding = "0";
    this.p_tbl.border = "0";
    this.polygon.appendChild(this.p_tbl);
    this.p_tbody = document.createElement("TBODY");
    this.p_tbl.appendChild(this.p_tbody);
    if (j.options != null) {
        for (var h = 0; h < j.options.length; h++) {
            var c = "_" + (j.options[h].type || "") + "ButtonSelectObject";
            if (j.options[h].id == null) {
                j.options[h].id = g._genStr(24)
            }
            if (typeof (this[c]) == "function") {
                new this[c](j.options[h].id, j.options[h])
            }
        }
    }
    document.body.appendChild(this.polygon);
    if (window.dhx4.isIE6) {
        this.polygon._ie6cover = document.createElement("IFRAME");
        this.polygon._ie6cover.frameBorder = 0;
        this.polygon._ie6cover.style.position = "absolute";
        this.polygon._ie6cover.style.border = "none";
        this.polygon._ie6cover.style.backgroundColor = "#000000";
        this.polygon._ie6cover.style.filter = "alpha(opacity=100)";
        this.polygon._ie6cover.style.display = "none";
        this.polygon._ie6cover.setAttribute("src", "javascript:false;");
        document.body.appendChild(this.polygon._ie6cover)
    }
    this.setWidth = function (m) {
        this.obj.style.width = m - this.arw.offsetWidth + "px";
        this.polygon.style.width = this.obj.offsetWidth + this.arw.offsetWidth - 2 + "px";
        this.p_tbl.style.width = this.polygon.style.width
    };
    this.enableItem = function () {
        g._enableItem(this)
    };
    this.disableItem = function () {
        g._disableItem(this)
    };
    this.isEnabled = function () {
        return this.state
    };
    this.showItem = function () {
        this.obj.style.display = "";
        this.arw.style.display = ""
    };
    this.hideItem = function () {
        this.obj.style.display = "none";
        this.arw.style.display = "none"
    };
    this.isVisible = function () {
        return (this.obj.style.display == "")
    };
    this.setItemText = function (m) {
        g._setItemText(this, m)
    };
    this.getItemText = function () {
        return g._getItemText(this)
    };
    this.setItemImage = function (m) {
        g._setItemImage(this, m, true)
    };
    this.clearItemImage = function () {
        g._clearItemImage(this, true)
    };
    this.setItemImageDis = function (m) {
        g._setItemImage(this, m, false)
    };
    this.clearItemImageDis = function () {
        g._clearItemImage(this, false)
    };
    this.setItemToolTip = function (m) {
        this.obj.title = m;
        this.arw.title = m
    };
    this.getItemToolTip = function () {
        return this.obj.title
    };
    this.addListOption = function (s, r, o, q, m) {
        if (!(o == "button" || o == "separator")) {
            return
        }
        var n = {
            id: s,
            type: o,
            text: q,
            img: m
        };
        new this["_" + o + "ButtonSelectObject"](s, n, r)
    };
    this.removeListOption = function (o) {
        if (!this._isListButton(o, true)) {
            return
        }
        var m = this._listOptions[o];
        if (m.td_a != null && m.td_b != null) {
            m.td_a.onselectstart = null;
            m.td_b.onselectstart = null;
            while (m.td_a.childNodes.length > 0) {
                m.td_a.removeChild(m.td_a.childNodes[0])
            }
            while (m.td_b.childNodes.length > 0) {
                m.td_b.removeChild(m.td_b.childNodes[0])
            }
            m.tr.onselectstart = null;
            m.tr.onmouseover = null;
            m.tr.onmouseout = null;
            m.tr.onclick = null;
            while (m.tr.childNodes.length > 0) {
                m.tr.removeChild(m.tr.childNodes[0])
            }
            m.tr.parentNode.removeChild(m.tr);
            m.td_a = null;
            m.td_b = null;
            m.tr = null
        } else {
            m.sep.onselectstart = null;
            m.td.onselectstart = null;
            m.tr.onselectstart = null;
            while (m.td.childNodes.length > 0) {
                m.td.removeChild(m.td.childNodes[0])
            }
            while (m.tr.childNodes.length > 0) {
                m.tr.removeChild(m.tr.childNodes[0])
            }
            m.tr.parentNode.removeChild(m.tr);
            m.sep = null;
            m.td = null;
            m.tr = null
        }
        m = null;
        this._listOptions[o] = null;
        try {
            delete this._listOptions[o]
        } catch (n) {}
    };
    this.showListOption = function (m) {
        if (!this._isListButton(m, true)) {
            return
        }
        this._listOptions[m].tr.style.display = ""
    };
    this.hideListOption = function (m) {
        if (!this._isListButton(m, true)) {
            return
        }
        this._listOptions[m].tr.style.display = "none"
    };
    this.isListOptionVisible = function (m) {
        if (!this._isListButton(m, true)) {
            return
        }
        return (this._listOptions[m].tr.style.display != "none")
    };
    this.enableListOption = function (m) {
        if (!this._isListButton(m)) {
            return
        }
        this._listOptions[m].tr.en = true;
        this._listOptions[m].tr.className = "tr_btn" + (this._listOptions[m].tr._selected && g.renderSelect ? " tr_btn_selected" : "")
    };
    this.disableListOption = function (m) {
        if (!this._isListButton(m)) {
            return
        }
        this._listOptions[m].tr.en = false;
        this._listOptions[m].tr.className = "tr_btn tr_btn_disabled"
    };
    this.isListOptionEnabled = function (m) {
        if (!this._isListButton(m)) {
            return
        }
        return this._listOptions[m].tr.en
    };
    this.setListOptionPosition = function (o, n) {
        if (!this._listOptions[o] || this.getListOptionPosition(o) == n || isNaN(n)) {
            return
        }
        if (n < 1) {
            n = 1
        }
        var m = this._listOptions[o].tr;
        this.p_tbody.removeChild(m);
        if (n > this.p_tbody.childNodes.length) {
            this.p_tbody.appendChild(m)
        } else {
            this.p_tbody.insertBefore(m, this.p_tbody.childNodes[n - 1])
        }
        m = null
    };
    this.getListOptionPosition = function (o) {
        var n = -1;
        if (!this._listOptions[o]) {
            return n
        }
        for (var m = 0; m < this.p_tbody.childNodes.length; m++) {
            if (this.p_tbody.childNodes[m] == this._listOptions[o].tr) {
                n = m + 1
            }
        }
        return n
    };
    this.setListOptionImage = function (q, m) {
        if (!this._isListButton(q)) {
            return
        }
        var o = this._listOptions[q].tr.childNodes[(g.rtl ? 1 : 0)];
        if (o.childNodes.length > 0) {
            o.childNodes[0].src = g.conf.icons_path + m
        } else {
            var n = document.createElement("IMG");
            n.className = "btn_sel_img";
            n.src = g.conf.icons_path + m;
            o.appendChild(n)
        }
        o = null
    };
    this.getListOptionImage = function (o) {
        if (!this._isListButton(o)) {
            return
        }
        var n = this._listOptions[o].tr.childNodes[(g.rtl ? 1 : 0)];
        var m = null;
        if (n.childNodes.length > 0) {
            m = n.childNodes[0].src
        }
        n = null;
        return m
    };
    this.clearListOptionImage = function (n) {
        if (!this._isListButton(n)) {
            return
        }
        var m = this._listOptions[n].tr.childNodes[(g.rtl ? 1 : 0)];
        while (m.childNodes.length > 0) {
            m.removeChild(m.childNodes[0])
        }
        m.innerHTML = "&nbsp;";
        m = null
    };
    this.setListOptionText = function (n, m) {
        if (!this._isListButton(n)) {
            return
        }
        this._listOptions[n].tr.childNodes[(g.rtl ? 0 : 1)].childNodes[0].innerHTML = m
    };
    this.getListOptionText = function (m) {
        if (!this._isListButton(m)) {
            return
        }
        return this._listOptions[m].tr.childNodes[(g.rtl ? 0 : 1)].childNodes[0].innerHTML
    };
    this.setListOptionToolTip = function (n, m) {
        if (!this._isListButton(n)) {
            return
        }
        this._listOptions[n].tr.title = m
    };
    this.getListOptionToolTip = function (m) {
        if (!this._isListButton(m)) {
            return
        }
        return this._listOptions[m].tr.title
    };
    this.forEachListOption = function (n) {
        for (var m in this._listOptions) {
            n(m)
        }
    };
    this.getAllListOptions = function () {
        var n = new Array();
        for (var m in this._listOptions) {
            n[n.length] = m
        }
        return n
    };
    this.setListOptionSelected = function (o) {
        for (var m in this._listOptions) {
            var n = this._listOptions[m];
            if (n.td_a != null && n.td_b != null && n.tr.en) {
                if (m == o) {
                    n.tr._selected = true;
                    n.tr.className = "tr_btn" + (this.renderSelect ? " tr_btn_selected" : "");
                    if (this.mode == "select") {
                        if (n.tr._img) {
                            this.setItemImage(n.tr._img)
                        } else {
                            this.clearItemImage()
                        }
                        this.setItemText(this.getListOptionText(o))
                    }
                } else {
                    n.tr._selected = false;
                    n.tr.className = "tr_btn"
                }
            }
            n = null
        }
    };
    this.getListOptionSelected = function () {
        var n = null;
        for (var m in this._listOptions) {
            if (this._listOptions[m].tr._selected == true) {
                n = m
            }
        }
        return n
    };
    this._isListButton = function (n, m) {
        if (this._listOptions[n] == null) {
            return false
        }
        if (!m && this._listOptions[n].tr.className == "tr_sep") {
            return false
        }
        return true
    };
    this.setMaxOpen = function (m) {
        this._ph = null;
        if (typeof (m) == "number") {
            this.maxOpen = m;
            this._maxOpenTest();
            return
        }
        this.maxOpen = null
    };
    if (j.width) {
        this.setWidth(j.width)
    }
    if (this.mode == "select" && typeof (j.selected) != "undefined") {
        this.setListOptionSelected(j.selected)
    }
    return this
};
dhtmlXToolbarObject.prototype._buttonInputObject = function (g, j, h) {
    this.id = g.idPrefix + j;
    this.obj = document.createElement("DIV");
    this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_def";
    this.obj.style.display = (h.hidden != null ? "none" : "");
    this.obj.idd = String(j);
    this.obj.w = (h.width != null ? h.width : 100);
    this.obj.title = (h.title != null ? h.title : "");
    this.obj.innerHTML = "<input class='dhxtoolbar_input' type='text' style='width:" + this.obj.w + "px;'" + (h.value != null ? " value='" + h.value + "'" : "") + ">";
    var c = g;
    var a = this;
    this.obj.childNodes[0].onkeydown = function (l) {
        l = l || event;
        if (l.keyCode == 13) {
            c.callEvent("onEnter", [a.obj.idd, this.value])
        }
    };
    g.base.appendChild(this.obj);
    this.enableItem = function () {
        this.obj.childNodes[0].disabled = false
    };
    this.disableItem = function () {
        this.obj.childNodes[0].disabled = true
    };
    this.isEnabled = function () {
        return (!this.obj.childNodes[0].disabled)
    };
    this.showItem = function () {
        this.obj.style.display = ""
    };
    this.hideItem = function () {
        this.obj.style.display = "none"
    };
    this.isVisible = function () {
        return (this.obj.style.display != "none")
    };
    this.setValue = function (l) {
        this.obj.childNodes[0].value = l
    };
    this.getValue = function () {
        return this.obj.childNodes[0].value
    };
    this.setWidth = function (l) {
        this.obj.w = l;
        this.obj.childNodes[0].style.width = this.obj.w + "px"
    };
    this.getWidth = function () {
        return this.obj.w
    };
    this.setItemToolTip = function (l) {
        this.obj.title = l
    };
    this.getItemToolTip = function () {
        return this.obj.title
    };
    this.getInput = function () {
        return this.obj.firstChild
    };
    if (typeof (h.enabled) != "undefined" && window.dhx4.s2b(h.enabled) == false) {
        this.disableItem()
    }
    return this
};
dhtmlXToolbarObject.prototype._buttonTwoStateObject = function (a, h, c) {
    this.id = a.idPrefix + h;
    this.state = (c.enabled != null ? false : true);
    this.imgEn = (c.img != null ? c.img : "");
    this.imgDis = (c.imgdis != null ? c.imgdis : "");
    this.img = (this.state ? (this.imgEn != "" ? this.imgEn : "") : (this.imgDis != "" ? this.imgDis : ""));
    this.obj = document.createElement("DIV");
    this.obj.pressed = (c.selected != null);
    this.obj.extAction = (c.action || null);
    this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_" + (this.obj.pressed ? "pres" + (this.state ? "" : "_dis") : (this.state ? "def" : "dis"));
    this.obj.style.display = (c.hidden != null ? "none" : "");
    this.obj.renderAs = this.obj.className;
    this.obj.idd = String(h);
    this.obj.title = (c.title || "");
    if (this.obj.pressed) {
        this.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_over"
    }
    this.obj.innerHTML = a._rtlParseBtn((this.img != "" ? "<img src='" + a.conf.icons_path + this.img + "'>" : ""), (c.text != null ? "<div class='dhxtoolbar_text'>" + c.text + "</div>" : ""));
    a.base.appendChild(this.obj);
    var g = this;
    this.obj.onselectstart = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
    };
    this.obj.onmouseover = function () {
        this._doOnMouseOver()
    };
    this.obj.onmouseout = function () {
        this._doOnMouseOut()
    };
    this.obj._doOnMouseOver = function () {
        if (g.state == false) {
            return
        }
        if (a.anyUsed != "none") {
            return
        }
        if (this.pressed) {
            this.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_over";
            return
        }
        this.className = "dhx_toolbar_btn dhxtoolbar_btn_over";
        this.renderAs = this.className
    };
    this.obj._doOnMouseOut = function () {
        if (g.state == false) {
            return
        }
        if (a.anyUsed != "none") {
            return
        }
        if (this.pressed) {
            this.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_def";
            return
        }
        this.className = "dhx_toolbar_btn dhxtoolbar_btn_def";
        this.renderAs = this.className
    };
    this.obj[window.dhx4.isIPad ? "ontouchstart" : "onmousedown"] = function (j) {
        if (a.checkEvent("onBeforeStateChange")) {
            if (!a.callEvent("onBeforeStateChange", [this.idd.replace(a.idPrefix, ""), this.pressed])) {
                return
            }
        }
        if (g.state == false) {
            return
        }
        if (a.anyUsed != "none") {
            return
        }
        this.pressed = !this.pressed;
        this.className = (this.pressed ? "dhx_toolbar_btn dhxtoolbar_btn_pres" : this.renderAs);
        var l = this.idd.replace(a.idPrefix, "");
        if (this.extAction) {
            try {
                window[this.extAction](l, this.pressed)
            } catch (j) {}
        }
        a.callEvent("onStateChange", [l, this.pressed]);
        return false
    };
    this.setItemState = function (j, m) {
        if (this.obj.pressed != j) {
            if (j == true) {
                this.obj.pressed = true;
                this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_pres" + (this.state ? "" : "_dis");
                this.obj.renderAs = "dhx_toolbar_btn dhxtoolbar_btn_over"
            } else {
                this.obj.pressed = false;
                this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_" + (this.state ? "def" : "dis");
                this.obj.renderAs = this.obj.className
            }
            if (m == true) {
                var n = this.obj.idd.replace(a.idPrefix, "");
                if (this.obj.extAction) {
                    try {
                        window[this.obj.extAction](n, this.obj.pressed)
                    } catch (l) {}
                }
                a.callEvent("onStateChange", [n, this.obj.pressed])
            }
        }
    };
    this.getItemState = function () {
        return this.obj.pressed
    };
    this.enableItem = function () {
        a._enableItem(this)
    };
    this.disableItem = function () {
        a._disableItem(this)
    };
    this.isEnabled = function () {
        return this.state
    };
    this.showItem = function () {
        this.obj.style.display = ""
    };
    this.hideItem = function () {
        this.obj.style.display = "none"
    };
    this.isVisible = function () {
        return (this.obj.style.display == "")
    };
    this.setItemText = function (j) {
        a._setItemText(this, j)
    };
    this.getItemText = function () {
        return a._getItemText(this)
    };
    this.setItemImage = function (j) {
        a._setItemImage(this, j, true)
    };
    this.clearItemImage = function () {
        a._clearItemImage(this, true)
    };
    this.setItemImageDis = function (j) {
        a._setItemImage(this, j, false)
    };
    this.clearItemImageDis = function () {
        a._clearItemImage(this, false)
    };
    this.setItemToolTip = function (j) {
        this.obj.title = j
    };
    this.getItemToolTip = function () {
        return this.obj.title
    };
    return this
};
dhtmlXToolbarObject.prototype._sliderObject = function (h, l, j) {
    this.id = h.idPrefix + l;
    this.state = (j.enabled != null ? (j.enabled == "true" ? true : false) : true);
    this.obj = document.createElement("DIV");
    this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_" + (this.state ? "def" : "dis");
    this.obj.style.display = (j.hidden != null ? "none" : "");
    this.obj.onselectstart = function (m) {
        m = m || event;
        if (m.preventDefault) {
            m.preventDefault()
        } else {
            m.returnValue = false
        }
    };
    this.obj.idd = String(l);
    this.obj.len = (j.length != null ? Number(j.length) : 50);
    this.obj.innerHTML = "<div class='dhxtoolbar_text'>" + (j.textMin || "") + "</div><div class='dhxtoolbar_sl_bg_l'></div><div class='dhxtoolbar_sl_bg_m' style='width:" + this.obj.len + "px;'></div><div class='dhxtoolbar_sl_bg_r'></div><div class='dhxtoolbar_text'>" + (j.textMax || "") + "</div>";
    h.base.appendChild(this.obj);
    var a = this;
    this.pen = document.createElement("DIV");
    this.pen.className = "dhxtoolbar_sl_pen";
    this.obj.appendChild(this.pen);
    var g = this.pen;
    this.label = document.createElement("DIV");
    this.label.dir = "ltr";
    this.label.className = "dhx_toolbar_slider_label_" + h.conf.skin + (h.rtl ? "_rtl" : "");
    this.label.style.display = "none";
    this.label.tip = (j.toolTip || "%v");
    this.label._zi = window.dhx4.newId();
    document.body.appendChild(this.label);
    var c = this.label;
    this.pen.valueMin = (j.valueMin != null ? Number(j.valueMin) : 0);
    this.pen.valueMax = (j.valueMax != null ? Number(j.valueMax) : 100);
    if (this.pen.valueMin > this.pen.valueMax) {
        this.pen.valueMin = this.pen.valueMax
    }
    this.pen.valueNow = (j.valueNow != null ? Number(j.valueNow) : this.pen.valueMax);
    if (this.pen.valueNow > this.pen.valueMax) {
        this.pen.valueNow = this.pen.valueMax
    }
    if (this.pen.valueNow < this.pen.valueMin) {
        this.pen.valueNow = this.pen.valueMin
    }
    this.pen._detectLimits = function () {
        this.minX = a.obj.childNodes[1].offsetLeft + 2;
        this.maxX = a.obj.childNodes[3].offsetLeft - this.offsetWidth + 1
    };
    this.pen._detectLimits();
    this.pen._definePos = function () {
        this.nowX = Math.round((this.valueNow - this.valueMin) * (this.maxX - this.minX) / (this.valueMax - this.valueMin) + this.minX);
        this.style.left = this.nowX + "px";
        this.newNowX = this.nowX
    };
    this.pen._definePos();
    this.pen.initXY = 0;
    this.pen.allowMove = false;
    this.pen[window.dhx4.isIPad ? "ontouchstart" : "onmousedown"] = function (m) {
        if (a.state == false) {
            return
        }
        m = m || event;
        this.initXY = (window.dhx4.isIPad ? m.touches[0].clientX : m.clientX);
        this.newValueNow = this.valueNow;
        this.allowMove = true;
        this.className = "dhxtoolbar_sl_pen dhxtoolbar_over";
        if (c.tip != "") {
            c.style.visibility = "hidden";
            c.style.display = "";
            c.innerHTML = c.tip.replace("%v", this.valueNow);
            c.style.left = Math.round(window.dhx4.absLeft(this) + this.offsetWidth / 2 - c.offsetWidth / 2) + "px";
            c.style.top = window.dhx4.absTop(this) - c.offsetHeight - 3 + "px";
            c.style.visibility = "";
            c.style.zIndex = window.dhx4.zim.reserve(c._zi)
        }
    };
    this.pen._doOnMouseMoveStart = function (n) {
        n = n || event;
        if (!g.allowMove) {
            return
        }
        var m = (window.dhx4.isIPad ? n.touches[0].clientX : n.clientX);
        var o = m - g.initXY;
        if (m < window.dhx4.absLeft(g) + Math.round(g.offsetWidth / 2) && g.nowX == g.minX) {
            return
        }
        if (m > window.dhx4.absLeft(g) + Math.round(g.offsetWidth / 2) && g.nowX == g.maxX) {
            return
        }
        g.newNowX = g.nowX + o;
        if (g.newNowX < g.minX) {
            g.newNowX = g.minX
        }
        if (g.newNowX > g.maxX) {
            g.newNowX = g.maxX
        }
        g.nowX = g.newNowX;
        g.style.left = g.nowX + "px";
        g.initXY = m;
        g.newValueNow = Math.round((g.valueMax - g.valueMin) * (g.newNowX - g.minX) / (g.maxX - g.minX) + g.valueMin);
        if (c.tip != "") {
            c.innerHTML = c.tip.replace(/%v/gi, g.newValueNow);
            c.style.left = Math.round(window.dhx4.absLeft(g) + g.offsetWidth / 2 - c.offsetWidth / 2) + "px";
            c.style.top = window.dhx4.absTop(g) - c.offsetHeight - 3 + "px"
        }
        n.cancelBubble = true;
        if (n.preventDefault) {
            n.preventDefault()
        } else {
            n.returnValue = false
        }
        return false
    };
    this.pen._doOnMouseMoveEnd = function () {
        if (!g.allowMove) {
            return
        }
        g.className = "dhxtoolbar_sl_pen";
        g.allowMove = false;
        g.nowX = g.newNowX;
        g.valueNow = g.newValueNow;
        if (c.tip != "") {
            c.style.display = "none";
            window.dhx4.zim.clear(c._zi)
        }
        h.callEvent("onValueChange", [a.obj.idd.replace(h.idPrefix, ""), g.valueNow])
    };
    if (window.dhx4.isIPad) {
        document.addEventListener("touchmove", g._doOnMouseMoveStart, false);
        document.addEventListener("touchend", g._doOnMouseMoveEnd, false)
    } else {
        if (typeof (window.addEventListener) != "undefined") {
            window.addEventListener("mousemove", g._doOnMouseMoveStart, false);
            window.addEventListener("mouseup", g._doOnMouseMoveEnd, false)
        } else {
            document.body.attachEvent("onmousemove", g._doOnMouseMoveStart);
            document.body.attachEvent("onmouseup", g._doOnMouseMoveEnd)
        }
    }
    this.enableItem = function () {
        if (this.state) {
            return
        }
        this.state = true;
        this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_def"
    };
    this.disableItem = function () {
        if (!this.state) {
            return
        }
        this.state = false;
        this.obj.className = "dhx_toolbar_btn dhxtoolbar_btn_dis"
    };
    this.isEnabled = function () {
        return this.state
    };
    this.showItem = function () {
        this.obj.style.display = ""
    };
    this.hideItem = function () {
        this.obj.style.display = "none"
    };
    this.isVisible = function () {
        return (this.obj.style.display == "")
    };
    this.setValue = function (m, n) {
        m = Number(m);
        if (m < this.pen.valueMin) {
            m = this.pen.valueMin
        }
        if (m > this.pen.valueMax) {
            m = this.pen.valueMax
        }
        this.pen.valueNow = m;
        this.pen._definePos();
        if (n == true) {
            h.callEvent("onValueChange", [this.obj.idd.replace(h.idPrefix, ""), this.pen.valueNow])
        }
    };
    this.getValue = function () {
        return this.pen.valueNow
    };
    this.setMinValue = function (n, m) {
        n = Number(n);
        if (n > this.pen.valueMax) {
            return
        }
        this.obj.childNodes[0].innerHTML = m;
        this.obj.childNodes[0].style.display = (m.length > 0 ? "" : "none");
        this.pen.valueMin = n;
        if (this.pen.valueNow < this.pen.valueMin) {
            this.pen.valueNow = this.pen.valueMin
        }
        this.pen._detectLimits();
        this.pen._definePos()
    };
    this.setMaxValue = function (n, m) {
        n = Number(n);
        if (n < this.pen.valueMin) {
            return
        }
        this.obj.childNodes[4].innerHTML = m;
        this.obj.childNodes[4].style.display = (m.length > 0 ? "" : "none");
        this.pen.valueMax = n;
        if (this.pen.valueNow > this.pen.valueMax) {
            this.pen.valueNow = this.pen.valueMax
        }
        this.pen._detectLimits();
        this.pen._definePos()
    };
    this.getMinValue = function () {
        var m = this.obj.childNodes[0].innerHTML;
        var n = this.pen.valueMin;
        return new Array(n, m)
    };
    this.getMaxValue = function () {
        var m = this.obj.childNodes[4].innerHTML;
        var n = this.pen.valueMax;
        return new Array(n, m)
    };
    this.setItemToolTipTemplate = function (m) {
        this.label.tip = m
    };
    this.getItemToolTipTemplate = function () {
        return this.label.tip
    };
    return this
};
dhtmlXToolbarObject.prototype.unload = function () {
    if (this.conf.isIPad) {
        document.removeEventListener("touchstart", this._doOnClick, false)
    } else {
        if (typeof (window.addEventListener) == "function") {
            window.removeEventListener("mousedown", this._doOnClick, false)
        } else {
            document.body.detachEvent("onmousedown", this._doOnClick)
        }
    }
    this._doOnClick = null;
    this.clearAll();
    this.objPull = null;
    if (this._xmlLoader) {
        this._xmlLoader.destructor();
        this._xmlLoader = null
    }
    while (this.base.childNodes.length > 0) {
        this.base.removeChild(this.base.childNodes[0])
    }
    this.cont.removeChild(this.base);
    this.base = null;
    while (this.cont.childNodes.length > 0) {
        this.cont.removeChild(this.cont.childNodes[0])
    }
    this.cont.className = "";
    this.cont = null;
    window.dhx4._enableDataLoading(this, null, null, null, "clear");
    window.dhx4._eventable(this, "clear");
    this.tX1 = null;
    this.tX2 = null;
    this.tY1 = null;
    this.tY2 = null;
    this.anyUsed = null;
    this.idPrefix = null;
    this.rootTypes = null;
    this._rtl = null;
    this._rtlParseBtn = null;
    this.setRTL = null;
    this._sbw = null;
    this._getObj = null;
    this._addImgObj = null;
    this._setItemImage = null;
    this._clearItemImage = null;
    this._setItemText = null;
    this._getItemText = null;
    this._enableItem = null;
    this._disableItem = null;
    this._xmlParser = null;
    this._addItemToStorage = null;
    this._genStr = null;
    this._addItem = null;
    this._getPosition = null;
    this._setPosition = null;
    this._getIdByPosition = null;
    this._separatorObject = null;
    this._textObject = null;
    this._buttonObject = null;
    this._buttonSelectObject = null;
    this._buttonInputObject = null;
    this._buttonTwoStateObject = null;
    this._sliderObject = null;
    this._autoDetectVisibleArea = null;
    this._removeItem = null;
    this.setAlign = null;
    this.setSkin = null;
    this.setIconsPath = null;
    this.setIconPath = null;
    this.loadXML = null;
    this.loadXMLString = null;
    this.clearAll = null;
    this.addSpacer = null;
    this.removeSpacer = null;
    this.getType = null;
    this.getTypeExt = null;
    this.inArray = null;
    this.getParentId = null;
    this.addButton = null;
    this.addText = null;
    this.addButtonSelect = null;
    this.addButtonTwoState = null;
    this.addSeparator = null;
    this.addSlider = null;
    this.addInput = null;
    this.forEachItem = null;
    this.showItem = null;
    this.hideItem = null;
    this.isVisible = null;
    this.enableItem = null;
    this.disableItem = null;
    this.isEnabled = null;
    this.setItemText = null;
    this.getItemText = null;
    this.setItemToolTip = null;
    this.getItemToolTip = null;
    this.setItemImage = null;
    this.setItemImageDis = null;
    this.clearItemImage = null;
    this.clearItemImageDis = null;
    this.setItemState = null;
    this.getItemState = null;
    this.setItemToolTipTemplate = null;
    this.getItemToolTipTemplate = null;
    this.setValue = null;
    this.getValue = null;
    this.setMinValue = null;
    this.getMinValue = null;
    this.setMaxValue = null;
    this.getMaxValue = null;
    this.setWidth = null;
    this.getWidth = null;
    this.getPosition = null;
    this.setPosition = null;
    this.removeItem = null;
    this.addListOption = null;
    this.removeListOption = null;
    this.showListOption = null;
    this.hideListOption = null;
    this.isListOptionVisible = null;
    this.enableListOption = null;
    this.disableListOption = null;
    this.isListOptionEnabled = null;
    this.setListOptionPosition = null;
    this.getListOptionPosition = null;
    this.setListOptionText = null;
    this.getListOptionText = null;
    this.setListOptionToolTip = null;
    this.getListOptionToolTip = null;
    this.setListOptionImage = null;
    this.getListOptionImage = null;
    this.clearListOptionImage = null;
    this.forEachListOption = null;
    this.getAllListOptions = null;
    this.setListOptionSelected = null;
    this.getListOptionSelected = null;
    this.unload = null;
    this.setUserData = null;
    this.getUserData = null;
    this.setMaxOpen = null;
    this.items = null;
    this.conf = null
};
dhtmlXToolbarObject.prototype._autoDetectVisibleArea = function () {
    var a = window.dhx4.screenDim();
    this.tX1 = a.left;
    this.tX2 = a.right;
    this.tY1 = a.top;
    this.tY2 = a.bottom
};
dhtmlXToolbarObject.prototype._initObj = function (c) {
    for (var a = 0; a < c.length; a++) {
        this._addItemToStorage(c[a])
    }
    if (this.conf.skin == "dhx_terrace") {
        this._improveTerraceSkin()
    }
};
dhtmlXToolbarObject.prototype._xmlToJson = function (s) {
    var n = [];
    var y = s.getElementsByTagName("toolbar");
    if (y != null && y[0] != null) {
        y = y[0];
        var D = ["id", "type", "hidden", "title", "text", "enabled", "img", "imgdis", "action", "openAll", "renderSelect", "mode", "maxOpen", "width", "value", "selected", "length", "textMin", "textMax", "toolTip", "valueMin", "valueMax", "valueNow"];
        var g = ["id", "type", "enabled", "disabled", "action", "selected", "img", "text"];
        for (var c = 0; c < y.childNodes.length; c++) {
            if (y.childNodes[c].tagName == "item") {
                var m = {};
                for (var A = 0; A < D.length; A++) {
                    var j = y.childNodes[c].getAttribute(D[A]);
                    if (j != null) {
                        m[D[A]] = j
                    }
                }
                for (var x = 0; x < y.childNodes[c].childNodes.length; x++) {
                    if (y.childNodes[c].childNodes[x].tagName == "item" && m.type == "buttonSelect") {
                        var C = {};
                        for (var A = 0; A < g.length; A++) {
                            var j = y.childNodes[c].childNodes[x].getAttribute(g[A]);
                            if (j != null) {
                                C[g[A]] = j
                            }
                        }
                        var v = y.childNodes[c].childNodes[x].getElementsByTagName("itemText");
                        if (v != null && v[0] != null) {
                            C.itemText = v[0].firstChild.nodeValue
                        }
                        var o = y.childNodes[c].childNodes[x].getElementsByTagName("userdata");
                        for (var A = 0; A < o.length; A++) {
                            if (!C.userdata) {
                                C.userdata = {}
                            }
                            var a = {};
                            try {
                                a.name = o[A].getAttribute("name")
                            } catch (l) {
                                a.name = null
                            }
                            try {
                                a.value = o[A].firstChild.nodeValue
                            } catch (l) {
                                a.value = ""
                            }
                            if (a.name != null) {
                                C.userdata[a.name] = a.value
                            }
                        }
                        if (m.options == null) {
                            m.options = []
                        }
                        m.options.push(C)
                    }
                    if (y.childNodes[c].childNodes[x].tagName == "userdata") {
                        if (m.userdata == null) {
                            m.userdata = {}
                        }
                        var C = {};
                        try {
                            C.name = y.childNodes[c].childNodes[x].getAttribute("name")
                        } catch (l) {
                            C.name = null
                        }
                        try {
                            C.value = y.childNodes[c].childNodes[x].firstChild.nodeValue
                        } catch (l) {
                            C.value = ""
                        }
                        if (C.name != null) {
                            m.userdata[C.name] = C.value
                        }
                    }
                }
                n.push(m)
            }
        }
    }
    return n
};
dhtmlXToolbarObject.prototype._addItemToStorage = function (l, n) {
    var m = (l.id || this._genStr(24));
    var h = (l.type || "");
    if (h != "" && this["_" + h + "Object"] != null) {
        if (h == "buttonSelect") {
            if (l.options != null) {
                for (var j = 0; j < l.options.length; j++) {
                    if (l.options[j].type == "obj") {
                        l.options[j].type = "button"
                    }
                    if (l.options[j].type == "sep") {
                        l.options[j].type = "separator"
                    }
                }
            }
        }
        if (h == "slider") {
            var g = {
                tip_template: "toolTip",
                value_min: "valueMin",
                value_max: "valueMax",
                value_now: "valueNow",
                text_min: "textMin",
                text_max: "textMax"
            };
            for (var c in g) {
                if (l[g[c]] == null && l[c] != null) {
                    l[g[c]] = l[c]
                }
            }
        }
        if (h == "buttonInput") {
            if (l.value == null && l.text != null) {
                l.value = l.text
            }
        }
        if (h == "buttonTwoState") {
            if (typeof (l.selected) == "undefined" && typeof (l.pressed) != "undefined" && window.dhx4.s2b(l.pressed)) {
                l.selected = true
            }
        }
        if (typeof (l.enabled) == "undefined" && typeof (l.disabled) != "undefined" && window.dhx4.s2b(l.disabled)) {
            l.enabled = false
        }
        if (l.imgDis == null && l.img_disabled != null) {
            l.imgdis = l.img_disabled
        }
        if ((typeof (l.openAll) == "undefined" || l.openAll == null) && this.conf.skin == "dhx_terrace") {
            l.openAll = true
        }
        this.objPull[this.idPrefix + m] = new this["_" + h + "Object"](this, m, l);
        this.objPull[this.idPrefix + m]["type"] = h;
        this.setPosition(m, n)
    }
    if (l.userdata != null) {
        for (var c in l.userdata) {
            this.setUserData(m, c, l.userdata[c])
        }
    }
    if (l.options != null) {
        for (var j = 0; j < l.options.length; j++) {
            if (l.options[j].userdata != null) {
                for (var c in l.options[j].userdata) {
                    this.setListOptionUserData(l.id, l.options[j].id, c, l.options[j].userdata[c])
                }
            }
        }
    }
};
dhtmlXToolbarObject.prototype.setSkin = function (j, g) {
    if (g === true) {
        this.cont.className = this.cont.className.replace(/dhxtoolbar_icons_\d{1,}/, "dhxtoolbar_icons_" + this.conf.iconSize)
    } else {
        this.conf.skin = j;
        if (this.conf.skin == "dhx_skyblue") {
            this.conf.sel_ofs_y = 1
        }
        if (this.conf.skin == "dhx_web") {
            this.conf.sel_ofs_y = 1;
            this.conf.sel_ofs_x = 1
        }
        if (this.conf.skin == "dhx_terrace") {
            this.conf.sel_ofs_y = -1;
            this.conf.sel_ofs_x = 0
        }
        this.cont.className = "dhx_toolbar_" + this.conf.skin + " dhxtoolbar_icons_" + this.conf.iconSize
    }
    for (var c in this.objPull) {
        var h = this.objPull[c];
        if (h.type == "slider") {
            h.pen._detectLimits();
            h.pen._definePos();
            h.label.className = "dhx_toolbar_slider_label_" + this.conf.skin
        }
        if (h.type == "buttonSelect") {
            h.polygon.className = "dhx_toolbar_poly_" + this.conf.skin + " dhxtoolbar_icons_" + this.conf.iconSize
        }
    }
    if (j == "dhx_terrace") {
        this._improveTerraceSkin()
    }
};
dhtmlXToolbarObject.prototype.setAlign = function (a) {
    this.conf.align = (a == "right" ? "right" : "left");
    this.base.className = (a == "right" ? "dhxtoolbar_float_right" : "dhxtoolbar_float_left");
    if (this._spacer) {
        this._spacer.className = (a == "right" ? " dhxtoolbar_float_left" : " dhxtoolbar_float_right")
    }
};
dhtmlXToolbarObject.prototype.setIconSize = function (a) {
    this.conf.iconSize = ({
        18: true,
        24: true,
        32: true,
        48: true
    }[a] ? a : 18);
    this.setSkin(this.conf.skin, true);
    this.callEvent("_onIconSizeChange", [this.conf.iconSize])
};
dhtmlXToolbarObject.prototype.setIconsPath = function (a) {
    this.conf.icons_path = a
};
dhtmlXToolbarObject.prototype.setUserData = function (g, a, c) {
    g = this.idPrefix + g;
    if (this.objPull[g] != null) {
        if (this.objPull[g].userData == null) {
            this.objPull[g].userData = {}
        }
        this.objPull[g].userData[a] = c
    }
};
dhtmlXToolbarObject.prototype.getUserData = function (c, a) {
    c = this.idPrefix + c;
    if (this.objPull[c] != null && this.objPull[c].userData != null) {
        return this.objPull[c].userData[a] || null
    }
    return null
};
dhtmlXToolbarObject.prototype._isListOptionExists = function (a, g) {
    if (this.objPull[this.idPrefix + a] == null) {
        return false
    }
    var c = this.objPull[this.idPrefix + a];
    if (c.type != "buttonSelect") {
        return false
    }
    if (c._listOptions[g] == null) {
        return false
    }
    return true
};
dhtmlXToolbarObject.prototype.setListOptionUserData = function (a, j, c, h) {
    if (!this._isListOptionExists(a, j)) {
        return
    }
    var g = this.objPull[this.idPrefix + a]._listOptions[j];
    if (g.userData == null) {
        g.userData = {}
    }
    g.userData[c] = h
};
dhtmlXToolbarObject.prototype.getListOptionUserData = function (a, h, c) {
    if (!this._isListOptionExists(a, h)) {
        return null
    }
    var g = this.objPull[this.idPrefix + a]._listOptions[h];
    if (!g.userData) {
        return null
    }
    return (g.userData[c] ? g.userData[c] : null)
};
dhtmlXToolbarObject.prototype._improveTerraceSkin = function () {
    if (this.conf.terrace_radius == null) {
        this.conf.terrace_radius = "3px"
    }
    var g = [];
    var h = {
        separator: true,
        text: true
    };
    var l = [this.base];
    if (this._spacer != null) {
        l.push(this._spacer)
    }
    for (var n = 0; n < l.length; n++) {
        g[n] = [];
        for (var c = 0; c < l[n].childNodes.length; c++) {
            if (l[n].childNodes[c].idd != null && l[n].childNodes[c].style.display != "none") {
                var m = this.idPrefix + l[n].childNodes[c].idd;
                if (this.objPull[m] != null && this.objPull[m].obj == l[n].childNodes[c]) {
                    g[n].push({
                        a: m,
                        type: this.objPull[m].type,
                        node: this.objPull[m][this.objPull[m].type == "buttonSelect" ? "arw" : "obj"]
                    })
                }
            }
        }
        l[n] = null
    }
    for (var n = 0; n < g.length; n++) {
        for (var c = 0; c < g[n].length; c++) {
            var o = g[n][c];
            var r = false;
            var j = false;
            if (!h[o.type]) {
                if (c == g[n].length - 1 || (g[n][c + 1] != null && h[g[n][c + 1].type])) {
                    r = true
                }
                if (c == 0 || (c - 1 >= 0 && g[n][c - 1] != null && h[g[n][c - 1].type])) {
                    j = true
                }
            }
            o.node.style.borderRightWidth = (r ? "1px" : "0px");
            o.node.style.borderTopRightRadius = o.node.style.borderBottomRightRadius = (r ? this.conf.terrace_radius : "0px");
            if (o.type == "buttonSelect") {
                o.node.previousSibling.style.borderTopLeftRadius = o.node.previousSibling.style.borderBottomLeftRadius = (j ? this.conf.terrace_radius : "0px");
                o.node.previousSibling._br = r;
                o.node.previousSibling._bl = j
            } else {
                o.node.style.borderTopLeftRadius = o.node.style.borderBottomLeftRadius = (j ? this.conf.terrace_radius : "0px")
            }
            o.node._br = r;
            o.node._bl = j
        }
    }
    for (var n = 0; n < g.length; n++) {
        for (var c = 0; c < g[n].length; c++) {
            for (var m in g[n][c]) {
                g[n][c][m] = null
            }
            g[n][c] = null
        }
        g[n] = null
    }
    g = l = null
};
dhtmlXToolbarObject.prototype._improveTerraceButtonSelect = function (g, c) {
    var a = this.objPull[g];
    if (c == true) {
        a.obj.style.borderBottomLeftRadius = (a.obj._bl ? this.conf.terrace_radius : "0px");
        a.arw.style.borderBottomRightRadius = (a.obj._br ? this.conf.terrace_radius : "0px")
    } else {
        a.obj.style.borderBottomLeftRadius = "0px";
        a.arw.style.borderBottomRightRadius = "0px"
    }
    a = null
};

function dhtmlXEditor(g, h) {
    var c = this;
    this.conf = {
        content: "",
        contentHTML: "",
        resizeTM: null,
        resizeTMTime: 100,
        roMode: false,
        toolbar: false,
        iconsPath: "",
        evs: ["focus", "blur", "keydown", "keyup", "keypress", "mouseup", "mousedown", "click"]
    };
    this._doOnFocusChanged = null;
    this._doOnAccess = null;
    if (typeof (g) == "object" && g != null && g.tagName == null) {
        h = g.skin;
        if (g.content != null) {
            this.conf.content = g.content
        }
        if (g.contentHTML != null) {
            this.conf.contentHTML = g.contentHTML
        }
        if (g.iconsPath != null) {
            this.conf.iconsPath = g.iconsPath
        }
        if (g.toolbar != null) {
            this.conf.toolbar = window.dhx4.s2b(g.toolbar)
        }
        if (g.onFocusChanged != null) {
            this._doOnFocusChanged = g.onFocusChanged
        }
        if (g.onAccess != null) {
            this._doOnAccess = g.onAccess
        }
        g = g.parent
    }
    this.conf.skin = (h || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxeditor") || "dhx_skyblue");
    if (typeof (g) == "string") {
        g = document.getElementById(g)
    }
    this.base = g;
    this.base.className += " dhxeditor_" + this.conf.skin;
    while (this.base.childNodes.length > 0) {
        this.base.removeChild(this.base.childNodes[0])
    }
    var j = (window.dhx4.isIE ? this.base.currentStyle.position : window.getComputedStyle(this.base, null).getPropertyValue("position"));
    if (!(j == "relative" || j == "absolute")) {
        this.base.style.position = "relative"
    }
    this.cell = new dhtmlXEditorCell(window.dhx4.newId(), this);
    this.base.appendChild(this.cell.cell);
    this.setSizes();
    this.cBlock = document.createElement("DIV");
    this.cBlock.className = "dhxcont_content_blocker";
    this.cBlock.style.display = "none";
    this.base.appendChild(this.cBlock);
    this.editor = document.createElement("IFRAME");
    this.editor.className = "dhxeditor_mainiframe";
    this.editor.frameBorder = 0;
    if (window.dhx4.isOpera) {
        this.editor.scrolling = "yes"
    }
    var a = this.editor;
    if (typeof (window.addEventListener) != "undefined") {
        a.onload = function () {
            for (var l = 0; l < c.conf.evs.length; l++) {
                a.contentWindow.addEventListener(c.conf.evs[l], c._ev, false)
            }
        }
    } else {
        a.onreadystatechange = function (l) {
            if (typeof (a.readyState) != "undefined" && a.readyState == "complete") {
                try {
                    for (var m = 0; m < c.conf.evs.length; m++) {
                        a.contentWindow.document.body.attachEvent("on" + c.conf.evs[m], c._ev)
                    }
                } catch (n) {}
            }
        }
    }
    this._ev = function (m) {
        m = m || event;
        var l = m.type;
        c.callEvent("onAccess", [l, m]);
        if (typeof (c._doOnAccess) == "function") {
            c._doOnAccess(l, m)
        } else {
            if (typeof (c._doOnAccess) == "string" && typeof (window[c._doOnAccess]) == "function") {
                window[c._doOnAccess](l, m)
            }
        }
    };
    this._focus = function () {
        if (window.dhx4.isIE) {
            this.editor.contentWindow.document.body.focus()
        } else {
            this.editor.contentWindow.focus()
        }
    };
    this.cell.attachObject(this.editor);
    this.edWin = this.editor.contentWindow;
    this.edDoc = this.edWin.document;
    this._prepareContent = function (n, q) {
        var m = "";
        if (n === true && this.getContent != null) {
            m = this.getContent()
        }
        var l = this.editor.contentWindow.document;
        l.open("text/html", "replace");
        if (window.dhx4.isOpera) {
            l.write("<html><head><style> html, body { overflow:auto;-webkit-overflow-scrolling: touch; padding:0px; padding-left:5px !important; height:100%; margin:0px; font-family:Tahoma; font-size:12px; background-color:#ffffff;} </style></head><body " + (q !== true ? "contenteditable='true'" : "") + " tabindex='0'></body></html>")
        } else {
            if (window.dhx4.isKHTML) {
                l.write("<html><head><style> html {overflow-x: auto;-webkit-overflow-scrolling: touch; overflow-y: auto;} body { overflow: auto; overflow-y: scroll;} html,body { padding:0px; padding-left:5px !important; height:100%; margin:0px; font-family:Tahoma; font-size:12px; background-color:#ffffff;} </style></head><body " + (q !== true ? "contenteditable='true'" : "") + " tabindex='0'></body></html>")
            } else {
                if (window.dhx4.isIE) {
                    l.write("<html><head><style> html {overflow-y: auto;} body {overflow-y: scroll;-webkit-overflow-scrolling: touch;} html,body { overflow-x: auto; padding:0px; padding-left:5px !important; height:100%; margin:0px; font-family:Tahoma; font-size:12px; background-color: #ffffff; outline: none;} </style></head><body " + (q !== true ? "contenteditable='true'" : "") + " tabindex='0'></body></html>")
                } else {
                    l.write("<html><head><style> html,body { overflow-x: auto; overflow-y:-webkit-overflow-scrolling: touch; scroll; padding:0px; padding-left:5px !important; height:100%; margin:0px; font-family:Tahoma; font-size:12px; background-color:#ffffff;} </style></head><body " + (q !== true ? "contenteditable='true'" : "") + " tabindex='0'></body></html>")
                }
            }
        }
        l.close();
        if (window.dhx4.isIE) {
            l.contentEditable = (q !== true)
        } else {
            l.designMode = (q !== true ? "On" : "Off")
        }
        if (window.dhx4.isFF) {
            try {
                l.execCommand("useCSS", false, true)
            } catch (o) {}
        }
        if (n === true && this.setContent != null) {
            this.setContent(m)
        }
    };
    this._prepareContent();
    this._doOnResize = function () {
        window.clearTimeout(c.conf.resizeTM);
        c.conf.resizeTM = window.setTimeout(function () {
            if (c.setSizes) {
                c.setSizes()
            }
        }, c.conf.resizeTMTime)
    };
    this._runCommand = function (n, q) {
        if (this.conf.roMode === true) {
            return
        }
        if (arguments.length < 2) {
            q = null
        }
        if (window.dhx4.isIE) {
            this.edWin.focus()
        }
        try {
            var m = this.editor.contentWindow.document;
            m.execCommand(n, false, q)
        } catch (o) {}
        if (window.dhx4.isIE) {
            this.edWin.focus();
            var l = this;
            window.setTimeout(function () {
                l.edWin.focus();
                l = null
            }, 1)
        }
    };
    this.applyBold = function () {
        this._runCommand("Bold")
    };
    this.applyItalic = function () {
        this._runCommand("Italic")
    };
    this.applyUnderscore = function () {
        this._runCommand("Underline")
    };
    this.clearFormatting = function () {
        this._runCommand("RemoveFormat")
    };
    this._doOnClick = function (n) {
        var m = n || window.event;
        var l = m.target || m.srcElement;
        c._showInfo(l)
    };
    this._doOnMouseDown = function (n) {
        var m = n || window.event;
        var l = m.target || m.srcElement;
        c._showInfo(l)
    };
    this._doOnKeyUp = function (o) {
        var n = o || window.event;
        var l = n.keyCode;
        var m = n.target || n.srcElement;
        if ({
            37: 1,
            38: 1,
            39: 1,
            40: 1,
            13: 1
        }[l] == 1) {
            c._showInfo(m)
        }
    };
    this._getParentByTag = function (l, n) {
        n = n.toLowerCase();
        var m = l;
        do {
            if (n == "" || m.nodeName.toLowerCase() == n) {
                return m
            }
        } while (m = m.parentNode);
        return l
    };
    this._isStyleProperty = function (m, q, l, o) {
        q = q.toLowerCase();
        var r = m;
        do {
            if ((r.nodeName.toLowerCase() == q) && (r.style[l] == o)) {
                return true
            }
        } while (r = r.parentNode);
        return false
    };
    this._setStyleProperty = function (l, o) {
        this.style[o] = false;
        var m = this._getParentByTag(l, o);
        if (m && (m.tagName.toLowerCase() == o)) {
            this.style[o] = true
        }
        if (o == "del" && this._getParentByTag(l, "strike") && this._getParentByTag(l, "strike").tagName.toLowerCase() == "strike") {
            this.style.del = true
        }
    };
    this._showInfo = function (m) {
        var m = (this._getSelectionBounds().end) ? this._getSelectionBounds().end : m;
        if (!m || !this._setStyleProperty) {
            return
        }
        try {
            if (this.edWin.getComputedStyle) {
                var l = this.edWin.getComputedStyle(m, null);
                var n = ((l.getPropertyValue("font-weight") == 401) ? 700 : l.getPropertyValue("font-weight"));
                this.style = {
                    fontStyle: l.getPropertyValue("font-style"),
                    fontSize: l.getPropertyValue("font-size"),
                    textDecoration: l.getPropertyValue("text-decoration"),
                    fontWeight: n,
                    fontFamily: l.getPropertyValue("font-family"),
                    textAlign: l.getPropertyValue("text-align")
                };
                if (window.dhx4.isKHTML) {
                    this.style.fontStyle = l.getPropertyValue("font-style");
                    this.style.vAlign = l.getPropertyValue("vertical-align");
                    this.style.del = this._isStyleProperty(m, "span", "textDecoration", "line-through");
                    this.style.u = this._isStyleProperty(m, "span", "textDecoration", "underline")
                }
            } else {
                var l = m.currentStyle;
                this.style = {
                    fontStyle: l.fontStyle,
                    fontSize: l.fontSize,
                    textDecoration: l.textDecoration,
                    fontWeight: l.fontWeight,
                    fontFamily: l.fontFamily,
                    textAlign: l.textAlign
                }
            }
            this._setStyleProperty(m, "h1");
            this._setStyleProperty(m, "h2");
            this._setStyleProperty(m, "h3");
            this._setStyleProperty(m, "h4");
            if (!window.dhx4.isKHTML) {
                this._setStyleProperty(m, "del");
                this._setStyleProperty(m, "sub");
                this._setStyleProperty(m, "sup");
                this._setStyleProperty(m, "u")
            }
            this.callEvent("onFocusChanged", [this.style, l])
        } catch (o) {
            return null
        }
    };
    this._getSelectionBounds = function () {
        var q, n, s, m;
        if (this.edWin.getSelection) {
            var r = this.edWin.getSelection();
            q = r.getRangeAt(r.rangeCount - 1);
            s = q.startContainer;
            m = q.endContainer;
            n = q.commonAncestorContainer;
            if (s.nodeName == "#text") {
                n = n.parentNode
            }
            if (s.nodeName == "#text") {
                s = s.parentNode
            }
            if (s.nodeName.toLowerCase() == "body") {
                s = s.firstChild
            }
            if (m.nodeName == "#text") {
                m = m.parentNode
            }
            if (m.nodeName.toLowerCase() == "body") {
                m = m.lastChild
            }
            if (s == m) {
                n = s
            }
            return {
                root: n,
                start: s,
                end: m
            }
        } else {
            if (this.edWin.document.selection) {
                q = this.edDoc.selection.createRange();
                if (!q.duplicate) {
                    return null
                }
                n = q.parentElement();
                var o = q.duplicate();
                var l = q.duplicate();
                o.collapse(true);
                l.moveToElementText(o.parentElement());
                l.setEndPoint("EndToStart", o);
                s = o.parentElement();
                o = q.duplicate();
                l = q.duplicate();
                l.collapse(false);
                o.moveToElementText(l.parentElement());
                o.setEndPoint("StartToEnd", l);
                m = l.parentElement();
                if (s.nodeName.toLowerCase() == "body") {
                    s = s.firstChild
                }
                if (m.nodeName.toLowerCase() == "body") {
                    m = m.lastChild
                }
                if (s == m) {
                    n = s
                }
                return {
                    root: n,
                    start: s,
                    end: m
                }
            }
        }
        return null
    };
    this.getContent = function () {
        if (!this.edDoc.body) {
            return ""
        } else {
            if (window.dhx4.isFF) {
                return this.editor.contentWindow.document.body.innerHTML.replace(/<\/{0,}br\/{0,}>\s{0,}$/gi, "")
            }
            if (window.dhx4.isIE && this.edDoc.body.innerText.length == 0) {
                return ""
            }
            return this.edDoc.body.innerHTML
        }
    };
    this.setContent = function (n) {
        n = n || "";
        if (this.edDoc.body) {
            var m = false;
            if (window.dhx4.isFF) {
                var l = navigator.userAgent.match(/Firefox\/(\d*)/);
                m = (l != null && l[1] < 28)
            }
            if (m) {
                if (typeof (this.conf.ffTest) == "undefined") {
                    this.editor.contentWindow.document.body.innerHTML = "";
                    this._runCommand("InsertHTML", "test");
                    this.conf.ffTest = (this.editor.contentWindow.document.body.innerHTML.length > 0)
                }
                if (this.conf.ffTest) {
                    this.editor.contentWindow.document.body.innerHTML = n
                } else {
                    this.editor.contentWindow.document.body.innerHTML = "";
                    if (n.length == 0) {
                        n = " "
                    }
                    this._runCommand("InsertHTML", n)
                }
            } else {
                this.editor.contentWindow.document.body.innerHTML = n
            }
            this.callEvent("onContentSet", [])
        } else {
            if (!this.conf.firstLoadEv) {
                this.conf.firstLoadEv = true;
                this.conf.firstLoadData = n;
                this._onFirstLoad = function () {
                    c.setContent(c.conf.firstLoadData);
                    if (typeof (window.addEventListener) == "function") {
                        c.edWin.removeEventListener("load", c._onFirstLoad, false)
                    } else {
                        c.edWin.detachEvent("onload", c._onFirstLoad)
                    }
                    c.conf.firstLoadData = null;
                    c.conf.firstLoadEv = false;
                    c._onFirstLoad = null
                };
                if (typeof (window.addEventListener) == "function") {
                    this.edWin.addEventListener("load", this._onFirstLoad, false)
                } else {
                    this.edWin.attachEvent("onload", this._onFirstLoad)
                }
            }
        }
    };
    this.setContentHTML = function (l) {
        window.dhx4.ajax.get(l, function (m) {
            if (m.xmlDoc.responseText != null) {
                c.setContent(m.xmlDoc.responseText)
            }
        })
    };
    window.dhx4._eventable(this);
    this.attachEvent("onFocusChanged", function (l) {
        if (typeof (this._doOnFocusChanged) == "function") {
            this._doOnFocusChanged(l)
        } else {
            if (typeof (this._doOnFocusChanged) == "string" && typeof (window[this._doOnFocusChanged]) == "function") {
                window[this._doOnFocusChanged](l)
            }
        }
    });
    if (typeof (window.addEventListener) == "function") {
        window.addEventListener("resize", this._doOnResize, false);
        this.edDoc.addEventListener("click", this._doOnClick, false);
        this.edDoc.addEventListener("keyup", this._doOnKeyUp, false);
        if (window.dhx4.isOpera) {
            this.edDoc.addEventListener("mousedown", this._doOnMouseDown, false)
        }
    } else {
        window.attachEvent("onresize", this._doOnResize);
        this.edDoc.attachEvent("onclick", this._doOnClick);
        this.edDoc.attachEvent("onkeyup", this._doOnKeyUp)
    }
    this.unload = function () {
        if (typeof (window.addEventListener) == "function") {
            window.removeEventListener("resize", this._doOnResize, false);
            this.edDoc.removeEventListener("click", this._doOnClick, false);
            this.edDoc.removeEventListener("keyup", this._doOnKeyUp, false);
            if (window.dhx4.isOpera) {
                this.edDoc.removeEventListener("mousedown", this._doOnMouseDown, false)
            }
            for (var l = 0; l < c.conf.evs.length; l++) {
                a.contentWindow.removeEventListener(c.conf.evs[l], c._ev, false)
            }
        } else {
            window.detachEvent("onresize", this._doOnResize, false);
            this.edDoc.detachEvent("onclick", this._doOnClick);
            this.edDoc.detachEvent("onkeyup", this._doOnKeyUp);
            for (var l = 0; l < c.conf.evs.length; l++) {
                a.contentWindow.document.body.detachEvent("on" + c.conf.evs[l], c._ev)
            }
        }
        this._doOnAccess = null;
        this._doOnFocusChanged = null;
        if (typeof (window.addEventListener) == "function") {
            this.editor.onload = null
        } else {
            this.editor.onreadystatechange = null
        }
        this.editor.parentNode.removeChild(this.editor);
        this.editor = null;
        this.edDoc = null;
        this.edWin = null;
        this.cell._unload();
        this.cell = null;
        this.tb = null;
        window.dhx4._eventable(this, "clear");
        this.cBlock.parentNode.removeChild(this.cBlock);
        this.cBlock = null;
        this.base.className = String(this.base.className).replace(new RegExp("\\s{0,}dhxeditor_" + this.conf.skin), "");
        while (this.base.childNodes.length > 0) {
            this.base.removeChild(this.base.childNodes[0])
        }
        this.base = null;
        this._doOnClick = null;
        this._doOnKeyUp = null;
        this._doOnMouseDown = null;
        this._ev = null;
        this._focus = null;
        this._prepareContent = null;
        this._doOnResize = null;
        this.setIconsPath = null;
        this.init = null;
        this.setSizes = null;
        this._runCommand = null;
        this.applyBold = null;
        this.applyItalic = null;
        this.applyUnderscore = null;
        this.clearFormatting = null;
        this._showInfo = null;
        this._getSelectionBounds = null;
        this.getContent = null;
        this.setContent = null;
        this.setContentHTML = null;
        this.setReadonly = null;
        this.isReadonly = null;
        this.unload = null;
        c = a = null
    };
    if (this.conf.toolbar == true && typeof (this.attachToolbar) == "function" && typeof (window.dhtmlXToolbarObject) == "function") {
        this.attachToolbar(this.conf.iconsPath)
    }
    this.setIconsPath = function (l) {
        this.conf.iconsPath = l
    };
    if (this.conf.content.length > 0) {
        this.setContent(this.conf.content);
        this.conf.content = ""
    } else {
        if (this.conf.contentHTML.length > 0) {
            this.setContentHTML(this.conf.contentHTML);
            this.conf.contentHTML = ""
        }
    }
    return this
}
dhtmlXEditor.prototype.setSizes = function () {
    this.cell._setSize(0, 0, this.base.clientWidth, this.base.clientHeight)
};
dhtmlXEditor.prototype.setReadonly = function (a) {
    this.conf.roMode = (a === true);
    this._prepareContent(true, this.conf.roMode);
    this.cBlock.style.display = (this.conf.roMode ? "" : "none")
};
dhtmlXEditor.prototype.isReadonly = function (a) {
    return (this.conf.roMode || false)
};
dhtmlXEditor.prototype.setSkin = function (a) {
    this.base.className = String(this.base.className).replace(new RegExp("dhxeditor_" + this.conf.skin), "dhxeditor_" + a);
    this.conf.skin = this.cell.conf.skin = a;
    if (this.tb) {
        this.cell.detachToolbar(a);
        this.tb = null;
        this.attachToolbar()
    }
    this.setSizes()
};
window.dhtmlXEditorCell = function (g, a) {
    dhtmlXCellObject.apply(this, [g, "_editor"]);
    var c = this;
    this.editor = a;
    this.conf.skin = this.editor.conf.skin;
    this.attachEvent("_onCellUnload", function () {
        this._stbUnload();
        this.editor = null;
        c = null
    });
    this._stbInit();
    return this
};
dhtmlXEditorCell.prototype = new dhtmlXCellObject();
dhtmlXEditorCell.prototype._stbInit = function () {
    var l = this;
    var j = document.createElement("DIV");
    j.className = "dhx_cell_stb";
    this.cell.insertBefore(j, this.cell.childNodes[this.conf.idx.cont]);
    j.onselectstart = function (a) {
        a = a || event;
        a.cancelBubble = true;
        if (a.preventDefault) {
            a.preventDefault()
        } else {
            a.returnValue = false
        }
        return false
    };
    var h = {
        bold: "applyBold",
        italic: "applyItalic",
        underline: "applyUnderscore",
        clearformat: "clearFormatting"
    };
    for (var g in h) {
        var c = document.createElement("A");
        c.href = "javascript:void(0);";
        c.tabIndex = -1;
        j.appendChild(c);
        c.onmousedown = c.onclick = function (a) {
            a = a || event;
            if (a.preventDefault) {
                a.preventDefault()
            } else {
                a.returnValue = false
            }
            return false
        };
        var m = document.createElement("DIV");
        m.className = "dhx_cell_stb_button btn_" + g;
        m._actv = g.charAt(0);
        m._cmd = h[g];
        c.appendChild(m);
        m.onclick = function (a) {
            a = a || event;
            if (a.preventDefault) {
                a.preventDefault()
            } else {
                a.returnValue = false
            }
            return false
        };
        m.onmousedown = function (a) {
            a = a || event;
            if (a.preventDefault) {
                a.preventDefault()
            } else {
                a.returnValue = false
            }
            l.editor[this._cmd]();
            l.editor.callEvent("onToolbarClick", [this._actv])
        };
        m = c = null
    }
    j = null;
    this._stbUnload = function () {
        var a = this.cell.childNodes[this.conf.idx.stb];
        a.onselectstart = null;
        while (a.childNodes.length > 0) {
            a.lastChild.onmousedown = a.lastChild.onclick = null;
            a.lastChild.firstChild.onmousedown = a.lastChild.firstChild.onclick = null;
            a.lastChild.firstChild._actv = a.lastChild.firstChild._cmd = null;
            a.lastChild.removeChild(a.lastChild.firstChild);
            a.removeChild(a.lastChild)
        }
        a.parentNode.removeChild(a);
        a = l = null;
        this.conf.idx_data.stb = this.conf.ofs_nodes.t._getStbHeight = null;
        delete this.conf.ofs_nodes.t._getStbHeight;
        delete this.conf.idx_data.stb;
        this._updateIdx()
    };
    this.conf.ofs_nodes.t._getStbHeight = "func";
    this.conf.idx_data.stb = "dhx_cell_stb";
    this._updateIdx()
};
dhtmlXEditorCell.prototype._stbHide = function () {
    this.cell.childNodes[this.conf.idx.stb].style.display = "none"
};
dhtmlXEditorCell.prototype._getStbHeight = function () {
    return this.cell.childNodes[this.conf.idx.stb].offsetHeight
};
dhtmlXEditor.prototype.attachToolbar = function (c) {
    if (this.tb != null) {
        return
    }
    if (c != null) {
        this.conf.iconsPath = c
    }
    this.cell._stbHide();
    this.tb = this.cell.attachToolbar({
        icons_path: this.conf.iconsPath + "/dhxeditor_" + String(this.conf.skin).replace(/^dhx_/, "") + "/",
        skin: this.conf.skin
    });
    this.setSizes();
    this._availFonts = new Array("Arial", "Arial Narrow", "Comic Sans MS", "Courier", "Georgia", "Impact", "Tahoma", "Times New Roman", "Verdana");
    this._initFont = this._availFonts[0];
    this._xmlFonts = "";
    for (var l = 0; l < this._availFonts.length; l++) {
        var h = String(this._availFonts[l]).replace(/\s/g, "_");
        this._xmlFonts += '<item type="button" id="applyFontFamily:' + h + '"><itemText><![CDATA[<img src="' + this.tb.imagePath + "font_" + String(h).toLowerCase() + '.gif" border="0" style="/*margin-top:1px;margin-bottom:1px;*/width:110px;height:16px;">]]></itemText></item>'
    }
    this._availSizes = {
        "1": "8pt",
        "2": "10pt",
        "3": "12pt",
        "4": "14pt",
        "5": "18pt",
        "6": "24pt",
        "7": "36pt"
    };
    this._xmlSizes = "";
    for (var g in this._availSizes) {
        this._xmlSizes += '<item type="button" id="applyFontSize:' + g + ":" + this._availSizes[g] + '" text="' + this._availSizes[g] + '"/>'
    }
    this.tbXML = '<toolbar><item id="applyH1" type="buttonTwoState" img="h1.gif" imgdis="h4_dis.gif" title="H1"/><item id="applyH2" type="buttonTwoState" img="h2.gif" imgdis="h4_dis.gif" title="H2"/><item id="applyH3" type="buttonTwoState" img="h3.gif" imgdis="h4_dis.gif" title="H3"/><item id="applyH4" type="buttonTwoState" img="h4.gif" imgdis="h4_dis.gif" title="H4"/><item id="separ01" type="separator"/><item id="applyBold" type="buttonTwoState" img="bold.gif" imgdis="bold_dis.gif" title="Bold Text"/><item id="applyItalic" type="buttonTwoState" img="italic.gif" imgdis="italic_dis.gif" title="Italic Text"/><item id="applyUnderscore" type="buttonTwoState" img="underline.gif" imgdis="underline_dis.gif" title="Underscore Text"/><item id="applyStrikethrough" type="buttonTwoState" img="strike.gif" imgdis="strike_dis.gif" title="Strikethrough Text"/><item id="separ02" type="separator"/><item id="alignLeft" type="buttonTwoState" img="align_left.gif" imgdis="align_left_dis.gif" title="Left Alignment"/><item id="alignCenter" type="buttonTwoState" img="align_center.gif" imgdis="align_center_dis.gif" title="Center Alignment"/><item id="alignRight" type="buttonTwoState" img="align_right.gif" imgdis="align_right_dis.gif" title="Right Alignment"/><item id="alignJustify" type="buttonTwoState" img="align_justify.gif" title="Justified Alignment"/><item id="separ03" type="separator"/><item id="applySub" type="buttonTwoState" img="script_sub.gif" imgdis="script_sub.gif" title="Subscript"/><item id="applySuper" type="buttonTwoState" img="script_super.gif" imgdis="script_super_dis.gif" title="Superscript"/><item id="separ04" type="separator"/><item id="createNumList" type="button" img="list_number.gif" imgdis="list_number_dis.gif" title="Number List"/><item id="createBulList" type="button" img="list_bullet.gif" imgdis="list_bullet_dis.gif" title="Bullet List"/><item id="separ05" type="separator"/><item id="increaseIndent" type="button" img="indent_inc.gif" imgdis="indent_inc_dis.gif" title="Increase Indent"/><item id="decreaseIndent" type="button" img="indent_dec.gif" imgdis="indent_dec_dis.gif" title="Decrease Indent"/><item id="separ06" type="separator"/><item id="clearFormatting" type="button" img="clear.gif" title="Clear Formatting"/></toolbar>';
    this.tb.loadStruct(this.tbXML);
    this._checkAlign = function (a) {
        this.tb.setItemState("alignCenter", false);
        this.tb.setItemState("alignRight", false);
        this.tb.setItemState("alignJustify", false);
        this.tb.setItemState("alignLeft", false);
        if (a) {
            this.tb.setItemState(a, true)
        }
    };
    this._checkH = function (a) {
        this.tb.setItemState("applyH1", false);
        this.tb.setItemState("applyH2", false);
        this.tb.setItemState("applyH3", false);
        this.tb.setItemState("applyH4", false);
        if (a) {
            this.tb.setItemState(a, true)
        }
    };
    this._doOnFocusChanged = function (n) {
        if (!n.h1 && !n.h2 && !n.h3 && !n.h4) {
            var a = (String(n.fontWeight).search(/bold/i) != -1) || (Number(n.fontWeight) >= 700);
            this.tb.setItemState("applyBold", a)
        } else {
            this.tb.setItemState("applyBold", false)
        }
        var m = "alignLeft";
        if (String(n.textAlign).search(/center/) != -1) {
            m = "alignCenter"
        }
        if (String(n.textAlign).search(/right/) != -1) {
            m = "alignRight"
        }
        if (String(n.textAlign).search(/justify/) != -1) {
            m = "alignJustify"
        }
        this.tb.setItemState(m, true);
        this._checkAlign(m);
        this.tb.setItemState("applyH1", n.h1);
        this.tb.setItemState("applyH2", n.h2);
        this.tb.setItemState("applyH3", n.h3);
        this.tb.setItemState("applyH4", n.h4);
        if (window._KHTMLrv) {
            n.sub = (n.vAlign == "sub");
            n.sup = (n.vAlign == "super")
        }
        this.tb.setItemState("applyItalic", (n.fontStyle == "italic"));
        this.tb.setItemState("applyStrikethrough", n.del);
        this.tb.setItemState("applySub", n.sub);
        this.tb.setItemState("applySuper", n.sup);
        this.tb.setItemState("applyUnderscore", n.u)
    };
    this._doOnToolbarClick = function (m) {
        var a = String(m).split(":");
        if (this[a[0]] != null) {
            if (typeof (this[a[0]]) == "function") {
                this[a[0]](a[1]);
                this.callEvent("onToolbarClick", [m])
            }
        }
    };
    this._doOnStateChange = function (m, a) {
        this[m]();
        switch (m) {
        case "alignLeft":
        case "alignCenter":
        case "alignRight":
        case "alignJustify":
            this._checkAlign(m);
            break;
        case "applyH1":
        case "applyH2":
        case "applyH3":
        case "applyH4":
            this._checkH(m);
            break
        }
        this.callEvent("onToolbarClick", [m])
    };
    this._doOnBeforeStateChange = function (m, a) {
        if ((m == "alignLeft" || m == "alignCenter" || m == "alignRight" || m == "alignJustify") && a == true) {
            return false
        }
        return true
    };
    var j = this;
    this.tb.attachEvent("onClick", function (a) {
        j._doOnToolbarClick(a)
    });
    this.tb.attachEvent("onStateChange", function (m, a) {
        j._doOnStateChange(m, a)
    });
    this.tb.attachEvent("onBeforeStateChange", function (m, a) {
        return j._doOnBeforeStateChange(m, a)
    });
    this.applyBold = function () {
        this._runCommand("Bold")
    };
    this.applyItalic = function () {
        this._runCommand("Italic")
    };
    this.applyUnderscore = function () {
        this._runCommand("Underline")
    };
    this.applyStrikethrough = function () {
        this._runCommand("StrikeThrough")
    };
    this.alignLeft = function () {
        this._runCommand("JustifyLeft")
    };
    this.alignRight = function () {
        this._runCommand("JustifyRight")
    };
    this.alignCenter = function () {
        this._runCommand("JustifyCenter")
    };
    this.alignJustify = function () {
        this._runCommand("JustifyFull")
    };
    this.applySub = function () {
        this._runCommand("Subscript")
    };
    this.applySuper = function () {
        this._runCommand("Superscript")
    };
    this.applyH1 = function () {
        this._runCommand("FormatBlock", "<H1>")
    };
    this.applyH2 = function () {
        this._runCommand("FormatBlock", "<H2>")
    };
    this.applyH3 = function () {
        this._runCommand("FormatBlock", "<H3>")
    };
    this.applyH4 = function () {
        this._runCommand("FormatBlock", "<H4>")
    };
    this.createNumList = function () {
        this._runCommand("InsertOrderedList")
    };
    this.createBulList = function () {
        this._runCommand("InsertUnorderedList")
    };
    this.increaseIndent = function () {
        this._runCommand("Indent")
    };
    this.decreaseIndent = function () {
        this._runCommand("Outdent")
    };
    this.clearFormatting = function () {
        this._runCommand("RemoveFormat");
        this.tb.setItemState("applyBold", false);
        this.tb.setItemState("applyItalic", false);
        this.tb.setItemState("applyStrikethrough", false);
        this.tb.setItemState("applySub", false);
        this.tb.setItemState("applySuper", false);
        this.tb.setItemState("applyUnderscore", false)
    }
};
dhtmlx.Group = {
    _init: function () {
        dhtmlx.assert(this.data, "DataStore required for grouping");
        this.data.attachEvent("onStoreLoad", dhtmlx.bind(function () {
            if (this._settings.group) {
                this.group(this._settings.group, false)
            }
        }, this));
        this.attachEvent("onBeforeRender", dhtmlx.bind(function (a) {
            if (this._settings.sort) {
                a.block();
                a.sort(this._settings.sort);
                a.unblock()
            }
        }, this));
        this.attachEvent("onBeforeSort", dhtmlx.bind(function () {
            this._settings.sort = null
        }, this))
    },
    _init_group_data_event: function (c, a) {
        c.attachEvent("onClearAll", dhtmlx.bind(function () {
            this.ungroup(false);
            this.block();
            this.clearAll();
            this.unblock()
        }, a))
    },
    sum: function (c, a) {
        c = dhtmlx.Template.setter(c);
        a = a || this.data;
        var g = 0;
        a.each(function (h) {
            g += c(h) * 1
        });
        return g
    },
    min: function (g, c) {
        g = dhtmlx.Template.setter(g);
        c = c || this.data;
        var a = Infinity;
        c.each(function (h) {
            if (g(h) * 1 < a) {
                a = g(h) * 1
            }
        });
        return a * 1
    },
    max: function (g, c) {
        g = dhtmlx.Template.setter(g);
        c = c || this.data;
        var a = -Infinity;
        c.each(function (h) {
            if (g(h) * 1 > a) {
                a = g(h) * 1
            }
        });
        return a
    },
    _split_data_by: function (j) {
        var l = function (q, o) {
                q = dhtmlx.Template.setter(q);
                return q(o[0])
            };
        var h = dhtmlx.Template.setter(j.by);
        if (!j.map[h]) {
            j.map[h] = [h, l]
        }
        var a = {};
        var n = [];
        this.data.each(function (o) {
            var q = h(o);
            if (!a[q]) {
                n.push({
                    id: q
                });
                a[q] = dhtmlx.toArray()
            }
            a[q].push(o)
        });
        for (var m in j.map) {
            var c = (j.map[m][1] || l);
            if (typeof c != "function") {
                c = this[c]
            }
            for (var g = 0; g < n.length; g++) {
                n[g][m] = c.call(this, j.map[m][0], a[n[g].id])
            }
        }
        this._not_grouped_data = this.data;
        this.data = new dhtmlx.DataStore();
        this.data.provideApi(this, true);
        this._init_group_data_event(this.data, this);
        this.parse(n, "json")
    },
    group: function (a, c) {
        this.ungroup(false);
        this._split_data_by(a);
        if (c !== false) {
            this.render()
        }
    },
    ungroup: function (a) {
        if (this._not_grouped_data) {
            this.data = this._not_grouped_data;
            this.data.provideApi(this, true)
        }
        if (a !== false) {
            this.render()
        }
    },
    group_setter: function (a) {
        dhtmlx.assert(typeof a == "object", "Incorrect group value");
        dhtmlx.assert(a.by, "group.by is mandatory");
        dhtmlx.assert(a.map, "group.map is mandatory");
        return a
    },
    sort_setter: function (a) {
        if (typeof a != "object") {
            a = {
                by: a
            }
        }
        this._mergeSettings(a, {
            as: "string",
            dir: "asc"
        });
        return a
    }
};
dhtmlx.Date = {
    Locale: {
        month_full: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
        month_short: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
        day_full: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
        day_short: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]
    },
    date_part: function (a) {
        a.setHours(0);
        a.setMinutes(0);
        a.setSeconds(0);
        a.setMilliseconds(0);
        return a
    },
    time_part: function (a) {
        return (a.valueOf() / 1000 - a.getTimezoneOffset() * 60) % 86400
    },
    week_start: function (c) {
        var a = c.getDay();
        if (this.config.start_on_monday) {
            if (a === 0) {
                a = 6
            } else {
                a--
            }
        }
        return this.date_part(this.add(c, -1 * a, "day"))
    },
    month_start: function (a) {
        a.setDate(1);
        return this.date_part(a)
    },
    year_start: function (a) {
        a.setMonth(0);
        return this.month_start(a)
    },
    day_start: function (a) {
        return this.date_part(a)
    },
    add: function (c, g, h) {
        var a = new Date(c.valueOf());
        switch (h) {
        case "day":
            a.setDate(a.getDate() + g);
            break;
        case "week":
            a.setDate(a.getDate() + 7 * g);
            break;
        case "month":
            a.setMonth(a.getMonth() + g);
            break;
        case "year":
            a.setYear(a.getFullYear() + g);
            break;
        case "hour":
            a.setHours(a.getHours() + g);
            break;
        case "minute":
            a.setMinutes(a.getMinutes() + g);
            break;
        default:
            return dhtmlx.Date["add_" + h](c, g, h)
        }
        return a
    },
    to_fixed: function (a) {
        if (a < 10) {
            return "0" + a
        }
        return a
    },
    copy: function (a) {
        return new Date(a.valueOf())
    },
    date_to_str: function (c, a) {
        c = c.replace(/%[a-zA-Z]/g, function (g) {
            switch (g) {
            case "%d":
                return '"+dhtmlx.Date.to_fixed(date.getDate())+"';
            case "%m":
                return '"+dhtmlx.Date.to_fixed((date.getMonth()+1))+"';
            case "%j":
                return '"+date.getDate()+"';
            case "%n":
                return '"+(date.getMonth()+1)+"';
            case "%y":
                return '"+dhtmlx.Date.to_fixed(date.getFullYear()%100)+"';
            case "%Y":
                return '"+date.getFullYear()+"';
            case "%D":
                return '"+dhtmlx.Date.Locale.day_short[date.getDay()]+"';
            case "%l":
                return '"+dhtmlx.Date.Locale.day_full[date.getDay()]+"';
            case "%M":
                return '"+dhtmlx.Date.Locale.month_short[date.getMonth()]+"';
            case "%F":
                return '"+dhtmlx.Date.Locale.month_full[date.getMonth()]+"';
            case "%h":
                return '"+dhtmlx.Date.to_fixed((date.getHours()+11)%12+1)+"';
            case "%g":
                return '"+((date.getHours()+11)%12+1)+"';
            case "%G":
                return '"+date.getHours()+"';
            case "%H":
                return '"+dhtmlx.Date.to_fixed(date.getHours())+"';
            case "%i":
                return '"+dhtmlx.Date.to_fixed(date.getMinutes())+"';
            case "%a":
                return '"+(date.getHours()>11?"pm":"am")+"';
            case "%A":
                return '"+(date.getHours()>11?"PM":"AM")+"';
            case "%s":
                return '"+dhtmlx.Date.to_fixed(date.getSeconds())+"';
            case "%W":
                return '"+dhtmlx.Date.to_fixed(dhtmlx.Date.getISOWeek(date))+"';
            default:
                return g
            }
        });
        if (a) {
            c = c.replace(/date\.get/g, "date.getUTC")
        }
        return new Function("date", 'return "' + c + '";')
    },
    str_to_date: function (j, g) {
        var l = "var temp=date.split(/[^0-9a-zA-Z]+/g);";
        var a = j.match(/%[a-zA-Z]/g);
        for (var c = 0; c < a.length; c++) {
            switch (a[c]) {
            case "%j":
            case "%d":
                l += "set[2]=temp[" + c + "]||1;";
                break;
            case "%n":
            case "%m":
                l += "set[1]=(temp[" + c + "]||1)-1;";
                break;
            case "%y":
                l += "set[0]=temp[" + c + "]*1+(temp[" + c + "]>50?1900:2000);";
                break;
            case "%g":
            case "%G":
            case "%h":
            case "%H":
                l += "set[3]=temp[" + c + "]||0;";
                break;
            case "%i":
                l += "set[4]=temp[" + c + "]||0;";
                break;
            case "%Y":
                l += "set[0]=temp[" + c + "]||0;";
                break;
            case "%a":
            case "%A":
                l += "set[3]=set[3]%12+((temp[" + c + "]||'').toLowerCase()=='am'?0:12);";
                break;
            case "%s":
                l += "set[5]=temp[" + c + "]||0;";
                break
            }
        }
        var h = "set[0],set[1],set[2],set[3],set[4],set[5]";
        if (g) {
            h = " Date.UTC(" + h + ")"
        }
        return new Function("date", "var set=[0,0,1,0,0,0]; " + l + " return new Date(" + h + ");")
    },
    getISOWeek: function (g) {
        if (!g) {
            return false
        }
        var c = g.getDay();
        if (c === 0) {
            c = 7
        }
        var h = new Date(g.valueOf());
        h.setDate(g.getDate() + (4 - c));
        var a = h.getFullYear();
        var l = Math.floor((h.getTime() - new Date(a, 0, 1).getTime()) / 86400000);
        var j = 1 + Math.floor(l / 7);
        return j
    },
    getUTCISOWeek: function (a) {
        return this.getISOWeek(a)
    }
};
dhtmlx.math = {};
dhtmlx.math._toHex = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F"];
dhtmlx.math.toHex = function (c, a) {
    c = parseInt(c, 10);
    str = "";
    while (c > 0) {
        str = this._toHex[c % 16] + str;
        c = Math.floor(c / 16)
    }
    while (str.length < a) {
        str = "0" + str
    }
    return str
};
dhtmlx.math.hexToDec = function (a) {
    return parseInt(a, 16)
};
dhtmlx.math.toRgb = function (c) {
    var j, h, a, l;
    if (typeof (c) != "string") {
        j = c[0];
        h = c[1];
        a = c[2]
    } else {
        if (c.indexOf("rgb") != -1) {
            l = c.substr(c.indexOf("(") + 1, c.lastIndexOf(")") - c.indexOf("(") - 1).split(",");
            j = l[0];
            h = l[1];
            a = l[2]
        } else {
            if (c.substr(0, 1) == "#") {
                c = c.substr(1)
            }
            j = this.hexToDec(c.substr(0, 2));
            h = this.hexToDec(c.substr(2, 2));
            a = this.hexToDec(c.substr(4, 2))
        }
    }
    j = (parseInt(j, 10) || 0);
    h = (parseInt(h, 10) || 0);
    a = (parseInt(a, 10) || 0);
    if (j < 0 || j > 255) {
        j = 0
    }
    if (h < 0 || h > 255) {
        h = 0
    }
    if (a < 0 || a > 255) {
        a = 0
    }
    return [j, h, a]
};
dhtmlx.math.hsvToRgb = function (m, y, w) {
    var l, o, j, c, x, a, n, u;
    l = Math.floor((m / 60)) % 6;
    o = m / 60 - l;
    j = w * (1 - y);
    c = w * (1 - o * y);
    x = w * (1 - (1 - o) * y);
    a = 0;
    n = 0;
    u = 0;
    switch (l) {
    case 0:
        a = w;
        n = x;
        u = j;
        break;
    case 1:
        a = c;
        n = w;
        u = j;
        break;
    case 2:
        a = j;
        n = w;
        u = x;
        break;
    case 3:
        a = j;
        n = c;
        u = w;
        break;
    case 4:
        a = x;
        n = j;
        u = w;
        break;
    case 5:
        a = w;
        n = j;
        u = c;
        break
    }
    a = Math.floor(a * 255);
    n = Math.floor(n * 255);
    u = Math.floor(u * 255);
    return [a, n, u]
};
dhtmlx.math.rgbToHsv = function (c, n, o) {
    var l, j, q, a, u, x, m, w;
    l = c / 255;
    j = n / 255;
    q = o / 255;
    var a = Math.min(l, j, q);
    var u = Math.max(l, j, q);
    m = 0;
    x = u == 0 ? 0 : (1 - a / u);
    w = u;
    if (u == a) {
        m = 0
    } else {
        if (u == l && j >= q) {
            m = 60 * (j - q) / (u - a) + 0
        } else {
            if (u == l && j < q) {
                m = 60 * (j - q) / (u - a) + 360
            } else {
                if (u == j) {
                    m = 60 * (q - l) / (u - a) + 120
                } else {
                    if (u == q) {
                        m = 60 * (l - j) / (u - a) + 240
                    }
                }
            }
        }
    }
    return [m, x, w]
};
if (!dhtmlx.presets) {
    dhtmlx.presets = {}
}
dhtmlx.presets.chart = {
    simple: {
        item: {
            borderColor: "#ffffff",
            color: "#2b7100",
            shadow: false,
            borderWidth: 2
        },
        line: {
            color: "#8ecf03",
            width: 2
        }
    },
    plot: {
        color: "#1293f8",
        item: {
            borderColor: "#636363",
            borderWidth: 1,
            color: "#ffffff",
            type: "r",
            shadow: false
        },
        line: {
            color: "#1293f8",
            width: 2
        }
    },
    diamond: {
        color: "#b64040",
        item: {
            borderColor: "#b64040",
            color: "#b64040",
            type: "d",
            radius: 3,
            shadow: true
        },
        line: {
            color: "#ff9000",
            width: 2
        }
    },
    point: {
        color: "#fe5916",
        disableLines: true,
        fill: false,
        disableItems: false,
        item: {
            color: "#feb916",
            borderColor: "#fe5916",
            radius: 2,
            borderWidth: 1,
            type: "r"
        },
        alpha: 1
    },
    line: {
        line: {
            color: "#3399ff",
            width: 2
        },
        item: {
            color: "#ffffff",
            borderColor: "#3399ff",
            radius: 2,
            borderWidth: 2,
            type: "d"
        },
        fill: false,
        disableItems: false,
        disableLines: false,
        alpha: 1
    },
    area: {
        fill: "#3399ff",
        line: {
            color: "#3399ff",
            width: 1
        },
        disableItems: true,
        alpha: 0.2,
        disableLines: false
    },
    round: {
        item: {
            radius: 3,
            borderColor: "#3f83ff",
            borderWidth: 1,
            color: "#3f83ff",
            type: "r",
            shadow: false,
            alpha: 0.6
        }
    },
    square: {
        item: {
            radius: 3,
            borderColor: "#447900",
            borderWidth: 2,
            color: "#69ba00",
            type: "s",
            shadow: false,
            alpha: 1
        }
    },
    column: {
        color: "RAINBOW",
        gradient: false,
        width: 45,
        radius: 0,
        alpha: 1,
        border: true
    },
    stick: {
        width: 5,
        gradient: false,
        color: "#67b5c9",
        radius: 2,
        alpha: 1,
        border: false
    },
    alpha: {
        color: "#b9a8f9",
        width: 70,
        gradient: "falling",
        radius: 0,
        alpha: 0.5,
        border: true
    }
};
dhtmlx.ui.Map = function (a) {
    this.name = "Map";
    this._id = "map_" + dhtmlx.uid();
    this._key = a;
    this._map = []
};
dhtmlx.ui.Map.prototype = {
    addRect: function (g, c, a) {
        this._createMapArea(g, "RECT", c, a)
    },
    addPoly: function (g, c, a) {
        this._createMapArea(g, "POLY", c, a)
    },
    _createMapArea: function (j, c, h, g) {
        var a = "";
        if (arguments.length == 4) {
            a = "userdata='" + g + "'"
        }
        this._map.push("<area " + this._key + "='" + j + "' shape='" + c + "' coords='" + h.join() + "' " + a + "></area>")
    },
    addSector: function (a, q, o, m, j, g, h, l) {
        var n = [];
        n.push(m);
        n.push(Math.floor(j * h));
        for (var c = q; c < o; c += Math.PI / 18) {
            n.push(Math.floor(m + g * Math.cos(c)));
            n.push(Math.floor((j + g * Math.sin(c)) * h))
        }
        n.push(Math.floor(m + g * Math.cos(o)));
        n.push(Math.floor((j + g * Math.sin(o)) * h));
        n.push(m);
        n.push(Math.floor(j * h));
        return this.addPoly(a, n, l)
    },
    render: function (a) {
        var g = dhtmlx.html.create("DIV");
        g.style.cssText = "position:absolute; width:100%; height:100%; top:0px; left:0px;";
        a.appendChild(g);
        var c = dhtmlx._isIE ? "" : "src='data:image/gif;base64,R0lGODlhEgASAIAAAP///////yH5BAUUAAEALAAAAAASABIAAAIPjI+py+0Po5y02ouz3pwXADs='";
        g.innerHTML = "<map id='" + this._id + "' name='" + this._id + "'>" + this._map.join("\n") + "</map><img " + c + " class='dhx_map_img' usemap='#" + this._id + "'>";
        a._htmlmap = g;
        this._map = []
    }
};
dhtmlx.chart = {};
dhtmlx.chart.scatter = {
    pvt_render_scatter: function (q, l, o, n, m, a) {
        if (!this._settings.xValue) {
            return dhtmlx.log("warning", "Undefined propery: xValue")
        }
        var g = this._getLimits();
        var j = this._getLimits("h", "xValue");
        if (!m) {
            if (!this.canvases.x) {
                this.canvases.x = new dhtmlx.ui.Canvas(this._obj, "axis_x")
            }
            if (!this.canvases.y) {
                this.canvases.y = new dhtmlx.ui.Canvas(this._obj, "axis_y")
            }
            this._drawYAxis(this.canvases.y.getCanvas(), l, o, n, g.min, g.max);
            this._drawHXAxis(this.canvases.x.getCanvas(), l, o, n, j.min, j.max)
        }
        g = {
            min: this._settings.yAxis.start,
            max: this._settings.yAxis.end
        };
        j = {
            min: this._settings.xAxis.start,
            max: this._settings.xAxis.end
        };
        var c = this._getScatterParams(q, l, o, n, j, g);
        this._mapStart = o;
        for (var h = 0; h < l.length; h++) {
            this._drawScatterItem(q, a, o, n, c, j, g, l[h], m)
        }
    },
    _getScatterParams: function (a, h, g, c, m, l) {
        var j = {};
        j.totalHeight = c.y - g.y;
        j.totalWidth = c.x - g.x;
        this._calcScatterUnit(j, m.min, m.max, j.totalWidth, "X");
        this._calcScatterUnit(j, l.min, l.max, j.totalHeight, "Y");
        return j
    },
    _drawScatterItem: function (r, a, o, n, g, j, h, l, m) {
        var c = this._calculateScatterItemPosition(g, n, o, j, l, "X");
        var q = this._calculateScatterItemPosition(g, o, n, h, l, "Y");
        this._drawItem(r, c, q, l, this._settings.label.call(this, l), m, a)
    },
    _calculateScatterItemPosition: function (g, n, m, a, j, c) {
        var q = this._settings[c == "X" ? "xValue" : "value"].call(this, j);
        var h = g["valueFactor" + c];
        var r = (parseFloat(q || 0) - a.min) * h;
        var o = g["unit" + c];
        var l = m[c.toLowerCase()] - (c == "X" ? (-1) : 1) * Math.floor(o * r);
        if (r < 0) {
            l = m[c.toLowerCase()]
        }
        if (q > a.max) {
            l = n[c.toLowerCase()]
        }
        if (q < a.min) {
            l = m[c.toLowerCase()]
        }
        return l
    },
    _calcScatterUnit: function (l, g, a, c, h) {
        var j = this._getRelativeValue(g, a);
        h = (h || "");
        l["relValue" + h] = j[0];
        l["valueFactor" + h] = j[1];
        l["unit" + h] = (l["relValue" + h] ? c / l["relValue" + h] : 10)
    }
};
dhtmlx.chart.radar = {
    pvt_render_radar: function (c, h, a, l, g, j) {
        this._renderRadarChart(c, h, a, l, g, j)
    },
    _renderRadarChart: function (u, j, r, q, o, a) {
        if (!j.length) {
            return
        }
        var m = this._getPieParameters(r, q);
        var n = (this._settings.radius ? this._settings.radius : m.radius);
        var c = (this._settings.x ? this._settings.x : m.x);
        var s = (this._settings.y ? this._settings.y : m.y);
        var g = [];
        for (var h = 0; h < j.length; h++) {
            g.push(1)
        }
        var l = this._getRatios(g, j.length);
        this._mapStart = r;
        if (!o) {
            this._drawRadarAxises(l, c, s, n, j)
        }
        this._drawRadarData(u, l, c, s, n, j, o, a)
    },
    _drawRadarData: function (C, s, n, m, j, N, D, M) {
        var A, v, L, J, E, I, h, g, F, K, H, u, c, w, q, o, a, r, l;
        L = this._settings;
        E = L.yAxis.start;
        I = L.yAxis.end;
        l = this._getRelativeValue(E, I);
        u = l[0];
        r = (u ? j / u : j / 2);
        a = l[1];
        c = -Math.PI / 2;
        A = v = c;
        F = [];
        g = 0;
        for (J = 0; J < N.length; J++) {
            if (!o) {
                w = L.value(N[J]);
                q = (parseFloat(w || 0) - E) * a
            } else {
                q = o
            }
            K = Math.floor(r * q);
            w = L.value((J != (N.length - 1)) ? N[J + 1] : N[0]);
            o = (parseFloat(w || 0) - E) * a;
            H = Math.floor(r * o);
            A = v;
            v = ((J != (N.length - 1)) ? (c + s[J] - 0.0001) : c);
            h = (g || this._getPositionByAngle(A, n, m, K));
            g = this._getPositionByAngle(v, n, m, H);
            F.push(h)
        }
        if (L.fill) {
            this._fillRadarChart(C, F, N)
        }
        if (!L.disableLines) {
            this._strokeRadarChart(C, F, N)
        }
        if (!L.disableItems) {
            this._drawRadarItemMarkers(C, F, N, D, M)
        }
        F = null
    },
    _drawRadarItemMarkers: function (a, g, j, h, l) {
        for (var c = 0; c < g.length; c++) {
            this._drawItem(a, g[c].x, g[c].y, j[c], this._settings.label.call(this, j), h, l)
        }
    },
    _fillRadarChart: function (a, h, l) {
        var j, g;
        a.globalAlpha = this._settings.alpha.call(this, {});
        a.beginPath();
        for (var c = 0; c < h.length; c++) {
            a.fillStyle = this._settings.fill.call(this, l[c]);
            j = h[c];
            g = (h[c + 1] || h[0]);
            if (!c) {
                a.moveTo(j.x, j.y)
            }
            a.lineTo(g.x, g.y)
        }
        a.fill();
        a.globalAlpha = 1
    },
    _strokeRadarChart: function (a, h, l) {
        var j, g;
        for (var c = 0; c < h.length; c++) {
            j = h[c];
            g = (h[c + 1] || h[0]);
            this._drawLine(a, j.x, j.y, g.x, g.y, this._settings.line.color.call(this, l[c]), this._settings.line.width)
        }
    },
    _drawRadarAxises: function (C, w, v, n, P) {
        var a = this._settings.yAxis;
        var h = this._settings.xAxis;
        var o = a.start;
        var m = a.end;
        var r = a.step;
        var D = {};
        var O = this._configYAxis;
        if (typeof O.step == "undefined" || typeof O.start == "undefined" || typeof O.end == "undefined") {
            var s = this._getLimits();
            D = this._calculateScale(s.min, s.max);
            o = D.start;
            m = D.end;
            r = D.step;
            a.end = m;
            a.start = o
        }
        var J = [];
        var M, L, E;
        var N = 0;
        var g = n * r / (m - o);
        var u, A;
        if (r < 1) {
            u = Math.min(this._log10(r), (o <= 0 ? 0 : this._log10(o)));
            A = Math.pow(10, -u)
        }
        var K = [];
        if (!this.canvases.scale) {
            this.canvases.scale = new dhtmlx.ui.Canvas(this._obj, "radar_scale")
        }
        var I = this.canvases.scale.getCanvas();
        for (M = m; M >= o; M -= r) {
            if (D.fixNum) {
                M = parseFloat((new Number(M)).toFixed(D.fixNum))
            }
            J.push(Math.floor(N * g) + 0.5);
            if (A) {
                M = Math.round(M * A) / A
            }
            var q = v - n + J[J.length - 1];
            this.canvases.scale.renderTextAt("middle", "left", w, q, a.template(M.toString()), "dhx_axis_item_y dhx_radar");
            if (C.length < 2) {
                this._drawScaleSector(I, "arc", w, v, n - J[J.length - 1], -Math.PI / 2, 3 * Math.PI / 2, M);
                return
            }
            var l = -Math.PI / 2;
            var H = l;
            var F;
            for (L = 0; L < C.length; L++) {
                if (M == m) {
                    K.push(H)
                }
                F = l + C[L] - 0.0001;
                this._drawScaleSector(I, (O.lineShape || "line"), w, v, n - J[J.length - 1], H, F, M, L, P[M]);
                H = F
            }
            N++
        }
        for (M = 0; M < K.length; M++) {
            E = this._getPositionByAngle(K[M], w, v, n);
            if (h.lines.call(this, P[M], M)) {
                this._drawLine(I, w, v, E.x, E.y, (h ? h.lineColor.call(this, P[M]) : "#cfcfcf"), 1)
            }
            this._drawRadarScaleLabel(I, w, v, n, K[M], (h ? h.template.call(this, P[M]) : "&nbsp;"))
        }
    },
    _drawScaleSector: function (u, m, s, q, l, c, a, h, g) {
        var r, o;
        if (l < 0) {
            return false
        }
        r = this._getPositionByAngle(c, s, q, l);
        o = this._getPositionByAngle(a, s, q, l);
        var n = this._settings.yAxis;
        if (n.bg) {
            u.beginPath();
            u.moveTo(s, q);
            if (m == "arc") {
                u.arc(s, q, l, c, a, false)
            } else {
                u.lineTo(r.x, r.y);
                u.lineTo(o.x, o.y)
            }
            u.fillStyle = n.bg(h, g);
            u.moveTo(s, q);
            u.fill();
            u.closePath()
        }
        if (n.lines.call(this, h)) {
            u.lineWidth = 1;
            u.beginPath();
            if (m == "arc") {
                u.arc(s, q, l, c, a, false)
            } else {
                u.moveTo(r.x, r.y);
                u.lineTo(o.x, o.y)
            }
            u.strokeStyle = n.lineColor.call(this, h);
            u.stroke()
        }
    },
    _drawRadarScaleLabel: function (w, o, m, c, n, u) {
        var v = this.canvases.scale.renderText(0, 0, u, "dhx_axis_radar_title", 1);
        var g = v.scrollWidth;
        var s = v.offsetHeight;
        var q = 0.001;
        var l = this._getPositionByAngle(n, o, m, c + 5);
        var j = 0,
            h = 0;
        if (n < 0 || n > Math.PI) {
            h = -s
        }
        if (n > Math.PI / 2) {
            j = -g
        }
        if (Math.abs(n + Math.PI / 2) < q || Math.abs(n - Math.PI / 2) < q) {
            j = -g / 2
        } else {
            if (Math.abs(n) < q || Math.abs(n - Math.PI) < q) {
                h = -s / 2
            }
        }
        v.style.top = l.y + h + "px";
        v.style.left = l.x + j + "px";
        v.style.width = g + "px";
        v.style.whiteSpace = "nowrap"
    }
};
dhtmlx.chart.area = {
    pvt_render_area: function (n, E, j, h, o, A) {
        var r, y, s, q, l, x, m, D, C, w, v, c, u, a, g;
        x = this._calculateLineParams(n, E, j, h, o);
        y = this._settings;
        q = (y.eventRadius || Math.floor(x.cellWidth / 2));
        if (E.length) {
            m = [];
            w = (!y.offset ? j.x : j.x + x.cellWidth * 0.5);
            for (s = 0; s < E.length; s++) {
                l = E[s];
                C = this._getPointY(l, j, h, x);
                u = w + x.cellWidth * s;
                if (C) {
                    a = (typeof C == "object" ? C.y0 : C);
                    if (s && this._settings.fixOverflow) {
                        D = this._getPointY(E[s - 1], j, h, x);
                        if (D.out && D.out == C.out) {
                            continue
                        }
                        v = x.cellWidth * (s - 1) - 0.5 + w;
                        c = (typeof D == "object" ? D.y0 : D);
                        if (D.out) {
                            g = (D.out == "min" ? h.y : j.y);
                            m.push([this._calcOverflowX(v, u, c, a, g), g])
                        }
                        if (C.out) {
                            g = (C.out == "min" ? h.y : j.y);
                            m.push([this._calcOverflowX(v, u, c, a, g), g]);
                            if (s == (E.length - 1) && g == j.y) {
                                m.push([u, j.y])
                            }
                        }
                    }
                    if (!C.out) {
                        m.push([u, a]);
                        A.addRect(l.id, [u - q - j.x, a - q - j.y, u + q - j.x, a + q - j.y], o)
                    }
                    if (!y.yAxis) {
                        r = (!y.offset && (s == E.length - 1) ? "left" : "center");
                        this.canvases[o].renderTextAt(false, r, u, a - y.labelOffset, y.label(l))
                    }
                }
            }
            if (m.length) {
                m.push([u, h.y]);
                m.push([m[0][0], h.y])
            }
            n.globalAlpha = this._settings.alpha.call(this, E[0]);
            n.fillStyle = this._settings.color.call(this, E[0]);
            n.beginPath();
            this._path(n, m);
            n.fill();
            if (y.border) {
                n.lineWidth = y.borderWidth || 1;
                if (y.borderColor) {
                    n.strokeStyle = y.borderColor.call(this, E[0])
                } else {
                    this._setBorderStyles(n, n.fillStyle)
                }
                n.beginPath();
                this._path(n, m);
                n.stroke()
            }
            n.lineWidth = 1;
            n.globalAlpha = 1
        }
    }
};
dhtmlx.chart.stackedArea = {
    pvt_render_stackedArea: function (q, H, c, a, r, E) {
        var J, I, v, D, A, w, l, u, m, C, o, h, g, n;
        C = this._calculateLineParams(q, H, c, a, r);
        D = this._settings;
        u = (D.eventRadius || Math.floor(C.cellWidth / 2));
        if (H.length) {
            o = [];
            n = [];
            h = (!D.offset ? c.x : c.x + C.cellWidth * 0.5);
            var F = function (j, x) {
                    return r ? (H[j].$startY ? x - a.y + H[j].$startY : 0) : x
                };
            var s = function (j, L, K) {
                    var y = (K.y - L.y) / (K.x - L.x);
                    return y * j + L.y - y * L.x
                };
            for (A = 0; A < H.length; A++) {
                m = H[A];
                if (!A) {
                    g = F(A, a.y);
                    o.push([h, g])
                } else {
                    h += C.cellWidth
                }
                g = F(A, this._getPointY(m, c, a, C));
                n.push((isNaN(g) && !A) ? (H[A].$startY || a.y) : g);
                if (g) {
                    o.push([h, g]);
                    E.addRect(m.id, [h - u - c.x, g - u - c.y, h + u - c.x, g + u - c.y], r);
                    if (!D.yAxis) {
                        v = (!D.offset && l ? "left" : "center");
                        this.canvases[r].renderTextAt(false, v, h, g - D.labelOffset, D.label(m))
                    }
                }
            }
            o.push([h, F(A - 1, a.y)]);
            if (r) {
                for (A = H.length - 2; A > 0; A--) {
                    h -= C.cellWidth;
                    g = H[A].$startY;
                    if (g) {
                        o.push([h, g])
                    }
                }
            }
            o.push([o[0][0], o[0][1]]);
            q.globalAlpha = this._settings.alpha.call(this, H[0]);
            q.fillStyle = this._settings.color.call(this, H[0]);
            q.beginPath();
            this._path(q, o);
            q.fill();
            for (A = 0; A < H.length; A++) {
                g = n[A];
                if (!g) {
                    if (A == H.length - 1) {
                        g = H[A].$startY
                    }
                    for (w = A + 1; w < H.length; w++) {
                        if (n[w]) {
                            J = {
                                x: c.x,
                                y: n[0]
                            };
                            I = {
                                x: (c.x + C.cellWidth * w),
                                y: n[w]
                            };
                            g = s(c.x + C.cellWidth * A, J, I);
                            break
                        }
                    }
                }
                H[A].$startY = g
            }
        }
    }
};
dhtmlx.chart.spline = {
    pvt_render_spline: function (q, I, h, g, r, H) {
        var F, u, o, s, E, n, m, A, w, v, l, c, a;
        E = this._calculateLineParams(q, I, h, g, r);
        F = this._settings;
        this._mapStart = h;
        o = [];
        if (I.length) {
            A = (F.offset ? h.x + E.cellWidth * 0.5 : h.x);
            for (u = 0; u < I.length; u++) {
                l = this._getPointY(I[u], h, g, E);
                if (l) {
                    m = ((!u) ? A : E.cellWidth * u - 0.5 + A);
                    o.push({
                        x: m,
                        y: l,
                        index: u
                    })
                }
            }
            n = this._getSplineParameters(o);
            for (u = 0; u < o.length; u++) {
                w = o[u].x;
                c = o[u].y;
                if (u < o.length - 1) {
                    v = o[u + 1].x;
                    a = o[u + 1].y;
                    for (s = w; s < v; s++) {
                        var D = this._getSplineYPoint(s, w, u, n.a, n.b, n.c, n.d);
                        if (D < h.y) {
                            D = h.y
                        }
                        if (D > g.y) {
                            D = g.y
                        }
                        var C = this._getSplineYPoint(s + 1, w, u, n.a, n.b, n.c, n.d);
                        if (C < h.y) {
                            C = h.y
                        }
                        if (C > g.y) {
                            C = g.y
                        }
                        this._drawLine(q, s, D, s + 1, C, F.line.color(I[u]), F.line.width)
                    }
                    this._drawLine(q, v - 1, this._getSplineYPoint(s, w, u, n.a, n.b, n.c, n.d), v, a, F.line.color(I[u]), F.line.width)
                }
                this._drawItem(q, w, c, I[o[u].index], F.label(I[o[u].index]), r, H)
            }
        }
    },
    _getSplineParameters: function (y) {
        var l, C, A, D, x, w, r, q, o = [],
            j = [],
            g = y.length;
        for (l = 0; l < g - 1; l++) {
            o[l] = y[l + 1].x - y[l].x;
            j[l] = (y[l + 1].y - y[l].y) / o[l]
        }
        C = [];
        A = [];
        C[0] = 0;
        C[1] = 2 * (o[0] + o[1]);
        A[0] = 0;
        A[1] = 6 * (j[1] - j[0]);
        for (l = 2; l < g - 1; l++) {
            C[l] = 2 * (o[l - 1] + o[l]) - o[l - 1] * o[l - 1] / C[l - 1];
            A[l] = 6 * (j[l] - j[l - 1]) - o[l - 1] * A[l - 1] / C[l - 1]
        }
        D = [];
        D[g - 1] = D[0] = 0;
        for (l = g - 2; l >= 1; l--) {
            D[l] = (A[l] - o[l] * D[l + 1]) / C[l]
        }
        x = [];
        w = [];
        r = [];
        q = [];
        for (l = 0; l < g - 1; l++) {
            x[l] = y[l].y;
            w[l] = -o[l] * D[l + 1] / 6 - o[l] * D[l] / 3 + (y[l + 1].y - y[l].y) / o[l];
            r[l] = D[l] / 2;
            q[l] = (D[l + 1] - D[l]) / (6 * o[l])
        }
        return {
            a: x,
            b: w,
            c: r,
            d: q
        }
    },
    _getSplineYPoint: function (h, l, m, j, g, o, n) {
        return j[m] + (h - l) * (g[m] + (h - l) * (o[m] + (h - l) * n[m]))
    }
};
dhtmlx.chart.barH = {
    pvt_render_barH: function (y, M, l, j, A, L) {
        var q, s, D, C, a, F, n, J, u, K, c, w, m, H, v, h, x, r, I, g, o;
        D = (j.y - l.y) / M.length;
        n = this._getLimits("h");
        J = n.max;
        u = n.min;
        h = j.x - l.x;
        o = !! this._settings.yAxis;
        if (!A) {
            this._drawHScales(y, M, l, j, u, J, D)
        }
        if (o) {
            J = parseFloat(this._settings.xAxis.end);
            u = parseFloat(this._settings.xAxis.start)
        }
        H = this._getRelativeValue(u, J);
        w = H[0];
        c = H[1];
        r = (w ? h / w : 10);
        if (!o) {
            v = 10;
            r = (w ? (h - v) / w : 10)
        }
        s = parseInt(this._settings.width, 10);
        if ((s * this._series.length + 4) > D) {
            s = D / this._series.length - 4
        }
        q = Math.floor((D - s * this._series.length) / 2);
        m = (typeof this._settings.radius != "undefined" ? parseInt(this._settings.radius, 10) : Math.round(s / 5));
        K = false;
        a = this._settings.gradient;
        if (a && typeof (a) != "function") {
            K = a;
            a = false
        } else {
            if (a) {
                a = y.createLinearGradient(l.x, l.y, j.x, l.y);
                this._settings.gradient(a)
            }
        }
        if (!o) {
            this._drawLine(y, l.x - 0.5, l.y, l.x - 0.5, j.y, "#000000", 1)
        }
        for (F = 0; F < M.length; F++) {
            x = parseFloat(this._settings.value(M[F] || 0));
            if (x > J) {
                x = J
            }
            x -= u;
            x *= c;
            I = l.x;
            g = l.y + q + F * D + (s + 1) * A;
            if ((x < 0 && this._settings.origin == "auto") || (this._settings.xAxis && x === 0 && !(this._settings.origin != "auto" && this._settings.origin > u))) {
                this.canvases[A].renderTextAt("middle", "right", I + 10, g + s / 2 + q, this._settings.label(M[F]));
                continue
            }
            if (x < 0 && this._settings.origin != "auto" && this._settings.origin > u) {
                x = 0
            }
            if (!o) {
                x += v / r
            }
            C = a || this._settings.color.call(this, M[F]);
            if (this._settings.border) {
                this._drawBarHBorder(y, I, g, s, u, m, r, x, C)
            }
            y.globalAlpha = this._settings.alpha.call(this, M[F]);
            var E = this._drawBarH(y, j, I, g, s, u, m, r, x, C, a, K);
            if (K != false) {
                this._drawBarHGradient(y, I, g, s, u, m, r, x, C, K)
            }
            y.globalAlpha = 1;
            if (E[3] == g) {
                this.canvases[A].renderTextAt("middle", "left", E[0] - 5, E[3] + Math.floor(s / 2), this._settings.label(M[F]));
                L.addRect(M[F].id, [E[0] - l.x, E[3] - l.y, E[2] - l.x, E[3] + s - l.y], A)
            } else {
                this.canvases[A].renderTextAt("middle", false, E[2] + 5, E[1] + Math.floor(s / 2), this._settings.label(M[F]));
                L.addRect(M[F].id, [E[0] - l.x, g - l.y, E[2] - l.x, E[3] - l.y], A)
            }
        }
    },
    _setBarHPoints: function (w, h, u, x, m, v, s, l, j) {
        var c = 0;
        if (m > v * s) {
            var r = (m - v * s) / m;
            c = -Math.asin(r) + Math.PI / 2
        }
        w.moveTo(h, u + l);
        var g = h + v * s - m - (m ? 0 : l);
        if (m < v * s) {
            w.lineTo(g, u + l)
        }
        var q = u + m;
        if (m && m > 0) {
            w.arc(g, q, m - l, -Math.PI / 2 + c, 0, false)
        }
        var o = u + x - m - (m ? 0 : l);
        var a = g + m - (m ? l : 0);
        w.lineTo(a, o);
        if (m && m > 0) {
            w.arc(g, o, m - l, 0, Math.PI / 2 - c, false)
        }
        var n = u + x - l;
        w.lineTo(h, n);
        if (!j) {
            w.lineTo(h, u + l)
        }
        return [a, n]
    },
    _drawHScales: function (g, m, l, j, n, c, h) {
        var a = 0;
        if (this._settings.xAxis) {
            if (!this.canvases.x) {
                this.canvases.x = new dhtmlx.ui.Canvas(this._obj)
            }
            a = this._drawHXAxis(this.canvases.x.getCanvas(), m, l, j, n, c)
        }
        if (this._settings.yAxis) {
            if (!this.canvases.y) {
                this.canvases.y = new dhtmlx.ui.Canvas(this._obj)
            }
            this._drawHYAxis(this.canvases.y.getCanvas(), m, l, j, h, a)
        }
    },
    _drawHYAxis: function (s, j, o, m, g, a) {
        if (!this._settings.yAxis) {
            return
        }
        var l;
        var c = parseInt((a ? a : o.x), 10) - 0.5;
        var q = m.y + 0.5;
        var n = o.y;
        this._drawLine(s, c, q, c, n, this._settings.yAxis.color, 1);
        for (var h = 0; h < j.length; h++) {
            var r = ((this._settings.origin != "auto") && (this._settings.view == "barH") && (parseFloat(this._settings.value(j[h])) < this._settings.origin));
            l = n + g / 2 + h * g;
            this.canvases.y.renderTextAt("middle", (r ? false : "left"), (r ? c + 5 : c - 5), l, this._settings.yAxis.template(j[h]), "dhx_axis_item_y", (r ? 0 : c - 10));
            if (this._settings.yAxis.lines.call(this, j[h])) {
                this._drawLine(s, o.x, l, m.x, l, this._settings.yAxis.lineColor.call(this, j[h]), 1)
            }
        }
        this._drawLine(s, o.x + 0.5, n + 0.5, m.x, n + 0.5, this._settings.yAxis.lineColor.call(this, {}), 1);
        this._setYAxisTitle(o, m)
    },
    _drawHXAxis: function (A, s, x, w, g, o) {
        var m;
        var j = {};
        var n = this._settings.xAxis;
        if (!n) {
            return
        }
        var y = w.y + 0.5;
        var h = x.x - 0.5;
        var a = w.x - 0.5;
        var r = x.x;
        this._drawLine(A, h, y, a, y, n.color, 1);
        if (n.step) {
            m = parseFloat(n.step)
        }
        if (typeof this._configXAxis.step == "undefined" || typeof this._configXAxis.start == "undefined" || typeof this._configXAxis.end == "undefined") {
            j = this._calculateScale(g, o);
            g = j.start;
            o = j.end;
            m = j.step;
            this._settings.xAxis.end = o;
            this._settings.xAxis.start = g;
            this._settings.xAxis.step = m
        }
        if (m === 0) {
            return
        }
        var l = (a - h) * m / (o - g);
        var v = 0;
        for (var q = g; q <= o; q += m) {
            if (j.fixNum) {
                q = parseFloat((new Number(q)).toFixed(j.fixNum))
            }
            var u = Math.floor(h + v * l) + 0.5;
            if (!(q == g && this._settings.origin == "auto") && n.lines.call(this, q)) {
                this._drawLine(A, u, y, u, x.y, this._settings.xAxis.lineColor.call(this, q), 1)
            }
            if (q == this._settings.origin) {
                r = u + 1
            }
            this.canvases.x.renderTextAt(false, true, u, y + 2, n.template(q.toString()), "dhx_axis_item_x");
            v++
        }
        this.canvases.x.renderTextAt(true, false, h, w.y + this._settings.padding.bottom - 3, this._settings.xAxis.title, "dhx_axis_title_x", w.x - x.x);
        if (!n.lines.call(this, {})) {
            this._drawLine(A, h, x.y - 0.5, a, x.y - 0.5, this._settings.xAxis.color, 0.2)
        }
        return r
    },
    _correctBarHParams: function (n, j, g, l, m, o, h) {
        var a = this._settings.yAxis;
        var c = j;
        if ( !! a && this._settings.origin != "auto" && (this._settings.origin > h)) {
            j += (this._settings.origin - h) * m;
            c = j;
            l = l - (this._settings.origin - h);
            if (l < 0) {
                l *= (-1);
                n.translate(j, g + o);
                n.rotate(Math.PI);
                j = 0.5;
                g = 0
            }
            j += 0.5
        }
        return {
            value: l,
            x0: j,
            y0: g,
            start: c
        }
    },
    _drawBarH: function (u, j, A, h, o, q, l, n, s, v, a, m) {
        u.save();
        var r = this._correctBarHParams(u, A, h, s, n, o, q);
        u.fillStyle = v;
        u.beginPath();
        var w = this._setBarHPoints(u, r.x0, r.y0, o, l, n, r.value, (this._settings.border ? 1 : 0));
        if (a && !m) {
            u.lineTo(j.x, r.y0 + (this._settings.border ? 1 : 0))
        }
        u.fill();
        u.restore();
        var g = r.y0;
        var c = (r.y0 != h ? h : w[1]);
        var y = (r.y0 != h ? (r.start - w[0]) : r.start);
        var x = (r.y0 != h ? r.start : w[0]);
        return [y, g, x, c]
    },
    _drawBarHBorder: function (o, c, m, q, j, h, n, l, g) {
        o.save();
        var a = this._correctBarHParams(o, c, m, l, n, q, j);
        o.beginPath();
        this._setBorderStyles(o, g);
        o.globalAlpha = 0.9;
        this._setBarHPoints(o, a.x0, a.y0, q, h, n, a.value, o.lineWidth / 2, 1);
        o.stroke();
        o.restore()
    },
    _drawBarHGradient: function (r, g, o, s, m, l, q, n, h, a) {
        r.save();
        var c = this._correctBarHParams(r, g, o, n, q, s, m);
        var j = this._setBarGradient(r, c.x0, c.y0 + s, c.x0 + q * c.value, c.y0, a, h, "x");
        r.fillStyle = j.gradient;
        r.beginPath();
        this._setBarHPoints(r, c.x0, c.y0 + j.offset, s - j.offset * 2, l, q, c.value, j.offset);
        r.fill();
        r.globalAlpha = 1;
        r.restore()
    }
};
dhtmlx.assert(dhtmlx.chart.barH);
dhtmlx.chart.stackedBarH = {
    pvt_render_stackedBarH: function (C, P, j, h, D, O) {
        var N, v;
        var c;
        var w;
        var y = h.x - j.x;
        var n = !! this._settings.yAxis;
        var m = this._getStackedLimits(P);
        N = m.max;
        v = m.min;
        var F = Math.floor((h.y - j.y) / P.length);
        if (!D) {
            this._drawHScales(C, P, j, h, v, N, F)
        }
        if (n) {
            N = parseFloat(this._settings.xAxis.end);
            v = parseFloat(this._settings.xAxis.start)
        }
        var K = this._getRelativeValue(v, N);
        w = K[0];
        c = K[1];
        var s = (w ? y / w : 10);
        if (!n) {
            var x = 10;
            s = (w ? (y - x) / w : 10)
        }
        var u = parseInt(this._settings.width, 10);
        if ((u + 4) > F) {
            u = F - 4
        }
        var o = (F - u) / 2;
        var l = 0;
        var q = false;
        var a = this._settings.gradient;
        if (a) {
            q = true
        }
        if (!n) {
            this._drawLine(C, j.x - 0.5, j.y, j.x - 0.5, h.y, "#000000", 1)
        }
        var M = 0;
        var J = 0;
        for (I = 0; I < this._series.length; I++) {
            if (I == D) {
                J = M
            }
            if (this._series[I].view == "stackedBarH") {
                M++
            }
        }
        for (var I = 0; I < P.length; I++) {
            if (!J) {
                P[I].$startX = j.x
            }
            var A = parseFloat(this._settings.value(P[I] || 0));
            if (A > N) {
                A = N
            }
            A -= v;
            A *= c;
            var L = j.x;
            var g = j.y + o + I * F;
            if (!J) {
                P[I].$startX = L
            } else {
                L = P[I].$startX
            }
            if (A < 0 || (this._settings.yAxis && A === 0)) {
                this.canvases.y.renderTextAt("middle", true, L + 10, g + u / 2, this._settings.label(P[I]));
                continue
            }
            if (!n) {
                A += x / s
            }
            var E = this._settings.color.call(this, P[I]);
            C.globalAlpha = this._settings.alpha.call(this, P[I]);
            C.fillStyle = this._settings.color.call(this, P[I]);
            C.beginPath();
            var H = this._setBarHPoints(C, L, g, u, l, s, A, (this._settings.border ? 1 : 0));
            if (a && !q) {
                C.lineTo(j.x + y, g + (this._settings.border ? 1 : 0))
            }
            C.fill();
            if (q != false) {
                var r = this._setBarGradient(C, L, g + u, L, g, q, E, "x");
                C.fillStyle = r.gradient;
                C.beginPath();
                H = this._setBarHPoints(C, L, g, u, l, s, A, 0);
                C.fill()
            }
            if (this._settings.border) {
                this._drawBarHBorder(C, L, g, u, v, l, s, A, E)
            }
            C.globalAlpha = 1;
            this.canvases[D].renderTextAt("middle", true, P[I].$startX + (H[0] - P[I].$startX) / 2 - 1, g + (H[1] - g) / 2, this._settings.label(P[I]));
            O.addRect(P[I].id, [P[I].$startX - j.x, g - j.y, H[0] - j.x, H[1] - j.y], D);
            P[I].$startX = H[0]
        }
    }
};
dhtmlx.chart.stackedBar = {
    pvt_render_stackedBar: function (x, L, h, g, y, K) {
        var I, s;
        var a;
        var u;
        var v = g.y - h.y;
        var l = !! this._settings.yAxis;
        var J = !! this._settings.xAxis;
        var j = this._getStackedLimits(L);
        I = j.max;
        s = j.min;
        var C = Math.floor((g.x - h.x) / L.length);
        if (!y) {
            this._drawScales(L, h, g, s, I, C)
        }
        if (l) {
            I = parseFloat(this._settings.yAxis.end);
            s = parseFloat(this._settings.yAxis.start)
        }
        var F = this._getRelativeValue(s, I);
        u = F[0];
        a = F[1];
        var q = (u ? v / u : 10);
        var r = parseInt(this._settings.width, 10);
        if (r + 4 > C) {
            r = C - 4
        }
        var m = Math.floor((C - r) / 2);
        var n = (this._settings.gradient ? this._settings.gradient : false);
        if (!J) {
            this._drawLine(x, h.x, g.y + 0.5, g.x, g.y + 0.5, "#000000", 1)
        }
        for (var E = 0; E < L.length; E++) {
            var w = parseFloat(this._settings.value(L[E] || 0));
            if (!w) {
                if (!y || !L[E].$startY) {
                    L[E].$startY = g.y
                }
                continue
            }
            if (!y) {
                w -= s
            }
            w *= a;
            var H = h.x + m + E * C;
            var c = g.y;
            if (!y) {
                L[E].$startY = c
            } else {
                c = L[E].$startY
            }
            if (c < (h.y + 1)) {
                continue
            }
            if (w < 0 || (this._settings.yAxis && w === 0)) {
                this.canvases.y.renderTextAt(true, true, H + Math.floor(r / 2), c, this._settings.label(L[E]));
                continue
            }
            var A = this._settings.color.call(this, L[E]);
            x.globalAlpha = this._settings.alpha.call(this, L[E]);
            x.fillStyle = this._settings.color.call(this, L[E]);
            x.beginPath();
            var D = this._setStakedBarPoints(x, H - (this._settings.border ? 0.5 : 0), c, r + (this._settings.border ? 0.5 : 0), q, w, 0, h.y);
            x.fill();
            if (n) {
                x.save();
                var o = this._setBarGradient(x, H, c, H + r, D[1], n, A, "y");
                x.fillStyle = o.gradient;
                x.beginPath();
                D = this._setStakedBarPoints(x, H + o.offset, c, r - o.offset * 2, q, w, (this._settings.border ? 1 : 0), h.y);
                x.fill();
                x.restore()
            }
            if (this._settings.border) {
                x.save();
                this._setBorderStyles(x, A);
                x.beginPath();
                this._setStakedBarPoints(x, H - 0.5, c, r + 1, q, w, 0, h.y, 1);
                x.stroke();
                x.restore()
            }
            x.globalAlpha = 1;
            this.canvases[y].renderTextAt(false, true, H + Math.floor(r / 2), (D[1] + (c - D[1]) / 2) - 7, this._settings.label(L[E]));
            K.addRect(L[E].id, [H - h.x, D[1] - h.y, D[0] - h.x, (L[E].$startY || c) - h.y], y);
            L[E].$startY = (this._settings.border ? (D[1] + 1) : D[1])
        }
    },
    _setStakedBarPoints: function (s, c, o, u, q, n, h, g, j) {
        s.moveTo(c, o);
        var m = o - q * n + h;
        if (m < g) {
            m = g
        }
        s.lineTo(c, m);
        var a = c + u;
        var l = m;
        s.lineTo(a, l);
        var r = c + u;
        s.lineTo(r, o);
        if (!j) {
            s.lineTo(c, o)
        }
        return [r, l - 2 * h]
    }
};
dhtmlx.chart.line = {
    pvt_render_line: function (m, A, j, h, n, x) {
        var w, o, l, u, s, r, q, c, a, g, y, v;
        u = this._calculateLineParams(m, A, j, h, n);
        w = this._settings;
        if (A.length) {
            s = (w.offset ? j.x + u.cellWidth * 0.5 : j.x);
            l = [];
            for (o = 0; o < A.length; o++) {
                v = this._getPointY(A[o], j, h, u);
                if (v) {
                    q = ((!o) ? s : u.cellWidth * o - 0.5 + s);
                    a = (typeof v == "object" ? v.y0 : v);
                    if (o && this._settings.fixOverflow) {
                        y = this._getPointY(A[o - 1], j, h, u);
                        if (y.out && y.out == v.out) {
                            continue
                        }
                        r = u.cellWidth * (o - 1) - 0.5 + s;
                        c = (typeof y == "object" ? y.y0 : y);
                        if (y.out) {
                            g = (y.out == "min" ? h.y : j.y);
                            l.push({
                                x: this._calcOverflowX(r, q, c, a, g),
                                y: g
                            })
                        }
                        if (v.out) {
                            g = (v.out == "min" ? h.y : j.y);
                            l.push({
                                x: this._calcOverflowX(r, q, c, a, g),
                                y: g
                            })
                        }
                    }
                    if (!v.out) {
                        l.push({
                            x: q,
                            y: v,
                            index: o
                        })
                    }
                }
            }
            this._mapStart = j;
            for (o = 1; o <= l.length; o++) {
                r = l[o - 1].x;
                c = l[o - 1].y;
                if (o < l.length) {
                    q = l[o].x;
                    a = l[o].y;
                    this._drawLine(m, r, c, q, a, w.line.color.call(this, A[o - 1]), w.line.width);
                    if (w.line && w.line.shadow) {
                        m.globalAlpha = 0.3;
                        this._drawLine(m, r + 2, c + w.line.width + 8, q + 2, a + w.line.width + 8, "#eeeeee", w.line.width + 3);
                        m.globalAlpha = 1
                    }
                }
                if (typeof l[o - 1].index != "undefined") {
                    this._drawItem(m, r, c, A[l[o - 1].index], w.label(A[l[o - 1].index]), n, x, j)
                }
            }
        }
    },
    _calcOverflowX: function (c, a, h, g, j) {
        return c + (j - h) * (a - c) / (g - h)
    },
    _drawItem: function (u, g, s, o, r, q, c) {
        var h = this._settings.item;
        var n = parseInt(h.radius.call(this, o), 10) || 0;
        var m = this._mapStart;
        if (n) {
            u.save();
            if (h.shadow) {
                u.lineWidth = 1;
                u.strokeStyle = "#bdbdbd";
                u.fillStyle = "#bdbdbd";
                var a = [0.1, 0.2, 0.3];
                for (var l = (a.length - 1); l >= 0; l--) {
                    u.globalAlpha = a[l];
                    u.strokeStyle = "#d0d0d0";
                    u.beginPath();
                    this._strokeChartItem(u, g, s + 2 * n / 3, n + l + 1, h.type);
                    u.stroke()
                }
                u.beginPath();
                u.globalAlpha = 0.3;
                u.fillStyle = "#bdbdbd";
                this._strokeChartItem(u, g, s + 2 * n / 3, n + 1, h.type);
                u.fill()
            }
            u.restore();
            u.lineWidth = h.borderWidth;
            u.fillStyle = h.color.call(this, o);
            u.strokeStyle = h.borderColor.call(this, o);
            u.globalAlpha = h.alpha.call(this, o);
            u.beginPath();
            this._strokeChartItem(u, g, s, n + 1, h.type);
            u.fill();
            u.stroke();
            u.globalAlpha = 1
        }
        if (r) {
            this.canvases[q].renderTextAt(false, true, g, s - n - this._settings.labelOffset, this._settings.label.call(this, o))
        }
        var j = (this._settings.eventRadius || n + 1);
        c.addRect(o.id, [g - j - m.x, s - j - m.y, g + j - m.x, s + j - m.y], q)
    },
    _strokeChartItem: function (a, c, j, h, g) {
        var l = [];
        c = parseInt(c, 10);
        j = parseInt(j, 10);
        if (g && (g == "square" || g == "s")) {
            h *= Math.sqrt(2) / 2;
            l = [
                [c - h - a.lineWidth / 2, j - h],
                [c + h, j - h],
                [c + h, j + h],
                [c - h, j + h],
                [c - h, j - h]
            ]
        } else {
            if (g && (g == "diamond" || g == "d")) {
                var m = (a.lineWidth > 1 ? a.lineWidth * Math.sqrt(2) / 4 : 0);
                l = [
                    [c, j - h],
                    [c + h, j],
                    [c, j + h],
                    [c - h, j],
                    [c + m, j - h - m]
                ]
            } else {
                if (g && (g == "triangle" || g == "t")) {
                    l = [
                        [c, j - h],
                        [c + Math.sqrt(3) * h / 2, j + h / 2],
                        [c - Math.sqrt(3) * h / 2, j + h / 2],
                        [c, j - h]
                    ]
                } else {
                    l = [
                        [c, j, h, 0, Math.PI * 2, true]
                    ]
                }
            }
        }
        this._path(a, l)
    },
    _getPointY: function (g, n, l, a) {
        var m = a.minValue;
        var h = a.maxValue;
        var q = a.unit;
        var c = a.valueFactor;
        var o = this._settings.value(g);
        var r = (parseFloat(o || 0) - m) * c;
        if (!this._settings.yAxis) {
            r += a.startValue / q
        }
        var j = l.y - q * r;
        if (this._settings.fixOverflow && (this._settings.view == "line" || this._settings.view == "area")) {
            if (o > h) {
                j = {
                    y: n.y,
                    y0: j,
                    out: "max"
                }
            } else {
                if (r < 0 || o < m) {
                    j = {
                        y: l.y,
                        y0: j,
                        out: "min"
                    }
                }
            }
        } else {
            if (o > h) {
                j = n.y
            }
            if (r < 0 || o < m) {
                j = l.y
            }
        }
        return j
    },
    _calculateLineParams: function (o, h, m, l, j) {
        var c = {};
        var q;
        c.totalHeight = l.y - m.y;
        c.cellWidth = (l.x - m.x) / ((!this._settings.offset) ? (h.length - 1) : h.length);
        var g = !! this._settings.yAxis;
        var a = (this._settings.view.indexOf("stacked") != -1 ? this._getStackedLimits(h) : this._getLimits());
        c.maxValue = a.max;
        c.minValue = a.min;
        if (!j) {
            this._drawScales(h, m, l, c.minValue, c.maxValue, c.cellWidth)
        }
        if (g) {
            c.maxValue = parseFloat(this._settings.yAxis.end);
            c.minValue = parseFloat(this._settings.yAxis.start)
        }
        var n = this._getRelativeValue(c.minValue, c.maxValue);
        q = n[0];
        c.valueFactor = n[1];
        c.unit = (q ? c.totalHeight / q : 10);
        c.startValue = 0;
        if (!g) {
            c.startValue = 10;
            if (c.unit != c.totalHeight) {
                c.unit = (q ? (c.totalHeight - c.startValue) / q : 10)
            }
        }
        return c
    }
};
dhtmlx.chart.bar = {
    pvt_render_bar: function (y, P, j, h, A, O) {
        var s, D, H, m, M, u, v, c, I, w, r, L, n, N = h.y - j.y;
        n = !! this._settings.yAxis;
        L = !! this._settings.xAxis;
        m = this._getLimits();
        M = m.max;
        u = m.min;
        D = (h.x - j.x) / P.length;
        if (!A && !(this._settings.origin != "auto" && !n)) {
            this._drawScales(P, j, h, u, M, D)
        }
        if (n) {
            M = parseFloat(this._settings.yAxis.end);
            u = parseFloat(this._settings.yAxis.start)
        }
        I = this._getRelativeValue(u, M);
        v = I[0];
        c = I[1];
        r = (v ? N / v : v);
        if (!n && !(this._settings.origin != "auto" && L)) {
            w = 10;
            r = (v ? (N - w) / v : w)
        }
        if (!A && (this._settings.origin != "auto" && !n) && this._settings.origin > u) {
            this._drawXAxis(y, P, j, h, D, h.y - r * (this._settings.origin - u))
        }
        s = parseInt(this._settings.width, 10);
        var K = 0;
        var F = 0;
        for (H = 0; H < this._series.length; H++) {
            if (H == A) {
                F = K
            }
            if (this._series[H].view == "bar") {
                K++
            }
        }
        if (this._series && (s * K + 4) > D) {
            s = parseInt(D / K - 4, 10)
        }
        var o = (D - s * K) / 2;
        var l = (typeof this._settings.radius != "undefined" ? parseInt(this._settings.radius, 10) : Math.round(s / 5));
        var q = false;
        var a = this._settings.gradient;
        if (a && typeof (a) != "function") {
            q = a;
            a = false
        } else {
            if (a) {
                a = y.createLinearGradient(0, h.y, 0, j.y);
                this._settings.gradient(a)
            }
        }
        if (!L) {
            this._drawLine(y, j.x, h.y + 0.5, h.x, h.y + 0.5, "#000000", 1)
        }
        for (H = 0; H < P.length; H++) {
            var x = parseFloat(this._settings.value(P[H]) || 0);
            if (isNaN(x)) {
                continue
            }
            if (x > M) {
                x = M
            }
            x -= u;
            x *= c;
            var J = j.x + o + parseInt(H * D, 10) + (s + 1) * F;
            var g = h.y;
            if (x < 0 || (this._settings.yAxis && x === 0 && !(this._settings.origin != "auto" && this._settings.origin > u))) {
                this.canvases[A].renderTextAt(true, true, J + Math.floor(s / 2), g, this._settings.label(P[H]));
                continue
            }
            if (!n && !(this._settings.origin != "auto" && L)) {
                x += w / r
            }
            var C = a || this._settings.color.call(this, P[H]);
            y.globalAlpha = this._settings.alpha.call(this, P[H]);
            var E = this._drawBar(y, j, J, g, s, u, l, r, x, C, a, q);
            if (q) {
                this._drawBarGradient(y, J, g, s, u, l, r, x, C, q)
            }
            if (this._settings.border) {
                this._drawBarBorder(y, J, g, s, u, l, r, x, C)
            }
            y.globalAlpha = 1;
            if (E[0] != J) {
                this.canvases[A].renderTextAt(false, true, J + Math.floor(s / 2), E[1], this._settings.label(P[H]))
            } else {
                this.canvases[A].renderTextAt(true, true, J + Math.floor(s / 2), E[3], this._settings.label(P[H]))
            }
            O.addRect(P[H].id, [J - j.x, E[3] - j.y, E[2] - j.x, E[1] - j.y], A)
        }
    },
    _correctBarParams: function (n, j, g, l, m, o, h) {
        var a = this._settings.xAxis;
        var c = g;
        if ( !! a && this._settings.origin != "auto" && (this._settings.origin > h)) {
            g -= (this._settings.origin - h) * m;
            c = g;
            l = l - (this._settings.origin - h);
            if (l < 0) {
                l *= (-1);
                n.translate(j + o, g);
                n.rotate(Math.PI);
                j = 0;
                g = 0
            }
            g -= 0.5
        }
        return {
            value: l,
            x0: j,
            y0: g,
            start: c
        }
    },
    _drawBar: function (u, j, A, h, o, q, l, n, s, v, a, m) {
        u.save();
        u.fillStyle = v;
        var r = this._correctBarParams(u, A, h, s, n, o, q);
        var w = this._setBarPoints(u, r.x0, r.y0, o, l, n, r.value, (this._settings.border ? 1 : 0));
        if (a && !m) {
            u.lineTo(r.x0 + (this._settings.border ? 1 : 0), j.y)
        }
        u.fill();
        u.restore();
        var y = r.x0;
        var x = (r.x0 != A ? A + w[0] : w[0]);
        var g = (r.x0 != A ? (r.start - w[1] - r.y0) : r.y0);
        var c = (r.x0 != A ? r.start - r.y0 : w[1]);
        return [y, g, x, c]
    },
    _drawBarBorder: function (o, c, m, q, j, h, n, l, g) {
        var a;
        o.save();
        a = this._correctBarParams(o, c, m, l, n, q, j);
        this._setBorderStyles(o, g);
        this._setBarPoints(o, a.x0, a.y0, q, h, n, a.value, o.lineWidth / 2, 1);
        o.stroke();
        o.restore()
    },
    _drawBarGradient: function (s, h, q, u, n, m, r, o, j, c) {
        s.save();
        var g = this._correctBarParams(s, h, q, o, r, u, n);
        var l = this._setBarGradient(s, g.x0, g.y0, g.x0 + u, g.y0 - r * g.value + 2, c, j, "y");
        var a = this._settings.border ? 1 : 0;
        s.fillStyle = l.gradient;
        this._setBarPoints(s, g.x0 + l.offset, g.y0, u - l.offset * 2, m, r, g.value, l.offset + a);
        s.fill();
        s.restore()
    },
    _setBarPoints: function (w, h, s, x, n, u, r, j, m) {
        w.beginPath();
        var c = 0;
        if (n > u * r) {
            var l = (n - u * r) / n;
            if (l <= 1 && l >= -1) {
                c = -Math.acos(l) + Math.PI / 2
            }
        }
        w.moveTo(h + j, s);
        var q = s - Math.floor(u * r) + n + (n ? 0 : j);
        if (n < u * r) {
            w.lineTo(h + j, q)
        }
        var g = h + n;
        if (n && n > 0) {
            w.arc(g, q, n - j, -Math.PI + c, -Math.PI / 2, false)
        }
        var a = h + x - n - j;
        var o = q - n + (n ? j : 0);
        w.lineTo(a, o);
        if (n && n > 0) {
            w.arc(a, q, n - j, -Math.PI / 2, 0 - c, false)
        }
        var v = h + x - j;
        w.lineTo(v, s);
        if (!m) {
            w.lineTo(h + j, s)
        }
        return [v, o]
    }
};
dhtmlx.chart.pie = {
    pvt_render_pie: function (c, h, a, l, g, j) {
        this._renderPie(c, h, a, l, 1, j, g)
    },
    _renderPie: function (r, E, j, h, C, D, s) {
        if (!E.length) {
            return
        }
        var u = this._getPieParameters(j, h);
        var m = (this._settings.radius ? this._settings.radius : u.radius);
        if (m < 0) {
            return
        }
        var a = this._getValues(E);
        var l = this._getTotalValue(a);
        var n = this._getRatios(a, l);
        var A = (this._settings.x ? this._settings.x : u.x);
        var g = (this._settings.y ? this._settings.y : u.y);
        if (C == 1 && this._settings.shadow) {
            this._addShadow(r, A, g, m)
        }
        g = g / C;
        var q = -Math.PI / 2;
        var w = [];
        r.scale(1, C);
        if (this._settings.gradient) {
            var y = (C != 1 ? A + m / 3 : A);
            var c = (C != 1 ? g + m / 3 : g);
            this._showRadialGradient(r, A, g, m, y, c)
        }
        for (var x = 0; x < E.length; x++) {
            if (!a[x]) {
                continue
            }
            r.strokeStyle = this._settings.lineColor.call(this, E[x]);
            r.beginPath();
            r.moveTo(A, g);
            w.push(q);
            alpha1 = -Math.PI / 2 + n[x] - 0.0001;
            r.arc(A, g, m, q, alpha1, false);
            r.lineTo(A, g);
            var v = this._settings.color.call(this, E[x]);
            r.fillStyle = v;
            r.fill();
            if (this._settings.pieInnerText) {
                this._drawSectorLabel(A, g, 5 * m / 6, q, alpha1, C, this._settings.pieInnerText(E[x], l), true)
            }
            if (this._settings.label) {
                this._drawSectorLabel(A, g, m + this._settings.labelOffset, q, alpha1, C, this._settings.label(E[x]))
            }
            if (C != 1) {
                this._createLowerSector(r, A, g, q, alpha1, m, true);
                r.fillStyle = "#000000";
                r.globalAlpha = 0.2;
                this._createLowerSector(r, A, g, q, alpha1, m, false);
                r.globalAlpha = 1;
                r.fillStyle = v
            }
            D.addSector(E[x].id, q, alpha1, A - j.x, g - j.y / C, m, C, s);
            q = alpha1
        }
        r.globalAlpha = 0.8;
        var o;
        for (x = 0; x < w.length; x++) {
            o = this._getPositionByAngle(w[x], A, g, m);
            this._drawLine(r, A, g, o.x, o.y, this._settings.lineColor.call(this, E[x]), 2)
        }
        if (C == 1) {
            r.lineWidth = 2;
            r.strokeStyle = "#ffffff";
            r.beginPath();
            r.arc(A, g, m + 1, 0, 2 * Math.PI, false);
            r.stroke()
        }
        r.globalAlpha = 1;
        r.scale(1, 1 / C)
    },
    _getValues: function (g) {
        var a = [];
        for (var c = 0; c < g.length; c++) {
            a.push(parseFloat(this._settings.value(g[c]) || 0))
        }
        return a
    },
    _getTotalValue: function (a) {
        var g = 0;
        for (var c = 0; c < a.length; c++) {
            g += a[c]
        }
        return g
    },
    _getRatios: function (c, a) {
        var l;
        var j = [];
        var h = 0;
        a = a || this._getTotalValue(c);
        for (var g = 0; g < c.length; g++) {
            l = c[g];
            j[g] = Math.PI * 2 * (a ? ((l + h) / a) : (1 / c.length));
            h += l
        }
        return j
    },
    _getPieParameters: function (m, j) {
        var h = j.x - m.x;
        var c = j.y - m.y;
        var g = m.x + h / 2;
        var l = m.y + c / 2;
        var a = Math.min(h / 2, c / 2);
        return {
            x: g,
            y: l,
            radius: a
        }
    },
    _createLowerSector: function (h, j, m, g, a, l, c) {
        h.lineWidth = 1;
        if (!((g <= 0 && a >= 0) || (g >= 0 && a <= Math.PI) || (Math.abs(g - Math.PI) > 0.003 && g <= Math.PI && a >= Math.PI))) {
            return
        }
        if (g <= 0 && a >= 0) {
            g = 0;
            c = false;
            this._drawSectorLine(h, j, m, l, g, a)
        }
        if (g <= Math.PI && a >= Math.PI) {
            a = Math.PI;
            c = false;
            this._drawSectorLine(h, j, m, l, g, a)
        }
        var n = (this._settings.height || Math.floor(l / 4)) / this._settings.cant;
        h.beginPath();
        h.arc(j, m, l, g, a, false);
        h.lineTo(j + l * Math.cos(a), m + l * Math.sin(a) + n);
        h.arc(j, m + n, l, a, g, true);
        h.lineTo(j + l * Math.cos(g), m + l * Math.sin(g));
        h.fill();
        if (c) {
            h.stroke()
        }
    },
    _drawSectorLine: function (g, h, l, j, c, a) {
        g.beginPath();
        g.arc(h, l, j, c, a, false);
        g.stroke()
    },
    _addShadow: function (c, a, l, h) {
        c.globalAlpha = 0.5;
        var j = ["#c4c4c4", "#c6c6c6", "#cacaca", "#dcdcdc", "#dddddd", "#e0e0e0", "#eeeeee", "#f5f5f5", "#f8f8f8"];
        for (var g = j.length - 1; g > -1; g--) {
            c.beginPath();
            c.fillStyle = j[g];
            c.arc(a + 1, l + 1, h + g, 0, Math.PI * 2, true);
            c.fill()
        }
        c.globalAlpha = 1
    },
    _getGrayGradient: function (a) {
        a.addColorStop(0, "#ffffff");
        a.addColorStop(0.7, "#7a7a7a");
        a.addColorStop(1, "#000000");
        return a
    },
    _showRadialGradient: function (g, c, m, a, h, j) {
        g.beginPath();
        var l;
        if (typeof this._settings.gradient != "function") {
            l = g.createRadialGradient(h, j, a / 4, c, m, a);
            l = this._getGrayGradient(l)
        } else {
            l = this._settings.gradient(l)
        }
        g.fillStyle = l;
        g.arc(c, m, a, 0, Math.PI * 2, true);
        g.fill();
        g.globalAlpha = 0.7
    },
    _drawSectorLabel: function (D, c, h, w, v, E, u, a) {
        var s = this.canvases[0].renderText(0, 0, u, 0, 1);
        if (!s) {
            return
        }
        var F = s.scrollWidth;
        s.style.width = F + "px";
        if (F > D) {
            F = D
        }
        var A = (v - w < 0.2 ? 4 : 8);
        if (a) {
            A = F / 1.8
        }
        var g = w + (v - w) / 2;
        h = h - (A - 8) / 2;
        var n = -A;
        var m = -8;
        var C = "right";
        if (g >= Math.PI / 2 && g < Math.PI || g <= 3 * Math.PI / 2 && g >= Math.PI) {
            n = -F - n + 1;
            C = "left"
        }
        var j = 0;
        if (!a && E < 1 && (g > 0 && g < Math.PI)) {
            j = (this._settings.height || Math.floor(h / 4)) / E
        }
        var o = (c + Math.floor((h + j) * Math.sin(g))) * E + m;
        var q = D + Math.floor((h + A / 2) * Math.cos(g)) + n;
        var l = (v < Math.PI / 2 + 0.01);
        var r = (w < Math.PI / 2);
        if (r && l) {
            q = Math.max(q, D + 3)
        } else {
            if (!r && !l) {
                q = Math.min(q, D - F)
            } else {
                if (!a && (g >= Math.PI / 2 && g < Math.PI || g <= 3 * Math.PI / 2 && g >= Math.PI)) {
                    q += F / 3
                }
            }
        }
        s.style.top = o + "px";
        s.style.left = q + "px";
        s.style.width = F + "px";
        s.style.textAlign = C;
        s.style.whiteSpace = "nowrap"
    }
};
dhtmlx.chart.pie3D = {
    pvt_render_pie3D: function (c, h, a, l, g, j) {
        this._renderPie(c, h, a, l, this._settings.cant, j)
    }
};
dhtmlx.chart.donut = {
    pvt_render_donut: function (s, j, q, o, m, c) {
        if (!j.length) {
            return
        }
        this._renderPie(s, j, q, o, 1, c);
        var h = this._settings;
        var l = this._getPieParameters(q, o);
        var a = (h.radius ? h.radius : l.radius);
        var n = ((h.innerRadius && (h.innerRadius < a)) ? h.innerRadius : a / 3);
        var g = (h.x ? h.x : l.x);
        var r = (h.y ? h.y : l.y);
        s.fillStyle = "#ffffff";
        s.beginPath();
        s.arc(g, r, n, 0, Math.PI * 2, true);
        s.fill()
    }
};
dhtmlx.DataDriver.dhtmlxgrid = {
    _grid_getter: "_get_cell_value",
    toObject: function (a) {
        this._grid = a;
        return a
    },
    getRecords: function (a) {
        return a.rowsBuffer
    },
    getDetails: function (g) {
        var a = {};
        for (var c = 0; c < this._grid.getColumnsNum(); c++) {
            a["data" + c] = this._grid[this._grid_getter](g, c)
        }
        return a
    },
    getInfo: function (a) {
        return {
            _size: 0,
            _from: 0
        }
    }
};
dhtmlx.ui.Canvas = function (c, g, j) {
    this._canvas_labels = [];
    this._canvas_name = g;
    this._obj = c;
    var h = c.offsetWidth * (window.devicePixelRatio || 1);
    var a = c.offsetHeight * (window.devicePixelRatio || 1);
    var j = j || "";
    j += ";width:" + c.offsetWidth + "px;height:" + c.offsetHeight + "px;";
    this._prepareCanvas(g, j, h, a)
};
dhtmlx.ui.Canvas.prototype = {
    _prepareCanvas: function (c, h, g, a) {
        this._canvas = dhtmlx.html.create("canvas", {
            width: g,
            height: a,
            canvas_id: c,
            style: (h || "")
        });
        this._obj.appendChild(this._canvas);
        if (!this._canvas.getContext) {
            if (dhtmlx._isIE) {
                dhtmlx.require("thirdparty/excanvas/excanvas.js");
                G_vmlCanvasManager.init_(document);
                G_vmlCanvasManager.initElement(this._canvas)
            } else {
                dhtmlx.error("Canvas is not supported in the current browser")
            }
        }
        return this._canvas
    },
    getCanvas: function (c) {
        var a = (this._canvas || this._prepareCanvas()).getContext(c || "2d");
        if (!this._webixDevicePixelRatio) {
            this._webixDevicePixelRatio = true;
            a.scale(window.devicePixelRatio || 1, window.devicePixelRatio || 1)
        }
        return a
    },
    _resizeCanvas: function () {
        if (this._canvas) {
            var a = this._canvas.parentNode.offsetWidth;
            var c = this._canvas.parentNode.offsetHeight;
            this._canvas.setAttribute("width", a * (window.devicePixelRatio || 1));
            this._canvas.setAttribute("height", c * (window.devicePixelRatio || 1));
            this._canvas.style.width = a + "px";
            this._canvas.style.height = c + "px";
            this._webixDevicePixelRatio = false
        }
    },
    renderText: function (a, l, j, h, c) {
        if (!j) {
            return
        }
        var g = dhtmlx.html.create("DIV", {
            "class": "dhx_canvas_text" + (h ? (" " + h) : ""),
            style: "left:" + a + "px; top:" + l + "px;"
        }, j);
        this._obj.appendChild(g);
        this._canvas_labels.push(g);
        if (c) {
            g.style.width = c + "px"
        }
        return g
    },
    renderTextAt: function (j, o, a, n, h, m, g) {
        var l = this.renderText.call(this, a, n, h, m, g);
        if (l) {
            if (j) {
                if (j == "middle") {
                    l.style.top = parseInt(n - l.offsetHeight / 2, 10) + "px"
                } else {
                    l.style.top = n - l.offsetHeight + "px"
                }
            }
            if (o) {
                if (o == "left") {
                    l.style.left = a - l.offsetWidth + "px"
                } else {
                    l.style.left = parseInt(a - l.offsetWidth / 2, 10) + "px"
                }
            }
        }
        return l
    },
    clearCanvas: function (a) {
        var c = [],
            g;
        for (g = 0; g < this._canvas_labels.length; g++) {
            this._obj.removeChild(this._canvas_labels[g])
        }
        this._canvas_labels = [];
        if (!a && this._obj._htmlmap) {
            c = this._getMapAreas();
            while (c.length) {
                c[0].parentNode.removeChild(c[0]);
                c.splice(0, 1)
            }
            c = null;
            if (!this._obj._htmlmap.getElementsByTagName("AREA").length) {
                this._obj._htmlmap.parentNode.removeChild(this._obj._htmlmap);
                this._obj._htmlmap = null
            }
        }
        this.getCanvas().clearRect(0, 0, this._obj.offsetWidth * (window.devicePixelRatio || 1), this._obj.offsetWidth * (window.devicePixelRatio || 1))
    },
    toggleCanvas: function () {
        this._toggleCanvas(this._canvas.style.display == "none")
    },
    showCanvas: function () {
        this._toggleCanvas(true)
    },
    hideCanvas: function () {
        this._toggleCanvas(false)
    },
    _toggleCanvas: function (a) {
        var c, g;
        for (g = 0; g < this._canvas_labels.length; g++) {
            this._canvas_labels[g].style.display = (a ? "" : "none")
        }
        if (this._obj._htmlmap) {
            c = this._getMapAreas();
            for (g = 0; g < c.length; g++) {
                if (a) {
                    c[g].removeAttribute("disabled")
                } else {
                    c[g].setAttribute("disabled", "true")
                }
            }
        }
        this._canvas.style.display = (a ? "" : "none")
    },
    _getMapAreas: function () {
        var g = [],
            a, c;
        a = this._obj._htmlmap.getElementsByTagName("AREA");
        for (c = 0; c < a.length; c++) {
            if (a[c].getAttribute("userdata") == this._canvas_name) {
                g.push(a[c])
            }
        }
        return g
    }
};
dhtmlXChart = function (a) {
    this.name = "Chart";
    this.version = "3.0";
    if (dhtmlx.assert_enabled()) {
        this._assert()
    }
    dhtmlx.extend(this, dhtmlx.Settings);
    this._parseContainer(a, "dhx_chart");
    dhtmlx.extend(this, dhtmlx.AtomDataLoader);
    dhtmlx.extend(this, dhtmlx.DataLoader);
    this.data.provideApi(this, true);
    dhtmlx.extend(this, dhtmlx.EventSystem);
    dhtmlx.extend(this, dhtmlx.MouseEvents);
    dhtmlx.extend(this, dhtmlx.Destruction);
    dhtmlx.extend(this, dhtmlx.Group);
    dhtmlx.extend(this, dhtmlx.AutoTooltip);
    for (var c in dhtmlx.chart) {
        dhtmlx.extend(this, dhtmlx.chart[c])
    }
    if (a.preset) {
        this.definePreset(a)
    }
    this._parseSettings(a, this.defaults);
    this._series = [this._settings];
    this.data.attachEvent("onStoreUpdated", dhtmlx.bind(function () {
        this.render()
    }, this));
    this.attachEvent("onLocateData", this._switchSerie)
};
dhtmlXChart.prototype = {
    _id: "dhx_area_id",
    on_click: {
        dhx_chart_legend_item: function (l, m, j) {
            var h = j.getAttribute("series_id");
            if (this.callEvent("onLegendClick", [l, h, j])) {
                var g = this._settings;
                var c = g.legend.values;
                var a = (c && (typeof c[h].toggle != "undefined")) ? c[h].toggle : g.legend.toggle;
                if ((typeof h != "undefined") && this._series.length > 1) {
                    if (a) {
                        if (j.className.indexOf("hidden") != -1) {
                            this.showSeries(h)
                        } else {
                            this.hideSeries(h)
                        }
                    }
                }
            }
        }
    },
    on_dblclick: {},
    on_mouse_move: {},
    bind: function () {
        dhx.BaseBind.legacyBind.apply(this, arguments)
    },
    sync: function () {
        dhx.BaseBind.legacySync.apply(this, arguments)
    },
    resize: function () {
        for (var a in this.canvases) {
            this.canvases[a]._resizeCanvas()
        }
        this.render()
    },
    view_setter: function (a) {
        if (!dhtmlx.chart[a]) {
            dhtmlx.error("Chart type extension is not loaded: " + a)
        }
        if (typeof this._settings.offset == "undefined") {
            this._settings.offset = !(a == "area" || a == "stackedArea")
        }
        if (a == "radar" && !this._settings.yAxis) {
            this.define("yAxis", {})
        }
        if (a == "scatter") {
            if (!this._settings.yAxis) {
                this.define("yAxis", {})
            }
            if (!this._settings.xAxis) {
                this.define("xAxis", {})
            }
        }
        return a
    },
    clearCanvas: function () {
        if (this.canvases && typeof this.canvases == "object") {
            for (var a in this.canvases) {
                this.canvases[a].clearCanvas()
            }
        }
    },
    render: function () {
        var g, c, h, j, a;
        if (!this.callEvent("onBeforeRender", [this.data])) {
            return
        }
        if (this.canvases && typeof this.canvases == "object") {
            for (c in this.canvases) {
                this.canvases[c].clearCanvas()
            }
        } else {
            this.canvases = {}
        }
        if (this._settings.legend) {
            if (!this.canvases.legend) {
                this.canvases.legend = new dhtmlx.ui.Canvas(this._obj, "legend")
            }
            this._drawLegend(this.data.getRange(), this._obj.offsetWidth)
        }
        g = this._getChartBounds(this._obj.offsetWidth, this._obj.offsetHeight);
        j = new dhtmlx.ui.Map(this._id);
        a = this._settings;
        h = this._getChartData();
        for (c = 0; c < this._series.length; c++) {
            this._settings = this._series[c];
            if (!this.canvases[c]) {
                this.canvases[c] = new dhtmlx.ui.Canvas(this._obj, c, "z-index:" + (2 + c))
            }
            this["pvt_render_" + this._settings.view](this.canvases[c].getCanvas(), h, g.start, g.end, c, j)
        }
        j.render(this._obj);
        this._obj.lastChild.style.zIndex = 1000;
        this._applyBounds(this._obj.lastChild, g);
        this.callEvent("onAfterRender", []);
        this._settings = a
    },
    _applyBounds: function (g, c) {
        var a = {};
        a.left = c.start.x;
        a.top = c.start.y;
        a.width = c.end.x - c.start.x;
        a.height = c.end.y - c.start.y;
        for (var h in a) {
            g.style[h] = a[h] + "px"
        }
    },
    _getChartData: function () {
        var h, m, g, j, l, q, a, n, o, c;
        j = this.data.getRange();
        h = (this._settings.view.toLowerCase().indexOf("barh") != -1 ? "yAxis" : "xAxis");
        m = this._settings[h];
        if (m && m.units && (typeof m.units == "object")) {
            g = m.units;
            n = [];
            if (typeof g.start != "undefined" && typeof g.end != "undefined" && typeof g.next != "undefined") {
                a = g.start;
                while (a <= g.end) {
                    n.push(a);
                    a = g.next.call(this, a)
                }
            } else {
                if (Object.prototype.toString.call(g) === "[object Array]") {
                    n = g
                }
            }
            q = [];
            if (n.length) {
                o = m.value;
                c = {};
                for (l = 0; l < j.length; l++) {
                    c[o(j[l])] = l
                }
                for (l = 0; l < n.length; l++) {
                    if (typeof c[n[l]] != "undefined") {
                        j[c[n[l]]].$unit = n[l];
                        q.push(j[c[n[l]]])
                    } else {
                        q.push({
                            $unit: n[l]
                        })
                    }
                }
            }
            return q
        }
        return j
    },
    value_setter: dhtmlx.Template.obj_setter,
    xValue_setter: dhtmlx.Template.obj_setter,
    yValue_setter: function (a) {
        this.define("value", a)
    },
    alpha_setter: dhtmlx.Template.obj_setter,
    label_setter: dhtmlx.Template.obj_setter,
    lineColor_setter: dhtmlx.Template.obj_setter,
    borderColor_setter: dhtmlx.Template.obj_setter,
    pieInnerText_setter: dhtmlx.Template.obj_setter,
    gradient_setter: function (a) {
        if ((typeof (a) != "function") && a && (a === true)) {
            a = "light"
        }
        return a
    },
    colormap: {
        RAINBOW: function (a) {
            var c = Math.floor(this.indexById(a.id) / this.dataCount() * 1536);
            if (c == 1536) {
                c -= 1
            }
            return this._rainbow[Math.floor(c / 256)](c % 256)
        }
    },
    color_setter: function (a) {
        return this.colormap[a] || dhtmlx.Template.obj_setter(a)
    },
    fill_setter: function (a) {
        return ((!a || a == 0) ? false : dhtmlx.Template.obj_setter(a))
    },
    definePreset: function (a) {
        this.define("preset", a.preset);
        delete a.preset
    },
    preset_setter: function (j) {
        var g, c, h;
        this.defaults = dhtmlx.extend({}, this.defaults);
        if (typeof dhtmlx.presets.chart[j] == "object") {
            h = dhtmlx.presets.chart[j];
            for (g in h) {
                if (typeof h[g] == "object") {
                    if (!this.defaults[g] || typeof this.defaults[g] != "object") {
                        this.defaults[g] = dhtmlx.extend({}, h[g])
                    } else {
                        this.defaults[g] = dhtmlx.extend({}, this.defaults[g]);
                        for (c in h[g]) {
                            this.defaults[g][c] = h[g][c]
                        }
                    }
                } else {
                    this.defaults[g] = h[g]
                }
            }
            return j
        }
        return false
    },
    legend_setter: function (a) {
        if (!a) {
            if (this.legendObj) {
                this.legendObj.innerHTML = "";
                this.legendObj = null
            }
            return false
        }
        if (typeof (a) != "object") {
            a = {
                template: a
            }
        }
        this._mergeSettings(a, {
            width: 150,
            height: 18,
            layout: "y",
            align: "left",
            valign: "bottom",
            template: "",
            toggle: (this._settings.view.toLowerCase().indexOf("stacked") != -1 ? "" : "hide"),
            marker: {
                type: "square",
                width: 15,
                height: 15,
                radius: 3
            },
            margin: 4,
            padding: 3
        });
        a.template = dhtmlx.Template.setter(a.template);
        return a
    },
    defaults: {
        color: "RAINBOW",
        alpha: "1",
        label: false,
        value: "{obj.value}",
        padding: {},
        view: "pie",
        lineColor: "#ffffff",
        cant: 0.5,
        width: 30,
        labelWidth: 100,
        line: {
            width: 2,
            color: "#1293f8"
        },
        item: {
            radius: 3,
            borderColor: "#636363",
            borderWidth: 1,
            color: "#ffffff",
            alpha: 1,
            type: "r",
            shadow: false
        },
        shadow: true,
        gradient: false,
        border: true,
        labelOffset: 20,
        origin: "auto"
    },
    item_setter: function (a) {
        if (typeof (a) != "object") {
            a = {
                color: a,
                borderColor: a
            }
        }
        this._mergeSettings(a, dhtmlx.extend({}, this.defaults.item));
        var g = ["alpha", "borderColor", "color", "radius"];
        for (var c = 0; c < g.length; c++) {
            a[g[c]] = dhtmlx.Template.setter(a[g[c]])
        }
        return a
    },
    line_setter: function (a) {
        if (typeof (a) != "object") {
            a = {
                color: a
            }
        }
        dhtmlx.extend(this.defaults.line, a);
        a = dhtmlx.extend({}, this.defaults.line);
        a.color = dhtmlx.Template.setter(a.color);
        return a
    },
    padding_setter: function (a) {
        if (typeof (a) != "object") {
            a = {
                left: a,
                right: a,
                top: a,
                bottom: a
            }
        }
        this._mergeSettings(a, {
            left: 50,
            right: 20,
            top: 35,
            bottom: 40
        });
        return a
    },
    xAxis_setter: function (a) {
        if (!a) {
            return false
        }
        if (typeof (a) != "object") {
            a = {
                template: a
            }
        }
        if (!a.value) {
            a.value = a.template
        }
        this._mergeSettings(a, {
            title: "",
            color: "#000000",
            lineColor: "#cfcfcf",
            template: "{obj}",
            value: "{obj}",
            lines: true
        });
        var c = ["lineColor", "template", "lines", "value"];
        this._converToTemplate(c, a);
        this._configXAxis = dhtmlx.extend({}, a);
        return a
    },
    yAxis_setter: function (a) {
        this._mergeSettings(a, {
            title: "",
            color: "#000000",
            lineColor: "#cfcfcf",
            template: "{obj}",
            lines: true,
            bg: "#ffffff"
        });
        var c = ["lineColor", "template", "lines", "bg"];
        this._converToTemplate(c, a);
        this._configYAxis = dhtmlx.extend({}, a);
        return a
    },
    _converToTemplate: function (a, c) {
        for (var g = 0; g < a.length; g++) {
            c[a[g]] = dhtmlx.Template.setter(c[a[g]])
        }
    },
    _drawScales: function (j, h, g, m, a, c) {
        var l = 0;
        if (this._settings.yAxis) {
            if (!this.canvases.y) {
                this.canvases.y = new dhtmlx.ui.Canvas(this._obj, "axis_y")
            }
            l = this._drawYAxis(this.canvases.y.getCanvas(), j, h, g, m, a)
        }
        if (this._settings.xAxis) {
            if (!this.canvases.x) {
                this.canvases.x = new dhtmlx.ui.Canvas(this._obj, "axis_x")
            }
            this._drawXAxis(this.canvases.x.getCanvas(), j, h, g, c, l)
        }
        return l
    },
    _drawXAxis: function (u, l, r, q, h, o) {
        var g = r.x - 0.5;
        var s = parseInt((o ? o : q.y), 10) + 0.5;
        var c = q.x;
        var m;
        var a = true;
        for (var j = 0; j < l.length; j++) {
            if (this._settings.offset === true) {
                m = g + h / 2 + j * h
            } else {
                m = (j == l.length - 1) ? q.x : g + j * h;
                a = !! j
            }
            m = Math.ceil(m) - 0.5;
            var n = ((this._settings.origin != "auto") && (this._settings.view == "bar") && (parseFloat(this._settings.value(l[j])) < this._settings.origin));
            this._drawXAxisLabel(m, s, l[j], a, n);
            if ((this._settings.offset || j) && this._settings.xAxis.lines.call(this, l[j])) {
                this._drawXAxisLine(u, m, q.y, r.y, l[j])
            }
        }
        this.canvases.x.renderTextAt(true, false, g, q.y + this._settings.padding.bottom - 3, this._settings.xAxis.title, "dhx_axis_title_x", q.x - r.x);
        this._drawLine(u, g, s, c, s, this._settings.xAxis.color, 1);
        if (!this._settings.xAxis.lines.call(this, {}) || !this._settings.offset) {
            return
        }
        this._drawLine(u, c + 0.5, q.y, c + 0.5, r.y + 0.5, this._settings.xAxis.color, 0.2)
    },
    _drawYAxis: function (w, D, l, j, n, m) {
        var o;
        var u = {};
        if (!this._settings.yAxis) {
            return
        }
        var y = l.x - 0.5;
        var h = j.y;
        var g = l.y;
        var v = j.y;
        if (this._settings.yAxis.step) {
            o = parseFloat(this._settings.yAxis.step)
        }
        if (typeof this._configYAxis.step == "undefined" || typeof this._configYAxis.start == "undefined" || typeof this._configYAxis.end == "undefined") {
            u = this._calculateScale(n, m);
            n = u.start;
            m = u.end;
            o = u.step;
            this._settings.yAxis.end = m;
            this._settings.yAxis.start = n
        }
        this._setYAxisTitle(l, j);
        if (o === 0) {
            m = n;
            o = 1
        }
        var a = (m == n ? h - g : (h - g) * o / (m - n));
        var A = 0;
        for (var x = n; x <= m; x += o) {
            if (u.fixNum) {
                x = parseFloat((new Number(x)).toFixed(u.fixNum))
            }
            var C = Math.floor(h - A * a) + 0.5;
            if (!(x == n && this._settings.origin == "auto") && this._settings.yAxis.lines.call(this, x)) {
                this._drawLine(w, y, C, j.x, C, this._settings.yAxis.lineColor.call(this, x), 1)
            }
            if (x == this._settings.origin) {
                v = C
            }
            var q = x;
            if (o < 1) {
                var r = Math.min(this._log10(o), (n <= 0 ? 0 : this._log10(n)));
                var s = Math.pow(10, -r);
                q = Math.round(x * s) / s;
                x = q
            }
            this.canvases.y.renderText(0, C - 5, this._settings.yAxis.template(q.toString()), "dhx_axis_item_y", l.x - 5);
            A++
        }
        this._drawLine(w, y, h + 1, y, g, this._settings.yAxis.color, 1);
        return v
    },
    _setYAxisTitle: function (g, c) {
        var a = "dhx_axis_title_y" + (dhtmlx._isIE && dhtmlx._isIE != 9 ? " dhx_ie_filter" : "");
        var h = this.canvases.y.renderTextAt("middle", false, 0, parseInt((c.y - g.y) / 2 + g.y, 10), this._settings.yAxis.title, a);
        if (h) {
            h.style.left = (dhtmlx.env.transform ? (h.offsetHeight - h.offsetWidth) / 2 : 0) + "px"
        }
    },
    _calculateScale: function (q, c) {
        if (this._settings.origin != "auto" && this._settings.origin < q) {
            q = this._settings.origin
        }
        var j, h, m;
        j = ((c - q) / 8) || 1;
        var g = Math.floor(this._log10(j));
        var a = Math.pow(10, g);
        var l = j / a;
        l = (l > 5 ? 10 : 5);
        j = parseInt(l, 10) * a;
        if (j > Math.abs(q)) {
            h = (q < 0 ? -j : 0)
        } else {
            var r = Math.abs(q);
            var o = Math.floor(this._log10(r));
            var n = r / Math.pow(10, o);
            h = Math.ceil(n * 10) / 10 * Math.pow(10, o) - j;
            if (r > 1 && j > 0.1) {
                h = Math.ceil(h)
            }
            while (q < 0 ? h <= q : h >= q) {
                h -= j
            }
            if (q < 0) {
                h = -h - 2 * j
            }
        }
        m = h;
        while (m < c) {
            m += j;
            m = parseFloat((new Number(m)).toFixed(Math.abs(g)))
        }
        return {
            start: h,
            end: m,
            step: j,
            fixNum: Math.abs(g)
        }
    },
    _getLimits: function (c, m) {
        var n, l;
        var j = ((arguments.length && c == "h") ? this._configXAxis : this._configYAxis);
        m = m || "value";
        if (j && (typeof j.end != "undefined") && (typeof j.start != "undefined") && j.step) {
            n = parseFloat(j.end);
            l = parseFloat(j.start)
        } else {
            n = this.max(this._series[0][m]);
            l = (j && (typeof j.start != "undefined")) ? parseFloat(j.start) : this.min(this._series[0][m]);
            if (this._series.length > 1) {
                for (var h = 1; h < this._series.length; h++) {
                    var a = this.max(this._series[h][m]);
                    var g = this.min(this._series[h][m]);
                    if (a > n) {
                        n = a
                    }
                    if (g < l) {
                        l = g
                    }
                }
            }
        }
        return {
            max: n,
            min: l
        }
    },
    _log10: function (c) {
        var a = "log";
        return Math.floor((Math[a](c) / Math.LN10))
    },
    _drawXAxisLabel: function (c, l, j, a, h) {
        if (!this._settings.xAxis) {
            return
        }
        var g = this.canvases.x.renderTextAt(h, a, c, l - (h ? 2 : 0), this._settings.xAxis.template(j));
        if (g) {
            g.className += " dhx_axis_item_x"
        }
    },
    _drawXAxisLine: function (c, a, h, g, j) {
        if (!this._settings.xAxis || !this._settings.xAxis.lines) {
            return
        }
        this._drawLine(c, a, h, a, g, this._settings.xAxis.lineColor.call(this, j), 1)
    },
    _drawLine: function (a, h, m, g, j, c, l) {
        a.strokeStyle = c;
        a.lineWidth = l;
        a.beginPath();
        a.moveTo(h, m);
        a.lineTo(g, j);
        a.stroke();
        a.lineWidth = 1
    },
    _getRelativeValue: function (h, j) {
        var g, a;
        var c = 1;
        if (j != h) {
            g = j - h
        } else {
            g = h
        }
        return [g, c]
    },
    _rainbow: [function (a) {
        return "#FF" + dhtmlx.math.toHex(a / 2, 2) + "00"
    }, function (a) {
        return "#FF" + dhtmlx.math.toHex(a / 2 + 128, 2) + "00"
    }, function (a) {
        return "#" + dhtmlx.math.toHex(255 - a, 2) + "FF00"
    }, function (a) {
        return "#00FF" + dhtmlx.math.toHex(a, 2)
    }, function (a) {
        return "#00" + dhtmlx.math.toHex(255 - a, 2) + "FF"
    }, function (a) {
        return "#" + dhtmlx.math.toHex(a, 2) + "00FF"
    }],
    addSeries: function (c) {
        var a = this._settings;
        this._settings = dhtmlx.extend({}, a);
        this._parseSettings(c, {});
        this._series.push(this._settings);
        this._settings = a
    },
    _switchSerie: function (h, a) {
        var g;
        this._active_serie = a.getAttribute("userdata");
        if (!this._series[this._active_serie]) {
            return
        }
        for (var c = 0; c < this._series.length; c++) {
            g = this._series[c].tooltip;
            if (g) {
                g.disable()
            }
        }
        if (!a.getAttribute("disabled")) {
            g = this._series[this._active_serie].tooltip;
            if (g) {
                g.enable()
            }
        }
    },
    hideSeries: function (a) {
        this.canvases[a].hideCanvas();
        if (this._settings.legend.values && this._settings.legend.values[a]) {
            this._settings.legend.values[a].$hidden = true
        }
        this._drawLegend()
    },
    showSeries: function (a) {
        this.canvases[a].showCanvas();
        if (this._settings.legend.values && this._settings.legend.values[a]) {
            delete this._settings.legend.values[a].$hidden
        }
        this._drawLegend()
    },
    _setBorderStyles: function (a, c) {
        var h, g;
        g = dhtmlx.math.toRgb(c);
        h = dhtmlx.math.rgbToHsv(g[0], g[1], g[2]);
        h[2] /= 2;
        c = "rgb(" + dhtmlx.math.hsvToRgb(h[0], h[1], h[2]) + ")";
        a.strokeStyle = c;
        if (a.globalAlpha == 1) {
            a.globalAlpha = 0.9
        }
    },
    _drawLegend: function (h, c) {
        var j, q, w, r, l, s, a, n = 0,
            m = 0,
            v, o, g, u;
        h = h || [];
        c = c || this._obj.offsetWidth;
        v = this.canvases.legend.getCanvas();
        q = this._settings.legend;
        a = (this._settings.legend.layout != "x" ? "width:" + q.width + "px" : "");
        if (this.legendObj) {
            this.legendObj.innerHTML = "";
            this.legendObj.parentNode.removeChild(this.legendObj)
        }
        this.canvases.legend.clearCanvas(true);
        w = dhtmlx.html.create("DIV", {
            "class": "dhx_chart_legend",
            style: "left:" + n + "px; top:" + m + "px;" + a
        }, "");
        if (q.padding) {
            w.style.padding = q.padding + "px"
        }
        this.legendObj = w;
        this._obj.appendChild(w);
        l = [];
        if (!q.values) {
            for (j = 0; j < h.length; j++) {
                l.push(this._drawLegendText(w, q.template(h[j])))
            }
        } else {
            for (j = 0; j < q.values.length; j++) {
                l.push(this._drawLegendText(w, q.values[j].text, (typeof q.values[j].id != "undefined" ? typeof q.values[j].id : j), q.values[j].$hidden))
            }
        }
        s = w.offsetWidth;
        r = w.offsetHeight;
        if (s < this._obj.offsetWidth) {
            if (q.layout == "x" && q.align == "center") {
                n = (this._obj.offsetWidth - s) / 2
            }
            if (q.align == "right") {
                n = this._obj.offsetWidth - s
            }
            if (q.margin && q.align != "center") {
                n += (q.align == "left" ? 1 : -1) * q.margin
            }
        }
        if (r < this._obj.offsetHeight) {
            if (q.valign == "middle" && q.align != "center" && q.layout != "x") {
                m = (this._obj.offsetHeight - r) / 2
            } else {
                if (q.valign == "bottom") {
                    m = this._obj.offsetHeight - r
                }
            }
            if (q.margin && q.valign != "middle") {
                m += (q.valign == "top" ? 1 : -1) * q.margin
            }
        }
        w.style.left = n + "px";
        w.style.top = m + "px";
        v.save();
        for (j = 0; j < l.length; j++) {
            u = l[j];
            if (q.values && q.values[j].$hidden) {
                g = true;
                o = (q.values[j].disableColor ? q.values[j].disableColor : "#d9d9d9")
            } else {
                g = false;
                o = (q.values ? q.values[j].color : this._settings.color.call(this, h[j]))
            }
            this._drawLegendMarker(v, u.offsetLeft + n, u.offsetTop + m, o, u.offsetHeight, g, j)
        }
        v.restore();
        l = null
    },
    _drawLegendText: function (a, j, c, h) {
        var g = "";
        if (this._settings.legend.layout == "x") {
            g = "float:left;"
        }
        var l = dhtmlx.html.create("DIV", {
            style: g + "padding-left:" + (10 + this._settings.legend.marker.width) + "px",
            "class": "dhx_chart_legend_item" + (h ? " hidden" : "")
        }, j);
        if (arguments.length > 2) {
            l.setAttribute("series_id", c)
        }
        a.appendChild(l);
        return l
    },
    _drawLegendMarker: function (A, s, r, j, w, l, n) {
        var c = [];
        var m = this._settings.legend.marker;
        var v = this._settings.legend.values;
        var q = (v && v[n].markerType ? v[n].markerType : m.type);
        if (j) {
            A.fillStyle = j;
            A.strokeStyle = this._getDarkenColor(j, 0.75)
        }
        A.beginPath();
        if (q == "round" || !m.radius) {
            A.lineWidth = m.height;
            A.lineCap = q;
            s += A.lineWidth / 2 + 5;
            r += w / 2;
            A.moveTo(s, r);
            var a = s + m.width - m.height + 1;
            A.lineTo(a, r)
        } else {
            if (q == "item") {
                if (this._settings.line && this._settings.view != "scatter" && !this._settings.disableLines) {
                    A.beginPath();
                    A.lineWidth = this._series[n].line.width;
                    A.strokeStyle = l ? j : this._series[n].line.color.call(this, {});
                    var g = s + 5;
                    var u = r + w / 2;
                    A.moveTo(g, u);
                    var a = g + m.width;
                    A.lineTo(a, u);
                    A.stroke()
                }
                var h = this._series[n].item;
                var o = parseInt(h.radius.call(this, {}), 10) || 0;
                if (o) {
                    A.beginPath();
                    if (l) {
                        A.lineWidth = h.borderWidth;
                        A.strokeStyle = j;
                        A.fillStyle = j
                    } else {
                        A.lineWidth = h.borderWidth;
                        A.fillStyle = h.color.call(this, {});
                        A.strokeStyle = h.borderColor.call(this, {});
                        A.globalAlpha = h.alpha.call(this, {})
                    }
                    A.beginPath();
                    s += m.width / 2 + 5;
                    r += w / 2;
                    this._strokeChartItem(A, s, r, o + 1, h.type);
                    A.fill();
                    A.stroke()
                }
                A.globalAlpha = 1
            } else {
                A.lineWidth = 1;
                s += 5;
                r += parseInt(w / 2 - m.height / 2, 10);
                c = [
                    [s + m.radius, r + m.radius, m.radius, Math.PI, 3 * Math.PI / 2, false],
                    [s + m.width - m.radius, r],
                    [s + m.width - m.radius, r + m.radius, m.radius, -Math.PI / 2, 0, false],
                    [s + m.width, r + m.height - m.radius],
                    [s + m.width - m.radius, r + m.height - m.radius, m.radius, 0, Math.PI / 2, false],
                    [s + m.radius, r + m.height],
                    [s + m.radius, r + m.height - m.radius, m.radius, Math.PI / 2, Math.PI, false],
                    [s, r + m.radius]
                ];
                this._path(A, c)
            }
        }
        A.stroke();
        A.fill()
    },
    _getDarkenColor: function (a, h) {
        var g, c;
        c = dhtmlx.math.toRgb(a);
        g = dhtmlx.math.rgbToHsv(c[0], c[1], c[2]);
        g[2] = g[2] * h;
        return "rgb(" + dhtmlx.math.hsvToRgb(g[0], g[1], g[2]) + ")"
    },
    _getChartBounds: function (a, m) {
        var o, g, n, c;
        o = this._settings.padding.left;
        g = this._settings.padding.top;
        n = a - this._settings.padding.right;
        c = m - this._settings.padding.bottom;
        if (this._settings.legend) {
            var j = this._settings.legend;
            var l = this._settings.legend.width;
            var h = this._settings.legend.height;
            if (j.layout == "x") {
                if (j.valign == "center") {
                    if (j.align == "right") {
                        n -= l
                    } else {
                        if (j.align == "left") {
                            o += l
                        }
                    }
                } else {
                    if (j.valign == "bottom") {
                        c -= h
                    } else {
                        g += h
                    }
                }
            } else {
                if (j.align == "right") {
                    n -= l
                } else {
                    if (j.align == "left") {
                        o += l
                    }
                }
            }
        }
        return {
            start: {
                x: o,
                y: g
            },
            end: {
                x: n,
                y: c
            }
        }
    },
    _getStackedLimits: function (l) {
        var c, a, m, h, g;
        if (this._settings.yAxis && (typeof this._settings.yAxis.end != "undefined") && (typeof this._settings.yAxis.start != "undefined") && this._settings.yAxis.step) {
            m = parseFloat(this._settings.yAxis.end);
            h = parseFloat(this._settings.yAxis.start)
        } else {
            for (c = 0; c < l.length; c++) {
                l[c].$sum = 0;
                l[c].$min = Infinity;
                for (a = 0; a < this._series.length; a++) {
                    g = parseFloat(this._series[a].value(l[c]) || 0);
                    if (isNaN(g)) {
                        continue
                    }
                    if (this._series[a].view.toLowerCase().indexOf("stacked") != -1) {
                        l[c].$sum += g
                    }
                    if (g < l[c].$min) {
                        l[c].$min = g
                    }
                }
            }
            m = -Infinity;
            h = Infinity;
            for (c = 0; c < l.length; c++) {
                if (l[c].$sum > m) {
                    m = l[c].$sum
                }
                if (l[c].$min < h) {
                    h = l[c].$min
                }
            }
            if (h > 0) {
                h = 0
            }
        }
        return {
            max: m,
            min: h
        }
    },
    _setBarGradient: function (v, c, r, a, o, n, h, g) {
        var q, j, m, l, u, s;
        if (n == "light") {
            if (g == "x") {
                q = v.createLinearGradient(c, r, a, r)
            } else {
                q = v.createLinearGradient(c, r, c, o)
            }
            s = [
                [0, "#FFFFFF"],
                [0.9, h],
                [1, h]
            ];
            j = 2
        } else {
            if (n == "falling" || n == "rising") {
                if (g == "x") {
                    q = v.createLinearGradient(c, r, a, r)
                } else {
                    q = v.createLinearGradient(c, r, c, o)
                }
                m = dhtmlx.math.toRgb(h);
                l = dhtmlx.math.rgbToHsv(m[0], m[1], m[2]);
                l[1] *= 1 / 2;
                u = "rgb(" + dhtmlx.math.hsvToRgb(l[0], l[1], l[2]) + ")";
                if (n == "falling") {
                    s = [
                        [0, u],
                        [0.7, h],
                        [1, h]
                    ]
                } else {
                    if (n == "rising") {
                        s = [
                            [0, h],
                            [0.3, h],
                            [1, u]
                        ]
                    }
                }
                j = 0
            } else {
                v.globalAlpha = 0.37;
                j = 0;
                if (g == "x") {
                    q = v.createLinearGradient(c, o, c, r)
                } else {
                    q = v.createLinearGradient(c, r, a, r)
                }
                s = [
                    [0, "#9d9d9d"],
                    [0.3, "#e8e8e8"],
                    [0.45, "#ffffff"],
                    [0.55, "#ffffff"],
                    [0.7, "#e8e8e8"],
                    [1, "#9d9d9d"]
                ]
            }
        }
        this._gradient(q, s);
        return {
            gradient: q,
            offset: j
        }
    },
    _getPositionByAngle: function (g, c, j, h) {
        g *= (-1);
        c = c + Math.cos(g) * h;
        j = j - Math.sin(g) * h;
        return {
            x: c,
            y: j
        }
    },
    _gradient: function (g, c) {
        for (var a = 0; a < c.length; a++) {
            g.addColorStop(c[a][0], c[a][1])
        }
    },
    _path: function (a, g) {
        var c, h;
        for (c = 0; c < g.length; c++) {
            h = (c ? "lineTo" : "moveTo");
            if (g[c].length > 2) {
                h = "arc"
            }
            a[h].apply(a, g[c])
        }
    },
    _circle: function (c, a, h, g) {
        c.arc(a, h, g, Math.PI * 2, true)
    },
    _addMapRect: function (h, j, a, g, c) {
        h.addRect(j, [a[0].x - g.x, a[0].y - g.y, a[1].x - g.x, a[1].y - g.y], c)
    }
};
dhtmlx.compat("layout");
dhtmlx.ui.pager = function (a) {
    this.name = "Pager";
    if (dhtmlx.assert_enabled()) {
        this._assert()
    }
    dhtmlx.extend(this, dhtmlx.Settings);
    this._parseContainer(a, "dhx_pager");
    dhtmlx.extend(this, dhtmlx.EventSystem);
    dhtmlx.extend(this, dhtmlx.SingleRender);
    dhtmlx.extend(this, dhtmlx.MouseEvents);
    this._parseSettings(a, {
        size: 10,
        page: -1,
        group: 5,
        count: 0,
        type: "default"
    });
    this.data = this._settings;
    this.refresh()
};
dhtmlx.ui.pager.prototype = {
    _id: "dhx_p_id",
    on_click: {
        dhx_pager_item: function (a, c) {
            this.select(c)
        }
    },
    select: function (a) {
        switch (a) {
        case "next":
            a = this._settings.page + 1;
            break;
        case "prev":
            a = this._settings.page - 1;
            break;
        case "first":
            a = 0;
            break;
        case "last":
            a = this._settings.limit - 1;
            break;
        default:
            break
        }
        if (a < 0) {
            a = 0
        }
        if (a >= this.data.limit) {
            a = this.data.limit - 1
        }
        if (this.callEvent("onBeforePageChange", [this._settings.page, a])) {
            this.data.page = a * 1;
            this.refresh();
            this.callEvent("onAfterPageChange", [a])
        }
    },
    types: {
        "default": {
            template: dhtmlx.Template.fromHTML("{common.pages()}"),
            pages: function (g) {
                var c = "";
                if (g.page == -1) {
                    return ""
                }
                g.min = g.page - Math.round((g.group - 1) / 2);
                g.max = g.min + g.group - 1;
                if (g.min < 0) {
                    g.max += g.min * (-1);
                    g.min = 0
                }
                if (g.max >= g.limit) {
                    g.min -= Math.min(g.min, g.max - g.limit + 1);
                    g.max = g.limit - 1
                }
                for (var a = (g.min || 0); a <= g.max; a++) {
                    c += this.button({
                        id: a,
                        index: (a + 1),
                        selected: (a == g.page ? "_selected" : "")
                    })
                }
                return c
            },
            page: function (a) {
                return a.page + 1
            },
            first: function () {
                return this.button({
                    id: "first",
                    index: " &lt;&lt; ",
                    selected: ""
                })
            },
            last: function () {
                return this.button({
                    id: "last",
                    index: " &gt;&gt; ",
                    selected: ""
                })
            },
            prev: function () {
                return this.button({
                    id: "prev",
                    index: "&lt;",
                    selected: ""
                })
            },
            next: function () {
                return this.button({
                    id: "next",
                    index: "&gt;",
                    selected: ""
                })
            },
            button: dhtmlx.Template.fromHTML("<div dhx_p_id='{obj.id}' class='dhx_pager_item{obj.selected}'>{obj.index}</div>")
        }
    },
    refresh: function () {
        var a = this._settings;
        a.limit = Math.ceil(a.count / a.size);
        if (a.limit && a.limit != a.old_limit) {
            a.page = Math.min(a.limit - 1, a.page)
        }
        var c = a.page;
        if (c != -1 && (c != a.old_page) || (a.limit != a.old_limit)) {
            this.render();
            this.callEvent("onRefresh", []);
            a.old_limit = a.limit;
            a.old_page = a.page
        }
    },
    template_item_start: dhtmlx.Template.fromHTML("<div>"),
    template_item_end: dhtmlx.Template.fromHTML("</div>")
};
dhtmlx.DataProcessor = {
    _dp_init: function (c) {
        var a = "_methods";
        c[a] = ["setItemStyle", "", "changeId", "remove"];
        this.attachEvent("onAfterAdd", function (g) {
            c.setUpdated(g, true, "inserted")
        });
        this.data.attachEvent("onStoreLoad", dhtmlx.bind(function (h, g) {
            if (h.getUserData) {
                h.getUserData(g, this._userdata)
            }
        }, this));
        this.attachEvent("onBeforeDelete", function (h) {
            if (c._silent_mode) {
                return true
            }
            var g = c.getState(h);
            if (g == "inserted") {
                c.setUpdated(h, false);
                return true
            }
            if (g == "deleted") {
                return false
            }
            if (g == "true_deleted") {
                return true
            }
            c.setUpdated(h, true, "deleted");
            return false
        });
        this.attachEvent("onAfterEditStop", function (g) {
            c.setUpdated(g, true, "updated")
        });
        this.attachEvent("onBindUpdate", function (g) {
            window.setTimeout(function () {
                c.setUpdated(g.id, true, "updated")
            }, 1)
        });
        a = "_getRowData";
        c[a] = function (m, g) {
            var j = this.obj.data.get(m);
            var l = {};
            for (var h in j) {
                if (h.indexOf("_") === 0) {
                    continue
                }
                l[h] = j[h]
            }
            return l
        };
        a = "_clearUpdateFlag";
        c[a] = function () {};
        this._userdata = {};
        c.attachEvent("insertCallback", this._dp_callback);
        c.attachEvent("updateCallback", this._dp_callback);
        c.attachEvent("deleteCallback", function (g, h) {
            this.obj.setUserData(h, this.action_param, "true_deleted");
            this.obj.remove(h)
        });
        dhtmlx.compat("dataProcessor", c)
    },
    _dp_callback: function (a, c) {
        this.obj.data.set(c, dhtmlx.DataDriver.xml.getDetails(a.firstChild));
        this.obj.data.refresh(c)
    },
    setItemStyle: function (g, a) {
        var c = this._locateHTML(g);
        if (c) {
            c.style.cssText += ";" + a
        }
    },
    changeId: function (c, a) {
        this.data.changeId(c, a);
        this.refresh()
    },
    setUserData: function (g, a, c) {
        if (g) {
            this.data.get(g)[a] = c
        } else {
            this._userdata[a] = c
        }
    },
    getUserData: function (c, a) {
        return c ? this.data.get(c)[a] : this._userdata[a]
    }
};
(function () {
    var a = "_dp_init";
    dhtmlx.DataProcessor[a] = dhtmlx.DataProcessor._dp_init
})();
dhtmlx.compat.dnd = function () {
    if (window.dhtmlDragAndDropObject) {
        var n = "_dragged";
        var h = dhtmlDragAndDropObject.prototype.checkLanding;
        dhtmlDragAndDropObject.prototype.checkLanding = function (q, r, o) {
            h.apply(this, arguments);
            if (!o) {
                var s = dhtmlx.DragControl._drag_context = dhtmlx.DragControl._drag_context || {};
                if (!s.from) {
                    s.from = this.dragStartObject
                }
                dhtmlx.DragControl._checkLand(q, r, true)
            }
        };
        var c = dhtmlDragAndDropObject.prototype.stopDrag;
        dhtmlDragAndDropObject.prototype.stopDrag = function (r, o, q) {
            if (!q) {
                if (dhtmlx.DragControl._last) {
                    dhtmlx.DragControl._active = m.dragStartNode;
                    dhtmlx.DragControl._stopDrag(r, true)
                }
            }
            c.apply(this, arguments)
        };
        var m = new dhtmlDragAndDropObject();
        var j = dhtmlx.DragControl._startDrag;
        dhtmlx.DragControl._startDrag = function () {
            j.apply(this, arguments);
            var s = dhtmlx.DragControl._drag_context;
            if (!s) {
                return
            }
            var r = [];
            var q = [];
            for (var o = 0; o < s.source.length; o++) {
                r[o] = {
                    idd: s.source[o]
                };
                q.push(s.source[o])
            }
            m.dragStartNode = {
                parentNode: {},
                parentObject: {
                    idd: r,
                    id: (q.length == 1 ? q[0] : q),
                    treeNod: {
                        object: s.from
                    }
                }
            };
            m.dragStartNode.parentObject.treeNod[n] = r;
            m.dragStartObject = s.from
        };
        var l = dhtmlx.DragControl._checkLand;
        dhtmlx.DragControl._checkLand = function (q, r, o) {
            l.apply(this, arguments);
            if (!this._last && !o) {
                q = m.checkLanding(q, r, true)
            }
        };
        var a = dhtmlx.DragControl._stopDrag;
        dhtmlx.DragControl._stopDrag = function (q, o) {
            a.apply(this, arguments);
            if (m.lastLanding && !o) {
                m.stopDrag(q, false, true)
            }
        };
        var g = dhtmlx.DragControl.getMaster;
        dhtmlx.DragControl.getMaster = function (q) {
            var r = null;
            if (q) {
                r = g.apply(this, arguments)
            }
            if (!r) {
                r = m.dragStartObject;
                var s = [];
                var u = r[n];
                for (var o = 0; o < u.length; o++) {
                    s.push(u[o].idd || u[o].id)
                }
                dhtmlx.DragControl._drag_context.source = s
            }
            return r
        }
    }
};
dhtmlx.DataMove = {
    _init: function () {
        dhtmlx.assert(this.data, "DataMove :: Component doesn't have DataStore")
    },
    copy: function (c, j, a, h) {
        var g = this.get(c);
        if (!g) {
            dhtmlx.log("Warning", "Incorrect ID in DataMove::copy");
            return
        }
        if (a) {
            dhtmlx.assert(a.externalData, "DataMove :: External object doesn't support operation");
            g = a.externalData(g)
        }
        a = a || this;
        return a.add(a.externalData(g, h), j)
    },
    move: function (g, m, c, l) {
        if (g instanceof Array) {
            for (var h = 0; h < g.length; h++) {
                var a = (c || this).indexById(this.move(g[h], m, c, dhtmlx.uid()));
                if (g[h + 1]) {
                    m = a + (this.indexById(g[h + 1]) < a ? 0 : 1)
                }
            }
            return
        }
        nid = g;
        if (m < 0) {
            dhtmlx.log("Info", "DataMove::move - moving outside of bounds is ignored");
            return
        }
        var j = this.get(g);
        if (!j) {
            dhtmlx.log("Warning", "Incorrect ID in DataMove::move");
            return
        }
        if (!c || c == this) {
            this.data.move(this.indexById(g), m)
        } else {
            dhtmlx.assert(c.externalData, "DataMove :: External object doesn't support operation");
            nid = c.add(c.externalData(j, l), m);
            this.remove(g)
        }
        return nid
    },
    moveUp: function (c, a) {
        return this.move(c, this.indexById(c) - (a || 1))
    },
    moveDown: function (c, a) {
        return this.moveUp(c, (a || 1) * -1)
    },
    moveTop: function (a) {
        return this.move(a, 0)
    },
    moveBottom: function (a) {
        return this.move(a, this.data.dataCount() - 1)
    },
    externalData: function (a, g) {
        var c = dhtmlx.extend({}, a);
        c.id = g || dhtmlx.uid();
        c.$selected = c.$template = null;
        return c
    }
};
dhtmlx.DragControl = {
    _drag_masters: dhtmlx.toArray(["dummy"]),
    addDrop: function (c, g, a) {
        c = dhtmlx.toNode(c);
        c.dhx_drop = this._getCtrl(g);
        if (a) {
            c.dhx_master = true
        }
    },
    _getCtrl: function (c) {
        c = c || dhtmlx.DragControl;
        var a = this._drag_masters.find(c);
        if (a < 0) {
            a = this._drag_masters.length;
            this._drag_masters.push(c)
        }
        return a
    },
    addDrag: function (a, c) {
        a = dhtmlx.toNode(a);
        a.dhx_drag = this._getCtrl(c);
        dhtmlx.event(a, "mousedown", this._preStart, a)
    },
    _preStart: function (a) {
        if (dhtmlx.DragControl._active) {
            dhtmlx.DragControl._preStartFalse();
            dhtmlx.DragControl.destroyDrag()
        }
        dhtmlx.DragControl._active = this;
        dhtmlx.DragControl._start_pos = {
            x: a.pageX,
            y: a.pageY
        };
        dhtmlx.DragControl._dhx_drag_mm = dhtmlx.event(document.body, "mousemove", dhtmlx.DragControl._startDrag);
        dhtmlx.DragControl._dhx_drag_mu = dhtmlx.event(document.body, "mouseup", dhtmlx.DragControl._preStartFalse);
        dhtmlx.DragControl._dhx_drag_sc = dhtmlx.event(this, "scroll", dhtmlx.DragControl._preStartFalse);
        a.cancelBubble = true;
        return false
    },
    _preStartFalse: function (a) {
        dhtmlx.DragControl._dhx_drag_mm = dhtmlx.eventRemove(dhtmlx.DragControl._dhx_drag_mm);
        dhtmlx.DragControl._dhx_drag_mu = dhtmlx.eventRemove(dhtmlx.DragControl._dhx_drag_mu);
        dhtmlx.DragControl._dhx_drag_sc = dhtmlx.eventRemove(dhtmlx.DragControl._dhx_drag_sc)
    },
    _startDrag: function (a) {
        var c = {
            x: a.pageX,
            y: a.pageY
        };
        if (Math.abs(c.x - dhtmlx.DragControl._start_pos.x) < 5 && Math.abs(c.y - dhtmlx.DragControl._start_pos.y) < 5) {
            return
        }
        dhtmlx.DragControl._preStartFalse();
        if (!dhtmlx.DragControl.createDrag(a)) {
            return
        }
        dhtmlx.DragControl.sendSignal("start");
        dhtmlx.DragControl._dhx_drag_mm = dhtmlx.event(document.body, "mousemove", dhtmlx.DragControl._moveDrag);
        dhtmlx.DragControl._dhx_drag_mu = dhtmlx.event(document.body, "mouseup", dhtmlx.DragControl._stopDrag);
        dhtmlx.DragControl._moveDrag(a)
    },
    _stopDrag: function (a) {
        dhtmlx.DragControl._dhx_drag_mm = dhtmlx.eventRemove(dhtmlx.DragControl._dhx_drag_mm);
        dhtmlx.DragControl._dhx_drag_mu = dhtmlx.eventRemove(dhtmlx.DragControl._dhx_drag_mu);
        if (dhtmlx.DragControl._last) {
            dhtmlx.DragControl.onDrop(dhtmlx.DragControl._active, dhtmlx.DragControl._last, this._landing, a);
            dhtmlx.DragControl.onDragOut(dhtmlx.DragControl._active, dhtmlx.DragControl._last, null, a)
        }
        dhtmlx.DragControl.destroyDrag();
        dhtmlx.DragControl.sendSignal("stop")
    },
    _moveDrag: function (a) {
        var c = dhtmlx.html.pos(a);
        dhtmlx.DragControl._html.style.top = c.y + dhtmlx.DragControl.top + "px";
        dhtmlx.DragControl._html.style.left = c.x + dhtmlx.DragControl.left + "px";
        if (dhtmlx.DragControl._skip) {
            dhtmlx.DragControl._skip = false
        } else {
            dhtmlx.DragControl._checkLand((a.srcElement || a.target), a)
        }
        a.cancelBubble = true;
        return false
    },
    _checkLand: function (a, c) {
        while (a && a.tagName != "BODY") {
            if (a.dhx_drop) {
                if (this._last && (this._last != a || a.dhx_master)) {
                    this.onDragOut(this._active, this._last, a, c)
                }
                if (!this._last || this._last != a || a.dhx_master) {
                    this._last = null;
                    this._landing = this.onDragIn(dhtmlx.DragControl._active, a, c);
                    if (this._landing) {
                        this._last = a
                    }
                    return
                }
                return
            }
            a = a.parentNode
        }
        if (this._last) {
            this._last = this._landing = this.onDragOut(this._active, this._last, null, c)
        }
    },
    sendSignal: function (a) {
        dhtmlx.DragControl.active = (a == "start")
    },
    getMaster: function (a) {
        return this._drag_masters[a.dhx_drag || a.dhx_drop]
    },
    getContext: function (a) {
        return this._drag_context
    },
    createDrag: function (j) {
        var g = dhtmlx.DragControl._active;
        var h = this._drag_masters[g.dhx_drag];
        var c;
        if (h.onDragCreate) {
            c = h.onDragCreate(g, j);
            c.style.position = "absolute";
            c.style.zIndex = dhtmlx.zIndex.drag;
            c.onmousemove = dhtmlx.DragControl._skip_mark
        } else {
            var l = dhtmlx.DragControl.onDrag(g, j);
            if (!l) {
                return false
            }
            var c = document.createElement("DIV");
            c.innerHTML = l;
            c.className = "dhx_drag_zone";
            c.onmousemove = dhtmlx.DragControl._skip_mark;
            document.body.appendChild(c)
        }
        dhtmlx.DragControl._html = c;
        return true
    },
    _skip_mark: function () {
        dhtmlx.DragControl._skip = true
    },
    destroyDrag: function () {
        var c = dhtmlx.DragControl._active;
        var g = this._drag_masters[c.dhx_drag];
        if (g && g.onDragDestroy) {
            g.onDragDestroy(c, dhtmlx.DragControl._html)
        } else {
            dhtmlx.html.remove(dhtmlx.DragControl._html)
        }
        dhtmlx.DragControl._landing = dhtmlx.DragControl._active = dhtmlx.DragControl._last = dhtmlx.DragControl._html = null
    },
    top: 5,
    left: 5,
    onDragIn: function (g, c, h) {
        var a = this._drag_masters[c.dhx_drop];
        if (a.onDragIn && a != this) {
            return a.onDragIn(g, c, h)
        }
        c.className = c.className + " dhx_drop_zone";
        return c
    },
    onDragOut: function (g, c, j, h) {
        var a = this._drag_masters[c.dhx_drop];
        if (a.onDragOut && a != this) {
            return a.onDragOut(g, c, j, h)
        }
        c.className = c.className.replace("dhx_drop_zone", "");
        return null
    },
    onDrop: function (g, c, j, h) {
        var a = this._drag_masters[c.dhx_drop];
        dhtmlx.DragControl._drag_context.from = dhtmlx.DragControl.getMaster(g);
        if (a.onDrop && a != this) {
            return a.onDrop(g, c, j, h)
        }
        c.appendChild(g)
    },
    onDrag: function (c, g) {
        var a = this._drag_masters[c.dhx_drag];
        if (a.onDrag && a != this) {
            return a.onDrag(c, g)
        }
        dhtmlx.DragControl._drag_context = {
            source: c,
            from: c
        };
        return "<div style='" + c.style.cssText + "'>" + c.innerHTML + "</div>"
    }
};
dhtmlx.DragItem = {
    _init: function () {
        dhtmlx.assert(this.move, "DragItem :: Component doesn't have DataMove interface");
        dhtmlx.assert(this.locate, "DragItem :: Component doesn't have RenderStack interface");
        dhtmlx.assert(dhtmlx.DragControl, "DragItem :: DragControl is not included");
        if (!this._settings || this._settings.drag) {
            dhtmlx.DragItem._initHandlers(this)
        } else {
            if (this._settings) {
                this.drag_setter = function (a) {
                    if (a) {
                        this._initHandlers(this);
                        delete this.drag_setter
                    }
                    return a
                }
            }
        }
        if (this.dragMarker) {
            this.attachEvent("onBeforeDragIn", this.dragMarker);
            this.attachEvent("onDragOut", this.dragMarker)
        }
    },
    _initHandlers: function (a) {
        dhtmlx.DragControl.addDrop(a._obj, a, true);
        dhtmlx.DragControl.addDrag(a._obj, a)
    },
    onDragIn: function (h, g, j) {
        var m = this.locate(j) || null;
        var c = dhtmlx.DragControl._drag_context;
        var l = dhtmlx.DragControl.getMaster(h);
        var a = (this._locateHTML(m) || this._obj);
        if (a == dhtmlx.DragControl._landing) {
            return a
        }
        c.target = m;
        c.to = l;
        if (!this.callEvent("onBeforeDragIn", [c, j])) {
            c.id = null;
            return null
        }
        dhtmlx.html.addCss(a, "dhx_drag_over");
        return a
    },
    onDragOut: function (h, g, m, j) {
        var l = this.locate(j) || null;
        if (m != this._dataobj) {
            l = null
        }
        var c = (this._locateHTML(l) || (m ? dhtmlx.DragControl.getMaster(m)._obj : window.undefined));
        if (c == dhtmlx.DragControl._landing) {
            return null
        }
        var a = dhtmlx.DragControl._drag_context;
        dhtmlx.html.removeCss(dhtmlx.DragControl._landing, "dhx_drag_over");
        a.target = a.to = null;
        this.callEvent("onDragOut", [a, j]);
        return null
    },
    onDrop: function (g, c, j, h) {
        var a = dhtmlx.DragControl._drag_context;
        a.to = this;
        a.index = a.target ? this.indexById(a.target) : this.dataCount();
        a.new_id = dhtmlx.uid();
        if (!this.callEvent("onBeforeDrop", [a, h])) {
            return
        }
        if (a.from == a.to) {
            this.move(a.source, a.index)
        } else {
            if (a.from) {
                a.from.move(a.source, a.index, a.to, a.new_id)
            } else {
                dhtmlx.error("Unsopported d-n-d combination")
            }
        }
        this.callEvent("onAfterDrop", [a, h])
    },
    onDrag: function (g, j) {
        var l = this.locate(j);
        var h = [l];
        if (l) {
            if (this.getSelected) {
                var c = this.getSelected();
                if (dhtmlx.PowerArray.find.call(c, l) != -1) {
                    h = c
                }
            }
            var a = dhtmlx.DragControl._drag_context = {
                source: h,
                start: l
            };
            a.from = this;
            if (this.callEvent("onBeforeDrag", [a, j])) {
                return a.html || this._toHTML(this.get(l))
            }
        }
        return null
    }
};
dhtmlx.EditAbility = {
    _init: function (a) {
        this._edit_id = null;
        this._edit_bind = null;
        dhtmlx.assert(this.data, "EditAbility :: Component doesn't have DataStore");
        dhtmlx.assert(this._locateHTML, "EditAbility :: Component doesn't have RenderStack");
        this.attachEvent("onEditKeyPress", function (g, h, c) {
            if (g == 13 && !c) {
                this.stopEdit()
            } else {
                if (g == 27) {
                    this.stopEdit(true)
                }
            }
        });
        this.attachEvent("onBeforeRender", function () {
            this.stopEdit()
        })
    },
    isEdit: function () {
        return this._edit_id
    },
    edit: function (c) {
        if (this.stopEdit(false, c)) {
            if (!this.callEvent("onBeforeEditStart", [c])) {
                return
            }
            var a = this.data.get(c);
            if (a.$template) {
                return
            }
            a.$template = "edit";
            this.data.refresh(c);
            this._edit_id = c;
            this._save_binding(c);
            this._edit_bind(true, a);
            this.callEvent("onAfterEditStart", [c])
        }
    },
    stopEdit: function (g, j) {
        if (!this._edit_id) {
            return true
        }
        if (this._edit_id == j) {
            return false
        }
        var a = {};
        if (!g) {
            this._edit_bind(false, a)
        } else {
            a = null
        }
        if (!this.callEvent("onBeforeEditStop", [this._edit_id, a])) {
            return false
        }
        var c = this.data.get(this._edit_id);
        c.$template = null;
        if (!g) {
            this._edit_bind(false, c)
        }
        var h = this._edit_id;
        this._edit_bind = this._edit_id = null;
        this.data.refresh(h);
        this.callEvent("onAfterEditStop", [h, a]);
        return true
    },
    _save_binding: function (n) {
        var a = this._locateHTML(n);
        var g = "";
        var l = "";
        var j = [];
        if (a) {
            var h = a.getElementsByTagName("*");
            var m = "";
            for (var c = 0; c < h.length; c++) {
                if (h[c].nodeType == 1 && (m = h[c].getAttribute("bind"))) {
                    g += "els[" + j.length + "].value=" + m + ";";
                    l += m + "=els[" + j.length + "].value;";
                    j.push(h[c]);
                    h[c].className += " dhx_allow_selection";
                    h[c].onselectstart = this._block_native
                }
            }
            h = null
        }
        g = Function("obj", "els", g);
        l = Function("obj", "els", l);
        this._edit_bind = function (q, o) {
            if (q) {
                g(o, j);
                if (j.length && j[0].select) {
                    j[0].select()
                }
            } else {
                l(o, j)
            }
        }
    },
    _block_native: function (a) {
        (a || event).cancelBubble = true;
        return true
    }
};
dhtmlx.SelectionModel = {
    _init: function () {
        this._selected = dhtmlx.toArray();
        dhtmlx.assert(this.data, "SelectionModel :: Component doesn't have DataStore");
        this.data.attachEvent("onStoreUpdated", dhtmlx.bind(this._data_updated, this));
        this.data.attachEvent("onStoreLoad", dhtmlx.bind(this._data_loaded, this));
        this.data.attachEvent("onAfterFilter", dhtmlx.bind(this._data_filtered, this));
        this.data.attachEvent("onIdChange", dhtmlx.bind(this._id_changed, this))
    },
    _id_changed: function (g, a) {
        for (var c = this._selected.length - 1; c >= 0; c--) {
            if (this._selected[c] == g) {
                this._selected[c] = a
            }
        }
    },
    _data_filtered: function () {
        for (var a = this._selected.length - 1; a >= 0; a--) {
            if (this.data.indexById(this._selected[a]) < 0) {
                var g = this._selected[a]
            }
            var c = this.item(g);
            if (c) {
                delete c.$selected
            }
            this._selected.splice(a, 1);
            this.callEvent("onSelectChange", [g])
        }
    },
    _data_updated: function (g, c, a) {
        if (a == "delete") {
            this._selected.remove(g)
        } else {
            if (!this.data.dataCount() && !this.data._filter_order) {
                this._selected = dhtmlx.toArray()
            }
        }
    },
    _data_loaded: function () {
        if (this._settings.select) {
            this.data.each(function (a) {
                if (a.$selected) {
                    this.select(a.id)
                }
            }, this)
        }
    },
    _select_mark: function (g, c, a) {
        if (!a && !this.callEvent("onBeforeSelect", [g, c])) {
            return false
        }
        this.data.item(g).$selected = c;
        if (a) {
            a.push(g)
        } else {
            if (c) {
                this._selected.push(g)
            } else {
                this._selected.remove(g)
            }
            this._refresh_selection(g)
        }
        return true
    },
    select: function (h, g, a) {
        if (!h) {
            return this.selectAll()
        }
        if (h instanceof Array) {
            for (var c = 0; c < h.length; c++) {
                this.select(h[c], g, a)
            }
            return
        }
        if (!this.data.exists(h)) {
            dhtmlx.error("Incorrect id in select command: " + h);
            return
        }
        if (a && this._selected.length) {
            return this.selectAll(this._selected[this._selected.length - 1], h)
        }
        if (!g && (this._selected.length != 1 || this._selected[0] != h)) {
            this._silent_selection = true;
            this.unselectAll();
            this._silent_selection = false
        }
        if (this.isSelected(h)) {
            if (g) {
                this.unselect(h)
            }
            return
        }
        if (this._select_mark(h, true)) {
            this.callEvent("onAfterSelect", [h])
        }
    },
    unselect: function (a) {
        if (!a) {
            return this.unselectAll()
        }
        if (!this.isSelected(a)) {
            return
        }
        this._select_mark(a, false)
    },
    selectAll: function (h, g) {
        var a;
        var c = [];
        if (h || g) {
            a = this.data.getRange(h || null, g || null)
        } else {
            a = this.data.getRange()
        }
        a.each(function (j) {
            var l = this.data.item(j.id);
            if (!l.$selected) {
                this._selected.push(j.id);
                this._select_mark(j.id, true, c)
            }
            return j.id
        }, this);
        this._refresh_selection(c)
    },
    unselectAll: function () {
        var a = [];
        this._selected.each(function (c) {
            this._select_mark(c, false, a)
        }, this);
        this._selected = dhtmlx.toArray();
        this._refresh_selection(a)
    },
    isSelected: function (a) {
        return this._selected.find(a) != -1
    },
    getSelected: function (a) {
        switch (this._selected.length) {
        case 0:
            return a ? [] : "";
        case 1:
            return a ? [this._selected[0]] : this._selected[0];
        default:
            return ([].concat(this._selected))
        }
    },
    _is_mass_selection: function (a) {
        return a.length > 100 || a.length > this.data.dataCount / 2
    },
    _refresh_selection: function (c) {
        if (typeof c != "object") {
            c = [c]
        }
        if (!c.length) {
            return
        }
        if (this._is_mass_selection(c)) {
            this.data.refresh()
        } else {
            for (var a = 0; a < c.length; a++) {
                this.render(c[a], this.data.item(c[a]), "update")
            }
        }
        if (!this._silent_selection) {
            this.callEvent("onSelectChange", [c])
        }
    }
};
dhtmlx.RenderStack = {
    _init: function () {
        dhtmlx.assert(this.data, "RenderStack :: Component doesn't have DataStore");
        dhtmlx.assert(dhtmlx.Template, "dhtmlx.Template :: dhtmlx.Template is not accessible");
        this._html = document.createElement("DIV")
    },
    _toHTML: function (a) {
        dhtmlx.assert((!a.$template || this.type["template_" + a.$template]), "RenderStack :: Unknown template: " + a.$template);
        this.callEvent("onItemRender", [a]);
        return this.type._item_start(a, this.type) + (a.$template ? this.type["template_" + a.$template] : this.type.template)(a, this.type) + this.type._item_end
    },
    _toHTMLObject: function (a) {
        this._html.innerHTML = this._toHTML(a);
        return this._html.firstChild
    },
    _locateHTML: function (a) {
        if (this._htmlmap) {
            return this._htmlmap[a]
        }
        this._htmlmap = {};
        var g = this._dataobj.childNodes;
        for (var c = 0; c < g.length; c++) {
            var h = g[c].getAttribute(this._id);
            if (h) {
                this._htmlmap[h] = g[c]
            }
        }
        return this._locateHTML(a)
    },
    locate: function (a) {
        return dhtmlx.html.locate(a, this._id)
    },
    show: function (c) {
        var a = this._locateHTML(c);
        if (a) {
            this._dataobj.scrollTop = a.offsetTop - this._dataobj.offsetTop
        }
    },
    render: function (l, h, g, j) {
        if (l) {
            var a = this._locateHTML(l);
            switch (g) {
            case "update":
                if (!a) {
                    return
                }
                var c = this._htmlmap[l] = this._toHTMLObject(h);
                dhtmlx.html.insertBefore(c, a);
                dhtmlx.html.remove(a);
                break;
            case "delete":
                if (!a) {
                    return
                }
                dhtmlx.html.remove(a);
                delete this._htmlmap[l];
                break;
            case "add":
                var c = this._htmlmap[l] = this._toHTMLObject(h);
                dhtmlx.html.insertBefore(c, this._locateHTML(this.data.next(l)), this._dataobj);
                break;
            case "move":
                this.render(l, h, "delete");
                this.render(l, h, "add");
                break;
            default:
                dhtmlx.error("Unknown render command: " + g);
                break
            }
        } else {
            if (this.callEvent("onBeforeRender", [this.data])) {
                this._dataobj.innerHTML = this.data.getRange().map(this._toHTML, this).join("");
                this._htmlmap = null
            }
        }
        this.callEvent("onAfterRender", [])
    },
    pager_setter: function (c) {
        this.attachEvent("onBeforeRender", function () {
            var h = this._settings.pager._settings;
            if (h.page == -1) {
                return false
            }
            this.data.min = h.page * h.size;
            this.data.max = (h.page + 1) * h.size - 1;
            return true
        });
        var a = new dhtmlx.ui.pager(c);
        var g = dhtmlx.bind(function () {
            this.data.refresh()
        }, this);
        a.attachEvent("onRefresh", g);
        this.data.attachEvent("onStoreUpdated", function (j) {
            var h = this.dataCount();
            if (h != a._settings.count) {
                a._settings.count = h;
                if (a._settings.page == -1) {
                    a._settings.page = 0
                }
                a.refresh()
            }
        });
        return a
    },
    height_setter: function (a) {
        if (a == "auto") {
            this.attachEvent("onAfterRender", this._correct_height);
            dhtmlx.event(window, "resize", dhtmlx.bind(this._correct_height, this))
        }
        return a
    },
    _correct_height: function () {
        this._dataobj.style.overflow = "hidden";
        this._dataobj.style.height = "1px";
        var a = this._dataobj.scrollHeight;
        this._dataobj.style.height = a + "px";
        if (dhtmlx._isFF) {
            var c = this._dataobj.scrollHeight;
            if (c != a) {
                this._dataobj.style.height = c + "px"
            }
        }
        this._obj.style.height = this._dataobj.style.height
    },
    _getDimension: function () {
        var a = this.type;
        var c = (a.border || 0) + (a.padding || 0) * 2 + (a.margin || 0) * 2;
        return {
            x: a.width + c,
            y: a.height + c
        }
    },
    x_count_setter: function (c) {
        var g = this._getDimension();
        var a = dhtmlx.$customScroll ? 0 : 18;
        this._dataobj.style.width = g.x * c + (this._settings.height != "auto" ? a : 0) + "px";
        return c
    },
    y_count_setter: function (a) {
        var c = this._getDimension();
        this._dataobj.style.height = c.y * a + "px";
        return a
    }
};
dhtmlx.VirtualRenderStack = {
    _init: function () {
        dhtmlx.assert(this.render, "VirtualRenderStack :: Object must use RenderStack first");
        this._htmlmap = {};
        this._dataobj.style.overflowY = "scroll";
        dhtmlx.event(this._dataobj, "scroll", dhtmlx.bind(this._render_visible_rows, this));
        dhtmlx.event(window, "resize", dhtmlx.bind(function () {
            this.render()
        }, this));
        this.data._unrendered_area = [];
        this.data.getIndexRange = this._getIndexRange
    },
    _locateHTML: function (a) {
        return this._htmlmap[a]
    },
    show: function (g) {
        range = this._getVisibleRange();
        var c = this.data.indexById(g);
        var a = Math.floor(c / range._dx) * range._y;
        this._dataobj.scrollTop = a
    },
    _getIndexRange: function (j, h) {
        if (h !== 0) {
            h = Math.min((h || Infinity), this.dataCount() - 1)
        }
        var a = dhtmlx.toArray();
        for (var c = (j || 0); c <= h; c++) {
            var g = this.item(this.order[c]);
            if (this.order.length > c) {
                if (!g) {
                    this.order[c] = dhtmlx.uid();
                    g = {
                        id: this.order[c],
                        $template: "loading"
                    };
                    this._unrendered_area.push(this.order[c])
                } else {
                    if (g.$template == "loading") {
                        this._unrendered_area.push(this.order[c])
                    }
                }
                a.push(g)
            }
        }
        return a
    },
    render: function (l, h, g, j) {
        if (l) {
            var a = this._locateHTML(l);
            switch (g) {
            case "update":
                if (!a) {
                    return
                }
                var c = this._htmlmap[l] = this._toHTMLObject(h);
                dhtmlx.html.insertBefore(c, a);
                dhtmlx.html.remove(a);
                break;
            default:
                this._render_delayed();
                break
            }
        } else {
            if (this.callEvent("onBeforeRender", [this.data])) {
                this._htmlmap = {};
                this._render_visible_rows(null, true);
                this._wait_for_render = false;
                this.callEvent("onAfterRender", [])
            }
        }
    },
    _render_delayed: function () {
        if (this._wait_for_render) {
            return
        }
        this._wait_for_render = true;
        window.setTimeout(dhtmlx.bind(function () {
            this.render()
        }, this), 1)
    },
    _create_placeholder: function (a) {
        var c = document.createElement("DIV");
        c.style.cssText = "height:" + a + "px; width:100%; overflow:hidden;";
        return c
    },
    _render_visible_rows: function (y, D) {
        this.data._unrendered_area = [];
        var x = this._getVisibleRange();
        if (!this._dataobj.firstChild || D) {
            this._dataobj.innerHTML = "";
            this._dataobj.appendChild(this._create_placeholder(x._max));
            this._htmlrows = [this._dataobj.firstChild]
        }
        var j = Math.max(x._from, 0);
        var w = (this.data.max || this.data.max === 0) ? this.data.max : Infinity;
        while (j <= x._height) {
            while (this._htmlrows[j] && this._htmlrows[j]._filled && j <= x._height) {
                j++
            }
            if (j > x._height) {
                break
            }
            var n = j;
            while (!this._htmlrows[n]) {
                n--
            }
            var a = this._htmlrows[n];
            var g = j * x._dx + (this.data.min || 0);
            if (g > w) {
                break
            }
            var l = Math.min(g + x._dx - 1, w);
            var q = this._create_placeholder(x._y);
            var m = this.data.getIndexRange(g, l);
            if (!m.length) {
                break
            }
            q.innerHTML = m.map(this._toHTML, this).join("");
            for (var u = 0; u < m.length; u++) {
                this._htmlmap[this.data.idByIndex(g + u)] = q.childNodes[u]
            }
            var v = parseInt(a.style.height, 10);
            var C = (j - n) * x._y;
            var s = (v - C - x._y);
            dhtmlx.html.insertBefore(q, C ? a.nextSibling : a, this._dataobj);
            this._htmlrows[j] = q;
            q._filled = true;
            if (C <= 0 && s > 0) {
                a.style.height = s + "px";
                this._htmlrows[j + 1] = a
            } else {
                if (C < 0) {
                    dhtmlx.html.remove(a)
                } else {
                    a.style.height = C + "px"
                }
                if (s > 0) {
                    var o = this._htmlrows[j + 1] = this._create_placeholder(s);
                    dhtmlx.html.insertBefore(o, q.nextSibling, this._dataobj)
                }
            }
            j++
        }
        if (this.data._unrendered_area.length) {
            var r = this.indexById(this.data._unrendered_area[0]);
            var c = this.indexById(this.data._unrendered_area.pop()) + 1;
            if (c > r) {
                if (!this.callEvent("onDataRequest", [r, c - r])) {
                    return false
                }
                dhtmlx.assert(this.data.feed, "Data feed is missed");
                this.data.feed.call(this, r, c - r)
            }
        }
        if (dhtmlx._isIE) {
            var A = this._getVisibleRange();
            if (A._from != x._from) {
                this._render_visible_rows()
            }
        }
    },
    _getVisibleRange: function () {
        var c = dhtmlx.$customScroll ? 0 : 18;
        var m = this._dataobj.scrollTop;
        var a = Math.max(this._dataobj.scrollWidth, this._dataobj.offsetWidth) - c;
        var n = this._dataobj.offsetHeight;
        var q = this.type;
        var h = this._getDimension();
        var r = Math.floor(a / h.x) || 1;
        var g = Math.floor(m / h.y);
        var o = Math.ceil((n + m) / h.y) - 1;
        var j = this.data.max ? (this.data.max - this.data.min) : this.data.dataCount();
        var l = Math.ceil(j / r) * h.y;
        return {
            _from: g,
            _height: o,
            _top: m,
            _max: l,
            _y: h.y,
            _dx: r
        }
    }
};
dhtmlXDataView = function (a) {
    this.name = "DataView";
    this.version = "3.0";
    if (dhtmlx.assert_enabled()) {
        this._assert()
    }
    dhtmlx.extend(this, dhtmlx.Settings);
    this._parseContainer(a, "dhx_dataview");
    dhtmlx.extend(this, dhtmlx.AtomDataLoader);
    dhtmlx.extend(this, dhtmlx.DataLoader);
    dhtmlx.extend(this, dhtmlx.EventSystem);
    dhtmlx.extend(this, dhtmlx.RenderStack);
    dhtmlx.extend(this, dhtmlx.SelectionModel);
    dhtmlx.extend(this, dhtmlx.MouseEvents);
    dhtmlx.extend(this, dhtmlx.KeyEvents);
    dhtmlx.extend(this, dhtmlx.EditAbility);
    dhtmlx.extend(this, dhtmlx.DataMove);
    dhtmlx.extend(this, dhtmlx.DragItem);
    dhtmlx.extend(this, dhtmlx.DataProcessor);
    dhtmlx.extend(this, dhtmlx.AutoTooltip);
    dhtmlx.extend(this, dhtmlx.Destruction);
    this.data.attachEvent("onStoreUpdated", dhtmlx.bind(function () {
        this.render.apply(this, arguments)
    }, this));
    this._parseSettings(a, {
        drag: false,
        edit: false,
        select: "multiselect",
        type: "default"
    });
    if (this._settings.height != "auto" && !this._settings.renderAll) {
        dhtmlx.extend(this, dhtmlx.VirtualRenderStack)
    }
    this.data.provideApi(this, true);
    if (dhtmlx.$customScroll) {
        dhtmlx.CustomScroll.enable(this)
    }
};
dhtmlXDataView.prototype = {
    bind: function () {
        dhx.BaseBind.legacyBind.apply(this, arguments)
    },
    sync: function () {
        dhx.BaseBind.legacySync.apply(this, arguments)
    },
    dragMarker: function (g, j) {
        var h = this._locateHTML(g.target);
        if (this.type.drag_marker) {
            if (this._drag_marker) {
                this._drag_marker.style.backgroundImage = "";
                this._drag_marker.style.backgroundRepeat = ""
            }
            if (h) {
                h.style.backgroundImage = "url(" + (dhtmlx.image_path || "") + this.type.drag_marker + ")";
                h.style.backgroundRepeat = "no-repeat";
                this._drag_marker = h
            }
        }
        if (h && this._settings.auto_scroll) {
            var a = h.offsetTop;
            var l = h.offsetHeight;
            var c = this._obj.scrollTop;
            var m = this._obj.offsetHeight;
            if (a - l >= 0 && a - l * 0.75 < c) {
                c = Math.max(a - l, 0)
            } else {
                if (a + l / 0.75 > c + m) {
                    c = c + l
                }
            }
            this._obj.scrollTop = c
        }
        return true
    },
    _id: "dhx_f_id",
    on_click: {
        dhx_dataview_item: function (a, c) {
            if (this.stopEdit(false, c)) {
                if (this._settings.select) {
                    if (this._settings.select == "multiselect") {
                        this.select(c, a.ctrlKey, a.shiftKey)
                    } else {
                        this.select(c)
                    }
                }
            }
        }
    },
    on_dblclick: {
        dhx_dataview_item: function (a, c) {
            if (this._settings.edit) {
                this.edit(c)
            }
        }
    },
    on_mouse_move: {},
    types: {
        "default": {
            css: "default",
            template: dhtmlx.Template.fromHTML("<div style='padding:10px; white-space:nowrap; overflow:hidden;'>{obj.text}</div>"),
            template_edit: dhtmlx.Template.fromHTML("<div style='padding:10px; white-space:nowrap; overflow:hidden;'><textarea style='width:100%; height:100%;' bind='obj.text'></textarea></div>"),
            template_loading: dhtmlx.Template.fromHTML("<div style='padding:10px; white-space:nowrap; overflow:hidden;'>Loading...</div>"),
            width: 210,
            height: 115,
            margin: 0,
            padding: 10,
            border: 1
        }
    },
    template_item_start: dhtmlx.Template.fromHTML("<div dhx_f_id='{-obj.id}' class='dhx_dataview_item dhx_dataview_{obj.css}_item{-obj.$selected?_selected:}' style='width:{obj.width}px; height:{obj.height}px; padding:{obj.padding}px; margin:{obj.margin}px; float:left; overflow:hidden;'>"),
    template_item_end: dhtmlx.Template.fromHTML("</div>")
};
dhtmlx.compat("layout");

function xmlPointer(a) {
    this.d = a
}
xmlPointer.prototype = {
    text: function () {
        if (!_isFF) {
            return this.d.xml
        }
        var a = new XMLSerializer();
        return a.serializeToString(this.d)
    },
    get: function (a) {
        return this.d.getAttribute(a)
    },
    exists: function () {
        return !!this.d
    },
    content: function () {
        return this.d.firstChild ? (this.d.firstChild.wholeText || this.d.firstChild.data) : ""
    },
    each: function (h, m, l, j) {
        var g = this.d.childNodes;
        var n = new xmlPointer();
        if (g.length) {
            for (j = j || 0; j < g.length; j++) {
                if (g[j].tagName == h) {
                    n.d = g[j];
                    if (m.apply(l, [n, j]) == -1) {
                        return
                    }
                }
            }
        }
    },
    get_all: function () {
        var g = {};
        var c = this.d.attributes;
        for (var h = 0; h < c.length; h++) {
            g[c[h].name] = c[h].value
        }
        return g
    },
    sub: function (h) {
        var g = this.d.childNodes;
        var l = new xmlPointer();
        if (g.length) {
            for (var j = 0; j < g.length; j++) {
                if (g[j].tagName == h) {
                    l.d = g[j];
                    return l
                }
            }
        }
    },
    up: function (a) {
        return new xmlPointer(this.d.parentNode)
    },
    set: function (a, c) {
        this.d.setAttribute(a, c)
    },
    clone: function (a) {
        return new xmlPointer(this.d)
    },
    sub_exists: function (g) {
        var c = this.d.childNodes;
        if (c.length) {
            for (var h = 0; h < c.length; h++) {
                if (c[h].tagName == g) {
                    return true
                }
            }
        }
        return false
    },
    through: function (g, m, q, j, r) {
        var n = this.d.childNodes;
        if (n.length) {
            for (var h = 0; h < n.length; h++) {
                if (n[h].tagName == g && n[h].getAttribute(m) != null && n[h].getAttribute(m) != "" && (!q || n[h].getAttribute(m) == q)) {
                    var l = new xmlPointer(n[h]);
                    j.apply(r, [l, h])
                }
                var o = this.d;
                this.d = n[h];
                this.through(g, m, q, j, r);
                this.d = o
            }
        }
    }
};

function dhtmlXTreeObject(l, h, c, a) {
    if (_isIE) {
        try {
            document.execCommand("BackgroundImageCache", false, true)
        } catch (j) {}
    }
    if (typeof (l) != "object") {
        this.parentObject = document.getElementById(l)
    } else {
        this.parentObject = l
    }
    this.parentObject.style.overflow = "hidden";
    this._itim_dg = true;
    this.dlmtr = ",";
    this.dropLower = false;
    this.enableIEImageFix();
    this.xmlstate = 0;
    this.mytype = "tree";
    this.smcheck = true;
    this.width = h;
    this.height = c;
    this.rootId = a;
    this.childCalc = null;
    this.def_img_x = "18px";
    this.def_img_y = "18px";
    this.def_line_img_x = "18px";
    this.def_line_img_y = "24px";
    this._dragged = new Array();
    this._selected = new Array();
    this.style_pointer = "pointer";
    this._aimgs = true;
    this.htmlcA = " [";
    this.htmlcB = "]";
    this.lWin = window;
    this.cMenu = 0;
    this.mlitems = 0;
    this.iconURL = "";
    this.dadmode = 0;
    this.slowParse = false;
    this.autoScroll = true;
    this.hfMode = 0;
    this.nodeCut = new Array();
    this.XMLsource = 0;
    this.XMLloadingWarning = 0;
    this._idpull = {};
    this._pullSize = 0;
    this.treeLinesOn = true;
    this.tscheck = false;
    this.timgen = true;
    this.dpcpy = false;
    this._ld_id = null;
    this._oie_onXLE = [];
    this.imPath = window.dhx_globalImgPath || "";
    this.checkArray = new Array("iconUncheckAll.gif", "iconCheckAll.gif", "iconCheckGray.gif", "iconUncheckDis.gif", "iconCheckDis.gif", "iconCheckDis.gif");
    this.radioArray = new Array("radio_off.gif", "radio_on.gif", "radio_on.gif", "radio_off.gif", "radio_on.gif", "radio_on.gif");
    this.lineArray = new Array("line2.gif", "line3.gif", "line4.gif", "blank.gif", "blank.gif", "line1.gif");
    this.minusArray = new Array("minus2.gif", "minus3.gif", "minus4.gif", "minus.gif", "minus5.gif");
    this.plusArray = new Array("plus2.gif", "plus3.gif", "plus4.gif", "plus.gif", "plus5.gif");
    this.imageArray = new Array("leaf.gif", "folderOpen.gif", "folderClosed.gif");
    this.cutImg = new Array(0, 0, 0);
    this.cutImage = "but_cut.gif";
    dhtmlxEventable(this);
    this.dragger = new dhtmlDragAndDropObject();
    this.htmlNode = new dhtmlXTreeItemObject(this.rootId, "", 0, this);
    this.htmlNode.htmlNode.childNodes[0].childNodes[0].style.display = "none";
    this.htmlNode.htmlNode.childNodes[0].childNodes[0].childNodes[0].className = "hiddenRow";
    this.allTree = this._createSelf();
    this.allTree.appendChild(this.htmlNode.htmlNode);
    if (dhtmlx.$customScroll) {
        dhtmlx.CustomScroll.enable(this)
    }
    if (_isFF) {
        this.allTree.childNodes[0].width = "100%";
        this.allTree.childNodes[0].style.overflow = "hidden"
    }
    var g = this;
    this.allTree.onselectstart = new Function("return false;");
    if (_isMacOS) {
        this.allTree.oncontextmenu = function (m) {
            return g._doContClick(m || window.event, true)
        }
    }
    this.allTree.onmousedown = function (m) {
        return g._doContClick(m || window.event)
    };
    this.XMLLoader = new dtmlXMLLoaderObject(this._parseXMLTree, this, true, this.no_cashe);
    if (_isIE) {
        this.preventIECashing(true)
    }
    this.selectionBar = document.createElement("DIV");
    this.selectionBar.className = "selectionBar";
    this.selectionBar.innerHTML = "&nbsp;";
    this.selectionBar.style.display = "none";
    this.allTree.appendChild(this.selectionBar);
    if (window.addEventListener) {
        window.addEventListener("unload", function () {
            try {
                g.destructor()
            } catch (m) {}
        }, false)
    }
    if (window.attachEvent) {
        window.attachEvent("onunload", function () {
            try {
                g.destructor()
            } catch (m) {}
        })
    }
    this.setImagesPath = this.setImagePath;
    this.setIconsPath = this.setIconPath;
    if (dhtmlx.image_path) {
        this.setImagePath(dhtmlx.image_path)
    }
    if (dhtmlx.skin) {
        this.setSkin(dhtmlx.skin)
    }
    return this
}
dhtmlXTreeObject.prototype.setDataMode = function (a) {
    this._datamode = a
};
dhtmlXTreeObject.prototype._doContClick = function (m, a) {
    if (!a && m.button != 2) {
        if (this._acMenu) {
            if (this._acMenu.hideContextMenu) {
                this._acMenu.hideContextMenu()
            } else {
                this.cMenu._contextEnd()
            }
        }
        return true
    }
    var c = (_isIE ? m.srcElement : m.target);
    while ((c) && (c.tagName != "BODY")) {
        if (c.parentObject) {
            break
        }
        c = c.parentNode
    }
    if ((!c) || (!c.parentObject)) {
        return true
    }
    var j = c.parentObject;
    if (!this.callEvent("onRightClick", [j.id, m])) {
        (m.srcElement || m.target).oncontextmenu = function (q) {
            (q || event).cancelBubble = true;
            return false
        }
    }
    this._acMenu = (j.cMenu || this.cMenu);
    if (this._acMenu) {
        if (!(this.callEvent("onBeforeContextMenu", [j.id]))) {
            return true
        }
        if (!_isMacOS) {
            (m.srcElement || m.target).oncontextmenu = function (q) {
                (q || event).cancelBubble = true;
                return false
            }
        }
        if (this._acMenu.showContextMenu) {
            var h = window.document.documentElement;
            var g = window.document.body;
            var n = new Array((h.scrollLeft || g.scrollLeft), (h.scrollTop || g.scrollTop));
            if (_isIE) {
                var o = m.clientX + n[0];
                var l = m.clientY + n[1]
            } else {
                var o = m.pageX;
                var l = m.pageY
            }
            this._acMenu.showContextMenu(o - 1, l - 1);
            this.contextID = j.id;
            m.cancelBubble = true;
            this._acMenu._skip_hide = true
        } else {
            c.contextMenuId = j.id;
            c.contextMenu = this._acMenu;
            c.a = this._acMenu._contextStart;
            c.a(c, m);
            c.a = null
        }
        return false
    }
    return true
};
dhtmlXTreeObject.prototype.enableIEImageFix = function (a) {
    if (!a) {
        this._getImg = function (c) {
            return document.createElement((c == this.rootId) ? "div" : "img")
        };
        this._setSrc = function (g, c) {
            g.src = c
        };
        this._getSrc = function (c) {
            return c.src
        }
    } else {
        this._getImg = function () {
            var c = document.createElement("DIV");
            c.innerHTML = "&nbsp;";
            c.className = "dhx_bg_img_fix";
            return c
        };
        this._setSrc = function (g, c) {
            g.style.backgroundImage = "url(" + c + ")"
        };
        this._getSrc = function (c) {
            var g = c.style.backgroundImage;
            return g.substr(4, g.length - 5).replace(/(^")|("$)/g, "")
        }
    }
};
dhtmlXTreeObject.prototype.destructor = function () {
    for (var c in this._idpull) {
        var g = this._idpull[c];
        if (!g) {
            continue
        }
        g.parentObject = null;
        g.treeNod = null;
        g.childNodes = null;
        g.span = null;
        g.tr.nodem = null;
        g.tr = null;
        g.htmlNode.objBelong = null;
        g.htmlNode = null;
        this._idpull[c] = null
    }
    this.parentObject.innerHTML = "";
    if (this.XMLLoader) {
        this.XMLLoader.destructor()
    }
    this.allTree.onselectstart = null;
    this.allTree.oncontextmenu = null;
    this.allTree.onmousedown = null;
    for (var c in this) {
        this[c] = null
    }
};

function cObject() {
    return this
}
cObject.prototype = new Object;
cObject.prototype.clone = function () {
    function a() {}
    a.prototype = this;
    return new a()
};

function dhtmlXTreeItemObject(l, c, g, a, h, j) {
    this.htmlNode = "";
    this.acolor = "";
    this.scolor = "";
    this.tr = 0;
    this.childsCount = 0;
    this.tempDOMM = 0;
    this.tempDOMU = 0;
    this.dragSpan = 0;
    this.dragMove = 0;
    this.span = 0;
    this.closeble = 1;
    this.childNodes = new Array();
    this.userData = new cObject();
    this.checkstate = 0;
    this.treeNod = a;
    this.label = c;
    this.parentObject = g;
    this.actionHandler = h;
    this.images = new Array(a.imageArray[0], a.imageArray[1], a.imageArray[2]);
    this.id = a._globalIdStorageAdd(l, this);
    if (this.treeNod.checkBoxOff) {
        this.htmlNode = this.treeNod._createItem(1, this, j)
    } else {
        this.htmlNode = this.treeNod._createItem(0, this, j)
    }
    this.htmlNode.objBelong = this;
    return this
}
dhtmlXTreeObject.prototype._globalIdStorageAdd = function (c, a) {
    if (this._globalIdStorageFind(c, 1, 1)) {
        c = c + "_" + (new Date()).valueOf();
        return this._globalIdStorageAdd(c, a)
    }
    this._idpull[c] = a;
    this._pullSize++;
    return c
};
dhtmlXTreeObject.prototype._globalIdStorageSub = function (a) {
    if (this._idpull[a]) {
        this._unselectItem(this._idpull[a]);
        this._idpull[a] = null;
        this._pullSize--
    }
    if ((this._locker) && (this._locker[a])) {
        this._locker[a] = false
    }
};
dhtmlXTreeObject.prototype._globalIdStorageFind = function (m, a, g, h) {
    var l = this._idpull[m];
    if (l) {
        if ((l.unParsed) && (!g)) {
            this.reParse(l, 0)
        }
        if (this._srnd && !l.htmlNode) {
            this._buildSRND(l, g)
        }
        if ((h) && (this._edsbpsA)) {
            for (var c = 0; c < this._edsbpsA.length; c++) {
                if (this._edsbpsA[c][2] == m) {
                    dhtmlxError.throwError("getItem", "Requested item still in parsing process.", m);
                    return null
                }
            }
        }
        return l
    }
    if ((this.slowParse) && (m != 0) && (!a)) {
        return this.preParse(m)
    } else {
        return null
    }
};
dhtmlXTreeObject.prototype._getSubItemsXML = function (a) {
    var c = [];
    a.each("item", function (g) {
        c.push(g.get("id"))
    }, this);
    return c.join(this.dlmtr)
};
dhtmlXTreeObject.prototype.enableSmartXMLParsing = function (a) {
    this.slowParse = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.findXML = function (c, a, g) {};
dhtmlXTreeObject.prototype._getAllCheckedXML = function (c, a, h) {
    var g = [];
    if (h == 2) {
        c.through("item", "checked", -1, function (j) {
            g.push(j.get("id"))
        }, this)
    }
    if (h == 1) {
        c.through("item", "id", null, function (j) {
            if (j.get("checked") && (j.get("checked") != -1)) {
                g.push(j.get("id"))
            }
        }, this)
    }
    if (h == 0) {
        c.through("item", "id", null, function (j) {
            if (!j.get("checked") || j.get("checked") == 0) {
                g.push(j.get("id"))
            }
        }, this)
    }
    if (g.length) {
        return a + (a ? this.dlmtr : "") + g.join(this.dlmtr)
    }
    if (a) {
        return a
    } else {
        return ""
    }
};
dhtmlXTreeObject.prototype._setSubCheckedXML = function (a, c) {
    var g = a ? "1" : "";
    c.through("item", "id", null, function (h) {
        if (!h.get("disabled") || h.get("disabled") == 0) {
            h.set("checked", g)
        }
    }, this)
};
dhtmlXTreeObject.prototype._getAllScraggyItemsXML = function (g, a) {
    var h = [];
    var c = function (j) {
            if (!j.sub_exists("item")) {
                h.push(j.get("id"))
            } else {
                j.each("item", c, this)
            }
        };
    c(g);
    return h.join(",")
};
dhtmlXTreeObject.prototype._getAllFatItemsXML = function (g, a) {
    var h = [];
    var c = function (j) {
            if (!j.sub_exists("item")) {
                return
            }
            h.push(j.get("id"));
            j.each("item", c, this)
        };
    c(g);
    return h.join(",")
};
dhtmlXTreeObject.prototype._getAllSubItemsXML = function (g, c, a) {
    var c = [];
    a.through("item", "id", null, function (h) {
        c.push(h.get("id"))
    }, this);
    return c.join(",")
};
dhtmlXTreeObject.prototype.reParse = function (g) {
    var l = this;
    if (!this.parsCount) {
        l.callEvent("onXLS", [l, g.id])
    }
    this.xmlstate = 1;
    var h = g.unParsed;
    g.unParsed = 0;
    this.XMLloadingWarning = 1;
    var a = this.parsingOn;
    var m = this.waitUpdateXML;
    var o = this.parsedArray;
    this.parsedArray = new Array();
    this.waitUpdateXML = false;
    this.parsingOn = g.id;
    this.parsedArray = new Array();
    this.setCheckList = "";
    this._parse(h, g.id, 2);
    var q = this.setCheckList.split(this.dlmtr);
    for (var j = 0; j < this.parsedArray.length; j++) {
        g.htmlNode.childNodes[0].appendChild(this.parsedArray[j])
    }
    if (h.get("order") && h.get("order") != "none") {
        this._reorderBranch(g, h.get("order"), true)
    }
    this.oldsmcheck = this.smcheck;
    this.smcheck = false;
    for (var c = 0; c < q.length; c++) {
        if (q[c]) {
            this.setCheck(q[c], 1)
        }
    }
    this.smcheck = this.oldsmcheck;
    this.parsingOn = a;
    this.waitUpdateXML = m;
    this.parsedArray = o;
    this.XMLloadingWarning = 0;
    this._redrawFrom(this, g);
    if (this._srnd && !g._sready) {
        this.prepareSR(g.id)
    }
    this.xmlstate = 0;
    return true
};
dhtmlXTreeObject.prototype.preParse = function (c) {
    if (!c || !this._p) {
        return null
    }
    var a = false;
    this._p.clone().through("item", "id", c, function (h) {
        this._globalIdStorageFind(h.up().get("id"));
        return a = true
    }, this);
    if (a) {
        var g = this._globalIdStorageFind(c, true, false);
        if (!g) {
            dhtmlxError.throwError("getItem", "The item " + c + " not operable. Seems you have non-unique|incorrect IDs in tree's XML.", c)
        }
    }
    return g
};
dhtmlXTreeObject.prototype._escape = function (a) {
    switch (this.utfesc) {
    case "none":
        return a;
        break;
    case "utf8":
        return encodeURIComponent(a);
        break;
    default:
        return escape(a);
        break
    }
};
dhtmlXTreeObject.prototype._drawNewTr = function (j, g) {
    var h = document.createElement("tr");
    var c = document.createElement("td");
    var a = document.createElement("td");
    c.appendChild(document.createTextNode(" "));
    a.colSpan = 3;
    a.appendChild(j);
    h.appendChild(c);
    h.appendChild(a);
    return h
};
dhtmlXTreeObject.prototype.loadXMLString = function (g, c) {
    var a = this;
    if (!this.parsCount) {
        this.callEvent("onXLS", [a, null])
    }
    this.xmlstate = 1;
    if (c) {
        this.XMLLoader.waitCall = c
    }
    this.XMLLoader.loadXMLString(g)
};
dhtmlXTreeObject.prototype.loadXML = function (a, g) {
    if (this._datamode && this._datamode != "xml") {
        return this["load" + this._datamode.toUpperCase()](a, g)
    }
    var c = this;
    if (!this.parsCount) {
        this.callEvent("onXLS", [c, this._ld_id])
    }
    this._ld_id = null;
    this.xmlstate = 1;
    this.XMLLoader = new dtmlXMLLoaderObject(this._parseXMLTree, this, true, this.no_cashe);
    if (g) {
        this.XMLLoader.waitCall = g
    }
    this.XMLLoader.loadXML(a)
};
dhtmlXTreeObject.prototype._attachChildNode = function (m, l, h, o, D, C, A, q, g, u, v) {
    if (u && u.parentObject) {
        m = u.parentObject
    }
    if (((m.XMLload == 0) && (this.XMLsource)) && (!this.XMLloadingWarning)) {
        m.XMLload = 1;
        this._loadDynXML(m.id)
    }
    var r = m.childsCount;
    var E = m.childNodes;
    if (v && v.tr.previousSibling) {
        if (v.tr.previousSibling.previousSibling) {
            u = v.tr.previousSibling.nodem
        } else {
            q = q.replace("TOP", "") + ",TOP"
        }
    }
    if (u) {
        var j, y;
        for (j = 0; j < r; j++) {
            if (E[j] == u) {
                for (y = r; y != j; y--) {
                    E[1 + y] = E[y]
                }
                break
            }
        }
        j++;
        r = j
    }
    if (q) {
        var w = q.split(",");
        for (var x = 0; x < w.length; x++) {
            switch (w[x]) {
            case "TOP":
                if (m.childsCount > 0) {
                    u = new Object;
                    u.tr = m.childNodes[0].tr.previousSibling
                }
                m._has_top = true;
                for (j = r; j > 0; j--) {
                    E[j] = E[j - 1]
                }
                r = 0;
                break
            }
        }
    }
    var s;
    if (!(s = this._idpull[l]) || s.span != -1) {
        s = E[r] = new dhtmlXTreeItemObject(l, h, m, this, o, 1);
        l = E[r].id;
        m.childsCount++
    }
    if (!s.htmlNode) {
        s.label = h;
        s.htmlNode = this._createItem((this.checkBoxOff ? 1 : 0), s);
        s.htmlNode.objBelong = s
    }
    if (D) {
        s.images[0] = D
    }
    if (C) {
        s.images[1] = C
    }
    if (A) {
        s.images[2] = A
    }
    var c = this._drawNewTr(s.htmlNode);
    if ((this.XMLloadingWarning) || (this._hAdI)) {
        s.htmlNode.parentNode.parentNode.style.display = "none"
    }
    if ((u) && u.tr && (u.tr.nextSibling)) {
        m.htmlNode.childNodes[0].insertBefore(c, u.tr.nextSibling)
    } else {
        if (this.parsingOn == m.id) {
            this.parsedArray[this.parsedArray.length] = c
        } else {
            m.htmlNode.childNodes[0].appendChild(c)
        }
    }
    if ((u) && (!u.span)) {
        u = null
    }
    if (this.XMLsource) {
        if ((g) && (g != 0)) {
            s.XMLload = 0
        } else {
            s.XMLload = 1
        }
    }
    s.tr = c;
    c.nodem = s;
    if (m.itemId == 0) {
        c.childNodes[0].className = "hiddenRow"
    }
    if ((m._r_logic) || (this._frbtr)) {
        this._setSrc(s.htmlNode.childNodes[0].childNodes[0].childNodes[1].childNodes[0], this.imPath + this.radioArray[0])
    }
    if (q) {
        var w = q.split(",");
        for (var x = 0; x < w.length; x++) {
            switch (w[x]) {
            case "SELECT":
                this.selectItem(l, false);
                break;
            case "CALL":
                this.selectItem(l, true);
                break;
            case "CHILD":
                s.XMLload = 0;
                break;
            case "CHECKED":
                if (this.XMLloadingWarning) {
                    this.setCheckList += this.dlmtr + l
                } else {
                    this.setCheck(l, 1)
                }
                break;
            case "HCHECKED":
                this._setCheck(s, "unsure");
                break;
            case "OPEN":
                s.openMe = 1;
                break
            }
        }
    }
    if (!this.XMLloadingWarning) {
        if ((this._getOpenState(m) < 0) && (!this._hAdI)) {
            this.openItem(m.id)
        }
        if (u) {
            this._correctPlus(u);
            this._correctLine(u)
        }
        this._correctPlus(m);
        this._correctLine(m);
        this._correctPlus(s);
        if (m.childsCount >= 2) {
            this._correctPlus(E[m.childsCount - 2]);
            this._correctLine(E[m.childsCount - 2])
        }
        if (m.childsCount != 2) {
            this._correctPlus(E[0])
        }
        if (this.tscheck) {
            this._correctCheckStates(m)
        }
        if (this._onradh) {
            if (this.xmlstate == 1) {
                var a = this.onXLE;
                this.onXLE = function (n) {
                    this._onradh(l);
                    if (a) {
                        a(n)
                    }
                }
            } else {
                this._onradh(l)
            }
        }
    }
    return s
};
dhtmlXTreeObject.prototype.enableContextMenu = function (a) {
    if (a) {
        this.cMenu = a
    }
};
dhtmlXTreeObject.prototype.setItemContextMenu = function (j, h) {
    var a = j.toString().split(this.dlmtr);
    for (var g = 0; g < a.length; g++) {
        var c = this._globalIdStorageFind(a[g]);
        if (!c) {
            continue
        }
        c.cMenu = h
    }
};
dhtmlXTreeObject.prototype.insertNewItem = function (h, n, q, g, m, l, j, c, a) {
    var r = this._globalIdStorageFind(h);
    if (!r) {
        return (-1)
    }
    var o = this._attachChildNode(r, n, q, g, m, l, j, c, a);
    if (!this._idpull[this.rootId].XMLload) {
        this._idpull[this.rootId].XMLload = 1
    }
    if ((!this.XMLloadingWarning) && (this.childCalc)) {
        this._fixChildCountLabel(r)
    }
    return o
};
dhtmlXTreeObject.prototype.insertNewChild = function (h, n, o, g, m, l, j, c, a) {
    return this.insertNewItem(h, n, o, g, m, l, j, c, a)
};
dhtmlXTreeObject.prototype._parseXMLTree = function (h, g, n, m, j) {
    var l = new xmlPointer(j.getXMLTopNode("tree"));
    h._parse(l);
    h._p = l
};
dhtmlXTreeObject.prototype._parseItem = function (l, q, j, n) {
    var g;
    if (this._srnd && (!this._idpull[g = l.get("id")] || !this._idpull[g].span)) {
        this._addItemSRND(q.id, g, l);
        return
    }
    var m = l.get_all();
    if ((typeof (this.waitUpdateXML) == "object") && (!this.waitUpdateXML[m.id])) {
        this._parse(l, m.id, 1);
        return
    }
    if ((m.text === null) || (typeof (m.text) == "undefined")) {
        m.text = l.sub("itemtext");
        if (m.text) {
            m.text = m.text.content()
        }
    }
    var s = [];
    if (m.select) {
        s.push("SELECT")
    }
    if (m.top) {
        s.push("TOP")
    }
    if (m.call) {
        this.nodeAskingCall = m.id
    }
    if (m.checked == -1) {
        s.push("HCHECKED")
    } else {
        if (m.checked) {
            s.push("CHECKED")
        }
    }
    if (m.open) {
        s.push("OPEN")
    }
    if (this.waitUpdateXML) {
        if (this._globalIdStorageFind(m.id)) {
            var o = this.updateItem(m.id, m.text, m.im0, m.im1, m.im2, m.checked, m.child)
        } else {
            if (this.npl == 0) {
                s.push("TOP")
            } else {
                j = q.childNodes[this.npl]
            }
            var o = this._attachChildNode(q, m.id, m.text, 0, m.im0, m.im1, m.im2, s.join(","), m.child, 0, j);
            m.id = o.id;
            j = null
        }
    } else {
        var o = this._attachChildNode(q, m.id, m.text, 0, m.im0, m.im1, m.im2, s.join(","), m.child, (n || 0), j)
    }
    if (m.tooltip) {
        o.span.parentNode.parentNode.title = m.tooltip
    }
    if (m.style) {
        if (o.span.style.cssText) {
            o.span.style.cssText += (";" + m.style)
        } else {
            o.span.setAttribute("style", o.span.getAttribute("style") + "; " + m.style)
        }
    }
    if (m.radio) {
        o._r_logic = true
    }
    if (m.nocheckbox) {
        var r = o.span.parentNode.previousSibling.previousSibling;
        r.style.display = "none";
        o.nocheckbox = true
    }
    if (m.disabled) {
        if (m.checked != null) {
            this._setCheck(o, m.checked)
        }
        this.disableCheckbox(o, 1)
    }
    o._acc = m.child || 0;
    if (this.parserExtension) {
        this.parserExtension._parseExtension.call(this, l, m, (q ? q.id : 0))
    }
    this.setItemColor(o, m.aCol, m.sCol);
    if (m.locked == "1") {
        this.lockItem(o.id, true, true)
    }
    if ((m.imwidth) || (m.imheight)) {
        this.setIconSize(m.imwidth, m.imheight, o)
    }
    if ((m.closeable == "0") || (m.closeable == "1")) {
        this.setItemCloseable(o, m.closeable)
    }
    var h = "";
    if (m.topoffset) {
        this.setItemTopOffset(o, m.topoffset)
    }
    if ((!this.slowParse) || (typeof (this.waitUpdateXML) == "object")) {
        if (l.sub_exists("item")) {
            h = this._parse(l, m.id, 1)
        }
    } else {
        if ((!o.childsCount) && l.sub_exists("item")) {
            o.unParsed = l.clone()
        }
        l.each("userdata", function (a) {
            this.setUserData(m.id, a.get("name"), a.content())
        }, this)
    }
    if (h != "") {
        this.nodeAskingCall = h
    }
    l.each("userdata", function (a) {
        this.setUserData(l.get("id"), a.get("name"), a.content())
    }, this)
};
dhtmlXTreeObject.prototype._parse = function (g, l, a, c) {
    if (this._srnd && !this.parentObject.offsetHeight) {
        var v = this;
        return window.setTimeout(function () {
            v._parse(g, l, a, c)
        }, 100)
    }
    if (!g.exists()) {
        return
    }
    this.skipLock = true;
    if (!l) {
        l = g.get("id");
        var s = g.get("dhx_security");
        if (s) {
            dhtmlx.security_key = s
        }
        if (g.get("radio")) {
            this.htmlNode._r_logic = true
        }
        this.parsingOn = l;
        this.parsedArray = new Array();
        this.setCheckList = "";
        this.nodeAskingCall = ""
    }
    var u = this._globalIdStorageFind(l);
    if (!u) {
        return dhtmlxError.throwError("DataStructure", "XML refers to not existing parent")
    }
    this.parsCount = this.parsCount ? (this.parsCount + 1) : 1;
    this.XMLloadingWarning = 1;
    if ((u.childsCount) && (!c) && (!this._edsbps) && (!u._has_top)) {
        var m = 0
    } else {
        var m = 0
    }
    this.npl = 0;
    g.each("item", function (w, n) {
        u.XMLload = 1;
        this._parseItem(w, u, 0, m);
        if ((this._edsbps) && (this.npl == this._edsbpsC)) {
            this._distributedStart(g, n + 1, l, a, u.childsCount);
            return -1
        }
        this.npl++
    }, this, c);
    if (!a) {
        g.each("userdata", function (n) {
            this.setUserData(g.get("id"), n.get("name"), n.content())
        }, this);
        u.XMLload = 1;
        if (this.waitUpdateXML) {
            this.waitUpdateXML = false;
            for (var j = u.childsCount - 1; j >= 0; j--) {
                if (u.childNodes[j]._dmark) {
                    this.deleteItem(u.childNodes[j].id)
                }
            }
        }
        var q = this._globalIdStorageFind(this.parsingOn);
        for (var j = 0; j < this.parsedArray.length; j++) {
            u.htmlNode.childNodes[0].appendChild(this.parsedArray[j])
        }
        this.parsedArray = [];
        this.lastLoadedXMLId = l;
        this.XMLloadingWarning = 0;
        var r = this.setCheckList.split(this.dlmtr);
        for (var h = 0; h < r.length; h++) {
            if (r[h]) {
                this.setCheck(r[h], 1)
            }
        }
        if ((this.XMLsource) && (this.tscheck) && (this.smcheck) && (u.id != this.rootId)) {
            if (u.checkstate === 0) {
                this._setSubChecked(0, u)
            } else {
                if (u.checkstate === 1) {
                    this._setSubChecked(1, u)
                }
            }
        }
        this._redrawFrom(this, null, c);
        if (g.get("order") && g.get("order") != "none") {
            this._reorderBranch(u, g.get("order"), true)
        }
        if (this.nodeAskingCall != "") {
            this.callEvent("onClick", [this.nodeAskingCall, this.getSelectedItemId()])
        }
        if (this._branchUpdate) {
            this._branchUpdateNext(g)
        }
    }
    if (this.parsCount == 1) {
        this.parsingOn = null;
        if (this._srnd && u.id != this.rootId) {
            this.prepareSR(u.id);
            if (this.XMLsource) {
                this.openItem(u.id)
            }
        }
        g.through("item", "open", null, function (n) {
            this.openItem(n.get("id"))
        }, this);
        if ((!this._edsbps) || (!this._edsbpsA.length)) {
            var o = this;
            window.setTimeout(function () {
                o.callEvent("onXLE", [o, l])
            }, 1);
            this.xmlstate = 0
        }
        this.skipLock = false
    }
    this.parsCount--;
    var o = this;
    if (this._edsbps) {
        window.setTimeout(function () {
            o._distributedStep(l)
        }, this._edsbpsD)
    }
    if (!a && this.onXLE) {
        this.onXLE(this, l)
    }
    return this.nodeAskingCall
};
dhtmlXTreeObject.prototype._branchUpdateNext = function (a) {
    a.each("item", function (h) {
        var g = h.get("id");
        if (this._idpull[g] && (!this._idpull[g].XMLload)) {
            return
        }
        this._branchUpdate++;
        this.smartRefreshItem(h.get("id"), h)
    }, this);
    this._branchUpdate--
};
dhtmlXTreeObject.prototype.checkUserData = function (c, g) {
    if ((c.nodeType == 1) && (c.tagName == "userdata")) {
        var a = c.getAttribute("name");
        if ((a) && (c.childNodes[0])) {
            this.setUserData(g, a, c.childNodes[0].data)
        }
    }
};
dhtmlXTreeObject.prototype._redrawFrom = function (n, c, m, g) {
    if (!c) {
        var j = n._globalIdStorageFind(n.lastLoadedXMLId);
        n.lastLoadedXMLId = -1;
        if (!j) {
            return 0
        }
    } else {
        j = c
    }
    var l = 0;
    for (var h = (m ? m - 1 : 0); h < j.childsCount; h++) {
        if ((!this._branchUpdate) || (this._getOpenState(j) == 1)) {
            if ((!c) || (g == 1)) {
                j.childNodes[h].htmlNode.parentNode.parentNode.style.display = ""
            }
        }
        if (j.childNodes[h].openMe == 1) {
            this._openItem(j.childNodes[h]);
            j.childNodes[h].openMe = 0
        }
        n._redrawFrom(n, j.childNodes[h]);
        if (this.childCalc != null) {
            if ((j.childNodes[h].unParsed) || ((!j.childNodes[h].XMLload) && (this.XMLsource))) {
                if (j.childNodes[h]._acc) {
                    j.childNodes[h].span.innerHTML = j.childNodes[h].label + this.htmlcA + j.childNodes[h]._acc + this.htmlcB
                } else {
                    j.childNodes[h].span.innerHTML = j.childNodes[h].label
                }
            }
            if ((j.childNodes[h].childNodes.length) && (this.childCalc)) {
                if (this.childCalc == 1) {
                    j.childNodes[h].span.innerHTML = j.childNodes[h].label + this.htmlcA + j.childNodes[h].childsCount + this.htmlcB
                }
                if (this.childCalc == 2) {
                    var a = j.childNodes[h].childsCount - (j.childNodes[h].pureChilds || 0);
                    if (a) {
                        j.childNodes[h].span.innerHTML = j.childNodes[h].label + this.htmlcA + a + this.htmlcB
                    }
                    if (j.pureChilds) {
                        j.pureChilds++
                    } else {
                        j.pureChilds = 1
                    }
                }
                if (this.childCalc == 3) {
                    j.childNodes[h].span.innerHTML = j.childNodes[h].label + this.htmlcA + j.childNodes[h]._acc + this.htmlcB
                }
                if (this.childCalc == 4) {
                    var a = j.childNodes[h]._acc;
                    if (a) {
                        j.childNodes[h].span.innerHTML = j.childNodes[h].label + this.htmlcA + a + this.htmlcB
                    }
                }
            } else {
                if (this.childCalc == 4) {
                    l++
                }
            }
            l += j.childNodes[h]._acc;
            if (this.childCalc == 3) {
                l++
            }
        }
    }
    if ((!j.unParsed) && ((j.XMLload) || (!this.XMLsource))) {
        j._acc = l
    }
    n._correctLine(j);
    n._correctPlus(j);
    if ((this.childCalc) && (!c)) {
        n._fixChildCountLabel(j)
    }
};
dhtmlXTreeObject.prototype._createSelf = function () {
    var a = document.createElement("div");
    a.className = "containerTableStyle";
    a.style.width = this.width;
    a.style.height = this.height;
    this.parentObject.appendChild(a);
    return a
};
dhtmlXTreeObject.prototype._xcloseAll = function (c) {
    if (c.unParsed) {
        return
    }
    if (this.rootId != c.id) {
        if (!c.htmlNode) {
            return
        }
        var h = c.htmlNode.childNodes[0].childNodes;
        var a = h.length;
        for (var g = 1; g < a; g++) {
            h[g].style.display = "none"
        }
        this._correctPlus(c)
    }
    for (var g = 0; g < c.childsCount; g++) {
        if (c.childNodes[g].childsCount) {
            this._xcloseAll(c.childNodes[g])
        }
    }
};
dhtmlXTreeObject.prototype._xopenAll = function (a) {
    this._HideShow(a, 2);
    for (var c = 0; c < a.childsCount; c++) {
        this._xopenAll(a.childNodes[c])
    }
};
dhtmlXTreeObject.prototype._correctPlus = function (c) {
    if (!c.htmlNode) {
        return
    }
    var g = c.htmlNode.childNodes[0].childNodes[0].childNodes[0].lastChild;
    var j = c.htmlNode.childNodes[0].childNodes[0].childNodes[2].childNodes[0];
    var a = this.lineArray;
    if ((this.XMLsource) && (!c.XMLload)) {
        var a = this.plusArray;
        this._setSrc(j, this.iconURL + c.images[2]);
        if (this._txtimg) {
            return (g.innerHTML = "[+]")
        }
    } else {
        if ((c.childsCount) || (c.unParsed)) {
            if ((c.htmlNode.childNodes[0].childNodes[1]) && (c.htmlNode.childNodes[0].childNodes[1].style.display != "none")) {
                if (!c.wsign) {
                    var a = this.minusArray
                }
                this._setSrc(j, this.iconURL + c.images[1]);
                if (this._txtimg) {
                    return (g.innerHTML = "[-]")
                }
            } else {
                if (!c.wsign) {
                    var a = this.plusArray
                }
                this._setSrc(j, this.iconURL + c.images[2]);
                if (this._txtimg) {
                    return (g.innerHTML = "[+]")
                }
            }
        } else {
            this._setSrc(j, this.iconURL + c.images[0])
        }
    }
    var h = 2;
    if (!c.treeNod.treeLinesOn) {
        this._setSrc(g, this.imPath + a[3])
    } else {
        if (c.parentObject) {
            h = this._getCountStatus(c.id, c.parentObject)
        }
        this._setSrc(g, this.imPath + a[h])
    }
};
dhtmlXTreeObject.prototype._correctLine = function (c) {
    if (!c.htmlNode) {
        return
    }
    var a = c.parentObject;
    if (a) {
        if ((this._getLineStatus(c.id, a) == 0) || (!this.treeLinesOn)) {
            for (var g = 1; g <= c.childsCount; g++) {
                if (!c.htmlNode.childNodes[0].childNodes[g]) {
                    break
                }
                c.htmlNode.childNodes[0].childNodes[g].childNodes[0].style.backgroundImage = "";
                c.htmlNode.childNodes[0].childNodes[g].childNodes[0].style.backgroundRepeat = ""
            }
        } else {
            for (var g = 1; g <= c.childsCount; g++) {
                if (!c.htmlNode.childNodes[0].childNodes[g]) {
                    break
                }
                c.htmlNode.childNodes[0].childNodes[g].childNodes[0].style.backgroundImage = "url(" + this.imPath + this.lineArray[5] + ")";
                c.htmlNode.childNodes[0].childNodes[g].childNodes[0].style.backgroundRepeat = "repeat-y"
            }
        }
    }
};
dhtmlXTreeObject.prototype._getCountStatus = function (c, a) {
    if (a.childsCount <= 1) {
        if (a.id == this.rootId) {
            return 4
        } else {
            return 0
        }
    }
    if (a.childNodes[0].id == c) {
        if (a.id == this.rootId) {
            return 2
        } else {
            return 1
        }
    }
    if (a.childNodes[a.childsCount - 1].id == c) {
        return 0
    }
    return 1
};
dhtmlXTreeObject.prototype._getLineStatus = function (c, a) {
    if (a.childNodes[a.childsCount - 1].id == c) {
        return 0
    }
    return 1
};
dhtmlXTreeObject.prototype._HideShow = function (c, j) {
    if ((this.XMLsource) && (!c.XMLload)) {
        if (j == 1) {
            return
        }
        c.XMLload = 1;
        this._loadDynXML(c.id);
        return
    }
    if (c.unParsed) {
        this.reParse(c)
    }
    var h = c.htmlNode.childNodes[0].childNodes;
    var a = h.length;
    if (a > 1) {
        if (((h[1].style.display != "none") || (j == 1)) && (j != 2)) {
            this.allTree.childNodes[0].border = "1";
            this.allTree.childNodes[0].border = "0";
            nodestyle = "none"
        } else {
            nodestyle = ""
        }
        for (var g = 1; g < a; g++) {
            h[g].style.display = nodestyle
        }
    }
    this._correctPlus(c)
};
dhtmlXTreeObject.prototype._getOpenState = function (a) {
    if (!a.htmlNode) {
        return 0
    }
    var c = a.htmlNode.childNodes[0].childNodes;
    if (c.length <= 1) {
        return 0
    }
    if (c[1].style.display != "none") {
        return 1
    } else {
        return -1
    }
};
dhtmlXTreeObject.prototype.onRowClick2 = function () {
    var a = this.parentObject.treeNod;
    if (!a.callEvent("onDblClick", [this.parentObject.id, a])) {
        return false
    }
    if ((this.parentObject.closeble) && (this.parentObject.closeble != "0")) {
        a._HideShow(this.parentObject)
    } else {
        a._HideShow(this.parentObject, 2)
    }
    if (a.checkEvent("onOpenEnd")) {
        if (!a.xmlstate) {
            a.callEvent("onOpenEnd", [this.parentObject.id, a._getOpenState(this.parentObject)])
        } else {
            a._oie_onXLE.push(a.onXLE);
            a.onXLE = a._epnFHe
        }
    }
    return false
};
dhtmlXTreeObject.prototype.onRowClick = function () {
    var a = this.parentObject.treeNod;
    if (!a.callEvent("onOpenStart", [this.parentObject.id, a._getOpenState(this.parentObject)])) {
        return 0
    }
    if ((this.parentObject.closeble) && (this.parentObject.closeble != "0")) {
        a._HideShow(this.parentObject)
    } else {
        a._HideShow(this.parentObject, 2)
    }
    if (a.checkEvent("onOpenEnd")) {
        if (!a.xmlstate) {
            a.callEvent("onOpenEnd", [this.parentObject.id, a._getOpenState(this.parentObject)])
        } else {
            a._oie_onXLE.push(a.onXLE);
            a.onXLE = a._epnFHe
        }
    }
};
dhtmlXTreeObject.prototype._epnFHe = function (c, g, a) {
    if (g != this.rootId) {
        this.callEvent("onOpenEnd", [g, c.getOpenState(g)])
    }
    c.onXLE = c._oie_onXLE.pop();
    if (!a && !c._oie_onXLE.length) {
        if (c.onXLE) {
            c.onXLE(c, g)
        }
    }
};
dhtmlXTreeObject.prototype.onRowClickDown = function (c) {
    c = c || window.event;
    var a = this.parentObject.treeNod;
    a._selectItem(this.parentObject, c)
};
dhtmlXTreeObject.prototype.getSelectedItemId = function () {
    var c = new Array();
    for (var a = 0; a < this._selected.length; a++) {
        c[a] = this._selected[a].id
    }
    return (c.join(this.dlmtr))
};
dhtmlXTreeObject.prototype._selectItem = function (l, m) {
    if (this.checkEvent("onSelect")) {
        this._onSSCFold = this.getSelectedItemId()
    }
    if ((!this._amsel) || (!m) || ((!m.ctrlKey) && (!m.metaKey) && (!m.shiftKey))) {
        this._unselectItems()
    }
    if ((l.i_sel) && (this._amsel) && (m) && (m.ctrlKey || m.metaKey)) {
        this._unselectItem(l)
    } else {
        if ((!l.i_sel) && ((!this._amselS) || (this._selected.length == 0) || (this._selected[0].parentObject == l.parentObject))) {
            if ((this._amsel) && (m) && (m.shiftKey) && (this._selected.length != 0) && (this._selected[this._selected.length - 1].parentObject == l.parentObject)) {
                var h = this._getIndex(this._selected[this._selected.length - 1]);
                var g = this._getIndex(l);
                if (g < h) {
                    var o = h;
                    h = g;
                    g = o
                }
                for (var j = h; j <= g; j++) {
                    if (!l.parentObject.childNodes[j].i_sel) {
                        this._markItem(l.parentObject.childNodes[j])
                    }
                }
            } else {
                this._markItem(l)
            }
        }
    }
    if (this.checkEvent("onSelect")) {
        var n = this.getSelectedItemId();
        if (n != this._onSSCFold) {
            this.callEvent("onSelect", [n])
        }
    }
};
dhtmlXTreeObject.prototype._markItem = function (a) {
    if (a.scolor) {
        a.span.style.color = a.scolor
    }
    a.span.className = "selectedTreeRow";
    a.i_sel = true;
    this._selected[this._selected.length] = a
};
dhtmlXTreeObject.prototype.getIndexById = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return null
    }
    return this._getIndex(a)
};
dhtmlXTreeObject.prototype._getIndex = function (a) {
    var g = a.parentObject;
    for (var c = 0; c < g.childsCount; c++) {
        if (g.childNodes[c] == a) {
            return c
        }
    }
};
dhtmlXTreeObject.prototype._unselectItem = function (c) {
    if ((c) && (c.i_sel)) {
        c.span.className = "standartTreeRow";
        if (c.acolor) {
            c.span.style.color = c.acolor
        }
        c.i_sel = false;
        for (var a = 0; a < this._selected.length; a++) {
            if (!this._selected[a].i_sel) {
                this._selected.splice(a, 1);
                break
            }
        }
    }
};
dhtmlXTreeObject.prototype._unselectItems = function () {
    for (var a = 0; a < this._selected.length; a++) {
        var c = this._selected[a];
        c.span.className = "standartTreeRow";
        if (c.acolor) {
            c.span.style.color = c.acolor
        }
        c.i_sel = false
    }
    this._selected = new Array()
};
dhtmlXTreeObject.prototype.onRowSelect = function (h, g, l) {
    h = h || window.event;
    var c = this.parentObject;
    if (g) {
        c = g.parentObject
    }
    var a = c.treeNod;
    var j = a.getSelectedItemId();
    if ((!h) || (!h.skipUnSel)) {
        a._selectItem(c, h)
    }
    if (!l) {
        if (c.actionHandler) {
            c.actionHandler(c.id, j)
        } else {
            a.callEvent("onClick", [c.id, j])
        }
    }
};
dhtmlXTreeObject.prototype._correctCheckStates = function (j) {
    if (!this.tscheck) {
        return
    }
    if (!j) {
        return
    }
    if (j.id == this.rootId) {
        return
    }
    var g = j.childNodes;
    var c = 0;
    var a = 0;
    if (j.childsCount == 0) {
        return
    }
    for (var h = 0; h < j.childsCount; h++) {
        if (g[h].dscheck) {
            continue
        }
        if (g[h].checkstate == 0) {
            c = 1
        } else {
            if (g[h].checkstate == 1) {
                a = 1
            } else {
                c = 1;
                a = 1;
                break
            }
        }
    }
    if ((c) && (a)) {
        this._setCheck(j, "unsure")
    } else {
        if (c) {
            this._setCheck(j, false)
        } else {
            this._setCheck(j, true)
        }
    }
    this._correctCheckStates(j.parentObject)
};
dhtmlXTreeObject.prototype.onCheckBoxClick = function (a) {
    if (!this.treeNod.callEvent("onBeforeCheck", [this.parentObject.id, this.parentObject.checkstate])) {
        return
    }
    if (this.parentObject.dscheck) {
        return true
    }
    if (this.treeNod.tscheck) {
        if (this.parentObject.checkstate == 1) {
            this.treeNod._setSubChecked(false, this.parentObject)
        } else {
            this.treeNod._setSubChecked(true, this.parentObject)
        }
    } else {
        if (this.parentObject.checkstate == 1) {
            this.treeNod._setCheck(this.parentObject, false)
        } else {
            this.treeNod._setCheck(this.parentObject, true)
        }
    }
    this.treeNod._correctCheckStates(this.parentObject.parentObject);
    return this.treeNod.callEvent("onCheck", [this.parentObject.id, this.parentObject.checkstate])
};
dhtmlXTreeObject.prototype._createItem = function (s, r, n) {
    var u = document.createElement("table");
    u.cellSpacing = 0;
    u.cellPadding = 0;
    u.border = 0;
    if (this.hfMode) {
        u.style.tableLayout = "fixed"
    }
    u.style.margin = 0;
    u.style.padding = 0;
    var m = document.createElement("tbody");
    var q = document.createElement("tr");
    var h = document.createElement("td");
    h.className = "standartTreeImage";
    if (this._txtimg) {
        var j = document.createElement("div");
        h.appendChild(j);
        j.className = "dhx_tree_textSign"
    } else {
        var j = this._getImg(r.id);
        j.border = "0";
        if (j.tagName == "IMG") {
            j.align = "absmiddle"
        }
        h.appendChild(j);
        j.style.padding = 0;
        j.style.margin = 0;
        j.style.width = this.def_line_img_x;
        j.style.height = this.def_line_img_y
    }
    var g = document.createElement("td");
    var o = this._getImg(this.cBROf ? this.rootId : r.id);
    o.checked = 0;
    this._setSrc(o, this.imPath + this.checkArray[0]);
    o.style.width = "18px";
    o.style.height = "18px";
    if (!s) {
        g.style.display = "none"
    }
    g.appendChild(o);
    if ((!this.cBROf) && (o.tagName == "IMG")) {
        o.align = "absmiddle"
    }
    o.onclick = this.onCheckBoxClick;
    o.treeNod = this;
    o.parentObject = r;
    if (!window._KHTMLrv) {
        g.width = "20px"
    } else {
        g.width = "16px"
    }
    var c = document.createElement("td");
    c.className = "standartTreeImage";
    var l = this._getImg(this.timgen ? r.id : this.rootId);
    l.onmousedown = this._preventNsDrag;
    l.ondragstart = this._preventNsDrag;
    l.border = "0";
    if (this._aimgs) {
        l.parentObject = r;
        if (l.tagName == "IMG") {
            l.align = "absmiddle"
        }
        l.onclick = this.onRowSelect
    }
    if (!n) {
        this._setSrc(l, this.iconURL + this.imageArray[0])
    }
    c.appendChild(l);
    l.style.padding = 0;
    l.style.margin = 0;
    if (this.timgen) {
        c.style.width = l.style.width = this.def_img_x;
        l.style.height = this.def_img_y
    } else {
        l.style.width = "0px";
        l.style.height = "0px";
        if (_isOpera || window._KHTMLrv) {
            c.style.display = "none"
        }
    }
    var a = document.createElement("td");
    a.className = "standartTreeRow";
    r.span = document.createElement("span");
    r.span.className = "standartTreeRow";
    if (this.mlitems) {
        r.span.style.width = this.mlitems;
        r.span.style.display = "block"
    } else {
        a.noWrap = true
    }
    if (_isIE && _isIE > 7) {
        a.style.width = "999999px"
    } else {
        if (!window._KHTMLrv) {
            a.style.width = "100%"
        }
    }
    r.span.innerHTML = r.label;
    a.appendChild(r.span);
    a.parentObject = r;
    h.parentObject = r;
    a.onclick = this.onRowSelect;
    h.onclick = this.onRowClick;
    a.ondblclick = this.onRowClick2;
    if (this.ettip) {
        q.title = r.label
    }
    if (this.dragAndDropOff) {
        if (this._aimgs) {
            this.dragger.addDraggableItem(c, this);
            c.parentObject = r
        }
        this.dragger.addDraggableItem(a, this)
    }
    r.span.style.paddingLeft = "5px";
    r.span.style.paddingRight = "5px";
    a.style.verticalAlign = "";
    a.style.fontSize = "10pt";
    a.style.cursor = this.style_pointer;
    q.appendChild(h);
    q.appendChild(g);
    q.appendChild(c);
    q.appendChild(a);
    m.appendChild(q);
    u.appendChild(m);
    if (this.ehlt || this.checkEvent("onMouseIn") || this.checkEvent("onMouseOut")) {
        q.onmousemove = this._itemMouseIn;
        q[(_isIE) ? "onmouseleave" : "onmouseout"] = this._itemMouseOut
    }
    return u
};
dhtmlXTreeObject.prototype.setImagePath = function (a) {
    this.imPath = a;
    this.iconURL = a
};
dhtmlXTreeObject.prototype.setIconPath = function (a) {
    this.iconURL = a
};
dhtmlXTreeObject.prototype._getLeafCount = function (h) {
    var g = 0;
    for (var c = 0; c < h.childsCount; c++) {
        if (h.childNodes[c].childsCount == 0) {
            g++
        }
    }
    return g
};
dhtmlXTreeObject.prototype._getChildCounterValue = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    }
    if ((a.unParsed) || ((!a.XMLload) && (this.XMLsource))) {
        return a._acc
    }
    switch (this.childCalc) {
    case 1:
        return a.childsCount;
        break;
    case 2:
        return this._getLeafCount(a);
        break;
    case 3:
        return a._acc;
        break;
    case 4:
        return a._acc;
        break
    }
};
dhtmlXTreeObject.prototype._fixChildCountLabel = function (l, h) {
    if (this.childCalc == null) {
        return
    }
    if ((l.unParsed) || ((!l.XMLload) && (this.XMLsource))) {
        if (l._acc) {
            l.span.innerHTML = l.label + this.htmlcA + l._acc + this.htmlcB
        } else {
            l.span.innerHTML = l.label
        }
        return
    }
    switch (this.childCalc) {
    case 1:
        if (l.childsCount != 0) {
            l.span.innerHTML = l.label + this.htmlcA + l.childsCount + this.htmlcB
        } else {
            l.span.innerHTML = l.label
        }
        break;
    case 2:
        var j = this._getLeafCount(l);
        if (j != 0) {
            l.span.innerHTML = l.label + this.htmlcA + j + this.htmlcB
        } else {
            l.span.innerHTML = l.label
        }
        break;
    case 3:
        if (l.childsCount != 0) {
            var g = 0;
            for (var c = 0; c < l.childsCount; c++) {
                if (!l.childNodes[c]._acc) {
                    l.childNodes[c]._acc = 0
                }
                g += l.childNodes[c]._acc * 1
            }
            g += l.childsCount * 1;
            l.span.innerHTML = l.label + this.htmlcA + g + this.htmlcB;
            l._acc = g
        } else {
            l.span.innerHTML = l.label;
            l._acc = 0
        }
        if ((l.parentObject) && (l.parentObject != this.htmlNode)) {
            this._fixChildCountLabel(l.parentObject)
        }
        break;
    case 4:
        if (l.childsCount != 0) {
            var g = 0;
            for (var c = 0; c < l.childsCount; c++) {
                if (!l.childNodes[c]._acc) {
                    l.childNodes[c]._acc = 1
                }
                g += l.childNodes[c]._acc * 1
            }
            l.span.innerHTML = l.label + this.htmlcA + g + this.htmlcB;
            l._acc = g
        } else {
            l.span.innerHTML = l.label;
            l._acc = 1
        }
        if ((l.parentObject) && (l.parentObject != this.htmlNode)) {
            this._fixChildCountLabel(l.parentObject)
        }
        break
    }
};
dhtmlXTreeObject.prototype.setChildCalcMode = function (a) {
    switch (a) {
    case "child":
        this.childCalc = 1;
        break;
    case "leafs":
        this.childCalc = 2;
        break;
    case "childrec":
        this.childCalc = 3;
        break;
    case "leafsrec":
        this.childCalc = 4;
        break;
    case "disabled":
        this.childCalc = null;
        break;
    default:
        this.childCalc = 4
    }
};
dhtmlXTreeObject.prototype.setChildCalcHTML = function (c, a) {
    this.htmlcA = c;
    this.htmlcB = a
};
dhtmlXTreeObject.prototype.setOnRightClickHandler = function (a) {
    this.attachEvent("onRightClick", a)
};
dhtmlXTreeObject.prototype.setOnClickHandler = function (a) {
    this.attachEvent("onClick", a)
};
dhtmlXTreeObject.prototype.setOnSelectStateChange = function (a) {
    this.attachEvent("onSelect", a)
};
dhtmlXTreeObject.prototype.setXMLAutoLoading = function (a) {
    this.XMLsource = a
};
dhtmlXTreeObject.prototype.setOnCheckHandler = function (a) {
    this.attachEvent("onCheck", a)
};
dhtmlXTreeObject.prototype.setOnOpenHandler = function (a) {
    this.attachEvent("onOpenStart", a)
};
dhtmlXTreeObject.prototype.setOnOpenStartHandler = function (a) {
    this.attachEvent("onOpenStart", a)
};
dhtmlXTreeObject.prototype.setOnOpenEndHandler = function (a) {
    this.attachEvent("onOpenEnd", a)
};
dhtmlXTreeObject.prototype.setOnDblClickHandler = function (a) {
    this.attachEvent("onDblClick", a)
};
dhtmlXTreeObject.prototype.openAllItems = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    }
    this._xopenAll(a)
};
dhtmlXTreeObject.prototype.getOpenState = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return ""
    }
    return this._getOpenState(a)
};
dhtmlXTreeObject.prototype.closeAllItems = function (c) {
    if (c === window.undefined) {
        c = this.rootId
    }
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    }
    this._xcloseAll(a);
    this.allTree.childNodes[0].border = "1";
    this.allTree.childNodes[0].border = "0"
};
dhtmlXTreeObject.prototype.setUserData = function (h, c, g) {
    var a = this._globalIdStorageFind(h, 0, true);
    if (!a) {
        return
    }
    if (c == "hint") {
        a.htmlNode.childNodes[0].childNodes[0].title = g
    }
    if (typeof (a.userData["t_" + c]) == "undefined") {
        if (!a._userdatalist) {
            a._userdatalist = c
        } else {
            a._userdatalist += "," + c
        }
    }
    a.userData["t_" + c] = g
};
dhtmlXTreeObject.prototype.getUserData = function (g, c) {
    var a = this._globalIdStorageFind(g, 0, true);
    if (!a) {
        return
    }
    return a.userData["t_" + c]
};
dhtmlXTreeObject.prototype.getItemColor = function (g) {
    var a = this._globalIdStorageFind(g);
    if (!a) {
        return 0
    }
    var c = new Object();
    if (a.acolor) {
        c.acolor = a.acolor
    }
    if (a.scolor) {
        c.scolor = a.scolor
    }
    return c
};
dhtmlXTreeObject.prototype.setItemColor = function (g, c, h) {
    if ((g) && (g.span)) {
        var a = g
    } else {
        var a = this._globalIdStorageFind(g)
    }
    if (!a) {
        return 0
    } else {
        if (a.i_sel) {
            if (h) {
                a.span.style.color = h
            }
        } else {
            if (c) {
                a.span.style.color = c
            }
        }
        if (h) {
            a.scolor = h
        }
        if (c) {
            a.acolor = c
        }
    }
};
dhtmlXTreeObject.prototype.getItemText = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    }
    return (a.htmlNode.childNodes[0].childNodes[0].childNodes[3].childNodes[0].innerHTML)
};
dhtmlXTreeObject.prototype.getParentId = function (c) {
    var a = this._globalIdStorageFind(c);
    if ((!a) || (!a.parentObject)) {
        return ""
    }
    return a.parentObject.id
};
dhtmlXTreeObject.prototype.changeItemId = function (c, g) {
    if (c == g) {
        return
    }
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    }
    a.id = g;
    a.span.contextMenuId = g;
    this._idpull[g] = this._idpull[c];
    delete this._idpull[c]
};
dhtmlXTreeObject.prototype.doCut = function () {
    if (this.nodeCut) {
        this.clearCut()
    }
    this.nodeCut = (new Array()).concat(this._selected);
    for (var a = 0; a < this.nodeCut.length; a++) {
        var c = this.nodeCut[a];
        c._cimgs = new Array();
        c._cimgs[0] = c.images[0];
        c._cimgs[1] = c.images[1];
        c._cimgs[2] = c.images[2];
        c.images[0] = c.images[1] = c.images[2] = this.cutImage;
        this._correctPlus(c)
    }
};
dhtmlXTreeObject.prototype.doPaste = function (g) {
    var a = this._globalIdStorageFind(g);
    if (!a) {
        return 0
    }
    for (var c = 0; c < this.nodeCut.length; c++) {
        if (this._checkPNodes(a, this.nodeCut[c])) {
            continue
        }
        this._moveNode(this.nodeCut[c], a)
    }
    this.clearCut()
};
dhtmlXTreeObject.prototype.clearCut = function () {
    for (var a = 0; a < this.nodeCut.length; a++) {
        var c = this.nodeCut[a];
        c.images[0] = c._cimgs[0];
        c.images[1] = c._cimgs[1];
        c.images[2] = c._cimgs[2];
        this._correctPlus(c)
    }
    this.nodeCut = new Array()
};
dhtmlXTreeObject.prototype._moveNode = function (a, c) {
    var l = this.dadmodec;
    if (l == 1) {
        var j = c;
        if (this.dadmodefix < 0) {
            while (true) {
                j = this._getPrevNode(j);
                if ((j == -1)) {
                    j = this.htmlNode;
                    break
                }
                if ((j.tr == 0) || (j.tr.style.display == "") || (!j.parentObject)) {
                    break
                }
            }
            var h = j;
            var g = c
        } else {
            if ((j.tr) && (j.tr.nextSibling) && (j.tr.nextSibling.nodem) && (this._getOpenState(j) < 1)) {
                j = j.tr.nextSibling.nodem
            } else {
                j = this._getNextNode(j);
                if ((j == -1)) {
                    j = this.htmlNode
                }
            }
            var g = j;
            var h = c
        }
        if (this._getNodeLevel(h, 0) > this._getNodeLevel(g, 0)) {
            if (!this.dropLower) {
                return this._moveNodeTo(a, h.parentObject)
            } else {
                if (g.id != this.rootId) {
                    return this._moveNodeTo(a, g.parentObject, g)
                } else {
                    return this._moveNodeTo(a, this.htmlNode, null)
                }
            }
        } else {
            return this._moveNodeTo(a, g.parentObject, g)
        }
    } else {
        return this._moveNodeTo(a, c)
    }
};
dhtmlXTreeObject.prototype._fixNodesCollection = function (n, l) {
    var c = 0;
    var h = 0;
    var m = n.childNodes;
    var a = n.childsCount - 1;
    if (l == m[a]) {
        return
    }
    for (var j = 0; j < a; j++) {
        if (m[j] == m[a]) {
            m[j] = m[j + 1];
            m[j + 1] = m[a]
        }
    }
    for (var j = 0; j < a + 1; j++) {
        if (c) {
            var g = m[j];
            m[j] = c;
            c = g
        } else {
            if (m[j] == l) {
                c = m[j];
                m[j] = m[a]
            }
        }
    }
};
dhtmlXTreeObject.prototype._recreateBranch = function (l, n, j, a) {
    var c;
    var o = "";
    if (j) {
        for (c = 0; c < n.childsCount; c++) {
            if (n.childNodes[c] == j) {
                break
            }
        }
        if (c != 0) {
            j = n.childNodes[c - 1]
        } else {
            o = "TOP";
            j = ""
        }
    }
    var g = this._onradh;
    this._onradh = null;
    var m = this._attachChildNode(n, l.id, l.label, 0, l.images[0], l.images[1], l.images[2], o, 0, j);
    m._userdatalist = l._userdatalist;
    m.userData = l.userData.clone();
    if (l._attrs) {
        m._attrs = {};
        for (var h in l._attrs) {
            m._attrs[h] = l._attrs[h]
        }
    }
    m.XMLload = l.XMLload;
    if (g) {
        this._onradh = g;
        this._onradh(m.id)
    }
    if (l.treeNod.dpcpy) {
        l.treeNod._globalIdStorageFind(l.id)
    } else {
        m.unParsed = l.unParsed
    }
    this._correctPlus(m);
    for (var c = 0; c < l.childsCount; c++) {
        this._recreateBranch(l.childNodes[c], m, 0, 1)
    }
    if ((!a) && (this.childCalc)) {
        this._redrawFrom(this, n)
    }
    return m
};
dhtmlXTreeObject.prototype._moveNodeTo = function (s, v, r) {
    if (s.treeNod._nonTrivialNode) {
        return s.treeNod._nonTrivialNode(this, v, r, s)
    }
    if (this._checkPNodes(v, s)) {
        return false
    }
    if (v.mytype) {
        var m = (s.treeNod.lWin != v.lWin)
    } else {
        var m = (s.treeNod.lWin != v.treeNod.lWin)
    }
    if (!this.callEvent("onDrag", [s.id, v.id, (r ? r.id : null), s.treeNod, v.treeNod])) {
        return false
    }
    if ((v.XMLload == 0) && (this.XMLsource)) {
        v.XMLload = 1;
        this._loadDynXML(v.id)
    }
    this.openItem(v.id);
    var g = s.treeNod;
    var o = s.parentObject.childsCount;
    var q = s.parentObject;
    if ((m) || (g.dpcpy)) {
        var h = s.id;
        s = this._recreateBranch(s, v, r);
        if (!g.dpcpy) {
            g.deleteItem(h)
        }
    } else {
        var j = v.childsCount;
        var u = v.childNodes;
        if (j == 0) {
            v._open = true
        }
        g._unselectItem(s);
        u[j] = s;
        s.treeNod = v.treeNod;
        v.childsCount++;
        var n = this._drawNewTr(u[j].htmlNode);
        if (!r) {
            v.htmlNode.childNodes[0].appendChild(n);
            if (this.dadmode == 1) {
                this._fixNodesCollection(v, r)
            }
        } else {
            v.htmlNode.childNodes[0].insertBefore(n, r.tr);
            this._fixNodesCollection(v, r);
            u = v.childNodes
        }
    }
    if ((!g.dpcpy) && (!m)) {
        var a = s.tr;
        if ((document.all) && (navigator.appVersion.search(/MSIE\ 5\.0/gi) != -1)) {
            window.setTimeout(function () {
                a.parentNode.removeChild(a)
            }, 250)
        } else {
            s.parentObject.htmlNode.childNodes[0].removeChild(s.tr)
        }
        if ((!r) || (v != s.parentObject)) {
            for (var l = 0; l < q.childsCount; l++) {
                if (q.childNodes[l].id == s.id) {
                    q.childNodes[l] = 0;
                    break
                }
            }
        } else {
            q.childNodes[q.childsCount - 1] = 0
        }
        g._compressChildList(q.childsCount, q.childNodes);
        q.childsCount--
    }
    if ((!m) && (!g.dpcpy)) {
        s.tr = n;
        n.nodem = s;
        s.parentObject = v;
        if (g != v.treeNod) {
            if (s.treeNod._registerBranch(s, g)) {
                return
            }
            this._clearStyles(s);
            this._redrawFrom(this, s.parentObject);
            if (this._onradh) {
                this._onradh(s.id)
            }
        }
        this._correctPlus(v);
        this._correctLine(v);
        this._correctLine(s);
        this._correctPlus(s);
        if (r) {
            this._correctPlus(r)
        } else {
            if (v.childsCount >= 2) {
                this._correctPlus(u[v.childsCount - 2]);
                this._correctLine(u[v.childsCount - 2])
            }
        }
        this._correctPlus(u[v.childsCount - 1]);
        if (this.tscheck) {
            this._correctCheckStates(v)
        }
        if (g.tscheck) {
            g._correctCheckStates(q)
        }
    }
    if (o > 1) {
        g._correctPlus(q.childNodes[o - 2]);
        g._correctLine(q.childNodes[o - 2])
    }
    g._correctPlus(q);
    g._correctLine(q);
    this._fixChildCountLabel(v);
    g._fixChildCountLabel(q);
    this.callEvent("onDrop", [s.id, v.id, (r ? r.id : null), g, v.treeNod]);
    return s.id
};
dhtmlXTreeObject.prototype._clearStyles = function (a) {
    if (!a.htmlNode) {
        return
    }
    var h = a.htmlNode.childNodes[0].childNodes[0].childNodes[1];
    var c = h.nextSibling.nextSibling;
    a.span.innerHTML = a.label;
    a.i_sel = false;
    if (a._aimgs) {
        this.dragger.removeDraggableItem(h.nextSibling)
    }
    if (this.checkBoxOff) {
        h.childNodes[0].style.display = "";
        h.childNodes[0].onclick = this.onCheckBoxClick;
        this._setSrc(h.childNodes[0], this.imPath + this.checkArray[a.checkstate])
    } else {
        h.style.display = "none"
    }
    h.childNodes[0].treeNod = this;
    this.dragger.removeDraggableItem(c);
    if (this.dragAndDropOff) {
        this.dragger.addDraggableItem(c, this)
    }
    if (this._aimgs) {
        this.dragger.addDraggableItem(h.nextSibling, this)
    }
    c.childNodes[0].className = "standartTreeRow";
    c.onclick = this.onRowSelect;
    c.ondblclick = this.onRowClick2;
    h.previousSibling.onclick = this.onRowClick;
    this._correctLine(a);
    this._correctPlus(a);
    for (var g = 0; g < a.childsCount; g++) {
        this._clearStyles(a.childNodes[g])
    }
};
dhtmlXTreeObject.prototype._registerBranch = function (c, a) {
    if (a) {
        a._globalIdStorageSub(c.id)
    }
    c.id = this._globalIdStorageAdd(c.id, c);
    c.treeNod = this;
    for (var g = 0; g < c.childsCount; g++) {
        this._registerBranch(c.childNodes[g], a)
    }
    return 0
};
dhtmlXTreeObject.prototype.enableThreeStateCheckboxes = function (a) {
    this.tscheck = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.setOnMouseInHandler = function (a) {
    this.ehlt = true;
    this.attachEvent("onMouseIn", a)
};
dhtmlXTreeObject.prototype.setOnMouseOutHandler = function (a) {
    this.ehlt = true;
    this.attachEvent("onMouseOut", a)
};
dhtmlXTreeObject.prototype.enableMercyDrag = function (a) {
    this.dpcpy = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.enableTreeImages = function (a) {
    this.timgen = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.enableFixedMode = function (a) {
    this.hfMode = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.enableCheckBoxes = function (c, a) {
    this.checkBoxOff = convertStringToBoolean(c);
    this.cBROf = (!(this.checkBoxOff || convertStringToBoolean(a)))
};
dhtmlXTreeObject.prototype.setStdImages = function (a, g, c) {
    this.imageArray[0] = a;
    this.imageArray[1] = g;
    this.imageArray[2] = c
};
dhtmlXTreeObject.prototype.enableTreeLines = function (a) {
    this.treeLinesOn = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.setImageArrays = function (h, a, l, j, g, c) {
    switch (h) {
    case "plus":
        this.plusArray[0] = a;
        this.plusArray[1] = l;
        this.plusArray[2] = j;
        this.plusArray[3] = g;
        this.plusArray[4] = c;
        break;
    case "minus":
        this.minusArray[0] = a;
        this.minusArray[1] = l;
        this.minusArray[2] = j;
        this.minusArray[3] = g;
        this.minusArray[4] = c;
        break
    }
};
dhtmlXTreeObject.prototype.openItem = function (c) {
    this.skipLock = true;
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    } else {
        return this._openItem(a)
    }
    this.skipLock = false
};
dhtmlXTreeObject.prototype._openItem = function (a) {
    var c = this._getOpenState(a);
    if ((c < 0) || (((this.XMLsource) && (!a.XMLload)))) {
        if (!this.callEvent("onOpenStart", [a.id, c])) {
            return 0
        }
        this._HideShow(a, 2);
        if (this.checkEvent("onOpenEnd")) {
            if (this.onXLE == this._epnFHe) {
                this._epnFHe(this, a.id, true)
            }
            if (!this.xmlstate || !this.XMLsource) {
                this.callEvent("onOpenEnd", [a.id, this._getOpenState(a)])
            } else {
                this._oie_onXLE.push(this.onXLE);
                this.onXLE = this._epnFHe
            }
        }
    } else {
        if (this._srnd) {
            this._HideShow(a, 2)
        }
    }
    if (a.parentObject && !this._skip_open_parent) {
        this._openItem(a.parentObject)
    }
};
dhtmlXTreeObject.prototype.closeItem = function (c) {
    if (this.rootId == c) {
        return 0
    }
    this.skipLock = true;
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    }
    if (a.closeble) {
        this._HideShow(a, 1)
    }
    this.skipLock = false
};
dhtmlXTreeObject.prototype.getLevel = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    }
    return this._getNodeLevel(a, 0)
};
dhtmlXTreeObject.prototype.setItemCloseable = function (g, a) {
    a = convertStringToBoolean(a);
    if ((g) && (g.span)) {
        var c = g
    } else {
        var c = this._globalIdStorageFind(g)
    }
    if (!c) {
        return 0
    }
    c.closeble = a
};
dhtmlXTreeObject.prototype._getNodeLevel = function (a, c) {
    if (a.parentObject) {
        return this._getNodeLevel(a.parentObject, c + 1)
    }
    return (c)
};
dhtmlXTreeObject.prototype.hasChildren = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return 0
    } else {
        if ((this.XMLsource) && (!a.XMLload)) {
            return true
        } else {
            return a.childsCount
        }
    }
};
dhtmlXTreeObject.prototype._getLeafCount = function (h) {
    var g = 0;
    for (var c = 0; c < h.childsCount; c++) {
        if (h.childNodes[c].childsCount == 0) {
            g++
        }
    }
    return g
};
dhtmlXTreeObject.prototype.setItemText = function (h, g, c) {
    var a = this._globalIdStorageFind(h);
    if (!a) {
        return 0
    }
    a.label = g;
    a.span.innerHTML = g;
    if (this.childCalc) {
        this._fixChildCountLabel(a)
    }
    a.span.parentNode.parentNode.title = c || ""
};
dhtmlXTreeObject.prototype.getItemTooltip = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return ""
    }
    return (a.span.parentNode.parentNode._dhx_title || a.span.parentNode.parentNode.title || "")
};
dhtmlXTreeObject.prototype.refreshItem = function (c) {
    if (!c) {
        c = this.rootId
    }
    var a = this._globalIdStorageFind(c);
    this.deleteChildItems(c);
    this._loadDynXML(c)
};
dhtmlXTreeObject.prototype.setItemImage2 = function (h, a, j, g) {
    var c = this._globalIdStorageFind(h);
    if (!c) {
        return 0
    }
    c.images[1] = j;
    c.images[2] = g;
    c.images[0] = a;
    this._correctPlus(c)
};
dhtmlXTreeObject.prototype.setItemImage = function (g, a, h) {
    var c = this._globalIdStorageFind(g);
    if (!c) {
        return 0
    }
    if (h) {
        c.images[1] = a;
        c.images[2] = h
    } else {
        c.images[0] = a
    }
    this._correctPlus(c)
};
dhtmlXTreeObject.prototype.getSubItems = function (g) {
    var a = this._globalIdStorageFind(g, 0, 1);
    if (!a) {
        return 0
    }
    if (a.unParsed) {
        return (this._getSubItemsXML(a.unParsed))
    }
    var c = "";
    for (i = 0; i < a.childsCount; i++) {
        if (!c) {
            c = "" + a.childNodes[i].id
        } else {
            c += this.dlmtr + a.childNodes[i].id
        }
    }
    return c
};
dhtmlXTreeObject.prototype._getAllScraggyItems = function (g) {
    var h = "";
    for (var c = 0; c < g.childsCount; c++) {
        if ((g.childNodes[c].unParsed) || (g.childNodes[c].childsCount > 0)) {
            if (g.childNodes[c].unParsed) {
                var a = this._getAllScraggyItemsXML(g.childNodes[c].unParsed, 1)
            } else {
                var a = this._getAllScraggyItems(g.childNodes[c])
            }
            if (a) {
                if (h) {
                    h += this.dlmtr + a
                } else {
                    h = a
                }
            }
        } else {
            if (!h) {
                h = "" + g.childNodes[c].id
            } else {
                h += this.dlmtr + g.childNodes[c].id
            }
        }
    }
    return h
};
dhtmlXTreeObject.prototype._getAllFatItems = function (g) {
    var h = "";
    for (var c = 0; c < g.childsCount; c++) {
        if ((g.childNodes[c].unParsed) || (g.childNodes[c].childsCount > 0)) {
            if (!h) {
                h = "" + g.childNodes[c].id
            } else {
                h += this.dlmtr + g.childNodes[c].id
            }
            if (g.childNodes[c].unParsed) {
                var a = this._getAllFatItemsXML(g.childNodes[c].unParsed, 1)
            } else {
                var a = this._getAllFatItems(g.childNodes[c])
            }
            if (a) {
                h += this.dlmtr + a
            }
        }
    }
    return h
};
dhtmlXTreeObject.prototype._getAllSubItems = function (l, j, h) {
    if (h) {
        c = h
    } else {
        var c = this._globalIdStorageFind(l)
    }
    if (!c) {
        return 0
    }
    j = "";
    for (var g = 0; g < c.childsCount; g++) {
        if (!j) {
            j = "" + c.childNodes[g].id
        } else {
            j += this.dlmtr + c.childNodes[g].id
        }
        var a = this._getAllSubItems(0, j, c.childNodes[g]);
        if (a) {
            j += this.dlmtr + a
        }
    }
    if (c.unParsed) {
        j = this._getAllSubItemsXML(l, j, c.unParsed)
    }
    return j
};
dhtmlXTreeObject.prototype.selectItem = function (h, g, c) {
    g = convertStringToBoolean(g);
    var a = this._globalIdStorageFind(h);
    if ((!a) || (!a.parentObject)) {
        return 0
    }
    if (this.XMLloadingWarning) {
        a.parentObject.openMe = 1
    } else {
        this._openItem(a.parentObject)
    }
    var j = null;
    if (c) {
        j = new Object;
        j.ctrlKey = true;
        if (a.i_sel) {
            j.skipUnSel = true
        }
    }
    if (g) {
        this.onRowSelect(j, a.htmlNode.childNodes[0].childNodes[0].childNodes[3], false)
    } else {
        this.onRowSelect(j, a.htmlNode.childNodes[0].childNodes[0].childNodes[3], true)
    }
};
dhtmlXTreeObject.prototype.getSelectedItemText = function () {
    var c = new Array();
    for (var a = 0; a < this._selected.length; a++) {
        c[a] = this._selected[a].span.innerHTML
    }
    return (c.join(this.dlmtr))
};
dhtmlXTreeObject.prototype._compressChildList = function (a, g) {
    a--;
    for (var c = 0; c < a; c++) {
        if (g[c] == 0) {
            g[c] = g[c + 1];
            g[c + 1] = 0
        }
    }
};
dhtmlXTreeObject.prototype._deleteNode = function (m, j, o) {
    if ((!j) || (!j.parentObject)) {
        return 0
    }
    var a = 0;
    var c = 0;
    if (j.tr.nextSibling) {
        a = j.tr.nextSibling.nodem
    }
    if (j.tr.previousSibling) {
        c = j.tr.previousSibling.nodem
    }
    var l = j.parentObject;
    var g = l.childsCount;
    var n = l.childNodes;
    for (var h = 0; h < g; h++) {
        if (n[h].id == m) {
            if (!o) {
                l.htmlNode.childNodes[0].removeChild(n[h].tr)
            }
            n[h] = 0;
            break
        }
    }
    this._compressChildList(g, n);
    if (!o) {
        l.childsCount--
    }
    if (a) {
        this._correctPlus(a);
        this._correctLine(a)
    }
    if (c) {
        this._correctPlus(c);
        this._correctLine(c)
    }
    if (this.tscheck) {
        this._correctCheckStates(l)
    }
    if (!o) {
        this._globalIdStorageRecSub(j)
    }
};
dhtmlXTreeObject.prototype.setCheck = function (g, c) {
    var a = this._globalIdStorageFind(g, 0, 1);
    if (!a) {
        return
    }
    if (c === "unsure") {
        this._setCheck(a, c)
    } else {
        c = convertStringToBoolean(c);
        if ((this.tscheck) && (this.smcheck)) {
            this._setSubChecked(c, a)
        } else {
            this._setCheck(a, c)
        }
    }
    if (this.smcheck) {
        this._correctCheckStates(a.parentObject)
    }
};
dhtmlXTreeObject.prototype._setCheck = function (a, g) {
    if (!a) {
        return
    }
    if (((a.parentObject._r_logic) || (this._frbtr)) && (g)) {
        if (this._frbtrs) {
            if (this._frbtrL) {
                this.setCheck(this._frbtrL.id, 0)
            }
            this._frbtrL = a
        } else {
            for (var c = 0; c < a.parentObject.childsCount; c++) {
                this._setCheck(a.parentObject.childNodes[c], 0)
            }
        }
    }
    var h = a.htmlNode.childNodes[0].childNodes[0].childNodes[1].childNodes[0];
    if (g == "unsure") {
        a.checkstate = 2
    } else {
        if (g) {
            a.checkstate = 1
        } else {
            a.checkstate = 0
        }
    }
    if (a.dscheck) {
        a.checkstate = a.dscheck
    }
    this._setSrc(h, this.imPath + ((a.parentObject._r_logic || this._frbtr) ? this.radioArray : this.checkArray)[a.checkstate])
};
dhtmlXTreeObject.prototype.setSubChecked = function (g, c) {
    var a = this._globalIdStorageFind(g);
    this._setSubChecked(c, a);
    this._correctCheckStates(a.parentObject)
};
dhtmlXTreeObject.prototype._setSubChecked = function (g, a) {
    g = convertStringToBoolean(g);
    if (!a) {
        return
    }
    if (((a.parentObject._r_logic) || (this._frbtr)) && (g)) {
        for (var c = 0; c < a.parentObject.childsCount; c++) {
            this._setSubChecked(0, a.parentObject.childNodes[c])
        }
    }
    if (a.unParsed) {
        this._setSubCheckedXML(g, a.unParsed)
    }
    if (a._r_logic || this._frbtr) {
        this._setSubChecked(g, a.childNodes[0])
    } else {
        for (var c = 0; c < a.childsCount; c++) {
            this._setSubChecked(g, a.childNodes[c])
        }
    }
    var h = a.htmlNode.childNodes[0].childNodes[0].childNodes[1].childNodes[0];
    if (g) {
        a.checkstate = 1
    } else {
        a.checkstate = 0
    }
    if (a.dscheck) {
        a.checkstate = a.dscheck
    }
    this._setSrc(h, this.imPath + ((a.parentObject._r_logic || this._frbtr) ? this.radioArray : this.checkArray)[a.checkstate])
};
dhtmlXTreeObject.prototype.isItemChecked = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return
    }
    return a.checkstate
};
dhtmlXTreeObject.prototype.deleteChildItems = function (h) {
    var a = this._globalIdStorageFind(h);
    if (!a) {
        return
    }
    var c = a.childsCount;
    for (var g = 0; g < c; g++) {
        this._deleteNode(a.childNodes[0].id, a.childNodes[0])
    }
};
dhtmlXTreeObject.prototype.deleteItem = function (g, a) {
    if ((!this._onrdlh) || (this._onrdlh(g))) {
        var c = this._deleteItem(g, a);
        if (c) {
            this._fixChildCountLabel(c)
        }
    }
    this.allTree.childNodes[0].border = "1";
    this.allTree.childNodes[0].border = "0"
};
dhtmlXTreeObject.prototype._deleteItem = function (l, c, j) {
    c = convertStringToBoolean(c);
    var a = this._globalIdStorageFind(l);
    if (!a) {
        return
    }
    var g = this.getParentId(l);
    var h = a.parentObject;
    this._deleteNode(l, a, j);
    if (this._editCell && this._editCell.id == l) {
        this._editCell = null
    }
    this._correctPlus(h);
    this._correctLine(h);
    if ((c) && (g != this.rootId)) {
        this.selectItem(g, 1)
    }
    return h
};
dhtmlXTreeObject.prototype._globalIdStorageRecSub = function (a) {
    for (var c = 0; c < a.childsCount; c++) {
        this._globalIdStorageRecSub(a.childNodes[c]);
        this._globalIdStorageSub(a.childNodes[c].id)
    }
    this._globalIdStorageSub(a.id);
    var g = a;
    g.span = null;
    g.tr.nodem = null;
    g.tr = null;
    g.htmlNode = null
};
dhtmlXTreeObject.prototype.insertNewNext = function (n, r, q, g, l, j, h, c, a) {
    var m = this._globalIdStorageFind(n);
    if ((!m) || (!m.parentObject)) {
        return (0)
    }
    var o = this._attachChildNode(0, r, q, g, l, j, h, c, a, m);
    if ((!this.XMLloadingWarning) && (this.childCalc)) {
        this._fixChildCountLabel(m.parentObject)
    }
    return o
};
dhtmlXTreeObject.prototype.getItemIdByIndex = function (g, a) {
    var c = this._globalIdStorageFind(g);
    if ((!c) || (a >= c.childsCount)) {
        return null
    }
    return c.childNodes[a].id
};
dhtmlXTreeObject.prototype.getChildItemIdByIndex = function (g, a) {
    var c = this._globalIdStorageFind(g);
    if ((!c) || (a >= c.childsCount)) {
        return null
    }
    return c.childNodes[a].id
};
dhtmlXTreeObject.prototype.setDragHandler = function (a) {
    this.attachEvent("onDrag", a)
};
dhtmlXTreeObject.prototype._clearMove = function () {
    if (this._lastMark) {
        this._lastMark.className = this._lastMark.className.replace(/dragAndDropRow/g, "");
        this._lastMark = null
    }
    this.selectionBar.style.display = "none";
    this.allTree.className = this.allTree.className.replace(" selectionBox", "")
};
dhtmlXTreeObject.prototype.enableDragAndDrop = function (c, a) {
    if (c == "temporary_disabled") {
        this.dADTempOff = false;
        c = true
    } else {
        this.dADTempOff = true
    }
    this.dragAndDropOff = convertStringToBoolean(c);
    if (this.dragAndDropOff) {
        this.dragger.addDragLanding(this.allTree, this)
    }
    if (arguments.length > 1) {
        this._ddronr = (!convertStringToBoolean(a))
    }
};
dhtmlXTreeObject.prototype._setMove = function (j, g, m) {
    if (j.parentObject.span) {
        var h = getAbsoluteTop(j);
        var c = getAbsoluteTop(this.allTree) - this.allTree.scrollTop;
        this.dadmodec = this.dadmode;
        this.dadmodefix = 0;
        if (this.dadmode == 2) {
            var l = m - h + (document.body.scrollTop || document.documentElement.scrollTop) - 2 - j.offsetHeight / 2;
            if ((Math.abs(l) - j.offsetHeight / 6) > 0) {
                this.dadmodec = 1;
                if (l < 0) {
                    this.dadmodefix = 0 - j.offsetHeight
                }
            } else {
                this.dadmodec = 0
            }
        }
        if (this.dadmodec == 0) {
            var a = j.parentObject.span;
            a.className += " dragAndDropRow";
            this._lastMark = a
        } else {
            this._clearMove();
            this.selectionBar.style.top = (h - c + ((parseInt(j.parentObject.span.parentNode.previousSibling.childNodes[0].style.height) || 18) - 1) + this.dadmodefix) + "px";
            this.selectionBar.style.left = "5px";
            if (this.allTree.offsetWidth > 20) {
                this.selectionBar.style.width = (this.allTree.offsetWidth - (_isFF ? 30 : 25)) + "px"
            }
            this.selectionBar.style.display = ""
        }
        this._autoScroll(null, h, c)
    }
};
dhtmlXTreeObject.prototype._autoScroll = function (g, c, a) {
    if (this.autoScroll) {
        if (g) {
            c = getAbsoluteTop(g);
            a = getAbsoluteTop(this.allTree) - this.allTree.scrollTop
        }
        if ((c - a - parseInt(this.allTree.scrollTop)) > (parseInt(this.allTree.offsetHeight) - 50)) {
            this.allTree.scrollTop = parseInt(this.allTree.scrollTop) + 20
        }
        if ((c - a) < (parseInt(this.allTree.scrollTop) + 30)) {
            this.allTree.scrollTop = parseInt(this.allTree.scrollTop) - 20
        }
    }
};
dhtmlXTreeObject.prototype._createDragNode = function (j, h) {
    if (!this.dADTempOff) {
        return null
    }
    var g = j.parentObject;
    if (!this.callEvent("onBeforeDrag", [g.id, h])) {
        return null
    }
    if (!g.i_sel) {
        this._selectItem(g, h)
    }
    this._checkMSelectionLogic();
    var c = document.createElement("div");
    var l = new Array();
    if (this._itim_dg) {
        for (var a = 0; a < this._selected.length; a++) {
            l[a] = "<table cellspacing='0' cellpadding='0'><tr><td><img width='18px' height='18px' src='" + this._getSrc(this._selected[a].span.parentNode.previousSibling.childNodes[0]) + "'></td><td>" + this._selected[a].span.innerHTML + "</td></tr></table>"
        }
    } else {
        l = this.getSelectedItemText().split(this.dlmtr)
    }
    c.innerHTML = l.join("");
    c.style.position = "absolute";
    c.className = "dragSpanDiv";
    this._dragged = (new Array()).concat(this._selected);
    return c
};
dhtmlXTreeObject.prototype._focusNode = function (a) {
    var c = getAbsoluteTop(a.htmlNode) - getAbsoluteTop(this.allTree);
    if ((c > (this.allTree.offsetHeight - 30)) || (c < 0)) {
        this.allTree.scrollTop = c + this.allTree.scrollTop
    }
};
dhtmlXTreeObject.prototype._preventNsDrag = function (a) {
    if ((a) && (a.preventDefault)) {
        a.preventDefault();
        return false
    }
    return false
};
dhtmlXTreeObject.prototype._drag = function (m, n, a) {
    if (this._autoOpenTimer) {
        clearTimeout(this._autoOpenTimer)
    }
    if (!a.parentObject) {
        a = this.htmlNode.htmlNode.childNodes[0].childNodes[0].childNodes[1].childNodes[0];
        this.dadmodec = 0
    }
    this._clearMove();
    var l = m.parentObject.treeNod;
    if ((l) && (l._clearMove)) {
        l._clearMove("")
    }
    if ((!this.dragMove) || (this.dragMove())) {
        if ((!l) || (!l._clearMove) || (!l._dragged)) {
            var h = new Array(m.parentObject)
        } else {
            var h = l._dragged
        }
        var c = a.parentObject;
        for (var j = 0; j < h.length; j++) {
            var g = this._moveNode(h[j], c);
            if ((this.dadmodec) && (g !== false)) {
                c = this._globalIdStorageFind(g, true, true)
            }
            if ((g) && (!this._sADnD)) {
                this.selectItem(g, 0, 1)
            }
        }
    }
    if (l) {
        l._dragged = new Array()
    }
};
dhtmlXTreeObject.prototype._dragIn = function (l, h, a, n) {
    if (!this.dADTempOff) {
        return 0
    }
    var m = h.parentObject;
    var c = l.parentObject;
    if ((!c) && (this._ddronr)) {
        return
    }
    if (!this.callEvent("onDragIn", [m.id, c ? c.id : null, m.treeNod, this])) {
        if (c) {
            this._autoScroll(l)
        }
        return 0
    }
    if (!c) {
        this.allTree.className += " selectionBox"
    } else {
        if (m.childNodes == null) {
            this._setMove(l, a, n);
            return l
        }
        var j = m.treeNod;
        for (var g = 0; g < j._dragged.length; g++) {
            if (this._checkPNodes(c, j._dragged[g])) {
                this._autoScroll(l);
                return 0
            }
        }
        this.selectionBar.parentNode.removeChild(this.selectionBar);
        c.span.parentNode.appendChild(this.selectionBar);
        this._setMove(l, a, n);
        if (this._getOpenState(c) <= 0) {
            this._autoOpenId = c.id;
            this._autoOpenTimer = window.setTimeout(new callerFunction(this._autoOpenItem, this), 1000)
        }
    }
    return l
};
dhtmlXTreeObject.prototype._autoOpenItem = function (c, a) {
    a.openItem(a._autoOpenId)
};
dhtmlXTreeObject.prototype._dragOut = function (a) {
    this._clearMove();
    if (this._autoOpenTimer) {
        clearTimeout(this._autoOpenTimer)
    }
};
dhtmlXTreeObject.prototype._getNextNode = function (a, c) {
    if ((!c) && (a.childsCount)) {
        return a.childNodes[0]
    }
    if (a == this.htmlNode) {
        return -1
    }
    if ((a.tr) && (a.tr.nextSibling) && (a.tr.nextSibling.nodem)) {
        return a.tr.nextSibling.nodem
    }
    return this._getNextNode(a.parentObject, true)
};
dhtmlXTreeObject.prototype._lastChild = function (a) {
    if (a.childsCount) {
        return this._lastChild(a.childNodes[a.childsCount - 1])
    } else {
        return a
    }
};
dhtmlXTreeObject.prototype._getPrevNode = function (a, c) {
    if ((a.tr) && (a.tr.previousSibling) && (a.tr.previousSibling.nodem)) {
        return this._lastChild(a.tr.previousSibling.nodem)
    }
    if (a.parentObject) {
        return a.parentObject
    } else {
        return -1
    }
};
dhtmlXTreeObject.prototype.findItem = function (a, g, c) {
    var h = this._findNodeByLabel(a, g, (c ? this.htmlNode : null));
    if (h) {
        this.selectItem(h.id, true);
        this._focusNode(h);
        return h.id
    } else {
        return null
    }
};
dhtmlXTreeObject.prototype.findItemIdByLabel = function (a, g, c) {
    var h = this._findNodeByLabel(a, g, (c ? this.htmlNode : null));
    if (h) {
        return h.id
    } else {
        return null
    }
};
dhtmlXTreeObject.prototype.findStrInXML = function (c, g, j) {
    if (!c.childNodes && c.item) {
        return this.findStrInJSON(c, g, j)
    }
    if (!c.childNodes) {
        return false
    }
    for (var a = 0; a < c.childNodes.length; a++) {
        if (c.childNodes[a].nodeType == 1) {
            var h = c.childNodes[a].getAttribute(g);
            if (!h && c.childNodes[a].tagName == "itemtext") {
                h = c.childNodes[a].firstChild.data
            }
            if ((h) && (h.toLowerCase().search(j) != -1)) {
                return true
            }
            if (this.findStrInXML(c.childNodes[a], g, j)) {
                return true
            }
        }
    }
    return false
};
dhtmlXTreeObject.prototype.findStrInJSON = function (c, g, j) {
    for (var a = 0; a < c.item.length; a++) {
        var h = c.item[a].text;
        if ((h) && (h.toLowerCase().search(j) != -1)) {
            return true
        }
        if (c.item[a].item && this.findStrInJSON(c.item[a], g, j)) {
            return true
        }
    }
    return false
};
dhtmlXTreeObject.prototype._findNodeByLabel = function (a, j, h) {
    var a = a.replace(new RegExp("^( )+"), "").replace(new RegExp("( )+$"), "");
    a = new RegExp(a.replace(/([\^\.\?\*\+\\\[\]\(\)]{1})/gi, "\\$1").replace(/ /gi, ".*"), "gi");
    if (!h) {
        h = this._selected[0];
        if (!h) {
            h = this.htmlNode
        }
    }
    var c = h;
    if (!j) {
        if ((h.unParsed) && (this.findStrInXML(h.unParsed.d, "text", a))) {
            this.reParse(h)
        }
        h = this._getNextNode(c);
        if (h == -1) {
            h = this.htmlNode.childNodes[0]
        }
    } else {
        var g = this._getPrevNode(c);
        if (g == -1) {
            g = this._lastChild(this.htmlNode)
        }
        if ((g.unParsed) && (this.findStrInXML(g.unParsed.d, "text", a))) {
            this.reParse(g);
            h = this._getPrevNode(c)
        } else {
            h = g
        }
        if (h == -1) {
            h = this._lastChild(this.htmlNode)
        }
    }
    while ((h) && (h != c)) {
        if ((h.label) && (h.label.search(a) != -1)) {
            return (h)
        }
        if (!j) {
            if (h == -1) {
                if (c == this.htmlNode) {
                    break
                }
                h = this.htmlNode.childNodes[0]
            }
            if ((h.unParsed) && (this.findStrInXML(h.unParsed.d, "text", a))) {
                this.reParse(h)
            }
            h = this._getNextNode(h);
            if (h == -1) {
                h = this.htmlNode
            }
        } else {
            var g = this._getPrevNode(h);
            if (g == -1) {
                g = this._lastChild(this.htmlNode)
            }
            if ((g.unParsed) && (this.findStrInXML(g.unParsed.d, "text", a))) {
                this.reParse(g);
                h = this._getPrevNode(h)
            } else {
                h = g
            }
            if (h == -1) {
                h = this._lastChild(this.htmlNode)
            }
        }
    }
    return null
};
dhtmlXTreeObject.prototype.moveItem = function (n, c, o, a) {
    var j = this._globalIdStorageFind(n);
    if (!j) {
        return (0)
    }
    var l = null;
    switch (c) {
    case "right":
        alert("Not supported yet");
        break;
    case "item_child":
        var g = (a || this)._globalIdStorageFind(o);
        if (!g) {
            return (0)
        }
        l = (a || this)._moveNodeTo(j, g, 0);
        break;
    case "item_sibling":
        var g = (a || this)._globalIdStorageFind(o);
        if (!g) {
            return (0)
        }
        l = (a || this)._moveNodeTo(j, g.parentObject, g);
        break;
    case "item_sibling_next":
        var g = (a || this)._globalIdStorageFind(o);
        if (!g) {
            return (0)
        }
        if ((g.tr) && (g.tr.nextSibling) && (g.tr.nextSibling.nodem)) {
            l = (a || this)._moveNodeTo(j, g.parentObject, g.tr.nextSibling.nodem)
        } else {
            l = (a || this)._moveNodeTo(j, g.parentObject)
        }
        break;
    case "left":
        if (j.parentObject.parentObject) {
            l = this._moveNodeTo(j, j.parentObject.parentObject, j.parentObject)
        }
        break;
    case "up":
        var m = this._getPrevNode(j);
        if ((m == -1) || (!m.parentObject)) {
            return null
        }
        l = this._moveNodeTo(j, m.parentObject, m);
        break;
    case "up_strict":
        var m = this._getIndex(j);
        if (m != 0) {
            l = this._moveNodeTo(j, j.parentObject, j.parentObject.childNodes[m - 1])
        }
        break;
    case "down_strict":
        var m = this._getIndex(j);
        var h = j.parentObject.childsCount - 2;
        if (m == h) {
            l = this._moveNodeTo(j, j.parentObject)
        } else {
            if (m < h) {
                l = this._moveNodeTo(j, j.parentObject, j.parentObject.childNodes[m + 2])
            }
        }
        break;
    case "down":
        var m = this._getNextNode(this._lastChild(j));
        if ((m == -1) || (!m.parentObject)) {
            return
        }
        if (m.parentObject == j.parentObject) {
            var m = this._getNextNode(m)
        }
        if (m == -1) {
            l = this._moveNodeTo(j, j.parentObject)
        } else {
            if ((m == -1) || (!m.parentObject)) {
                return
            }
            l = this._moveNodeTo(j, m.parentObject, m)
        }
        break
    }
    if (_isIE && _isIE < 8) {
        this.allTree.childNodes[0].border = "1";
        this.allTree.childNodes[0].border = "0"
    }
    return l
};
dhtmlXTreeObject.prototype.setDragBehavior = function (c, a) {
    this._sADnD = (!convertStringToBoolean(a));
    switch (c) {
    case "child":
        this.dadmode = 0;
        break;
    case "sibling":
        this.dadmode = 1;
        break;
    case "complex":
        this.dadmode = 2;
        break
    }
};
dhtmlXTreeObject.prototype._loadDynXML = function (g, c) {
    c = c || this.XMLsource;
    var a = (new Date()).valueOf();
    this._ld_id = g;
    if (this.xmlalb == "function") {
        if (c) {
            c(this._escape(g))
        }
    } else {
        if (this.xmlalb == "name") {
            this.loadXML(c + this._escape(g))
        } else {
            if (this.xmlalb == "xmlname") {
                this.loadXML(c + this._escape(g) + ".xml?uid=" + a)
            } else {
                this.loadXML(c + getUrlSymbol(c) + "uid=" + a + "&id=" + this._escape(g))
            }
        }
    }
};
dhtmlXTreeObject.prototype.enableMultiselection = function (c, a) {
    this._amsel = convertStringToBoolean(c);
    this._amselS = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype._checkMSelectionLogic = function () {
    var g = new Array();
    for (var c = 0; c < this._selected.length; c++) {
        for (var a = 0; a < this._selected.length; a++) {
            if ((c != a) && (this._checkPNodes(this._selected[a], this._selected[c]))) {
                g[g.length] = this._selected[a]
            }
        }
    }
    for (var c = 0; c < g.length; c++) {
        this._unselectItem(g[c])
    }
};
dhtmlXTreeObject.prototype._checkPNodes = function (c, a) {
    if (this._dcheckf) {
        return false
    }
    if (a == c) {
        return 1
    }
    if (c.parentObject) {
        return this._checkPNodes(c.parentObject, a)
    } else {
        return 0
    }
};
dhtmlXTreeObject.prototype.disableDropCheck = function (a) {
    this._dcheckf = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.enableDistributedParsing = function (g, c, a) {
    this._edsbps = convertStringToBoolean(g);
    this._edsbpsA = new Array();
    this._edsbpsC = c || 10;
    this._edsbpsD = a || 250
};
dhtmlXTreeObject.prototype.getDistributedParsingState = function () {
    return (!((!this._edsbpsA) || (!this._edsbpsA.length)))
};
dhtmlXTreeObject.prototype.getItemParsingState = function (g) {
    var c = this._globalIdStorageFind(g, true, true);
    if (!c) {
        return 0
    }
    if (this._edsbpsA) {
        for (var a = 0; a < this._edsbpsA.length; a++) {
            if (this._edsbpsA[a][2] == g) {
                return -1
            }
        }
    }
    return 1
};
dhtmlXTreeObject.prototype._distributedStart = function (c, j, h, g, a) {
    if (!this._edsbpsA) {
        this._edsbpsA = new Array()
    }
    this._edsbpsA[this._edsbpsA.length] = [c, j, h, g, a]
};
dhtmlXTreeObject.prototype._distributedStep = function (h) {
    var c = this;
    if ((!this._edsbpsA) || (!this._edsbpsA.length)) {
        c.XMLloadingWarning = 0;
        return
    }
    var j = this._edsbpsA[0];
    this.parsedArray = new Array();
    this._parse(j[0], j[2], j[3], j[1]);
    var a = this._globalIdStorageFind(j[2]);
    this._redrawFrom(this, a, j[4], this._getOpenState(a));
    var g = this.setCheckList.split(this.dlmtr);
    for (var l = 0; l < g.length; l++) {
        if (g[l]) {
            this.setCheck(g[l], 1)
        }
    }
    this._edsbpsA = (new Array()).concat(this._edsbpsA.slice(1));
    if ((!this._edsbpsA.length)) {
        window.setTimeout(function () {
            if (c.onXLE) {
                c.onXLE(c, h)
            }
            c.callEvent("onXLE", [c, h])
        }, 1);
        c.xmlstate = 0
    }
};
dhtmlXTreeObject.prototype.enableTextSigns = function (a) {
    this._txtimg = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.preventIECaching = function (a) {
    this.no_cashe = convertStringToBoolean(a);
    this.XMLLoader.rSeed = this.no_cashe
};
dhtmlXTreeObject.prototype.preventIECashing = dhtmlXTreeObject.prototype.preventIECaching;
dhtmlXTreeObject.prototype.disableCheckbox = function (g, c) {
    if (typeof (g) != "object") {
        var a = this._globalIdStorageFind(g, 0, 1)
    } else {
        var a = g
    }
    if (!a) {
        return
    }
    a.dscheck = convertStringToBoolean(c) ? (((a.checkstate || 0) % 3) + 3) : ((a.checkstate > 2) ? (a.checkstate - 3) : a.checkstate);
    this._setCheck(a);
    if (a.dscheck < 3) {
        a.dscheck = false
    }
};
dhtmlXTreeObject.prototype.smartRefreshBranch = function (c, a) {
    this._branchUpdate = 1;
    this.smartRefreshItem(c, a)
};
dhtmlXTreeObject.prototype.smartRefreshItem = function (h, g) {
    var a = this._globalIdStorageFind(h);
    for (var c = 0; c < a.childsCount; c++) {
        a.childNodes[c]._dmark = true
    }
    this.waitUpdateXML = true;
    if (g && g.exists) {
        this._parse(g, h)
    } else {
        this._loadDynXML(h, g)
    }
};
dhtmlXTreeObject.prototype.refreshItems = function (c, g) {
    var h = c.toString().split(this.dlmtr);
    this.waitUpdateXML = new Array();
    for (var a = 0; a < h.length; a++) {
        this.waitUpdateXML[h[a]] = true
    }
    this.loadXML((g || this.XMLsource) + getUrlSymbol(g || this.XMLsource) + "ids=" + this._escape(c))
};
dhtmlXTreeObject.prototype.updateItem = function (m, l, h, g, c, j, n) {
    var a = this._globalIdStorageFind(m);
    a.userData = new cObject();
    if (l) {
        a.label = l
    }
    a.images = new Array(h || this.imageArray[0], g || this.imageArray[1], c || this.imageArray[2]);
    this.setItemText(m, l);
    if (j) {
        this._setCheck(a, true)
    }
    if (n == "1" && !this.hasChildren(m)) {
        a.XMLload = 0
    }
    this._correctPlus(a);
    a._dmark = false;
    return a
};
dhtmlXTreeObject.prototype.setDropHandler = function (a) {
    this.attachEvent("onDrop", a)
};
dhtmlXTreeObject.prototype.setOnLoadingStart = function (a) {
    this.attachEvent("onXLS", a)
};
dhtmlXTreeObject.prototype.setOnLoadingEnd = function (a) {
    this.attachEvent("onXLE", a)
};
dhtmlXTreeObject.prototype.setXMLAutoLoadingBehaviour = function (a) {
    this.xmlalb = a
};
dhtmlXTreeObject.prototype.enableSmartCheckboxes = function (a) {
    this.smcheck = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.getXMLState = function () {
    return (this.xmlstate == 1)
};
dhtmlXTreeObject.prototype.setItemTopOffset = function (l, h) {
    var g;
    if (typeof (l) != "object") {
        g = this._globalIdStorageFind(l)
    } else {
        g = l
    }
    var j = g.span.parentNode.parentNode;
    g.span.style.paddingBottom = "1px";
    for (var c = 0; c < j.childNodes.length; c++) {
        if (c != 0) {
            if (_isIE) {
                j.childNodes[c].style.height = "18px";
                j.childNodes[c].style.paddingTop = parseInt(h) + "px"
            } else {
                j.childNodes[c].style.height = 18 + parseInt(h) + "px"
            }
        } else {
            var a = j.childNodes[c].firstChild;
            if (j.childNodes[c].firstChild.tagName != "DIV") {
                a = document.createElement("DIV");
                j.childNodes[c].insertBefore(a, j.childNodes[c].firstChild)
            }
            a.style.height = parseInt(h) + "px";
            if ((g.parentObject.id != this.rootId || g.parentObject.childNodes[0] != g) && this.treeLinesOn) {
                a.style.backgroundImage = "url(" + this.imPath + this.lineArray[5] + ")"
            }
            a.innerHTML = "&nbsp;";
            a.style.overflow = "hidden";
            if (parseInt(h) == 0) {
                j.childNodes[c].removeChild(a)
            }
        }
        if (!_isIE) {
            j.childNodes[c].style.verticalAlign = "bottom"
        }
        if (_isIE) {
            this.allTree.childNodes[0].border = "1";
            this.allTree.childNodes[0].border = "0"
        }
    }
};
dhtmlXTreeObject.prototype.setIconSize = function (h, c, j) {
    if (j) {
        if ((j) && (j.span)) {
            var a = j
        } else {
            var a = this._globalIdStorageFind(j)
        }
        if (!a) {
            return (0)
        }
        var g = a.span.parentNode.previousSibling.childNodes[0];
        if (h) {
            g.style.width = h;
            if (window._KHTMLrv) {
                g.parentNode.style.width = h
            }
        }
        if (c) {
            g.style.height = c;
            if (window._KHTMLrv) {
                g.parentNode.style.height = c
            }
        }
    } else {
        this.def_img_x = h;
        this.def_img_y = c
    }
};
dhtmlXTreeObject.prototype.getItemImage = function (j, h, c) {
    var g = this._globalIdStorageFind(j);
    if (!g) {
        return ""
    }
    var a = g.images[h || 0];
    if (c) {
        a = this.iconURL + a
    }
    return a
};
dhtmlXTreeObject.prototype.enableRadioButtons = function (h, g) {
    if (arguments.length == 1) {
        this._frbtr = convertStringToBoolean(h);
        this.checkBoxOff = this.checkBoxOff || this._frbtr;
        return
    }
    var c = this._globalIdStorageFind(h);
    if (!c) {
        return ""
    }
    g = convertStringToBoolean(g);
    if ((g) && (!c._r_logic)) {
        c._r_logic = true;
        for (var a = 0; a < c.childsCount; a++) {
            this._setCheck(c.childNodes[a], c.childNodes[a].checkstate)
        }
    }
    if ((!g) && (c._r_logic)) {
        c._r_logic = false;
        for (var a = 0; a < c.childsCount; a++) {
            this._setCheck(c.childNodes[a], c.childNodes[a].checkstate)
        }
    }
};
dhtmlXTreeObject.prototype.enableSingleRadioMode = function (a) {
    this._frbtrs = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.openOnItemAdded = function (a) {
    this._hAdI = !convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.openOnItemAdding = function (a) {
    this._hAdI = !convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.enableMultiLineItems = function (a) {
    if (a === true) {
        this.mlitems = "100%"
    } else {
        this.mlitems = a
    }
};
dhtmlXTreeObject.prototype.enableAutoTooltips = function (a) {
    this.ettip = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.clearSelection = function (a) {
    if (a) {
        this._unselectItem(this._globalIdStorageFind(a))
    } else {
        this._unselectItems()
    }
};
dhtmlXTreeObject.prototype.showItemSign = function (h, c) {
    var a = this._globalIdStorageFind(h);
    if (!a) {
        return 0
    }
    var g = a.span.parentNode.previousSibling.previousSibling.previousSibling;
    if (!convertStringToBoolean(c)) {
        this._openItem(a);
        a.closeble = false;
        a.wsign = true
    } else {
        a.closeble = true;
        a.wsign = false
    }
    this._correctPlus(a)
};
dhtmlXTreeObject.prototype.showItemCheckbox = function (j, h) {
    if (!j) {
        for (var c in this._idpull) {
            this.showItemCheckbox(this._idpull[c], h)
        }
    }
    if (typeof (j) != "object") {
        j = this._globalIdStorageFind(j, 0, 0)
    }
    if (!j) {
        return 0
    }
    j.nocheckbox = !convertStringToBoolean(h);
    var g = j.span.parentNode.previousSibling.previousSibling.childNodes[0];
    g.parentNode.style.display = (!j.nocheckbox) ? "" : "none"
};
dhtmlXTreeObject.prototype.setListDelimeter = function (a) {
    this.dlmtr = a
};
dhtmlXTreeObject.prototype.setEscapingMode = function (a) {
    this.utfesc = a
};
dhtmlXTreeObject.prototype.enableHighlighting = function (a) {
    this.ehlt = true;
    this.ehlta = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype._itemMouseOut = function () {
    var c = this.childNodes[3].parentObject;
    var a = c.treeNod;
    a.callEvent("onMouseOut", [c.id]);
    if (c.id == a._l_onMSI) {
        a._l_onMSI = null
    }
    if (!a.ehlta) {
        return
    }
    c.span.className = c.span.className.replace("_lor", "")
};
dhtmlXTreeObject.prototype._itemMouseIn = function () {
    var c = this.childNodes[3].parentObject;
    var a = c.treeNod;
    if (a._l_onMSI != c.id) {
        a.callEvent("onMouseIn", [c.id])
    }
    a._l_onMSI = c.id;
    if (!a.ehlta) {
        return
    }
    c.span.className = c.span.className.replace("_lor", "");
    c.span.className = c.span.className.replace(/((standart|selected)TreeRow)/, "$1_lor")
};
dhtmlXTreeObject.prototype.enableActiveImages = function (a) {
    this._aimgs = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.focusItem = function (c) {
    var a = this._globalIdStorageFind(c);
    if (!a) {
        return (0)
    }
    this._focusNode(a)
};
dhtmlXTreeObject.prototype.getAllSubItems = function (a) {
    return this._getAllSubItems(a)
};
dhtmlXTreeObject.prototype.getAllChildless = function () {
    return this._getAllScraggyItems(this.htmlNode)
};
dhtmlXTreeObject.prototype.getAllLeafs = dhtmlXTreeObject.prototype.getAllChildless;
dhtmlXTreeObject.prototype._getAllScraggyItems = function (g) {
    var h = "";
    for (var c = 0; c < g.childsCount; c++) {
        if ((g.childNodes[c].unParsed) || (g.childNodes[c].childsCount > 0)) {
            if (g.childNodes[c].unParsed) {
                var a = this._getAllScraggyItemsXML(g.childNodes[c].unParsed, 1)
            } else {
                var a = this._getAllScraggyItems(g.childNodes[c])
            }
            if (a) {
                if (h) {
                    h += this.dlmtr + a
                } else {
                    h = a
                }
            }
        } else {
            if (!h) {
                h = "" + g.childNodes[c].id
            } else {
                h += this.dlmtr + g.childNodes[c].id
            }
        }
    }
    return h
};
dhtmlXTreeObject.prototype._getAllFatItems = function (g) {
    var h = "";
    for (var c = 0; c < g.childsCount; c++) {
        if ((g.childNodes[c].unParsed) || (g.childNodes[c].childsCount > 0)) {
            if (!h) {
                h = "" + g.childNodes[c].id
            } else {
                h += this.dlmtr + g.childNodes[c].id
            }
            if (g.childNodes[c].unParsed) {
                var a = this._getAllFatItemsXML(g.childNodes[c].unParsed, 1)
            } else {
                var a = this._getAllFatItems(g.childNodes[c])
            }
            if (a) {
                h += this.dlmtr + a
            }
        }
    }
    return h
};
dhtmlXTreeObject.prototype.getAllItemsWithKids = function () {
    return this._getAllFatItems(this.htmlNode)
};
dhtmlXTreeObject.prototype.getAllFatItems = dhtmlXTreeObject.prototype.getAllItemsWithKids;
dhtmlXTreeObject.prototype.getAllChecked = function () {
    return this._getAllChecked("", "", 1)
};
dhtmlXTreeObject.prototype.getAllUnchecked = function (a) {
    if (a) {
        a = this._globalIdStorageFind(a)
    }
    return this._getAllChecked(a, "", 0)
};
dhtmlXTreeObject.prototype.getAllPartiallyChecked = function () {
    return this._getAllChecked("", "", 2)
};
dhtmlXTreeObject.prototype.getAllCheckedBranches = function () {
    var a = [this._getAllChecked("", "", 1)];
    var c = this._getAllChecked("", "", 2);
    if (c) {
        a.push(c)
    }
    return a.join(this.dlmtr)
};
dhtmlXTreeObject.prototype._getAllChecked = function (h, g, l) {
    if (!h) {
        h = this.htmlNode
    }
    if (h.checkstate == l) {
        if (!h.nocheckbox) {
            if (g) {
                g += this.dlmtr + h.id
            } else {
                g = "" + h.id
            }
        }
    }
    var a = h.childsCount;
    for (var c = 0; c < a; c++) {
        g = this._getAllChecked(h.childNodes[c], g, l)
    }
    if (h.unParsed) {
        g = this._getAllCheckedXML(h.unParsed, g, l)
    }
    if (g) {
        return g
    } else {
        return ""
    }
};
dhtmlXTreeObject.prototype.setItemStyle = function (h, g, c) {
    var c = c || false;
    var a = this._globalIdStorageFind(h);
    if (!a) {
        return 0
    }
    if (!a.span.style.cssText) {
        a.span.setAttribute("style", a.span.getAttribute("style") + "; " + g)
    } else {
        a.span.style.cssText = c ? g : a.span.style.cssText + ";" + g
    }
};
dhtmlXTreeObject.prototype.enableImageDrag = function (a) {
    this._itim_dg = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.setOnDragIn = function (a) {
    this.attachEvent("onDragIn", a)
};
dhtmlXTreeObject.prototype.enableDragAndDropScrolling = function (a) {
    this.autoScroll = convertStringToBoolean(a)
};
dhtmlXTreeObject.prototype.setSkin = function (a) {
    var c = this.parentObject.className.replace(/dhxtree_[^ ]*/gi, "");
    this.parentObject.className = c + " dhxtree_" + a;
    if (a == "dhx_terrace" || a == "dhx_web") {
        this.enableTreeLines(false)
    }
};
(function () {
    dhtmlx.extend_api("dhtmlXTreeObject", {
        _init: function (a) {
            return [a.parent, (a.width || "100%"), (a.height || "100%"), (a.root_id || 0)]
        },
        auto_save_selection: "enableAutoSavingSelected",
        auto_tooltip: "enableAutoTooltips",
        checkbox: "enableCheckBoxes",
        checkbox_3_state: "enableThreeStateCheckboxes",
        checkbox_smart: "enableSmartCheckboxes",
        context_menu: "enableContextMenu",
        distributed_parsing: "enableDistributedParsing",
        drag: "enableDragAndDrop",
        drag_copy: "enableMercyDrag",
        drag_image: "enableImageDrag",
        drag_scroll: "enableDragAndDropScrolling",
        editor: "enableItemEditor",
        hover: "enableHighlighting",
        images: "enableTreeImages",
        image_fix: "enableIEImageFix",
        image_path: "setImagePath",
        lines: "enableTreeLines",
        loading_item: "enableLoadingItem",
        multiline: "enableMultiLineItems",
        multiselect: "enableMultiselection",
        navigation: "enableKeyboardNavigation",
        radio: "enableRadioButtons",
        radio_single: "enableSingleRadioMode",
        rtl: "enableRTL",
        search: "enableKeySearch",
        smart_parsing: "enableSmartXMLParsing",
        smart_rendering: "enableSmartRendering",
        text_icons: "enableTextSigns",
        xml: "loadXML",
        skin: "setSkin"
    }, {})
})();
dhtmlXTreeObject.prototype._dp_init = function (a) {
    a.attachEvent("insertCallback", function (h, l, c) {
        var g = this._loader.doXPath(".//item", h);
        var j = g[0].getAttribute("text");
        this.obj.insertNewItem(c, l, j, 0, 0, 0, 0, "CHILD")
    });
    a.attachEvent("updateCallback", function (h, l, c) {
        var g = this._loader.doXPath(".//item", h);
        var j = g[0].getAttribute("text");
        this.obj.setItemText(l, j);
        if (this.obj.getParentId(l) != c) {
            this.obj.moveItem(l, "item_child", c)
        }
        this.setUpdated(l, true, "updated")
    });
    a.attachEvent("deleteCallback", function (g, h, c) {
        this.obj.setUserData(h, this.action_param, "true_deleted");
        this.obj.deleteItem(h, false)
    });
    a._methods = ["setItemStyle", "", "changeItemId", "deleteItem"];
    this.attachEvent("onEdit", function (c, g) {
        if (c == 3) {
            a.setUpdated(g, true)
        }
        return true
    });
    this.attachEvent("onDrop", function (l, j, h, g, c) {
        if (g == c) {
            a.setUpdated(l, true)
        }
    });
    this._onrdlh = function (c) {
        var g = a.getState(c);
        if (g == "inserted") {
            a.set_invalid(c, false);
            a.setUpdated(c, false);
            return true
        }
        if (g == "true_deleted") {
            a.setUpdated(c, false);
            return true
        }
        a.setUpdated(c, true, "deleted");
        return false
    };
    this._onradh = function (c) {
        a.setUpdated(c, true, "inserted")
    };
    a._getRowData = function (j) {
        var h = {};
        var l = this.obj._globalIdStorageFind(j);
        var g = l.parentObject;
        var c = 0;
        for (c = 0; c < g.childsCount; c++) {
            if (g.childNodes[c] == l) {
                break
            }
        }
        h.tr_id = l.id;
        h.tr_pid = g.id;
        h.tr_order = c;
        h.tr_text = l.span.innerHTML;
        g = (l._userdatalist || "").split(",");
        for (c = 0; c < g.length; c++) {
            h[g[c]] = l.userData["t_" + g[c]]
        }
        return h
    }
};
dhtmlXTreeObject.prototype.makeDraggable = function (c, a) {
    if (typeof (c) != "object") {
        c = document.getElementById(c)
    }
    dragger = new dhtmlDragAndDropObject();
    dropper = new dhx_dragSomethingInTree();
    dragger.addDraggableItem(c, dropper);
    c.dragLanding = null;
    c.ondragstart = dropper._preventNsDrag;
    c.onselectstart = new Function("return false;");
    c.parentObject = new Object;
    c.parentObject.img = c;
    c.parentObject.treeNod = dropper;
    dropper._customDrop = a
};
dhtmlXTreeObject.prototype.makeDragable = dhtmlXTreeObject.prototype.makeDraggable;
dhtmlXTreeObject.prototype.makeAllDraggable = function (c) {
    var g = document.getElementsByTagName("div");
    for (var a = 0; a < g.length; a++) {
        if (g[a].getAttribute("dragInDhtmlXTree")) {
            this.makeDragable(g[a], c)
        }
    }
};

function dhx_dragSomethingInTree() {
    this.lWin = window;
    this._createDragNode = function (c) {
        var a = document.createElement("div");
        a.style.position = "absolute";
        a.innerHTML = (c.innerHTML || c.value);
        a.className = "dragSpanDiv";
        return a
    };
    this._preventNsDrag = function (a) {
        (a || window.event).cancelBubble = true;
        if ((a) && (a.preventDefault)) {
            a.preventDefault();
            return false
        }
        return false
    };
    this._nonTrivialNode = function (c, g, a, h) {
        if (this._customDrop) {
            return this._customDrop(c, h.img.id, g.id, a ? a.id : null)
        }
        var j = (h.img.getAttribute("image") || "");
        var m = h.img.id || "new";
        var l = (h.img.getAttribute("text") || (_isIE ? h.img.innerText : h.img.textContent));
        c[a ? "insertNewNext" : "insertNewItem"](a ? a.id : g.id, m, l, "", j, j, j)
    }
}
dhtmlXTreeObject.prototype.enableItemEditor = function (a) {
    this._eItEd = convertStringToBoolean(a);
    if (!this._eItEdFlag) {
        this._edn_click_IE = true;
        this._edn_dblclick = true;
        this._ie_aFunc = this.aFunc;
        this._ie_dblclickFuncHandler = this.dblclickFuncHandler;
        this.setOnDblClickHandler(function (g, c) {
            if (this._edn_dblclick) {
                this._editItem(g, c)
            }
            return true
        });
        this.setOnClickHandler(function (g, c) {
            this._stopEditItem(g, c);
            if ((this.ed_hist_clcik == g) && (this._edn_click_IE)) {
                this._editItem(g, c)
            }
            this.ed_hist_clcik = g;
            return true
        });
        this._eItEdFlag = true
    }
};
dhtmlXTreeObject.prototype.setOnEditHandler = function (a) {
    this.attachEvent("onEdit", a)
};
dhtmlXTreeObject.prototype.setEditStartAction = function (a, c) {
    this._edn_click_IE = convertStringToBoolean(a);
    this._edn_dblclick = convertStringToBoolean(c)
};
dhtmlXTreeObject.prototype._stopEdit = function (c, l) {
    if (this._editCell) {
        this.dADTempOff = this.dADTempOffEd;
        if (this._editCell.id != c) {
            var h = true;
            if (!l) {
                h = this.callEvent("onEdit", [2, this._editCell.id, this, this._editCell.span.childNodes[0].value])
            } else {
                h = false;
                this.callEvent("onEditCancel", [this._editCell.id, this._editCell._oldValue])
            }
            if (h === true) {
                h = this._editCell.span.childNodes[0].value
            } else {
                if (h === false) {
                    h = this._editCell._oldValue
                }
            }
            var j = (h != this._editCell._oldValue);
            this._editCell.span.innerHTML = h;
            this._editCell.label = this._editCell.span.innerHTML;
            var g = this._editCell.i_sel ? "selectedTreeRow" : "standartTreeRow";
            this._editCell.span.className = g;
            this._editCell.span.parentNode.className = "standartTreeRow";
            this._editCell.span.style.paddingRight = this._editCell.span.style.paddingLeft = "5px";
            this._editCell.span.onclick = this._editCell.span.ondblclick = function () {};
            var m = this._editCell.id;
            if (this.childCalc) {
                this._fixChildCountLabel(this._editCell)
            }
            this._editCell = null;
            if (!l) {
                this.callEvent("onEdit", [3, m, this, j])
            }
            if (this._enblkbrd) {
                this.parentObject.lastChild.focus();
                this.parentObject.lastChild.focus()
            }
        }
    }
};
dhtmlXTreeObject.prototype._stopEditItem = function (c, a) {
    this._stopEdit(c)
};
dhtmlXTreeObject.prototype.stopEdit = function (a) {
    if (this._editCell) {
        this._stopEdit(this._editCell.id + "_non", a)
    }
};
dhtmlXTreeObject.prototype.editItem = function (a) {
    this._editItem(a, this)
};
dhtmlXTreeObject.prototype._editItem = function (j, a) {
    if (this._eItEd) {
        this._stopEdit();
        var g = this._globalIdStorageFind(j);
        if (!g) {
            return
        }
        var h = this.callEvent("onEdit", [0, j, this, g.span.innerHTML]);
        if (h === true) {
            h = (typeof g.span.innerText != "undefined" ? g.span.innerText : g.span.textContent)
        } else {
            if (h === false) {
                return
            }
        }
        this.dADTempOffEd = this.dADTempOff;
        this.dADTempOff = false;
        this._editCell = g;
        g._oldValue = h;
        g.span.innerHTML = "<input type='text' class='intreeeditRow' />";
        g.span.style.paddingRight = g.span.style.paddingLeft = "0px";
        g.span.onclick = g.span.ondblclick = function (l) {
            (l || event).cancelBubble = true
        };
        g.span.childNodes[0].value = h;
        g.span.childNodes[0].onselectstart = function (l) {
            (l || event).cancelBubble = true;
            return true
        };
        g.span.childNodes[0].onmousedown = function (l) {
            (l || event).cancelBubble = true;
            return true
        };
        g.span.childNodes[0].focus();
        g.span.childNodes[0].focus();
        g.span.onclick = function (l) {
            (l || event).cancelBubble = true;
            return false
        };
        g.span.className = "";
        g.span.parentNode.className = "";
        var c = this;
        g.span.childNodes[0].onkeydown = function (l) {
            if (!l) {
                l = window.event
            }
            if (l.keyCode == 13) {
                l.cancelBubble = true;
                c._stopEdit(window.undefined)
            } else {
                if (l.keyCode == 27) {
                    c._stopEdit(window.undefined, true)
                }
            }(l || event).cancelBubble = true
        };
        this.callEvent("onEdit", [1, j, this])
    }
};

function jsonPointer(c, a) {
    this.d = c;
    this.dp = a
}
jsonPointer.prototype = {
    text: function () {
        var a = function (j) {
                var h = [];
                for (var g = 0; g < j.length; g++) {
                    h.push("{" + c(j[g]) + "}")
                }
                return h.join(",")
            };
        var c = function (j) {
                var h = [];
                for (var g in j) {
                    if (typeof (j[g]) == "object") {
                        if (g.length) {
                            h.push('"' + g + '":[' + a(j[g]) + "]")
                        } else {
                            h.push('"' + g + '":{' + c(j[g]) + "}")
                        }
                    } else {
                        h.push('"' + g + '":"' + j[g] + '"')
                    }
                }
                return h.join(",")
            };
        return "{" + c(this.d) + "}"
    },
    get: function (a) {
        return this.d[a]
    },
    exists: function () {
        return !!this.d
    },
    content: function () {
        return this.d.content
    },
    each: function (h, m, l) {
        var g = this.d[h];
        var n = new jsonPointer();
        if (g) {
            for (var j = 0; j < g.length; j++) {
                n.d = g[j];
                m.apply(l, [n, j])
            }
        }
    },
    get_all: function () {
        return this.d
    },
    sub: function (a) {
        return new jsonPointer(this.d[a], this.d)
    },
    sub_exists: function (a) {
        return !!this.d[a]
    },
    each_x: function (h, n, m, l, j) {
        var g = this.d[h];
        var o = new jsonPointer(0, this.d);
        if (g) {
            for (j = j || 0; j < g.length; j++) {
                if (g[j][n]) {
                    o.d = g[j];
                    if (m.apply(l, [o, j]) == -1) {
                        return
                    }
                }
            }
        }
    },
    up: function (a) {
        return new jsonPointer(this.dp, this.d)
    },
    set: function (a, c) {
        this.d[a] = c
    },
    clone: function (a) {
        return new jsonPointer(this.d, this.dp)
    },
    through: function (g, m, q, j, r) {
        var n = this.d[g];
        if (n.length) {
            for (var h = 0; h < n.length; h++) {
                if (n[h][m] != null && n[h][m] != "" && (!q || n[h][m] == q)) {
                    var l = new jsonPointer(n[h], this.d);
                    j.apply(r, [l, h])
                }
                var o = this.d;
                this.d = n[h];
                if (this.sub_exists(g)) {
                    this.through(g, m, q, j, r)
                }
                this.d = o
            }
        }
    }
};
dhtmlXTreeObject.prototype.loadJSArrayFile = function (file, afterCall) {
    if (!this.parsCount) {
        this.callEvent("onXLS", [this, this._ld_id])
    }
    this._ld_id = null;
    this.xmlstate = 1;
    var that = this;
    this.XMLLoader = new dtmlXMLLoaderObject(function () {
        eval("var z=" + arguments[4].xmlDoc.responseText);
        that.loadJSArray(z)
    }, this, true, this.no_cashe);
    if (afterCall) {
        this.XMLLoader.waitCall = afterCall
    }
    this.XMLLoader.loadXML(file)
};
dhtmlXTreeObject.prototype.loadCSV = function (a, g) {
    if (!this.parsCount) {
        this.callEvent("onXLS", [this, this._ld_id])
    }
    this._ld_id = null;
    this.xmlstate = 1;
    var c = this;
    this.XMLLoader = new dtmlXMLLoaderObject(function () {
        c.loadCSVString(arguments[4].xmlDoc.responseText)
    }, this, true, this.no_cashe);
    if (g) {
        this.XMLLoader.waitCall = g
    }
    this.XMLLoader.loadXML(a)
};
dhtmlXTreeObject.prototype.loadJSArray = function (a, h) {
    var l = [];
    for (var c = 0; c < a.length; c++) {
        if (!l[a[c][1]]) {
            l[a[c][1]] = []
        }
        l[a[c][1]].push({
            id: a[c][0],
            text: a[c][2]
        })
    }
    var j = {
        id: this.rootId
    };
    var g = function (o, n) {
            if (l[o.id]) {
                o.item = l[o.id];
                for (var m = 0; m < o.item.length; m++) {
                    n(o.item[m], n)
                }
            }
        };
    g(j, g);
    this.loadJSONObject(j, h)
};
dhtmlXTreeObject.prototype.loadCSVString = function (a, l) {
    var n = [];
    var c = a.split("\n");
    for (var h = 0; h < c.length; h++) {
        var g = c[h].split(",");
        if (!n[g[1]]) {
            n[g[1]] = []
        }
        n[g[1]].push({
            id: g[0],
            text: g[2]
        })
    }
    var m = {
        id: this.rootId
    };
    var j = function (r, q) {
            if (n[r.id]) {
                r.item = n[r.id];
                for (var o = 0; o < r.item.length; o++) {
                    q(r.item[o], q)
                }
            }
        };
    j(m, j);
    this.loadJSONObject(m, l)
};
dhtmlXTreeObject.prototype.loadJSONObject = function (a, c) {
    if (!this.parsCount) {
        this.callEvent("onXLS", [this, null])
    }
    this.xmlstate = 1;
    var g = new jsonPointer(a);
    this._parse(g);
    this._p = g;
    if (c) {
        c()
    }
};
dhtmlXTreeObject.prototype.loadJSON = function (file, afterCall) {
    if (!this.parsCount) {
        this.callEvent("onXLS", [this, this._ld_id])
    }
    this._ld_id = null;
    this.xmlstate = 1;
    var that = this;
    this.XMLLoader = new dtmlXMLLoaderObject(function () {
        try {
            eval("var t=" + arguments[4].xmlDoc.responseText)
        } catch (e) {
            dhtmlxError.throwError("LoadXML", "Incorrect JSON", [(arguments[4].xmlDoc), this]);
            return
        }
        var p = new jsonPointer(t);
        that._parse(p);
        that._p = p
    }, this, true, this.no_cashe);
    if (afterCall) {
        this.XMLLoader.waitCall = afterCall
    }
    this.XMLLoader.loadXML(file)
};
dhtmlXTreeObject.prototype.serializeTreeToJSON = function () {
    var a = ['{"id":"' + this.rootId + '", "item":['];
    var g = [];
    for (var c = 0; c < this.htmlNode.childsCount; c++) {
        g.push(this._serializeItemJSON(this.htmlNode.childNodes[c]))
    }
    a.push(g.join(","));
    a.push("]}");
    return a.join("")
};
dhtmlXTreeObject.prototype._serializeItemJSON = function (m) {
    var a = [];
    if (m.unParsed) {
        return (m.unParsed.text())
    }
    if (this._selected.length) {
        var g = this._selected[0].id
    } else {
        g = ""
    }
    var l = m.span.innerHTML;
    l = l.replace(/\"/g, '\\"', l);
    if (!this._xfullXML) {
        a.push('{ "id":"' + m.id + '", ' + (this._getOpenState(m) == 1 ? ' "open":"1", ' : "") + (g == m.id ? ' "select":"1",' : "") + ' "text":"' + l + '"' + (((this.XMLsource) && (m.XMLload == 0)) ? ', "child":"1" ' : ""))
    } else {
        a.push('{ "id":"' + m.id + '", ' + (this._getOpenState(m) == 1 ? ' "open":"1", ' : "") + (g == m.id ? ' "select":"1",' : "") + ' "text":"' + l + '", "im0":"' + m.images[0] + '", "im1":"' + m.images[1] + '", "im2":"' + m.images[2] + '" ' + (m.acolor ? (', "aCol":"' + m.acolor + '" ') : "") + (m.scolor ? (', "sCol":"' + m.scolor + '" ') : "") + (m.checkstate == 1 ? ', "checked":"1" ' : (m.checkstate == 2 ? ', "checked":"-1"' : "")) + (m.closeable ? ', "closeable":"1" ' : "") + (((this.XMLsource) && (m.XMLload == 0)) ? ', "child":"1" ' : ""))
    }
    if ((this._xuserData) && (m._userdatalist)) {
        a.push(', "userdata":[');
        var j = m._userdatalist.split(",");
        var h = [];
        for (var c = 0; c < j.length; c++) {
            h.push('{ "name":"' + j[c] + '" , "content":"' + m.userData["t_" + j[c]] + '" }')
        }
        a.push(h.join(","));
        a.push("]")
    }
    if (m.childsCount) {
        a.push(', "item":[');
        var h = [];
        for (var c = 0; c < m.childsCount; c++) {
            h.push(this._serializeItemJSON(m.childNodes[c]))
        }
        a.push(h.join(","));
        a.push("]\n")
    }
    a.push("}\n");
    return a.join("")
};

function dhtmlXTreeFromHTML(obj) {
    if (typeof (obj) != "object") {
        obj = document.getElementById(obj)
    }
    var n = obj;
    var id = n.id;
    var cont = "";
    for (var j = 0; j < obj.childNodes.length; j++) {
        if (obj.childNodes[j].nodeType == "1") {
            if (obj.childNodes[j].tagName == "XMP") {
                var cHead = obj.childNodes[j];
                for (var m = 0; m < cHead.childNodes.length; m++) {
                    cont += cHead.childNodes[m].data
                }
            } else {
                if (obj.childNodes[j].tagName.toLowerCase() == "ul") {
                    cont = dhx_li2trees(obj.childNodes[j], new Array(), 0)
                }
            }
            break
        }
    }
    obj.innerHTML = "";
    var t = new dhtmlXTreeObject(obj, "100%", "100%", 0);
    var z_all = new Array();
    for (b in t) {
        z_all[b.toLowerCase()] = b
    }
    var atr = obj.attributes;
    for (var a = 0; a < atr.length; a++) {
        if ((atr[a].name.indexOf("set") == 0) || (atr[a].name.indexOf("enable") == 0)) {
            var an = atr[a].name;
            if (!t[an]) {
                an = z_all[atr[a].name]
            }
            t[an].apply(t, atr[a].value.split(","))
        }
    }
    if (typeof (cont) == "object") {
        t.XMLloadingWarning = 1;
        for (var i = 0; i < cont.length; i++) {
            var n = t.insertNewItem(cont[i][0], cont[i][3], cont[i][1]);
            if (cont[i][2]) {
                t._setCheck(n, cont[i][2])
            }
        }
        t.XMLloadingWarning = 0;
        t.lastLoadedXMLId = 0;
        t._redrawFrom(t)
    } else {
        t.loadXMLString("<tree id='0'>" + cont + "</tree>")
    }
    window[id] = t;
    var oninit = obj.getAttribute("oninit");
    if (oninit) {
        eval(oninit)
    }
    return t
}
function dhx_init_trees() {
    var c = document.getElementsByTagName("div");
    for (var a = 0; a < c.length; a++) {
        if (c[a].className == "dhtmlxTree") {
            dhtmlXTreeFromHTML(c[a])
        }
    }
}
function dhx_li2trees(s, m, g) {
    for (var n = 0; n < s.childNodes.length; n++) {
        var r = s.childNodes[n];
        if ((r.nodeType == 1) && (r.tagName.toLowerCase() == "li")) {
            var q = "";
            var o = null;
            var a = r.getAttribute("checked");
            for (var l = 0; l < r.childNodes.length; l++) {
                var h = r.childNodes[l];
                if (h.nodeType == 3) {
                    q += h.data
                } else {
                    if (h.tagName.toLowerCase() != "ul") {
                        q += dhx_outer_html(h)
                    } else {
                        o = h
                    }
                }
            }
            m[m.length] = [g, q, a, (r.id || (m.length + 1))];
            if (o) {
                m = dhx_li2trees(o, m, (r.id || m.length))
            }
        }
    }
    return m
}
function dhx_outer_html(c) {
    if (c.outerHTML) {
        return c.outerHTML
    }
    var a = document.createElement("DIV");
    a.appendChild(c.cloneNode(true));
    a = a.innerHTML;
    return a
}
if (window.addEventListener) {
    window.addEventListener("load", dhx_init_trees, false)
} else {
    if (window.attachEvent) {
        window.attachEvent("onload", dhx_init_trees)
    }
}
var globalActiveDHTMLGridObject;
String.prototype._dhx_trim = function () {
    return this.replace(/&nbsp;/g, " ").replace(/(^[ \t]*)|([ \t]*$)/g, "")
};

function dhtmlxArray(a) {
    return dhtmlXHeir((a || new Array()), dhtmlxArray._master)
}
dhtmlxArray._master = {
    _dhx_find: function (c) {
        for (var a = 0; a < this.length; a++) {
            if (c == this[a]) {
                return a
            }
        }
        return -1
    },
    _dhx_insertAt: function (g, c) {
        this[this.length] = null;
        for (var a = this.length - 1; a >= g; a--) {
            this[a] = this[a - 1]
        }
        this[g] = c
    },
    _dhx_removeAt: function (a) {
        this.splice(a, 1)
    },
    _dhx_swapItems: function (a, g) {
        var c = this[a];
        this[a] = this[g];
        this[g] = c
    }
};

function dhtmlXGridObject(id) {
    if (_isIE) {
        try {
            document.execCommand("BackgroundImageCache", false, true)
        } catch (e) {}
    }
    if (id) {
        if (typeof (id) == "object") {
            this.entBox = id;
            if (!this.entBox.id) {
                this.entBox.id = "cgrid2_" + this.uid()
            }
        } else {
            this.entBox = document.getElementById(id)
        }
    } else {
        this.entBox = document.createElement("DIV");
        this.entBox.id = "cgrid2_" + this.uid()
    }
    this.entBox.innerHTML = "";
    dhtmlxEventable(this);
    var self = this;
    this._wcorr = 0;
    this.fontWidth = 7;
    this.cell = null;
    this.row = null;
    this.iconURL = "";
    this.editor = null;
    this._f2kE = true;
    this._dclE = true;
    this.combos = new Array(0);
    this.defVal = new Array(0);
    this.rowsAr = {};
    this.rowsBuffer = dhtmlxArray();
    this.rowsCol = dhtmlxArray();
    this._data_cache = {};
    this._ecache = {};
    this._ud_enabled = true;
    this.xmlLoader = new dtmlXMLLoaderObject(this.doLoadDetails, this, true, this.no_cashe);
    this._maskArr = [];
    this.selectedRows = dhtmlxArray();
    this.UserData = {};
    this._sizeFix = this._borderFix = 0;
    this.entBox.className += " gridbox";
    this.entBox.style.width = this.entBox.getAttribute("width") || (window.getComputedStyle ? (this.entBox.style.width || window.getComputedStyle(this.entBox, null)["width"]) : (this.entBox.currentStyle ? this.entBox.currentStyle.width : this.entBox.style.width || 0)) || "100%";
    this.entBox.style.height = this.entBox.getAttribute("height") || (window.getComputedStyle ? (this.entBox.style.height || window.getComputedStyle(this.entBox, null)["height"]) : (this.entBox.currentStyle ? this.entBox.currentStyle.height : this.entBox.style.height || 0)) || "100%";
    this.entBox.style.cursor = "default";
    this.entBox.onselectstart = function () {
        return false
    };
    var t_creator = function (name) {
            var t = document.createElement("TABLE");
            t.cellSpacing = t.cellPadding = 0;
            t.style.cssText = "width:100%;table-layout:fixed;";
            t.className = name.substr(2);
            return t
        };
    this.obj = t_creator("c_obj");
    this.hdr = t_creator("c_hdr");
    this.hdr.style.marginRight = "20px";
    this.hdr.style.paddingRight = "20px";
    this.objBox = document.createElement("DIV");
    this.objBox.style.width = "100%";
    this.objBox.style.overflow = "auto";
    this.objBox.appendChild(this.obj);
    this.objBox.className = "objbox";
    if (dhtmlx.$customScroll) {
        dhtmlx.CustomScroll.enable(this)
    }
    this.hdrBox = document.createElement("DIV");
    this.hdrBox.style.width = "100%";
    this.hdrBox.style.height = "25px";
    this.hdrBox.style.overflow = "hidden";
    this.hdrBox.className = "xhdr";
    this.preloadImagesAr = new Array(0);
    this.sortImg = document.createElement("DIV");
    this.sortImg.style.display = "none";
    this.hdrBox.appendChild(this.sortImg);
    this.hdrBox.appendChild(this.hdr);
    this.hdrBox.style.position = "relative";
    this.entBox.appendChild(this.hdrBox);
    this.entBox.appendChild(this.objBox);
    this.entBox.grid = this;
    this.objBox.grid = this;
    this.hdrBox.grid = this;
    this.obj.grid = this;
    this.hdr.grid = this;
    this.cellWidthPX = [];
    this.cellWidthPC = [];
    this.cellWidthType = this.entBox.cellwidthtype || "px";
    this.delim = this.entBox.delimiter || ",";
    this._csvDelim = ",";
    this.hdrLabels = [];
    this.columnIds = [];
    this.columnColor = [];
    this._hrrar = [];
    this.cellType = dhtmlxArray();
    this.cellAlign = [];
    this.initCellWidth = [];
    this.fldSort = [];
    this._srdh = (_isIE && (document.compatMode != "BackCompat") ? 22 : 20);
    this.imgURL = window.dhx_globalImgPath || "";
    this.isActive = false;
    this.isEditable = true;
    this.useImagesInHeader = false;
    this.pagingOn = false;
    this.rowsBufferOutSize = 0;
    dhtmlxEvent(window, "unload", function () {
        try {
            if (self.destructor) {
                self.destructor()
            }
        } catch (e) {}
    });
    this.setSkin = function (name) {
        this.skin_name = name;
        if (this._imgURL) {
            this.setImagePath(this._imgURL)
        }
        var classname = this.entBox.className.split(" gridbox")[0];
        this.entBox.className = classname + " gridbox gridbox_" + name + (_isIE ? " isIE" : " isModern");
        this.skin_h_correction = 0;
        this.enableAlterCss("ev_" + name, "odd_" + name, this.isTreeGrid());
        this._fixAlterCss();
        switch (name) {
        case "clear":
            this._topMb = document.createElement("DIV");
            this._topMb.className = "topMumba";
            this._topMb.innerHTML = "<img style='left:0px'   src='" + this.imgURL + "skinC_top_left.gif'><img style='right:20px' src='" + this.imgURL + "skinC_top_right.gif'>";
            this.entBox.appendChild(this._topMb);
            this._botMb = document.createElement("DIV");
            this._botMb.className = "bottomMumba";
            this._botMb.innerHTML = "<img style='left:0px'   src='" + this.imgURL + "skinD_bottom_left.gif'><img style='right:20px' src='" + this.imgURL + "skinD_bottom_right.gif'>";
            this.entBox.appendChild(this._botMb);
            if (this.entBox.style.position != "absolute") {
                this.entBox.style.position = "relative"
            }
            this.skin_h_correction = 20;
            break;
        case "dhx_terrace":
            this._srdh = 33;
            this.forceDivInHeader = true;
            break;
        case "dhx_skyblue":
        case "dhx_web":
        case "glassy_blue":
        case "dhx_black":
        case "dhx_blue":
        case "modern":
        case "light":
            this._srdh = 29;
            this.forceDivInHeader = true;
            break;
        case "xp":
            this.forceDivInHeader = true;
            if ((_isIE) && (document.compatMode != "BackCompat")) {
                this._srdh = 26
            } else {
                this._srdh = 22
            }
            break;
        case "mt":
            if ((_isIE) && (document.compatMode != "BackCompat")) {
                this._srdh = 26
            } else {
                this._srdh = 22
            }
            break;
        case "gray":
            if ((_isIE) && (document.compatMode != "BackCompat")) {
                this._srdh = 22
            }
            break;
        case "sbdark":
            break
        }
        if (_isIE && this.hdr) {
            var d = this.hdr.parentNode;
            d.removeChild(this.hdr);
            d.appendChild(this.hdr)
        }
        this.setSizes()
    };
    if (_isIE) {
        this.preventIECaching(true)
    }
    if (window.dhtmlDragAndDropObject) {
        this.dragger = new dhtmlDragAndDropObject()
    }
    this._doOnScroll = function (e, mode) {
        this.callEvent("onScroll", [this.objBox.scrollLeft, this.objBox.scrollTop]);
        this.doOnScroll(e, mode)
    };
    this.doOnScroll = function (e, mode) {
        this.hdrBox.scrollLeft = this.objBox.scrollLeft;
        if (this.ftr) {
            this.ftr.parentNode.scrollLeft = this.objBox.scrollLeft
        }
        if (mode) {
            return
        }
        if (this._srnd) {
            if (this._dLoadTimer) {
                window.clearTimeout(this._dLoadTimer)
            }
            this._dLoadTimer = window.setTimeout(function () {
                if (self._update_srnd_view) {
                    self._update_srnd_view()
                }
            }, 100)
        }
    };
    this.attachToObject = function (obj) {
        obj.appendChild(this.globalBox ? this.globalBox : this.entBox);
        this.setSizes()
    };
    this.init = function (fl) {
        if ((this.isTreeGrid()) && (!this._h2)) {
            this._h2 = new dhtmlxHierarchy();
            if ((this._fake) && (!this._realfake)) {
                this._fake._h2 = this._h2
            }
            this._tgc = {
                imgURL: null
            }
        }
        if (!this._hstyles) {
            return
        }
        if (!this.skin_name) {
            this.setSkin("dhx_skyblue")
        }
        this.editStop();
        this.lastClicked = null;
        this.resized = null;
        this.fldSorted = this.r_fldSorted = null;
        this.cellWidthPX = [];
        this.cellWidthPC = [];
        if (this.hdr.rows.length > 0) {
            var temp = this.xmlFileUrl;
            this.clearAll(true);
            this.xmlFileUrl = temp
        }
        var hdrRow = this.hdr.insertRow(0);
        for (var i = 0; i < this.hdrLabels.length; i++) {
            hdrRow.appendChild(document.createElement("TH"));
            hdrRow.childNodes[i]._cellIndex = i;
            hdrRow.childNodes[i].style.height = "0px"
        }
        if (_isIE && _isIE < 8 && document.body.style.msTouchAction == this.undefined) {
            hdrRow.style.position = "absolute"
        } else {
            hdrRow.style.height = "auto"
        }
        var hdrRow = this.hdr.insertRow(_isKHTML ? 2 : 1);
        hdrRow._childIndexes = new Array();
        var col_ex = 0;
        for (var i = 0; i < this.hdrLabels.length; i++) {
            hdrRow._childIndexes[i] = i - col_ex;
            if ((this.hdrLabels[i] == this.splitSign) && (i != 0)) {
                if (_isKHTML) {
                    hdrRow.insertCell(i - col_ex)
                }
                hdrRow.cells[i - col_ex - 1].colSpan = (hdrRow.cells[i - col_ex - 1].colSpan || 1) + 1;
                hdrRow.childNodes[i - col_ex - 1]._cellIndex++;
                col_ex++;
                hdrRow._childIndexes[i] = i - col_ex;
                continue
            }
            hdrRow.insertCell(i - col_ex);
            hdrRow.childNodes[i - col_ex]._cellIndex = i;
            hdrRow.childNodes[i - col_ex]._cellIndexS = i;
            this.setColumnLabel(i, this.hdrLabels[i])
        }
        if (col_ex == 0) {
            hdrRow._childIndexes = null
        }
        this._cCount = this.hdrLabels.length;
        if (_isIE) {
            window.setTimeout(function () {
                if (self.setSizes) {
                    self.setSizes()
                }
            }, 1)
        }
        if (!this.obj.firstChild) {
            this.obj.appendChild(document.createElement("TBODY"))
        }
        var tar = this.obj.firstChild;
        if (!tar.firstChild) {
            tar.appendChild(document.createElement("TR"));
            tar = tar.firstChild;
            if (_isIE && _isIE < 8 && document.body.style.msTouchAction == this.undefined) {
                tar.style.position = "absolute"
            } else {
                tar.style.height = "auto"
            }
            for (var i = 0; i < this.hdrLabels.length; i++) {
                tar.appendChild(document.createElement("TH"));
                tar.childNodes[i].style.height = "0px"
            }
        }
        this._c_order = null;
        if (this.multiLine != true) {
            this.obj.className += " row20px"
        }
        this.sortImg.style.position = "absolute";
        this.sortImg.style.display = "none";
        this.sortImg.className = "dhxgrid_sort_desc";
        this.sortImg.defLeft = 0;
        if (this.noHeader) {
            this.hdrBox.style.display = "none"
        } else {
            this.noHeader = false
        }
        if (this._ivizcol) {
            this.setColHidden()
        }
        this.attachHeader();
        this.attachHeader(0, 0, "_aFoot");
        this.setSizes();
        if (fl) {
            this.parseXML()
        }
        this.obj.scrollTop = 0;
        if (this.dragAndDropOff) {
            this.dragger.addDragLanding(this.entBox, this)
        }
        if (this._initDrF) {
            this._initD()
        }
        if (this._init_point) {
            this._init_point()
        }
    };
    this.setColumnSizes = function (gridWidth) {
        var summ = 0;
        var fcols = [];
        var fix = 0;
        for (var i = 0; i < this._cCount; i++) {
            if ((this.initCellWidth[i] == "*") && !this._hrrar[i]) {
                this._awdth = false;
                fcols.push(i);
                continue
            }
            if (this.cellWidthType == "%") {
                if (typeof this.cellWidthPC[i] == "undefined") {
                    this.cellWidthPC[i] = this.initCellWidth[i]
                }
                var cwidth = (gridWidth * this.cellWidthPC[i] / 100) || 0;
                if (fix > 0.5) {
                    cwidth++;
                    fix--
                }
                var rwidth = this.cellWidthPX[i] = Math.floor(cwidth);
                var fix = fix + cwidth - rwidth
            } else {
                if (typeof this.cellWidthPX[i] == "undefined") {
                    this.cellWidthPX[i] = this.initCellWidth[i]
                }
            }
            if (!this._hrrar[i]) {
                summ += this.cellWidthPX[i] * 1
            }
        }
        if (fcols.length) {
            var ms = Math.floor((gridWidth - summ) / fcols.length);
            if (ms < 0) {
                ms = 1
            }
            for (var i = 0; i < fcols.length; i++) {
                var next = Math.max((this._drsclmW ? (this._drsclmW[fcols[i]] || 0) : 0), ms);
                this.cellWidthPX[fcols[i]] = next;
                summ += next
            }
            if (gridWidth > summ) {
                var last = fcols[fcols.length - 1];
                this.cellWidthPX[last] = this.cellWidthPX[last] + (gridWidth - summ);
                summ = gridWidth
            }
            this._setAutoResize()
        }
        this.obj.style.width = summ + "px";
        this.hdr.style.width = summ + "px";
        if (this.ftr) {
            this.ftr.style.width = summ + "px"
        }
        this.chngCellWidth();
        return summ
    };
    this.setSizes = function () {
        if ((!this.hdr.rows[0])) {
            return
        }
        var quirks = this.quirks = (_isIE && document.compatMode == "BackCompat");
        var outerBorder = (this.entBox.offsetWidth - this.entBox.clientWidth) / 2;
        if (!this.dontSetSizes) {
            if (this.globalBox) {
                var splitOuterBorder = (this.globalBox.offsetWidth - this.globalBox.clientWidth) / 2;
                if (this._delta_x && !this._realfake) {
                    var ow = this.globalBox.clientWidth;
                    this.globalBox.style.width = this._delta_x;
                    this.entBox.style.width = Math.max(0, (this.globalBox.clientWidth + (quirks ? splitOuterBorder * 2 : 0)) - this._fake.entBox.clientWidth) + "px";
                    if (ow != this.globalBox.clientWidth) {
                        this._fake._correctSplit(this._fake.entBox.clientWidth)
                    }
                }
                if (this._delta_y && !this._realfake) {
                    this.globalBox.style.height = this._delta_y;
                    this.entBox.style.overflow = this._fake.entBox.style.overflow = "hidden";
                    this.entBox.style.height = this._fake.entBox.style.height = this.globalBox.clientHeight + (quirks ? splitOuterBorder * 2 : 0) + "px"
                }
            } else {
                if (this._delta_x) {
                    if (this.entBox.parentNode && this.entBox.parentNode.tagName == "TD") {
                        this.entBox.style.width = "1px";
                        this.entBox.style.width = parseInt(this._delta_x) * this.entBox.parentNode.clientWidth / 100 - outerBorder * 2 + "px"
                    } else {
                        this.entBox.style.width = this._delta_x
                    }
                }
                if (this._delta_y) {
                    this.entBox.style.height = this._delta_y
                }
            }
        }
        window.clearTimeout(this._sizeTime);
        if (!this.entBox.offsetWidth && (!this.globalBox || !this.globalBox.offsetWidth)) {
            this._sizeTime = window.setTimeout(function () {
                if (self.setSizes) {
                    self.setSizes()
                }
            }, 250);
            return
        }
        var border_x = ((!this._wthB) && ((this.entBox.cmp || this._delta_x) && (this.skin_name || "").indexOf("dhx") == 0 && !quirks) ? 2 : 0);
        var border_y = ((!this._wthB) && ((this.entBox.cmp || this._delta_y) && (this.skin_name || "").indexOf("dhx") == 0 && !quirks) ? 2 : 0);
        if (this._sizeFix) {
            border_x -= this._sizeFix;
            border_y -= this._sizeFix
        }
        var isVScroll = this.parentGrid ? false : (this.objBox.scrollHeight > this.objBox.offsetHeight);
        var scrfix = dhtmlx.$customScroll ? 0 : 18;
        var gridWidth = this.entBox.clientWidth - (this.skin_h_correction || 0) * (quirks ? 0 : 1) - border_x;
        var gridWidthActive = this.entBox.clientWidth - (this.skin_h_correction || 0) - border_x;
        var gridHeight = this.entBox.clientHeight - border_y;
        var summ = this.setColumnSizes(gridWidthActive - (isVScroll ? scrfix : 0) - (this._correction_x || 0));
        var isHScroll = this.parentGrid ? false : ((this.objBox.scrollWidth > this.objBox.offsetWidth) || (this.objBox.style.overflowX == "scroll"));
        var headerHeight = this.hdr.clientHeight;
        var footerHeight = this.ftr ? this.ftr.clientHeight : 0;
        var newWidth = gridWidth;
        var newHeight = gridHeight - headerHeight - footerHeight;
        if (this._awdth && this._awdth[0] && this._awdth[1] == 99999) {
            isHScroll = 0
        }
        if (this._ahgr) {
            if (this._ahgrMA) {
                newHeight = this.entBox.parentNode.clientHeight - headerHeight - footerHeight
            } else {
                newHeight = this.obj.offsetHeight + (isHScroll ? scrfix : 0) + (this._correction_y || 0)
            }
            if (this._ahgrM) {
                if (this._ahgrF) {
                    newHeight = Math.min(this._ahgrM, newHeight + headerHeight + footerHeight) - headerHeight - footerHeight
                } else {
                    newHeight = Math.min(this._ahgrM, newHeight)
                }
            }
            if (isVScroll && newHeight >= this.obj.scrollHeight + (isHScroll ? scrfix : 0)) {
                isVScroll = false;
                this.setColumnSizes(gridWidthActive - (this._correction_x || 0))
            }
        }
        if ((this._awdth) && (this._awdth[0])) {
            if (this.cellWidthType == "%") {
                this.cellWidthType = "px"
            }
            if (this._fake) {
                summ += this._fake.entBox.clientWidth
            }
            var newWidth = Math.min(Math.max(summ + (isVScroll ? scrfix : 0), this._awdth[2]), this._awdth[1]) + (this._correction_x || 0);
            this.objBox.style.overflowX = (!isVScroll && this.objBox.scrollWidth <= newWidth) ? "hidden" : "auto";
            if (this._fake) {
                newWidth -= this._fake.entBox.clientWidth
            }
        }
        newHeight = Math.max(0, newHeight);
        this._ff_size_delta = (this._ff_size_delta == 0.1) ? 0.2 : 0.1;
        if (!_isFF) {
            this._ff_size_delta = 0
        }
        if (!this.dontSetSizes) {
            this.entBox.style.width = Math.max(0, newWidth + (quirks ? 2 : 0) * outerBorder + this._ff_size_delta) + "px";
            this.entBox.style.height = newHeight + (quirks ? 2 : 0) * outerBorder + headerHeight + footerHeight + "px"
        }
        this.objBox.style.height = newHeight + ((quirks && !isVScroll) ? 2 : 0) * outerBorder + "px";
        this.hdrBox.style.height = headerHeight + "px";
        if (newHeight != gridHeight) {
            this.doOnScroll(0, !this._srnd)
        }
        var ext = this["setSizes_" + this.skin_name];
        if (ext) {
            ext.call(this)
        }
        this.setSortImgPos();
        if (headerHeight != this.hdr.clientHeight && this._ahgr) {
            this.setSizes()
        }
        this.callEvent("onSetSizes", [])
    };
    this.setSizes_clear = function () {
        var y = this.hdr.offsetHeight;
        var x = this.entBox.offsetWidth;
        var y2 = y + this.objBox.offsetHeight;
        this._topMb.style.top = (y || 0) + "px";
        this._topMb.style.width = (x + 20) + "px";
        this._botMb.style.top = (y2 - 3) + "px";
        this._botMb.style.width = (x + 20) + "px"
    };
    this.chngCellWidth = function () {
        if ((_isOpera) && (this.ftr)) {
            this.ftr.width = this.objBox.scrollWidth + "px"
        }
        var l = this._cCount;
        for (var i = 0; i < l; i++) {
            this.hdr.rows[0].cells[i].style.width = this.cellWidthPX[i] + "px";
            this.obj.rows[0].childNodes[i].style.width = this.cellWidthPX[i] + "px";
            if (this.ftr) {
                this.ftr.rows[0].cells[i].style.width = this.cellWidthPX[i] + "px"
            }
        }
    };
    this.setDelimiter = function (delim) {
        this.delim = delim
    };
    this.setInitWidthsP = function (wp) {
        this.cellWidthType = "%";
        this.initCellWidth = wp.split(this.delim.replace(/px/gi, ""));
        if (!arguments[1]) {
            this._setAutoResize()
        }
    };
    this._setAutoResize = function () {
        if (this._realfake) {
            return
        }
        var el = window;
        var self = this;
        dhtmlxEvent(window, "resize", function () {
            window.clearTimeout(self._resize_timer);
            if (self._setAutoResize) {
                self._resize_timer = window.setTimeout(function () {
                    if (self.setSizes) {
                        self.setSizes()
                    }
                    if (self._fake) {
                        self._fake._correctSplit()
                    }
                }, 100)
            }
        })
    };
    this.setInitWidths = function (wp) {
        this.cellWidthType = "px";
        this.initCellWidth = wp.split(this.delim);
        if (_isFF) {
            for (var i = 0; i < this.initCellWidth.length; i++) {
                if (this.initCellWidth[i] != "*") {
                    this.initCellWidth[i] = parseInt(this.initCellWidth[i])
                }
            }
        }
    };
    this.enableMultiline = function (state) {
        this.multiLine = convertStringToBoolean(state)
    };
    this.enableMultiselect = function (state) {
        this.selMultiRows = convertStringToBoolean(state)
    };
    this.setImagePath = function (path) {
        this._imgURL = path;
        this.imgURL = path + "dhxgrid_" + (this.skin_name || "dhx_skyblue").replace("dhx_", "") + "/";
        this.iconTree = this.imgURL + "tree/"
    };
    this.setImagesPath = this.setImagePath;
    this.setIconPath = function (path) {
        this.iconURL = path
    };
    this.setIconsPath = this.setIconPath;
    this.changeCursorState = function (ev) {
        var el = ev.target || ev.srcElement;
        if (el.tagName != "TD") {
            el = this.getFirstParentOfType(el, "TD")
        }
        if (!el) {
            return
        }
        if ((el.tagName == "TD") && (this._drsclmn) && (!this._drsclmn[el._cellIndex])) {
            return el.style.cursor = "default"
        }
        var check = (ev.layerX || 0) + (((!_isIE) && (ev.target.tagName == "DIV")) ? el.offsetLeft : 0);
        if ((el.offsetWidth - (ev.offsetX || (parseInt(this.getPosition(el, this.hdrBox)) - check) * -1)) < (_isOpera ? 20 : 10)) {
            el.style.cursor = "E-resize"
        } else {
            el.style.cursor = "default"
        }
        if (_isOpera) {
            this.hdrBox.scrollLeft = this.objBox.scrollLeft
        }
    };
    this.startColResize = function (ev) {
        if (this.resized) {
            this.stopColResize()
        }
        this.resized = null;
        var el = ev.target || ev.srcElement;
        if (el.tagName != "TD") {
            el = this.getFirstParentOfType(el, "TD")
        }
        var x = ev.clientX;
        var tabW = this.hdr.offsetWidth;
        var startW = parseInt(el.offsetWidth);
        if (el.tagName == "TD" && el.style.cursor != "default") {
            if ((this._drsclmn) && (!this._drsclmn[el._cellIndex])) {
                return
            }
            self._old_d_mm = document.body.onmousemove;
            self._old_d_mu = document.body.onmouseup;
            document.body.onmousemove = function (e) {
                if (self) {
                    self.doColResize(e || window.event, el, startW, x, tabW)
                }
            };
            document.body.onmouseup = function () {
                if (self) {
                    self.stopColResize()
                }
            }
        }
    };
    this.stopColResize = function () {
        document.body.onmousemove = self._old_d_mm || "";
        document.body.onmouseup = self._old_d_mu || "";
        this.setSizes();
        this.doOnScroll(0, 1);
        this.callEvent("onResizeEnd", [this])
    };
    this.doColResize = function (ev, el, startW, x, tabW) {
        el.style.cursor = "E-resize";
        this.resized = el;
        var fcolW = startW + (ev.clientX - x);
        var wtabW = tabW + (ev.clientX - x);
        if (!(this.callEvent("onResize", [el._cellIndex, fcolW, this]))) {
            return
        }
        if (_isIE) {
            this.objBox.scrollLeft = this.hdrBox.scrollLeft
        }
        if (el.colSpan > 1) {
            var a_sizes = new Array();
            for (var i = 0; i < el.colSpan; i++) {
                a_sizes[i] = Math.round(fcolW * this.hdr.rows[0].childNodes[el._cellIndexS + i].offsetWidth / el.offsetWidth)
            }
            for (var i = 0; i < el.colSpan; i++) {
                this._setColumnSizeR(el._cellIndexS + i * 1, a_sizes[i])
            }
        } else {
            this._setColumnSizeR(el._cellIndex, fcolW)
        }
        this.doOnScroll(0, 1);
        this.setSizes();
        if (this._fake && this._awdth) {
            this._fake._correctSplit()
        }
    };
    this._setColumnSizeR = function (ind, fcolW) {
        if (fcolW > ((this._drsclmW && !this._notresize) ? (this._drsclmW[ind] || 10) : 10)) {
            this.obj.rows[0].childNodes[ind].style.width = fcolW + "px";
            this.hdr.rows[0].childNodes[ind].style.width = fcolW + "px";
            if (this.ftr) {
                this.ftr.rows[0].childNodes[ind].style.width = fcolW + "px"
            }
            if (this.cellWidthType == "px") {
                this.cellWidthPX[ind] = fcolW
            } else {
                var gridWidth = parseInt(this.entBox.offsetWidth);
                if (this.objBox.scrollHeight > this.objBox.offsetHeight) {
                    gridWidth -= 17
                }
                var pcWidth = Math.round(fcolW / gridWidth * 100);
                this.cellWidthPC[ind] = pcWidth
            }
            if (this.sortImg.style.display != "none") {
                this.setSortImgPos()
            }
        }
    };
    this.setSortImgState = function (state, ind, order, row) {
        order = (order || "asc").toLowerCase();
        if (!convertStringToBoolean(state)) {
            this.sortImg.style.display = "none";
            this.fldSorted = this.r_fldSorted = null;
            return
        }
        if (order == "asc") {
            this.sortImg.className = "dhxgrid_sort_asc"
        } else {
            this.sortImg.className = "dhxgrid_sort_desc"
        }
        this.sortImg.style.display = "";
        this.fldSorted = this.hdr.rows[0].childNodes[ind];
        var r = this.hdr.rows[row || 1];
        if (!r) {
            return
        }
        for (var i = 0; i < r.childNodes.length; i++) {
            if (r.childNodes[i]._cellIndexS == ind) {
                this.r_fldSorted = r.childNodes[i];
                return this.setSortImgPos()
            }
        }
        return this.setSortImgState(state, ind, order, (row || 1) + 1)
    };
    this.setSortImgPos = function (ind, mode, hRowInd, el) {
        if (this._hrrar && this._hrrar[this.r_fldSorted ? this.r_fldSorted._cellIndex : ind]) {
            return
        }
        if (!el) {
            if (!ind) {
                var el = this.r_fldSorted
            } else {
                var el = this.hdr.rows[hRowInd || 0].cells[ind]
            }
        }
        if (el != null) {
            var pos = this.getPosition(el, this.hdrBox);
            var wdth = el.offsetWidth;
            this.sortImg.style.left = Number(pos[0] + wdth - 13) + "px";
            this.sortImg.defLeft = parseInt(this.sortImg.style.left);
            this.sortImg.style.top = Number(pos[1] + 5) + "px";
            if ((!this.useImagesInHeader) && (!mode)) {
                this.sortImg.style.display = "inline"
            }
            this.sortImg.style.left = this.sortImg.defLeft + "px"
        }
    };
    this.setActive = function (fl) {
        if (arguments.length == 0) {
            var fl = true
        }
        if (fl == true) {
            if (globalActiveDHTMLGridObject && (globalActiveDHTMLGridObject != this)) {
                globalActiveDHTMLGridObject.editStop();
                globalActiveDHTMLGridObject.callEvent("onBlur", [globalActiveDHTMLGridObject])
            }
            globalActiveDHTMLGridObject = this;
            this.isActive = true
        } else {
            this.isActive = false;
            this.callEvent("onBlur", [this])
        }
    };
    this._doClick = function (ev) {
        var selMethod = 0;
        var el = this.getFirstParentOfType(_isIE ? ev.srcElement : ev.target, "TD");
        if (!el || !el.parentNode || !el.parentNode.idd) {
            return
        }
        var fl = true;
        if (this.markedCells) {
            var markMethod = 0;
            if (ev.shiftKey || ev.metaKey) {
                markMethod = 1
            }
            if (ev.ctrlKey) {
                markMethod = 2
            }
            this.doMark(el, markMethod);
            return true
        }
        if (this.selMultiRows != false) {
            if (ev.shiftKey && this.row != null && this.selectedRows.length) {
                selMethod = 1
            }
            if (ev.ctrlKey || ev.metaKey) {
                selMethod = 2
            }
        }
        this.doClick(el, fl, selMethod, false)
    };
    this._doContClick = function (ev) {
        var el = this.getFirstParentOfType(_isIE ? ev.srcElement : ev.target, "TD");
        if ((!el) || (typeof (el.parentNode.idd) == "undefined")) {
            this.callEvent("onEmptyClick", [ev]);
            return true
        }
        if (ev.button == 2 || (_isMacOS && ev.ctrlKey)) {
            if (!this.callEvent("onRightClick", [el.parentNode.idd, el._cellIndex, ev])) {
                var z = function (e) {
                        (e || event).cancelBubble = true;
                        return false
                    };
                (ev.srcElement || ev.target).oncontextmenu = z;
                return z(ev)
            }
            if (this._ctmndx) {
                if (!(this.callEvent("onBeforeContextMenu", [el.parentNode.idd, el._cellIndex, this]))) {
                    return true
                }
                if (_isIE) {
                    ev.srcElement.oncontextmenu = function () {
                        event.cancelBubble = true;
                        return false
                    }
                }
                if (this._ctmndx.showContextMenu) {
                    var dEl0 = window.document.documentElement;
                    var dEl1 = window.document.body;
                    var corrector = new Array((dEl0.scrollLeft || dEl1.scrollLeft), (dEl0.scrollTop || dEl1.scrollTop));
                    if (_isIE) {
                        var x = ev.clientX + corrector[0];
                        var y = ev.clientY + corrector[1]
                    } else {
                        var x = ev.pageX;
                        var y = ev.pageY
                    }
                    this._ctmndx.showContextMenu(x - 1, y - 1);
                    this.contextID = this._ctmndx.contextMenuZoneId = el.parentNode.idd + "_" + el._cellIndex;
                    this._ctmndx._skip_hide = true
                } else {
                    el.contextMenuId = el.parentNode.idd + "_" + el._cellIndex;
                    el.contextMenu = this._ctmndx;
                    el.a = this._ctmndx._contextStart;
                    el.a(el, ev);
                    el.a = null
                }
                ev.cancelBubble = true;
                return false
            }
        } else {
            if (this._ctmndx) {
                if (this._ctmndx.hideContextMenu) {
                    this._ctmndx.hideContextMenu()
                } else {
                    this._ctmndx._contextEnd()
                }
            }
        }
        return true
    };
    this.doClick = function (el, fl, selMethod, show) {
        if (!this.selMultiRows) {
            selMethod = 0
        }
        var psid = this.row ? this.row.idd : 0;
        this.setActive(true);
        if (!selMethod) {
            selMethod = 0
        }
        if (this.cell != null) {
            this.cell.className = this.cell.className.replace(/cellselected/g, "")
        }
        if (el.tagName == "TD") {
            if (this.checkEvent("onSelectStateChanged")) {
                var initial = this.getSelectedId()
            }
            var prow = this.row;
            if (selMethod == 1) {
                var elRowIndex = this.rowsCol._dhx_find(el.parentNode);
                var lcRowIndex = this.rowsCol._dhx_find(this.lastClicked);
                if (elRowIndex > lcRowIndex) {
                    var strt = lcRowIndex;
                    var end = elRowIndex
                } else {
                    var strt = elRowIndex;
                    var end = lcRowIndex
                }
                for (var i = 0; i < this.rowsCol.length; i++) {
                    if ((i >= strt && i <= end)) {
                        if (this.rowsCol[i] && (!this.rowsCol[i]._sRow)) {
                            if (this.rowsCol[i].className.indexOf("rowselected") == -1 && (this._realfake || this.callEvent("onBeforeSelect", [this.rowsCol[i].idd, psid, el._cellIndex]))) {
                                this.rowsCol[i].className += " rowselected";
                                this.selectedRows[this.selectedRows.length] = this.rowsCol[i]
                            }
                        } else {
                            this.clearSelection();
                            return this.doClick(el, fl, 0, show)
                        }
                    }
                }
            } else {
                if (selMethod == 2) {
                    if (el.parentNode.className.indexOf("rowselected") != -1) {
                        el.parentNode.className = el.parentNode.className.replace(/rowselected/g, "");
                        this.selectedRows._dhx_removeAt(this.selectedRows._dhx_find(el.parentNode));
                        var skipRowSelection = true;
                        show = false
                    }
                }
            }
            this.editStop();
            if (typeof (el.parentNode.idd) == "undefined") {
                return true
            }
            if ((!skipRowSelection) && (!el.parentNode._sRow)) {
                if (this._realfake || this.callEvent("onBeforeSelect", [el.parentNode.idd, psid, el._cellIndex])) {
                    if (this.getSelectedRowId() != el.parentNode.idd) {
                        if (selMethod == 0) {
                            this.clearSelection()
                        }
                        this.cell = el;
                        if ((prow == el.parentNode) && (this._chRRS)) {
                            fl = false
                        }
                        this.row = el.parentNode;
                        this.row.className += " rowselected";
                        if (this.selectedRows._dhx_find(this.row) == -1) {
                            this.selectedRows[this.selectedRows.length] = this.row
                        }
                    } else {
                        this.cell = el;
                        this.row = el.parentNode
                    }
                } else {
                    fl = false
                }
            }
            if (this.cell && this.cell.parentNode.className.indexOf("rowselected") != -1) {
                this.cell.className = this.cell.className.replace(/cellselected/g, "") + " cellselected"
            }
            if (selMethod != 1) {
                if (!this.row) {
                    return
                }
            }
            this.lastClicked = el.parentNode;
            var rid = this.row.idd;
            var cid = this.cell;
            if (fl && typeof (rid) != "undefined" && cid && !skipRowSelection) {
                self.onRowSelectTime = setTimeout(function () {
                    if (self.callEvent) {
                        self.callEvent("onRowSelect", [rid, cid._cellIndex])
                    }
                }, 100)
            } else {
                this.callEvent("onRowSelectRSOnly", [rid])
            }
            if (this.checkEvent("onSelectStateChanged")) {
                var afinal = this.getSelectedId();
                if (initial != afinal) {
                    this.callEvent("onSelectStateChanged", [afinal, initial])
                }
            }
        }
        this.isActive = true;
        if (show !== false && this.cell && this.cell.parentNode.idd) {
            this.moveToVisible(this.cell)
        }
    };
    this.selectAll = function () {
        this.clearSelection();
        var coll = this.rowsBuffer;
        if (this.pagingOn) {
            coll = this.rowsCol
        }
        for (var i = 0; i < coll.length; i++) {
            this.render_row(i).className += " rowselected"
        }
        this.selectedRows = dhtmlxArray([].concat(coll));
        if (this.selectedRows.length) {
            this.row = this.selectedRows[0];
            this.cell = this.row.cells[0]
        }
        if ((this._fake) && (!this._realfake)) {
            this._fake.selectAll()
        }
    };
    this.selectCell = function (r, cInd, fl, preserve, edit, show) {
        if (!fl) {
            fl = false
        }
        if (typeof (r) != "object") {
            r = this.render_row(r)
        }
        if (!r || r == -1) {
            return null
        }
        if (r._childIndexes) {
            var c = r.childNodes[r._childIndexes[cInd]]
        } else {
            var c = r.childNodes[cInd]
        }
        if (!c) {
            c = r.childNodes[0]
        }
        if (!this.markedCells) {
            if (preserve) {
                this.doClick(c, fl, 3, show)
            } else {
                this.doClick(c, fl, 0, show)
            }
        } else {
            this.doMark(c, preserve ? 2 : 0)
        }
        if (edit) {
            this.editCell()
        }
    };
    this.moveToVisible = function (cell_obj, onlyVScroll) {
        if (this.pagingOn) {
            var newPage = Math.floor(this.getRowIndex(cell_obj.parentNode.idd) / this.rowsBufferOutSize) + 1;
            if (newPage != this.currentPage) {
                this.changePage(newPage)
            }
        }
        try {
            if (cell_obj.offsetHeight) {
                var distance = cell_obj.offsetLeft + cell_obj.offsetWidth + 20;
                var scrollLeft = 0;
                if (distance > (this.objBox.offsetWidth + this.objBox.scrollLeft)) {
                    if (cell_obj.offsetLeft > this.objBox.scrollLeft) {
                        scrollLeft = cell_obj.offsetLeft - (this.objBox.offsetWidth - cell_obj.offsetWidth) + 5
                    }
                } else {
                    if (cell_obj.offsetLeft < this.objBox.scrollLeft) {
                        distance -= cell_obj.offsetWidth * 2 / 3;
                        if (distance < this.objBox.scrollLeft) {
                            scrollLeft = cell_obj.offsetLeft - 5
                        }
                    }
                }
                if ((scrollLeft) && (!onlyVScroll)) {
                    this.objBox.scrollLeft = scrollLeft
                }
            }
            if (!cell_obj.offsetHeight) {
                var mask = this._realfake ? this._fake.rowsAr[cell_obj.parentNode.idd] : cell_obj.parentNode;
                distance = this.rowsBuffer._dhx_find(mask) * this._srdh
            } else {
                distance = cell_obj.offsetTop
            }
            var distancemax = distance + cell_obj.offsetHeight + 38;
            if (distancemax > (this.objBox.offsetHeight + this.objBox.scrollTop)) {
                var scrollTop = distance
            } else {
                if (distance < this.objBox.scrollTop) {
                    var scrollTop = distance - 5
                }
            }
            if (scrollTop) {
                this.objBox.scrollTop = scrollTop
            }
        } catch (er) {}
    };
    this.editCell = function () {
        if (this.editor && this.cell == this.editor.cell) {
            return
        }
        this.editStop();
        if ((this.isEditable != true) || (!this.cell)) {
            return false
        }
        var c = this.cell;
        if (c.parentNode._locked) {
            return false
        }
        this.editor = this.cells4(c);
        if (this.editor != null) {
            if (this.editor.isDisabled()) {
                this.editor = null;
                return false
            }
            if (this.callEvent("onEditCell", [0, this.row.idd, this.cell._cellIndex]) != false && this.editor.edit) {
                this._Opera_stop = (new Date).valueOf();
                c.className += " editable";
                this.editor.edit();
                this.callEvent("onEditCell", [1, this.row.idd, this.cell._cellIndex])
            } else {
                this.editor = null
            }
        }
    };
    this.editStop = function (mode) {
        if (_isOpera) {
            if (this._Opera_stop) {
                if ((this._Opera_stop * 1 + 50) > (new Date).valueOf()) {
                    return
                }
                this._Opera_stop = null
            }
        }
        if (this.editor && this.editor != null) {
            this.editor.cell.className = this.editor.cell.className.replace("editable", "");
            if (mode) {
                var t = this.editor.val;
                this.editor.detach();
                this.editor.setValue(t);
                this.editor = null;
                this.callEvent("onEditCancel", [this.row.idd, this.cell._cellIndex, t]);
                return
            }
            if (this.editor.detach()) {
                this.cell.wasChanged = true
            }
            var g = this.editor;
            this.editor = null;
            var z = this.callEvent("onEditCell", [2, this.row.idd, this.cell._cellIndex, g.getValue(), g.val]);
            if ((typeof (z) == "string") || (typeof (z) == "number")) {
                g[g.setImage ? "setLabel" : "setValue"](z)
            } else {
                if (!z) {
                    g[g.setImage ? "setLabel" : "setValue"](g.val)
                }
            }
            if (this._ahgr && this.multiLine) {
                this.setSizes()
            }
        }
    };
    this._nextRowCell = function (row, dir, pos) {
        row = this._nextRow((this._groups ? this.rowsCol : this.rowsBuffer)._dhx_find(row), dir);
        if (!row) {
            return null
        }
        return row.childNodes[row._childIndexes ? row._childIndexes[pos] : pos]
    };
    this._getNextCell = function (acell, dir, i) {
        acell = acell || this.cell;
        var arow = acell.parentNode;
        if (this._tabOrder) {
            i = this._tabOrder[acell._cellIndex];
            if (typeof i != "undefined") {
                if (i < 0) {
                    acell = this._nextRowCell(arow, dir, Math.abs(i) - 1)
                } else {
                    acell = arow.childNodes[i]
                }
            }
        } else {
            var i = acell._cellIndex + dir;
            if (i >= 0 && i < this._cCount) {
                if (arow._childIndexes) {
                    i = arow._childIndexes[acell._cellIndex] + dir
                }
                acell = arow.childNodes[i]
            } else {
                acell = this._nextRowCell(arow, dir, (dir == 1 ? 0 : (this._cCount - 1)))
            }
        }
        if (!acell) {
            if ((dir == 1) && this.tabEnd) {
                this.tabEnd.focus();
                this.tabEnd.focus();
                this.setActive(false)
            }
            if ((dir == -1) && this.tabStart) {
                this.tabStart.focus();
                this.tabStart.focus();
                this.setActive(false)
            }
            return null
        }
        if (acell.style.display != "none" && (!this.smartTabOrder || !this.cells(acell.parentNode.idd, acell._cellIndex).isDisabled())) {
            return acell
        }
        return this._getNextCell(acell, dir)
    };
    this._nextRow = function (ind, dir) {
        var r = this.render_row(ind + dir);
        if (!r || r == -1) {
            return null
        }
        if (r && r.style.display == "none") {
            return this._nextRow(ind + dir, dir)
        }
        return r
    };
    this.scrollPage = function (dir) {
        if (!this.rowsBuffer.length) {
            return
        }
        var master = this._realfake ? this._fake : this;
        var new_ind = Math.floor((master._r_select || this.getRowIndex(this.row.idd) || 0) + (dir) * this.objBox.offsetHeight / (this._srdh || 20));
        if (new_ind < 0) {
            new_ind = 0
        }
        if (new_ind >= this.rowsBuffer.length) {
            new_ind = this.rowsBuffer.length - 1
        }
        if (this._srnd && !this.rowsBuffer[new_ind]) {
            this.objBox.scrollTop += Math.floor((dir) * this.objBox.offsetHeight / (this._srdh || 20)) * (this._srdh || 20);
            if (this._fake) {
                this._fake.objBox.scrollTop = this.objBox.scrollTop
            }
            master._r_select = new_ind
        } else {
            this.selectCell(new_ind, this.cell._cellIndex, true, false, false, (this.multiLine || this._srnd));
            if (!this.multiLine && !this._srnd && !this._realfake) {
                this.objBox.scrollTop = this.getRowById(this.getRowId(new_ind)).offsetTop;
                if (this._fake) {
                    this._fake.objBox.scrollTop = this.objBox.scrollTop
                }
            }
            master._r_select = null
        }
    };
    this.doKey = function (ev) {
        if (!ev) {
            return true
        }
        if ((ev.target || ev.srcElement).value !== window.undefined) {
            var zx = (ev.target || ev.srcElement);
            if ((!zx.parentNode) || (zx.parentNode.className.indexOf("editable") == -1)) {
                return true
            }
        }
        if ((globalActiveDHTMLGridObject) && (this != globalActiveDHTMLGridObject)) {
            return globalActiveDHTMLGridObject.doKey(ev)
        }
        if (this.isActive == false) {
            return true
        }
        if (this._htkebl) {
            return true
        }
        if (!this.callEvent("onKeyPress", [ev.keyCode, ev.ctrlKey, ev.shiftKey, ev])) {
            return false
        }
        var code = "k" + ev.keyCode + "_" + (ev.ctrlKey ? 1 : 0) + "_" + (ev.shiftKey ? 1 : 0);
        if (this.cell) {
            if (this._key_events[code]) {
                if (false === this._key_events[code].call(this)) {
                    return true
                }
                if (ev.preventDefault) {
                    ev.preventDefault()
                }
                ev.cancelBubble = true;
                return false
            }
            if (this._key_events.k_other) {
                this._key_events.k_other.call(this, ev)
            }
        }
        return true
    };
    this.selectRow = function (r, fl, preserve, show) {
        if (typeof (r) != "object") {
            r = this.render_row(r)
        }
        this.selectCell(r, 0, fl, preserve, false, show)
    };
    this.wasDblClicked = function (ev) {
        var el = this.getFirstParentOfType(_isIE ? ev.srcElement : ev.target, "TD");
        if (el) {
            var rowId = el.parentNode.idd;
            return this.callEvent("onRowDblClicked", [rowId, el._cellIndex, ev])
        }
    };
    this._onHeaderClick = function (e, el) {
        var that = this.grid;
        el = el || that.getFirstParentOfType(_isIE ? event.srcElement : e.target, "TD");
        if (this.grid.resized == null) {
            if (!(this.grid.callEvent("onHeaderClick", [el._cellIndexS, (e || window.event)]))) {
                return false
            }
            that.sortField(el._cellIndexS, false, el)
        }
        this.grid.resized = null
    };
    this.deleteSelectedRows = function () {
        var num = this.selectedRows.length;
        if (num == 0) {
            return
        }
        var tmpAr = this.selectedRows;
        this.selectedRows = dhtmlxArray();
        for (var i = num - 1; i >= 0; i--) {
            var node = tmpAr[i];
            if (!this.deleteRow(node.idd, node)) {
                this.selectedRows[this.selectedRows.length] = node
            } else {
                if (node == this.row) {
                    var ind = i
                }
            }
        }
        if (ind) {
            try {
                if (ind + 1 > this.rowsCol.length) {
                    ind--
                }
                this.selectCell(ind, 0, true)
            } catch (er) {
                this.row = null;
                this.cell = null
            }
        }
    };
    this.getSelectedRowId = function () {
        var selAr = new Array(0);
        var uni = {};
        for (var i = 0; i < this.selectedRows.length; i++) {
            var id = this.selectedRows[i].idd;
            if (uni[id]) {
                continue
            }
            selAr[selAr.length] = id;
            uni[id] = true
        }
        if (selAr.length == 0) {
            return null
        } else {
            return selAr.join(this.delim)
        }
    };
    this.getSelectedCellIndex = function () {
        if (this.cell != null) {
            return this.cell._cellIndex
        } else {
            return -1
        }
    };
    this.getColWidth = function (ind) {
        return parseInt(this.cellWidthPX[ind])
    };
    this.setColWidth = function (ind, value) {
        if (value == "*") {
            this.initCellWidth[ind] = "*"
        } else {
            if (this._hrrar[ind]) {
                return
            }
            if (this.cellWidthType == "px") {
                this.cellWidthPX[ind] = parseInt(value)
            } else {
                this.cellWidthPC[ind] = parseInt(value)
            }
        }
        this.setSizes()
    };
    this.getRowIndex = function (row_id) {
        for (var i = 0; i < this.rowsBuffer.length; i++) {
            if (this.rowsBuffer[i] && this.rowsBuffer[i].idd == row_id) {
                return i
            }
        }
        return -1
    };
    this.getRowId = function (ind) {
        return this.rowsBuffer[ind] ? this.rowsBuffer[ind].idd : this.undefined
    };
    this.setRowId = function (ind, row_id) {
        this.changeRowId(this.getRowId(ind), row_id)
    };
    this.changeRowId = function (oldRowId, newRowId) {
        if (oldRowId == newRowId) {
            return
        }
        var row = this.rowsAr[oldRowId];
        row.idd = newRowId;
        if (this.UserData[oldRowId]) {
            this.UserData[newRowId] = this.UserData[oldRowId];
            this.UserData[oldRowId] = null
        }
        if (this._h2 && this._h2.get[oldRowId]) {
            this._h2.get[newRowId] = this._h2.get[oldRowId];
            this._h2.get[newRowId].id = newRowId;
            delete this._h2.get[oldRowId]
        }
        this.rowsAr[oldRowId] = null;
        this.rowsAr[newRowId] = row;
        for (var i = 0; i < row.childNodes.length; i++) {
            if (row.childNodes[i]._code) {
                row.childNodes[i]._code = this._compileSCL(row.childNodes[i]._val, row.childNodes[i])
            }
        }
        if (this._mat_links && this._mat_links[oldRowId]) {
            var a = this._mat_links[oldRowId];
            delete this._mat_links[oldRowId];
            for (var c in a) {
                for (var i = 0; i < a[c].length; i++) {
                    this._compileSCL(a[c][i].original, a[c][i])
                }
            }
        }
        this.callEvent("onRowIdChange", [oldRowId, newRowId])
    };
    this.setColumnIds = function (ids) {
        this.columnIds = ids.split(this.delim)
    };
    this.setColumnId = function (ind, id) {
        this.columnIds[ind] = id
    };
    this.getColIndexById = function (id) {
        for (var i = 0; i < this.columnIds.length; i++) {
            if (this.columnIds[i] == id) {
                return i
            }
        }
    };
    this.getColumnId = function (cin) {
        return this.columnIds[cin]
    };
    this.getColumnLabel = function (cin, ind, hdr) {
        var z = (hdr || this.hdr).rows[(ind || 0) + 1];
        for (var i = 0; i < z.cells.length; i++) {
            if (z.cells[i]._cellIndexS == cin) {
                return (_isIE ? z.cells[i].innerText : z.cells[i].textContent)
            }
        }
        return ""
    };
    this.getColLabel = this.getColumnLabel;
    this.getFooterLabel = function (cin, ind) {
        return this.getColumnLabel(cin, ind, this.ftr)
    };
    this.setRowTextBold = function (row_id) {
        var r = this.getRowById(row_id);
        if (r) {
            r.style.fontWeight = "bold"
        }
    };
    this.setRowTextStyle = function (row_id, styleString) {
        var r = this.getRowById(row_id);
        if (!r) {
            return
        }
        for (var i = 0; i < r.childNodes.length; i++) {
            var pfix = r.childNodes[i]._attrs.style || "";
            if ((this._hrrar) && (this._hrrar[i])) {
                pfix = "display:none;"
            }
            if (_isIE) {
                r.childNodes[i].style.cssText = pfix + "width:" + r.childNodes[i].style.width + ";" + styleString
            } else {
                r.childNodes[i].style.cssText = pfix + "width:" + r.childNodes[i].style.width + ";" + styleString
            }
        }
    };
    this.setRowColor = function (row_id, color) {
        var r = this.getRowById(row_id);
        for (var i = 0; i < r.childNodes.length; i++) {
            r.childNodes[i].bgColor = color
        }
    };
    this.setCellTextStyle = function (row_id, ind, styleString) {
        var r = this.getRowById(row_id);
        if (!r) {
            return
        }
        var cell = r.childNodes[r._childIndexes ? r._childIndexes[ind] : ind];
        if (!cell) {
            return
        }
        var pfix = "";
        if ((this._hrrar) && (this._hrrar[ind])) {
            pfix = "display:none;"
        }
        if (_isIE) {
            cell.style.cssText = pfix + "width:" + cell.style.width + ";" + styleString
        } else {
            cell.style.cssText = pfix + "width:" + cell.style.width + ";" + styleString
        }
    };
    this.setRowTextNormal = function (row_id) {
        var r = this.getRowById(row_id);
        if (r) {
            r.style.fontWeight = "normal"
        }
    };
    this.doesRowExist = function (row_id) {
        if (this.getRowById(row_id) != null) {
            return true
        } else {
            return false
        }
    };
    this.getColumnsNum = function () {
        return this._cCount
    };
    this.moveRowUp = function (row_id) {
        var r = this.getRowById(row_id);
        if (this.isTreeGrid()) {
            return this.moveRowUDTG(row_id, -1)
        }
        var rInd = this.rowsCol._dhx_find(r);
        if ((r.previousSibling) && (rInd != 0)) {
            r.parentNode.insertBefore(r, r.previousSibling);
            this.rowsCol._dhx_swapItems(rInd, rInd - 1);
            this.setSizes();
            var bInd = this.rowsBuffer._dhx_find(r);
            this.rowsBuffer._dhx_swapItems(bInd, bInd - 1);
            if (this._cssEven) {
                this._fixAlterCss(rInd - 1)
            }
        }
    };
    this.moveRowDown = function (row_id) {
        var r = this.getRowById(row_id);
        if (this.isTreeGrid()) {
            return this.moveRowUDTG(row_id, 1)
        }
        var rInd = this.rowsCol._dhx_find(r);
        if (r.nextSibling) {
            this.rowsCol._dhx_swapItems(rInd, rInd + 1);
            if (r.nextSibling.nextSibling) {
                r.parentNode.insertBefore(r, r.nextSibling.nextSibling)
            } else {
                r.parentNode.appendChild(r)
            }
            this.setSizes();
            var bInd = this.rowsBuffer._dhx_find(r);
            this.rowsBuffer._dhx_swapItems(bInd, bInd + 1);
            if (this._cssEven) {
                this._fixAlterCss(rInd)
            }
        }
    };
    this.getCombo = function (col_ind) {
        if (!this.combos[col_ind]) {
            this.combos[col_ind] = new dhtmlXGridComboObject()
        }
        return this.combos[col_ind]
    };
    this.setUserData = function (row_id, name, value) {
        if (!row_id) {
            row_id = "gridglobaluserdata"
        }
        if (!this.UserData[row_id]) {
            this.UserData[row_id] = new Hashtable()
        }
        this.UserData[row_id].put(name, value)
    };
    this.getUserData = function (row_id, name) {
        if (!row_id) {
            row_id = "gridglobaluserdata"
        }
        this.getRowById(row_id);
        var z = this.UserData[row_id];
        return (z ? z.get(name) : "")
    };
    this.setEditable = function (fl) {
        this.isEditable = convertStringToBoolean(fl)
    };
    this.selectRowById = function (row_id, multiFL, show, call) {
        if (!call) {
            call = false
        }
        this.selectCell(this.getRowById(row_id), 0, call, multiFL, false, show)
    };
    this.clearSelection = function () {
        this.editStop();
        for (var i = 0; i < this.selectedRows.length; i++) {
            var r = this.rowsAr[this.selectedRows[i].idd];
            if (r) {
                r.className = r.className.replace(/rowselected/g, "")
            }
        }
        this.selectedRows = dhtmlxArray();
        this.row = null;
        if (this.cell != null) {
            this.cell.className = this.cell.className.replace(/cellselected/g, "");
            this.cell = null
        }
        this.callEvent("onSelectionCleared", [])
    };
    this.copyRowContent = function (from_row_id, to_row_id) {
        var frRow = this.getRowById(from_row_id);
        if (!this.isTreeGrid()) {
            for (var i = 0; i < frRow.cells.length; i++) {
                this.cells(to_row_id, i).setValue(this.cells(from_row_id, i).getValue())
            }
        } else {
            this._copyTreeGridRowContent(frRow, from_row_id, to_row_id)
        }
        if (!_isIE) {
            this.getRowById(from_row_id).cells[0].height = frRow.cells[0].offsetHeight
        }
    };
    this.setFooterLabel = function (c, label, ind) {
        return this.setColumnLabel(c, label, ind, this.ftr)
    };
    this.setColumnLabel = function (c, label, ind, hdr) {
        var z = (hdr || this.hdr).rows[ind || 1];
        var col = (z._childIndexes ? z._childIndexes[c] : c);
        if (!z.cells[col]) {
            return
        }
        if (!this.useImagesInHeader) {
            var hdrHTML = "<div class='hdrcell'>";
            if (label.indexOf("img:[") != -1) {
                var imUrl = label.replace(/.*\[([^>]+)\].*/, "$1");
                label = label.substr(label.indexOf("]") + 1, label.length);
                hdrHTML += "<img width='18px' height='18px' align='absmiddle' src='" + imUrl + "' hspace='2'>"
            }
            hdrHTML += label;
            hdrHTML += "</div>";
            z.cells[col].innerHTML = hdrHTML;
            if (this._hstyles[col]) {
                z.cells[col].style.cssText = this._hstyles[col]
            }
        } else {
            z.cells[col].style.textAlign = "left";
            z.cells[col].innerHTML = "<img src='" + label + "'>";
            var a = new Image();
            a.src = "" + label.replace(/(\.[a-z]+)/, ".des$1");
            this.preloadImagesAr[this.preloadImagesAr.length] = a;
            var b = new Image();
            b.src = "" + label.replace(/(\.[a-z]+)/, ".asc$1");
            this.preloadImagesAr[this.preloadImagesAr.length] = b
        }
        if ((label || "").indexOf("#") != -1) {
            var t = label.match(/(^|{)#([^}]+)(}|$)/);
            if (t) {
                var tn = "_in_header_" + t[2];
                if (this[tn]) {
                    this[tn]((this.forceDivInHeader ? z.cells[col].firstChild : z.cells[col]), col, label.split(t[0]))
                }
            }
        }
    };
    this.setColLabel = function (a, b, ind, c) {
        return this.setColumnLabel(a, b, (ind || 0) + 1, c)
    };
    this.clearAll = function (header) {
        if (!this.obj.rows[0]) {
            return
        }
        if (this._h2) {
            this._h2 = new dhtmlxHierarchy();
            if (this._fake) {
                if (this._realfake) {
                    this._h2 = this._fake._h2
                } else {
                    this._fake._h2 = this._h2
                }
            }
        }
        this.limit = this._limitC = 0;
        this.editStop(true);
        if (this._dLoadTimer) {
            window.clearTimeout(this._dLoadTimer)
        }
        if (this._dload) {
            this.objBox.scrollTop = 0;
            this.limit = this._limitC || 0;
            this._initDrF = true
        }
        var len = this.rowsCol.length;
        len = this.obj.rows.length;
        for (var i = len - 1; i > 0; i--) {
            var t_r = this.obj.rows[i];
            t_r.parentNode.removeChild(t_r)
        }
        if (header) {
            this._master_row = null;
            this.obj.rows[0].parentNode.removeChild(this.obj.rows[0]);
            for (var i = this.hdr.rows.length - 1; i >= 0; i--) {
                var t_r = this.hdr.rows[i];
                t_r.parentNode.removeChild(t_r)
            }
            if (this.ftr) {
                this.ftr.parentNode.removeChild(this.ftr);
                this.ftr = null
            }
            this._aHead = this.ftr = this.cellWidth = this._aFoot = null;
            this.cellType = dhtmlxArray();
            this._hrrar = [];
            this.columnIds = [];
            this.combos = [];
            this._strangeParams = [];
            this.defVal = [];
            this._ivizcol = null
        }
        this.row = null;
        this.cell = null;
        this.rowsCol = dhtmlxArray();
        this.rowsAr = {};
        this._RaSeCol = [];
        this.rowsBuffer = dhtmlxArray();
        this.UserData = [];
        this.selectedRows = dhtmlxArray();
        if (this.pagingOn || this._srnd) {
            this.xmlFileUrl = ""
        }
        if (this.pagingOn) {
            this.changePage(1)
        }
        if (this._contextCallTimer) {
            window.clearTimeout(this._contextCallTimer)
        }
        if (this._sst) {
            this.enableStableSorting(true)
        }
        this._fillers = this.undefined;
        this.setSortImgState(false);
        this.setSizes();
        this.callEvent("onClearAll", [])
    };
    this.sortField = function (ind, repeatFl, r_el) {
        if (this.getRowsNum() == 0) {
            return false
        }
        var el = this.hdr.rows[0].cells[ind];
        if (!el) {
            return
        }
        if (el.tagName == "TH" && (this.fldSort.length - 1) >= el._cellIndex && this.fldSort[el._cellIndex] != "na") {
            var data = this.getSortingState();
            var sortType = (data[0] == ind && data[1] == "asc") ? "des" : "asc";
            if (!this.callEvent("onBeforeSorting", [ind, this.fldSort[ind], sortType])) {
                return
            }
            this.sortImg.className = "dhxgrid_sort_" + (sortType == "asc" ? "asc" : "desc");
            if (this.useImagesInHeader) {
                var cel = this.hdr.rows[1].cells[el._cellIndex].firstChild;
                if (this.fldSorted != null) {
                    var celT = this.hdr.rows[1].cells[this.fldSorted._cellIndex].firstChild;
                    celT.src = celT.src.replace(/(\.asc\.)|(\.des\.)/, ".")
                }
                cel.src = cel.src.replace(/(\.[a-z]+)$/, "." + sortType + "$1")
            }
            this.sortRows(el._cellIndex, this.fldSort[el._cellIndex], sortType);
            this.fldSorted = el;
            this.r_fldSorted = r_el;
            var c = this.hdr.rows[1];
            var c = r_el.parentNode;
            var real_el = c._childIndexes ? c._childIndexes[el._cellIndex] : el._cellIndex;
            this.setSortImgPos(false, false, false, r_el)
        }
    };
    this.setCustomSorting = function (func, col) {
        if (!this._customSorts) {
            this._customSorts = new Array()
        }
        this._customSorts[col] = (typeof (func) == "string") ? eval(func) : func;
        this.fldSort[col] = "cus"
    };
    this.enableHeaderImages = function (fl) {
        this.useImagesInHeader = fl
    };
    this.setHeader = function (hdrStr, splitSign, styles) {
        if (typeof (hdrStr) != "object") {
            var arLab = this._eSplit(hdrStr)
        } else {
            arLab = [].concat(hdrStr)
        }
        var arWdth = new Array(0);
        var arTyp = new dhtmlxArray(0);
        var arAlg = new Array(0);
        var arVAlg = new Array(0);
        var arSrt = new Array(0);
        for (var i = 0; i < arLab.length; i++) {
            arWdth[arWdth.length] = Math.round(100 / arLab.length);
            arTyp[arTyp.length] = "ed";
            arAlg[arAlg.length] = "left";
            arVAlg[arVAlg.length] = "middle";
            arSrt[arSrt.length] = "na"
        }
        this.splitSign = splitSign || "#cspan";
        this.hdrLabels = arLab;
        this.cellWidth = arWdth;
        if (!this.initCellWidth.length) {
            this.setInitWidthsP(arWdth.join(this.delim), true)
        }
        this.cellType = arTyp;
        this.cellAlign = arAlg;
        this.cellVAlign = arVAlg;
        this.fldSort = arSrt;
        this._hstyles = styles || []
    };
    this._eSplit = function (str) {
        if (![].push) {
            return str.split(this.delim)
        }
        var a = "r" + (new Date()).valueOf();
        var z = this.delim.replace(/([\|\+\*\^])/g, "\\$1");
        return (str || "").replace(RegExp(z, "g"), a).replace(RegExp("\\\\" + a, "g"), this.delim).split(a)
    };
    this.getColType = function (cInd) {
        return this.cellType[cInd]
    };
    this.getColTypeById = function (cID) {
        return this.cellType[this.getColIndexById(cID)]
    };
    this.setColTypes = function (typeStr) {
        this.cellType = dhtmlxArray(typeStr.split(this.delim));
        this._strangeParams = new Array();
        for (var i = 0; i < this.cellType.length; i++) {
            if ((this.cellType[i].indexOf("[") != -1)) {
                var z = this.cellType[i].split(/[\[\]]+/g);
                this.cellType[i] = z[0];
                this.defVal[i] = z[1];
                if (z[1].indexOf("=") == 0) {
                    this.cellType[i] = "math";
                    this._strangeParams[i] = z[0]
                }
            }
            if (!window["eXcell_" + this.cellType[i]]) {
                dhtmlxError.throwError("Configuration", "Incorrect cell type: " + this.cellType[i], [this, this.cellType[i]])
            }
        }
    };
    this.setColSorting = function (sortStr) {
        this.fldSort = sortStr.split(this.delim);
        var check = {
            str: 1,
            "int": 1,
            date: 1
        };
        for (var i = 0; i < this.fldSort.length; i++) {
            if ((!check[this.fldSort[i]]) && (typeof (window[this.fldSort[i]]) == "function")) {
                if (!this._customSorts) {
                    this._customSorts = new Array()
                }
                this._customSorts[i] = window[this.fldSort[i]];
                this.fldSort[i] = "cus"
            }
        }
    };
    this.setColAlign = function (alStr) {
        this.cellAlign = alStr.split(this.delim);
        for (var i = 0; i < this.cellAlign.length; i++) {
            this.cellAlign[i] = this.cellAlign[i]._dhx_trim()
        }
    };
    this.setColVAlign = function (valStr) {
        this.cellVAlign = valStr.split(this.delim)
    };
    this.setNoHeader = function (fl) {
        this.noHeader = convertStringToBoolean(fl)
    };
    this.showRow = function (rowID) {
        this.getRowById(rowID);
        if (this._h2) {
            this.openItem(this._h2.get[rowID].parent.id)
        }
        var c = this.getRowById(rowID).childNodes[0];
        while (c && c.style.display == "none") {
            c = c.nextSibling
        }
        if (c) {
            this.moveToVisible(c, true)
        }
    };
    this.setStyle = function (ss_header, ss_grid, ss_selCell, ss_selRow) {
        this.ssModifier = [ss_header, ss_grid, ss_selCell, ss_selCell, ss_selRow];
        var prefs = ["#" + this.entBox.id + " table.hdr td", "#" + this.entBox.id + " table.obj td", "#" + this.entBox.id + " table.obj tr.rowselected td.cellselected", "#" + this.entBox.id + " table.obj td.cellselected", "#" + this.entBox.id + " table.obj tr.rowselected td"];
        var index = 0;
        while (!_isIE) {
            try {
                var temp = document.styleSheets[index].cssRules.length
            } catch (e) {
                index++;
                continue
            }
            break
        }
        for (var i = 0; i < prefs.length; i++) {
            if (this.ssModifier[i]) {
                if (_isIE) {
                    document.styleSheets[0].addRule(prefs[i], this.ssModifier[i])
                } else {
                    document.styleSheets[index].insertRule(prefs[i] + (" { " + this.ssModifier[i] + " }"), document.styleSheets[index].cssRules.length)
                }
            }
        }
    };
    this.setColumnColor = function (clr) {
        this.columnColor = clr.split(this.delim)
    };
    this.enableAlterCss = function (cssE, cssU, perLevel, levelUnique) {
        if (cssE || cssU) {
            this.attachEvent("onGridReconstructed", function () {
                this._fixAlterCss();
                if (this._fake) {
                    this._fake._fixAlterCss()
                }
            })
        }
        this._cssSP = perLevel;
        this._cssSU = levelUnique;
        this._cssEven = cssE;
        this._cssUnEven = cssU
    };
    this._fixAlterCss = function (ind) {
        if (this._h2 && (this._cssSP || this._cssSU)) {
            return this._fixAlterCssTGR(ind)
        }
        if (!this._cssEven && !this._cssUnEven) {
            return
        }
        ind = ind || 0;
        var j = ind;
        for (var i = ind; i < this.rowsCol.length; i++) {
            if (!this.rowsCol[i]) {
                continue
            }
            if (this.rowsCol[i].style.display != "none") {
                if (this.rowsCol[i]._cntr) {
                    j = 1;
                    continue
                }
                if (this.rowsCol[i].className.indexOf("rowselected") != -1) {
                    if (j % 2 == 1) {
                        this.rowsCol[i].className = this._cssUnEven + " rowselected " + (this.rowsCol[i]._css || "")
                    } else {
                        this.rowsCol[i].className = this._cssEven + " rowselected " + (this.rowsCol[i]._css || "")
                    }
                } else {
                    if (j % 2 == 1) {
                        this.rowsCol[i].className = this._cssUnEven + " " + (this.rowsCol[i]._css || "")
                    } else {
                        this.rowsCol[i].className = this._cssEven + " " + (this.rowsCol[i]._css || "")
                    }
                }
                j++
            }
        }
    };
    this.clearChangedState = function () {
        for (var i = 0; i < this.rowsCol.length; i++) {
            var row = this.rowsCol[i];
            if (row && row.childNodes) {
                var cols = row.childNodes.length;
                for (var j = 0; j < cols; j++) {
                    row.childNodes[j].wasChanged = false
                }
            }
        }
    };
    this.getChangedRows = function (and_added) {
        var res = new Array();
        this.forEachRow(function (id) {
            var row = this.rowsAr[id];
            if (row.tagName != "TR") {
                return
            }
            var cols = row.childNodes.length;
            if (and_added && row._added) {
                res[res.length] = row.idd
            } else {
                for (var j = 0; j < cols; j++) {
                    if (row.childNodes[j].wasChanged) {
                        res[res.length] = row.idd;
                        break
                    }
                }
            }
        });
        return res.join(this.delim)
    };
    this._sUDa = false;
    this._sAll = false;
    this.setSerializationLevel = function (userData, fullXML, config, changedAttr, onlyChanged, asCDATA) {
        this._sUDa = userData;
        this._sAll = fullXML;
        this._sConfig = config;
        this._chAttr = changedAttr;
        this._onlChAttr = onlyChanged;
        this._asCDATA = asCDATA
    };
    this.setSerializableColumns = function (list) {
        if (!list) {
            this._srClmn = null;
            return
        }
        this._srClmn = (list || "").split(",");
        for (var i = 0; i < this._srClmn.length; i++) {
            this._srClmn[i] = convertStringToBoolean(this._srClmn[i])
        }
    };
    this._serialise = function (rCol, inner, closed) {
        this.editStop();
        var out = [];
        var close = "</" + this.xml.s_row + ">";
        if (this.isTreeGrid()) {
            this._h2.forEachChildF(0, function (el) {
                var temp = this._serializeRow(this.render_row_tree(-1, el.id));
                out.push(temp);
                if (temp) {
                    return true
                } else {
                    return false
                }
            }, this, function () {
                out.push(close)
            })
        } else {
            for (var i = 0; i < this.rowsBuffer.length; i++) {
                if (this.rowsBuffer[i]) {
                    if (this._chAttr && this.rowsBuffer[i]._locator) {
                        continue
                    }
                    var temp = this._serializeRow(this.render_row(i));
                    out.push(temp);
                    if (temp) {
                        out.push(close)
                    }
                }
            }
        }
        return [out.join("")]
    };
    this._serializeRow = function (r, i) {
        var out = [];
        var ra = this.xml.row_attrs;
        var ca = this.xml.cell_attrs;
        out.push("<" + this.xml.s_row);
        out.push(" id='" + r.idd + "'");
        if ((this._sAll) && this.selectedRows._dhx_find(r) != -1) {
            out.push(" selected='1'")
        }
        if (this._h2 && this._h2.get[r.idd].state == "minus") {
            out.push(" open='1'")
        }
        if (ra.length) {
            for (var i = 0; i < ra.length; i++) {
                out.push(" " + ra[i] + "='" + r._attrs[ra[i]] + "'")
            }
        }
        out.push(">");
        if (this._sUDa && this.UserData[r.idd]) {
            keysAr = this.UserData[r.idd].getKeys();
            for (var ii = 0; ii < keysAr.length; ii++) {
                out.push("<userdata name='" + keysAr[ii] + "'>" + (this._asCDATA ? "<![CDATA[" : "") + this.UserData[r.idd].get(keysAr[ii]) + (this._asCDATA ? "]]>" : "") + "</userdata>")
            }
        }
        var changeFl = false;
        for (var jj = 0; jj < this._cCount; jj++) {
            if ((!this._srClmn) || (this._srClmn[jj])) {
                var zx = this.cells3(r, jj);
                out.push("<cell");
                if (ca.length) {
                    for (var i = 0; i < ca.length; i++) {
                        out.push(" " + ca[i] + "='" + zx.cell._attrs[ca[i]] + "'")
                    }
                }
                zxVal = zx[this._agetm]();
                if (this._asCDATA) {
                    zxVal = "<![CDATA[" + zxVal + "]]>"
                }
                if ((this._ecspn) && (zx.cell.colSpan) && zx.cell.colSpan > 1) {
                    out.push(' colspan="' + zx.cell.colSpan + '" ')
                }
                if (this._chAttr) {
                    if (zx.wasChanged()) {
                        out.push(' changed="1"');
                        changeFl = true
                    }
                } else {
                    if ((this._onlChAttr) && (zx.wasChanged())) {
                        changeFl = true
                    }
                }
                if (this._sAll && this.cellType[jj] == "tree") {
                    out.push((this._h2 ? (" image='" + this._h2.get[r.idd].image + "'") : "") + ">" + zxVal + "</cell>")
                } else {
                    out.push(">" + zxVal + "</cell>")
                }
                if ((this._ecspn) && (zx.cell.colSpan)) {
                    for (var u = 0; u < zx.cell.colSpan - 1; u++) {
                        out.push("<cell/>");
                        jj++
                    }
                }
            }
        }
        if ((this._onlChAttr) && (!changeFl) && (!r._added)) {
            return ""
        }
        return out.join("")
    };
    this._serialiseConfig = function () {
        var out = "<head>";
        for (var i = 0; i < this.hdr.rows[0].cells.length; i++) {
            if (this._srClmn && !this._srClmn[i]) {
                continue
            }
            var sort = this.fldSort[i];
            if (sort == "cus") {
                sort = this._customSorts[i].toString();
                sort = sort.replace(/function[\ ]*/, "").replace(/\([^\f]*/, "")
            }
            out += "<column width='" + this.getColWidth(i) + "' align='" + this.cellAlign[i] + "' type='" + this.cellType[i] + "' sort='" + (sort || "na") + "' color='" + this.columnColor[i] + "'" + (this.columnIds[i] ? (" id='" + this.columnIds[i] + "'") : "") + ">";
            if (this._asCDATA) {
                out += "<![CDATA[" + this.getHeaderCol(i) + "]]>"
            } else {
                out += this.getHeaderCol(i)
            }
            var z = this.getCombo(i);
            if (z) {
                for (var j = 0; j < z.keys.length; j++) {
                    out += "<option value='" + z.keys[j] + "'>" + z.values[j] + "</option>"
                }
            }
            out += "</column>"
        }
        return out += "</head>"
    };
    this.serialize = function () {
        var out = '<?xml version="1.0"?><rows>';
        if (this._mathSerialization) {
            this._agetm = "getMathValue"
        } else {
            this._agetm = "getValue"
        }
        if (this._sUDa && this.UserData.gridglobaluserdata) {
            var keysAr = this.UserData.gridglobaluserdata.getKeys();
            for (var i = 0; i < keysAr.length; i++) {
                out += "<userdata name='" + keysAr[i] + "'>" + this.UserData.gridglobaluserdata.get(keysAr[i]) + "</userdata>"
            }
        }
        if (this._sConfig) {
            out += this._serialiseConfig()
        }
        out += this._serialise();
        out += "</rows>";
        return out
    };
    this.getPosition = function (oNode, pNode) {
        if (!pNode) {
            var pos = getOffset(oNode);
            return [pos.left, pos.top]
        }
        pNode = pNode || document.body;
        var oCurrentNode = oNode;
        var iLeft = 0;
        var iTop = 0;
        while ((oCurrentNode) && (oCurrentNode != pNode)) {
            iLeft += oCurrentNode.offsetLeft - oCurrentNode.scrollLeft;
            iTop += oCurrentNode.offsetTop - oCurrentNode.scrollTop;
            oCurrentNode = oCurrentNode.offsetParent
        }
        if (pNode == document.body) {
            if (_isIE) {
                iTop += document.body.offsetTop || document.documentElement.offsetTop;
                iLeft += document.body.offsetLeft || document.documentElement.offsetLeft
            } else {
                if (!_isFF) {
                    iLeft += document.body.offsetLeft;
                    iTop += document.body.offsetTop
                }
            }
        }
        return [iLeft, iTop]
    };
    this.getFirstParentOfType = function (obj, tag) {
        while (obj && obj.tagName != tag && obj.tagName != "BODY") {
            obj = obj.parentNode
        }
        return obj
    };
    this.objBox.onscroll = function () {
        this.grid._doOnScroll()
    };
    this.objBox.ontouchend = function () {
        this.hdrBox.scrollLeft = this.objBox.scrollLeft
    };
    this.hdrBox.onscroll = function () {
        if (this._try_header_sync) {
            return
        }
        this._try_header_sync = true;
        if (Math.abs(this.grid.objBox.scrollLeft - this.scrollLeft) > 1) {
            this.grid.objBox.scrollLeft = this.scrollLeft
        }
        this._try_header_sync = false
    };
    if ((!_isOpera) || (_OperaRv > 8.5)) {
        this.hdr.onmousemove = function (e) {
            this.grid.changeCursorState(e || window.event)
        };
        this.hdr.onmousedown = function (e) {
            return this.grid.startColResize(e || window.event)
        }
    }
    this.obj.onmousemove = this._drawTooltip;
    this.objBox.onclick = function (e) {
        (e || event).cancelBubble = true
    };
    this.obj.onclick = function (e) {
        this.grid._doClick(e || window.event);
        if (this.grid._sclE) {
            this.grid.editCell(e || window.event)
        } else {
            this.grid.editStop()
        }(e || event).cancelBubble = true
    };
    if (_isMacOS) {
        this.entBox.oncontextmenu = function (e) {
            e.cancelBubble = true;
            if (e.preventDefault) {
                e.preventDefault()
            } else {
                e.returnValue = false
            }
            var that = this.grid;
            if (that._realfake) {
                that = that._fake
            }
            return that._doContClick(e || window.event)
        }
    } else {
        this.entBox.onmousedown = function (e) {
            return this.grid._doContClick(e || window.event)
        };
        this.entBox.oncontextmenu = function (e) {
            if (this.grid._ctmndx) {
                (e || event).cancelBubble = true
            }
            return !this.grid._ctmndx
        }
    }
    this.obj.ondblclick = function (e) {
        if (!this.grid.wasDblClicked(e || window.event)) {
            return false
        }
        if (this.grid._dclE) {
            var row = this.grid.getFirstParentOfType((_isIE ? event.srcElement : e.target), "TR");
            if (row == this.grid.row) {
                this.grid.editCell(e || window.event)
            }
        }(e || event).cancelBubble = true;
        if (_isOpera) {
            return false
        }
    };
    this.hdr.onclick = this._onHeaderClick;
    this.sortImg.onclick = function () {
        self._onHeaderClick.apply({
            grid: self
        }, [null, self.r_fldSorted])
    };
    this.hdr.ondblclick = this._onHeaderDblClick;
    if (!document.body._dhtmlxgrid_onkeydown) {
        dhtmlxEvent(document, "keydown", function (e) {
            if (globalActiveDHTMLGridObject) {
                return globalActiveDHTMLGridObject.doKey(e || window.event)
            }
        });
        document.body._dhtmlxgrid_onkeydown = true
    }
    dhtmlxEvent(document.body, "click", function () {
        if (self.editStop) {
            self.editStop()
        }
        if (self.isActive) {
            self.setActive(false)
        }
    });
    if (this.entBox.style.height.toString().indexOf("%") != -1) {
        this._delta_y = this.entBox.style.height
    }
    if (this.entBox.style.width.toString().indexOf("%") != -1) {
        this._delta_x = this.entBox.style.width
    }
    if (this._delta_x || this._delta_y) {
        this._setAutoResize()
    }
    this.setColHidden = this.setColumnsVisibility;
    this.enableCollSpan = this.enableColSpan;
    this.setMultiselect = this.enableMultiselect;
    this.setMultiLine = this.enableMultiline;
    this.deleteSelectedItem = this.deleteSelectedRows;
    this.getSelectedId = this.getSelectedRowId;
    this.getHeaderCol = this.getColumnLabel;
    this.isItemExists = this.doesRowExist;
    this.getColumnCount = this.getColumnsNum;
    this.setSelectedRow = this.selectRowById;
    this.setHeaderCol = this.setColumnLabel;
    this.preventIECashing = this.preventIECaching;
    this.enableAutoHeigth = this.enableAutoHeight;
    this.getUID = this.uid;
    if (dhtmlx.image_path) {
        this.setImagePath(dhtmlx.image_path)
    }
    if (dhtmlx.skin) {
        this.setSkin(dhtmlx.skin)
    }
    return this
}
dhtmlXGridObject.prototype = {
    getRowAttribute: function (c, a) {
        return this.getRowById(c)._attrs[a]
    },
    setRowAttribute: function (g, a, c) {
        this.getRowById(g)._attrs[a] = c
    },
    isTreeGrid: function () {
        return (this.cellType._dhx_find("tree") != -1)
    },
    setRowHidden: function (l, g) {
        var c = convertStringToBoolean(g);
        var j = this.getRowById(l);
        if (!j) {
            return
        }
        if (j.expand === "") {
            this.collapseKids(j)
        }
        if ((g) && (j.style.display != "none")) {
            j.style.display = "none";
            var h = this.selectedRows._dhx_find(j);
            if (h != -1) {
                j.className = j.className.replace("rowselected", "");
                for (var a = 0; a < j.childNodes.length; a++) {
                    j.childNodes[a].className = j.childNodes[a].className.replace(/cellselected/g, "")
                }
                this.selectedRows._dhx_removeAt(h)
            }
            this.callEvent("onGridReconstructed", [])
        }
        if ((!g) && (j.style.display == "none")) {
            j.style.display = "";
            this.callEvent("onGridReconstructed", [])
        }
        this.callEvent("onRowHide", [l, g]);
        this.setSizes()
    },
    setColumnHidden: function (g, c) {
        if (!this.hdr.rows.length) {
            if (!this._ivizcol) {
                this._ivizcol = []
            }
            return this._ivizcol[g] = c
        }
        if ((this.fldSorted) && (this.fldSorted.cellIndex == g) && (c)) {
            this.sortImg.style.display = "none"
        }
        var a = convertStringToBoolean(c);
        if (a) {
            if (!this._hrrar) {
                this._hrrar = new Array()
            } else {
                if (this._hrrar[g]) {
                    return
                }
            }
            this._hrrar[g] = "display:none;";
            this._hideShowColumn(g, "none")
        } else {
            if ((!this._hrrar) || (!this._hrrar[g])) {
                return
            }
            this._hrrar[g] = "";
            this._hideShowColumn(g, "")
        }
        if ((this.fldSorted) && (this.fldSorted.cellIndex == g) && (!c)) {
            this.sortImg.style.display = "inline"
        }
        this.setSortImgPos();
        this.callEvent("onColumnHidden", [g, c])
    },
    isColumnHidden: function (a) {
        if ((this._hrrar) && (this._hrrar[a])) {
            return true
        }
        return false
    },
    setColumnsVisibility: function (c) {
        if (c) {
            this._ivizcol = c.split(this.delim)
        }
        if (this.hdr.rows.length && this._ivizcol) {
            for (var a = 0; a < this._ivizcol.length; a++) {
                this.setColumnHidden(a, this._ivizcol[a])
            }
        }
    },
    _fixHiddenRowsAll: function (o, g, a, c, m) {
        m = m || "_cellIndex";
        var n = o.rows.length;
        for (var l = 0; l < n; l++) {
            var q = o.rows[l].childNodes;
            if (q.length != this._cCount) {
                for (var h = 0; h < q.length; h++) {
                    if (q[h][m] == g) {
                        q[h].style[a] = c;
                        break
                    }
                }
            } else {
                q[g].style[a] = c
            }
        }
    },
    _hideShowColumn: function (j, h) {
        var a = j;
        if (this.hdr.rows[1] && (this.hdr.rows[1]._childIndexes) && (this.hdr.rows[1]._childIndexes[j] != j)) {
            a = this.hdr.rows[1]._childIndexes[j]
        }
        if (h == "none") {
            this.hdr.rows[0].cells[j]._oldWidth = this.hdr.rows[0].cells[j].style.width || (this.initCellWidth[j] + "px");
            this.hdr.rows[0].cells[j]._oldWidthP = this.cellWidthPC[j];
            this.obj.rows[0].cells[j].style.width = "0px";
            var c = {
                rows: [this.obj.rows[0]]
            };
            this.forEachRow(function (l) {
                if (this.rowsAr[l].tagName == "TR") {
                    c.rows.push(this.rowsAr[l])
                }
            });
            this._fixHiddenRowsAll(c, j, "display", "none");
            if (this.isTreeGrid()) {
                this._fixHiddenRowsAllTG(j, "none")
            }
            if ((_isOpera && _OperaRv < 9) || _isKHTML || (_isFF)) {
                this._fixHiddenRowsAll(this.hdr, j, "display", "none", "_cellIndexS")
            }
            if (this.ftr) {
                this._fixHiddenRowsAll(this.ftr.childNodes[0], j, "display", "none")
            }
            this._fixHiddenRowsAll(this.hdr, j, "whiteSpace", "nowrap", "_cellIndexS");
            if (!this.cellWidthPX.length && !this.cellWidthPC.length) {
                this.cellWidthPX = [].concat(this.initCellWidth)
            }
            if (this.cellWidthPX[j]) {
                this.cellWidthPX[j] = 0
            }
            if (this.cellWidthPC[j]) {
                this.cellWidthPC[j] = 0
            }
        } else {
            if (this.hdr.rows[0].cells[j]._oldWidth) {
                var g = this.hdr.rows[0].cells[j];
                if (_isOpera || _isKHTML || (_isFF)) {
                    this._fixHiddenRowsAll(this.hdr, j, "display", "", "_cellIndexS")
                }
                if (this.ftr) {
                    this._fixHiddenRowsAll(this.ftr.childNodes[0], j, "display", "")
                }
                var c = {
                    rows: [this.obj.rows[0]]
                };
                this.forEachRow(function (l) {
                    if (this.rowsAr[l].tagName == "TR") {
                        c.rows.push(this.rowsAr[l])
                    }
                });
                this._fixHiddenRowsAll(c, j, "display", "");
                if (this.isTreeGrid()) {
                    this._fixHiddenRowsAllTG(j, "")
                }
                this._fixHiddenRowsAll(this.hdr, j, "whiteSpace", "normal", "_cellIndexS");
                if (g._oldWidthP) {
                    this.cellWidthPC[j] = g._oldWidthP
                }
                if (g._oldWidth) {
                    this.cellWidthPX[j] = parseInt(g._oldWidth)
                }
            }
        }
        this.setSizes();
        if ((!_isIE) && (!_isFF)) {
            this.obj.border = 1;
            this.obj.border = 0
        }
    },
    enableColSpan: function (a) {
        this._ecspn = convertStringToBoolean(a)
    },
    enableRowsHover: function (c, a) {
        this._unsetRowHover(false, true);
        this._hvrCss = a;
        if (convertStringToBoolean(c)) {
            if (!this._elmnh) {
                this.obj._honmousemove = this.obj.onmousemove;
                this.obj.onmousemove = this._setRowHover;
                if (_isIE) {
                    this.obj.onmouseleave = this._unsetRowHover
                } else {
                    this.obj.onmouseout = this._unsetRowHover
                }
                this._elmnh = true
            }
        } else {
            if (this._elmnh) {
                this.obj.onmousemove = this.obj._honmousemove;
                if (_isIE) {
                    this.obj.onmouseleave = null
                } else {
                    this.obj.onmouseout = null
                }
                this._elmnh = false
            }
        }
    },
    enableEditEvents: function (c, g, a) {
        this._sclE = convertStringToBoolean(c);
        this._dclE = convertStringToBoolean(g);
        this._f2kE = convertStringToBoolean(a)
    },
    enableLightMouseNavigation: function (a) {
        if (convertStringToBoolean(a)) {
            if (!this._elmn) {
                this.entBox._onclick = this.entBox.onclick;
                this.entBox.onclick = function () {
                    return true
                };
                this.obj._onclick = this.obj.onclick;
                this.obj.onclick = function (g) {
                    var h = this.grid.getFirstParentOfType(g ? g.target : event.srcElement, "TD");
                    if (!h) {
                        return
                    }
                    this.grid.editStop();
                    this.grid.doClick(h);
                    this.grid.editCell();
                    (g || event).cancelBubble = true
                };
                this.obj._onmousemove = this.obj.onmousemove;
                this.obj.onmousemove = this._autoMoveSelect;
                this._elmn = true
            }
        } else {
            if (this._elmn) {
                this.entBox.onclick = this.entBox._onclick;
                this.obj.onclick = this.obj._onclick;
                this.obj.onmousemove = this.obj._onmousemove;
                this._elmn = false
            }
        }
    },
    _unsetRowHover: function (g, h) {
        if (h) {
            that = this
        } else {
            that = this.grid
        }
        if ((that._lahRw) && (that._lahRw != h)) {
            for (var a = 0; a < that._lahRw.childNodes.length; a++) {
                that._lahRw.childNodes[a].className = that._lahRw.childNodes[a].className.replace(that._hvrCss, "")
            }
            that._lahRw = null
        }
    },
    _setRowHover: function (g) {
        var h = this.grid.getFirstParentOfType(g ? g.target : event.srcElement, "TD");
        if (h && h.parentNode != this.grid._lahRw) {
            this.grid._unsetRowHover(0, h);
            h = h.parentNode;
            if (!h.idd || h.idd == "__filler__") {
                return
            }
            for (var a = 0; a < h.childNodes.length; a++) {
                h.childNodes[a].className += " " + this.grid._hvrCss
            }
            this.grid._lahRw = h
        }
        this._honmousemove(g)
    },
    _autoMoveSelect: function (a) {
        if (!this.grid.editor) {
            var g = this.grid.getFirstParentOfType(a ? a.target : event.srcElement, "TD");
            if (g.parentNode.idd) {
                this.grid.doClick(g, true, 0)
            }
        }
        this._onmousemove(a)
    },
    enableDistributedParsing: function (g, a, c) {
        if (convertStringToBoolean(g)) {
            this._ads_count = a || 10;
            this._ads_time = c || 250
        } else {
            this._ads_count = 0
        }
    },
    destructor: function () {
        this.editStop(true);
        if (this._sizeTime) {
            this._sizeTime = window.clearTimeout(this._sizeTime)
        }
        this.entBox.className = (this.entBox.className || "").replace(/gridbox.*/, "");
        if (this.formInputs) {
            for (var g = 0; g < this.formInputs.length; g++) {
                this.parentForm.removeChild(this.formInputs[g])
            }
        }
        var c;
        this.xmlLoader = this.xmlLoader.destructor();
        for (var g = 0; g < this.rowsCol.length; g++) {
            if (this.rowsCol[g]) {
                this.rowsCol[g].grid = null
            }
        }
        for (g in this.rowsAr) {
            if (this.rowsAr[g]) {
                this.rowsAr[g] = null
            }
        }
        this.rowsCol = new dhtmlxArray();
        this.rowsAr = {};
        this.entBox.innerHTML = "";
        var h = function () {};
        this.entBox.onclick = this.entBox.onmousedown = this.entBox.onbeforeactivate = this.entBox.onbeforedeactivate = this.entBox.onbeforedeactivate = this.entBox.onselectstart = h;
        this.setSizes = this._update_srnd_view = this.callEvent = h;
        this.entBox.grid = this.objBox.grid = this.hdrBox.grid = this.obj.grid = this.hdr.grid = null;
        if (this._fake) {
            this.globalBox.innerHTML = "";
            this._fake.setSizes = this._fake._update_srnd_view = this._fake.callEvent = h;
            this.globalBox.onclick = this.globalBox.onmousedown = this.globalBox.onbeforeactivate = this.globalBox.onbeforedeactivate = this.globalBox.onbeforedeactivate = this.globalBox.onselectstart = h
        }
        for (c in this) {
            if ((this[c]) && (this[c].m_obj)) {
                this[c].m_obj = null
            }
            this[c] = null
        }
        if (this == globalActiveDHTMLGridObject) {
            globalActiveDHTMLGridObject = null
        }
        return null
    },
    getSortingState: function () {
        var a = new Array();
        if (this.fldSorted) {
            a[0] = this.fldSorted._cellIndex;
            a[1] = (this.sortImg.className == "dhxgrid_sort_desc" ? "des" : "asc")
        }
        return a
    },
    enableAutoHeight: function (g, c, a) {
        this._ahgr = convertStringToBoolean(g);
        this._ahgrF = convertStringToBoolean(a);
        this._ahgrM = c || null;
        if (arguments.length == 1) {
            this.objBox.style.overflowY = g ? "hidden" : "auto"
        }
        if (c == "auto") {
            this._ahgrM = null;
            this._ahgrMA = true;
            this._setAutoResize()
        }
    },
    enableStableSorting: function (a) {
        this._sst = convertStringToBoolean(a);
        this.rowsCol.stablesort = function (m) {
            var l = this.length - 1;
            for (var h = 0; h < this.length - 1; h++) {
                for (var g = 0; g < l; g++) {
                    if (m(this[g], this[g + 1]) > 0) {
                        var c = this[g];
                        this[g] = this[g + 1];
                        this[g + 1] = c
                    }
                }
                l--
            }
        }
    },
    enableKeyboardSupport: function (a) {
        this._htkebl = !convertStringToBoolean(a)
    },
    enableContextMenu: function (a) {
        this._ctmndx = a
    },
    setScrollbarWidthCorrection: function (a) {},
    enableTooltips: function (c) {
        this._enbTts = c.split(",");
        for (var a = 0; a < this._enbTts.length; a++) {
            this._enbTts[a] = convertStringToBoolean(this._enbTts[a])
        }
    },
    enableResizing: function (c) {
        this._drsclmn = c.split(",");
        for (var a = 0; a < this._drsclmn.length; a++) {
            this._drsclmn[a] = convertStringToBoolean(this._drsclmn[a])
        }
    },
    setColumnMinWidth: function (a, c) {
        if (arguments.length == 2) {
            if (!this._drsclmW) {
                this._drsclmW = new Array()
            }
            this._drsclmW[c] = a
        } else {
            this._drsclmW = a.split(",")
        }
    },
    enableCellIds: function (a) {
        this._enbCid = convertStringToBoolean(a)
    },
    lockRow: function (a, g) {
        var c = this.getRowById(a);
        if (c) {
            c._locked = convertStringToBoolean(g);
            if ((this.cell) && (this.cell.parentNode.idd == a)) {
                this.editStop()
            }
        }
    },
    _getRowArray: function (j) {
        var h = new Array();
        for (var g = 0; g < j.childNodes.length; g++) {
            var c = this.cells3(j, g);
            h[g] = c.getValue()
        }
        return h
    },
    setDateFormat: function (c, a) {
        this._dtmask = c;
        this._dtmask_inc = a
    },
    setNumberFormat: function (n, g, j, m) {
        var h = n.replace(/[^0\,\.]*/g, "");
        var a = h.indexOf(".");
        if (a > -1) {
            a = h.length - a - 1
        }
        var c = h.indexOf(",");
        if (c > -1) {
            c = h.length - a - 2 - c
        }
        if (typeof j != "string") {
            j = this.i18n.decimal_separator
        }
        if (typeof m != "string") {
            m = this.i18n.group_separator
        }
        var o = n.split(h)[0];
        var l = n.split(h)[1];
        this._maskArr[g] = [a, c, o, l, j, m]
    },
    _aplNFb: function (j, h) {
        var c = this._maskArr[h];
        if (!c) {
            return j
        }
        var g = parseFloat(j.toString().replace(/[^0-9]*/g, ""));
        if (j.toString().substr(0, 1) == "-") {
            g = g * -1
        }
        if (c[0] > 0) {
            g = g / Math.pow(10, c[0])
        }
        return g
    },
    _aplNF: function (m, l) {
        var g = this._maskArr[l];
        if (!g) {
            return m
        }
        var n = (parseFloat(m) < 0 ? "-" : "") + g[2];
        m = Math.abs(Math.round(parseFloat(m) * Math.pow(10, g[0] > 0 ? g[0] : 0))).toString();
        m = (m.length < g[0] ? Math.pow(10, g[0] + 1 - m.length).toString().substr(1, g[0] + 1) + m.toString() : m).split("").reverse();
        m[g[0]] = (m[g[0]] || "0") + g[4];
        if (g[1] > 0) {
            for (var h = (g[0] > 0 ? 0 : 1) + g[0] + g[1]; h < m.length; h += g[1]) {
                m[h] += g[5]
            }
        }
        return n + m.reverse().join("") + g[3]
    },
    _launchCommands: function (a) {
        for (var h = 0; h < a.length; h++) {
            var g = new Array();
            for (var c = 0; c < a[h].childNodes.length; c++) {
                if (a[h].childNodes[c].nodeType == 1) {
                    g[g.length] = a[h].childNodes[c].firstChild.data
                }
            }
            this[a[h].getAttribute("command")].apply(this, g)
        }
    },
    _parseHead: function (l) {
        var h = this.xmlLoader.doXPath("./head", l);
        if (h.length) {
            var m = this.xmlLoader.doXPath("./column", h[0]);
            var n = this.xmlLoader.doXPath("./settings", h[0]);
            var C = "setInitWidths";
            var w = false;
            if (n[0]) {
                for (var o = 0; o < n[0].childNodes.length; o++) {
                    switch (n[0].childNodes[o].tagName) {
                    case "colwidth":
                        if (n[0].childNodes[o].firstChild && n[0].childNodes[o].firstChild.data == "%") {
                            C = "setInitWidthsP"
                        }
                        break;
                    case "splitat":
                        w = (n[0].childNodes[o].firstChild ? n[0].childNodes[o].firstChild.data : false);
                        break
                    }
                }
            }
            this._launchCommands(this.xmlLoader.doXPath("./beforeInit/call", h[0]));
            if (m.length > 0) {
                if (this.hdr.rows.length > 0) {
                    this.clearAll(true)
                }
                var a = [
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    []
                ];
                var v = ["", "width", "type", "align", "sort", "color", "format", "hidden", "id"];
                var u = ["", C, "setColTypes", "setColAlign", "setColSorting", "setColumnColor", "", "", "setColumnIds"];
                for (var A = 0; A < m.length; A++) {
                    for (var y = 1; y < v.length; y++) {
                        a[y].push(m[A].getAttribute(v[y]))
                    }
                    a[0].push((m[A].firstChild ? m[A].firstChild.data : "").replace(/^\s*((\s\S)*.+)\s*$/gi, "$1"))
                }
                this.setHeader(a[0]);
                for (var A = 0; A < u.length; A++) {
                    if (u[A]) {
                        this[u[A]](a[A].join(this.delim))
                    }
                }
                for (var A = 0; A < m.length; A++) {
                    if ((this.cellType[A].indexOf("co") == 0) || (this.cellType[A] == "clist")) {
                        var q = this.xmlLoader.doXPath("./option", m[A]);
                        if (q.length) {
                            var x = new Array();
                            if (this.cellType[A] == "clist") {
                                for (var y = 0; y < q.length; y++) {
                                    x[x.length] = q[y].firstChild ? q[y].firstChild.data : ""
                                }
                                this.registerCList(A, x)
                            } else {
                                var D = this.getCombo(A);
                                for (var y = 0; y < q.length; y++) {
                                    D.put(q[y].getAttribute("value"), q[y].firstChild ? q[y].firstChild.data : "")
                                }
                            }
                        }
                    } else {
                        if (a[6][A]) {
                            if ((this.cellType[A].toLowerCase().indexOf("calendar") != -1) || (this.fldSort[A] == "date")) {
                                this.setDateFormat(a[6][A])
                            } else {
                                this.setNumberFormat(a[6][A], A)
                            }
                        }
                    }
                }
                this.init();
                var g = a[7].join(this.delim);
                if (this.setColHidden && g.replace(/,/g, "") != "") {
                    this.setColHidden(g)
                }
                if ((w) && (this.splitAt)) {
                    this.splitAt(w)
                }
            }
            this._launchCommands(this.xmlLoader.doXPath("./afterInit/call", h[0]))
        }
        var c = this.xmlLoader.doXPath("//rows/userdata", l);
        if (c.length > 0) {
            if (!this.UserData.gridglobaluserdata) {
                this.UserData.gridglobaluserdata = new Hashtable()
            }
            for (var y = 0; y < c.length; y++) {
                var E = "";
                for (var r = 0; r < c[y].childNodes.length; r++) {
                    E += c[y].childNodes[r].nodeValue
                }
                this.UserData.gridglobaluserdata.put(c[y].getAttribute("name"), E)
            }
        }
    },
    getCheckedRows: function (a) {
        var c = new Array();
        this.forEachRowA(function (h) {
            var g = this.cells(h, a);
            if (g.changeState && g.getValue() != 0) {
                c.push(h)
            }
        }, true);
        return c.join(",")
    },
    checkAll: function () {
        var c = arguments.length ? arguments[0] : 1;
        for (var a = 0; a < this.getColumnsNum(); a++) {
            if (this.getColType(a) == "ch") {
                this.setCheckedRows(a, c)
            }
        }
    },
    uncheckAll: function () {
        this.checkAll(0)
    },
    setCheckedRows: function (c, a) {
        this.forEachRowA(function (g) {
            if (this.cells(g, c).isCheckbox()) {
                this.cells(g, c).setValue(a)
            }
        })
    },
    _drawTooltip: function (j) {
        var l = this.grid.getFirstParentOfType(j ? j.target : event.srcElement, "TD");
        if (!l || ((this.grid.editor) && (this.grid.editor.cell == l))) {
            return true
        }
        var h = l.parentNode;
        if (!h.idd || h.idd == "__filler__") {
            return
        }
        var g = (j ? j.target : event.srcElement);
        if (h.idd == window.unknown) {
            return true
        }
        if (!this.grid.callEvent("onMouseOver", [h.idd, l._cellIndex, (j || window.event)])) {
            return true
        }
        if ((this.grid._enbTts) && (!this.grid._enbTts[l._cellIndex])) {
            if (g.title) {
                g.title = ""
            }
            return true
        }
        if (l._cellIndex >= this.grid._cCount) {
            return
        }
        var a = this.grid.cells3(h, l._cellIndex);
        if (!a || !a.cell || !a.cell._attrs) {
            return
        }
        if (g._title) {
            a.cell.title = ""
        }
        if (!a.cell._attrs.title) {
            g._title = true
        }
        if (a) {
            g.title = a.cell._attrs.title || (a.getTitle ? a.getTitle() : (a.getValue() || "").toString().replace(/<[^>]*>/gi, ""))
        }
        return true
    },
    enableCellWidthCorrection: function (a) {
        if (_isFF) {
            this._wcorr = parseInt(a)
        }
    },
    getAllRowIds: function (g) {
        var a = [];
        for (var c = 0; c < this.rowsBuffer.length; c++) {
            if (this.rowsBuffer[c]) {
                a.push(this.rowsBuffer[c].idd)
            }
        }
        return a.join(g || this.delim)
    },
    getAllItemIds: function () {
        return this.getAllRowIds()
    },
    setColspan: function (g, x, h) {
        if (!this._ecspn) {
            return
        }
        var a = this.getRowById(g);
        if ((a._childIndexes) && (a.childNodes[a._childIndexes[x]])) {
            var q = a._childIndexes[x];
            var l = a.childNodes[q];
            var o = l.colSpan;
            l.colSpan = 1;
            if ((o) && (o != 1)) {
                for (var u = 1; u < o; u++) {
                    var w = document.createElement("TD");
                    if (l.nextSibling) {
                        a.insertBefore(w, l.nextSibling)
                    } else {
                        a.appendChild(w)
                    }
                    a._childIndexes[x + u] = q + u;
                    w._cellIndex = x + u;
                    w.style.textAlign = this.cellAlign[u];
                    w.style.verticalAlign = this.cellVAlign[u];
                    l = w;
                    this.cells3(a, x + u).setValue("")
                }
            }
            for (var v = x * 1 + 1 * o; v < a._childIndexes.length; v++) {
                a._childIndexes[v] += (o - 1) * 1
            }
        }
        if ((h) && (h > 1)) {
            if (a._childIndexes) {
                var q = a._childIndexes[x]
            } else {
                var q = x;
                a._childIndexes = new Array();
                for (var v = 0; v < a.childNodes.length; v++) {
                    a._childIndexes[v] = v
                }
            }
            a.childNodes[q].colSpan = h;
            for (var v = 1; v < h; v++) {
                a._childIndexes[a.childNodes[q + 1]._cellIndex] = q;
                a.removeChild(a.childNodes[q + 1])
            }
            var s = a.childNodes[a._childIndexes[x]]._cellIndex;
            for (var v = s * 1 + 1 * h; v < a._childIndexes.length; v++) {
                a._childIndexes[v] -= (h - 1)
            }
        }
    },
    preventIECaching: function (a) {
        this.no_cashe = convertStringToBoolean(a);
        this.xmlLoader.rSeed = this.no_cashe
    },
    enableColumnAutoSize: function (a) {
        this._eCAS = convertStringToBoolean(a)
    },
    _onHeaderDblClick: function (g) {
        var c = this.grid;
        var a = c.getFirstParentOfType(_isIE ? event.srcElement : g.target, "TD");
        if (!c._eCAS) {
            return false
        }
        c.adjustColumnSize(a._cellIndexS)
    },
    adjustColumnSize: function (q, c) {
        if (this._hrrar && this._hrrar[q]) {
            return
        }
        this._notresize = true;
        var g = 0;
        this._setColumnSizeR(q, 20);
        for (var n = 1; n < this.hdr.rows.length; n++) {
            var s = this.hdr.rows[n];
            s = s.childNodes[(s._childIndexes) ? s._childIndexes[q] : q];
            if ((s) && ((!s.colSpan) || (s.colSpan < 2)) && s._cellIndex == q) {
                if ((s.childNodes[0]) && (s.childNodes[0].className == "hdrcell")) {
                    s = s.childNodes[0]
                }
                g = Math.max(g, s.scrollWidth)
            }
        }
        var h = this.obj.rows.length;
        var r = 0;
        var v = this.cellType._dhx_find("tree");
        for (var o = 1; o < h; o++) {
            var u = this.obj.rows[o];
            if (!this.rowsAr[u.idd]) {
                continue
            }
            if (u._childIndexes && u._childIndexes[q] != q || !u.childNodes[q]) {
                continue
            }
            r = (u.childNodes[q].innerText || u.childNodes[q].textContent || "").length * this.fontWidth;
            if (this._h2 && q == v) {
                r += this._h2.get[u.idd].level * 22
            }
            if (r > g) {
                g = r
            }
        }
        g += 20 + (c || 0);
        this._setColumnSizeR(q, g);
        this._notresize = false;
        this.setSizes()
    },
    detachHeader: function (a, g) {
        g = g || this.hdr;
        var c = g.rows[a + 1];
        if (c) {
            c.parentNode.removeChild(c)
        }
        this.setSizes()
    },
    detachFooter: function (a) {
        this.detachHeader(a, this.ftr)
    },
    attachHeader: function (a, h, c) {
        if (typeof (a) == "string") {
            a = this._eSplit(a)
        }
        if (typeof (h) == "string") {
            h = h.split(this.delim)
        }
        c = c || "_aHead";
        if (this.hdr.rows.length) {
            if (a) {
                this._createHRow([a, h], this[(c == "_aHead") ? "hdr" : "ftr"])
            } else {
                if (this[c]) {
                    for (var g = 0; g < this[c].length; g++) {
                        this.attachHeader.apply(this, this[c][g])
                    }
                }
            }
        } else {
            if (!this[c]) {
                this[c] = new Array()
            }
            this[c][this[c].length] = [a, h, c]
        }
    },
    _createHRow: function (g, r) {
        if (!r) {
            if (this.entBox.style.position != "absolute") {
                this.entBox.style.position = "relative"
            }
            var n = document.createElement("DIV");
            n.className = "c_ftr".substr(2);
            this.entBox.appendChild(n);
            var v = document.createElement("TABLE");
            v.cellPadding = v.cellSpacing = 0;
            if (!_isIE || _isIE == 8) {
                v.width = "100%";
                v.style.paddingRight = "20px"
            }
            v.style.marginRight = "20px";
            v.style.tableLayout = "fixed";
            n.appendChild(v);
            v.appendChild(document.createElement("TBODY"));
            this.ftr = r = v;
            var m = v.insertRow(0);
            var a = ((this.hdrLabels.length <= 1) ? g[0].length : this.hdrLabels.length);
            for (var h = 0; h < a; h++) {
                m.appendChild(document.createElement("TH"));
                m.childNodes[h]._cellIndex = h
            }
            if (_isIE && _isIE < 8) {
                m.style.position = "absolute"
            } else {
                m.style.height = "auto"
            }
        }
        var l = g[1];
        var n = document.createElement("TR");
        r.rows[0].parentNode.appendChild(n);
        for (var h = 0; h < g[0].length; h++) {
            if (g[0][h] == "#cspan") {
                var o = n.cells[n.cells.length - 1];
                o.colSpan = (o.colSpan || 1) + 1;
                continue
            }
            if ((g[0][h] == "#rspan") && (r.rows.length > 1)) {
                var y = r.rows.length - 2;
                var x = false;
                var o = null;
                while (!x) {
                    var o = r.rows[y];
                    for (var c = 0; c < o.cells.length; c++) {
                        if (o.cells[c]._cellIndex == h) {
                            x = c + 1;
                            break
                        }
                    }
                    y--
                }
                o = o.cells[x - 1];
                o.rowSpan = (o.rowSpan || 1) + 1;
                continue
            }
            var q = document.createElement("TD");
            q._cellIndex = q._cellIndexS = h;
            if (this._hrrar && this._hrrar[h] && !_isIE) {
                q.style.display = "none"
            }
            if (typeof g[0][h] == "object") {
                q.appendChild(g[0][h])
            } else {
                if (this.forceDivInHeader) {
                    q.innerHTML = "<div class='hdrcell'>" + (g[0][h] || "&nbsp;") + "</div>"
                } else {
                    q.innerHTML = (g[0][h] || "&nbsp;")
                }
                if ((g[0][h] || "").indexOf("#") != -1) {
                    var v = g[0][h].match(/(^|{)#([^}]+)(}|$)/);
                    if (v) {
                        var s = "_in_header_" + v[2];
                        if (this[s]) {
                            this[s]((this.forceDivInHeader ? q.firstChild : q), h, g[0][h].split(v[0]))
                        }
                    }
                }
            }
            if (l) {
                q.style.cssText = l[h]
            }
            n.appendChild(q)
        }
        var u = r;
        if (_isKHTML) {
            if (r._kTimer) {
                window.clearTimeout(r._kTimer)
            }
            r._kTimer = window.setTimeout(function () {
                r.rows[1].style.display = "none";
                window.setTimeout(function () {
                    r.rows[1].style.display = ""
                }, 1)
            }, 500)
        }
    },
    attachFooter: function (a, c) {
        this.attachHeader(a, c, "_aFoot")
    },
    setCellExcellType: function (g, a, c) {
        this.changeCellType(this.getRowById(g), a, c)
    },
    changeCellType: function (g, h, c) {
        c = c || this.cellType[h];
        var j = this.cells3(g, h);
        var a = j.getValue();
        j.cell._cellType = c;
        var j = this.cells3(g, h);
        j.setValue(a)
    },
    setRowExcellType: function (g, c) {
        var h = this.rowsAr[g];
        for (var a = 0; a < h.childNodes.length; a++) {
            this.changeCellType(h, a, c)
        }
    },
    setColumnExcellType: function (a, g) {
        for (var c = 0; c < this.rowsBuffer.length; c++) {
            if (this.rowsBuffer[c] && this.rowsBuffer[c].tagName == "TR") {
                this.changeCellType(this.rowsBuffer[c], a, g)
            }
        }
        if (this.cellType[a] == "math") {
            this._strangeParams[c] = g
        } else {
            this.cellType[a] = g
        }
    },
    forEachRow: function (g) {
        for (var c in this.rowsAr) {
            if (this.rowsAr[c] && this.rowsAr[c].idd) {
                g.apply(this, [this.rowsAr[c].idd])
            }
        }
    },
    forEachRowA: function (g) {
        for (var c = 0; c < this.rowsBuffer.length; c++) {
            if (this.rowsBuffer[c]) {
                g.call(this, this.render_row(c).idd)
            }
        }
    },
    forEachCell: function (g, c) {
        var h = this.getRowById(g);
        if (!h) {
            return
        }
        for (var a = 0; a < this._cCount; a++) {
            c(this.cells3(h, a), a)
        }
    },
    enableAutoWidth: function (g, a, c) {
        this._awdth = [convertStringToBoolean(g), parseInt(a || 99999), parseInt(c || 0)];
        if (arguments.length == 1) {
            this.objBox.style.overflowX = g ? "hidden" : "auto"
        }
    },
    updateFromXML: function (a, h, c, g) {
        if (typeof h == "undefined") {
            h = true
        }
        this._refresh_mode = [true, h, c];
        this.load(a, g)
    },
    _refreshFromXML: function (h) {
        if (this._f_rowsBuffer) {
            this.filterBy(0, "")
        }
        reset = false;
        if (window.eXcell_tree) {
            eXcell_tree.prototype.setValueX = eXcell_tree.prototype.setValue;
            eXcell_tree.prototype.setValue = function (u) {
                var s = this.grid._h2.get[this.cell.parentNode.idd];
                if (s && this.cell.parentNode.valTag) {
                    this.setLabel(u)
                } else {
                    this.setValueX(u)
                }
            }
        }
        var q = this.cellType._dhx_find("tree");
        h.getXMLTopNode("rows");
        var j = h.doXPath("//rows")[0].getAttribute("parent") || 0;
        var m = {};
        if (this._refresh_mode[2]) {
            if (q != -1) {
                this._h2.forEachChild(j, function (r) {
                    m[r.id] = true
                }, this)
            } else {
                this.forEachRow(function (r) {
                    m[r] = true
                })
            }
        }
        var o = h.doXPath("//row");
        for (var g = 0; g < o.length; g++) {
            var n = o[g];
            var a = n.getAttribute("id");
            m[a] = false;
            var j = n.parentNode.getAttribute("id") || j;
            if (this.rowsAr[a] && this.rowsAr[a].tagName != "TR") {
                if (this._h2) {
                    this._h2.get[a].buff.data = n
                } else {
                    this.rowsBuffer[this.getRowIndex(a)].data = n
                }
                this.rowsAr[a] = n
            } else {
                if (this.rowsAr[a]) {
                    this._process_xml_row(this.rowsAr[a], n, -1);
                    this._postRowProcessing(this.rowsAr[a], true);
                    if (this._fake && this._fake.rowsAr[a]) {
                        this._fake._process_xml_row(this._fake.rowsAr[a], n, -1)
                    }
                } else {
                    if (this._refresh_mode[1]) {
                        var l = {
                            idd: a,
                            data: n,
                            _parser: this._process_xml_row,
                            _locator: this._get_xml_data
                        };
                        var c = this.rowsBuffer.length;
                        if (this._refresh_mode[1] == "top") {
                            this.rowsBuffer.unshift(l);
                            c = 0
                        } else {
                            this.rowsBuffer.push(l)
                        }
                        if (this._h2) {
                            reset = true;
                            (this._h2.add(a, (n.parentNode.getAttribute("id") || n.parentNode.getAttribute("parent")))).buff = this.rowsBuffer[this.rowsBuffer.length - 1]
                        } else {
                            if (this._srnd) {
                                reset = true
                            }
                        }
                        this.rowsAr[a] = n;
                        n = this.render_row(c);
                        this._insertRowAt(n, c ? -1 : 0)
                    }
                }
            }
        }
        if (this._refresh_mode[2]) {
            for (a in m) {
                if (m[a] && this.rowsAr[a]) {
                    this.deleteRow(a)
                }
            }
        }
        this._refresh_mode = null;
        if (window.eXcell_tree) {
            eXcell_tree.prototype.setValue = eXcell_tree.prototype.setValueX
        }
        if (reset) {
            if (this._h2) {
                this._renderSort()
            } else {
                this.render_dataset()
            }
        }
        if (this._f_rowsBuffer) {
            this._f_rowsBuffer = null;
            this.filterByAll()
        }
    },
    getCustomCombo: function (g, c) {
        var a = this.cells(g, c).cell;
        if (!a._combo) {
            a._combo = new dhtmlXGridComboObject()
        }
        return a._combo
    },
    setTabOrder: function (c) {
        var h = c.split(this.delim);
        this._tabOrder = [];
        var a = this._cCount || c.length;
        for (var g = 0; g < a; g++) {
            h[g] = {
                c: parseInt(h[g]),
                ind: g
            }
        }
        h.sort(function (l, j) {
            return (l.c > j.c ? 1 : -1)
        });
        for (var g = 0; g < a; g++) {
            if (!h[g + 1] || (typeof h[g].c == "undefined")) {
                this._tabOrder[h[g].ind] = (h[0].ind + 1) * -1
            } else {
                this._tabOrder[h[g].ind] = h[g + 1].ind
            }
        }
    },
    i18n: {
        loading: "Loading",
        decimal_separator: ".",
        group_separator: ","
    },
    _key_events: {
        k13_1_0: function () {
            var a = this.rowsCol._dhx_find(this.row);
            this.selectCell(this.rowsCol[a + 1], this.cell._cellIndex, true)
        },
        k13_0_1: function () {
            var a = this.rowsCol._dhx_find(this.row);
            this.selectCell(this.rowsCol[a - 1], this.cell._cellIndex, true)
        },
        k13_0_0: function () {
            this.editStop();
            this.callEvent("onEnter", [(this.row ? this.row.idd : null), (this.cell ? this.cell._cellIndex : null)]);
            this._still_active = true
        },
        k9_0_0: function () {
            this.editStop();
            if (!this.callEvent("onTab", [true])) {
                return true
            }
            var a = this._getNextCell(null, 1);
            if (a) {
                this.selectCell(a.parentNode, a._cellIndex, (this.row != a.parentNode), false, true);
                this._still_active = true
            }
        },
        k9_0_1: function () {
            this.editStop();
            if (!this.callEvent("onTab", [false])) {
                return false
            }
            var a = this._getNextCell(null, -1);
            if (a) {
                this.selectCell(a.parentNode, a._cellIndex, (this.row != a.parentNode), false, true);
                this._still_active = true
            }
        },
        k113_0_0: function () {
            if (this._f2kE) {
                this.editCell()
            }
        },
        k32_0_0: function () {
            var a = this.cells4(this.cell);
            if (!a.changeState || (a.changeState() === false)) {
                return false
            }
        },
        k27_0_0: function () {
            this.editStop(true)
        },
        k33_0_0: function () {
            if (this.pagingOn) {
                this.changePage(this.currentPage - 1)
            } else {
                this.scrollPage(-1)
            }
        },
        k34_0_0: function () {
            if (this.pagingOn) {
                this.changePage(this.currentPage + 1)
            } else {
                this.scrollPage(1)
            }
        },
        k37_0_0: function () {
            if (!this.editor && this.isTreeGrid()) {
                this.collapseKids(this.row)
            } else {
                return false
            }
        },
        k39_0_0: function () {
            if (!this.editor && this.isTreeGrid()) {
                this.expandKids(this.row)
            } else {
                return false
            }
        },
        k40_0_0: function () {
            var c = this._realfake ? this._fake : this;
            if (this.editor && this.editor.combo) {
                this.editor.shiftNext()
            } else {
                if (!this.row.idd) {
                    return
                }
                var a = Math.max((c._r_select || 0), this.getRowIndex(this.row.idd));
                var g = this._nextRow(a, 1);
                if (g) {
                    c._r_select = null;
                    this.selectCell(g, this.cell._cellIndex, true);
                    if (c.pagingOn) {
                        c.showRow(g.idd)
                    }
                } else {
                    if (!this.callEvent("onLastRow", [])) {
                        return false
                    }
                    this._key_events.k34_0_0.apply(this, []);
                    if (this.pagingOn && this.rowsCol[a + 1]) {
                        this.selectCell(a + 1, 0, true)
                    }
                }
            }
            this._still_active = true
        },
        k38_0_0: function () {
            var c = this._realfake ? this._fake : this;
            if (this.editor && this.editor.combo) {
                this.editor.shiftPrev()
            } else {
                if (!this.row.idd) {
                    return
                }
                var a = this.getRowIndex(this.row.idd) + 1;
                if (a != -1 && (!this.pagingOn || (a != 1))) {
                    var g = this._nextRow(a - 1, -1);
                    this.selectCell(g, this.cell._cellIndex, true);
                    if (c.pagingOn && g) {
                        c.showRow(g.idd)
                    }
                } else {
                    this._key_events.k33_0_0.apply(this, [])
                }
            }
            this._still_active = true
        }
    },
    _build_master_row: function () {
        var g = document.createElement("DIV");
        var c = ["<table><tr>"];
        for (var a = 0; a < this._cCount; a++) {
            c.push("<td></td>")
        }
        c.push("</tr></table>");
        g.innerHTML = c.join("");
        this._master_row = g.firstChild.rows[0]
    },
    _prepareRow: function (a) {
        if (!this._master_row) {
            this._build_master_row()
        }
        var g = this._master_row.cloneNode(true);
        for (var c = 0; c < g.childNodes.length; c++) {
            g.childNodes[c]._cellIndex = c;
            if (this._enbCid) {
                g.childNodes[c].id = "c_" + a + "_" + c
            }
            if (this.dragAndDropOff) {
                this.dragger.addDraggableItem(g.childNodes[c], this)
            }
        }
        g.idd = a;
        g.grid = this;
        return g
    },
    _process_jsarray_row: function (c, g) {
        c._attrs = {};
        for (var a = 0; a < c.childNodes.length; a++) {
            c.childNodes[a]._attrs = {}
        }
        this._fillRow(c, (this._c_order ? this._swapColumns(g) : g));
        return c
    },
    _get_jsarray_data: function (c, a) {
        return c[a]
    },
    _process_json_row: function (a, c) {
        c = this._c_order ? this._swapColumns(c.data) : c.data;
        return this._process_some_row(a, c)
    },
    _process_some_row: function (c, g) {
        c._attrs = {};
        for (var a = 0; a < c.childNodes.length; a++) {
            c.childNodes[a]._attrs = {}
        }
        this._fillRow(c, g);
        return c
    },
    _get_json_data: function (c, a) {
        return c.data[a]
    },
    _process_js_row: function (g, h) {
        var a = [];
        for (var c = 0; c < this.columnIds.length; c++) {
            a[c] = h[this.columnIds[c]];
            if (!a[c] && a[c] !== 0) {
                a[c] = ""
            }
        }
        this._process_some_row(g, a);
        g._attrs = h;
        return g
    },
    _get_js_data: function (c, a) {
        return c[this.columnIds[a]]
    },
    _process_csv_row: function (c, g) {
        c._attrs = {};
        for (var a = 0; a < c.childNodes.length; a++) {
            c.childNodes[a]._attrs = {}
        }
        this._fillRow(c, (this._c_order ? this._swapColumns(g.split(this.csv.cell)) : g.split(this.csv.cell)));
        return c
    },
    _get_csv_data: function (c, a) {
        return c.split(this.csv.cell)[a]
    },
    _process_store_row: function (l, h) {
        var a = [];
        for (var g = 0; g < this.columnIds.length; g++) {
            a[g] = h[this.columnIds[g]]
        }
        for (var c = 0; c < l.childNodes.length; c++) {
            l.childNodes[c]._attrs = {}
        }
        l._attrs = h;
        this._fillRow(l, a)
    },
    _process_xml_row: function (a, m) {
        var u = this.xmlLoader.doXPath(this.xml.cell, m);
        var q = [];
        a._attrs = this._xml_attrs(m);
        if (this._ud_enabled) {
            var s = this.xmlLoader.doXPath("./userdata", m);
            for (var l = s.length - 1; l >= 0; l--) {
                var o = "";
                for (var g = 0; g < s[l].childNodes.length; g++) {
                    o += s[l].childNodes[g].nodeValue
                }
                this.setUserData(a.idd, s[l].getAttribute("name"), o)
            }
        }
        for (var g = 0; g < u.length; g++) {
            var h = u[this._c_order ? this._c_order[g] : g];
            if (!h) {
                continue
            }
            var c = a._childIndexes ? a._childIndexes[g] : g;
            var n = h.getAttribute("type");
            if (a.childNodes[c]) {
                if (n) {
                    a.childNodes[c]._cellType = n
                }
                a.childNodes[c]._attrs = this._xml_attrs(h)
            }
            if (!h.getAttribute("xmlcontent")) {
                if (h.firstChild) {
                    h = h.firstChild.data
                } else {
                    h = ""
                }
            }
            q.push(h)
        }
        for (g < u.length; g < a.childNodes.length; g++) {
            a.childNodes[g]._attrs = {}
        }
        if (a.parentNode && a.parentNode.tagName == "row") {
            a._attrs.parent = a.parentNode.getAttribute("idd")
        }
        this._fillRow(a, q);
        return a
    },
    _get_xml_data: function (c, a) {
        c = c.firstChild;
        while (true) {
            if (!c) {
                return ""
            }
            if (c.tagName == "cell") {
                a--
            }
            if (a < 0) {
                break
            }
            c = c.nextSibling
        }
        return (c.firstChild ? c.firstChild.data : "")
    },
    _fillRow: function (h, l) {
        if (this.editor) {
            this.editStop()
        }
        for (var c = 0; c < h.childNodes.length; c++) {
            if ((c < l.length) || (this.defVal[c])) {
                var g = h.childNodes[c]._cellIndex;
                var j = l[g];
                var a = this.cells4(h.childNodes[c]);
                if ((this.defVal[g]) && ((j == "") || (typeof (j) == "undefined"))) {
                    j = this.defVal[g]
                }
                if (a) {
                    a.setValue(j)
                }
            } else {
                h.childNodes[c].innerHTML = "&nbsp;";
                h.childNodes[c]._clearCell = true
            }
        }
        return h
    },
    _postRowProcessing: function (l, n) {
        if (l._attrs["class"]) {
            l._css = l.className = l._attrs["class"]
        }
        if (l._attrs.locked) {
            l._locked = true
        }
        if (l._attrs.bgColor) {
            l.bgColor = l._attrs.bgColor
        }
        var m = 0;
        for (var g = 0; g < l.childNodes.length; g++) {
            var o = l.childNodes[g];
            var j = o._cellIndex;
            var h = o._attrs.style || l._attrs.style;
            if (h) {
                o.style.cssText += ";" + h
            }
            if (o._attrs["class"]) {
                o.className = o._attrs["class"]
            }
            h = o._attrs.align || this.cellAlign[j];
            if (h) {
                o.align = h
            }
            o.vAlign = o._attrs.valign || this.cellVAlign[j];
            var a = o._attrs.bgColor || this.columnColor[j];
            if (a) {
                o.bgColor = a
            }
            if (o._attrs.colspan && !n) {
                this.setColspan(l.idd, g + m, o._attrs.colspan);
                m += (o._attrs.colspan - 1)
            }
            if (this._hrrar && this._hrrar[j] && !n) {
                o.style.display = "none"
            }
        }
        this.callEvent("onRowCreated", [l.idd, l, null])
    },
    load: function (a, g, c) {
        this.callEvent("onXLS", [this]);
        if (arguments.length == 2 && typeof g != "function") {
            c = g;
            g = null
        }
        c = c || "xml";
        if (!this.xmlFileUrl) {
            this.xmlFileUrl = a
        }
        this._data_type = c;
        this.xmlLoader = new dtmlXMLLoaderObject(this.doLoadDetails, this, true, this.no_cashe);
        this.xmlLoader.onloadAction = function (l, h, n, m, j) {
            if (!l.callEvent) {
                return
            }
            j = l["_process_" + c](j);
            if (!l._contextCallTimer) {
                l.callEvent("onXLE", [l, 0, 0, j])
            }
            if (g) {
                g();
                g = null
            }
        };
        this.xmlLoader.loadXML(a)
    },
    loadXMLString: function (g, c) {
        var a = new dtmlXMLLoaderObject(function () {});
        a.loadXMLString(g);
        this.parse(a, c, "xml")
    },
    loadXML: function (a, c) {
        this.load(a, c, "xml")
    },
    parse: function (g, c, a) {
        if (arguments.length == 2 && typeof c != "function") {
            a = c;
            c = null
        }
        a = a || "xml";
        this._data_type = a;
        g = this["_process_" + a](g);
        if (!this._contextCallTimer) {
            this.callEvent("onXLE", [this, 0, 0, g])
        }
        if (c) {
            c()
        }
    },
    xml: {
        top: "rows",
        row: "./row",
        cell: "./cell",
        s_row: "row",
        s_cell: "cell",
        row_attrs: [],
        cell_attrs: []
    },
    csv: {
        row: "\n",
        cell: ","
    },
    _xml_attrs: function (c) {
        var g = {};
        if (c.attributes.length) {
            for (var a = 0; a < c.attributes.length; a++) {
                g[c.attributes[a].name] = c.attributes[a].value
            }
        }
        return g
    },
    _process_xml: function (j) {
        if (!j.doXPath) {
            var r = new dtmlXMLLoaderObject(function () {});
            if (typeof j == "string") {
                r.loadXMLString(j)
            } else {
                if (j.responseXML) {
                    r.xmlDoc = j
                } else {
                    r.xmlDoc = {}
                }
                r.xmlDoc.responseXML = j
            }
            j = r
        }
        if (this._refresh_mode) {
            return this._refreshFromXML(j)
        }
        this._parsing = true;
        var n = j.getXMLTopNode(this.xml.top);
        if (n.tagName != this.xml.top) {
            return
        }
        var q = n.getAttribute("dhx_security");
        if (q) {
            dhtmlx.security_key = q
        }
        this._parseHead(n);
        var s = j.doXPath(this.xml.row, n);
        var m = parseInt(j.doXPath("//" + this.xml.top)[0].getAttribute("pos") || 0);
        var o = parseInt(j.doXPath("//" + this.xml.top)[0].getAttribute("total_count") || 0);
        var o = Math.min(o, 32000000 / this._srdh);
        var l = false;
        if (o && o != this.rowsBuffer.length) {
            if (!this.rowsBuffer[o - 1]) {
                if (this.rowsBuffer.length) {
                    l = true
                }
                this.rowsBuffer[o - 1] = null
            }
            if (o < this.rowsBuffer.length) {
                this.rowsBuffer.splice(o, this.rowsBuffer.length - o);
                l = true
            }
        }
        if (this.isTreeGrid()) {
            return this._process_tree_xml(j)
        }
        for (var c = 0; c < s.length; c++) {
            if (this.rowsBuffer[c + m]) {
                continue
            }
            var a = s[c].getAttribute("id") || (c + m + 1);
            this.rowsBuffer[c + m] = {
                idd: a,
                data: s[c],
                _parser: this._process_xml_row,
                _locator: this._get_xml_data
            };
            this.rowsAr[a] = s[c]
        }
        this.callEvent("onDataReady", []);
        if (l && this._srnd) {
            var g = this.objBox.scrollTop;
            this._reset_view();
            this.objBox.scrollTop = g
        } else {
            this.render_dataset()
        }
        this._parsing = false;
        return j.xmlDoc.responseXML ? j.xmlDoc.responseXML : j.xmlDoc
    },
    _process_jsarray: function (data) {
        this._parsing = true;
        if (data && data.xmlDoc) {
            eval("dhtmlx.temp=" + data.xmlDoc.responseText + ";");
            data = dhtmlx.temp
        }
        for (var i = 0; i < data.length; i++) {
            var id = i + 1;
            this.rowsBuffer.push({
                idd: id,
                data: data[i],
                _parser: this._process_jsarray_row,
                _locator: this._get_jsarray_data
            });
            this.rowsAr[id] = data[i]
        }
        this.render_dataset();
        this._parsing = false
    },
    _process_csv: function (h) {
        this._parsing = true;
        if (h.xmlDoc) {
            h = h.xmlDoc.responseText
        }
        h = h.replace(/\r/g, "");
        h = h.split(this.csv.row);
        if (this._csvHdr) {
            this.clearAll();
            var g = h.splice(0, 1)[0].split(this.csv.cell);
            if (!this._csvAID) {
                g.splice(0, 1)
            }
            this.setHeader(g.join(this.delim));
            this.init()
        }
        for (var c = 0; c < h.length; c++) {
            if (!h[c] && c == h.length - 1) {
                continue
            }
            if (this._csvAID) {
                var j = c + 1;
                this.rowsBuffer.push({
                    idd: j,
                    data: h[c],
                    _parser: this._process_csv_row,
                    _locator: this._get_csv_data
                })
            } else {
                var a = h[c].split(this.csv.cell);
                var j = a.splice(0, 1)[0];
                this.rowsBuffer.push({
                    idd: j,
                    data: a,
                    _parser: this._process_jsarray_row,
                    _locator: this._get_jsarray_data
                })
            }
            this.rowsAr[j] = h[c]
        }
        this.render_dataset();
        this._parsing = false
    },
    _process_js: function (a) {
        return this._process_json(a, "js")
    },
    _process_json: function (data, mode) {
        this._parsing = true;
        if (data && data.xmlDoc) {
            eval("dhtmlx.temp=" + data.xmlDoc.responseText + ";");
            data = dhtmlx.temp
        }
        if (mode == "js") {
            if (data.data) {
                data = data.data
            }
            for (var i = 0; i < data.length; i++) {
                var row = data[i];
                var id = row.id || (i + 1);
                this.rowsBuffer.push({
                    idd: id,
                    data: row,
                    _parser: this._process_js_row,
                    _locator: this._get_js_data
                });
                this.rowsAr[id] = data[i]
            }
        } else {
            for (var i = 0; i < data.rows.length; i++) {
                var id = data.rows[i].id;
                this.rowsBuffer.push({
                    idd: id,
                    data: data.rows[i],
                    _parser: this._process_json_row,
                    _locator: this._get_json_data
                });
                this.rowsAr[id] = data.rows[i]
            }
        }
        if (data.dhx_security) {
            dhtmlx.security_key = data.dhx_security
        }
        this.render_dataset();
        this._parsing = false
    },
    render_dataset: function (h, a) {
        if (this._srnd) {
            if (this._fillers) {
                return this._update_srnd_view()
            }
            a = Math.min((this._get_view_size() + (this._srnd_pr || 0)), this.rowsBuffer.length)
        }
        if (this.pagingOn) {
            h = Math.max((h || 0), (this.currentPage - 1) * this.rowsBufferOutSize);
            a = Math.min(this.currentPage * this.rowsBufferOutSize, this.rowsBuffer.length)
        } else {
            h = h || 0;
            a = a || this.rowsBuffer.length
        }
        for (var g = h; g < a; g++) {
            var l = this.render_row(g);
            if (l == -1) {
                if (this.xmlFileUrl) {
                    if (this.callEvent("onDynXLS", [g, (this._dpref ? this._dpref : (a - g))])) {
                        this.load(this.xmlFileUrl + getUrlSymbol(this.xmlFileUrl) + "posStart=" + g + "&count=" + (this._dpref ? this._dpref : (a - g)), this._data_type)
                    }
                }
                a = g;
                break
            }
            if (!l.parentNode || !l.parentNode.tagName) {
                this._insertRowAt(l, g);
                if (l._attrs.selected || l._attrs.select) {
                    this.selectRow(l, l._attrs.call ? true : false, true);
                    l._attrs.selected = l._attrs.select = null
                }
            }
            if (this._ads_count && g - h == this._ads_count) {
                var j = this;
                this._context_parsing = this._context_parsing || this._parsing;
                return this._contextCallTimer = window.setTimeout(function () {
                    j._contextCallTimer = null;
                    j.render_dataset(g, a);
                    if (!j._contextCallTimer) {
                        if (j._context_parsing) {
                            j.callEvent("onXLE", [])
                        } else {
                            j._fixAlterCss()
                        }
                        j.callEvent("onDistributedEnd", []);
                        j._context_parsing = false
                    }
                }, this._ads_time)
            }
        }
        if (this._ads_count && g == a) {
            this.callEvent("onDistributedEnd", [])
        }
        if (this._srnd && !this._fillers) {
            var c = this.rowsBuffer.length - a;
            this._fillers = [];
            if (this._fake) {
                this._fake._fillers = []
            }
            while (c > 0) {
                var n = (_isIE || window._FFrv) ? Math.min(c, 50000) : c;
                var m = this._add_filler(a, n);
                if (m) {
                    this._fillers.push(m)
                }
                c -= n;
                a += n
            }
        }
        this.setSizes()
    },
    render_row: function (c) {
        if (!this.rowsBuffer[c]) {
            return -1
        }
        if (this.rowsBuffer[c]._parser) {
            var a = this.rowsBuffer[c];
            if (this.rowsAr[a.idd] && this.rowsAr[a.idd].tagName == "TR") {
                return this.rowsBuffer[c] = this.rowsAr[a.idd]
            }
            var g = this._prepareRow(a.idd);
            this.rowsBuffer[c] = g;
            this.rowsAr[a.idd] = g;
            a._parser.call(this, g, a.data);
            this._postRowProcessing(g);
            return g
        }
        return this.rowsBuffer[c]
    },
    _get_cell_value: function (c, a, g) {
        if (c._locator) {
            if (this._c_order) {
                a = this._c_order[a]
            }
            return c._locator.call(this, c.data, a)
        }
        return this.cells3(c, a)[g ? g : "getValue"]()
    },
    sortRows: function (g, l, c) {
        this.editStop();
        c = (c || "asc").toLowerCase();
        l = (l || this.fldSort[g]);
        g = g || 0;
        if (this.isTreeGrid()) {
            this.sortTreeRows(g, l, c)
        } else {
            var a = {};
            var j = this.cellType[g];
            var m = "getValue";
            if (j == "link") {
                m = "getContent"
            }
            if (j == "dhxCalendar" || j == "dhxCalendarA") {
                m = "getDate"
            }
            for (var h = 0; h < this.rowsBuffer.length; h++) {
                a[this.rowsBuffer[h].idd] = this._get_cell_value(this.rowsBuffer[h], g, m)
            }
            this._sortRows(g, l, c, a)
        }
        this.callEvent("onAfterSorting", [g, l, c])
    },
    _sortCore: function (g, l, c, a, j) {
        var h = "sort";
        if (this._sst) {
            j.stablesort = this.rowsCol.stablesort;
            h = "stablesort"
        }
        if (l.length > 4) {
            l = window[l]
        }
        if (l == "cus") {
            var m = this._customSorts[g];
            j[h](function (o, n) {
                return m(a[o.idd], a[n.idd], c, o.idd, n.idd)
            })
        } else {
            if (typeof (l) == "function") {
                j[h](function (o, n) {
                    return l(a[o.idd], a[n.idd], c, o.idd, n.idd)
                })
            } else {
                if (l == "str") {
                    j[h](function (o, n) {
                        if (c == "asc") {
                            return a[o.idd] > a[n.idd] ? 1 : (a[o.idd] < a[n.idd] ? -1 : 0)
                        } else {
                            return a[o.idd] < a[n.idd] ? 1 : (a[o.idd] > a[n.idd] ? -1 : 0)
                        }
                    })
                } else {
                    if (l == "int") {
                        j[h](function (q, o) {
                            var n = parseFloat(a[q.idd]);
                            n = isNaN(n) ? -99999999999999 : n;
                            var r = parseFloat(a[o.idd]);
                            r = isNaN(r) ? -99999999999999 : r;
                            if (c == "asc") {
                                return n - r
                            } else {
                                return r - n
                            }
                        })
                    } else {
                        if (l == "date") {
                            j[h](function (q, o) {
                                var n = Date.parse(a[q.idd]) || (Date.parse("01/01/1900"));
                                var r = Date.parse(a[o.idd]) || (Date.parse("01/01/1900"));
                                if (c == "asc") {
                                    return n - r
                                } else {
                                    return r - n
                                }
                            })
                        }
                    }
                }
            }
        }
    },
    _sortRows: function (g, h, c, a) {
        this._sortCore(g, h, c, a, this.rowsBuffer);
        this._reset_view();
        this.callEvent("onGridReconstructed", [])
    },
    _reset_view: function (g) {
        if (!this.obj.rows[0]) {
            return
        }
        if (this._lahRw) {
            this._unsetRowHover(0, true)
        }
        this.callEvent("onResetView", []);
        var a = this.obj.rows[0].parentNode;
        var h = a.removeChild(a.childNodes[0], true);
        if (_isKHTML) {
            for (var c = a.parentNode.childNodes.length - 1; c >= 0; c--) {
                if (a.parentNode.childNodes[c].tagName == "TR") {
                    a.parentNode.removeChild(a.parentNode.childNodes[c], true)
                }
            }
        } else {
            if (_isIE) {
                for (var c = a.childNodes.length - 1; c >= 0; c--) {
                    a.childNodes[c].removeNode(true)
                }
            } else {
                a.innerHTML = ""
            }
        }
        a.appendChild(h);
        this.rowsCol = dhtmlxArray();
        if (this._sst) {
            this.enableStableSorting(true)
        }
        this._fillers = this.undefined;
        if (!g) {
            if (_isIE && this._srnd) {
                this.render_dataset()
            } else {
                this.render_dataset()
            }
        }
    },
    deleteRow: function (c, h) {
        if (!h) {
            h = this.getRowById(c)
        }
        if (!h) {
            return
        }
        this.editStop();
        if (!this._realfake) {
            if (this.callEvent("onBeforeRowDeleted", [c]) == false) {
                return false
            }
        }
        var a = 0;
        if (this.cellType._dhx_find("tree") != -1 && !this._realfake) {
            a = this._h2.get[c].parent.id;
            this._removeTrGrRow(h)
        } else {
            if (h.parentNode) {
                h.parentNode.removeChild(h)
            }
            var l = this.rowsCol._dhx_find(h);
            if (l != -1) {
                this.rowsCol._dhx_removeAt(l)
            }
            for (var g = 0; g < this.rowsBuffer.length; g++) {
                if (this.rowsBuffer[g] && this.rowsBuffer[g].idd == c) {
                    this.rowsBuffer._dhx_removeAt(g);
                    l = g;
                    break
                }
            }
        }
        this.rowsAr[c] = null;
        for (var g = 0; g < this.selectedRows.length; g++) {
            if (this.selectedRows[g].idd == c) {
                this.selectedRows._dhx_removeAt(g)
            }
        }
        if (this._srnd) {
            for (var g = 0; g < this._fillers.length; g++) {
                var j = this._fillers[g];
                if (!j) {
                    continue
                }
                if (j[0] >= l) {
                    this._update_fillers(g, 0, -1)
                } else {
                    if (j[0] + j[1] > l) {
                        this._update_fillers(g, -1, 0)
                    }
                }
            }
            this._update_srnd_view()
        }
        if (this.pagingOn) {
            this.changePage()
        }
        if (!this._realfake) {
            this.callEvent("onAfterRowDeleted", [c, a])
        }
        this.callEvent("onGridReconstructed", []);
        if (this._ahgr) {
            this.setSizes()
        }
        return true
    },
    _addRow: function (m, n, c) {
        if (c == -1 || typeof c == "undefined") {
            c = this.rowsBuffer.length
        }
        if (typeof n == "string") {
            n = n.split(this.delim)
        }
        var o = this._prepareRow(m);
        o._attrs = {};
        for (var g = 0; g < o.childNodes.length; g++) {
            o.childNodes[g]._attrs = {}
        }
        this.rowsAr[o.idd] = o;
        if (this._h2) {
            this._h2.get[o.idd].buff = o
        }
        this._fillRow(o, n);
        this._postRowProcessing(o);
        if (this._skipInsert) {
            this._skipInsert = false;
            return this.rowsAr[o.idd] = o
        }
        if (this.pagingOn) {
            this.rowsBuffer._dhx_insertAt(c, o);
            this.rowsAr[o.idd] = o;
            return o
        }
        if (this._fillers) {
            this.rowsCol._dhx_insertAt(c, null);
            this.rowsBuffer._dhx_insertAt(c, o);
            if (this._fake) {
                this._fake.rowsCol._dhx_insertAt(c, null)
            }
            this.rowsAr[o.idd] = o;
            var q = false;
            for (var h = 0; h < this._fillers.length; h++) {
                var l = this._fillers[h];
                if (l && l[0] <= c && (l[0] + l[1]) >= c) {
                    l[1] = l[1] + 1;
                    var a = l[2].firstChild.style.height = parseInt(l[2].firstChild.style.height) + this._srdh + "px";
                    q = true;
                    if (this._fake) {
                        this._fake._fillers[h][1]++;
                        this._fake._fillers[h][2].firstChild.style.height = a
                    }
                }
                if (l && l[0] > c) {
                    l[0] = l[0] + 1;
                    if (this._fake) {
                        this._fake._fillers[h][0]++
                    }
                }
            }
            if (!q) {
                this._fillers.push(this._add_filler(c, 1, (c == 0 ? {
                    parentNode: this.obj.rows[0].parentNode,
                    nextSibling: (this.rowsCol[1])
                } : this.rowsCol[c - 1])))
            }
            return o
        }
        this.rowsBuffer._dhx_insertAt(c, o);
        return this._insertRowAt(o, c)
    },
    addRow: function (a, h, g) {
        var c = this._addRow(a, h, g);
        if (!this.dragContext) {
            this.callEvent("onRowAdded", [a])
        }
        if (this.pagingOn) {
            this.changePage(this.currentPage)
        }
        if (this._srnd) {
            this._update_srnd_view()
        }
        c._added = true;
        if (this._ahgr) {
            this.setSizes()
        }
        this.callEvent("onGridReconstructed", []);
        return c
    },
    _insertRowAt: function (g, h, c) {
        this.rowsAr[g.idd] = g;
        if (this._skipInsert) {
            this._skipInsert = false;
            return g
        }
        if ((h < 0) || ((!h) && (parseInt(h) !== 0))) {
            h = this.rowsCol.length
        } else {
            if (h > this.rowsCol.length) {
                h = this.rowsCol.length
            }
        }
        if (this._cssEven) {
            var a = g.className.replace(this._cssUnEven, "");
            if ((this._cssSP ? this.getLevel(g.idd) : h) % 2 == 1) {
                g.className = a + " " + this._cssUnEven + (this._cssSU ? (" " + this._cssUnEven + "_" + this.getLevel(g.idd)) : "")
            } else {
                g.className = a + " " + this._cssEven + (this._cssSU ? (" " + this._cssEven + "_" + this.getLevel(g.idd)) : "")
            }
        }
        if (!c) {
            if ((h == (this.obj.rows.length - 1)) || (!this.rowsCol[h])) {
                if (_isKHTML) {
                    this.obj.appendChild(g)
                } else {
                    this.obj.firstChild.appendChild(g)
                }
            } else {
                this.rowsCol[h].parentNode.insertBefore(g, this.rowsCol[h])
            }
        }
        this.rowsCol._dhx_insertAt(h, g);
        this.callEvent("onRowInserted", [g, h]);
        return g
    },
    getRowById: function (g) {
        var c = this.rowsAr[g];
        if (c) {
            if (c.tagName != "TR") {
                for (var a = 0; a < this.rowsBuffer.length; a++) {
                    if (this.rowsBuffer[a] && this.rowsBuffer[a].idd == g) {
                        return this.render_row(a)
                    }
                }
                if (this._h2) {
                    return this.render_row(null, c.idd)
                }
            }
            return c
        }
        return null
    },
    cellById: function (c, a) {
        return this.cells(c, a)
    },
    cells: function (h, g) {
        if (arguments.length == 0) {
            return this.cells4(this.cell)
        } else {
            var j = this.getRowById(h)
        }
        var a = (j._childIndexes ? j.childNodes[j._childIndexes[g]] : j.childNodes[g]);
        if (!a && j._childIndexes) {
            a = j.firstChild || {}
        }
        return this.cells4(a)
    },
    cellByIndex: function (c, a) {
        return this.cells2(c, a)
    },
    cells2: function (h, g) {
        var j = this.render_row(h);
        var a = (j._childIndexes ? j.childNodes[j._childIndexes[g]] : j.childNodes[g]);
        if (!a && j._childIndexes) {
            a = j.firstChild || {}
        }
        return this.cells4(a)
    },
    cells3: function (g, c) {
        var a = (g._childIndexes ? g.childNodes[g._childIndexes[c]] : g.childNodes[c]);
        return this.cells4(a)
    },
    cells4: function (a) {
        var c = window["eXcell_" + (a._cellType || this.cellType[a._cellIndex])];
        if (c) {
            return new c(a)
        }
    },
    cells5: function (a, g) {
        var g = g || (a._cellType || this.cellType[a._cellIndex]);
        if (!this._ecache[g]) {
            if (!window["eXcell_" + g]) {
                var c = eXcell_ro
            } else {
                var c = window["eXcell_" + g]
            }
            this._ecache[g] = new c(a)
        }
        this._ecache[g].cell = a;
        return this._ecache[g]
    },
    dma: function (a) {
        if (!this._ecache) {
            this._ecache = {}
        }
        if (a && !this._dma) {
            this._dma = this.cells4;
            this.cells4 = this.cells5
        } else {
            if (!a && this._dma) {
                this.cells4 = this._dma;
                this._dma = null
            }
        }
    },
    getRowsNum: function () {
        return this.rowsBuffer.length
    },
    enableEditTabOnly: function (a) {
        if (arguments.length > 0) {
            this.smartTabOrder = convertStringToBoolean(a)
        } else {
            this.smartTabOrder = true
        }
    },
    setExternalTabOrder: function (j, a) {
        var c = this;
        this.tabStart = (typeof (j) == "object") ? j : document.getElementById(j);
        var g = this.tabStart.onkeydown;
        this.tabStart.onkeydown = function (m) {
            if (g) {
                g.call(this, m)
            }
            var l = (m || window.event);
            if (l.keyCode == 9 && !l.shiftKey) {
                l.cancelBubble = true;
                c.selectCell(0, 0, 0, 0, 1);
                if (c.smartTabOrder && c.cells2(0, 0).isDisabled()) {
                    c._key_events.k9_0_0.call(c)
                }
                this.blur();
                return false
            }
        };
        if (_isOpera) {
            this.tabStart.onkeypress = this.tabStart.onkeydown
        }
        this.tabEnd = (typeof (a) == "object") ? a : document.getElementById(a);
        var h = this.tabEnd.onkeydown;
        this.tabEnd.onkeydown = this.tabEnd.onkeypress = function (m) {
            if (h) {
                h.call(this, m)
            }
            var l = (m || window.event);
            if (l.keyCode == 9 && l.shiftKey) {
                l.cancelBubble = true;
                c.selectCell((c.getRowsNum() - 1), (c.getColumnCount() - 1), 0, 0, 1);
                if (c.smartTabOrder && c.cells2((c.getRowsNum() - 1), (c.getColumnCount() - 1)).isDisabled()) {
                    c._key_events.k9_0_1.call(c)
                }
                this.blur();
                return false
            }
        };
        if (_isOpera) {
            this.tabEnd.onkeypress = this.tabEnd.onkeydown
        }
    },
    uid: function () {
        if (!this._ui_seed) {
            this._ui_seed = (new Date()).valueOf()
        }
        return this._ui_seed++
    },
    clearAndLoad: function () {
        var a = this._pgn_skin;
        this._pgn_skin = null;
        this.clearAll();
        this._pgn_skin = a;
        this.load.apply(this, arguments)
    },
    getStateOfView: function () {
        if (this.pagingOn) {
            var a = (this.currentPage - 1) * this.rowsBufferOutSize;
            return [this.currentPage, a, Math.min(a + this.rowsBufferOutSize, this.rowsBuffer.length), this.rowsBuffer.length]
        }
        return [Math.floor(this.objBox.scrollTop / this._srdh), Math.ceil(parseInt(this.objBox.offsetHeight) / this._srdh), this.rowsBuffer.length]
    }
};
(function () {
    function h(m, n) {
        this[m] = n
    }
    function l(m, n) {
        this[m].call(this, n)
    }
    function g(m, n) {
        this[m].call(this, n.join(this.delim))
    }
    function a(m, q) {
        for (var o = 0; o < q.length; o++) {
            if (typeof q[o] == "object") {
                var r = this.getCombo(o);
                for (var n in q[o]) {
                    r.put(n, q[o][n])
                }
            }
        }
    }
    function j(m, v, q) {
        var x = 1;
        var u = [];

        function w(A, y, C) {
            if (!u[y]) {
                u[y] = []
            }
            if (typeof C == "object") {
                C.toString = function () {
                    return this.text
                }
            }
            u[y][A] = C
        }
        for (var r = 0; r < v.length; r++) {
            if (typeof (v[r]) == "object" && v[r].length) {
                for (var o = 0; o < v[r].length; o++) {
                    w(r, o, v[r][o])
                }
            } else {
                w(r, 0, v[r])
            }
        }
        for (var r = 0; r < u.length; r++) {
            for (var o = 0; o < u[0].length; o++) {
                var s = u[r][o];
                u[r][o] = (s || "").toString() || "&nbsp;";
                if (s && s.colspan) {
                    for (var n = 1; n < s.colspan; n++) {
                        w(o + n, r, "#cspan")
                    }
                }
                if (s && s.rowspan) {
                    for (var n = 1; n < s.rowspan; n++) {
                        w(o, r + n, "#rspan")
                    }
                }
            }
        }
        this.setHeader(u[0]);
        for (var r = 1; r < u.length; r++) {
            this.attachHeader(u[r])
        }
    }
    var c = [{
        name: "label",
        def: "&nbsp;",
        operation: "setHeader",
        type: j
    }, {
        name: "id",
        def: "",
        operation: "columnIds",
        type: h
    }, {
        name: "width",
        def: "*",
        operation: "setInitWidths",
        type: g
    }, {
        name: "align",
        def: "left",
        operation: "cellAlign",
        type: h
    }, {
        name: "valign",
        def: "middle",
        operation: "cellVAlign",
        type: h
    }, {
        name: "sort",
        def: "na",
        operation: "fldSort",
        type: h
    }, {
        name: "type",
        def: "ro",
        operation: "setColTypes",
        type: g
    }, {
        name: "options",
        def: "",
        operation: "",
        type: a
    }];
    dhtmlx.extend_api("dhtmlXGridObject", {
        _init: function (m) {
            return [m.parent]
        },
        image_path: "setImagePath",
        columns: "columns",
        rows: "rows",
        headers: "headers",
        skin: "setSkin",
        smart_rendering: "enableSmartRendering",
        css: "enableAlterCss",
        auto_height: "enableAutoHeight",
        save_hidden: "enableAutoHiddenColumnsSaving",
        save_cookie: "enableAutoSaving",
        save_size: "enableAutoSizeSaving",
        auto_width: "enableAutoWidth",
        block_selection: "enableBlockSelection",
        csv_id: "enableCSVAutoID",
        csv_header: "enableCSVHeader",
        cell_ids: "enableCellIds",
        colspan: "enableColSpan",
        column_move: "enableColumnMove",
        context_menu: "enableContextMenu",
        distributed: "enableDistributedParsing",
        drag: "enableDragAndDrop",
        drag_order: "enableDragOrder",
        tabulation: "enableEditTabOnly",
        header_images: "enableHeaderImages",
        header_menu: "enableHeaderMenu",
        keymap: "enableKeyboardSupport",
        mouse_navigation: "enableLightMouseNavigation",
        markers: "enableMarkedCells",
        math_editing: "enableMathEditing",
        math_serialization: "enableMathSerialization",
        drag_copy: "enableMercyDrag",
        multiline: "enableMultiline",
        multiselect: "enableMultiselect",
        save_column_order: "enableOrderSaving",
        hover: "enableRowsHover",
        rowspan: "enableRowspan",
        smart: "enableSmartRendering",
        save_sorting: "enableSortingSaving",
        stable_sorting: "enableStableSorting",
        undo: "enableUndoRedo",
        csv_cell: "setCSVDelimiter",
        date_format: "setDateFormat",
        drag_behavior: "setDragBehavior",
        editable: "setEditable",
        without_header: "setNoHeader",
        submit_changed: "submitOnlyChanged",
        submit_serialization: "submitSerialization",
        submit_selected: "submitOnlySelected",
        submit_id: "submitOnlyRowID",
        xml: "load"
    }, {
        columns: function (r) {
            for (var m = 0; m < c.length; m++) {
                var q = [];
                for (var n = 0; n < r.length; n++) {
                    q[n] = r[n][c[m].name] || c[m].def
                }
                var o = c[m].type || l;
                o.call(this, c[m].operation, q, r)
            }
            this.init()
        },
        rows: function (m) {},
        headers: function (n) {
            for (var m = 0; m < n.length; m++) {
                this.attachHeader(n[m])
            }
        }
    })
})();
dhtmlXGridObject.prototype._dp_init = function (a) {
    a.attachEvent("insertCallback", function (c, h) {
        if (this.obj._h2) {
            this.obj.addRow(h, g, null, parent)
        } else {
            this.obj.addRow(h, [], 0)
        }
        var g = this.obj.getRowById(h);
        if (g) {
            this.obj._process_xml_row(g, c.firstChild);
            this.obj._postRowProcessing(g)
        }
    });
    a.attachEvent("updateCallback", function (c, h) {
        var g = this.obj.getRowById(h);
        if (g) {
            this.obj._process_xml_row(g, c.firstChild);
            this.obj._postRowProcessing(g)
        }
    });
    a.attachEvent("deleteCallback", function (c, g) {
        this.obj.setUserData(g, this.action_param, "true_deleted");
        this.obj.deleteRow(g)
    });
    a._methods = ["setRowTextStyle", "setCellTextStyle", "changeRowId", "deleteRow"];
    this.attachEvent("onEditCell", function (h, j, g) {
        if (a._columns && !a._columns[g]) {
            return true
        }
        var c = this.cells(j, g);
        if (h == 1) {
            if (c.isCheckbox()) {
                a.setUpdated(j, true)
            }
        } else {
            if (h == 2) {
                if (c.wasChanged()) {
                    a.setUpdated(j, true)
                }
            }
        }
        return true
    });
    this.attachEvent("onRowPaste", function (c) {
        a.setUpdated(c, true)
    });
    this.attachEvent("onUndo", function (c) {
        a.setUpdated(c, true)
    });
    this.attachEvent("onRowIdChange", function (h, c) {
        var g = a.findRow(h);
        if (g < a.updatedRows.length) {
            a.updatedRows[g] = c
        }
    });
    this.attachEvent("onSelectStateChanged", function (c) {
        if (a.updateMode == "row") {
            a.sendData()
        }
        return true
    });
    this.attachEvent("onEnter", function (g, c) {
        if (a.updateMode == "row") {
            a.sendData()
        }
        return true
    });
    this.attachEvent("onBeforeRowDeleted", function (c) {
        if (!this.rowsAr[c]) {
            return true
        }
        if (this.dragContext && a.dnd) {
            window.setTimeout(function () {
                a.setUpdated(c, true)
            }, 1);
            return true
        }
        var g = a.getState(c);
        if (this._h2) {
            this._h2.forEachChild(c, function (h) {
                a.setUpdated(h.id, false);
                a.markRow(h.id, true, "deleted")
            }, this)
        }
        if (g == "inserted") {
            a.set_invalid(c, false);
            a.setUpdated(c, false);
            return true
        }
        if (g == "deleted") {
            return false
        }
        if (g == "true_deleted") {
            a.setUpdated(c, false);
            return true
        }
        a.setUpdated(c, true, "deleted");
        return false
    });
    this.attachEvent("onBindUpdate", function (c) {
        if (typeof c == "object") {
            c = c.id
        }
        a.setUpdated(c, true)
    });
    this.attachEvent("onRowAdded", function (c) {
        if (this.dragContext && a.dnd) {
            return true
        }
        a.setUpdated(c, true, "inserted");
        return true
    });
    a._getRowData = function (h, u) {
        var n = [];
        n.gr_id = h;
        if (this.obj.isTreeGrid()) {
            n.gr_pid = this.obj.getParentId(h)
        }
        var g = this.obj.getRowById(h);
        for (var o = 0; o < this.obj._cCount; o++) {
            if (this.obj._c_order) {
                var q = this.obj._c_order[o]
            } else {
                var q = o
            }
            var s = this.obj.cells(g.idd, o);
            if (this._changed && !s.wasChanged()) {
                continue
            }
            if (this._endnm) {
                n[this.obj.getColumnId(o)] = s.getValue()
            } else {
                n["c" + q] = s.getValue()
            }
        }
        var l = this.obj.UserData[h];
        if (l) {
            for (var m = 0; m < l.keys.length; m++) {
                if (l.keys[m] && l.keys[m].indexOf("__") != 0) {
                    n[l.keys[m]] = l.values[m]
                }
            }
        }
        var l = this.obj.UserData.gridglobaluserdata;
        if (l) {
            for (var m = 0; m < l.keys.length; m++) {
                n[l.keys[m]] = l.values[m]
            }
        }
        return n
    };
    a._clearUpdateFlag = function (g) {
        var h = this.obj.getRowById(g);
        if (h) {
            for (var c = 0; c < this.obj._cCount; c++) {
                this.obj.cells(g, c).cell.wasChanged = false
            }
        }
    };
    a.checkBeforeUpdate = function (l) {
        var j = true;
        var c = [];
        for (var h = 0; h < this.obj._cCount; h++) {
            if (this.mandatoryFields[h]) {
                var g = this.mandatoryFields[h].call(this.obj, this.obj.cells(l, h).getValue(), l, h);
                if (typeof g == "string") {
                    this.messages.push(g);
                    j = false
                } else {
                    j &= g;
                    c[h] = !g
                }
            }
        }
        if (!j) {
            this.set_invalid(l, "invalid", c);
            this.setUpdated(l, false)
        }
        return j
    }
};

function dhtmlXGridCellObject(a) {
    this.destructor = function () {
        this.cell.obj = null;
        this.cell = null;
        this.grid = null;
        this.base = null;
        return null
    };
    this.cell = a;
    this.getValue = function () {
        if ((this.cell.firstChild) && (this.cell.firstChild.tagName == "TEXTAREA")) {
            return this.cell.firstChild.value
        } else {
            return this.cell.innerHTML._dhx_trim()
        }
    };
    this.getMathValue = function () {
        if (this.cell.original) {
            return this.cell.original
        } else {
            return this.getValue()
        }
    };
    this.getFont = function () {
        arOut = new Array(3);
        if (this.cell.style.fontFamily) {
            arOut[0] = this.cell.style.fontFamily
        }
        if (this.cell.style.fontWeight == "bold" || this.cell.parentNode.style.fontWeight == "bold") {
            arOut[1] = "bold"
        }
        if (this.cell.style.fontStyle == "italic" || this.cell.parentNode.style.fontWeight == "italic") {
            arOut[1] += "italic"
        }
        if (this.cell.style.fontSize) {
            arOut[2] = this.cell.style.fontSize
        } else {
            arOut[2] = ""
        }
        return arOut.join("-")
    };
    this.getTextColor = function () {
        if (this.cell.style.color) {
            return this.cell.style.color
        } else {
            return "#000000"
        }
    };
    this.getBgColor = function () {
        if (this.cell.bgColor) {
            return this.cell.bgColor
        } else {
            return "#FFFFFF"
        }
    };
    this.getHorAlign = function () {
        if (this.cell.style.textAlign) {
            return this.cell.style.textAlign
        } else {
            if (this.cell.style.textAlign) {
                return this.cell.style.textAlign
            } else {
                return "left"
            }
        }
    };
    this.getWidth = function () {
        return this.cell.scrollWidth
    };
    this.setFont = function (c) {
        fntAr = c.split("-");
        this.cell.style.fontFamily = fntAr[0];
        this.cell.style.fontSize = fntAr[fntAr.length - 1];
        if (fntAr.length == 3) {
            if (/bold/.test(fntAr[1])) {
                this.cell.style.fontWeight = "bold"
            }
            if (/italic/.test(fntAr[1])) {
                this.cell.style.fontStyle = "italic"
            }
            if (/underline/.test(fntAr[1])) {
                this.cell.style.textDecoration = "underline"
            }
        }
    };
    this.setTextColor = function (c) {
        this.cell.style.color = c
    };
    this.setBgColor = function (c) {
        if (c == "") {
            c = null
        }
        this.cell.bgColor = c
    };
    this.setHorAlign = function (c) {
        if (c.length == 1) {
            if (c == "c") {
                this.cell.style.textAlign = "center"
            } else {
                if (c == "l") {
                    this.cell.style.textAlign = "left"
                } else {
                    this.cell.style.textAlign = "right"
                }
            }
        } else {
            this.cell.style.textAlign = c
        }
    };
    this.wasChanged = function () {
        if (this.cell.wasChanged) {
            return true
        } else {
            return false
        }
    };
    this.isCheckbox = function () {
        var c = this.cell.firstChild;
        if (c && c.tagName == "INPUT") {
            type = c.type;
            if (type == "radio" || type == "checkbox") {
                return true
            } else {
                return false
            }
        } else {
            return false
        }
    };
    this.isChecked = function () {
        if (this.isCheckbox()) {
            return this.cell.firstChild.checked
        }
    };
    this.isDisabled = function () {
        return this.cell._disabled
    };
    this.setChecked = function (c) {
        if (this.isCheckbox()) {
            if (c != "true" && c != 1) {
                c = false
            }
            this.cell.firstChild.checked = c
        }
    };
    this.setDisabled = function (c) {
        if (c != "true" && c != 1) {
            c = false
        }
        if (this.isCheckbox()) {
            this.cell.firstChild.disabled = c;
            if (this.disabledF) {
                this.disabledF(c)
            }
        }
        this.cell._disabled = c
    }
}
dhtmlXGridCellObject.prototype = {
    getAttribute: function (a) {
        return this.cell._attrs[a]
    },
    setAttribute: function (a, c) {
        this.cell._attrs[a] = c
    },
    getInput: function () {
        if (this.obj && (this.obj.tagName == "INPUT" || this.obj.tagName == "TEXTAREA")) {
            return this.obj
        }
        var a = (this.obj || this.cell).getElementsByTagName("TEXTAREA");
        if (!a.length) {
            a = (this.obj || this.cell).getElementsByTagName("INPUT")
        }
        return a[0]
    }
};
dhtmlXGridCellObject.prototype.setValue = function (a) {
    if ((typeof (a) != "number") && (!a || a.toString()._dhx_trim() == "")) {
        a = "&nbsp;";
        this.cell._clearCell = true
    } else {
        this.cell._clearCell = false
    }
    this.setCValue(a)
};
dhtmlXGridCellObject.prototype.getTitle = function () {
    return (_isIE ? this.cell.innerText : this.cell.textContent)
};
dhtmlXGridCellObject.prototype.setCValue = function (c, a) {
    this.cell.innerHTML = c;
    this.grid.callEvent("onCellChanged", [this.cell.parentNode.idd, this.cell._cellIndex, (arguments.length > 1 ? a : c)])
};
dhtmlXGridCellObject.prototype.setCTxtValue = function (a) {
    this.cell.innerHTML = "";
    this.cell.appendChild(document.createTextNode(a));
    this.grid.callEvent("onCellChanged", [this.cell.parentNode.idd, this.cell._cellIndex, a])
};
dhtmlXGridCellObject.prototype.setLabel = function (a) {
    this.cell.innerHTML = a
};
dhtmlXGridCellObject.prototype.getMath = function () {
    if (this._val) {
        return this.val
    } else {
        return this.getValue()
    }
};

function eXcell() {
    this.obj = null;
    this.val = null;
    this.changeState = function () {
        return false
    };
    this.edit = function () {
        this.val = this.getValue()
    };
    this.detach = function () {
        return false
    };
    this.getPosition = function (h) {
        var a = h;
        var g = 0;
        var c = 0;
        while (a.tagName != "BODY") {
            g += a.offsetLeft;
            c += a.offsetTop;
            a = a.offsetParent
        }
        return new Array(g, c)
    }
}
eXcell.prototype = new dhtmlXGridCellObject;

function eXcell_ed(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    }
    this.edit = function () {
        this.cell.atag = ((!this.grid.multiLine) && (_isKHTML || _isMacOS || _isFF)) ? "INPUT" : "TEXTAREA";
        this.val = this.getValue();
        this.obj = document.createElement(this.cell.atag);
        this.obj.setAttribute("autocomplete", "off");
        this.obj.style.height = (this.cell.offsetHeight - (_isIE ? 4 : 4)) + "px";
        this.obj.className = "dhx_combo_edit";
        this.obj.wrap = "soft";
        this.obj.style.textAlign = this.cell.style.textAlign;
        this.obj.onclick = function (c) {
            (c || event).cancelBubble = true
        };
        this.obj.onmousedown = function (c) {
            (c || event).cancelBubble = true
        };
        this.obj.value = this.val;
        this.cell.innerHTML = "";
        this.cell.appendChild(this.obj);
        this.obj.onselectstart = function (c) {
            if (!c) {
                c = event
            }
            c.cancelBubble = true;
            return true
        };
        if (_isIE) {
            this.obj.focus();
            this.obj.blur()
        }
        this.obj.focus()
    };
    this.getValue = function () {
        if ((this.cell.firstChild) && ((this.cell.atag) && (this.cell.firstChild.tagName == this.cell.atag))) {
            return this.cell.firstChild.value
        }
        if (this.cell._clearCell) {
            return ""
        }
        return this.cell.innerHTML.toString()._dhx_trim()
    };
    this.detach = function () {
        this.setValue(this.obj.value);
        return this.val != this.getValue()
    }
}
eXcell_ed.prototype = new eXcell;

function eXcell_edtxt(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    }
    this.getValue = function () {
        if ((this.cell.firstChild) && ((this.cell.atag) && (this.cell.firstChild.tagName == this.cell.atag))) {
            return this.cell.firstChild.value
        }
        if (this.cell._clearCell) {
            return ""
        }
        return (_isIE ? this.cell.innerText : this.cell.textContent)
    };
    this.setValue = function (c) {
        if (!c || c.toString()._dhx_trim() == "") {
            c = " ";
            this.cell._clearCell = true
        } else {
            this.cell._clearCell = false
        }
        this.setCTxtValue(c)
    }
}
eXcell_edtxt.prototype = new eXcell_ed;

function eXcell_edn(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    }
    this.getValue = function () {
        if ((this.cell.firstChild) && (this.cell.firstChild.tagName == "TEXTAREA")) {
            return this.cell.firstChild.value
        }
        if (this.cell._clearCell) {
            return ""
        }
        return this.cell._orig_value || this.grid._aplNFb(this.cell.innerHTML.toString()._dhx_trim(), this.cell._cellIndex)
    };
    this.detach = function () {
        var c = this.obj.value;
        this.setValue(c);
        return this.val != this.getValue()
    }
}
eXcell_edn.prototype = new eXcell_ed;
eXcell_edn.prototype.setValue = function (a) {
    if (!a || a.toString()._dhx_trim() == "") {
        this.cell._clearCell = true;
        return this.setCValue("&nbsp;", 0)
    } else {
        this.cell._clearCell = false;
        this.cell._orig_value = a
    }
    this.setCValue(this.grid._aplNF(a, this.cell._cellIndex), a)
};

function eXcell_ch(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    }
    this.disabledF = function (c) {
        if ((c == true) || (c == 1)) {
            this.cell.innerHTML = this.cell.innerHTML.replace("item_chk0.", "item_chk0_dis.").replace("item_chk1.", "item_chk1_dis.")
        } else {
            this.cell.innerHTML = this.cell.innerHTML.replace("item_chk0_dis.", "item_chk0.").replace("item_chk1_dis.", "item_chk1.")
        }
    };
    this.changeState = function (c) {
        if (c === true && !this.grid.isActive) {
            if (window.globalActiveDHTMLGridObject != null && window.globalActiveDHTMLGridObject != this.grid && window.globalActiveDHTMLGridObject.isActive) {
                window.globalActiveDHTMLGridObject.setActive(false)
            }
            this.grid.setActive(true)
        }
        if ((!this.grid.isEditable) || (this.cell.parentNode._locked) || (this.isDisabled())) {
            return
        }
        if (this.grid.callEvent("onEditCell", [0, this.cell.parentNode.idd, this.cell._cellIndex])) {
            this.val = this.getValue();
            if (this.val == "1") {
                this.setValue("0")
            } else {
                this.setValue("1")
            }
            this.cell.wasChanged = true;
            this.grid.callEvent("onEditCell", [1, this.cell.parentNode.idd, this.cell._cellIndex]);
            this.grid.callEvent("onCheckbox", [this.cell.parentNode.idd, this.cell._cellIndex, (this.val != "1")]);
            this.grid.callEvent("onCheck", [this.cell.parentNode.idd, this.cell._cellIndex, (this.val != "1")])
        } else {
            this.editor = null
        }
    };
    this.getValue = function () {
        return this.cell.chstate ? this.cell.chstate.toString() : "0"
    };
    this.isCheckbox = function () {
        return true
    };
    this.isChecked = function () {
        if (this.getValue() == "1") {
            return true
        } else {
            return false
        }
    };
    this.setChecked = function (c) {
        this.setValue(c.toString())
    };
    this.detach = function () {
        return this.val != this.getValue()
    };
    this.edit = null
}
eXcell_ch.prototype = new eXcell;
eXcell_ch.prototype.setValue = function (c) {
    this.cell.style.verticalAlign = "middle";
    if (c) {
        c = c.toString()._dhx_trim();
        if ((c == "false") || (c == "0")) {
            c = ""
        }
    }
    if (c) {
        c = "1";
        this.cell.chstate = "1"
    } else {
        c = "0";
        this.cell.chstate = "0"
    }
    var a = this;
    this.setCValue("<img src='" + this.grid.imgURL + "item_chk" + c + ".gif' onclick='new eXcell_ch(this.parentNode).changeState(true); (arguments[0]||event).cancelBubble=true; '>", this.cell.chstate)
};

function eXcell_ra(a) {
    this.base = eXcell_ch;
    this.base(a);
    this.grid = a.parentNode.grid;
    this.disabledF = function (c) {
        if ((c == true) || (c == 1)) {
            this.cell.innerHTML = this.cell.innerHTML.replace("radio_chk0.", "radio_chk0_dis.").replace("radio_chk1.", "radio_chk1_dis.")
        } else {
            this.cell.innerHTML = this.cell.innerHTML.replace("radio_chk0_dis.", "radio_chk0.").replace("radio_chk1_dis.", "radio_chk1.")
        }
    };
    this.changeState = function (c) {
        if (c === false && this.getValue() == 1) {
            return
        }
        if ((!this.grid.isEditable) || (this.cell.parentNode._locked) || (this.isDisabled())) {
            return
        }
        if (this.grid.callEvent("onEditCell", [0, this.cell.parentNode.idd, this.cell._cellIndex]) != false) {
            this.val = this.getValue();
            if (this.val == "1") {
                this.setValue("0")
            } else {
                this.setValue("1")
            }
            this.cell.wasChanged = true;
            this.grid.callEvent("onEditCell", [1, this.cell.parentNode.idd, this.cell._cellIndex]);
            this.grid.callEvent("onCheckbox", [this.cell.parentNode.idd, this.cell._cellIndex, (this.val != "1")]);
            this.grid.callEvent("onCheck", [this.cell.parentNode.idd, this.cell._cellIndex, (this.val != "1")])
        } else {
            this.editor = null
        }
    };
    this.edit = null
}
eXcell_ra.prototype = new eXcell_ch;
eXcell_ra.prototype.setValue = function (c) {
    this.cell.style.verticalAlign = "middle";
    if (c) {
        c = c.toString()._dhx_trim();
        if ((c == "false") || (c == "0")) {
            c = ""
        }
    }
    if (c) {
        if (!this.grid._RaSeCol) {
            this.grid._RaSeCol = []
        }
        if (this.grid._RaSeCol[this.cell._cellIndex]) {
            var a = this.grid.cells4(this.grid._RaSeCol[this.cell._cellIndex]);
            a.setValue("0");
            if (this.grid.rowsAr[a.cell.parentNode.idd]) {
                this.grid.callEvent("onEditCell", [1, a.cell.parentNode.idd, a.cell._cellIndex])
            }
        }
        this.grid._RaSeCol[this.cell._cellIndex] = this.cell;
        c = "1";
        this.cell.chstate = "1"
    } else {
        c = "0";
        this.cell.chstate = "0"
    }
    this.setCValue("<img src='" + this.grid.imgURL + "radio_chk" + c + ".gif' onclick='new eXcell_ra(this.parentNode).changeState(false);'>", this.cell.chstate)
};

function eXcell_txt(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    }
    this.edit = function () {
        this.val = this.getValue();
        this.obj = document.createElement("TEXTAREA");
        this.obj.className = "dhx_textarea";
        this.obj.onclick = function (j) {
            (j || event).cancelBubble = true
        };
        var g = this.grid.getPosition(this.cell);
        this.obj.value = this.val;
        this.obj.style.display = "";
        this.obj.style.textAlign = this.cell.style.textAlign;
        if (_isFF) {
            var c = document.createElement("DIV");
            c.appendChild(this.obj);
            c.style.overflow = "auto";
            c.className = "dhx_textarea";
            this.obj.style.margin = "0px 0px 0px 0px";
            this.obj.style.border = "0px";
            this.obj = c
        }
        document.body.appendChild(this.obj);
        if (_isOpera) {
            this.obj.onkeypress = function (j) {
                if (j.keyCode == 9) {
                    return false
                }
            }
        }
        this.obj.onkeydown = function (l) {
            var j = (l || event);
            if (j.keyCode == 9) {
                globalActiveDHTMLGridObject.entBox.focus();
                globalActiveDHTMLGridObject.doKey({
                    keyCode: j.keyCode,
                    shiftKey: j.shiftKey,
                    srcElement: "0"
                });
                return false
            }
        };
        this.obj.style.left = g[0] + "px";
        this.obj.style.top = g[1] + this.cell.offsetHeight + "px";
        if (this.cell.offsetWidth < 200) {
            var h = 200
        } else {
            var h = this.cell.offsetWidth
        }
        this.obj.style.width = h + (_isFF ? 18 : 16) + "px";
        if (_isFF) {
            this.obj.firstChild.style.width = parseInt(this.obj.style.width) + "px";
            this.obj.firstChild.style.height = this.obj.offsetHeight - 3 + "px"
        }
        if (_isIE) {
            this.obj.select();
            this.obj.value = this.obj.value
        }
        if (_isFF) {
            this.obj.firstChild.focus()
        } else {
            this.obj.focus()
        }
    };
    this.detach = function () {
        var c = "";
        if (_isFF) {
            c = this.obj.firstChild.value
        } else {
            c = this.obj.value
        }
        if (c == "") {
            this.cell._clearCell = true
        } else {
            this.cell._clearCell = false
        }
        this.setValue(c);
        document.body.removeChild(this.obj);
        this.obj = null;
        return this.val != this.getValue()
    };
    this.getValue = function () {
        if (this.obj) {
            if (_isFF) {
                return this.obj.firstChild.value
            } else {
                return this.obj.value
            }
        }
        if (this.cell._clearCell) {
            return ""
        }
        if (typeof this.cell._brval != "undefined") {
            return this.cell._brval
        }
        if ((!this.grid.multiLine)) {
            return this.cell._brval || this.cell.innerHTML
        } else {
            return this.cell._brval || this.cell.innerHTML.replace(/<br[^>]*>/gi, "\n")._dhx_trim()
        }
    }
}
eXcell_txt.prototype = new eXcell;

function eXcell_txttxt(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    }
    this.getValue = function () {
        if ((this.cell.firstChild) && (this.cell.firstChild.tagName == "TEXTAREA")) {
            return this.cell.firstChild.value
        }
        if (this.cell._clearCell) {
            return ""
        }
        if ((!this.grid.multiLine) && this.cell._brval) {
            return this.cell._brval
        }
        return (_isIE ? this.cell.innerText : this.cell.textContent)
    };
    this.setValue = function (c) {
        this.cell._brval = c;
        if (!c || c.toString()._dhx_trim() == "") {
            c = " ";
            this.cell._clearCell = true
        } else {
            this.cell._clearCell = false
        }
        this.setCTxtValue(c)
    }
}
eXcell_txttxt.prototype = new eXcell_txt;
eXcell_txt.prototype.setValue = function (a) {
    this.cell._brval = a;
    if (!a || a.toString()._dhx_trim() == "") {
        a = "&nbsp;";
        this.cell._clearCell = true
    } else {
        this.cell._clearCell = false
    }
    if ((!this.grid.multiLine) || this.cell._clearCell) {
        this.setCValue(a, this.cell._brval)
    } else {
        this.setCValue(a.replace(/\n/g, "<br/>"), a)
    }
};

function eXcell_co(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid;
        this.combo = (this.cell._combo || this.grid.getCombo(this.cell._cellIndex));
        this.editable = true
    }
    this.shiftNext = function () {
        var c = this.list.options[this.list.selectedIndex + 1];
        if (c) {
            c.selected = true
        }
        this.obj.value = this.list.options[this.list.selectedIndex].text;
        return true
    };
    this.shiftPrev = function () {
        if (this.list.selectedIndex != 0) {
            var c = this.list.options[this.list.selectedIndex - 1];
            if (c) {
                c.selected = true
            }
            this.obj.value = this.list.options[this.list.selectedIndex].text
        }
        return true
    };
    this.edit = function () {
        this.val = this.getValue();
        this.text = this.getText()._dhx_trim();
        var h = this.grid.getPosition(this.cell);
        this.obj = document.createElement("TEXTAREA");
        this.obj.className = "dhx_combo_edit";
        this.obj.style.height = (this.cell.offsetHeight - 4) + "px";
        this.obj.wrap = "soft";
        this.obj.style.textAlign = this.cell.style.textAlign;
        this.obj.onclick = function (o) {
            (o || event).cancelBubble = true
        };
        this.obj.onmousedown = function (o) {
            (o || event).cancelBubble = true
        };
        this.obj.value = this.text;
        this.obj.onselectstart = function (o) {
            if (!o) {
                o = event
            }
            o.cancelBubble = true;
            return true
        };
        var l = this;
        this.obj.onkeyup = function (r) {
            var q = (r || event).keyCode;
            if (q == 38 || q == 40 || q == 9) {
                return
            }
            var s = this.readonly ? String.fromCharCode(q) : this.value;
            var u = l.list.options;
            for (var o = 0; o < u.length; o++) {
                if (u[o].text.indexOf(s) == 0) {
                    return u[o].selected = true
                }
            }
        };
        this.list = document.createElement("SELECT");
        this.list.className = "dhx_combo_select";
        this.list.style.width = this.cell.offsetWidth + "px";
        this.list.style.left = h[0] + "px";
        this.list.style.top = h[1] + this.cell.offsetHeight + "px";
        this.list.onclick = function (r) {
            var q = r || window.event;
            var o = q.target || q.srcElement;
            if (o.tagName == "OPTION") {
                o = o.parentNode
            }
            l.editable = false;
            l.grid.editStop();
            q.cancelBubble = true
        };
        var c = this.combo.getKeys();
        var j = false;
        var n = 0;
        for (var g = 0; g < c.length; g++) {
            var m = this.combo.get(c[g]);
            this.list.options[this.list.options.length] = new Option(m, c[g]);
            if (c[g] == this.val) {
                n = this.list.options.length - 1;
                j = true
            }
        }
        if (j == false) {
            this.list.options[this.list.options.length] = new Option(this.text, this.val === null ? "" : this.val);
            n = this.list.options.length - 1
        }
        document.body.appendChild(this.list);
        this.list.size = "6";
        this.cstate = 1;
        if (this.editable) {
            this.cell.innerHTML = ""
        } else {
            this.obj.style.width = "1px";
            this.obj.style.height = "1px"
        }
        this.cell.appendChild(this.obj);
        this.list.options[n].selected = true;
        if ((!_isFF) || (this.editable)) {
            this.obj.focus();
            this.obj.focus()
        }
        if (!this.editable) {
            this.obj.style.visibility = "hidden";
            this.list.focus();
            this.list.onkeydown = function (o) {
                o = o || window.event;
                l.grid.setActive(true);
                if (o.keyCode < 30) {
                    return l.grid.doKey({
                        target: l.cell,
                        keyCode: o.keyCode,
                        shiftKey: o.shiftKey,
                        ctrlKey: o.ctrlKey
                    })
                }
            }
        }
    };
    this.getValue = function () {
        return ((this.cell.combo_value == window.undefined) ? "" : this.cell.combo_value)
    };
    this.detach = function () {
        if (this.val != this.getValue()) {
            this.cell.wasChanged = true
        }
        if (this.list.parentNode != null) {
            if (this.editable) {
                var c = this.list.options[this.list.selectedIndex];
                if (c && c.text == this.obj.value) {
                    this.setValue(this.list.value)
                } else {
                    var g = (this.cell._combo || this.grid.getCombo(this.cell._cellIndex));
                    var h = g.values._dhx_find(this.obj.value);
                    if (h != -1) {
                        this.setValue(g.keys[h])
                    } else {
                        this.setValue(this.cell.combo_value = this.obj.value)
                    }
                }
            } else {
                this.setValue(this.list.value)
            }
        }
        if (this.list.parentNode) {
            this.list.parentNode.removeChild(this.list)
        }
        if (this.obj.parentNode) {
            this.obj.parentNode.removeChild(this.obj)
        }
        return this.val != this.getValue()
    }
}
eXcell_co.prototype = new eXcell;
eXcell_co.prototype.getText = function () {
    return this.cell.innerHTML
};
eXcell_co.prototype.setValue = function (h) {
    if (typeof (h) == "object") {
        var g = this.grid.xmlLoader.doXPath("./option", h);
        if (g.length) {
            this.cell._combo = new dhtmlXGridComboObject()
        }
        for (var c = 0; c < g.length; c++) {
            this.cell._combo.put(g[c].getAttribute("value"), g[c].firstChild ? g[c].firstChild.data : "")
        }
        h = h.firstChild.data
    }
    if ((h || "").toString()._dhx_trim() == "") {
        h = null
    }
    this.cell.combo_value = h;
    if (h !== null) {
        var a = (this.cell._combo || this.grid.getCombo(this.cell._cellIndex)).get(h);
        this.setCValue(a === null ? h : a, h)
    } else {
        this.setCValue("&nbsp;", h)
    }
};

function eXcell_coro(a) {
    this.base = eXcell_co;
    this.base(a);
    this.editable = false
}
eXcell_coro.prototype = new eXcell_co;

function eXcell_cotxt(a) {
    this.base = eXcell_co;
    this.base(a)
}
eXcell_cotxt.prototype = new eXcell_co;
eXcell_cotxt.prototype.getText = function () {
    return (_isIE ? this.cell.innerText : this.cell.textContent)
};
eXcell_cotxt.prototype.setValue = function (g) {
    if (typeof (g) == "object") {
        var c = this.grid.xmlLoader.doXPath("./option", g);
        if (c.length) {
            this.cell._combo = new dhtmlXGridComboObject()
        }
        for (var a = 0; a < c.length; a++) {
            this.cell._combo.put(c[a].getAttribute("value"), c[a].firstChild ? c[a].firstChild.data : "")
        }
        g = g.firstChild.data
    }
    if ((g || "").toString()._dhx_trim() == "") {
        g = null
    }
    if (g !== null) {
        this.setCTxtValue((this.cell._combo || this.grid.getCombo(this.cell._cellIndex)).get(g) || g, g)
    } else {
        this.setCTxtValue(" ", g)
    }
    this.cell.combo_value = g
};

function eXcell_corotxt(a) {
    this.base = eXcell_co;
    this.base(a);
    this.editable = false
}
eXcell_corotxt.prototype = new eXcell_cotxt;

function eXcell_cp(a) {
    try {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    } catch (c) {}
    this.edit = function () {
        this.val = this.getValue();
        this.obj = document.createElement("SPAN");
        this.obj.style.border = "1px solid black";
        this.obj.style.position = "absolute";
        var g = this.grid.getPosition(this.cell);
        this.colorPanel(4, this.obj);
        document.body.appendChild(this.obj);
        this.obj.style.left = g[0] + "px";
        this.obj.style.zIndex = 1000;
        this.obj.style.top = g[1] + this.cell.offsetHeight + "px"
    };
    this.toolDNum = function (g) {
        if (g.length == 1) {
            g = "0" + g
        }
        return g
    };
    this.colorPanel = function (s, w) {
        var o = document.createElement("TABLE");
        w.appendChild(o);
        o.cellSpacing = 0;
        o.editor_obj = this;
        o.style.cursor = "default";
        o.onclick = function (x) {
            var r = x || window.event;
            var j = r.target || r.srcElement;
            var n = j.parentNode.parentNode.parentNode.editor_obj;
            n.setValue(j._bg);
            n.grid.editStop()
        };
        var l = 256 / s;
        for (var m = 0; m <= (256 / l); m++) {
            var g = o.insertRow(m);
            for (var q = 0; q <= (256 / l); q++) {
                for (var h = 0; h <= (256 / l); h++) {
                    R = new Number(l * m) - (m == 0 ? 0 : 1);
                    G = new Number(l * q) - (q == 0 ? 0 : 1);
                    B = new Number(l * h) - (h == 0 ? 0 : 1);
                    var v = this.toolDNum(R.toString(16)) + "" + this.toolDNum(G.toString(16)) + "" + this.toolDNum(B.toString(16));
                    var u = g.insertCell(q);
                    u.width = "10px";
                    u.innerHTML = "&nbsp;";
                    u.title = v.toUpperCase();
                    u.style.backgroundColor = "#" + v;
                    u._bg = "#" + v;
                    if (this.val != null && "#" + v.toUpperCase() == this.val.toUpperCase()) {
                        u.style.border = "2px solid white"
                    }
                }
            }
        }
    };
    this.getValue = function () {
        return this.cell.firstChild._bg || ""
    };
    this.getRed = function () {
        return Number(parseInt(this.getValue().substr(1, 2), 16))
    };
    this.getGreen = function () {
        return Number(parseInt(this.getValue().substr(3, 2), 16))
    };
    this.getBlue = function () {
        return Number(parseInt(this.getValue().substr(5, 2), 16))
    };
    this.detach = function () {
        if (this.obj.offsetParent != null) {
            document.body.removeChild(this.obj)
        }
        return this.val != this.getValue()
    }
}
eXcell_cp.prototype = new eXcell;
eXcell_cp.prototype.setValue = function (a) {
    this.setCValue("<div style='width:100%;height:" + ((this.grid.multiLine ? this.cell.offsetHeight - 2 : 16)) + ";background-color:" + (a || "") + ";border:0px;'>&nbsp;</div>", a);
    this.cell.firstChild._bg = a
};

function eXcell_img(a) {
    try {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    } catch (c) {}
    this.getValue = function () {
        if (this.cell.firstChild.tagName == "IMG") {
            return this.cell.firstChild.src + (this.cell.titFl != null ? "^" + this.cell._brval : "")
        } else {
            if (this.cell.firstChild.tagName == "A") {
                var g = this.cell.firstChild.firstChild.src + (this.cell.titFl != null ? "^" + this.cell._brval : "");
                g += "^" + this.cell.lnk;
                if (this.cell.trg) {
                    g += "^" + this.cell.trg
                }
                return g
            }
        }
    };
    this.isDisabled = function () {
        return true
    }
}
eXcell_img.prototype = new eXcell;
eXcell_img.prototype.getTitle = function () {
    return this.cell._brval
};
eXcell_img.prototype.setValue = function (g) {
    var c = g;
    if ((g || "").indexOf("^") != -1) {
        var a = g.split("^");
        g = a[0];
        c = this.cell._attrs.title || a[1];
        if (a.length > 2) {
            this.cell.lnk = a[2];
            if (a[3]) {
                this.cell.trg = a[3]
            }
        }
        this.cell.titFl = "1"
    }
    this.setCValue("<img src='" + this.grid.iconURL + (g || "")._dhx_trim() + "' border='0'>", g);
    if (this.cell.lnk) {
        this.cell.innerHTML = "<a href='" + this.cell.lnk + "' target='" + this.cell.trg + "'>" + this.cell.innerHTML + "</a>"
    }
    this.cell._brval = c
};

function eXcell_price(a) {
    this.base = eXcell_ed;
    this.base(a);
    this.getValue = function () {
        if (this.cell.childNodes.length > 1) {
            return this.cell.childNodes[1].innerHTML.toString()._dhx_trim()
        } else {
            return "0"
        }
    }
}
eXcell_price.prototype = new eXcell_ed;
eXcell_price.prototype.setValue = function (c) {
    if (isNaN(parseFloat(c))) {
        c = this.val || 0
    }
    var a = "green";
    if (c < 0) {
        a = "red"
    }
    this.setCValue("<span>$</span><span style='padding-right:2px;color:" + a + ";'>" + c + "</span>", c)
};

function eXcell_dyn(a) {
    this.base = eXcell_ed;
    this.base(a);
    this.getValue = function () {
        return this.cell.firstChild.childNodes[1].innerHTML.toString()._dhx_trim()
    }
}
eXcell_dyn.prototype = new eXcell_ed;
eXcell_dyn.prototype.setValue = function (g) {
    if (!g || isNaN(Number(g))) {
        if (g !== "") {
            g = 0
        }
    }
    if (g > 0) {
        var c = "green";
        var a = "dyn_up.gif"
    } else {
        if (g == 0) {
            var c = "black";
            var a = "dyn_.gif"
        } else {
            var c = "red";
            var a = "dyn_down.gif"
        }
    }
    this.setCValue("<div style='position:relative;padding-right:2px; width:100%;overflow:hidden; white-space:nowrap;'><img src='" + this.grid.imgURL + "" + a + "' height='15' style='position:absolute;top:0px;left:0px;'><span style=' padding-left:20px; width:100%;color:" + c + ";'>" + g + "</span></div>", g)
};

function eXcell_ro(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    }
    this.edit = function () {};
    this.isDisabled = function () {
        return true
    };
    this.getValue = function () {
        return this.cell._clearCell ? "" : this.cell.innerHTML.toString()._dhx_trim()
    }
}
eXcell_ro.prototype = new eXcell;
window.eXcell_hidden = function (a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid
    }
    this.edit = function () {};
    this.isDisabled = function () {
        return true
    };
    this.getValue = function () {
        return this.cell.val
    }
};
eXcell_hidden.prototype = new eXcell;
eXcell_hidden.prototype.setValue = function (a) {
    this.cell.val = a
};

function eXcell_ron(a) {
    this.cell = a;
    this.grid = this.cell.parentNode.grid;
    this.edit = function () {};
    this.isDisabled = function () {
        return true
    };
    this.getValue = function () {
        return this.cell._clearCell ? "" : this.grid._aplNFb(this.cell.innerHTML.toString()._dhx_trim(), this.cell._cellIndex).toString()
    }
}
eXcell_ron.prototype = new eXcell;
eXcell_ron.prototype.setValue = function (a) {
    if (a === 0) {} else {
        if (!a || a.toString()._dhx_trim() == "") {
            this.setCValue("&nbsp;");
            return this.cell._clearCell = true
        }
    }
    this.cell._clearCell = false;
    this.setCValue(a ? this.grid._aplNF(a, this.cell._cellIndex) : "0")
};

function eXcell_rotxt(a) {
    this.cell = a;
    this.grid = this.cell.parentNode.grid;
    this.edit = function () {};
    this.isDisabled = function () {
        return true
    };
    this.setValue = function (c) {
        if (!c) {
            c = " ";
            this.cell._clearCell = true
        } else {
            this.cell._clearCell = false
        }
        this.setCTxtValue(c)
    };
    this.getValue = function () {
        if (this.cell._clearCell) {
            return ""
        }
        return (_isIE ? this.cell.innerText : this.cell.textContent)
    }
}
eXcell_rotxt.prototype = new eXcell;

function dhtmlXGridComboObject() {
    this.keys = new dhtmlxArray();
    this.values = new dhtmlxArray();
    this.put = function (c, g) {
        for (var a = 0; a < this.keys.length; a++) {
            if (this.keys[a] == c) {
                this.values[a] = g;
                return true
            }
        }
        this.values[this.values.length] = g;
        this.keys[this.keys.length] = c
    };
    this.get = function (c) {
        for (var a = 0; a < this.keys.length; a++) {
            if (this.keys[a] == c) {
                return this.values[a]
            }
        }
        return null
    };
    this.clear = function () {
        this.keys = new dhtmlxArray();
        this.values = new dhtmlxArray()
    };
    this.remove = function (c) {
        for (var a = 0; a < this.keys.length; a++) {
            if (this.keys[a] == c) {
                this.keys._dhx_removeAt(a);
                this.values._dhx_removeAt(a);
                return true
            }
        }
    };
    this.size = function () {
        var a = 0;
        for (var c = 0; c < this.keys.length; c++) {
            if (this.keys[c] != null) {
                a++
            }
        }
        return a
    };
    this.getKeys = function () {
        var a = new Array(0);
        for (var c = 0; c < this.keys.length; c++) {
            if (this.keys[c] != null) {
                a[a.length] = this.keys[c]
            }
        }
        return a
    };
    this.save = function () {
        this._save = new Array();
        for (var a = 0; a < this.keys.length; a++) {
            this._save[a] = [this.keys[a], this.values[a]]
        }
    };
    this.restore = function () {
        if (this._save) {
            this.keys[a] = new Array();
            this.values[a] = new Array();
            for (var a = 0; a < this._save.length; a++) {
                this.keys[a] = this._save[a][0];
                this.values[a] = this._save[a][1]
            }
        }
    };
    return this
}
function Hashtable() {
    this.keys = new dhtmlxArray();
    this.values = new dhtmlxArray();
    return this
}
Hashtable.prototype = new dhtmlXGridComboObject;
dhtmlXGridObject.prototype.enableDragAndDrop = function (a) {
    if (a == "temporary_disabled") {
        this.dADTempOff = false;
        a = true
    } else {
        this.dADTempOff = true
    }
    this.dragAndDropOff = convertStringToBoolean(a);
    this._drag_validate = true;
    if (a) {
        this.objBox.ondragstart = function (c) {
            (c || event).cancelBubble = true;
            return false
        }
    }
};
dhtmlXGridObject.prototype.setDragBehavior = function (a) {
    this.dadmodec = this.dadmodefix = 0;
    switch (a) {
    case "child":
        this.dadmode = 0;
        this._sbmod = false;
        break;
    case "sibling":
        this.dadmode = 1;
        this._sbmod = false;
        break;
    case "sibling-next":
        this.dadmode = 1;
        this._sbmod = true;
        break;
    case "complex":
        this.dadmode = 2;
        this._sbmod = false;
        break;
    case "complex-next":
        this.dadmode = 2;
        this._sbmod = true;
        break
    }
};
dhtmlXGridObject.prototype.enableDragOrder = function (a) {
    this._dndorder = convertStringToBoolean(a)
};
dhtmlXGridObject.prototype._checkParent = function (h, c) {
    var g = this._h2.get[h.idd].parent;
    if (!g.parent) {
        return
    }
    for (var a = 0; a < c.length; a++) {
        if (c[a] == g.id) {
            return true
        }
    }
    return this._checkParent(this.rowsAr[g.id], c)
};
dhtmlXGridObject.prototype._createDragNode = function (g, h) {
    this.editStop();
    if (window.dhtmlDragAndDrop.dragNode) {
        return null
    }
    if (!this.dADTempOff) {
        return null
    }
    g.parentObject = new Object();
    g.parentObject.treeNod = this;
    var n = this.callEvent("onBeforeDrag", [g.parentNode.idd, g._cellIndex, h]);
    if (!n) {
        return null
    }
    var j = new Array();
    j = this.getSelectedId();
    j = (((j) && (j != "")) ? j.split(this.delim) : []);
    var l = false;
    for (var c = 0; c < j.length; c++) {
        if (j[c] == g.parentNode.idd) {
            l = true
        }
    }
    if (!l) {
        this.selectRow(this.rowsAr[g.parentNode.idd], false, h.ctrlKey, false);
        if (!h.ctrlKey) {
            j = []
        }
        j[this.selMultiRows ? j.length : 0] = g.parentNode.idd
    }
    if (this.isTreeGrid()) {
        for (var c = j.length - 1; c >= 0; c--) {
            if (this._checkParent(this.rowsAr[j[c]], j)) {
                j.splice(c, 1)
            }
        }
    }
    var o = this;
    if (j.length && this._dndorder) {
        j.sort(function (r, q) {
            return (o.rowsAr[r].rowIndex > o.rowsAr[q].rowIndex ? 1 : -1)
        })
    }
    var a = this.getFirstParentOfType(_isIE ? h.srcElement : h.target, "TD");
    if (a) {
        this._dndExtra = a._cellIndex
    }
    this._dragged = new Array();
    for (var c = 0; c < j.length; c++) {
        if (this.rowsAr[j[c]]) {
            this._dragged[this._dragged.length] = this.rowsAr[j[c]];
            this.rowsAr[j[c]].treeNod = this
        }
    }
    g.parentObject.parentNode = g.parentNode;
    var m = document.createElement("div");
    m.innerHTML = (n !== true ? n : this.rowToDragElement(g.parentNode.idd));
    m.style.position = "absolute";
    m.className = "dragSpanDiv";
    return m
};
dhtmlXGridObject.prototype._createSdrgc = function () {
    this._sdrgc = document.createElement("DIV");
    this._sdrgc.innerHTML = "&nbsp;";
    this._sdrgc.className = "gridDragLine";
    this.objBox.appendChild(this._sdrgc)
};

function dragContext(w, v, u, s, r, q, n, o, m, g) {
    this.source = w || "grid";
    this.target = v || "grid";
    this.mode = u || "move";
    this.dropmode = s || "child";
    this.sid = r || 0;
    this.tid = q;
    this.sobj = n || null;
    this.tobj = o || null;
    this.sExtra = m || null;
    this.tExtra = g || null;
    return this
}
dragContext.prototype.valid = function () {
    if (this.sobj != this.tobj) {
        return true
    }
    if (this.sid == this.tid) {
        return false
    }
    if (this.target == "treeGrid") {
        var a = this.tid;
        while (a = this.tobj.getParentId(a)) {
            if (this.sid == a) {
                return false
            }
        }
    }
    return true
};
dragContext.prototype.close = function () {
    this.sobj = null;
    this.tobj = null
};
dragContext.prototype.copy = function () {
    return new dragContext(this.source, this.target, this.mode, this.dropmode, this.sid, this.tid, this.sobj, this.tobj, this.sExtra, this.tExtra)
};
dragContext.prototype.set = function (g, c) {
    this[g] = c;
    return this
};
dragContext.prototype.uid = function (g, c) {
    this.nid = this.sid;
    while (this.tobj.rowsAr[this.nid]) {
        this.nid = this.nid + ((new Date()).valueOf())
    }
    return this
};
dragContext.prototype.data = function () {
    if (this.sobj == this.tobj) {
        return this.sobj._getRowArray(this.sobj.rowsAr[this.sid])
    }
    if (this.source == "tree") {
        return this.tobj.treeToGridElement(this.sobj, this.sid, this.tid)
    } else {
        return this.tobj.gridToGrid(this.sid, this.sobj, this.tobj)
    }
};
dragContext.prototype.attrs = function () {
    if (this.source == "tree") {
        return {}
    } else {
        return this.sobj.rowsAr[this.sid]._attrs
    }
};
dragContext.prototype.childs = function () {
    if (this.source == "treeGrid") {
        return this.sobj._h2.get[this.sid]._xml_await ? this.sobj._h2.get[this.sid].has_kids : null
    }
    return null
};
dragContext.prototype.pid = function () {
    if (!this.tid) {
        return 0
    }
    if (!this.tobj._h2) {
        return 0
    }
    if (this.target == "treeGrid") {
        if (this.dropmode == "child") {
            return this.tid
        } else {
            var c = this.tobj.rowsAr[this.tid];
            var a = this.tobj._h2.get[c.idd].parent.id;
            if ((this.alfa) && (this.tobj._sbmod) && (c.nextSibling)) {
                var g = this.tobj._h2.get[c.nextSibling.idd].parent.id;
                if (g == this.tid) {
                    return this.tid
                }
                if (g != a) {
                    return g
                }
            }
            return a
        }
    }
};
dragContext.prototype.ind = function () {
    if (this.tid == window.unknown) {
        return this.tobj.rowsBuffer.length
    }
    if (this.target == "treeGrid") {
        if (this.dropmode == "child") {
            this.tobj.openItem(this.tid)
        } else {
            this.tobj.openItem(this.tobj.getParentId(this.tid))
        }
    }
    var a = this.tobj.rowsBuffer._dhx_find(this.tobj.rowsAr[this.tid]);
    if ((this.alfa) && (this.tobj._sbmod) && (this.dropmode == "sibling")) {
        var c = this.tobj.rowsAr[this.tid];
        if ((c.nextSibling) && (this._h2.get[c.nextSibling.idd].parent.id == this.tid)) {
            return a + 1
        }
    }
    return (a + 1 + ((this.target == "treeGrid" && a >= 0 && this.tobj._h2.get[this.tobj.rowsBuffer[a].idd].state == "minus") ? this.tobj._getOpenLenght(this.tobj.rowsBuffer[a].idd, 0) : 0))
};
dragContext.prototype.img = function () {
    if ((this.target != "grid") && (this.sobj._h2)) {
        return this.sobj.getItemImage(this.sid)
    } else {
        return null
    }
};
dragContext.prototype.slist = function () {
    var c = new Array();
    for (var a = 0; a < this.sid.length; a++) {
        c[c.length] = this.sid[a][(this.source == "tree") ? "id" : "idd"]
    }
    return c.join(",")
};
dhtmlXGridObject.prototype._drag = function (r, j, q, s) {
    if (this._realfake) {
        return this._fake._drag()
    }
    var o = (this.lastLanding);
    if (this._autoOpenTimer) {
        window.clearTimeout(this._autoOpenTimer)
    }
    var h = q.parentNode;
    var g = r.parentObject;
    if (!h.idd) {
        h.grid = this;
        this.dadmodefix = 0
    }
    var n = new dragContext(0, 0, 0, ((h.grid.dadmode == 1 || h.grid.dadmodec) ? "sibling" : "child"));
    if (g && g.childNodes) {
        n.set("source", "tree").set("sobj", g.treeNod).set("sid", n.sobj._dragged)
    } else {
        if (!g) {
            return true
        }
        if (g.treeNod.isTreeGrid && g.treeNod.isTreeGrid()) {
            n.set("source", "treeGrid")
        }
        n.set("sobj", g.treeNod).set("sid", n.sobj._dragged)
    }
    if (h.grid.isTreeGrid()) {
        n.set("target", "treeGrid")
    } else {
        n.set("dropmode", "sibling")
    }
    n.set("tobj", h.grid).set("tid", h.idd);
    if (((n.tobj.dadmode == 2) && (n.tobj.dadmodec == 1)) && (n.tobj.dadmodefix < 0)) {
        if (n.tobj.obj.rows[1].idd != n.tid) {
            n.tid = h.previousSibling.idd
        } else {
            n.tid = 0
        }
    }
    var a = this.getFirstParentOfType(s, "TD");
    if (a) {
        n.set("tExtra", a._cellIndex)
    }
    if (a) {
        n.set("sExtra", n.sobj._dndExtra)
    }
    if (n.sobj.dpcpy) {
        n.set("mode", "copy")
    }
    if (n.tobj._realfake) {
        n.tobj = n.tobj._fake
    }
    if (n.sobj._realfake) {
        n.sobj = n.sobj._fake
    }
    n.tobj._clearMove();
    if (g && g.treeNod && g.treeNod._nonTrivialRow) {
        g.treeNod._nonTrivialRow(this, n.tid, n.dropmode, g)
    } else {
        n.tobj.dragContext = n;
        if (!n.tobj.callEvent("onDrag", [n.slist(), n.tid, n.sobj, n.tobj, n.sExtra, n.tExtra])) {
            return n.tobj.dragContext = null
        }
        var u = new Array();
        if (typeof (n.sid) == "object") {
            var m = n.copy();
            for (var l = 0; l < n.sid.length; l++) {
                if (!m.set("alfa", (!l)).set("sid", n.sid[l][(n.source == "tree" ? "id" : "idd")]).valid()) {
                    continue
                }
                m.tobj._dragRoutine(m);
                if (m.target == "treeGrid" && m.dropmode == "child") {
                    m.tobj.openItem(m.tid)
                }
                u[u.length] = m.nid;
                m.set("dropmode", "sibling").set("tid", m.nid)
            }
            m.close()
        } else {
            n.tobj._dragRoutine(n)
        }
        if (n.tobj.laterLink) {
            n.tobj.laterLink()
        }
        n.tobj.callEvent("onDrop", [n.slist(), n.tid, u.join(","), n.sobj, n.tobj, n.sExtra, n.tExtra])
    }
    n.tobj.dragContext = null;
    n.close()
};
dhtmlXGridObject.prototype._dragRoutine = function (s) {
    if ((s.sobj == s.tobj) && (s.source == "grid") && (s.mode == "move") && !this._fake) {
        if (s.sobj._dndProblematic) {
            return
        }
        var q = s.sobj.rowsAr[s.sid];
        var r = s.sobj.rowsCol._dhx_find(q);
        s.sobj.rowsCol._dhx_removeAt(s.sobj.rowsCol._dhx_find(q));
        s.sobj.rowsBuffer._dhx_removeAt(s.sobj.rowsBuffer._dhx_find(q));
        s.sobj.rowsBuffer._dhx_insertAt(s.ind(), q);
        if (s.tobj._fake) {
            s.tobj._fake.rowsCol._dhx_removeAt(r);
            var u = s.tobj._fake.rowsAr[s.sid];
            u.parentNode.removeChild(u)
        }
        s.sobj._insertRowAt(q, s.ind());
        s.nid = s.sid;
        s.sobj.callEvent("onGridReconstructed", []);
        return
    }
    var o;
    if (this._h2 && typeof s.tid != "undefined" && s.dropmode == "sibling" && (this._sbmod || s.tid)) {
        if (s.alfa && this._sbmod && this._h2.get[s.tid].childs.length) {
            this.openItem(s.tid);
            o = s.uid().tobj.addRowBefore(s.nid, s.data(), this._h2.get[s.tid].childs[0].id, s.img(), s.childs())
        } else {
            o = s.uid().tobj.addRowAfter(s.nid, s.data(), s.tid, s.img(), s.childs())
        }
    } else {
        o = s.uid().tobj.addRow(s.nid, s.data(), s.ind(), s.pid(), s.img(), s.childs())
    }
    o._attrs = s.attrs();
    if (s.source == "tree") {
        this.callEvent("onRowAdded", [s.nid]);
        var a = s.sobj._globalIdStorageFind(s.sid);
        if (a.childsCount) {
            var n = s.copy().set("tid", s.nid).set("dropmode", s.target == "grid" ? "sibling" : "child");
            for (var h = 0; h < a.childsCount; h++) {
                s.tobj._dragRoutine(n.set("sid", a.childNodes[h].id));
                if (s.mode == "move") {
                    h--
                }
            }
            n.close()
        }
    } else {
        s.tobj._copyUserData(s);
        this.callEvent("onRowAdded", [s.nid]);
        if ((s.source == "treeGrid")) {
            if (s.sobj == s.tobj) {
                o._xml = s.sobj.rowsAr[s.sid]._xml
            }
            var m = s.sobj._h2.get[s.sid];
            if ((m) && (m.childs.length)) {
                var n = s.copy().set("tid", s.nid);
                if (s.target == "grid") {
                    n.set("dropmode", "sibling")
                } else {
                    n.tobj.openItem(s.tid);
                    n.set("dropmode", "child")
                }
                var g = m.childs.length;
                for (var h = 0; h < g; h++) {
                    s.sobj.render_row_tree(null, m.childs[h].id);
                    s.tobj._dragRoutine(n.set("sid", m.childs[h].id));
                    if (g != m.childs.length) {
                        h--;
                        g = m.childs.length
                    }
                }
                n.close()
            }
        }
    }
    if (s.mode == "move") {
        s.sobj[(s.source == "tree") ? "deleteItem" : "deleteRow"](s.sid);
        if ((s.sobj == s.tobj) && (!s.tobj.rowsAr[s.sid])) {
            s.tobj.changeRowId(s.nid, s.sid);
            s.nid = s.sid
        }
    }
};
dhtmlXGridObject.prototype.gridToGrid = function (h, a, g) {
    var j = new Array();
    for (var c = 0; c < a.hdr.rows[0].cells.length; c++) {
        j[c] = a.cells(h, c).getValue()
    }
    return j
};
dhtmlXGridObject.prototype.checkParentLine = function (a, c) {
    if ((!this._h2) || (!c) || (!a)) {
        return false
    }
    if (a.id == c) {
        return true
    } else {
        return this.checkParentLine(a.parent, c)
    }
};
dhtmlXGridObject.prototype._dragIn = function (j, g, c, l) {
    if (!this.dADTempOff) {
        return 0
    }
    var a = this.isTreeGrid();
    var h = g.parentNode.idd ? g.parentNode : g.parentObject;
    if (this._drag_validate) {
        if (j.parentNode == g.parentNode) {
            return 0
        }
        if ((a) && (this == h.grid) && ((this.checkParentLine(this._h2.get[j.parentNode.idd], g.parentNode.idd)))) {
            return 0
        }
    }
    if (!this.callEvent("onDragIn", [h.idd || h.id, j.parentNode.idd, h.grid || h.treeNod, (j.grid || j.parentNode.grid)])) {
        return this._setMove(j, c, l, true)
    }
    this._setMove(j, c, l);
    if ((a) && (j.parentNode.expand != "")) {
        this._autoOpenTimer = window.setTimeout(new callerFunction(this._autoOpenItem, this), 1000);
        this._autoOpenId = j.parentNode.idd
    } else {
        if (this._autoOpenTimer) {
            window.clearTimeout(this._autoOpenTimer)
        }
    }
    return j
};
dhtmlXGridObject.prototype._autoOpenItem = function (a, c) {
    c.openItem(c._autoOpenId)
};
dhtmlXGridObject.prototype._dragOut = function (c) {
    this._clearMove();
    var a = c.parentNode.parentObject ? c.parentObject.id : c.parentNode.idd;
    this.callEvent("onDragOut", [a]);
    if (this._autoOpenTimer) {
        window.clearTimeout(this._autoOpenTimer)
    }
};
dhtmlXGridObject.prototype._setMove = function (l, c, n, j) {
    if (!l.parentNode.idd) {
        return
    }
    var g = getAbsoluteTop(l);
    var a = getAbsoluteTop(this.objBox);
    if ((g - a) > (parseInt(this.objBox.offsetHeight) - 50)) {
        this.objBox.scrollTop = parseInt(this.objBox.scrollTop) + 20
    }
    if ((g - a + parseInt(this.objBox.scrollTop)) < (parseInt(this.objBox.scrollTop) + 30)) {
        this.objBox.scrollTop = parseInt(this.objBox.scrollTop) - 20
    }
    if (j) {
        return 0
    }
    if (this.dadmode == 2) {
        var m = n - g + (document.body.scrollTop || document.documentElement.scrollTop) - 2 - l.offsetHeight / 2;
        if ((Math.abs(m) - l.offsetHeight / 6) > 0) {
            this.dadmodec = 1;
            if (m < 0) {
                this.dadmodefix = -1
            } else {
                this.dadmodefix = 1
            }
        } else {
            this.dadmodec = 0
        }
    } else {
        this.dadmodec = this.dadmode
    }
    if (this.dadmodec) {
        if (!this._sdrgc) {
            this._createSdrgc()
        }
        this._sdrgc.style.display = "block";
        this._sdrgc.style.top = g - a + parseInt(this.objBox.scrollTop) + ((this.dadmodefix >= 0) ? l.offsetHeight : 0) + "px"
    } else {
        this._llSelD = l;
        if (l.parentNode.tagName == "TR") {
            for (var h = 0; h < l.parentNode.childNodes.length; h++) {
                var m = l.parentNode.childNodes[h];
                m._bgCol = m.style.backgroundColor;
                m.style.backgroundColor = "#FFCCCC"
            }
        }
    }
};
dhtmlXGridObject.prototype._clearMove = function () {
    if (this._sdrgc) {
        this._sdrgc.style.display = "none"
    }
    if ((this._llSelD) && (this._llSelD.parentNode.tagName == "TR")) {
        var c = this._llSelD.parentNode.childNodes;
        for (var a = 0; a < c.length; a++) {
            c[a].style.backgroundColor = c[a]._bgCol
        }
    }
    this._llSelD = null
};
dhtmlXGridObject.prototype.rowToDragElement = function (a) {
    var c = this.cells(a, 0).getValue();
    return c
};
dhtmlXGridObject.prototype._copyUserData = function (h) {
    if (!h.tobj.UserData[h.nid] || h.tobj != h.sobj) {
        h.tobj.UserData[h.nid] = new Hashtable()
    } else {
        return
    }
    var g = h.sobj.UserData[h.sid];
    var a = h.tobj.UserData[h.nid];
    if (g) {
        a.keys = a.keys.concat(g.keys);
        a.values = a.values.concat(g.values)
    }
};
dhtmlXGridObject.prototype.moveRow = function (g, h, a, c) {
    switch (h) {
    case "row_sibling":
        this.moveRowTo(g, a, "move", "sibling", this, c);
        break;
    case "up":
        this.moveRowUp(g);
        break;
    case "down":
        this.moveRowDown(g);
        break
    }
};
dhtmlXGridObject.prototype._nonTrivialNode = function (r, q, m, n, g) {
    if ((r.callEvent) && (!g)) {
        if (!r.callEvent("onDrag", [n.idd, q.id, (m ? m.id : null), this, r])) {
            return false
        }
    }
    var o = n.idd;
    var a = o;
    while (r._idpull[a]) {
        a += (new Date()).getMilliseconds().toString()
    }
    var j = (this.isTreeGrid() ? this.getItemImage(o) : "");
    if (m) {
        for (h = 0; h < q.childsCount; h++) {
            if (q.childNodes[h] == m) {
                break
            }
        }
        if (h != 0) {
            m = q.childNodes[h - 1]
        } else {
            st = "TOP";
            m = ""
        }
    }
    var c = r._attachChildNode(q, a, this.gridToTreeElement(r, a, o), "", j, j, j, "", "", m);
    if (this._h2) {
        var l = this._h2.get[o];
        if (l.childs.length) {
            for (var h = 0; h < l.childs.length; h++) {
                this._nonTrivialNode(r, c, 0, this.rowsAr[l.childs[h].id], 1);
                if (!this.dpcpy) {
                    h--
                }
            }
        }
    }
    if (!this.dpcpy) {
        this.deleteRow(o)
    }
    if ((r.callEvent) && (!g)) {
        r.callEvent("onDrop", [a, q.id, (m ? m.id : null), this, r])
    }
};
dhtmlXGridObject.prototype.gridToTreeElement = function (c, g, a) {
    return this.cells(a, 0).getValue()
};
dhtmlXGridObject.prototype.treeToGridElement = function (h, j, a) {
    var c = new Array();
    var l = this.cellType._dhx_find("tree");
    if (l == -1) {
        l = 0
    }
    for (var g = 0; g < this.getColumnCount(); g++) {
        c[c.length] = (g != l) ? (h.getUserData(j, this.getColumnId(g)) || "") : h.getItemText(j)
    }
    return c
};
dhtmlXGridObject.prototype.moveRowTo = function (h, g, m, l, a, j) {
    var n = new dragContext((a || this).isTreeGrid() ? "treeGrid" : "grid", (j || this).isTreeGrid() ? "treeGrid" : "grid", m, l || "sibling", h, g, a || this, j || this);
    n.tobj._dragRoutine(n);
    n.close();
    return n.nid
};
dhtmlXGridObject.prototype.enableMercyDrag = function (a) {
    this.dpcpy = convertStringToBoolean(a)
};
dhtmlXGridObject.prototype.toPDF = function (h, q, v, s, n, A) {
    var j = {
        row: this.getSelectedRowId(),
        col: this.getSelectedCellIndex()
    };
    if (j.row === null || j.col === -1) {
        j = false
    } else {
        var c = this.cells(j.row, j.col).cell;
        c.parentNode.className = c.parentNode.className.replace(" rowselected", "");
        c.className = c.className.replace(" cellselected", "");
        j.el = c
    }
    q = q || "color";
    var w = q == "full_color";
    var a = this;
    a._asCDATA = true;
    if (typeof (A) === "undefined") {
        this.target = ' target="_blank"'
    } else {
        this.target = A
    }
    eXcell_ch.prototype.getContent = function () {
        return this.getValue()
    };
    eXcell_ra.prototype.getContent = function () {
        return this.getValue()
    };

    function y(E) {
        var L = [];
        for (var J = 1; J < a.hdr.rows.length; J++) {
            L[J] = [];
            for (var I = 0; I < a._cCount; I++) {
                var N = a.hdr.rows[J].childNodes[I];
                if (!L[J][I]) {
                    L[J][I] = [0, 0]
                }
                if (N) {
                    L[J][N._cellIndexS] = [N.colSpan, N.rowSpan]
                }
            }
        }
        var K = "<rows profile='" + E + "'";
        if (v) {
            K += " header='" + v + "'"
        }
        if (s) {
            K += " footer='" + s + "'"
        }
        K += "><head>" + a._serialiseExportConfig(L).replace(/^<head/, "<columns").replace(/head>$/, "columns>");
        for (var J = 2; J < a.hdr.rows.length; J++) {
            var C = 0;
            var Q = a.hdr.rows[J];
            var M = "";
            for (var I = 0; I < a._cCount; I++) {
                if ((a._srClmn && !a._srClmn[I]) || (a._hrrar[I] && (!a._fake || I >= a._fake.hdrLabels.length))) {
                    C++;
                    continue
                }
                var P = L[J][I];
                var O = ((P[0] && P[0] > 1) ? ' colspan="' + P[0] + '" ' : "");
                if (P[1] && P[1] > 1) {
                    O += ' rowspan="' + P[1] + '" ';
                    C = -1
                }
                var D = "";
                var H = Q;
                if (a._fake && I < a._fake._cCount) {
                    H = a._fake.hdr.rows[J]
                }
                for (var F = 0; F < H.cells.length; F++) {
                    if (H.cells[F]._cellIndexS == I) {
                        if (H.cells[F].getElementsByTagName("SELECT").length) {
                            D = ""
                        } else {
                            D = _isIE ? H.cells[F].innerText : H.cells[F].textContent
                        }
                        D = D.replace(/[ \n\r\t\xA0]+/, " ");
                        break
                    }
                }
                if (!D || D == " ") {
                    C++
                }
                M += "<column" + O + "><![CDATA[" + D + "]]></column>"
            }
            if (C != a._cCount) {
                K += "\n<columns>" + M + "</columns>"
            }
        }
        K += "</head>\n";
        K += o();
        return K
    }
    function g() {
        var C = [];
        if (n) {
            for (var D = 0; D < n.length; D++) {
                C.push(u(a.getRowIndex(n[D])))
            }
        } else {
            for (var D = 0; D < a.getRowsNum(); D++) {
                C.push(u(D))
            }
        }
        return C.join("\n")
    }
    function o() {
        var E = ["<foot>"];
        if (!a.ftr) {
            return ""
        }
        for (var F = 1; F < a.ftr.rows.length; F++) {
            E.push("<columns>");
            var J = a.ftr.rows[F];
            for (var D = 0; D < a._cCount; D++) {
                if (a._srClmn && !a._srClmn[D]) {
                    continue
                }
                if (a._hrrar[D] && (!a._fake || D >= a._fake.hdrLabels.length)) {
                    continue
                }
                for (var C = 0; C < J.cells.length; C++) {
                    var I = "";
                    var H = "";
                    if (J.cells[C]._cellIndexS == D) {
                        I = _isIE ? J.cells[C].innerText : J.cells[C].textContent;
                        I = I.replace(/[ \n\r\t\xA0]+/, " ");
                        if (J.cells[C].colSpan && J.cells[C].colSpan != 1) {
                            H = " colspan='" + J.cells[C].colSpan + "' "
                        }
                        if (J.cells[C].rowSpan && J.cells[C].rowSpan != 1) {
                            H = " rowspan='" + J.cells[C].rowSpan + "' "
                        }
                        break
                    }
                }
                E.push("<column" + H + "><![CDATA[" + I + "]]></column>")
            }
            E.push("</columns>")
        }
        E.push("</foot>");
        return E.join("\n")
    }
    function m(D, C) {
        return (window.getComputedStyle ? (window.getComputedStyle(D, null)[C]) : (D.currentStyle ? D.currentStyle[C] : null)) || ""
    }
    function u(F) {
        if (!a.rowsBuffer[F]) {
            return ""
        }
        var C = a.render_row(F);
        if (C.style.display == "none") {
            return ""
        }
        var D = a.isTreeGrid() ? ' level="' + a.getLevel(C.idd) + '"' : "";
        var K = "<row" + D + ">";
        for (var I = 0; I < a._cCount; I++) {
            if (((!a._srClmn) || (a._srClmn[I])) && (!a._hrrar[I] || (a._fake && I < a._fake.hdrLabels.length))) {
                var O = a.cells(C.idd, I);
                if (w) {
                    var H = m(O.cell, "color");
                    var N = m(O.cell, "backgroundColor");
                    var M = m(O.cell, "font-weight") || m(O.cell, "fontWeight");
                    var J = m(O.cell, "font-style") || m(O.cell, "fontStyle");
                    var L = m(O.cell, "text-align") || m(O.cell, "textAlign");
                    var E = m(O.cell, "font-family") || m(O.cell, "fontFamily");
                    if (N == "transparent" || N == "rgba(0, 0, 0, 0)") {
                        N = "rgb(255,255,255)"
                    }
                    K += "<cell bgColor='" + N + "' textColor='" + H + "' bold='" + M + "' italic='" + J + "' align='" + L + "' font='" + E + "'>"
                } else {
                    K += "<cell>"
                }
                K += "<![CDATA[" + (O.getContent ? O.getContent() : O.getTitle()) + "]]></cell>"
            }
        }
        return K + "</row>"
    }
    function r() {
        var C = "</rows>";
        return C
    }
    var x = document.createElement("div");
    x.style.display = "none";
    document.body.appendChild(x);
    var l = "form_" + a.uid();
    x.innerHTML = '<form id="' + l + '" method="post" action="' + h + '" accept-charset="utf-8"  enctype="application/x-www-form-urlencoded"' + this.target + '><input type="hidden" name="grid_xml" id="grid_xml"/> </form>';
    document.getElementById(l).firstChild.value = encodeURIComponent(y(q).replace("\u2013", "-") + g() + r());
    document.getElementById(l).submit();
    x.parentNode.removeChild(x);
    a = null;
    if (j) {
        j.el.parentNode.className += " rowselected";
        j.el.className += " cellselected"
    }
    j = null
};
dhtmlXGridObject.prototype._serialiseExportConfig = function (m) {
    function l(j) {
        if (typeof (j) !== "string") {
            return j
        }
        j = j.replace(/&/g, "&amp;");
        j = j.replace(/"/g, "&quot;");
        j = j.replace(/'/g, "&apos;");
        j = j.replace(/</g, "&lt;");
        j = j.replace(/>/g, "&gt;");
        return j
    }
    var c = "<head>";
    for (var g = 0; g < this.hdr.rows[0].cells.length; g++) {
        if (this._srClmn && !this._srClmn[g]) {
            continue
        }
        if (this._hrrar[g] && (!this._fake || g >= this._fake.hdrLabels.length)) {
            continue
        }
        var h = this.fldSort[g];
        if (h == "cus") {
            h = this._customSorts[g].toString();
            h = h.replace(/function[\ ]*/, "").replace(/\([^\f]*/, "")
        }
        var q = m[1][g];
        var n = ((q[1] && q[1] > 1) ? ' rowspan="' + q[1] + '" ' : "") + ((q[0] && q[0] > 1) ? ' colspan="' + q[0] + '" ' : "");
        c += "<column " + n + " width='" + this.getColWidth(g) + "' align='" + this.cellAlign[g] + "' type='" + this.cellType[g] + "' hidden='" + ((this.isColumnHidden && this.isColumnHidden(g)) ? "true" : "false") + "' sort='" + (h || "na") + "' color='" + (this.columnColor[g] || "") + "'" + (this.columnIds[g] ? (" id='" + this.columnIds[g] + "'") : "") + ">";
        if (this._asCDATA) {
            c += "<![CDATA[" + this.getHeaderCol(g) + "]]>"
        } else {
            c += this.getHeaderCol(g)
        }
        var o = this.combos[g] ? this.getCombo(g) : null;
        if (o) {
            for (var a = 0; a < o.keys.length; a++) {
                c += "<option value='" + l(o.keys[a]) + "'><![CDATA[" + o.values[a] + "]]></option>"
            }
        }
        c += "</column>"
    }
    return c += "</head>"
};
if (window.eXcell_sub_row_grid) {
    window.eXcell_sub_row_grid.prototype.getContent = function () {
        return ""
    }
}
dhtmlXGridObject.prototype.toExcel = function (a, h, m, l, c) {
    if (!document.getElementById("ifr")) {
        var j = document.createElement("iframe");
        j.style.display = "none";
        j.setAttribute("name", "dhx_export_iframe");
        j.setAttribute("src", "");
        j.setAttribute("id", "dhx_export_iframe");
        document.body.appendChild(j)
    }
    var g = ' target="dhx_export_iframe"';
    this.toPDF(a, h, m, l, c, g)
};
dhtmlXGridObject.prototype.filterBy = function (g, h, c) {
    if (this.isTreeGrid()) {
        return this.filterTreeBy(g, h, c)
    }
    if (this._f_rowsBuffer) {
        if (!c) {
            this.rowsBuffer = dhtmlxArray([].concat(this._f_rowsBuffer));
            if (this._fake) {
                this._fake.rowsBuffer = this.rowsBuffer
            }
        }
    } else {
        this._f_rowsBuffer = [].concat(this.rowsBuffer)
    }
    if (!this.rowsBuffer.length) {
        return
    }
    var l = true;
    this.dma(true);
    if (typeof (g) == "object") {
        for (var a = 0; a < h.length; a++) {
            this._filterA(g[a], h[a])
        }
    } else {
        this._filterA(g, h)
    }
    this.dma(false);
    if (this.pagingOn && this.rowsBuffer.length / this.rowsBufferOutSize < (this.currentPage - 1)) {
        this.changePage(0)
    }
    this._reset_view();
    this.callEvent("onGridReconstructed", [])
};
dhtmlXGridObject.prototype._filterA = function (c, g) {
    if (g == "") {
        return
    }
    var h = true;
    if (typeof (g) == "function") {
        h = false
    } else {
        g = (g || "").toString().toLowerCase()
    }
    if (!this.rowsBuffer.length) {
        return
    }
    for (var a = this.rowsBuffer.length - 1; a >= 0; a--) {
        if (h ? (this._get_cell_value(this.rowsBuffer[a], c).toString().toLowerCase().indexOf(g) == -1) : (!g.call(this, this._get_cell_value(this.rowsBuffer[a], c), this.rowsBuffer[a].idd))) {
            this.rowsBuffer.splice(a, 1)
        }
    }
};
dhtmlXGridObject.prototype.getFilterElement = function (a) {
    if (!this.filters) {
        return
    }
    for (var c = 0; c < this.filters.length; c++) {
        if (this.filters[c][1] == a) {
            return (this.filters[c][0].combo || this.filters[c][0])
        }
    }
    return null
};
dhtmlXGridObject.prototype.collectValues = function (h) {
    var q = this.callEvent("onCollectValues", [h]);
    if (q !== true) {
        return q
    }
    if (this.isTreeGrid()) {
        return this.collectTreeValues(h)
    }
    this.dma(true);
    this._build_m_order();
    h = this._m_order ? this._m_order[h] : h;
    var n = {};
    var l = [];
    var g = this._f_rowsBuffer || this.rowsBuffer;
    for (var j = 0; j < g.length; j++) {
        var a = this._get_cell_value(g[j], h);
        if (a && (!g[j]._childIndexes || g[j]._childIndexes[h] != g[j]._childIndexes[h - 1])) {
            n[a] = true
        }
    }
    this.dma(false);
    var o = (this.combos[h] || (this._col_combos ? this._col_combos[h] : false));
    for (var m in n) {
        if (n[m] === true) {
            if (o) {
                if (o.get && o.get(m)) {
                    m = o.get(m)
                } else {
                    if (o.getOption && o.getOption(m)) {
                        m = o.getOption(m).text
                    }
                }
            }
            l.push(m)
        }
    }
    return l.sort()
};
dhtmlXGridObject.prototype._build_m_order = function () {
    if (this._c_order) {
        this._m_order = [];
        for (var a = 0; a < this._c_order.length; a++) {
            this._m_order[this._c_order[a]] = a
        }
    }
};
dhtmlXGridObject.prototype.filterByAll = function () {
    var g = [];
    var c = [];
    this._build_m_order();
    for (var h = 0; h < this.filters.length; h++) {
        var l = this._m_order ? this._m_order[this.filters[h][1]] : this.filters[h][1];
        if (l >= this._cCount) {
            continue
        }
        c.push(l);
        var m = this.filters[h][0].old_value = this.filters[h][0].value;
        if (this.filters[h][0]._filter) {
            m = this.filters[h][0]._filter()
        }
        var j;
        if (typeof m != "function" && (j = (this.combos[l] || (this._col_combos ? this._col_combos[l] : false)))) {
            if (j.values) {
                l = j.values._dhx_find(m);
                m = (l == -1) ? m : j.keys[l]
            } else {
                if (j.getOptionByLabel) {
                    m = (j.getOptionByLabel(m) ? j.getOptionByLabel(m).value : m)
                }
            }
        }
        g.push(m)
    }
    if (!this.callEvent("onFilterStart", [c, g])) {
        return
    }
    this.filterBy(c, g);
    if (this._cssEven) {
        this._fixAlterCss()
    }
    this.callEvent("onFilterEnd", [this.filters]);
    if (this._f_rowsBuffer && this.rowsBuffer.length == this._f_rowsBuffer.length) {
        this._f_rowsBuffer = null
    }
};
dhtmlXGridObject.prototype.makeFilter = function (j, g, c) {
    if (!this.filters) {
        this.filters = []
    }
    if (typeof (j) != "object") {
        j = document.getElementById(j)
    }
    if (!j) {
        return
    }
    var a = this;
    if (!j.style.width) {
        j.style.width = "90%"
    }
    if (j.tagName == "SELECT") {
        this.filters.push([j, g]);
        this._loadSelectOptins(j, g);
        j.onchange = function () {
            a.filterByAll()
        };
        if (_isIE) {
            j.style.marginTop = "1px"
        }
        this.attachEvent("onEditCell", function (m, l, n) {
            this._build_m_order();
            if (m == 2 && this.filters && (this._m_order ? (n == this._m_order[g]) : (n == g))) {
                this._loadSelectOptins(j, g)
            }
            return true
        })
    } else {
        if (j.tagName == "INPUT") {
            this.filters.push([j, g]);
            j.old_value = j.value = "";
            j.onkeydown = function () {
                if (this._timer) {
                    window.clearTimeout(this._timer)
                }
                this._timer = window.setTimeout(function () {
                    if (j.value != j.old_value) {
                        a.filterByAll();
                        j.old_value = j.value
                    }
                }, 500)
            }
        } else {
            if (j.tagName == "DIV" && j.className == "combo") {
                this.filters.push([j, g]);
                j.style.padding = "0px";
                j.style.margin = "0px";
                if (!window.dhx_globalImgPath) {
                    window.dhx_globalImgPath = this.imgURL
                }
                var h = new dhtmlXCombo(j, "_filter", "90%");
                h.filterSelfA = h.filterSelf;
                h.filterSelf = function () {
                    if (this.getSelectedIndex() == 0) {
                        this.setComboText("")
                    }
                    this.filterSelfA.apply(this, arguments);
                    this.optionsArr[0].hide(false)
                };
                h.enableFilteringMode(true);
                j.combo = h;
                j.value = "";
                this._loadComboOptins(j, g);
                h.attachEvent("onChange", function () {
                    j.value = h.getSelectedValue();
                    if (j.value === null) {
                        j.value = ""
                    }
                    a.filterByAll()
                })
            }
        }
    }
    if (j.parentNode) {
        j.parentNode.className += " filter"
    }
    this._filters_ready()
};
dhtmlXGridObject.prototype.findCell = function (m, n, h, l) {
    var l = l || (function (o, j) {
        return j.toString().toLowerCase().indexOf(o) != -1
    });
    if (l === true) {
        l = function (o, j) {
            return j.toString().toLowerCase() == o
        }
    }
    var g = new Array();
    m = m.toString().toLowerCase();
    if (typeof h != "number") {
        h = h ? 1 : 0
    }
    if (!this.rowsBuffer.length) {
        return g
    }
    for (var c = (n || 0); c < this._cCount; c++) {
        if (this._h2) {
            this._h2.forEachChild(0, function (j) {
                if (h && g.length == h) {
                    return g
                }
                if (l(m, this._get_cell_value(j.buff, c))) {
                    g.push([j.id, c])
                }
            }, this)
        } else {
            for (var a = 0; a < this.rowsBuffer.length; a++) {
                if (l(m, this._get_cell_value(this.rowsBuffer[a], c))) {
                    g.push([this.rowsBuffer[a].idd, c]);
                    if (h && g.length == h) {
                        return g
                    }
                }
            }
        }
        if (typeof (n) != "undefined") {
            return g
        }
    }
    return g
};
dhtmlXGridObject.prototype.makeSearch = function (h, g, a) {
    if (typeof (h) != "object") {
        h = document.getElementById(h)
    }
    if (!h) {
        return
    }
    var c = this;
    if (h.tagName == "INPUT") {
        h.onkeypress = function () {
            if (this._timer) {
                window.clearTimeout(this._timer)
            }
            this._timer = window.setTimeout(function () {
                if (h.value == "") {
                    return
                }
                var j = c.findCell(h.value, g, true, a);
                if (j.length) {
                    if (c._h2) {
                        c.openItem(j[0][0])
                    }
                    c.selectCell(c.getRowIndex(j[0][0]), (g || 0))
                }
            }, 500)
        }
    }
    if (h.parentNode) {
        h.parentNode.className += " filter"
    }
};
dhtmlXGridObject.prototype._loadSelectOptins = function (j, n) {
    var a = this.collectValues(n);
    var g = j.value;
    j.innerHTML = "";
    j.options[0] = new Option("", "");
    var m = this._filter_tr ? this._filter_tr[n] : null;
    for (var h = 0; h < a.length; h++) {
        j.options[j.options.length] = new Option(m ? m(a[h]) : a[h], a[h])
    }
    j.value = g
};
dhtmlXGridObject.prototype.setSelectFilterLabel = function (c, a) {
    if (!this._filter_tr) {
        this._filter_tr = []
    }
    this._filter_tr[c] = a
};
dhtmlXGridObject.prototype._loadComboOptins = function (h, m) {
    if (!h.combo) {
        return
    }
    var a = this.collectValues(m);
    h.combo.clearAll();
    var j = [
        ["", ""]
    ];
    for (var g = 0; g < a.length; g++) {
        j.push([a[g], a[g]])
    }
    h.combo.addOption(j)
};
dhtmlXGridObject.prototype.refreshFilters = function () {
    if (!this.filters) {
        return
    }
    for (var a = 0; a < this.filters.length; a++) {
        switch (this.filters[a][0].tagName.toLowerCase()) {
        case "input":
            break;
        case "select":
            this._loadSelectOptins.apply(this, this.filters[a]);
            break;
        case "div":
            this._loadComboOptins.apply(this, this.filters[a]);
            break
        }
    }
};
dhtmlXGridObject.prototype._filters_ready = function (c, a) {
    this.attachEvent("onXLE", this.refreshFilters);
    this.attachEvent("onRowCreated", function (j, h) {
        if (this._f_rowsBuffer) {
            for (var g = 0; g < this._f_rowsBuffer.length; g++) {
                if (this._f_rowsBuffer[g].idd == j) {
                    return this._f_rowsBuffer[g] = h
                }
            }
        }
    });
    this.attachEvent("onClearAll", function () {
        this._f_rowsBuffer = null;
        if (!this.hdr.rows.length) {
            this.filters = []
        }
    });
    this.attachEvent("onSetSizes", this._filters_resize_combo);
    this.attachEvent("onResize", this._filters_resize_combo);
    this._filters_ready = function () {}
};
dhtmlXGridObject.prototype._filters_resize_combo = function () {
    if (!this.filters) {
        return
    }
    for (var a = 0; a < this.filters.length; a++) {
        if (this.filters[a][0].combo != null) {
            this.filters[a][0].combo.setSize(Math.round(this.filters[a][0].offsetWidth * 90 / 100))
        }
    }
    return true
};
dhtmlXGridObject.prototype._in_header_text_filter = function (c, a) {
    c.innerHTML = "<input type='text'>";
    c.onclick = c.onmousedown = function (g) {
        (g || event).cancelBubble = true;
        return true
    };
    c.onselectstart = function () {
        return (event.cancelBubble = true)
    };
    this.makeFilter(c.firstChild, a)
};
dhtmlXGridObject.prototype._in_header_text_filter_inc = function (c, a) {
    c.innerHTML = "<input type='text'>";
    c.onclick = c.onmousedown = function (g) {
        (g || event).cancelBubble = true;
        return true
    };
    c.onselectstart = function () {
        return (event.cancelBubble = true)
    };
    this.makeFilter(c.firstChild, a);
    c.firstChild._filter = function () {
        if (c.firstChild.value == "") {
            return ""
        }
        return function (g) {
            return (g.toString().toLowerCase().indexOf(c.firstChild.value.toLowerCase()) == 0)
        }
    };
    this._filters_ready()
};
dhtmlXGridObject.prototype._in_header_select_filter = function (c, a) {
    c.innerHTML = "<select></select>";
    c.onclick = function (g) {
        (g || event).cancelBubble = true;
        return false
    };
    this.makeFilter(c.firstChild, a)
};
dhtmlXGridObject.prototype._in_header_select_filter_strict = function (g, c) {
    g.innerHTML = "<select style='width:90%; font-size:8pt; font-family:Tahoma;'></select>";
    g.onclick = function (h) {
        (h || event).cancelBubble = true;
        return false
    };
    this.makeFilter(g.firstChild, c);
    var a = this.combos;
    g.firstChild._filter = function () {
        var h = g.firstChild.value;
        if (!h) {
            return ""
        }
        if (a[c]) {
            h = a[c].keys[a[c].values._dhx_find(h)]
        }
        h = h.toLowerCase();
        return function (j) {
            return (j.toString().toLowerCase() == h)
        }
    };
    this._filters_ready()
};
dhtmlXGridObject.prototype._in_header_combo_filter = function (c, a) {
    c.innerHTML = "<div style='width:100%; padding-left:2px; overflow:hidden; ' class='combo'></div>";
    c.onselectstart = function () {
        return (event.cancelBubble = true)
    };
    c.onclick = c.onmousedown = function (g) {
        (g || event).cancelBubble = true;
        return true
    };
    this.makeFilter(c.firstChild, a)
};
dhtmlXGridObject.prototype._search_common = function (c, a) {
    c.innerHTML = "<input type='text' style='width:90%; '>";
    c.onclick = c.onmousedown = function (g) {
        (g || event).cancelBubble = true;
        return true
    };
    c.onselectstart = function () {
        return (event.cancelBubble = true)
    }
};
dhtmlXGridObject.prototype._in_header_text_search = function (g, c, a) {
    this._search_common(g, c);
    this.makeSearch(g.firstChild, c)
};
dhtmlXGridObject.prototype._in_header_text_search_strict = function (c, a) {
    this._search_common(c, a);
    this.makeSearch(c.firstChild, a, true)
};
dhtmlXGridObject.prototype._in_header_numeric_filter = function (c, a) {
    this._in_header_text_filter.call(this, c, a);
    c.firstChild._filter = function () {
        var g = this.value;
        var j;
        var m = "==";
        var h = parseFloat(g.replace("=", ""));
        var l = null;
        if (g) {
            if (g.indexOf("..") != -1) {
                g = g.split("..");
                h = parseFloat(g[0]);
                l = parseFloat(g[1]);
                return function (n) {
                    if (n >= h && n <= l) {
                        return true
                    }
                    return false
                }
            }
            j = g.match(/>=|<=|>|</);
            if (j) {
                m = j[0];
                h = parseFloat(g.replace(m, ""))
            }
            return Function("v", " if (v " + m + " " + h + " ) return true; return false;")
        }
        return ""
    }
};
dhtmlXGridObject.prototype._in_header_master_checkbox = function (h, g, j) {
    h.innerHTML = j[0] + "<input type='checkbox' />" + j[1];
    var a = this;
    h.getElementsByTagName("input")[0].onclick = function (l) {
        a._build_m_order();
        var c = a._m_order ? a._m_order[g] : g;
        var m = this.checked ? 1 : 0;
        a.forEachRowA(function (o) {
            var n = this.cells(o, c);
            if (n.isCheckbox()) {
                n.setValue(m);
                n.cell.wasChanged = true
            }
            this.callEvent("onEditCell", [1, o, c, m]);
            this.callEvent("onCheckbox", [o, c, m])
        });
        (l || event).cancelBubble = true
    }
};
dhtmlXGridObject.prototype._in_header_stat_total = function (g, a, j) {
    var h = function () {
            var n = 0;
            this._build_m_order();
            var m = this._m_order ? this._m_order[a] : a;
            for (var l = 0; l < this.rowsBuffer.length; l++) {
                var c = parseFloat(this._get_cell_value(this.rowsBuffer[l], m));
                n += isNaN(c) ? 0 : c
            }
            return this._maskArr[m] ? this._aplNF(n, m) : (Math.round(n * 100) / 100)
        };
    this._stat_in_header(g, h, a, j, j)
};
dhtmlXGridObject.prototype._in_header_stat_multi_total = function (j, h, o) {
    var n = o[1].split(":");
    o[1] = "";
    for (var g = 0; g < n.length; g++) {
        n[g] = parseInt(n[g])
    }
    var l = function () {
            var s = 0;
            for (var r = 0; r < this.rowsBuffer.length; r++) {
                var q = 1;
                for (var c = 0; c < n.length; c++) {
                    q *= parseFloat(this._get_cell_value(this.rowsBuffer[r], n[c]))
                }
                s += isNaN(q) ? 0 : q
            }
            return this._maskArr[h] ? this._aplNF(s, h) : (Math.round(s * 100) / 100)
        };
    var a = [];
    for (var m = 0; m < n.length; m++) {
        a[n[m]] = true
    }
    this._stat_in_header(j, l, a, o, o)
};
dhtmlXGridObject.prototype._in_header_stat_max = function (g, a, j) {
    var h = function () {
            this._build_m_order();
            var l = this._m_order ? this._m_order[a] : a;
            var m = -999999999;
            if (this.getRowsNum() == 0) {
                return "&nbsp;"
            }
            for (var c = 0; c < this.rowsBuffer.length; c++) {
                m = Math.max(m, parseFloat(this._get_cell_value(this.rowsBuffer[c], l)))
            }
            return this._maskArr[a] ? this._aplNF(m, a) : m
        };
    this._stat_in_header(g, h, a, j)
};
dhtmlXGridObject.prototype._in_header_stat_min = function (g, a, j) {
    var h = function () {
            this._build_m_order();
            var l = this._m_order ? this._m_order[a] : a;
            var m = 999999999;
            if (this.getRowsNum() == 0) {
                return "&nbsp;"
            }
            for (var c = 0; c < this.rowsBuffer.length; c++) {
                m = Math.min(m, parseFloat(this._get_cell_value(this.rowsBuffer[c], l)))
            }
            return this._maskArr[a] ? this._aplNF(m, a) : m
        };
    this._stat_in_header(g, h, a, j)
};
dhtmlXGridObject.prototype._in_header_stat_average = function (g, a, j) {
    var h = function () {
            this._build_m_order();
            var m = this._m_order ? this._m_order[a] : a;
            var o = 0;
            var n = 0;
            if (this.getRowsNum() == 0) {
                return "&nbsp;"
            }
            for (var l = 0; l < this.rowsBuffer.length; l++) {
                var c = parseFloat(this._get_cell_value(this.rowsBuffer[l], m));
                o += isNaN(c) ? 0 : c;
                n++
            }
            return this._maskArr[a] ? this._aplNF(o / n, a) : (Math.round(o / n * 100) / 100)
        };
    this._stat_in_header(g, h, a, j)
};
dhtmlXGridObject.prototype._in_header_stat_count = function (g, a, j) {
    var h = function () {
            return this.getRowsNum()
        };
    this._stat_in_header(g, h, a, j)
};
dhtmlXGridObject.prototype._stat_in_header = function (g, h, a, m) {
    var j = this;
    var l = function () {
            this.dma(true);
            g.innerHTML = (m[0] ? m[0] : "") + h.call(this) + (m[1] ? m[1] : "");
            this.dma(false);
            this.callEvent("onStatReady", [])
        };
    if (!this._stat_events) {
        this._stat_events = [];
        this.attachEvent("onClearAll", function () {
            if (!this.hdr.rows[1]) {
                for (var n = 0; n < this._stat_events.length; n++) {
                    for (var c = 0; c < 4; c++) {
                        this.detachEvent(this._stat_events[n][c])
                    }
                }
                this._stat_events = []
            }
        })
    }
    this._stat_events.push([this.attachEvent("onGridReconstructed", l), this.attachEvent("onXLE", l), this.attachEvent("onFilterEnd", l), this.attachEvent("onEditCell", function (c, o, n) {
        if (c == 2 && (n == a || (a && a[n]))) {
            l.call(this)
        }
        return true
    })]);
    g.innerHTML = ""
};
dhtmlXGridObject.prototype.loadCSVFile = function (c, a) {
    this.load(c, a, "csv")
};
dhtmlXGridObject.prototype.enableCSVAutoID = function (a) {
    this._csvAID = convertStringToBoolean(a)
};
dhtmlXGridObject.prototype.enableCSVHeader = function (a) {
    this._csvHdr = convertStringToBoolean(a)
};
dhtmlXGridObject.prototype.setCSVDelimiter = function (a) {
    this.csv.cell = a
};
dhtmlXGridObject.prototype._csvAID = true;
dhtmlXGridObject.prototype.loadCSVString = function (a) {
    this.parse(a, "csv")
};
dhtmlXGridObject.prototype.serializeToCSV = function (o) {
    this.editStop();
    if (this._mathSerialization) {
        this._agetm = "getMathValue"
    } else {
        if (this._strictText || o) {
            this._agetm = "getTitle"
        } else {
            this._agetm = "getValue"
        }
    }
    var m = [];
    if (this._csvHdr) {
        for (var l = 1; l < this.hdr.rows.length; l++) {
            var c = [];
            for (var n = 0; n < this._cCount; n++) {
                if ((!this._srClmn) || (this._srClmn[n])) {
                    c.push(this.getColumnLabel(n, l - 1))
                }
            }
            m.push(this.csvParser.str(c, this.csv.cell, this.csv.row))
        }
    }
    var n = 0;
    var h = this.rowsBuffer.length;
    for (n; n < h; n++) {
        var g = this._serializeRowToCVS(null, n);
        if (g != "") {
            m.push(g)
        }
    }
    return this.csvParser.block(m, this.csv.row)
};
dhtmlXGridObject.prototype._serializeRowToCVS = function (a, o, g, m) {
    var n = new Array();
    if (!a) {
        a = this.render_row(o);
        if (this._fake && !this._fake.rowsAr[a.idd]) {
            this._fake.render_row(o)
        }
    }
    if (!this._csvAID) {
        n[n.length] = a.idd
    }
    g = g || 0;
    m = m || this._cCount;
    var s = false;
    var h = g;
    while (a.childNodes[g]._cellIndex > h && g) {
        g--
    }
    for (var q = g; h < m; q++) {
        if (!a.childNodes[q]) {
            break
        }
        var c = a.childNodes[q]._cellIndex;
        if (((!this._srClmn) || (this._srClmn[c])) && (!this._serialize_visible || !this._hrrar[c])) {
            var j = a.childNodes[q];
            var l = this.cells(a.idd, c);
            while (h != c) {
                h++;
                n.push("");
                if (h >= m) {
                    break
                }
            }
            if (h >= m) {
                break
            }
            h++;
            if (l.cell) {
                zxVal = l[this._agetm]()
            } else {
                zxVal = ""
            }
            if ((this._chAttr) && (l.wasChanged())) {
                s = true
            }
            n[n.length] = ((zxVal === null) ? "" : zxVal);
            if (this._ecspn && j.colSpan && j.colSpan > 1) {
                j = j.colSpan - 1;
                for (var v = 0; v < j; v++) {
                    n[n.length] = "";
                    h++
                }
            }
        } else {
            h++
        }
    }
    if ((this._onlChAttr) && (!s)) {
        return ""
    }
    return this.csvParser.str(n, this.csv.cell, this.csv.row)
};
dhtmlXGridObject.prototype.toClipBoard = function (a) {
    if (window.clipboardData) {
        window.clipboardData.setData("Text", a)
    } else {
        (new Clipboard()).copy(a)
    }
};
dhtmlXGridObject.prototype.fromClipBoard = function () {
    if (window.clipboardData) {
        return window.clipboardData.getData("Text")
    } else {
        return (new Clipboard()).paste()
    }
};
dhtmlXGridObject.prototype.cellToClipboard = function (g, c) {
    if ((!g) || (!c)) {
        if (!this.selectedRows[0]) {
            return
        }
        g = this.selectedRows[0].idd;
        c = this.cell._cellIndex
    }
    var a = this.cells(g, c);
    this.toClipBoard(((a.getLabel ? a.getLabel() : a.getValue()) || "").toString())
};
dhtmlXGridObject.prototype.updateCellFromClipboard = function (g, c) {
    if ((!g) || (!c)) {
        if (!this.selectedRows[0]) {
            return
        }
        g = this.selectedRows[0].idd;
        c = this.cell._cellIndex
    }
    var a = this.cells(g, c);
    a[a.setImage ? "setLabel" : "setValue"](this.fromClipBoard())
};
dhtmlXGridObject.prototype.rowToClipboard = function (h) {
    var a = "";
    if (this._mathSerialization) {
        this._agetm = "getMathValue"
    } else {
        if (this._strictText) {
            this._agetm = "getTitle"
        } else {
            this._agetm = "getValue"
        }
    }
    this._serialize_visible = true;
    if (h) {
        a = this._serializeRowToCVS(this.getRowById(h))
    } else {
        var g = [];
        for (var c = 0; c < this.selectedRows.length; c++) {
            g[g.length] = this._serializeRowToCVS(this.selectedRows[c]);
            a = this.csvParser.block(g, this.csv.row)
        }
    }
    this._serialize_visible = false;
    this.toClipBoard(a)
};
dhtmlXGridObject.prototype.updateRowFromClipboard = function (j) {
    var a = this.fromClipBoard();
    if (!a) {
        return
    }
    if (j) {
        var h = this.getRowById(j)
    } else {
        var h = this.selectedRows[0]
    }
    if (!h) {
        return
    }
    var l = this.csvParser;
    a = l.unblock(a, this.csv.cell, this.csv.row)[0];
    if (!this._csvAID) {
        a.splice(0, 1)
    }
    for (var g = 0; g < a.length; g++) {
        var c = this.cells3(h, g);
        c[c.setImage ? "setLabel" : "setValue"](a[g])
    }
};
dhtmlXGridObject.prototype.csvParser = {
    block: function (a, c) {
        return a.join(c)
    },
    unblock: function (l, a, j) {
        var h = (l || "").split(j);
        for (var c = 0; c < h.length; c++) {
            h[c] = (h[c] || "").split(a)
        }
        var g = h.length - 1;
        if (h[g].length == 1 && h[g][0] == "") {
            h.splice(g, 1)
        }
        return h
    },
    str: function (c, a, g) {
        return c.join(a)
    }
};
dhtmlXGridObject.prototype.csvExtParser = {
    _quote: RegExp('"', "g"),
    _quote_esc: RegExp('\\\\"', "g"),
    block: function (a, c) {
        return a.join(c)
    },
    unblock: function (n, r, u) {
        var g = [
            []
        ];
        var c = 0;
        if (!n) {
            return g
        }
        var o = /^[ ]*"/;
        var m = /"[ ]*$/;
        var a = new RegExp(".*" + u + ".*$");
        var j = n.split(r);
        for (var h = 0; h < j.length; h++) {
            if (j[h].match(o)) {
                var s = j[h].replace(o, "");
                while (!j[h].match(m)) {
                    h++;
                    s += j[h]
                }
                g[c].push(s.replace(m, "").replace(this._quote_esc, '"'))
            } else {
                if (j[h].match(a)) {
                    var l = j[h].indexOf(u);
                    g[c].push(j[h].substr(0, l));
                    c++;
                    g[c] = [];
                    j[h] = j[h].substr(l + 1);
                    h--
                } else {
                    if (j[h] || h != j.length - 1) {
                        g[c].push(j[h])
                    }
                }
            }
        }
        var q = g.length - 1;
        if (q > 0 && !g[q].length) {
            g.splice(q, 1)
        }
        return g
    },
    str: function (g, a, h) {
        for (var c = 0; c < g.length; c++) {
            g[c] = '"' + g[c].replace(this._quote, '\\"') + '"'
        }
        return g.join(a)
    }
};
dhtmlXGridObject.prototype.addRowFromClipboard = function () {
    var a = this.fromClipBoard();
    if (!a) {
        return
    }
    var g = this.csvParser.unblock(a, this.csv.cell, this.csv.row);
    for (var c = 0; c < g.length; c++) {
        if (g[c]) {
            a = g[c];
            if (!a.length) {
                continue
            }
            if (this._csvAID) {
                this.addRow(this.getRowsNum() + 2, a)
            } else {
                if (this.rowsAr[a[0]]) {
                    a[0] = this.uid()
                }
                this.addRow(a[0], a.slice(1))
            }
        }
    }
};
dhtmlXGridObject.prototype.gridToClipboard = function () {
    this.toClipBoard(this.serializeToCSV())
};
dhtmlXGridObject.prototype.gridFromClipboard = function () {
    var a = this.fromClipBoard();
    if (!a) {
        return
    }
    this.loadCSVString(a)
};
dhtmlXGridObject.prototype.getXLS = function (m) {
    if (!this.xslform) {
        this.xslform = document.createElement("FORM");
        this.xslform.action = (m || "") + "xls.php";
        this.xslform.method = "post";
        this.xslform.target = (_isIE ? "_blank" : "");
        document.body.appendChild(this.xslform);
        var j = document.createElement("INPUT");
        j.type = "hidden";
        j.name = "csv";
        this.xslform.appendChild(j);
        var h = document.createElement("INPUT");
        h.type = "hidden";
        h.name = "csv_header";
        this.xslform.appendChild(h)
    }
    var n = this.serializeToCSV();
    this.xslform.childNodes[0].value = n;
    var g = [];
    var a = this._cCount;
    for (var c = 0; c < a; c++) {
        g.push(this.getHeaderCol(c))
    }
    g = g.join(",");
    this.xslform.childNodes[1].value = g;
    this.xslform.submit()
};
dhtmlXGridObject.prototype.printView = function (s, g) {
    var q = "<style>TD { font-family:Arial; text-align:center; padding-left:2px;padding-right:2px; } \n td.filter input, td.filter select { display:none; }	\n  </style>";
    var C = null;
    if (this._fake) {
        C = [].concat(this._hrrar);
        for (var A = 0; A < this._fake._cCount; A++) {
            this._hrrar[A] = null
        }
    }
    q += "<base  href='" + document.location.href + "'></base>";
    if (!this.parentGrid) {
        q += (s || "")
    }
    q += '<table width="100%" border="2px" cellpadding="0" cellspacing="0">';
    var r = Math.max(this.rowsBuffer.length, this.rowsCol.length);
    var o = this._cCount;
    var u = this._printWidth();
    q += '<tr class="header_row_1">';
    for (var A = 0; A < o; A++) {
        if (this._hrrar && this._hrrar[A]) {
            continue
        }
        var l = this.hdr.rows[1].cells[this.hdr.rows[1]._childIndexes ? this.hdr.rows[1]._childIndexes[parseInt(A)] : A];
        var a = (l.colSpan || 1);
        var H = (l.rowSpan || 1);
        for (var y = 1; y < a; y++) {
            u[A] += u[y]
        }
        q += '<td rowspan="' + H + '" width="' + u[A] + '%" style="background-color:lightgrey;" colspan="' + a + '">' + this.getHeaderCol(A) + "</td>";
        A += a - 1
    }
    q += "</tr>";
    for (var A = 2; A < this.hdr.rows.length; A++) {
        if (_isIE) {
            q += "<tr style='background-color:lightgrey' class='header_row_" + A + "'>";
            var h = this.hdr.rows[A].childNodes;
            for (var y = 0; y < h.length; y++) {
                if (!this._hrrar || !this._hrrar[h[y]._cellIndex]) {
                    q += h[y].outerHTML
                }
            }
            q += "</tr>"
        } else {
            q += "<tr class='header_row_" + A + "' style='background-color:lightgrey'>" + (this._fake ? this._fake.hdr.rows[A].innerHTML : "") + this.hdr.rows[A].innerHTML + "</tr>"
        }
    }
    for (var A = 0; A < r; A++) {
        q += "<tr>";
        if (this.rowsCol[A] && this.rowsCol[A]._cntr) {
            q += this.rowsCol[A].innerHTML.replace(/<img[^>]*>/gi, "") + "</tr>";
            continue
        }
        if (this.rowsCol[A] && this.rowsCol[A].style.display == "none") {
            continue
        }
        var n;
        if (this.rowsCol[A]) {
            n = this.rowsCol[A].idd
        } else {
            if (this.rowsBuffer[A]) {
                n = this.rowsBuffer[A].idd
            } else {
                continue
            }
        }
        for (var y = 0; y < o; y++) {
            if (this._hrrar && this._hrrar[y]) {
                continue
            }
            if (this.rowsAr[n] && this.rowsAr[n].tagName == "TR") {
                var F = this.cells(n, y);
                if (F._setState) {
                    var v = ""
                } else {
                    if (F.getContent) {
                        v = F.getContent()
                    } else {
                        if (F.getImage || F.combo) {
                            var v = F.cell.innerHTML
                        } else {
                            var v = F.getValue()
                        }
                    }
                }
            } else {
                var v = this._get_cell_value(this.rowsBuffer[A], y)
            }
            var w = this.columnColor[y] ? "background-color:" + this.columnColor[y] + ";" : "";
            var x = this.cellAlign[y] ? "text-align:" + this.cellAlign[y] + ";" : "";
            var D = F.getAttribute("colspan");
            q += '<td style="' + w + x + '" ' + (D ? 'colSpan="' + D + '"' : "") + ">" + (v === "" ? "&nbsp;" : v) + "</td>";
            if (D) {
                y += D - 1
            }
        }
        q += "</tr>";
        if (this.rowsCol[A] && this.rowsCol[A]._expanded) {
            var m = this.cells4(this.rowsCol[A]._expanded.ctrl);
            if (m.getSubGrid) {
                q += '<tr><td colspan="' + o + '">' + m.getSubGrid().printView() + "</td></tr>"
            } else {
                q += '<tr><td colspan="' + o + '">' + this.rowsCol[A]._expanded.innerHTML + "</td></tr>"
            }
        }
    }
    if (this.ftr) {
        for (var A = 1; A < this.ftr.childNodes[0].rows.length; A++) {
            q += "<tr style='background-color:lightgrey'>" + ((this._fake) ? this._fake.ftr.childNodes[0].rows[A].innerHTML : "") + this.ftr.childNodes[0].rows[A].innerHTML + "</tr>"
        }
    }
    q += "</table>";
    if (this.parentGrid) {
        return q
    }
    q += (g || "");
    var E = window.open("", "_blank");
    E.document.write(q);
    E.document.write("<script>window.onerror=function(){return true;}<\/script>");
    E.document.close();
    if (this._fake) {
        this._hrrar = C
    }
};
dhtmlXGridObject.prototype._printWidth = function () {
    var j = [];
    var h = 0;
    for (var g = 0; g < this._cCount; g++) {
        var a = this.getColWidth(g);
        j.push(a);
        h += a
    }
    var m = [];
    var c = 0;
    for (var g = 0; g < j.length; g++) {
        var l = Math.floor((j[g] / h) * 100);
        c += l;
        m.push(l)
    }
    m[m.length - 1] += 100 - c;
    return m
};
if (!window.clipboardData) {
    window.clipboardData = {
        _make: function () {
            var c = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
            if (!c) {
                return null
            }
            var a = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
            if (!a) {
                return null
            }
            a.addDataFlavor("text/unicode");
            var g = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
            this._p = [c, a, g];
            return true
        },
        setData: function (a, h) {
            try {
                netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect")
            } catch (g) {
                dhtmlxError.throwError("Clipboard", "Access to clipboard denied", [a, h]);
                return ""
            }
            if (!this._make()) {
                return false
            }
            this._p[2].data = h;
            this._p[1].setTransferData("text/unicode", this._p[2], h.length * 2);
            var c = Components.interfaces.nsIClipboard;
            this._p[0].setData(this._p[1], null, c.kGlobalClipboard)
        },
        getData: function (a) {
            try {
                netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect")
            } catch (g) {
                dhtmlxError.throwError("Clipboard", "Access to clipboard denied", [a]);
                return ""
            }
            if (!this._make()) {
                return false
            }
            this._p[0].getData(this._p[1], this._p[0].kGlobalClipboard);
            var c = new Object();
            var h = new Object();
            try {
                this._p[1].getTransferData("text/unicode", h, c)
            } catch (g) {
                return ""
            }
            if (h) {
                h = h.value.QueryInterface(Components.interfaces.nsISupportsString)
            }
            if (h) {
                return h.data.substring(0, c.value / 2)
            }
            return ""
        }
    }
}
dhtmlXGridObject.prototype.enableBlockSelection = function (g) {
    if (typeof this._bs_mode == "undefined") {
        var a = this;
        this.obj.onmousedown = function (h) {
            if (a._bs_mode) {
                a._OnSelectionStart((h || event), this)
            }
            return true
        };
        this._CSVRowDelimiter = this.csv.row;
        this.attachEvent("onResize", function () {
            a._HideSelection();
            return true
        });
        this.attachEvent("onGridReconstructed", function () {
            a._HideSelection();
            return true
        });
        this.attachEvent("onFilterEnd", this._HideSelection)
    }
    if (g === false) {
        this._bs_mode = false;
        return this._HideSelection()
    } else {
        this._bs_mode = true
    }
    var c = this._clip_area = document.createElement("textarea");
    c.style.cssText = "position:absolute; width:1px; height:1px; overflow:hidden; color:transparent; background-color:transparent; bottom:1px; right:1px; border:none;";
    c.onkeydown = function (h) {
        h = h || event;
        if (h.keyCode == 86 && (h.ctrlKey || h.metaKey)) {
            a.pasteBlockFromClipboard()
        }
    };
    document.body.insertBefore(this._clip_area, document.body.firstChild);
    dhtmlxEvent(this.entBox, "click", function () {
        if (!a.editor) {
            a._clip_area.select()
        }
    })
};
dhtmlXGridObject.prototype.forceLabelSelection = function (a) {
    this._strictText = convertStringToBoolean(a)
};
dhtmlXGridObject.prototype._OnSelectionStart = function (g, h) {
    var c = this;
    if (g.button == 2) {
        return
    }
    var j = g.srcElement || g.target;
    if (this.editor) {
        if (j.tagName && (j.tagName == "INPUT" || j.tagName == "TEXTAREA")) {
            return
        }
        this.editStop()
    }
    c.setActive(true);
    var m = this.getPosition(this.obj);
    var a = g.clientX - m[0] + (document.body.scrollLeft || (document.documentElement ? document.documentElement.scrollLeft : 0));
    var l = g.clientY - m[1] + (document.body.scrollTop || (document.documentElement ? document.documentElement.scrollTop : 0));
    this._CreateSelection(a - 4, l - 4);
    if (j == this._selectionObj) {
        this._HideSelection();
        this._startSelectionCell = null
    } else {
        while (j && (!j.tagName || j.tagName.toLowerCase() != "td")) {
            j = j.parentNode
        }
        this._startSelectionCell = j
    }
    if (this._startSelectionCell) {
        if (!this.callEvent("onBeforeBlockSelected", [this._startSelectionCell.parentNode.idd, this._startSelectionCell._cellIndex])) {
            return this._startSelectionCell = null
        }
    }
    this.obj.onmousedown = null;
    this.obj[_isIE ? "onmouseleave" : "onmouseout"] = function (n) {
        if (c._blsTimer) {
            window.clearTimeout(c._blsTimer)
        }
    };
    this.obj.onmmold = this.obj.onmousemove;
    this._init_pos = [a, l];
    this._selectionObj.onmousemove = this.obj.onmousemove = function (n) {
        n = n || g;
        if (n.preventDefault) {
            n.preventDefault()
        } else {
            n.returnValue = false
        }
        c._OnSelectionMove(n)
    };
    this._oldDMP = document.body.onmouseup;
    document.body.onmouseup = function (n) {
        n = n || g;
        c._OnSelectionStop(n, this);
        return true
    };
    this.callEvent("onBeforeBlockSelection", []);
    document.body.onselectstart = function () {
        return false
    }
};
dhtmlXGridObject.prototype._getCellByPos = function (a, h) {
    a = a;
    if (this._fake) {
        a += this._fake.objBox.scrollWidth
    }
    h = h;
    var c = 0;
    for (var g = 0; g < this.obj.rows.length; g++) {
        h -= this.obj.rows[g].offsetHeight;
        if (h <= 0) {
            c = this.obj.rows[g];
            break
        }
    }
    if (!c || !c.idd) {
        return null
    }
    for (var g = 0; g < this._cCount; g++) {
        a -= this.getColWidth(g);
        if (a <= 0) {
            while (true) {
                if (c._childIndexes && c._childIndexes[g + 1] == c._childIndexes[g]) {
                    c = c.previousSibling
                } else {
                    return this.cells(c.idd, g).cell
                }
            }
        }
    }
    return null
};
dhtmlXGridObject.prototype._OnSelectionMove = function (h) {
    var w = this;
    this._ShowSelection();
    var r = this.getPosition(this.obj);
    var m = h.clientX - r[0] + (document.body.scrollLeft || (document.documentElement ? document.documentElement.scrollLeft : 0));
    var l = h.clientY - r[1] + (document.body.scrollTop || (document.documentElement ? document.documentElement.scrollTop : 0));
    if ((Math.abs(this._init_pos[0] - m) < 5) && (Math.abs(this._init_pos[1] - l) < 5)) {
        return this._HideSelection()
    }
    var u = this._endSelectionCell;
    if (this._startSelectionCell == null) {
        this._endSelectionCell = this._startSelectionCell = this.getFirstParentOfType(h.srcElement || h.target, "TD")
    } else {
        if (h.srcElement || h.target) {
            if ((h.srcElement || h.target).className == "dhtmlxGrid_selection") {
                this._endSelectionCell = (this._getCellByPos(m, l) || this._endSelectionCell)
            } else {
                var v = this.getFirstParentOfType(h.srcElement || h.target, "TD");
                if (v.parentNode.idd) {
                    this._endSelectionCell = v
                }
            }
        }
    }
    if (this._endSelectionCell) {
        if (!this.callEvent("onBeforeBlockSelected", [this._endSelectionCell.parentNode.idd, this._endSelectionCell._cellIndex])) {
            this._endSelectionCell = u
        }
    }
    var j = this.objBox.scrollLeft + this.objBox.clientWidth;
    var c = this.objBox.scrollTop + this.objBox.clientHeight;
    var o = this.objBox.scrollLeft;
    var n = this.objBox.scrollTop;
    var g = false;
    if (this._blsTimer) {
        window.clearTimeout(this._blsTimer)
    }
    if (m + 20 >= j) {
        this.objBox.scrollLeft = this.objBox.scrollLeft + 20;
        g = true
    } else {
        if (m - 20 < o) {
            this.objBox.scrollLeft = this.objBox.scrollLeft - 20;
            g = true
        }
    }
    if (l + 20 >= c && !this._realfake) {
        this.objBox.scrollTop = this.objBox.scrollTop + 20;
        g = true
    } else {
        if (l - 20 < n && !this._realfake) {
            this.objBox.scrollTop = this.objBox.scrollTop - 20;
            g = true
        }
    }
    this._selectionArea = this._RedrawSelectionPos(this._startSelectionCell, this._endSelectionCell);
    if (g) {
        var s = h.clientX;
        var q = h.clientY;
        this._blsTimer = window.setTimeout(function () {
            w._OnSelectionMove({
                clientX: s,
                clientY: q
            })
        }, 100)
    }
};
dhtmlXGridObject.prototype._OnSelectionStop = function (c) {
    var a = this;
    if (this._blsTimer) {
        window.clearTimeout(this._blsTimer)
    }
    this.obj.onmousedown = function (h) {
        if (a._bs_mode) {
            a._OnSelectionStart((h || c), this)
        }
        return true
    };
    this.obj.onmousemove = this.obj.onmmold || null;
    this._selectionObj.onmousemove = null;
    document.body.onmouseup = this._oldDMP || null;
    if (parseInt(this._selectionObj.style.width) < 2 && parseInt(this._selectionObj.style.height) < 2) {
        this._HideSelection()
    } else {
        var g = this.getFirstParentOfType(c.srcElement || c.target, "TD");
        if ((!g) || (!g.parentNode.idd)) {
            g = this._endSelectionCell
        }
        while (g && (!g.tagName || g.tagName.toLowerCase() != "td")) {
            g = g.parentNode
        }
        if (!g) {
            return this._HideSelection()
        }
        this._stopSelectionCell = g;
        this._selectionArea = this._RedrawSelectionPos(this._startSelectionCell, this._stopSelectionCell);
        this.callEvent("onBlockSelected", [])
    }
    document.body.onselectstart = function () {}
};
dhtmlXGridObject.prototype._RedrawSelectionPos = function (s, m) {
    var q = {};
    q.LeftTopCol = s._cellIndex;
    q.LeftTopRow = this.getRowIndex(s.parentNode.idd);
    q.RightBottomCol = m._cellIndex;
    q.RightBottomRow = this.getRowIndex(m.parentNode.idd);
    var h = s.offsetWidth;
    var g = s.offsetHeight;
    s = this.getPosition(s, this.obj);
    var u = m.offsetWidth;
    var n = m.offsetHeight;
    m = this.getPosition(m, this.obj);
    if (s[0] < m[0]) {
        var j = s[0];
        var l = m[0] + u
    } else {
        var o = q.RightBottomCol;
        q.RightBottomCol = q.LeftTopCol;
        q.LeftTopCol = o;
        var j = m[0];
        var l = s[0] + h
    }
    if (s[1] < m[1]) {
        var r = s[1];
        var a = m[1] + n
    } else {
        var o = q.RightBottomRow;
        q.RightBottomRow = q.LeftTopRow;
        q.LeftTopRow = o;
        var r = m[1];
        var a = s[1] + g
    }
    var v = l - j;
    var c = a - r;
    this._selectionObj.style.left = j + "px";
    this._selectionObj.style.top = r + "px";
    this._selectionObj.style.width = v + "px";
    this._selectionObj.style.height = c + "px";
    return q
};
dhtmlXGridObject.prototype._CreateSelection = function (a, g) {
    if (this._selectionObj == null) {
        var c = document.createElement("div");
        c.style.position = "absolute";
        c.style.display = "none";
        c.className = "dhtmlxGrid_selection";
        this._selectionObj = c;
        this._selectionObj.onmousedown = function (h) {
            h = h || event;
            if (h.button == 2 || (_isMacOS && h.ctrlKey)) {
                return this.parentNode.grid.callEvent("onBlockRightClick", ["BLOCK", h])
            }
        };
        this._selectionObj.oncontextmenu = function (h) {
            (h || event).cancelBubble = true;
            return false
        };
        this.objBox.appendChild(this._selectionObj)
    }
    this._selectionObj.style.width = "0px";
    this._selectionObj.style.height = "0px";
    this._selectionObj.style.left = a + "px";
    this._selectionObj.style.top = g + "px";
    this._selectionObj.startX = a;
    this._selectionObj.startY = g
};
dhtmlXGridObject.prototype._ShowSelection = function () {
    if (this._selectionObj) {
        this._selectionObj.style.display = ""
    }
};
dhtmlXGridObject.prototype._HideSelection = function () {
    if (this._selectionObj) {
        this._selectionObj.style.display = "none"
    }
    this._selectionArea = null;
    this._clip_area.value = "";
    this._clip_area.blur()
};
dhtmlXGridObject.prototype.copyBlockToClipboard = function () {
    if (this._selectionArea != null) {
        var g = new Array();
        if (this._mathSerialization) {
            this._agetm = "getMathValue"
        } else {
            if (this._strictText) {
                this._agetm = "getTitle"
            } else {
                this._agetm = "getValue"
            }
        }
        this._serialize_visible = true;
        for (var a = this._selectionArea.LeftTopRow; a <= this._selectionArea.RightBottomRow; a++) {
            var c = this._serializeRowToCVS(this.rowsBuffer[a], null, this._selectionArea.LeftTopCol, this._selectionArea.RightBottomCol + 1);
            if (!this._csvAID) {
                g[g.length] = c.substr(c.indexOf(this.csv.cell) + 1)
            } else {
                g[g.length] = c
            }
        }
        g = g.join(this._CSVRowDelimiter);
        this._clip_area.value = g;
        this._clip_area.select();
        this._serialize_visible = false
    }
};
dhtmlXGridObject.prototype.pasteBlockFromClipboard = function () {
    this._clip_area.select();
    var a = this;
    window.setTimeout(function () {
        a._pasteBlockFromClipboard();
        a = null
    }, 1)
};
dhtmlXGridObject.prototype._pasteBlockFromClipboard = function () {
    var o = this._clip_area.value;
    if (this._selectionArea != null) {
        var w = this._selectionArea.LeftTopRow;
        var a = this._selectionArea.LeftTopCol
    } else {
        if (this.cell != null && !this.editor) {
            var w = this.getRowIndex(this.cell.parentNode.idd);
            var a = this.cell._cellIndex
        } else {
            return false
        }
    }
    o = this.csvParser.unblock(o, this.csv.cell, this.csv.row);
    var q = w + o.length;
    var u = a + o[0].length;
    if (u > this._cCount) {
        u = this._cCount
    }
    var h = 0;
    for (var r = w; r < q; r++) {
        var x = this.render_row(r);
        if (x == -1) {
            continue
        }
        var g = 0;
        for (var m = a; m < u; m++) {
            if (this._hrrar[m]) {
                u = Math.max(u + 1, this._cCount);
                continue
            }
            var s = this.cells3(x, m);
            if (s.isDisabled()) {
                g++;
                continue
            }
            if (this._onEditUndoRedo) {
                this._onEditUndoRedo(2, x.idd, m, o[h][g], s.getValue())
            }
            if (s.combo) {
                var v = s.combo.values;
                for (var c = 0; c < v.length; c++) {
                    if (o[h][g] == v[c]) {
                        s.setValue(s.combo.keys[c]);
                        v = null;
                        break
                    }
                }
                if (v != null && s.editable) {
                    s.setValue(o[h][g++])
                } else {
                    g++
                }
            } else {
                s[s.setImage ? "setLabel" : "setValue"](o[h][g++])
            }
            s.cell.wasChanged = true
        }
        this.callEvent("onRowPaste", [x.idd]);
        h++
    }
};
dhtmlXGridObject.prototype.getSelectedBlock = function () {
    if (this._selectionArea) {
        return this._selectionArea
    } else {
        if (this.getSelectedRowId() !== null) {
            return {
                LeftTopRow: this.getSelectedRowId(),
                LeftTopCol: this.getSelectedCellIndex(),
                RightBottomRow: this.getSelectedRowId(),
                RightBottomCol: this.getSelectedCellIndex()
            }
        } else {
            return null
        }
    }
};
dhtmlXGridObject.prototype.enableSmartRendering = function (g, c, a) {
    if (arguments.length > 2) {
        if (c && !this.rowsBuffer[c - 1]) {
            this.rowsBuffer[c - 1] = 0
        }
        c = a
    }
    this._srnd = convertStringToBoolean(g);
    this._srdh = this._srdh || 20;
    this._dpref = c || 0
};
dhtmlXGridObject.prototype.enablePreRendering = function (a) {
    this._srnd_pr = parseInt(a || 50)
};
dhtmlXGridObject.prototype.forceFullLoading = function (a, j) {
    for (var g = 0; g < this.rowsBuffer.length; g++) {
        if (!this.rowsBuffer[g]) {
            var h = a || (this.rowsBuffer.length - g);
            if (this.callEvent("onDynXLS", [g, h])) {
                var c = this;
                this.load(this.xmlFileUrl + getUrlSymbol(this.xmlFileUrl) + "posStart=" + g + "&count=" + h, function () {
                    window.setTimeout(function () {
                        c.forceFullLoading(a, j)
                    }, 100)
                }, this._data_type)
            }
            return
        }
    }
    if (j) {
        j.call(this)
    }
};
dhtmlXGridObject.prototype.setAwaitedRowHeight = function (a) {
    this._srdh = parseInt(a)
};
dhtmlXGridObject.prototype._get_view_size = function () {
    return Math.floor(parseInt(this.entBox.offsetHeight) / this._srdh) + 2
};
dhtmlXGridObject.prototype._add_filler = function (m, a, c, h) {
    if (!a) {
        return null
    }
    var l = "__filler__";
    var j = this._prepareRow(l);
    j.firstChild.style.width = "1px";
    for (var g = 1; g < j.childNodes.length; g++) {
        j.childNodes[g].style.display = "none"
    }
    j.firstChild.style.height = a * this._srdh + "px";
    c = c || this.rowsCol[m];
    if (c && c.nextSibling) {
        c.parentNode.insertBefore(j, c.nextSibling)
    } else {
        if (_isKHTML) {
            this.obj.appendChild(j)
        } else {
            this.obj.rows[0].parentNode.appendChild(j)
        }
    }
    this.callEvent("onAddFiller", [m, a, j, c, h]);
    return [m, a, j]
};
dhtmlXGridObject.prototype._update_srnd_view = function () {
    var m = Math.floor(this.objBox.scrollTop / this._srdh);
    var c = m + this._get_view_size();
    if (this.multiLine) {
        var n = this.objBox.scrollTop;
        m = 0;
        while (n > 0) {
            n -= this.rowsCol[m] ? this.rowsCol[m].offsetHeight : this._srdh;
            m++
        }
        c = m + this._get_view_size();
        if (m > 0) {
            m--
        }
    }
    c += (this._srnd_pr || 0);
    if (c > this.rowsBuffer.length) {
        c = this.rowsBuffer.length
    }
    for (var h = m; h < c; h++) {
        if (!this.rowsCol[h]) {
            var l = this._add_from_buffer(h);
            if (l == -1) {
                if (this.xmlFileUrl) {
                    if (this._dpref && this.rowsBuffer[c - 1]) {
                        var g = this._dpref ? this._dpref : (c - h);
                        var a = Math.max(0, Math.min(h, c - this._dpref));
                        this._current_load = [a, c - a]
                    } else {
                        this._current_load = [h, (this._dpref ? this._dpref : (c - h))]
                    }
                    if (this.callEvent("onDynXLS", this._current_load)) {
                        this.load(this.xmlFileUrl + getUrlSymbol(this.xmlFileUrl) + "posStart=" + this._current_load[0] + "&count=" + this._current_load[1], this._data_type)
                    }
                }
                return
            } else {
                if (this._tgle) {
                    this._updateLine(this._h2.get[this.rowsBuffer[h].idd], this.rowsBuffer[h]);
                    this._updateParentLine(this._h2.get[this.rowsBuffer[h].idd], this.rowsBuffer[h])
                }
                if (h && h == (this._realfake ? this._fake : this)["_r_select"]) {
                    this.selectCell(h, this.cell ? this.cell._cellIndex : 0, true)
                }
            }
        }
    }
    if (this._fake && !this._realfake && this.multiLine) {
        this._fake.objBox.scrollTop = this.objBox.scrollTop
    }
};
dhtmlXGridObject.prototype._add_from_buffer = function (h) {
    var j = this.render_row(h);
    if (j == -1) {
        return -1
    }
    if (j._attrs.selected || j._attrs.select) {
        this.selectRow(j, false, true);
        j._attrs.selected = j._attrs.select = null
    }
    if (!this._cssSP) {
        if (this._cssEven && h % 2 == 0) {
            j.className = this._cssEven + ((j.className.indexOf("rowselected") != -1) ? " rowselected " : " ") + (j._css || "")
        } else {
            if (this._cssUnEven && h % 2 == 1) {
                j.className = this._cssUnEven + ((j.className.indexOf("rowselected") != -1) ? " rowselected " : " ") + (j._css || "")
            }
        }
    } else {
        if (this._h2) {
            var a = this._h2.get[j.idd];
            j.className += " " + ((a.level % 2) ? (this._cssUnEven + " " + this._cssUnEven) : (this._cssEven + " " + this._cssEven)) + "_" + a.level + (this.rowsAr[a.id]._css || "")
        }
    }
    for (var c = 0; c < this._fillers.length; c++) {
        var g = this._fillers[c];
        if (g && g[0] <= h && (g[0] + g[1]) > h) {
            var l = h - g[0];
            if (l == 0) {
                this._insert_before(h, j, g[2]);
                this._update_fillers(c, -1, 1)
            } else {
                if (l == g[1] - 1) {
                    this._insert_after(h, j, g[2]);
                    this._update_fillers(c, -1, 0)
                } else {
                    this._fillers.push(this._add_filler(h + 1, g[1] - l - 1, g[2], 1));
                    this._insert_after(h, j, g[2]);
                    this._update_fillers(c, -g[1] + l, 0)
                }
            }
            return
        }
    }
};
dhtmlXGridObject.prototype._update_fillers = function (g, a, h) {
    var c = this._fillers[g];
    c[1] = c[1] + a;
    c[0] = c[0] + h;
    if (!c[1]) {
        this.callEvent("onRemoveFiller", [c[2]]);
        c[2].parentNode.removeChild(c[2]);
        this._fillers.splice(g, 1)
    } else {
        c[2].firstChild.style.height = parseFloat(c[2].firstChild.style.height) + a * this._srdh + "px";
        this.callEvent("onUpdateFiller", [c[2]])
    }
};
dhtmlXGridObject.prototype._insert_before = function (c, g, a) {
    a.parentNode.insertBefore(g, a);
    this.rowsCol[c] = g;
    this.callEvent("onRowInserted", [g, null, a, "before"])
};
dhtmlXGridObject.prototype._insert_after = function (c, g, a) {
    if (a.nextSibling) {
        a.parentNode.insertBefore(g, a.nextSibling)
    } else {
        a.parentNode.appendChild(g)
    }
    this.rowsCol[c] = g;
    this.callEvent("onRowInserted", [g, null, a, "after"])
};
dhtmlxValidation = function () {};
dhtmlxValidation.prototype = {
    trackInput: function (g, h, c, a) {
        dhtmlxEvent(g, "keyup", function (j) {
            if (dhtmlxValidation._timer) {
                window.clearTimeout(dhtmlxValidation._timer);
                dhtmlxValidation._timer = null
            }
            dhtmlxValidation._timer = window.setTimeout(function () {
                if (!dhtmlxValidation.checkInput(g, h)) {
                    if (!c || c(g, g.value, h)) {
                        g.className += " dhtmlx_live_validation_error"
                    }
                } else {
                    g.className = g.className.replace(/[ ]*dhtmlx_live_validation_error/g, "");
                    if (a) {
                        a(g, g.value, h)
                    }
                }
            }, 250)
        })
    },
    checkInput: function (a, c) {
        return this.checkValue(a.value, c)
    },
    checkValue: function (g, h) {
        if (typeof h == "string") {
            h = h.split(",")
        }
        var a = true;
        for (var c = 0; c < h.length; c++) {
            if (!this["is" + h[c]]) {
                alert("Incorrect validation rule: " + h[c])
            } else {
                a = a && this["is" + h[c]](g)
            }
        }
        return a
    },
    isEmpty: function (a) {
        return a == ""
    },
    isNotEmpty: function (a) {
        return (a instanceof Array ? a.length > 0 : !a == "")
    },
    isValidBoolean: function (a) {
        return !!a.toString().match(/^(0|1|true|false)$/)
    },
    isValidEmail: function (a) {
        return !!a.toString().match(/(^[a-z0-9]([0-9a-z\-_\.]*)@([0-9a-z_\-\.]*)([.][a-z]{3})$)|(^[a-z]([0-9a-z_\.\-]*)@([0-9a-z_\-\.]*)(\.[a-z]{2,4})$)/i)
    },
    isValidInteger: function (a) {
        return !!a.toString().match(/(^-?\d+$)/)
    },
    isValidNumeric: function (a) {
        return !!a.toString().match(/(^-?\d\d*[\.|,]\d*$)|(^-?\d\d*$)|(^-?[\.|,]\d\d*$)/)
    },
    isValidAplhaNumeric: function (a) {
        return !!a.toString().match(/^[_\-a-z0-9]+$/gi)
    },
    isValidDatetime: function (c) {
        var a = c.toString().match(/^(\d{4})-(\d{2})-(\d{2})\s(\d{2}):(\d{2}):(\d{2})$/);
        return a && !! (a[1] <= 9999 && a[2] <= 12 && a[3] <= 31 && a[4] <= 59 && a[5] <= 59 && a[6] <= 59) || false
    },
    isValidDate: function (a) {
        var c = a.toString().match(/^(\d{4})-(\d{2})-(\d{2})$/);
        return c && !! (c[1] <= 9999 && c[2] <= 12 && c[3] <= 31) || false
    },
    isValidTime: function (c) {
        var a = c.toString().match(/^(\d{1,2}):(\d{1,2}):(\d{1,2})$/);
        return a && !! (a[1] <= 24 && a[2] <= 59 && a[3] <= 59) || false
    },
    isValidIPv4: function (a) {
        var c = a.toString().match(/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/);
        return c && !! (c[1] <= 255 && c[2] <= 255 && c[3] <= 255 && c[4] <= 255) || false
    },
    isValidCurrency: function (a) {
        return a.toString().match(/^\$?\s?\d+?([\.,\,]?\d+)?\s?\$?$/) && true || false
    },
    isValidSSN: function (a) {
        return a.toString().match(/^\d{3}\-?\d{2}\-?\d{4}$/) && true || false
    },
    isValidSIN: function (a) {
        return a.toString().match(/^\d{9}$/) && true || false
    }
};
dhtmlxValidation = new dhtmlxValidation();
dhtmlXGridObject.prototype.enableValidation = function (c, a) {
    c = convertStringToBoolean(c);
    if (c) {
        this._validators = {
            data: []
        }
    } else {
        this._validators = false
    }
    if (arguments.length > 1) {
        this._validators._live = a
    }
    if (!this._validators._event) {
        this._validators._event = this.attachEvent("onEditCell", this.validationEvent)
    }
};
dhtmlXGridObject.prototype.setColValidators = function (a) {
    if (!this._validators) {
        this.enableValidation(true)
    }
    if (typeof a == "string") {
        a = a.split(this.delim)
    }
    this._validators.data = a
};
dhtmlXGridObject.prototype.validationEvent = function (l, c, h, g, n) {
    var o = this._validators;
    if (!o) {
        return true
    }
    var m = (o.data[h] || this.cells(c, h).getAttribute("validate")) || "";
    if (l == 1 && m) {
        var j = this.editor || (this._fake || {}).editor;
        if (!j) {
            return true
        }
        j.cell.className = j.cell.className.replace(/[ ]*dhtmlx_validation_error/g, "");
        if (o._live) {
            var a = this;
            dhtmlxValidation.trackInput(j.getInput(), m, function (q, r, s) {
                return a.callEvent("onLiveValidationError", [c, h, r, q, s])
            }, function (q, r, s) {
                return a.callEvent("onLiveValidationCorrect", [c, h, r, q, s])
            })
        }
    }
    if (l == 2) {
        this.validateCell(c, h, m, g)
    }
    return true
};
dhtmlXGridObject.prototype.validateCell = function (m, j, l, h) {
    l = l || (this._validators.data[j] || this.cells(m, j).getAttribute("validate"));
    h = h || this.cells(m, j).getValue();
    if (!l) {
        return
    }
    var c = this.cells(m, j).cell;
    var a = true;
    if (typeof l == "string") {
        l = l.split(this.delim)
    }
    for (var g = 0; g < l.length; g++) {
        if (!dhtmlxValidation.checkValue(h, l[g])) {
            if (this.callEvent("onValidationError", [m, j, h, l[g]])) {
                c.className += " dhtmlx_validation_error"
            }
            a = false
        }
    }
    if (a) {
        this.callEvent("onValidationCorrect", [m, j, h, l]);
        c.className = c.className.replace(/[ ]*dhtmlx_validation_error/g, "")
    }
    return a
};

function eXcell_stree(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid;
        if (!this.grid._sub_trees) {
            return
        }
        this._sub = this.grid._sub_trees[a._cellIndex];
        if (!this._sub) {
            return
        }
        this._sub = this._sub[0]
    }
    this.getValue = function () {
        return this.cell._val
    };
    this.setValue = function (c) {
        this.cell._val = c;
        c = this._sub.getItemText(this.cell._val);
        this.setCValue((c || "&nbsp;"), c)
    };
    this.edit = function () {
        this._sub.parentObject.style.display = "block";
        var g = this.grid.getPosition(this.cell);
        this._sub.parentObject.style.top = g[1] + "px";
        this._sub.parentObject.style.left = g[0] + "px";
        this._sub.parentObject.style.position = "absolute";
        var c = this.grid.editStop;
        this.grid.editStop = function () {};
        this.grid.editStop = c
    };
    this.detach = function () {
        this._sub.parentObject.style.display = "none";
        if (this.grid._sub_id != null) {
            var c = this.cell._val;
            this.setValue(this._sub.getSelectedItemId());
            this.grid._sub_id = null;
            return this.cell._val != c
        }
    }
}
eXcell_stree.prototype = new eXcell;
dhtmlXGridObject.prototype.setSubTree = function (a, c) {
    if (!this._sub_trees) {
        this._sub_trees = []
    }
    this._sub_trees[c] = [a];
    a.parentObject.style.display = "none";
    var g = this;
    a.parentObject.onclick = function (h) {
        (h || window.event).cancelBubble = true;
        return false
    };
    a.ev_onDblClick = null;
    a.attachEvent("onDblClick", function (h) {
        g._sub_id = h;
        g.editStop();
        return true
    });
    a._chRRS = true
};

function eXcell_link(a) {
    this.cell = a;
    this.grid = this.cell.parentNode.grid;
    this.isDisabled = function () {
        return true
    };
    this.edit = function () {};
    this.getValue = function () {
        if (this.cell.firstChild.getAttribute) {
            var c = this.cell.firstChild.getAttribute("target");
            return this.cell.firstChild.innerHTML + "^" + this.cell.firstChild.getAttribute("href") + (c ? ("^" + c) : "")
        } else {
            return ""
        }
    };
    this.setValue = function (g) {
        if ((typeof (g) != "number") && (!g || g.toString()._dhx_trim() == "")) {
            this.setCValue("&nbsp;", c);
            return (this.cell._clearCell = true)
        }
        var c = g.split("^");
        if (c.length == 1) {
            c[1] = ""
        } else {
            if (c.length > 1) {
                c[1] = "href='" + c[1] + "'";
                if (c.length == 3) {
                    c[1] += " target='" + c[2] + "'"
                } else {
                    c[1] += " target='_blank'"
                }
            }
        }
        this.setCValue("<a " + c[1] + " onclick='(_isIE?event:arguments[0]).cancelBubble = true;'>" + c[0] + "</a>", c)
    }
}
eXcell_link.prototype = new eXcell;
eXcell_link.prototype.getTitle = function () {
    var a = this.cell.firstChild;
    return ((a && a.tagName) ? a.getAttribute("href") : "")
};
eXcell_link.prototype.getContent = function () {
    var a = this.cell.firstChild;
    return ((a && a.tagName) ? a.innerHTML : "")
};

function eXcell_grid(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid;
        if (!this.grid._sub_grids) {
            return
        }
        this._sub = this.grid._sub_grids[a._cellIndex];
        if (!this._sub) {
            return
        }
        this._sindex = this._sub[1];
        this._sub = this._sub[0]
    }
    this.getValue = function () {
        return this.cell.val
    };
    this.setValue = function (c) {
        this.cell.val = c;
        if (this._sub.getRowById(c)) {
            c = this._sub.cells(c, this._sindex);
            if (c) {
                c = c.getValue()
            } else {
                c = ""
            }
        }
        this.setCValue((c || "&nbsp;"), c)
    };
    this.edit = function () {
        this.val = this.cell.val;
        this._sub.entBox.style.display = "block";
        var g = this.grid.getPosition(this.cell);
        this._sub.entBox.style.top = g[1] + "px";
        this._sub.entBox.style.left = g[0] + "px";
        this._sub.entBox.style.position = "absolute";
        this._sub.setSizes();
        var c = this.grid.editStop;
        this.grid.editStop = function () {};
        if (this._sub.getRowById(this.cell.val)) {
            this._sub.setSelectedRow(this.cell.val)
        }
        this._sub.setActive(true);
        this.grid.editStop = c
    };
    this.detach = function () {
        var c = this.cell.val;
        this._sub.entBox.style.display = "none";
        if (this._sub.getSelectedId() === null) {
            return false
        }
        this.setValue(this._sub.getSelectedId());
        this.grid.setActive(true);
        return this.cell.val != c
    }
}
eXcell_grid.prototype = new eXcell;
dhtmlXGridObject.prototype.setSubGrid = function (c, a, h) {
    if (!this._sub_grids) {
        this._sub_grids = []
    }
    this._sub_grids[a] = [c, h];
    c.entBox.style.display = "none";
    var g = this;
    c.attachEvent("onRowSelect", function (j) {
        g.editStop();
        return true
    });
    c._chRRS = false
};

function eXcell_dhxCalendar(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid;
        if (!this.grid._grid_calendarA) {
            var g = this.grid._grid_calendarA = new dhtmlxCalendarObject();
            this.grid.callEvent("onDhxCalendarCreated", [g]);
            var c = this.grid;
            g.attachEvent("onClick", function () {
                this._last_operation_calendar = true;
                window.setTimeout(function () {
                    c.editStop()
                }, 1);
                return true
            });
            var h = function (j) {
                    (j || event).cancelBubble = true
                };
            dhtmlxEvent(g.base, "click", h);
            g = null
        }
    }
}
eXcell_dhxCalendar.prototype = new eXcell;
eXcell_dhxCalendar.prototype.edit = function () {
    var c = this.grid.getPosition(this.cell);
    this.grid._grid_calendarA._show(false, false);
    this.grid._grid_calendarA.setPosition(c[0], c[1] + this.cell.offsetHeight);
    this.grid._grid_calendarA._last_operation_calendar = false;
    this.grid.callEvent("onCalendarShow", [this.grid._grid_calendarA, this.cell.parentNode.idd, this.cell._cellIndex]);
    this.cell._cediton = true;
    this.val = this.cell.val;
    this._val = this.cell.innerHTML;
    var a = this.grid._grid_calendarA.draw;
    this.grid._grid_calendarA.draw = function () {};
    this.grid._grid_calendarA.setDateFormat((this.grid._dtmask || "%d/%m/%Y"));
    this.grid._grid_calendarA.setDate(this.val || (new Date()));
    this.grid._grid_calendarA.draw = a
};
eXcell_dhxCalendar.prototype.getDate = function () {
    if (this.cell.val) {
        return this.cell.val
    }
    return null
};
eXcell_dhxCalendar.prototype.getValue = function () {
    if (this.cell._clearCell) {
        return ""
    }
    if (this.grid._dtmask_inc && this.cell.val) {
        return this.grid._grid_calendarA.getFormatedDate(this.grid._dtmask_inc, this.cell.val).toString()
    }
    return this.cell.innerHTML.toString()._dhx_trim()
};
eXcell_dhxCalendar.prototype.detach = function () {
    if (!this.grid._grid_calendarA) {
        return
    }
    this.grid._grid_calendarA.hide();
    if (this.cell._cediton) {
        this.cell._cediton = false
    } else {
        return
    }
    if (this.grid._grid_calendarA._last_operation_calendar) {
        var g = this.grid._grid_calendarA.getFormatedDate((this.grid._dtmask || "%d/%m/%Y"));
        var c = this.grid._grid_calendarA.getDate();
        this.cell.val = new Date(c);
        this.setCValue(g, c);
        this.cell._clearCell = !g;
        var a = this.val;
        this.val = this._val;
        return (this.cell.val.valueOf() != a)
    }
    return false
};
eXcell_dhxCalendar.prototype.setValue = function (a) {
    if (a && typeof a == "object") {
        this.cell.val = a;
        this.cell._clearCell = false;
        this.setCValue(this.grid._grid_calendarA.getFormatedDate((this.grid._dtmask || "%d/%m/%Y"), a).toString(), this.cell.val);
        return
    }
    if (!a || a.toString()._dhx_trim() == "") {
        a = "&nbsp";
        this.cell._clearCell = true;
        this.cell.val = ""
    } else {
        this.cell._clearCell = false;
        this.cell.val = new Date(this.grid._grid_calendarA.setFormatedDate((this.grid._dtmask_inc || this.grid._dtmask || "%d/%m/%Y"), a.toString(), null, true));
        if (this.grid._dtmask_inc) {
            a = this.grid._grid_calendarA.getFormatedDate((this.grid._dtmask || "%d/%m/%Y"), this.cell.val)
        }
    }
    if ((this.cell.val == "NaN") || (this.cell.val == "Invalid Date")) {
        this.cell._clearCell = true;
        this.cell.val = new Date();
        this.setCValue("&nbsp;", 0)
    } else {
        this.setCValue((a || "").toString(), this.cell.val)
    }
};

function eXcell_dhxCalendarA(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid;
        if (!this.grid._grid_calendarA) {
            var g = this.grid._grid_calendarA = new dhtmlxCalendarObject();
            this.grid.callEvent("onDhxCalendarCreated", [g]);
            var c = this.grid;
            g.attachEvent("onClick", function () {
                this._last_operation_calendar = true;
                window.setTimeout(function () {
                    c.editStop()
                }, 1);
                return true
            });
            var h = function (j) {
                    (j || event).cancelBubble = true
                };
            dhtmlxEvent(g.base, "click", h)
        }
    }
}
eXcell_dhxCalendarA.prototype = new eXcell;
eXcell_dhxCalendarA.prototype.edit = function () {
    var c = this.grid.getPosition(this.cell);
    this.grid._grid_calendarA._show(false, false);
    this.grid._grid_calendarA.setPosition(c[0] * 1 + this.cell.offsetWidth, c[1] * 1);
    this.grid.callEvent("onCalendarShow", [this.grid._grid_calendarA, this.cell.parentNode.idd, this.cell._cellIndex]);
    this.grid._grid_calendarA._last_operation_calendar = false;
    this.cell._cediton = true;
    this.val = this.cell.val;
    this._val = this.cell.innerHTML;
    var a = this.grid._grid_calendarA.draw;
    this.grid._grid_calendarA.draw = function () {};
    this.grid._grid_calendarA.setDateFormat((this.grid._dtmask || "%d/%m/%Y"));
    this.grid._grid_calendarA.setDate(this.val);
    this.grid._grid_calendarA.draw = a;
    this.cell.atag = ((!this.grid.multiLine) && (_isKHTML || _isMacOS || _isFF)) ? "INPUT" : "TEXTAREA";
    this.obj = document.createElement(this.cell.atag);
    this.obj.style.height = (this.cell.offsetHeight - (_isIE ? 4 : 2)) + "px";
    this.obj.className = "dhx_combo_edit";
    this.obj.wrap = "soft";
    this.obj.style.textAlign = this.cell.align;
    this.obj.onclick = function (g) {
        (g || event).cancelBubble = true
    };
    this.obj.onmousedown = function (g) {
        (g || event).cancelBubble = true
    };
    this.obj.value = this.getValue();
    this.cell.innerHTML = "";
    this.cell.appendChild(this.obj);
    if (window.dhx4.isIE) {
        this.obj.style.overflow = "visible";
        if ((this.grid.multiLine) && (this.obj.offsetHeight >= 18) && (this.obj.offsetHeight < 40)) {
            this.obj.style.height = "36px";
            this.obj.style.overflow = "scroll"
        }
    }
    this.obj.onselectstart = function (g) {
        if (!g) {
            g = event
        }
        g.cancelBubble = true;
        return true
    };
    this.obj.focus();
    this.obj.focus()
};
eXcell_dhxCalendarA.prototype.getDate = function () {
    if (this.cell.val) {
        return this.cell.val
    }
    return null
};
eXcell_dhxCalendarA.prototype.getValue = function () {
    if (this.cell._clearCell) {
        return ""
    }
    if (this.grid._dtmask_inc && this.cell.val) {
        return this.grid._grid_calendarA.getFormatedDate(this.grid._dtmask_inc, this.cell.val).toString()
    }
    return this.cell.innerHTML.toString()._dhx_trim()
};
eXcell_dhxCalendarA.prototype.detach = function () {
    if (!this.grid._grid_calendarA) {
        return
    }
    this.grid._grid_calendarA.hide();
    if (this.cell._cediton) {
        this.cell._cediton = false
    } else {
        return
    }
    if (this.grid._grid_calendarA._last_operation_calendar) {
        this.grid._grid_calendarA._last_operation_calendar = false;
        var g = this.grid._grid_calendarA.getFormatedDate(this.grid._dtmask || "%d/%m/%Y");
        var c = this.grid._grid_calendarA.getDate();
        this.cell.val = new Date(c);
        this.setCValue(g, c);
        this.cell._clearCell = !g;
        var a = this.val;
        this.val = this._val;
        return (this.cell.val.valueOf() != (a | "").valueOf())
    }
    this.setValue(this.obj.value);
    var a = this.val;
    this.val = this._val;
    return (this.cell.val.valueOf() != (a || "").valueOf())
};
eXcell_dhxCalendarA.prototype.setValue = function (a) {
    if (a && typeof a == "object") {
        this.cell.val = a;
        this.cell._clearCell = false;
        this.setCValue(this.grid._grid_calendarA.getFormatedDate((this.grid._dtmask || "%d/%m/%Y"), a).toString(), this.cell.val);
        return
    }
    if (!a || a.toString()._dhx_trim() == "") {
        a = "&nbsp";
        this.cell._clearCell = true;
        this.cell.val = ""
    } else {
        this.cell._clearCell = false;
        this.cell.val = new Date(this.grid._grid_calendarA.setFormatedDate((this.grid._dtmask_inc || this.grid._dtmask || "%d/%m/%Y"), a.toString(), null, true));
        if (this.grid._dtmask_inc) {
            a = this.grid._grid_calendarA.getFormatedDate((this.grid._dtmask || "%d/%m/%Y"), this.cell.val)
        }
    }
    if ((this.cell.val == "NaN") || (this.cell.val == "Invalid Date")) {
        this.cell.val = new Date();
        this.cell._clearCell = true;
        this.setCValue("&nbsp;", 0)
    } else {
        this.setCValue((a || "").toString(), this.cell.val)
    }
};

function eXcell_cntr(a) {
    this.cell = a;
    this.grid = this.cell.parentNode.grid;
    if (!this.grid._ex_cntr_ready && !this._realfake) {
        this.grid._ex_cntr_ready = true;
        if (this.grid._h2) {
            this.grid.attachEvent("onOpenEn", function (g) {
                this.resetCounter(a._cellIndex)
            })
        }
        var c = function () {
                var g = this;
                window.setTimeout(function () {
                    if (!g.resetCounter) {
                        return
                    }
                    if (g._fake && !g._realfake && a._cellIndex < g._fake._cCount) {
                        g._fake.resetCounter(a._cellIndex)
                    } else {
                        g.resetCounter(a._cellIndex)
                    }
                }, 1);
                return true
            };
        this.grid.attachEvent("onBeforeSorting", c);
        this.grid.attachEvent("onFilterEnd", c)
    }
    this.edit = function () {};
    this.getValue = function () {
        return this.cell.innerHTML
    };
    this.setValue = function (h) {
        this.cell.style.paddingRight = "2px";
        var g = this.cell;
        window.setTimeout(function () {
            if (!g.parentNode) {
                return
            }
            var j = g.parentNode.rowIndex;
            if (g.parentNode.grid.currentPage || j < 0 || g.parentNode.grid._srnd) {
                j = g.parentNode.grid.rowsBuffer._dhx_find(g.parentNode) + 1
            }
            if (j <= 0) {
                return
            }
            g.innerHTML = j;
            if (g.parentNode.grid._fake && g._cellIndex < g.parentNode.grid._fake._cCount && g.parentNode.grid._fake.rowsAr[g.parentNode.idd]) {
                g.parentNode.grid._fake.cells(g.parentNode.idd, g._cellIndex).setCValue(j)
            }
            g = null
        }, 100)
    }
}
dhtmlXGridObject.prototype.resetCounter = function (c) {
    if (this._fake && !this._realfake && c < this._fake._cCount) {
        this._fake.resetCounter(c, this.currentPage)
    }
    var a = arguments[0] || 0;
    if (this.currentPage) {
        a = (this.currentPage - 1) * this.rowsBufferOutSize
    }
    for (a = 0; a < this.rowsBuffer.length; a++) {
        if (this.rowsBuffer[a] && this.rowsBuffer[a].tagName == "TR" && this.rowsAr[this.rowsBuffer[a].idd]) {
            this.rowsAr[this.rowsBuffer[a].idd].childNodes[c].innerHTML = a + 1
        }
    }
};
eXcell_cntr.prototype = new eXcell;

function eXcell_acheck(a) {
    try {
        this.cell = a;
        this.grid = this.cell.parentNode.grid;
        this.cell.obj = this
    } catch (c) {}
    this.changeState = function () {
        if ((!this.grid.isEditable) || (this.cell.parentNode._locked) || (this.isDisabled())) {
            return
        }
        if (this.grid.callEvent("onEditCell", [0, this.cell.parentNode.idd, this.cell._cellIndex]) != false) {
            this.val = this.getValue();
            if (this.val == "1") {
                this.setValue("<checkbox state='false'>")
            } else {
                this.setValue("<checkbox state='true'>")
            }
            this.cell.wasChanged = true;
            this.grid.callEvent("onEditCell", [1, this.cell.parentNode.idd, this.cell._cellIndex]);
            this.grid.callEvent("onCheck", [this.cell.parentNode.idd, this.cell._cellIndex, (this.val != "1")]);
            this.grid.callEvent("onCheckbox", [this.cell.parentNode.idd, this.cell._cellIndex, (this.val != "1")])
        } else {
            this.editor = null
        }
    };
    this.getValue = function () {
        try {
            return this.cell.chstate.toString()
        } catch (g) {
            return null
        }
    };
    this.isCheckbox = function () {
        return true
    };
    this.isChecked = function () {
        if (this.getValue() == "1") {
            return true
        } else {
            return false
        }
    };
    this.setChecked = function (g) {
        this.setValue(g.toString())
    };
    this.detach = function () {
        return this.val != this.getValue()
    };
    this.drawCurrentState = function () {
        if (this.cell.chstate == 1) {
            return "<div  onclick='(new eXcell_acheck(this.parentNode)).changeState(); (arguments[0]||event).cancelBubble=true;'  style='cursor:pointer; font-weight:bold; text-align:center; '><span style='height:8px; width:8px; background:green; display:inline-block;'></span>&nbsp;Yes</div>"
        } else {
            return "<div  onclick='(new eXcell_acheck(this.parentNode)).changeState(); (arguments[0]||event).cancelBubble=true;' style='cursor:pointer;  text-align:center; '><span style='height:8px; width:8px; background:red; display:inline-block;'></span>&nbsp;No</div>"
        }
    }
}
eXcell_acheck.prototype = new eXcell;
eXcell_acheck.prototype.setValue = function (c) {
    c = (c || "").toString();
    if (c.indexOf("1") != -1 || c.indexOf("true") != -1) {
        c = "1";
        this.cell.chstate = "1"
    } else {
        c = "0";
        this.cell.chstate = "0"
    }
    var a = this;
    this.setCValue(this.drawCurrentState(), this.cell.chstate)
};

function eXcell_context(a) {
    if (a) {
        this.cell = a;
        this.grid = this.cell.parentNode.grid;
        if (!this.grid._sub_context) {
            return
        }
        this._sub = this.grid._sub_context[a._cellIndex];
        if (!this._sub) {
            return
        }
        this._sindex = this._sub[1];
        this._sub = this._sub[0]
    }
    this.getValue = function () {
        return _isIE ? this.cell.innerText : this.cell.textContent
    };
    this.setValue = function (g) {
        this.cell._val = g;
        var c = this._sub.itemPull[this._sub.idPrefix + this.cell._val];
        g = c ? c.title : g;
        this.setCValue((g || "&nbsp;"), g)
    };
    this.edit = function () {
        var g = this.grid.getPosition(this.cell);
        this._sub.showContextMenu(g[0] + this.cell.offsetWidth, g[1]);
        var c = this.grid.editStop;
        this.grid.editStop = function () {};
        this.grid.editStop = c
    };
    this.detach = function () {
        if (this.grid._sub_id != null) {
            var c = this.cell._val;
            this.setValue(this.grid._sub_id);
            this.grid._sub_id = null;
            return this.cell._val != c
        }
        this._sub.hideContextMenu()
    }
}
eXcell_context.prototype = new eXcell;
dhtmlXGridObject.prototype.setSubContext = function (a, c, h) {
    var g = this;
    a.attachEvent("onClick", function (l, j) {
        g._sub_id = l;
        g.editStop();
        a.hideContextMenu();
        return true
    });
    if (!this._sub_context) {
        this._sub_context = []
    }
    this._sub_context[c] = [a, h];
    a.hideContextMenu()
};

function dhtmlXGridFromTable(obj, init) {
    if (typeof (obj) != "object") {
        obj = document.getElementById(obj)
    }
    var w = document.createElement("DIV");
    w.setAttribute("width", obj.getAttribute("gridWidth") || (obj.offsetWidth ? (obj.offsetWidth + "px") : 0) || (window.getComputedStyle ? window.getComputedStyle(obj, null)["width"] : (obj.currentStyle ? obj.currentStyle.width : 0)));
    w.setAttribute("height", obj.getAttribute("gridHeight") || (obj.offsetHeight ? (obj.offsetHeight + "px") : 0) || (window.getComputedStyle ? window.getComputedStyle(obj, null)["height"] : (obj.currentStyle ? obj.currentStyle.height : 0)));
    w.className = obj.className;
    obj.className = "";
    if (obj.id) {
        w.id = obj.id
    }
    var mr = obj;
    var drag = obj.getAttribute("dragAndDrop");
    mr.parentNode.insertBefore(w, mr);
    var f = mr.getAttribute("name") || ("name_" + (new Date()).valueOf());
    var windowf = new dhtmlXGridObject(w);
    window[f] = windowf;
    var acs = mr.getAttribute("onbeforeinit");
    var acs2 = mr.getAttribute("oninit");
    if (acs) {
        eval(acs)
    }
    windowf.setImagePath(windowf.imgURL || (mr.getAttribute("imgpath") || mr.getAttribute("image_path") || ""));
    var skin = mr.getAttribute("skin");
    if (skin) {
        windowf.setSkin(skin)
    }
    if (init) {
        init(windowf)
    }
    var hrow = mr.rows[0];
    var za = "";
    var zb = "";
    var zc = "";
    var zd = "";
    var ze = "";
    for (var i = 0; i < hrow.cells.length; i++) {
        za += (za ? "," : "") + hrow.cells[i].innerHTML;
        var width = hrow.cells[i].getAttribute("width") || hrow.cells[i].offsetWidth || (window.getComputedStyle ? window.getComputedStyle(hrow.cells[i], null)["width"] : (hrow.cells[i].currentStyle ? hrow.cells[i].currentStyle.width : 0));
        zb += (zb ? "," : "") + (width == "*" ? width : parseInt(width));
        zc += (zc ? "," : "") + (hrow.cells[i].getAttribute("align") || "left");
        zd += (zd ? "," : "") + (hrow.cells[i].getAttribute("type") || "ed");
        ze += (ze ? "," : "") + (hrow.cells[i].getAttribute("sort") || "str");
        var f_a = hrow.cells[i].getAttribute("format");
        if (f_a) {
            if (hrow.cells[i].getAttribute("type").toLowerCase().indexOf("calendar") != -1) {
                windowf._dtmask = f_a
            } else {
                windowf.setNumberFormat(f_a, i)
            }
        }
    }
    windowf.setHeader(za);
    windowf.setInitWidths(zb);
    windowf.setColAlign(zc);
    windowf.setColTypes(zd);
    windowf.setColSorting(ze);
    if (obj.getAttribute("gridHeight") == "auto") {
        windowf.enableAutoHeigth(true)
    }
    if (obj.getAttribute("multiline")) {
        windowf.enableMultiline(true)
    }
    var lmn = mr.getAttribute("lightnavigation");
    if (lmn) {
        windowf.enableLightMouseNavigation(lmn)
    }
    var evr = mr.getAttribute("evenrow");
    var uevr = mr.getAttribute("unevenrow");
    if (evr || uevr) {
        windowf.enableAlterCss(evr, uevr)
    }
    if (drag) {
        windowf.enableDragAndDrop(true)
    }
    windowf.init();
    if (obj.getAttribute("split")) {
        windowf.splitAt(obj.getAttribute("split"))
    }
    windowf._process_inner_html(mr, 1);
    if (acs2) {
        eval(acs2)
    }
    if (obj.parentNode && obj.parentNode.removeChild) {
        obj.parentNode.removeChild(obj)
    }
    return windowf
}
dhtmlXGridObject.prototype._process_html = function (c) {
    if (c.tagName && c.tagName == "TABLE") {
        return this._process_inner_html(c, 0)
    }
    var a = document.createElement("DIV");
    a.innerHTML = c.xmlDoc.responseText;
    var g = a.getElementsByTagName("TABLE")[0];
    this._process_inner_html(g, 0)
};
dhtmlXGridObject.prototype._process_inner_html = function (g, l) {
    var c = g.rows.length;
    for (var a = l; a < c; a++) {
        var h = g.rows[a].getAttribute("id") || a;
        this.rowsBuffer.push({
            idd: h,
            data: g.rows[a],
            _parser: this._process_html_row,
            _locator: this._get_html_data
        })
    }
    this.render_dataset();
    this.setSizes()
};
dhtmlXGridObject.prototype._process_html_row = function (o, l) {
    var n = l.getElementsByTagName("TD");
    var c = [];
    o._attrs = this._xml_attrs(l);
    for (var h = 0; h < n.length; h++) {
        var m = n[h];
        var a = m.getAttribute("type");
        if (o.childNodes[h]) {
            if (a) {
                o.childNodes[h]._cellType = a
            }
            o.childNodes[h]._attrs = this._xml_attrs(n[h])
        }
        if (m.firstChild) {
            c.push(m.innerHTML)
        } else {
            c.push("")
        }
        if (m.colSpan > 1) {
            o.childNodes[h]._attrs.colspan = m.colSpan;
            for (var g = 1; g < m.colSpan; g++) {
                c.push("")
            }
        }
    }
    for (h < n.length; h < o.childNodes.length; h++) {
        o.childNodes[h]._attrs = {}
    }
    this._fillRow(o, (this._c_order ? this._swapColumns(c) : c));
    return o
};
dhtmlXGridObject.prototype._get_html_data = function (c, a) {
    c = c.firstChild;
    while (true) {
        if (!c) {
            return ""
        }
        if (c.tagName == "TD") {
            a--
        }
        if (a < 0) {
            break
        }
        c = c.nextSibling
    }
    return (c.firstChild ? c.firstChild.data : "")
};
dhtmlxEvent(window, "load", function () {
    var g = document.getElementsByTagName("table");
    for (var c = 0; c < g.length; c++) {
        if (g[c].className == "dhtmlxGrid") {
            dhtmlXGridFromTable(g[c])
        }
    }
});

function dhtmlXForm(j, h, l) {
    this.idef = {
        position: "label-left",
        labelWidth: "auto",
        labelHeight: "auto",
        inputWidth: "auto",
        inputHeight: "auto",
        labelAlign: "left",
        noteWidth: "auto",
        offsetTop: 0,
        offsetLeft: 0,
        blockOffset: 20
    };
    this.idef_const = {
        offsetNested: 20
    };
    this.apos_css = {
        "label-left": "dhxform_item_label_left",
        "label-right": "dhxform_item_label_right",
        "label-top": "dhxform_item_label_top",
        "label-bottom": "dhxform_item_label_bottom",
        absolute: "dhxform_item_absolute"
    };
    this.align_css = {
        left: "dhxform_label_align_left",
        center: "dhxform_label_align_center",
        right: "dhxform_label_align_right"
    };
    var g = this;
    this.setSkin = function (a) {
        this.skin = a;
        this.cont.className = "dhxform_obj_" + this.skin;
        this.cont.style.fontSize = (a == "dhx_terrace" ? "13px" : "12px");
        this._updateBlocks();
        this.forEachItem(function (n) {
            var m = g.getItemType(n);
            if (typeof (g.items[m]) != "undefined" && typeof (g.items[m].setSkin) == "function") {
                g.doWithItem(n, "setSkin", a)
            }
        })
    };
    this.skin = (l || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhx_form") || "dhx_skyblue");
    this.separator = ",";
    this.live_validate = false;
    this._type = "checkbox";
    this._rGroup = "default";
    this._idIndex = {};
    this._indexId = [];
    this.cont = (typeof (j) == "object" ? j : document.getElementById(j));
    if (!j._isNestedForm) {
        this._parentForm = true;
        this.cont.style.fontSize = (this.skin == "dhx_terrace" ? "13px" : "12px");
        this.cont.className = "dhxform_obj_" + this.skin;
        this.setFontSize = function (a) {
            this.cont.style.fontSize = a;
            this._updateBlocks()
        };
        this.getForm = function () {
            return this
        };
        this.cont.onkeypress = function (m) {
            m = (m || event);
            if (m.keyCode == 13) {
                var a = (m.target || m.srcElement);
                if (typeof (a.tagName) != "undefined" && String(a.tagName).toLowerCase() == "textarea" && !m.ctrlKey) {
                    return
                }
                g.callEvent("onEnter", [])
            }
        }
    }
    this.b_index = null;
    this.base = [];
    this._prepare = function (u, v) {
        if (this.b_index == null) {
            this.b_index = 0
        } else {
            this.b_index++
        }
        var n = null;
        var m = null;
        if (v != null) {
            if (v < 0) {
                v = 0
            }
            var r = 0;
            for (var a = 0; a < this.cont.childNodes.length; a++) {
                for (var s = 0; s < this.cont.childNodes[a].childNodes.length; s++) {
                    if (m == null && this.cont.childNodes[a].childNodes[s]._isNestedForm != true) {
                        if (r == v) {
                            n = this.cont.childNodes[a].nextSibling;
                            m = this.cont.childNodes[a].childNodes[s]
                        }
                        r++
                    }
                }
            }
        }
        this.base[this.b_index] = document.createElement("DIV");
        this.base[this.b_index].className = "dhxform_base";
        if (typeof (u) != "undefined") {
            this.base[this.b_index].style.cssText += " margin-left:" + u + "px!important;"
        }
        if (n != null) {
            this.cont.insertBefore(this.base[this.b_index], n);
            n = null
        } else {
            this.cont.appendChild(this.base[this.b_index])
        }
        if (m != null) {
            while (m != null) {
                var o = m;
                m = m.nextSibling;
                this.base[this.b_index].appendChild(o);
                o = null
            }
        }
    };
    this.setSizes = function () {};
    this._mergeSettings = function (s) {
        var n = -1;
        var o = {
            type: "settings"
        };
        for (var m in this.idef) {
            o[m] = this.idef[m]
        }
        for (var r = 0; r < s.length; r++) {
            if (typeof (s[r]) != "undefined" && s[r].type == "settings") {
                for (var m in s[r]) {
                    o[m] = s[r][m]
                }
                n = r
            }
        }
        s[n >= 0 ? n : s.length] = o;
        return s
    };
    this._genStr = function (a) {
        var m = "";
        var o = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        for (var n = 0; n < a; n++) {
            m += o.charAt(Math.floor(Math.random() * o.length))
        }
        return m
    };
    this.idPrefix = "dhxForm_" + this._genStr(12) + "_";
    this._rId = (this._parentForm ? this._genStr(12) + "_" : j._rId);
    this.objPull = {};
    this.itemPull = {};
    this._ic = 0;
    this._addItem = function (E, r, x, u, C, F, A) {
        if (this.items[E]._index) {
            this.getForm()._indexId.push(r);
            this.getForm()._idIndex[r] = {
                ind: this.getForm()._indexId.length - 1
            }
        }
        if (!E) {
            E = this._type
        }
        if (E == "list" && C != null && this.itemPull[this.idPrefix + C] != null && typeof (this.itemPull[this.idPrefix + C]._addSubListNode) == "function") {
            var D = this.itemPull[this.idPrefix + C]._addSubListNode()
        } else {
            if (E == "newcolumn") {
                var D = {}
            } else {
                var s = this.base[this.b_index];
                var m = null;
                if (typeof (F) != "undefined" && !isNaN(F) && E != "list") {
                    F = Math.max(parseInt(F), 0) + 1;
                    for (var I = 0; I < this.cont.childNodes.length; I++) {
                        for (var n = 0; n < this.cont.childNodes[I].childNodes.length; n++) {
                            if (m == null && this.cont.childNodes[I].childNodes[n]._isNestedForm != true) {
                                F--;
                                if (F == 0) {
                                    m = this.cont.childNodes[I].childNodes[n];
                                    s = this.cont.childNodes[I]
                                }
                            }
                        }
                    }
                } else {
                    if (E == "list") {
                        for (var H in this.itemPull) {
                            if (H == this.idPrefix + r) {
                                m = this.itemPull[H].nextSibling;
                                if (this.itemPull[H]._listBase != null && this.itemPull[H]._listBase.length > 0) {
                                    m = this.itemPull[H]._listBase[this.itemPull[H]._listBase.length - 1]
                                }
                            }
                        }
                    }
                }
                var D = document.createElement("DIV");
                if (A == true && m != null) {
                    m = m.nextSibling
                }
                if (m != null) {
                    s.insertBefore(D, m)
                } else {
                    s.appendChild(D)
                }
            }
        }
        D._idd = r;
        D._rId = this._rId;
        if (typeof (D.style) != "undefined") {
            if (typeof (x.offsetLeft) == "undefined" && this.idef.offsetLeft > 0) {
                x.offsetLeft = this.idef.offsetLeft
            }
            if (typeof (x.offsetTop) == "undefined" && this.idef.offsetTop > 0) {
                x.offsetTop = this.idef.offsetTop
            }
            var v = "";
            if (typeof (x.offsetLeft) != "undefined") {
                v += " padding-left:" + x.offsetLeft + "px!important;"
            }
            if (typeof (x.offsetTop) != "undefined") {
                v += " padding-top:" + x.offsetTop + "px!important;"
            }
            D.style.cssText += v
        }
        if (E == "block") {
            if (isNaN(x.blockOffset)) {
                x.blockOffset = this.idef.blockOffset
            }
        }
        if (E == "list") {
            if (typeof (D._ofsNested) == "undefined") {
                D._ofsNested = this.idef_const.offsetNested
            }
            if (u != null) {
                D._sId = u
            }
            var y = this.items[E].render(D, this.skin);
            if (!this.itemPull[this.idPrefix + r]._listObj) {
                this.itemPull[this.idPrefix + r]._listObj = []
            }
            if (!this.itemPull[this.idPrefix + r]._list) {
                this.itemPull[this.idPrefix + r]._list = []
            }
            if (!this.itemPull[this.idPrefix + r]._listBase) {
                this.itemPull[this.idPrefix + r]._listBase = []
            }(this.itemPull[this.idPrefix + r]._listObj).push(y[0]);
            (this.itemPull[this.idPrefix + r]._list).push(y[1]);
            (this.itemPull[this.idPrefix + r]._listBase).push(D);
            y[1].checkEvent = function (a) {
                return g.checkEvent(a)
            };
            y[1].callEvent = function (a, q) {
                return g.callEvent(a, q)
            };
            y[1].getForm = function () {
                return g.getForm()
            };
            y[1]._initObj(this._mergeSettings(x));
            if (D._inBlcok) {
                D.className += " in_block"
            }
            return y[1]
        }
        if (E == "newcolumn") {
            this._prepare(x.offset, F);
            return
        }
        if (E == "label" && this._ic++ == 0) {
            x._isTopmost = true
        }
        x.position = this.apos_css[(!x.position || !this.apos_css[x.position] ? this.idef.position : x.position)];
        D.className = x.position + (typeof (x.className) == "string" ? " " + x.className : "");
        if (!x.labelWidth) {
            x.labelWidth = this.idef.labelWidth
        }
        if (!x.labelHeight) {
            x.labelHeight = this.idef.labelHeight
        }
        if (typeof (x.wrap) != "undefined") {
            x.wrap = window.dhx4.s2b(x.wrap)
        }
        x.labelAlign = (this.align_css[x.labelAlign] ? this.align_css[x.labelAlign] : this.align_css[this.idef.labelAlign]);
        x.inputWidth = (x.width ? x.width : (x.inputWidth ? x.inputWidth : this.idef.inputWidth));
        if (!x.inputHeight) {
            x.inputHeight = this.idef.inputHeight
        }
        if (typeof (x.note) != "undefined") {
            if (x.note.length != null && x.note[0] != null) {
                x.note = x.note[0]
            }
            if (typeof (x.note.width) == "undefined") {
                x.note.width = this.idef.noteWidth
            }
            if (x.note.width == "auto") {
                x.note.width = x.inputWidth
            }
        }
        D.checkEvent = function (a) {
            return g.checkEvent(a)
        };
        D.callEvent = function (a, q) {
            return g.callEvent(a, q)
        };
        D.getForm = function () {
            return g.getForm()
        };
        D._autoCheck = function (a) {
            g._autoCheck(a)
        };
        if (typeof (x.readonly) == "string") {
            x.readonly = window.dhx4.s2b(x.readonly)
        }
        if (typeof (x.autoStart) == "string") {
            x.autoStart = window.dhx4.s2b(x.autoStart)
        }
        if (typeof (x.autoRemove) == "string") {
            x.autoRemove = window.dhx4.s2b(x.autoRemove)
        }
        if (typeof (x.titleScreen) == "string") {
            x.titleScreen = window.dhx4.s2b(x.titleScreen)
        }
        if (typeof (x.info) == "string") {
            x.info = window.dhx4.s2b(x.info)
        }
        if (typeof (x.hidden) == "string") {
            x.hidden = window.dhx4.s2b(x.hidden)
        }
        if (typeof (x.checked) == "string") {
            x.checked = window.dhx4.s2b(x.checked)
        }
        if (typeof (x.userdata) != "undefined") {
            for (var H in x.userdata) {
                this.getForm().setUserData(r, H, x.userdata[H])
            }
        }
        if (x.validate) {
            if (typeof (x.validate != "undefined") && (typeof (x.validate) == "function" || typeof (window[x.validate]) == "function")) {
                D._validate = [x.validate]
            } else {
                D._validate = String(x.validate).split(this.separator)
            }
        }
        if (typeof (x.required) != "undefined") {
            if (typeof (x.required) == "string") {
                x.required = window.dhx4.s2b(x.required)
            }
            D._required = (x.required == true)
        }
        if (D._required) {
            if (!D._validate) {
                D._validate = []
            }
            var o = false;
            for (n = 0; n < D._validate.length; n++) {
                o = (o || (D._validate[n] == "NotEmpty"))
            }
            if (!o) {
                D._validate.push("NotEmpty")
            }
        }
        D._ll = (x.position == this.apos_css["label-left"] || x.position == this.apos_css["label-top"]);
        this.objPull[this.idPrefix + r] = this.items[E].render(D, x);
        this.itemPull[this.idPrefix + r] = D
    };
    this._initObj = function (r, n) {
        if (typeof (r.data) != "undefined") {
            var s = null;
            if (typeof (n) != "undefined") {
                s = n.match(/(\?|\&)id\=([a-z0-9_\-]*)/i);
                if (s != null && s[0] != null) {
                    s = s[0].split("=")[1]
                }
            }
            if (this.callEvent("onBeforeDataLoad", [s, window.dhx4._copyObj(r.data)]) === true) {
                this.formId = s;
                this._last_load_data = r;
                this.setFormData(r.data);
                this.resetDataProcessor("updated")
            }
            return
        }
        this._prepare();
        for (var o = 0; o < r.length; o++) {
            if (typeof (r[o]) != "undefined" && r[o].type == "settings") {
                for (var m in r[o]) {
                    this.idef[m] = r[o][m]
                }
            }
        }
        for (var o = 0; o < r.length; o++) {
            this._prepareItem(r[o])
        }
        this._autoCheck()
    };
    this._prepareItem = function (q, u, o) {
        var n = (q != null && q.type != null ? q.type : "");
        if (this.items[n]) {
            if (!q.name) {
                q.name = this._genStr(12)
            }
            var s = q.name;
            if (this.objPull[this.idPrefix + s] != null || n == "radio") {
                s = this._genStr(12)
            }
            var r = q;
            r.label = r.label || "";
            r.value = r.value;
            r.checked = window.dhx4.s2b(r.checked);
            r.disabled = window.dhx4.s2b(r.disabled);
            r.name = r.name || this._genStr(12);
            r.options = r.options || [];
            r.rows = r.rows || "none";
            r.uid = this._genStr(12);
            this._addItem(n, s, r, null, null, u, o);
            u = null;
            if (this._parentEnabled === false) {
                this._disableItem(s)
            }
            for (var m = 0; m < r.options.length; m++) {
                if (r.options[m].list != null) {
                    if (!r.options[m].value) {
                        r.options[m].value = this._genStr()
                    }
                    var a = this._addItem("list", s, r.options[m].list, r.options[m].value, null);
                    a._subSelect = true;
                    a._subSelectId = r.options[m].value
                }
            }
            if (q.list != null) {
                if (!q.listParent) {
                    q.listParent = r.name
                }
                var a = this._addItem("list", s, q.list, null, q.listParent)
            }
        }
    };
    this._xmlSubItems = {
        item: "list",
        option: "options",
        note: "note",
        userdata: "_userdata"
    };
    this._xmlToObject = function (A, m) {
        if (typeof (m) == "undefined") {
            m = true
        }
        if (m) {
            var D = A.getElementsByTagName("items");
            D = (D != null && D[0] != null ? D[0] : null);
            var n = A.getElementsByTagName("data");
            n = (n != null && n[0] != null ? n[0] : null)
        } else {
            D = A
        }
        var y = (m ? [] : {});
        if (D != null) {
            for (var r = 0; r < D.childNodes.length; r++) {
                if (typeof (D.childNodes[r].tagName) != "undefined") {
                    var s = D.childNodes[r].tagName;
                    if (this._xmlSubItems[s] != null) {
                        var u = this._xmlSubItems[s];
                        if (typeof (y[u]) == "undefined") {
                            y[u] = []
                        }
                        var x = {};
                        for (var I = 0; I < D.childNodes[r].attributes.length; I++) {
                            var E = D.childNodes[r].attributes[I].name;
                            var C = D.childNodes[r].attributes[I].value;
                            x[E] = C
                        }
                        if (u == "note") {
                            x.text = D.childNodes[r].firstChild.nodeValue
                        }
                        if (u == "_userdata") {
                            x.value = D.childNodes[r].firstChild.nodeValue
                        }
                        var v = this._xmlToObject(D.childNodes[r], false);
                        for (var F in v) {
                            if (F == "_userdata") {
                                if (!x.userdata) {
                                    x.userdata = {}
                                }
                                for (var I = 0; I < v[F].length; I++) {
                                    x.userdata[v[F][I].name] = v[F][I].value
                                }
                            } else {
                                x[F] = v[F]
                            }
                        }
                        if (m) {
                            y.push(x)
                        } else {
                            y[u].push(x)
                        }
                    }
                }
            }
        }
        if (n != null) {
            y = {
                data: {}
            };
            for (var r = 0; r < n.childNodes.length; r++) {
                if (typeof (n.childNodes[r].tagName) != "undefined") {
                    var o = n.childNodes[r].tagName;
                    var H = (n.childNodes[r].firstChild != null ? n.childNodes[r].firstChild.nodeValue : "");
                    y.data[o] = H
                }
            }
        }
        return y
    };
    this._autoCheck = function (s) {
        if (this._locked === true) {
            s = false
        } else {
            if (typeof (s) == "undefined") {
                s = true
            }
        }
        for (var o in this.itemPull) {
            var u = (s && (this.itemPull[o]._udis !== true));
            this[u ? "_enableItem" : "_disableItem"](this.itemPull[o]._idd);
            if (this.getForm()._idIndex[this.itemPull[o]._idd] != null) {
                this.getForm()._idIndex[this.itemPull[o]._idd].enabled = u
            }
            var n = (u && (typeof (this.itemPull[o]._checked) == "boolean" ? this.itemPull[o]._checked : true));
            if (this.itemPull[o]._list) {
                for (var y = 0; y < this.itemPull[o]._list.length; y++) {
                    var x = true;
                    if (this.itemPull[o]._list[y]._subSelect == true) {
                        x = false;
                        var r = this.getItemValue(this.itemPull[o]._idd);
                        if (!(typeof (r) == "object" && typeof (r.length) == "number")) {
                            r = [r]
                        }
                        for (var m = 0; m < r.length; m++) {
                            x = (r[m] == this.itemPull[o]._list[y]._subSelectId) || x
                        }
                        this.itemPull[o]._listObj[y][x ? "show" : "hide"](this.itemPull[o]._listBase[y])
                    }
                    this.itemPull[o]._list[y]._autoCheck(n && x)
                }
            }
        }
    };
    this.doWithItem = function (o, m, x, w, v, u) {
        if (typeof (o) == "object") {
            var A = o[0];
            var y = o[1];
            var C = null;
            var s = null;
            for (var r in this.itemPull) {
                if ((this.itemPull[r]._value == y || y === null) && this.itemPull[r]._group == A) {
                    return this.objPull[r][m](this.itemPull[r], x, w, v, u)
                }
                if (this.itemPull[r]._list != null && !s) {
                    for (var n = 0; n < this.itemPull[r]._list.length; n++) {
                        s = this.itemPull[r]._list[n].doWithItem(o, m, x, w, v)
                    }
                }
            }
            if (s != null) {
                return s
            } else {
                if (m == "getType") {
                    return this.doWithItem(o[0], "getType")
                }
            }
        } else {
            if (!this.itemPull[this.idPrefix + o]) {
                var s = null;
                for (var r in this.itemPull) {
                    if (this.itemPull[r]._list && !s) {
                        for (var n = 0; n < this.itemPull[r]._list.length; n++) {
                            if (s == null) {
                                s = this.itemPull[r]._list[n].doWithItem(o, m, x, w, v, u)
                            }
                        }
                    }
                }
                return s
            } else {
                return this.objPull[this.idPrefix + o][m](this.itemPull[this.idPrefix + o], x, w, v, u)
            }
        }
    };
    this._removeItem = function (m, a) {
        if (a != null) {
            m = this.doWithItem([m, a], "destruct")
        } else {
            this.doWithItem(m, "destruct")
        }
        this._clearItemData(m)
    };
    this._clearItemData = function (o) {
        if (this.itemPull[this.idPrefix + o]) {
            o = this.idPrefix + o;
            try {
                this.objPull[o] = null;
                this.itemPull[o] = null;
                delete this.objPull[o];
                delete this.itemPull[o]
            } catch (n) {}
        } else {
            for (var a in this.itemPull) {
                if (this.itemPull[a]._list) {
                    for (var m = 0; m < this.itemPull[a]._list.length; m++) {
                        this.itemPull[a]._list[m]._clearItemData(o)
                    }
                }
            }
        }
    };
    this.isItem = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        return this.doWithItem(m, "isExist")
    };
    this.getItemType = function (m, a) {
        m = [m, (a || null)];
        return this.doWithItem(m, "getType")
    };
    this.forEachItem = function (n) {
        for (var m in this.objPull) {
            if (this.objPull[m].t == "radio") {
                n(this.itemPull[m]._group, this.itemPull[m]._value)
            } else {
                n(String(m).replace(this.idPrefix, ""))
            }
            if (this.itemPull[m]._list) {
                for (var o = 0; o < this.itemPull[m]._list.length; o++) {
                    this.itemPull[m]._list[o].forEachItem(n)
                }
            }
        }
    };
    this.setItemLabel = function (n, a, m) {
        if (m != null) {
            n = [n, a]
        } else {
            m = a
        }
        this.doWithItem(n, "setText", m)
    };
    this.getItemLabel = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        return this.doWithItem(m, "getText")
    };
    this._enableItem = function (a) {
        this.doWithItem(a, "enable")
    };
    this._disableItem = function (a) {
        this.doWithItem(a, "disable")
    };
    this._isItemEnabled = function (a) {
        return this.doWithItem(a, "isEnabled")
    };
    this.checkItem = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        this.doWithItem(m, "check");
        this._autoCheck()
    };
    this.uncheckItem = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        this.doWithItem(m, "unCheck");
        this._autoCheck()
    };
    this.isItemChecked = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        return this.doWithItem(m, "isChecked")
    };
    this.getCheckedValue = function (a) {
        return this.doWithItem([a, null], "getChecked")
    };
    this._getRGroup = function (u, s) {
        for (var m in this.itemPull) {
            if (this.itemPull[m]._group == u && (s == null || this.itemPull[m]._value == s)) {
                return this.itemPull[m]._idd
            }
            if (this.itemPull[m]._list != null) {
                for (var o = 0; o < this.itemPull[m]._list.length; o++) {
                    var n = this.itemPull[m]._list[o]._getRGroup(u, s);
                    if (n != null) {
                        return n
                    }
                }
            }
        }
        return null
    };
    this.setItemValue = function (m, a) {
        if (this.getItemType(m) == "radio") {
            if (this._getRGroup(m, a) != null) {
                this.checkItem(m, a)
            } else {
                this.uncheckItem(m, this.getCheckedValue(m))
            }
            return null
        }
        return this.doWithItem(m, "setValue", a)
    };
    this.getItemValue = function (m, a) {
        if (this.getItemType(m) == "radio") {
            return this.getCheckedValue(m)
        }
        return this.doWithItem(m, "getValue", a)
    };
    this.updateValues = function () {
        this._updateValues()
    };
    this.showItem = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        this.doWithItem(m, "show")
    };
    this.hideItem = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        this.doWithItem(m, "hide")
    };
    this.isItemHidden = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        return this.doWithItem(m, "isHidden")
    };
    this.getOptions = function (a) {
        return this.doWithItem(a, "getOptions")
    };
    this.setItemWidth = function (m, a) {
        this.doWithItem(m, "setWidth", a)
    };
    this.getItemWidth = function (a) {
        return this.doWithItem(a, "getWidth")
    };
    this.setItemHeight = function (m, a) {
        this.doWithItem(m, "setHeight", a)
    };
    this.setItemFocus = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        this.doWithItem(m, "setFocus")
    };
    this._updateValues = function () {
        for (var m in this.itemPull) {
            if (this.objPull[m] && typeof (this.objPull[m].updateValue) == "function") {
                this.objPull[m].updateValue(this.itemPull[m])
            }
            if (this.itemPull[m]._list) {
                for (var n = 0; n < this.itemPull[m]._list.length; n++) {
                    this.itemPull[m]._list[n]._updateValues()
                }
            }
        }
    };
    this._getItemByName = function (s) {
        for (var m in this.itemPull) {
            if (this.itemPull[m]._idd == s) {
                return this.itemPull[m]
            }
            if (this.itemPull[m]._list != null) {
                for (var o = 0; o < this.itemPull[m]._list.length; o++) {
                    var n = this.itemPull[m]._list[o]._getItemByName(s);
                    if (n != null) {
                        return n
                    }
                }
            }
        }
        return null
    };
    this._resetValidateCss = function (a) {
        a.className = (a.className).replace(a._vcss, "");
        a._vcss = null
    };
    this.setValidateCss = function (a, o, n) {
        var m = this[this.getItemType(a) == "radio" ? "_getRGroup" : "_getItemByName"](a);
        if (!m) {
            return
        }
        if (m._vcss != null) {
            this._resetValidateCss(m)
        }
        m._vcss = (typeof (n) == "string" ? n : "validate_" + (o === true ? "ok" : "error"));
        m.className += " " + m._vcss
    };
    this.resetValidateCss = function (n) {
        for (var m in this.itemPull) {
            if (this.itemPull[m]._vcss != null) {
                this._resetValidateCss(this.itemPull[m])
            }
            if (this.itemPull[m]._list != null) {
                for (var o = 0; o < this.itemPull[m]._list.length; o++) {
                    this.itemPull[m]._list[o].resetValidateCss()
                }
            }
        }
    };
    this.validate = function (m) {
        if (this.callEvent("onBeforeValidate", []) == false) {
            return
        }
        var a = true;
        this.forEachItem(function (o, q) {
            if (typeof (q) != "undefined") {
                o = [o, q]
            }
            var n = g.doWithItem(o, "_validate");
            if (typeof (n) != "boolean") {
                n = true
            }
            a = n && a
        });
        this.callEvent("onAfterValidate", [a]);
        return a
    };
    this.validateItem = function (a, m) {
        if (typeof (m) != "undefined") {
            a = [a, m]
        }
        return this.doWithItem(a, "_validate")
    };
    this.enableLiveValidation = function (a) {
        this.live_validate = (a == true)
    };
    this.setReadonly = function (m, a) {
        this.doWithItem(m, "setReadonly", a)
    };
    this.isReadonly = function (a) {
        return this.doWithItem(a, "isReadonly")
    };
    this.getFirstActive = function (m) {
        for (var o = 0; o < this._indexId.length; o++) {
            var a = true;
            if (m == true) {
                var n = this.getItemType(this._indexId[o]);
                if (!dhtmlXForm.prototype.items[n].setFocus) {
                    a = false
                }
            }
            if (a && this._idIndex[this._indexId[o]].enabled) {
                return this._indexId[o]
            }
        }
        return null
    };
    this.setFocusOnFirstActive = function () {
        var a = this.getFirstActive(true);
        if (a != null) {
            this.setItemFocus(a)
        }
    };
    this.enableItem = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        this.doWithItem(m, "userEnable");
        this._autoCheck()
    };
    this.disableItem = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        this.doWithItem(m, "userDisable");
        this._autoCheck()
    };
    this.isItemEnabled = function (m, a) {
        if (a != null) {
            m = [m, a]
        }
        return this.doWithItem(m, "isUserEnabled")
    };
    this.clear = function () {
        var m = {};
        this.formId = (new Date()).valueOf();
        this.resetDataProcessor("inserted");
        for (var n in this.itemPull) {
            var o = this.itemPull[n]._idd;
            if (this.itemPull[n]._type == "ch") {
                this.uncheckItem(o)
            }
            if (this.itemPull[n]._type in {
                ta: 1,
                editor: 1,
                calendar: 1,
                pw: 1,
                hd: 1
            }) {
                this.setItemValue(o, "")
            }
            if (this.itemPull[n]._type == "combo") {
                this.itemPull[n]._apiChange = true;
                var v = this.getCombo(o);
                v.selectOption(0);
                v = null;
                this.itemPull[n]._apiChange = false
            }
            if (this.itemPull[n]._type == "se") {
                var s = this.getOptions(o);
                if (s.length > 0) {
                    s[0].selected = true
                }
            }
            if (this.itemPull[n]._type == "ra") {
                var r = this.itemPull[n]._group;
                if (!m[r]) {
                    this.checkItem(r, this.doWithItem(o, "_getFirstValue"));
                    m[r] = true
                }
            }
            if (this.itemPull[n]._list) {
                for (var u = 0; u < this.itemPull[n]._list.length; u++) {
                    this.itemPull[n]._list[u].clear()
                }
            }
            if (this["setFormData_" + this.itemPull[n]._type]) {
                this["setFormData_" + this.itemPull[n]._type](o, "")
            }
        }
        m = null;
        if (this._parentForm) {
            this._autoCheck()
        }
        this.resetValidateCss()
    };
    this.unload = function () {
        window.dhx4._enableDataLoading(this, null, null, null, "clear");
        window.dhx4._eventable(this, "clear");
        for (var m in this.objPull) {
            this._removeItem(String(m).replace(this.idPrefix, ""))
        }
        if (this._ccTm) {
            window.clearTimeout(this._ccTm)
        }
        this._formLS = null;
        for (var n = 0; n < this.base.length; n++) {
            while (this.base[n].childNodes.length > 0) {
                this.base[n].removeChild(this.base[n].childNodes[0])
            }
            if (this.base[n].parentNode) {
                this.base[n].parentNode.removeChild(this.base[n])
            }
            this.base[n] = null
        }
        this.base = null;
        this.cont.onkeypress = null;
        this.cont.className = "";
        this.cont = null;
        for (var m in this) {
            this[m] = null
        }
        g = null
    };
    for (var c in this.items) {
        this.items[c].t = c;
        if (typeof (this.items[c]._index) == "undefined") {
            this.items[c]._index = true
        }
        if (!this.items[c].show) {
            this.items[c].show = function (a) {
                a.style.display = "";
                if (a._listObj) {
                    for (var m = 0; m < a._listObj.length; m++) {
                        a._listObj[m].show(a._listBase[m])
                    }
                }
            }
        }
        if (!this.items[c].hide) {
            this.items[c].hide = function (a) {
                a.style.display = "none";
                if (a._listObj) {
                    for (var m = 0; m < a._listObj.length; m++) {
                        a._listObj[m].hide(a._listBase[m])
                    }
                }
            }
        }
        if (!this.items[c].isHidden) {
            this.items[c].isHidden = function (a) {
                return (a.style.display == "none")
            }
        }
        if (!this.items[c].userEnable) {
            this.items[c].userEnable = function (a) {
                a._udis = false
            }
        }
        if (!this.items[c].userDisable) {
            this.items[c].userDisable = function (a) {
                a._udis = true
            }
        }
        if (!this.items[c].isUserEnabled) {
            this.items[c].isUserEnabled = function (a) {
                return (a._udis !== true)
            }
        }
        if (!this.items[c].getType) {
            this.items[c].getType = function () {
                return this.t
            }
        }
        if (!this.items[c].isExist) {
            this.items[c].isExist = function () {
                return true
            }
        }
        if (!this.items[c]._validate) {
            this.items[c]._validate = function (n) {
                if (!n._validate || !n._enabled) {
                    return true
                }
                if (n._type == "ch") {
                    var u = (this.isChecked(n) ? this.getValue(n) : 0)
                } else {
                    var u = this.getValue(n)
                }
                var m = true;
                for (var s = 0; s < n._validate.length; s++) {
                    var a = "is" + n._validate[s];
                    if ((u == null || u.length == 0) && a != "isNotEmpty" && n._type != "container") {} else {
                        var o = dhtmlxValidation[a];
                        if (n._type == "container" && typeof (o) == "function") {
                            o = function () {
                                return true
                            }
                        }
                        if (typeof (o) != "function" && typeof (n._validate[s]) == "function") {
                            o = n._validate[s]
                        }
                        if (typeof (o) != "function" && typeof (window[n._validate[s]]) == "function") {
                            o = window[n._validate[s]]
                        }
                        m = ((typeof (o) == "function" ? o(u, n._idd) : new RegExp(n._validate[s]).test(u)) && m);
                        o = null
                    }
                }
                if (!(n.callEvent("onValidate" + (m ? "Success" : "Error"), [n._idd, u, m]) === false)) {
                    n.getForm().setValidateCss(n._idd, m)
                }
                return m
            }
        }
    }
    this._locked = false;
    this._doLock = function (m) {
        var a = (m === true ? true : false);
        if (this._locked == a) {
            return
        } else {
            this._locked = a
        }
        this._autoCheck(!this._locked)
    };
    this.lock = function () {
        this._doLock(true)
    };
    this.unlock = function () {
        this._doLock(false)
    };
    this.isLocked = function () {
        return this._locked
    };
    this.setNumberFormat = function (o, m, a, n) {
        return this.doWithItem(o, "setNumberFormat", m, a, n)
    };
    window.dhx4._enableDataLoading(this, "_initObj", "_xmlToObject", "items", {
        struct: true,
        data: true
    });
    window.dhx4._eventable(this);
    this.attachEvent("_onButtonClick", function (a, m) {
        this.callEvent("onButtonClick", [a, m])
    });
    this._updateBlocks = function () {
        this.forEachItem(function (a) {
            if (g.getItemType(a) == "block" || g.getItemType(a) == "combo") {
                g.doWithItem(a, "_setCss", g.skin, g.cont.style.fontSize)
            }
        })
    };
    this._isObj = function (a) {
        return (a != null && typeof (a) == "object" && typeof (a.length) == "undefined")
    };
    this._copyObj = function (o) {
        if (this._isObj(o)) {
            var n = {};
            for (var m in o) {
                if (typeof (o[m]) == "object" && o[m] != null) {
                    n[m] = this._copyObj(o[m])
                } else {
                    n[m] = o[m]
                }
            }
        } else {
            var n = [];
            for (var m = 0; m < o.length; m++) {
                if (typeof (o[m]) == "object" && o[m] != null) {
                    n[m] = this._copyObj(o[m])
                } else {
                    n[m] = o[m]
                }
            }
        }
        return n
    };
    if (h != null && typeof (h) == "object") {
        this._initObj(this._copyObj(h))
    }
    if (this._parentForm) {
        this._updateBlocks()
    }
    this._ccActive = false;
    this._ccTm = null;
    return this
}
dhtmlXForm.prototype.getInput = function (a) {
    return this.doWithItem(a, "getInput")
};
dhtmlXForm.prototype.getSelect = function (a) {
    return this.doWithItem(a, "getSelect")
};
dhtmlXForm.prototype.items = {};
dhtmlXForm.prototype.items.checkbox = {
    render: function (a, c) {
        a._type = "ch";
        a._enabled = true;
        a._checked = false;
        a._value = (typeof (c.value) == "undefined" ? null : String(c.value));
        a._ro = (c.readonly == true);
        if (c._autoInputWidth !== false) {
            c.inputWidth = 14
        }
        this.doAddLabel(a, c);
        this.doAddInput(a, c, "INPUT", "TEXT", true, true, "dhxform_textarea");
        a.childNodes[a._ll ? 1 : 0].className += " dhxform_img_node";
        var g = document.createElement("DIV");
        g.className = "dhxform_img chbx0";
        a.appendChild(g);
        if (!isNaN(c.inputLeft)) {
            a.childNodes[a._ll ? 1 : 0].style.left = parseInt(c.inputLeft) + "px"
        }
        if (!isNaN(c.inputTop)) {
            a.childNodes[a._ll ? 1 : 0].style.top = parseInt(c.inputTop) + "px"
        }
        a.childNodes[a._ll ? 1 : 0].appendChild(g);
        a.childNodes[a._ll ? 1 : 0].firstChild.value = String(c.value);
        a._updateImgNode = function (j, l) {
            var h = j.childNodes[j._ll ? 1 : 0].lastChild;
            h.className = (l ? "dhxform_actv_c" : "dhxform_img") + " " + (j._checked ? "chbx1" : "chbx0");
            j = h = null
        };
        a._doOnFocus = function (h) {
            h.getForm().callEvent("onFocus", [h._idd])
        };
        a._doOnBlur = function (h) {
            h.getForm().callEvent("onBlur", [h._idd])
        };
        a._doOnKeyUpDown = function (j, h) {
            this.callEvent(j, [this.childNodes[this._ll ? 0 : 1].childNodes[0], h, this._idd])
        };
        if (c.checked == true) {
            this.check(a)
        }
        if (c.hidden == true) {
            this.hide(a)
        }
        if (c.disabled == true) {
            this.userDisable(a)
        }
        this.doAttachEvents(a);
        return this
    },
    destruct: function (a) {
        a._doOnFocus = a._doOnBlur = a._updateImgNode = null;
        this.doUnloadNestedLists(a);
        this.doDestruct(a)
    },
    doAddLabel: function (c, g) {
        var a = document.createElement("DIV");
        a.className = "dhxform_label " + g.labelAlign;
        if (g.wrap == true) {
            a.style.whiteSpace = "normal"
        }
        if (c._ll) {
            c.insertBefore(a, c.firstChild)
        } else {
            c.appendChild(a)
        }
        if (typeof (g.tooltip) != "undefined") {
            a.title = g.tooltip
        }
        a.innerHTML = "<div class='dhxform_label_nav_link' onfocus='if(this.parentNode.parentNode._updateImgNode)this.parentNode.parentNode._updateImgNode(this.parentNode.parentNode,true);this.parentNode.parentNode._doOnFocus(this.parentNode.parentNode);' onblur='if(this.parentNode.parentNode._updateImgNode)this.parentNode.parentNode._updateImgNode(this.parentNode.parentNode,false);this.parentNode.parentNode._doOnBlur(this.parentNode.parentNode);' onkeypress='var e=event||window.arguments[0];if(e.keyCode==32||e.charCode==32){e.cancelBubble=true;if(e.preventDefault)e.preventDefault();else e.returnValue=false;_dhxForm_doClick(this,\"mousedown\");return false;}' onkeyup='var e=event||window.arguments[0];this.parentNode.parentNode._doOnKeyUpDown(\"onKeyUp\",e);' onkeydown='var e=event||window.arguments[0];this.parentNode.parentNode._doOnKeyUpDown(\"onKeyDown\",e);' " + (window.dhx4.isIPad ? "ontouchstart='var e=event;e.preventDefault();_dhxForm_doClick(this,\"mousedown\");' " : "") + "role='link' tabindex='0'>" + g.label + (g.info ? "<span class='dhxform_info'>[?]</span>" : "") + (c._required ? "<span class='dhxform_item_required'>*</span>" : "") + "</div>";
        if (!isNaN(g.labelWidth)) {
            a.firstChild.style.width = parseInt(g.labelWidth) + "px"
        }
        if (!isNaN(g.labelHeight)) {
            a.firstChild.style.height = parseInt(g.labelHeight) + "px"
        }
        if (!isNaN(g.labelLeft)) {
            a.style.left = parseInt(g.labelLeft) + "px"
        }
        if (!isNaN(g.labelTop)) {
            a.style.top = parseInt(g.labelTop) + "px"
        }
    },
    doAddInput: function (x, h, c, o, q, j, l) {
        var a = document.createElement("DIV");
        a.className = "dhxform_control";
        if (x._ll) {
            x.appendChild(a)
        } else {
            x.insertBefore(a, x.firstChild)
        }
        var v = document.createElement(c);
        v.className = l;
        v.name = x._idd;
        v._idd = x._idd;
        v.id = h.uid;
        if (typeof (o) == "string") {
            v.type = o
        }
        if (c == "INPUT" || c == "TEXTAREA") {
            v.onkeyup = function (u) {
                u = u || event;
                x.callEvent("onKeyUp", [this, u, this._idd])
            };
            v.onkeydown = function (u) {
                u = u || event;
                x.callEvent("onKeyDown", [this, u, this._idd])
            }
        }
        a.appendChild(v);
        if (h.readonly) {
            this.setReadonly(x, true)
        }
        if (h.hidden == true) {
            this.hide(x)
        }
        if (h.disabled == true) {
            this.userDisable(x)
        }
        if (q) {
            if (!isNaN(h.inputLeft)) {
                a.style.left = parseInt(h.inputLeft) + "px"
            }
            if (!isNaN(h.inputTop)) {
                a.style.top = parseInt(h.inputTop) + "px"
            }
        }
        var s = "";
        var m = false;
        if (j) {
            if (!isNaN(h.inputWidth)) {
                s += "width:" + parseInt(h.inputWidth) + "px;";
                m = true
            }
            if (!isNaN(h.inputHeight)) {
                s += "height:" + parseInt(h.inputHeight) + "px;"
            }
        }
        if (typeof (h.style) == "string") {
            s += h.style
        }
        v.style.cssText = s;
        if (h.maxLength) {
            v.setAttribute("maxLength", h.maxLength)
        }
        if (h.connector) {
            v.setAttribute("connector", h.connector)
        }
        if (m && {
            input: 1,
            password: 1,
            select: 1,
            calendar: 1,
            colorpicker: 1
        }[this.t]) {
            if (dhtmlXForm.prototype.items[this.t]._dim == null) {
                var r = parseInt(v.style.width);
                var g = (dhx4.isFF || dhx4.isIE ? v.offsetWidth : v.clientWidth);
                dhtmlXForm.prototype.items[this.t]._dim = g - r
            }
            v.style.width = parseInt(v.style.width) - dhtmlXForm.prototype.items[this.t]._dim + "px"
        }
        if (typeof (h.note) == "object") {
            var n = document.createElement("DIV");
            n.className = "dhxform_note";
            n.style.width = (isNaN(h.note.width) ? v.offsetWidth : parseInt(h.note.width)) + "px";
            n._w = h.note.width;
            n.innerHTML = h.note.text;
            a.appendChild(n);
            n = null
        }
    },
    doUnloadNestedLists: function (a) {
        if (!a._list) {
            return
        }
        for (var c = 0; c < a._list.length; c++) {
            a._list[c].unload();
            a._list[c] = null;
            a._listObj[c] = null;
            a._listBase[c].parentNode.removeChild(a._listBase[c]);
            a._listBase[c] = null
        }
        a._list = null;
        a._listObj = null;
        a._listBase = null
    },
    doDestruct: function (a) {
        a.callEvent = null;
        a.checkEvent = null;
        a.getForm = null;
        a._autoCheck = null;
        a._checked = null;
        a._enabled = null;
        a._idd = null;
        a._type = null;
        a._value = null;
        a._group = null;
        a.onselectstart = null;
        a.childNodes[a._ll ? 1 : 0].onmousedown = null;
        a.childNodes[a._ll ? 1 : 0].ontouchstart = null;
        a.childNodes[a._ll ? 0 : 1].onmousedown = null;
        a.childNodes[a._ll ? 0 : 1].ontouchstart = null;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].onfocus = null;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].onblur = null;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].onkeypress = null;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].onkeyup = null;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].onkeydown = null;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].onmousedown = null;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].ontouchstart = null;
        a.childNodes[a._ll ? 0 : 1].removeChild(a.childNodes[a._ll ? 0 : 1].childNodes[0]);
        while (a.childNodes.length > 0) {
            a.removeChild(a.childNodes[0])
        }
        a.parentNode.removeChild(a);
        a = null
    },
    doAttachEvents: function (c) {
        var a = this;
        c.childNodes[c._ll ? 1 : 0][window.dhx4.isIPad ? "ontouchstart" : "onmousedown"] = function (h) {
            h = h || event;
            if (h.preventDefault) {
                h.preventDefault()
            }
            var g = (h.target || h.srcElement);
            if (!this.parentNode._enabled || this.parentNode._ro || (typeof (g.className) != "undefined" && g.className == "dhxform_note")) {
                h.cancelBubble = true;
                if (h.preventDefault) {
                    h.preventDefault()
                } else {
                    h.returnValue = false
                }
                return false
            }
            a.doClick(this.parentNode)
        };
        c.childNodes[c._ll ? 0 : 1].childNodes[0][window.dhx4.isIPad ? "ontouchstart" : "onmousedown"] = function (h) {
            h = h || event;
            if (h.preventDefault) {
                h.preventDefault()
            }
            if (!this.parentNode.parentNode._enabled) {
                h.cancelBubble = true;
                if (h.preventDefault) {
                    h.preventDefault()
                } else {
                    h.returnValue = false
                }
                return false
            }
            var g = h.target || h.srcElement;
            if (typeof (g.className) != "undefined" && g.className == "dhxform_info") {
                this.parentNode.parentNode.callEvent("onInfo", [this.parentNode.parentNode._idd]);
                h.cancelBubble = true;
                if (h.preventDefault) {
                    h.preventDefault()
                } else {
                    h.returnValue = false
                }
                return false
            }
            a.doClick(this.parentNode.parentNode)
        }
    },
    doClick: function (a) {
        a.childNodes[a._ll ? 0 : 1].childNodes[0].focus();
        if (!a._enabled || a._ro) {
            return
        }
        if (a.checkEvent("onBeforeChange")) {
            if (a.callEvent("onBeforeChange", [a._idd, a._value, a._checked]) !== true) {
                return
            }
        }
        this.setChecked(a, !a._checked);
        a._autoCheck();
        a.callEvent("onChange", [a._idd, a._value, a._checked])
    },
    doCheckValue: function (a) {
        if (a._checked && a._enabled) {
            a.childNodes[a._ll ? 1 : 0].firstChild.name = String(a._idd);
            a.childNodes[a._ll ? 1 : 0].firstChild.value = this.getValue(a)
        } else {
            a.childNodes[a._ll ? 1 : 0].firstChild.name = "";
            a.childNodes[a._ll ? 1 : 0].firstChild.value = ""
        }
    },
    setChecked: function (a, c) {
        a._checked = (c === true ? true : false);
        a.childNodes[a._ll ? 1 : 0].lastChild.className = a.childNodes[a._ll ? 1 : 0].lastChild.className.replace(/chbx[0-1]{1}/gi, "") + (a._checked ? " chbx1" : " chbx0");
        this.doCheckValue(a)
    },
    check: function (a) {
        this.setChecked(a, true)
    },
    unCheck: function (a) {
        this.setChecked(a, false)
    },
    isChecked: function (a) {
        return a._checked
    },
    enable: function (a) {
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
        a._enabled = true;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].tabIndex = 0;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].removeAttribute("disabled");
        this.doCheckValue(a)
    },
    disable: function (a) {
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
        a._enabled = false;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].tabIndex = -1;
        a.childNodes[a._ll ? 0 : 1].childNodes[0].setAttribute("disabled", "true");
        this.doCheckValue(a)
    },
    isEnabled: function (a) {
        return a._enabled
    },
    setText: function (a, c) {
        a.childNodes[a._ll ? 0 : 1].childNodes[0].innerHTML = c + (a._required ? "<span class='dhxform_item_required'>*</span>" : "")
    },
    getText: function (a) {
        return a.childNodes[a._ll ? 0 : 1].childNodes[0].innerHTML.replace(/<span class=\"dhxform_item_required\">[^<]*<\/span>/g, "")
    },
    setValue: function (a, c) {
        this.setChecked(a, (c === true || parseInt(c) == 1 || c == "true" || a._value === c))
    },
    getValue: function (a, c) {
        if (c == "realvalue") {
            return a._value
        }
        return ((typeof (a._value) == "undefined" || a._value == null) ? (a._checked ? 1 : 0) : a._value)
    },
    setReadonly: function (a, c) {
        a._ro = (c === true)
    },
    isReadonly: function (a) {
        return a._ro
    },
    setFocus: function (a) {
        a.childNodes[a._ll ? 0 : 1].childNodes[0].focus()
    }
};
dhtmlXForm.prototype.items.radio = {
    input: {},
    r: {},
    firstValue: {},
    render: function (g, h, c) {
        g._type = "ra";
        g._enabled = true;
        g._checked = false;
        g._group = h.name;
        g._value = h.value;
        g._uid = c;
        g._ro = (h.readonly == true);
        g._rName = g._rId + g._group;
        this.r[g._idd] = g;
        h.inputWidth = 14;
        this.doAddLabel(g, h);
        this.doAddInput(g, h, "INPUT", "TEXT", true, true, "dhxform_textarea");
        g.childNodes[g._ll ? 1 : 0].className += " dhxform_img_node";
        var j = document.createElement("DIV");
        j.className = "dhxform_img rdbt0";
        g.appendChild(j);
        if (!isNaN(h.inputLeft)) {
            g.childNodes[g._ll ? 1 : 0].style.left = parseInt(h.inputLeft) + "px"
        }
        if (!isNaN(h.inputTop)) {
            g.childNodes[g._ll ? 1 : 0].style.top = parseInt(h.inputTop) + "px"
        }
        g.childNodes[g._ll ? 1 : 0].appendChild(j);
        g.childNodes[g._ll ? 1 : 0].firstChild.name = "";
        g.childNodes[g._ll ? 1 : 0].firstChild.value = "";
        g._updateImgNode = function (m, n) {
            var l = m.childNodes[m._ll ? 1 : 0].lastChild;
            l.className = (n ? "dhxform_actv_r" : "dhxform_img") + " " + (m._checked ? "rdbt1" : "rdbt0");
            m = l = null
        };
        g._doOnFocus = function (l) {
            l.getForm().callEvent("onFocus", [l._group, l._value])
        };
        g._doOnBlur = function (l) {
            l.getForm().callEvent("onBlur", [l._group, l._value])
        };
        g._doOnKeyUpDown = function (m, l) {
            this.callEvent(m, [this.childNodes[this._ll ? 0 : 1].childNodes[0], l, this._group, this._value])
        };
        if (this.input[g._rName] == null) {
            var a = document.createElement("INPUT");
            a.type = "HIDDEN";
            a.name = h.name;
            a.firstValue = g._value;
            g.appendChild(a);
            this.input[g._rName] = a
        }
        if (!this.firstValue[g._rName]) {
            this.firstValue[g._rName] = h.value
        }
        if (h.checked == true) {
            this.check(g)
        }
        if (h.hidden == true) {
            this.hide(g)
        }
        if (h.disabled == true) {
            this.userDisable(g)
        }
        this.doAttachEvents(g);
        return this
    },
    destruct: function (h, j) {
        if (h.lastChild == this.input[h._rName]) {
            var g = false;
            for (var c in this.r) {
                if (!g && this.r[c]._group == h._group && this.r[c]._idd != h._idd) {
                    this.r[c].appendChild(this.input[h._rName]);
                    g = true
                }
            }
            if (!g) {
                this.input[h._rName].parentNode.removeChild(this.input[h._rName]);
                this.input[h._rName] = null;
                this.firstValue[h._rName] = null
            }
        }
        var l = h._idd;
        h._doOnFocus = h._doOnBlur = h._updateImgNode = null;
        this.doUnloadNestedLists(h);
        this.doDestruct(h);
        return l
    },
    doClick: function (c) {
        c.childNodes[c._ll ? 0 : 1].childNodes[0].focus();
        if (!(c._enabled && !c._checked)) {
            return
        }
        if (c._ro) {
            return
        }
        var a = [c._group, c._value, true];
        if (c.checkEvent("onBeforeChange")) {
            if (c.callEvent("onBeforeChange", a) !== true) {
                return
            }
        }
        this.setChecked(c, true);
        c.getForm()._autoCheck();
        c.callEvent("onChange", a)
    },
    doCheckValue: function (g) {
        var h = null;
        for (var c in this.r) {
            if (this.r[c]._checked && this.r[c]._group == g._group && this.r[c]._rId == g._rId) {
                h = this.r[c]._value
            }
        }
        if (h != null && this.r[c]._enabled) {
            this.input[g._rName].name = String(g._group);
            this.input[g._rName].value = h
        } else {
            this.input[g._rName].name = "";
            this.input[g._rName].value = ""
        }
        this.input[g._rName]._value = h
    },
    setChecked: function (j, l) {
        l = (l === true);
        for (var c in this.r) {
            if (this.r[c]._group == j._group && this.r[c]._rId == j._rId) {
                var h = false;
                if (this.r[c]._idd == j._idd) {
                    if (this.r[c]._checked != l) {
                        this.r[c]._checked = l;
                        h = true
                    }
                } else {
                    if (this.r[c]._checked) {
                        this.r[c]._checked = false;
                        h = true
                    }
                }
                if (h) {
                    var g = this.r[c].childNodes[this.r[c]._ll ? 1 : 0].childNodes[1];
                    g.className = g.className.replace(/rdbt[0-1]{1}/gi, "") + (this.r[c]._checked ? " rdbt1" : " rdbt0");
                    g = null
                }
            }
        }
        this.doCheckValue(j)
    },
    getChecked: function (a) {
        return this.input[a._rName]._value
    },
    _getFirstValue: function (a) {
        return this.firstValue[a._rName]
    },
    _getId: function (a) {
        return a._idd
    },
    setValue: function (a, c) {}
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        doDestruct: 1,
        doUnloadNestedLists: 1,
        doAttachEvents: 1,
        check: 1,
        unCheck: 1,
        isChecked: 1,
        enable: 1,
        disable: 1,
        isEnabled: 1,
        setText: 1,
        getText: 1,
        getValue: 1,
        setReadonly: 1,
        isReadonly: 1,
        setFocus: 1
    }) {
        dhtmlXForm.prototype.items.radio[c] = dhtmlXForm.prototype.items.checkbox[c]
    }
})();
dhtmlXForm.prototype.items.select = {
    render: function (a, c) {
        a._type = "se";
        a._enabled = true;
        a._value = null;
        a._newValue = null;
        if (window.dhx4.isFF || window.dhx4.isIE && typeof (c.inputWidth) == "number") {
            c.inputWidth = Number(c.inputWidth)
        }
        this.doAddLabel(a, c);
        this.doAddInput(a, c, "SELECT", null, true, true, "dhxform_select");
        this.doAttachEvents(a);
        this.doLoadOpts(a, c);
        if (c.connector != null) {
            this.doLoadOptsConnector(a, c.connector)
        }
        if (typeof (c.value) != "undefined" && c.value != null) {
            this.setValue(a, c.value)
        }
        return this
    },
    destruct: function (a) {
        this.doUnloadNestedLists(a);
        a.callEvent = null;
        a.checkEvent = null;
        a.getForm = null;
        a._autoCheck = null;
        a._enabled = null;
        a._idd = null;
        a._type = null;
        a._value = null;
        a._newValue = null;
        a.onselectstart = null;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].onclick = null;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].onkeydown = null;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].onchange = null;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].onfocus = null;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].onblur = null;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].onkeyup = null;
        a.childNodes[a._ll ? 1 : 0].removeChild(a.childNodes[a._ll ? 1 : 0].childNodes[0]);
        while (a.childNodes.length > 0) {
            a.removeChild(a.childNodes[0])
        }
        a.parentNode.removeChild(a);
        a = null
    },
    doAddLabel: function (c, g) {
        var a = document.createElement("DIV");
        a.className = "dhxform_label " + g.labelAlign;
        a.innerHTML = "<label for='" + g.uid + "'>" + g.label + (g.info ? "<span class='dhxform_info'>[?]</span>" : "") + (c._required ? "<span class='dhxform_item_required'>*</span>" : "") + "</label>";
        if (g.wrap == true) {
            a.style.whiteSpace = "normal"
        }
        if (typeof (g.tooltip) != "undefined") {
            a.title = g.tooltip
        }
        c.appendChild(a);
        if (typeof (g.label) == "undefined" || g.label == null || g.label.length == 0) {
            a.style.display = "none"
        }
        if (!isNaN(g.labelWidth)) {
            a.style.width = parseInt(g.labelWidth) + "px"
        }
        if (!isNaN(g.labelHeight)) {
            a.style.height = parseInt(g.labelHeight) + "px"
        }
        if (!isNaN(g.labelLeft)) {
            a.style.left = parseInt(g.labelLeft) + "px"
        }
        if (!isNaN(g.labelTop)) {
            a.style.top = parseInt(g.labelTop) + "px"
        }
        if (g.info) {
            a.onclick = function (j) {
                j = j || event;
                var h = j.target || j.srcElement;
                if (typeof (h.className) != "undefined" && h.className == "dhxform_info") {
                    this.parentNode.callEvent("onInfo", [this.parentNode._idd]);
                    j.cancelBubble = true;
                    if (j.preventDefault) {
                        j.preventDefault()
                    } else {
                        j.returnValue = false
                    }
                    return false
                }
            }
        }
    },
    doAttachEvents: function (g) {
        var a = g.childNodes[g._ll ? 1 : 0].childNodes[0];
        var c = this;
        a.onclick = function () {
            c.doOnChange(this)
        };
        a.onkeydown = function (h) {
            h = h || event;
            c.doOnChange(this);
            this.parentNode.parentNode.callEvent("onKeyDown", [this, h, this.parentNode.parentNode._idd])
        };
        a.onchange = function () {
            c.doOnChange(this)
        };
        a.onkeyup = function (h) {
            h = h || event;
            this.parentNode.parentNode.callEvent("onKeyUp", [this, h, this.parentNode.parentNode._idd])
        };
        a = null;
        this.doAttachChangeLS(g)
    },
    doAttachChangeLS: function (c) {
        var a = c.childNodes[c._ll ? 1 : 0].childNodes[0];
        a.onfocus = function () {
            var g = this.parentNode.parentNode;
            g.getForm()._ccActivate(g._idd, this, g.getForm().getItemValue(g._idd, true));
            g.getForm().callEvent("onFocus", [g._idd]);
            g = null
        };
        a.onblur = function () {
            var g = this.parentNode.parentNode;
            g.getForm()._ccDeactivate(g._idd);
            g.getForm().callEvent("onBlur", [g._idd]);
            g = null
        };
        a = null
    },
    doValidate: function (a) {
        if (a.getForm().live_validate) {
            this._validate(a)
        }
    },
    doLoadOpts: function (m, j, o) {
        var n = m.childNodes[m._ll ? 1 : 0].childNodes[0];
        var a = j.options;
        var h = false;
        for (var c = 0; c < a.length; c++) {
            var l = a[c].text || a[c].label;
            if (!l || typeof (l) == "undefined") {
                l = ""
            }
            var g = new Option(l, a[c].value);
            if (typeof (a[c].img_src) == "string") {
                g.setAttribute("img_src", a[c].img_src)
            }
            n.options.add(g);
            if (typeof (a[c].selected) != "undefined" && window.dhx4.s2b(a[c].selected) == true) {
                g.selected = true;
                m._value = a[c].value;
                h = true
            }
            if (typeof (a[c].checked) != "undefined" && window.dhx4.s2b(a[c].checked) == true) {
                g.setAttribute("checked", "1")
            }
            if (typeof (a[c].img) != "undefined") {
                g.setAttribute("img", a[c].img)
            }
            if (typeof (a[c].img_dis) != "undefined") {
                g.setAttribute("img_dis", a[c].img_dis)
            }
        }
        if (!h && n.selectedIndex >= 0) {
            m._value = n.options[n.selectedIndex].value
        }
        if (o === true) {
            m.callEvent("onOptionsLoaded", [m._idd])
        }
        this._checkNoteWidth(m)
    },
    doLoadOptsConnector: function (g, a) {
        var c = this;
        g._connector_working = true;
        window.dhx4.ajax.get(a, function (m) {
            m = m.xmlDoc.responseXML;
            if (m == null) {
                return
            }
            var h = m.getElementsByTagName("data");
            if (h == null || h[0] == null) {
                return
            }
            h = h[0];
            var l = [];
            for (var n = 0; n < h.childNodes.length; n++) {
                if (typeof (h.childNodes[n].tagName) != "undefined" && String(h.childNodes[n].tagName).toLowerCase() == "item") {
                    var j = h.childNodes[n];
                    l.push({
                        label: j.getAttribute("label"),
                        value: j.getAttribute("value"),
                        selected: (j.getAttribute("selected") != null)
                    });
                    j = null
                }
            }
            c.doLoadOpts(g, {
                options: l
            }, true);
            g._connector_working = false;
            if (g._connector_value != null) {
                c.setValue(g, g._connector_value);
                g._connector_value = null
            }
            c = g = null
        })
    },
    doOnChange: function (g) {
        var a = g.parentNode.parentNode;
        a._newValue = (g.selectedIndex >= 0 ? g.options[g.selectedIndex].value : null);
        if (a._newValue != a._value) {
            if (a.checkEvent("onBeforeChange")) {
                if (a.callEvent("onBeforeChange", [a._idd, a._value, a._newValue]) !== true) {
                    for (var c = 0; c < g.options.length; c++) {
                        if (g.options[c].value == a._value) {
                            g.options[c].selected = true
                        }
                    }
                    return
                }
            }
            a._value = a._newValue;
            a.callEvent("onChange", [a._idd, a._value]);
            if (a._type == "se" && a.getForm().live_validate) {
                this._validate(a)
            }
        }
        a._autoCheck()
    },
    setText: function (a, c) {
        if (!c) {
            c = ""
        }
        a.childNodes[a._ll ? 0 : 1].childNodes[0].innerHTML = c + (a._required ? "<span class='dhxform_item_required'>*</span>" : "");
        a.childNodes[a._ll ? 0 : 1].style.display = (c.length == 0 || c == null ? "none" : "")
    },
    getText: function (a) {
        return a.childNodes[a._ll ? 0 : 1].childNodes[0].innerHTML.replace(/<span class=\"dhxform_item_required\">[^<]*<\/span>/g, "")
    },
    enable: function (a) {
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
        a._enabled = true;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].removeAttribute("disabled")
    },
    disable: function (a) {
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
        a._enabled = false;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].setAttribute("disabled", true)
    },
    getOptions: function (a) {
        return a.childNodes[a._ll ? 1 : 0].childNodes[0].options
    },
    setValue: function (c, h) {
        if (c._connector_working) {
            c._connector_value = h;
            return
        }
        var a = this.getOptions(c);
        for (var g = 0; g < a.length; g++) {
            if (a[g].value == h) {
                a[g].selected = true;
                c._value = a[g].value
            }
        }
        if (c._list != null && c._list.length > 0) {
            c.getForm()._autoCheck()
        }
        c.getForm()._ccReload(c._idd, c._value)
    },
    getValue: function (g) {
        var a = -1;
        var c = this.getOptions(g);
        for (var h = 0; h < c.length; h++) {
            if (c[h].selected) {
                a = c[h].value
            }
        }
        return a
    },
    setWidth: function (c, a) {
        c.childNodes[c._ll ? 1 : 0].childNodes[0].style.width = a + "px"
    },
    getSelect: function (a) {
        return a.childNodes[a._ll ? 1 : 0].childNodes[0]
    },
    setFocus: function (a) {
        a.childNodes[a._ll ? 1 : 0].childNodes[0].focus()
    },
    _checkNoteWidth: function (c) {
        var a;
        if (c.childNodes[c._ll ? 1 : 0].childNodes[1] != null) {
            a = c.childNodes[c._ll ? 1 : 0].childNodes[1];
            if (a.className != null && a.className.search(/dhxform_note/gi) >= 0 && a._w == "auto") {
                a.style.width = c.childNodes[c._ll ? 1 : 0].childNodes[0].offsetWidth + "px"
            }
        }
        a = null
    }
};
(function () {
    for (var c in {
        doAddInput: 1,
        doUnloadNestedLists: 1,
        isEnabled: 1
    }) {
        dhtmlXForm.prototype.items.select[c] = dhtmlXForm.prototype.items.checkbox[c]
    }
})();
dhtmlXForm.prototype.items.multiselect = {
    doLoadOpts: function (h, l, m) {
        var c = h.childNodes[h._ll ? 1 : 0].childNodes[0];
        c.multiple = true;
        if (!isNaN(l.size)) {
            c.size = Number(l.size)
        }
        h._value = [];
        h._newValue = [];
        var g = l.options;
        for (var j = 0; j < g.length; j++) {
            var a = new Option(g[j].text || g[j].label, g[j].value);
            c.options.add(a);
            if (g[j].selected == true || g[j].selected == "true") {
                a.selected = true;
                h._value.push(g[j].value)
            }
        }
        if (m === true) {
            h.callEvent("onOptionsLoaded", [h._idd])
        }
        this._checkNoteWidth(h)
    },
    doAttachEvents: function (g) {
        var a = g.childNodes[g._ll ? 1 : 0].childNodes[0];
        var c = this;
        a.onfocus = function () {
            c.doOnChange(this);
            var h = this.parentNode.parentNode;
            h.getForm().callEvent("onFocus", [h._idd]);
            h = null
        };
        a.onblur = function () {
            c.doOnChange(this);
            var h = this.parentNode.parentNode;
            h.getForm().callEvent("onBlur", [h._idd]);
            h = null
        };
        a.onclick = function () {
            c.doOnChange(this);
            var h = this.parentNode.parentNode;
            h._autoCheck();
            h = null
        }
    },
    doOnChange: function (h) {
        var c = h.parentNode.parentNode;
        c._newValue = [];
        for (var g = 0; g < h.options.length; g++) {
            if (h.options[g].selected) {
                c._newValue.push(h.options[g].value)
            }
        }
        if ((c._value).sort().toString() != (c._newValue).sort().toString()) {
            if (c.checkEvent("onBeforeChange")) {
                if (c.callEvent("onBeforeChange", [c._idd, c._value, c._newValue]) !== true) {
                    var a = {};
                    for (var g = 0; g < c._value.length; g++) {
                        a[c._value[g]] = true
                    }
                    for (var g = 0; g < h.options.length; g++) {
                        h.options[g].selected = (a[h.options[g].value] == true)
                    }
                    a = null;
                    return
                }
            }
            c._value = [];
            for (var g = 0; g < c._newValue.length; g++) {
                c._value.push(c._newValue[g])
            }
            c.callEvent("onChange", [c._idd, c._value])
        }
        c._autoCheck()
    },
    setValue: function (g, j) {
        var a = {};
        if (typeof (j) == "string") {
            j = j.split(",")
        }
        if (typeof (j) != "object") {
            j = [j]
        }
        for (var h = 0; h < j.length; h++) {
            a[j[h]] = true
        }
        var c = this.getOptions(g);
        for (var h = 0; h < c.length; h++) {
            c[h].selected = (a[c[h].value] == true)
        }
        g._autoCheck()
    },
    getValue: function (g) {
        var a = [];
        var c = this.getOptions(g);
        for (var h = 0; h < c.length; h++) {
            if (c[h].selected) {
                a.push(c[h].value)
            }
        }
        return a
    }
};
(function () {
    for (var c in dhtmlXForm.prototype.items.select) {
        if (!dhtmlXForm.prototype.items.multiselect[c]) {
            dhtmlXForm.prototype.items.multiselect[c] = dhtmlXForm.prototype.items.select[c]
        }
    }
})();
dhtmlXForm.prototype.items.input = {
    render: function (l, m) {
        var j = (!isNaN(m.rows));
        l._type = "ta";
        l._enabled = true;
        this.doAddLabel(l, m);
        this.doAddInput(l, m, (j ? "TEXTAREA" : "INPUT"), (j ? null : "TEXT"), true, true, "dhxform_textarea");
        this.doAttachEvents(l);
        if (j) {
            l.childNodes[l._ll ? 1 : 0].childNodes[0].rows = Number(m.rows) + (window.dhx4.isIE6 ? 1 : 0)
        }
        if (typeof (m.numberFormat) != "undefined") {
            var h, g = null,
                n = null;
            if (typeof (m.numberFormat) != "string") {
                h = m.numberFormat[0];
                g = m.numberFormat[1] || null;
                n = m.numberFormat[2] || null
            } else {
                h = m.numberFormat;
                if (typeof (m.groupSep) == "string") {
                    g = m.groupSep
                }
                if (typeof (m.decSep) == "string") {
                    n = m.decSep
                }
            }
            this.setNumberFormat(l, h, g, n, false)
        }
        this.setValue(l, m.value);
        return this
    },
    doAttachEvents: function (c) {
        var a = this;
        if (c._type == "ta" || c._type == "se" || c._type == "pw") {
            c.childNodes[c._ll ? 1 : 0].childNodes[0].onfocus = function () {
                var g = this.parentNode.parentNode;
                if (g._df != null) {
                    this.value = g._value || ""
                }
                g.getForm()._ccActivate(g._idd, this, this.value);
                g.getForm().callEvent("onFocus", [g._idd]);
                g = null
            }
        }
        c.childNodes[c._ll ? 1 : 0].childNodes[0].onblur = function () {
            var g = this.parentNode.parentNode;
            g.getForm()._ccDeactivate(g._idd);
            a.updateValue(g, true);
            if (g.getForm().live_validate) {
                a._validate(g)
            }
            g.getForm().callEvent("onBlur", [g._idd]);
            g = null
        }
    },
    updateValue: function (g, a) {
        var h = g.childNodes[g._ll ? 1 : 0].childNodes[0].value;
        if (!a && g._df != null && h == this._getFmtValue(g, h)) {
            return
        }
        var c = this;
        if (g._value != h) {
            if (g.checkEvent("onBeforeChange")) {
                if (g.callEvent("onBeforeChange", [g._idd, g._value, h]) !== true) {
                    if (g._df != null) {
                        c.setValue(g, g._value)
                    } else {
                        g.childNodes[g._ll ? 1 : 0].childNodes[0].value = g._value
                    }
                    return
                }
            }
            if (g._df != null) {
                c.setValue(g, h)
            } else {
                g._value = h
            }
            g.callEvent("onChange", [g._idd, h]);
            return
        }
        if (g._df != null) {
            this.setValue(g, g._value)
        }
    },
    setValue: function (g, h) {
        g._value = (typeof (h) != "undefined" && h != null ? h : "");
        var c = (String(g._value) || "");
        var a = g.childNodes[g._ll ? 1 : 0].childNodes[0];
        if (g._df != null && typeof (this._getFmtValue) == "function") {
            c = this._getFmtValue(g, c)
        }
        if (a.value != c) {
            a.value = c;
            g.getForm()._ccReload(g._idd, c)
        }
        a = null
    },
    getValue: function (a) {
        var c = a.getForm();
        if (c._formLS && c._formLS[a._idd] != null) {
            this.updateValue(a)
        }
        c = null;
        return (typeof (a._value) != "undefined" && a._value != null ? a._value : "")
    },
    setReadonly: function (a, c) {
        a._ro = (c === true);
        if (a._ro) {
            a.childNodes[a._ll ? 1 : 0].childNodes[0].setAttribute("readOnly", "true")
        } else {
            a.childNodes[a._ll ? 1 : 0].childNodes[0].removeAttribute("readOnly")
        }
    },
    isReadonly: function (a) {
        if (!a._ro) {
            a._ro = false
        }
        return a._ro
    },
    getInput: function (a) {
        return a.childNodes[a._ll ? 1 : 0].childNodes[0]
    },
    setNumberFormat: function (j, m, h, n, c) {
        if (typeof (c) != "boolean") {
            c = true
        }
        if (m == "") {
            j._df = null;
            if (c) {
                this.setValue(j, j._value)
            }
            return true
        }
        if (typeof (m) != "string") {
            return
        }
        var a = m.match(/^([^\.\,0-9]*)([0\.\,]*)([^\.\,0-9]*)/);
        if (a == null || a.length != 4) {
            return false
        }
        j._df = {
            i_len: false,
            i_sep: (typeof (h) == "string" ? h : ","),
            d_len: false,
            d_sep: (typeof (n) == "string" ? n : "."),
            s_bef: (typeof (a[1]) == "string" ? a[1] : ""),
            s_aft: (typeof (a[3]) == "string" ? a[3] : "")
        };
        var l = a[2].split(".");
        if (l[1] != null) {
            j._df.d_len = l[1].length
        }
        var g = l[0].split(",");
        if (g.length > 1) {
            j._df.i_len = g[g.length - 1].length
        }
        if (c) {
            this.setValue(j, j._value)
        }
        return true
    },
    _getFmtValue: function (item, v) {
        var r = v.match(/^(-)?([0-9]{1,})(\.([0-9]{1,}))?$/);
        if (r != null && r.length == 5) {
            var v0 = "";
            if (r[1] != null) {
                v0 += r[1]
            }
            v0 += item._df.s_bef;
            if (item._df.i_len !== false) {
                var i = 0;
                var v1 = "";
                for (var q = r[2].length - 1; q >= 0; q--) {
                    v1 = "" + r[2].charAt(q) + v1;
                    if (++i == item._df.i_len && q > 0) {
                        v1 = item._df.i_sep + v1;
                        i = 0
                    }
                }
                v0 += v1
            } else {
                v0 += r[2]
            }
            if (item._df.d_len !== false) {
                if (r[4] == null) {
                    r[4] = ""
                }
                while (r[4].length < item._df.d_len) {
                    r[4] += "0"
                }
                eval("dhx4.temp = new RegExp(/\\d{" + item._df.d_len + "}/);");
                var t1 = (r[4]).match(dhx4.temp);
                if (t1 != null) {
                    v0 += item._df.d_sep + t1
                }
                dhx4.temp = t1 = null
            }
            v0 += item._df.s_aft;
            return v0
        }
        return v
    }
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        destruct: 1,
        doUnloadNestedLists: 1,
        setText: 1,
        getText: 1,
        enable: 1,
        disable: 1,
        isEnabled: 1,
        setWidth: 1,
        setFocus: 1
    }) {
        dhtmlXForm.prototype.items.input[c] = dhtmlXForm.prototype.items.select[c]
    }
})();
dhtmlXForm.prototype.items.password = {
    render: function (a, c) {
        a._type = "pw";
        a._enabled = true;
        this.doAddLabel(a, c);
        this.doAddInput(a, c, "INPUT", "PASSWORD", true, true, "dhxform_textarea");
        this.doAttachEvents(a);
        this.setValue(a, c.value);
        return this
    }
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        doAttachEvents: 1,
        destruct: 1,
        doUnloadNestedLists: 1,
        setText: 1,
        getText: 1,
        setValue: 1,
        getValue: 1,
        updateValue: 1,
        enable: 1,
        disable: 1,
        isEnabled: 1,
        setWidth: 1,
        setReadonly: 1,
        isReadonly: 1,
        setFocus: 1,
        getInput: 1
    }) {
        dhtmlXForm.prototype.items.password[c] = dhtmlXForm.prototype.items.input[c]
    }
})();
dhtmlXForm.prototype.items.file = {
    render: function (g, h) {
        g._type = "fl";
        g._enabled = true;
        this.doAddLabel(g, h);
        this.doAddInput(g, h, "INPUT", "FILE", true, false, "dhxform_textarea");
        var a = g.childNodes[g._ll ? 1 : 0].childNodes[0];
        var c = this;
        a.onfocus = function () {
            var j = this.parentNode.parentNode;
            j.getForm().callEvent("onFocus", [j._idd]);
            j = null
        };
        a.onblur = function () {
            var j = this.parentNode.parentNode;
            if (j.getForm().live_validate) {
                c._validate(j)
            }
            j.getForm().callEvent("onBlur", [j._idd]);
            j = null
        };
        a = null;
        g.childNodes[g._ll ? 1 : 0].childNodes[0].onchange = function () {
            g.callEvent("onChange", [g._idd, this.value])
        };
        return this
    },
    setValue: function () {},
    getValue: function (a) {
        return a.childNodes[a._ll ? 1 : 0].childNodes[0].value
    }
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        destruct: 1,
        doUnloadNestedLists: 1,
        setText: 1,
        getText: 1,
        enable: 1,
        disable: 1,
        isEnabled: 1,
        setWidth: 1
    }) {
        dhtmlXForm.prototype.items.file[c] = dhtmlXForm.prototype.items.input[c]
    }
})();
dhtmlXForm.prototype.items.label = {
    _index: false,
    render: function (c, g) {
        c._type = "lb";
        c._enabled = true;
        c._checked = true;
        var a = document.createElement("DIV");
        a.className = "dhxform_txt_label2" + (g._isTopmost ? " topmost" : "");
        a.innerHTML = g.label;
        c.appendChild(a);
        if (g.hidden == true) {
            this.hide(c)
        }
        if (g.disabled == true) {
            this.userDisable(c)
        }
        if (!isNaN(g.labelWidth)) {
            a.style.width = parseInt(g.labelWidth) + "px"
        }
        if (!isNaN(g.labelHeight)) {
            a.style.height = parseInt(g.labelHeight) + "px"
        }
        if (!isNaN(g.labelLeft)) {
            a.style.left = parseInt(g.labelLeft) + "px"
        }
        if (!isNaN(g.labelTop)) {
            a.style.top = parseInt(g.labelTop) + "px"
        }
        return this
    },
    destruct: function (a) {
        this.doUnloadNestedLists(a);
        a._autoCheck = null;
        a._enabled = null;
        a._type = null;
        a.callEvent = null;
        a.checkEvent = null;
        a.getForm = null;
        a.onselectstart = null;
        a.parentNode.removeChild(a);
        a = null
    },
    enable: function (a) {
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
        a._enabled = true
    },
    disable: function (a) {
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
        a._enabled = false
    },
    setText: function (a, c) {
        a.firstChild.innerHTML = c
    },
    getText: function (a) {
        return a.firstChild.innerHTML
    }
};
(function () {
    for (var c in {
        doUnloadNestedLists: 1,
        isEnabled: 1
    }) {
        dhtmlXForm.prototype.items.label[c] = dhtmlXForm.prototype.items.checkbox[c]
    }
})();
dhtmlXForm.prototype.items.button = {
    render: function (g, h) {
        g._type = "bt";
        g._enabled = true;
        g._name = h.name;
        g.className = String(g.className).replace("item_label_top", "item_label_left").replace("item_label_right", "item_label_left");
        if (!isNaN(h.width)) {
            var a = Math.max(h.width, 10)
        }
        var c = (typeof (a) != "undefined");
        g._doOnKeyUpDown = function (l, j) {
            this.callEvent(l, [this.childNodes[0].childNodes[0], j, this._idd])
        };
        g.innerHTML = '<div class="dhxform_btn" role="link" tabindex="0" dir="ltr"><div class="dhxform_btn_txt" ' + (c ? ' style="width:' + a + 'px;"' : "") + ">" + h.value + "</div></div>";
        if (!isNaN(h.inputLeft)) {
            g.childNodes[0].style.left = parseInt(h.inputLeft) + "px"
        }
        if (!isNaN(h.inputTop)) {
            g.childNodes[0].style.top = parseInt(h.inputTop) + "px"
        }
        if (h.hidden == true) {
            this.hide(g)
        }
        if (h.disabled == true) {
            this.userDisable(g)
        }
        if (typeof (h.tooltip) != "undefined") {
            g.firstChild.title = h.tooltip
        }
        g.onselectstart = function (j) {
            j = j || event;
            j.cancelBubble = true;
            if (j.preventDefault) {
                j.preventDefault()
            } else {
                j.returnValue = false
            }
            return false
        };
        g.firstChild.onselectstart = function (j) {
            j = j || event;
            j.cancelBubble = true;
            if (j.preventDefault) {
                j.preventDefault()
            } else {
                j.returnValue = false
            }
            return false
        };
        g.firstChild.onkeypress = function (j) {
            j = j || event;
            if ((j.keyCode == 32 || j.charCode == 32 || j.keyCode == 13 || j.charCode == 13) && !this.parentNode._busy) {
                this.parentNode._busy = true;
                j.cancelBubble = true;
                if (j.preventDefault) {
                    j.preventDefault()
                } else {
                    j.returnValue = false
                }
                _dhxForm_doClick(this.childNodes[0], ["mousedown", "mouseup"]);
                return false
            }
        };
        g.firstChild.ontouchstart = function () {
            e = e || event;
            e.preventDefault();
            if (!this.parentNode._busy) {
                this.parentNode._busy = true;
                _dhxForm_doClick(this.childNodes[0], ["mousedown", "mouseup"])
            }
        };
        g.firstChild.onfocus = function () {
            this.parentNode._doOnFocus(this.parentNode)
        };
        g.firstChild.onblur = function () {
            _dhxForm_doClick(this.childNodes[0], "mouseout");
            this.parentNode._doOnBlur(this.parentNode)
        };
        g.firstChild.onkeyup = function (j) {
            this.parentNode._doOnKeyUpDown("onKeyUp", j || event)
        };
        g.firstChild.onkeydown = function (j) {
            this.parentNode._doOnKeyUpDown("onKeyDown", j || event)
        };
        g.firstChild.onmouseover = function () {
            var j = this.parentNode;
            if (!j._enabled) {
                return
            }
            this._isOver = true;
            this.className = "dhxform_btn dhxform_btn_over";
            j = null
        };
        g.firstChild.onmouseout = function () {
            var j = this.parentNode;
            if (!j._enabled) {
                return
            }
            this.className = "dhxform_btn";
            this._allowClick = false;
            this._pressed = false;
            this._isOver = false;
            j = null
        };
        g.firstChild.onmousedown = function (l) {
            l = l || event;
            if (l.button >= 2) {
                return
            }
            if (this._pressed) {
                return
            }
            var j = this.parentNode;
            if (!j._enabled) {
                return
            }
            this.className = "dhxform_btn dhxform_btn_pressed";
            this._allowClick = true;
            this._pressed = true;
            j = null
        };
        g.firstChild.onmouseup = function (l) {
            l = l || event;
            if (l.button >= 2) {
                return
            }
            if (!this._pressed) {
                return
            }
            var j = this.parentNode;
            if (!j._enabled) {
                return
            }
            j._busy = false;
            this.className = "dhxform_btn" + (this._isOver ? " dhxform_btn_over" : "");
            if (this._pressed && this._allowClick) {
                j.callEvent("_onButtonClick", [j._name, j._cmd])
            }
            this._allowClick = false;
            this._pressed = false;
            j = null
        };
        g._doOnFocus = function (j) {
            j.getForm().callEvent("onFocus", [j._idd])
        };
        g._doOnBlur = function (j) {
            j.getForm().callEvent("onBlur", [j._idd])
        };
        return this
    },
    destruct: function (a) {
        this.doUnloadNestedLists(a);
        a.callEvent = null;
        a.checkEvent = null;
        a.getForm = null;
        a._autoCheck = null;
        a._type = null;
        a._enabled = null;
        a._cmd = null;
        a._name = null;
        a._doOnFocus = null;
        a._doOnBlur = null;
        a._doOnKeyUpDown = null;
        a.onselectstart = null;
        a.firstChild.onselectstart = null;
        a.firstChild.onkeypress = null;
        a.firstChild.ontouchstart = null;
        a.firstChild.onfocus = null;
        a.firstChild.onblur = null;
        a.firstChild.onkeyup = null;
        a.firstChild.onkeydown = null;
        a.firstChild.onmouseover = null;
        a.firstChild.onmouseout = null;
        a.firstChild.onmousedown = null;
        a.firstChild.onmouseup = null;
        while (a.childNodes.length > 0) {
            a.removeChild(a.childNodes[0])
        }
        a.parentNode.removeChild(a);
        a = null
    },
    enable: function (a) {
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
        a._enabled = true;
        a.childNodes[0].removeAttribute("disabled");
        a.childNodes[0].setAttribute("role", "link");
        a.childNodes[0].setAttribute("tabIndex", "0")
    },
    disable: function (a) {
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
        a._enabled = false;
        a.childNodes[0].setAttribute("disabled", "true");
        a.childNodes[0].removeAttribute("role");
        a.childNodes[0].removeAttribute("tabIndex")
    },
    setText: function (a, c) {
        a.childNodes[0].childNodes[0].innerHTML = c
    },
    getText: function (a) {
        return a.childNodes[0].childNodes[0].innerHTML
    },
    setFocus: function (a) {
        a.childNodes[0].focus()
    }
};
(function () {
    for (var c in {
        doUnloadNestedLists: 1,
        isEnabled: 1
    }) {
        dhtmlXForm.prototype.items.button[c] = dhtmlXForm.prototype.items.checkbox[c]
    }
})();
dhtmlXForm.prototype.items.hidden = {
    _index: false,
    render: function (c, g) {
        c.style.display = "none";
        c._name = g.name;
        c._type = "hd";
        c._enabled = true;
        var a = document.createElement("INPUT");
        a.type = "HIDDEN";
        a.name = g.name;
        a.value = (g.value || "");
        c.appendChild(a);
        return this
    },
    destruct: function (a) {
        this.doUnloadNestedLists(a);
        while (a.childNodes.length > 0) {
            a.removeChild(a.childNodes[0])
        }
        a._autoCheck = null;
        a._name = null;
        a._type = null;
        a._enabled = null;
        a.onselectstart = null;
        a.callEvent = null;
        a.checkEvent = null;
        a.getForm = null;
        a.parentNode.removeChild(a);
        a = null
    },
    enable: function (a) {
        a._enabled = true;
        a.childNodes[0].setAttribute("name", a._name)
    },
    disable: function (a) {
        a._enabled = false;
        a.childNodes[0].removeAttribute("name")
    },
    show: function () {},
    hide: function () {},
    isHidden: function () {
        return true
    },
    setValue: function (a, c) {
        a.childNodes[0].value = c
    },
    getValue: function (a) {
        return a.childNodes[0].value
    },
    getInput: function (a) {
        return a.childNodes[0]
    }
};
(function () {
    for (var c in {
        doUnloadNestedLists: 1,
        isEnabled: 1
    }) {
        dhtmlXForm.prototype.items.hidden[c] = dhtmlXForm.prototype.items.checkbox[c]
    }
})();
dhtmlXForm.prototype.items.list = {
    _index: false,
    render: function (a, c) {
        a._type = "list";
        a._enabled = true;
        a._isNestedForm = true;
        a.style.paddingLeft = a._ofsNested + "px";
        a.className = "dhxform_base_nested" + (a._custom_css || "");
        return [this, new dhtmlXForm(a, null, c)]
    },
    destruct: function (a) {}
};
dhtmlXForm.prototype.items.fieldset = {
    _index: false,
    render: function (c, h) {
        c._type = "fs";
        if (typeof (parseInt(h.inputWidth)) == "number") {}
        c._width = h.width;
        c._enabled = true;
        c._checked = true;
        c.className = "fs_" + h.position + (typeof (h.className) == "string" ? " " + h.className : "");
        var g = document.createElement("FIELDSET");
        g.className = "dhxform_fs";
        var j = String(h.labelAlign).replace("align_", "");
        g.innerHTML = "<legend class='fs_legend' align='" + j + "' style='text-align:" + j + "'>" + h.label + "</legend>";
        c.appendChild(g);
        if (!isNaN(h.inputLeft)) {
            g.style.left = parseInt(h.inputLeft) + "px"
        }
        if (!isNaN(h.inputTop)) {
            g.style.top = parseInt(h.inputTop) + "px"
        }
        if (h.inputWidth != "auto") {
            if (!isNaN(h.inputWidth)) {
                g.style.width = parseInt(h.inputWidth) + "px";
                var a = parseInt(g.style.width);
                if (g.offsetWidth > a) {
                    g.style.width = a + (a - g.offsetWidth) + "px"
                }
            }
        }
        c._addSubListNode = function () {
            var l = document.createElement("DIV");
            l._custom_css = " dhxform_fs_nested";
            this.childNodes[0].appendChild(l);
            return l
        };
        if (h.hidden == true) {
            this.hide(c)
        }
        if (h.disabled == true) {
            this.userDisable(c)
        }
        return this
    },
    destruct: function (a) {
        this.doUnloadNestedLists(a);
        a._checked = null;
        a._enabled = null;
        a._idd = null;
        a._type = null;
        a._width = null;
        a.onselectstart = null;
        a._addSubListNode = null;
        a._autoCheck = null;
        a.callEvent = null;
        a.checkEvent = null;
        a.getForm = null;
        while (a.childNodes.length > 0) {
            a.removeChild(a.childNodes[0])
        }
        a.parentNode.removeChild(a);
        a = null
    },
    setText: function (a, c) {
        a.childNodes[0].childNodes[0].innerHTML = c
    },
    getText: function (a) {
        return a.childNodes[0].childNodes[0].innerHTML
    },
    enable: function (a) {
        a._enabled = true;
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
    },
    disable: function (a) {
        a._enabled = false;
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
    },
    setWidth: function (c, a) {
        c.childNodes[0].style.width = a + "px";
        c._width = a
    },
    getWidth: function (a) {
        return a._width
    }
};
(function () {
    for (var c in {
        doUnloadNestedLists: 1,
        isEnabled: 1
    }) {
        dhtmlXForm.prototype.items.fieldset[c] = dhtmlXForm.prototype.items.checkbox[c]
    }
})();
dhtmlXForm.prototype.items.block = {
    _index: false,
    render: function (c, g) {
        c._type = "bl";
        c._width = g.width;
        c._enabled = true;
        c._checked = true;
        c.className = "block_" + g.position + (typeof (g.className) == "string" ? " " + g.className : "");
        var a = document.createElement("DIV");
        a.className = "dhxform_obj_" + c.getForm().skin + " dhxform_block";
        a.style.fontSize = c.getForm().cont.style.fontSize;
        if (g.style) {
            a.style.cssText = g.style
        }
        if (typeof (g.id) != "undefined") {
            a.id = g.id
        }
        c.appendChild(a);
        if (!isNaN(g.inputLeft)) {
            a.style.left = parseInt(g.inputLeft) + "px"
        }
        if (!isNaN(g.inputTop)) {
            a.style.top = parseInt(g.inputTop) + "px"
        }
        if (g.inputWidth != "auto") {
            if (!isNaN(g.inputWidth)) {
                a.style.width = parseInt(g.inputWidth) + "px"
            }
        }
        if (!isNaN(g.blockOffset)) {
            c._ofsNested = g.blockOffset
        }
        c._addSubListNode = function () {
            var h = document.createElement("DIV");
            h._inBlcok = true;
            if (typeof (this._ofsNested) != "undefined") {
                h._ofsNested = this._ofsNested
            }
            this.childNodes[0].appendChild(h);
            return h
        };
        if (g.hidden == true) {
            this.hide(c)
        }
        if (g.disabled == true) {
            this.userDisable(c)
        }
        return this
    },
    _setCss: function (a, g, c) {
        a.firstChild.className = "dhxform_obj_" + g + " dhxform_block";
        a.firstChild.style.fontSize = c
    }
};
(function () {
    for (var c in {
        enable: 1,
        disable: 1,
        isEnabled: 1,
        setWidth: 1,
        getWidth: 1,
        doUnloadNestedLists: 1,
        destruct: 1
    }) {
        dhtmlXForm.prototype.items.block[c] = dhtmlXForm.prototype.items.fieldset[c]
    }
})();
dhtmlXForm.prototype.items.newcolumn = {
    _index: false
};
dhtmlXForm.prototype.items.template = {
    render: function (c, g) {
        var a = (!isNaN(g.rows));
        c._type = "tp";
        c._enabled = true;
        if (g.format) {
            if (typeof (g.format) == "function") {
                c.format = g.format
            }
            if (typeof (window[g.format]) == "function") {
                c.format = window[g.format]
            }
        }
        if (!c.format) {
            c.format = function (h, j) {
                return j
            }
        }
        this.doAddLabel(c, g);
        this.doAddInput(c, g, "DIV", null, true, true, "dhxform_item_template");
        c._value = (g.value || "");
        c.childNodes[1].childNodes[0].innerHTML = c.format(c._idd, c._value);
        return this
    },
    setValue: function (a, c) {
        a._value = c;
        a.childNodes[1].childNodes[0].innerHTML = a.format(a._idd, a._value)
    },
    getValue: function (a) {
        return a._value
    },
    enable: function (a) {
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
        a._enabled = true
    },
    disable: function (a) {
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
        a._enabled = false
    }
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        destruct: 1,
        doUnloadNestedLists: 1,
        setText: 1,
        getText: 1,
        isEnabled: 1,
        setWidth: 1
    }) {
        dhtmlXForm.prototype.items.template[c] = dhtmlXForm.prototype.items.select[c]
    }
})();
dhtmlXForm.prototype._ulToObject = function (j, o) {
    var l = [];
    for (var c = 0; c < j.childNodes.length; c++) {
        if (String(j.childNodes[c].tagName || "").toLowerCase() == "li") {
            var g = {};
            var s = j.childNodes[c];
            for (var r = 0; r < o.length; r++) {
                if (s.getAttribute(o[r]) != null) {
                    g[String(o[r]).replace("ftype", "type")] = s.getAttribute(o[r])
                }
            }
            if (!g.label) {
                try {
                    g.label = s.firstChild.nodeValue
                } catch (m) {}
            }
            var h = s.getElementsByTagName("UL");
            if (h[0] != null) {
                g[(g.type == "select" ? "options" : "list")] = dhtmlXForm.prototype._ulToObject(h[0], o)
            }
            for (var r = 0; r < s.childNodes.length; r++) {
                if (String(s.childNodes[r].tagName || "").toLowerCase() == "userdata") {
                    if (!g.userdata) {
                        g.userdata = {}
                    }
                    g.userdata[s.childNodes[r].getAttribute("name")] = s.childNodes[r].firstChild.nodeValue
                }
            }
            l[l.length] = g
        }
        if (String(j.childNodes[c].tagName || "").toLowerCase() == "div") {
            var g = {};
            g.type = "label";
            try {
                g.label = j.childNodes[c].firstChild.nodeValue
            } catch (m) {}
            l[l.length] = g
        }
    }
    return l
};
dhtmlXForm.prototype.setUserData = function (j, g, h, a) {
    if (typeof (a) != "undefined") {
        var c = this.doWithItem([j, g], "_getId");
        if (c != null) {
            j = c;
            g = h;
            h = a
        }
    }
    if (!this._userdata) {
        this._userdata = {}
    }
    this._userdata[j] = (this._userdata[j] || {});
    this._userdata[j][g] = h
};
dhtmlXForm.prototype.getUserData = function (h, g, a) {
    if (typeof (a) != "undefined") {
        var c = this.doWithItem([h, g], "_getId");
        if (c != null) {
            h = c;
            g = a
        }
    }
    if (this._userdata != null && typeof (this._userdata[h]) != "undefined" && typeof (this._userdata[h][g]) != "undefined") {
        return this._userdata[h][g]
    }
    return ""
};
dhtmlXForm.prototype.setRTL = function (a) {
    this._rtl = (a === true ? true : false);
    if (this._rtl) {
        if (String(this.cont).search(/dhxform_rtl/gi) < 0) {
            this.cont.className += " dhxform_rtl"
        }
    } else {
        if (String(this.cont).search(/dhxform_rtl/gi) >= 0) {
            this.cont.className = String(this.cont.className).replace(/dhxform_rtl/gi, "")
        }
    }
};
_dhxForm_doClick = function (h, c) {
    if (typeof (c) == "object") {
        var a = c[1];
        c = c[0]
    }
    if (document.createEvent) {
        var g = document.createEvent("MouseEvents");
        g.initEvent(c, true, false);
        h.dispatchEvent(g)
    } else {
        if (document.createEventObject) {
            var g = document.createEventObject();
            g.button = 1;
            h.fireEvent("on" + c, g)
        }
    }
    if (a) {
        window.setTimeout(function () {
            _dhxForm_doClick(h, a)
        }, 100)
    }
};
dhtmlXForm.prototype.setFormData = function (g) {
    for (var c in g) {
        var h = this.getItemType(c);
        switch (h) {
        case "checkbox":
            this[g[c] == true || parseInt(g[c]) == 1 || g[c] == "true" || g[c] == this.getItemValue(c, "realvalue") ? "checkItem" : "uncheckItem"](c);
            break;
        case "radio":
            this.checkItem(c, g[c]);
            break;
        case "input":
        case "textarea":
        case "password":
        case "select":
        case "multiselect":
        case "hidden":
        case "template":
        case "combo":
        case "calendar":
        case "colorpicker":
        case "editor":
            this.setItemValue(c, g[c]);
            break;
        default:
            if (this["setFormData_" + h]) {
                this["setFormData_" + h](c, g[c])
            } else {
                if (!this.hId) {
                    this.hId = this._genStr(12)
                }
                this.setUserData(this.hId, c, g[c])
            }
            break
        }
    }
};
dhtmlXForm.prototype.getFormData = function (v, l) {
    var c = {};
    var o = this;
    for (var u in this.itemPull) {
        var n = this.itemPull[u]._idd;
        var w = this.itemPull[u]._type;
        if (w == "ch") {
            c[n] = (this.isItemChecked(n) ? this.getItemValue(n) : 0)
        }
        if (w == "ra" && !c[this.itemPull[u]._group]) {
            c[this.itemPull[u]._group] = this.getCheckedValue(this.itemPull[u]._group)
        }
        if (w in {
            se: 1,
            ta: 1,
            pw: 1,
            hd: 1,
            tp: 1,
            fl: 1,
            calendar: 1,
            combo: 1,
            editor: 1,
            colorpicker: 1
        }) {
            c[n] = this.getItemValue(n, v)
        }
        if (this["getFormData_" + w]) {
            c[n] = this["getFormData_" + w](n)
        }
        if (w == "up") {
            var j = this.getItemValue(n);
            for (var h in j) {
                c[h] = j[h]
            }
        }
        if (this.itemPull[u]._list) {
            for (var g = 0; g < this.itemPull[u]._list.length; g++) {
                var m = this.itemPull[u]._list[g].getFormData(v, l);
                for (var s in m) {
                    c[s] = m[s]
                }
            }
        }
    }
    if (!l && this.hId && this._userdata[this.hId]) {
        for (var u in this._userdata[this.hId]) {
            if (!c[u]) {
                c[u] = this._userdata[this.hId][u]
            }
        }
    }
    return c
};
dhtmlXForm.prototype.adjustParentSize = function () {
    var j = 0;
    var h = -1;
    for (var l = 0; l < this.base.length; l++) {
        j += this.base[l].firstChild.offsetWidth;
        if (this.base[l].offsetHeight > h) {
            h = this.base[l].offsetHeight
        }
    }
    var g = false;
    try {
        g = (this.cont.parentNode.parentNode.parentNode.parentNode._isCell == true);
        if (g) {
            var a = this.cont.parentNode.parentNode.parentNode.parentNode
        }
    } catch (m) {}
    if (g && typeof (a) != "undefined") {
        if (j > 0) {
            a.setWidth(j + 10)
        }
        if (h > 0) {
            a.setHeight(h + a.firstChild.firstChild.offsetHeight + 5)
        }
        g = a = null;
        return
    }
    var c = false;
    try {
        c = (this.cont.parentNode.parentNode.parentNode._isWindow == true);
        if (c) {
            var n = this.cont.parentNode.parentNode;
            if (typeof (n.callEvent) == "function") {
                this.cont.style.display = "none";
                n.callEvent("_setCellSize", [j + 15, h + 15]);
                this.cont.style.display = ""
            }
        }
    } catch (m) {}
};
dhtmlXForm.prototype.reset = function () {
    if (this.callEvent("onBeforeReset", [this.formId, this.getFormData()])) {
        if (this._last_load_data) {
            this.setFormData(this._last_load_data)
        }
        this.callEvent("onAfterReset", [this.formId])
    }
};
dhtmlXForm.prototype.send = function (c, m, n, h) {
    if (typeof m == "function") {
        n = m;
        m = "post"
    } else {
        m = (m == "get" ? "get" : "post")
    }
    if (h !== true && !this.validate()) {
        return
    }
    var l = this.getFormData(true);
    var j = [];
    for (var g in l) {
        j.push(g + "=" + encodeURIComponent(l[g]))
    }
    var a = function (o) {
            if (n) {
                n.call(this, o, o.xmlDoc.responseText)
            }
        };
    if (m == "get") {
        window.dhx4.ajax.get(c + (c.indexOf("?") == -1 ? "?" : "&") + j.join("&"), a)
    } else {
        window.dhx4.ajax.post(c, j.join("&"), a)
    }
};
dhtmlXForm.prototype.save = function (a, c) {};
dhtmlXForm.prototype.dummy = function () {};
dhtmlXForm.prototype._changeFormId = function (c, a) {
    this.formId = a
};
dhtmlXForm.prototype._dp_init = function (a) {
    a._methods = ["dummy", "dummy", "_changeFormId", "dummy"];
    a._getRowData = function (h, c) {
        var g = this.obj.getFormData(true);
        g[this.action_param] = this.obj.getUserData(h, this.action_param);
        return g
    };
    a._clearUpdateFlag = function () {};
    a.attachEvent("onAfterUpdate", function (g, h, j, c) {
        if (h == "inserted" || h == "updated") {
            this.obj.resetDataProcessor("updated");
            this.obj._last_load_data = this.obj.getFormData(true)
        }
        this.obj.callEvent("onAfterSave", [this.obj.formId, c]);
        return true
    });
    a.autoUpdate = false;
    a.setTransactionMode("POST", true);
    this.dp = a;
    this.formId = (new Date()).valueOf();
    this.resetDataProcessor("inserted");
    this.save = function () {
        if (!this.callEvent("onBeforeSave", [this.formId, this.getFormData()])) {
            return
        }
        if (!this.validate()) {
            return
        }
        a.sendData()
    }
};
dhtmlXForm.prototype.resetDataProcessor = function (a) {
    if (!this.dp) {
        return
    }
    this.dp.updatedRows = [];
    this.dp._in_progress = [];
    this.dp.setUpdated(this.formId, true, a)
};
dhtmlXForm.prototype._ccActivate = function (g, a, c) {
    if (!this._formLS) {
        this._formLS = {}
    }
    if (!this._formLS[g]) {
        this._formLS[g] = {
            input: a,
            value: c
        }
    }
    if (!this._ccActive) {
        this._ccActive = true;
        this._ccDo()
    }
    a = null
};
dhtmlXForm.prototype._ccDeactivate = function (a) {
    if (this._ccTm) {
        window.clearTimeout(this._ccTm)
    }
    this._ccActive = false;
    if (this._formLS != null && this._formLS[a] != null) {
        this._formLS[a].input = null;
        this._formLS[a] = null;
        delete this._formLS[a]
    }
};
dhtmlXForm.prototype._ccDo = function () {
    if (this._ccTm) {
        window.clearTimeout(this._ccTm)
    }
    for (var c in this._formLS) {
        var j = this._formLS[c].input;
        if (String(j.tagName).toLowerCase() == "select") {
            var g = "";
            if (j.selectedIndex >= 0 && j.selectedIndex < j.options.length) {
                g = j.options[j.selectedIndex].value
            }
        } else {
            var g = j.value
        }
        if (g != this._formLS[c].value) {
            this._formLS[c].value = g;
            this.callEvent("onInputChange", [j._idd, g, this])
        }
        j = null
    }
    if (this._ccActive) {
        var h = this;
        this._ccTm = window.setTimeout(function () {
            h._ccDo();
            h = null
        }, 100)
    }
};
dhtmlXForm.prototype._ccReload = function (c, a) {
    if (this._formLS && this._formLS[c]) {
        this._formLS[c].value = a
    }
};
dhtmlXForm.prototype._autoload = function () {
    var c = ["ftype", "name", "value", "label", "check", "checked", "disabled", "text", "rows", "select", "selected", "width", "style", "className", "labelWidth", "labelHeight", "labelLeft", "labelTop", "inputWidth", "inputHeight", "inputLeft", "inputTop", "position", "size"];
    var g = document.getElementsByTagName("UL");
    var h = [];
    for (var m = 0; m < g.length; m++) {
        if (g[m].className == "dhtmlxForm") {
            var l = document.createElement("DIV");
            h[h.length] = {
                nodeUL: g[m],
                nodeForm: l,
                data: dhtmlXForm.prototype._ulToObject(g[m], c),
                name: (g[m].getAttribute("name") || null)
            }
        }
    }
    for (var m = 0; m < h.length; m++) {
        h[m].nodeUL.parentNode.insertBefore(h[m].nodeForm, h[m].nodeUL);
        var n = new dhtmlXForm(h[m].nodeForm, h[m].data);
        if (h[m].name !== null) {
            window[h[m].name] = n
        }
        var j = (h[m].nodeUL.getAttribute("oninit") || null);
        h[m].nodeUL.parentNode.removeChild(h[m].nodeUL);
        h[m].nodeUL = null;
        h[m].nodeForm = null;
        h[m].data = null;
        h[m] = null;
        if (j) {
            if (typeof (j) == "function") {
                j()
            } else {
                if (typeof (window[j]) == "function") {
                    window[j]()
                }
            }
        }
    }
    if (typeof (window.addEventListener) == "function") {
        window.removeEventListener("load", dhtmlXForm.prototype._autoload, false)
    } else {
        window.detachEvent("onload", dhtmlXForm.prototype._autoload)
    }
};
if (typeof (window.addEventListener) == "function") {
    window.addEventListener("load", dhtmlXForm.prototype._autoload, false)
} else {
    window.attachEvent("onload", dhtmlXForm.prototype._autoload)
}
if (!window.dhtmlxValidation) {
    dhtmlxValidation = function () {};
    dhtmlxValidation.prototype = {
        isEmpty: function (a) {
            return a == ""
        },
        isNotEmpty: function (a) {
            return (a instanceof Array ? a.length > 0 : !a == "")
        },
        isValidBoolean: function (a) {
            return !!a.toString().match(/^(0|1|true|false)$/)
        },
        isValidEmail: function (a) {
            return !!a.toString().match(/(^[a-z0-9]([0-9a-z\-_\.]*)@([0-9a-z_\-\.]*)([.][a-z]{3})$)|(^[a-z]([0-9a-z_\.\-]*)@([0-9a-z_\-\.]*)(\.[a-z]{2,4})$)/i)
        },
        isValidInteger: function (a) {
            return !!a.toString().match(/(^-?\d+$)/)
        },
        isValidNumeric: function (a) {
            return !!a.toString().match(/(^-?\d\d*[\.|,]\d*$)|(^-?\d\d*$)|(^-?[\.|,]\d\d*$)/)
        },
        isValidAplhaNumeric: function (a) {
            return !!a.toString().match(/^[_\-a-z0-9]+$/gi)
        },
        isValidDatetime: function (c) {
            var a = c.toString().match(/^(\d{4})-(\d{2})-(\d{2})\s(\d{2}):(\d{2}):(\d{2})$/);
            return a && !! (a[1] <= 9999 && a[2] <= 12 && a[3] <= 31 && a[4] <= 59 && a[5] <= 59 && a[6] <= 59) || false
        },
        isValidDate: function (a) {
            var c = a.toString().match(/^(\d{4})-(\d{2})-(\d{2})$/);
            return c && !! (c[1] <= 9999 && c[2] <= 12 && c[3] <= 31) || false
        },
        isValidTime: function (c) {
            var a = c.toString().match(/^(\d{1,2}):(\d{1,2}):(\d{1,2})$/);
            return a && !! (a[1] <= 24 && a[2] <= 59 && a[3] <= 59) || false
        },
        isValidIPv4: function (a) {
            var c = a.toString().match(/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/);
            return c && !! (c[1] <= 255 && c[2] <= 255 && c[3] <= 255 && c[4] <= 255) || false
        },
        isValidCurrency: function (a) {
            return a.toString().match(/^\$?\s?\d+?([\.,\,]?\d+)?\s?\$?$/) && true || false
        },
        isValidSSN: function (a) {
            return a.toString().match(/^\d{3}\-?\d{2}\-?\d{4}$/) && true || false
        },
        isValidSIN: function (a) {
            return a.toString().match(/^\d{9}$/) && true || false
        }
    };
    dhtmlxValidation = new dhtmlxValidation()
}
dhtmlXForm.prototype.addItem = function (g, a, l, h) {
    var c = null;
    if (g instanceof Array) {
        c = g[1];
        g = g[0]
    }
    var j = null;
    if (g != null) {
        var j = this._getParentForm(g, c);
        if (j != null) {
            if (j.item._list == null) {
                if (!a.listParent) {
                    a.listParent = j.item._idd
                }
                j.form._addItem("list", j.item._idd, [a], null, j.item._idd, l, h)
            } else {
                j.item._list[0].addItem(null, a, l, h)
            }
            j.form = j.item = null;
            j = null;
            this._autoCheck();
            return
        }
    }
    this._prepareItem(a, l, h);
    this._autoCheck()
};
dhtmlXForm.prototype.removeItem = function (c, a) {
    this._removeItem(c, a)
};
dhtmlXForm.prototype.removeColumn = function (m, l, h, g) {
    var o = null;
    if (m instanceof Array) {
        o = m[1];
        m = m[0]
    }
    if (m != null) {
        var j = this._getParentForm(m, o);
        if (j != null) {
            if (j.item._list != null && j.item._list[0] != null) {
                j.item._list[0].removeColumn(null, l, h, g)
            }
            j.form = j.item = null;
            j = null
        }
        return
    }
    l = Math.min(Math.max(l, 0), this.cont.childNodes.length - 1);
    if (this.cont.childNodes.length == 1) {
        if (h == true) {
            this._removeItemsInColumn(this.cont.childNodes[l])
        }
    } else {
        if (h == true) {
            this._removeItemsInColumn(this.cont.childNodes[l])
        } else {
            if (!g) {
                var a = l - 1;
                if (a < 0) {
                    a = l + 1
                }
            } else {
                var a = l + 1;
                if (a > this.cont.childNodes.length - 1) {
                    a = l - 1
                }
            }
            while (this.cont.childNodes[l].childNodes.length > 0) {
                this.cont.childNodes[a].appendChild(this.cont.childNodes[l].childNodes[0])
            }
        }
        var n = [];
        for (var c = 0; c < this.base.length; c++) {
            if (this.cont.childNodes[l] != this.base[c]) {
                n.push(this.base[c])
            }
        }
        this.base = n;
        this.cont.removeChild(this.cont.childNodes[l]);
        this.b_index--;
        n = null
    }
};
dhtmlXForm.prototype.getColumnNode = function (g, c) {
    var h = null;
    var a = null;
    if (g instanceof Array) {
        a = g[1];
        g = g[0]
    }
    if (g != null) {
        var j = this._getParentForm(g, a);
        if (j != null) {
            if (j.item._list != null && j.item._list[0] != null && h == null) {
                h = j.item._list[0].getColumnNode(null, c)
            }
            j.form = j.item = null;
            j = null
        }
        return h
    }
    if (c < 0 || c > this.cont.childNodes.length - 1) {
        return null
    }
    return this.cont.childNodes[c]
};
dhtmlXForm.prototype._removeItemsInColumn = function (h) {
    var a = [];
    for (var g = 0; g < h.childNodes.length; g++) {
        var c = h.childNodes[g];
        if (c._idd != null && c._type != null) {
            a.push([c._idd, (c._type == "ra" ? c._value : null)])
        }
        c = null
    }
    for (var g = 0; g < a.length; g++) {
        this.removeItem(a[g][0], a[g][1])
    }
};
dhtmlXForm.prototype._getParentForm = function (l, j) {
    if (this.itemPull[this.idPrefix + l] != null) {
        return {
            form: this,
            item: this.itemPull[this.idPrefix + l]
        }
    }
    for (var c in this.itemPull) {
        if (this.itemPull[c]._type == "ra" && this.itemPull[c]._group == l && this.itemPull[c]._value == j) {
            return {
                form: this,
                item: this.itemPull[c]
            }
        }
    }
    var h = null;
    for (var c in this.itemPull) {
        if (!h && this.itemPull[c]._list != null) {
            for (var g = 0; g < this.itemPull[c]._list.length; g++) {
                if (!h) {
                    h = this.itemPull[c]._list[g]._getParentForm(l, j)
                }
            }
        }
    }
    return h
};
(function () {
    for (var c in dhtmlXForm.prototype.items) {
        if (!dhtmlXForm.prototype.items[c]._getItemNode) {
            dhtmlXForm.prototype.items[c]._getItemNode = function (a) {
                return a
            }
        }
    }
})();
dhtmlXForm.prototype._getItemNode = function (c, a) {
    if (a != null) {
        c = [c, a]
    }
    return this.doWithItem(c, "_getItemNode")
};
dhtmlXForm.prototype.setRequired = function (n, l, j) {
    if (typeof (j) == "undefined") {
        j = l
    } else {
        n = [n, l]
    }
    var g = this._getItemNode(n);
    if (!g) {
        return
    }
    j = window.dhx4.s2b(j);
    g._required = (j == true);
    if (g._required) {
        if (!g._validate) {
            g._validate = []
        }
        var c = false;
        for (var h = 0; h < g._validate.length; h++) {
            c = (g._validate[h] == "NotEmpty" || c)
        }
        if (!c) {
            g._validate.push("NotEmpty")
        }
        var m = g.childNodes[g._ll ? 0 : 1].childNodes[0];
        if (!(m.lastChild && m.lastChild.className && m.lastChild.className.search(/required/) >= 0)) {
            var a = document.createElement("SPAN");
            a.className = "dhxform_item_required";
            a.innerHTML = "*";
            m.appendChild(a);
            a = m = null
        }
    } else {
        if (g._validate != null) {
            var c = g._validate;
            g._validate = [];
            for (var h = 0; h < c.length; h++) {
                if (c[h] != "NotEmpty") {
                    g._validate.push(c[h])
                }
            }
            if (g._validate.length == 0) {
                g._validate = null
            }
        }
        var m = g.childNodes[g._ll ? 0 : 1].childNodes[0];
        if (m.lastChild && m.lastChild.className && m.lastChild.className.search(/required/) >= 0) {
            m.removeChild(m.lastChild);
            m = null
        }
    }
    this._resetValidateCss(g);
    g = null
};
dhtmlXForm.prototype.setNote = function (j, g, a) {
    if (typeof (a) == "undefined") {
        a = g
    } else {
        j = [j, g]
    }
    var c = this._getItemNode(j);
    if (!c) {
        return
    }
    var h = this._getNoteNode(c);
    if (!h) {
        if (!a.width) {
            a.width = c.childNodes[c._ll ? 1 : 0].childNodes[0].offsetWidth
        }
        h = document.createElement("DIV");
        h.className = "dhxform_note";
        if ({
            ch: 1,
            ra: 1
        }[c._type]) {
            c.childNodes[c._ll ? 1 : 0].insertBefore(h, c.childNodes[c._ll ? 1 : 0].lastChild)
        } else {
            c.childNodes[c._ll ? 1 : 0].appendChild(h)
        }
    }
    h.innerHTML = a.text;
    if (a.width != null) {
        h.style.width = a.width + "px";
        h._w = a.width
    }
    h = null
};
dhtmlXForm.prototype.clearNote = function (h, c) {
    if (typeof (c) != "undefined") {
        h = [h, c]
    }
    var a = this._getItemNode(h);
    if (!a) {
        return
    }
    var g = this._getNoteNode(a);
    if (g != null) {
        g.parentNode.removeChild(g);
        g = null
    }
};
dhtmlXForm.prototype._getNoteNode = function (a) {
    var g = null;
    for (var c = 0; c < a.childNodes[a._ll ? 1 : 0].childNodes.length; c++) {
        if (String(a.childNodes[a._ll ? 1 : 0].childNodes[c].className).search(/dhxform_note/) >= 0) {
            g = a.childNodes[a._ll ? 1 : 0].childNodes[c]
        }
    }
    a = null;
    return g
};
dhtmlXForm.prototype.setValidation = function (l, h, j) {
    if (typeof (note) == "undefined") {
        j = h
    } else {
        l = [l, h]
    }
    var c = this._getItemNode(l);
    if (!c) {
        return
    }
    if (c._validate != null) {
        for (var g = 0; g < c._validate.length; g++) {
            c._validate[g] = null
        }
    }
    c._validate = [];
    if (typeof (j) == "function" || typeof (window[j]) == "function") {
        c._validate = [j]
    } else {
        c._validate = String(j).split(this.separator)
    }
    if (c._required) {
        var a = false;
        for (var g = 0; g < c._validate.length; g++) {
            a = (c._validate[g] == "NotEmpty" || a)
        }
        if (!a) {
            c._validate.push("NotEmpty")
        }
    }
    c = null
};
dhtmlXForm.prototype.clearValidation = function (h, g) {
    if (typeof (g) != "undefined") {
        h = [h, g]
    }
    var a = this._getItemNode(h);
    if (!a) {
        return
    }
    if (a._validate != null) {
        for (var c = 0; c < a._validate.length; c++) {
            a._validate[c] = null
        }
    }
    a._validate = a._required ? ["NotEmpty"] : null;
    a = null
};
dhtmlXForm.prototype.reloadOptions = function (a, l) {
    var c = this.getItemType(a);
    if (!{
        select: 1,
        multiselect: 1,
        combo: 1
    }[c]) {
        return
    }
    if (c == "select" || c == "multiselect") {
        var h = this.getOptions(a);
        while (h.length > 0) {
            h.remove(0)
        }
        h.length = 0;
        h = null;
        if (typeof (l) == "string") {
            this.doWithItem(a, "doLoadOptsConnector", l)
        } else {
            if (l instanceof Array) {
                this.doWithItem(a, "doLoadOpts", {
                    options: l
                })
            }
        }
    }
    if (c == "combo") {
        var m = this.getCombo(a);
        m.clearAll();
        m.setComboValue("");
        if (typeof (l) == "string") {
            this.doWithItem(a, "doLoadOptsConnector", l)
        } else {
            if (l instanceof Array) {
                var g = null;
                for (var j = 0; j < l.length; j++) {
                    if (window.dhx4.s2b(l[j].selected)) {
                        g = l[j].value
                    }
                }
                m.addOption(l);
                if (g != null) {
                    this.setItemValue(a, g)
                }
                m = null
            }
        }
    }
};
dhtmlXForm.prototype.setTooltip = function (l, j, h) {
    if (typeof (h) == "undefined") {
        h = j
    } else {
        l = [l, j]
    }
    var c = this._getItemNode(l);
    if (!c) {
        return
    }
    var a = null;
    if (c.childNodes.length == 1) {
        a = c.childNodes[0]
    } else {
        for (var g = 0; g < c.childNodes.length; g++) {
            if (c.childNodes[g].className != null && c.childNodes[g].className.search("dhxform_label") >= 0) {
                a = c.childNodes[g]
            }
        }
    }
    if (a != null) {
        if (h == null || h.length == 0) {
            a.removeAttribute("title")
        } else {
            a.title = h
        }
    }
    a = null
};
dhtmlXForm.prototype.saveBackup = function () {
    if (!this._backup) {
        this._backup = {};
        this._backupId = new Date().getTime()
    }
    this._backup[++this._backupId] = this.getFormData();
    return this._backupId
};
dhtmlXForm.prototype.restoreBackup = function (a) {
    if (this._backup != null && this._backup[a] != null) {
        this.setFormData(this._backup[a])
    }
};
dhtmlXForm.prototype.clearBackup = function (a) {
    if (this._backup != null && this._backup[a] != null) {
        this._backup[a] = null;
        delete this._backup[a]
    }
};
dhtmlXForm.prototype.items.combo = {
    render: function (c, g) {
        c._type = "combo";
        c._enabled = true;
        c._value = null;
        c._newValue = null;
        this.doAddLabel(c, g);
        this.doAddInput(c, g, "SELECT", null, true, true, "dhxform_select");
        this.doAttachEvents(c);
        this.doLoadOpts(c, g);
        c.onselectstart = function (h) {
            return true
        };
        c.childNodes[c._ll ? 1 : 0].childNodes[0].setAttribute("mode", g.comboType || "");
        if (g.comboImagePath) {
            c.childNodes[c._ll ? 1 : 0].childNodes[0].setAttribute("imagePath", g.comboImagePath)
        }
        if (g.comboDefaultImage) {
            c.childNodes[c._ll ? 1 : 0].childNodes[0].setAttribute("defaultImage", g.comboDefaultImage)
        }
        if (g.comboDefaultImageDis) {
            c.childNodes[c._ll ? 1 : 0].childNodes[0].setAttribute("defaultImageDis", g.comboDefaultImageDis)
        }
        c._combo = new dhtmlXComboFromSelect(c.childNodes[c._ll ? 1 : 0].childNodes[0]);
        c._combo.setSkin(c.getForm().skin);
        c._combo._currentComboValue = c._combo.getSelectedValue();
        c._combo.getInput().id = g.uid;
        var a = this;
        c._combo.attachEvent("onChange", function () {
            a.doOnChange(this)
        });
        if (g.connector) {
            this.doLoadOptsConnector(c, g.connector)
        }
        if (g.filtering) {
            c._combo.enableFilteringMode(true)
        } else {
            if (g.serverFiltering) {
                c._combo.enableFilteringMode(true, g.serverFiltering, g.filterCache, g.filterSubLoad)
            }
        }
        if (g.readonly == true) {
            this.setReadonly(c, true)
        }
        if (g.style) {
            c._combo.DOMelem_input.style.cssText += g.style
        }
        c._combo.attachEvent("onFocus", function () {
            var h = this.cont.parentNode.parentNode;
            var j = h.getForm();
            if (j.skin == "dhx_terrace" && this.cont.className.search(/combo_in_focus/) < 0) {
                this.cont.className += " combo_in_focus"
            }
            j.callEvent("onFocus", [h._idd]);
            j = h = null
        });
        c._combo.attachEvent("onBlur", function () {
            var h = this.cont.parentNode.parentNode;
            var j = h.getForm();
            if (j.skin == "dhx_terrace" && this.cont.className.search(/combo_in_focus/) >= 0) {
                this.cont.className = this.cont.className.replace(/\s{0,}combo_in_focus/gi, "")
            }
            j.callEvent("onBlur", [h._idd]);
            j = h = null
        });
        return this
    },
    destruct: function (a) {
        a.childNodes[a._ll ? 1 : 0].childNodes[0].onchange = null;
        a._combo._currentComboValue = null;
        a._combo.unload();
        a._combo = null;
        a._apiChange = null;
        this.d2(a);
        a = null
    },
    doAttachEvents: function (c) {
        var a = this;
        c.childNodes[c._ll ? 1 : 0].childNodes[0].onchange = function () {
            a.doOnChange(this);
            a.doValidate(this.DOMParent.parentNode.parentNode)
        }
    },
    doValidate: function (a) {
        if (a.getForm().hot_validate) {
            this._validate(a)
        }
    },
    doOnChange: function (c) {
        var a = c.base.parentNode.parentNode.parentNode;
        if (a._apiChange) {
            return
        }
        c._newComboValue = c.getSelectedValue();
        if (c._newComboValue != c._currentComboValue) {
            if (a.checkEvent("onBeforeChange")) {
                if (a.callEvent("onBeforeChange", [a._idd, c._currentComboValue, c._newComboValue]) !== true) {
                    window.setTimeout(function () {
                        c.setComboValue(c._currentComboValue)
                    }, 1);
                    return false
                }
            }
            c._currentComboValue = c._newComboValue;
            a.callEvent("onChange", [a._idd, c._currentComboValue])
        }
        a._autoCheck(a._enabled)
    },
    doLoadOptsConnector: function (h, a) {
        var g = this;
        var c = h;
        h._connector_working = true;
        h._apiChange = true;
        h._combo.load(a, function () {
            c.callEvent("onOptionsLoaded", [c._idd]);
            c._connector_working = false;
            if (c._connector_value != null) {
                g.setValue(c, c._connector_value);
                c._connector_value = null
            }
            c._apiChange = false;
            g = c = null
        })
    },
    enable: function (a) {
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
        a._enabled = true;
        a._combo.enable()
    },
    disable: function (a) {
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
        a._enabled = false;
        a._combo.disable()
    },
    getCombo: function (a) {
        return a._combo
    },
    setValue: function (a, c) {
        if (a._connector_working) {
            a._connector_value = c;
            return
        }
        a._apiChange = true;
        a._combo.setComboValue(c);
        a._combo._currentComboValue = a._combo.getActualValue();
        a._apiChange = false
    },
    getValue: function (a) {
        return a._combo.getActualValue()
    },
    setWidth: function (c, a) {
        c.childNodes[c._ll ? 1 : 0].childNodes[0].style.width = a + "px"
    },
    setReadonly: function (a, c) {
        if (!a._combo) {
            return
        }
        a._combo_ro = c;
        a._combo.readonly(a._combo_ro)
    },
    isReadonly: function (a, c) {
        return a._combo_ro || false
    },
    setFocus: function (a) {
        if (a._enabled) {
            a._combo.setFocus()
        }
    },
    _setCss: function (a, g, c) {
        a._combo.setFontSize(c, c)
    }
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        doLoadOpts: 1,
        doUnloadNestedLists: 1,
        setText: 1,
        getText: 1,
        isEnabled: 1,
        _checkNoteWidth: 1
    }) {
        dhtmlXForm.prototype.items.combo[c] = dhtmlXForm.prototype.items.select[c]
    }
})();
dhtmlXForm.prototype.items.combo.d2 = dhtmlXForm.prototype.items.select.destruct;
dhtmlXForm.prototype.getCombo = function (a) {
    return this.doWithItem(a, "getCombo")
};
dhtmlXForm.prototype.items.calendar = {
    render: function (g, j) {
        var c = this;
        g._type = "calendar";
        g._enabled = true;
        var l = navigator.userAgent;
        var a = (l.indexOf("MSIE 6.0") >= 0 || l.indexOf("MSIE 7.0") >= 0 || l.indexOf("MSIE 8.0") >= 0);
        this.doAddLabel(g, j);
        this.doAddInput(g, j, "INPUT", "TEXT", true, true, "dhxform_textarea calendar");
        this.doAttachChangeLS(g);
        if (a) {
            g.childNodes[g._ll ? 1 : 0].childNodes[0].onfocus2 = g.childNodes[g._ll ? 1 : 0].childNodes[0].onfocus;
            g.childNodes[g._ll ? 1 : 0].childNodes[0].onfocus = function () {
                if (this._skipOnFocus == true) {
                    this._skipOnFocus = false;
                    return
                }
                this.onfocus2.apply(this, arguments)
            }
        }
        g.childNodes[g._ll ? 1 : 0].childNodes[0]._idd = g._idd;
        g.childNodes[g._ll ? 1 : 0].childNodes[0].onblur = function () {
            var m = this.parentNode.parentNode;
            if (m._c.base._formMouseDown) {
                m._c.base._formMouseDown = false;
                this._skipOnFocus = true;
                this.focus();
                this.value = this.value;
                m = null;
                return true
            }
            var n = m.getForm();
            n._ccDeactivate(m._idd);
            c.checkEnteredValue(this.parentNode.parentNode);
            if (n.live_validate) {
                c._validate(m)
            }
            n.callEvent("onBlur", [m._idd]);
            n = m = null
        };
        g._f = (j.dateFormat || null);
        g._f0 = (j.serverDateFormat || g._f);
        var h = g.getForm();
        g._c = new dhtmlXCalendarObject(g.childNodes[g._ll ? 1 : 0].childNodes[0], j.skin || h.skin || "dhx_skyblue");
        g._c._nullInInput = true;
        g._c.enableListener(g.childNodes[g._ll ? 1 : 0].childNodes[0]);
        if (g._f != null) {
            g._c.setDateFormat(g._f)
        }
        if (!window.dhx4.s2b(j.enableTime)) {
            g._c.hideTime()
        }
        if (window.dhx4.s2b(j.showWeekNumbers)) {
            g._c.showWeekNumbers()
        }
        if (!isNaN(j.weekStart)) {
            g._c.setWeekStartDay(j.weekStart)
        }
        if (typeof (j.calendarPosition) != "undefined") {
            g._c.setPosition(j.calendarPosition)
        }
        if (j.minutesInterval != null) {
            g._c.setMinutesInterval(j.minutesInterval)
        }
        g._c._itemIdd = g._idd;
        g._c.attachEvent("onBeforeChange", function (m) {
            if (g._value != m) {
                if (g.checkEvent("onBeforeChange")) {
                    if (g.callEvent("onBeforeChange", [g._idd, g._value, m]) !== true) {
                        return false
                    }
                }
                g._tempValue = g._value = m;
                c.setValue(g, m, false);
                g.callEvent("onChange", [this._itemIdd, g._value])
            }
            return true
        });
        g._c.attachEvent("onClick", function () {
            g._tempValue = null
        });
        if (a) {
            g._c.base.onmousedown = function () {
                this._formMouseDown = true;
                return false
            }
        }
        this.setValue(g, j.value);
        h = null;
        return this
    },
    getCalendar: function (a) {
        return a._c
    },
    setSkin: function (a, c) {
        a._c.setSkin(c)
    },
    setValue: function (c, g, a) {
        if (!g || g == null || typeof (g) == "undefined" || g == "") {
            c._value = null;
            c.childNodes[c._ll ? 1 : 0].childNodes[0].value = ""
        } else {
            c._value = (g instanceof Date ? g : c._c._strToDate(g, c._f0 || c._c._dateFormat));
            c.childNodes[c._ll ? 1 : 0].childNodes[0].value = c._c._dateToStr(c._value, c._f || c._c._dateFormat)
        }
        if (a !== false) {
            c._c.setDate(c._value)
        }
    },
    getValue: function (c, a) {
        var g = c._tempValue || c._c.getDate();
        if (a === true && g == null) {
            return ""
        }
        return (a === true ? c._c._dateToStr(g, c._f0 || c._c._dateFormat) : g)
    },
    setDateFormat: function (c, a, g) {
        c._f = a;
        c._f0 = (g || c._f);
        c._c.setDateFormat(c._f);
        this.setValue(c, this.getValue(c))
    },
    destruct: function (a) {
        a._c.disableListener(a.childNodes[a._ll ? 1 : 0].childNodes[0]);
        a._c.unload();
        a._c = null;
        try {
            delete a._c
        } catch (c) {}
        a._f = null;
        try {
            delete a._f
        } catch (c) {}
        a._f0 = null;
        try {
            delete a._f0
        } catch (c) {}
        a.childNodes[a._ll ? 1 : 0].childNodes[0]._idd = null;
        a.childNodes[a._ll ? 1 : 0].childNodes[0].onblur = null;
        this.d2(a);
        a = null
    },
    checkEnteredValue: function (a) {
        this.setValue(a, a._c.getDate())
    }
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        doUnloadNestedLists: 1,
        setText: 1,
        getText: 1,
        enable: 1,
        disable: 1,
        isEnabled: 1,
        setWidth: 1,
        setReadonly: 1,
        isReadonly: 1,
        setFocus: 1,
        getInput: 1
    }) {
        dhtmlXForm.prototype.items.calendar[c] = dhtmlXForm.prototype.items.input[c]
    }
})();
dhtmlXForm.prototype.items.calendar.doAttachChangeLS = dhtmlXForm.prototype.items.select.doAttachChangeLS;
dhtmlXForm.prototype.items.calendar.d2 = dhtmlXForm.prototype.items.input.destruct;
dhtmlXForm.prototype.getCalendar = function (a) {
    return this.doWithItem(a, "getCalendar")
};
dhtmlXForm.prototype.setCalendarDateFormat = function (c, a, g) {
    this.doWithItem(c, "setDateFormat", a, g)
};
dhtmlXForm.prototype.items.btn2state = {
    setChecked: function (a, c) {
        a._checked = (c === true ? true : false);
        a.childNodes[a._ll ? 1 : 0].lastChild.className = "dhxform_img " + a._cssName + "_" + (a._checked ? "1" : "0");
        this.doCheckValue(a)
    }
};
(function () {
    for (var c in dhtmlXForm.prototype.items.checkbox) {
        if (!dhtmlXForm.prototype.items.btn2state[c]) {
            dhtmlXForm.prototype.items.btn2state[c] = dhtmlXForm.prototype.items.checkbox[c]
        }
    }
})();
dhtmlXForm.prototype.items.btn2state.render2 = dhtmlXForm.prototype.items.btn2state.render;
dhtmlXForm.prototype.items.btn2state.render = function (a, c) {
    c._autoInputWidth = false;
    this.render2(a, c);
    a._type = "btn2state";
    a._cssName = (typeof (c.cssName) == "undefined" ? "btn2state" : c.cssName);
    a._updateImgNode = function () {};
    a._doOnFocus = function () {
        a.getForm().callEvent("onFocus", [a._idd])
    };
    a._doOnBlur = function () {
        a.getForm().callEvent("onBlur", [a._idd])
    };
    a._doOnKeyUpDown = function (h, g, j) {
        this.callEvent(h, [this.childNodes[this._ll ? 0 : 1].childNodes[0], g, this._idd])
    };
    this.setChecked(a, a._checked);
    return this
};
dhtmlXForm.prototype.setFormData_btn2state = function (a, c) {
    this[c == true || parseInt(c) == 1 || c == "true" || c == this.getItemValue(a) ? "checkItem" : "uncheckItem"](a)
};
dhtmlXForm.prototype.getFormData_btn2state = function (a) {
    return (this.isItemChecked(a) ? this.getItemValue(a) : 0)
};
dhtmlXForm.prototype.items.colorpicker = {
    colorpicker: {},
    render: function (g, h) {
        var c = this;
        g._type = "colorpicker";
        g._enabled = true;
        this.doAddLabel(g, h);
        this.doAddInput(g, h, "INPUT", "TEXT", true, true, "dhxform_textarea");
        g._value = (h.value || "");
        g.childNodes[g._ll ? 1 : 0].childNodes[0].value = g._value;
        var a = {
            input: g.childNodes[g._ll ? 1 : 0].childNodes[0],
            custom_colors: (window.dhx4.s2b(h.enableCustomColors) == true),
            skin: g.getForm().skin
        };
        this.colorpicker[g._idd] = new dhtmlXColorPicker(a);
        this.colorpicker[g._idd]._nodes[0].valueColor = null;
        this.colorpicker[g._idd].base.className += " dhtmlxcp_in_form";
        if (typeof (h.customColors) != "undefined") {
            this.colorpicker[g._idd].setCustomColors(h.customColors)
        }
        this.colorpicker[g._idd].attachEvent("onSelect", function (j) {
            if (g._value != j) {
                if (g.checkEvent("onBeforeChange")) {
                    if (g.callEvent("onBeforeChange", [g._idd, g._value, j]) !== true) {
                        g.childNodes[g._ll ? 1 : 0].childNodes[0].value = g._value;
                        return
                    }
                }
                g._value = j;
                c.setValue(g, j);
                g.callEvent("onChange", [g._idd, g._value])
            }
        });
        this.colorpicker[g._idd].attachEvent("onHide", function (j) {
            var l = g.childNodes[g._ll ? 1 : 0].childNodes[0];
            if (l.value != g._value) {
                l.value = g._value
            }
            l = null
        });
        g.childNodes[g._ll ? 1 : 0].childNodes[0]._idd = g._idd;
        return this
    },
    getColorPicker: function (a) {
        return this.colorpicker[a._idd]
    },
    destruct: function (a) {
        if (this.colorpicker[a._idd].unload) {
            this.colorpicker[a._idd].unload()
        }
        this.colorpicker[a._idd] = null;
        try {
            delete this.colorpicker[a._idd]
        } catch (c) {}
        a.childNodes[a._ll ? 1 : 0].childNodes[0]._idd = null;
        this.d2(a);
        a = null
    },
    setSkin: function (a, c) {
        this.colorpicker[a._idd].setSkin(c)
    }
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        doUnloadNestedLists: 1,
        setText: 1,
        getText: 1,
        enable: 1,
        disable: 1,
        isEnabled: 1,
        setWidth: 1,
        setReadonly: 1,
        isReadonly: 1,
        setValue: 1,
        getValue: 1,
        updateValue: 1,
        setFocus: 1,
        getInput: 1
    }) {
        dhtmlXForm.prototype.items.colorpicker[c] = dhtmlXForm.prototype.items.input[c]
    }
})();
dhtmlXForm.prototype.items.colorpicker.d2 = dhtmlXForm.prototype.items.input.destruct;
dhtmlXForm.prototype.getColorPicker = function (a) {
    return this.doWithItem(a, "getColorPicker")
};
dhtmlXForm.prototype.items.container = {
    render: function (a, c) {
        a._type = "container";
        a._enabled = true;
        this.doAddLabel(a, c);
        this.doAddInput(a, c, "DIV", null, true, true, "dhxform_container");
        return this
    },
    getContainer: function (a) {
        return a.childNodes[a._ll ? 1 : 0].childNodes[0]
    },
    enable: function (a) {
        a._enabled = true;
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
        a.callEvent("onEnable", [a._idd])
    },
    disable: function (a) {
        a._enabled = false;
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
        a.callEvent("onDisable", [a._idd])
    },
    doAttachEvents: function () {},
    setValue: function () {},
    getValue: function () {
        return null
    }
};
dhtmlXForm.prototype.getContainer = function (a) {
    return this.doWithItem(a, "getContainer")
};
(function () {
    for (var c in dhtmlXForm.prototype.items.input) {
        if (!dhtmlXForm.prototype.items.container[c]) {
            dhtmlXForm.prototype.items.container[c] = dhtmlXForm.prototype.items.input[c]
        }
    }
})();
dhtmlXForm.prototype.items.editor = {
    editor: {},
    render: function (g, h) {
        var a = (!isNaN(h.rows));
        g._type = "editor";
        g._enabled = true;
        this.doAddLabel(g, h);
        this.doAddInput(g, h, "DIV", null, true, true, "dhxform_item_template");
        g._value = (h.value || "");
        var c = this;
        this.editor[g._idd] = new dhtmlXEditor({
            parent: g.childNodes[g._ll ? 1 : 0].childNodes[0],
            content: g._value
        });
        this.editor[g._idd].attachEvent("onAccess", function (l, m) {
            g.callEvent("_onBeforeEditorAccess", []);
            _dhxForm_doClick(document.body, "click");
            if (l == "blur") {
                c.doOnBlur(g, this);
                g.callEvent("onBlur", [g._idd]);
                if (g.getForm().skin == "dhx_terrace") {
                    var j = g.childNodes[g._ll ? 1 : 0].className;
                    if (j.indexOf("dhxeditor_focus") >= 0) {
                        g.childNodes[g._ll ? 1 : 0].className = (j).replace(/\s{0,}dhxeditor_focus/gi, "")
                    }
                }
            } else {
                g.callEvent("onEditorAccess", [g._idd, l, m, this, g.getForm()]);
                g.callEvent("onFocus", [g._idd]);
                if (g.getForm().skin == "dhx_terrace") {
                    var j = g.childNodes[g._ll ? 1 : 0].className;
                    if (j.indexOf("dhxeditor_focus") == -1) {
                        g.childNodes[g._ll ? 1 : 0].className += " dhxeditor_focus"
                    }
                }
            }
        });
        this.editor[g._idd].attachEvent("onToolbarClick", function (j) {
            g.callEvent("onEditorToolbarClick", [g._idd, j, this, g.getForm()])
        });
        if (h.readonly) {
            this.setReadonly(g, true)
        }
        g.childNodes[g._ll ? 0 : 1].childNodes[0].removeAttribute("for");
        g.childNodes[g._ll ? 0 : 1].childNodes[0].onclick = function () {
            c.editor[g._idd]._focus()
        };
        return this
    },
    doOnBlur: function (g, c) {
        var a = c.getContent();
        if (g._value != a) {
            if (g.checkEvent("onBeforeChange")) {
                if (g.callEvent("onBeforeChange", [g._idd, g._value, a]) !== true) {
                    c.setContent(g._value);
                    return
                }
            }
            g._value = a;
            g.callEvent("onChange", [g._idd, a])
        }
    },
    setValue: function (a, c) {
        if (a._value == c) {
            return
        }
        a._value = c;
        this.editor[a._idd].setContent(a._value)
    },
    getValue: function (a) {
        a._value = this.editor[a._idd].getContent();
        return a._value
    },
    enable: function (a) {
        this.editor[a._idd].setReadonly(false);
        this.doEn(a)
    },
    disable: function (a) {
        this.editor[a._idd].setReadonly(true);
        this.doDis(a)
    },
    setReadonly: function (a, c) {
        this.editor[a._idd].setReadonly(c)
    },
    getEditor: function (a) {
        return (this.editor[a._idd] || null)
    },
    destruct: function (a) {
        a.childNodes[a._ll ? 0 : 1].childNodes[0].onclick = null;
        this.editor[a._idd].unload();
        this.editor[a._idd] = null;
        this.d2(a);
        a = null
    },
    setFocus: function (a) {
        this.editor[a._idd]._focus()
    }
};
(function () {
    for (var c in {
        doAddLabel: 1,
        doAddInput: 1,
        doUnloadNestedLists: 1,
        setText: 1,
        getText: 1,
        setWidth: 1,
        isEnabled: 1
    }) {
        dhtmlXForm.prototype.items.editor[c] = dhtmlXForm.prototype.items.template[c]
    }
})();
dhtmlXForm.prototype.items.editor.d2 = dhtmlXForm.prototype.items.select.destruct;
dhtmlXForm.prototype.items.editor.doEn = dhtmlXForm.prototype.items.select.enable;
dhtmlXForm.prototype.items.editor.doDis = dhtmlXForm.prototype.items.select.disable;
dhtmlXForm.prototype.getEditor = function (a) {
    return this.doWithItem(a, "getEditor")
};
dhtmlXForm.prototype.items.upload = {
    render: function (c, g) {
        c._type = "up";
        c._enabled = true;
        c._checked = true;
        c.className = g.position + (typeof (g.className) == "string" ? " " + g.className : "");
        var a = document.createElement("DIV");
        c.appendChild(a);
        if (!isNaN(g.inputLeft)) {
            c.style.left = parseInt(g.inputLeft) + "px"
        }
        if (!isNaN(g.inputTop)) {
            c.style.top = parseInt(g.inputTop) + "px"
        }
        if (g.inputWidth != "auto") {
            if (!isNaN(g.inputWidth)) {
                a.style.width = parseInt(g.inputWidth) + "px"
            }
        }
        c._uploader = new dhtmlXFileUploader(a, g.swfPath || "", g.swfUrl || "", g.mode || null, g.swfLogs, g.slXap || "", g.slUrl || "", g.slLogs || "", g.multiple);
        c._uploader.setURL(g.url || "");
        c._uploader.callEvent = c.callEvent;
        if (typeof (g.autoStart) != "undefined") {
            c._uploader.setAutoStart(g.autoStart)
        }
        if (typeof (g.autoRemove) != "undefined") {
            c._uploader.setAutoRemove(g.autoRemove)
        }
        if (typeof (g.titleScreen) != "undefined") {
            c._uploader.enableTitleScreen(g.titleScreen)
        }
        if (typeof (g.titleText) != "undefined") {
            c._uploader.setTitleText(g.titleText)
        }
        if (g.hidden == true) {
            this.hide(c)
        }
        if (g.disabled == true) {
            this.userDisable(c)
        }
        if (!(g.inputHeight == "auto" || parseInt(g.inputHeight) == NaN)) {
            c._uploader.p_files.style.height = parseInt(g.inputHeight) + "px"
        }
        return this
    },
    destruct: function (a) {
        this.doUnloadNestedLists(a);
        a._uploader.callEvent = null;
        a._uploader.unload();
        a._uploader = null;
        a._checked = null;
        a._enabled = null;
        a._idd = null;
        a._type = null;
        a.onselectstart = null;
        a._autoCheck = null;
        a.callEvent = null;
        a.checkEvent = null;
        a.getForm = null;
        while (a.childNodes.length > 0) {
            a.removeChild(a.childNodes[0])
        }
        a.parentNode.removeChild(a);
        a = null
    },
    setText: function (a, c) {},
    getText: function (a) {},
    enable: function (a) {
        a._enabled = true;
        if (String(a.className).search("disabled") >= 0) {
            a.className = String(a.className).replace(/disabled/gi, "")
        }
        a._uploader.enable()
    },
    disable: function (a) {
        a._enabled = false;
        if (String(a.className).search("disabled") < 0) {
            a.className += " disabled"
        }
        a._uploader.disable()
    },
    setWidth: function (c, a) {
        c.childNodes[0].style.width = a + "px";
        c._width = a
    },
    getWidth: function (a) {
        return a._width || parseInt(a.childNodes[0].style.width)
    },
    setValue: function (a) {
        a._uploader.clear()
    },
    getValue: function (l) {
        var h = l._uploader.getData();
        var j = {};
        var g = 0;
        for (var c in h) {
            j[l._idd + "_r_" + g] = h[c].realName;
            j[l._idd + "_s_" + g] = h[c].serverName;
            g++
        }
        j[l._idd + "_count"] = g;
        return j
    },
    getUploader: function (a) {
        return a._uploader
    },
    getStatus: function (a) {
        return a._uploader.getStatus()
    }
};
(function () {
    for (var c in {
        doUnloadNestedLists: 1,
        isEnabled: 1
    }) {
        dhtmlXForm.prototype.items.upload[c] = dhtmlXForm.prototype.items.checkbox[c]
    }
})();
dhtmlXForm.prototype.setFormData_upload = function (a) {
    this.doWithItem(a, "setValue")
};
dhtmlXForm.prototype.getUploader = function (a) {
    return this.doWithItem(a, "getUploader")
};
dhtmlXForm.prototype.getUploaderStatus = function (a) {
    return this.doWithItem(a, "getStatus")
};

function dhtmlXFileUploader(p, swfPath, swfUrl, mode, swfLogs, slXap, slUrl, slLogs, multiple) {
    var that = this;
    if (typeof (mode) == "string" && typeof (this[mode]) == "function") {
        this.engine = mode
    } else {
        this.engine = "html4";
        var k = null;
        if (typeof (window.FormData) != "undefined" && typeof (window.XMLHttpRequest) != "undefined") {
            k = new XMLHttpRequest();
            if (typeof (k.upload) == "undefined") {
                k = null
            }
        }
        if (k != null) {
            this.engine = "html5"
        } else {
            if (typeof (window.swfobject) != "undefined" || k === false) {
                var k = swfobject.getFlashPlayerVersion();
                if (k.major >= 10) {
                    this.engine = "flash"
                }
            } else {
                this._sl_v = this.getSLVersion();
                if (this._sl_v) {
                    this.engine = "sl"
                }
            }
        }
        k = null
    }
    if (typeof (p) == "string") {
        p = document.getElementById(p)
    }
    this._upload_mp = (typeof (multiple) != "undefined" ? multiple == true : true);
    this._upload_dnd = true;
    this._swf_file_url = swfPath || "";
    this._swf_upolad_url = swfUrl || "";
    this._swf_logs = swfLogs;
    this._sl_xap = slXap;
    this._sl_upload_url = slUrl;
    this._sl_logs = slLogs;
    this.p = document.createElement("DIV");
    this.p.className += " dhx_file_uploader";
    p.appendChild(this.p);
    this.p_files = document.createElement("DIV");
    this.p_files.className = "dhx_upload_files";
    this.p.appendChild(this.p_files);
    this.p_controls = document.createElement("DIV");
    this.p_controls.className = "dhx_upload_controls";
    this.p.appendChild(this.p_controls);
    this._files = {};
    this._items = {};
    this._data = {};
    this._autoStart = false;
    this._autoRemove = false;
    this._titleScreen = true;
    this._enabled = true;
    this._uploaded_count = 0;
    this._initToolbar = function () {
        this.b_opts = {
            info: {
                onclick: null
            },
            browse: {
                onclick: null,
                tooltip: "Browse"
            },
            upload: {
                onclick: function () {
                    if (!that._enabled) {
                        return
                    }
                    if (!that._uploading) {
                        that._uploadStart()
                    }
                },
                tooltip: "Upload"
            },
            cancel: {
                onclick: function () {
                    if (!that._enabled) {
                        return
                    }
                    that._uploadStop();
                    that._switchButton(false)
                },
                tooltip: "Stop"
            },
            clear: {
                onclick: function () {
                    if (!that._enabled) {
                        return
                    }
                    that.clear()
                },
                tooltip: "Clear list"
            }
        };
        this.buttons = {};
        for (var a in this.b_opts) {
            var k = document.createElement("DIV");
            k.innerHTML = "&nbsp;";
            k.className = "dhx_file_uploader_button button_" + a;
            k.onclick = this.b_opts[a].onclick;
            if (this.b_opts[a].tooltip) {
                k.title = this.b_opts[a].tooltip
            }
            this.p_controls.appendChild(k);
            this.buttons[a] = k;
            k = null
        }
        this.buttons.cancel.style.display = "none"
    };
    this._readableSize = function (t) {
        var i = false;
        var b = ["b", "Kb", "Mb", "Gb", "Tb", "Pb", "Eb"];
        for (var q = 0; q < b.length; q++) {
            if (t > 1024) {
                t = t / 1024
            } else {
                if (i === false) {
                    i = q
                }
            }
        }
        if (i === false) {
            i = b.length - 1
        }
        return Math.round(t * 100) / 100 + " " + b[i]
    };
    this._beforeAddFileToList = function (name, size) {
        return (this.callEvent("onBeforeFileAdd", [name, size]) === true)
    };
    this._addFileToList = function (id, name, size, state, progress) {
        this._checkTitleScreen();
        var t = document.createElement("DIV");
        t._idd = id;
        t.className = "dhx_file dhx_file_" + state;
        t.innerHTML = "<div class='dhx_file_param dhx_file_name'>&nbsp;</div><div class='dhx_file_param dhx_file_progress'>" + progress + "%</div><div class='dhx_file_param dhx_file_delete' title='Remove from list'>&nbsp;</div>";
        this.p_files.appendChild(t);
        t.childNodes[0].style.width = t.offsetWidth - 127 + "px";
        this._items[id] = t;
        this._updateFileNameSize(id);
        t.childNodes[2].onclick = function () {
            if (!that._enabled) {
                return
            }
            var id = this.parentNode._idd;
            that._removeFileFromQueue(id)
        };
        this.callEvent("onFileAdd", [name])
    };
    this._removeFileFromList = function (id) {
        if (!this._items[id]) {
            return
        }
        this._items[id].childNodes[2].onclick = null;
        this._items[id].parentNode.removeChild(this._items[id]);
        this._items[id] = null;
        delete this._items[id];
        if (this._data[id]) {
            this._data[id] = null;
            delete this._data[id]
        }
        this._checkTitleScreen()
    };
    this._updateFileNameSize = function (id) {
        this._items[id].childNodes[0].innerHTML = this._files[id].name + (!isNaN(this._files[id].size) ? " (" + this._readableSize(this._files[id].size) + ")" : "&nbsp;");
        this._items[id].childNodes[0].title = this._files[id].name + (!isNaN(this._files[id].size) ? " (" + this._readableSize(this._files[id].size) + ")" : "")
    };
    this._updateFileInList = function (id, state, progress) {
        if (!this._items[id]) {
            return
        }
        this._items[id].className = "dhx_file dhx_file_" + state;
        this._updateProgress(id, state, progress);
        this._updateFileNameSize(id)
    };
    this._updateProgress = function (id, state, progress) {
        if (state == "uploading" && progress < 100 && this._progress_type == "loader") {
            this._items[id].childNodes[1].className = "dhx_file_param dhx_file_uploading";
            this._items[id].childNodes[1].innerHTML = "&nbsp;"
        } else {
            this._items[id].childNodes[1].className = "dhx_file_param dhx_file_progress";
            this._items[id].childNodes[1].innerHTML = progress + "%"
        }
        this._updateFileNameSize(id)
    };
    this._removeFilesByState = function (state) {
        for (var a in this._files) {
            if (state === true || this._files[a].state == state) {
                this._removeFileFromQueue(a)
            }
        }
    };
    this._switchButton = function (state) {
        if (state == true) {
            this.buttons.upload.style.display = "none";
            this.buttons.cancel.style.display = ""
        } else {
            var t = this._uploaded_count;
            this.buttons.upload.style.display = "";
            this.buttons.cancel.style.display = "none";
            this._uploaded_count = 0;
            if (t > 0) {
                this.callEvent("onUploadComplete", [t])
            }
        }
    };
    this._uploadStart = function () {
        this._switchButton(true);
        if (!this._uploading) {
            for (var a in this._files) {
                if (this._files[a].state == "fail") {
                    this._files[a].state = "added";
                    this._updateFileInList(a, "added", 0)
                }
            }
        }
        this._uploading = true;
        var t = false;
        for (var a in this._files) {
            if (!t && [this._files[a].state] == "added") {
                t = true;
                this._files[a].state = "uploading";
                this._updateFileInList(a, "uploading", 0);
                this._doUploadFile(a)
            }
        }
        if (!t) {
            this._uploading = false;
            this._switchButton(false)
        }
    };
    this._onUploadSuccess = function (id, serverName, r, extra) {
        if (typeof (r) != "undefined" && this.engine == "flash") {
            dhx4.temp = null;
            try {
                eval("dhx4.temp=" + r.data)
            } catch (e) {
                dhx4.temp = null
            }
            var t = dhx4.temp;
            dhx4.temp = null;
            if (t != null && t.state == true && t.name != null) {
                serverName = t.name;
                if (t.extra != null) {
                    extra = t.extra
                }
            } else {
                this._onUploadFail(id, (t != null && t.extra != null ? t.extra : null));
                return
            }
        }
        this._uploaded_count++;
        this._data[id] = {
            realName: this._files[id].name,
            serverName: serverName
        };
        this._files[id].state = "uploaded";
        this._updateFileInList(id, "uploaded", 100);
        this.callEvent("onUploadFile", [this._files[id].name, serverName, extra]);
        if (this._autoRemove) {
            this._removeFileFromQueue(id)
        }
        if (this._uploading) {
            this._uploadStart()
        }
    };
    this._onUploadFail = function (id, extra) {
        this._files[id].state = "fail";
        this._updateFileInList(id, "fail", 0);
        this.callEvent("onUploadFail", [this._files[id].name, extra]);
        if (this._uploading) {
            this._uploadStart()
        }
    };
    this._onUploadAbort = function (id) {
        this._uploading = false;
        this._files[id].state = "added";
        this._updateFileInList(id, "added", 0);
        this.callEvent("onUploadCancel", [this._files[id].name])
    };
    this._checkTitleScreen = function () {
        var k = 0;
        for (var a in this._files) {
            k++
        }
        if (k == 0 && this.p.className.search("dhx_file_uploader_title") < 0 && this._titleScreen) {
            this.p.className += " dhx_file_uploader_title";
            this.buttons.info.innerHTML = this._titleText;
            this.buttons.info.style.width = Math.max(this.p_controls.offsetWidth - 134, 0) + "px"
        }
        if ((k > 0 || !this._titleScreen) && this.p.className.search("dhx_file_uploader_title") >= 0) {
            this.p.className = this.p.className.replace(/dhx_file_uploader_title/g, "");
            this.buttons.info.innerHTML = ""
        }
    };
    this.callEvent = function () {};
    this.upload = function () {
        if (!this._uploading) {
            this._uploadStart()
        }
    };
    this.setAutoStart = function (state) {
        this._autoStart = (state == true)
    };
    this.setAutoRemove = function (state) {
        this._autoRemove = (state == true)
    };
    this.enableTitleScreen = function (state) {
        this._titleScreen = (state == true);
        this._checkTitleScreen()
    };
    this.setTitleText = function (text) {
        this._titleText = text;
        if (this.p.className.search("dhx_file_uploader_title") >= 0) {
            this.buttons.info.innerHTML = this._titleText
        }
    };
    this.setURL = function (url) {
        this._url = url
    };
    this.setSWFURL = function (url) {
        this._swf_upolad_url = url
    };
    this.enable = function () {
        this._enabled = true;
        this.p_files.className = "dhx_upload_files";
        this.p_controls.className = "dhx_upload_controls"
    };
    this.disable = function () {
        this._enabled = false;
        this.p_files.className = "dhx_upload_files dhx_uploader_dis";
        this.p_controls.className = "dhx_upload_controls dhx_uploader_dis"
    };
    this.getStatus = function () {
        var t = 0;
        for (var a in this._files) {
            if (this._files[a].state != "uploaded") {
                return -1
            }
            t = 1
        }
        return t
    };
    this.getData = function () {
        return this._data
    };
    this.clear = function () {
        if (this.callEvent("onBeforeClear", []) !== true) {
            return
        }
        if (this._uploading) {
            that._uploadStop()
        }
        that._switchButton(false);
        that._removeFilesByState(true);
        this.callEvent("onClear", [])
    };
    this.unload = function () {
        this._removeFilesByState(true);
        this._data = null;
        this._files = null;
        this._items = null;
        this._unloadEngine();
        for (var a in this.buttons) {
            this.buttons[a].onclick = null;
            this.buttons[a].parentNode.removeChild(this.buttons[a]);
            this.buttons[a] = null;
            delete this.buttons[a]
        }
        this.buttons = null;
        for (var a in this.b_opts) {
            this.b_opts[a].onclick = null;
            this.b_opts[a] = null;
            delete this.b_opts[a]
        }
        this.b_opts = null;
        this.p_controls.parentNode.removeChild(this.p_controls);
        this.p_files.parentNode.removeChild(this.p_files);
        this.p.className = this.p.className.replace(/dhx_file_uploader_title/gi, "").replace(/dhx_file_uploader/gi, "");
        for (var a in this) {
            this[a] = null
        }
        that = a = null
    };
    var e = new this[this.engine]();
    for (var a in e) {
        this[a] = e[a];
        e[a] = null
    }
    a = e = p = null;
    this._initToolbar();
    this._initEngine();
    this._checkTitleScreen();
    return this
}
dhtmlXFileUploader.prototype.html5 = function () {};
dhtmlXFileUploader.prototype.html5.prototype = {
    _initEngine: function () {
        var c = this;
        this.buttons.browse.onclick = function () {
            if (c._enabled) {
                c.f.click()
            }
        };
        this._progress_type = "percentage";
        var a = window.navigator.userAgent;
        if (a.match(/Windows/gi) != null && a.match(/AppleWebKit/gi) != null && a.match(/Safari/gi) != null) {
            if (a.match(/Version\/5\.1\.5/gi)) {
                this._upload_mp = false
            }
            if (a.match(/Version\/5\.1[^\.\d{1,}]/gi)) {
                this._upload_dnd = false
            }
            if (a.match(/Version\/5\.1\.1/gi)) {
                this._upload_mp = false;
                this._upload_dnd = false
            }
            if (a.match(/Version\/5\.1\.2/gi)) {
                this._upload_dnd = false
            }
            if (a.match(/Version\/5\.1\.7/gi)) {
                this._upload_mp = false
            }
        }
        this._addFileInput();
        if (this._upload_dnd) {
            this.p.ondragenter = function (g) {
                if (!g.dataTransfer) {
                    return
                }
                g.stopPropagation();
                g.preventDefault()
            };
            this.p.ondragover = function (g) {
                if (!g.dataTransfer) {
                    return
                }
                g.stopPropagation();
                g.preventDefault()
            };
            this.p.ondrop = function (g) {
                if (!g.dataTransfer) {
                    return
                }
                g.stopPropagation();
                g.preventDefault();
                if (c._enabled) {
                    c._parseFilesInInput(g.dataTransfer.files)
                }
            };
            this._titleText = "Drag-n-Drop files here or<br>click to select files for upload."
        } else {
            this._titleText = "Click to select files for upload."
        }
    },
    _addFileInput: function () {
        if (this.f != null) {
            this.f.onchange = null;
            this.f.parentNode.removeChild(this.f);
            this.f = null
        }
        var a = this;
        this.f = document.createElement("INPUT");
        this.f.type = "file";
        if (this._upload_mp) {
            this.f.multiple = "1"
        }
        this.f.className = "dhx_uploader_input";
        this.p_controls.appendChild(this.f);
        this.f.onchange = function () {
            a._parseFilesInInput(this.files);
            if (window.dhx4.isOpera) {
                a._addFileInput()
            } else {
                this.value = ""
            }
        }
    },
    _doUploadFile: function (id) {
        var that = this;
        if (!this._loader) {
            this._loader = new XMLHttpRequest();
            this._loader.upload.onprogress = function (e) {
                if (that._files[this._idd].state == "uploading") {
                    that._updateFileInList(this._idd, "uploading", Math.round(e.loaded * 100 / e.total))
                }
            };
            this._loader.onload = function (e) {
                dhx4.temp = null;
                try {
                    eval("dhx4.temp=" + this.responseText)
                } catch (e) {}
                var r = dhx4.temp;
                dhx4.temp = null;
                if (typeof (r) == "object" && r != null && typeof (r.state) != "undefined" && r.state == true) {
                    that._onUploadSuccess(this.upload._idd, r.name, null, r.extra);
                    r = null
                } else {
                    that._onUploadFail(this.upload._idd, (r != null && r.extra != null ? r.extra : null))
                }
            };
            this._loader.onerror = function (e) {
                that._onUploadFail(this.upload._idd)
            };
            this._loader.onabort = function (e) {
                that._onUploadAbort(this.upload._idd)
            }
        }
        this._loader.upload._idd = id;
        var form = new FormData();
        form.append("file", this._files[id].file);
        this._loader.open("POST", this._url + (String(this._url).indexOf("?") < 0 ? "?" : "&") + "mode=html5&dhxr" + new Date().getTime(), true);
        this._loader.setRequestHeader("X-Requested-With", "XMLHttpRequest");
        this._loader.send(form)
    },
    _uploadStop: function () {
        if (!this._uploading || !this._loader) {
            return
        }
        this._loader.abort()
    },
    _parseFilesInInput: function (c) {
        for (var a = 0; a < c.length; a++) {
            this._addFileToQueue(c[a])
        }
    },
    _addFileToQueue: function (a) {
        if (!this._beforeAddFileToList(a.name, a.size)) {
            return
        }
        var c = (a._idd || window.dhx4.newId());
        this._files[c] = {
            file: a,
            name: a.name,
            size: a.size,
            state: "added"
        };
        this._addFileToList(c, a.name, a.size, "added", 0);
        if (this._autoStart && !this._uploading) {
            this._uploadStart(true)
        }
    },
    _removeFileFromQueue: function (h) {
        if (!this._files[h]) {
            return
        }
        var c = this._files[h].name;
        var g = (this._data != null && this._data[h] != null ? this._data[h].serverName : null);
        if (this.callEvent("onBeforeFileRemove", [c, g]) !== true) {
            return
        }
        var a = false;
        if (this._uploading && h == this._loader.upload._idd && this._files[h].state == "uploading") {
            this._uploadStop();
            a = true
        }
        this._files[h].file = null;
        this._files[h].name = null;
        this._files[h].size = null;
        this._files[h].state = null;
        this._files[h] = null;
        delete this._files[h];
        this._removeFileFromList(h);
        this.callEvent("onFileRemove", [c, g]);
        if (a) {
            this._uploadStart()
        }
    },
    _unloadEngine: function () {
        this.buttons.browse.onclick = null;
        this.f.onchange = null;
        this.f.parentNode.removeChild(this.f);
        this.f = null;
        this.p.ondragenter = null;
        this.p.ondragover = null;
        this.p.ondrop = null;
        if (this._loader) {
            this._loader.upload.onprogress = null;
            this._loader.onload = null;
            this._loader.onerror = null;
            this._loader.onabort = null;
            this._loader.upload._idd = null;
            this._loader = null
        }
        this._initEngine = null;
        this._doUploadFile = null;
        this._uploadStop = null;
        this._parseFilesInInput = null;
        this._addFileToQueue = null;
        this._removeFileFromQueue = null;
        this._unloadEngine = null
    }
};
dhtmlXFileUploader.prototype.html4 = function () {};
dhtmlXFileUploader.prototype.html4.prototype = {
    _initEngine: function () {
        this._addForm();
        this._progress_type = "loader";
        this._titleText = "Click button<br>to select files for upload."
    },
    _addForm: function () {
        var a = this;
        var g = window.dhx4.newId();
        if (!this.k) {
            this.k = document.createElement("DIV");
            this.k.className = "dhx_file_form_cont";
            this.buttons.browse.appendChild(this.k);
            this.fr_name = "dhx_file_" + window.dhx4.newId();
            this.k.innerHTML = '<iframe name="' + this.fr_name + '" style="height:0px;width:0px;" frameBorder="0"></iframe>';
            this.fr = this.k.firstChild;
            if (window.navigator.userAgent.indexOf("MSIE") >= 0) {
                this.fr.onreadystatechange = function () {
                    if (this.readyState == "complete") {
                        a._onLoad()
                    }
                }
            } else {
                this.fr.onload = function () {
                    a._onLoad()
                }
            }
        }
        var c = document.createElement("DIV");
        c.innerHTML = "<form method='POST' enctype='multipart/form-data' target='" + this.fr_name + "' class='dhx_file_form' name='dhx_file_form_" + window.dhx4.newId() + "'><input type='hidden' name='mode' value='html4'><input type='hidden' name='uid' value='" + g + "'><input type='file' name='file' class='dhx_file_input'></form>";
        this.k.appendChild(c);
        c.firstChild.lastChild._idd = g;
        c.firstChild.lastChild.onchange = function () {
            if (!a._beforeAddFileToList(this.value, null)) {
                return
            }
            a._addFileToQueue(this);
            this.onchange = null;
            this.parentNode.parentNode.style.display = "none";
            a._addForm()
        };
        c = null
    },
    _onLoad: function () {
        if (this._uploading) {
            dhx4.temp = null;
            try {
                eval("dhx4.temp=" + this.fr.contentWindow.document.body.innerHTML)
            } catch (e) {}
            var r = dhx4.temp;
            dhx4.temp = null;
            if (typeof (r) == "object" && r != null) {
                if (typeof (r.state) != "undefined") {
                    if (r.state == "cancelled") {
                        this._onUploadAbort(this.fr._idd);
                        r = null;
                        return
                    } else {
                        if (r.state == true) {
                            if (typeof (r.size) != "undefined" && !isNaN(r.size)) {
                                this._files[this.fr._idd].size = r.size
                            }
                            this._onUploadSuccess(this.fr._idd, r.name, null, r.extra);
                            r = null;
                            return
                        }
                    }
                }
            }
            this._onUploadFail(this.fr._idd, (r != null && r.extra != null ? r.extra : null))
        }
    },
    _addFileToQueue: function (c) {
        var a = c.value.match(/[^\\\/]*$/g);
        if (a[0] != null) {
            a = a[0]
        } else {
            a = c.value
        }
        this._files[c._idd] = {
            name: a,
            form: c.parentNode,
            node: c.parentNode.parentNode,
            input: c,
            state: "added"
        };
        this._addFileToList(c._idd, c.value, false, "added", 0);
        if (this._autoStart && !this._uploading) {
            this._uploadStart(true)
        }
    },
    _removeFileFromQueue: function (g) {
        var a = this._files[g].name;
        var c = (this._data != null && this._data[g] != null ? this._data[g].serverName : null);
        if (this.callEvent("onBeforeFileRemove", [a, c]) !== true) {
            return
        }
        this._files[g].input.onchange = null;
        this._files[g].form.removeChild(this._files[g].input);
        this._files[g].node.removeChild(this._files[g].form);
        this._files[g].node.parentNode.removeChild(this._files[g].node);
        this._files[g].input = null;
        this._files[g].name = null;
        this._files[g].form = null;
        this._files[g].node = null;
        this._files[g].size = null;
        this._files[g].state = null;
        this._files[g] = null;
        delete this._files[g];
        this._removeFileFromList(g);
        this.callEvent("onFileRemove", [a, c])
    },
    _doUploadFile: function (a) {
        this.fr._idd = a;
        this._files[a].form.action = this._url;
        this._files[a].form.submit()
    },
    _uploadStop: function () {
        if (!this._uploading) {
            return
        }
        this.fr.contentWindow.location.href = (this._url) + (this._url.indexOf("?") < 0 ? "?" : "&") + "mode=html4&action=cancel&dhxr" + new Date().getTime()
    },
    _unloadEngine: function () {
        if (this.k) {
            this.fr_name = null;
            this.fr.onreadystatechange = null;
            this.fr.onload = null;
            this.fr.parentNode.removeChild(this.fr);
            this.fr = null;
            this.k.firstChild.firstChild.lastChild.onchange = null;
            this.k.parentNode.removeChild(this.k);
            this.k = null
        }
        this._initEngine = null;
        this._addForm = null;
        this._onLoad = null;
        this._addFileToQueue = null;
        this._removeFileFromQueue = null;
        this._doUploadFile = null;
        this._uploadStop = null;
        this._unloadEngine = null
    }
};
dhtmlXFileUploader.prototype.flash = function () {};
dhtmlXFileUploader.prototype.flash.prototype = {
    _initEngine: function () {
        if (!window.dhtmlXFileUploaderSWFObjects) {
            window.dhtmlXFileUploaderSWFObjects = {
                items: {},
                callEvent: function (j, g, h) {
                    return window.dhtmlXFileUploaderSWFObjects.items[j].uploader[g].apply(window.dhtmlXFileUploaderSWFObjects.items[j].uploader, h)
                }
            }
        }
        var c = this;
        this._swf_obj_id = "dhtmlXFileUploaderSWFObject_" + window.dhx4.newId();
        this._swf_file_url = this._swf_file_url + (this._swf_file_url.indexOf("?") >= 0 ? "&" : "?") + "dhxr" + new Date().getTime();
        this.buttons.browse.innerHTML = "<div id='" + this._swf_obj_id + "' style='width:100%;height:100%;'></div>";
        swfobject.embedSWF(this._swf_file_url, this._swf_obj_id, "100%", "100%", "9", null, {
            ID: this._swf_obj_id,
            enableLogs: this._swf_logs
        }, {
            wmode: "transparent"
        });
        var a = swfobject.getFlashPlayerVersion();
        this._titleText = "Engine successfuly inited<br>Flash Player: " + a.major + "." + a.minor + "." + a.release;
        this._progress_type = "percentage";
        window.dhtmlXFileUploaderSWFObjects.items[this._swf_obj_id] = {
            id: this._swf_obj_id,
            uploader: this
        }
    },
    _beforeAddFileToQueue: function (a, c) {
        return (this.callEvent("onBeforeFileAdd", [a, c]) === true)
    },
    _addFileToQueue: function (h, c, g) {
        if (window.dhx4.isIE) {
            var a = document.createElement("INPUT");
            a.type = "TEXT";
            a.style.position = "absolute";
            a.style.left = "0px";
            a.style.top = window.dhx4.absTop(this.buttons.browse) + "px";
            a.style.width = "10px";
            document.body.appendChild(a);
            a.focus();
            document.body.removeChild(a);
            a = null
        }
        this._files[h] = {
            name: c,
            size: g,
            state: "added"
        };
        this._addFileToList(h, c, g, "added", 0);
        if (this._autoStart && !this._uploading) {
            this._uploadStart(true)
        }
    },
    _removeFileFromQueue: function (h) {
        if (!this._files[h]) {
            return
        }
        var c = this._files[h].name;
        var g = (this._data != null && this._data[h] != null ? this._data[h].serverName : null);
        if (this.callEvent("onBeforeFileRemove", [c, g]) !== true) {
            return
        }
        var a = false;
        if (this._uploading && this._files[h].state == "uploading") {
            this._uploadStop();
            a = true
        }
        swfobject.getObjectById(this._swf_obj_id).removeFileById(h);
        this._files[h].name = null;
        this._files[h].size = null;
        this._files[h].state = null;
        this._files[h] = null;
        delete this._files[h];
        this._removeFileFromList(h);
        this.callEvent("onFileRemove", [c, g]);
        if (a) {
            this._uploadStart()
        }
    },
    _doUploadFile: function (a) {
        swfobject.getObjectById(this._swf_obj_id).upload(a, this._swf_upolad_url)
    },
    _uploadStop: function (g) {
        for (var c in this._files) {
            if (this._files[c].state == "uploading") {
                swfobject.getObjectById(this._swf_obj_id).uploadStop(c)
            }
        }
    },
    _unloadEngine: function () {
        if (window.dhtmlXFileUploaderSWFObjects.items[this._swf_obj_id]) {
            window.dhtmlXFileUploaderSWFObjects.items[this._swf_obj_id].id = null;
            window.dhtmlXFileUploaderSWFObjects.items[this._swf_obj_id].uploader = null;
            window.dhtmlXFileUploaderSWFObjects.items[this._swf_obj_id] = null;
            delete window.dhtmlXFileUploaderSWFObjects.items[this._swf_obj_id]
        }
        this._swf_obj_id = null;
        this._initEngine = null;
        this._addFileToQueue = null;
        this._removeFileFromQueue = null;
        this._doUploadFile = null;
        this._uploadStop = null;
        this._unloadEngine = null
    }
};
dhtmlXFileUploader.prototype.sl = function () {};
dhtmlXFileUploader.prototype.sl.prototype = {
    _initEngine: function () {
        if (typeof (this._sl_v) == "undefined") {
            this._sl_v = this.getSLVersion()
        }
        if (!window.dhtmlXFileUploaderSLObjects) {
            window.dhtmlXFileUploaderSLObjects = {
                items: {},
                callEvent: function (g, a, c) {
                    window.dhtmlXFileUploaderSLObjects.items[g].uploader[a].apply(window.dhtmlXFileUploaderSLObjects.items[g].uploader, c)
                }
            }
        }
        this._sl_obj_id = "dhtmlXFileUploaderSLObject_" + window.dhx4.newId();
        if (this._sl_v != false) {
            this._titleText = "Engine successfuly inited<br>Silverlight version: " + this._sl_v[0] + "." + this._sl_v[1];
            this.buttons.browse.innerHTML = '<div style="width:100%;height:100%;"><object data="data:application/x-silverlight-2," type="application/x-silverlight-2" width="100%" height="100%" id="' + this._sl_obj_id + '"><param name="source" value="' + this._sl_xap + '"/><param name="background" value="Transparent"/><param name="windowless" value="true"/><param name="initParams" value="SLID=' + this._sl_obj_id + ",LOGS=" + this._sl_logs + '"/><param name="minRuntimeVersion" value="5.0"/></object></div>'
        } else {
            this._titleText = "Silverlight plugin not found<br>or version less than 4.0";
            this.buttons.browse.style.cursor = "wait";
            this.buttons.browse.title = ""
        }
        this._progress_type = "percentage";
        window.dhtmlXFileUploaderSLObjects.items[this._sl_obj_id] = {
            id: this._sl_obj_id,
            uploader: this
        }
    },
    _addFileToQueue: function (g, a, c) {
        this._files[g] = {
            name: a,
            size: c,
            state: "added"
        };
        this._addFileToList(g, a, c, "added", 0);
        if (this._autoStart && !this._uploading) {
            this._uploadStart(true)
        }
    },
    _removeFileFromQueue: function (c) {
        if (!this._files[c]) {
            return
        }
        var a = false;
        if (this._uploading && this._files[c].state == "uploading") {
            this._uploadStop();
            a = true
        }
        document.getElementById([this._sl_obj_id]).Content.a.removeFileById(c);
        this._files[c].name = null;
        this._files[c].size = null;
        this._files[c].state = null;
        this._files[c] = null;
        delete this._files[c];
        this._removeFileFromList(c);
        if (a) {
            this._uploadStart()
        }
    },
    _doUploadFile: function (a) {
        document.getElementById(this._sl_obj_id).Content.a.upload(a, this._sl_upload_url, "&mode=sl&dhxr" + new Date().getTime())
    },
    _uploadStop: function (g) {
        this._uploading = false;
        for (var c in this._files) {
            if (this._files[c].state == "uploading") {
                document.getElementById(this._sl_obj_id).Content.a.uploadStop(c)
            }
        }
    },
    _unloadEngine: function () {
        if (window.dhtmlXFileUploaderSLObjects.items[this._sl_obj_id]) {
            window.dhtmlXFileUploaderSLObjects.items[this._sl_obj_id].id = null;
            window.dhtmlXFileUploaderSLObjects.items[this._sl_obj_id].uploader = null;
            window.dhtmlXFileUploaderSLObjects.items[this._sl_obj_id] = null;
            delete window.dhtmlXFileUploaderSLObjects.items[this._sl_obj_id]
        }
        this._sl_obj_id = null;
        this._initEngine = null;
        this._addFileToQueue = null;
        this._removeFileFromQueue = null;
        this._doUploadFile = null;
        this._uploadStop = null;
        this._unloadEngine = null
    }
};
dhtmlXFileUploader.prototype.setSLURL = function (a) {
    this._sl_upload_url = a
};
dhtmlXFileUploader.prototype.getSLVersion = function () {
    var a = false;
    if (window.dhx4.isIE) {
        try {
            var c = new ActiveXObject("AgControl.AgControl");
            if (c != null) {
                var j = 4,
                    h = 0;
                while (c.isVersionSupported([j, h].join("."))) {
                    a = [j, h];
                    if (++h > 9) {
                        j++;
                        h = 0
                    }
                }
            }
            c = null
        } catch (g) {}
    } else {
        if (navigator.plugins["Silverlight Plug-In"] != null) {
            a = navigator.plugins["Silverlight Plug-In"].description.split(".")
        }
    }
    return a
};

function dhtmlXAccordion(j, m) {
    var h = this;
    var g = window.dhx4.transDetect();
    this.conf = {
        skin: (m || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxacc") || "dhx_skyblue"),
        icons_path: "",
        multi_mode: false,
        last_opened: null,
        on_active_id: null,
        on_active_click: false,
        size_changed: true,
        def_height: 90,
        total_count: 0,
        hiden_count: 0,
        base_w: null,
        fs_mode: false,
        fs_tm: null,
        fs_base_ofs: {
            w: 2,
            h: 2
        }
    };
    this.conf.tr = {
        prop: g.transProp,
        ev: g.transEv,
        height_open: "height 0.2s cubic-bezier(0.25,0.1,0.25,1)",
        height_close: "height 0.18s cubic-bezier(0.25,0.1,0.25,1)",
        op_open: "opacity 0.16s ease-in",
        op_close: "opacity 0.2s ease-out",
        op_v_open: "1",
        op_v_close: "0.4",
        dnd_top: "top 0.16s"
    };
    this.ofs = {
        m: {},
        s: {},
        def: {
            m: {
                left: 0,
                right: 0,
                first: 0,
                between: 8
            },
            s: {
                left: 0,
                right: 0,
                first: 0,
                between: -1,
                last: 0
            }
        },
        base: {
            s: {},
            m: {}
        },
        skin: {
            dhx_web: {
                s: {
                    between: 3
                },
                m: {
                    between: 3
                }
            },
            dhx_terrace: {
                m: {
                    between: 12,
                    left: 0,
                    right: 0
                }
            }
        }
    };
    if (navigator.userAgent.indexOf("MSIE") >= 0 || navigator.userAgent.indexOf("Trident") >= 0) {
        this.conf.tr.height_open = this.conf.tr.height_close
    } else {
        this.conf.tr.height_open = this.conf.tr.height_close
    }
    var l = null;
    if (typeof (j) == "object" && !j.tagName) {
        l = {};
        for (var c in j) {
            l[c] = j[c];
            j[c] = null
        }
        j = l.parent;
        l.parent = null
    }
    if (j == document.body) {
        document.documentElement.className += " dhxacc_fullscreen";
        document.body.className += " dhxacc_fullscreen";
        this.conf.fs_mode = true;
        this.base = document.createElement("DIV");
        this.base.className = "dhxacc_base_" + this.conf.skin;
        this.base.style.position = "absolute";
        this.base.style.left = this.conf.fs_base_ofs.w + "px";
        this.base.style.top = this.conf.fs_base_ofs.h + "px";
        document.body.appendChild(this.base)
    } else {
        this.base = (typeof (j) == "string" ? document.getElementById(j) : j);
        j = null;
        this.base.className += " dhxacc_base_" + this.conf.skin;
        while (this.base.childNodes.length > 0) {
            this.base.removeChild(this.base.lastChild)
        }
    }
    if (this.base._ofs != null) {
        for (var n in this.ofs.base) {
            if (this.base._ofs[n] != null) {
                for (var c in this.base._ofs[n]) {
                    this.ofs.base[n][c] = this.base._ofs[n][c]
                }
            }
        }
    }
    this._applyOffsets = function () {
        for (var u in this.ofs.def) {
            var r = this.ofs.def[u];
            var s = (this.ofs.skin[this.conf.skin] != null && this.ofs.skin[this.conf.skin][u] != null ? this.ofs.skin[this.conf.skin][u] : null);
            var q = (this.base._ofs != null ? this.base._ofs[u] : null);
            for (var o in r) {
                if (s != null && s[o] != null) {
                    this.ofs[u][o] = s[o]
                } else {
                    if (q != null && q[o] != null) {
                        this.ofs[u][o] = q[o]
                    } else {
                        this.ofs[u][o] = r[o]
                    }
                }
            }
        }
    };
    this._applyOffsets();
    this.t = {};
    this.addItem = function (w, v, q, o, u) {
        if (w == null) {
            w = "a" + window.dhx4.newId()
        }
        while (this.t[w] != null) {
            w = "a" + window.dhx4.newId()
        }
        var a = new dhtmlXAccordionCell(w, this);
        a.conf.skin = this.conf.skin;
        a.setText(v);
        if (u != null) {
            a.setIcon(u)
        }
        a.cell._accId = w;
        a.cell.childNodes[a.conf.idx.hdr].onselectstart = function (x) {
            x = x || event;
            if (x.preventDefault) {
                x.preventDefault()
            } else {
                x.returnValue = false
            }
            return false
        };
        a.cell.childNodes[a.conf.idx.hdr].onclick = function (y) {
            y = y || event;
            if (y.preventDefault) {
                y.preventDefault()
            } else {
                y.returnValue = false
            }
            if (h._dnd != null && h._dnd.ofs == true) {
                return
            }
            var x = (y.target || y.srcElement);
            var A = null;
            while (x._accId != this && A == null) {
                if (x._accId != null) {
                    A = x._accId
                } else {
                    x = x.parentNode
                }
            }
            if (A != null) {
                h._hdrClick(A)
            }
        };
        this.t[w] = {
            cell: a
        };
        this.conf.total_count++;
        if (this.conf.multi_mode) {
            if (typeof (q) == "undefined") {
                q = true
            }
            this.base.appendChild(a.cell);
            a.conf.opened = (q == true);
            if (typeof (o) == "undefined" || o == null || o == "*") {
                if (o == "*") {
                    a.conf.h_auto = true
                }
                o = this.conf.def_height
            } else {
                o = Math.max(parseInt(o), 30)
            }
            a._setSize(this.ofs.m.left, 0, this.conf.base_w || this._getAvailItemWidth(), a.conf.opened ? o : a._getHdrHeight());
            a.cell.style.marginTop = (a.cell == this.base.firstChild ? this.ofs.m.first : this.ofs.m.between) + "px";
            if (q != true) {
                a.conf.size.h = o;
                a._adjustCell();
                a.cell.className += " dhx_cell_closed"
            }
            this._adjustOpened();
            if (this._dnd != null) {
                this._dndAttachEvent(w)
            }
        } else {
            q = (this.conf.last_opened == null ? true : window.dhx4.s2b(q));
            var s = this._updateCellsHeight();
            if (this.conf.last_opened != null) {
                if (q) {
                    this._closeItem(this.conf.last_opened, false)
                } else {
                    var r = this.t[this.conf.last_opened].cell;
                    r._setSize(r.conf.size.x, r.conf.size.y, r.conf.size.w, s);
                    r = null
                }
            }
            this.base.appendChild(a.cell);
            a.conf.opened = q;
            a.cell.style.marginTop = String(a.cell == this.base.firstChild ? this.ofs.s.first : this.ofs.s.between) + "px";
            a._setSize(this.ofs.s.left, 0, this.conf.base_w || this._getAvailItemWidth(), q ? s : a._getHdrHeight());
            if (q) {
                this.conf.last_opened = w
            } else {
                a.conf.size.h = s;
                a._adjustCell();
                a.cell.className += " dhx_cell_closed"
            }
        }
        a = null;
        return this.t[w].cell
    };
    this.removeItem = function (a) {
        if (!this.t[a]) {
            return
        }
        if (this.conf.last_opened == a) {
            this.conf.last_opened = null
        }
        if (this.conf.on_active_id == a) {
            this.conf.on_active_id = null
        }
        if (this._dnd != null) {
            this._dndClearCell(a)
        }
        this.conf.total_count--;
        if (!this.conf.multi_mode && !this.t[a].cell.conf.visible) {
            this.conf.hiden_count--
        }
        this.t[a].cell._unload();
        this.t[a].cell = null;
        this.t[a] = null;
        delete this.t[a];
        if (!this.conf.unloading) {
            if (!this.conf.multi_mode) {
                this._updateCellsMargin()
            }
            this.setSizes()
        }
    };
    this.cells = function (a) {
        return this.t[a].cell
    };
    this.enableMultiMode = function (a, o) {
        this.conf.multi_mode = true;
        if (!isNaN(o)) {
            this.conf.def_height = o
        }
        if (a == "auto" || a == "scroll") {
            this.base.style.overflowX = "hidden";
            this.base.style.overflowY = a
        } else {
            this.base.style.overflow = "visible"
        }
    };
    this.forEachItem = function (q) {
        for (var o in this.t) {
            if (typeof (q) == "function") {
                q.apply(this, [this.t[o].cell])
            } else {
                if (typeof (q) == "string" && typeof (window[q]) == "function") {
                    window[q].apply(this, [this.t[o].cell])
                }
            }
        }
    };
    this._openItem = function (o, a) {
        if (typeof (a) == "undefined") {
            a = true
        }
        if (this.t[o].cell.conf.opened == false) {
            if (this.conf.multi_mode) {
                this.t[o].cell._open(a)
            } else {
                if (this.conf.tr.prop == false) {
                    if (this.conf.last_opened != null) {
                        this.t[this.conf.last_opened].cell._close(false)
                    }
                    this.t[o].cell._open(false);
                    this.conf.last_opened = o
                } else {
                    this.conf.on_active_id = o;
                    this.t[o].cell._open(a);
                    if (this.conf.last_opened != null) {
                        this.t[this.conf.last_opened].cell._close(a)
                    }
                    this.conf.last_opened = o
                }
            }
        }
    };
    this._closeItem = function (o, a) {
        if (typeof (a) == "undefined") {
            a = true
        }
        if (this.t[o].cell.conf.opened == true) {
            this.t[o].cell._close(a);
            this.conf.last_opened = null
        }
    };
    this._adjustOpened = function () {
        if (this.conf.multi_mode == true) {
            if (this._openCache == null) {
                var s = this._getDynData();
                for (var q in s) {
                    this.t[q].cell.conf.size.h = s[q];
                    this.t[q].cell.cell.style.height = s[q] + "px"
                }
            } else {
                var u = false;
                for (var q in this._openCache) {
                    u = (u || this._openCache[q])
                }
                if (u == true) {
                    return
                }
                this._openCache = this._openId = null
            }
            var o = this._getAvailItemWidth();
            for (var q in this.t) {
                var r = true;
                if (o == this.t[q].cell.conf.size.w && (this._openMode == "close" || this.t[q].cell.conf.opened == false)) {
                    r = false
                }
                if (r) {
                    this.t[q].cell._setWidth(o)
                }
            }
            this._openMode = null
        } else {
            if (this.conf.last_opened != null) {
                var v = this.conf.last_opened;
                this.t[v].cell._setSize(this.t[v].cell.conf.size.x, this.t[v].cell.conf.size.y, this.t[v].cell.conf.size.w, this.t[v].cell.conf.size.h)
            }
        }
    };
    this._getDynData = function (D, C) {
        if (typeof (D) == "undefined" || D == null) {
            D = {}
        }
        if (typeof (C) == "undefined" || C == null) {
            C = {}
        }
        var w = {};
        var A = 0;
        var v = 0;
        var s = 0;
        for (var o = 0; o < this.base.childNodes.length; o++) {
            var r = this.base.childNodes[o]._accId;
            var F = this.t[r].cell;
            if (F.conf.visible == true) {
                var x = this.ofs.m[s == 0 ? "first" : "between"];
                if (D[r] == true || C[r] == true || (F.conf.opened == true && F.conf.h_auto == true)) {
                    if (C[r] == true) {
                        var y = F._getHdrHeight();
                        w[r] = y;
                        v += y + x
                    } else {
                        if (F.conf.h_auto == true) {
                            w[r] = true;
                            v += x;
                            A++
                        } else {
                            if (D[r] == true) {
                                w[r] = F.conf.size.h;
                                v += F.conf.size.h + x
                            }
                        }
                    }
                } else {
                    v += F.cell.offsetHeight + x
                }
                s++
            }
            F = null
        }
        if (A > 0) {
            var u = this.base.offsetHeight - v;
            var v = Math.floor(u / A);
            for (var E in w) {
                if (w[E] == true) {
                    if (A > 1) {
                        u -= v
                    } else {
                        v = u
                    }
                    w[E] = v;
                    A--
                }
            }
        }
        return w
    };
    this._adjustBase = function () {
        if (this.conf.fs_mode) {
            this.base.style.width = document.body.offsetWidth - this.conf.fs_base_ofs.w * 2 + "px";
            this.base.style.height = document.body.offsetHeight - this.conf.fs_base_ofs.h * 2 + "px"
        }
    };
    this.setSizes = function () {
        this._adjustBase();
        if (this.conf.multi_mode == true) {
            this._adjustOpened()
        } else {
            this.conf.base_w = null;
            var q = this._updateCellsHeight();
            for (var o in this.t) {
                this.t[o].cell._setSize(this.ofs.s.left, 0, this.conf.base_w || this._getAvailItemWidth(), this.t[o].cell.conf.opened ? q : this.t[o].cell._getHdrHeight());
                if (!this.t[o].cell.conf.opened) {
                    this.t[o].cell.conf.size.h = q;
                    this.t[o].cell._adjustCell()
                }
            }
            this.conf.size_changed = true
        }
    };
    this.setSkin = function (q) {
        this.base.className = String(this.base.className).replace(new RegExp("\\s{1,}dhxacc_base_" + this.conf.skin + "\\s{0,}$"), " dhxacc_base_" + q);
        this.conf.skin = q;
        for (var o in this.t) {
            this.t[o].cell.conf.cells_cont = null;
            this.t[o].cell.conf.skin = this.conf.skin
        }
        this._applyOffsets();
        this._updateCellsMargin();
        this.setSizes()
    };
    this.setIconsPath = function (a) {
        this.conf.icons_path = a
    };
    this._getAvailItemWidth = function () {
        var o = this.ofs[(this.conf.multi_mode ? "m" : "s")];
        var a = Math.max(this.base.clientWidth - o.left - o.right, 10);
        this.conf.base_w = a;
        o = null;
        return a
    };
    this._updateCellsHeight = function () {
        if (this.conf.multi_mode == true) {
            return
        }
        var r = this.conf.total_count - this.conf.hiden_count;
        var s = this.base.offsetHeight - this.ofs.s.last;
        if (r == 0) {
            return s
        }
        var v = false;
        for (var u = 0; u < this.base.childNodes.length; u++) {
            if (v == false) {
                var w = this.base.childNodes[u]._accId;
                if (this.t[w].cell.conf.visible) {
                    s -= this.t[w].cell._getHdrHeight() * (r - 1);
                    v = true
                }
            }
        }
        s -= (r - 1) * this.ofs.s.between + this.ofs.s.first;
        for (var o in this.t) {
            if (this.t[o].cell.conf.size != null) {
                this.t[o].cell.conf.size.h = s;
                this.t[o].cell._adjustCell()
            }
        }
        return s
    };
    this._updateCellsMargin = function () {
        var a = 0;
        for (var o = 0; o < this.base.childNodes.length; o++) {
            var r = this.base.childNodes[o]._accId;
            if (this.t[r].cell.conf.visible) {
                this.t[r].cell.cell.style.marginTop = String(this.ofs[this.conf.multi_mode ? "m" : "s"][a++ == 0 ? "first" : "between"]) + "px"
            }
        }
    };
    this._hdrClick = function (o) {
        if (!this.conf.multi_mode && this.t[o].cell.conf.opened) {
            return
        }
        var a = this.t[o].cell.conf.opened;
        if (this.callEvent("onBeforeActive", [o, (a ? false : true)]) !== true) {
            return
        }
        this.conf.on_active_click = true;
        this[a ? "_closeItem" : "_openItem"](o);
        if (this.conf.multi_mode && this.conf.tr.prop == false) {
            this._adjustOpened()
        }
    };
    this.unload = function () {
        this.conf.unloading = true;
        for (var o in this.t) {
            this.removeItem(o)
        }
        this.t = null;
        if (typeof (this._unloadDND) == "function") {
            this._unloadDND()
        }
        if (this.conf.fs_mode) {
            if (this.conf.fs_tm) {
                window.clearTimeout(this.conf.fs_tm)
            }
            if (window.addEventListener) {
                window.removeEventListener("resize", this._doOnResizeStart, false)
            } else {
                window.detachEvent("onresize", this._doOnResizeStart)
            }
            this._doOnResizeStart = null;
            this._doOnResizeEnd = null;
            this.conf.fs_tm = null
        }
        if (this.dhxWins) {
            this.dhxWins.unload();
            this.dhxWins = null
        }
        window.dhx4._eventable(this, "clear");
        window.dhx4._enableDataLoading(this, null, null, null, "clear");
        this.base.className = String(this.base.className).replace(new RegExp("\\s{1,}dhxacc_base_" + this.conf.skin + "\\s{0,}$"), "");
        this.base = null;
        this.ofs = this.conf = null;
        for (var o in this) {
            this[o] = null
        }
        h = null
    };
    this.setOffset = function (a) {
        this.ofs.s.between = a;
        this.ofs.m.between = a;
        this._updateCellsMargin();
        this.setSizes()
    };
    this._initObj = function (o) {
        if (o.skin != null) {
            this.setSkin(o.skin)
        }
        if (window.dhx4.s2b(o.multi_mode)) {
            this.enableMultiMode()
        }
        if (o.icons_path != null) {
            this.setIconsPath(o.icons_path)
        }
        if (o.icon_path != null) {
            this.setIconsPath(o.icon_path)
        }
        if (o.items != null) {
            for (var a = 0; a < o.items.length; a++) {
                this.addItem(o.items[a].id, o.items[a].text, o.items[a].open, o.items[a].height, o.items[a].icon || o.items[a].img)
            }
        }
        if (window.dhx4.s2b(o.dnd) == true && typeof (this.enableDND) == "function") {
            this.enableDND()
        }
    };
    this._xmlToObj = function (u) {
        var r = {
            items: []
        };
        var a = u.getElementsByTagName("accordion")[0];
        if (a.getAttribute("skin") != null) {
            r.skin = a.getAttribute("skin")
        }
        if (a.getAttribute("mode") == "multi") {
            r.multi_mode = true
        }
        if (a.getAttribute("multiMode") != null) {
            r.multi_mode = window.dhx4.s2b(a.getAttribute("multiMode"))
        }
        if (a.getAttribute("iconsPath") != null) {
            r.icons_path = a.getAttribute("iconsPath")
        }
        for (var s = 0; s < a.childNodes.length; s++) {
            var v = a.childNodes[s];
            if (typeof (v.tagName) != "undefined" && String(v.tagName).toLowerCase() == "cell") {
                var o = {};
                if (v.getAttribute("id") != null) {
                    o.id = v.getAttribute("id")
                }
                if (v.getAttribute("icon") != null) {
                    o.icon = v.getAttribute("icon")
                }
                if (v.getAttribute("height") != null) {
                    o.height = v.getAttribute("height")
                }
                if (v.getAttribute("open") != null) {
                    o.open = window.dhx4.s2b(v.getAttribute("open"))
                }
                o.text = v.firstChild.nodeValue;
                r.items.push(o)
            }
            v = null
        }
        return r
    };
    window.dhx4._enableDataLoading(this, "_initObj", "_xmlToObj", "accordion", {
        struct: true
    });
    window.dhx4._eventable(this);
    this._callMainEvent = function (o, a) {
        return this.callEvent(o, a)
    };
    this.attachEvent("onActive", function (a) {
        if (this.t[a].cell.dataObj != null && this.t[a].cell.dataType == "editor") {
            this.t[a].cell.dataObj._prepareContent(true)
        }
        if (this.t[a].cell.conf.opened == true) {
            this.t[a].cell._adjustProgress()
        }
    });
    if (this.conf.fs_mode) {
        this._adjustBase();
        this.conf.fs_tm = null;
        this._doOnResizeStart = function () {
            if (h.conf.fs_tm) {
                window.clearTimeout(h.conf.fs_tm)
            }
            h.conf.fs_tm = window.setTimeout(h._doOnResizeEnd, 200)
        };
        this._doOnResizeEnd = function () {
            h.setSizes()
        };
        if (window.addEventListener) {
            window.addEventListener("resize", this._doOnResizeStart, false)
        } else {
            window.attachEvent("onresize", this._doOnResizeStart)
        }
    }
    if (typeof (window.dhtmlXWindows) == "function") {
        this.dhxWins = new dhtmlXWindows();
        this.dhxWins.setSkin(this.conf.skin)
    }
    if (l != null) {
        this._initObj(l);
        l = null
    }
    return this
}
function dhtmlXAccordionCell(h, g) {
    dhtmlXCellObject.apply(this, [h, "_acc"]);
    this.acc = g;
    this.conf.visible = true;
    this.conf.docked = true;
    this.attachEvent("_onCellUnload", function () {
        this._trDetachEv();
        this._unloadDocking();
        this.acc = null;
        this.cell._accObj = null;
        this.cell.childNodes[this.conf.idx.hdr].onselectstart = null;
        this.cell.childNodes[this.conf.idx.hdr].onclick = null;
        this._initHeader = null;
        this._getHdrHeight = null;
        this._setWidth = null;
        this._adjustCell = null;
        this._open = null;
        this._close = null;
        this._isOpened = null;
        this._trInitEv = null;
        this._trAttachEv = null;
        this._trDetachEv = null;
        this._trOnEnd = null;
        this._onActiveCall = null;
        this.setText = null;
        this.getText = null;
        this.setIcon = null;
        this.clearIcon = null;
        this.show = null;
        this.hide = null;
        this.isVisible = null;
        this.setHeight = null;
        this.moveOnTop = null
    });
    this.attachEvent("_onContentLoaded", function () {
        this.acc._callMainEvent("onContentLoaded", arguments)
    });
    this._initHeader();
    this.conf.tr = {};
    for (var c in this.acc.conf.tr) {
        this.conf.tr[c] = this.acc.conf.tr[c]
    }
    if (this.conf.tr.prop != false) {
        this.attachEvent("_onIdxUpdated", function () {
            this._cellSetOpacity((this.conf.opened ? "open" : "close"), false)
        })
    }
    this.open = function () {
        this.acc._openItem(this._idd)
    };
    this.close = function () {
        this.acc._closeItem(this._idd)
    };
    this._setWidth = function (a) {
        if (a != this.conf.size.w) {
            this.conf.size.w = a;
            this.cell.style.width = a + "px"
        }
        this._adjustCell()
    };
    this._adjustCell = function () {
        this._adjustCont();
        if (this.dataObj != null && typeof (this.dataObj.setSizes) == "function") {
            this.dataObj.setSizes()
        }
    };
    this._initDocking();
    return this
}
dhtmlXAccordionCell.prototype = new dhtmlXCellObject();
dhtmlXAccordionCell.prototype._initHeader = function () {
    var a = document.createElement("DIV");
    a.className = "dhx_cell_hdr";
    a.innerHTML = "<div class='dhx_cell_hdr_text'></div><div class='dhx_cell_hdr_arrow'></div>";
    this.cell.insertBefore(a, this.cell.childNodes[this.conf.idx.cont]);
    a = null;
    this.conf.ofs_nodes.t._getHdrHeight = "func";
    this.conf.hdr = {
        visible: true
    };
    this.conf.idx_data.hdr = "dhx_cell_hdr";
    this._updateIdx()
};
dhtmlXAccordionCell.prototype._getHdrHeight = function () {
    return this.cell.childNodes[this.conf.idx.hdr].offsetHeight
};
dhtmlXAccordionCell.prototype.setText = function (a) {
    this.conf.text = a;
    this.cell.childNodes[this.conf.idx.hdr].firstChild.innerHTML = "<span>" + a + "</span>"
};
dhtmlXAccordionCell.prototype.getText = function () {
    return this.conf.text
};
dhtmlXAccordionCell.prototype.setIcon = function (g) {
    var c = this.cell.childNodes[this.conf.idx.hdr];
    if (c.firstChild.className != "dhx_cell_hdr_icon") {
        c.firstChild.className += " dhx_cell_hdr_icon";
        var a = document.createElement("IMG");
        a.className = "dhx_cell_hdr_icon";
        c.insertBefore(a, c.firstChild);
        a = null
    }
    c.firstChild.src = this.acc.conf.icons_path + g;
    c = null
};
dhtmlXAccordionCell.prototype.clearIcon = function () {
    var a = this.cell.childNodes[this.conf.idx.hdr];
    if (a.firstChild.className == "dhx_cell_hdr_icon") {
        a.removeChild(a.firstChild);
        a.firstChild.className = String(a.firstChild.className).replace(/\s{1,}dhx_cell_hdr_icon/gi, "")
    }
    a = null
};
dhtmlXAccordionCell.prototype._open = function (c) {
    var j = {};
    if (this.acc.conf.multi_mode) {
        var h = {};
        h[this._idd] = true;
        j = this.acc._getDynData(h);
        this.acc._openId = this._idd;
        this.acc._openCache = {};
        this.acc._openMode = "open"
    } else {
        j[this._idd] = this.conf.size.h
    }
    for (var g in j) {
        if (this.acc._openCache != null) {
            this.acc._openCache[g] = true
        }
        var l = this.acc.t[g].cell;
        l.cell.className = String(l.cell.className).replace(/\s{1,}dhx_cell_closed/gi, "");
        l.conf.opened = true;
        l._trInitEv("open", c);
        l.conf.size.h = j[g];
        l.cell.style.height = l.conf.size.h + "px";
        l = null
    }
    if (this.conf.tr.prop == false) {
        this.acc._openId = this.acc._openCache = this.acc._openMode = null;
        this._onActiveCall(true)
    }
};
dhtmlXAccordionCell.prototype._close = function (c) {
    var h = {};
    if (this.acc.conf.multi_mode) {
        var j = {};
        j[this._idd] = true;
        h = this.acc._getDynData(null, j);
        this.acc._openId = this._idd;
        this.acc._openCache = {};
        this.acc._openMode = "close"
    } else {
        h[this._idd] = this._getHdrHeight()
    }
    for (var g in h) {
        var l = this.acc.t[g].cell;
        if (this.acc._openCache != null) {
            this.acc._openCache[g] = true
        }
        if (g == this._idd) {
            l.cell.className += " dhx_cell_closed";
            l.conf.opened = false;
            l._trInitEv("close", c)
        } else {
            l.conf.size.h = h[g];
            l._adjustCell();
            l._trInitEv("open", c)
        }
        l.cell.style.height = h[g] + "px";
        l = null
    }
    if (this.conf.tr.prop == false) {
        this.acc._openId = this.acc._openCache = this.acc._openMode = null;
        this._onActiveCall(false)
    }
};
dhtmlXAccordionCell.prototype.isOpened = function () {
    return (this.conf.opened == true)
};
dhtmlXAccordionCell.prototype._trInitEv = function (c, a) {
    if (this.conf.tr.prop == false) {
        return
    }
    this._trAttachEv();
    if (!this.cell._accObj) {
        this.cell._accObj = this.acc
    }
    if (a) {
        this.cell.style[this.conf.tr.prop] = this.conf.tr["height_" + c]
    }
    this._cellSetOpacity(c, a)
};
dhtmlXAccordionCell.prototype._trAttachEv = function () {
    if (!this.conf.tr.ev_attached) {
        this.cell._trProp = this.conf.tr.prop;
        this.cell.addEventListener(this.conf.tr.ev, this._trOnEnd, false);
        this.conf.tr.ev_attached = true
    }
};
dhtmlXAccordionCell.prototype._trDetachEv = function () {
    if (this.conf.tr.ev_attached) {
        this.cell.addEventListener(this.conf.tr.ev, this._trOnEnd, false);
        this.conf.tr.ev_attached = false
    }
};
dhtmlXAccordionCell.prototype._trOnEnd = function (a) {
    if (a.stopPropagation) {
        a.stopPropagation()
    }
    if (a.propertyName == "height") {
        this.style[this._trProp] = "";
        if (this._accObj.conf.multi_mode) {
            if (this._accObj._openCache != null) {
                this._accObj._openCache[this._accId] = false
            }
            this._accObj._adjustOpened()
        }
        if (this._accObj.conf.on_active_click == true) {
            if (this._accObj.conf.multi_mode) {
                this._accObj._callMainEvent("onActive", [this._accId, this._accObj.t[this._accId].cell.conf.opened]);
                this._accObj.conf.on_active_click = false
            } else {
                this._accObj._callMainEvent("onActive", [this._accObj.conf.on_active_id, true]);
                this._accObj.conf.on_active_id = null;
                this._accObj.conf.on_active_click = false
            }
        }
        this._accObj = null
    }
};
dhtmlXAccordionCell.prototype._cellSetOpacity = function (h, c) {
    for (var g in this.conf.idx) {
        if ({
            hdr: true,
            pr1: true,
            pr2: true
        }[g] != true) {
            if (c) {
                this.cell.childNodes[this.conf.idx[g]].style[this.conf.tr.prop] = this.conf.tr["op_" + h]
            }
            this.cell.childNodes[this.conf.idx[g]].style.opacity = this.conf.tr["op_v_" + h]
        }
    }
};
dhtmlXAccordionCell.prototype._onActiveCall = function (a) {
    if (this.acc.conf.on_active_click == false) {
        return
    }
    if (this.acc.conf.multi_mode == true) {
        this.acc._callMainEvent("onActive", [this._idd, this.conf.opened]);
        this.acc.conf.on_active_click = false
    } else {
        if (a == true) {
            this.acc._callMainEvent("onActive", [this._idd, true]);
            this.acc.conf.on_active_click = false
        }
    }
};
dhtmlXAccordionCell.prototype.show = function () {
    if (this.conf.visible) {
        return
    }
    if (this.conf.docked == false) {
        this.dock();
        return
    }
    this.cell.style.display = "";
    this.conf.visible = true;
    if (!this.acc.conf.multi_mode) {
        this.acc.conf.hiden_count--;
        this.acc._updateCellsHeight();
        this.acc._updateCellsMargin()
    }
    if (this.acc.conf.size_changed) {
        this.acc.setSizes();
        this.acc.conf.size_changed = false
    } else {
        this.acc._adjustOpened()
    }
};
dhtmlXAccordionCell.prototype.hide = function () {
    if (!this.conf.visible) {
        return
    }
    if (!this.acc.conf.multi_mode && this.conf.opened) {
        this._close(false);
        this.acc.conf.last_opened = null
    }
    this.cell.style.display = "none";
    this.conf.visible = false;
    if (!this.acc.conf.multi_mode) {
        this.acc.conf.hiden_count++;
        this.acc._updateCellsHeight();
        this.acc._updateCellsMargin()
    }
    this.acc._adjustOpened()
};
dhtmlXAccordionCell.prototype.isVisible = function () {
    return (this.conf.visible == true)
};
dhtmlXAccordionCell.prototype.setHeight = function (a) {
    if (!this.acc.conf.multi_mode) {
        return
    }
    if (a == "*") {
        this.conf.h_auto = true
    } else {
        this.conf.h_auto = false;
        this.conf.size.h = a
    }
    if (this.conf.opened) {
        if (a != "*") {
            this.cell.style.height = a + "px"
        }
        this.acc._adjustOpened()
    }
};
dhtmlXAccordionCell.prototype.moveOnTop = function () {
    if (this.cell.parentNode.firstChild == this.cell) {
        return
    }
    this.cell.parentNode.insertBefore(this.cell, this.cell.parentNode.firstChild);
    this.acc._updateCellsMargin()
};
dhtmlXAccordionCell.prototype._initDocking = function () {
    var a = this;
    this.dock = function () {
        if (this.acc.dhxWins == null || this.conf.docked == true) {
            return
        }
        var c = this.acc.dhxWins.window(this._idd);
        c.close();
        this._attachFromCell(c);
        this.conf.docked = true;
        this.show();
        if (this.conf.dock_opened) {
            this.open()
        }
        c = null;
        this.acc._callMainEvent("onDock", [this._idd])
    };
    this.undock = function (c, m, j, l) {
        if (this.acc.dhxWins == null || this.conf.docked == false) {
            return
        }
        this.conf.dock_opened = this.conf.opened;
        if (this.acc.dhxWins.window(this._idd) != null) {
            var g = this.acc.dhxWins.window(this._idd);
            g.show()
        } else {
            if (c == null) {
                c = 20
            }
            if (m == null) {
                m = 20
            }
            if (j == null) {
                j = 320
            }
            if (l == null) {
                l = 200
            }
            var g = this.acc.dhxWins.createWindow(this._idd, c, m, j, l);
            g.button("close").hide();
            g.addUserButton("dock", 99, "Dock");
            g.button("dock").show();
            g.button("dock").attachEvent("onClick", this._doOnDockClick);
            g.setText(this.getText());
            g.attachEvent("onClose", this._doOnDockWinClose)
        }
        this.conf.docked = false;
        this.hide();
        g._attachFromCell(this);
        g = null;
        this.acc._callMainEvent("onUnDock", [this._idd])
    };
    this._doOnDockClick = function () {
        a.dock()
    };
    this._doOnDockWinClose = function (c) {
        c.hide();
        return false
    };
    this._unloadDocking = function () {
        a = null
    }
};
dhtmlXAccordion.prototype.enableDND = function () {
    if (this.conf.multi_mode == false || this._dnd != null) {
        return
    }
    var g = this;
    this._dnd = {
        tr_count: 0,
        tr_items: {}
    };
    this._dndAttachEvent = function (h) {
        var a = this.t[h].cell;
        if (a.conf.dnd_inited != true) {
            if (typeof (window.addEventListener) == "function") {
                a.cell.childNodes[a.conf.idx.hdr].addEventListener("mousedown", this._dndOnMouseDown, false)
            } else {
                a.cell.childNodes[a.conf.idx.hdr].attachEvent("onmousedown", this._dndOnMouseDown)
            }
            a.conf.dnd_inited = true
        }
        a = null
    };
    this._dndDetachEvent = function (h) {
        var a = this.t[h].cell;
        if (a.conf.dnd_inited == true) {
            if (typeof (window.addEventListener) == "function") {
                a.cell.childNodes[a.conf.idx.hdr].removeEventListener("mousedown", this._dndOnMouseDown, false)
            } else {
                a.cell.childNodes[a.conf.idx.hdr].detachEvent("onmousedown", this._dndOnMouseDown)
            }
            a.conf.dnd_inited = false
        }
        a = null
    };
    this._dndOnMouseDown = function (h) {
        h = h || event;
        if (h.preventDefault) {
            h.preventDefault()
        }
        var a = (h.target || h.srcElement);
        while (a != null && a.parentNode != g.base) {
            a = a.parentNode
        }
        if (a != null) {
            g._dndDragStart(h, a)
        }
        a = null
    };
    this._dndDragStart = function (l, h) {
        if (this._dnd.tr_waiting == true) {
            return
        }
        this._dnd.dragObj = h;
        this._dnd.dy = l.clientY;
        var a = 0;
        for (var j = 0; j < this._dnd.dragObj.parentNode.childNodes.length; j++) {
            this._dnd.dragObj.parentNode.childNodes[j]._ind = j;
            if (this._dnd.dragObj.parentNode.childNodes[j] == this._dnd.dragObj) {
                this._dnd.dragObj._k0 = a;
                if (j > 0) {
                    this._dnd.dragObj._k0 += this.ofs.m.between - this.ofs.m.first
                }
                a = 0
            } else {
                a += this._dnd.dragObj.parentNode.childNodes[j].offsetHeight + parseInt(this._dnd.dragObj.parentNode.childNodes[j].style.marginTop)
            }
        }
        this._dnd.dragObj._k1 = a;
        this._dnd.h = this._dnd.dragObj.offsetHeight;
        this._dnd.ofs = false
    };
    this._dndDoDrag = function (u) {
        if (!this._dnd.dragObj) {
            return
        }
        if (this._dnd.tr_waiting == true) {
            return
        }
        var m = u.clientY - this._dnd.dy;
        if (this._dnd.ofs == false && Math.abs(m) > 5) {
            this._dnd.dragObj.className += " acc_cell_dragged";
            this._dnd.ofs = true
        }
        if (m < 0) {
            if (m < -this._dnd.dragObj._k0) {
                m = -this._dnd.dragObj._k0
            }
        } else {
            if (m > this._dnd.dragObj._k1) {
                m = this._dnd.dragObj._k1
            }
        }
        this._dnd.dragObj.style.top = m + "px";
        var o = u.clientY - this._dnd.dy;
        var l = 0;
        var h = 0;
        for (var n = this._dnd.dragObj._ind + 1; n <= this._dnd.dragObj.parentNode.lastChild._ind; n++) {
            var a = this._dnd.dragObj.parentNode.childNodes[n].offsetHeight;
            if (o > l + a * 2 / 3) {
                h++
            }
            l += a
        }
        var j = this._dnd.dragObj.nextSibling;
        var n = 0;
        while (j != null) {
            if (++n <= h && j != null) {
                if (!j._ontop) {
                    if (j._tm) {
                        window.clearTimeout(j._tm)
                    }
                    this._dndAnim(j, false, parseInt(j.style.top || 0), -this._dnd.h - this.ofs.m.between);
                    j._ontop = true
                }
            } else {
                if (j._ontop) {
                    if (j._tm) {
                        window.clearTimeout(j._tm)
                    }
                    this._dndAnim(j, true, parseInt(j.style.top || 0), 0);
                    j._ontop = false
                }
            }
            j = j.nextSibling
        }
        var o = this._dnd.dy - u.clientY;
        var l = 0;
        var h = 0;
        for (var n = this._dnd.dragObj._ind - 1; n >= this._dnd.dragObj.parentNode.firstChild._ind; n--) {
            var a = this._dnd.dragObj.parentNode.childNodes[n].offsetHeight;
            if (o > l + a * 2 / 3) {
                h++
            }
            l += a
        }
        var j = this._dnd.dragObj.previousSibling;
        var n = 0;
        while (j != null) {
            if (++n <= h && j != null) {
                if (!j._onbottom) {
                    if (j._tm) {
                        window.clearTimeout(j._tm)
                    }
                    this._dndAnim(j, true, parseInt(j.style.top || 0), this._dnd.h + this.ofs.m.between);
                    j._onbottom = true
                }
            } else {
                if (j._onbottom) {
                    if (j._tm) {
                        window.clearTimeout(j._tm)
                    }
                    this._dndAnim(j, false, parseInt(j.style.top), 0);
                    j._onbottom = false
                }
            }
            j = j.previousSibling
        }
    };
    this._dndDragStop = function (o, m) {
        if (m) {} else {
            if (this._dnd.tr_count > 0) {
                this._dnd.tr_waiting = true;
                return
            }
        }
        if (!this._dnd.dragObj) {
            return
        }
        this._dnd.dragObj.className = String(this._dnd.dragObj.className).replace(/\s{0,}acc_cell_dragged/gi, "");
        this._dnd.dragObj.style.top = "0px";
        var n = false;
        for (var l = 0; l < this._dnd.dragObj.parentNode.childNodes.length; l++) {
            var j = this._dnd.dragObj.parentNode.childNodes[l];
            if (j != this._dnd.dragObj) {
                if (j._tm) {
                    window.clearTimeout(j._tm)
                }
                j.style.top = "0px";
                if (j._ontop && ((j.nextSibling != null && j.nextSibling._ontop != true) || !j.nextSibling)) {
                    n = (j.nextSibling || null)
                }
                if (j._onbottom && ((j.previousSibling != null && j.previousSibling._onbottom != true) || !j.previousSibling)) {
                    n = j
                }
            }
            j = null
        }
        for (var l = 0; l < this._dnd.dragObj.parentNode.childNodes.length; l++) {
            this._dnd.dragObj.parentNode.childNodes[l]._ontop = null;
            this._dnd.dragObj.parentNode.childNodes[l]._onbottom = null
        }
        if (n !== false) {
            if (n == null) {
                this._dnd.dragObj.parentNode.appendChild(this._dnd.dragObj)
            } else {
                this._dnd.dragObj.parentNode.insertBefore(this._dnd.dragObj, n)
            }
        }
        var r = this._dnd.dragObj._accId;
        var h = this._dnd.dragObj._ind;
        var a = h;
        for (var l = 0; l < this._dnd.dragObj.parentNode.childNodes.length; l++) {
            if (this._dnd.dragObj.parentNode.childNodes[l] == this._dnd.dragObj) {
                a = l
            }
        }
        this._dnd.dragObj = null;
        this._dnd.tr_waiting = false;
        this._updateCellsMargin();
        if (h != a) {
            this.setSizes();
            this.callEvent("onDrop", [r, h, a])
        }
    };
    this._dndAnim = function (m, a, l, j) {
        if (this.conf.tr.prop != false) {
            if (!m._dnd_ev) {
                m._dnd_ev = true;
                m._dnd_tr_prop = this.conf.tr.prop;
                m.addEventListener(this.conf.tr.ev, this._dndOnTrEnd, false)
            }
            if (this._dnd.tr_items[m._accId] != true) {
                this._dnd.tr_items[m._accId] = true;
                this._dnd.tr_count++
            }
            m.style[this.conf.tr.prop] = this.conf.tr.dnd_top;
            m.style.top = j + "px";
            return
        }
        var h = false;
        if (a) {
            l += 5;
            if (l >= j) {
                l = j;
                h = true
            }
        } else {
            l -= 5;
            if (l <= j) {
                l = j;
                h = true
            }
        }
        m.style.top = l + "px";
        if (m._tm) {
            window.clearTimeout(m._tm)
        }
        if (!h) {
            m._tm = window.setTimeout(function () {
                g._dndAnim(m, a, l, j)
            }, 5)
        } else {
            m._tm = null
        }
    };
    this._dndOnTrEnd = function (a) {
        if (a.stopPropagation) {
            a.stopPropagation()
        }
        if (a.propertyName == "top") {
            if (g._dnd.tr_items[this._accId] == true) {
                g._dnd.tr_count--;
                g._dnd.tr_items[this._accId] = false
            }
            this.style[this._dnd_tr_prop] = "";
            if (g._dnd.tr_count == 0 && g._dnd.tr_waiting == true) {
                g._dndDragStop(null, true)
            }
        }
    };
    this._dndOnMouseMove = function (a) {
        g._dndDoDrag(a || event)
    };
    this._dndOnMouseUp = function (a) {
        g._dndDragStop(a || event)
    };
    if (window.addEventListener) {
        document.body.addEventListener("mousemove", this._dndOnMouseMove, false);
        document.body.addEventListener("mouseup", this._dndOnMouseUp, false)
    } else {
        document.body.attachEvent("onmousemove", this._dndOnMouseMove, false);
        document.body.attachEvent("onmouseup", this._dndOnMouseUp, false)
    }
    this._dndClearCell = function (a) {
        if (this.t[a].cell.cell._dnd_ev) {
            this.t[a].cell.cell.addEventListener(this.conf.tr.ev, this._dndOnTrEnd, false)
        }
        this._dndDetachEvent(a)
    };
    this._unloadDND = function () {
        if (typeof (window.addEventListener) == "function") {
            document.body.removeEventListener("mousemove", this._dndOnMouseMove, false);
            document.body.removeEventListener("mouseup", this._dndOnMouseUp, false)
        } else {
            document.body.detachEvent("onmousemove", this._dndOnMouseMove, false);
            document.body.detachEvent("onmouseup", this._dndOnMouseUp, false)
        }
        for (var h in this) {
            if (String(h).indexOf("_dnd") == 0 && typeof (this[h]) == "function") {
                this[h] = null
            }
        }
        this._dnd = null;
        g = null
    };
    for (var c in this.t) {
        this._dndAttachEvent(c)
    }
};

function dhtmlXLayoutObject(g, o, w) {
    var u = null;
    if (g != null && typeof (g) == "object" && typeof (g.tagName) == "undefined" && g._isCell != true) {
        u = {};
        if (g.autosize != null) {
            u.autosize = g.autosize
        }
        if (g.cells != null) {
            u.cells = g.cells
        }
        if (g.pattern != null) {
            o = g.pattern
        }
        if (g.skin != null) {
            w = g.skin
        }
        if (g.offsets != null) {
            u.offsets = g.offsets
        }
        g = g.parent
    }
    if (g == document.body) {
        this.base = g
    } else {
        if (typeof (g) == "string") {
            this.base = document.getElementById(g)
        } else {
            if (g._isCell == true) {
                var n = (typeof (u) != "undefined" && u != null ? u : {});
                if (n.pattern == null && o != null) {
                    n.pattern = o
                }
                if (n.skin == null && w != null) {
                    n.skin = w
                }
                var l = g.attachLayout(n);
                return l
            }
            this.base = g
        }
    }
    if (this.base != document.body) {
        while (this.base.childNodes.length > 0) {
            this.base.removeChild(this.base.lastChild)
        }
    }
    this.cdata = {};
    this.conf = {
        skin: (w || window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxlayout") || "dhx_skyblue"),
        hh: 20,
        progress: false,
        autosize: "b",
        nextCell: {
            a: "b",
            b: "a"
        },
        ofs: {
            t: 0,
            b: 0,
            l: 0,
            r: 0
        },
        ofs_nodes: {
            t: {},
            b: {}
        },
        inited: false,
        b_size: {
            w: -1,
            h: -1
        }
    };
    this.conf.sw = this._detectSW();
    if (true || this.base._isParentCell !== true) {
        this.base.className += " dhxlayout_base_" + this.conf.skin
    }
    if (this.base == document.body) {
        var h = {
            dhx_skyblue: {
                t: 2,
                b: 2,
                l: 2,
                r: 2
            },
            dhx_web: {
                t: 8,
                b: 8,
                l: 8,
                r: 8
            },
            dhx_terrace: {
                t: 9,
                b: 9,
                l: 8,
                r: 8
            }
        };
        this.conf.ofs = (h[this.conf.skin] != null ? h[this.conf.skin] : h.dhx_skyblue)
    }
    if (u != null && u.offsets != null) {
        this.setOffsets(u.offsets)
    } else {
        if (this.base._ofs != null) {
            this.setOffsets(this.base._ofs);
            this.base._ofs = null;
            delete this.base._ofs
        }
    }
    this.dataNodes = {};
    var m = this;
    this._getLayout = function () {
        return this
    };
    this.mainInst = (g._layoutMainInst != null ? g._layoutMainInst : null);
    this._getMainInst = function () {
        if (this.mainInst != null) {
            return this.mainInst._getMainInst()
        }
        return this
    };
    this._init = function (A) {
        var y = (typeof (A) == "string" ? this.tplData[A] : A);
        this.conf.mode = y.mode;
        if (this.conf.mode == "c") {
            this.cdata.a = new dhtmlXLayoutCell("a", this)
        } else {
            this.cdata.a = new dhtmlXLayoutCell("a", this);
            this.cdata.b = new dhtmlXLayoutCell("b", this)
        }
        for (var x in this.cdata) {
            this.base.appendChild(this.cdata[x].cell);
            this.cdata[x].conf.init = {
                w: 0.5,
                h: 0.5
            }
        }
        if (this.conf.mode != "c") {
            var q = this._getMainInst();
            if (q.conf.sep_idx == null) {
                q.conf.sep_idx = 1
            } else {
                q.conf.sep_idx++
            }
            this.sep = new dhtmlXLayoutSepObject(this.conf.mode, q.conf.sep_idx);
            this.base.appendChild(this.sep.sep);
            this.sep._getLayout = function () {
                return m._getLayout()
            };
            q = null
        }
        if (y.cells != null) {
            for (var x in y.cells) {
                if (y.cells[x].width != null) {
                    this.cdata[x].conf.init.w = y.cells[x].width
                }
                if (y.cells[x].height != null) {
                    this.cdata[x].conf.init.h = y.cells[x].height
                }
                if (y.cells[x].name != null) {
                    this.cdata[x].conf.name = y.cells[x].name;
                    this.cdata[x].setText(y.cells[x].name)
                }
                if (y.cells[x].fsize != null) {
                    this.cdata[x].conf.fsize = y.cells[x].fsize
                }
            }
        }
        this.setSizes();
        for (var x in this.cdata) {
            this.cdata[x].conf.init = {}
        }
        if (y.cells != null) {
            for (var x in y.cells) {
                if (y.cells[x].layout != null) {
                    this.cdata[x].dataNested = true;
                    this.cdata[x]._layoutMainInst = this;
                    this.cdata[x].attachLayout({
                        pattern: y.cells[x].layout
                    });
                    this.cdata[x]._layoutMainInst = null
                }
            }
        }
    };
    this.setSizes = function (N, C, M, E) {
        var q = (this.conf.inited == true && this._getMainInst() == this && this.checkEvent("onResizeFinish") == true ? {} : false);
        var S = this.conf.ofs.t;
        for (var U in this.conf.ofs_nodes.t) {
            S += (this.conf.ofs_nodes.t[U] == true ? this.dataNodes[U].offsetHeight : 0)
        }
        var A = this.conf.ofs.b;
        for (var U in this.conf.ofs_nodes.b) {
            A += (this.conf.ofs_nodes.b[U] == true ? this.dataNodes[U].offsetHeight : 0)
        }
        var K = this.conf.ofs.l;
        var J = this.conf.ofs.r;
        var x = this.base.offsetWidth;
        var D = this.base.offsetHeight;
        if (this.conf.mode == "c") {
            var H = J;
            var F = S;
            var I = x - K - J;
            var Q = D - S - A;
            this.cdata.a._setSize(H, F, I, Q, N, M, E);
            this.callEvent("_onSetSizes", []);
            if (q && (!(this.conf.b_size.w == x && this.conf.b_size.h == D))) {
                this._callMainEvent("onResizeFinish", [])
            }
            this.conf.b_size = {
                w: x,
                h: D
            };
            return
        }
        if (typeof (C) == "undefined") {
            var L = (this.conf.mode == "v" ? "w" : "h");
            C = this.conf.autosize;
            if (this.cdata.a.conf.collapsed) {
                C = "b"
            } else {
                if (this.cdata.b.conf.collapsed) {
                    C = "a"
                } else {
                    if (N == "a" || N == "b") {
                        C = this.conf.nextCell[N]
                    }
                }
            }
        } else {} if (this.conf.mode == "v") {
            if (C == "a") {
                if (this.cdata.b.conf.init.w != null) {
                    var T = Math.round(x * this.cdata.b.conf.init.w - this.conf.sw / 2) - J
                } else {
                    var T = this.cdata.b.conf.size.w
                }
                var P = x - T - J;
                var O = S;
                var y = D - S - A;
                var H = K;
                var F = O;
                var I = P - H - this.conf.sw;
                var Q = y
            } else {
                var H = K;
                var F = S;
                if (this.cdata.a.conf.init.w != null) {
                    var I = Math.round(x * this.cdata.a.conf.init.w - this.conf.sw / 2) - H
                } else {
                    var I = this.cdata.a.conf.size.w
                }
                var Q = D - F - A;
                var P = H + I + this.conf.sw;
                var O = F;
                var T = x - P - J;
                var y = Q
            }
            this.cdata.a._setSize(H, F, I, Q, N, M, E);
            this.cdata.b._setSize(P, O, T, y, N, M, E);
            this.sep._setSize(H + I, F, this.conf.sw, Q)
        } else {
            if (C == "a") {
                if (this.cdata.b.conf.init.h != null) {
                    var y = Math.round((D - S) * this.cdata.b.conf.init.h - this.conf.sw / 2)
                } else {
                    var y = this.cdata.b.conf.size.h
                }
                var P = K;
                var O = D - A - y;
                var T = x - P - J;
                var H = P;
                var F = S;
                var I = T;
                var Q = O - F - this.conf.sw
            } else {
                var H = K;
                var F = S;
                var I = x - H - J;
                if (this.cdata.a.conf.init.h != null) {
                    var Q = Math.round((D - S) * this.cdata.a.conf.init.h - this.conf.sw / 2)
                } else {
                    var Q = this.cdata.a.conf.size.h
                }
                var P = H;
                var O = F + Q + this.conf.sw;
                var T = I;
                var y = D - O - A
            }
            this.cdata.a._setSize(H, F, I, Q, N, M, E);
            this.cdata.b._setSize(P, O, T, y, N, M, E);
            this.sep._setSize(H, F + Q, I, this.conf.sw)
        }
        this.callEvent("_onSetSizes", []);
        if (q && (!(this.conf.b_size.w == x && this.conf.b_size.h == D))) {
            this._callMainEvent("onResizeFinish", [])
        }
        this.conf.b_size = {
            w: x,
            h: D
        }
    };
    this._getAvailWidth = function () {
        var A = [];
        for (var E = 0; E < this.conf.as_cells.h.length; E++) {
            var x = this.cells(this.conf.as_cells.h[E]);
            var C = x.layout;
            var y = C.conf.autosize;
            if (x.conf.collapsed) {
                x = C.cdata[C.conf.nextCell[x._idd]];
                y = C.conf.nextCell[y]
            }
            A.push(Math.max(0, x.getWidth() - x._getMinWidth(y)));
            C = x = null
        }
        var D = (A.length > 0 ? Math.min.apply(window, A) : 0);
        return this.base.offsetWidth - D
    };
    this._getAvailHeight = function () {
        var C = [];
        for (var E = 0; E < this.conf.as_cells.v.length; E++) {
            var x = this.cells(this.conf.as_cells.v[E]);
            var A = x.layout;
            var y = A.conf.autosize;
            if (x.conf.collapsed) {
                x = A.cdata[A.conf.nextCell[x._idd]];
                y = A.conf.nextCell[y]
            }
            C.push(Math.max(0, x.getHeight() - x._getHdrHeight() - x._getMinHeight(y)));
            A = x = null
        }
        var D = Math.min.apply(window, C);
        return this.base.offsetHeight - D
    };
    this.setSkin = function (a) {
        this.base.className = this.base.className.replace(new RegExp("dhxlayout_dhx_" + this.conf.skin, "gi"), "dhxlayout_dhx_" + a);
        this.conf.skin = a
    };
    this.unload = function () {
        this.conf.unloading = true;
        this.mainInst = null;
        this.parentLayout = null;
        this._mtbUnload();
        this.detachHeader();
        this.detachFooter();
        window.dhx4._eventable(this, "clear");
        var y = new RegExp("s{0,}dhxlayout_base_" + this.conf.skin, "gi");
        this.base.className = this.base.className.replace(y, "");
        if (this.items != null) {
            for (var A = 0; A < this.items.length; A++) {
                this.items[A] = null
            }
            this.items = null
        }
        if (this.conf.fs_mode == true) {
            if (window.addEventListener) {
                window.removeEventListener("resize", this._doOnResizeStart, false)
            } else {
                window.detachEvent("onresize", this._doOnResizeStart)
            }
        }
        if (this.dhxWins != null) {
            this.dhxWins.unload();
            this.dhxWins = null
        }
        if (this.sep != null) {
            this.sep._unload();
            this.sep = null
        }
        for (var x in this.cdata) {
            this.cdata[x]._unload()
        }
        this.base = null;
        for (var x in this) {
            this[x] = null
        }
        m = null
    };
    this._getWindowMinDimension = function (y) {
        var a = m._getAvailWidth() + 7 + 7;
        var x = m._getAvailHeight() + 7 + 31;
        var q = {
            w: Math.max(a, 200),
            h: Math.max(x, 140)
        };
        y = null;
        return q
    };
    if (this.base == document.body) {
        this.conf.fs_mode = true;
        this._tmTime = null;
        this._doOnResizeStart = function () {
            window.clearTimeout(m._tmTime);
            m._tmTime = window.setTimeout(m._doOnResizeEnd, 200)
        };
        this._doOnResizeEnd = function () {
            m.setSizes()
        };
        if (window.addEventListener) {
            window.addEventListener("resize", this._doOnResizeStart, false)
        } else {
            window.attachEvent("onresize", this._doOnResizeStart)
        }
    }
    window.dhx4._eventable(this);
    this._callMainEvent = function (q, a) {
        return this.callEvent(q, a)
    };
    this._init(o || "3E");
    var r = this._availAutoSize[o];
    if (r != null) {
        this.conf.pattern = o;
        this.setAutoSize(r.h[r.h.length - 1], r.v[r.v.length - 1])
    }
    if (typeof (window.dhtmlXWindows) == "function") {
        this.dhxWins = new dhtmlXWindows();
        this.dhxWins.setSkin(this.conf.skin)
    }
    this.conf.inited = true;
    if (this == this._getMainInst()) {
        var s = 0;
        this.items = [];
        this.forEachItem(function (a) {
            m.items.push(a);
            a.conf.index = s++
        })
    }
    if (this == this._getMainInst() && u != null) {
        if (u.autosize != null) {
            this.setAutoSize.apply(this, u.autosize)
        }
        if (u.cells != null) {
            for (var c = 0; c < u.cells.length; c++) {
                var j = u.cells[c];
                var v = this.cells(j.id);
                if (j.width) {
                    v.setWidth(j.width)
                }
                if (j.height) {
                    v.setHeight(j.height)
                }
                if (j.text) {
                    v.setText(j.text)
                }
                if (j.collapsed_text) {
                    v.setCollapsedText(j.collapsed_text)
                }
                if (j.collapse) {
                    v.collapse()
                }
                if (j.fix_size) {
                    v.fixSize(j.fix_size[0], j.fix_size[1])
                }
                if (typeof (j.header) != "undefined" && window.dhx4.s2b(j.header) == false) {
                    v.hideHeader()
                }
            }
        }
    }
    u = null;
    return this
}
dhtmlXLayoutObject.prototype.cells = function (h) {
    for (var c in this.cdata) {
        if (this.cdata[c].conf.name == h) {
            return this.cdata[c]
        }
        if (this.cdata[c].dataType == "layout" && this.cdata[c].dataNested == true && this.cdata[c].dataObj != null) {
            var g = this.cdata[c].dataObj.cells(h);
            if (g != null) {
                return g
            }
        }
    }
    return null
};
dhtmlXLayoutObject.prototype.forEachItem = function (h, g) {
    if (typeof (h) != "function") {
        return
    }
    if (typeof (g) == "undefined") {
        g = this
    }
    for (var c in this.cdata) {
        if (typeof (this.cdata[c].conf.name) != "undefined") {
            h.apply(g, [this.cdata[c]])
        }
        if (this.cdata[c].dataType == "layout" && this.cdata[c].dataNested == true && this.cdata[c].dataObj != null) {
            this.cdata[c].dataObj.forEachItem(h, g)
        }
    }
    g = null
};
dhtmlXLayoutObject.prototype._forEachSep = function (h, g) {
    if (typeof (h) != "function") {
        return
    }
    if (typeof (g) == "undefined") {
        g = this
    }
    if (this.sep != null) {
        h.apply(g, [this.sep])
    }
    for (var c in this.cdata) {
        if (this.cdata[c].dataType == "layout" && this.cdata[c].dataNested == true && this.cdata[c].dataObj != null) {
            this.cdata[c].dataObj._forEachSep(h, g)
        }
    }
    g = null
};
dhtmlXLayoutObject.prototype.setOffsets = function (j) {
    var h = false;
    for (var c in j) {
        var g = c.charAt(0);
        if (typeof (this.conf.ofs[g]) != "undefined" && !isNaN(j[c])) {
            this.conf.ofs[g] = parseInt(j[c]);
            h = true
        }
    }
    if (typeof (this.setSizes) == "function" && h == true) {
        this.setSizes()
    }
};
dhtmlXLayoutObject.prototype._detectSW = function () {
    if (dhtmlXLayoutObject.prototype._confGlob.sw == null) {
        dhtmlXLayoutObject.prototype._confGlob.sw = {}
    }
    if (dhtmlXLayoutObject.prototype._confGlob.sw[this.conf.skin] == null) {
        var a = document.createElement("DIV");
        a.className = "dhxlayout_sep_sw_" + this.conf.skin;
        if (document.body.firstChild != null) {
            document.body.insertBefore(a, document.body.firstChild)
        } else {
            document.body.appendChild(a)
        }
        dhtmlXLayoutObject.prototype._confGlob.sw[this.conf.skin] = a.offsetWidth;
        document.body.removeChild(a);
        a = null
    }
    return dhtmlXLayoutObject.prototype._confGlob.sw[this.conf.skin]
};
dhtmlXLayoutObject.prototype._confGlob = {};
dhtmlXLayoutObject.prototype.attachHeader = function (c, a) {
    if (this.dataNodes.haObj != null) {
        return
    }
    if (typeof (c) != "object") {
        c = document.getElementById(c)
    }
    this.dataNodes.haObj = document.createElement("DIV");
    this.dataNodes.haObj.className = "dhxlayout_hdr_attached";
    this.dataNodes.haObj.style.height = (a || c.offsetHeight) + "px";
    this.base.insertBefore(this.dataNodes.haObj, this.dataNodes.menuObj || this.dataNodes.toolbarObj || this.cdata.a.cell);
    this.dataNodes.haObj.appendChild(c);
    c.style.visibility = "visible";
    c = null;
    this.dataNodes.haEv = this.attachEvent("_onSetSizes", function () {
        this.dataNodes.haObj.style.left = this.conf.ofs.l + "px";
        this.dataNodes.haObj.style.marginTop = this.conf.ofs.t + "px";
        this.dataNodes.haObj.style.width = this.base.offsetWidth - this.conf.ofs.l - this.conf.ofs.r + "px"
    });
    this.conf.ofs_nodes.t.haObj = true;
    this.setSizes()
};
dhtmlXLayoutObject.prototype.detachHeader = function () {
    if (!this.dataNodes.haObj) {
        return
    }
    while (this.dataNodes.haObj.childNodes.length > 0) {
        this.dataNodes.haObj.lastChild.style.visibility = "hidden";
        document.body.appendChild(this.dataNodes.haObj.lastChild)
    }
    this.dataNodes.haObj.parentNode.removeChild(this.dataNodes.haObj);
    this.dataNodes.haObj = null;
    this.detachEvent(this.dataNodes.haEv);
    this.dataNodes.haEv = null;
    this.conf.ofs_nodes.t.haObj = false;
    delete this.dataNodes.haEv;
    delete this.dataNodes.haObj;
    if (!this.conf.unloading) {
        this.setSizes()
    }
};
dhtmlXLayoutObject.prototype.attachFooter = function (g, a) {
    if (this.dataNodes.faObj != null) {
        return
    }
    if (typeof (g) != "object") {
        g = document.getElementById(g)
    }
    this.dataNodes.faObj = document.createElement("DIV");
    this.dataNodes.faObj.className = "dhxlayout_ftr_attached";
    this.dataNodes.faObj.style.height = (a || g.offsetHeight) + "px";
    var c = (this.dataNodes.sbObj || (this.conf.pattern == "1C" ? this.cdata.a : this.sep.sep));
    if (this.base.lastChild == c) {
        this.base.appendChild(this.dataNodes.faObj)
    } else {
        this.base.insertBefore(this.dataNodes.faObj, c.nextSibling)
    }
    this.dataNodes.faEv = this.attachEvent("_onSetSizes", function () {
        this.dataNodes.faObj.style.left = this.conf.ofs.l + "px";
        this.dataNodes.faObj.style.bottom = this.conf.ofs.t + "px";
        this.dataNodes.faObj.style.width = this.base.offsetWidth - this.conf.ofs.l - this.conf.ofs.r + "px"
    });
    this.dataNodes.faObj.appendChild(g);
    g.style.visibility = "visible";
    c = g = null;
    this.conf.ofs_nodes.b.faObj = true;
    this.setSizes()
};
dhtmlXLayoutObject.prototype.detachFooter = function () {
    if (!this.dataNodes.faObj) {
        return
    }
    while (this.dataNodes.faObj.childNodes.length > 0) {
        this.dataNodes.faObj.lastChild.style.visibility = "hidden";
        document.body.appendChild(this.dataNodes.faObj.lastChild)
    }
    this.dataNodes.faObj.parentNode.removeChild(this.dataNodes.faObj);
    this.dataNodes.faObj = null;
    this.detachEvent(this.dataNodes.faEv);
    this.dataNodes.faEv = null;
    this.conf.ofs_nodes.b.faObj = false;
    delete this.dataNodes.faEv;
    delete this.dataNodes.faObj;
    if (!this.conf.unloading) {
        this.setSizes()
    }
};
dhtmlXLayoutObject.prototype.attachMenu = function (a) {
    if (this.dataNodes.menu != null) {
        return
    }
    this.dataNodes.menuObj = document.createElement("DIV");
    this.dataNodes.menuObj.className = "dhxlayout_menu";
    this.base.insertBefore(this.dataNodes.menuObj, this.dataNodes.toolbarObj || this.dataNodes.ribbonObj || this.cdata.a.cell);
    if (typeof (a) != "object" || a == null) {
        a = {}
    }
    a.skin = this.conf.skin;
    a.parent = this.dataNodes.menuObj;
    this.dataNodes.menu = new dhtmlXMenuObject(a);
    this.dataNodes.menuEv = this.attachEvent("_onSetSizes", function () {
        if (this.dataNodes.menuObj.style.display == "none") {
            return
        }
        this.dataNodes.menuObj.style.left = this.conf.ofs.l + "px";
        this.dataNodes.menuObj.style.marginTop = (this.dataNodes.haObj != null ? 0 : this.conf.ofs.t) + "px";
        this.dataNodes.menuObj.style.width = this.base.offsetWidth - this.conf.ofs.l - this.conf.ofs.r + "px"
    });
    this.conf.ofs_nodes.t.menuObj = true;
    this.setSizes();
    a.parnt = null;
    a = null;
    return this.dataNodes.menu
};
dhtmlXLayoutObject.prototype.detachMenu = function () {
    if (this.dataNodes.menu == null) {
        return
    }
    this.dataNodes.menu.unload();
    this.dataNodes.menu = null;
    this.dataNodes.menuObj.parentNode.removeChild(this.dataNodes.menuObj);
    this.dataNodes.menuObj = null;
    this.detachEvent(this.dataNodes.menuEv);
    this.dataNodes.menuEv = null;
    delete this.dataNodes.menu;
    delete this.dataNodes.menuObj;
    delete this.dataNodes.menuEv;
    this.conf.ofs_nodes.t.menuObj = false;
    if (!this.conf.unloading) {
        this.setSizes()
    }
};
dhtmlXLayoutObject.prototype.attachToolbar = function (a) {
    if (!(this.dataNodes.ribbon == null && this.dataNodes.toolbar == null)) {
        return
    }
    this.dataNodes.toolbarObj = document.createElement("DIV");
    this.dataNodes.toolbarObj.className = "dhxlayout_toolbar";
    this.base.insertBefore(this.dataNodes.toolbarObj, this.cdata.a.cell);
    this.dataNodes.toolbarObj.appendChild(document.createElement("DIV"));
    if (typeof (a) != "object" || a == null) {
        a = {}
    }
    a.skin = this.conf.skin;
    a.parent = this.dataNodes.toolbarObj.firstChild;
    this.dataNodes.toolbar = new dhtmlXToolbarObject(a);
    this.dataNodes.toolbarEv = this.attachEvent("_onSetSizes", function () {
        if (this.dataNodes.toolbarObj.style.display == "none") {
            return
        }
        this.dataNodes.toolbarObj.style.left = this.conf.ofs.l + "px";
        this.dataNodes.toolbarObj.style.marginTop = (this.dataNodes.haObj != null || this.dataNodes.menuObj != null ? 0 : this.conf.ofs.t) + "px";
        this.dataNodes.toolbarObj.style.width = this.base.offsetWidth - this.conf.ofs.l - this.conf.ofs.r + "px"
    });
    this.dataNodes.toolbar._masterCell = this;
    this.dataNodes.toolbar.attachEvent("_onIconSizeChange", function () {
        this._masterCell.setSizes()
    });
    this.conf.ofs_nodes.t.toolbarObj = true;
    this.setSizes();
    a.parnt = null;
    a = null;
    return this.dataNodes.toolbar
};
dhtmlXLayoutObject.prototype.detachToolbar = function () {
    if (this.dataNodes.toolbar == null) {
        return
    }
    this.dataNodes.toolbar._masterCell = null;
    this.dataNodes.toolbar.unload();
    this.dataNodes.toolbar = null;
    this.dataNodes.toolbarObj.parentNode.removeChild(this.dataNodes.toolbarObj);
    this.dataNodes.toolbarObj = null;
    this.detachEvent(this.dataNodes.toolbarEv);
    this.dataNodes.toolbarEv = null;
    this.conf.ofs_nodes.t.toolbarObj = false;
    delete this.dataNodes.toolbar;
    delete this.dataNodes.toolbarObj;
    delete this.dataNodes.toolbarEv;
    if (!this.conf.unloading) {
        this.setSizes()
    }
};
dhtmlXLayoutObject.prototype.attachRibbon = function (a) {
    if (!(this.dataNodes.ribbon == null && this.dataNodes.toolbar == null)) {
        return
    }
    this.dataNodes.ribbonObj = document.createElement("DIV");
    this.dataNodes.ribbonObj.className = "dhxlayout_ribbon";
    this.base.insertBefore(this.dataNodes.ribbonObj, this.cdata.a.cell);
    this.dataNodes.ribbonObj.appendChild(document.createElement("DIV"));
    if (typeof (a) != "object" || a == null) {
        a = {}
    }
    a.skin = this.conf.skin;
    a.parent = this.dataNodes.ribbonObj.firstChild;
    this.dataNodes.ribbon = new dhtmlXRibbon(a);
    this.dataNodes.ribbonEv = this.attachEvent("_onSetSizes", function () {
        if (this.dataNodes.ribbonObj.style.display == "none") {
            return
        }
        this.dataNodes.ribbonObj.style.left = this.conf.ofs.l + "px";
        this.dataNodes.ribbonObj.style.marginTop = (this.dataNodes.haObj != null || this.dataNodes.menuObj != null ? 0 : this.conf.ofs.t) + "px";
        this.dataNodes.ribbonObj.style.width = this.base.offsetWidth - this.conf.ofs.l - this.conf.ofs.r + "px";
        this.dataNodes.ribbon.setSizes()
    });
    this.conf.ofs_nodes.t.ribbonObj = true;
    var c = this;
    this.dataNodes.ribbon.attachEvent("_onHeightChanged", function () {
        c.setSizes()
    });
    this.setSizes();
    a.parnt = null;
    a = null;
    return this.dataNodes.ribbon
};
dhtmlXLayoutObject.prototype.detachRibbon = function () {
    if (this.dataNodes.ribbon == null) {
        return
    }
    this.dataNodes.ribbon.unload();
    this.dataNodes.ribbon = null;
    this.dataNodes.ribbonObj.parentNode.removeChild(this.dataNodes.ribbonObj);
    this.dataNodes.ribbonObj = null;
    this.detachEvent(this.dataNodes.ribbonEv);
    this.dataNodes.ribbonEv = null;
    this.conf.ofs_nodes.t.ribbonObj = false;
    delete this.dataNodes.ribbon;
    delete this.dataNodes.ribbonObj;
    delete this.dataNodes.ribbonEv;
    if (!this.conf.unloading) {
        this.setSizes()
    }
};
dhtmlXLayoutObject.prototype.attachStatusBar = function (a) {
    if (this.dataNodes.sbObj) {
        return
    }
    if (typeof (a) == "undefined") {
        a = {}
    }
    this.dataNodes.sbObj = document.createElement("DIV");
    this.dataNodes.sbObj.className = "dhxlayout_statusbar";
    if (this.dataNodes.faObj != null) {
        this.base.insertBefore(this.dataNodes.sbObj, this.dataNodes.faObj)
    } else {
        if (this.sep == null || this.base.lastChild == this.sep.sep) {
            this.base.appendChild(this.dataNodes.sbObj)
        } else {
            this.base.insertBefore(this.dataNodes.sbObj, this.sep.sep.nextSibling)
        }
    }
    this.dataNodes.sbObj.innerHTML = "<div class='dhxcont_statusbar'>" + (typeof (a.text) == "string" && a.text.length > 0 ? a.text : "&nbsp;") + "</div>";
    if (typeof (a.height) == "number") {
        this.dataNodes.sbObj.firstChild.style.height = this.dataNodes.sbObj.firstChild.style.lineHeight = a.height + "px"
    }
    this.dataNodes.sbObj.setText = function (c) {
        this.childNodes[0].innerHTML = c
    };
    this.dataNodes.sbObj.getText = function () {
        return this.childNodes[0].innerHTML
    };
    this.dataNodes.sbObj.onselectstart = function (c) {
        return false
    };
    this.dataNodes.sbEv = this.attachEvent("_onSetSizes", function () {
        if (this.dataNodes.sbObj.style.display == "none") {
            return
        }
        this.dataNodes.sbObj.style.left = this.conf.ofs.l + "px";
        this.dataNodes.sbObj.style.bottom = (this.dataNodes.faObj != null ? this.dataNodes.faObj.offsetHeight : 0) + this.conf.ofs.t + "px";
        this.dataNodes.sbObj.style.width = this.base.offsetWidth - this.conf.ofs.l - this.conf.ofs.r + "px"
    });
    this.conf.ofs_nodes.b.sbObj = true;
    this.setSizes();
    return this.dataNodes.sbObj
};
dhtmlXLayoutObject.prototype.detachStatusBar = function () {
    if (!this.dataNodes.sbObj) {
        return
    }
    this.dataNodes.sbObj.setText = this.dataNodes.sbObj.getText = this.dataNodes.sbObj.onselectstart = null;
    this.dataNodes.sbObj.parentNode.removeChild(this.dataNodes.sbObj);
    this.dataNodes.sbObj = null;
    this.detachEvent(this.dataNodes.sbEv);
    this.dataNodes.sbEv = null;
    this.conf.ofs_nodes.b.sbObj = false;
    delete this.dataNodes.sb;
    delete this.dataNodes.sbObj;
    delete this.dataNodes.sbEv;
    if (!this.conf.unloading) {
        this.setSizes()
    }
};
dhtmlXLayoutObject.prototype.showMenu = function () {
    this._mtbShowHide("menuObj", "")
};
dhtmlXLayoutObject.prototype.hideMenu = function () {
    this._mtbShowHide("menuObj", "none")
};
dhtmlXLayoutObject.prototype.showToolbar = function () {
    this._mtbShowHide("toolbarObj", "")
};
dhtmlXLayoutObject.prototype.hideToolbar = function () {
    this._mtbShowHide("toolbarObj", "none")
};
dhtmlXLayoutObject.prototype.showRibbon = function () {
    this._mtbShowHide("ribbonObj", "")
};
dhtmlXLayoutObject.prototype.hideRibbon = function () {
    this._mtbShowHide("ribbonObj", "none")
};
dhtmlXLayoutObject.prototype.showStatusBar = function () {
    this._mtbShowHide("sbObj", "")
};
dhtmlXLayoutObject.prototype.hideStatusBar = function () {
    this._mtbShowHide("sbObj", "none")
};
dhtmlXLayoutObject.prototype._mtbShowHide = function (c, a) {
    if (this.dataNodes[c] == null) {
        return
    }
    this.dataNodes[c].style.display = a;
    this.setSizes()
};
dhtmlXLayoutObject.prototype._mtbUnload = function (c, a) {
    this.detachMenu();
    this.detachToolbar();
    this.detachStatusBar();
    this.detachRibbon()
};
dhtmlXLayoutObject.prototype.getAttachedMenu = function () {
    return this.dataNodes.menu
};
dhtmlXLayoutObject.prototype.getAttachedToolbar = function () {
    return this.dataNodes.toolbar
};
dhtmlXLayoutObject.prototype.getAttachedRibbon = function () {
    return this.dataNodes.ribbon
};
dhtmlXLayoutObject.prototype.getAttachedStatusBar = function () {
    return this.dataNodes.sbObj
};
dhtmlXLayoutObject.prototype.progressOn = function () {
    if (this.conf.progress) {
        return
    }
    this.conf.progress = true;
    var c = document.createElement("DIV");
    c.className = "dhxlayout_progress";
    this.base.appendChild(c);
    var a = document.createElement("DIV");
    a.className = "dhxlayout_progress_img";
    this.base.appendChild(a);
    c = a = null
};
dhtmlXLayoutObject.prototype.progressOff = function () {
    if (!this.conf.progress) {
        return
    }
    var h = {
        dhxlayout_progress: true,
        dhxlayout_progress_img: true
    };
    for (var g = 0; g < this.base.childNodes.length; g++) {
        if (typeof (this.base.childNodes[g].className) != "undefined" && h[this.base.childNodes[g].className] == true) {
            h[this.base.childNodes[g].className] = this.base.childNodes[g]
        }
    }
    for (var c in h) {
        if (h[c] != true) {
            this.base.removeChild(h[c])
        }
        h[c] = null
    }
    this.conf.progress = false;
    h = null
};
dhtmlXLayoutObject.prototype.listPatterns = function () {
    var g = [];
    for (var c in this.tplData) {
        g.push(c)
    }
    return g
};
dhtmlXLayoutObject.prototype.listAutoSizes = function () {
    var h = (this.conf.as_cells != null ? (this.conf.as_cells.h).join(";") : "");
    var g = (this.conf.as_cells != null ? (this.conf.as_cells.v).join(";") : "");
    var c = this._availAutoSize[this.conf.pattern].h;
    var a = this._availAutoSize[this.conf.pattern].v;
    return [h, g, c, a]
};
dhtmlXLayoutObject.prototype._getCellsNames = function (h) {
    var j = {};
    if (this.cdata[h].conf.name != null) {
        j[this.cdata[h].conf.name] = true
    }
    if (this.cdata[h].dataType == "layout" && this.cdata[h].dataObj != null && this.cdata[h].dataObj.mainInst == this) {
        var c = this.cdata[h].dataObj._getCellsNames("a");
        var l = this.cdata[h].dataObj._getCellsNames("b");
        for (var g in c) {
            j[g] = c[g]
        }
        for (var g in l) {
            j[g] = l[g]
        }
    }
    return j
};
dhtmlXLayoutObject.prototype.setAutoSize = function (c, o, r) {
    if (r !== true) {
        var v = this.listAutoSizes();
        if (v[0] == c && v[1] == o) {
            return
        }
        var n = false;
        var l = false;
        for (var g = 0; g < v[2].length; g++) {
            n = n || v[2][g] == c
        }
        for (var g = 0; g < v[3].length; g++) {
            l = l || v[3][g] == o
        }
        if (!n || !l) {
            return
        }
    }
    this.conf.as_cells = {
        h: c.split(";"),
        v: o.split(";")
    };
    var h = (this.conf.mode == "v" ? "h" : "v");
    for (var u in this.cdata) {
        var j = this._getCellsNames(u);
        var w = false;
        for (var g = 0; g < this.conf.as_cells[h].length; g++) {
            w = w || j[this.conf.as_cells[h][g]]
        }
        if (w) {
            this.conf.autosize = u
        }
        if (this.cdata[u].dataType == "layout" && this.cdata[u].dataObj != null) {
            this.cdata[u].dataObj.setAutoSize(c, o, true)
        }
    }
};
dhtmlXLayoutObject.prototype.tplData = {
    "1C": {
        mode: "c",
        cells: {
            a: {
                name: "a"
            }
        }
    },
    "2E": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                fsize: {
                    v: 1
                }
            },
            b: {
                name: "b",
                fsize: {
                    v: 1
                }
            }
        }
    },
    "2U": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                fsize: {
                    h: 1
                }
            },
            b: {
                name: "b",
                fsize: {
                    h: 1
                }
            }
        }
    },
    "3E": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                height: 1 / 3,
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "b",
                            fsize: {
                                v: [1, 2]
                            }
                        },
                        b: {
                            name: "c",
                            fsize: {
                                v: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "3W": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                width: 1 / 3,
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "b",
                            fsize: {
                                h: [1, 2]
                            }
                        },
                        b: {
                            name: "c",
                            fsize: {
                                h: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "3J": {
        mode: "v",
        cells: {
            a: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "a",
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            name: "c",
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        }
                    }
                }
            },
            b: {
                name: "b",
                fsize: {
                    h: 1
                }
            }
        }
    },
    "3L": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "b",
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            name: "c",
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "3T": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "b",
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        },
                        b: {
                            name: "c",
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        }
                    }
                }
            }
        }
    },
    "3U": {
        mode: "h",
        cells: {
            a: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "a",
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        },
                        b: {
                            name: "b",
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        }
                    }
                }
            },
            b: {
                name: "c",
                fsize: {
                    v: 1
                }
            }
        }
    },
    "4H": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                width: 1 / 3,
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        fsize: {
                                            h: [1, 2],
                                            v: 3
                                        }
                                    },
                                    b: {
                                        name: "c",
                                        fsize: {
                                            h: [1, 2],
                                            v: 3
                                        }
                                    }
                                }
                            }
                        },
                        b: {
                            name: "d",
                            fsize: {
                                h: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "4I": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                height: 1 / 3,
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "b",
                                        fsize: {
                                            h: 3,
                                            v: [1, 2]
                                        }
                                    },
                                    b: {
                                        name: "c",
                                        fsize: {
                                            h: 3,
                                            v: [1, 2]
                                        }
                                    }
                                }
                            }
                        },
                        b: {
                            name: "d",
                            fsize: {
                                v: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "4T": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "b",
                            width: 1 / 3,
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        },
                        b: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "c",
                                        fsize: {
                                            h: [2, 3],
                                            v: 1
                                        }
                                    },
                                    b: {
                                        name: "d",
                                        fsize: {
                                            h: 3,
                                            v: 1
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "4U": {
        mode: "h",
        cells: {
            a: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "a",
                            width: 1 / 3,
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        },
                        b: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "b",
                                        fsize: {
                                            h: [2, 3],
                                            v: 1
                                        }
                                    },
                                    b: {
                                        name: "c",
                                        fsize: {
                                            h: 3,
                                            v: 1
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            },
            b: {
                name: "d",
                fsize: {
                    v: 1
                }
            }
        }
    },
    "4E": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                height: 1 / 4,
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "b",
                            height: 1 / 3,
                            fsize: {
                                v: [1, 2]
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "c",
                                        fsize: {
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        name: "d",
                                        fsize: {
                                            v: 3
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "4W": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                width: 1 / 4,
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "b",
                            width: 1 / 3,
                            fsize: {
                                h: [1, 2]
                            }
                        },
                        b: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "c",
                                        fsize: {
                                            h: [2, 3]
                                        }
                                    },
                                    b: {
                                        name: "d",
                                        fsize: {
                                            h: 3
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "4A": {
        mode: "v",
        cells: {
            a: {
                width: 1 / 3,
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "a",
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            name: "b",
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        }
                    }
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "c",
                            fsize: {
                                h: [1, 3]
                            }
                        },
                        b: {
                            name: "d",
                            fsize: {
                                h: 3
                            }
                        }
                    }
                }
            }
        }
    },
    "4L": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                width: 1 / 3,
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "b",
                            fsize: {
                                h: [1, 2]
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "c",
                                        fsize: {
                                            h: 2,
                                            v: 3
                                        }
                                    },
                                    b: {
                                        name: "d",
                                        fsize: {
                                            h: 2,
                                            v: 3
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "4J": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                height: 1 / 3,
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "b",
                            fsize: {
                                v: [1, 2]
                            }
                        },
                        b: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "c",
                                        fsize: {
                                            h: 3,
                                            v: 2
                                        }
                                    },
                                    b: {
                                        name: "d",
                                        fsize: {
                                            h: 3,
                                            v: 2
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "4F": {
        mode: "h",
        cells: {
            a: {
                height: 1 / 3,
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "a",
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        },
                        b: {
                            name: "b",
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        }
                    }
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "c",
                            fsize: {
                                v: [1, 3]
                            }
                        },
                        b: {
                            name: "d",
                            fsize: {
                                v: 3
                            }
                        }
                    }
                }
            }
        }
    },
    "4G": {
        mode: "v",
        cells: {
            a: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "a",
                            height: 1 / 3,
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        fsize: {
                                            h: 1,
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        name: "c",
                                        fsize: {
                                            h: 1,
                                            v: 3
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            },
            b: {
                name: "d",
                fsize: {
                    h: 1
                }
            }
        }
    },
    "4C": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "b",
                            height: 1 / 3,
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "c",
                                        fsize: {
                                            h: 1,
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        name: "d",
                                        fsize: {
                                            h: 1,
                                            v: 3
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "5H": {
        mode: "v",
        cells: {
            a: {
                width: 1 / 3,
                name: "a",
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        height: 1 / 3,
                                        fsize: {
                                            h: [1, 2],
                                            v: 3
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "h",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    fsize: {
                                                        h: [1, 2],
                                                        v: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    name: "d",
                                                    fsize: {
                                                        h: [1, 2],
                                                        v: 4
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        },
                        b: {
                            name: "e",
                            fsize: {
                                h: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "5I": {
        mode: "h",
        cells: {
            a: {
                height: 1 / 3,
                name: "a",
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "b",
                                        width: 1 / 3,
                                        fsize: {
                                            h: 3,
                                            v: [1, 2]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "v",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    fsize: {
                                                        h: [3, 4],
                                                        v: [1, 2]
                                                    }
                                                },
                                                b: {
                                                    name: "d",
                                                    fsize: {
                                                        h: 4,
                                                        v: [1, 2]
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        },
                        b: {
                            name: "e",
                            fsize: {
                                v: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "5U": {
        mode: "h",
        cells: {
            a: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "a",
                            width: 1 / 4,
                            fsize: {
                                h: 2,
                                v: 1
                            }
                        },
                        b: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "b",
                                        width: 1 / 3,
                                        fsize: {
                                            h: [2, 3],
                                            v: 1
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "v",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    fsize: {
                                                        h: [3, 4],
                                                        v: 1
                                                    }
                                                },
                                                b: {
                                                    name: "d",
                                                    fsize: {
                                                        h: 4,
                                                        v: 1
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            },
            b: {
                name: "e",
                fsize: {
                    v: 1
                }
            }
        }
    },
    "5E": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                height: 1 / 5,
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "b",
                            height: 1 / 4,
                            fsize: {
                                v: [1, 2]
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "c",
                                        height: 1 / 3,
                                        fsize: {
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "h",
                                            cells: {
                                                a: {
                                                    name: "d",
                                                    fsize: {
                                                        v: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    name: "e",
                                                    fsize: {
                                                        v: 4
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "5W": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                width: 1 / 5,
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "b",
                            width: 1 / 4,
                            fsize: {
                                h: [1, 2]
                            }
                        },
                        b: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "c",
                                        width: 1 / 3,
                                        fsize: {
                                            h: [2, 3]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "v",
                                            cells: {
                                                a: {
                                                    name: "d",
                                                    fsize: {
                                                        h: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    name: "e",
                                                    fsize: {
                                                        h: 4
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "5K": {
        mode: "v",
        cells: {
            a: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "a",
                            height: 1 / 3,
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        fsize: {
                                            h: 1,
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        name: "c",
                                        fsize: {
                                            h: 1,
                                            v: 3
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "d",
                            fsize: {
                                h: 1,
                                v: 4
                            }
                        },
                        b: {
                            name: "e",
                            fsize: {
                                h: 1,
                                v: 4
                            }
                        }
                    }
                }
            }
        }
    },
    "5S": {
        mode: "v",
        cells: {
            a: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "a",
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            name: "b",
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        }
                    }
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "c",
                            height: 1 / 3,
                            fsize: {
                                h: 1,
                                v: 3
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "d",
                                        fsize: {
                                            h: 1,
                                            v: [3, 2]
                                        }
                                    },
                                    b: {
                                        name: "e",
                                        fsize: {
                                            h: 1,
                                            v: 4
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "5G": {
        mode: "v",
        cells: {
            a: {
                width: 1 / 3,
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "a",
                            height: 1 / 3,
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        fsize: {
                                            h: 1,
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        name: "c",
                                        fsize: {
                                            h: 1,
                                            v: 3
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "d",
                            fsize: {
                                h: [1, 4]
                            }
                        },
                        b: {
                            name: "e",
                            fsize: {
                                h: 4
                            }
                        }
                    }
                }
            }
        }
    },
    "5C": {
        mode: "v",
        cells: {
            a: {
                width: 2 / 3,
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "a",
                            fsize: {
                                h: 2
                            }
                        },
                        b: {
                            name: "b",
                            fsize: {
                                h: [2, 1]
                            }
                        }
                    }
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "c",
                            height: 1 / 3,
                            fsize: {
                                h: 1,
                                v: 3
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "d",
                                        fsize: {
                                            h: 1,
                                            v: [3, 4]
                                        }
                                    },
                                    b: {
                                        name: "e",
                                        fsize: {
                                            h: 1,
                                            v: 4
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "6H": {
        mode: "v",
        cells: {
            a: {
                width: 1 / 3,
                name: "a",
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        height: 1 / 4,
                                        fsize: {
                                            h: [1, 2],
                                            v: 3
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "h",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    height: 1 / 3,
                                                    fsize: {
                                                        h: [1, 2],
                                                        v: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    layout: {
                                                        mode: "h",
                                                        cells: {
                                                            a: {
                                                                name: "d",
                                                                fsize: {
                                                                    h: [1, 2],
                                                                    v: [4, 5]
                                                                }
                                                            },
                                                            b: {
                                                                name: "e",
                                                                fsize: {
                                                                    h: [1, 2],
                                                                    v: 5
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        },
                        b: {
                            name: "f",
                            fsize: {
                                h: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "6I": {
        mode: "h",
        cells: {
            a: {
                height: 1 / 3,
                name: "a",
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "b",
                                        width: 1 / 4,
                                        fsize: {
                                            h: 3,
                                            v: [1, 2]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "v",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    width: 1 / 3,
                                                    fsize: {
                                                        h: [3, 4],
                                                        v: [1, 2]
                                                    }
                                                },
                                                b: {
                                                    layout: {
                                                        mode: "v",
                                                        cells: {
                                                            a: {
                                                                name: "d",
                                                                fsize: {
                                                                    h: [4, 5],
                                                                    v: [1, 2]
                                                                }
                                                            },
                                                            b: {
                                                                name: "e",
                                                                fsize: {
                                                                    h: 5,
                                                                    v: [1, 2]
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        },
                        b: {
                            name: "f",
                            fsize: {
                                v: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "6A": {
        mode: "v",
        cells: {
            a: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "a",
                            height: 1 / 5,
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        height: 1 / 4,
                                        fsize: {
                                            h: 1,
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "h",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    height: 1 / 3,
                                                    fsize: {
                                                        h: 1,
                                                        v: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    layout: {
                                                        mode: "h",
                                                        cells: {
                                                            a: {
                                                                name: "d",
                                                                fsize: {
                                                                    h: 1,
                                                                    v: [4, 5]
                                                                }
                                                            },
                                                            b: {
                                                                name: "e",
                                                                fsize: {
                                                                    h: 1,
                                                                    v: 5
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            },
            b: {
                name: "f",
                fsize: {
                    h: 1
                }
            }
        }
    },
    "6C": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "b",
                            height: 1 / 5,
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "c",
                                        height: 1 / 4,
                                        fsize: {
                                            h: 1,
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "h",
                                            cells: {
                                                a: {
                                                    name: "d",
                                                    height: 1 / 3,
                                                    fsize: {
                                                        h: 1,
                                                        v: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    layout: {
                                                        mode: "h",
                                                        cells: {
                                                            a: {
                                                                name: "e",
                                                                fsize: {
                                                                    h: 1,
                                                                    v: [4, 5]
                                                                }
                                                            },
                                                            b: {
                                                                name: "f",
                                                                fsize: {
                                                                    h: 1,
                                                                    v: 5
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "6J": {
        mode: "v",
        cells: {
            a: {
                width: 1 / 3,
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            name: "a",
                            height: 1 / 4,
                            fsize: {
                                h: 1,
                                v: 2
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        height: 1 / 3,
                                        fsize: {
                                            h: 1,
                                            v: [2, 3]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "h",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    fsize: {
                                                        h: 1,
                                                        v: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    name: "d",
                                                    fsize: {
                                                        h: 1,
                                                        v: 4
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "e",
                            fsize: {
                                h: [1, 5]
                            }
                        },
                        b: {
                            name: "f",
                            fsize: {
                                h: 5
                            }
                        }
                    }
                }
            }
        }
    },
    "6E": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                width: 1 / 3,
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "b",
                            fsize: {
                                h: [1, 2]
                            }
                        },
                        b: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "c",
                                        height: 1 / 4,
                                        fsize: {
                                            h: 2,
                                            v: 3
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "h",
                                            cells: {
                                                a: {
                                                    name: "d",
                                                    height: 1 / 3,
                                                    fsize: {
                                                        h: 2,
                                                        v: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    layout: {
                                                        mode: "h",
                                                        cells: {
                                                            a: {
                                                                name: "e",
                                                                fsize: {
                                                                    h: 2,
                                                                    v: [4, 5]
                                                                }
                                                            },
                                                            b: {
                                                                name: "f",
                                                                fsize: {
                                                                    h: 2,
                                                                    v: 5
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "6W": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                width: 1 / 6,
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            name: "b",
                            width: 1 / 5,
                            fsize: {
                                h: [1, 2]
                            }
                        },
                        b: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "c",
                                        width: 1 / 4,
                                        fsize: {
                                            h: [2, 3]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "v",
                                            cells: {
                                                a: {
                                                    name: "d",
                                                    width: 1 / 3,
                                                    fsize: {
                                                        h: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    layout: {
                                                        mode: "v",
                                                        cells: {
                                                            a: {
                                                                name: "e",
                                                                fsize: {
                                                                    h: [4, 5]
                                                                }
                                                            },
                                                            b: {
                                                                name: "f",
                                                                fsize: {
                                                                    h: 5
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    "7H": {
        mode: "v",
        cells: {
            a: {
                name: "a",
                width: 1 / 3,
                fsize: {
                    h: 1
                }
            },
            b: {
                layout: {
                    mode: "v",
                    cells: {
                        a: {
                            layout: {
                                mode: "h",
                                cells: {
                                    a: {
                                        name: "b",
                                        height: 1 / 5,
                                        fsize: {
                                            h: [1, 2],
                                            v: 3
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "h",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    height: 1 / 4,
                                                    fsize: {
                                                        h: [1, 2],
                                                        v: [3, 4]
                                                    }
                                                },
                                                b: {
                                                    layout: {
                                                        mode: "h",
                                                        cells: {
                                                            a: {
                                                                name: "d",
                                                                height: 1 / 3,
                                                                fsize: {
                                                                    h: [1, 2],
                                                                    v: [4, 5]
                                                                }
                                                            },
                                                            b: {
                                                                layout: {
                                                                    mode: "h",
                                                                    cells: {
                                                                        a: {
                                                                            name: "e",
                                                                            fsize: {
                                                                                h: [1, 2],
                                                                                v: [5, 6]
                                                                            }
                                                                        },
                                                                        b: {
                                                                            name: "f",
                                                                            fsize: {
                                                                                h: [1, 2],
                                                                                v: 6
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        },
                        b: {
                            name: "g",
                            fsize: {
                                h: 2
                            }
                        }
                    }
                }
            }
        }
    },
    "7I": {
        mode: "h",
        cells: {
            a: {
                name: "a",
                height: 1 / 3,
                fsize: {
                    v: 1
                }
            },
            b: {
                layout: {
                    mode: "h",
                    cells: {
                        a: {
                            layout: {
                                mode: "v",
                                cells: {
                                    a: {
                                        name: "b",
                                        width: 1 / 5,
                                        fsize: {
                                            h: 3,
                                            v: [1, 2]
                                        }
                                    },
                                    b: {
                                        layout: {
                                            mode: "v",
                                            cells: {
                                                a: {
                                                    name: "c",
                                                    width: 1 / 4,
                                                    fsize: {
                                                        h: [3, 4],
                                                        v: [1, 2]
                                                    }
                                                },
                                                b: {
                                                    layout: {
                                                        mode: "v",
                                                        cells: {
                                                            a: {
                                                                name: "d",
                                                                width: 1 / 3,
                                                                fsize: {
                                                                    h: [4, 5],
                                                                    v: [1, 2]
                                                                }
                                                            },
                                                            b: {
                                                                layout: {
                                                                    mode: "v",
                                                                    cells: {
                                                                        a: {
                                                                            name: "e",
                                                                            fsize: {
                                                                                h: [5, 6],
                                                                                v: [1, 2]
                                                                            }
                                                                        },
                                                                        b: {
                                                                            name: "f",
                                                                            fsize: {
                                                                                h: 6,
                                                                                v: [1, 2]
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        },
                        b: {
                            name: "g",
                            fsize: {
                                v: 2
                            }
                        }
                    }
                }
            }
        }
    }
};
dhtmlXLayoutObject.prototype._availAutoSize = {
    "1C": {
        h: ["a"],
        v: ["a"]
    },
    "2E": {
        h: ["a;b"],
        v: ["a", "b"]
    },
    "2U": {
        h: ["a", "b"],
        v: ["a;b"]
    },
    "3E": {
        h: ["a;b;c"],
        v: ["a", "b", "c"]
    },
    "3W": {
        h: ["a", "b", "c"],
        v: ["a;b;c"]
    },
    "3J": {
        h: ["a;c", "b"],
        v: ["a;b", "b;c"]
    },
    "3L": {
        h: ["a", "b;c"],
        v: ["a;b", "a;c"]
    },
    "3T": {
        h: ["a;b", "a;c"],
        v: ["a", "b;c"]
    },
    "3U": {
        h: ["a;c", "b;c"],
        v: ["a;b", "c"]
    },
    "4H": {
        h: ["a", "b;c", "d"],
        v: ["a;b;d", "a;c;d"]
    },
    "4I": {
        h: ["a;b;d", "a;c;d"],
        v: ["a", "b;c", "d"]
    },
    "4T": {
        h: ["a;b", "a;c", "a;d"],
        v: ["a", "b;c;d"]
    },
    "4U": {
        h: ["a;d", "b;d", "c;d"],
        v: ["a;b;c", "d"]
    },
    "4E": {
        h: ["a;b;c;d"],
        v: ["a", "b", "c", "d"]
    },
    "4W": {
        h: ["a", "b", "c", "d"],
        v: ["a;b;c;d"]
    },
    "4A": {
        h: ["a;b", "c", "d"],
        v: ["a;c;d", "b;c;d"]
    },
    "4L": {
        h: ["a", "b", "c;d"],
        v: ["a;b;c", "a;b;d"]
    },
    "4J": {
        h: ["a;b;c", "a;b;d"],
        v: ["a", "b", "c;d"]
    },
    "4F": {
        h: ["a;c;d", "b;c;d"],
        v: ["a;b", "c", "d"]
    },
    "4G": {
        h: ["a;b;c", "d"],
        v: ["a;d", "b;d", "c;d"]
    },
    "4C": {
        h: ["a", "b;c;d"],
        v: ["a;b", "a;c", "a;d"]
    },
    "5H": {
        h: ["a", "b;c;d", "e"],
        v: ["a;b;e", "a;c;e", "a;d;e"]
    },
    "5I": {
        h: ["a;b;e", "a;c;e", "a;d;e"],
        v: ["a", "b;c;d", "e"]
    },
    "5U": {
        h: ["a;e", "b;e", "c;e", "d;e"],
        v: ["a;b;c;d", "e"]
    },
    "5E": {
        h: ["a;b;c;d;e"],
        v: ["a", "b", "c", "d", "e"]
    },
    "5W": {
        h: ["a", "b", "c", "d", "e"],
        v: ["a;b;c;d;e"]
    },
    "5K": {
        h: ["a;b;c", "d;e"],
        v: ["a;d", "b;d", "c;d", "a;e", "b;e", "c;e"]
    },
    "5S": {
        h: ["a;b", "c;d;e"],
        v: ["a;c", "a;d", "a;e", "b;c", "b;d", "b;e"]
    },
    "5G": {
        h: ["a;b;c", "d", "e"],
        v: ["a;d;e", "b;d;e", "c;d;e"]
    },
    "5C": {
        h: ["a", "b", "c;d;e"],
        v: ["a;b;c", "a;b;d", "a;b;e"]
    },
    "6H": {
        h: ["a", "b;c;d;e", "f"],
        v: ["a;b;f", "a;c;f", "a;d;f", "a;e;f"]
    },
    "6I": {
        h: ["a;b;f", "a;c;f", "a;d;f", "a;e;f"],
        v: ["a", "b;c;d;e", "f"]
    },
    "6A": {
        h: ["a;b;c;d;e", "f"],
        v: ["a;f", "b;f", "c;f", "d;f", "e;f"]
    },
    "6C": {
        h: ["a", "b;c;d;e;f"],
        v: ["a;b", "a;c", "a;d", "a;e", "a;f"]
    },
    "6J": {
        h: ["a;b;c;d", "e", "f"],
        v: ["a;e;f", "b;e;f", "c;e;f", "d;e;f"]
    },
    "6E": {
        h: ["a", "b", "c;d;e;f"],
        v: ["a;b;c", "a;b;d", "a;b;e", "a;b;f"]
    },
    "6W": {
        h: ["a", "b", "c", "d", "e", "f"],
        v: ["a;b;c;d;e;f"]
    },
    "7H": {
        h: ["a", "b;c;d;e;f", "g"],
        v: ["a;b;g", "a;c;g", "a;d;g", "a;e;g", "a;f;g"]
    },
    "7I": {
        h: ["a;b;g", "a;c;g", "a;d;g", "a;e;g", "a;f;g"],
        v: ["a", "b;c;d;e;f", "g"]
    }
};

function dhtmlXLayoutSepObject(g, a) {
    var c = this;
    this.conf = {
        mode: g,
        idx: a,
        blocked: false,
        locked: false
    };
    this._isLayoutSep = true;
    this.sep = document.createElement("DIV");
    this.sep.className = "dhxlayout_sep";
    this._btnLeft = (window.dhx4.isIE && !window.addEventListener ? 1 : 0);
    if (window.dhx4.isIE) {
        this.sep.onselectstart = function () {
            return false
        }
    }
    this.sep.className = "dhxlayout_sep dhxlayout_sep_resize_" + this.conf.mode;
    this._setSize = function (j, n, l, m) {
        this.sep.style.left = j + "px";
        this.sep.style.top = n + "px";
        this.sep.style.width = l + "px";
        this.sep.style.height = m + "px"
    };
    this._lockSep = function (h) {
        this.conf.locked = (h == true);
        this._blockSep()
    };
    this._blockSep = function () {
        var h = this._getLayout();
        var j = h.cdata.a.conf.collapsed || h.cdata.b.conf.collapsed || this.conf.locked;
        h = null;
        if (this.conf.blocked == j) {
            return
        }
        this.sep.className = "dhxlayout_sep" + (j ? "" : " dhxlayout_sep_resize_" + this.conf.mode);
        this.conf.blocked = j
    };
    this._beforeResize = function (j) {
        if (this.conf.blocked) {
            return
        }
        if (this.conf.resize != null && this.conf.resize.active == true) {
            return
        }
        if (j.button !== this._btnLeft) {
            return
        }
        var h = this._getLayout();
        this.conf.resize = {
            sx: j.clientX,
            sy: j.clientY,
            tx: j.layerX,
            ty: j.layerY,
            sep_x: parseInt(this.sep.style.left),
            sep_y: parseInt(this.sep.style.top),
            min_wa: h.cdata.a._getAvailWidth("a"),
            min_wb: h.cdata.b._getAvailWidth("b"),
            min_ha: h.cdata.a._getAvailHeight("a"),
            min_hb: h.cdata.b._getAvailHeight("b")
        };
        this.conf.resize.nx = this.conf.resize.sep_x;
        this.conf.resize.ny = this.conf.resize.sep_y;
        if (window.addEventListener) {
            document.body.addEventListener("mousemove", this._doOnMouseMove, false);
            document.body.addEventListener("mouseup", this._doOnMouseUp, false)
        } else {
            document.body.attachEvent("onmousemove", this._doOnMouseMove);
            document.body.attachEvent("onmouseup", this._doOnMouseUp)
        }
        h = null
    };
    this._onResize = function (j) {
        if (!this.conf.resize.active) {
            this._initResizeArea();
            this.conf.resize.active = true
        }
        if (this.conf.mode == "v") {
            var h = this.conf.resize.sx - j.clientX;
            this.conf.resize.nx = this.conf.resize.sep_x - h;
            if (this.conf.resize.nx > this.conf.resize.sep_x + this.conf.resize.min_wb) {
                this.conf.resize.nx = this.conf.resize.sep_x + this.conf.resize.min_wb
            } else {
                if (this.conf.resize.nx < this.conf.resize.sep_x - this.conf.resize.min_wa) {
                    this.conf.resize.nx = this.conf.resize.sep_x - this.conf.resize.min_wa
                }
            }
            this.r_sep.style.left = this.conf.resize.nx + "px"
        } else {
            var h = this.conf.resize.sy - j.clientY;
            this.conf.resize.ny = this.conf.resize.sep_y - h;
            if (this.conf.resize.ny > this.conf.resize.sep_y + this.conf.resize.min_hb) {
                this.conf.resize.ny = this.conf.resize.sep_y + this.conf.resize.min_hb
            } else {
                if (this.conf.resize.ny < this.conf.resize.sep_y - this.conf.resize.min_ha) {
                    this.conf.resize.ny = this.conf.resize.sep_y - this.conf.resize.min_ha
                }
            }
            this.r_sep.style.top = this.conf.resize.ny + "px"
        }
    };
    this._afterResize = function (q) {
        if (window.addEventListener) {
            document.body.removeEventListener("mousemove", this._doOnMouseMove, false);
            document.body.removeEventListener("mouseup", this._doOnMouseUp, false)
        } else {
            document.body.detachEvent("onmousemove", this._doOnMouseMove);
            document.body.detachEvent("onmouseup", this._doOnMouseUp)
        }
        if (!this.conf.resize.active) {
            this.conf.resize = null;
            return
        }
        if (q.button !== this._btnLeft) {
            return
        }
        var m = this._getLayout();
        var j = m._getMainInst();
        var n = (j.checkEvent("onPanelResizeFinish") == true ? {} : false);
        if (n !== false) {
            j.forEachItem(function (s) {
                n[s.conf.name] = {
                    w: s.conf.size.w,
                    h: s.conf.size.h
                };
                s = null
            })
        }
        var l = this.conf.resize.nx - this.conf.resize.sep_x;
        var h = this.conf.resize.ny - this.conf.resize.sep_y;
        m.cdata.a._setSize(m.cdata.a.conf.size.x, m.cdata.a.conf.size.y, m.cdata.a.conf.size.w + l, m.cdata.a.conf.size.h + h, "a");
        m.cdata.b._setSize(m.cdata.b.conf.size.x + l, m.cdata.b.conf.size.y + h, m.cdata.b.conf.size.w - l, m.cdata.b.conf.size.h - h, "b");
        this._setSize(parseInt(this.r_sep.style.left), parseInt(this.r_sep.style.top), parseInt(this.r_sep.style.width), parseInt(this.r_sep.style.height));
        if (window.dhx4.isIE) {
            var r = this;
            window.setTimeout(function () {
                r._removeResizeArea();
                r = null
            }, 1)
        } else {
            this._removeResizeArea()
        }
        if (n !== false) {
            var o = [];
            j.forEachItem(function (s) {
                var u = n[s.conf.name];
                if (!(u.w == s.conf.size.w && u.h == s.conf.size.h)) {
                    o.push(s.conf.name)
                }
                s = null
            });
            j._callMainEvent("onPanelResizeFinish", [o])
        }
        j = m = null;
        this.conf.resize.active = false;
        this.conf.resize = null
    };
    this._initResizeArea = function () {
        if (!this.r_sep) {
            this.r_sep = document.createElement("DIV");
            this.r_sep.className = "dhxlayout_resize_sep";
            this.r_sep.style.left = this.sep.style.left;
            this.r_sep.style.top = this.sep.style.top;
            this.r_sep.style.width = this.sep.style.width;
            this.r_sep.style.height = this.sep.style.height;
            this.sep.parentNode.appendChild(this.r_sep);
            if (window.dhx4.isIE) {
                this.r_sep.onselectstart = function () {
                    return false
                }
            }
        }
        if (!this.r_area) {
            this.r_area = document.createElement("DIV");
            this.r_area.className = "dhxlayout_resize_area";
            this.sep.parentNode.appendChild(this.r_area);
            if (window.dhx4.isIE) {
                this.r_area.onselectstart = function () {
                    return false
                }
            }
            if (this.conf.mode == "v") {
                var j = parseInt(this.r_sep.style.left) - this.conf.resize.min_wa;
                var n = parseInt(this.r_sep.style.top);
                var l = this.conf.resize.min_wa + this.conf.resize.min_wb + parseInt(this.r_sep.style.width);
                var m = parseInt(this.r_sep.style.height)
            } else {
                var j = parseInt(this.r_sep.style.left);
                var n = parseInt(this.r_sep.style.top) - this.conf.resize.min_ha;
                var l = parseInt(this.r_sep.style.width);
                var m = this.conf.resize.min_ha + this.conf.resize.min_hb + parseInt(this.r_sep.style.height)
            }
            this.r_area.style.left = j + "px";
            this.r_area.style.top = n + "px";
            if (!dhtmlXLayoutObject.prototype._confGlob.reszieCover) {
                dhtmlXLayoutObject.prototype._confGlob.reszieCover = {};
                this.r_area.style.width = l + "px";
                this.r_area.style.height = m + "px";
                dhtmlXLayoutObject.prototype._confGlob.reszieCover.w = parseInt(this.r_area.style.width) - this.r_area.offsetWidth;
                dhtmlXLayoutObject.prototype._confGlob.reszieCover.h = parseInt(this.r_area.style.height) - this.r_area.offsetHeight
            }
            this.r_area.style.width = l + dhtmlXLayoutObject.prototype._confGlob.reszieCover.w + "px";
            this.r_area.style.height = m + dhtmlXLayoutObject.prototype._confGlob.reszieCover.h + "px"
        }
        document.body.className += " dhxlayout_resize_" + this.conf.mode
    };
    this._removeResizeArea = function () {
        this.r_sep.onselectstart = null;
        this.r_sep.parentNode.removeChild(this.r_sep);
        this.r_sep = null;
        this.r_area.onselectstart = null;
        this.r_area.parentNode.removeChild(this.r_area);
        this.r_area = null;
        document.body.className = String(document.body.className).replace(/\s{0,}dhxlayout_resize_[vh]/gi, "")
    };
    this._doOnMouseDown = function (h) {
        h = h || event;
        if (h.preventDefault) {
            h.preventDefault()
        } else {
            h.cancelBubble = true
        }
        c._beforeResize(h)
    };
    this._doOnMouseMove = function (h) {
        h = h || event;
        if (h.preventDefault) {
            h.preventDefault()
        } else {
            h.cancelBubble = true
        }
        c._onResize(h)
    };
    this._doOnMouseUp = function (h) {
        h = h || event;
        c._afterResize(h)
    };
    if (typeof (window.addEventListener) == "function") {
        this.sep.addEventListener("mousedown", this._doOnMouseDown, false)
    } else {
        this.sep.attachEvent("onmousedown", this._doOnMouseDown)
    }
    this._unload = function () {
        if (typeof (window.addEventListener) == "function") {
            this.sep.removeEventListener("mousedown", this._doOnMouseDown, false)
        } else {
            this.sep.detachEvent("onmousedown", this._doOnMouseDown)
        }
        this.sep.parentNode.removeChild(this.sep);
        this.sep = null;
        for (var h in this) {
            this[h] = null
        }
        c = null
    };
    return this
}
window.dhtmlXLayoutCell = function (h, g) {
    dhtmlXCellObject.apply(this, [h, "_layout"]);
    var c = this;
    this.layout = g;
    this.conf.skin = this.layout.conf.skin;
    this.conf.mode = this.layout.conf.mode;
    this.conf.collapsed = false;
    this.conf.fixed = {
        w: false,
        h: false
    };
    this.conf.docked = true;
    this.attachEvent("_onCellUnload", function () {
        this.cell.childNodes[this.conf.idx.hdr].ondblclick = null;
        this._unloadDocking();
        this.layout = null;
        c = null
    });
    this._hdrInit();
    this.cell.childNodes[this.conf.idx.hdr].ondblclick = function () {
        var j = c.layout._getMainInst();
        j._callMainEvent("onDblClick", [c.conf.name]);
        j = null
    };
    this.attachEvent("_onContentLoaded", function () {
        var j = this.layout._getMainInst();
        j._callMainEvent("onContentLoaded", [this.conf.name]);
        j = null
    });
    if (this.conf.mode != "c") {
        var a = document.createElement("DIV");
        a.className = "dhxlayout_arrow dhxlayout_arrow_" + this.conf.mode + this._idd;
        this.cell.childNodes[this.conf.idx.hdr].appendChild(a);
        a.onclick = function (j) {
            if (c.conf.collapsed) {
                c.expand()
            } else {
                c.collapse()
            }
        };
        a = null
    }
    this._initDocking();
    return this
};
dhtmlXLayoutCell.prototype = new dhtmlXCellObject();
dhtmlXLayoutCell.prototype.getId = function () {
    return this.conf.name
};
dhtmlXLayoutCell.prototype._initDocking = function () {
    var a = this;
    this.dock = function () {
        var g = this.layout._getMainInst();
        if (g.dhxWins == null || this.conf.docked) {
            g = null;
            return
        }
        var c = g.dhxWins.window(this.conf.name);
        c.close();
        this._attachFromCell(c);
        this.conf.docked = true;
        if (!this.conf.dock_collapsed) {
            this.expand()
        }
        g._callMainEvent("onDock", [this.conf.name]);
        g = c = null
    };
    this.undock = function (c, n, l, m) {
        var j = this.layout._getMainInst();
        if (j.dhxWins == null || this.conf.docked == false) {
            j = null;
            return
        }
        this.conf.dock_collapsed = this.conf.collapsed;
        if (!this.conf.collapsed) {
            this.collapse()
        }
        if (j.dhxWins.window(this.conf.name) != null) {
            var g = j.dhxWins.window(this.conf.name);
            g.show()
        } else {
            if (c == null) {
                c = 20
            }
            if (n == null) {
                n = 20
            }
            if (l == null) {
                l = 320
            }
            if (m == null) {
                m = 200
            }
            var g = j.dhxWins.createWindow(this.conf.name, c, n, l, m);
            g.button("close").hide();
            g.addUserButton("dock", 99, "Dock");
            g.button("dock").show();
            g.button("dock").attachEvent("onClick", this._doOnDockClick);
            g.setText(this.getText());
            g.attachEvent("onClose", this._doOnDockWinClose)
        }
        this.conf.docked = false;
        g._attachFromCell(this);
        j._callMainEvent("onUnDock", [this.conf.name]);
        j = g = null
    };
    this._doOnDockClick = function () {
        a.dock()
    };
    this._doOnDockWinClose = function (c) {
        c.hide();
        return false
    };
    this._unloadDocking = function () {
        a = null
    }
};
dhtmlXLayoutCell.prototype._hdrInit = function () {
    var c = "";
    if (window.dhx4.isIE) {
        if (navigator.userAgent.indexOf("MSIE 8.0") != -1) {
            c = " dhx_cell_hdr_text_ie8"
        } else {
            if (navigator.userAgent.indexOf("MSIE 7.0") != -1) {
                c = " dhx_cell_hdr_text_ie7"
            } else {
                if (navigator.userAgent.indexOf("MSIE 6.0") != -1) {
                    c = " dhx_cell_hdr_text_ie6"
                }
            }
        }
    } else {
        if (window.dhx4.isChrome) {
            c = " dhx_cell_hdr_text_chrome"
        }
    }
    var a = document.createElement("DIV");
    a.className = "dhx_cell_hdr";
    a.innerHTML = "<div class='dhx_cell_hdr_text" + c + "'></div>";
    this.cell.insertBefore(a, this.cell.childNodes[this.conf.idx.cont]);
    a = null;
    this.conf.ofs_nodes.t._getHdrHeight = "func";
    this.conf.hdr = {
        visible: true
    };
    this.conf.idx_data.hdr = "dhx_cell_hdr";
    this._updateIdx();
    this.attachEvent("_onSetSize", this._hdrOnSetSize);
    this.attachEvent("_onBorderChange", this._hdrOnBorderChange);
    this.attachEvent("_onViewSave", this._hdrOnViewSave);
    this.attachEvent("_onViewRestore", this._hdrOnViewRestore)
};
dhtmlXLayoutCell.prototype.showHeader = function (a) {
    if (this.conf.hdr.visible || this.conf.collapsed) {
        return
    }
    if (this.conf.hdr.w_saved > this._getAvailWidth() || this.conf.hdr.h_saved > this._getAvailHeight()) {
        return
    }
    this.conf.hdr.w_saved = this.conf.hdr.h_saved = null;
    this.conf.hdr.visible = true;
    this.cell.childNodes[this.conf.idx.hdr].className = "dhx_cell_hdr";
    if (a !== true) {
        this._adjustCont(this._idd)
    }
};
dhtmlXLayoutCell.prototype.hideHeader = function (a) {
    if (!this.conf.hdr.visible || this.conf.collapsed) {
        return
    }
    this.conf.hdr.w_saved = this._getMinWidth();
    this.conf.hdr.h_saved = this._getMinHeight();
    this.conf.hdr.visible = false;
    this.cell.childNodes[this.conf.idx.hdr].className = "dhx_cell_hdr dhx_cell_hdr_hidden";
    this._hdrUpdBorder();
    this._mtbUpdBorder();
    if (a !== true) {
        this._adjustCont(this._idd)
    }
};
dhtmlXLayoutCell.prototype.isHeaderVisible = function () {
    return (this.conf.hdr.visible == true)
};
dhtmlXLayoutCell.prototype.showArrow = function () {
    this.cell.childNodes[this.conf.idx.hdr].childNodes[1].style.display = ""
};
dhtmlXLayoutCell.prototype.hideArrow = function () {
    this.cell.childNodes[this.conf.idx.hdr].childNodes[1].style.display = "none"
};
dhtmlXLayoutCell.prototype.isArrowVisible = function () {
    return (this.cell.childNodes[this.conf.idx.hdr].childNodes[1].style.display == "")
};
dhtmlXLayoutCell.prototype.setText = function (a) {
    this.conf.hdr.text = a;
    this._hdrUpdText()
};
dhtmlXLayoutCell.prototype.getText = function () {
    return this.conf.hdr.text
};
dhtmlXLayoutCell.prototype.setCollapsedText = function (a) {
    this.conf.hdr.text_collapsed = a;
    this._hdrUpdText()
};
dhtmlXLayoutCell.prototype.getCollapsedText = function () {
    return (this.conf.hdr.text_collapsed != null ? this.conf.hdr.text_collapsed : this.conf.hdr.text)
};
dhtmlXLayoutCell.prototype._hdrUpdText = function () {
    var a = (this.conf.collapsed == true && this.conf.hdr.text_collapsed != null ? this.conf.hdr.text_collapsed : this.conf.hdr.text);
    this.cell.childNodes[this.conf.idx.hdr].firstChild.innerHTML = "<span>" + a + "</span>"
};
dhtmlXLayoutCell.prototype._hdrUpdBorder = function () {
    if (this.conf.borders == true) {
        this.cell.childNodes[this.conf.idx.hdr].className = "dhx_cell_hdr" + (this.conf.hdr.visible ? "" : " dhx_cell_hdr_hidden")
    } else {
        if (!this.conf.hdr.visible) {
            this.cell.childNodes[this.conf.idx.hdr].className = "dhx_cell_hdr dhx_cell_hdr_hidden_no_borders"
        }
    }
};
dhtmlXLayoutCell.prototype._hdrOnSetSize = function () {
    if (this.conf.collapsed && this.conf.mode == "v") {
        this._fitHdr()
    }
};
dhtmlXLayoutCell.prototype._hdrOnBorderChange = function () {
    this.hideHeader(true);
    this._hdrUpdBorder()
};
dhtmlXLayoutCell.prototype._hdrOnViewSave = function (a) {
    this.views[a].hdr_vis = this.conf.hdr.visible
};
dhtmlXLayoutCell.prototype._hdrOnViewRestore = function (a) {
    if (this.conf.hdr.visible != this.views[a].hdr_vis) {
        this[this.views[a].hdr_vis ? "showHeader" : "hideHeader"](true)
    }
    this.views[a].hdr_vis = null;
    delete this.views[a].hdr_vis
};
dhtmlXLayoutCell.prototype._getHdrHeight = function (a) {
    if (this.conf.collapsed && this.conf.mode == "v" && a !== true) {
        return 27
    }
    return this.cell.childNodes[this.conf.idx.hdr].offsetHeight
};
dhtmlXLayoutCell.prototype._fitHdr = function () {
    if (this.conf.collapsed) {
        if (typeof (dhtmlXLayoutObject.prototype._confGlob.hdrColH) == "undefined") {
            this.cell.childNodes[this.conf.idx.hdr].style.height = this.cell.offsetHeight + "px";
            dhtmlXLayoutObject.prototype._confGlob.hdrColH = parseInt(this.cell.childNodes[this.conf.idx.hdr].style.height) - this._getHdrHeight(true)
        }
        this.cell.childNodes[this.conf.idx.hdr].style.height = this.cell.offsetHeight + dhtmlXLayoutObject.prototype._confGlob.hdrColH + "px"
    } else {
        this.cell.childNodes[this.conf.idx.hdr].style.height = null
    }
};
dhtmlXLayoutCell.prototype.expand = function (m) {
    if (!this.conf.collapsed) {
        return true
    }
    var g = this.layout;
    if (this.conf.mode == "v") {
        var l = (m ? g.conf.hh : g.cdata[g.conf.nextCell[this._idd]]._getMinWidth(this._idd));
        var h = g.base.offsetWidth - g.conf.sw;
        if (l + this.conf.size.w_avl > h) {
            g = null;
            return false
        }
    } else {
        var j = (m ? g.conf.hh : g.cdata[g.conf.nextCell[this._idd]]._getMinHeight(this._idd) + g.cdata[g.conf.nextCell[this._idd]]._getHdrHeight());
        var c = g.base.offsetHeight - g.conf.sw;
        if (j + this.conf.size.h_avl > c) {
            g = null;
            return false
        }
    }
    if (this.conf.docked == false) {
        this.dock();
        return
    }
    this.cell.className = String(this.cell.className).replace(/\s{0,}dhxlayout_collapsed_[hv]/gi, "");
    this.conf.collapsed = false;
    if (this.conf.mode == "v") {
        this.conf.size.w = Math.min(h - l, this.conf.size.w_saved);
        this.conf.size.w_saved = this.conf.size.w_avl = null
    } else {
        this.conf.size.h = Math.min(c - j, this.conf.size.h_saved);
        this.conf.size.h_saved = this.conf.size.h_avl = null
    }
    if (this.conf.mode == "v") {
        this._fitHdr()
    }
    g.setSizes(g.conf.nextCell[this._idd], g.conf.nextCell[this._idd], m == true, "expand");
    g.sep._blockSep();
    g = null;
    this._hdrUpdText();
    var a = this.layout._getMainInst();
    a._callMainEvent("onExpand", [this.conf.name]);
    a = null;
    return true
};
dhtmlXLayoutCell.prototype.collapse = function () {
    if (this.conf.collapsed) {
        return false
    }
    var c = this.layout;
    if (c.cdata[c.conf.nextCell[this._idd]].expand(true) == false) {
        return false
    }
    if (this.conf.mode == "v") {
        this.conf.size.w_saved = this.conf.size.w;
        this.conf.size.w_avl = this._getMinWidth(this._idd)
    } else {
        this.conf.size.h_saved = this.conf.size.h;
        this.conf.size.h_avl = this._getMinHeight(this._idd) + this._getHdrHeight()
    }
    this.cell.className += " dhxlayout_collapsed_" + this.conf.mode;
    this.conf.collapsed = true;
    if (this.conf.mode == "v") {
        this.conf.size.w = c.conf.hh
    } else {
        this.conf.size.h = this._getHdrHeight()
    }
    c.setSizes(c.conf.nextCell[this._idd], c.conf.nextCell[this._idd], false, "collapse");
    c.sep._blockSep();
    c = null;
    this._hdrUpdText();
    var a = this.layout._getMainInst();
    a._callMainEvent("onCollapse", [this.conf.name]);
    a = null;
    return true
};
dhtmlXLayoutCell.prototype.isCollapsed = function () {
    return (this.conf.collapsed == true)
};
dhtmlXLayoutCell.prototype._getMinWidth = function (c) {
    if (this.dataType == "layout" && this.dataObj != null) {
        if (this.dataObj.conf.pattern == "1C") {
            return this.dataObj.cdata.a._getMinWidth(c)
        } else {
            if (this.dataObj.conf.mode == "v") {
                var a = c;
                if (this.dataObj.cdata[a].conf.collapsed) {
                    a = this.dataObj.conf.nextCell[a]
                }
                return this.dataObj.cdata[a]._getMinWidth(c) + this.dataObj.cdata[this.dataObj.conf.nextCell[a]]._getWidth() + this.dataObj.conf.sw
            } else {
                return Math.max(this.dataObj.cdata.a._getMinWidth(c), this.dataObj.cdata.b._getMinWidth(c))
            }
        }
    }
    return 26
};
dhtmlXLayoutCell.prototype._getMinHeight = function (g) {
    var c = 26;
    if (this.conf.idx.menu != null) {
        c += this.cell.childNodes[this.conf.idx.menu].offsetHeight
    }
    if (this.dataType == "layout" && this.dataObj != null) {
        if (this.dataObj.conf.pattern == "1C") {
            return this.dataObj.cdata.a._getMinHeight(g)
        } else {
            if (this.dataObj.conf.mode == "h") {
                var a = g;
                if (this.dataObj.cdata[a].conf.collapsed) {
                    a = this.dataObj.conf.nextCell[a]
                }
                return this.dataObj.cdata[a]._getMinHeight(g) + this.dataObj.cdata[a]._getHdrHeight() + this.dataObj.cdata[this.dataObj.conf.nextCell[a]]._getHeight() + this.dataObj.conf.sw
            } else {
                return Math.max(this.dataObj.cdata.a._getMinHeight(g) + this.dataObj.cdata.a._getHdrHeight(), this.dataObj.cdata.b._getMinHeight(g) + this.dataObj.cdata.b._getHdrHeight())
            }
        }
    }
    return c
};
dhtmlXLayoutCell.prototype._getAvailWidth = function (g) {
    if (this.dataType == "layout" && this.dataObj != null) {
        if (this.dataObj.conf.pattern == "1C") {
            return this.dataObj.cdata.a._getAvailWidth(g)
        } else {
            if (this.dataObj.conf.mode == "v") {
                var a = (this.dataObj.cdata.a.conf.collapsed == true);
                var c = (this.dataObj.cdata.b.conf.collapsed == true);
                if (g == "a") {
                    return this.dataObj.cdata[c ? "a" : "b"]._getAvailWidth(g)
                } else {
                    return this.dataObj.cdata[a ? "b" : "a"]._getAvailWidth(g)
                }
            } else {
                return Math.min(this.dataObj.cdata.a._getAvailWidth(g), this.dataObj.cdata.b._getAvailWidth(g))
            }
        }
    }
    return this.cell.offsetWidth - this._getMinWidth()
};
dhtmlXLayoutCell.prototype._getAvailHeight = function (h) {
    if (this.dataType == "layout" && this.dataObj != null) {
        if (this.dataObj.conf.pattern == "1C") {
            return this.dataObj.cdata.a._getAvailHeight(h)
        } else {
            if (this.dataObj.conf.mode == "h") {
                var c = (this.dataObj.cdata.a.conf.collapsed == true);
                var g = (this.dataObj.cdata.b.conf.collapsed == true);
                if (h == "a") {
                    return this.dataObj.cdata[g ? "a" : "b"]._getAvailHeight(h)
                } else {
                    return this.dataObj.cdata[c ? "b" : "a"]._getAvailHeight(h)
                }
            } else {
                return Math.min(this.dataObj.cdata.a._getAvailHeight(h), this.dataObj.cdata.b._getAvailHeight(h))
            }
        }
    }
    var a = this._getHdrHeight();
    if (this.conf.mode == "v" && this.conf.collapsed) {
        a = this.conf.hh
    }
    return this.cell.offsetHeight - a - this._getMinHeight()
};
dhtmlXLayoutCell.prototype.setWidth = function (h) {
    if (this.conf.mode == "v") {
        if (this.conf.collapsed) {
            return
        }
        var j = this.layout;
        var l = j.cdata[j.conf.nextCell[this._idd]];
        if (l.conf.collapsed) {
            h = h + j.conf.sw + l._getWidth();
            m = j = l = null;
            return
        }
        var g = this._getMinWidth(this._idd);
        var n = j.base.offsetWidth - l._getMinWidth(this._idd) - j.conf.sw;
        h = Math.max(g, Math.min(h, n));
        this.conf.size.w = h;
        j.setSizes(l._idd, l._idd);
        j = l = null
    } else {
        if (this.layout == null || this.layout.parentLayout == null) {
            return
        }
        var m = this.layout.parentLayout;
        var j = this.layout;
        var l = j.cdata[j.conf.nextCell[this._idd]];
        for (var c in m.cdata) {
            if (m.cdata[c].dataObj == j) {
                m.cdata[c].setWidth(h)
            }
        }
        m = j = null
    }
};
dhtmlXLayoutCell.prototype.setHeight = function (n) {
    if (this.conf.mode == "h") {
        if (this.conf.collapsed) {
            return
        }
        var j = this.layout;
        var m = j.cdata[j.conf.nextCell[this._idd]];
        if (m.conf.collapsed) {
            n = n + j.conf.sw + m._getHeight();
            var o = (this.layout != null && this.layout.parentLayout != null ? this.layout.parentLayout : null);
            if (o != null) {
                for (var c in o.cdata) {
                    if (o.cdata[c].dataObj == j) {
                        o.cdata[c].setHeight(n)
                    }
                }
            }
            o = j = m = null;
            return
        }
        var l = this._getMinHeight(this._idd) + this._getHdrHeight();
        var g = j.base.offsetHeight - m._getMinHeight(this._idd) - m._getHdrHeight() - j.conf.sw;
        n = Math.max(l, Math.min(n, g));
        this.conf.size.h = n;
        j.setSizes(m._idd, m._idd);
        j = m = null
    } else {
        if (this.layout == null || this.layout.parentLayout == null) {
            return
        }
        var o = this.layout.parentLayout;
        var j = this.layout;
        var m = j.cdata[j.conf.nextCell[this._idd]];
        for (var c in o.cdata) {
            if (o.cdata[c].dataObj == j) {
                o.cdata[c].setHeight(n)
            }
        }
        o = j = null
    }
};
dhtmlXLayoutCell.prototype.getWidth = function () {
    return this.conf.size.w
};
dhtmlXLayoutCell.prototype.getHeight = function () {
    return this.conf.size.h
};
dhtmlXLayoutCell.prototype.fixSize = function (c, j) {
    this.conf.fixed.w = window.dhx4.s2b(c);
    this.conf.fixed.h = window.dhx4.s2b(j);
    var a = this.layout._getMainInst();
    var g = {};
    a.forEachItem(function (h) {
        if (h.conf.fsize != null) {
            var o = h.getId();
            var n = {
                h: (h.conf.fixed.w == true),
                v: (h.conf.fixed.h == true)
            };
            for (var l in n) {
                if (n[l] == true && h.conf.fsize[l] != null) {
                    if (!(h.conf.fsize[l] instanceof Array)) {
                        h.conf.fsize[l] = [h.conf.fsize[l]]
                    }
                    for (var m = 0; m < h.conf.fsize[l].length; m++) {
                        g[h.conf.fsize[l][m]] = true
                    }
                }
            }
        }
        h = null
    });
    a._forEachSep(function (h) {
        h._lockSep(g[h.conf.idx] == true);
        h = null
    });
    a = null
};

function dhtmlXTabBar(c, j) {
    var g = this;
    this.conf = {
        skin: (window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxtabbar") || "dhx_skyblue"),
        fullScreen: false,
        fullScreenResize: false,
        lastActive: null,
        closeButton: false,
        align: "left",
        tabsMode: (j == "bottom" ? "bottom" : "top"),
        contZone: true,
        transSpeed: "0.15s",
        baseOfs: {
            w: 2,
            h: 2
        },
        tabsOfs: 1,
        tabsTop: 0,
        autoload: {}
    };
    var h;
    if (c != null && typeof (c) == "object" && typeof (c.tagName) == "undefined") {
        h = c.parent;
        if (typeof (c.skin) != "undefined") {
            this.conf.skin = c.skin
        }
        if (typeof (c.mode) != "undefined") {
            this.conf.tabsMode = (c.mode == "bottom" ? "bottom" : "top")
        }
        if (typeof (c.align) != "undefined") {
            this.conf.align = (c.align == "right" ? "right" : "left")
        }
        if (typeof (c.close_button) != "undefined") {
            this.conf.closeButton = window.dhx4.s2b(c.close_button)
        }
        if (typeof (c.content_zone) != "undefined") {
            this.conf.contZone = window.dhx4.s2b(c.content_zone)
        }
        if (typeof (c.xml) != "undefined") {
            this.conf.autoload.xml = c.xml
        }
        if (typeof (c.json) != "undefined") {
            this.conf.autoload.xml = c.json
        }
        if (typeof (c.tabs) != "undefined") {
            this.conf.autoload.tabs = c.tabs
        }
        if (typeof (c.onload) != "undefined") {
            this.conf.autoload.tabs = c.tabs
        }
    } else {
        h = c
    }
    if (h == document.body) {
        document.documentElement.className += " dhxtabbar_fullscreen";
        document.body.className += " dhxtabbar_fullscreen";
        this.conf.fullScreen = true;
        this.base = document.createElement("DIV");
        this.base.className = "dhxtabbar_base_" + this.conf.skin;
        this.base.style.position = "absolute";
        this.base.style.left = this.conf.baseOfs.w + "px";
        this.base.style.top = this.conf.baseOfs.h + "px";
        document.body.appendChild(this.base)
    } else {
        this.base = (typeof (h) == "string" ? document.getElementById(h) : h);
        h = null;
        this.base.className += " dhxtabbar_base_" + this.conf.skin
    }
    if (this.base._ofs != null && this.base._ofs.t != null) {
        this.conf.tabsTop = this.base._ofs.t
    }
    this.tabsMode = document.createElement("DIV");
    this.tabsMode.className = "dhxtabbar_tabs_" + this.conf.tabsMode;
    this.base.appendChild(this.tabsMode);
    this.tabsArea = document.createElement("DIV");
    this.tabsArea.className = "dhxtabbar_tabs dhxtabbar_tabs_" + this.conf.tabsMode;
    this.tabsArea.innerHTML = "<div class='dhxtabbar_tabs_ar_left'><div class='dhxtabbar_arrow_img'></div></div><div class='dhxtabbar_tabs_base'><div class='dhxtabbar_tabs_cont_" + this.conf.align + "'><div class='dhxtabbar_tabs_line'></div></div></div><div class='dhxtabbar_tabs_ar_right'><div class='dhxtabbar_arrow_img'></div></div>";
    if (this.conf.tabsMode == "top") {
        this.tabsArea.style.top = this.conf.tabsTop + "px"
    }
    this.tabsMode.appendChild(this.tabsArea);
    this.tabsArea.childNodes[1].childNodes[0].style[this.conf.align] = "0px";
    this.tabsArea.childNodes[0].onclick = function () {
        if (g.conf.align == "left") {
            g._moveTabs(1)
        } else {
            g._moveTabs(-1)
        }
    };
    this.tabsArea.childNodes[2].onclick = function () {
        if (g.conf.align == "left") {
            g._moveTabs(-1)
        } else {
            g._moveTabs(1)
        }
    };
    this._onTabsAreaClick = function (l) {
        return this._callMainEvent("onTabClose", [l])
    };
    this.tabsArea.onclick = function (m) {
        m = m || event;
        var l = (m.target || m.srcElement);
        while (l != null) {
            if (typeof (l._tabCloseId) != "undefined") {
                if (g._onTabsAreaClick(l._tabCloseId) !== true) {
                    return
                }
                g.t[l._tabCloseId].conf.remove = true;
                g._hideTab(l._tabCloseId);
                l = null
            } else {
                if (typeof (l._tabId) != "undefined") {
                    g._doOnClick(l._tabId);
                    l = null
                }
            }
            if (l != null) {
                l = l.parentNode;
                if (l == this) {
                    l = null
                }
            }
        }
    };
    this.tabsArea.onselectstart = function (l) {
        l = l || event;
        if (l.preventDefault) {
            l.preventDefault()
        } else {
            l.returnValue = false
        }
    };
    this._doOnClick = function (l) {
        this.callEvent("onTabClick", [l, this.conf.lastActive]);
        if (this.t[l].conf.enabled) {
            this._setTabActive(l)
        }
    };
    this.t = {};
    this.addTab = function (l, u, n, r, q, v) {
        if (typeof (v) != "boolean") {
            v = (this.conf.closeButton == true)
        }
        q = window.dhx4.s2b(q);
        var o = document.createElement("DIV");
        o.className = "dhxtabbar_tab";
        o.innerHTML = "<div class='dhxtabbar_tab_text" + (v ? " dhxtabbar_tab_text_close" : "") + "'>" + u + "</div>" + (v ? "<div class='dhxtabbar_tab_close'></div>" : "");
        o._tabId = l;
        if (v) {
            o.childNodes[1]._tabCloseId = l
        }
        var m = this.tabsArea.childNodes[1].firstChild;
        if (r != null && r + 1 > 0 && r + 1 < m.childNodes.length) {
            m.insertBefore(o, m.childNodes[r + 1])
        } else {
            m.appendChild(o)
        }
        var w = false;
        if (typeof (n) == "undefined" || n == null || n == "*") {
            n = this._getLabelWidth(u, v);
            w = true
        } else {
            n = parseInt(n)
        }
        o.style.width = n + "px";
        var s = new dhtmlXTabBarCell(l, this);
        this.tabsMode.appendChild(s.cell);
        this.t[l] = {
            tab: o,
            cell: s,
            conf: {
                text: u,
                visible: true,
                active: false,
                enabled: true,
                close: v,
                width: n,
                autowidth: w
            }
        };
        m = s = null;
        if (q) {
            this._setTabActive(l)
        } else {
            this._adjustCell(l)
        }
    };
    this.setSizes = function () {
        if (this.conf.fullScreen) {
            this.base.style.width = document.body.offsetWidth - this.conf.baseOfs.w * 2 + "px";
            this.base.style.height = document.body.offsetHeight - this.conf.baseOfs.h * 2 + "px"
        }
        if (this.conf.tabsAreaOfs == null) {
            this.tabsArea.style.width = this.base.offsetWidth + "px";
            this.conf.tabsAreaOfs = parseInt(this.tabsArea.style.width) - this.tabsArea.offsetWidth
        }
        this.tabsArea.style.width = this.base.offsetWidth + this.conf.tabsAreaOfs + "px";
        this.tabsArea.childNodes[1].style.left = this.tabsArea.childNodes[0].offsetWidth - 1 + "px";
        this.tabsArea.childNodes[1].style.width = Math.max(0, this.tabsArea.offsetWidth - this.tabsArea.childNodes[0].offsetWidth - this.tabsArea.childNodes[2].offsetWidth) + 1 + "px";
        this._adjustCell(this.conf.lastActive);
        this._adjustTabs()
    };
    this._adjustCell = function (o) {
        if (!this.conf.contZone || o == null) {
            return
        }
        var n = (this.conf.tabsMode == "top" ? this.tabsArea.offsetHeight : 0) + this.conf.tabsTop;
        var m = this.base.offsetHeight - this.tabsArea.offsetHeight - this.conf.tabsTop;
        var l = this.t[o].cell.dataType;
        if (this.conf.skin == "dhx_skyblue" && (l == "layout" || l == "tabbar" || l == "acc")) {
            if (this.conf.tabsMode == "top") {
                n = n - 1
            }
            m = m + 1
        }
        if (o != this.conf.lastActive) {
            n = -5000;
            this.t[o].cell.cell.style.visibility = "hidden";
            this.t[o].cell.cell.style.zIndex = 0
        }
        this.t[o].cell._setSize(0, n, this.base.offsetWidth, m)
    };
    this.setTabsMode = function (l) {
        this.conf.tabsMode = (l == "bottom" ? "bottom" : "top");
        this.tabsMode.className = "dhxtabbar_tabs_" + this.conf.tabsMode;
        this.setSizes()
    };
    this._tabCss = function (q, n) {
        var l = this.t[q].conf.active;
        var o = !this.t[q].conf.enabled;
        var m = !this.t[q].conf.visible;
        return "dhxtabbar_tab" + (m ? " dhxtabbar_tab_hidden" : (l || o ? " dhxtabbar_tab" + (l ? "_actv" : "") + (o ? "_dis" : "") : ""))
    };
    this._getLabelWidth = function (n, m) {
        if (!this.tabsTextTest) {
            this.tabsTextTest = document.createElement("SPAN");
            this.tabsTextTest.className = "dhxtabbar_tabs_text_test_" + this.conf.skin
        }
        document.body.appendChild(this.tabsTextTest);
        this.tabsTextTest.innerHTML = n;
        var l = this.tabsTextTest.offsetWidth;
        l += (this.conf.skin == "dhx_terrace" ? 44 : 35);
        l += (m ? (this.conf.skin == "dhx_terrace" ? 14 : 9) : 0);
        document.body.removeChild(this.tabsTextTest);
        return l
    };
    this._adjustTabs = function () {
        var r = this.tabsArea.childNodes[1];
        if (r.offsetWidth < 5) {
            r = null;
            return
        }
        var l = parseInt(r.childNodes[0].style[this.conf.align]);
        var n = null;
        for (var o = 0; o < r.childNodes[0].childNodes.length; o++) {
            var s = r.childNodes[0].childNodes[o]._tabId;
            if (s != null && this.t[s].conf.visible) {
                var m = this.t[s].tab.offsetWidth - this.conf.tabsOfs;
                if (this.t[s].conf.active) {
                    if (l < 0 || r.offsetWidth < m) {
                        n = {
                            d: 1,
                            id: s
                        }
                    } else {
                        if (l + m > r.offsetWidth) {
                            n = {
                                d: -1,
                                id: s
                            }
                        }
                    }
                }
                l += m
            }
        }
        if (n != null) {
            this._moveTabs(n.d, n.id)
        } else {
            if (r.offsetWidth > l + 1) {
                r.childNodes[0].style[this.conf.align] = Math.min(0, parseInt(r.childNodes[0].style[this.conf.align]) + (r.offsetWidth - l)) + "px"
            }
        }
        r = n = null
    };
    this._moveTabs = function (y, r) {
        var o = this.tabsArea.childNodes[1].childNodes[0];
        var v = 0;
        var A = [];
        var D = null;
        for (var m = 0; m < o.childNodes.length; m++) {
            var n = o.childNodes[m]._tabId;
            if (n != null && this.t[n].conf.visible) {
                A.push({
                    id: n,
                    w: this.t[n].tab.offsetWidth - this.conf.tabsOfs,
                    ind: v
                });
                if (n == r) {
                    D = v
                }
                v++
            }
        }
        var C = parseInt(this.tabsArea.childNodes[1].childNodes[0].style[this.conf.align]);
        var u = this.tabsArea.offsetWidth - this.tabsArea.childNodes[0].offsetWidth - this.tabsArea.childNodes[2].offsetWidth;
        var w = null;
        var s = null;
        for (var m = 0; m < A.length; m++) {
            A[m].x = C;
            if (w == null && C >= 0 && C + A[m].w > 0) {
                w = A[m]
            }
            if (C < u && C + A[m].w <= u) {
                s = A[m]
            }
            C += A[m].w
        }
        if (D != null) {
            var E = A[D]
        } else {
            var E = null;
            if (y > 0) {
                if (w == null) {
                    if (A.length > 0) {
                        E = A[A.length - 1]
                    }
                } else {
                    if (w.ind > 0 && A.length >= w.ind) {
                        E = A[w.ind - 1]
                    }
                }
            } else {
                if (s == null) {
                    if (A.length > 0) {
                        E = A[0]
                    }
                } else {
                    if (A.length > s.ind) {
                        E = A[s.ind + 1]
                    }
                }
            }
        }
        if (E != null) {
            if (y > 0) {
                if (C < u) {
                    o.style[this.conf.align] = Math.min(0, parseInt(o.style[this.conf.align]) + (u - C)) + "px"
                } else {
                    o.style[this.conf.align] = parseInt(o.style[this.conf.align]) - E.x + "px"
                }
            } else {
                o.style[this.conf.align] = parseInt(o.style[this.conf.align]) - E.x + u - E.w + "px"
            }
        }
        o = E = A = null
    };
    this._getNextVisible = function (m, l) {
        return this._getNearVisible(m, l, "next")
    };
    this._getPrevVisible = function (m, l) {
        return this._getNearVisible(m, l, "previous")
    };
    this._getFirstVisible = function () {
        return this._getNearVisible(null, false, "first")
    };
    this._getNearVisible = function (r, n, q) {
        if (q == "first") {
            var o = this.tabsArea.childNodes[1].childNodes[0].childNodes[1];
            q = "next"
        } else {
            if (r == null || this.t[r] == null) {
                return (n ? this._getFirstVisible() : null)
            }
            var o = this.t[r].tab[q + "Sibling"]
        }
        var m = null;
        while (o != null && m == null) {
            var l = o._tabId;
            if (l != null && m == null && this.t[l].conf.visible) {
                m = l
            } else {
                o = o[q + "Sibling"]
            }
        }
        o = null;
        return m
    };
    this._showTab = function (m, l) {
        if (!this.t[m] || this.t[m].conf.visible || this.t[m].conf.transActv) {
            return
        }
        if (this.conf.transProp !== false) {
            this.t[m].conf.transActv = true;
            this.t[m].conf.transMode = "show";
            this.t[m].conf.transProp = this.conf.transProp;
            this.t[m].conf.transActvId = (l ? m : null);
            if (!this.t[m].conf.transEv) {
                this.t[m].tab.addEventListener(this.conf.transEv, this._doOnTrEnd);
                this.t[m].conf.transEv = true
            }
            this.t[m].conf.visible = true;
            this.t[m].tab.className = this._tabCss(m);
            this.t[m].tab.style[this.conf.transProp] = this.conf.transValueWidth;
            this.t[m].tab.style.width = this.t[m].conf.width + "px"
        } else {
            this.t[m].conf.visible = true;
            this.t[m].tab.style.display = "";
            if (l) {
                this._setTabActive(m)
            } else {
                this._adjustTabs()
            }
        }
    };
    this._hideTab = function (r, l) {
        if (!this.t[r] || !this.t[r].conf.visible || this.t[r].conf.transActv) {
            return
        }
        var m = false;
        if (this.conf.lastActive == r) {
            this.conf.lastActive = null;
            this.t[r].conf.active = false;
            this.t[r].tab.className = this._tabCss(r);
            m = true
        }
        var o = this._getPrevVisible(r);
        var n = this._getNextVisible(r);
        var q = (m && l !== false ? (l == true ? null : l) || n || o : null);
        if (this.conf.transProp !== false) {
            this.t[r].conf.transActv = true;
            this.t[r].conf.transMode = "hide";
            this.t[r].conf.transProp = this.conf.transProp;
            this.t[r].conf.transActvId = q;
            this.t[r].conf.visible = false;
            if (!this.t[r].conf.transEv) {
                this.t[r].tab.addEventListener(this.conf.transEv, this._doOnTrEnd);
                this.t[r].conf.transEv = true
            }
            this.t[r].tab.style.visibility = "hidden";
            this.t[r].tab.className = g._tabCss(r);
            this.t[r].tab.style[this.conf.transProp] = this.conf.transValueWidth;
            this.t[r].tab.style.width = "0px"
        } else {
            this.t[r].tab.style.display = "none";
            this.t[r].conf.visible = false;
            if (this.conf.contZone) {
                this.t[r].cell.cell.style.visibility = "hidden";
                this.t[r].cell.cell.style.top = "-5000px"
            }
            if (q != null) {
                this._setTabActive(q)
            }
            this._adjustTabs();
            if (this.t[r].conf.remove) {
                this._removeTab(r)
            }
        }
    };
    this._isTabVisible = function (l) {
        return (this.t[l].conf.visible == true)
    };
    this._doOnTrEnd = function () {
        var n = this._tabId;
        if (g.t[n] == null) {
            return
        }
        var l = g.t[n];
        var m = l.conf.transActvId;
        if (l.conf.transMode == "hide") {
            if (l.conf.remove) {
                g._removeTab(n)
            } else {
                l.tab.style[l.conf.transProp] = "";
                if (g.conf.contZone) {
                    l.cell.cell.style.visibility = "hidden";
                    l.cell.cell.style.top = "-5000px"
                }
                l.conf.transActv = false
            }
        } else {
            if (l.conf.transMode == "show") {
                l.tab.style[l.conf.transProp] = "";
                l.tab.style.visibility = "visible";
                l.conf.transMode = null;
                l.conf.transActv = false
            }
        }
        if (m != null) {
            g._setTabActive(m)
        } else {
            g._adjustTabs()
        }
        l = null
    };
    this.enableTabCloseButton = function (l) {
        this.conf.closeButton = window.dhx4.s2b(l)
    };
    this.unload = function () {
        this.clearAll();
        this.t = null;
        if (this.conf.fullScreen) {
            if (window.addEventListener) {
                window.removeEventListener("resize", this._doOnResizeStart, false)
            } else {
                window.detachEvent("onresize", this._doOnResizeStart)
            }
            this._doOnResizeStart = null;
            this._doOnResizeEnd = null
        }
        if (this.tabsTextTest != null) {
            if (this.tabsTextTest.parentNode) {
                this.tabsTextTest.parentNode.removeChild(this.tabsTextTest)
            }
            this.tabsTextTest = null
        }
        window.dhx4._eventable(this, "clear");
        window.dhx4._enableDataLoading(this, null, null, null, "clear");
        this.tabsArea.childNodes[0].onclick = null;
        this.tabsArea.childNodes[2].onclick = null;
        this.tabsArea.onclick = null;
        this.tabsArea.onselectstart = null;
        this.tabsArea.parentNode.removeChild(this.tabsArea);
        this.tabsArea = null;
        this.tabsMode.parentNode.removeChild(this.tabsMode);
        this.tabsMode = null;
        if (this.conf.fullScreen) {
            this.base.parentNode.removeChild(this.base);
            document.documentElement.className = document.documentElement.className.replace("dhxtabbar_fullscreen", "");
            document.body.className = document.body.className.replace("dhxtabbar_fullscreen", "")
        } else {
            this.base.className = this.base.className.replace("dhxtabbar_base_" + this.conf.skin, "")
        }
        this.base = null;
        for (var l in this) {
            this[l] = null
        }
        g = null
    };
    this.enableContentZone = function (l) {
        this.conf.contZone = (l == true)
    };
    this.setSkin = function (m) {
        this.base.className = this.base.className.replace(new RegExp("dhxtabbar_base_" + this.conf.skin), "dhxtabbar_base_" + m);
        this.conf.skin = m;
        if (this.tabsTextTest != null) {
            this.tabsTextTest.className = "dhxtabbar_tabs_text_test_" + this.conf.skin
        }
        for (var l in this.t) {
            this.t[l].cell._resetSizeState();
            if (this.t[l].conf.autowidth == true) {
                this.t[l].conf.width = this._getLabelWidth(this.t[l].conf.text, this.t[l].conf.close);
                if (this.t[l].conf.visible) {
                    this.t[l].tab.style.width = this.t[l].conf.width + "px"
                }
            }
        }
        this.conf.tabsAreaOfs = null;
        this._fixTabsOfs();
        this.setSizes()
    };
    this.setAlign = function (l) {
        l = (l == "left" ? "left" : "right");
        if (l == this.conf.align) {
            this.tabsArea.childNodes[1].childNodes[0].style[this.conf.align] = "0px";
            return
        }
        if (this.conf.transProp !== false) {
            this.tabsArea.childNodes[1].childNodes[0].style[this.conf.transProp] = ""
        }
        this.tabsArea.childNodes[1].childNodes[0].style[this.conf.align] = "";
        this.conf.align = l;
        this.tabsArea.childNodes[1].childNodes[0].className = "dhxtabbar_tabs_cont_" + this.conf.align;
        this.tabsArea.childNodes[1].childNodes[0].style[this.conf.align] = "0px";
        if (this.conf.transProp !== false) {
            this.conf.transValuePos = this.conf.align + " " + this.conf.transSpeed;
            this.tabsArea.childNodes[1].childNodes[0].style[this.conf.transProp] = this.conf.transValuePos
        }
    };
    this._initObj = function (o) {
        this.clearAll();
        var l = false;
        if (o.settings != null) {
            if (o.settings.skin != null) {
                this.setSkin(o.settings.skin)
            }
            if (o.settings.closeButton != null) {
                this.enableTabCloseButton(window.dhx4.s2b(o.settings.closeButton))
            }
            if (o.settings.align != null) {
                this.setAlign(o.settings.align)
            }
            if (o.settings.hrefmode == "ajax" || o.settings.hrefmode == "ajax-html") {
                l = true
            }
        }
        if (o.tabs != null) {
            for (var n = 0; n < o.tabs.length; n++) {
                var m = o.tabs[n];
                if (typeof (m.id) == "undefined") {
                    m.id = window.dhx4.newId()
                }
                if (!isNaN(parseInt(m.width))) {
                    m.width = parseInt(m.width)
                } else {
                    m.width = null
                }
                this.addTab(m.id, m.text || m.label || "", m.width, m.index, window.dhx4.s2b(m.selected) || window.dhx4.s2b(m.active), m.close);
                if (m.content != null) {
                    this.cells(m.id).attachHTMLString(m.content)
                }
                if (m.href != null) {
                    this.cells(m.id).attachURL(m.href, l)
                }
                if (typeof (m.enabled) != "undefined" && window.dhx4.s2b(m.enabled) == false) {
                    this.tabs(m.id).disable()
                } else {
                    if (typeof (m.disabled) != "undefined" && window.dhx4.s2b(m.disabled) == true) {
                        this.tabs(m.id).disable()
                    }
                }
            }
        }
    };
    this._xmlToObj = function (s) {
        var o = {
            settings: {},
            tabs: []
        };
        var l = s.getElementsByTagName("tabbar")[0];
        if (l != null) {
            for (var u in {
                skin: 1,
                align: 1,
                closeButton: 1,
                hrefmode: 1
            }) {
                if (l.getAttribute(u) != null) {
                    o.settings[u] = l.getAttribute(u)
                }
            }
            var x = l.getElementsByTagName("tab");
            for (var m = 0; m < x.length; m++) {
                var n = {
                    text: (x[m].firstChild.nodeValue || "")
                };
                for (var u in {
                    id: 1,
                    width: 1,
                    close: 1,
                    selected: 1,
                    active: 1,
                    enabled: 1,
                    disabled: 1,
                    href: 1
                }) {
                    if (x[m].getAttribute(u) != null) {
                        n[u] = x[m].getAttribute(u)
                    }
                }
                var y = x[m].getElementsByTagName("content")[0];
                if (y != null) {
                    n.content = "";
                    for (var v = 0; v < y.childNodes.length; v++) {
                        n.content += (y.childNodes[v].nodeValue || "")
                    }
                }
                o.tabs.push(n)
            }
        }
        return o
    };
    dhx4._enableDataLoading(this, "_initObj", "_xmlToObj", "tabbar", {
        struct: true
    });
    var a = window.dhx4.transDetect();
    this.conf.transProp = a.transProp;
    this.conf.transEv = a.transEv;
    this.conf.transValueWidth = "width " + this.conf.transSpeed;
    a = null;
    if (this.conf.transProp !== false) {
        this.conf.transValuePos = this.conf.align + " " + this.conf.transSpeed;
        this.tabsArea.childNodes[1].childNodes[0].style[this.conf.transProp] = this.conf.transValuePos
    }
    this._initFullScreenResize = function () {
        if (this.conf.fullScreenResize) {
            return
        }
        this.conf.tmResize = null;
        this._doOnResizeStart = function () {
            window.clearTimeout(g.conf.tmResize);
            g.conf.tmResize = window.setTimeout(g._doOnResizeEnd, 200)
        };
        this._doOnResizeEnd = function () {
            g.setSizes()
        };
        if (window.addEventListener) {
            window.addEventListener("resize", this._doOnResizeStart, false)
        } else {
            window.attachEvent("onresize", this._doOnResizeStart)
        }
        this.conf.fullScreenResize = true
    };
    if (this.conf.fullScreen) {
        this._initFullScreenResize()
    }
    this._callMainEvent = function (m, l) {
        return this.callEvent(m, l)
    };
    window.dhx4._eventable(this);
    if (this.conf.autoload.json != null) {
        this.loadStruct(this.conf.autoload.json, this.conf.autoload.onload)
    } else {
        if (this.conf.autoload.xml != null) {
            this.loadStruct(this.conf.autoload.xml, this.conf.autoload.onload)
        } else {
            if (this.conf.autoload.tabs != null) {
                this.loadStruct({
                    tabs: this.conf.autoload.tabs
                })
            }
        }
    }
    this._fixTabsOfs();
    this.setSizes();
    return this
}
dhtmlXTabBar.prototype._fixTabsOfs = function (a) {};
dhtmlXTabBar.prototype.cells = dhtmlXTabBar.prototype.tabs = function (a) {
    if (this.t[a]) {
        return this.t[a].cell
    }
    return null
};
dhtmlXTabBar.prototype.getAllTabs = function () {
    var g = [];
    for (var c in this.t) {
        g.push(c)
    }
    return g
};
dhtmlXTabBar.prototype._setTabActive = function (c, a) {
    if (!this.t[c] || !this.t[c].conf.visible || this.t[c].conf.active) {
        return
    }
    if (typeof (a) == "undefined") {
        a = true
    }
    if (a == true && this.callEvent("onSelect", [c, this.conf.lastActive]) !== true) {
        return
    }
    this.setTabInActive();
    this.t[c].conf.active = true;
    if (this.conf.contZone) {
        this.t[c].cell.cell.style.visibility = "visible";
        this.t[c].cell.cell.style.top = "0px";
        this.t[c].cell.cell.style.zIndex = 1
    }
    this.t[c].tab.className = this._tabCss(c);
    this.conf.lastActive = c;
    this.setSizes()
};
dhtmlXTabBar.prototype.setTabInActive = function () {
    if (this.conf.lastActive && this.t[this.conf.lastActive]) {
        this.t[this.conf.lastActive].conf.active = false;
        if (this.conf.contZone) {
            this.t[this.conf.lastActive].cell.cell.style.visibility = "hidden";
            this.t[this.conf.lastActive].cell.cell.style.top = "-5000px";
            this.t[this.conf.lastActive].cell.cell.style.zIndex = 0
        }
        this.t[this.conf.lastActive].tab.className = this._tabCss(this.conf.lastActive);
        this.conf.lastActive = null
    }
};
dhtmlXTabBar.prototype._isTabActive = function (a) {
    return (a == this.conf.lastActive && this.conf.lastActive != null)
};
dhtmlXTabBar.prototype.getActiveTab = function () {
    return this.conf.lastActive
};
dhtmlXTabBar.prototype.goToNextTab = function () {
    var a = this._getNextVisible(this.conf.lastActive, true);
    if (a != null) {
        this._setTabActive(a)
    }
};
dhtmlXTabBar.prototype.goToPrevTab = function () {
    var a = this._getPrevVisible(this.conf.lastActive, true);
    if (a != null) {
        this._setTabActive(a)
    }
};
dhtmlXTabBar.prototype._enableTab = function (c, a) {
    if (!this.t[c] || this.t[c].conf.enabled) {
        return
    }
    this.t[c].conf.enabled = true;
    this.t[c].tab.className = this._tabCss(c);
    if (a == true) {
        this._setTabActive(c)
    }
};
dhtmlXTabBar.prototype._disableTab = function (c, a) {
    if (!this.t[c] || !this.t[c].conf.enabled) {
        return
    }
    this.t[c].conf.enabled = false;
    this.t[c].tab.className = this._tabCss(c);
    if (a !== false && this.conf.lastActive == c) {
        if (a == true) {
            a = this._getNextVisible(c) || this._getPrevVisible(c)
        }
        this._setTabActive(a)
    }
};
dhtmlXTabBar.prototype._isTabEnabled = function (a) {
    return (this.t[a] != null && this.t[a].conf.enabled == true)
};
dhtmlXTabBar.prototype._setTabText = function (h, g, c) {
    if (!this.t[h]) {
        return
    }
    var a = false;
    if (typeof (c) == "undefined" || c == null) {
        c = this._getLabelWidth(g, this.t[h].conf.close);
        a = true
    }
    this.t[h].tab.style.width = c + "px";
    this.t[h].tab.childNodes[0].innerHTML = g;
    this.t[h].conf.text = g;
    this.t[h].conf.width = c;
    this.t[h].conf.autowidth = a
};
dhtmlXTabBar.prototype._getTabText = function (a) {
    if (!this.t[a]) {
        return null
    }
    return this.t[a].conf.text
};
dhtmlXTabBar.prototype._removeTab = function (n, g, l) {
    if (!this.t[n]) {
        return
    }
    if (l != true && this.t[n].conf.remove != true) {
        this.t[n].conf.remove = true;
        this._hideTab(n, g);
        return
    }
    if (typeof (g) == "undefined") {
        g = true
    }
    var h = this._getNextVisible(n);
    var j = this._getPrevVisible(n);
    if (this.t[n].conf.transEv == true) {
        this.t[n].tab.removeEventListener(this.conf.transEv, this._doOnTrEnd);
        this.t[n].conf.transEv = false
    }
    for (var c in this.t[n].conf) {
        this.t[n].conf[c] = null
    }
    this.t[n].conf = null;
    delete this.t[n].conf;
    this.t[n].cell._unload();
    this.t[n].cell = null;
    this.t[n].tab.parentNode.removeChild(this.t[n].tab);
    this.t[n].tab = null;
    this.t[n] = null;
    delete this.t[n];
    if (this.conf.lastActive == n && g != false) {
        this.conf.lastActive = null;
        var m = (g == true ? (h || j || this._getFirstVisible()) : g);
        if (m != null) {
            this._setTabActive(m)
        }
    } else {
        if (l != true) {
            this._adjustTabs()
        }
    }
};
dhtmlXTabBar.prototype.clearAll = function () {
    for (var c in this.t) {
        this._removeTab(c, false, true)
    }
    this.tabsArea.childNodes[1].childNodes[0].style[this.conf.align] = "0px"
};
dhtmlXTabBar.prototype.moveTab = function (g, a) {
    if (!this.t[g] || a < 0) {
        return
    }
    a += 1;
    var c = this.tabsArea.childNodes[1].firstChild;
    if (c.childNodes[a] != this.t[g].tab) {
        c.removeChild(this.t[g].tab);
        if (a >= c.childNodes.length) {
            c.appendChild(this.t[g].tab)
        } else {
            c.insertBefore(this.t[g].tab, c.childNodes[a])
        }
    }
    c = null
};
dhtmlXTabBar.prototype._getIndex = function (h) {
    var a = -1;
    var g = this.tabsArea.childNodes[1].firstChild;
    for (var c = 1; c < g.childNodes.length; c++) {
        if (g.childNodes[c]._tabId == h) {
            a = c - 1
        }
    }
    g = null;
    return a
};
dhtmlXTabBar.prototype.getNumberOfTabs = function (h) {
    var g = 0;
    for (var c in this.t) {
        g += (h != true ? 1 : (this.t[c].conf.visible == true ? 1 : 0))
    }
    return g
};
dhtmlXTabBar.prototype.forEachCell = dhtmlXTabBar.prototype.forEachTab = function (g) {
    for (var c in this.t) {
        g.apply(window, [this.t[c].cell])
    }
};
dhtmlXTabBar.prototype.enableAutoReSize = function () {
    this._initFullScreenResize()
};
window.dhtmlXTabBarCell = function (h, g) {
    dhtmlXCellObject.apply(this, [h, "_tabbar"]);
    this.tabbar = g;
    this.conf.skin = this.tabbar.conf.skin;
    this.conf.tabbar_funcs = {
        show: "_showTab",
        hide: "_hideTab",
        isVisible: "_isTabVisible",
        enable: "_enableTab",
        disable: "_disableTab",
        isEnabled: "_isTabEnabled",
        getIndex: "_getIndex",
        getText: "_getTabText",
        setText: "_setTabText",
        setActive: "_setTabActive",
        isActive: "_isTabActive",
        close: "_removeTab"
    };
    this._tabbarCall = function (a) {
        return function () {
            var j = [this._idd];
            for (var l = 0; l < arguments.length; l++) {
                j.push(arguments[l])
            }
            return this.tabbar[a].apply(this.tabbar, j)
        }
    };
    for (var c in this.conf.tabbar_funcs) {
        this[c] = this._tabbarCall(this.conf.tabbar_funcs[c])
    }
    this.attachEvent("_onCellUnload", function () {
        this.tabbar = null;
        for (var j in this.conf.tabbar_funcs) {
            this[j] = null;
            this.conf.tabbar_funcs[j] = null
        }
        this.conf.tabbar_funcs = null
    });
    this.attachEvent("_onContentLoaded", function () {
        this.tabbar._callMainEvent("onContentLoaded", arguments);
        this.tabbar._callMainEvent("onTabContentLoaded", arguments)
    });
    this.attachEvent("_onContentAttach", function () {
        this.tabbar._adjustCell(this.tabbar.conf.lastActive)
    })
};
window.dhtmlXTabBarCell.prototype = new dhtmlXCellObject();

function dhtmlXTabBarInitFromHTML() {
    var z = document.getElementsByTagName("div");
    for (var i = 0; i < z.length; i++) {
        if (z[i].className.indexOf("dhtmlxTabBar") != -1) {
            var conf = {
                settings: {},
                tabs: []
            };
            var n = z[i];
            var id = n.id;
            n.className = "";
            var k = new Array();
            for (var j = 0; j < n.childNodes.length; j++) {
                if (n.childNodes[j].tagName && n.childNodes[j].tagName != "!") {
                    k[k.length] = n.childNodes[j]
                }
            }
            var skin = n.getAttribute("skin");
            if (skin != null) {
                conf.settings.skin = skin
            }
            var w = new dhtmlXTabBar({
                parent: id,
                mode: n.getAttribute("mode")
            });
            window[id] = w;
            acs = n.getAttribute("onbeforeinit");
            if (acs) {
                eval(acs)
            }
            align = n.getAttribute("align");
            if (align) {
                conf.settings.align = align
            }
            var cont = {};
            for (var j = 0; j < k.length; j++) {
                var m = k[j];
                var tab = {
                    id: m.id,
                    text: m.getAttribute("name"),
                    width: m.getAttribute("width"),
                    selected: m.getAttribute("selected"),
                    active: m.getAttribute("active"),
                    close: m.getAttribute("close")
                };
                var href = m.getAttribute("href");
                if (href) {
                    cont[m.id] = {
                        href: href
                    }
                } else {
                    cont[m.id] = {
                        cont: m
                    }
                }
                conf.tabs.push(tab)
            }
            w.loadStruct(conf);
            for (var a in cont) {
                if (cont[a].href) {
                    w.cells(a).attachURL(cont[a].href);
                    cont[a].href = null
                } else {
                    w.cells(a).attachObject(cont[a].cont);
                    if (cont[a].cont.style.display == "none") {
                        cont[a].cont.style.display = ""
                    }
                    cont[a].cont = null
                }
                cont[a] = null
            }
            var selId = n.getAttribute("select");
            if (selId != null) {
                w.tabs(selId).setActive()
            } else {
                if (w.getActiveTab() == null) {
                    var v = w._getFirstVisible();
                    if (v != null) {
                        w.cells(v).setActive()
                    }
                }
            }
            acs = n.getAttribute("oninit");
            if (acs) {
                eval(acs)
            }
        }
    }
    if (typeof (window.addEventListener) == "function") {
        window.removeEventListener("load", dhtmlXTabBarInitFromHTML, false)
    } else {
        window.detachEvent("onload", dhtmlXTabBarInitFromHTML)
    }
}
if (typeof (window.addEventListener) == "function") {
    window.addEventListener("load", dhtmlXTabBarInitFromHTML, false)
} else {
    window.attachEvent("onload", dhtmlXTabBarInitFromHTML)
}
function dhtmlXWindows(n) {
    var l = this;
    var h = {};
    if (typeof (n) != "undefined") {
        for (var g in n) {
            h[g] = n[g]
        }
    }
    n = null;
    this.conf = {
        skin: window.dhx4.skin || (typeof (dhtmlx) != "undefined" ? dhtmlx.skin : null) || window.dhx4.skinDetect("dhxwins") || "dhx_skyblue",
        vp_pos_ofs: 20,
        vp_custom: false,
        ofs_w: null,
        ofs_h: null,
        button_last: null,
        dblclick_tm: 300,
        dblclick_last: null,
        dblclick_id: null,
        dblclick_mode: "minmax",
        dblclick_active: false,
        dblclick_ev: (navigator.userAgent.indexOf("MSIE 6.0") >= 0 || navigator.userAgent.indexOf("MSIE 7.0") >= 0 || navigator.userAgent.indexOf("MSIE 8.0") >= 0),
        fr_cover: (navigator.userAgent.indexOf("MSIE 6.0") >= 0)
    };
    var c = window.dhx4.transDetect();
    this.conf.tr = {
        prop: c.transProp,
        ev: c.transEv,
        height_open: "height 0.2s cubic-bezier(0.25,0.1,0.25,1)",
        height_close: "height 0.18s cubic-bezier(0.25,0.1,0.25,1)",
        op_open: "opacity 0.16s ease-in",
        op_close: "opacity 0.2s ease-out",
        op_v_open: "1",
        op_v_close: "0.4"
    };
    if (!h.viewport) {
        this.attachViewportTo(document.body)
    } else {
        if (h.viewport.object != null) {
            this.attachViewportTo(h.viewport.object)
        } else {
            if (h.viewport.left != null && h.viewport.top != null && h.viewport.width != null && h.viewport.height != null) {
                this.setViewport(h.viewport.left, h.viewport.top, h.viewport.width, h.viewport.height, h.viewport.parent)
            } else {
                this.attachViewportTo(document.body)
            }
        }
    }
    this.w = {};
    this.createWindow = function (q, F, D, s, I) {
        var o = {};
        if (arguments.length == 1 && typeof (q) == "object") {
            o = q
        } else {
            o.id = q;
            o.left = F;
            o.top = D;
            o.width = s;
            o.height = I;
            if (typeof (o.id) == "undefined" || o.id == null) {
                o.id = window.dhx4.newId()
            }
            while (this.w[o.id] != null) {
                o.id = window.dhx4.newId()
            }
        }
        if (o.left == null) {
            o.left = 0
        }
        if (o.top == null) {
            o.top = 0
        }
        o.move = (o.move != null && window.dhx4.s2b(o.move) == false ? false : (o.deny_move != null && window.dhx4.s2b(o.deny_move) == true ? false : true));
        o.park = (o.park != null && window.dhx4.s2b(o.park) == false ? false : (o.deny_park != null && window.dhx4.s2b(o.deny_park) == true ? false : true));
        o.resize = (o.resize != null && window.dhx4.s2b(o.resize) == false ? false : (o.deny_resize != null && window.dhx4.s2b(o.deny_resize) == true ? false : true));
        o.keep_in_viewport = (o.keep_in_viewport != null && window.dhx4.s2b(o.keep_in_viewport));
        o.modal = (o.modal != null && window.dhx4.s2b(o.modal));
        o.center = (o.center != null && window.dhx4.s2b(o.center));
        o.text = (o.text != null ? o.text : (o.caption != null ? o.caption : "dhtmlxWindow"));
        o.header = (!(o.header != null && window.dhx4.s2b(o.header) == false));
        var J = document.createElement("DIV");
        J.className = "dhxwin_active";
        J.style.viosibility = "hidden";
        this.vp.appendChild(J);
        J._isWindow = true;
        J._idd = o.id;
        var w = document.createElement("DIV");
        w.className = "dhxwin_hdr";
        w.style.zIndex = 0;
        w.innerHTML = "<div class='dhxwin_icon'></div><div class='dhxwin_text'><div class='dhxwin_text_inside'>" + o.text + "</div></div><div class='dhxwin_btns'></div>";
        J.appendChild(w);
        w.onselectstart = function (a) {
            a = a || event;
            if (a.preventDefault) {
                a.preventDefault()
            } else {
                a.returnValue = false
            }
            return false
        };
        w.oncontextmenu = function (a) {
            a = a || event;
            a.cancelBubble = true;
            return false
        };
        w._isWinHdr = true;
        w.firstChild._isWinIcon = true;
        var u = document.createElement("DIV");
        u.className = "dhxwin_brd";
        J.appendChild(u);
        var C = document.createElement("DIV");
        C.className = "dhxwin_fr_cover";
        C.innerHTML = "<iframe class='dhxwin_fr_cover_inner' frameborder='0' border='0'></iframe><div class='dhxwin_fr_cover_inner'></div>";
        J.appendChild(C);
        this.w[o.id] = {
            win: J,
            hdr: w,
            brd: u,
            fr_cover: C,
            b: {},
            conf: {
                z_id: window.dhx4.newId(),
                actv: false,
                modal: false,
                maxed: false,
                parked: false,
                sticked: false,
                visible: true,
                header: true,
                text: o.text,
                keep_in_vp: o.keep_in_viewport,
                allow_move: o.move,
                allow_park: o.park,
                allow_resize: o.resize,
                max_w: null,
                max_h: null,
                min_w: 80,
                min_h: 80
            }
        };
        var v = {
            help: {
                title: "Help",
                visible: false
            },
            stick: {
                title: "Stick",
                visible: false
            },
            park: {
                title: "Park",
                visible: true
            },
            minmax: {
                title: "Min/Max",
                visible: true
            },
            close: {
                title: "Close",
                visible: true
            }
        };
        for (var E in v) {
            var A = new dhtmlXWindowsButton(this, o.id, E, v[E].title, false);
            if (v[E].visible == false) {
                A.hide()
            }
            w.lastChild.appendChild(A.button);
            this.w[o.id].b[E] = A;
            A = null
        }
        this._winAdjustTitle(o.id);
        this.w[o.id].win.style.zIndex = window.dhx4.zim.reserve(this.w[o.id].conf.z_id);
        var H = new dhtmlXWindowsCell(o.id, this);
        this.w[o.id].win.insertBefore(H.cell, C);
        this.w[o.id].cell = H;
        if (typeof (window.addEventListener) == "function") {
            this.w[o.id].win.addEventListener("mousedown", this._winOnMouseDown, false);
            this.w[o.id].win.addEventListener("mouseup", this._winOnMouseDown, false);
            if (this.conf.dblclick_ev) {
                this.w[o.id].win.addEventListener("dblclick", this._winOnMouseDown, false)
            }
        } else {
            this.w[o.id].win.attachEvent("onmousedown", this._winOnMouseDown);
            this.w[o.id].win.attachEvent("onmouseup", this._winOnMouseDown);
            if (this.conf.dblclick_ev) {
                this.w[o.id].win.attachEvent("ondblclick", this._winOnMouseDown)
            }
        }
        this._winInitFRM(o.id);
        this._winSetPosition(o.id, o.left, o.top);
        this._winSetSize(o.id, o.width, o.height);
        this._winMakeActive(o.id);
        if (o.center == true) {
            this.w[o.id].cell.center()
        }
        if (o.modal == true) {
            this.w[o.id].cell.setModal(true)
        }
        if (o.header == false) {
            this.w[o.id].cell.hideHeader()
        }
        f = J = w = u = C = H = null;
        return this.w[o.id].cell
    };
    this._winOnMouseDown = function (q) {
        q = q || event;
        var a = q.target || q.srcElement;
        var o = {
            press_type: q.type
        };
        while (a != null && a._isWindow != true) {
            if (typeof (a.className) != "undefined" && o.mode == null) {
                if (typeof (a._buttonName) != "undefined") {
                    o.mode = "button";
                    o.button_name = a._buttonName
                } else {
                    if (a._isWinHdr == true) {
                        o.mode = "hdr"
                    } else {
                        if (a._isWinIcon == true) {
                            o.mode = "icon"
                        }
                    }
                }
            }
            a = a.parentNode
        }
        if (o.mode == null) {
            o.mode = "win"
        }
        o.id = (a != null && a._isWindow == true ? a._idd : null);
        a = null;
        if (o.id != null) {
            l.callEvent("_winMouseDown", [q, o])
        }
    };
    this._winOnParkTrans = function (o) {
        if (o.stopPropagation) {
            o.stopPropagation()
        }
        var a = l.w[this._idd];
        if (o.propertyName == "opacity") {
            l._winCellClearOpacity(this._idd)
        }
        if (o.propertyName == "height" && a.conf.tr_mode == "park") {
            if (a.conf.tr_mode == "park") {
                a.win.style[l.conf.tr.prop] = "";
                if (!a.conf.parked) {
                    l._winAdjustCell(this._idd);
                    l._callMainEvent("onParkDown", this._idd);
                    if (a.conf.keep_in_vp) {
                        l._winAdjustPosition(this._idd, a.conf.x, a.conf.y)
                    }
                } else {
                    a.hdr.style.zIndex = 3;
                    l._callMainEvent("onParkUp", this._idd)
                }
            }
        }
        a = null
    };
    this.unload = function () {
        this.conf.unloading = true;
        if (this._dndInitModule) {
            this._dndUnloadModule()
        }
        for (var o in this.w) {
            this._winClose(o)
        }
        this.w = null;
        if (this.cm != null && typeof (this._unloadContextMenu) == "function") {
            this._unloadContextMenu()
        }
        window.dhx4._eventable(this, "clear");
        this.attachViewportTo(null);
        for (var o in this.conf) {
            this.conf[o] = null;
            delete this.conf[o]
        }
        for (var o in this) {
            this[o] = null
        }
        l = o = null
    };
    window.dhx4._eventable(this);
    this.attachEvent("_winMouseDown", this._winMouseDownHandler);
    if (this._dndInitModule) {
        this._dndInitModule()
    }
    if (h.wins != null) {
        for (var m = 0; m < h.wins.length; m++) {
            var j = h.wins[m];
            this.createWindow(j)
        }
    }
    h = null;
    return this
}
dhtmlXWindows.prototype.forEachWindow = function (g) {
    for (var c in this.w) {
        g.apply(window, [this.w[c].cell])
    }
};
dhtmlXWindows.prototype.window = function (a) {
    if (this.w[a] != null) {
        return this.w[a].cell
    }
    return null
};
dhtmlXWindows.prototype.isWindow = function (a) {
    return (this.w[a] != null)
};
dhtmlXWindows.prototype.findByText = function (h) {
    var g = [];
    for (var c in this.w) {
        if ((this.w[c].cell.getText()).indexOf(String(h)) >= 0) {
            g.push(this.w[c])
        }
    }
    return g
};
dhtmlXWindows.prototype.setSkin = function (g) {
    if (g == this.conf.skin) {
        return
    }
    if (this.vp != null) {
        this.vp.className = String(this.vp.className).replace("dhxwins_vp_" + this.conf.skin, " dhxwins_vp_" + g)
    }
    for (var c in this.w) {
        this.w[c].cell._resetSizeState();
        this._winAdjustCell(c);
        this._winAdjustTitle(c)
    }
    this.conf.skin = g
};
dhtmlXWindows.prototype.getBottommostWindow = function () {
    return this._getTopBottomWin(false)
};
dhtmlXWindows.prototype.getTopmostWindow = function () {
    return this._getTopBottomWin(true)
};
dhtmlXWindows.prototype._getTopBottomWin = function (j) {
    var h = null;
    for (var c in this.w) {
        if (this.w[c].conf.visible) {
            var g = false;
            if (h != null) {
                g = h.z > this.w[c].win.style.zIndex;
                if (j) {
                    g = !g
                }
            }
            if (h == null || g) {
                h = {
                    id: c,
                    z: this.w[c].win.style.zIndex
                }
            }
        }
    }
    return (h ? h.id : null)
};
dhtmlXWindows.prototype._winMakeActive = function (g, j) {
    if (g != null && j !== true && this.w[g].conf.actv == true) {
        return
    }
    var v = [];
    var o = [{
        name: "modal",
        value: true
    }, {
        name: "sticked",
        value: true
    }, {
        name: "sticked",
        value: false
    }];
    var n = {};
    for (var c = 0; c < o.length; c++) {
        var m = o[c].name;
        var h = o[c].value;
        var x = [];
        for (var s in this.w) {
            var u = this.w[s];
            if (n[s] == null && u.conf[m] === h && u.conf.visible == true) {
                if (g != s) {
                    window.dhx4.zim.clear(u.conf.z_id);
                    x.push([s, Number(u.win.style.zIndex)]);
                    n[s] = true
                }
            }
            u = null
        }
        x.sort(function (w, q) {
            return (w[1] < q[1] ? 1 : -1)
        });
        if (g != null && this.w[g].conf[m] === h && n[g] == null) {
            window.dhx4.zim.clear(this.w[g].conf.z_id);
            var l = [
                [g, Number(this.w[g].win.style.zIndex)]
            ];
            x = l.concat(x);
            n[g] = true
        }
        v = v.concat(x)
    }
    for (var c = v.length - 1; c >= 0; c--) {
        var s = v[c][0];
        var u = this.w[s];
        u.win.style.zIndex = window.dhx4.zim.reserve(u.conf.z_id);
        if (u.conf.modal && this.mcover != null) {
            for (var r in this.mcover) {
                this.mcover[r].style.zIndex = u.win.style.zIndex
            }
        }
        this._winAdjustFRMZIndex(s);
        if (g == null && c == 0) {
            g = s
        }
        u.conf.actv = (g == s);
        u.win.className = (u.conf.actv ? "dhxwin_active" : "dhxwin_inactive");
        u = null
    }
    if (g != null && this.conf.last_active != g) {
        this._callMainEvent("onFocus", g)
    }
    this.conf.last_active = g
};
dhtmlXWindows.prototype.attachViewportTo = function (g) {
    if (this.conf.vp_custom) {
        while (this.vp.childNodes.length > 0) {
            this.vp.removeChild(this.vp.lastChild)
        }
        this.vp.parentNode.removeChild(this.vp);
        this.vp = null
    } else {
        if (this.vp != null) {
            this.vp.className = String(this.vp.className).replace(new RegExp("\\s{1,}dhxwins_vp_" + this.conf.skin), "")
        }
    }
    if (g == null) {
        this.vp = null
    } else {
        this.vp = (typeof (g) == "string" ? document.getElementById(g) : g);
        this.vp.className += " dhxwins_vp_" + this.conf.skin;
        g = null;
        for (var c in this.w) {
            this.vp.appendChild(this.w[c].win)
        }
        this.conf.vp_custom = false
    }
    if (this.vp == document.body) {
        document.body.style.position = "static"
    }
};
dhtmlXWindows.prototype.setViewport = function (c, l, h, a, j) {
    var g = document.createElement("DIV");
    g.style.position = "absolute";
    g.style.left = c + "px";
    g.style.top = l + "px";
    g.style.width = h + "px";
    g.style.height = a + "px";
    if (typeof (j) == "undefined" || j == null) {
        j = document.body
    } else {
        if (typeof (j) == "string") {
            j = document.getElementById(j)
        }
    }
    j.appendChild(g);
    this.attachViewportTo(g);
    this.conf.vp_custom = true;
    j = g = null
};
dhtmlXWindows.prototype._winSetPosition = function (h, a, g) {
    var c = this.w[h];
    if (c.conf.maxed) {
        c.conf.lastMX += (a - c.conf.x);
        c.conf.lastMY += (g - c.conf.y)
    }
    c.conf.x = a;
    c.conf.y = g;
    c.win.style.left = c.conf.x + "px";
    c.win.style.top = c.conf.y + "px";
    this._winAdjustFRMPosition(h);
    c = null
};
dhtmlXWindows.prototype._winAdjustPosition = function (m, c, l) {
    var g = this.w[m];
    if (typeof (c) == "undefined") {
        c = g.conf.x
    }
    if (typeof (l) == "undefined") {
        l = g.conf.y
    }
    var a = (g.conf.keep_in_vp ? 0 : -g.conf.w + this.conf.vp_pos_ofs);
    var j = (g.conf.keep_in_vp ? this.vp.clientWidth - g.conf.w : this.vp.clientWidth - this.conf.vp_pos_ofs);
    if (c < a) {
        c = a
    } else {
        if (c > j) {
            c = j
        }
    }
    var h = (g.conf.keep_in_vp ? this.vp.clientHeight - g.conf.h : this.vp.clientHeight - this.conf.vp_pos_ofs);
    if (l < 0) {
        l = 0
    } else {
        if (l > h) {
            l = h
        }
    }
    if (c != g.conf.x || l != g.conf.y) {
        this._winSetPosition(m, c, l)
    }
    g = null
};
dhtmlXWindows.prototype._winSetSize = function (n, l, g, m, c) {
    var h = this.w[n];
    var a = (l != null ? l : h.conf.w);
    var j = (g != null ? g : h.conf.h);
    if (this.conf.ofs_w == null) {
        h.win.style.width = a + "px";
        h.win.style.height = j + "px";
        this.conf.ofs_w = h.win.offsetWidth - a;
        this.conf.ofs_h = h.win.offsetHeight - j
    }
    if (h.conf.min_w != null && a < h.conf.min_w) {
        a = h.conf.min_w
    }
    if (h.conf.max_w != null && a > h.conf.max_w) {
        a = h.conf.max_w
    }
    if (!h.conf.parked && h.conf.min_h != null && j < h.conf.min_h) {
        j = h.conf.min_h
    }
    if (h.conf.max_h != null && j > h.conf.max_h) {
        j = h.conf.max_h
    }
    if (h.conf.keep_in_vp) {
        if (a > this.vp.clientWidth) {
            a = this.vp.clientWidth
        }
        if (j > this.vp.clientHeight) {
            j = this.vp.clientHeight
        }
    }
    h.win.style.width = a - this.conf.ofs_w + "px";
    h.win.style.height = j - this.conf.ofs_h + "px";
    h.conf.w = a;
    h.conf.h = j;
    this._winAdjustFRMSize(n);
    if (c) {
        this._winAdjustPosition(n, h.conf.x, h.conf.y)
    }
    if (!h.conf.parked && m != true) {
        this._winAdjustCell(n)
    }
    h = null
};
dhtmlXWindows.prototype._winMinmax = function (j, g) {
    if (typeof (g) != "undefined" && this.w[j].conf.maxed == g) {
        return
    }
    if (this.w[j].conf.allow_resize == false) {
        return
    }
    var c = this.w[j];
    if (c.conf.parked) {
        this._winPark(j, false)
    }
    if (c.conf.maxed) {
        this._winSetSize(j, c.conf.lastMW, c.conf.lastMH);
        this._winAdjustPosition(j, c.conf.lastMX, c.conf.lastMY);
        c.conf.maxed = false
    } else {
        var a = 0;
        var h = 0;
        if (c.conf.max_w != null) {
            a = c.conf.x + Math.round(c.conf.w - c.conf.max_w) / 2
        }
        if (c.conf.max_h != null) {
            h = Math.max(c.conf.y + Math.round(c.conf.h - c.conf.max_h) / 2, 0)
        }
        c.conf.lastMX = c.conf.x;
        c.conf.lastMY = c.conf.y;
        c.conf.lastMW = c.conf.w;
        c.conf.lastMH = c.conf.h;
        this._winSetSize(j, this.vp.clientWidth, this.vp.clientHeight);
        this._winAdjustPosition(j, a, h);
        c.conf.maxed = true
    }
    c.b.minmax.setCss(c.conf.maxed ? "minmaxed" : "minmax");
    if (c.conf.maxed) {
        this._callMainEvent("onMaximize", j)
    } else {
        this._callMainEvent("onMinimize", j)
    }
    c = null
};
dhtmlXWindows.prototype._winShow = function (c, a) {
    if (this.w[c].conf.visible == true) {
        return
    }
    this.w[c].win.style.display = "";
    this.w[c].conf.visible = true;
    if (a == true || this.conf.last_active == null) {
        this._winMakeActive(c, true)
    }
    this._callMainEvent("onShow", c)
};
dhtmlXWindows.prototype._winHide = function (c, a) {
    if (this.w[c].conf.visible == false) {
        return
    }
    this.w[c].win.style.display = "none";
    this.w[c].conf.visible = false;
    if (this.w[c].conf.actv) {
        this.w[c].conf.actv = false;
        this.w[c].win.className = "dhxwin_inactive";
        this._winMakeActive(null, true)
    }
    this._callMainEvent("onHide", c)
};
dhtmlXWindows.prototype._winPark = function (g, a) {
    if (this.w[g].conf.allow_park == false) {
        return
    }
    if (this.w[g].conf.header == false) {
        return
    }
    var c = this.w[g];
    if (a == true && this.conf.tr.prop !== false) {
        c.win.style[this.conf.tr.prop] = this.conf.tr[c.conf.parked ? "height_open" : "height_close"];
        if (!c.conf.tr_ev) {
            c.win.addEventListener(this.conf.tr.ev, this._winOnParkTrans, false);
            c.conf.tr_ev = true
        }
    }
    if (c.conf.parked) {
        c.hdr.className = String(c.hdr.className).replace(/\s{1,}dhxwin_hdr_parked/gi, "");
        c.hdr.style.zIndex = 0;
        c.conf.parked = false;
        c.conf.tr_mode = "park";
        this._winCellSetOpacity(g, "open", a);
        this._winSetSize(g, c.conf.w, c.conf.lastPH, (a == true && this.conf.tr.prop !== false));
        if (!(a == true && this.conf.tr.prop !== false)) {
            this._callMainEvent("onParkDown", g);
            if (c.conf.keep_in_vp) {
                this._winAdjustPosition(g, c.conf.x, c.conf.y)
            }
        }
    } else {
        c.conf.lastPH = c.conf.h;
        c.hdr.className += " dhxwin_hdr_parked";
        if (a == false || this.conf.tr.prop == false) {
            c.hdr.style.zIndex = 3
        }
        c.conf.parked = true;
        c.conf.tr_mode = "park";
        this._winCellSetOpacity(g, "close", a);
        this._winSetSize(g, c.conf.w, c.hdr.offsetHeight + this.conf.ofs_h, (a == true && this.conf.tr.prop !== false));
        if (!(a == true && this.conf.tr.prop !== false)) {
            this._callMainEvent("onParkUp", g)
        }
    }
    c = null
};
dhtmlXWindows.prototype._winCellSetOpacity = function (m, l, g, j) {
    var c = this.w[m].cell;
    for (var h in c.conf.idx) {
        if ({
            pr1: true,
            pr2: true
        }[h] != true) {
            if (g == true && this.conf.tr.prop != false) {
                c.cell.childNodes[c.conf.idx[h]].style[this.conf.tr.prop] = this.conf.tr["op_" + l]
            }
            c.cell.childNodes[c.conf.idx[h]].style.opacity = this.conf.tr["op_v_" + l]
        }
    }
    c = null
};
dhtmlXWindows.prototype._winCellClearOpacity = function (h) {
    var c = this.w[h].cell;
    for (var g in c.conf.idx) {
        if ({
            pr1: true,
            pr2: true
        }[g] != true) {
            if (this.conf.tr.prop != false) {
                c.cell.childNodes[c.conf.idx[g]].style[this.conf.tr.prop] = ""
            }
        }
    }
    c = null
};
dhtmlXWindows.prototype._winStick = function (c, a) {
    if (typeof (a) != "undefined" && this.w[c].conf.sticked == a) {
        return
    }
    this.w[c].conf.sticked = !this.w[c].conf.sticked;
    this.w[c].b.stick.setCss(this.w[c].conf.sticked ? "sticked" : "stick");
    this._winMakeActive(this.conf.last_active, true);
    if (this.w[c].conf.sticked) {
        this._callMainEvent("onStick", c)
    } else {
        this._callMainEvent("onUnStick", c)
    }
};
dhtmlXWindows.prototype._winClose = function (h) {
    if (this._callMainEvent("onClose", h) !== true && this.conf.unloading != true) {
        return
    }
    var g = this.w[h];
    if (g.conf.fs_mode) {
        g.cell.setToFullScreen(false)
    }
    if (g.conf.modal) {
        this._winSetModal(h, false)
    }
    window.dhx4.zim.clear(g.conf.z_id);
    if (this.cm != null && this.cm.icon[h] != null) {
        this._detachContextMenu("icon", h, null)
    }
    if (typeof (window.addEventListener) == "function") {
        g.win.removeEventListener("mousedown", this._winOnMouseDown, false);
        if (this.conf.dblclick_ev) {
            g.win.removeEventListener("dblclick", this._winOnMouseDown, false)
        }
    } else {
        g.win.detachEvent("onmousedown", this._winOnMouseDown);
        if (this.conf.dblclick_ev) {
            g.win.attachEvent("ondblclick", this._winOnMouseDown)
        }
    }
    for (var c in g.b) {
        this._winRemoveButton(h, c, true)
    }
    g.b = null;
    g.cell._unload();
    g.cell = null;
    g.brd.parentNode.removeChild(g.brd);
    g.brd = null;
    if (g.fr_cover != null) {
        g.fr_cover.parentNode.removeChild(g.fr_cover);
        g.fr_cover = null
    }
    if (g.fr_m_cover != null) {
        g.fr_m_cover.parentNode.removeChild(g.fr_m_cover);
        g.fr_m_cover = null
    }
    g.hdr._isWinHdr = true;
    g.hdr.firstChild._isWinIcon = true;
    g.hdr.onselectstart = null;
    g.hdr.parentNode.removeChild(g.hdr);
    g.hdr = null;
    for (var c in g.conf) {
        g.conf[c] = null;
        delete g.conf[c]
    }
    g.conf = null;
    g.win._idd = null;
    g.win._isWindow = null;
    g.win.parentNode.removeChild(g.win);
    g.win = null;
    g = null;
    this.w[h] = null;
    delete this.w[h];
    if (!this.conf.unloading) {
        this._winMakeActive(null, true)
    }
};
dhtmlXWindows.prototype._winSetModal = function (m, h, l) {
    if (this.w[m].conf.modal == h) {
        return
    }
    if (typeof (l) == "undefined") {
        l = true
    }
    var g = this.w[m];
    if (h == true && g.conf.modal == false) {
        if (this.conf.last_modal != null) {
            this._winSetModal(this.conf.last_modal, false, false)
        }
        if (this.mcover == null) {
            var j = document.createElement("DIV");
            j.className = "dhxwins_mcover";
            this.vp.insertBefore(j, g.fr_m_cover || g.win);
            this.mcover = {
                d: j
            };
            if (this.conf.fr_cover) {
                this.mcover.f = document.createElement("IFRAME");
                this.mcover.f.className = "dhxwins_mcover";
                this.mcover.f.border = 0;
                this.mcover.f.frameBorder = 0;
                this.vp.insertBefore(this.mcover.f, j)
            }
            j = null
        } else {
            if (this.mcover.d.nextSibling != (g.fr_m_cover || g.win)) {
                this.vp.insertBefore(this.mcover.d, g.fr_m_cover || g.win);
                if (this.mcover.f != null) {
                    this.vp.insertBefore(this.mcover.f, this.mcover.d)
                }
            }
        }
        g.conf.modal = true;
        this.conf.last_modal = m;
        this._winMakeActive(m, true)
    } else {
        if (h == false && g.conf.modal == true) {
            g.conf.modal = false;
            this.conf.last_modal = null;
            if (l && this.mcover != null) {
                for (var c in this.mcover) {
                    this.vp.removeChild(this.mcover[c]);
                    this.mcover[c] = null
                }
                this.mcover = null
            }
        }
    }
    g = null
};
dhtmlXWindows.prototype._winMouseDownHandler = function (g, c) {
    var a = g.target || g.srcElement;
    if (g.button >= 2) {
        return
    }
    if (c.mode == "button") {
        if (c.press_type == "mousedown") {
            this.conf.button_last = c.button_name
        } else {
            if (c.press_type == "mouseup" && c.button_name == this.conf.button_last) {
                this.conf.button_last = null;
                if (this._winButtonClick(c.id, c.button_name, g) !== true) {
                    return
                }
            }
        }
    }
    if ((c.press_type == "mousedown" || c.press_type == "dblclick") && c.mode == "hdr") {
        this.conf.dblclick_active = false;
        if (this.conf.dblclick_ev == true) {
            if (c.press_type == "dblclick") {
                this.conf.dblclick_active = true
            }
        } else {
            if (this.conf.dblclick_last == null) {
                this.conf.dblclick_last = new Date().getTime();
                this.dblclick_id = c.id
            } else {
                var a = new Date().getTime();
                if (this.conf.dblclick_last + this.conf.dblclick_tm > a && this.dblclick_id == c.id) {
                    this.conf.dblclick_active = true;
                    this.conf.dblclick_last = null;
                    this.dblclick_id = null
                } else {
                    this.conf.dblclick_last = a;
                    this.dblclick_id = c.id
                }
            }
        }
        if (this.conf.dblclick_active) {
            this._winDoHeaderDblClick(c.id);
            return
        }
    }
    if (c.press_type == "mousedown") {
        this._winMakeActive(c.id)
    }
};
dhtmlXWindows.prototype._winDoHeaderDblClick = function (a) {
    if (this.conf.dblclick_mode == "minmax") {
        this._winMinmax(a);
        return
    }
    if (this.conf.dblclick_mode == "park") {
        this._winPark(a, true);
        return
    }
    if (typeof (this.conf.dblclick_mode) == "function") {
        this.conf.dblclick_mode.apply(window, [a]);
        return
    }
    if (typeof (window[this.conf.dblclick_mode]) == "function") {
        window[this.conf.dblclick_mode].apply(window, [a]);
        return
    }
};
dhtmlXWindows.prototype._winAdjustCell = function (c) {
    var q = this.w[c];
    var o = 1;
    var n = (q.conf.header ? q.hdr.offsetHeight : 1);
    var h = q.win.clientWidth - 2;
    var r = q.win.clientHeight - n - 1;
    q.brd.style.left = o + "px";
    q.brd.style.top = n + "px";
    if (q.conf.brd == null) {
        q.brd.style.width = h + "px";
        q.brd.style.height = r + "px";
        q.conf.brd = {
            w: h - q.brd.offsetWidth,
            h: r - q.brd.offsetHeight
        }
    }
    q.brd.style.width = h + q.conf.brd.w + "px";
    q.brd.style.height = r + q.conf.brd.h + "px";
    var g = 5;
    var a = 1 + g;
    var m = (q.conf.header ? n : n + g);
    var j = q.brd.clientWidth;
    var l = q.brd.clientHeight;
    q.cell._setSize(a, m, j, l);
    q.fr_cover.style.left = a + "px";
    q.fr_cover.style.top = m + "px";
    q.fr_cover.style.width = j + "px";
    q.fr_cover.style.height = l + "px";
    q = null
};
dhtmlXWindows.prototype._winAdjustTitle = function (h) {
    var a = this.w[h].hdr.childNodes[0];
    var g = this.w[h].hdr.childNodes[1];
    var c = this.w[h].hdr.childNodes[2];
    g.style.paddingLeft = a.offsetWidth + 12 + "px";
    g.style.paddingRight = c.offsetWidth + 10 + "px";
    g = c = a = null
};
dhtmlXWindows.prototype._callMainEvent = function (c, h) {
    var a = this.w[h];
    if (a.cell.checkEvent(c)) {
        var g = a.cell._callMainEvent(c, [a.cell])
    } else {
        var g = this.callEvent(c, [a.cell])
    }
    a = null;
    return g
};
dhtmlXWindows.prototype._winInitFRM = function (g) {
    if (this.conf.fr_cover != true) {
        return
    }
    var a = this.w[g];
    var c = document.createElement("IFRAME");
    c.className = "dhxwin_main_fr_cover";
    c.border = 0;
    c.frameBorder = 0;
    c.style.zIndex = a.win.style.zIndex;
    a.win.parentNode.insertBefore(c, a.win);
    a.fr_m_cover = c;
    c = null
};
dhtmlXWindows.prototype._winAdjustFRMSize = function (c) {
    var a = this.w[c];
    if (a.fr_m_cover != null) {
        a.fr_m_cover.style.width = a.conf.w + "px";
        a.fr_m_cover.style.height = a.conf.h + "px"
    }
    a = null
};
dhtmlXWindows.prototype._winAdjustFRMPosition = function (c) {
    var a = this.w[c];
    if (a.fr_m_cover != null) {
        a.fr_m_cover.style.left = a.win.style.left;
        a.fr_m_cover.style.top = a.win.style.top
    }
    a = null
};
dhtmlXWindows.prototype._winAdjustFRMZIndex = function (c) {
    var a = this.w[c];
    if (a.fr_m_cover != null) {
        a.fr_m_cover.style.zIndex = a.win.style.zIndex
    }
    a = null
};

function dhtmlXWindowsCell(j, h) {
    dhtmlXCellObject.apply(this, [j, "_wins"]);
    this.wins = h;
    this.cell._winId = j;
    this.conf.skin = this.wins.conf.skin;
    this.attachEvent("_onCellUnload", function () {
        if (this._unloadResize) {
            this._unloadResize()
        }
        window.dhx4._eventable(this.cell, "clear");
        this.cell._winId = null;
        this.wins = null;
        this.setText = null;
        this.getText = null;
        this.allowMove = null;
        this.denyMove = null;
        this.isMovable = null;
        this.allowResize = null;
        this.denyResize = null;
        this.isResizable = null;
        this.maximize = null;
        this.minimize = null;
        this.isMaximized = null;
        this.setPosition = null;
        this.getPosition = null;
        this.adjustPosition = null;
        this.park = null;
        this.isParked = null;
        this.allowPark = null;
        this.denyPark = null;
        this.isParkable = null;
        this.show = null;
        this.hide = null;
        this.isHidden = null;
        this.stick = null;
        this.unstick = null;
        this.isSticked = null;
        this.setDimension = null;
        this.getDimension = null;
        this.setMinDimension = null;
        this.getMinDimension = null;
        this.setMaxDimension = null;
        this.getMaxDimension = null;
        this.keepInViewport = null;
        this.center = null;
        this.centerOnScreen = null;
        this.bringToTop = null;
        this.bringToBottom = null;
        this.isOnTop = null;
        this.isOnBottom = null;
        this.showHeader = null;
        this.hideHeader = null;
        this.setModal = null;
        this.isModal = null;
        this.close = null;
        this._adjustByCont = null;
        this.button = null;
        this.addUserButton = null;
        this.removeUserButton = null;
        g = null
    });
    this.attachEvent("_onContentLoaded", function () {
        this.wins._callMainEvent("onContentLoaded", this._idd)
    });
    this.attachEvent("_onContentMouseDown", function (l, a) {
        this.wins.callEvent("_winMouseDown", [a,
        {
            id: l,
            mode: "win"
        }])
    });
    this._callMainEvent = function (l, a) {
        return this.callEvent(l, a)
    };
    this.conf.tr = {};
    for (var c in this.wins.conf.tr) {
        this.conf.tr[c] = this.wins.conf.tr[c]
    }
    if (this.conf.tr.prop != false) {}
    if (this._initResize) {
        this._initResize()
    }
    window.dhx4._eventable(this.cell);
    var g = this;
    this.cell.attachEvent("_setCellSize", function (a, n) {
        var l = g.wins.w[this._winId].conf.w - g.conf.size.w;
        var m = g.wins.w[this._winId].conf.h - g.conf.size.h;
        g.setDimension(a + l, n + m)
    });
    return this
}
dhtmlXWindowsCell.prototype = new dhtmlXCellObject();
dhtmlXWindowsCell.prototype.setText = function (a) {
    this.wins.w[this._idd].conf.text = a;
    this.wins.w[this._idd].hdr.childNodes[1].firstChild.innerHTML = a
};
dhtmlXWindowsCell.prototype.getText = function () {
    return this.wins.w[this._idd].conf.text
};
dhtmlXWindowsCell.prototype.allowMove = function () {
    this.wins.w[this._idd].conf.allow_move = true
};
dhtmlXWindowsCell.prototype.denyMove = function () {
    this.wins.w[this._idd].conf.allow_move = false
};
dhtmlXWindowsCell.prototype.isMovable = function () {
    return (this.wins.w[this._idd].conf.allow_move == true)
};
dhtmlXWindowsCell.prototype.allowResize = function () {
    this.wins.w[this._idd].conf.allow_resize = true;
    this.wins.w[this._idd].b.minmax.enable()
};
dhtmlXWindowsCell.prototype.denyResize = function () {
    this.wins.w[this._idd].conf.allow_resize = false;
    this.wins.w[this._idd].b.minmax.disable()
};
dhtmlXWindowsCell.prototype.isResizable = function () {
    return (this.wins.w[this._idd].conf.allow_resize == true)
};
dhtmlXWindowsCell.prototype.maximize = function () {
    this.wins._winMinmax(this._idd, true)
};
dhtmlXWindowsCell.prototype.minimize = function () {
    this.wins._winMinmax(this._idd, false)
};
dhtmlXWindowsCell.prototype.isMaximized = function () {
    return (this.wins.w[this._idd].conf.maxed == true)
};
dhtmlXWindowsCell.prototype.setPosition = function (a, c) {
    this.wins._winSetPosition(this._idd, a, c)
};
dhtmlXWindowsCell.prototype.getPosition = function () {
    var a = this.wins.w[this._idd];
    var c = [a.conf.x, a.conf.y];
    a = null;
    return c
};
dhtmlXWindowsCell.prototype.adjustPosition = function () {
    this.wins._winAdjustPosition(this._idd)
};
dhtmlXWindowsCell.prototype.park = function () {
    this.wins._winPark(this._idd, true)
};
dhtmlXWindowsCell.prototype.isParked = function () {
    return (this.wins.w[this._idd].conf.parked == true)
};
dhtmlXWindowsCell.prototype.allowPark = function () {
    this.wins.w[this._idd].conf.allow_park = true;
    this.wins.w[this._idd].b.park.enable()
};
dhtmlXWindowsCell.prototype.denyPark = function () {
    this.wins.w[this._idd].conf.allow_park = false;
    this.wins.w[this._idd].b.park.disable()
};
dhtmlXWindowsCell.prototype.isParkable = function () {
    return (this.wins.w[this._idd].conf.allow_park == true)
};
dhtmlXWindowsCell.prototype.show = function (a) {
    this.wins._winShow(this._idd, window.dhx4.s2b(a))
};
dhtmlXWindowsCell.prototype.hide = function () {
    this.wins._winHide(this._idd)
};
dhtmlXWindowsCell.prototype.isHidden = function () {
    return (this.wins.w[this._idd].conf.visible != true)
};
dhtmlXWindowsCell.prototype.stick = function () {
    this.wins._winStick(this._idd, true)
};
dhtmlXWindowsCell.prototype.unstick = function () {
    this.wins._winStick(this._idd, false)
};
dhtmlXWindowsCell.prototype.isSticked = function () {
    return (this.wins.w[this._idd].conf.sticked == true)
};
dhtmlXWindowsCell.prototype.setDimension = function (g, a) {
    var c = this.wins.w[this._idd];
    if (c.conf.parked) {
        this.wins._winPark(this._idd, false)
    }
    if (c.conf.maxed) {
        if (g != null) {
            c.conf.lastMW = g
        }
        if (a != null) {
            c.conf.lastMH = a
        }
        this.wins._winMinmax(this._idd)
    } else {
        this.wins._winSetSize(this._idd, g, a, false, true)
    }
    c = null
};
dhtmlXWindowsCell.prototype.getDimension = function () {
    var a = this.wins.w[this._idd];
    var c = [a.conf.w, a.conf.h];
    a = null;
    return c
};
dhtmlXWindowsCell.prototype.setMinDimension = function (g, a) {
    var c = this.wins.w[this._idd];
    c.conf.min_w = g;
    c.conf.min_h = a;
    this.wins._winSetSize(this._idd, c.conf.w, c.conf.h);
    c = null
};
dhtmlXWindowsCell.prototype.getMinDimension = function () {
    var a = this.wins.w[this._idd];
    var c = [a.conf.min_w, a.conf.min_h];
    a = null;
    return c
};
dhtmlXWindowsCell.prototype.setMaxDimension = function (g, a) {
    var c = this.wins.w[this._idd];
    c.conf.max_w = g;
    c.conf.max_h = a;
    this.wins._winSetSize(this._idd, c.conf.w, c.conf.h);
    c = null
};
dhtmlXWindowsCell.prototype.getMaxDimension = function () {
    var a = this.wins.w[this._idd];
    var c = [a.conf.max_w, a.conf.max_h];
    a = null;
    return c
};
dhtmlXWindowsCell.prototype.keepInViewport = function (a) {
    this.wins.w[this._idd].conf.keep_in_vp = window.dhx4.s2b(a)
};
dhtmlXWindowsCell.prototype.center = function () {
    var g = this.wins.vp;
    var c = this.wins.w[this._idd];
    var a = Math.round((g.clientWidth - c.conf.w) / 2);
    var h = Math.round((g.clientHeight - c.conf.h) / 2);
    this.wins._winSetPosition(this._idd, a, h);
    g = c = null
};
dhtmlXWindowsCell.prototype.centerOnScreen = function () {
    var c = this.wins.w[this._idd];
    var l = window.dhx4.screenDim();
    var j = window.dhx4.absLeft(this.wins.vp);
    var h = window.dhx4.absTop(this.wins.vp);
    var g = this.wins.vp.parentNode;
    while (g != null) {
        if (g.scrollLeft) {
            j = j - g.scrollLeft
        }
        if (g.scrollTop) {
            h = h - g.scrollTop
        }
        g = g.parentNode
    }
    var a = Math.round((l.right - l.left - c.conf.w) / 2);
    var m = Math.round((l.bottom - l.top - c.conf.h) / 2);
    this.wins._winAdjustPosition(this._idd, a - j, m - h);
    d = c = null
};
dhtmlXWindowsCell.prototype.bringToTop = function () {
    this.wins._winMakeActive(this._idd, true)
};
dhtmlXWindowsCell.prototype.bringToBottom = function () {
    var a = (this.wins.w[this._idd].conf.actv ? null : this.wins.conf.last_active);
    window.dhx4.zim.clear(this.wins.w[this._idd].conf.z_id);
    this.wins.w[this._idd].win.style.zIndex = 0;
    this.wins._winMakeActive(a, true)
};
dhtmlXWindowsCell.prototype.isOnTop = function () {
    return (this.wins.w[this._idd].conf.actv == true)
};
dhtmlXWindowsCell.prototype.isOnBottom = function () {
    var g = {
        id: null,
        z: +Infinity
    };
    for (var c in this.wins.w) {
        if (this.wins.w[c].conf.visible && this.wins.w[c].win.style.zIndex < g.z) {
            g.id = c;
            g.z = this.wins.w[c].win.style.zIndex
        }
    }
    return (g.id == this._idd)
};
dhtmlXWindowsCell.prototype.showHeader = function () {
    var a = this.wins.w[this._idd];
    if (a.conf.header == false) {
        a.hdr.className = String(a.hdr.className).replace(/\s{0,}dhxwin_hdr_hidden/gi, "");
        a.brd.className = String(a.brd.className).replace(/\s{0,}dhxwin_hdr_hidden/gi, "");
        this.conf.cells_cont = null;
        a.conf.brd = null;
        a.conf.header = true;
        this.wins._winAdjustCell(this._idd)
    }
    a = null
};
dhtmlXWindowsCell.prototype.hideHeader = function () {
    var a = this.wins.w[this._idd];
    if (a.conf.header == true) {
        if (a.conf.parked) {
            this.wins._winPark(this._idd, false)
        }
        a.hdr.className += " dhxwin_hdr_hidden";
        a.brd.className += " dhxwin_hdr_hidden";
        this.conf.cells_cont = null;
        a.conf.brd = null;
        a.conf.header = false;
        this.wins._winAdjustCell(this._idd)
    }
    a = null
};
dhtmlXWindowsCell.prototype.setModal = function (a) {
    this.wins._winSetModal(this._idd, window.dhx4.s2b(a))
};
dhtmlXWindowsCell.prototype.isModal = function () {
    return (this.wins.w[this._idd].conf.modal == true)
};
dhtmlXWindowsCell.prototype._adjustByCont = function (a, c) {
    a += this.wins.w[this._idd].conf.w - this.conf.size.w;
    c += this.wins.w[this._idd].conf.h - this.conf.size.h;
    this.wins._winSetSize(this._idd, a, c)
};
dhtmlXWindowsCell.prototype.close = function () {
    this.wins._winClose(this._idd)
};
dhtmlXWindowsCell.prototype.setIconCss = function (a) {
    this.wins.w[this._idd].hdr.firstChild.className = "dhxwin_icon " + a;
    this.wins._winAdjustTitle(this._idd)
};
dhtmlXWindowsCell.prototype.setToFullScreen = function (c) {
    c = window.dhx4.s2b(c);
    var a = this.wins.w[this._idd];
    if (a.conf.fs_mode == c) {
        a = null;
        return
    }
    if (this.wins.fsn == null) {
        this.wins.fsn = document.createElement("DIV");
        this.wins.fsn.className = this.wins.vp.className + " dhxwins_vp_fs";
        document.body.appendChild(this.wins.fsn)
    }
    if (c) {
        this.wins.fsn.appendChild(a.win);
        this.maximize();
        this.hideHeader()
    } else {
        this.wins.vp.appendChild(a.win);
        this.minimize();
        this.showHeader();
        if (this.wins.fsn.childNodes.length == 0) {
            this.wins.fsn.parentNode.removeChild(this.wins.fsn);
            this.wins.fsn = null
        }
    }
    a.conf.fs_mode = c;
    a = null
};
dhtmlXWindowsCell.prototype.button = function (a) {
    if (a == "minmax1" || a == "minmax2") {
        a = "minmax"
    }
    return this.wins.w[this._idd].b[a]
};
dhtmlXWindowsCell.prototype.addUserButton = function (m, l, g) {
    var a = new dhtmlXWindowsButton(this.wins, this._idd, m, g, true);
    var j = null;
    var c = this.wins.w[this._idd].hdr.lastChild;
    if (isNaN(l)) {
        l = 0
    } else {
        if (l < 0) {
            l = 0
        }
    }
    if (c.childNodes[l] != null) {
        j = c.childNodes[l]
    }
    if (j != null) {
        c.insertBefore(a.button, j)
    } else {
        c.appendChild(a.button)
    }
    this.wins.w[this._idd].b[m] = a;
    a = j = c = null;
    this.wins._winAdjustTitle(this._idd)
};
dhtmlXWindowsCell.prototype.removeUserButton = function (a) {
    if (this.wins.w[this._idd].b[a] == null || this.wins.w[this._idd].b[a].conf.custom != true) {
        return
    }
    this.wins._winRemoveButton(this._idd, a)
};
window.dhtmlXWindowsButton = function (j, c, a, h, g) {
    this.conf = {
        wins: j,
        winId: c,
        name: a,
        enabled: true,
        visible: true,
        custom: true
    };
    this.button = document.createElement("DIV");
    this.button._buttonName = a;
    this.button.title = h;
    this.enable = function () {
        this.conf.enabled = true;
        this.setCss(this.conf.css)
    };
    this.disable = function () {
        this.conf.enabled = false;
        this.setCss(this.conf.css)
    };
    this.isEnabled = function () {
        return (this.conf.enabled == true)
    };
    this.show = function () {
        this.button.style.display = "";
        this.conf.visible = true;
        this.conf.wins._winAdjustTitle(this.conf.winId)
    };
    this.hide = function () {
        this.button.style.display = "none";
        this.conf.visible = false;
        this.conf.wins._winAdjustTitle(this.conf.winId)
    };
    this.isHidden = function () {
        return (this.conf.visible == false)
    };
    this.setCss = function (m) {
        this.conf.css = m;
        var l = (this.conf.enabled ? "" : "_dis");
        this.button.className = "dhxwin_button" + l + " dhxwin_button_" + this.conf.css + l
    };
    this._doOnClick = function (l) {
        return this.callEvent("onClick", [this.conf.wins.w[this.conf.winId].cell, this])
    };
    this.unload = function (l) {
        dhx4._eventable(this, "clear");
        this.button._buttonName = null;
        this.button.parentNode.removeChild(this.button);
        if (this.conf.wins.cm != null && this.conf.wins.cm.button[this.conf.winId] != null && this.conf.wins.cm.button[this.conf.winId][this.conf.name] != null) {
            this.conf.wins._detachContextMenu("button", this.conf.winId, this.conf.name)
        }
        this.button = null;
        this.enable = null;
        this.disable = null;
        this.isEnabled = null;
        this.show = null;
        this.hide = null;
        this.isHidden = null;
        this.setCss = null;
        this.unload = null;
        if (l != true) {
            this.conf.wins._winAdjustTitle(this.conf.winId)
        }
        this.conf.wins = null;
        this.conf.winId = null;
        this.conf = null
    };
    this.setCss(a);
    dhx4._eventable(this);
    return this
};
dhtmlXWindows.prototype._winButtonClick = function (g, a, c) {
    if (!this.w[g].b[a].isEnabled()) {
        return true
    }
    if (this.w[g].b[a]._doOnClick() !== true) {
        return
    }
    if (a == "help") {
        this._callMainEvent("onHelp", g)
    }
    if (a == "park") {
        this._winPark(g, true)
    }
    if (a == "minmax") {
        this._winMinmax(g)
    }
    if (a == "stick") {
        this._winStick(g);
        return false
    }
    if (a == "close") {
        this._winClose(g);
        return false
    }
    return true
};
dhtmlXWindows.prototype._winRemoveButton = function (g, a, c) {
    this.w[g].b[a].unload(c);
    this.w[g].b[a] = null;
    delete this.w[g].b[a]
};
dhtmlXWindows.prototype._dndInitModule = function () {
    var a = this;
    this._dndOnMouseDown = function (h, j) {
        if (a.conf.dblclick_active) {
            return
        }
        if (h.preventDefault) {
            h.preventDefault()
        } else {
            h.returnValue = false
        }
        a.conf.dnd = {
            id: j,
            x: h.clientX,
            y: h.clientY,
            ready: true,
            css: false,
            tr: null,
            mode: "def",
            moved: false
        };
        if (a.w[j].conf.keep_in_vp) {
            a.conf.dnd.minX = 0;
            a.conf.dnd.maxX = a.vp.clientWidth - a.w[j].conf.w;
            a.conf.dnd.minY = 0;
            a.conf.dnd.maxY = a.vp.clientHeight - a.w[j].conf.h
        } else {
            a.conf.dnd.minX = -a.w[j].conf.w + a.conf.vp_pos_ofs;
            a.conf.dnd.maxX = a.vp.clientWidth - a.conf.vp_pos_ofs;
            a.conf.dnd.minY = 0;
            a.conf.dnd.maxY = a.vp.clientHeight - a.conf.vp_pos_ofs
        }
        var c = ["MozTransform", "WebkitTransform", "OTransform", "msTransform", "transform"];
        for (var g = 0; g < c.length; g++) {
            if (document.documentElement.style[c[g]] != null && a.conf.dnd.tr == null) {
                a.conf.dnd.tr = c[g];
                a.conf.dnd.mode = "tr"
            }
        }
        if (a.conf.dnd.mode == "tr") {
            a.w[j].win.style[a.conf.dnd.tr] = "translate(0px,0px)"
        }
        a._dndInitEvents()
    };
    this._dndOnMouseMove = function (j) {
        j = j || event;
        if (j.preventDefault) {
            j.preventDefault()
        } else {
            j.returnValue = false
        }
        var h = a.conf.dnd;
        var g = a.w[h.id];
        if (!h.css) {
            g.win.className += " dhxwin_dnd";
            g.fr_cover.className += " dhxwin_fr_cover_dnd";
            a.vp.className += " dhxwins_vp_dnd";
            h.css = true
        }
        var c = j.clientX - h.x;
        var l = j.clientY - h.y;
        h.newX = g.conf.x + c;
        h.newY = g.conf.y + l;
        if (h.mode == "tr") {
            h.newX = Math.min(Math.max(h.newX, h.minX), h.maxX);
            c = h.newX - g.conf.x;
            h.newY = Math.min(Math.max(h.newY, h.minY), h.maxY);
            l = h.newY - g.conf.y;
            g.win.style[h.tr] = "translate(" + c + "px," + l + "px)"
        } else {
            if (h.newX < h.minX || h.newX > h.maxX) {
                h.newX = Math.min(Math.max(h.newX, h.minX), h.maxX)
            } else {
                h.x = j.clientX
            }
            if (h.newY < h.minY || h.newY > h.maxY) {
                h.newY = Math.min(Math.max(h.newY, h.minY), h.maxY)
            } else {
                h.y = j.clientY
            }
            a._winSetPosition(h.id, h.newX, h.newY)
        }
        h.moved = true;
        g = h = null
    };
    this._dndOnMouseUp = function () {
        if (a.conf.dnd != null) {
            var g = a.conf.dnd;
            var c = a.w[g.id];
            if (g.newX != null) {
                if (g.mode == "tr") {
                    a._winSetPosition(g.id, g.newX, g.newY);
                    c.win.style[g.tr] = "translate(0px,0px)"
                }
            }
            if (g.css) {
                c.win.className = String(c.win.className).replace(/\s{0,}dhxwin_dnd/gi, "");
                c.fr_cover.className = String(c.fr_cover.className).replace(/\s{0,}dhxwin_fr_cover_dnd/gi, "");
                a.vp.className = String(a.vp.className).replace(/\s{0,}dhxwins_vp_dnd/gi, "")
            }
            a._dndUnloadEvents();
            if (g.moved) {
                a._callMainEvent("onMoveFinish", g.id)
            }
            c = g = a.conf.dnd = null
        }
    };
    this._dndOnSelectStart = function (c) {
        c = c || event;
        if (c.preventDefault) {
            c.preventDefault()
        } else {
            c.returnValue = false
        }
        return false
    };
    this._dndInitEvents = function () {
        if (typeof (window.addEventListener) == "function") {
            window.addEventListener("mousemove", this._dndOnMouseMove, false);
            window.addEventListener("mouseup", this._dndOnMouseUp, false);
            window.addEventListener("selectstart", this._dndOnSelectStart, false)
        } else {
            document.body.attachEvent("onmousemove", this._dndOnMouseMove);
            document.body.attachEvent("onmouseup", this._dndOnMouseUp);
            document.body.attachEvent("onselectstart", this._dndOnSelectStart)
        }
    };
    this._dndUnloadEvents = function () {
        if (typeof (window.addEventListener) == "function") {
            window.removeEventListener("mousemove", this._dndOnMouseMove, false);
            window.removeEventListener("mouseup", this._dndOnMouseUp, false);
            window.removeEventListener("selectstart", this._dndOnSelectStart, false)
        } else {
            document.body.detachEvent("onmousemove", this._dndOnMouseMove);
            document.body.detachEvent("onmouseup", this._dndOnMouseUp);
            document.body.detachEvent("onselectstart", this._dndOnSelectStart)
        }
    };
    this._dndUnloadModule = function () {
        this.detachEvent(this.conf.dnd_evid);
        this.conf.dnd_evid = null;
        this._dndOnMouseDown = null;
        this._dndOnMouseMove = null;
        this._dndOnMouseUp = null;
        this._dndOnSelectStart = null;
        this._dndInitEvents = null;
        this._dndUnloadEvents = null;
        this._dndInitModule = null;
        this._dndUnloadModule = null;
        a = null
    };
    this.conf.dnd_evid = this.attachEvent("_winMouseDown", function (g, c) {
        if (g.button >= 2) {
            return
        }
        if (!(c.mode == "hdr" && g.type == "mousedown" && this.w[c.id].conf.allow_move == true)) {
            return
        }
        if (this.w[c.id].conf.maxed && this.w[c.id].conf.max_w == null && this.w[c.id].conf.max_h == null) {
            return
        }
        if (g.preventDefault) {
            g.preventDefault()
        } else {
            g.returnValue = false
        }
        this._dndOnMouseDown(g, c.id);
        return false
    })
};
dhtmlXWindowsCell.prototype._initResize = function () {
    var a = this;
    var c = navigator.userAgent;
    this.conf.resize = {
        b_width: 6,
        c_type: (c.indexOf("MSIE 10.0") > 0 || c.indexOf("MSIE 9.0") > 0 || c.indexOf("MSIE 8.0") > 0 || c.indexOf("MSIE 7.0") > 0 || c.indexOf("MSIE 6.0") > 0)
    };
    this._rOnCellMouseMove = function (m) {
        if (a.wins.conf.resize_actv == true || a.wins.w[a._idd].conf.allow_resize == false || a.conf.progress == true || a.wins.w[a._idd].conf.maxed == true || a.wins.w[a._idd].conf.fs_mode == true) {
            var j = a.wins.w[a._idd].brd;
            if (j.style.cursor != "default") {
                j.style.cursor = "default"
            }
            j = null;
            return
        }
        m = m || event;
        var u = a.wins.w[a._idd].brd;
        var g = a.conf.resize;
        var o = (a.wins.w[a._idd].conf.header == false);
        var q = m.clientX;
        var n = m.clientY;
        var h = window.dhx4.absLeft(u);
        var s = window.dhx4.absTop(u);
        var l = "";
        if (q <= h + g.b_width) {
            l = "w"
        } else {
            if (q >= h + u.offsetWidth - g.b_width) {
                l = "e"
            }
        }
        if (n >= s + u.offsetHeight - g.b_width) {
            l = "s" + l
        } else {
            if (o && n <= s + g.b_width) {
                l = "n" + l
            }
        }
        if (l == "") {
            l = false
        }
        if (g.mode != l) {
            g.mode = l;
            if (l == false) {
                u.style.cursor = "default"
            } else {
                u.style.cursor = l + "-resize"
            }
        }
        u = g = null
    };
    this._rOnCellMouseDown = function (l) {
        if (a.conf.resize.mode == false) {
            return
        }
        if (a.conf.progress == true) {
            return
        }
        if (a.wins.w[a._idd].conf.allow_resize == false) {
            return
        }
        if (a.wins.w[a._idd].conf.fs_mode == true) {
            return
        }
        if (l.preventDefault) {
            l.preventDefault()
        } else {
            l.returnValue = false
        }
        var g = a.wins.w[a._idd];
        var j = a.conf.resize;
        a.wins.conf.resize_actv = true;
        j.min_w = g.conf.min_w;
        j.min_h = g.conf.min_h;
        j.max_w = g.conf.max_w || +Infinity;
        j.max_h = g.conf.max_h || +Infinity;
        if (g.cell.dataType == "layout" && g.cell.dataObj != null && typeof (g.cell.dataObj._getWindowMinDimension) == "function") {
            var h = g.cell.dataObj._getWindowMinDimension(g.cell);
            j.min_w = Math.max(h.w, j.min_w);
            j.min_h = Math.max(h.h, j.min_h)
        }
        j.vp_l = a.wins.conf.vp_pos_ofs;
        j.vp_r = a.wins.vp.clientWidth - a.wins.conf.vp_pos_ofs;
        j.vp_b = a.wins.vp.clientHeight - a.wins.conf.vp_pos_ofs;
        j.x = l.clientX;
        j.y = l.clientY;
        if (typeof (window.addEventListener) == "function") {
            window.addEventListener("mousemove", a._rOnWinMouseMove, false);
            window.addEventListener("mouseup", a._rOnWinMouseUp, false);
            window.addEventListener("selectstart", a._rOnSelectStart, false)
        } else {
            document.body.attachEvent("onmousemove", a._rOnWinMouseMove);
            document.body.attachEvent("onmouseup", a._rOnWinMouseUp);
            document.body.attachEvent("onselectstart", a._rOnSelectStart)
        }
        j.resized = false;
        j.vp_cursor = a.wins.vp.style.cursor;
        a.wins.vp.style.cursor = j.mode + "-resize";
        g = j = null
    };
    this._rOnWinMouseMove = function (l) {
        l = l || event;
        var h = a.wins.w[a._idd];
        var j = a.conf.resize;
        if (!j.resized) {
            h.fr_cover.className += " dhxwin_fr_cover_resize";
            j.resized = true
        }
        var g = l.clientX - j.x;
        var m = l.clientY - j.y;
        if (j.mode.indexOf("e") >= 0) {
            j.rw = Math.min(Math.max(h.conf.w + g, j.min_w), j.max_w);
            j.rx = null;
            if (h.conf.x + j.rw < j.vp_l) {
                j.rw = j.vp_l - h.conf.x
            } else {
                if (h.conf.x + j.rw > a.wins.vp.clientWidth) {
                    j.rw = a.wins.vp.clientWidth - h.conf.x
                }
            }
        } else {
            if (j.mode.indexOf("w") >= 0) {
                j.rw = Math.min(Math.max(h.conf.w - g, j.min_w), j.max_w);
                j.rx = h.conf.x + h.conf.w - j.rw;
                if (j.rx < 0) {
                    j.rw = j.rw + j.rx;
                    j.rx = 0
                } else {
                    if (j.rx > j.vp_r) {
                        j.rw = j.rw - j.vp_r;
                        j.rx = j.vp_r
                    }
                }
            }
        }
        if (j.mode.indexOf("s") >= 0) {
            j.rh = Math.min(Math.max(h.conf.h + m, j.min_h), j.max_h);
            j.ry = null;
            if (h.conf.y + j.rh > a.wins.vp.clientHeight) {
                j.rh = a.wins.vp.clientHeight - h.conf.y
            }
        } else {
            if (j.mode.indexOf("n") >= 0) {
                j.rh = Math.min(Math.max(h.conf.h - m, j.min_h), j.max_h);
                j.ry = h.conf.y + h.conf.h - j.rh;
                if (j.ry < 0) {
                    j.rh = j.rh + j.ry;
                    j.ry = 0
                } else {
                    if (j.ry > j.vp_b) {
                        j.rh = j.rh - j.vp_b;
                        j.ry = j.vp_b
                    }
                }
            }
        }
        a._rAdjustSizer();
        h = j = null
    };
    this._rOnWinMouseUp = function () {
        var h = a.conf.resize;
        var g = a.wins.w[a._idd];
        a.wins.conf.resize_actv = false;
        a.wins.vp.style.cursor = h.vp_cursor;
        g.fr_cover.className = String(g.fr_cover.className).replace(/\s{0,}dhxwin_fr_cover_resize/gi, "");
        if (h.resized) {
            a.wins._winSetSize(a._idd, h.rw, h.rh);
            if (h.rx == null) {
                h.rx = g.conf.x
            }
            if (h.ry == null) {
                h.ry = g.conf.y
            }
            if (h.rx != g.conf.x || h.ry != g.conf.y) {
                a.wins._winSetPosition(a._idd, h.rx, h.ry)
            }
        }
        if (h.obj != null) {
            h.obj.parentNode.removeChild(h.obj);
            h.obj = null
        }
        if (h.objFR != null) {
            h.objFR.parentNode.removeChild(h.objFR);
            h.objFR = null
        }
        if (typeof (window.addEventListener) == "function") {
            window.removeEventListener("mousemove", a._rOnWinMouseMove, false);
            window.removeEventListener("mouseup", a._rOnWinMouseUp, false);
            window.removeEventListener("selectstart", a._rOnSelectStart, false)
        } else {
            document.body.detachEvent("onmousemove", a._rOnWinMouseMove);
            document.body.detachEvent("onmouseup", a._rOnWinMouseUp);
            document.body.detachEvent("onselectstart", a._rOnSelectStart)
        }
        if (h.resized) {
            if (a.dataType == "layout" && a.dataObj != null) {
                a.dataObj.callEvent("onResize", [])
            }
            a.wins._callMainEvent("onResizeFinish", a._idd)
        }
        h.mode = "";
        g = h = null
    };
    this._rOnSelectStart = function (g) {
        g = g || event;
        if (g.preventDefault) {
            g.preventDefault()
        } else {
            g.returnValue = false
        }
        return false
    };
    this._rInitSizer = function () {
        var h = a.conf.resize;
        var g = a.wins.w[a._idd];
        h.obj = document.createElement("DIV");
        h.obj.className = "dhxwin_resize";
        h.obj.style.zIndex = g.win.style.zIndex;
        h.obj.style.cursor = h.mode + "-resize";
        a.wins.vp.appendChild(h.obj);
        if (a.wins.conf.fr_cover == true) {
            h.objFR = document.createElement("IFRAME");
            h.objFR.className = "dhxwin_resize_fr_cover";
            h.objFR.style.zIndex = h.obj.style.zIndex;
            a.wins.vp.insertBefore(h.objFR, h.obj)
        }
        h.rx = g.conf.x;
        h.ry = g.conf.y;
        h.rw = g.conf.w;
        h.rh = g.conf.h;
        h = null
    };
    this._rAdjustSizer = function () {
        var g = a.conf.resize;
        if (!g.obj) {
            this._rInitSizer()
        }
        g.obj.style.width = g.rw + "px";
        g.obj.style.height = g.rh + "px";
        if (g.rx != null) {
            g.obj.style.left = g.rx + "px"
        }
        if (g.ry != null) {
            g.obj.style.top = g.ry + "px"
        }
        if (g.objFR != null) {
            g.objFR.style.width = g.obj.style.width;
            g.objFR.style.height = g.obj.style.height;
            if (g.rx != null) {
                g.objFR.style.left = g.obj.style.left
            }
            if (g.ry != null) {
                g.objFR.style.top = g.obj.style.top
            }
        }
        g = null
    };
    if (typeof (window.addEventListener) == "function") {
        this.wins.w[this._idd].brd.addEventListener("mousemove", this._rOnCellMouseMove, false);
        this.wins.w[this._idd].brd.addEventListener("mousedown", this._rOnCellMouseDown, false)
    } else {
        this.wins.w[this._idd].brd.attachEvent("onmousemove", this._rOnCellMouseMove);
        this.wins.w[this._idd].brd.attachEvent("onmousedown", this._rOnCellMouseDown)
    }
    this._unloadResize = function () {
        if (typeof (window.addEventListener) == "function") {
            this.wins.w[this._idd].brd.removeEventListener("mousemove", this._rOnCellMouseMove, false);
            this.wins.w[this._idd].brd.removeEventListener("mousedown", this._rOnCellMouseDown, false)
        } else {
            this.wins.w[this._idd].brd.detachEvent("onmousemove", this._rOnCellMouseMove);
            this.wins.w[this._idd].brd.detachEvent("onmousedown", this._rOnCellMouseDown)
        }
        this._initResize = null;
        this._rOnCellMouseMove = null;
        this._rOnCellMouseDown = null;
        this._rOnWinMouseMove = null;
        this._rOnWinMouseUp = null;
        this._rOnSelectStart = null;
        this._rInitSizer = null;
        this._rAdjustSizer = null;
        this._unloadResize = null;
        this.conf.resize = null;
        a = null
    }
};
dhtmlXWindows.prototype.attachContextMenu = function (a) {
    return this._renderContextMenu("icon", null, null, a)
};
dhtmlXWindows.prototype.getContextMenu = function () {
    if (this.cm != null && this.cm.global != null) {
        return this.cm.global
    }
    return null
};
dhtmlXWindows.prototype.detachContextMenu = function () {
    this._detachContextMenu("icon", null, null)
};
dhtmlXWindowsCell.prototype.attachContextMenu = function (a) {
    return this.wins._renderContextMenu("icon", this._idd, null, a)
};
dhtmlXWindowsCell.prototype.getContextMenu = function () {
    if (this.wins.cm != null && this.wins.cm.icon[this._idd] != null) {
        return this.wins.cm.icon[this._idd]
    }
    return null
};
dhtmlXWindowsCell.prototype.detachContextMenu = function () {
    this.wins._detachContextMenu("icon", this._idd, null)
};
dhtmlXWindowsButton.prototype.attachContextMenu = function (a) {
    return this.conf.wins._renderContextMenu("button", this.conf.winId, this.conf.name, a)
};
dhtmlXWindowsButton.prototype.getContextMenu = function () {
    if (this.conf.wins.cm == null || this.conf.wins.cm.button[this.conf.winId] == null) {
        return null
    }
    if (this.conf.wins.cm.button[this.conf.winId][this.conf.name] != null) {
        return this.conf.wins.cm.button[this.conf.winId][this.conf.name]
    }
    return null
};
dhtmlXWindowsButton.prototype.detachContextMenu = function () {
    this.conf.wins._detachContextMenu("button", this.conf.winId, this.conf.name)
};
dhtmlXWindows.prototype._renderContextMenu = function (m, l, g, c) {
    var h = this;
    var a = false;
    if (this.cm == null) {
        this.cm = {
            global: null,
            icon: {},
            button: {}
        };
        a = true
    }
    if (l == null) {
        if (this.cm.global != null) {
            return
        }
    } else {
        if (m == "icon") {
            if (this.cm.icon[l] != null) {
                return
            }
        } else {
            if (m == "button") {
                if (this.cm.button[l] != null && this.cm.button[l][g] != null) {
                    return
                }
            }
        }
    }
    if (c == null) {
        c = {}
    }
    c.parent = null;
    c.context = true;
    var j = new dhtmlXMenuObject(c);
    j.setAutoHideMode(false);
    j.attachEvent("onShow", function () {
        this.conf.wins_menu_open = true
    });
    j.attachEvent("onHide", function () {
        this.conf.wins_menu_open = false;
        h.conf.opened_menu = null
    });
    if (l == null) {
        this.cm.global = j
    } else {
        if (m == "icon") {
            this.cm.icon[l] = j
        } else {
            if (m == "button") {
                if (this.cm.button[l] == null) {
                    this.cm.button[l] = {}
                }
                this.cm.button[l][g] = j
            }
        }
    }
    if (a) {
        this._showContextMenu = function (r, q) {
            if (r.button >= 2) {
                return
            }
            if (q.mode == "icon" && q.id != null && q.press_type == "mousedown") {
                var s = this.cm.icon[q.id] || this.cm.global;
                if (s == null) {
                    return
                }
                r.cancelBubble = true;
                var o = this.w[q.id].hdr.firstChild;
                if (s.conf.wins_menu_open && this.conf.opened_menu == q.id) {
                    s.hideContextMenu()
                } else {
                    this._hideContextMenu();
                    s.showContextMenu(window.dhx4.absLeft(o), window.dhx4.absTop(o) + o.offsetHeight);
                    this.conf.opened_menu = q.id
                }
                s = o = null
            }
            if (q.mode == "button" && q.id != null && q.press_type == "mousedown") {
                if (this.cm.button[q.id] == null || this.cm.button[q.id][q.button_name] == null) {
                    return
                }
                r.cancelBubble = true;
                this.conf.button_last = null;
                var s = this.cm.button[q.id][q.button_name];
                var n = this.w[q.id].b[q.button_name].button;
                if (s.conf.wins_menu_open && this.conf.opened_menu == q.id) {
                    s.hideContextMenu()
                } else {
                    this._hideContextMenu();
                    s.showContextMenu(window.dhx4.absLeft(n), window.dhx4.absTop(n) + n.offsetHeight);
                    this.conf.opened_menu = q.id
                }
                s = n = null
            }
        };
        this._hideContextMenu = function (s) {
            if (s != null) {
                s = s || event;
                if (s.type == "keydown" && s.keyCode != 27) {
                    return
                }
                var r = s.target || s.srcElement;
                var o = true;
                while (r != null && o == true) {
                    if (r.className != null && r.className.search(/SubLevelArea_Polygon/) >= 0) {
                        o = false
                    } else {
                        r = r.parentNode
                    }
                }
            }
            if (o || s == null) {
                if (h.cm.global != null) {
                    h.cm.global.hideContextMenu()
                }
                for (var q in h.cm.icon) {
                    if (h.cm.icon[q] != null) {
                        h.cm.icon[q].hideContextMenu()
                    }
                }
                for (var q in h.cm.button) {
                    for (var n in h.cm.button[q]) {
                        if (h.cm.button[q][n] != null) {
                            h.cm.button[q][n].hideContextMenu()
                        }
                    }
                }
            }
        };
        this._detachContextMenu = function (q, o, n) {
            if (this.cm == null) {
                return
            }
            if (o == null) {
                if (this.cm.global != null) {
                    this.cm.global.unload();
                    this.cm.global = null
                }
            } else {
                if (q == "icon") {
                    if (this.cm.icon[o] != null) {
                        this.cm.icon[o].unload();
                        this.cm.icon[o] = null
                    }
                } else {
                    if (q == "button") {
                        if (this.cm.button[o] != null && this.cm.button[o][n] != null) {
                            this.cm.button[o][n].unload();
                            this.cm.button[o][n] = null
                        }
                    }
                }
            }
        };
        this.attachEvent("_winMouseDown", this._showContextMenu);
        if (typeof (window.addEventListener) == "function") {
            window.addEventListener("mousedown", this._hideContextMenu, false);
            window.addEventListener("keydown", this._hideContextMenu, false)
        } else {
            document.body.attachEvent("onmousedown", this._hideContextMenu);
            document.body.attachEvent("onkeydown", this._hideContextMenu)
        }
        this._unloadContextMenu = function () {
            this._detachContextMenu("icon", null, null);
            this.cm = null;
            if (typeof (window.addEventListener) == "function") {
                window.removeEventListener("mousedown", this._hideContextMenu, false);
                window.removeEventListener("keydown", this._hideContextMenu, false)
            } else {
                document.body.detachEvent("onmousedown", this._hideContextMenu);
                document.body.detachEvent("onkeydown", this._hideContextMenu)
            }
            h = null
        }
    }
    return j
};
if (!window.dhx) {
    dhx = {}
}
dhx.assert = function (c, a) {
    if (!c) {
        dhx.assert_error(a)
    }
};
dhx.assert_error = function (message) {
    dhx.log("error", message);
    if (dhx.message && typeof message == "string") {
        dhx.message({
            type: "debug",
            text: message,
            expire: -1
        })
    }
    if (dhx.debug !== false) {
        eval("debugger;")
    }
};
dhx.assert_core_ready = function () {
    if (window.dhx_on_core_ready) {
        dhx_on_core_ready()
    }
};
dhx.version = "3.0";
dhx.codebase = "./";
dhx.name = "Core";
dhx.clone = function (c) {
    var a = dhx.clone._function;
    a.prototype = c;
    return new a()
};
dhx.clone._function = function () {};
dhx.extend = function (g, c, a) {
    dhx.assert(g, "Invalid mixing target");
    dhx.assert(c, "Invalid mixing source");
    if (g._dhx_proto_wait) {
        dhx.PowerArray.insertAt.call(g._dhx_proto_wait, c, 1);
        return g
    }
    for (var h in c) {
        if (!g[h] || a) {
            g[h] = c[h]
        }
    }
    if (c.defaults) {
        dhx.extend(g.defaults, c.defaults)
    }
    if (c.$init) {
        c.$init.call(g)
    }
    return g
};
dhx.copy = function (a) {
    dhx.assert(a, "Invalid mixing target");
    if (arguments.length > 1) {
        var c = arguments[0];
        a = arguments[1]
    } else {
        var c = (dhx.isArray(a) ? [] : {})
    }
    for (var g in a) {
        if (a[g] && typeof a[g] == "object" && !dhx.isDate(a[g])) {
            c[g] = (dhx.isArray(a[g]) ? [] : {});
            dhx.copy(c[g], a[g])
        } else {
            c[g] = a[g]
        }
    }
    return c
};
dhx.single = function (g) {
    var a = null;
    var c = function (h) {
            if (!a) {
                a = new g({})
            }
            if (a._reinit) {
                a._reinit.apply(a, arguments)
            }
            return a
        };
    return c
};
dhx.protoUI = function () {
    if (dhx.debug_proto) {
        dhx.log("UI registered: " + arguments[0].name)
    }
    var g = arguments;
    var a = g[0].name;
    var c = function (j) {
            if (!c) {
                return dhx.ui[a].prototype
            }
            var m = c._dhx_proto_wait;
            if (m) {
                var l = [m[0]];
                for (var h = 1; h < m.length; h++) {
                    l[h] = m[h];
                    if (l[h]._dhx_proto_wait) {
                        l[h] = l[h].call(dhx, l[h].name)
                    }
                    if (l[h].prototype && l[h].prototype.name) {
                        dhx.ui[l[h].prototype.name] = l[h]
                    }
                }
                dhx.ui[a] = dhx.proto.apply(dhx, l);
                if (c._dhx_type_wait) {
                    for (var h = 0; h < c._dhx_type_wait.length; h++) {
                        dhx.Type(dhx.ui[a], c._dhx_type_wait[h])
                    }
                }
                c = m = null
            }
            if (this != dhx) {
                return new dhx.ui[a](j)
            } else {
                return dhx.ui[a]
            }
        };
    c._dhx_proto_wait = Array.prototype.slice.call(arguments, 0);
    return dhx.ui[a] = c
};
dhx.proto = function () {
    if (dhx.debug_proto) {
        dhx.log("Proto chain:" + arguments[0].name + "[" + arguments.length + "]")
    }
    var l = arguments;
    var j = l[0];
    var c = !! j.$init;
    var n = [];
    dhx.assert(j, "Invalid mixing target");
    for (var h = l.length - 1; h > 0; h--) {
        dhx.assert(l[h], "Invalid mixing source");
        if (typeof l[h] == "function") {
            l[h] = l[h].prototype
        }
        if (l[h].$init) {
            n.push(l[h].$init)
        }
        if (l[h].defaults) {
            var g = l[h].defaults;
            if (!j.defaults) {
                j.defaults = {}
            }
            for (var a in g) {
                if (dhx.isUndefined(j.defaults[a])) {
                    j.defaults[a] = g[a]
                }
            }
        }
        if (l[h].type && j.type) {
            for (var a in l[h].type) {
                if (!j.type[a]) {
                    j.type[a] = l[h].type[a]
                }
            }
        }
        for (var m in l[h]) {
            if (!j[m]) {
                j[m] = l[h][m]
            }
        }
    }
    if (c) {
        n.push(j.$init)
    }
    j.$init = function () {
        for (var q = 0; q < n.length; q++) {
            n[q].apply(this, arguments)
        }
    };
    var o = function (q) {
            this.$ready = [];
            dhx.assert(this.$init, "object without init method");
            this.$init(q);
            if (this._parseSettings) {
                this._parseSettings(q, this.defaults)
            }
            for (var r = 0; r < this.$ready.length; r++) {
                this.$ready[r].call(this)
            }
        };
    o.prototype = j;
    j = l = null;
    return o
};
dhx.bind = function (c, a) {
    return function () {
        return c.apply(a, arguments)
    }
};
dhx.require = function (c, n, m) {
    if (typeof c != "string") {
        var l = c.length || 0;
        var j = n;
        if (!l) {
            for (var a in c) {
                l++
            }
            n = function () {
                l--;
                if (l === 0) {
                    j.apply(this, arguments)
                }
            };
            for (var a in c) {
                dhx.require(a, n, m)
            }
        } else {
            n = function () {
                if (l) {
                    l--;
                    dhx.require(c[c.length - l - 1], n, m)
                } else {
                    return j.apply(this, arguments)
                }
            };
            n()
        }
        return
    }
    if (dhx._modules[c] !== true) {
        if (c.substr(-4) == ".css") {
            var h = dhx.html.create("LINK", {
                type: "text/css",
                rel: "stylesheet",
                href: dhx.codebase + c
            });
            document.head.appendChild(h);
            if (n) {
                n.call(m || window)
            }
            return
        }
        var g = arguments[4];
        if (!n) {
            dhx.exec(dhx.ajax().sync().get(dhx.codebase + c).responseText);
            dhx._modules[c] = true
        } else {
            if (!dhx._modules[c]) {
                dhx._modules[c] = [
                    [n, m]
                ];
                dhx.ajax(dhx.codebase + c, function (r) {
                    dhx.exec(r);
                    var q = dhx._modules[c];
                    dhx._modules[c] = true;
                    for (var o = 0; o < q.length; o++) {
                        q[o][0].call(q[o][1] || window, !o)
                    }
                })
            } else {
                dhx._modules[c].push([n, m])
            }
        }
    }
};
dhx._modules = {};
dhx.exec = function (code) {
    if (window.execScript) {
        window.execScript(code)
    } else {
        window.eval(code)
    }
};
dhx.wrap = function (c, a) {
    if (!c) {
        return a
    }
    return function () {
        var g = c.apply(this, arguments);
        a.apply(this, arguments);
        return g
    }
};
dhx.isUndefined = function (c) {
    return typeof c == "undefined"
};
dhx.delay = function (h, c, g, a) {
    return window.setTimeout(function () {
        var j = h.apply(c, (g || []));
        h = c = g = null;
        return j
    }, a || 1)
};
dhx.uid = function () {
    if (!this._seed) {
        this._seed = (new Date).valueOf()
    }
    this._seed++;
    return this._seed
};
dhx.toNode = function (a) {
    if (typeof a == "string") {
        return document.getElementById(a)
    }
    return a
};
dhx.toArray = function (a) {
    return dhx.extend((a || []), dhx.PowerArray, true)
};
dhx.toFunctor = function (str) {
    return (typeof (str) == "string") ? eval(str) : str
};
dhx.isArray = function (a) {
    return Array.isArray ? Array.isArray(a) : (Object.prototype.toString.call(a) === "[object Array]")
};
dhx.isDate = function (a) {
    return a instanceof Date
};
dhx._events = {};
dhx.event = function (h, g, a, c) {
    h = dhx.toNode(h);
    var j = dhx.uid();
    if (c) {
        a = dhx.bind(a, c)
    }
    dhx._events[j] = [h, g, a];
    if (h.addEventListener) {
        h.addEventListener(g, a, false)
    } else {
        if (h.attachEvent) {
            h.attachEvent("on" + g, a)
        }
    }
    return j
};
dhx.eventRemove = function (c) {
    if (!c) {
        return
    }
    dhx.assert(this._events[c], "Removing non-existing event");
    var a = dhx._events[c];
    if (a[0].removeEventListener) {
        a[0].removeEventListener(a[1], a[2], false)
    } else {
        if (a[0].detachEvent) {
            a[0].detachEvent("on" + a[1], a[2])
        }
    }
    delete this._events[c]
};
dhx.log = function (c, g, a) {
    if (arguments.length == 1) {
        g = c;
        c = "log"
    }
    if (window.console && console.log) {
        c = c.toLowerCase();
        if (window.console[c]) {
            window.console[c](g || "unknown error")
        } else {
            window.console.log(c + ": " + g)
        }
        if (a) {
            window.console.log(a)
        }
    }
};
dhx.log_full_time = function (a) {
    dhx._start_time_log = new Date();
    dhx.log("Timing start [" + a + "]");
    window.setTimeout(function () {
        var c = new Date();
        dhx.log("Timing end [" + a + "]:" + (c.valueOf() - dhx._start_time_log.valueOf()) / 1000 + "s")
    }, 1)
};
dhx.log_time = function (a) {
    var g = "_start_time_log" + a;
    if (!dhx[g]) {
        dhx[g] = new Date();
        dhx.log("Info", "Timing start [" + a + "]")
    } else {
        var c = new Date();
        dhx.log("Info", "Timing end [" + a + "]:" + (c.valueOf() - dhx[g].valueOf()) / 1000 + "s");
        dhx[g] = null
    }
};
dhx.debug_code = function (a) {
    a.call(dhx)
};
dhx.EventSystem = {
    $init: function () {
        if (!this._evs_events) {
            this._evs_events = {};
            this._evs_handlers = {};
            this._evs_map = {}
        }
    },
    blockEvent: function () {
        this._evs_events._block = true
    },
    unblockEvent: function () {
        this._evs_events._block = false
    },
    mapEvent: function (a) {
        dhx.extend(this._evs_map, a, true)
    },
    on_setter: function (a) {
        if (a) {
            for (var c in a) {
                if (typeof a[c] == "function") {
                    this.attachEvent(c, a[c])
                }
            }
        }
    },
    callEvent: function (g, j) {
        if (this._evs_events._block) {
            return true
        }
        g = g.toLowerCase();
        var h = this._evs_events[g.toLowerCase()];
        var a = true;
        if (dhx.debug) {
            dhx.log("info", "[" + this.name + "] event:" + g, j)
        }
        if (h) {
            for (var c = 0; c < h.length; c++) {
                if (h[c].apply(this, (j || [])) === false) {
                    a = false
                }
            }
        }
        if (this._evs_map[g] && !this._evs_map[g].callEvent(g, j)) {
            a = false
        }
        return a
    },
    attachEvent: function (c, a, h) {
        dhx.assert(a, "Invalid event handler for " + c);
        c = c.toLowerCase();
        h = h || dhx.uid();
        a = dhx.toFunctor(a);
        var g = this._evs_events[c] || dhx.toArray();
        g.push(a);
        this._evs_events[c] = g;
        this._evs_handlers[h] = {
            f: a,
            t: c
        };
        return h
    },
    detachEvent: function (h) {
        if (!this._evs_handlers[h]) {
            return
        }
        var c = this._evs_handlers[h].t;
        var a = this._evs_handlers[h].f;
        var g = this._evs_events[c];
        g.remove(a);
        delete this._evs_handlers[h]
    },
    hasEvent: function (a) {
        a = a.toLowerCase();
        return this._evs_events[a] ? true : false
    }
};
dhx.extend(dhx, dhx.EventSystem);
dhx.PowerArray = {
    removeAt: function (c, a) {
        if (c >= 0) {
            this.splice(c, (a || 1))
        }
    },
    remove: function (a) {
        this.removeAt(this.find(a))
    },
    insertAt: function (c, g) {
        if (!g && g !== 0) {
            this.push(c)
        } else {
            var a = this.splice(g, (this.length - g));
            this[g] = c;
            this.push.apply(this, a)
        }
    },
    find: function (c) {
        for (var a = 0; a < this.length; a++) {
            if (c == this[a]) {
                return a
            }
        }
        return -1
    },
    each: function (a, g) {
        for (var c = 0; c < this.length; c++) {
            a.call((g || this), this[c])
        }
    },
    map: function (a, g) {
        for (var c = 0; c < this.length; c++) {
            this[c] = a.call((g || this), this[c])
        }
        return this
    },
    filter: function (a, g) {
        for (var c = 0; c < this.length; c++) {
            if (!a.call((g || this), this[c])) {
                this.splice(c, 1);
                c--
            }
        }
        return this
    }
};
dhx.env = {};
(function () {
    if (navigator.userAgent.indexOf("Mobile") != -1) {
        dhx.env.mobile = true
    }
    if (dhx.env.mobile || navigator.userAgent.indexOf("iPad") != -1 || navigator.userAgent.indexOf("Android") != -1) {
        dhx.env.touch = true
    }
    if (navigator.userAgent.indexOf("Opera") != -1) {
        dhx.env.isOpera = true
    } else {
        dhx.env.isIE = !! document.all;
        dhx.env.isFF = !document.all;
        dhx.env.isWebKit = (navigator.userAgent.indexOf("KHTML") != -1);
        dhx.env.isSafari = dhx.env.isWebKit && (navigator.userAgent.indexOf("Mac") != -1)
    }
    if (navigator.userAgent.toLowerCase().indexOf("android") != -1) {
        dhx.env.isAndroid = true
    }
    dhx.env.transform = false;
    dhx.env.transition = false;
    var g = {};
    g.names = ["transform", "transition"];
    g.transform = ["transform", "WebkitTransform", "MozTransform", "OTransform", "msTransform"];
    g.transition = ["transition", "WebkitTransition", "MozTransition", "OTransition", "msTransition"];
    var n = document.createElement("DIV");
    for (var l = 0; l < g.names.length; l++) {
        var h = g[g.names[l]];
        for (var c = 0; c < h.length; c++) {
            if (typeof n.style[h[c]] != "undefined") {
                dhx.env[g.names[l]] = h[c];
                break
            }
        }
    }
    n.style[dhx.env.transform] = "translate3d(0,0,0)";
    dhx.env.translate = (n.style[dhx.env.transform]) ? "translate3d" : "translate";
    var m = "";
    var a = false;
    if (dhx.env.isOpera) {
        m = "-o-";
        a = "O"
    }
    if (dhx.env.isFF) {
        m = "-Moz-"
    }
    if (dhx.env.isWebKit) {
        m = "-webkit-"
    }
    if (dhx.env.isIE) {
        m = "-ms-"
    }
    dhx.env.transformCSSPrefix = m;
    dhx.env.transformPrefix = a || (dhx.env.transformCSSPrefix.replace(/-/gi, ""));
    dhx.env.transitionEnd = ((dhx.env.transformCSSPrefix == "-Moz-") ? "transitionend" : (dhx.env.transformPrefix + "TransitionEnd"))
})();
dhx.env.svg = (function () {
    return document.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#BasicStructure", "1.1")
})();
dhx.html = {
    _native_on_selectstart: 0,
    denySelect: function () {
        if (!dhx._native_on_selectstart) {
            dhx._native_on_selectstart = document.onselectstart
        }
        document.onselectstart = dhx.html.stopEvent
    },
    allowSelect: function () {
        if (dhx._native_on_selectstart !== 0) {
            document.onselectstart = dhx._native_on_selectstart || null
        }
        dhx._native_on_selectstart = 0
    },
    index: function (c) {
        var a = 0;
        while (c = c.previousSibling) {
            a++
        }
        return a
    },
    _style_cache: {},
    createCss: function (g) {
        var h = "";
        for (var c in g) {
            h += c + ":" + g[c] + ";"
        }
        var a = this._style_cache[h];
        if (!a) {
            a = "s" + dhx.uid();
            this.addStyle("." + a + "{" + h + "}");
            this._style_cache[h] = a
        }
        return a
    },
    addStyle: function (c) {
        var a = document.createElement("style");
        a.setAttribute("type", "text/css");
        a.setAttribute("media", "screen");
        if (a.styleSheet) {
            a.styleSheet.cssText = c
        } else {
            a.appendChild(document.createTextNode(c))
        }
        document.getElementsByTagName("head")[0].appendChild(a)
    },
    create: function (c, a, g) {
        a = a || {};
        var h = document.createElement(c);
        for (var j in a) {
            h.setAttribute(j, a[j])
        }
        if (a.style) {
            h.style.cssText = a.style
        }
        if (a["class"]) {
            h.className = a["class"]
        }
        if (g) {
            h.innerHTML = g
        }
        return h
    },
    getValue: function (a) {
        a = dhx.toNode(a);
        if (!a) {
            return ""
        }
        return dhx.isUndefined(a.value) ? a.innerHTML : a.value
    },
    remove: function (c) {
        if (c instanceof Array) {
            for (var a = 0; a < c.length; a++) {
                this.remove(c[a])
            }
        } else {
            if (c && c.parentNode) {
                c.parentNode.removeChild(c)
            }
        }
    },
    insertBefore: function (c, g, a) {
        if (!c) {
            return
        }
        if (g && g.parentNode) {
            g.parentNode.insertBefore(c, g)
        } else {
            a.appendChild(c)
        }
    },
    locate: function (c, h) {
        if (c.tagName) {
            var a = c
        } else {
            c = c || event;
            var a = c.target || c.srcElement
        }
        while (a) {
            if (a.getAttribute) {
                var g = a.getAttribute(h);
                if (g) {
                    return g
                }
            }
            a = a.parentNode
        }
        return null
    },
    offset: function (h) {
        if (h.getBoundingClientRect) {
            var m = h.getBoundingClientRect();
            var n = document.body;
            var c = document.documentElement;
            var a = window.pageYOffset || c.scrollTop || n.scrollTop;
            var j = window.pageXOffset || c.scrollLeft || n.scrollLeft;
            var l = c.clientTop || n.clientTop || 0;
            var o = c.clientLeft || n.clientLeft || 0;
            var q = m.top + a - l;
            var g = m.left + j - o;
            return {
                y: Math.round(q),
                x: Math.round(g)
            }
        } else {
            var q = 0,
                g = 0;
            while (h) {
                q = q + parseInt(h.offsetTop, 10);
                g = g + parseInt(h.offsetLeft, 10);
                h = h.offsetParent
            }
            return {
                y: q,
                x: g
            }
        }
    },
    posRelative: function (a) {
        a = a || event;
        if (!dhx.isUndefined(a.offsetX)) {
            return {
                x: a.offsetX,
                y: a.offsetY
            }
        } else {
            return {
                x: a.layerX,
                y: a.layerY
            }
        }
    },
    pos: function (a) {
        a = a || event;
        if (a.pageX || a.pageY) {
            return {
                x: a.pageX,
                y: a.pageY
            }
        }
        var c = ((dhx.env.isIE) && (document.compatMode != "BackCompat")) ? document.documentElement : document.body;
        return {
            x: a.clientX + c.scrollLeft - c.clientLeft,
            y: a.clientY + c.scrollTop - c.clientTop
        }
    },
    preventEvent: function (a) {
        if (a && a.preventDefault) {
            a.preventDefault()
        }
        return dhx.html.stopEvent(a)
    },
    stopEvent: function (a) {
        (a || event).cancelBubble = true;
        return false
    },
    addCss: function (c, a) {
        c.className += " " + a
    },
    removeCss: function (c, a) {
        c.className = c.className.replace(RegExp(" " + a, "g"), "")
    }
};
dhx.ready = function (a) {
    if (this._ready) {
        a.call()
    } else {
        this._ready_code.push(a)
    }
};
dhx._ready_code = [];
(function () {
    var a = document.getElementsByTagName("SCRIPT");
    dhx.assert(a.length, "Can't locate codebase");
    if (a.length) {
        a = (a[a.length - 1].getAttribute("src") || "").split("/");
        a.splice(a.length - 1, 1);
        dhx.codebase = a.slice(0, a.length).join("/") + "/"
    }
    dhx.event(window, "load", function () {
        dhx.callEvent("onReady", []);
        dhx.delay(function () {
            dhx._ready = true;
            for (var c = 0; c < dhx._ready_code.length; c++) {
                dhx._ready_code[c].call()
            }
            dhx._ready_code = []
        })
    })
})();
dhx.locale = dhx.locale || {};
dhx.assert_core_ready();
dhx.ready(function () {
    dhx.event(document.body, "click", function (a) {
        dhx.callEvent("onClick", [a || event])
    })
});
(function () {
    var g = {};
    var c = new RegExp("(\\r\\n|\\n)", "g");
    var a = new RegExp('(\\")', "g");
    dhx.Template = function (j) {
        if (typeof j == "function") {
            return j
        }
        if (g[j]) {
            return g[j]
        }
        j = (j || "").toString();
        if (j.indexOf("->") != -1) {
            j = j.split("->");
            switch (j[0]) {
            case "html":
                j = dhx.html.getValue(j[1]);
                break;
            case "http":
                j = new dhx.ajax().sync().get(j[1], {
                    uid: dhx.uid()
                }).responseText;
                break;
            default:
                break
            }
        }
        j = (j || "").toString();
        j = j.replace(c, "\\n");
        j = j.replace(a, '\\"');
        j = j.replace(/\{obj\.([^}?]+)\?([^:]*):([^}]*)\}/g, '"+(obj.$1?"$2":"$3")+"');
        j = j.replace(/\{common\.([^}\(]*)\}/g, "\"+(common.$1||'')+\"");
        j = j.replace(/\{common\.([^\}\(]*)\(\)\}/g, '"+(common.$1?common.$1.apply(this, arguments):"")+"');
        j = j.replace(/\{obj\.([^}]*)\}/g, '"+(obj.$1)+"');
        j = j.replace("{obj}", '"+obj+"');
        j = j.replace(/#([^#'";, ]+)#/gi, '"+(obj.$1)+"');
        try {
            g[j] = Function("obj", "common", 'return "' + j + '";')
        } catch (h) {
            dhx.assert_error("Invalid template:" + j)
        }
        return g[j]
    };
    dhx.Template.empty = function () {
        return ""
    };
    dhx.Template.bind = function (h) {
        return dhx.bind(dhx.Template(h), this)
    };
    dhx.Type = function (n, m) {
        if (n._dhx_proto_wait) {
            if (!n._dhx_type_wait) {
                n._dhx_type_wait = []
            }
            n._dhx_type_wait.push(m);
            return
        }
        if (typeof n == "function") {
            n = n.prototype
        }
        if (!n.types) {
            n.types = {
                "default": n.type
            };
            n.type.name = "default"
        }
        var h = m.name;
        var l = n.type;
        if (h) {
            l = n.types[h] = dhx.clone(m.baseType ? n.types[m.baseType] : n.type)
        }
        for (var j in m) {
            if (j.indexOf("template") === 0) {
                l[j] = dhx.Template(m[j])
            } else {
                l[j] = m[j]
            }
        }
        return h
    }
})();
dhx.Settings = {
    $init: function () {
        this._settings = this.config = {}
    },
    define: function (c, a) {
        if (typeof c == "object") {
            return this._parseSeetingColl(c)
        }
        return this._define(c, a)
    },
    _define: function (c, a) {
        var g = this[c + "_setter"];
        return this._settings[c] = g ? g.call(this, a, c) : a
    },
    _parseSeetingColl: function (g) {
        if (g) {
            for (var c in g) {
                this._define(c, g[c])
            }
        }
    },
    _parseSettings: function (g, a) {
        var c = {};
        if (a) {
            c = dhx.extend(c, a)
        }
        if (typeof g == "object" && !g.tagName) {
            dhx.extend(c, g, true)
        }
        this._parseSeetingColl(c)
    },
    _mergeSettings: function (a, g) {
        for (var c in g) {
            switch (typeof a[c]) {
            case "object":
                a[c] = this._mergeSettings((a[c] || {}), g[c]);
                break;
            case "undefined":
                a[c] = g[c];
                break;
            default:
                break
            }
        }
        return a
    },
    debug_freid_c_id: true,
    debug_freid_a_name: true
};
dhx.ajax = function (a, c, g) {
    if (arguments.length !== 0) {
        var h = new dhx.ajax();
        if (g) {
            h.master = g
        }
        return h.get(a, null, c)
    }
    if (!this.getXHR) {
        return new dhx.ajax()
    }
    return this
};
dhx.ajax.count = 0;
dhx.ajax.prototype = {
    master: null,
    getXHR: function () {
        if (dhx.env.isIE) {
            return new ActiveXObject("Microsoft.xmlHTTP")
        } else {
            return new XMLHttpRequest()
        }
    },
    send: function (j, o, m) {
        var c = this.getXHR();
        if (!dhx.isArray(m)) {
            m = [m]
        }
        if (typeof o == "object") {
            var l = [];
            for (var g in o) {
                var n = o[g];
                if (n === null || n === dhx.undefined) {
                    n = ""
                }
                l.push(g + "=" + encodeURIComponent(n))
            }
            o = l.join("&")
        }
        if (o && this.request === "GET") {
            j = j + (j.indexOf("?") != -1 ? "&" : "?") + o;
            o = null
        }
        c.open(this.request, j, !this._sync);
        if (this.request === "POST") {
            c.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
        }
        var h = this;
        c.onreadystatechange = function () {
            if (!c.readyState || c.readyState == 4) {
                if (dhx.debug_time) {
                    dhx.log_full_time("data_loading")
                }
                dhx.ajax.count++;
                if (m && h) {
                    for (var a = 0; a < m.length; a++) {
                        if (m[a]) {
                            var q = (m[a].success || m[a]);
                            if (c.status >= 400 || (!c.status && !c.responseText)) {
                                q = m[a].error
                            }
                            if (q) {
                                q.call((h.master || h), c.responseText, c.responseXML, c)
                            }
                        }
                    }
                }
                if (h) {
                    h.master = null
                }
                m = h = null
            }
        };
        c.send(o || null);
        return c
    },
    get: function (a, g, c) {
        if (arguments.length == 2) {
            c = g;
            g = null
        }
        this.request = "GET";
        return this.send(a, g, c)
    },
    post: function (a, g, c) {
        this.request = "POST";
        return this.send(a, g, c)
    },
    put: function (a, g, c) {
        this.request = "PUT";
        return this.send(a, g, c)
    },
    del: function (a, g, c) {
        this.request = "DELETE";
        return this.send(a, g, c)
    },
    sync: function () {
        this._sync = true;
        return this
    },
    bind: function (a) {
        this.master = a;
        return this
    }
};
dhx.send = function (g, c, m, l) {
    var h = dhx.html.create("FORM", {
        target: (l || "_self"),
        action: g,
        method: (m || "POST")
    }, "");
    for (var a in c) {
        var j = dhx.html.create("INPUT", {
            type: "hidden",
            name: a,
            value: c[a]
        }, "");
        h.appendChild(j)
    }
    h.style.display = "none";
    document.body.appendChild(h);
    h.submit();
    document.body.removeChild(h)
};
dhx.AtomDataLoader = {
    $init: function (a) {
        this.data = {};
        if (a) {
            this._settings.datatype = a.datatype || "json";
            this.$ready.push(this._load_when_ready)
        }
    },
    _load_when_ready: function () {
        this._ready_for_data = true;
        if (this._settings.url) {
            this.url_setter(this._settings.url)
        }
        if (this._settings.data) {
            this.data_setter(this._settings.data)
        }
    },
    url_setter: function (a) {
        if (!this._ready_for_data) {
            return a
        }
        this.load(a, this._settings.datatype);
        return a
    },
    data_setter: function (a) {
        if (!this._ready_for_data) {
            return a
        }
        this.parse(a, this._settings.datatype);
        return true
    },
    debug_freid_c_datatype: true,
    debug_freid_c_dataFeed: true,
    load: function (a, c) {
        if (a.$proxy) {
            a.load(this, typeof c == "string" ? c : "json");
            return
        }
        this.callEvent("onXLS", []);
        if (typeof c == "string") {
            this.data.driver = dhx.DataDriver[c];
            c = arguments[2]
        } else {
            if (!this.data.driver) {
                this.data.driver = dhx.DataDriver.json
            }
        }
        var g = [{
            success: this._onLoad,
            error: this._onLoadError
        }];
        if (c) {
            if (dhx.isArray(c)) {
                g.push.apply(g, c)
            } else {
                g.push(c)
            }
        }
        return dhx.ajax(a, g, this)
    },
    parse: function (c, a) {
        this.callEvent("onXLS", []);
        this.data.driver = dhx.DataDriver[a || "json"];
        this._onLoad(c, null)
    },
    _onLoad: function (m, c, a, g) {
        var j = this.data.driver;
        var h = j.toObject(m, c);
        if (h) {
            var l = j.getRecords(h)[0];
            this.data = (j ? j.getDetails(l) : m)
        } else {
            this._onLoadError(m, c, a)
        }
        this.callEvent("onXLE", [])
    },
    _onLoadError: function (g, a, c) {
        this.callEvent("onXLE", []);
        this.callEvent("onLoadError", arguments);
        dhx.callEvent("onLoadError", [g, a, c, this])
    },
    _check_data_feed: function (c) {
        if (!this._settings.dataFeed || this._ignore_feed || !c) {
            return true
        }
        var a = this._settings.dataFeed;
        if (typeof a == "function") {
            return a.call(this, (c.id || c), c)
        }
        a = a + (a.indexOf("?") == -1 ? "?" : "&") + "action=get&id=" + encodeURIComponent(c.id || c);
        this.callEvent("onXLS", []);
        dhx.ajax(a, function (l, h, g) {
            this._ignore_feed = true;
            var j = dhx.DataDriver.toObject(l, h);
            if (j) {
                this.setValues(j.getDetails(j.getRecords()[0]))
            } else {
                this._onLoadError(l, h, g)
            }
            this._ignore_feed = false;
            this.callEvent("onXLE", [])
        }, this);
        return false
    }
};
dhx.DataDriver = {};
dhx.DataDriver.json = {
    toObject: function (data) {
        if (!data) {
            data = "[]"
        }
        if (typeof data == "string") {
            try {
                eval("dhx.temp=" + data)
            } catch (e) {
                dhx.assert_error(e);
                return null
            }
            data = dhx.temp
        }
        if (data.data) {
            var t = data.data.config = {};
            for (var key in data) {
                if (key != "data") {
                    t[key] = data[key]
                }
            }
            data = data.data
        }
        return data
    },
    getRecords: function (a) {
        if (a && !dhx.isArray(a)) {
            return [a]
        }
        return a
    },
    getDetails: function (a) {
        if (typeof a == "string") {
            return {
                id: dhx.uid(),
                value: a
            }
        }
        return a
    },
    getInfo: function (c) {
        var a = c.config;
        if (!a) {
            return {}
        }
        return {
            _size: (a.total_count || 0),
            _from: (a.pos || 0),
            _parent: (a.parent || 0),
            _config: (a.config),
            _key: (a.dhx_security)
        }
    },
    child: "data"
};
dhx.DataDriver.html = {
    toObject: function (c) {
        if (typeof c == "string") {
            var a = null;
            if (c.indexOf("<") == -1) {
                a = dhx.toNode(c)
            }
            if (!a) {
                a = document.createElement("DIV");
                a.innerHTML = c
            }
            return a.getElementsByTagName(this.tag)
        }
        return c
    },
    getRecords: function (c) {
        var g = [];
        for (var a = 0; a < c.childNodes.length; a++) {
            var h = c.childNodes[a];
            if (h.nodeType == 1) {
                g.push(h)
            }
        }
        return g
    },
    getDetails: function (a) {
        return dhx.DataDriver.xml.tagToObject(a)
    },
    getInfo: function (a) {
        return {
            _size: 0,
            _from: 0
        }
    },
    tag: "LI"
};
dhx.DataDriver.jsarray = {
    toObject: function (data) {
        if (typeof data == "string") {
            eval("dhx.temp=" + data);
            return dhx.temp
        }
        return data
    },
    getRecords: function (a) {
        return a
    },
    getDetails: function (g) {
        var a = {};
        for (var c = 0; c < g.length; c++) {
            a["data" + c] = g[c]
        }
        return a
    },
    getInfo: function (a) {
        return {
            _size: 0,
            _from: 0
        }
    }
};
dhx.DataDriver.csv = {
    toObject: function (a) {
        return a
    },
    getRecords: function (a) {
        return a.split(this.row)
    },
    getDetails: function (g) {
        g = this.stringToArray(g);
        var a = {};
        for (var c = 0; c < g.length; c++) {
            a["data" + c] = g[c]
        }
        return a
    },
    getInfo: function (a) {
        return {
            _size: 0,
            _from: 0
        }
    },
    stringToArray: function (c) {
        c = c.split(this.cell);
        for (var a = 0; a < c.length; a++) {
            c[a] = c[a].replace(/^[ \t\n\r]*(\"|)/g, "").replace(/(\"|)[ \t\n\r]*$/g, "")
        }
        return c
    },
    row: "\n",
    cell: ","
};
dhx.DataDriver.xml = {
    _isValidXML: function (a) {
        if (!a || !a.documentElement) {
            return null
        }
        if (a.getElementsByTagName("parsererror").length) {
            return null
        }
        return a
    },
    toObject: function (g, a) {
        if (this._isValidXML(c)) {
            return c
        }
        if (typeof g == "string") {
            var c = this.fromString(g.replace(/^[\s]+/, ""))
        } else {
            c = g
        }
        if (this._isValidXML(c)) {
            return c
        }
        return null
    },
    getRecords: function (a) {
        return this.xpath(a, this.records)
    },
    records: "/*/item",
    child: "item",
    config: "/*/config",
    getDetails: function (a) {
        return this.tagToObject(a, {})
    },
    getInfo: function (c) {
        var a = this.xpath(c, this.config);
        if (a.length) {
            a = this.assignTypes(this.tagToObject(a[0], {}))
        } else {
            a = null
        }
        return {
            _size: (c.documentElement.getAttribute("total_count") || 0),
            _from: (c.documentElement.getAttribute("pos") || 0),
            _parent: (c.documentElement.getAttribute("parent") || 0),
            _config: a,
            _key: (c.documentElement.getAttribute("dhx_security") || null)
        }
    },
    xpath: function (h, o) {
        if (window.XPathResult) {
            var g = h;
            if (h.nodeName.indexOf("document") == -1) {
                h = h.ownerDocument
            }
            var m = [];
            var c = h.evaluate(o, g, null, XPathResult.ANY_TYPE, null);
            var n = c.iterateNext();
            while (n) {
                m.push(n);
                n = c.iterateNext()
            }
            return m
        } else {
            var l = true;
            try {
                if (typeof (h.selectNodes) == "undefined") {
                    l = false
                }
            } catch (j) {}
            if (l) {
                return h.selectNodes(o)
            } else {
                var a = o.split("/").pop();
                return h.getElementsByTagName(a)
            }
        }
    },
    assignTypes: function (c) {
        for (var a in c) {
            var g = c[a];
            if (typeof g == "object") {
                this.assignTypes(g)
            } else {
                if (typeof g == "string") {
                    if (g === "") {
                        continue
                    }
                    if (g == "true") {
                        c[a] = true
                    } else {
                        if (g == "false") {
                            c[a] = false
                        } else {
                            if (g == g * 1) {
                                c[a] = c[a] * 1
                            }
                        }
                    }
                }
            }
        }
        return c
    },
    tagToObject: function (g, o) {
        o = o || {};
        var j = false;
        var h = g.attributes;
        if (h && h.length) {
            for (var m = 0; m < h.length; m++) {
                o[h[m].name] = h[m].value
            }
            j = true
        }
        var c = g.childNodes;
        var n = {};
        for (var m = 0; m < c.length; m++) {
            if (c[m].nodeType == 1) {
                var l = c[m].tagName;
                if (typeof o[l] != "undefined") {
                    if (!dhx.isArray(o[l])) {
                        o[l] = [o[l]]
                    }
                    o[l].push(this.tagToObject(c[m], {}))
                } else {
                    o[c[m].tagName] = this.tagToObject(c[m], {})
                }
                j = true
            }
        }
        if (!j) {
            return this.nodeValue(g)
        }
        o.value = o.value || this.nodeValue(g);
        return o
    },
    nodeValue: function (a) {
        if (a.firstChild) {
            return a.firstChild.data
        }
        return ""
    },
    fromString: function (g) {
        try {
            if (window.DOMParser) {
                return (new DOMParser()).parseFromString(g, "text/xml")
            }
            if (window.ActiveXObject) {
                var a = new ActiveXObject("Microsoft.xmlDOM");
                a.loadXML(g);
                return a
            }
        } catch (c) {
            dhx.assert_error(c);
            return null
        }
        dhx.assert_error("Load from xml string is not supported")
    }
};
dhx.DataLoader = dhx.proto({
    $init: function (a) {
        a = a || "";
        this._ajax_queue = dhx.toArray();
        this.data = new dhx.DataStore();
        this.data.attachEvent("onClearAll", dhx.bind(this._call_onclearall, this));
        this.data.attachEvent("onServerConfig", dhx.bind(this._call_on_config, this));
        this.data.feed = this._feed
    },
    _feed: function (g, a, c) {
        if (this._load_count) {
            return this._load_count = [g, a, c]
        } else {
            this._load_count = true
        }
        this._feed_last = [g, a];
        this._feed_common.call(this, g, a, c)
    },
    _feed_common: function (h, c, g) {
        var a = this.data.url;
        if (h < 0) {
            h = 0
        }
        this.load(a + ((a.indexOf("?") == -1) ? "?" : "&") + (this.dataCount() ? ("continue=true&") : "") + "start=" + h + "&count=" + c, [this._feed_callback, g])
    },
    _feed_callback: function () {
        var a = this._load_count;
        var c = this._feed_last;
        this._load_count = false;
        if (typeof a == "object" && (a[0] != c[0] || a[1] != c[1])) {
            this.data.feed.apply(this, a)
        }
    },
    load: function (a, c) {
        var g = dhx.AtomDataLoader.load.apply(this, arguments);
        this._ajax_queue.push(g);
        if (!this.data.url) {
            this.data.url = a
        }
    },
    loadNext: function (g, j, h, c, a) {
        if (this._settings.datathrottle && !a) {
            if (this._throttle_request) {
                window.clearTimeout(this._throttle_request)
            }
            this._throttle_request = dhx.delay(function () {
                this.loadNext(g, j, h, c, true)
            }, this, 0, this._settings.datathrottle);
            return
        }
        if (!j && j !== 0) {
            j = this.dataCount()
        }
        this.data.url = this.data.url || c;
        if (this.callEvent("onDataRequest", [j, g, h, c]) && this.data.url) {
            this.data.feed.call(this, j, g, h)
        }
    },
    _maybe_loading_already: function (c, g) {
        var a = this._feed_last;
        if (this._load_count && a) {
            if (a[0] <= g && (a[1] + a[0] >= c + g)) {
                return true
            }
        }
        return false
    },
    _onLoad: function (h, c, a) {
        this._ajax_queue.remove(a);
        var g = this.data.driver.toObject(h, c);
        if (g) {
            this.data._parse(g)
        } else {
            return this._onLoadError(h, c, a)
        }
        this._call_onready();
        this.callEvent("onXLE", [])
    },
    removeMissed_setter: function (a) {
        return this.data._removeMissed = a
    },
    scheme_setter: function (a) {
        this.data.scheme(a)
    },
    dataFeed_setter: function (a) {
        this.data.attachEvent("onBeforeFilter", dhx.bind(function (m, l) {
            if (this._settings.dataFeed) {
                var j = {};
                if (!m && !l) {
                    return
                }
                if (typeof m == "function") {
                    if (!l) {
                        return
                    }
                    m(l, j)
                } else {
                    j = {
                        text: l
                    }
                }
                this.clearAll();
                var c = this._settings.dataFeed;
                var h = [];
                if (typeof c == "function") {
                    return c.call(this, l, j)
                }
                for (var g in j) {
                    h.push("dhx_filter[" + g + "]=" + encodeURIComponent(j[g]))
                }
                this.load(c + (c.indexOf("?") < 0 ? "?" : "&") + h.join("&"), this._settings.datatype);
                return false
            }
        }, this));
        return a
    },
    debug_freid_c_ready: true,
    debug_freid_c_datathrottle: true,
    _call_onready: function () {
        if (this._settings.ready && !this._ready_was_used) {
            var a = dhx.toFunctor(this._settings.ready);
            if (a) {
                dhx.delay(a, this, arguments)
            }
            this._ready_was_used = true
        }
    },
    _call_onclearall: function () {
        for (var a = 0; a < this._ajax_queue.length; a++) {
            this._ajax_queue[a].abort()
        }
        this._ajax_queue = dhx.toArray()
    },
    _call_on_config: function (a) {
        this._parseSeetingColl(a)
    }
}, dhx.AtomDataLoader);
dhx.DataStore = function () {
    this.name = "DataStore";
    dhx.extend(this, dhx.EventSystem);
    this.setDriver("json");
    this.pull = {};
    this.order = dhx.toArray();
    this._marks = {}
};
dhx.DataStore.prototype = {
    setDriver: function (a) {
        dhx.assert(dhx.DataDriver[a], "incorrect DataDriver");
        this.driver = dhx.DataDriver[a]
    },
    _parse: function (g, a) {
        this.callEvent("onParse", [this.driver, g]);
        if (this._filter_order) {
            this.filter()
        }
        var h = this.driver.getInfo(g);
        if (h._key) {
            dhx.securityKey = h._key
        }
        if (h._config) {
            this.callEvent("onServerConfig", [h._config])
        }
        var c = this.driver.getRecords(g);
        this._inner_parse(h, c);
        if (this._scheme_group && this._group_processing) {
            this._group_processing(this._scheme_group)
        }
        if (this._scheme_sort) {
            this.blockEvent();
            this.sort(this._scheme_sort);
            this.unblockEvent()
        }
        this.callEvent("onStoreLoad", [this.driver, g]);
        this.refresh()
    },
    _inner_parse: function (c, n) {
        var q = (c._from || 0) * 1;
        var m = true;
        var o = false;
        if (q === 0 && this.order[0]) {
            if (this._removeMissed) {
                o = {};
                for (var h = 0; h < this.order.length; h++) {
                    o[this.order[h]] = true
                }
            }
            m = false;
            q = this.order.length
        }
        var g = 0;
        for (var h = 0; h < n.length; h++) {
            var r = this.driver.getDetails(n[h]);
            var a = this.id(r);
            if (!this.pull[a]) {
                this.order[g + q] = a;
                g++
            } else {
                if (m && this.order[g + q]) {
                    g++
                }
            }
            if (this.pull[a]) {
                dhx.extend(this.pull[a], r, true);
                if (this._scheme_update) {
                    this._scheme_update(this.pull[a])
                }
                if (o) {
                    delete o[a]
                }
            } else {
                this.pull[a] = r;
                if (this._scheme_init) {
                    this._scheme_init(r)
                }
            }
        }
        if (o) {
            this.blockEvent();
            for (var l in o) {
                this.remove(l)
            }
            this.unblockEvent()
        }
        if (!this.order[c._size - 1]) {
            this.order[c._size - 1] = dhx.undefined
        }
    },
    id: function (a) {
        return a.id || (a.id = dhx.uid())
    },
    changeId: function (c, a) {
        if (this.pull[c]) {
            this.pull[a] = this.pull[c]
        }
        this.pull[a].id = a;
        this.order[this.order.find(c)] = a;
        if (this._filter_order) {
            this._filter_order[this._filter_order.find(c)] = a
        }
        if (this._marks[c]) {
            this._marks[a] = this._marks[c];
            delete this._marks[c]
        }
        this.callEvent("onIdChange", [c, a]);
        if (this._render_change_id) {
            this._render_change_id(c, a)
        }
        delete this.pull[c]
    },
    item: function (a) {
        return this.pull[a]
    },
    update: function (c, a) {
        if (dhx.isUndefined(a)) {
            a = this.item(c)
        }
        if (this._scheme_update) {
            this._scheme_update(a)
        }
        if (this.callEvent("onBeforeUpdate", [c, a]) === false) {
            return false
        }
        this.pull[c] = a;
        this.callEvent("onStoreUpdated", [c, a, "update"])
    },
    refresh: function (a) {
        if (this._skip_refresh) {
            return
        }
        if (a) {
            this.callEvent("onStoreUpdated", [a, this.pull[a], "paint"])
        } else {
            this.callEvent("onStoreUpdated", [null, null, null])
        }
    },
    silent: function (c, a) {
        this._skip_refresh = true;
        c.call(a || this);
        this._skip_refresh = false
    },
    getRange: function (h, g) {
        if (h) {
            h = this.indexById(h)
        } else {
            h = (this.$min || this.startOffset) || 0
        }
        if (g) {
            g = this.indexById(g)
        } else {
            g = Math.min(((this.$max || this.endOffset) || Infinity), (this.dataCount() - 1));
            if (g < 0) {
                g = 0
            }
        }
        if (h > g) {
            var c = g;
            g = h;
            h = c
        }
        return this.getIndexRange(h, g)
    },
    getIndexRange: function (h, g) {
        g = Math.min((g || Infinity), this.dataCount() - 1);
        var a = dhx.toArray();
        for (var c = (h || 0); c <= g; c++) {
            a.push(this.item(this.order[c]))
        }
        return a
    },
    dataCount: function () {
        return this.order.length
    },
    exists: function (a) {
        return !!(this.pull[a])
    },
    move: function (a, h) {
        dhx.assert(a >= 0 && h >= 0, "DataStore::move", "Incorrect indexes");
        var g = this.idByIndex(a);
        var c = this.item(g);
        this.order.removeAt(a);
        this.order.insertAt(g, Math.min(this.order.length, h));
        this.callEvent("onStoreUpdated", [g, c, "move"])
    },
    scheme: function (a) {
        this._scheme = {};
        this._scheme_init = a.$init;
        this._scheme_update = a.$update;
        this._scheme_serialize = a.$serialize;
        this._scheme_group = a.$group;
        this._scheme_sort = a.$sort;
        for (var c in a) {
            if (c.substr(0, 1) != "$") {
                this._scheme[c] = a[c]
            }
        }
    },
    sync: function (h, g, a) {
        if (typeof h == "string") {
            h = $$("source")
        }
        if (typeof g != "function") {
            a = g;
            g = null
        }
        if (dhx.debug_bind) {
            this.debug_sync_master = h;
            dhx.log("[sync] " + this.debug_bind_master.name + "@" + this.debug_bind_master._settings.id + " <= " + this.debug_sync_master.name + "@" + this.debug_sync_master._settings.id)
        }
        this._backbone_source = false;
        if (h.name != "DataStore") {
            if (h.data && h.data.name == "DataStore") {
                h = h.data
            } else {
                this._backbone_source = true
            }
        }
        var c = dhx.bind(function (n, j, m) {
            if (this._backbone_source) {
                if (!n) {
                    return
                }
                if (n.indexOf("change") === 0) {
                    if (n == "change") {
                        this.pull[j.id] = j.attributes;
                        this.refresh(j.id);
                        return
                    } else {
                        return
                    }
                }
                if (n == "reset") {
                    m = j
                }
                this.order = [];
                this.pull = {};
                this._filter_order = null;
                for (var l = 0; l < m.models.length; l++) {
                    var o = m.models[l].id;
                    this.order.push(o);
                    this.pull[o] = m.models[l].attributes
                }
            } else {
                this._filter_order = null;
                this.order = dhx.toArray([].concat(h.order));
                this.pull = h.pull
            }
            if (g) {
                this.silent(g)
            }
            if (this._on_sync) {
                this._on_sync()
            }
            if (dhx.debug_bind) {
                dhx.log("[sync:request] " + this.debug_sync_master.name + "@" + this.debug_sync_master._settings.id + " <= " + this.debug_bind_master.name + "@" + this.debug_bind_master._settings.id)
            }
            this.callEvent("onSyncApply", []);
            if (!a) {
                this.refresh()
            } else {
                a = false
            }
        }, this);
        if (this._backbone_source) {
            h.bind("all", c)
        } else {
            this._sync_events = [h.attachEvent("onStoreUpdated", c), h.attachEvent("onIdChange", dhx.bind(function (j, l) {
                this.changeId(j, l)
            }, this))]
        }
        c()
    },
    add: function (l, c) {
        if (this._scheme) {
            for (var g in this._scheme) {
                if (dhx.isUndefined(l[g])) {
                    l[g] = this._scheme[g]
                }
            }
        }
        if (this._scheme_init) {
            this._scheme_init(l)
        }
        var m = this.id(l);
        var a = arguments[2] || this.order;
        var j = a.length;
        if (dhx.isUndefined(c) || c < 0) {
            c = j
        }
        if (c > j) {
            dhx.log("Warning", "DataStore:add", "Index of out of bounds");
            c = Math.min(a.length, c)
        }
        if (this.callEvent("onBeforeAdd", [m, l, c]) === false) {
            return false
        }
        dhx.assert(!this.exists(m), "Not unique ID");
        this.pull[m] = l;
        a.insertAt(m, c);
        if (this._filter_order) {
            var h = this._filter_order.length;
            if (!c && this.order.length) {
                h = 0
            }
            this._filter_order.insertAt(m, h)
        }
        this.callEvent("onAfterAdd", [m, c]);
        this.callEvent("onStoreUpdated", [m, l, "add"]);
        return m
    },
    remove: function (g) {
        if (dhx.isArray(g)) {
            for (var a = 0; a < g.length; a++) {
                this.remove(g[a])
            }
            return
        }
        if (this.callEvent("onBeforeDelete", [g]) === false) {
            return false
        }
        dhx.assert(this.exists(g), "Not existing ID in remove command" + g);
        var c = this.item(g);
        this.order.remove(g);
        if (this._filter_order) {
            this._filter_order.remove(g)
        }
        delete this.pull[g];
        if (this._marks[g]) {
            delete this._marks[g]
        }
        this.callEvent("onAfterDelete", [g]);
        this.callEvent("onStoreUpdated", [g, c, "delete"])
    },
    clearAll: function () {
        this.pull = {};
        this.order = dhx.toArray();
        this._filter_order = this.url = null;
        this.callEvent("onClearAll", []);
        this.refresh()
    },
    idByIndex: function (a) {
        if (a >= this.order.length || a < 0) {
            dhx.log("Warning", "DataStore::idByIndex Incorrect index")
        }
        return this.order[a]
    },
    indexById: function (c) {
        var a = this.order.find(c);
        if (!this.pull[c]) {
            dhx.log("Warning", "DataStore::indexById Non-existing ID: " + c)
        }
        return a
    },
    next: function (c, a) {
        return this.order[this.indexById(c) + (a || 1)]
    },
    first: function () {
        return this.order[0]
    },
    last: function () {
        return this.order[this.order.length - 1]
    },
    previous: function (c, a) {
        return this.order[this.indexById(c) - (a || 1)]
    },
    sort: function (j, c, a) {
        var g = j;
        if (typeof j == "function") {
            g = {
                as: j,
                dir: c
            }
        } else {
            if (typeof j == "string") {
                g = {
                    by: j.replace(/#/g, ""),
                    dir: c,
                    as: a
                }
            }
        }
        var h = [g.by, g.dir, g.as];
        if (!this.callEvent("onBeforeSort", h)) {
            return
        }
        this._sort_core(g);
        this.refresh();
        this.callEvent("onAfterSort", h)
    },
    _sort_core: function (a) {
        if (this.order.length) {
            var g = this._sort._create(a);
            var c = this.getRange(this.first(), this.last());
            c.sort(g);
            this.order = c.map(function (h) {
                dhx.assert(h, "Client sorting can't be used with dynamic loading");
                return this.id(h)
            }, this)
        }
    },
    _filter_reset: function (a) {
        if (this._filter_order && !a) {
            this.order = this._filter_order;
            delete this._filter_order
        }
    },
    _filter_core: function (g, j, c) {
        var h = dhx.toArray();
        for (var a = 0; a < this.order.length; a++) {
            var l = this.order[a];
            if (g(this.item(l), j)) {
                h.push(l)
            }
        }
        if (!c || !this._filter_order) {
            this._filter_order = this.order
        }
        this.order = h
    },
    filter: function (h, g, a) {
        if (!this.callEvent("onBeforeFilter", [h, g])) {
            return
        }
        this._filter_reset(a);
        if (!this.order.length) {
            return
        }
        if (h) {
            var c = h;
            g = g || "";
            if (typeof h == "string") {
                h = h.replace(/#/g, "");
                if (typeof g == "function") {
                    c = function (j) {
                        return g(j[h])
                    }
                } else {
                    g = g.toString().toLowerCase();
                    c = function (l, j) {
                        dhx.assert(l, "Client side filtering can't be used with dynamic loading");
                        return (l[h] || "").toString().toLowerCase().indexOf(j) != -1
                    }
                }
            }
            this._filter_core(c, g, a, this._filterMode)
        }
        this.refresh();
        this.callEvent("onAfterFilter", [])
    },
    each: function (g, c) {
        for (var a = 0; a < this.order.length; a++) {
            g.call((c || this), this.item(this.order[a]))
        }
    },
    _methodPush: function (a, c) {
        return function () {
            return a[c].apply(a, arguments)
        }
    },
    addMark: function (j, h, a, c) {
        var g = this._marks[j] || {};
        this._marks[j] = g;
        if (!g[h]) {
            g[h] = c || true;
            if (a) {
                this.item(j).$css = (this.item(j).$css || "") + " " + h;
                this.refresh(j)
            }
        }
        return g[h]
    },
    removeMark: function (j, h, a) {
        var g = this._marks[j];
        if (g && g[h]) {
            delete g[h]
        }
        if (a) {
            var c = this.item(j).$css;
            if (c) {
                this.item(j).$css = c.replace(h, "");
                this.refresh(j)
            }
        }
    },
    hasMark: function (g, c) {
        var a = this._marks[g];
        return (a && a[c])
    },
    provideApi: function (h, c) {
        this.debug_bind_master = h;
        if (c) {
            this.mapEvent({
                onbeforesort: h,
                onaftersort: h,
                onbeforeadd: h,
                onafteradd: h,
                onbeforedelete: h,
                onafterdelete: h,
                onbeforeupdate: h
            })
        }
        var g = ["sort", "add", "remove", "exists", "idByIndex", "indexById", "item", "update", "refresh", "dataCount", "filter", "next", "previous", "clearAll", "first", "last", "serialize", "sync", "addMark", "removeMark", "hasMark"];
        for (var a = 0; a < g.length; a++) {
            h[g[a]] = this._methodPush(this, g[a])
        }
    },
    serialize: function () {
        var h = this.order;
        var a = [];
        for (var c = 0; c < h.length; c++) {
            var g = this.pull[h[c]];
            if (this._scheme_serialize) {
                g = this._scheme_serialize(g);
                if (g === false) {
                    continue
                }
            }
            a.push(g)
        }
        return a
    },
    _sort: {
        _create: function (a) {
            return this._dir(a.dir, this._by(a.by, a.as))
        },
        _as: {
            date: function (g, c) {
                g = g - 0;
                c = c - 0;
                return g > c ? 1 : (g < c ? -1 : 0)
            },
            "int": function (g, c) {
                g = g * 1;
                c = c * 1;
                return g > c ? 1 : (g < c ? -1 : 0)
            },
            string_strict: function (g, c) {
                g = g.toString();
                c = c.toString();
                return g > c ? 1 : (g < c ? -1 : 0)
            },
            string: function (g, c) {
                if (!c) {
                    return 1
                }
                if (!g) {
                    return -1
                }
                g = g.toString().toLowerCase();
                c = c.toString().toLowerCase();
                return g > c ? 1 : (g < c ? -1 : 0)
            }
        },
        _by: function (c, a) {
            if (!c) {
                return a
            }
            if (typeof a != "function") {
                a = this._as[a || "string"]
            }
            dhx.assert(a, "Invalid sorting method");
            return function (h, g) {
                return a(h[c], g[c])
            }
        },
        _dir: function (c, a) {
            if (c == "asc" || !c) {
                return a
            }
            return function (h, g) {
                return a(h, g) * -1
            }
        }
    }
};
dhx.BaseBind = {
    debug_freid_ignore: {
        id: true
    },
    bind: function (j, h, g) {
        if (typeof j == "string") {
            j = dhx.ui.get(j)
        }
        if (j._initBindSource) {
            j._initBindSource()
        }
        if (this._initBindSource) {
            this._initBindSource()
        }
        if (!j.getBindData) {
            dhx.extend(j, dhx.BindSource)
        }
        if (!this._bind_ready) {
            var l = this.render;
            if (this.filter) {
                var c = this._settings.id;
                this.data._on_sync = function () {
                    j._bind_updated[c] = false
                }
            }
            this.render = function () {
                if (this._in_bind_processing) {
                    return
                }
                this._in_bind_processing = true;
                var m = this.callEvent("onBindRequest");
                this._in_bind_processing = false;
                return l.apply(this, ((m === false) ? arguments : []))
            };
            if (this.getValue || this.getValues) {
                this.save = function () {
                    if (this.validate && !this.validate()) {
                        return
                    }
                    j.setBindData((this.getValue ? this.getValue : this.getValues()), this._settings.id)
                }
            }
            this._bind_ready = true
        }
        j.addBind(this._settings.id, h, g);
        if (dhx.debug_bind) {
            dhx.log("[bind] " + this.name + "@" + this._settings.id + " <= " + j.name + "@" + j._settings.id)
        }
        var a = this._settings.id;
        this.attachEvent(this.touchable ? "onAfterRender" : "onBindRequest", function () {
            return j.getBindData(a)
        });
        if (!this._settings.dataFeed && this.loadNext) {
            this.data.attachEvent("onStoreLoad", function () {
                j._bind_updated[a] = false
            })
        }
        if (this.isVisible(this._settings.id)) {
            this.refresh()
        }
    },
    _unbind: function (g) {
        g.removeBind(this._settings.id);
        var c = (this._sync_events || (this.data ? this.data._sync_events : 0));
        if (c && g.data) {
            for (var a = 0; a < c.length; a++) {
                g.data.detachEvent(c[a])
            }
        }
    }
};
dhx.BindSource = {
    $init: function () {
        this._bind_hash = {};
        this._bind_updated = {};
        this._ignore_binds = {};
        this._bind_specific_rules(this)
    },
    saveBatch: function (a) {
        this._do_not_update_binds = true;
        a.call(this);
        this._do_not_update_binds = false;
        this._update_binds()
    },
    setBindData: function (c, a) {
        if (a) {
            this._ignore_binds[a] = true
        }
        if (dhx.debug_bind) {
            dhx.log("[bind:save] " + this.name + "@" + this._settings.id + " <= @" + a)
        }
        if (this.setValue) {
            this.setValue(c)
        } else {
            if (this.setValues) {
                this.setValues(c)
            } else {
                var g = this.getCursor();
                if (g) {
                    c = dhx.extend(this.item(g), c, true);
                    this.update(g, c)
                }
            }
        }
        this.callEvent("onBindUpdate", [c, a]);
        if (this.save) {
            this.save()
        }
        if (a) {
            this._ignore_binds[a] = false
        }
    },
    getBindData: function (a, g) {
        if (this._bind_updated[a]) {
            return false
        }
        var c = dhx.ui.get(a);
        if (c.isVisible(c._settings.id)) {
            this._bind_updated[a] = true;
            if (dhx.debug_bind) {
                dhx.log("[bind:request] " + this.name + "@" + this._settings.id + " => " + c.name + "@" + c._settings.id)
            }
            this._bind_update(c, this._bind_hash[a][0], this._bind_hash[a][1]);
            if (g && c.filter) {
                c.refresh()
            }
        }
    },
    addBind: function (a, g, c) {
        this._bind_hash[a] = [g, c]
    },
    removeBind: function (a) {
        delete this._bind_hash[a];
        delete this._bind_updated[a];
        delete this._ignore_binds[a]
    },
    _bind_specific_rules: function (a) {
        if (a.filter) {
            dhx.extend(this, dhx.CollectionBind)
        } else {
            if (a.setValue) {
                dhx.extend(this, dhx.ValueBind)
            } else {
                dhx.extend(this, dhx.RecordBind)
            }
        }
    },
    _update_binds: function () {
        if (!this._do_not_update_binds) {
            for (var a in this._bind_hash) {
                if (this._ignore_binds[a]) {
                    continue
                }
                this._bind_updated[a] = false;
                this.getBindData(a, true)
            }
        }
    },
    _bind_update_common: function (g, c, a) {
        if (g.setValue) {
            g.setValue(a ? a[c] : a)
        } else {
            if (!g.filter) {
                if (!a && g.clear) {
                    g.clear()
                } else {
                    if (g._check_data_feed(a)) {
                        g.setValues(dhx.clone(a))
                    }
                }
            } else {
                g.data.silent(function () {
                    this.filter(c, a)
                })
            }
        }
        g.callEvent("onBindApply", [a, c, this])
    }
};
dhx.DataValue = dhx.proto({
    name: "DataValue",
    isVisible: function () {
        return true
    },
    $init: function (a) {
        this.data = "" || a;
        var c = (a && a.id) ? a.id : dhx.uid();
        this._settings = {
            id: c
        };
        dhx.ui.views[c] = this
    },
    setValue: function (a) {
        this.data = a;
        this.callEvent("onChange", [a])
    },
    getValue: function () {
        return this.data
    },
    refresh: function () {
        this.callEvent("onBindRequest")
    }
}, dhx.EventSystem, dhx.BaseBind);
dhx.DataRecord = dhx.proto({
    name: "DataRecord",
    isVisible: function () {
        return true
    },
    $init: function (a) {
        this.data = a || {};
        var c = (a && a.id) ? a.id : dhx.uid();
        this._settings = {
            id: c
        };
        dhx.ui.views[c] = this
    },
    getValues: function () {
        return this.data
    },
    setValues: function (a) {
        this.data = a;
        this.callEvent("onChange", [a])
    },
    refresh: function () {
        this.callEvent("onBindRequest")
    }
}, dhx.EventSystem, dhx.BaseBind, dhx.AtomDataLoader, dhx.Settings);
dhx.DataCollection = dhx.proto({
    name: "DataCollection",
    isVisible: function () {
        if (!this.data.order.length && !this.data._filter_order && !this._settings.dataFeed) {
            return false
        }
        return true
    },
    $init: function (a) {
        this.data.provideApi(this, true);
        var c = (a && a.id) ? a.id : dhx.uid();
        this._settings.id = c;
        dhx.ui.views[c] = this;
        this.data.attachEvent("onStoreLoad", dhx.bind(function () {
            this.callEvent("onBindRequest", [])
        }, this))
    },
    refresh: function () {
        this.callEvent("onBindRequest", [])
    }
}, dhx.DataLoader, dhx.EventSystem, dhx.BaseBind, dhx.Settings);
dhx.ValueBind = {
    $init: function () {
        this.attachEvent("onChange", this._update_binds)
    },
    _bind_update: function (j, h, g) {
        var c = this.getValue() || "";
        if (g) {
            c = g(c)
        }
        if (j.setValue) {
            j.setValue(c)
        } else {
            if (!j.filter) {
                var a = {};
                a[h] = c;
                if (j._check_data_feed(c)) {
                    j.setValues(a)
                }
            } else {
                j.data.silent(function () {
                    this.filter(h, c)
                })
            }
        }
        j.callEvent("onBindApply", [c, h, this])
    }
};
dhx.RecordBind = {
    $init: function () {
        this.attachEvent("onChange", this._update_binds)
    },
    _bind_update: function (g, c) {
        var a = this.getValues() || null;
        this._bind_update_common(g, c, a)
    }
};
dhx.CollectionBind = {
    $init: function () {
        this._cursor = null;
        this.attachEvent("onSelectChange", function (c) {
            var a = this.getSelected();
            this.setCursor(a ? (a.id || a) : null)
        });
        this.attachEvent("onAfterCursorChange", this._update_binds);
        this.data.attachEvent("onStoreUpdated", dhx.bind(function (g, a, c) {
            if (g && g == this.getCursor() && c != "paint") {
                this._update_binds()
            }
        }, this));
        this.data.attachEvent("onClearAll", dhx.bind(function () {
            this._cursor = null
        }, this));
        this.data.attachEvent("onIdChange", dhx.bind(function (c, a) {
            if (this._cursor == c) {
                this._cursor = a
            }
        }, this))
    },
    setCursor: function (a) {
        if (a == this._cursor || (a !== null && !this.item(a))) {
            return
        }
        this.callEvent("onBeforeCursorChange", [this._cursor]);
        this._cursor = a;
        this.callEvent("onAfterCursorChange", [a])
    },
    getCursor: function () {
        return this._cursor
    },
    _bind_update: function (g, c) {
        var a = this.item(this.getCursor()) || this._settings.defaultData || null;
        this._bind_update_common(g, c, a)
    }
};
if (!dhx.ui) {
    dhx.ui = {}
}
if (!dhx.ui.views) {
    dhx.ui.views = {};
    dhx.ui.get = function (a) {
        if (a._settings) {
            return a
        }
        return dhx.ui.views[a]
    }
}
dhtmlXDataStore = function (c) {
    var g = new dhx.DataCollection(c);
    var a = "_dp_init";
    g[a] = function (j) {
        var h = "_methods";
        j[h] = ["dummy", "dummy", "changeId", "dummy"];
        this.data._old_names = {
            add: "inserted",
            update: "updated",
            "delete": "deleted"
        };
        this.data.attachEvent("onStoreUpdated", function (n, l, m) {
            if (n && !j._silent) {
                j.setUpdated(n, true, this._old_names[m])
            }
        });
        h = "_getRowData";
        j[h] = function (q, l) {
            var n = this.obj.data.item(q);
            var o = {
                id: q
            };
            o[this.action_param] = this.obj.getUserData(q);
            if (n) {
                for (var m in n) {
                    o[m] = n[m]
                }
            }
            return o
        };
        this.changeId = function (m, l) {
            this.data.changeId(m, l);
            j._silent = true;
            this.data.callEvent("onStoreUpdated", [l, this.item(l), "update"]);
            j._silent = false
        };
        h = "_clearUpdateFlag";
        j[h] = function () {};
        this._userdata = {}
    };
    g.dummy = function () {};
    g.setUserData = function (l, h, j) {
        this._userdata[l] = j
    };
    g.getUserData = function (j, h) {
        return this._userdata[j]
    };
    g.dataFeed = function (h) {
        this.define("dataFeed", h)
    };
    dhx.extend(g, dhx.BindSource);
    return g
};
if (window.dhtmlXDataView) {
    dhtmlXDataView.prototype._initBindSource = function () {
        this.isVisible = function () {
            if (!this.data.order.length && !this.data._filter_order && !this._settings.dataFeed) {
                return false
            }
            return true
        };
        var a = "_settings";
        this._settings = this._settings || this[a];
        if (!this._settings.id) {
            this._settings.id = dhx.uid()
        }
        this.unbind = dhx.BaseBind.unbind;
        this.unsync = dhx.BaseBind.unsync;
        dhx.ui.views[this._settings.id] = this
    }
}
if (window.dhtmlXChart) {
    dhtmlXChart.prototype._initBindSource = function () {
        this.isVisible = function () {
            if (!this.data.order.length && !this.data._filtered_state && !this._settings.dataFeed) {
                return false
            }
            return true
        };
        var a = "_settings";
        this._settings = this._settings || this[a];
        if (!this._settings.id) {
            this._settings.id = dhx.uid()
        }
        this.unbind = dhx.BaseBind.unbind;
        this.unsync = dhx.BaseBind.unsync;
        dhx.ui.views[this._settings.id] = this
    }
}
dhx.BaseBind.unsync = function (a) {
    return dhx.BaseBind._unbind.call(this, a)
};
dhx.BaseBind.unbind = function (a) {
    return dhx.BaseBind._unbind.call(this, a)
};
dhx.BaseBind.legacyBind = function () {
    return dhx.BaseBind.bind.apply(this, arguments)
};
dhx.BaseBind.legacySync = function (a, c) {
    if (this._initBindSource) {
        this._initBindSource()
    }
    if (a._initBindSource) {
        a._initBindSource()
    }
    this.attachEvent("onAfterEditStop", function (g) {
        this.save(g);
        return true
    });
    this.attachEvent("onDataRequest", function (j, h) {
        for (var g = j; g < j + h; g++) {
            if (!a.data.order[g]) {
                a.loadNext(h, j);
                return false
            }
        }
    });
    this.save = function (l) {
        if (!l) {
            l = this.getCursor()
        }
        var j = this.item(l);
        var g = a.item(l);
        for (var h in j) {
            if (h.indexOf("$") !== 0) {
                g[h] = j[h]
            }
        }
        a.refresh(l)
    };
    if (a && a.name == "DataCollection") {
        return a.data.sync.apply(this.data, arguments)
    } else {
        return this.data.sync.apply(this.data, arguments)
    }
};
if (window.dhtmlXForm) {
    dhtmlXForm.prototype.bind = function (a) {
        dhx.BaseBind.bind.apply(this, arguments);
        a.getBindData(this._settings.id)
    };
    dhtmlXForm.prototype.unbind = function (a) {
        dhx.BaseBind._unbind.call(this, a)
    };
    dhtmlXForm.prototype._initBindSource = function () {
        if (dhx.isUndefined(this._settings)) {
            this._settings = {
                id: dhx.uid(),
                dataFeed: this._server_feed
            };
            dhx.ui.views[this._settings.id] = this
        }
    };
    dhtmlXForm.prototype._check_data_feed = function (c) {
        if (!this._settings.dataFeed || this._ignore_feed || !c) {
            return true
        }
        var a = this._settings.dataFeed;
        if (typeof a == "function") {
            return a.call(this, (c.id || c), c)
        }
        a = a + (a.indexOf("?") == -1 ? "?" : "&") + "action=get&id=" + encodeURIComponent(c.id || c);
        this.load(a);
        return false
    };
    dhtmlXForm.prototype.setValues = dhtmlXForm.prototype.setFormData;
    dhtmlXForm.prototype.getValues = function () {
        return this.getFormData(false, true)
    };
    dhtmlXForm.prototype.dataFeed = function (a) {
        if (this._settings) {
            this._settings.dataFeed = a
        } else {
            this._server_feed = a
        }
    };
    dhtmlXForm.prototype.refresh = dhtmlXForm.prototype.isVisible = function (a) {
        return true
    }
}
if (window.scheduler) {
    if (!window.Scheduler) {
        window.Scheduler = {}
    }
    Scheduler.$syncFactory = function (a) {
        a.sync = function (g, j) {
            if (this._initBindSource) {
                this._initBindSource()
            }
            if (g._initBindSource) {
                g._initBindSource()
            }
            var h = "_process_loading";
            var c = function (q) {
                    a.clearAll();
                    var l = g.data.order;
                    var o = g.data.pull;
                    var m = [];
                    for (var n = 0; n < l.length; n++) {
                        if (j && j.copy) {
                            m[n] = dhx.clone(o[l[n]])
                        } else {
                            m[n] = o[l[n]]
                        }
                    }
                    a[h](m)
                };
            this.save = function (n) {
                if (!n) {
                    n = this.getCursor()
                }
                var m = this.item(n);
                var l = g.item(n);
                if (this.callEvent("onStoreSave", [n, m, l])) {
                    dhx.extend(g.item(n), m, true);
                    g.update(n)
                }
            };
            this.item = function (l) {
                return this.getEvent(l)
            };
            this._sync_events = [g.data.attachEvent("onStoreUpdated", function (n, l, m) {
                c.call(this)
            }), g.data.attachEvent("onIdChange", function (m, l) {
                combo.changeOptionId(m, l)
            })];
            this.attachEvent("onEventChanged", function (l) {
                this.save(l)
            });
            this.attachEvent("onEventAdded", function (m, l) {
                if (!g.data.pull[m]) {
                    g.add(l)
                }
            });
            this.attachEvent("onEventDeleted", function (l) {
                if (g.data.pull[l]) {
                    g.remove(l)
                }
            });
            c()
        };
        a.unsync = function (c) {
            dhx.BaseBind._unbind.call(this, c)
        };
        a._initBindSource = function () {
            if (!this._settings) {
                this._settings = {
                    id: dhx.uid()
                }
            }
        }
    };
    Scheduler.$syncFactory(window.scheduler)
}
if (window.dhtmlXCombo) {
    dhtmlXCombo.prototype.bind = function () {
        dhx.BaseBind.bind.apply(this, arguments)
    };
    dhtmlXCombo.unbind = function (a) {
        dhx.BaseBind._unbind.call(this, a)
    };
    dhtmlXCombo.unsync = function (a) {
        dhx.BaseBind._unbind.call(this, a)
    };
    dhtmlXCombo.prototype.dataFeed = function (a) {
        if (this._settings) {
            this._settings.dataFeed = a
        } else {
            this._server_feed = a
        }
    };
    dhtmlXCombo.prototype.sync = function (c, h) {
        if (this._initBindSource) {
            this._initBindSource()
        }
        if (c._initBindSource) {
            c._initBindSource()
        }
        var g = this;
        var a = function (j) {
                g.clearAll();
                g.addOption(this.serialize())
            };
        this._sync_events = [c.data.attachEvent("onStoreUpdated", function (m, j, l) {
            a.call(this)
        }), c.data.attachEvent("onIdChange", function (l, j) {
            g.changeOptionId(l, j)
        })];
        a.call(c)
    };
    dhtmlXCombo.prototype._initBindSource = function () {
        if (dhx.isUndefined(this._settings)) {
            this._settings = {
                id: dhx.uid(),
                dataFeed: this._server_feed
            };
            dhx.ui.views[this._settings.id] = this;
            this.data = {
                silent: dhx.bind(function (a) {
                    a.call(this)
                }, this)
            };
            dhtmlxEventable(this.data);
            this.attachEvent("onChange", function () {
                this.callEvent("onSelectChange", [this.getSelectedValue()])
            });
            this.attachEvent("onXLE", function () {
                this.callEvent("onBindRequest", [])
            })
        }
    };
    dhtmlXCombo.prototype.item = function (a) {
        return this.getOption(a)
    };
    dhtmlXCombo.prototype.getSelected = function () {
        return this.getSelectedValue()
    };
    dhtmlXCombo.prototype.isVisible = function () {
        if (!this.optionsArr.length && !this._settings.dataFeed) {
            return false
        }
        return true
    };
    dhtmlXCombo.prototype.refresh = function () {
        this.render(true)
    };
    dhtmlXCombo.prototype.filter = function (c, a) {
        alert("not implemented")
    }
}
if (window.dhtmlXGridObject) {
    dhtmlXGridObject.prototype.bind = function (a, g, c) {
        dhx.BaseBind.bind.apply(this, arguments)
    };
    dhtmlXGridObject.prototype.unbind = function (a) {
        dhx.BaseBind._unbind.call(this, a)
    };
    dhtmlXGridObject.prototype.unsync = function (a) {
        dhx.BaseBind._unbind.call(this, a)
    };
    dhtmlXGridObject.prototype.dataFeed = function (a) {
        if (this._settings) {
            this._settings.dataFeed = a
        } else {
            this._server_feed = a
        }
    };
    dhtmlXGridObject.prototype.sync = function (a, o) {
        if (this._initBindSource) {
            this._initBindSource()
        }
        if (a._initBindSource) {
            a._initBindSource()
        }
        var c = this;
        var n = "_parsing";
        var g = "_parser";
        var l = "_locator";
        var h = "_process_store_row";
        var m = "_get_store_data";
        this.save = function (q) {
            if (!q) {
                q = this.getCursor()
            }
            dhx.extend(a.item(q), this.item(q), true);
            a.update(q)
        };
        var j = function (w) {
                var s = c.getCursor ? c.getCursor() : null;
                var v = 0;
                if (c._legacy_ignore_next) {
                    v = c._legacy_ignore_next;
                    c._legacy_ignore_next = false
                } else {
                    c.clearAll()
                }
                var r = this.dataCount();
                if (r) {
                    c[n] = true;
                    for (var q = v; q < r; q++) {
                        var u = this.order[q];
                        if (!u) {
                            continue
                        }
                        if (v && c.rowsBuffer[q]) {
                            continue
                        }
                        c.rowsBuffer[q] = {
                            idd: u,
                            data: this.pull[u]
                        };
                        c.rowsBuffer[q][g] = c[h];
                        c.rowsBuffer[q][l] = c[m];
                        c.rowsAr[u] = this.pull[u]
                    }
                    if (!c.rowsBuffer[r - 1]) {
                        c.rowsBuffer[r - 1] = dhtmlx.undefined;
                        c.xmlFileUrl = c.xmlFileUrl || this.url
                    }
                    if (c.pagingOn) {
                        c.changePage()
                    } else {
                        if (c._srnd && c._fillers) {
                            c._update_srnd_view()
                        } else {
                            c.render_dataset();
                            c.callEvent("onXLE", [])
                        }
                    }
                    c[n] = false
                }
                if (s && c.setCursor) {
                    c.setCursor(c.rowsAr[s] ? s : null)
                }
            };
        this._sync_events = [a.data.attachEvent("onStoreUpdated", function (s, q, r) {
            if (r == "delete") {
                c.deleteRow(s);
                c.data.callEvent("onStoreUpdated", [s, q, r])
            } else {
                if (r == "update") {
                    c.callEvent("onSyncUpdate", [q, r]);
                    c.update(s, q);
                    c.data.callEvent("onStoreUpdated", [s, q, r])
                } else {
                    if (r == "add") {
                        c.callEvent("onSyncUpdate", [q, r]);
                        c.add(s, q, this.indexById(s));
                        c.data.callEvent("onStoreUpdated", [s, q, r])
                    } else {
                        j.call(this)
                    }
                }
            }
        }), a.data.attachEvent("onStoreLoad", function (r, q) {
            c.xmlFileUrl = a.data.url;
            c._legacy_ignore_next = r.getInfo(q)._from
        }), a.data.attachEvent("onIdChange", function (r, q) {
            c.changeRowId(r, q)
        })];
        c.attachEvent("onDynXLS", function (s, r) {
            for (var q = s; q < s + r; q++) {
                if (!a.data.order[q]) {
                    a.loadNext(r, s);
                    return false
                }
            }
            c._legacy_ignore_next = s;
            j.call(a.data)
        });
        j.call(a.data);
        c.attachEvent("onEditCell", function (q, v, s, r, u) {
            if (q == 2 && r != u) {
                this.save(v)
            }
            return true
        });
        c.attachEvent("onClearAll", function () {
            var q = "_f_rowsBuffer";
            this[q] = null
        });
        if (o && o.sort) {
            c.attachEvent("onBeforeSorting", function (s, r, q) {
                if (r == "connector") {
                    return false
                }
                var u = this.getColumnId(s);
                a.sort("#" + u + "#", (q == "asc" ? "asc" : "desc"), (r == "int" ? r : "string"));
                c.setSortImgState(true, s, q);
                return false
            })
        }
        if (o && o.filter) {
            c.attachEvent("onFilterStart", function (s, q) {
                var r = "_con_f_used";
                if (c[r] && c[r].length) {
                    return false
                }
                a.data.silent(function () {
                    a.filter();
                    for (var u = 0; u < s.length; u++) {
                        if (q[u] == "") {
                            continue
                        }
                        var v = c.getColumnId(s[u]);
                        a.filter("#" + v + "#", q[u], u != 0)
                    }
                });
                a.refresh();
                return false
            });
            c.collectValues = function (q) {
                var r = this.getColumnId(q);
                return (function (v) {
                    var s = [];
                    var u = {};
                    this.data.each(function (x) {
                        var w = x[v];
                        if (!u[w]) {
                            u[w] = true;
                            s.push(w)
                        }
                    });
                    s.sort();
                    return s
                }).call(a, r)
            }
        }
        if (o && o.select) {
            c.attachEvent("onRowSelect", function (q) {
                a.setCursor(q)
            })
        }
        c.clearAndLoad = function (q) {
            a.clearAll();
            a.load(q)
        }
    };
    dhtmlXGridObject.prototype._initBindSource = function () {
        if (dhx.isUndefined(this._settings)) {
            this._settings = {
                id: dhx.uid(),
                dataFeed: this._server_feed
            };
            dhx.ui.views[this._settings.id] = this;
            this.data = {
                silent: dhx.bind(function (g) {
                    g.call(this)
                }, this)
            };
            dhtmlxEventable(this.data);
            var a = "_cCount";
            for (var c = 0; c < this[a]; c++) {
                if (!this.columnIds[c]) {
                    this.columnIds[c] = "cell" + c
                }
            }
            this.attachEvent("onSelectStateChanged", function (g) {
                this.callEvent("onSelectChange", [g])
            });
            this.attachEvent("onSelectionCleared", function () {
                this.callEvent("onSelectChange", [null])
            });
            this.attachEvent("onEditCell", function (g, h) {
                if (g === 2 && this.getCursor) {
                    if (h && h == this.getCursor()) {
                        this._update_binds()
                    }
                }
                return true
            });
            this.attachEvent("onXLE", function () {
                this.callEvent("onBindRequest", [])
            })
        }
    };
    dhtmlXGridObject.prototype.item = function (l) {
        if (l === null) {
            return null
        }
        var j = this.getRowById(l);
        if (!j) {
            return null
        }
        var a = "_attrs";
        var h = dhx.copy(j[a]);
        h.id = l;
        var g = this.getColumnsNum();
        for (var c = 0; c < g; c++) {
            h[this.columnIds[c]] = this.cells(l, c).getValue()
        }
        return h
    };
    dhtmlXGridObject.prototype.update = function (l, j) {
        for (var h = 0; h < this.columnIds.length; h++) {
            var g = this.columnIds[h];
            if (!dhx.isUndefined(j[g])) {
                this.cells(l, h).setValue(j[g])
            }
        }
        var c = "_attrs";
        var a = this.getRowById(l)[c];
        for (var g in j) {
            a[g] = j[g]
        }
        this.callEvent("onBindUpdate", [l])
    };
    dhtmlXGridObject.prototype.add = function (m, l, g) {
        var a = [];
        for (var j = 0; j < this.columnIds.length; j++) {
            var h = this.columnIds[j];
            a[j] = dhx.isUndefined(l[h]) ? "" : l[h]
        }
        this.addRow(m, a, g);
        var c = "_attrs";
        this.getRowById(m)[c] = dhx.copy(l)
    };
    dhtmlXGridObject.prototype.getSelected = function () {
        return this.getSelectedRowId()
    };
    dhtmlXGridObject.prototype.isVisible = function () {
        var a = "_f_rowsBuffer";
        if (!this.rowsBuffer.length && !this[a] && !this._settings.dataFeed) {
            return false
        }
        return true
    };
    dhtmlXGridObject.prototype.refresh = function () {
        this.render_dataset()
    };
    dhtmlXGridObject.prototype.filter = function (l, j) {
        if (this._settings.dataFeed) {
            var h = {};
            if (!l && !j) {
                return
            }
            if (typeof l == "function") {
                if (!j) {
                    return
                }
                l(j, h)
            } else {
                if (dhx.isUndefined(l)) {
                    h = j
                } else {
                    h[l] = j
                }
            }
            this.clearAll();
            var a = this._settings.dataFeed;
            if (typeof a == "function") {
                return a.call(this, j, h)
            }
            var g = [];
            for (var c in h) {
                g.push("dhx_filter[" + c + "]=" + encodeURIComponent(h[c]))
            }
            this.load(a + (a.indexOf("?") < 0 ? "?" : "&") + g.join("&"));
            return false
        }
        if (j === null) {
            return this.filterBy(0, function () {
                return false
            })
        }
        this.filterBy(0, function (m, n) {
            return l.call(this, n, j)
        })
    }
}
if (window.dhtmlXTreeObject) {
    dhtmlXTreeObject.prototype.bind = function () {
        dhx.BaseBind.bind.apply(this, arguments)
    };
    dhtmlXTreeObject.prototype.unbind = function (a) {
        dhx.BaseBind._unbind.call(this, a)
    };
    dhtmlXTreeObject.prototype.dataFeed = function (a) {
        if (this._settings) {
            this._settings.dataFeed = a
        } else {
            this._server_feed = a
        }
    };
    dhtmlXTreeObject.prototype._initBindSource = function () {
        if (dhx.isUndefined(this._settings)) {
            this._settings = {
                id: dhx.uid(),
                dataFeed: this._server_feed
            };
            dhx.ui.views[this._settings.id] = this;
            this.data = {
                silent: dhx.bind(function (a) {
                    a.call(this)
                }, this)
            };
            dhtmlxEventable(this.data);
            this.attachEvent("onSelect", function (a) {
                this.callEvent("onSelectChange", [a])
            });
            this.attachEvent("onEdit", function (a, c) {
                if (a === 2) {
                    if (c && c == this.getCursor()) {
                        this._update_binds()
                    }
                }
                return true
            })
        }
    };
    dhtmlXTreeObject.prototype.item = function (a) {
        if (a === null) {
            return null
        }
        return {
            id: a,
            text: this.getItemText(a)
        }
    };
    dhtmlXTreeObject.prototype.getSelected = function () {
        return this.getSelectedItemId()
    };
    dhtmlXTreeObject.prototype.isVisible = function () {
        return true
    };
    dhtmlXTreeObject.prototype.refresh = function () {};
    dhtmlXTreeObject.prototype.filter = function (l, j) {
        if (this._settings.dataFeed) {
            var h = {};
            if (!l && !j) {
                return
            }
            if (typeof l == "function") {
                if (!j) {
                    return
                }
                l(j, h)
            } else {
                if (dhx.isUndefined(l)) {
                    h = j
                } else {
                    h[l] = j
                }
            }
            this.deleteChildItems(0);
            var a = this._settings.dataFeed;
            if (typeof a == "function") {
                return a.call(this, [(data.id || data), data])
            }
            var g = [];
            for (var c in h) {
                g.push("dhx_filter[" + c + "]=" + encodeURIComponent(h[c]))
            }
            this.loadXML(a + (a.indexOf("?") < 0 ? "?" : "&") + g.join("&"));
            return false
        }
    };
    dhtmlXTreeObject.prototype.update = function (c, a) {
        if (!dhx.isUndefined(a.text)) {
            this.setItemText(c, a.text)
        }
    }
}
if (!window.dhtmlx) {
    window.dhtmlx = {}
}(function () {
    var q = null;

    function s(y, w) {
        var x = y.callback;
        r(false);
        y.box.parentNode.removeChild(y.box);
        q = y.box = null;
        if (x) {
            x(w)
        }
    }
    function a(x) {
        if (q) {
            x = x || event;
            var w = x.which || event.keyCode;
            if (dhtmlx.message.keyboard) {
                if (w == 13 || w == 32) {
                    s(q, true)
                }
                if (w == 27) {
                    s(q, false)
                }
            }
            if (x.preventDefault) {
                x.preventDefault()
            }
            return !(x.cancelBubble = true)
        }
    }
    if (document.attachEvent) {
        document.attachEvent("onkeydown", a)
    } else {
        document.addEventListener("keydown", a, true)
    }
    function r(x) {
        if (!r.cover) {
            r.cover = document.createElement("DIV");
            r.cover.onkeydown = a;
            r.cover.className = "dhx_modal_cover";
            document.body.appendChild(r.cover)
        }
        var w = document.body.scrollHeight;
        r.cover.style.display = x ? "inline-block" : "none"
    }
    function l(x, w) {
        return "<div class='dhtmlx_popup_button' result='" + w + "' ><div>" + x + "</div></div>"
    }
    function g(x) {
        if (!u.area) {
            u.area = document.createElement("DIV");
            u.area.className = "dhtmlx_message_area";
            u.area.style[u.position] = "5px";
            document.body.appendChild(u.area)
        }
        u.hide(x.id);
        var w = document.createElement("DIV");
        w.innerHTML = "<div>" + x.text + "</div>";
        w.className = "dhtmlx-info dhtmlx-" + x.type;
        w.onclick = function () {
            u.hide(x.id);
            x = null
        };
        if (u.position == "bottom" && u.area.firstChild) {
            u.area.insertBefore(w, u.area.firstChild)
        } else {
            u.area.appendChild(w)
        }
        if (x.expire > 0) {
            u.timers[x.id] = window.setTimeout(function () {
                u.hide(x.id)
            }, x.expire)
        }
        u.pull[x.id] = w;
        w = null;
        return x.id
    }
    function m(x, A, E) {
        var D = document.createElement("DIV");
        D.className = " dhtmlx_modal_box dhtmlx-" + x.type;
        D.setAttribute("dhxbox", 1);
        var w = "";
        if (x.width) {
            D.style.width = x.width
        }
        if (x.height) {
            D.style.height = x.height
        }
        if (x.title) {
            w += '<div class="dhtmlx_popup_title">' + x.title + "</div>"
        }
        w += '<div class="dhtmlx_popup_text"><span>' + (x.content ? "" : x.text) + '</span></div><div  class="dhtmlx_popup_controls">';
        if (A) {
            w += l(x.ok || "OK", true)
        }
        if (E) {
            w += l(x.cancel || "Cancel", false)
        }
        if (x.buttons) {
            for (var y = 0; y < x.buttons.length; y++) {
                w += l(x.buttons[y], y)
            }
        }
        w += "</div>";
        D.innerHTML = w;
        if (x.content) {
            var C = x.content;
            if (typeof C == "string") {
                C = document.getElementById(C)
            }
            if (C.style.display == "none") {
                C.style.display = ""
            }
            D.childNodes[x.title ? 1 : 0].appendChild(C)
        }
        D.onclick = function (I) {
            I = I || event;
            var H = I.target || I.srcElement;
            if (!H.className) {
                H = H.parentNode
            }
            if (H.className == "dhtmlx_popup_button") {
                var F = H.getAttribute("result");
                F = (F == "true") || (F == "false" ? false : F);
                s(x, F)
            }
        };
        x.box = D;
        if (A || E) {
            q = x
        }
        return D
    }
    function v(A, C, E) {
        var D = A.tagName ? A : m(A, C, E);
        if (!A.hidden) {
            r(true)
        }
        document.body.appendChild(D);
        var w = A.left || Math.abs(Math.floor(((window.innerWidth || document.documentElement.offsetWidth) - D.offsetWidth) / 2));
        var F = A.top || Math.abs(Math.floor(((window.innerHeight || document.documentElement.offsetHeight) - D.offsetHeight) / 2));
        if (A.position == "top") {
            D.style.top = "-3px"
        } else {
            D.style.top = F + "px"
        }
        D.style.left = w + "px";
        D.onkeydown = a;
        D.focus();
        if (A.hidden) {
            dhtmlx.modalbox.hide(D)
        }
        return D
    }
    function o(w) {
        return v(w, true, false)
    }
    function c(w) {
        return v(w, true, true)
    }
    function j(w) {
        return v(w)
    }
    function n(x, w, y) {
        if (typeof x != "object") {
            if (typeof w == "function") {
                y = w;
                w = ""
            }
            x = {
                text: x,
                type: w,
                callback: y
            }
        }
        return x
    }
    function h(y, x, w, A) {
        if (typeof y != "object") {
            y = {
                text: y,
                type: x,
                expire: w,
                id: A
            }
        }
        y.id = y.id || u.uid();
        y.expire = y.expire || u.expire;
        return y
    }
    dhtmlx.alert = function () {
        var w = n.apply(this, arguments);
        w.type = w.type || "confirm";
        return o(w)
    };
    dhtmlx.confirm = function () {
        var w = n.apply(this, arguments);
        w.type = w.type || "alert";
        return c(w)
    };
    dhtmlx.modalbox = function () {
        var w = n.apply(this, arguments);
        w.type = w.type || "alert";
        return j(w)
    };
    dhtmlx.modalbox.hide = function (w) {
        while (w && w.getAttribute && !w.getAttribute("dhxbox")) {
            w = w.parentNode
        }
        if (w) {
            w.parentNode.removeChild(w);
            r(false)
        }
    };
    var u = dhtmlx.message = function (A, y, x, C) {
            A = h.apply(this, arguments);
            A.type = A.type || "info";
            var w = A.type.split("-")[0];
            switch (w) {
            case "alert":
                return o(A);
            case "confirm":
                return c(A);
            case "modalbox":
                return j(A);
            default:
                return g(A);
                break
            }
        };
    u.seed = (new Date()).valueOf();
    u.uid = function () {
        return u.seed++
    };
    u.expire = 4000;
    u.keyboard = true;
    u.position = "top";
    u.pull = {};
    u.timers = {};
    u.hideAll = function () {
        for (var w in u.pull) {
            u.hide(w)
        }
    };
    u.hide = function (x) {
        var w = u.pull[x];
        if (w && w.parentNode) {
            window.setTimeout(function () {
                w.parentNode.removeChild(w);
                w = null
            }, 2000);
            w.className += " hidden";
            if (u.timers[x]) {
                window.clearTimeout(u.timers[x])
            }
            delete u.pull[x]
        }
    }
})();
